import 'dart:ffi';
import 'dart:typed_data';
import 'package:ffi/ffi.dart';
import 'package:test/test.dart';
import '../lib/assimp.dart';
import '../lib/src/bindings.dart';
import 'test_utils.dart';

// DO NOT EDIT (generated by tool/testgen)

void main() {
  prepareTest();

  test('null', () {
    expect(MemoryInfo.fromNative(null), isNull);
  });

  test('size', () {
    expect(sizeOf<aiMemoryInfo>(), equals(32));
  });

  test('equals', () {
    final a = MemoryInfo.fromNative(allocate<aiMemoryInfo>());
    final b = MemoryInfo.fromNative(allocate<aiMemoryInfo>());
    expect(a, equals(a));
    expect(b, equals(b));
    expect(a, isNot(equals(b)));
    expect(b, isNot(equals(a)));
  });

  test('toString', () {
    expect(MemoryInfo.fromNative(allocate<aiMemoryInfo>()).toString(), matches(r'MemoryInfo\(Pointer<aiMemoryInfo>: address=0x[0-f]+\)'));
  });

  test('3mf', () {
    testScene('3mf/box.3mf', (scene) {
      final mem = MemoryInfo.fromScene(scene);
      expect(mem, isNotNull);
      expect(mem.textures, isZero);
      expect(mem.materials, equals(88));
      expect(mem.meshes, equals(1408));
      expect(mem.nodes, equals(2300));
      expect(mem.animations, isZero);
      expect(mem.cameras, isZero);
      expect(mem.lights, isZero);
      expect(mem.total, equals(3924));
    });
    testScene('3mf/spider.3mf', (scene) {
      final mem = MemoryInfo.fromScene(scene);
      expect(mem, isNotNull);
      expect(mem.textures, isZero);
      expect(mem.materials, equals(287));
      expect(mem.meshes, equals(80980));
      expect(mem.nodes, equals(23108));
      expect(mem.animations, isZero);
      expect(mem.cameras, isZero);
      expect(mem.lights, isZero);
      expect(mem.total, equals(104503));
    });
  });

  test('fbx', () {
    testScene('fbx/huesitos.fbx', (scene) {
      final mem = MemoryInfo.fromScene(scene);
      expect(mem, isNotNull);
      expect(mem.textures, isZero);
      expect(mem.materials, equals(301));
      expect(mem.meshes, equals(33736));
      expect(mem.nodes, equals(18428));
      expect(mem.animations, equals(13336));
      expect(mem.cameras, equals(1080));
      expect(mem.lights, equals(1132));
      expect(mem.total, equals(68141));
    });
  });

  test('obj', () {
    testScene('Obj/Spider/spider.obj', (scene) {
      final mem = MemoryInfo.fromScene(scene);
      expect(mem, isNotNull);
      expect(mem.textures, isZero);
      expect(mem.materials, equals(1642));
      expect(mem.meshes, equals(210976));
      expect(mem.nodes, equals(23108));
      expect(mem.animations, isZero);
      expect(mem.cameras, isZero);
      expect(mem.lights, isZero);
      expect(mem.total, equals(235854));
    });
  });

}
