# The Assimp-Model-Database
The Asset-Importer-Lib Model-Database - a collection of free models, links to common model-databases, free or commercials,
other importer libraries and model specifications. If you need to start working on a special format you can use this list to find useful resources (WIP).

## The Model-Database
See [Model-Database](https://github.com/assimp/assimp-mdb/tree/master/model-db/) to find the free models provided by us. Feel free to provide yours!

## The Model knowledge base
- [The Asset-Importer-Lib knowledge wiki](https://github.com/assimp/assimp/wiki/The-asset-knowledge-base) - The collection of specs collected by the Asset-Importer-Library contributors.
- [glTF](https://github.com/KhronosGroup/glTF) - glTF – Runtime 3D Asset Delivery

## List of awesome free and commercial Model-Databases
- [The assimp test models](https://github.com/assimp/assimp/tree/master/test/models) - All the test models provided by the Asset-Importer-Lib
- [Open3DModels](http://open3dmodel.com/) - Another free model database containing a lo of models, scenes and mre in different formmats
- [TurboSquid free mode database](https://www.turbosquid.com/Search/3D-Models/free) - 3D models for free.
- [Sketchfab](https://sketchfab.com) - Publish ad find 3D-models online
- [glTF Tests](https://github.com/KhronosGroup/glTF-Sample-Models) - The glFT test model database from the Kronos-Group, includes 1.0 and 2.0 models.
- [The 3MF-samples](https://github.com/3MFConsortium/3mf-samples) - The 3MF Samples repository.
- [Free3D Model database](https://free3d.com/) - Free 3D-models to download.
- [The Stanford 3D Scanning Repository](http://graphics.stanford.edu/data/3Dscanrep/) - The famous Standforf 3D Scanning Repository, contains a lot of widely used models like the bunny or the dragon.
- [3MF-Models for money](https://www.cgtrader.com/3d-models/ext/3mf) - Download 3D Manufacturing File (3MF) file format 3D assets
- [CadNav](http://www.cadnav.com/) - CADnav is the online 3D Models Library for CGI graphic designers and CAD/CAM/CAE engineers

## List of awesome model importer libraries
- [The Asset-Importer-Lib](http://www.assimp.org/) - Open Asset Import Library (short name: Assimp) is a portable Open Source library to import various well-known 3D model formats in a uniform manner. The most recent version also knows how to export 3d files and is therefore suitable as a general-purpose 3D model converter.
- [OpenFBX](https://github.com/nem0/OpenFBX) - Lightweight open source FBX importer
- [FBX](https://github.com/jskorepa/fbx) - C++ Library for reading and writing FBX files
- [fbx](https://github.com/origamicomet/fbx) -  Single-file binary FBX importer.
- [StepCode](https://github.com/stepcode/stepcode) - STEPcode (formerly NIST's STEP Class Library) is used with IFC, STEP, and other standards that utilize the technologies of ISO10303 (STEP). It generates C++ and Python from EXPRESS (10303-11) schemas. The code is capable of reading and writing STEP Part 21 exchange files. It also utilizes Parts 22 and 23 (SDAI and its C++ binding). http://stepcode.org
- [TinyGLTF](https://github.com/syoyo/tinygltf) - Header only C++11 tiny glTF 2.0 library
- [glTF-Toolkit](https://github.com/Microsoft/glTF-Toolkit) - A collection of tools for modifying and optimizing glTF assets
- [FBX2glTF](https://github.com/facebookincubator/FBX2glTF) - A command-line tool for the conversion of 3D model assets on the FBX file format to the glTF file format.
- [IfcOpenShell](IfcOpenShell) - Open source IFC library and geometry engine
- [Meshoptimizer](https://github.com/zeux/meshoptimizer) - Mesh optimization library that makes meshes smaller and faster to render
- [lib3mf](https://github.com/3MFConsortium/lib3mf) - Lib3MF is the reference implementation of the 3D Manufacturing Format file standard http://3mf.io
- [Mesh-processing-library](https://github.com/Microsoft/Mesh-processing-library) - C++ library and programs that demonstrate mesh processing techniques in computer graphics published at ACM SIGGRAPH in 1992–1998

## List of awesome model / asset utility libraries and applications
- [binary-gltf-utils](https://github.com/Qantas94Heavy/binary-gltf-utils) - Bundles glTF models, images, shaders and other assets into a Binary glTF (.glb) file.
- [Blender](https://www.blender.org/) - A free and OS-based 3D-modeling software for modeling, animations and more.
- [Free-CAD](https://www.freecadweb.org/) - A free and OS-based CAD system.

## How to contribute
- Clone from this repository 
- Prepare a branch with your model in it. Place the model at the model-bd, select the name of the format in the folder and create another
  folder with the name of your model. If you want o share some special information abou the model add a readme-file.
- Create a pull-request
- The pull-request will be reviewed and merged afterwards. We will add your name to the list of contributors.
