import 'dart:ffi';
import 'dart:typed_data';
import 'package:ffi/ffi.dart';
import 'package:test/test.dart';
import '../lib/assimp.dart';
import '../lib/src/bindings.dart';
import 'test_utils.dart';

// DO NOT EDIT (generated by tool/testgen)

void main() {
  prepareTest();

  test('null', () {
    expect(Mesh.fromNative(null), isNull);
  });

  test('size', () {
    expect(sizeOf<aiMesh>(), equals(1312));
  });

  test('equals', () {
    final a = Mesh.fromNative(allocate<aiMesh>());
    final b = Mesh.fromNative(allocate<aiMesh>());
    expect(a, equals(a));
    expect(b, equals(b));
    expect(a, isNot(equals(b)));
    expect(b, isNot(equals(a)));
  });

  test('toString', () {
    expect(Mesh.fromNative(allocate<aiMesh>()).toString(), matches(r'Mesh\(Pointer<aiMesh>: address=0x[0-f]+\)'));
  });

  test('3mf', () {
    testScene('3mf/box.3mf', (scene) {
      final meshes = scene.meshes;
      expect(meshes, isNotEmpty);
      expect(meshes.length, equals(1));
      final mesh_0 = meshes.elementAt(0);
      expect(mesh_0.primitiveTypes, isZero);
      expect(mesh_0.vertices.length, equals(8));
      final vertex_0_0 = mesh_0.vertices.elementAt(0);
      expect(vertex_0_0, vector3MoreOrLessEquals(Vector3(10, 0, 0)));
      final vertex_0_1 = mesh_0.vertices.elementAt(1);
      expect(vertex_0_1, vector3MoreOrLessEquals(Vector3(10, 20, 0)));
      final vertex_0_2 = mesh_0.vertices.elementAt(2);
      expect(vertex_0_2, vector3MoreOrLessEquals(Vector3(0, 20, 0)));
      final vertex_0_3 = mesh_0.vertices.elementAt(3);
      expect(vertex_0_3, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final vertex_0_4 = mesh_0.vertices.elementAt(4);
      expect(vertex_0_4, vector3MoreOrLessEquals(Vector3(10, 20, 30)));
      final vertex_0_5 = mesh_0.vertices.elementAt(5);
      expect(vertex_0_5, vector3MoreOrLessEquals(Vector3(10, 0, 30)));
      final vertex_0_6 = mesh_0.vertices.elementAt(6);
      expect(vertex_0_6, vector3MoreOrLessEquals(Vector3(0, 0, 30)));
      final vertex_0_7 = mesh_0.vertices.elementAt(7);
      expect(vertex_0_7, vector3MoreOrLessEquals(Vector3(0, 20, 30)));
      expect(mesh_0.normals.length, isZero);
      expect(mesh_0.tangents.length, isZero);
      expect(mesh_0.bitangents.length, isZero);
      expect(mesh_0.colors.length, isZero);
      expect(mesh_0.textureCoords.length, isZero);
      expect(mesh_0.uvComponents.length, isZero);
      expect(mesh_0.uvComponents, equals([]));
      expect(mesh_0.faces.length, isZero);
      expect(mesh_0.bones.length, isZero);
      expect(mesh_0.materialIndex, isZero);
      expect(mesh_0.name, isEmpty);
      expect(mesh_0.animMeshes.length, isZero);
      expect(mesh_0.morphingMethod, isZero);
      expect(mesh_0.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));
    });
    testScene('3mf/spider.3mf', (scene) {
      final meshes = scene.meshes;
      expect(meshes, isNotEmpty);
      expect(meshes.length, equals(19));
      final mesh_0 = meshes.elementAt(0);
      expect(mesh_0.primitiveTypes, equals(4));
      expect(mesh_0.vertices.length, equals(71));
      final vertex_0_0 = mesh_0.vertices.elementAt(0);
      expect(vertex_0_0, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, 5.61962)));
      final vertex_0_1 = mesh_0.vertices.elementAt(1);
      expect(vertex_0_1, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_2 = mesh_0.vertices.elementAt(2);
      expect(vertex_0_2, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, 6.44917)));
      final vertex_0_3 = mesh_0.vertices.elementAt(3);
      expect(vertex_0_3, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -0.537529)));
      final vertex_0_4 = mesh_0.vertices.elementAt(4);
      expect(vertex_0_4, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, 11.4516)));
      final vertex_0_5 = mesh_0.vertices.elementAt(5);
      expect(vertex_0_5, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, 3.41483)));
      final vertex_0_6 = mesh_0.vertices.elementAt(6);
      expect(vertex_0_6, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -4.34285)));
      final vertex_0_7 = mesh_0.vertices.elementAt(7);
      expect(vertex_0_7, vector3MoreOrLessEquals(Vector3(-8.12036, 15.6845, -10.5)));
      final vertex_0_8 = mesh_0.vertices.elementAt(8);
      expect(vertex_0_8, vector3MoreOrLessEquals(Vector3(-9.87648, 2.96156, -10.5)));
      final vertex_0_9 = mesh_0.vertices.elementAt(9);
      expect(vertex_0_9, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -16.6571)));
      final vertex_0_10 = mesh_0.vertices.elementAt(10);
      expect(vertex_0_10, vector3MoreOrLessEquals(Vector3(12.9532, 36.8733, -11.5)));
      final vertex_0_11 = mesh_0.vertices.elementAt(11);
      expect(vertex_0_11, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -2.73328)));
      final vertex_0_12 = mesh_0.vertices.elementAt(12);
      expect(vertex_0_12, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, -26.4148)));
      final vertex_0_13 = mesh_0.vertices.elementAt(13);
      expect(vertex_0_13, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -20.2667)));
      final vertex_0_14 = mesh_0.vertices.elementAt(14);
      expect(vertex_0_14, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -20.4625)));
      final vertex_0_15 = mesh_0.vertices.elementAt(15);
      expect(vertex_0_15, vector3MoreOrLessEquals(Vector3(-8.12036, 15.6845, -10.5)));
      final vertex_0_16 = mesh_0.vertices.elementAt(16);
      expect(vertex_0_16, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, -26.6196)));
      final vertex_0_17 = mesh_0.vertices.elementAt(17);
      expect(vertex_0_17, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, -34.4516)));
      final vertex_0_18 = mesh_0.vertices.elementAt(18);
      expect(vertex_0_18, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, -34.4516)));
      final vertex_0_19 = mesh_0.vertices.elementAt(19);
      expect(vertex_0_19, vector3MoreOrLessEquals(Vector3(44.3013, 33.9647, -11.5)));
      final vertex_0_20 = mesh_0.vertices.elementAt(20);
      expect(vertex_0_20, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, -25.6848)));
      final vertex_0_21 = mesh_0.vertices.elementAt(21);
      expect(vertex_0_21, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, -35.6327)));
      final vertex_0_22 = mesh_0.vertices.elementAt(22);
      expect(vertex_0_22, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, -39.8697)));
      final vertex_0_23 = mesh_0.vertices.elementAt(23);
      expect(vertex_0_23, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, -39.8697)));
      final vertex_0_24 = mesh_0.vertices.elementAt(24);
      expect(vertex_0_24, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, -27.4492)));
      final vertex_0_25 = mesh_0.vertices.elementAt(25);
      expect(vertex_0_25, vector3MoreOrLessEquals(Vector3(-9.87648, 2.96156, -10.5)));
      final vertex_0_26 = mesh_0.vertices.elementAt(26);
      expect(vertex_0_26, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, -25.6848)));
      final vertex_0_27 = mesh_0.vertices.elementAt(27);
      expect(vertex_0_27, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      final vertex_0_28 = mesh_0.vertices.elementAt(28);
      expect(vertex_0_28, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      final vertex_0_29 = mesh_0.vertices.elementAt(29);
      expect(vertex_0_29, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, 2.68485)));
      final vertex_0_30 = mesh_0.vertices.elementAt(30);
      expect(vertex_0_30, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, 11.4516)));
      final vertex_0_31 = mesh_0.vertices.elementAt(31);
      expect(vertex_0_31, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, 12.6327)));
      final vertex_0_32 = mesh_0.vertices.elementAt(32);
      expect(vertex_0_32, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, 2.68485)));
      final vertex_0_33 = mesh_0.vertices.elementAt(33);
      expect(vertex_0_33, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      final vertex_0_34 = mesh_0.vertices.elementAt(34);
      expect(vertex_0_34, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_35 = mesh_0.vertices.elementAt(35);
      expect(vertex_0_35, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, 2.68485)));
      final vertex_0_36 = mesh_0.vertices.elementAt(36);
      expect(vertex_0_36, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      final vertex_0_37 = mesh_0.vertices.elementAt(37);
      expect(vertex_0_37, vector3MoreOrLessEquals(Vector3(54.5036, 5.93402, -11.5)));
      final vertex_0_38 = mesh_0.vertices.elementAt(38);
      expect(vertex_0_38, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -2.73328)));
      final vertex_0_39 = mesh_0.vertices.elementAt(39);
      expect(vertex_0_39, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, 11.4516)));
      final vertex_0_40 = mesh_0.vertices.elementAt(40);
      expect(vertex_0_40, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, 12.6327)));
      final vertex_0_41 = mesh_0.vertices.elementAt(41);
      expect(vertex_0_41, vector3MoreOrLessEquals(Vector3(32.3592, -16.4443, -11.5)));
      final vertex_0_42 = mesh_0.vertices.elementAt(42);
      expect(vertex_0_42, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, 3.41483)));
      final vertex_0_43 = mesh_0.vertices.elementAt(43);
      expect(vertex_0_43, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -20.2667)));
      final vertex_0_44 = mesh_0.vertices.elementAt(44);
      expect(vertex_0_44, vector3MoreOrLessEquals(Vector3(54.5036, 5.93402, -11.5)));
      final vertex_0_45 = mesh_0.vertices.elementAt(45);
      expect(vertex_0_45, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_46 = mesh_0.vertices.elementAt(46);
      expect(vertex_0_46, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -4.34285)));
      final vertex_0_47 = mesh_0.vertices.elementAt(47);
      expect(vertex_0_47, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, 5.61962)));
      final vertex_0_48 = mesh_0.vertices.elementAt(48);
      expect(vertex_0_48, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, 11.4516)));
      final vertex_0_49 = mesh_0.vertices.elementAt(49);
      expect(vertex_0_49, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -16.6571)));
      final vertex_0_50 = mesh_0.vertices.elementAt(50);
      expect(vertex_0_50, vector3MoreOrLessEquals(Vector3(-4.68149, -8.78444, -10.5)));
      final vertex_0_51 = mesh_0.vertices.elementAt(51);
      expect(vertex_0_51, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -0.537529)));
      final vertex_0_52 = mesh_0.vertices.elementAt(52);
      expect(vertex_0_52, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, 6.44917)));
      final vertex_0_53 = mesh_0.vertices.elementAt(53);
      expect(vertex_0_53, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_54 = mesh_0.vertices.elementAt(54);
      expect(vertex_0_54, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_55 = mesh_0.vertices.elementAt(55);
      expect(vertex_0_55, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -0.537529)));
      final vertex_0_56 = mesh_0.vertices.elementAt(56);
      expect(vertex_0_56, vector3MoreOrLessEquals(Vector3(-9.87648, 2.96156, -10.5)));
      final vertex_0_57 = mesh_0.vertices.elementAt(57);
      expect(vertex_0_57, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -20.4625)));
      final vertex_0_58 = mesh_0.vertices.elementAt(58);
      expect(vertex_0_58, vector3MoreOrLessEquals(Vector3(-9.87648, 2.96156, -10.5)));
      final vertex_0_59 = mesh_0.vertices.elementAt(59);
      expect(vertex_0_59, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -20.4625)));
      final vertex_0_60 = mesh_0.vertices.elementAt(60);
      expect(vertex_0_60, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, -27.4492)));
      final vertex_0_61 = mesh_0.vertices.elementAt(61);
      expect(vertex_0_61, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, -26.6196)));
      final vertex_0_62 = mesh_0.vertices.elementAt(62);
      expect(vertex_0_62, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, -39.8697)));
      final vertex_0_63 = mesh_0.vertices.elementAt(63);
      expect(vertex_0_63, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, -34.4516)));
      final vertex_0_64 = mesh_0.vertices.elementAt(64);
      expect(vertex_0_64, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, -26.4148)));
      final vertex_0_65 = mesh_0.vertices.elementAt(65);
      expect(vertex_0_65, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, -34.4516)));
      final vertex_0_66 = mesh_0.vertices.elementAt(66);
      expect(vertex_0_66, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, -25.6848)));
      final vertex_0_67 = mesh_0.vertices.elementAt(67);
      expect(vertex_0_67, vector3MoreOrLessEquals(Vector3(54.5036, 5.93402, -11.5)));
      final vertex_0_68 = mesh_0.vertices.elementAt(68);
      expect(vertex_0_68, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, -39.8697)));
      final vertex_0_69 = mesh_0.vertices.elementAt(69);
      expect(vertex_0_69, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, -35.6327)));
      final vertex_0_70 = mesh_0.vertices.elementAt(70);
      expect(vertex_0_70, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      expect(mesh_0.normals.length, isZero);
      expect(mesh_0.tangents.length, isZero);
      expect(mesh_0.bitangents.length, isZero);
      expect(mesh_0.colors.length, isZero);
      expect(mesh_0.textureCoords.length, isZero);
      expect(mesh_0.uvComponents.length, isZero);
      expect(mesh_0.uvComponents, equals([]));
      expect(mesh_0.faces.length, equals(80));
      expect(mesh_0.bones.length, isZero);
      expect(mesh_0.materialIndex, equals(1));
      expect(mesh_0.name, equals('HLeib01'));
      expect(mesh_0.animMeshes.length, isZero);
      expect(mesh_0.morphingMethod, isZero);
      expect(mesh_0.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_1 = meshes.elementAt(1);
      expect(mesh_1.primitiveTypes, equals(4));
      expect(mesh_1.vertices.length, equals(93));
      final vertex_1_0 = mesh_1.vertices.elementAt(0);
      expect(vertex_1_0, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, 8.47976)));
      final vertex_1_1 = mesh_1.vertices.elementAt(1);
      expect(vertex_1_1, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, 3.08142)));
      final vertex_1_2 = mesh_1.vertices.elementAt(2);
      expect(vertex_1_2, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, 9.43077)));
      final vertex_1_3 = mesh_1.vertices.elementAt(3);
      expect(vertex_1_3, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, 0.583091)));
      final vertex_1_4 = mesh_1.vertices.elementAt(4);
      expect(vertex_1_4, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, 0.583091)));
      final vertex_1_5 = mesh_1.vertices.elementAt(5);
      expect(vertex_1_5, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, 8.47976)));
      final vertex_1_6 = mesh_1.vertices.elementAt(6);
      expect(vertex_1_6, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -3.12269)));
      final vertex_1_7 = mesh_1.vertices.elementAt(7);
      expect(vertex_1_7, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -2.94136)));
      final vertex_1_8 = mesh_1.vertices.elementAt(8);
      expect(vertex_1_8, vector3MoreOrLessEquals(Vector3(-23.7785, 14.1423, -10)));
      final vertex_1_9 = mesh_1.vertices.elementAt(9);
      expect(vertex_1_9, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -5.95762)));
      final vertex_1_10 = mesh_1.vertices.elementAt(10);
      expect(vertex_1_10, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, 3.08142)));
      final vertex_1_11 = mesh_1.vertices.elementAt(11);
      expect(vertex_1_11, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, 1.12772)));
      final vertex_1_12 = mesh_1.vertices.elementAt(12);
      expect(vertex_1_12, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -0.594703)));
      final vertex_1_13 = mesh_1.vertices.elementAt(13);
      expect(vertex_1_13, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -14.0424)));
      final vertex_1_14 = mesh_1.vertices.elementAt(14);
      expect(vertex_1_14, vector3MoreOrLessEquals(Vector3(-1.33709, 1.10811, -10)));
      final vertex_1_15 = mesh_1.vertices.elementAt(15);
      expect(vertex_1_15, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_16 = mesh_1.vertices.elementAt(16);
      expect(vertex_1_16, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -19.4053)));
      final vertex_1_17 = mesh_1.vertices.elementAt(17);
      expect(vertex_1_17, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_18 = mesh_1.vertices.elementAt(18);
      expect(vertex_1_18, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -16.8773)));
      final vertex_1_19 = mesh_1.vertices.elementAt(19);
      expect(vertex_1_19, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, -20.5831)));
      final vertex_1_20 = mesh_1.vertices.elementAt(20);
      expect(vertex_1_20, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, -21.1277)));
      final vertex_1_21 = mesh_1.vertices.elementAt(21);
      expect(vertex_1_21, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, -28.4798)));
      final vertex_1_22 = mesh_1.vertices.elementAt(22);
      expect(vertex_1_22, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, -23.0814)));
      final vertex_1_23 = mesh_1.vertices.elementAt(23);
      expect(vertex_1_23, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -17.0586)));
      final vertex_1_24 = mesh_1.vertices.elementAt(24);
      expect(vertex_1_24, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, -21.4211)));
      final vertex_1_25 = mesh_1.vertices.elementAt(25);
      expect(vertex_1_25, vector3MoreOrLessEquals(Vector3(-44.8447, 15.2285, -10)));
      final vertex_1_26 = mesh_1.vertices.elementAt(26);
      expect(vertex_1_26, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_27 = mesh_1.vertices.elementAt(27);
      expect(vertex_1_27, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, -28.4798)));
      final vertex_1_28 = mesh_1.vertices.elementAt(28);
      expect(vertex_1_28, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, -29.4308)));
      final vertex_1_29 = mesh_1.vertices.elementAt(29);
      expect(vertex_1_29, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, 1.42112)));
      final vertex_1_30 = mesh_1.vertices.elementAt(30);
      expect(vertex_1_30, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_31 = mesh_1.vertices.elementAt(31);
      expect(vertex_1_31, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, 8.47976)));
      final vertex_1_32 = mesh_1.vertices.elementAt(32);
      expect(vertex_1_32, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, 9.43077)));
      final vertex_1_33 = mesh_1.vertices.elementAt(33);
      expect(vertex_1_33, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, -28.4798)));
      final vertex_1_34 = mesh_1.vertices.elementAt(34);
      expect(vertex_1_34, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, -29.4308)));
      final vertex_1_35 = mesh_1.vertices.elementAt(35);
      expect(vertex_1_35, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, -20.5831)));
      final vertex_1_36 = mesh_1.vertices.elementAt(36);
      expect(vertex_1_36, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, -23.0814)));
      final vertex_1_37 = mesh_1.vertices.elementAt(37);
      expect(vertex_1_37, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, 8.47976)));
      final vertex_1_38 = mesh_1.vertices.elementAt(38);
      expect(vertex_1_38, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, 9.43077)));
      final vertex_1_39 = mesh_1.vertices.elementAt(39);
      expect(vertex_1_39, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, 0.583091)));
      final vertex_1_40 = mesh_1.vertices.elementAt(40);
      expect(vertex_1_40, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, 3.08142)));
      final vertex_1_41 = mesh_1.vertices.elementAt(41);
      expect(vertex_1_41, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -0.594703)));
      final vertex_1_42 = mesh_1.vertices.elementAt(42);
      expect(vertex_1_42, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_43 = mesh_1.vertices.elementAt(43);
      expect(vertex_1_43, vector3MoreOrLessEquals(Vector3(-6.30518, -14.1821, -10)));
      final vertex_1_44 = mesh_1.vertices.elementAt(44);
      expect(vertex_1_44, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, 0.583091)));
      final vertex_1_45 = mesh_1.vertices.elementAt(45);
      expect(vertex_1_45, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, 1.12772)));
      final vertex_1_46 = mesh_1.vertices.elementAt(46);
      expect(vertex_1_46, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, 3.08142)));
      final vertex_1_47 = mesh_1.vertices.elementAt(47);
      expect(vertex_1_47, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, 8.47976)));
      final vertex_1_48 = mesh_1.vertices.elementAt(48);
      expect(vertex_1_48, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -3.12269)));
      final vertex_1_49 = mesh_1.vertices.elementAt(49);
      expect(vertex_1_49, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -19.4053)));
      final vertex_1_50 = mesh_1.vertices.elementAt(50);
      expect(vertex_1_50, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -19.4053)));
      final vertex_1_51 = mesh_1.vertices.elementAt(51);
      expect(vertex_1_51, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -0.594703)));
      final vertex_1_52 = mesh_1.vertices.elementAt(52);
      expect(vertex_1_52, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -0.594703)));
      final vertex_1_53 = mesh_1.vertices.elementAt(53);
      expect(vertex_1_53, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, 1.12772)));
      final vertex_1_54 = mesh_1.vertices.elementAt(54);
      expect(vertex_1_54, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -0.594703)));
      final vertex_1_55 = mesh_1.vertices.elementAt(55);
      expect(vertex_1_55, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -0.594703)));
      final vertex_1_56 = mesh_1.vertices.elementAt(56);
      expect(vertex_1_56, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_57 = mesh_1.vertices.elementAt(57);
      expect(vertex_1_57, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -19.4053)));
      final vertex_1_58 = mesh_1.vertices.elementAt(58);
      expect(vertex_1_58, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -19.4053)));
      final vertex_1_59 = mesh_1.vertices.elementAt(59);
      expect(vertex_1_59, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, -21.1277)));
      final vertex_1_60 = mesh_1.vertices.elementAt(60);
      expect(vertex_1_60, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_61 = mesh_1.vertices.elementAt(61);
      expect(vertex_1_61, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -19.4053)));
      final vertex_1_62 = mesh_1.vertices.elementAt(62);
      expect(vertex_1_62, vector3MoreOrLessEquals(Vector3(-6.30518, -14.1821, -10)));
      final vertex_1_63 = mesh_1.vertices.elementAt(63);
      expect(vertex_1_63, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, -20.5831)));
      final vertex_1_64 = mesh_1.vertices.elementAt(64);
      expect(vertex_1_64, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, -21.1277)));
      final vertex_1_65 = mesh_1.vertices.elementAt(65);
      expect(vertex_1_65, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, -28.4798)));
      final vertex_1_66 = mesh_1.vertices.elementAt(66);
      expect(vertex_1_66, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -16.8773)));
      final vertex_1_67 = mesh_1.vertices.elementAt(67);
      expect(vertex_1_67, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, -23.0814)));
      final vertex_1_68 = mesh_1.vertices.elementAt(68);
      expect(vertex_1_68, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, -23.0814)));
      final vertex_1_69 = mesh_1.vertices.elementAt(69);
      expect(vertex_1_69, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, -28.4798)));
      final vertex_1_70 = mesh_1.vertices.elementAt(70);
      expect(vertex_1_70, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, -29.4308)));
      final vertex_1_71 = mesh_1.vertices.elementAt(71);
      expect(vertex_1_71, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, -20.5831)));
      final vertex_1_72 = mesh_1.vertices.elementAt(72);
      expect(vertex_1_72, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, 8.47976)));
      final vertex_1_73 = mesh_1.vertices.elementAt(73);
      expect(vertex_1_73, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, 1.42112)));
      final vertex_1_74 = mesh_1.vertices.elementAt(74);
      expect(vertex_1_74, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, 9.43077)));
      final vertex_1_75 = mesh_1.vertices.elementAt(75);
      expect(vertex_1_75, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_76 = mesh_1.vertices.elementAt(76);
      expect(vertex_1_76, vector3MoreOrLessEquals(Vector3(-51.6476, -5.70869, -10)));
      final vertex_1_77 = mesh_1.vertices.elementAt(77);
      expect(vertex_1_77, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, 1.42112)));
      final vertex_1_78 = mesh_1.vertices.elementAt(78);
      expect(vertex_1_78, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, 1.42112)));
      final vertex_1_79 = mesh_1.vertices.elementAt(79);
      expect(vertex_1_79, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, 9.43077)));
      final vertex_1_80 = mesh_1.vertices.elementAt(80);
      expect(vertex_1_80, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, 1.42112)));
      final vertex_1_81 = mesh_1.vertices.elementAt(81);
      expect(vertex_1_81, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_82 = mesh_1.vertices.elementAt(82);
      expect(vertex_1_82, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, 1.42112)));
      final vertex_1_83 = mesh_1.vertices.elementAt(83);
      expect(vertex_1_83, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, -21.4211)));
      final vertex_1_84 = mesh_1.vertices.elementAt(84);
      expect(vertex_1_84, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_85 = mesh_1.vertices.elementAt(85);
      expect(vertex_1_85, vector3MoreOrLessEquals(Vector3(-51.6476, -5.70869, -10)));
      final vertex_1_86 = mesh_1.vertices.elementAt(86);
      expect(vertex_1_86, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, -28.4798)));
      final vertex_1_87 = mesh_1.vertices.elementAt(87);
      expect(vertex_1_87, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, -29.4308)));
      final vertex_1_88 = mesh_1.vertices.elementAt(88);
      expect(vertex_1_88, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, -21.4211)));
      final vertex_1_89 = mesh_1.vertices.elementAt(89);
      expect(vertex_1_89, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, -21.4211)));
      final vertex_1_90 = mesh_1.vertices.elementAt(90);
      expect(vertex_1_90, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, -21.4211)));
      final vertex_1_91 = mesh_1.vertices.elementAt(91);
      expect(vertex_1_91, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, -21.4211)));
      final vertex_1_92 = mesh_1.vertices.elementAt(92);
      expect(vertex_1_92, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      expect(mesh_1.normals.length, isZero);
      expect(mesh_1.tangents.length, isZero);
      expect(mesh_1.bitangents.length, isZero);
      expect(mesh_1.colors.length, isZero);
      expect(mesh_1.textureCoords.length, isZero);
      expect(mesh_1.uvComponents.length, isZero);
      expect(mesh_1.uvComponents, equals([]));
      expect(mesh_1.faces.length, equals(60));
      expect(mesh_1.bones.length, isZero);
      expect(mesh_1.materialIndex, isZero);
      expect(mesh_1.name, equals('OK'));
      expect(mesh_1.animMeshes.length, isZero);
      expect(mesh_1.morphingMethod, isZero);
      expect(mesh_1.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_2 = meshes.elementAt(2);
      expect(mesh_2.primitiveTypes, equals(4));
      expect(mesh_2.vertices.length, equals(111));
      final vertex_2_0 = mesh_2.vertices.elementAt(0);
      expect(vertex_2_0, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_1 = mesh_2.vertices.elementAt(1);
      expect(vertex_2_1, vector3MoreOrLessEquals(Vector3(-41.9633, -2.24616, -18.4852)));
      final vertex_2_2 = mesh_2.vertices.elementAt(2);
      expect(vertex_2_2, vector3MoreOrLessEquals(Vector3(-40.6715, -3.47289, -21.3692)));
      final vertex_2_3 = mesh_2.vertices.elementAt(3);
      expect(vertex_2_3, vector3MoreOrLessEquals(Vector3(-87.9502, -39.4551, -104.26)));
      final vertex_2_4 = mesh_2.vertices.elementAt(4);
      expect(vertex_2_4, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_5 = mesh_2.vertices.elementAt(5);
      expect(vertex_2_5, vector3MoreOrLessEquals(Vector3(-87.6058, -39.9835, -104.352)));
      final vertex_2_6 = mesh_2.vertices.elementAt(6);
      expect(vertex_2_6, vector3MoreOrLessEquals(Vector3(-47.1467, 8.70439, -37.6816)));
      final vertex_2_7 = mesh_2.vertices.elementAt(7);
      expect(vertex_2_7, vector3MoreOrLessEquals(Vector3(-47.0984, 7.38926, -39.585)));
      final vertex_2_8 = mesh_2.vertices.elementAt(8);
      expect(vertex_2_8, vector3MoreOrLessEquals(Vector3(-40.6715, -3.47289, -21.3692)));
      final vertex_2_9 = mesh_2.vertices.elementAt(9);
      expect(vertex_2_9, vector3MoreOrLessEquals(Vector3(-41.9633, -2.24616, -18.4852)));
      final vertex_2_10 = mesh_2.vertices.elementAt(10);
      expect(vertex_2_10, vector3MoreOrLessEquals(Vector3(-55.4437, 28.017, -51.0206)));
      final vertex_2_11 = mesh_2.vertices.elementAt(11);
      expect(vertex_2_11, vector3MoreOrLessEquals(Vector3(-55.8051, 29.5003, -50.3606)));
      final vertex_2_12 = mesh_2.vertices.elementAt(12);
      expect(vertex_2_12, vector3MoreOrLessEquals(Vector3(-56.925, 29.8275, -49.5558)));
      final vertex_2_13 = mesh_2.vertices.elementAt(13);
      expect(vertex_2_13, vector3MoreOrLessEquals(Vector3(-48.8624, 8.96432, -36.1507)));
      final vertex_2_14 = mesh_2.vertices.elementAt(14);
      expect(vertex_2_14, vector3MoreOrLessEquals(Vector3(-57.933, 29.2079, -55.0394)));
      final vertex_2_15 = mesh_2.vertices.elementAt(15);
      expect(vertex_2_15, vector3MoreOrLessEquals(Vector3(-55.8051, 29.5003, -50.3606)));
      final vertex_2_16 = mesh_2.vertices.elementAt(16);
      expect(vertex_2_16, vector3MoreOrLessEquals(Vector3(-60.0122, 29.5602, -54.0867)));
      final vertex_2_17 = mesh_2.vertices.elementAt(17);
      expect(vertex_2_17, vector3MoreOrLessEquals(Vector3(-50.9535, 7.97335, -36.1451)));
      final vertex_2_18 = mesh_2.vertices.elementAt(18);
      expect(vertex_2_18, vector3MoreOrLessEquals(Vector3(-57.9601, 28.752, -49.2124)));
      final vertex_2_19 = mesh_2.vertices.elementAt(19);
      expect(vertex_2_19, vector3MoreOrLessEquals(Vector3(-61.0849, 28.3104, -52.4613)));
      final vertex_2_20 = mesh_2.vertices.elementAt(20);
      expect(vertex_2_20, vector3MoreOrLessEquals(Vector3(-57.9601, 28.752, -49.2124)));
      final vertex_2_21 = mesh_2.vertices.elementAt(21);
      expect(vertex_2_21, vector3MoreOrLessEquals(Vector3(-45.2746, -1.92132, -17.5626)));
      final vertex_2_22 = mesh_2.vertices.elementAt(22);
      expect(vertex_2_22, vector3MoreOrLessEquals(Vector3(-48.1119, -2.74297, -19.296)));
      final vertex_2_23 = mesh_2.vertices.elementAt(23);
      expect(vertex_2_23, vector3MoreOrLessEquals(Vector3(-48.3386, -4.0924, -22.3802)));
      final vertex_2_24 = mesh_2.vertices.elementAt(24);
      expect(vertex_2_24, vector3MoreOrLessEquals(Vector3(-51.8454, 6.4777, -37.669)));
      final vertex_2_25 = mesh_2.vertices.elementAt(25);
      expect(vertex_2_25, vector3MoreOrLessEquals(Vector3(-50.8665, 5.60359, -39.5749)));
      final vertex_2_26 = mesh_2.vertices.elementAt(26);
      expect(vertex_2_26, vector3MoreOrLessEquals(Vector3(-45.784, -4.95347, -24.4927)));
      final vertex_2_27 = mesh_2.vertices.elementAt(27);
      expect(vertex_2_27, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_28 = mesh_2.vertices.elementAt(28);
      expect(vertex_2_28, vector3MoreOrLessEquals(Vector3(-57.309, 26.0791, -50.4018)));
      final vertex_2_29 = mesh_2.vertices.elementAt(29);
      expect(vertex_2_29, vector3MoreOrLessEquals(Vector3(-58.346, 25.2666, -51.6732)));
      final vertex_2_30 = mesh_2.vertices.elementAt(30);
      expect(vertex_2_30, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_31 = mesh_2.vertices.elementAt(31);
      expect(vertex_2_31, vector3MoreOrLessEquals(Vector3(-56.113, 26.4944, -51.039)));
      final vertex_2_32 = mesh_2.vertices.elementAt(32);
      expect(vertex_2_32, vector3MoreOrLessEquals(Vector3(-56.113, 26.4944, -51.039)));
      final vertex_2_33 = mesh_2.vertices.elementAt(33);
      expect(vertex_2_33, vector3MoreOrLessEquals(Vector3(-60.3433, 26.3996, -51.3871)));
      final vertex_2_34 = mesh_2.vertices.elementAt(34);
      expect(vertex_2_34, vector3MoreOrLessEquals(Vector3(-72.0687, 14.2065, -79.3609)));
      final vertex_2_35 = mesh_2.vertices.elementAt(35);
      expect(vertex_2_35, vector3MoreOrLessEquals(Vector3(-72.8725, 13.6618, -77.2604)));
      final vertex_2_36 = mesh_2.vertices.elementAt(36);
      expect(vertex_2_36, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_37 = mesh_2.vertices.elementAt(37);
      expect(vertex_2_37, vector3MoreOrLessEquals(Vector3(-71.6997, 12.8818, -75.4244)));
      final vertex_2_38 = mesh_2.vertices.elementAt(38);
      expect(vertex_2_38, vector3MoreOrLessEquals(Vector3(-61.0849, 28.3104, -52.4613)));
      final vertex_2_39 = mesh_2.vertices.elementAt(39);
      expect(vertex_2_39, vector3MoreOrLessEquals(Vector3(-83.2428, -30.649, -99.5034)));
      final vertex_2_40 = mesh_2.vertices.elementAt(40);
      expect(vertex_2_40, vector3MoreOrLessEquals(Vector3(-69.4333, 12.454, -75.2354)));
      final vertex_2_41 = mesh_2.vertices.elementAt(41);
      expect(vertex_2_41, vector3MoreOrLessEquals(Vector3(-81.2603, -33.4162, -99.5484)));
      final vertex_2_42 = mesh_2.vertices.elementAt(42);
      expect(vertex_2_42, vector3MoreOrLessEquals(Vector3(-83.4747, -29.5186, -100.471)));
      final vertex_2_43 = mesh_2.vertices.elementAt(43);
      expect(vertex_2_43, vector3MoreOrLessEquals(Vector3(-88.235, -39.3502, -103.866)));
      final vertex_2_44 = mesh_2.vertices.elementAt(44);
      expect(vertex_2_44, vector3MoreOrLessEquals(Vector3(-88.2457, -39.7477, -103.466)));
      final vertex_2_45 = mesh_2.vertices.elementAt(45);
      expect(vertex_2_45, vector3MoreOrLessEquals(Vector3(-71.6997, 12.8818, -75.4244)));
      final vertex_2_46 = mesh_2.vertices.elementAt(46);
      expect(vertex_2_46, vector3MoreOrLessEquals(Vector3(-82.2572, -32.3836, -99.0929)));
      final vertex_2_47 = mesh_2.vertices.elementAt(47);
      expect(vertex_2_47, vector3MoreOrLessEquals(Vector3(-87.9744, -40.3484, -103.362)));
      final vertex_2_48 = mesh_2.vertices.elementAt(48);
      expect(vertex_2_48, vector3MoreOrLessEquals(Vector3(-87.9502, -39.4551, -104.26)));
      final vertex_2_49 = mesh_2.vertices.elementAt(49);
      expect(vertex_2_49, vector3MoreOrLessEquals(Vector3(-82.7785, -29.8435, -101.267)));
      final vertex_2_50 = mesh_2.vertices.elementAt(50);
      expect(vertex_2_50, vector3MoreOrLessEquals(Vector3(-83.4747, -29.5186, -100.471)));
      final vertex_2_51 = mesh_2.vertices.elementAt(51);
      expect(vertex_2_51, vector3MoreOrLessEquals(Vector3(-87.6058, -39.9835, -104.352)));
      final vertex_2_52 = mesh_2.vertices.elementAt(52);
      expect(vertex_2_52, vector3MoreOrLessEquals(Vector3(-81.6783, -31.3792, -101.292)));
      final vertex_2_53 = mesh_2.vertices.elementAt(53);
      expect(vertex_2_53, vector3MoreOrLessEquals(Vector3(-67.985, 13.4356, -79.0204)));
      final vertex_2_54 = mesh_2.vertices.elementAt(54);
      expect(vertex_2_54, vector3MoreOrLessEquals(Vector3(-69.8936, 14.1058, -80.1441)));
      final vertex_2_55 = mesh_2.vertices.elementAt(55);
      expect(vertex_2_55, vector3MoreOrLessEquals(Vector3(-56.413, 27.5188, -54.6021)));
      final vertex_2_56 = mesh_2.vertices.elementAt(56);
      expect(vertex_2_56, vector3MoreOrLessEquals(Vector3(-82.7785, -29.8435, -101.267)));
      final vertex_2_57 = mesh_2.vertices.elementAt(57);
      expect(vertex_2_57, vector3MoreOrLessEquals(Vector3(-55.4437, 28.017, -51.0206)));
      final vertex_2_58 = mesh_2.vertices.elementAt(58);
      expect(vertex_2_58, vector3MoreOrLessEquals(Vector3(-57.933, 29.2079, -55.0394)));
      final vertex_2_59 = mesh_2.vertices.elementAt(59);
      expect(vertex_2_59, vector3MoreOrLessEquals(Vector3(-81.2603, -33.4162, -99.5484)));
      final vertex_2_60 = mesh_2.vertices.elementAt(60);
      expect(vertex_2_60, vector3MoreOrLessEquals(Vector3(-87.6253, -40.6998, -103.631)));
      final vertex_2_61 = mesh_2.vertices.elementAt(61);
      expect(vertex_2_61, vector3MoreOrLessEquals(Vector3(-67.7802, 12.7004, -76.8358)));
      final vertex_2_62 = mesh_2.vertices.elementAt(62);
      expect(vertex_2_62, vector3MoreOrLessEquals(Vector3(-81.0026, -32.9692, -100.527)));
      final vertex_2_63 = mesh_2.vertices.elementAt(63);
      expect(vertex_2_63, vector3MoreOrLessEquals(Vector3(-87.4612, -40.5375, -104.072)));
      final vertex_2_64 = mesh_2.vertices.elementAt(64);
      expect(vertex_2_64, vector3MoreOrLessEquals(Vector3(-56.5968, 25.7647, -53.104)));
      final vertex_2_65 = mesh_2.vertices.elementAt(65);
      expect(vertex_2_65, vector3MoreOrLessEquals(Vector3(-56.413, 27.5188, -54.6021)));
      final vertex_2_66 = mesh_2.vertices.elementAt(66);
      expect(vertex_2_66, vector3MoreOrLessEquals(Vector3(-55.4437, 28.017, -51.0206)));
      final vertex_2_67 = mesh_2.vertices.elementAt(67);
      expect(vertex_2_67, vector3MoreOrLessEquals(Vector3(-67.985, 13.4356, -79.0204)));
      final vertex_2_68 = mesh_2.vertices.elementAt(68);
      expect(vertex_2_68, vector3MoreOrLessEquals(Vector3(-48.7538, 6.00928, -40.4276)));
      final vertex_2_69 = mesh_2.vertices.elementAt(69);
      expect(vertex_2_69, vector3MoreOrLessEquals(Vector3(-47.0984, 7.38926, -39.585)));
      final vertex_2_70 = mesh_2.vertices.elementAt(70);
      expect(vertex_2_70, vector3MoreOrLessEquals(Vector3(-55.4437, 28.017, -51.0206)));
      final vertex_2_71 = mesh_2.vertices.elementAt(71);
      expect(vertex_2_71, vector3MoreOrLessEquals(Vector3(-42.3719, -4.67776, -24.0427)));
      final vertex_2_72 = mesh_2.vertices.elementAt(72);
      expect(vertex_2_72, vector3MoreOrLessEquals(Vector3(-40.6715, -3.47289, -21.3692)));
      final vertex_2_73 = mesh_2.vertices.elementAt(73);
      expect(vertex_2_73, vector3MoreOrLessEquals(Vector3(-81.6783, -31.3792, -101.292)));
      final vertex_2_74 = mesh_2.vertices.elementAt(74);
      expect(vertex_2_74, vector3MoreOrLessEquals(Vector3(-87.6058, -39.9835, -104.352)));
      final vertex_2_75 = mesh_2.vertices.elementAt(75);
      expect(vertex_2_75, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_76 = mesh_2.vertices.elementAt(76);
      expect(vertex_2_76, vector3MoreOrLessEquals(Vector3(-45.2746, -1.92132, -17.5626)));
      final vertex_2_77 = mesh_2.vertices.elementAt(77);
      expect(vertex_2_77, vector3MoreOrLessEquals(Vector3(-41.9633, -2.24616, -18.4852)));
      final vertex_2_78 = mesh_2.vertices.elementAt(78);
      expect(vertex_2_78, vector3MoreOrLessEquals(Vector3(-88.235, -39.3502, -103.866)));
      final vertex_2_79 = mesh_2.vertices.elementAt(79);
      expect(vertex_2_79, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_80 = mesh_2.vertices.elementAt(80);
      expect(vertex_2_80, vector3MoreOrLessEquals(Vector3(-87.9502, -39.4551, -104.26)));
      final vertex_2_81 = mesh_2.vertices.elementAt(81);
      expect(vertex_2_81, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_82 = mesh_2.vertices.elementAt(82);
      expect(vertex_2_82, vector3MoreOrLessEquals(Vector3(-48.1119, -2.74297, -19.296)));
      final vertex_2_83 = mesh_2.vertices.elementAt(83);
      expect(vertex_2_83, vector3MoreOrLessEquals(Vector3(-45.2746, -1.92132, -17.5626)));
      final vertex_2_84 = mesh_2.vertices.elementAt(84);
      expect(vertex_2_84, vector3MoreOrLessEquals(Vector3(-88.2457, -39.7477, -103.466)));
      final vertex_2_85 = mesh_2.vertices.elementAt(85);
      expect(vertex_2_85, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_86 = mesh_2.vertices.elementAt(86);
      expect(vertex_2_86, vector3MoreOrLessEquals(Vector3(-88.235, -39.3502, -103.866)));
      final vertex_2_87 = mesh_2.vertices.elementAt(87);
      expect(vertex_2_87, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_88 = mesh_2.vertices.elementAt(88);
      expect(vertex_2_88, vector3MoreOrLessEquals(Vector3(-48.3386, -4.0924, -22.3802)));
      final vertex_2_89 = mesh_2.vertices.elementAt(89);
      expect(vertex_2_89, vector3MoreOrLessEquals(Vector3(-48.1119, -2.74297, -19.296)));
      final vertex_2_90 = mesh_2.vertices.elementAt(90);
      expect(vertex_2_90, vector3MoreOrLessEquals(Vector3(-87.9744, -40.3484, -103.362)));
      final vertex_2_91 = mesh_2.vertices.elementAt(91);
      expect(vertex_2_91, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_92 = mesh_2.vertices.elementAt(92);
      expect(vertex_2_92, vector3MoreOrLessEquals(Vector3(-88.2457, -39.7477, -103.466)));
      final vertex_2_93 = mesh_2.vertices.elementAt(93);
      expect(vertex_2_93, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_94 = mesh_2.vertices.elementAt(94);
      expect(vertex_2_94, vector3MoreOrLessEquals(Vector3(-45.784, -4.95347, -24.4927)));
      final vertex_2_95 = mesh_2.vertices.elementAt(95);
      expect(vertex_2_95, vector3MoreOrLessEquals(Vector3(-48.3386, -4.0924, -22.3802)));
      final vertex_2_96 = mesh_2.vertices.elementAt(96);
      expect(vertex_2_96, vector3MoreOrLessEquals(Vector3(-87.6253, -40.6998, -103.631)));
      final vertex_2_97 = mesh_2.vertices.elementAt(97);
      expect(vertex_2_97, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_98 = mesh_2.vertices.elementAt(98);
      expect(vertex_2_98, vector3MoreOrLessEquals(Vector3(-87.9744, -40.3484, -103.362)));
      final vertex_2_99 = mesh_2.vertices.elementAt(99);
      expect(vertex_2_99, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_100 = mesh_2.vertices.elementAt(100);
      expect(vertex_2_100, vector3MoreOrLessEquals(Vector3(-42.3719, -4.67776, -24.0427)));
      final vertex_2_101 = mesh_2.vertices.elementAt(101);
      expect(vertex_2_101, vector3MoreOrLessEquals(Vector3(-45.784, -4.95347, -24.4927)));
      final vertex_2_102 = mesh_2.vertices.elementAt(102);
      expect(vertex_2_102, vector3MoreOrLessEquals(Vector3(-87.4612, -40.5375, -104.072)));
      final vertex_2_103 = mesh_2.vertices.elementAt(103);
      expect(vertex_2_103, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_104 = mesh_2.vertices.elementAt(104);
      expect(vertex_2_104, vector3MoreOrLessEquals(Vector3(-87.6253, -40.6998, -103.631)));
      final vertex_2_105 = mesh_2.vertices.elementAt(105);
      expect(vertex_2_105, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_106 = mesh_2.vertices.elementAt(106);
      expect(vertex_2_106, vector3MoreOrLessEquals(Vector3(-40.6715, -3.47289, -21.3692)));
      final vertex_2_107 = mesh_2.vertices.elementAt(107);
      expect(vertex_2_107, vector3MoreOrLessEquals(Vector3(-42.3719, -4.67776, -24.0427)));
      final vertex_2_108 = mesh_2.vertices.elementAt(108);
      expect(vertex_2_108, vector3MoreOrLessEquals(Vector3(-87.6058, -39.9835, -104.352)));
      final vertex_2_109 = mesh_2.vertices.elementAt(109);
      expect(vertex_2_109, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_110 = mesh_2.vertices.elementAt(110);
      expect(vertex_2_110, vector3MoreOrLessEquals(Vector3(-87.4612, -40.5375, -104.072)));
      expect(mesh_2.normals.length, isZero);
      expect(mesh_2.tangents.length, isZero);
      expect(mesh_2.bitangents.length, isZero);
      expect(mesh_2.colors.length, isZero);
      expect(mesh_2.textureCoords.length, isZero);
      expect(mesh_2.uvComponents.length, isZero);
      expect(mesh_2.uvComponents, equals([]));
      expect(mesh_2.faces.length, equals(98));
      expect(mesh_2.bones.length, isZero);
      expect(mesh_2.materialIndex, equals(2));
      expect(mesh_2.name, equals('Bein1Li'));
      expect(mesh_2.animMeshes.length, isZero);
      expect(mesh_2.morphingMethod, isZero);
      expect(mesh_2.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_3 = meshes.elementAt(3);
      expect(mesh_3.primitiveTypes, equals(4));
      expect(mesh_3.vertices.length, equals(117));
      final vertex_3_0 = mesh_3.vertices.elementAt(0);
      expect(vertex_3_0, vector3MoreOrLessEquals(Vector3(-41.9601, -3.15467, 1.81762)));
      final vertex_3_1 = mesh_3.vertices.elementAt(1);
      expect(vertex_3_1, vector3MoreOrLessEquals(Vector3(-42.838, -1.82275, -1.17338)));
      final vertex_3_2 = mesh_3.vertices.elementAt(2);
      expect(vertex_3_2, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_3 = mesh_3.vertices.elementAt(3);
      expect(vertex_3_3, vector3MoreOrLessEquals(Vector3(-91.9595, -39.7327, 57.5408)));
      final vertex_3_4 = mesh_3.vertices.elementAt(4);
      expect(vertex_3_4, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_5 = mesh_3.vertices.elementAt(5);
      expect(vertex_3_5, vector3MoreOrLessEquals(Vector3(-92.2904, -39.2116, 57.3825)));
      final vertex_3_6 = mesh_3.vertices.elementAt(6);
      expect(vertex_3_6, vector3MoreOrLessEquals(Vector3(-41.9601, -3.15467, 1.81762)));
      final vertex_3_7 = mesh_3.vertices.elementAt(7);
      expect(vertex_3_7, vector3MoreOrLessEquals(Vector3(-49.1963, 7.80456, 21.2935)));
      final vertex_3_8 = mesh_3.vertices.elementAt(8);
      expect(vertex_3_8, vector3MoreOrLessEquals(Vector3(-49.3681, 8.47676, 19.0859)));
      final vertex_3_9 = mesh_3.vertices.elementAt(9);
      expect(vertex_3_9, vector3MoreOrLessEquals(Vector3(-42.838, -1.82275, -1.17338)));
      final vertex_3_10 = mesh_3.vertices.elementAt(10);
      expect(vertex_3_10, vector3MoreOrLessEquals(Vector3(-54.2547, 27.2729, 30.4489)));
      final vertex_3_11 = mesh_3.vertices.elementAt(11);
      expect(vertex_3_11, vector3MoreOrLessEquals(Vector3(-54.9258, 28.3424, 29.3661)));
      final vertex_3_12 = mesh_3.vertices.elementAt(12);
      expect(vertex_3_12, vector3MoreOrLessEquals(Vector3(-45.9887, -1.45013, -2.53574)));
      final vertex_3_13 = mesh_3.vertices.elementAt(13);
      expect(vertex_3_13, vector3MoreOrLessEquals(Vector3(-50.885, 7.78515, 17.481)));
      final vertex_3_14 = mesh_3.vertices.elementAt(14);
      expect(vertex_3_14, vector3MoreOrLessEquals(Vector3(-55.9834, 28.0877, 28.4576)));
      final vertex_3_15 = mesh_3.vertices.elementAt(15);
      expect(vertex_3_15, vector3MoreOrLessEquals(Vector3(-54.2547, 27.2729, 30.4489)));
      final vertex_3_16 = mesh_3.vertices.elementAt(16);
      expect(vertex_3_16, vector3MoreOrLessEquals(Vector3(-57.455, 28.7062, 33.8355)));
      final vertex_3_17 = mesh_3.vertices.elementAt(17);
      expect(vertex_3_17, vector3MoreOrLessEquals(Vector3(-57.455, 28.7062, 33.8355)));
      final vertex_3_18 = mesh_3.vertices.elementAt(18);
      expect(vertex_3_18, vector3MoreOrLessEquals(Vector3(-59.4156, 28.147, 32.741)));
      final vertex_3_19 = mesh_3.vertices.elementAt(19);
      expect(vertex_3_19, vector3MoreOrLessEquals(Vector3(-52.6046, 6.25055, 17.6873)));
      final vertex_3_20 = mesh_3.vertices.elementAt(20);
      expect(vertex_3_20, vector3MoreOrLessEquals(Vector3(-56.6312, 26.7007, 28.4076)));
      final vertex_3_21 = mesh_3.vertices.elementAt(21);
      expect(vertex_3_21, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_22 = mesh_3.vertices.elementAt(22);
      expect(vertex_3_22, vector3MoreOrLessEquals(Vector3(-49.0396, -2.31741, -1.24353)));
      final vertex_3_23 = mesh_3.vertices.elementAt(23);
      expect(vertex_3_23, vector3MoreOrLessEquals(Vector3(-49.6933, -3.77151, 1.73014)));
      final vertex_3_24 = mesh_3.vertices.elementAt(24);
      expect(vertex_3_24, vector3MoreOrLessEquals(Vector3(-53.2322, 5.02854, 19.5495)));
      final vertex_3_25 = mesh_3.vertices.elementAt(25);
      expect(vertex_3_25, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_26 = mesh_3.vertices.elementAt(26);
      expect(vertex_3_26, vector3MoreOrLessEquals(Vector3(-52.295, 5.03929, 21.6653)));
      final vertex_3_27 = mesh_3.vertices.elementAt(27);
      expect(vertex_3_27, vector3MoreOrLessEquals(Vector3(-47.4576, -4.71747, 4.14606)));
      final vertex_3_28 = mesh_3.vertices.elementAt(28);
      expect(vertex_3_28, vector3MoreOrLessEquals(Vector3(-55.422, 24.7735, 30.3588)));
      final vertex_3_29 = mesh_3.vertices.elementAt(29);
      expect(vertex_3_29, vector3MoreOrLessEquals(Vector3(-44.016, -4.44295, 4.18499)));
      final vertex_3_30 = mesh_3.vertices.elementAt(30);
      expect(vertex_3_30, vector3MoreOrLessEquals(Vector3(-50.4989, 6.27475, 22.4414)));
      final vertex_3_31 = mesh_3.vertices.elementAt(31);
      expect(vertex_3_31, vector3MoreOrLessEquals(Vector3(-54.4755, 25.6846, 30.8906)));
      final vertex_3_32 = mesh_3.vertices.elementAt(32);
      expect(vertex_3_32, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_33 = mesh_3.vertices.elementAt(33);
      expect(vertex_3_33, vector3MoreOrLessEquals(Vector3(-56.3447, 24.0645, 31.7721)));
      final vertex_3_34 = mesh_3.vertices.elementAt(34);
      expect(vertex_3_34, vector3MoreOrLessEquals(Vector3(-54.4755, 25.6846, 30.8906)));
      final vertex_3_35 = mesh_3.vertices.elementAt(35);
      expect(vertex_3_35, vector3MoreOrLessEquals(Vector3(-56.6312, 26.7007, 28.4076)));
      final vertex_3_36 = mesh_3.vertices.elementAt(36);
      expect(vertex_3_36, vector3MoreOrLessEquals(Vector3(-58.5252, 24.4246, 31.0863)));
      final vertex_3_37 = mesh_3.vertices.elementAt(37);
      expect(vertex_3_37, vector3MoreOrLessEquals(Vector3(-55.9834, 28.0877, 28.4576)));
      final vertex_3_38 = mesh_3.vertices.elementAt(38);
      expect(vertex_3_38, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_39 = mesh_3.vertices.elementAt(39);
      expect(vertex_3_39, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_40 = mesh_3.vertices.elementAt(40);
      expect(vertex_3_40, vector3MoreOrLessEquals(Vector3(-70.41, 6.51407, 40.0833)));
      final vertex_3_41 = mesh_3.vertices.elementAt(41);
      expect(vertex_3_41, vector3MoreOrLessEquals(Vector3(-71.6158, 8.68279, 43.4344)));
      final vertex_3_42 = mesh_3.vertices.elementAt(42);
      expect(vertex_3_42, vector3MoreOrLessEquals(Vector3(-71.9709, 7.37398, 41.5594)));
      final vertex_3_43 = mesh_3.vertices.elementAt(43);
      expect(vertex_3_43, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_44 = mesh_3.vertices.elementAt(44);
      expect(vertex_3_44, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_45 = mesh_3.vertices.elementAt(45);
      expect(vertex_3_45, vector3MoreOrLessEquals(Vector3(-67.4683, 9.10906, 43.4964)));
      final vertex_3_46 = mesh_3.vertices.elementAt(46);
      expect(vertex_3_46, vector3MoreOrLessEquals(Vector3(-69.612, 9.45497, 44.2965)));
      final vertex_3_47 = mesh_3.vertices.elementAt(47);
      expect(vertex_3_47, vector3MoreOrLessEquals(Vector3(-85.9715, -32.0747, 52.6385)));
      final vertex_3_48 = mesh_3.vertices.elementAt(48);
      expect(vertex_3_48, vector3MoreOrLessEquals(Vector3(-87.0142, -30.5141, 52.422)));
      final vertex_3_49 = mesh_3.vertices.elementAt(49);
      expect(vertex_3_49, vector3MoreOrLessEquals(Vector3(-87.0142, -30.5141, 52.422)));
      final vertex_3_50 = mesh_3.vertices.elementAt(50);
      expect(vertex_3_50, vector3MoreOrLessEquals(Vector3(-87.7561, -30.2962, 51.631)));
      final vertex_3_51 = mesh_3.vertices.elementAt(51);
      expect(vertex_3_51, vector3MoreOrLessEquals(Vector3(-87.7561, -30.2962, 51.631)));
      final vertex_3_52 = mesh_3.vertices.elementAt(52);
      expect(vertex_3_52, vector3MoreOrLessEquals(Vector3(-87.6385, -31.585, 50.8611)));
      final vertex_3_53 = mesh_3.vertices.elementAt(53);
      expect(vertex_3_53, vector3MoreOrLessEquals(Vector3(-92.6001, -39.1617, 56.9964)));
      final vertex_3_54 = mesh_3.vertices.elementAt(54);
      expect(vertex_3_54, vector3MoreOrLessEquals(Vector3(-92.2904, -39.2116, 57.3825)));
      final vertex_3_55 = mesh_3.vertices.elementAt(55);
      expect(vertex_3_55, vector3MoreOrLessEquals(Vector3(-92.6552, -39.6206, 56.6732)));
      final vertex_3_56 = mesh_3.vertices.elementAt(56);
      expect(vertex_3_56, vector3MoreOrLessEquals(Vector3(-91.9595, -39.7327, 57.5408)));
      final vertex_3_57 = mesh_3.vertices.elementAt(57);
      expect(vertex_3_57, vector3MoreOrLessEquals(Vector3(-86.7501, -33.41, 50.692)));
      final vertex_3_58 = mesh_3.vertices.elementAt(58);
      expect(vertex_3_58, vector3MoreOrLessEquals(Vector3(-70.41, 6.51407, 40.0833)));
      final vertex_3_59 = mesh_3.vertices.elementAt(59);
      expect(vertex_3_59, vector3MoreOrLessEquals(Vector3(-92.4144, -40.2427, 56.6563)));
      final vertex_3_60 = mesh_3.vertices.elementAt(60);
      expect(vertex_3_60, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_61 = mesh_3.vertices.elementAt(61);
      expect(vertex_3_61, vector3MoreOrLessEquals(Vector3(-68.1082, 6.7506, 40.1178)));
      final vertex_3_62 = mesh_3.vertices.elementAt(62);
      expect(vertex_3_62, vector3MoreOrLessEquals(Vector3(-85.7597, -34.397, 51.2511)));
      final vertex_3_63 = mesh_3.vertices.elementAt(63);
      expect(vertex_3_63, vector3MoreOrLessEquals(Vector3(-85.7597, -34.397, 51.2511)));
      final vertex_3_64 = mesh_3.vertices.elementAt(64);
      expect(vertex_3_64, vector3MoreOrLessEquals(Vector3(-92.0589, -40.5596, 56.9584)));
      final vertex_3_65 = mesh_3.vertices.elementAt(65);
      expect(vertex_3_65, vector3MoreOrLessEquals(Vector3(-85.4132, -33.8027, 52.1173)));
      final vertex_3_66 = mesh_3.vertices.elementAt(66);
      expect(vertex_3_66, vector3MoreOrLessEquals(Vector3(-66.7991, 7.9055, 41.6367)));
      final vertex_3_67 = mesh_3.vertices.elementAt(67);
      expect(vertex_3_67, vector3MoreOrLessEquals(Vector3(-91.8565, -40.3327, 57.3521)));
      final vertex_3_68 = mesh_3.vertices.elementAt(68);
      expect(vertex_3_68, vector3MoreOrLessEquals(Vector3(-85.9715, -32.0747, 52.6385)));
      final vertex_3_69 = mesh_3.vertices.elementAt(69);
      expect(vertex_3_69, vector3MoreOrLessEquals(Vector3(-91.9595, -39.7327, 57.5408)));
      final vertex_3_70 = mesh_3.vertices.elementAt(70);
      expect(vertex_3_70, vector3MoreOrLessEquals(Vector3(-67.4683, 9.10906, 43.4964)));
      final vertex_3_71 = mesh_3.vertices.elementAt(71);
      expect(vertex_3_71, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_72 = mesh_3.vertices.elementAt(72);
      expect(vertex_3_72, vector3MoreOrLessEquals(Vector3(-54.9923, 25.4323, 33.0586)));
      final vertex_3_73 = mesh_3.vertices.elementAt(73);
      expect(vertex_3_73, vector3MoreOrLessEquals(Vector3(-54.9923, 25.4323, 33.0586)));
      final vertex_3_74 = mesh_3.vertices.elementAt(74);
      expect(vertex_3_74, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_75 = mesh_3.vertices.elementAt(75);
      expect(vertex_3_75, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_76 = mesh_3.vertices.elementAt(76);
      expect(vertex_3_76, vector3MoreOrLessEquals(Vector3(-54.2547, 27.2729, 30.4489)));
      final vertex_3_77 = mesh_3.vertices.elementAt(77);
      expect(vertex_3_77, vector3MoreOrLessEquals(Vector3(-49.1963, 7.80456, 21.2935)));
      final vertex_3_78 = mesh_3.vertices.elementAt(78);
      expect(vertex_3_78, vector3MoreOrLessEquals(Vector3(-41.9601, -3.15467, 1.81762)));
      final vertex_3_79 = mesh_3.vertices.elementAt(79);
      expect(vertex_3_79, vector3MoreOrLessEquals(Vector3(-54.2547, 27.2729, 30.4489)));
      final vertex_3_80 = mesh_3.vertices.elementAt(80);
      expect(vertex_3_80, vector3MoreOrLessEquals(Vector3(-49.1963, 7.80456, 21.2935)));
      final vertex_3_81 = mesh_3.vertices.elementAt(81);
      expect(vertex_3_81, vector3MoreOrLessEquals(Vector3(-42.838, -1.82275, -1.17338)));
      final vertex_3_82 = mesh_3.vertices.elementAt(82);
      expect(vertex_3_82, vector3MoreOrLessEquals(Vector3(-45.9887, -1.45013, -2.53574)));
      final vertex_3_83 = mesh_3.vertices.elementAt(83);
      expect(vertex_3_83, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_84 = mesh_3.vertices.elementAt(84);
      expect(vertex_3_84, vector3MoreOrLessEquals(Vector3(-92.2904, -39.2116, 57.3825)));
      final vertex_3_85 = mesh_3.vertices.elementAt(85);
      expect(vertex_3_85, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_86 = mesh_3.vertices.elementAt(86);
      expect(vertex_3_86, vector3MoreOrLessEquals(Vector3(-92.6001, -39.1617, 56.9964)));
      final vertex_3_87 = mesh_3.vertices.elementAt(87);
      expect(vertex_3_87, vector3MoreOrLessEquals(Vector3(-45.9887, -1.45013, -2.53574)));
      final vertex_3_88 = mesh_3.vertices.elementAt(88);
      expect(vertex_3_88, vector3MoreOrLessEquals(Vector3(-49.0396, -2.31741, -1.24353)));
      final vertex_3_89 = mesh_3.vertices.elementAt(89);
      expect(vertex_3_89, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_90 = mesh_3.vertices.elementAt(90);
      expect(vertex_3_90, vector3MoreOrLessEquals(Vector3(-92.6001, -39.1617, 56.9964)));
      final vertex_3_91 = mesh_3.vertices.elementAt(91);
      expect(vertex_3_91, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_92 = mesh_3.vertices.elementAt(92);
      expect(vertex_3_92, vector3MoreOrLessEquals(Vector3(-92.6552, -39.6206, 56.6732)));
      final vertex_3_93 = mesh_3.vertices.elementAt(93);
      expect(vertex_3_93, vector3MoreOrLessEquals(Vector3(-49.0396, -2.31741, -1.24353)));
      final vertex_3_94 = mesh_3.vertices.elementAt(94);
      expect(vertex_3_94, vector3MoreOrLessEquals(Vector3(-49.6933, -3.77151, 1.73014)));
      final vertex_3_95 = mesh_3.vertices.elementAt(95);
      expect(vertex_3_95, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_96 = mesh_3.vertices.elementAt(96);
      expect(vertex_3_96, vector3MoreOrLessEquals(Vector3(-92.6552, -39.6206, 56.6732)));
      final vertex_3_97 = mesh_3.vertices.elementAt(97);
      expect(vertex_3_97, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_98 = mesh_3.vertices.elementAt(98);
      expect(vertex_3_98, vector3MoreOrLessEquals(Vector3(-92.4144, -40.2427, 56.6563)));
      final vertex_3_99 = mesh_3.vertices.elementAt(99);
      expect(vertex_3_99, vector3MoreOrLessEquals(Vector3(-49.6933, -3.77151, 1.73014)));
      final vertex_3_100 = mesh_3.vertices.elementAt(100);
      expect(vertex_3_100, vector3MoreOrLessEquals(Vector3(-47.4576, -4.71747, 4.14606)));
      final vertex_3_101 = mesh_3.vertices.elementAt(101);
      expect(vertex_3_101, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_102 = mesh_3.vertices.elementAt(102);
      expect(vertex_3_102, vector3MoreOrLessEquals(Vector3(-92.4144, -40.2427, 56.6563)));
      final vertex_3_103 = mesh_3.vertices.elementAt(103);
      expect(vertex_3_103, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_104 = mesh_3.vertices.elementAt(104);
      expect(vertex_3_104, vector3MoreOrLessEquals(Vector3(-92.0589, -40.5596, 56.9584)));
      final vertex_3_105 = mesh_3.vertices.elementAt(105);
      expect(vertex_3_105, vector3MoreOrLessEquals(Vector3(-47.4576, -4.71747, 4.14606)));
      final vertex_3_106 = mesh_3.vertices.elementAt(106);
      expect(vertex_3_106, vector3MoreOrLessEquals(Vector3(-44.016, -4.44295, 4.18499)));
      final vertex_3_107 = mesh_3.vertices.elementAt(107);
      expect(vertex_3_107, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_108 = mesh_3.vertices.elementAt(108);
      expect(vertex_3_108, vector3MoreOrLessEquals(Vector3(-92.0589, -40.5596, 56.9584)));
      final vertex_3_109 = mesh_3.vertices.elementAt(109);
      expect(vertex_3_109, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_110 = mesh_3.vertices.elementAt(110);
      expect(vertex_3_110, vector3MoreOrLessEquals(Vector3(-91.8565, -40.3327, 57.3521)));
      final vertex_3_111 = mesh_3.vertices.elementAt(111);
      expect(vertex_3_111, vector3MoreOrLessEquals(Vector3(-44.016, -4.44295, 4.18499)));
      final vertex_3_112 = mesh_3.vertices.elementAt(112);
      expect(vertex_3_112, vector3MoreOrLessEquals(Vector3(-41.9601, -3.15467, 1.81762)));
      final vertex_3_113 = mesh_3.vertices.elementAt(113);
      expect(vertex_3_113, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_114 = mesh_3.vertices.elementAt(114);
      expect(vertex_3_114, vector3MoreOrLessEquals(Vector3(-91.8565, -40.3327, 57.3521)));
      final vertex_3_115 = mesh_3.vertices.elementAt(115);
      expect(vertex_3_115, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_116 = mesh_3.vertices.elementAt(116);
      expect(vertex_3_116, vector3MoreOrLessEquals(Vector3(-91.9595, -39.7327, 57.5408)));
      expect(mesh_3.normals.length, isZero);
      expect(mesh_3.tangents.length, isZero);
      expect(mesh_3.bitangents.length, isZero);
      expect(mesh_3.colors.length, isZero);
      expect(mesh_3.textureCoords.length, isZero);
      expect(mesh_3.uvComponents.length, isZero);
      expect(mesh_3.uvComponents, equals([]));
      expect(mesh_3.faces.length, equals(98));
      expect(mesh_3.bones.length, isZero);
      expect(mesh_3.materialIndex, equals(2));
      expect(mesh_3.name, equals('Bein1Re'));
      expect(mesh_3.animMeshes.length, isZero);
      expect(mesh_3.morphingMethod, isZero);
      expect(mesh_3.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_4 = meshes.elementAt(4);
      expect(mesh_4.primitiveTypes, equals(4));
      expect(mesh_4.vertices.length, equals(113));
      final vertex_4_0 = mesh_4.vertices.elementAt(0);
      expect(vertex_4_0, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_1 = mesh_4.vertices.elementAt(1);
      expect(vertex_4_1, vector3MoreOrLessEquals(Vector3(-34.3837, -1.82275, -16.6522)));
      final vertex_4_2 = mesh_4.vertices.elementAt(2);
      expect(vertex_4_2, vector3MoreOrLessEquals(Vector3(-32.5358, -3.15467, -19.1625)));
      final vertex_4_3 = mesh_4.vertices.elementAt(3);
      expect(vertex_4_3, vector3MoreOrLessEquals(Vector3(-43.6942, -41.0689, -95.4345)));
      final vertex_4_4 = mesh_4.vertices.elementAt(4);
      expect(vertex_4_4, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_5 = mesh_4.vertices.elementAt(5);
      expect(vertex_4_5, vector3MoreOrLessEquals(Vector3(-43.3858, -41.5832, -95.2187)));
      final vertex_4_6 = mesh_4.vertices.elementAt(6);
      expect(vertex_4_6, vector3MoreOrLessEquals(Vector3(-36.3516, 8.47676, -37.1534)));
      final vertex_4_7 = mesh_4.vertices.elementAt(7);
      expect(vertex_4_7, vector3MoreOrLessEquals(Vector3(-35.099, 7.80456, -38.9793)));
      final vertex_4_8 = mesh_4.vertices.elementAt(8);
      expect(vertex_4_8, vector3MoreOrLessEquals(Vector3(-32.5358, -3.15467, -19.1625)));
      final vertex_4_9 = mesh_4.vertices.elementAt(9);
      expect(vertex_4_9, vector3MoreOrLessEquals(Vector3(-34.3837, -1.82275, -16.6522)));
      final vertex_4_10 = mesh_4.vertices.elementAt(10);
      expect(vertex_4_10, vector3MoreOrLessEquals(Vector3(-37.5541, 27.2729, -51.6328)));
      final vertex_4_11 = mesh_4.vertices.elementAt(11);
      expect(vertex_4_11, vector3MoreOrLessEquals(Vector3(-38.6766, 28.3424, -51.0306)));
      final vertex_4_12 = mesh_4.vertices.elementAt(12);
      expect(vertex_4_12, vector3MoreOrLessEquals(Vector3(-38.6323, 28.7062, -56.1659)));
      final vertex_4_13 = mesh_4.vertices.elementAt(13);
      expect(vertex_4_13, vector3MoreOrLessEquals(Vector3(-37.5541, 27.2729, -51.6328)));
      final vertex_4_14 = mesh_4.vertices.elementAt(14);
      expect(vertex_4_14, vector3MoreOrLessEquals(Vector3(-40.0468, 28.0877, -50.7727)));
      final vertex_4_15 = mesh_4.vertices.elementAt(15);
      expect(vertex_4_15, vector3MoreOrLessEquals(Vector3(-38.6323, 28.7062, -56.1659)));
      final vertex_4_16 = mesh_4.vertices.elementAt(16);
      expect(vertex_4_16, vector3MoreOrLessEquals(Vector3(-36.8568, 27.4981, -55.3041)));
      final vertex_4_17 = mesh_4.vertices.elementAt(17);
      expect(vertex_4_17, vector3MoreOrLessEquals(Vector3(-39.3216, 4.10906, -79.2096)));
      final vertex_4_18 = mesh_4.vertices.elementAt(18);
      expect(vertex_4_18, vector3MoreOrLessEquals(Vector3(-40.778, 4.45497, -80.9743)));
      final vertex_4_19 = mesh_4.vertices.elementAt(19);
      expect(vertex_4_19, vector3MoreOrLessEquals(Vector3(-40.8775, 28.147, -56.1983)));
      final vertex_4_20 = mesh_4.vertices.elementAt(20);
      expect(vertex_4_20, vector3MoreOrLessEquals(Vector3(-42.9444, 3.68279, -81.2297)));
      final vertex_4_21 = mesh_4.vertices.elementAt(21);
      expect(vertex_4_21, vector3MoreOrLessEquals(Vector3(-41.6864, -30.9586, -90.7611)));
      final vertex_4_22 = mesh_4.vertices.elementAt(22);
      expect(vertex_4_22, vector3MoreOrLessEquals(Vector3(-40.8771, -32.4266, -89.8897)));
      final vertex_4_23 = mesh_4.vertices.elementAt(23);
      expect(vertex_4_23, vector3MoreOrLessEquals(Vector3(-41.6864, -30.9586, -90.7611)));
      final vertex_4_24 = mesh_4.vertices.elementAt(24);
      expect(vertex_4_24, vector3MoreOrLessEquals(Vector3(-41.9018, 26.2415, -55.3768)));
      final vertex_4_25 = mesh_4.vertices.elementAt(25);
      expect(vertex_4_25, vector3MoreOrLessEquals(Vector3(-44.1895, 2.37398, -79.7834)));
      final vertex_4_26 = mesh_4.vertices.elementAt(26);
      expect(vertex_4_26, vector3MoreOrLessEquals(Vector3(-43.2233, -31.6319, -89.6851)));
      final vertex_4_27 = mesh_4.vertices.elementAt(27);
      expect(vertex_4_27, vector3MoreOrLessEquals(Vector3(-42.7306, -30.6049, -90.67)));
      final vertex_4_28 = mesh_4.vertices.elementAt(28);
      expect(vertex_4_28, vector3MoreOrLessEquals(Vector3(-38.4677, 7.78515, -36.5219)));
      final vertex_4_29 = mesh_4.vertices.elementAt(29);
      expect(vertex_4_29, vector3MoreOrLessEquals(Vector3(-39.8538, 6.25055, -37.5604)));
      final vertex_4_30 = mesh_4.vertices.elementAt(30);
      expect(vertex_4_30, vector3MoreOrLessEquals(Vector3(-40.6329, 26.7007, -51.0533)));
      final vertex_4_31 = mesh_4.vertices.elementAt(31);
      expect(vertex_4_31, vector3MoreOrLessEquals(Vector3(-37.8103, -1.45013, -16.4496)));
      final vertex_4_32 = mesh_4.vertices.elementAt(32);
      expect(vertex_4_32, vector3MoreOrLessEquals(Vector3(-40.2353, -2.31741, -18.7073)));
      final vertex_4_33 = mesh_4.vertices.elementAt(33);
      expect(vertex_4_33, vector3MoreOrLessEquals(Vector3(-39.8325, -3.77151, -21.7252)));
      final vertex_4_34 = mesh_4.vertices.elementAt(34);
      expect(vertex_4_34, vector3MoreOrLessEquals(Vector3(-39.4662, 5.02854, -39.4869)));
      final vertex_4_35 = mesh_4.vertices.elementAt(35);
      expect(vertex_4_35, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_36 = mesh_4.vertices.elementAt(36);
      expect(vertex_4_36, vector3MoreOrLessEquals(Vector3(-37.5967, 5.03929, -40.8506)));
      final vertex_4_37 = mesh_4.vertices.elementAt(37);
      expect(vertex_4_37, vector3MoreOrLessEquals(Vector3(-36.9054, -4.71747, -23.2308)));
      final vertex_4_38 = mesh_4.vertices.elementAt(38);
      expect(vertex_4_38, vector3MoreOrLessEquals(Vector3(-40.6329, 26.7007, -51.0533)));
      final vertex_4_39 = mesh_4.vertices.elementAt(39);
      expect(vertex_4_39, vector3MoreOrLessEquals(Vector3(-38.6101, 24.7735, -52.1384)));
      final vertex_4_40 = mesh_4.vertices.elementAt(40);
      expect(vertex_4_40, vector3MoreOrLessEquals(Vector3(-40.0468, 28.0877, -50.7727)));
      final vertex_4_41 = mesh_4.vertices.elementAt(41);
      expect(vertex_4_41, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_42 = mesh_4.vertices.elementAt(42);
      expect(vertex_4_42, vector3MoreOrLessEquals(Vector3(-40.9338, 24.4246, -54.3201)));
      final vertex_4_43 = mesh_4.vertices.elementAt(43);
      expect(vertex_4_43, vector3MoreOrLessEquals(Vector3(-43.5756, 1.51407, -77.7246)));
      final vertex_4_44 = mesh_4.vertices.elementAt(44);
      expect(vertex_4_44, vector3MoreOrLessEquals(Vector3(-38.7024, 24.0645, -53.8238)));
      final vertex_4_45 = mesh_4.vertices.elementAt(45);
      expect(vertex_4_45, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_46 = mesh_4.vertices.elementAt(46);
      expect(vertex_4_46, vector3MoreOrLessEquals(Vector3(-41.5651, 1.7506, -76.6036)));
      final vertex_4_47 = mesh_4.vertices.elementAt(47);
      expect(vertex_4_47, vector3MoreOrLessEquals(Vector3(-37.5244, 25.6846, -52.1258)));
      final vertex_4_48 = mesh_4.vertices.elementAt(48);
      expect(vertex_4_48, vector3MoreOrLessEquals(Vector3(-36.888, 25.4323, -54.2617)));
      final vertex_4_49 = mesh_4.vertices.elementAt(49);
      expect(vertex_4_49, vector3MoreOrLessEquals(Vector3(-39.6719, 2.9055, -77.2645)));
      final vertex_4_50 = mesh_4.vertices.elementAt(50);
      expect(vertex_4_50, vector3MoreOrLessEquals(Vector3(-41.7649, -34.2772, -88.115)));
      final vertex_4_51 = mesh_4.vertices.elementAt(51);
      expect(vertex_4_51, vector3MoreOrLessEquals(Vector3(-40.9121, -33.9035, -88.7121)));
      final vertex_4_52 = mesh_4.vertices.elementAt(52);
      expect(vertex_4_52, vector3MoreOrLessEquals(Vector3(-41.7649, -34.2772, -88.115)));
      final vertex_4_53 = mesh_4.vertices.elementAt(53);
      expect(vertex_4_53, vector3MoreOrLessEquals(Vector3(-36.8568, 27.4981, -55.3041)));
      final vertex_4_54 = mesh_4.vertices.elementAt(54);
      expect(vertex_4_54, vector3MoreOrLessEquals(Vector3(-39.3216, 4.10906, -79.2096)));
      final vertex_4_55 = mesh_4.vertices.elementAt(55);
      expect(vertex_4_55, vector3MoreOrLessEquals(Vector3(-40.8771, -32.4266, -89.8897)));
      final vertex_4_56 = mesh_4.vertices.elementAt(56);
      expect(vertex_4_56, vector3MoreOrLessEquals(Vector3(-37.5541, 27.2729, -51.6328)));
      final vertex_4_57 = mesh_4.vertices.elementAt(57);
      expect(vertex_4_57, vector3MoreOrLessEquals(Vector3(-36.8568, 27.4981, -55.3041)));
      final vertex_4_58 = mesh_4.vertices.elementAt(58);
      expect(vertex_4_58, vector3MoreOrLessEquals(Vector3(-43.4746, -42.1016, -94.8589)));
      final vertex_4_59 = mesh_4.vertices.elementAt(59);
      expect(vertex_4_59, vector3MoreOrLessEquals(Vector3(-43.3858, -41.5832, -95.2187)));
      final vertex_4_60 = mesh_4.vertices.elementAt(60);
      expect(vertex_4_60, vector3MoreOrLessEquals(Vector3(-43.8937, -42.2338, -94.6259)));
      final vertex_4_61 = mesh_4.vertices.elementAt(61);
      expect(vertex_4_61, vector3MoreOrLessEquals(Vector3(-44.3276, -41.8803, -94.6953)));
      final vertex_4_62 = mesh_4.vertices.elementAt(62);
      expect(vertex_4_62, vector3MoreOrLessEquals(Vector3(-44.4495, -41.3072, -95.0147)));
      final vertex_4_63 = mesh_4.vertices.elementAt(63);
      expect(vertex_4_63, vector3MoreOrLessEquals(Vector3(-42.7935, -33.2662, -88.548)));
      final vertex_4_64 = mesh_4.vertices.elementAt(64);
      expect(vertex_4_64, vector3MoreOrLessEquals(Vector3(-44.1677, -40.9461, -95.3437)));
      final vertex_4_65 = mesh_4.vertices.elementAt(65);
      expect(vertex_4_65, vector3MoreOrLessEquals(Vector3(-41.9018, 26.2415, -55.3768)));
      final vertex_4_66 = mesh_4.vertices.elementAt(66);
      expect(vertex_4_66, vector3MoreOrLessEquals(Vector3(-43.6942, -41.0689, -95.4345)));
      final vertex_4_67 = mesh_4.vertices.elementAt(67);
      expect(vertex_4_67, vector3MoreOrLessEquals(Vector3(-42.7306, -30.6049, -90.67)));
      final vertex_4_68 = mesh_4.vertices.elementAt(68);
      expect(vertex_4_68, vector3MoreOrLessEquals(Vector3(-43.3858, -41.5832, -95.2187)));
      final vertex_4_69 = mesh_4.vertices.elementAt(69);
      expect(vertex_4_69, vector3MoreOrLessEquals(Vector3(-42.9444, 3.68279, -81.2297)));
      final vertex_4_70 = mesh_4.vertices.elementAt(70);
      expect(vertex_4_70, vector3MoreOrLessEquals(Vector3(-37.5244, 25.6846, -52.1258)));
      final vertex_4_71 = mesh_4.vertices.elementAt(71);
      expect(vertex_4_71, vector3MoreOrLessEquals(Vector3(-35.6531, 6.27475, -40.6247)));
      final vertex_4_72 = mesh_4.vertices.elementAt(72);
      expect(vertex_4_72, vector3MoreOrLessEquals(Vector3(-35.099, 7.80456, -38.9793)));
      final vertex_4_73 = mesh_4.vertices.elementAt(73);
      expect(vertex_4_73, vector3MoreOrLessEquals(Vector3(-35.099, 7.80456, -38.9793)));
      final vertex_4_74 = mesh_4.vertices.elementAt(74);
      expect(vertex_4_74, vector3MoreOrLessEquals(Vector3(-37.5541, 27.2729, -51.6328)));
      final vertex_4_75 = mesh_4.vertices.elementAt(75);
      expect(vertex_4_75, vector3MoreOrLessEquals(Vector3(-33.658, -4.44295, -22.0903)));
      final vertex_4_76 = mesh_4.vertices.elementAt(76);
      expect(vertex_4_76, vector3MoreOrLessEquals(Vector3(-32.5358, -3.15467, -19.1625)));
      final vertex_4_77 = mesh_4.vertices.elementAt(77);
      expect(vertex_4_77, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_78 = mesh_4.vertices.elementAt(78);
      expect(vertex_4_78, vector3MoreOrLessEquals(Vector3(-37.8103, -1.45013, -16.4496)));
      final vertex_4_79 = mesh_4.vertices.elementAt(79);
      expect(vertex_4_79, vector3MoreOrLessEquals(Vector3(-34.3837, -1.82275, -16.6522)));
      final vertex_4_80 = mesh_4.vertices.elementAt(80);
      expect(vertex_4_80, vector3MoreOrLessEquals(Vector3(-44.1677, -40.9461, -95.3437)));
      final vertex_4_81 = mesh_4.vertices.elementAt(81);
      expect(vertex_4_81, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_82 = mesh_4.vertices.elementAt(82);
      expect(vertex_4_82, vector3MoreOrLessEquals(Vector3(-43.6942, -41.0689, -95.4345)));
      final vertex_4_83 = mesh_4.vertices.elementAt(83);
      expect(vertex_4_83, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_84 = mesh_4.vertices.elementAt(84);
      expect(vertex_4_84, vector3MoreOrLessEquals(Vector3(-40.2353, -2.31741, -18.7073)));
      final vertex_4_85 = mesh_4.vertices.elementAt(85);
      expect(vertex_4_85, vector3MoreOrLessEquals(Vector3(-37.8103, -1.45013, -16.4496)));
      final vertex_4_86 = mesh_4.vertices.elementAt(86);
      expect(vertex_4_86, vector3MoreOrLessEquals(Vector3(-44.4495, -41.3072, -95.0147)));
      final vertex_4_87 = mesh_4.vertices.elementAt(87);
      expect(vertex_4_87, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_88 = mesh_4.vertices.elementAt(88);
      expect(vertex_4_88, vector3MoreOrLessEquals(Vector3(-44.1677, -40.9461, -95.3437)));
      final vertex_4_89 = mesh_4.vertices.elementAt(89);
      expect(vertex_4_89, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_90 = mesh_4.vertices.elementAt(90);
      expect(vertex_4_90, vector3MoreOrLessEquals(Vector3(-39.8325, -3.77151, -21.7252)));
      final vertex_4_91 = mesh_4.vertices.elementAt(91);
      expect(vertex_4_91, vector3MoreOrLessEquals(Vector3(-40.2353, -2.31741, -18.7073)));
      final vertex_4_92 = mesh_4.vertices.elementAt(92);
      expect(vertex_4_92, vector3MoreOrLessEquals(Vector3(-44.3276, -41.8803, -94.6953)));
      final vertex_4_93 = mesh_4.vertices.elementAt(93);
      expect(vertex_4_93, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_94 = mesh_4.vertices.elementAt(94);
      expect(vertex_4_94, vector3MoreOrLessEquals(Vector3(-44.4495, -41.3072, -95.0147)));
      final vertex_4_95 = mesh_4.vertices.elementAt(95);
      expect(vertex_4_95, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_96 = mesh_4.vertices.elementAt(96);
      expect(vertex_4_96, vector3MoreOrLessEquals(Vector3(-36.9054, -4.71747, -23.2308)));
      final vertex_4_97 = mesh_4.vertices.elementAt(97);
      expect(vertex_4_97, vector3MoreOrLessEquals(Vector3(-39.8325, -3.77151, -21.7252)));
      final vertex_4_98 = mesh_4.vertices.elementAt(98);
      expect(vertex_4_98, vector3MoreOrLessEquals(Vector3(-43.8937, -42.2338, -94.6259)));
      final vertex_4_99 = mesh_4.vertices.elementAt(99);
      expect(vertex_4_99, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_100 = mesh_4.vertices.elementAt(100);
      expect(vertex_4_100, vector3MoreOrLessEquals(Vector3(-44.3276, -41.8803, -94.6953)));
      final vertex_4_101 = mesh_4.vertices.elementAt(101);
      expect(vertex_4_101, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_102 = mesh_4.vertices.elementAt(102);
      expect(vertex_4_102, vector3MoreOrLessEquals(Vector3(-33.658, -4.44295, -22.0903)));
      final vertex_4_103 = mesh_4.vertices.elementAt(103);
      expect(vertex_4_103, vector3MoreOrLessEquals(Vector3(-36.9054, -4.71747, -23.2308)));
      final vertex_4_104 = mesh_4.vertices.elementAt(104);
      expect(vertex_4_104, vector3MoreOrLessEquals(Vector3(-43.4746, -42.1016, -94.8589)));
      final vertex_4_105 = mesh_4.vertices.elementAt(105);
      expect(vertex_4_105, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_106 = mesh_4.vertices.elementAt(106);
      expect(vertex_4_106, vector3MoreOrLessEquals(Vector3(-43.8937, -42.2338, -94.6259)));
      final vertex_4_107 = mesh_4.vertices.elementAt(107);
      expect(vertex_4_107, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_108 = mesh_4.vertices.elementAt(108);
      expect(vertex_4_108, vector3MoreOrLessEquals(Vector3(-32.5358, -3.15467, -19.1625)));
      final vertex_4_109 = mesh_4.vertices.elementAt(109);
      expect(vertex_4_109, vector3MoreOrLessEquals(Vector3(-33.658, -4.44295, -22.0903)));
      final vertex_4_110 = mesh_4.vertices.elementAt(110);
      expect(vertex_4_110, vector3MoreOrLessEquals(Vector3(-43.3858, -41.5832, -95.2187)));
      final vertex_4_111 = mesh_4.vertices.elementAt(111);
      expect(vertex_4_111, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_112 = mesh_4.vertices.elementAt(112);
      expect(vertex_4_112, vector3MoreOrLessEquals(Vector3(-43.4746, -42.1016, -94.8589)));
      expect(mesh_4.normals.length, isZero);
      expect(mesh_4.tangents.length, isZero);
      expect(mesh_4.bitangents.length, isZero);
      expect(mesh_4.colors.length, isZero);
      expect(mesh_4.textureCoords.length, isZero);
      expect(mesh_4.uvComponents.length, isZero);
      expect(mesh_4.uvComponents, equals([]));
      expect(mesh_4.faces.length, equals(98));
      expect(mesh_4.bones.length, isZero);
      expect(mesh_4.materialIndex, equals(2));
      expect(mesh_4.name, equals('Bein2Li'));
      expect(mesh_4.animMeshes.length, isZero);
      expect(mesh_4.morphingMethod, isZero);
      expect(mesh_4.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_5 = meshes.elementAt(5);
      expect(mesh_5.primitiveTypes, equals(4));
      expect(mesh_5.vertices.length, equals(115));
      final vertex_5_0 = mesh_5.vertices.elementAt(0);
      expect(vertex_5_0, vector3MoreOrLessEquals(Vector3(-32.2028, -2.60241, -2.72874)));
      final vertex_5_1 = mesh_5.vertices.elementAt(1);
      expect(vertex_5_1, vector3MoreOrLessEquals(Vector3(-34.5024, -1.65542, -5.0322)));
      final vertex_5_2 = mesh_5.vertices.elementAt(2);
      expect(vertex_5_2, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_3 = mesh_5.vertices.elementAt(3);
      expect(vertex_5_3, vector3MoreOrLessEquals(Vector3(-28.3272, -39.1319, 75.6947)));
      final vertex_5_4 = mesh_5.vertices.elementAt(4);
      expect(vertex_5_4, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_5 = mesh_5.vertices.elementAt(5);
      expect(vertex_5_5, vector3MoreOrLessEquals(Vector3(-28.6964, -38.6124, 75.6981)));
      final vertex_5_6 = mesh_5.vertices.elementAt(6);
      expect(vertex_5_6, vector3MoreOrLessEquals(Vector3(-32.2028, -2.60241, -2.72874)));
      final vertex_5_7 = mesh_5.vertices.elementAt(7);
      expect(vertex_5_7, vector3MoreOrLessEquals(Vector3(-34.5764, 8.10736, 17.2474)));
      final vertex_5_8 = mesh_5.vertices.elementAt(8);
      expect(vertex_5_8, vector3MoreOrLessEquals(Vector3(-36.1079, 8.51989, 15.5624)));
      final vertex_5_9 = mesh_5.vertices.elementAt(9);
      expect(vertex_5_9, vector3MoreOrLessEquals(Vector3(-34.5024, -1.65542, -5.0322)));
      final vertex_5_10 = mesh_5.vertices.elementAt(10);
      expect(vertex_5_10, vector3MoreOrLessEquals(Vector3(-39.059, 27.0856, 30.0882)));
      final vertex_5_11 = mesh_5.vertices.elementAt(11);
      expect(vertex_5_11, vector3MoreOrLessEquals(Vector3(-40.4062, 27.9341, 29.6066)));
      final vertex_5_12 = mesh_5.vertices.elementAt(12);
      expect(vertex_5_12, vector3MoreOrLessEquals(Vector3(-37.9441, -1.8839, -4.87553)));
      final vertex_5_13 = mesh_5.vertices.elementAt(13);
      expect(vertex_5_13, vector3MoreOrLessEquals(Vector3(-38.1253, 7.46189, 15.1556)));
      final vertex_5_14 = mesh_5.vertices.elementAt(14);
      expect(vertex_5_14, vector3MoreOrLessEquals(Vector3(-41.7305, 27.442, 29.4933)));
      final vertex_5_15 = mesh_5.vertices.elementAt(15);
      expect(vertex_5_15, vector3MoreOrLessEquals(Vector3(-39.059, 27.0856, 30.0882)));
      final vertex_5_16 = mesh_5.vertices.elementAt(16);
      expect(vertex_5_16, vector3MoreOrLessEquals(Vector3(-39.8973, 28.3933, 34.7092)));
      final vertex_5_17 = mesh_5.vertices.elementAt(17);
      expect(vertex_5_17, vector3MoreOrLessEquals(Vector3(-39.8973, 28.3933, 34.7092)));
      final vertex_5_18 = mesh_5.vertices.elementAt(18);
      expect(vertex_5_18, vector3MoreOrLessEquals(Vector3(-41.9958, 27.4554, 34.9761)));
      final vertex_5_19 = mesh_5.vertices.elementAt(19);
      expect(vertex_5_19, vector3MoreOrLessEquals(Vector3(-39.1095, 5.73008, 16.3333)));
      final vertex_5_20 = mesh_5.vertices.elementAt(20);
      expect(vertex_5_20, vector3MoreOrLessEquals(Vector3(-42.0347, 25.9799, 29.8337)));
      final vertex_5_21 = mesh_5.vertices.elementAt(21);
      expect(vertex_5_21, vector3MoreOrLessEquals(Vector3(-42.7527, 25.387, 34.2662)));
      final vertex_5_22 = mesh_5.vertices.elementAt(22);
      expect(vertex_5_22, vector3MoreOrLessEquals(Vector3(-39.9361, -3.11581, -2.37666)));
      final vertex_5_23 = mesh_5.vertices.elementAt(23);
      expect(vertex_5_23, vector3MoreOrLessEquals(Vector3(-38.9784, -4.42348, 0.582626)));
      final vertex_5_24 = mesh_5.vertices.elementAt(24);
      expect(vertex_5_24, vector3MoreOrLessEquals(Vector3(-38.3193, 4.62854, 18.2087)));
      final vertex_5_25 = mesh_5.vertices.elementAt(25);
      expect(vertex_5_25, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_26 = mesh_5.vertices.elementAt(26);
      expect(vertex_5_26, vector3MoreOrLessEquals(Vector3(-36.3498, 4.98674, 19.3696)));
      final vertex_5_27 = mesh_5.vertices.elementAt(27);
      expect(vertex_5_27, vector3MoreOrLessEquals(Vector3(-35.7923, -4.82223, 1.77398)));
      final vertex_5_28 = mesh_5.vertices.elementAt(28);
      expect(vertex_5_28, vector3MoreOrLessEquals(Vector3(-42.0347, 25.9799, 29.8337)));
      final vertex_5_29 = mesh_5.vertices.elementAt(29);
      expect(vertex_5_29, vector3MoreOrLessEquals(Vector3(-39.6072, 24.451, 30.7014)));
      final vertex_5_30 = mesh_5.vertices.elementAt(30);
      expect(vertex_5_30, vector3MoreOrLessEquals(Vector3(-32.7769, -4.01178, 0.300282)));
      final vertex_5_31 = mesh_5.vertices.elementAt(31);
      expect(vertex_5_31, vector3MoreOrLessEquals(Vector3(-34.6841, 6.53497, 18.9417)));
      final vertex_5_32 = mesh_5.vertices.elementAt(32);
      expect(vertex_5_32, vector3MoreOrLessEquals(Vector3(-38.7034, 25.5355, 30.5754)));
      final vertex_5_33 = mesh_5.vertices.elementAt(33);
      expect(vertex_5_33, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_34 = mesh_5.vertices.elementAt(34);
      expect(vertex_5_34, vector3MoreOrLessEquals(Vector3(-39.401, 23.7674, 32.3872)));
      final vertex_5_35 = mesh_5.vertices.elementAt(35);
      expect(vertex_5_35, vector3MoreOrLessEquals(Vector3(-38.7034, 25.5355, 30.5754)));
      final vertex_5_36 = mesh_5.vertices.elementAt(36);
      expect(vertex_5_36, vector3MoreOrLessEquals(Vector3(-37.8164, 25.4358, 32.6331)));
      final vertex_5_37 = mesh_5.vertices.elementAt(37);
      expect(vertex_5_37, vector3MoreOrLessEquals(Vector3(-38.0373, 27.4945, 33.6665)));
      final vertex_5_38 = mesh_5.vertices.elementAt(38);
      expect(vertex_5_38, vector3MoreOrLessEquals(Vector3(-39.059, 27.0856, 30.0882)));
      final vertex_5_39 = mesh_5.vertices.elementAt(39);
      expect(vertex_5_39, vector3MoreOrLessEquals(Vector3(-34.8747, 16.0338, 44.8611)));
      final vertex_5_40 = mesh_5.vertices.elementAt(40);
      expect(vertex_5_40, vector3MoreOrLessEquals(Vector3(-34.5404, 17.3149, 46.759)));
      final vertex_5_41 = mesh_5.vertices.elementAt(41);
      expect(vertex_5_41, vector3MoreOrLessEquals(Vector3(-36.5964, 14.5575, 44.4017)));
      final vertex_5_42 = mesh_5.vertices.elementAt(42);
      expect(vertex_5_42, vector3MoreOrLessEquals(Vector3(-28.7396, -36.0421, 65.8585)));
      final vertex_5_43 = mesh_5.vertices.elementAt(43);
      expect(vertex_5_43, vector3MoreOrLessEquals(Vector3(-27.9077, -35.3406, 66.0571)));
      final vertex_5_44 = mesh_5.vertices.elementAt(44);
      expect(vertex_5_44, vector3MoreOrLessEquals(Vector3(-28.0087, -33.484, 66.3923)));
      final vertex_5_45 = mesh_5.vertices.elementAt(45);
      expect(vertex_5_45, vector3MoreOrLessEquals(Vector3(-28.0087, -33.484, 66.3923)));
      final vertex_5_46 = mesh_5.vertices.elementAt(46);
      expect(vertex_5_46, vector3MoreOrLessEquals(Vector3(-38.4091, 13.9977, 45.7268)));
      final vertex_5_47 = mesh_5.vertices.elementAt(47);
      expect(vertex_5_47, vector3MoreOrLessEquals(Vector3(-28.7727, -40.0365, 75.5681)));
      final vertex_5_48 = mesh_5.vertices.elementAt(48);
      expect(vertex_5_48, vector3MoreOrLessEquals(Vector3(-28.3611, -39.7656, 75.6369)));
      final vertex_5_49 = mesh_5.vertices.elementAt(49);
      expect(vertex_5_49, vector3MoreOrLessEquals(Vector3(-28.3272, -39.1319, 75.6947)));
      final vertex_5_50 = mesh_5.vertices.elementAt(50);
      expect(vertex_5_50, vector3MoreOrLessEquals(Vector3(-29.2519, -39.7405, 75.5401)));
      final vertex_5_51 = mesh_5.vertices.elementAt(51);
      expect(vertex_5_51, vector3MoreOrLessEquals(Vector3(-28.7396, -36.0421, 65.8585)));
      final vertex_5_52 = mesh_5.vertices.elementAt(52);
      expect(vertex_5_52, vector3MoreOrLessEquals(Vector3(-30.4656, -33.1345, 66.2537)));
      final vertex_5_53 = mesh_5.vertices.elementAt(53);
      expect(vertex_5_53, vector3MoreOrLessEquals(Vector3(-29.4379, -39.1005, 75.5741)));
      final vertex_5_54 = mesh_5.vertices.elementAt(54);
      expect(vertex_5_54, vector3MoreOrLessEquals(Vector3(-29.878, -35.0603, 65.9459)));
      final vertex_5_55 = mesh_5.vertices.elementAt(55);
      expect(vertex_5_55, vector3MoreOrLessEquals(Vector3(-38.4091, 13.9977, 45.7268)));
      final vertex_5_56 = mesh_5.vertices.elementAt(56);
      expect(vertex_5_56, vector3MoreOrLessEquals(Vector3(-37.8067, 16.3061, 49.1466)));
      final vertex_5_57 = mesh_5.vertices.elementAt(57);
      expect(vertex_5_57, vector3MoreOrLessEquals(Vector3(-30.06, -31.7149, 66.5499)));
      final vertex_5_58 = mesh_5.vertices.elementAt(58);
      expect(vertex_5_58, vector3MoreOrLessEquals(Vector3(-38.9477, 14.7759, 47.8385)));
      final vertex_5_59 = mesh_5.vertices.elementAt(59);
      expect(vertex_5_59, vector3MoreOrLessEquals(Vector3(-29.1907, -38.5984, 75.6444)));
      final vertex_5_60 = mesh_5.vertices.elementAt(60);
      expect(vertex_5_60, vector3MoreOrLessEquals(Vector3(-42.7527, 25.387, 34.2662)));
      final vertex_5_61 = mesh_5.vertices.elementAt(61);
      expect(vertex_5_61, vector3MoreOrLessEquals(Vector3(-30.4656, -33.1345, 66.2537)));
      final vertex_5_62 = mesh_5.vertices.elementAt(62);
      expect(vertex_5_62, vector3MoreOrLessEquals(Vector3(-41.7305, 27.442, 29.4933)));
      final vertex_5_63 = mesh_5.vertices.elementAt(63);
      expect(vertex_5_63, vector3MoreOrLessEquals(Vector3(-41.5979, 23.7457, 33.114)));
      final vertex_5_64 = mesh_5.vertices.elementAt(64);
      expect(vertex_5_64, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_65 = mesh_5.vertices.elementAt(65);
      expect(vertex_5_65, vector3MoreOrLessEquals(Vector3(-35.8452, 17.4361, 48.6662)));
      final vertex_5_66 = mesh_5.vertices.elementAt(66);
      expect(vertex_5_66, vector3MoreOrLessEquals(Vector3(-28.9666, -31.8704, 66.6116)));
      final vertex_5_67 = mesh_5.vertices.elementAt(67);
      expect(vertex_5_67, vector3MoreOrLessEquals(Vector3(-38.0373, 27.4945, 33.6665)));
      final vertex_5_68 = mesh_5.vertices.elementAt(68);
      expect(vertex_5_68, vector3MoreOrLessEquals(Vector3(-34.5404, 17.3149, 46.759)));
      final vertex_5_69 = mesh_5.vertices.elementAt(69);
      expect(vertex_5_69, vector3MoreOrLessEquals(Vector3(-28.0087, -33.484, 66.3923)));
      final vertex_5_70 = mesh_5.vertices.elementAt(70);
      expect(vertex_5_70, vector3MoreOrLessEquals(Vector3(-28.9666, -31.8704, 66.6116)));
      final vertex_5_71 = mesh_5.vertices.elementAt(71);
      expect(vertex_5_71, vector3MoreOrLessEquals(Vector3(-28.3272, -39.1319, 75.6947)));
      final vertex_5_72 = mesh_5.vertices.elementAt(72);
      expect(vertex_5_72, vector3MoreOrLessEquals(Vector3(-28.6964, -38.6124, 75.6981)));
      final vertex_5_73 = mesh_5.vertices.elementAt(73);
      expect(vertex_5_73, vector3MoreOrLessEquals(Vector3(-30.06, -31.7149, 66.5499)));
      final vertex_5_74 = mesh_5.vertices.elementAt(74);
      expect(vertex_5_74, vector3MoreOrLessEquals(Vector3(-37.8067, 16.3061, 49.1466)));
      final vertex_5_75 = mesh_5.vertices.elementAt(75);
      expect(vertex_5_75, vector3MoreOrLessEquals(Vector3(-34.5764, 8.10736, 17.2474)));
      final vertex_5_76 = mesh_5.vertices.elementAt(76);
      expect(vertex_5_76, vector3MoreOrLessEquals(Vector3(-32.2028, -2.60241, -2.72874)));
      final vertex_5_77 = mesh_5.vertices.elementAt(77);
      expect(vertex_5_77, vector3MoreOrLessEquals(Vector3(-39.059, 27.0856, 30.0882)));
      final vertex_5_78 = mesh_5.vertices.elementAt(78);
      expect(vertex_5_78, vector3MoreOrLessEquals(Vector3(-34.5764, 8.10736, 17.2474)));
      final vertex_5_79 = mesh_5.vertices.elementAt(79);
      expect(vertex_5_79, vector3MoreOrLessEquals(Vector3(-34.5024, -1.65542, -5.0322)));
      final vertex_5_80 = mesh_5.vertices.elementAt(80);
      expect(vertex_5_80, vector3MoreOrLessEquals(Vector3(-37.9441, -1.8839, -4.87553)));
      final vertex_5_81 = mesh_5.vertices.elementAt(81);
      expect(vertex_5_81, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_82 = mesh_5.vertices.elementAt(82);
      expect(vertex_5_82, vector3MoreOrLessEquals(Vector3(-28.6964, -38.6124, 75.6981)));
      final vertex_5_83 = mesh_5.vertices.elementAt(83);
      expect(vertex_5_83, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_84 = mesh_5.vertices.elementAt(84);
      expect(vertex_5_84, vector3MoreOrLessEquals(Vector3(-29.1907, -38.5984, 75.6444)));
      final vertex_5_85 = mesh_5.vertices.elementAt(85);
      expect(vertex_5_85, vector3MoreOrLessEquals(Vector3(-37.9441, -1.8839, -4.87553)));
      final vertex_5_86 = mesh_5.vertices.elementAt(86);
      expect(vertex_5_86, vector3MoreOrLessEquals(Vector3(-39.9361, -3.11581, -2.37666)));
      final vertex_5_87 = mesh_5.vertices.elementAt(87);
      expect(vertex_5_87, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_88 = mesh_5.vertices.elementAt(88);
      expect(vertex_5_88, vector3MoreOrLessEquals(Vector3(-29.1907, -38.5984, 75.6444)));
      final vertex_5_89 = mesh_5.vertices.elementAt(89);
      expect(vertex_5_89, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_90 = mesh_5.vertices.elementAt(90);
      expect(vertex_5_90, vector3MoreOrLessEquals(Vector3(-29.4379, -39.1005, 75.5741)));
      final vertex_5_91 = mesh_5.vertices.elementAt(91);
      expect(vertex_5_91, vector3MoreOrLessEquals(Vector3(-39.9361, -3.11581, -2.37666)));
      final vertex_5_92 = mesh_5.vertices.elementAt(92);
      expect(vertex_5_92, vector3MoreOrLessEquals(Vector3(-38.9784, -4.42348, 0.582626)));
      final vertex_5_93 = mesh_5.vertices.elementAt(93);
      expect(vertex_5_93, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_94 = mesh_5.vertices.elementAt(94);
      expect(vertex_5_94, vector3MoreOrLessEquals(Vector3(-29.4379, -39.1005, 75.5741)));
      final vertex_5_95 = mesh_5.vertices.elementAt(95);
      expect(vertex_5_95, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_96 = mesh_5.vertices.elementAt(96);
      expect(vertex_5_96, vector3MoreOrLessEquals(Vector3(-29.2519, -39.7405, 75.5401)));
      final vertex_5_97 = mesh_5.vertices.elementAt(97);
      expect(vertex_5_97, vector3MoreOrLessEquals(Vector3(-38.9784, -4.42348, 0.582626)));
      final vertex_5_98 = mesh_5.vertices.elementAt(98);
      expect(vertex_5_98, vector3MoreOrLessEquals(Vector3(-35.7923, -4.82223, 1.77398)));
      final vertex_5_99 = mesh_5.vertices.elementAt(99);
      expect(vertex_5_99, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_100 = mesh_5.vertices.elementAt(100);
      expect(vertex_5_100, vector3MoreOrLessEquals(Vector3(-29.2519, -39.7405, 75.5401)));
      final vertex_5_101 = mesh_5.vertices.elementAt(101);
      expect(vertex_5_101, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_102 = mesh_5.vertices.elementAt(102);
      expect(vertex_5_102, vector3MoreOrLessEquals(Vector3(-28.7727, -40.0365, 75.5681)));
      final vertex_5_103 = mesh_5.vertices.elementAt(103);
      expect(vertex_5_103, vector3MoreOrLessEquals(Vector3(-35.7923, -4.82223, 1.77398)));
      final vertex_5_104 = mesh_5.vertices.elementAt(104);
      expect(vertex_5_104, vector3MoreOrLessEquals(Vector3(-32.7769, -4.01178, 0.300282)));
      final vertex_5_105 = mesh_5.vertices.elementAt(105);
      expect(vertex_5_105, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_106 = mesh_5.vertices.elementAt(106);
      expect(vertex_5_106, vector3MoreOrLessEquals(Vector3(-28.7727, -40.0365, 75.5681)));
      final vertex_5_107 = mesh_5.vertices.elementAt(107);
      expect(vertex_5_107, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_108 = mesh_5.vertices.elementAt(108);
      expect(vertex_5_108, vector3MoreOrLessEquals(Vector3(-28.3611, -39.7656, 75.6369)));
      final vertex_5_109 = mesh_5.vertices.elementAt(109);
      expect(vertex_5_109, vector3MoreOrLessEquals(Vector3(-32.7769, -4.01178, 0.300282)));
      final vertex_5_110 = mesh_5.vertices.elementAt(110);
      expect(vertex_5_110, vector3MoreOrLessEquals(Vector3(-32.2028, -2.60241, -2.72874)));
      final vertex_5_111 = mesh_5.vertices.elementAt(111);
      expect(vertex_5_111, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_112 = mesh_5.vertices.elementAt(112);
      expect(vertex_5_112, vector3MoreOrLessEquals(Vector3(-28.3611, -39.7656, 75.6369)));
      final vertex_5_113 = mesh_5.vertices.elementAt(113);
      expect(vertex_5_113, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_114 = mesh_5.vertices.elementAt(114);
      expect(vertex_5_114, vector3MoreOrLessEquals(Vector3(-28.3272, -39.1319, 75.6947)));
      expect(mesh_5.normals.length, isZero);
      expect(mesh_5.tangents.length, isZero);
      expect(mesh_5.bitangents.length, isZero);
      expect(mesh_5.colors.length, isZero);
      expect(mesh_5.textureCoords.length, isZero);
      expect(mesh_5.uvComponents.length, isZero);
      expect(mesh_5.uvComponents, equals([]));
      expect(mesh_5.faces.length, equals(98));
      expect(mesh_5.bones.length, isZero);
      expect(mesh_5.materialIndex, equals(2));
      expect(mesh_5.name, equals('Bein2Re'));
      expect(mesh_5.animMeshes.length, isZero);
      expect(mesh_5.morphingMethod, isZero);
      expect(mesh_5.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_6 = meshes.elementAt(6);
      expect(mesh_6.primitiveTypes, equals(4));
      expect(mesh_6.vertices.length, equals(107));
      final vertex_6_0 = mesh_6.vertices.elementAt(0);
      expect(vertex_6_0, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -4.81347)));
      final vertex_6_1 = mesh_6.vertices.elementAt(1);
      expect(vertex_6_1, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -5.88753)));
      final vertex_6_2 = mesh_6.vertices.elementAt(2);
      expect(vertex_6_2, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_3 = mesh_6.vertices.elementAt(3);
      expect(vertex_6_3, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, 86.1982)));
      final vertex_6_4 = mesh_6.vertices.elementAt(4);
      expect(vertex_6_4, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_5 = mesh_6.vertices.elementAt(5);
      expect(vertex_6_5, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, 86.5102)));
      final vertex_6_6 = mesh_6.vertices.elementAt(6);
      expect(vertex_6_6, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -4.81347)));
      final vertex_6_7 = mesh_6.vertices.elementAt(7);
      expect(vertex_6_7, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, 12.4635)));
      final vertex_6_8 = mesh_6.vertices.elementAt(8);
      expect(vertex_6_8, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, 11.176)));
      final vertex_6_9 = mesh_6.vertices.elementAt(9);
      expect(vertex_6_9, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -5.88753)));
      final vertex_6_10 = mesh_6.vertices.elementAt(10);
      expect(vertex_6_10, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, 26.4104)));
      final vertex_6_11 = mesh_6.vertices.elementAt(11);
      expect(vertex_6_11, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, 26.2119)));
      final vertex_6_12 = mesh_6.vertices.elementAt(12);
      expect(vertex_6_12, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -4.14655)));
      final vertex_6_13 = mesh_6.vertices.elementAt(13);
      expect(vertex_6_13, vector3MoreOrLessEquals(Vector3(-18.5514, 8.96432, 11.3467)));
      final vertex_6_14 = mesh_6.vertices.elementAt(14);
      expect(vertex_6_14, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, 26.4584)));
      final vertex_6_15 = mesh_6.vertices.elementAt(15);
      expect(vertex_6_15, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, 12.847)));
      final vertex_6_16 = mesh_6.vertices.elementAt(16);
      expect(vertex_6_16, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -0.901443)));
      final vertex_6_17 = mesh_6.vertices.elementAt(17);
      expect(vertex_6_17, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, 26.9645)));
      final vertex_6_18 = mesh_6.vertices.elementAt(18);
      expect(vertex_6_18, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, 1.40408)));
      final vertex_6_19 = mesh_6.vertices.elementAt(19);
      expect(vertex_6_19, vector3MoreOrLessEquals(Vector3(-19.5314, 6.4777, 14.5472)));
      final vertex_6_20 = mesh_6.vertices.elementAt(20);
      expect(vertex_6_20, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_21 = mesh_6.vertices.elementAt(21);
      expect(vertex_6_21, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, 15.167)));
      final vertex_6_22 = mesh_6.vertices.elementAt(22);
      expect(vertex_6_22, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, 1.03395)));
      final vertex_6_23 = mesh_6.vertices.elementAt(23);
      expect(vertex_6_23, vector3MoreOrLessEquals(Vector3(-14.1676, 26.0791, 27.3223)));
      final vertex_6_24 = mesh_6.vertices.elementAt(24);
      expect(vertex_6_24, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -1.73312)));
      final vertex_6_25 = mesh_6.vertices.elementAt(25);
      expect(vertex_6_25, vector3MoreOrLessEquals(Vector3(-15.3994, 6.00928, 14.2396)));
      final vertex_6_26 = mesh_6.vertices.elementAt(26);
      expect(vertex_6_26, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, 26.9046)));
      final vertex_6_27 = mesh_6.vertices.elementAt(27);
      expect(vertex_6_27, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_28 = mesh_6.vertices.elementAt(28);
      expect(vertex_6_28, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, 28.9514)));
      final vertex_6_29 = mesh_6.vertices.elementAt(29);
      expect(vertex_6_29, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, 26.9046)));
      final vertex_6_30 = mesh_6.vertices.elementAt(30);
      expect(vertex_6_30, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, 26.9645)));
      final vertex_6_31 = mesh_6.vertices.elementAt(31);
      expect(vertex_6_31, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, 31.4691)));
      final vertex_6_32 = mesh_6.vertices.elementAt(32);
      expect(vertex_6_32, vector3MoreOrLessEquals(Vector3(-15.5666, 26.3996, 30.1895)));
      final vertex_6_33 = mesh_6.vertices.elementAt(33);
      expect(vertex_6_33, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, 26.2119)));
      final vertex_6_34 = mesh_6.vertices.elementAt(34);
      expect(vertex_6_34, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, 30.9928)));
      final vertex_6_35 = mesh_6.vertices.elementAt(35);
      expect(vertex_6_35, vector3MoreOrLessEquals(Vector3(-13.3946, 29.5602, 31.8266)));
      final vertex_6_36 = mesh_6.vertices.elementAt(36);
      expect(vertex_6_36, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, 26.4104)));
      final vertex_6_37 = mesh_6.vertices.elementAt(37);
      expect(vertex_6_37, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, 30.9928)));
      final vertex_6_38 = mesh_6.vertices.elementAt(38);
      expect(vertex_6_38, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, 29.5956)));
      final vertex_6_39 = mesh_6.vertices.elementAt(39);
      expect(vertex_6_39, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, 54.8821)));
      final vertex_6_40 = mesh_6.vertices.elementAt(40);
      expect(vertex_6_40, vector3MoreOrLessEquals(Vector3(-1.5147, 14.1058, 57.0357)));
      final vertex_6_41 = mesh_6.vertices.elementAt(41);
      expect(vertex_6_41, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, 58.0563)));
      final vertex_6_42 = mesh_6.vertices.elementAt(42);
      expect(vertex_6_42, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, 80.768)));
      final vertex_6_43 = mesh_6.vertices.elementAt(43);
      expect(vertex_6_43, vector3MoreOrLessEquals(Vector3(2.445, -29.5186, 81.251)));
      final vertex_6_44 = mesh_6.vertices.elementAt(44);
      expect(vertex_6_44, vector3MoreOrLessEquals(Vector3(-5.65842, 13.6618, 57.1753)));
      final vertex_6_45 = mesh_6.vertices.elementAt(45);
      expect(vertex_6_45, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, 80.7919)));
      final vertex_6_46 = mesh_6.vertices.elementAt(46);
      expect(vertex_6_46, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, 79.7065)));
      final vertex_6_47 = mesh_6.vertices.elementAt(47);
      expect(vertex_6_47, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, 86.1982)));
      final vertex_6_48 = mesh_6.vertices.elementAt(48);
      expect(vertex_6_48, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, 86.5102)));
      final vertex_6_49 = mesh_6.vertices.elementAt(49);
      expect(vertex_6_49, vector3MoreOrLessEquals(Vector3(4.58777, -39.3502, 86.6912)));
      final vertex_6_50 = mesh_6.vertices.elementAt(50);
      expect(vertex_6_50, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, 86.6049)));
      final vertex_6_51 = mesh_6.vertices.elementAt(51);
      expect(vertex_6_51, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, 86.3163)));
      final vertex_6_52 = mesh_6.vertices.elementAt(52);
      expect(vertex_6_52, vector3MoreOrLessEquals(Vector3(1.40262, -32.3836, 79.7363)));
      final vertex_6_53 = mesh_6.vertices.elementAt(53);
      expect(vertex_6_53, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, 78.8791)));
      final vertex_6_54 = mesh_6.vertices.elementAt(54);
      expect(vertex_6_54, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, 86.0428)));
      final vertex_6_55 = mesh_6.vertices.elementAt(55);
      expect(vertex_6_55, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, 55.0563)));
      final vertex_6_56 = mesh_6.vertices.elementAt(56);
      expect(vertex_6_56, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, 31.4691)));
      final vertex_6_57 = mesh_6.vertices.elementAt(57);
      expect(vertex_6_57, vector3MoreOrLessEquals(Vector3(-4.72603, 12.454, 53.2947)));
      final vertex_6_58 = mesh_6.vertices.elementAt(58);
      expect(vertex_6_58, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_59 = mesh_6.vertices.elementAt(59);
      expect(vertex_6_59, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, 53.2173)));
      final vertex_6_60 = mesh_6.vertices.elementAt(60);
      expect(vertex_6_60, vector3MoreOrLessEquals(Vector3(-11.729, 25.7647, 28.6871)));
      final vertex_6_61 = mesh_6.vertices.elementAt(61);
      expect(vertex_6_61, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, 29.5956)));
      final vertex_6_62 = mesh_6.vertices.elementAt(62);
      expect(vertex_6_62, vector3MoreOrLessEquals(Vector3(3.09747, -32.9692, 78.8659)));
      final vertex_6_63 = mesh_6.vertices.elementAt(63);
      expect(vertex_6_63, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, 54.8821)));
      final vertex_6_64 = mesh_6.vertices.elementAt(64);
      expect(vertex_6_64, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, 79.7065)));
      final vertex_6_65 = mesh_6.vertices.elementAt(65);
      expect(vertex_6_65, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, 26.4104)));
      final vertex_6_66 = mesh_6.vertices.elementAt(66);
      expect(vertex_6_66, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, 12.4635)));
      final vertex_6_67 = mesh_6.vertices.elementAt(67);
      expect(vertex_6_67, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, 26.4104)));
      final vertex_6_68 = mesh_6.vertices.elementAt(68);
      expect(vertex_6_68, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -4.81347)));
      final vertex_6_69 = mesh_6.vertices.elementAt(69);
      expect(vertex_6_69, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, 85.9902)));
      final vertex_6_70 = mesh_6.vertices.elementAt(70);
      expect(vertex_6_70, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, 86.1982)));
      final vertex_6_71 = mesh_6.vertices.elementAt(71);
      expect(vertex_6_71, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -5.88753)));
      final vertex_6_72 = mesh_6.vertices.elementAt(72);
      expect(vertex_6_72, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -4.14655)));
      final vertex_6_73 = mesh_6.vertices.elementAt(73);
      expect(vertex_6_73, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_74 = mesh_6.vertices.elementAt(74);
      expect(vertex_6_74, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, 86.5102)));
      final vertex_6_75 = mesh_6.vertices.elementAt(75);
      expect(vertex_6_75, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_76 = mesh_6.vertices.elementAt(76);
      expect(vertex_6_76, vector3MoreOrLessEquals(Vector3(4.58777, -39.3502, 86.6912)));
      final vertex_6_77 = mesh_6.vertices.elementAt(77);
      expect(vertex_6_77, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -4.14655)));
      final vertex_6_78 = mesh_6.vertices.elementAt(78);
      expect(vertex_6_78, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -0.901443)));
      final vertex_6_79 = mesh_6.vertices.elementAt(79);
      expect(vertex_6_79, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_80 = mesh_6.vertices.elementAt(80);
      expect(vertex_6_80, vector3MoreOrLessEquals(Vector3(4.58777, -39.3502, 86.6912)));
      final vertex_6_81 = mesh_6.vertices.elementAt(81);
      expect(vertex_6_81, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_82 = mesh_6.vertices.elementAt(82);
      expect(vertex_6_82, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, 86.6049)));
      final vertex_6_83 = mesh_6.vertices.elementAt(83);
      expect(vertex_6_83, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -0.901443)));
      final vertex_6_84 = mesh_6.vertices.elementAt(84);
      expect(vertex_6_84, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, 1.40408)));
      final vertex_6_85 = mesh_6.vertices.elementAt(85);
      expect(vertex_6_85, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_86 = mesh_6.vertices.elementAt(86);
      expect(vertex_6_86, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, 86.6049)));
      final vertex_6_87 = mesh_6.vertices.elementAt(87);
      expect(vertex_6_87, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_88 = mesh_6.vertices.elementAt(88);
      expect(vertex_6_88, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, 86.3163)));
      final vertex_6_89 = mesh_6.vertices.elementAt(89);
      expect(vertex_6_89, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, 1.40408)));
      final vertex_6_90 = mesh_6.vertices.elementAt(90);
      expect(vertex_6_90, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, 1.03395)));
      final vertex_6_91 = mesh_6.vertices.elementAt(91);
      expect(vertex_6_91, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_92 = mesh_6.vertices.elementAt(92);
      expect(vertex_6_92, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, 86.3163)));
      final vertex_6_93 = mesh_6.vertices.elementAt(93);
      expect(vertex_6_93, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_94 = mesh_6.vertices.elementAt(94);
      expect(vertex_6_94, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, 86.0428)));
      final vertex_6_95 = mesh_6.vertices.elementAt(95);
      expect(vertex_6_95, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, 1.03395)));
      final vertex_6_96 = mesh_6.vertices.elementAt(96);
      expect(vertex_6_96, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -1.73312)));
      final vertex_6_97 = mesh_6.vertices.elementAt(97);
      expect(vertex_6_97, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_98 = mesh_6.vertices.elementAt(98);
      expect(vertex_6_98, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, 86.0428)));
      final vertex_6_99 = mesh_6.vertices.elementAt(99);
      expect(vertex_6_99, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_100 = mesh_6.vertices.elementAt(100);
      expect(vertex_6_100, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, 85.9902)));
      final vertex_6_101 = mesh_6.vertices.elementAt(101);
      expect(vertex_6_101, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -1.73312)));
      final vertex_6_102 = mesh_6.vertices.elementAt(102);
      expect(vertex_6_102, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -4.81347)));
      final vertex_6_103 = mesh_6.vertices.elementAt(103);
      expect(vertex_6_103, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_104 = mesh_6.vertices.elementAt(104);
      expect(vertex_6_104, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, 85.9902)));
      final vertex_6_105 = mesh_6.vertices.elementAt(105);
      expect(vertex_6_105, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_106 = mesh_6.vertices.elementAt(106);
      expect(vertex_6_106, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, 86.1982)));
      expect(mesh_6.normals.length, isZero);
      expect(mesh_6.tangents.length, isZero);
      expect(mesh_6.bitangents.length, isZero);
      expect(mesh_6.colors.length, isZero);
      expect(mesh_6.textureCoords.length, isZero);
      expect(mesh_6.uvComponents.length, isZero);
      expect(mesh_6.uvComponents, equals([]));
      expect(mesh_6.faces.length, equals(98));
      expect(mesh_6.bones.length, isZero);
      expect(mesh_6.materialIndex, equals(2));
      expect(mesh_6.name, equals('Bein3Re'));
      expect(mesh_6.animMeshes.length, isZero);
      expect(mesh_6.morphingMethod, isZero);
      expect(mesh_6.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_7 = meshes.elementAt(7);
      expect(mesh_7.primitiveTypes, equals(4));
      expect(mesh_7.vertices.length, equals(107));
      final vertex_7_0 = mesh_7.vertices.elementAt(0);
      expect(vertex_7_0, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_1 = mesh_7.vertices.elementAt(1);
      expect(vertex_7_1, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -14.1125)));
      final vertex_7_2 = mesh_7.vertices.elementAt(2);
      expect(vertex_7_2, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -15.1865)));
      final vertex_7_3 = mesh_7.vertices.elementAt(3);
      expect(vertex_7_3, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, -106.51)));
      final vertex_7_4 = mesh_7.vertices.elementAt(4);
      expect(vertex_7_4, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_5 = mesh_7.vertices.elementAt(5);
      expect(vertex_7_5, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, -106.198)));
      final vertex_7_6 = mesh_7.vertices.elementAt(6);
      expect(vertex_7_6, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, -31.176)));
      final vertex_7_7 = mesh_7.vertices.elementAt(7);
      expect(vertex_7_7, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, -32.4635)));
      final vertex_7_8 = mesh_7.vertices.elementAt(8);
      expect(vertex_7_8, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -15.1865)));
      final vertex_7_9 = mesh_7.vertices.elementAt(9);
      expect(vertex_7_9, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -14.1125)));
      final vertex_7_10 = mesh_7.vertices.elementAt(10);
      expect(vertex_7_10, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, -46.4104)));
      final vertex_7_11 = mesh_7.vertices.elementAt(11);
      expect(vertex_7_11, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, -46.2119)));
      final vertex_7_12 = mesh_7.vertices.elementAt(12);
      expect(vertex_7_12, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, -46.4584)));
      final vertex_7_13 = mesh_7.vertices.elementAt(13);
      expect(vertex_7_13, vector3MoreOrLessEquals(Vector3(-18.5514, 8.96432, -31.3467)));
      final vertex_7_14 = mesh_7.vertices.elementAt(14);
      expect(vertex_7_14, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, -50.9928)));
      final vertex_7_15 = mesh_7.vertices.elementAt(15);
      expect(vertex_7_15, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, -46.2119)));
      final vertex_7_16 = mesh_7.vertices.elementAt(16);
      expect(vertex_7_16, vector3MoreOrLessEquals(Vector3(-13.3946, 29.5602, -51.8266)));
      final vertex_7_17 = mesh_7.vertices.elementAt(17);
      expect(vertex_7_17, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, -32.847)));
      final vertex_7_18 = mesh_7.vertices.elementAt(18);
      expect(vertex_7_18, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, -46.9645)));
      final vertex_7_19 = mesh_7.vertices.elementAt(19);
      expect(vertex_7_19, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, -51.4691)));
      final vertex_7_20 = mesh_7.vertices.elementAt(20);
      expect(vertex_7_20, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, -46.9645)));
      final vertex_7_21 = mesh_7.vertices.elementAt(21);
      expect(vertex_7_21, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -15.8535)));
      final vertex_7_22 = mesh_7.vertices.elementAt(22);
      expect(vertex_7_22, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -19.0986)));
      final vertex_7_23 = mesh_7.vertices.elementAt(23);
      expect(vertex_7_23, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, -21.4041)));
      final vertex_7_24 = mesh_7.vertices.elementAt(24);
      expect(vertex_7_24, vector3MoreOrLessEquals(Vector3(-19.5314, 6.4777, -34.5472)));
      final vertex_7_25 = mesh_7.vertices.elementAt(25);
      expect(vertex_7_25, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, -35.167)));
      final vertex_7_26 = mesh_7.vertices.elementAt(26);
      expect(vertex_7_26, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, -21.034)));
      final vertex_7_27 = mesh_7.vertices.elementAt(27);
      expect(vertex_7_27, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_28 = mesh_7.vertices.elementAt(28);
      expect(vertex_7_28, vector3MoreOrLessEquals(Vector3(-14.1676, 26.0791, -47.3223)));
      final vertex_7_29 = mesh_7.vertices.elementAt(29);
      expect(vertex_7_29, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, -48.9514)));
      final vertex_7_30 = mesh_7.vertices.elementAt(30);
      expect(vertex_7_30, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_31 = mesh_7.vertices.elementAt(31);
      expect(vertex_7_31, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, -46.9046)));
      final vertex_7_32 = mesh_7.vertices.elementAt(32);
      expect(vertex_7_32, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, -46.9046)));
      final vertex_7_33 = mesh_7.vertices.elementAt(33);
      expect(vertex_7_33, vector3MoreOrLessEquals(Vector3(-15.5666, 26.3996, -50.1895)));
      final vertex_7_34 = mesh_7.vertices.elementAt(34);
      expect(vertex_7_34, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, -78.0563)));
      final vertex_7_35 = mesh_7.vertices.elementAt(35);
      expect(vertex_7_35, vector3MoreOrLessEquals(Vector3(-5.65842, 13.6618, -77.1753)));
      final vertex_7_36 = mesh_7.vertices.elementAt(36);
      expect(vertex_7_36, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_37 = mesh_7.vertices.elementAt(37);
      expect(vertex_7_37, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, -75.0563)));
      final vertex_7_38 = mesh_7.vertices.elementAt(38);
      expect(vertex_7_38, vector3MoreOrLessEquals(Vector3(-4.72603, 12.454, -73.2947)));
      final vertex_7_39 = mesh_7.vertices.elementAt(39);
      expect(vertex_7_39, vector3MoreOrLessEquals(Vector3(-11.729, 25.7647, -48.6871)));
      final vertex_7_40 = mesh_7.vertices.elementAt(40);
      expect(vertex_7_40, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, -73.2173)));
      final vertex_7_41 = mesh_7.vertices.elementAt(41);
      expect(vertex_7_41, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, -98.8791)));
      final vertex_7_42 = mesh_7.vertices.elementAt(42);
      expect(vertex_7_42, vector3MoreOrLessEquals(Vector3(3.09747, -32.9692, -98.8659)));
      final vertex_7_43 = mesh_7.vertices.elementAt(43);
      expect(vertex_7_43, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, -49.5956)));
      final vertex_7_44 = mesh_7.vertices.elementAt(44);
      expect(vertex_7_44, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, -74.8821)));
      final vertex_7_45 = mesh_7.vertices.elementAt(45);
      expect(vertex_7_45, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, -99.7065)));
      final vertex_7_46 = mesh_7.vertices.elementAt(46);
      expect(vertex_7_46, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, -46.4104)));
      final vertex_7_47 = mesh_7.vertices.elementAt(47);
      expect(vertex_7_47, vector3MoreOrLessEquals(Vector3(-15.3994, 6.00928, -34.2396)));
      final vertex_7_48 = mesh_7.vertices.elementAt(48);
      expect(vertex_7_48, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, -32.4635)));
      final vertex_7_49 = mesh_7.vertices.elementAt(49);
      expect(vertex_7_49, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, -46.4104)));
      final vertex_7_50 = mesh_7.vertices.elementAt(50);
      expect(vertex_7_50, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -18.2669)));
      final vertex_7_51 = mesh_7.vertices.elementAt(51);
      expect(vertex_7_51, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -15.1865)));
      final vertex_7_52 = mesh_7.vertices.elementAt(52);
      expect(vertex_7_52, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, -105.99)));
      final vertex_7_53 = mesh_7.vertices.elementAt(53);
      expect(vertex_7_53, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, -106.198)));
      final vertex_7_54 = mesh_7.vertices.elementAt(54);
      expect(vertex_7_54, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, -106.043)));
      final vertex_7_55 = mesh_7.vertices.elementAt(55);
      expect(vertex_7_55, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, -106.316)));
      final vertex_7_56 = mesh_7.vertices.elementAt(56);
      expect(vertex_7_56, vector3MoreOrLessEquals(Vector3(1.40262, -32.3836, -99.7363)));
      final vertex_7_57 = mesh_7.vertices.elementAt(57);
      expect(vertex_7_57, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, -106.605)));
      final vertex_7_58 = mesh_7.vertices.elementAt(58);
      expect(vertex_7_58, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, -100.792)));
      final vertex_7_59 = mesh_7.vertices.elementAt(59);
      expect(vertex_7_59, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, -51.4691)));
      final vertex_7_60 = mesh_7.vertices.elementAt(60);
      expect(vertex_7_60, vector3MoreOrLessEquals(Vector3(2.445, -29.5186, -101.251)));
      final vertex_7_61 = mesh_7.vertices.elementAt(61);
      expect(vertex_7_61, vector3MoreOrLessEquals(Vector3(4.58776, -39.3502, -106.691)));
      final vertex_7_62 = mesh_7.vertices.elementAt(62);
      expect(vertex_7_62, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, -100.768)));
      final vertex_7_63 = mesh_7.vertices.elementAt(63);
      expect(vertex_7_63, vector3MoreOrLessEquals(Vector3(-1.5147, 14.1058, -77.0357)));
      final vertex_7_64 = mesh_7.vertices.elementAt(64);
      expect(vertex_7_64, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, -74.8821)));
      final vertex_7_65 = mesh_7.vertices.elementAt(65);
      expect(vertex_7_65, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, -49.5956)));
      final vertex_7_66 = mesh_7.vertices.elementAt(66);
      expect(vertex_7_66, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, -46.4104)));
      final vertex_7_67 = mesh_7.vertices.elementAt(67);
      expect(vertex_7_67, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, -99.7065)));
      final vertex_7_68 = mesh_7.vertices.elementAt(68);
      expect(vertex_7_68, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, -106.198)));
      final vertex_7_69 = mesh_7.vertices.elementAt(69);
      expect(vertex_7_69, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, -106.51)));
      final vertex_7_70 = mesh_7.vertices.elementAt(70);
      expect(vertex_7_70, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, -50.9928)));
      final vertex_7_71 = mesh_7.vertices.elementAt(71);
      expect(vertex_7_71, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_72 = mesh_7.vertices.elementAt(72);
      expect(vertex_7_72, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -15.8535)));
      final vertex_7_73 = mesh_7.vertices.elementAt(73);
      expect(vertex_7_73, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -14.1125)));
      final vertex_7_74 = mesh_7.vertices.elementAt(74);
      expect(vertex_7_74, vector3MoreOrLessEquals(Vector3(4.58776, -39.3502, -106.691)));
      final vertex_7_75 = mesh_7.vertices.elementAt(75);
      expect(vertex_7_75, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_76 = mesh_7.vertices.elementAt(76);
      expect(vertex_7_76, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, -106.51)));
      final vertex_7_77 = mesh_7.vertices.elementAt(77);
      expect(vertex_7_77, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_78 = mesh_7.vertices.elementAt(78);
      expect(vertex_7_78, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -19.0986)));
      final vertex_7_79 = mesh_7.vertices.elementAt(79);
      expect(vertex_7_79, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -15.8535)));
      final vertex_7_80 = mesh_7.vertices.elementAt(80);
      expect(vertex_7_80, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, -106.605)));
      final vertex_7_81 = mesh_7.vertices.elementAt(81);
      expect(vertex_7_81, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_82 = mesh_7.vertices.elementAt(82);
      expect(vertex_7_82, vector3MoreOrLessEquals(Vector3(4.58776, -39.3502, -106.691)));
      final vertex_7_83 = mesh_7.vertices.elementAt(83);
      expect(vertex_7_83, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_84 = mesh_7.vertices.elementAt(84);
      expect(vertex_7_84, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, -21.4041)));
      final vertex_7_85 = mesh_7.vertices.elementAt(85);
      expect(vertex_7_85, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -19.0986)));
      final vertex_7_86 = mesh_7.vertices.elementAt(86);
      expect(vertex_7_86, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, -106.316)));
      final vertex_7_87 = mesh_7.vertices.elementAt(87);
      expect(vertex_7_87, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_88 = mesh_7.vertices.elementAt(88);
      expect(vertex_7_88, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, -106.605)));
      final vertex_7_89 = mesh_7.vertices.elementAt(89);
      expect(vertex_7_89, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_90 = mesh_7.vertices.elementAt(90);
      expect(vertex_7_90, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, -21.034)));
      final vertex_7_91 = mesh_7.vertices.elementAt(91);
      expect(vertex_7_91, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, -21.4041)));
      final vertex_7_92 = mesh_7.vertices.elementAt(92);
      expect(vertex_7_92, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, -106.043)));
      final vertex_7_93 = mesh_7.vertices.elementAt(93);
      expect(vertex_7_93, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_94 = mesh_7.vertices.elementAt(94);
      expect(vertex_7_94, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, -106.316)));
      final vertex_7_95 = mesh_7.vertices.elementAt(95);
      expect(vertex_7_95, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_96 = mesh_7.vertices.elementAt(96);
      expect(vertex_7_96, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -18.2669)));
      final vertex_7_97 = mesh_7.vertices.elementAt(97);
      expect(vertex_7_97, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, -21.034)));
      final vertex_7_98 = mesh_7.vertices.elementAt(98);
      expect(vertex_7_98, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, -105.99)));
      final vertex_7_99 = mesh_7.vertices.elementAt(99);
      expect(vertex_7_99, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_100 = mesh_7.vertices.elementAt(100);
      expect(vertex_7_100, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, -106.043)));
      final vertex_7_101 = mesh_7.vertices.elementAt(101);
      expect(vertex_7_101, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_102 = mesh_7.vertices.elementAt(102);
      expect(vertex_7_102, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -15.1865)));
      final vertex_7_103 = mesh_7.vertices.elementAt(103);
      expect(vertex_7_103, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -18.2669)));
      final vertex_7_104 = mesh_7.vertices.elementAt(104);
      expect(vertex_7_104, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, -106.198)));
      final vertex_7_105 = mesh_7.vertices.elementAt(105);
      expect(vertex_7_105, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_106 = mesh_7.vertices.elementAt(106);
      expect(vertex_7_106, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, -105.99)));
      expect(mesh_7.normals.length, isZero);
      expect(mesh_7.tangents.length, isZero);
      expect(mesh_7.bitangents.length, isZero);
      expect(mesh_7.colors.length, isZero);
      expect(mesh_7.textureCoords.length, isZero);
      expect(mesh_7.uvComponents.length, isZero);
      expect(mesh_7.uvComponents, equals([]));
      expect(mesh_7.faces.length, equals(98));
      expect(mesh_7.bones.length, isZero);
      expect(mesh_7.materialIndex, equals(2));
      expect(mesh_7.name, equals('Bein3Li'));
      expect(mesh_7.animMeshes.length, isZero);
      expect(mesh_7.morphingMethod, isZero);
      expect(mesh_7.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_8 = meshes.elementAt(8);
      expect(mesh_8.primitiveTypes, equals(4));
      expect(mesh_8.vertices.length, equals(113));
      final vertex_8_0 = mesh_8.vertices.elementAt(0);
      expect(vertex_8_0, vector3MoreOrLessEquals(Vector3(-11.2052, -7.28023, -5.84188)));
      final vertex_8_1 = mesh_8.vertices.elementAt(1);
      expect(vertex_8_1, vector3MoreOrLessEquals(Vector3(-14.1027, -6.07578, -7.12446)));
      final vertex_8_2 = mesh_8.vertices.elementAt(2);
      expect(vertex_8_2, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_3 = mesh_8.vertices.elementAt(3);
      expect(vertex_8_3, vector3MoreOrLessEquals(Vector3(19.8971, -38.1552, 68.0391)));
      final vertex_8_4 = mesh_8.vertices.elementAt(4);
      expect(vertex_8_4, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_5 = mesh_8.vertices.elementAt(5);
      expect(vertex_8_5, vector3MoreOrLessEquals(Vector3(19.7499, -37.6075, 68.3299)));
      final vertex_8_6 = mesh_8.vertices.elementAt(6);
      expect(vertex_8_6, vector3MoreOrLessEquals(Vector3(-11.2052, -7.28023, -5.84188)));
      final vertex_8_7 = mesh_8.vertices.elementAt(7);
      expect(vertex_8_7, vector3MoreOrLessEquals(Vector3(-2.87765, 5.5176, 11.0769)));
      final vertex_8_8 = mesh_8.vertices.elementAt(8);
      expect(vertex_8_8, vector3MoreOrLessEquals(Vector3(-4.90751, 6.09364, 10.1268)));
      final vertex_8_9 = mesh_8.vertices.elementAt(9);
      expect(vertex_8_9, vector3MoreOrLessEquals(Vector3(-14.1027, -6.07578, -7.12446)));
      final vertex_8_10 = mesh_8.vertices.elementAt(10);
      expect(vertex_8_10, vector3MoreOrLessEquals(Vector3(1.74567, 26.1369, 21.0078)));
      final vertex_8_11 = mesh_8.vertices.elementAt(11);
      expect(vertex_8_11, vector3MoreOrLessEquals(Vector3(0.474552, 27.2094, 20.9797)));
      final vertex_8_12 = mesh_8.vertices.elementAt(12);
      expect(vertex_8_12, vector3MoreOrLessEquals(Vector3(-17.116, -5.53336, -5.52842)));
      final vertex_8_13 = mesh_8.vertices.elementAt(13);
      expect(vertex_8_13, vector3MoreOrLessEquals(Vector3(-7.03667, 5.46706, 10.7817)));
      final vertex_8_14 = mesh_8.vertices.elementAt(14);
      expect(vertex_8_14, vector3MoreOrLessEquals(Vector3(-0.824137, 27.0092, 21.5109)));
      final vertex_8_15 = mesh_8.vertices.elementAt(15);
      expect(vertex_8_15, vector3MoreOrLessEquals(Vector3(1.74567, 26.1369, 21.0078)));
      final vertex_8_16 = mesh_8.vertices.elementAt(16);
      expect(vertex_8_16, vector3MoreOrLessEquals(Vector3(3.23343, 28.024, 25.2494)));
      final vertex_8_17 = mesh_8.vertices.elementAt(17);
      expect(vertex_8_17, vector3MoreOrLessEquals(Vector3(3.23343, 28.024, 25.2494)));
      final vertex_8_18 = mesh_8.vertices.elementAt(18);
      expect(vertex_8_18, vector3MoreOrLessEquals(Vector3(1.34655, 27.5951, 26.5185)));
      final vertex_8_19 = mesh_8.vertices.elementAt(19);
      expect(vertex_8_19, vector3MoreOrLessEquals(Vector3(-7.66182, 4.10971, 12.5486)));
      final vertex_8_20 = mesh_8.vertices.elementAt(20);
      expect(vertex_8_20, vector3MoreOrLessEquals(Vector3(-1.17244, 25.687, 22.2014)));
      final vertex_8_21 = mesh_8.vertices.elementAt(21);
      expect(vertex_8_21, vector3MoreOrLessEquals(Vector3(0.042627, 25.6839, 26.5647)));
      final vertex_8_22 = mesh_8.vertices.elementAt(22);
      expect(vertex_8_22, vector3MoreOrLessEquals(Vector3(-17.976, -6.06143, -2.25557)));
      final vertex_8_23 = mesh_8.vertices.elementAt(23);
      expect(vertex_8_23, vector3MoreOrLessEquals(Vector3(-16.0352, -7.26234, 0.229479)));
      final vertex_8_24 = mesh_8.vertices.elementAt(24);
      expect(vertex_8_24, vector3MoreOrLessEquals(Vector3(-6.31225, 3.04369, 14.0968)));
      final vertex_8_25 = mesh_8.vertices.elementAt(25);
      expect(vertex_8_25, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_26 = mesh_8.vertices.elementAt(26);
      expect(vertex_8_26, vector3MoreOrLessEquals(Vector3(-4.00416, 3.07172, 14.2606)));
      final vertex_8_27 = mesh_8.vertices.elementAt(27);
      expect(vertex_8_27, vector3MoreOrLessEquals(Vector3(-12.755, -8.2318, 0.055506)));
      final vertex_8_28 = mesh_8.vertices.elementAt(28);
      expect(vertex_8_28, vector3MoreOrLessEquals(Vector3(-1.17244, 25.687, 22.2014)));
      final vertex_8_29 = mesh_8.vertices.elementAt(29);
      expect(vertex_8_29, vector3MoreOrLessEquals(Vector3(1.11807, 23.7546, 22.252)));
      final vertex_8_30 = mesh_8.vertices.elementAt(30);
      expect(vertex_8_30, vector3MoreOrLessEquals(Vector3(-10.6055, -8.23976, -2.6465)));
      final vertex_8_31 = mesh_8.vertices.elementAt(31);
      expect(vertex_8_31, vector3MoreOrLessEquals(Vector3(-2.47562, 4.17273, 12.9166)));
      final vertex_8_32 = mesh_8.vertices.elementAt(32);
      expect(vertex_8_32, vector3MoreOrLessEquals(Vector3(2.03204, 24.5994, 21.574)));
      final vertex_8_33 = mesh_8.vertices.elementAt(33);
      expect(vertex_8_33, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_34 = mesh_8.vertices.elementAt(34);
      expect(vertex_8_34, vector3MoreOrLessEquals(Vector3(1.93285, 23.2039, 23.7963)));
      final vertex_8_35 = mesh_8.vertices.elementAt(35);
      expect(vertex_8_35, vector3MoreOrLessEquals(Vector3(2.03204, 24.5994, 21.574)));
      final vertex_8_36 = mesh_8.vertices.elementAt(36);
      expect(vertex_8_36, vector3MoreOrLessEquals(Vector3(3.70363, 24.5026, 23.0664)));
      final vertex_8_37 = mesh_8.vertices.elementAt(37);
      expect(vertex_8_37, vector3MoreOrLessEquals(Vector3(4.28245, 26.6477, 23.7131)));
      final vertex_8_38 = mesh_8.vertices.elementAt(38);
      expect(vertex_8_38, vector3MoreOrLessEquals(Vector3(4.28245, 26.6477, 23.7131)));
      final vertex_8_39 = mesh_8.vertices.elementAt(39);
      expect(vertex_8_39, vector3MoreOrLessEquals(Vector3(1.74567, 26.1369, 21.0078)));
      final vertex_8_40 = mesh_8.vertices.elementAt(40);
      expect(vertex_8_40, vector3MoreOrLessEquals(Vector3(13.5324, 4.29248, 46.2889)));
      final vertex_8_41 = mesh_8.vertices.elementAt(41);
      expect(vertex_8_41, vector3MoreOrLessEquals(Vector3(14.8602, 5.64247, 47.619)));
      final vertex_8_42 = mesh_8.vertices.elementAt(42);
      expect(vertex_8_42, vector3MoreOrLessEquals(Vector3(11.5766, 3.19019, 46.8499)));
      final vertex_8_43 = mesh_8.vertices.elementAt(43);
      expect(vertex_8_43, vector3MoreOrLessEquals(Vector3(17.5072, -31.6087, 60.4299)));
      final vertex_8_44 = mesh_8.vertices.elementAt(44);
      expect(vertex_8_44, vector3MoreOrLessEquals(Vector3(17.5072, -31.6087, 60.4299)));
      final vertex_8_45 = mesh_8.vertices.elementAt(45);
      expect(vertex_8_45, vector3MoreOrLessEquals(Vector3(18.5469, -31.2314, 60.445)));
      final vertex_8_46 = mesh_8.vertices.elementAt(46);
      expect(vertex_8_46, vector3MoreOrLessEquals(Vector3(19.2007, -29.6602, 61.2654)));
      final vertex_8_47 = mesh_8.vertices.elementAt(47);
      expect(vertex_8_47, vector3MoreOrLessEquals(Vector3(10.4657, 3.16569, 48.8797)));
      final vertex_8_48 = mesh_8.vertices.elementAt(48);
      expect(vertex_8_48, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_49 = mesh_8.vertices.elementAt(49);
      expect(vertex_8_49, vector3MoreOrLessEquals(Vector3(0.303562, 23.7297, 25.3531)));
      final vertex_8_50 = mesh_8.vertices.elementAt(50);
      expect(vertex_8_50, vector3MoreOrLessEquals(Vector3(-0.824137, 27.0092, 21.5109)));
      final vertex_8_51 = mesh_8.vertices.elementAt(51);
      expect(vertex_8_51, vector3MoreOrLessEquals(Vector3(12.8583, 5.59827, 51.2765)));
      final vertex_8_52 = mesh_8.vertices.elementAt(52);
      expect(vertex_8_52, vector3MoreOrLessEquals(Vector3(11.0361, 4.23739, 50.8497)));
      final vertex_8_53 = mesh_8.vertices.elementAt(53);
      expect(vertex_8_53, vector3MoreOrLessEquals(Vector3(14.5603, 6.22359, 49.8387)));
      final vertex_8_54 = mesh_8.vertices.elementAt(54);
      expect(vertex_8_54, vector3MoreOrLessEquals(Vector3(18.9761, -28.0781, 62.2734)));
      final vertex_8_55 = mesh_8.vertices.elementAt(55);
      expect(vertex_8_55, vector3MoreOrLessEquals(Vector3(18.0423, -27.6766, 62.7098)));
      final vertex_8_56 = mesh_8.vertices.elementAt(56);
      expect(vertex_8_56, vector3MoreOrLessEquals(Vector3(17.1025, -28.758, 62.2462)));
      final vertex_8_57 = mesh_8.vertices.elementAt(57);
      expect(vertex_8_57, vector3MoreOrLessEquals(Vector3(0.042627, 25.6839, 26.5647)));
      final vertex_8_58 = mesh_8.vertices.elementAt(58);
      expect(vertex_8_58, vector3MoreOrLessEquals(Vector3(16.8644, -30.508, 61.2315)));
      final vertex_8_59 = mesh_8.vertices.elementAt(59);
      expect(vertex_8_59, vector3MoreOrLessEquals(Vector3(18.821, -38.4449, 68.1251)));
      final vertex_8_60 = mesh_8.vertices.elementAt(60);
      expect(vertex_8_60, vector3MoreOrLessEquals(Vector3(19.3002, -37.4672, 68.49)));
      final vertex_8_61 = mesh_8.vertices.elementAt(61);
      expect(vertex_8_61, vector3MoreOrLessEquals(Vector3(18.8869, -37.8399, 68.3988)));
      final vertex_8_62 = mesh_8.vertices.elementAt(62);
      expect(vertex_8_62, vector3MoreOrLessEquals(Vector3(19.1522, -38.8267, 67.8748)));
      final vertex_8_63 = mesh_8.vertices.elementAt(63);
      expect(vertex_8_63, vector3MoreOrLessEquals(Vector3(19.6311, -38.6978, 67.8366)));
      final vertex_8_64 = mesh_8.vertices.elementAt(64);
      expect(vertex_8_64, vector3MoreOrLessEquals(Vector3(19.8971, -38.1552, 68.0391)));
      final vertex_8_65 = mesh_8.vertices.elementAt(65);
      expect(vertex_8_65, vector3MoreOrLessEquals(Vector3(18.9761, -28.0781, 62.2734)));
      final vertex_8_66 = mesh_8.vertices.elementAt(66);
      expect(vertex_8_66, vector3MoreOrLessEquals(Vector3(19.7499, -37.6075, 68.3299)));
      final vertex_8_67 = mesh_8.vertices.elementAt(67);
      expect(vertex_8_67, vector3MoreOrLessEquals(Vector3(18.0423, -27.6766, 62.7098)));
      final vertex_8_68 = mesh_8.vertices.elementAt(68);
      expect(vertex_8_68, vector3MoreOrLessEquals(Vector3(14.8602, 5.64247, 47.619)));
      final vertex_8_69 = mesh_8.vertices.elementAt(69);
      expect(vertex_8_69, vector3MoreOrLessEquals(Vector3(19.2007, -29.6602, 61.2654)));
      final vertex_8_70 = mesh_8.vertices.elementAt(70);
      expect(vertex_8_70, vector3MoreOrLessEquals(Vector3(19.8971, -38.1552, 68.0391)));
      final vertex_8_71 = mesh_8.vertices.elementAt(71);
      expect(vertex_8_71, vector3MoreOrLessEquals(Vector3(12.8583, 5.59827, 51.2765)));
      final vertex_8_72 = mesh_8.vertices.elementAt(72);
      expect(vertex_8_72, vector3MoreOrLessEquals(Vector3(4.28245, 26.6477, 23.7131)));
      final vertex_8_73 = mesh_8.vertices.elementAt(73);
      expect(vertex_8_73, vector3MoreOrLessEquals(Vector3(-2.87765, 5.5176, 11.0769)));
      final vertex_8_74 = mesh_8.vertices.elementAt(74);
      expect(vertex_8_74, vector3MoreOrLessEquals(Vector3(-11.2052, -7.28023, -5.84188)));
      final vertex_8_75 = mesh_8.vertices.elementAt(75);
      expect(vertex_8_75, vector3MoreOrLessEquals(Vector3(1.74567, 26.1369, 21.0078)));
      final vertex_8_76 = mesh_8.vertices.elementAt(76);
      expect(vertex_8_76, vector3MoreOrLessEquals(Vector3(-2.87765, 5.5176, 11.0769)));
      final vertex_8_77 = mesh_8.vertices.elementAt(77);
      expect(vertex_8_77, vector3MoreOrLessEquals(Vector3(-14.1027, -6.07578, -7.12446)));
      final vertex_8_78 = mesh_8.vertices.elementAt(78);
      expect(vertex_8_78, vector3MoreOrLessEquals(Vector3(-17.116, -5.53336, -5.52842)));
      final vertex_8_79 = mesh_8.vertices.elementAt(79);
      expect(vertex_8_79, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_80 = mesh_8.vertices.elementAt(80);
      expect(vertex_8_80, vector3MoreOrLessEquals(Vector3(19.7499, -37.6075, 68.3299)));
      final vertex_8_81 = mesh_8.vertices.elementAt(81);
      expect(vertex_8_81, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_82 = mesh_8.vertices.elementAt(82);
      expect(vertex_8_82, vector3MoreOrLessEquals(Vector3(19.3002, -37.4672, 68.49)));
      final vertex_8_83 = mesh_8.vertices.elementAt(83);
      expect(vertex_8_83, vector3MoreOrLessEquals(Vector3(-17.116, -5.53336, -5.52842)));
      final vertex_8_84 = mesh_8.vertices.elementAt(84);
      expect(vertex_8_84, vector3MoreOrLessEquals(Vector3(-17.976, -6.06143, -2.25557)));
      final vertex_8_85 = mesh_8.vertices.elementAt(85);
      expect(vertex_8_85, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_86 = mesh_8.vertices.elementAt(86);
      expect(vertex_8_86, vector3MoreOrLessEquals(Vector3(19.3002, -37.4672, 68.49)));
      final vertex_8_87 = mesh_8.vertices.elementAt(87);
      expect(vertex_8_87, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_88 = mesh_8.vertices.elementAt(88);
      expect(vertex_8_88, vector3MoreOrLessEquals(Vector3(18.8869, -37.8399, 68.3988)));
      final vertex_8_89 = mesh_8.vertices.elementAt(89);
      expect(vertex_8_89, vector3MoreOrLessEquals(Vector3(-17.976, -6.06143, -2.25557)));
      final vertex_8_90 = mesh_8.vertices.elementAt(90);
      expect(vertex_8_90, vector3MoreOrLessEquals(Vector3(-16.0352, -7.26234, 0.229479)));
      final vertex_8_91 = mesh_8.vertices.elementAt(91);
      expect(vertex_8_91, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_92 = mesh_8.vertices.elementAt(92);
      expect(vertex_8_92, vector3MoreOrLessEquals(Vector3(18.8869, -37.8399, 68.3988)));
      final vertex_8_93 = mesh_8.vertices.elementAt(93);
      expect(vertex_8_93, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_94 = mesh_8.vertices.elementAt(94);
      expect(vertex_8_94, vector3MoreOrLessEquals(Vector3(18.821, -38.4449, 68.1251)));
      final vertex_8_95 = mesh_8.vertices.elementAt(95);
      expect(vertex_8_95, vector3MoreOrLessEquals(Vector3(-16.0352, -7.26234, 0.229479)));
      final vertex_8_96 = mesh_8.vertices.elementAt(96);
      expect(vertex_8_96, vector3MoreOrLessEquals(Vector3(-12.755, -8.2318, 0.055506)));
      final vertex_8_97 = mesh_8.vertices.elementAt(97);
      expect(vertex_8_97, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_98 = mesh_8.vertices.elementAt(98);
      expect(vertex_8_98, vector3MoreOrLessEquals(Vector3(18.821, -38.4449, 68.1251)));
      final vertex_8_99 = mesh_8.vertices.elementAt(99);
      expect(vertex_8_99, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_100 = mesh_8.vertices.elementAt(100);
      expect(vertex_8_100, vector3MoreOrLessEquals(Vector3(19.1522, -38.8267, 67.8748)));
      final vertex_8_101 = mesh_8.vertices.elementAt(101);
      expect(vertex_8_101, vector3MoreOrLessEquals(Vector3(-12.755, -8.2318, 0.055506)));
      final vertex_8_102 = mesh_8.vertices.elementAt(102);
      expect(vertex_8_102, vector3MoreOrLessEquals(Vector3(-10.6055, -8.23976, -2.6465)));
      final vertex_8_103 = mesh_8.vertices.elementAt(103);
      expect(vertex_8_103, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_104 = mesh_8.vertices.elementAt(104);
      expect(vertex_8_104, vector3MoreOrLessEquals(Vector3(19.1522, -38.8267, 67.8748)));
      final vertex_8_105 = mesh_8.vertices.elementAt(105);
      expect(vertex_8_105, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_106 = mesh_8.vertices.elementAt(106);
      expect(vertex_8_106, vector3MoreOrLessEquals(Vector3(19.6311, -38.6978, 67.8366)));
      final vertex_8_107 = mesh_8.vertices.elementAt(107);
      expect(vertex_8_107, vector3MoreOrLessEquals(Vector3(-10.6055, -8.23976, -2.6465)));
      final vertex_8_108 = mesh_8.vertices.elementAt(108);
      expect(vertex_8_108, vector3MoreOrLessEquals(Vector3(-11.2052, -7.28023, -5.84188)));
      final vertex_8_109 = mesh_8.vertices.elementAt(109);
      expect(vertex_8_109, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_110 = mesh_8.vertices.elementAt(110);
      expect(vertex_8_110, vector3MoreOrLessEquals(Vector3(19.6311, -38.6978, 67.8366)));
      final vertex_8_111 = mesh_8.vertices.elementAt(111);
      expect(vertex_8_111, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_112 = mesh_8.vertices.elementAt(112);
      expect(vertex_8_112, vector3MoreOrLessEquals(Vector3(19.8971, -38.1552, 68.0391)));
      expect(mesh_8.normals.length, isZero);
      expect(mesh_8.tangents.length, isZero);
      expect(mesh_8.bitangents.length, isZero);
      expect(mesh_8.colors.length, isZero);
      expect(mesh_8.textureCoords.length, isZero);
      expect(mesh_8.uvComponents.length, isZero);
      expect(mesh_8.uvComponents, equals([]));
      expect(mesh_8.faces.length, equals(98));
      expect(mesh_8.bones.length, isZero);
      expect(mesh_8.materialIndex, equals(2));
      expect(mesh_8.name, equals('Bein4Re'));
      expect(mesh_8.animMeshes.length, isZero);
      expect(mesh_8.morphingMethod, isZero);
      expect(mesh_8.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_9 = meshes.elementAt(9);
      expect(mesh_9.primitiveTypes, equals(4));
      expect(mesh_9.vertices.length, equals(113));
      final vertex_9_0 = mesh_9.vertices.elementAt(0);
      expect(vertex_9_0, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_1 = mesh_9.vertices.elementAt(1);
      expect(vertex_9_1, vector3MoreOrLessEquals(Vector3(-15.436, -6.07578, -12.2089)));
      final vertex_9_2 = mesh_9.vertices.elementAt(2);
      expect(vertex_9_2, vector3MoreOrLessEquals(Vector3(-12.5385, -7.28023, -13.4915)));
      final vertex_9_3 = mesh_9.vertices.elementAt(3);
      expect(vertex_9_3, vector3MoreOrLessEquals(Vector3(18.4165, -37.6075, -87.6633)));
      final vertex_9_4 = mesh_9.vertices.elementAt(4);
      expect(vertex_9_4, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_5 = mesh_9.vertices.elementAt(5);
      expect(vertex_9_5, vector3MoreOrLessEquals(Vector3(18.5638, -38.1552, -87.3725)));
      final vertex_9_6 = mesh_9.vertices.elementAt(6);
      expect(vertex_9_6, vector3MoreOrLessEquals(Vector3(-6.24084, 6.09364, -29.4602)));
      final vertex_9_7 = mesh_9.vertices.elementAt(7);
      expect(vertex_9_7, vector3MoreOrLessEquals(Vector3(-4.21098, 5.5176, -30.4103)));
      final vertex_9_8 = mesh_9.vertices.elementAt(8);
      expect(vertex_9_8, vector3MoreOrLessEquals(Vector3(-12.5385, -7.28023, -13.4915)));
      final vertex_9_9 = mesh_9.vertices.elementAt(9);
      expect(vertex_9_9, vector3MoreOrLessEquals(Vector3(-15.436, -6.07578, -12.2089)));
      final vertex_9_10 = mesh_9.vertices.elementAt(10);
      expect(vertex_9_10, vector3MoreOrLessEquals(Vector3(0.412342, 26.1369, -40.3411)));
      final vertex_9_11 = mesh_9.vertices.elementAt(11);
      expect(vertex_9_11, vector3MoreOrLessEquals(Vector3(-0.85878, 27.2094, -40.313)));
      final vertex_9_12 = mesh_9.vertices.elementAt(12);
      expect(vertex_9_12, vector3MoreOrLessEquals(Vector3(1.9001, 28.024, -44.5828)));
      final vertex_9_13 = mesh_9.vertices.elementAt(13);
      expect(vertex_9_13, vector3MoreOrLessEquals(Vector3(0.412342, 26.1369, -40.3411)));
      final vertex_9_14 = mesh_9.vertices.elementAt(14);
      expect(vertex_9_14, vector3MoreOrLessEquals(Vector3(-2.15747, 27.0092, -40.8442)));
      final vertex_9_15 = mesh_9.vertices.elementAt(15);
      expect(vertex_9_15, vector3MoreOrLessEquals(Vector3(1.9001, 28.024, -44.5828)));
      final vertex_9_16 = mesh_9.vertices.elementAt(16);
      expect(vertex_9_16, vector3MoreOrLessEquals(Vector3(2.94912, 26.6477, -43.0465)));
      final vertex_9_17 = mesh_9.vertices.elementAt(17);
      expect(vertex_9_17, vector3MoreOrLessEquals(Vector3(13.5269, 5.64247, -66.9523)));
      final vertex_9_18 = mesh_9.vertices.elementAt(18);
      expect(vertex_9_18, vector3MoreOrLessEquals(Vector3(13.2269, 6.22359, -69.172)));
      final vertex_9_19 = mesh_9.vertices.elementAt(19);
      expect(vertex_9_19, vector3MoreOrLessEquals(Vector3(0.013222, 27.5951, -45.8518)));
      final vertex_9_20 = mesh_9.vertices.elementAt(20);
      expect(vertex_9_20, vector3MoreOrLessEquals(Vector3(11.525, 5.59827, -70.6098)));
      final vertex_9_21 = mesh_9.vertices.elementAt(21);
      expect(vertex_9_21, vector3MoreOrLessEquals(Vector3(17.6427, -28.0781, -81.6067)));
      final vertex_9_22 = mesh_9.vertices.elementAt(22);
      expect(vertex_9_22, vector3MoreOrLessEquals(Vector3(17.8673, -29.6602, -80.5987)));
      final vertex_9_23 = mesh_9.vertices.elementAt(23);
      expect(vertex_9_23, vector3MoreOrLessEquals(Vector3(17.6427, -28.0781, -81.6067)));
      final vertex_9_24 = mesh_9.vertices.elementAt(24);
      expect(vertex_9_24, vector3MoreOrLessEquals(Vector3(-1.2907, 25.6839, -45.898)));
      final vertex_9_25 = mesh_9.vertices.elementAt(25);
      expect(vertex_9_25, vector3MoreOrLessEquals(Vector3(9.70273, 4.23739, -70.183)));
      final vertex_9_26 = mesh_9.vertices.elementAt(26);
      expect(vertex_9_26, vector3MoreOrLessEquals(Vector3(15.7692, -28.758, -81.5795)));
      final vertex_9_27 = mesh_9.vertices.elementAt(27);
      expect(vertex_9_27, vector3MoreOrLessEquals(Vector3(16.7089, -27.6766, -82.0432)));
      final vertex_9_28 = mesh_9.vertices.elementAt(28);
      expect(vertex_9_28, vector3MoreOrLessEquals(Vector3(-8.37001, 5.46706, -30.1151)));
      final vertex_9_29 = mesh_9.vertices.elementAt(29);
      expect(vertex_9_29, vector3MoreOrLessEquals(Vector3(-8.99515, 4.10971, -31.8819)));
      final vertex_9_30 = mesh_9.vertices.elementAt(30);
      expect(vertex_9_30, vector3MoreOrLessEquals(Vector3(-2.50577, 25.687, -41.5347)));
      final vertex_9_31 = mesh_9.vertices.elementAt(31);
      expect(vertex_9_31, vector3MoreOrLessEquals(Vector3(-18.4493, -5.53336, -13.8049)));
      final vertex_9_32 = mesh_9.vertices.elementAt(32);
      expect(vertex_9_32, vector3MoreOrLessEquals(Vector3(-19.3093, -6.06143, -17.0778)));
      final vertex_9_33 = mesh_9.vertices.elementAt(33);
      expect(vertex_9_33, vector3MoreOrLessEquals(Vector3(-17.3685, -7.26234, -19.5628)));
      final vertex_9_34 = mesh_9.vertices.elementAt(34);
      expect(vertex_9_34, vector3MoreOrLessEquals(Vector3(-7.64558, 3.04369, -33.4301)));
      final vertex_9_35 = mesh_9.vertices.elementAt(35);
      expect(vertex_9_35, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_36 = mesh_9.vertices.elementAt(36);
      expect(vertex_9_36, vector3MoreOrLessEquals(Vector3(-5.33749, 3.07172, -33.5939)));
      final vertex_9_37 = mesh_9.vertices.elementAt(37);
      expect(vertex_9_37, vector3MoreOrLessEquals(Vector3(-14.0883, -8.2318, -19.3888)));
      final vertex_9_38 = mesh_9.vertices.elementAt(38);
      expect(vertex_9_38, vector3MoreOrLessEquals(Vector3(-2.50577, 25.687, -41.5347)));
      final vertex_9_39 = mesh_9.vertices.elementAt(39);
      expect(vertex_9_39, vector3MoreOrLessEquals(Vector3(-0.215265, 23.7546, -41.5854)));
      final vertex_9_40 = mesh_9.vertices.elementAt(40);
      expect(vertex_9_40, vector3MoreOrLessEquals(Vector3(-2.15747, 27.0092, -40.8442)));
      final vertex_9_41 = mesh_9.vertices.elementAt(41);
      expect(vertex_9_41, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_42 = mesh_9.vertices.elementAt(42);
      expect(vertex_9_42, vector3MoreOrLessEquals(Vector3(-1.02977, 23.7297, -44.6865)));
      final vertex_9_43 = mesh_9.vertices.elementAt(43);
      expect(vertex_9_43, vector3MoreOrLessEquals(Vector3(9.13232, 3.16569, -68.2131)));
      final vertex_9_44 = mesh_9.vertices.elementAt(44);
      expect(vertex_9_44, vector3MoreOrLessEquals(Vector3(0.599522, 23.2039, -43.1296)));
      final vertex_9_45 = mesh_9.vertices.elementAt(45);
      expect(vertex_9_45, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_46 = mesh_9.vertices.elementAt(46);
      expect(vertex_9_46, vector3MoreOrLessEquals(Vector3(10.2433, 3.19019, -66.1832)));
      final vertex_9_47 = mesh_9.vertices.elementAt(47);
      expect(vertex_9_47, vector3MoreOrLessEquals(Vector3(0.698708, 24.5994, -40.9074)));
      final vertex_9_48 = mesh_9.vertices.elementAt(48);
      expect(vertex_9_48, vector3MoreOrLessEquals(Vector3(2.3703, 24.5026, -42.3997)));
      final vertex_9_49 = mesh_9.vertices.elementAt(49);
      expect(vertex_9_49, vector3MoreOrLessEquals(Vector3(12.199, 4.29248, -65.6222)));
      final vertex_9_50 = mesh_9.vertices.elementAt(50);
      expect(vertex_9_50, vector3MoreOrLessEquals(Vector3(16.1739, -31.6087, -79.7632)));
      final vertex_9_51 = mesh_9.vertices.elementAt(51);
      expect(vertex_9_51, vector3MoreOrLessEquals(Vector3(17.2136, -31.2314, -79.7783)));
      final vertex_9_52 = mesh_9.vertices.elementAt(52);
      expect(vertex_9_52, vector3MoreOrLessEquals(Vector3(16.1739, -31.6087, -79.7632)));
      final vertex_9_53 = mesh_9.vertices.elementAt(53);
      expect(vertex_9_53, vector3MoreOrLessEquals(Vector3(2.94912, 26.6477, -43.0465)));
      final vertex_9_54 = mesh_9.vertices.elementAt(54);
      expect(vertex_9_54, vector3MoreOrLessEquals(Vector3(13.5269, 5.64247, -66.9523)));
      final vertex_9_55 = mesh_9.vertices.elementAt(55);
      expect(vertex_9_55, vector3MoreOrLessEquals(Vector3(17.8673, -29.6602, -80.5987)));
      final vertex_9_56 = mesh_9.vertices.elementAt(56);
      expect(vertex_9_56, vector3MoreOrLessEquals(Vector3(0.412342, 26.1369, -40.3411)));
      final vertex_9_57 = mesh_9.vertices.elementAt(57);
      expect(vertex_9_57, vector3MoreOrLessEquals(Vector3(2.94912, 26.6477, -43.0465)));
      final vertex_9_58 = mesh_9.vertices.elementAt(58);
      expect(vertex_9_58, vector3MoreOrLessEquals(Vector3(18.2978, -38.6978, -87.17)));
      final vertex_9_59 = mesh_9.vertices.elementAt(59);
      expect(vertex_9_59, vector3MoreOrLessEquals(Vector3(18.5638, -38.1552, -87.3725)));
      final vertex_9_60 = mesh_9.vertices.elementAt(60);
      expect(vertex_9_60, vector3MoreOrLessEquals(Vector3(17.8189, -38.8267, -87.2082)));
      final vertex_9_61 = mesh_9.vertices.elementAt(61);
      expect(vertex_9_61, vector3MoreOrLessEquals(Vector3(17.4877, -38.4449, -87.4584)));
      final vertex_9_62 = mesh_9.vertices.elementAt(62);
      expect(vertex_9_62, vector3MoreOrLessEquals(Vector3(17.5535, -37.8399, -87.7321)));
      final vertex_9_63 = mesh_9.vertices.elementAt(63);
      expect(vertex_9_63, vector3MoreOrLessEquals(Vector3(15.5311, -30.508, -80.5649)));
      final vertex_9_64 = mesh_9.vertices.elementAt(64);
      expect(vertex_9_64, vector3MoreOrLessEquals(Vector3(17.9669, -37.4672, -87.8233)));
      final vertex_9_65 = mesh_9.vertices.elementAt(65);
      expect(vertex_9_65, vector3MoreOrLessEquals(Vector3(-1.2907, 25.6839, -45.898)));
      final vertex_9_66 = mesh_9.vertices.elementAt(66);
      expect(vertex_9_66, vector3MoreOrLessEquals(Vector3(18.4165, -37.6075, -87.6633)));
      final vertex_9_67 = mesh_9.vertices.elementAt(67);
      expect(vertex_9_67, vector3MoreOrLessEquals(Vector3(16.7089, -27.6766, -82.0432)));
      final vertex_9_68 = mesh_9.vertices.elementAt(68);
      expect(vertex_9_68, vector3MoreOrLessEquals(Vector3(18.5638, -38.1552, -87.3725)));
      final vertex_9_69 = mesh_9.vertices.elementAt(69);
      expect(vertex_9_69, vector3MoreOrLessEquals(Vector3(11.525, 5.59827, -70.6098)));
      final vertex_9_70 = mesh_9.vertices.elementAt(70);
      expect(vertex_9_70, vector3MoreOrLessEquals(Vector3(0.698708, 24.5994, -40.9074)));
      final vertex_9_71 = mesh_9.vertices.elementAt(71);
      expect(vertex_9_71, vector3MoreOrLessEquals(Vector3(-3.80895, 4.17273, -32.25)));
      final vertex_9_72 = mesh_9.vertices.elementAt(72);
      expect(vertex_9_72, vector3MoreOrLessEquals(Vector3(-4.21098, 5.5176, -30.4103)));
      final vertex_9_73 = mesh_9.vertices.elementAt(73);
      expect(vertex_9_73, vector3MoreOrLessEquals(Vector3(-4.21098, 5.5176, -30.4103)));
      final vertex_9_74 = mesh_9.vertices.elementAt(74);
      expect(vertex_9_74, vector3MoreOrLessEquals(Vector3(0.412342, 26.1369, -40.3411)));
      final vertex_9_75 = mesh_9.vertices.elementAt(75);
      expect(vertex_9_75, vector3MoreOrLessEquals(Vector3(-11.9388, -8.23976, -16.6868)));
      final vertex_9_76 = mesh_9.vertices.elementAt(76);
      expect(vertex_9_76, vector3MoreOrLessEquals(Vector3(-12.5385, -7.28023, -13.4915)));
      final vertex_9_77 = mesh_9.vertices.elementAt(77);
      expect(vertex_9_77, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_78 = mesh_9.vertices.elementAt(78);
      expect(vertex_9_78, vector3MoreOrLessEquals(Vector3(-18.4493, -5.53336, -13.8049)));
      final vertex_9_79 = mesh_9.vertices.elementAt(79);
      expect(vertex_9_79, vector3MoreOrLessEquals(Vector3(-15.436, -6.07578, -12.2089)));
      final vertex_9_80 = mesh_9.vertices.elementAt(80);
      expect(vertex_9_80, vector3MoreOrLessEquals(Vector3(17.9669, -37.4672, -87.8233)));
      final vertex_9_81 = mesh_9.vertices.elementAt(81);
      expect(vertex_9_81, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_82 = mesh_9.vertices.elementAt(82);
      expect(vertex_9_82, vector3MoreOrLessEquals(Vector3(18.4165, -37.6075, -87.6633)));
      final vertex_9_83 = mesh_9.vertices.elementAt(83);
      expect(vertex_9_83, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_84 = mesh_9.vertices.elementAt(84);
      expect(vertex_9_84, vector3MoreOrLessEquals(Vector3(-19.3093, -6.06143, -17.0778)));
      final vertex_9_85 = mesh_9.vertices.elementAt(85);
      expect(vertex_9_85, vector3MoreOrLessEquals(Vector3(-18.4493, -5.53336, -13.8049)));
      final vertex_9_86 = mesh_9.vertices.elementAt(86);
      expect(vertex_9_86, vector3MoreOrLessEquals(Vector3(17.5535, -37.8399, -87.7321)));
      final vertex_9_87 = mesh_9.vertices.elementAt(87);
      expect(vertex_9_87, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_88 = mesh_9.vertices.elementAt(88);
      expect(vertex_9_88, vector3MoreOrLessEquals(Vector3(17.9669, -37.4672, -87.8233)));
      final vertex_9_89 = mesh_9.vertices.elementAt(89);
      expect(vertex_9_89, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_90 = mesh_9.vertices.elementAt(90);
      expect(vertex_9_90, vector3MoreOrLessEquals(Vector3(-17.3685, -7.26234, -19.5628)));
      final vertex_9_91 = mesh_9.vertices.elementAt(91);
      expect(vertex_9_91, vector3MoreOrLessEquals(Vector3(-19.3093, -6.06143, -17.0778)));
      final vertex_9_92 = mesh_9.vertices.elementAt(92);
      expect(vertex_9_92, vector3MoreOrLessEquals(Vector3(17.4877, -38.4449, -87.4584)));
      final vertex_9_93 = mesh_9.vertices.elementAt(93);
      expect(vertex_9_93, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_94 = mesh_9.vertices.elementAt(94);
      expect(vertex_9_94, vector3MoreOrLessEquals(Vector3(17.5535, -37.8399, -87.7321)));
      final vertex_9_95 = mesh_9.vertices.elementAt(95);
      expect(vertex_9_95, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_96 = mesh_9.vertices.elementAt(96);
      expect(vertex_9_96, vector3MoreOrLessEquals(Vector3(-14.0883, -8.2318, -19.3888)));
      final vertex_9_97 = mesh_9.vertices.elementAt(97);
      expect(vertex_9_97, vector3MoreOrLessEquals(Vector3(-17.3685, -7.26234, -19.5628)));
      final vertex_9_98 = mesh_9.vertices.elementAt(98);
      expect(vertex_9_98, vector3MoreOrLessEquals(Vector3(17.8189, -38.8267, -87.2082)));
      final vertex_9_99 = mesh_9.vertices.elementAt(99);
      expect(vertex_9_99, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_100 = mesh_9.vertices.elementAt(100);
      expect(vertex_9_100, vector3MoreOrLessEquals(Vector3(17.4877, -38.4449, -87.4584)));
      final vertex_9_101 = mesh_9.vertices.elementAt(101);
      expect(vertex_9_101, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_102 = mesh_9.vertices.elementAt(102);
      expect(vertex_9_102, vector3MoreOrLessEquals(Vector3(-11.9388, -8.23976, -16.6868)));
      final vertex_9_103 = mesh_9.vertices.elementAt(103);
      expect(vertex_9_103, vector3MoreOrLessEquals(Vector3(-14.0883, -8.2318, -19.3888)));
      final vertex_9_104 = mesh_9.vertices.elementAt(104);
      expect(vertex_9_104, vector3MoreOrLessEquals(Vector3(18.2978, -38.6978, -87.17)));
      final vertex_9_105 = mesh_9.vertices.elementAt(105);
      expect(vertex_9_105, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_106 = mesh_9.vertices.elementAt(106);
      expect(vertex_9_106, vector3MoreOrLessEquals(Vector3(17.8189, -38.8267, -87.2082)));
      final vertex_9_107 = mesh_9.vertices.elementAt(107);
      expect(vertex_9_107, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_108 = mesh_9.vertices.elementAt(108);
      expect(vertex_9_108, vector3MoreOrLessEquals(Vector3(-12.5385, -7.28023, -13.4915)));
      final vertex_9_109 = mesh_9.vertices.elementAt(109);
      expect(vertex_9_109, vector3MoreOrLessEquals(Vector3(-11.9388, -8.23976, -16.6868)));
      final vertex_9_110 = mesh_9.vertices.elementAt(110);
      expect(vertex_9_110, vector3MoreOrLessEquals(Vector3(18.5638, -38.1552, -87.3725)));
      final vertex_9_111 = mesh_9.vertices.elementAt(111);
      expect(vertex_9_111, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_112 = mesh_9.vertices.elementAt(112);
      expect(vertex_9_112, vector3MoreOrLessEquals(Vector3(18.2978, -38.6978, -87.17)));
      expect(mesh_9.normals.length, isZero);
      expect(mesh_9.tangents.length, isZero);
      expect(mesh_9.bitangents.length, isZero);
      expect(mesh_9.colors.length, isZero);
      expect(mesh_9.textureCoords.length, isZero);
      expect(mesh_9.uvComponents.length, isZero);
      expect(mesh_9.uvComponents, equals([]));
      expect(mesh_9.faces.length, equals(98));
      expect(mesh_9.bones.length, isZero);
      expect(mesh_9.materialIndex, equals(2));
      expect(mesh_9.name, equals('Bein4Li'));
      expect(mesh_9.animMeshes.length, isZero);
      expect(mesh_9.morphingMethod, isZero);
      expect(mesh_9.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_10 = meshes.elementAt(10);
      expect(mesh_10.primitiveTypes, equals(4));
      expect(mesh_10.vertices.length, equals(42));
      final vertex_10_0 = mesh_10.vertices.elementAt(0);
      expect(vertex_10_0, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_1 = mesh_10.vertices.elementAt(1);
      expect(vertex_10_1, vector3MoreOrLessEquals(Vector3(-64.846, 4.36871, -2.07566)));
      final vertex_10_2 = mesh_10.vertices.elementAt(2);
      expect(vertex_10_2, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_3 = mesh_10.vertices.elementAt(3);
      expect(vertex_10_3, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_4 = mesh_10.vertices.elementAt(4);
      expect(vertex_10_4, vector3MoreOrLessEquals(Vector3(-69.1192, 4.23108, -2.6071)));
      final vertex_10_5 = mesh_10.vertices.elementAt(5);
      expect(vertex_10_5, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_6 = mesh_10.vertices.elementAt(6);
      expect(vertex_10_6, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_7 = mesh_10.vertices.elementAt(7);
      expect(vertex_10_7, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_8 = mesh_10.vertices.elementAt(8);
      expect(vertex_10_8, vector3MoreOrLessEquals(Vector3(-63.9712, 3.6617, -3.83047)));
      final vertex_10_9 = mesh_10.vertices.elementAt(9);
      expect(vertex_10_9, vector3MoreOrLessEquals(Vector3(-61.4476, 8.1901, -3.64704)));
      final vertex_10_10 = mesh_10.vertices.elementAt(10);
      expect(vertex_10_10, vector3MoreOrLessEquals(Vector3(-62.9869, 9.87084, -6.30849)));
      final vertex_10_11 = mesh_10.vertices.elementAt(11);
      expect(vertex_10_11, vector3MoreOrLessEquals(Vector3(-61.4965, 6.34016, -5.81228)));
      final vertex_10_12 = mesh_10.vertices.elementAt(12);
      expect(vertex_10_12, vector3MoreOrLessEquals(Vector3(-62.5578, 11.3056, -3.48591)));
      final vertex_10_13 = mesh_10.vertices.elementAt(13);
      expect(vertex_10_13, vector3MoreOrLessEquals(Vector3(-63.9911, 13.3408, -5.45025)));
      final vertex_10_14 = mesh_10.vertices.elementAt(14);
      expect(vertex_10_14, vector3MoreOrLessEquals(Vector3(-64.6682, 12.763, -8.06086)));
      final vertex_10_15 = mesh_10.vertices.elementAt(15);
      expect(vertex_10_15, vector3MoreOrLessEquals(Vector3(-64.0793, 10.0074, -9.3519)));
      final vertex_10_16 = mesh_10.vertices.elementAt(16);
      expect(vertex_10_16, vector3MoreOrLessEquals(Vector3(-62.6678, 7.14898, -8.35118)));
      final vertex_10_17 = mesh_10.vertices.elementAt(17);
      expect(vertex_10_17, vector3MoreOrLessEquals(Vector3(-64.846, 4.36871, -2.07566)));
      final vertex_10_18 = mesh_10.vertices.elementAt(18);
      expect(vertex_10_18, vector3MoreOrLessEquals(Vector3(-63.9712, 3.6617, -3.83047)));
      final vertex_10_19 = mesh_10.vertices.elementAt(19);
      expect(vertex_10_19, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_20 = mesh_10.vertices.elementAt(20);
      expect(vertex_10_20, vector3MoreOrLessEquals(Vector3(-61.4965, 6.34016, -5.81228)));
      final vertex_10_21 = mesh_10.vertices.elementAt(21);
      expect(vertex_10_21, vector3MoreOrLessEquals(Vector3(-65.1715, 3.03351, -5.47424)));
      final vertex_10_22 = mesh_10.vertices.elementAt(22);
      expect(vertex_10_22, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_23 = mesh_10.vertices.elementAt(23);
      expect(vertex_10_23, vector3MoreOrLessEquals(Vector3(-62.6678, 7.14898, -8.35118)));
      final vertex_10_24 = mesh_10.vertices.elementAt(24);
      expect(vertex_10_24, vector3MoreOrLessEquals(Vector3(-61.4965, 6.34016, -5.81228)));
      final vertex_10_25 = mesh_10.vertices.elementAt(25);
      expect(vertex_10_25, vector3MoreOrLessEquals(Vector3(-61.4476, 8.1901, -3.64704)));
      final vertex_10_26 = mesh_10.vertices.elementAt(26);
      expect(vertex_10_26, vector3MoreOrLessEquals(Vector3(-62.5578, 11.3056, -3.48591)));
      final vertex_10_27 = mesh_10.vertices.elementAt(27);
      expect(vertex_10_27, vector3MoreOrLessEquals(Vector3(-67.1371, 4.62209, -1.5312)));
      final vertex_10_28 = mesh_10.vertices.elementAt(28);
      expect(vertex_10_28, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_29 = mesh_10.vertices.elementAt(29);
      expect(vertex_10_29, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_30 = mesh_10.vertices.elementAt(30);
      expect(vertex_10_30, vector3MoreOrLessEquals(Vector3(-69.1192, 4.23108, -2.6071)));
      final vertex_10_31 = mesh_10.vertices.elementAt(31);
      expect(vertex_10_31, vector3MoreOrLessEquals(Vector3(-67.1371, 4.62209, -1.5312)));
      final vertex_10_32 = mesh_10.vertices.elementAt(32);
      expect(vertex_10_32, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_33 = mesh_10.vertices.elementAt(33);
      expect(vertex_10_33, vector3MoreOrLessEquals(Vector3(-62.5578, 11.3056, -3.48591)));
      final vertex_10_34 = mesh_10.vertices.elementAt(34);
      expect(vertex_10_34, vector3MoreOrLessEquals(Vector3(-63.9911, 13.3408, -5.45025)));
      final vertex_10_35 = mesh_10.vertices.elementAt(35);
      expect(vertex_10_35, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_36 = mesh_10.vertices.elementAt(36);
      expect(vertex_10_36, vector3MoreOrLessEquals(Vector3(-69.2999, 3.49013, -4.49317)));
      final vertex_10_37 = mesh_10.vertices.elementAt(37);
      expect(vertex_10_37, vector3MoreOrLessEquals(Vector3(-64.6682, 12.763, -8.06086)));
      final vertex_10_38 = mesh_10.vertices.elementAt(38);
      expect(vertex_10_38, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_39 = mesh_10.vertices.elementAt(39);
      expect(vertex_10_39, vector3MoreOrLessEquals(Vector3(-64.0793, 10.0074, -9.3519)));
      final vertex_10_40 = mesh_10.vertices.elementAt(40);
      expect(vertex_10_40, vector3MoreOrLessEquals(Vector3(-62.6678, 7.14898, -8.35118)));
      final vertex_10_41 = mesh_10.vertices.elementAt(41);
      expect(vertex_10_41, vector3MoreOrLessEquals(Vector3(-64.0793, 10.0074, -9.3519)));
      expect(mesh_10.normals.length, isZero);
      expect(mesh_10.tangents.length, isZero);
      expect(mesh_10.bitangents.length, isZero);
      expect(mesh_10.colors.length, isZero);
      expect(mesh_10.textureCoords.length, isZero);
      expect(mesh_10.uvComponents.length, isZero);
      expect(mesh_10.uvComponents, equals([]));
      expect(mesh_10.faces.length, equals(42));
      expect(mesh_10.bones.length, isZero);
      expect(mesh_10.materialIndex, equals(2));
      expect(mesh_10.name, equals('Zahn'));
      expect(mesh_10.animMeshes.length, isZero);
      expect(mesh_10.morphingMethod, isZero);
      expect(mesh_10.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_11 = meshes.elementAt(11);
      expect(mesh_11.primitiveTypes, equals(4));
      expect(mesh_11.vertices.length, equals(44));
      final vertex_11_0 = mesh_11.vertices.elementAt(0);
      expect(vertex_11_0, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_1 = mesh_11.vertices.elementAt(1);
      expect(vertex_11_1, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_2 = mesh_11.vertices.elementAt(2);
      expect(vertex_11_2, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_3 = mesh_11.vertices.elementAt(3);
      expect(vertex_11_3, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_4 = mesh_11.vertices.elementAt(4);
      expect(vertex_11_4, vector3MoreOrLessEquals(Vector3(-56.0517, 7.15647, 5.00228)));
      final vertex_11_5 = mesh_11.vertices.elementAt(5);
      expect(vertex_11_5, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_6 = mesh_11.vertices.elementAt(6);
      expect(vertex_11_6, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_7 = mesh_11.vertices.elementAt(7);
      expect(vertex_11_7, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_8 = mesh_11.vertices.elementAt(8);
      expect(vertex_11_8, vector3MoreOrLessEquals(Vector3(-59.6895, 8.14495, 1.86181)));
      final vertex_11_9 = mesh_11.vertices.elementAt(9);
      expect(vertex_11_9, vector3MoreOrLessEquals(Vector3(-55.5099, 10.2797, -2.97612)));
      final vertex_11_10 = mesh_11.vertices.elementAt(10);
      expect(vertex_11_10, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6178, -0.764661)));
      final vertex_11_11 = mesh_11.vertices.elementAt(11);
      expect(vertex_11_11, vector3MoreOrLessEquals(Vector3(-58.2127, 12.0868, -3.03212)));
      final vertex_11_12 = mesh_11.vertices.elementAt(12);
      expect(vertex_11_12, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2333, -1.25485)));
      final vertex_11_13 = mesh_11.vertices.elementAt(13);
      expect(vertex_11_13, vector3MoreOrLessEquals(Vector3(-51.7578, 11.9824, 0.83556)));
      final vertex_11_14 = mesh_11.vertices.elementAt(14);
      expect(vertex_11_14, vector3MoreOrLessEquals(Vector3(-53.534, 14.21, 1.72102)));
      final vertex_11_15 = mesh_11.vertices.elementAt(15);
      expect(vertex_11_15, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2387, 0.734676)));
      final vertex_11_16 = mesh_11.vertices.elementAt(16);
      expect(vertex_11_16, vector3MoreOrLessEquals(Vector3(-58.7103, 14.2937, -1.38064)));
      final vertex_11_17 = mesh_11.vertices.elementAt(17);
      expect(vertex_11_17, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_18 = mesh_11.vertices.elementAt(18);
      expect(vertex_11_18, vector3MoreOrLessEquals(Vector3(-59.6895, 8.14495, 1.86181)));
      final vertex_11_19 = mesh_11.vertices.elementAt(19);
      expect(vertex_11_19, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_20 = mesh_11.vertices.elementAt(20);
      expect(vertex_11_20, vector3MoreOrLessEquals(Vector3(-58.2127, 12.0868, -3.03212)));
      final vertex_11_21 = mesh_11.vertices.elementAt(21);
      expect(vertex_11_21, vector3MoreOrLessEquals(Vector3(-55.5099, 10.2797, -2.97612)));
      final vertex_11_22 = mesh_11.vertices.elementAt(22);
      expect(vertex_11_22, vector3MoreOrLessEquals(Vector3(-60.2821, 9.59619, 3.13846)));
      final vertex_11_23 = mesh_11.vertices.elementAt(23);
      expect(vertex_11_23, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_24 = mesh_11.vertices.elementAt(24);
      expect(vertex_11_24, vector3MoreOrLessEquals(Vector3(-58.7103, 14.2937, -1.38064)));
      final vertex_11_25 = mesh_11.vertices.elementAt(25);
      expect(vertex_11_25, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_26 = mesh_11.vertices.elementAt(26);
      expect(vertex_11_26, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_27 = mesh_11.vertices.elementAt(27);
      expect(vertex_11_27, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2387, 0.734676)));
      final vertex_11_28 = mesh_11.vertices.elementAt(28);
      expect(vertex_11_28, vector3MoreOrLessEquals(Vector3(-57.3648, 8.80349, 5.6569)));
      final vertex_11_29 = mesh_11.vertices.elementAt(29);
      expect(vertex_11_29, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_30 = mesh_11.vertices.elementAt(30);
      expect(vertex_11_30, vector3MoreOrLessEquals(Vector3(-53.534, 14.21, 1.72102)));
      final vertex_11_31 = mesh_11.vertices.elementAt(31);
      expect(vertex_11_31, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_32 = mesh_11.vertices.elementAt(32);
      expect(vertex_11_32, vector3MoreOrLessEquals(Vector3(-56.2969, 6.18843, 3.35651)));
      final vertex_11_33 = mesh_11.vertices.elementAt(33);
      expect(vertex_11_33, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_34 = mesh_11.vertices.elementAt(34);
      expect(vertex_11_34, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2333, -1.25485)));
      final vertex_11_35 = mesh_11.vertices.elementAt(35);
      expect(vertex_11_35, vector3MoreOrLessEquals(Vector3(-55.5099, 10.2797, -2.97612)));
      final vertex_11_36 = mesh_11.vertices.elementAt(36);
      expect(vertex_11_36, vector3MoreOrLessEquals(Vector3(-56.0517, 7.15647, 5.00228)));
      final vertex_11_37 = mesh_11.vertices.elementAt(37);
      expect(vertex_11_37, vector3MoreOrLessEquals(Vector3(-56.2969, 6.18843, 3.35651)));
      final vertex_11_38 = mesh_11.vertices.elementAt(38);
      expect(vertex_11_38, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_39 = mesh_11.vertices.elementAt(39);
      expect(vertex_11_39, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2333, -1.25485)));
      final vertex_11_40 = mesh_11.vertices.elementAt(40);
      expect(vertex_11_40, vector3MoreOrLessEquals(Vector3(-51.7578, 11.9824, 0.83556)));
      final vertex_11_41 = mesh_11.vertices.elementAt(41);
      expect(vertex_11_41, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_42 = mesh_11.vertices.elementAt(42);
      expect(vertex_11_42, vector3MoreOrLessEquals(Vector3(-57.3648, 8.80349, 5.6569)));
      final vertex_11_43 = mesh_11.vertices.elementAt(43);
      expect(vertex_11_43, vector3MoreOrLessEquals(Vector3(-53.534, 14.21, 1.72102)));
      expect(mesh_11.normals.length, isZero);
      expect(mesh_11.tangents.length, isZero);
      expect(mesh_11.bitangents.length, isZero);
      expect(mesh_11.colors.length, isZero);
      expect(mesh_11.textureCoords.length, isZero);
      expect(mesh_11.uvComponents.length, isZero);
      expect(mesh_11.uvComponents, equals([]));
      expect(mesh_11.faces.length, equals(42));
      expect(mesh_11.bones.length, isZero);
      expect(mesh_11.materialIndex, equals(2));
      expect(mesh_11.name, equals('klZahn'));
      expect(mesh_11.animMeshes.length, isZero);
      expect(mesh_11.morphingMethod, isZero);
      expect(mesh_11.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_12 = meshes.elementAt(12);
      expect(mesh_12.primitiveTypes, equals(4));
      expect(mesh_12.vertices.length, equals(79));
      final vertex_12_0 = mesh_12.vertices.elementAt(0);
      expect(vertex_12_0, vector3MoreOrLessEquals(Vector3(-43.2, 24.2518, -9.94445)));
      final vertex_12_1 = mesh_12.vertices.elementAt(1);
      expect(vertex_12_1, vector3MoreOrLessEquals(Vector3(-44.0038, 24.2518, -7.33652)));
      final vertex_12_2 = mesh_12.vertices.elementAt(2);
      expect(vertex_12_2, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.94445)));
      final vertex_12_3 = mesh_12.vertices.elementAt(3);
      expect(vertex_12_3, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -0.760711)));
      final vertex_12_4 = mesh_12.vertices.elementAt(4);
      expect(vertex_12_4, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -0.760713)));
      final vertex_12_5 = mesh_12.vertices.elementAt(5);
      expect(vertex_12_5, vector3MoreOrLessEquals(Vector3(-38.8077, 21.886, -9.94445)));
      final vertex_12_6 = mesh_12.vertices.elementAt(6);
      expect(vertex_12_6, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, 2.54601)));
      final vertex_12_7 = mesh_12.vertices.elementAt(7);
      expect(vertex_12_7, vector3MoreOrLessEquals(Vector3(-37.2, 18.6544, -9.94445)));
      final vertex_12_8 = mesh_12.vertices.elementAt(8);
      expect(vertex_12_8, vector3MoreOrLessEquals(Vector3(-39.2521, 18.6544, -0.06192)));
      final vertex_12_9 = mesh_12.vertices.elementAt(9);
      expect(vertex_12_9, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_10 = mesh_12.vertices.elementAt(10);
      expect(vertex_12_10, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -0.081627)));
      final vertex_12_11 = mesh_12.vertices.elementAt(11);
      expect(vertex_12_11, vector3MoreOrLessEquals(Vector3(-43.6077, 8.33333, -9.94445)));
      final vertex_12_12 = mesh_12.vertices.elementAt(12);
      expect(vertex_12_12, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_13 = mesh_12.vertices.elementAt(13);
      expect(vertex_12_13, vector3MoreOrLessEquals(Vector3(-54, 10.6667, 1.82244)));
      final vertex_12_14 = mesh_12.vertices.elementAt(14);
      expect(vertex_12_14, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -0.944447)));
      final vertex_12_15 = mesh_12.vertices.elementAt(15);
      expect(vertex_12_15, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -4.74829)));
      final vertex_12_16 = mesh_12.vertices.elementAt(16);
      expect(vertex_12_16, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -3.94445)));
      final vertex_12_17 = mesh_12.vertices.elementAt(17);
      expect(vertex_12_17, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -4.74829)));
      final vertex_12_18 = mesh_12.vertices.elementAt(18);
      expect(vertex_12_18, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -0.944447)));
      final vertex_12_19 = mesh_12.vertices.elementAt(19);
      expect(vertex_12_19, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.94445)));
      final vertex_12_20 = mesh_12.vertices.elementAt(20);
      expect(vertex_12_20, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -0.760711)));
      final vertex_12_21 = mesh_12.vertices.elementAt(21);
      expect(vertex_12_21, vector3MoreOrLessEquals(Vector3(-54, 24.7256, -3.94445)));
      final vertex_12_22 = mesh_12.vertices.elementAt(22);
      expect(vertex_12_22, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.94445)));
      final vertex_12_23 = mesh_12.vertices.elementAt(23);
      expect(vertex_12_23, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -4.74829)));
      final vertex_12_24 = mesh_12.vertices.elementAt(24);
      expect(vertex_12_24, vector3MoreOrLessEquals(Vector3(-59.1961, 24.7256, -6.94445)));
      final vertex_12_25 = mesh_12.vertices.elementAt(25);
      expect(vertex_12_25, vector3MoreOrLessEquals(Vector3(-54, 20.3333, 0.447858)));
      final vertex_12_26 = mesh_12.vertices.elementAt(26);
      expect(vertex_12_26, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, 2.54601)));
      final vertex_12_27 = mesh_12.vertices.elementAt(27);
      expect(vertex_12_27, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -2.19914)));
      final vertex_12_28 = mesh_12.vertices.elementAt(28);
      expect(vertex_12_28, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_29 = mesh_12.vertices.elementAt(29);
      expect(vertex_12_29, vector3MoreOrLessEquals(Vector3(-60, 24.7256, -9.94445)));
      final vertex_12_30 = mesh_12.vertices.elementAt(30);
      expect(vertex_12_30, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.94445)));
      final vertex_12_31 = mesh_12.vertices.elementAt(31);
      expect(vertex_12_31, vector3MoreOrLessEquals(Vector3(-64.3923, 20.3333, -9.94445)));
      final vertex_12_32 = mesh_12.vertices.elementAt(32);
      expect(vertex_12_32, vector3MoreOrLessEquals(Vector3(-66.4, 12.3333, -9.94445)));
      final vertex_12_33 = mesh_12.vertices.elementAt(33);
      expect(vertex_12_33, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -6.36709)));
      final vertex_12_34 = mesh_12.vertices.elementAt(34);
      expect(vertex_12_34, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -4.74829)));
      final vertex_12_35 = mesh_12.vertices.elementAt(35);
      expect(vertex_12_35, vector3MoreOrLessEquals(Vector3(-64.1923, 7.53335, -9.94445)));
      final vertex_12_36 = mesh_12.vertices.elementAt(36);
      expect(vertex_12_36, vector3MoreOrLessEquals(Vector3(-58.8, 5.77436, -9.94445)));
      final vertex_12_37 = mesh_12.vertices.elementAt(37);
      expect(vertex_12_37, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -6.94445)));
      final vertex_12_38 = mesh_12.vertices.elementAt(38);
      expect(vertex_12_38, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.94445)));
      final vertex_12_39 = mesh_12.vertices.elementAt(39);
      expect(vertex_12_39, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -4.74829)));
      final vertex_12_40 = mesh_12.vertices.elementAt(40);
      expect(vertex_12_40, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -3.94445)));
      final vertex_12_41 = mesh_12.vertices.elementAt(41);
      expect(vertex_12_41, vector3MoreOrLessEquals(Vector3(-54, 10.6667, 1.82244)));
      final vertex_12_42 = mesh_12.vertices.elementAt(42);
      expect(vertex_12_42, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -0.944447)));
      final vertex_12_43 = mesh_12.vertices.elementAt(43);
      expect(vertex_12_43, vector3MoreOrLessEquals(Vector3(-54, 14.3333, 2.05555)));
      final vertex_12_44 = mesh_12.vertices.elementAt(44);
      expect(vertex_12_44, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_45 = mesh_12.vertices.elementAt(45);
      expect(vertex_12_45, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_46 = mesh_12.vertices.elementAt(46);
      expect(vertex_12_46, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -6.94445)));
      final vertex_12_47 = mesh_12.vertices.elementAt(47);
      expect(vertex_12_47, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -4.74829)));
      final vertex_12_48 = mesh_12.vertices.elementAt(48);
      expect(vertex_12_48, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.94445)));
      final vertex_12_49 = mesh_12.vertices.elementAt(49);
      expect(vertex_12_49, vector3MoreOrLessEquals(Vector3(-54, 14.3333, 2.05555)));
      final vertex_12_50 = mesh_12.vertices.elementAt(50);
      expect(vertex_12_50, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -4.19187)));
      final vertex_12_51 = mesh_12.vertices.elementAt(51);
      expect(vertex_12_51, vector3MoreOrLessEquals(Vector3(-61.6405, 15.3095, -2.69388)));
      final vertex_12_52 = mesh_12.vertices.elementAt(52);
      expect(vertex_12_52, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -2.24448)));
      final vertex_12_53 = mesh_12.vertices.elementAt(53);
      expect(vertex_12_53, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -2.54408)));
      final vertex_12_54 = mesh_12.vertices.elementAt(54);
      expect(vertex_12_54, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_55 = mesh_12.vertices.elementAt(55);
      expect(vertex_12_55, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -4.04208)));
      final vertex_12_56 = mesh_12.vertices.elementAt(56);
      expect(vertex_12_56, vector3MoreOrLessEquals(Vector3(-61.8597, 18.4762, -3.14327)));
      final vertex_12_57 = mesh_12.vertices.elementAt(57);
      expect(vertex_12_57, vector3MoreOrLessEquals(Vector3(-61.725, 18.1557, -3.36926)));
      final vertex_12_58 = mesh_12.vertices.elementAt(58);
      expect(vertex_12_58, vector3MoreOrLessEquals(Vector3(-61.8941, 18.0416, -3.95886)));
      final vertex_12_59 = mesh_12.vertices.elementAt(59);
      expect(vertex_12_59, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -4.94086)));
      final vertex_12_60 = mesh_12.vertices.elementAt(60);
      expect(vertex_12_60, vector3MoreOrLessEquals(Vector3(-61.5825, 17.6345, -2.87215)));
      final vertex_12_61 = mesh_12.vertices.elementAt(61);
      expect(vertex_12_61, vector3MoreOrLessEquals(Vector3(-61.5534, 16.7451, -2.77082)));
      final vertex_12_62 = mesh_12.vertices.elementAt(62);
      expect(vertex_12_62, vector3MoreOrLessEquals(Vector3(-61.7381, 15.7372, -3.41491)));
      final vertex_12_63 = mesh_12.vertices.elementAt(63);
      expect(vertex_12_63, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_64 = mesh_12.vertices.elementAt(64);
      expect(vertex_12_64, vector3MoreOrLessEquals(Vector3(-62.0774, 15.0709, -4.59818)));
      final vertex_12_65 = mesh_12.vertices.elementAt(65);
      expect(vertex_12_65, vector3MoreOrLessEquals(Vector3(-62.9556, 14.6429, -5.39026)));
      final vertex_12_66 = mesh_12.vertices.elementAt(66);
      expect(vertex_12_66, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -5.48682)));
      final vertex_12_67 = mesh_12.vertices.elementAt(67);
      expect(vertex_12_67, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -5.48682)));
      final vertex_12_68 = mesh_12.vertices.elementAt(68);
      expect(vertex_12_68, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -6.13926)));
      final vertex_12_69 = mesh_12.vertices.elementAt(69);
      expect(vertex_12_69, vector3MoreOrLessEquals(Vector3(-62.366, 15.3991, -5.60484)));
      final vertex_12_70 = mesh_12.vertices.elementAt(70);
      expect(vertex_12_70, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -5.98946)));
      final vertex_12_71 = mesh_12.vertices.elementAt(71);
      expect(vertex_12_71, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -5.39026)));
      final vertex_12_72 = mesh_12.vertices.elementAt(72);
      expect(vertex_12_72, vector3MoreOrLessEquals(Vector3(-62.2019, 16.1617, -5.03228)));
      final vertex_12_73 = mesh_12.vertices.elementAt(73);
      expect(vertex_12_73, vector3MoreOrLessEquals(Vector3(-62.366, 15.3991, -5.60484)));
      final vertex_12_74 = mesh_12.vertices.elementAt(74);
      expect(vertex_12_74, vector3MoreOrLessEquals(Vector3(-62.1186, 16.9811, -4.74192)));
      final vertex_12_75 = mesh_12.vertices.elementAt(75);
      expect(vertex_12_75, vector3MoreOrLessEquals(Vector3(-62.0704, 17.6997, -4.57366)));
      final vertex_12_76 = mesh_12.vertices.elementAt(76);
      expect(vertex_12_76, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -0.944447)));
      final vertex_12_77 = mesh_12.vertices.elementAt(77);
      expect(vertex_12_77, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -0.081627)));
      final vertex_12_78 = mesh_12.vertices.elementAt(78);
      expect(vertex_12_78, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -4.74829)));
      expect(mesh_12.normals.length, isZero);
      expect(mesh_12.tangents.length, isZero);
      expect(mesh_12.bitangents.length, isZero);
      expect(mesh_12.colors.length, isZero);
      expect(mesh_12.textureCoords.length, isZero);
      expect(mesh_12.uvComponents.length, isZero);
      expect(mesh_12.uvComponents, equals([]));
      expect(mesh_12.faces.length, equals(90));
      expect(mesh_12.bones.length, isZero);
      expect(mesh_12.materialIndex, isZero);
      expect(mesh_12.name, equals('Kopf'));
      expect(mesh_12.animMeshes.length, isZero);
      expect(mesh_12.morphingMethod, isZero);
      expect(mesh_12.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_13 = meshes.elementAt(13);
      expect(mesh_13.primitiveTypes, equals(4));
      expect(mesh_13.vertices.length, equals(17));
      final vertex_13_0 = mesh_13.vertices.elementAt(0);
      expect(vertex_13_0, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -14.0424)));
      final vertex_13_1 = mesh_13.vertices.elementAt(1);
      expect(vertex_13_1, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, -20.5831)));
      final vertex_13_2 = mesh_13.vertices.elementAt(2);
      expect(vertex_13_2, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -16.8773)));
      final vertex_13_3 = mesh_13.vertices.elementAt(3);
      expect(vertex_13_3, vector3MoreOrLessEquals(Vector3(-32.1219, -11.5362, -10)));
      final vertex_13_4 = mesh_13.vertices.elementAt(4);
      expect(vertex_13_4, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -17.0586)));
      final vertex_13_5 = mesh_13.vertices.elementAt(5);
      expect(vertex_13_5, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, -28.4798)));
      final vertex_13_6 = mesh_13.vertices.elementAt(6);
      expect(vertex_13_6, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -19.4053)));
      final vertex_13_7 = mesh_13.vertices.elementAt(7);
      expect(vertex_13_7, vector3MoreOrLessEquals(Vector3(-6.30518, -14.1821, -10)));
      final vertex_13_8 = mesh_13.vertices.elementAt(8);
      expect(vertex_13_8, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -5.95762)));
      final vertex_13_9 = mesh_13.vertices.elementAt(9);
      expect(vertex_13_9, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -3.12269)));
      final vertex_13_10 = mesh_13.vertices.elementAt(10);
      expect(vertex_13_10, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -2.94136)));
      final vertex_13_11 = mesh_13.vertices.elementAt(11);
      expect(vertex_13_11, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, 0.583091)));
      final vertex_13_12 = mesh_13.vertices.elementAt(12);
      expect(vertex_13_12, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -0.594703)));
      final vertex_13_13 = mesh_13.vertices.elementAt(13);
      expect(vertex_13_13, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, 8.47976)));
      final vertex_13_14 = mesh_13.vertices.elementAt(14);
      expect(vertex_13_14, vector3MoreOrLessEquals(Vector3(-51.6476, -5.70869, -10)));
      final vertex_13_15 = mesh_13.vertices.elementAt(15);
      expect(vertex_13_15, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, 1.42112)));
      final vertex_13_16 = mesh_13.vertices.elementAt(16);
      expect(vertex_13_16, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, -21.4211)));
      expect(mesh_13.normals.length, isZero);
      expect(mesh_13.tangents.length, isZero);
      expect(mesh_13.bitangents.length, isZero);
      expect(mesh_13.colors.length, isZero);
      expect(mesh_13.textureCoords.length, isZero);
      expect(mesh_13.uvComponents.length, isZero);
      expect(mesh_13.uvComponents, equals([]));
      expect(mesh_13.faces.length, equals(20));
      expect(mesh_13.bones.length, isZero);
      expect(mesh_13.materialIndex, isZero);
      expect(mesh_13.name, equals('Brust'));
      expect(mesh_13.animMeshes.length, isZero);
      expect(mesh_13.morphingMethod, isZero);
      expect(mesh_13.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_14 = meshes.elementAt(14);
      expect(mesh_14.primitiveTypes, equals(4));
      expect(mesh_14.vertices.length, equals(79));
      final vertex_14_0 = mesh_14.vertices.elementAt(0);
      expect(vertex_14_0, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.98889)));
      final vertex_14_1 = mesh_14.vertices.elementAt(1);
      expect(vertex_14_1, vector3MoreOrLessEquals(Vector3(-44.0038, 24.2518, -12.5968)));
      final vertex_14_2 = mesh_14.vertices.elementAt(2);
      expect(vertex_14_2, vector3MoreOrLessEquals(Vector3(-43.2, 24.2518, -9.98889)));
      final vertex_14_3 = mesh_14.vertices.elementAt(3);
      expect(vertex_14_3, vector3MoreOrLessEquals(Vector3(-38.8077, 21.886, -9.98889)));
      final vertex_14_4 = mesh_14.vertices.elementAt(4);
      expect(vertex_14_4, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -19.1726)));
      final vertex_14_5 = mesh_14.vertices.elementAt(5);
      expect(vertex_14_5, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -19.1726)));
      final vertex_14_6 = mesh_14.vertices.elementAt(6);
      expect(vertex_14_6, vector3MoreOrLessEquals(Vector3(-37.2, 18.6544, -9.98889)));
      final vertex_14_7 = mesh_14.vertices.elementAt(7);
      expect(vertex_14_7, vector3MoreOrLessEquals(Vector3(-39.2521, 18.6544, -19.8714)));
      final vertex_14_8 = mesh_14.vertices.elementAt(8);
      expect(vertex_14_8, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_9 = mesh_14.vertices.elementAt(9);
      expect(vertex_14_9, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, -22.4793)));
      final vertex_14_10 = mesh_14.vertices.elementAt(10);
      expect(vertex_14_10, vector3MoreOrLessEquals(Vector3(-43.6077, 8.33333, -9.98889)));
      final vertex_14_11 = mesh_14.vertices.elementAt(11);
      expect(vertex_14_11, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -19.8517)));
      final vertex_14_12 = mesh_14.vertices.elementAt(12);
      expect(vertex_14_12, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_13 = mesh_14.vertices.elementAt(13);
      expect(vertex_14_13, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -18.9889)));
      final vertex_14_14 = mesh_14.vertices.elementAt(14);
      expect(vertex_14_14, vector3MoreOrLessEquals(Vector3(-54, 10.6667, -21.7558)));
      final vertex_14_15 = mesh_14.vertices.elementAt(15);
      expect(vertex_14_15, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -15.185)));
      final vertex_14_16 = mesh_14.vertices.elementAt(16);
      expect(vertex_14_16, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -15.9889)));
      final vertex_14_17 = mesh_14.vertices.elementAt(17);
      expect(vertex_14_17, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -18.9889)));
      final vertex_14_18 = mesh_14.vertices.elementAt(18);
      expect(vertex_14_18, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -15.185)));
      final vertex_14_19 = mesh_14.vertices.elementAt(19);
      expect(vertex_14_19, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.98889)));
      final vertex_14_20 = mesh_14.vertices.elementAt(20);
      expect(vertex_14_20, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.98889)));
      final vertex_14_21 = mesh_14.vertices.elementAt(21);
      expect(vertex_14_21, vector3MoreOrLessEquals(Vector3(-54, 24.7256, -15.9889)));
      final vertex_14_22 = mesh_14.vertices.elementAt(22);
      expect(vertex_14_22, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -19.1726)));
      final vertex_14_23 = mesh_14.vertices.elementAt(23);
      expect(vertex_14_23, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, -22.4793)));
      final vertex_14_24 = mesh_14.vertices.elementAt(24);
      expect(vertex_14_24, vector3MoreOrLessEquals(Vector3(-54, 20.3333, -20.3812)));
      final vertex_14_25 = mesh_14.vertices.elementAt(25);
      expect(vertex_14_25, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -15.185)));
      final vertex_14_26 = mesh_14.vertices.elementAt(26);
      expect(vertex_14_26, vector3MoreOrLessEquals(Vector3(-59.1961, 24.7256, -12.9889)));
      final vertex_14_27 = mesh_14.vertices.elementAt(27);
      expect(vertex_14_27, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -17.7342)));
      final vertex_14_28 = mesh_14.vertices.elementAt(28);
      expect(vertex_14_28, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_29 = mesh_14.vertices.elementAt(29);
      expect(vertex_14_29, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.98889)));
      final vertex_14_30 = mesh_14.vertices.elementAt(30);
      expect(vertex_14_30, vector3MoreOrLessEquals(Vector3(-60, 24.7256, -9.98889)));
      final vertex_14_31 = mesh_14.vertices.elementAt(31);
      expect(vertex_14_31, vector3MoreOrLessEquals(Vector3(-64.3923, 20.3333, -9.98889)));
      final vertex_14_32 = mesh_14.vertices.elementAt(32);
      expect(vertex_14_32, vector3MoreOrLessEquals(Vector3(-66.4, 12.3333, -9.98889)));
      final vertex_14_33 = mesh_14.vertices.elementAt(33);
      expect(vertex_14_33, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -15.185)));
      final vertex_14_34 = mesh_14.vertices.elementAt(34);
      expect(vertex_14_34, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -13.5662)));
      final vertex_14_35 = mesh_14.vertices.elementAt(35);
      expect(vertex_14_35, vector3MoreOrLessEquals(Vector3(-64.1923, 7.53335, -9.98889)));
      final vertex_14_36 = mesh_14.vertices.elementAt(36);
      expect(vertex_14_36, vector3MoreOrLessEquals(Vector3(-58.8, 5.77436, -9.98889)));
      final vertex_14_37 = mesh_14.vertices.elementAt(37);
      expect(vertex_14_37, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.98889)));
      final vertex_14_38 = mesh_14.vertices.elementAt(38);
      expect(vertex_14_38, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -12.9889)));
      final vertex_14_39 = mesh_14.vertices.elementAt(39);
      expect(vertex_14_39, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -15.9889)));
      final vertex_14_40 = mesh_14.vertices.elementAt(40);
      expect(vertex_14_40, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -15.185)));
      final vertex_14_41 = mesh_14.vertices.elementAt(41);
      expect(vertex_14_41, vector3MoreOrLessEquals(Vector3(-54, 10.6667, -21.7558)));
      final vertex_14_42 = mesh_14.vertices.elementAt(42);
      expect(vertex_14_42, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -18.9889)));
      final vertex_14_43 = mesh_14.vertices.elementAt(43);
      expect(vertex_14_43, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_44 = mesh_14.vertices.elementAt(44);
      expect(vertex_14_44, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_45 = mesh_14.vertices.elementAt(45);
      expect(vertex_14_45, vector3MoreOrLessEquals(Vector3(-54, 14.3333, -21.9889)));
      final vertex_14_46 = mesh_14.vertices.elementAt(46);
      expect(vertex_14_46, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -19.8517)));
      final vertex_14_47 = mesh_14.vertices.elementAt(47);
      expect(vertex_14_47, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -18.9889)));
      final vertex_14_48 = mesh_14.vertices.elementAt(48);
      expect(vertex_14_48, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -15.185)));
      final vertex_14_49 = mesh_14.vertices.elementAt(49);
      expect(vertex_14_49, vector3MoreOrLessEquals(Vector3(-54, 14.3333, -21.9889)));
      final vertex_14_50 = mesh_14.vertices.elementAt(50);
      expect(vertex_14_50, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -15.7415)));
      final vertex_14_51 = mesh_14.vertices.elementAt(51);
      expect(vertex_14_51, vector3MoreOrLessEquals(Vector3(-61.6405, 15.3095, -17.2395)));
      final vertex_14_52 = mesh_14.vertices.elementAt(52);
      expect(vertex_14_52, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -17.6889)));
      final vertex_14_53 = mesh_14.vertices.elementAt(53);
      expect(vertex_14_53, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -17.3893)));
      final vertex_14_54 = mesh_14.vertices.elementAt(54);
      expect(vertex_14_54, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -15.185)));
      final vertex_14_55 = mesh_14.vertices.elementAt(55);
      expect(vertex_14_55, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -12.9889)));
      final vertex_14_56 = mesh_14.vertices.elementAt(56);
      expect(vertex_14_56, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.98889)));
      final vertex_14_57 = mesh_14.vertices.elementAt(57);
      expect(vertex_14_57, vector3MoreOrLessEquals(Vector3(-61.5825, 17.6345, -17.0612)));
      final vertex_14_58 = mesh_14.vertices.elementAt(58);
      expect(vertex_14_58, vector3MoreOrLessEquals(Vector3(-61.5534, 16.7451, -17.1625)));
      final vertex_14_59 = mesh_14.vertices.elementAt(59);
      expect(vertex_14_59, vector3MoreOrLessEquals(Vector3(-61.725, 18.1557, -16.5641)));
      final vertex_14_60 = mesh_14.vertices.elementAt(60);
      expect(vertex_14_60, vector3MoreOrLessEquals(Vector3(-61.8597, 18.4762, -16.7901)));
      final vertex_14_61 = mesh_14.vertices.elementAt(61);
      expect(vertex_14_61, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_62 = mesh_14.vertices.elementAt(62);
      expect(vertex_14_62, vector3MoreOrLessEquals(Vector3(-61.7381, 15.7372, -16.5184)));
      final vertex_14_63 = mesh_14.vertices.elementAt(63);
      expect(vertex_14_63, vector3MoreOrLessEquals(Vector3(-62.0774, 15.0709, -15.3352)));
      final vertex_14_64 = mesh_14.vertices.elementAt(64);
      expect(vertex_14_64, vector3MoreOrLessEquals(Vector3(-62.9556, 14.6429, -14.5431)));
      final vertex_14_65 = mesh_14.vertices.elementAt(65);
      expect(vertex_14_65, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -14.4465)));
      final vertex_14_66 = mesh_14.vertices.elementAt(66);
      expect(vertex_14_66, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -14.4465)));
      final vertex_14_67 = mesh_14.vertices.elementAt(67);
      expect(vertex_14_67, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -13.7941)));
      final vertex_14_68 = mesh_14.vertices.elementAt(68);
      expect(vertex_14_68, vector3MoreOrLessEquals(Vector3(-62.366, 15.3991, -14.3285)));
      final vertex_14_69 = mesh_14.vertices.elementAt(69);
      expect(vertex_14_69, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -13.9439)));
      final vertex_14_70 = mesh_14.vertices.elementAt(70);
      expect(vertex_14_70, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -14.5431)));
      final vertex_14_71 = mesh_14.vertices.elementAt(71);
      expect(vertex_14_71, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -14.9925)));
      final vertex_14_72 = mesh_14.vertices.elementAt(72);
      expect(vertex_14_72, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -15.8913)));
      final vertex_14_73 = mesh_14.vertices.elementAt(73);
      expect(vertex_14_73, vector3MoreOrLessEquals(Vector3(-62.2019, 16.1617, -14.9011)));
      final vertex_14_74 = mesh_14.vertices.elementAt(74);
      expect(vertex_14_74, vector3MoreOrLessEquals(Vector3(-62.366, 15.3991, -14.3285)));
      final vertex_14_75 = mesh_14.vertices.elementAt(75);
      expect(vertex_14_75, vector3MoreOrLessEquals(Vector3(-62.1186, 16.9811, -15.1914)));
      final vertex_14_76 = mesh_14.vertices.elementAt(76);
      expect(vertex_14_76, vector3MoreOrLessEquals(Vector3(-61.8941, 18.0416, -15.9745)));
      final vertex_14_77 = mesh_14.vertices.elementAt(77);
      expect(vertex_14_77, vector3MoreOrLessEquals(Vector3(-62.0704, 17.6997, -15.3597)));
      final vertex_14_78 = mesh_14.vertices.elementAt(78);
      expect(vertex_14_78, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      expect(mesh_14.normals.length, isZero);
      expect(mesh_14.tangents.length, isZero);
      expect(mesh_14.bitangents.length, isZero);
      expect(mesh_14.colors.length, isZero);
      expect(mesh_14.textureCoords.length, isZero);
      expect(mesh_14.uvComponents.length, isZero);
      expect(mesh_14.uvComponents, equals([]));
      expect(mesh_14.faces.length, equals(90));
      expect(mesh_14.bones.length, isZero);
      expect(mesh_14.materialIndex, isZero);
      expect(mesh_14.name, equals('Kopf2'));
      expect(mesh_14.animMeshes.length, isZero);
      expect(mesh_14.morphingMethod, isZero);
      expect(mesh_14.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_15 = meshes.elementAt(15);
      expect(mesh_15.primitiveTypes, equals(4));
      expect(mesh_15.vertices.length, equals(42));
      final vertex_15_0 = mesh_15.vertices.elementAt(0);
      expect(vertex_15_0, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_1 = mesh_15.vertices.elementAt(1);
      expect(vertex_15_1, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_2 = mesh_15.vertices.elementAt(2);
      expect(vertex_15_2, vector3MoreOrLessEquals(Vector3(-64.6642, 4.2778, -18.2395)));
      final vertex_15_3 = mesh_15.vertices.elementAt(3);
      expect(vertex_15_3, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_4 = mesh_15.vertices.elementAt(4);
      expect(vertex_15_4, vector3MoreOrLessEquals(Vector3(-68.9374, 4.14017, -17.7081)));
      final vertex_15_5 = mesh_15.vertices.elementAt(5);
      expect(vertex_15_5, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_6 = mesh_15.vertices.elementAt(6);
      expect(vertex_15_6, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_7 = mesh_15.vertices.elementAt(7);
      expect(vertex_15_7, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_8 = mesh_15.vertices.elementAt(8);
      expect(vertex_15_8, vector3MoreOrLessEquals(Vector3(-63.7893, 3.57079, -16.4847)));
      final vertex_15_9 = mesh_15.vertices.elementAt(9);
      expect(vertex_15_9, vector3MoreOrLessEquals(Vector3(-61.3147, 6.24925, -14.5029)));
      final vertex_15_10 = mesh_15.vertices.elementAt(10);
      expect(vertex_15_10, vector3MoreOrLessEquals(Vector3(-62.805, 9.77993, -14.0067)));
      final vertex_15_11 = mesh_15.vertices.elementAt(11);
      expect(vertex_15_11, vector3MoreOrLessEquals(Vector3(-61.2658, 8.09919, -16.6681)));
      final vertex_15_12 = mesh_15.vertices.elementAt(12);
      expect(vertex_15_12, vector3MoreOrLessEquals(Vector3(-62.376, 11.2147, -16.8292)));
      final vertex_15_13 = mesh_15.vertices.elementAt(13);
      expect(vertex_15_13, vector3MoreOrLessEquals(Vector3(-63.8093, 13.2499, -14.8649)));
      final vertex_15_14 = mesh_15.vertices.elementAt(14);
      expect(vertex_15_14, vector3MoreOrLessEquals(Vector3(-64.4864, 12.6721, -12.2543)));
      final vertex_15_15 = mesh_15.vertices.elementAt(15);
      expect(vertex_15_15, vector3MoreOrLessEquals(Vector3(-63.8974, 9.91648, -10.9633)));
      final vertex_15_16 = mesh_15.vertices.elementAt(16);
      expect(vertex_15_16, vector3MoreOrLessEquals(Vector3(-62.4859, 7.05807, -11.964)));
      final vertex_15_17 = mesh_15.vertices.elementAt(17);
      expect(vertex_15_17, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_18 = mesh_15.vertices.elementAt(18);
      expect(vertex_15_18, vector3MoreOrLessEquals(Vector3(-63.7893, 3.57079, -16.4847)));
      final vertex_15_19 = mesh_15.vertices.elementAt(19);
      expect(vertex_15_19, vector3MoreOrLessEquals(Vector3(-64.6642, 4.2778, -18.2395)));
      final vertex_15_20 = mesh_15.vertices.elementAt(20);
      expect(vertex_15_20, vector3MoreOrLessEquals(Vector3(-61.3147, 6.24925, -14.5029)));
      final vertex_15_21 = mesh_15.vertices.elementAt(21);
      expect(vertex_15_21, vector3MoreOrLessEquals(Vector3(-61.2658, 8.09919, -16.6681)));
      final vertex_15_22 = mesh_15.vertices.elementAt(22);
      expect(vertex_15_22, vector3MoreOrLessEquals(Vector3(-66.9553, 4.53118, -18.784)));
      final vertex_15_23 = mesh_15.vertices.elementAt(23);
      expect(vertex_15_23, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_24 = mesh_15.vertices.elementAt(24);
      expect(vertex_15_24, vector3MoreOrLessEquals(Vector3(-62.376, 11.2147, -16.8292)));
      final vertex_15_25 = mesh_15.vertices.elementAt(25);
      expect(vertex_15_25, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_26 = mesh_15.vertices.elementAt(26);
      expect(vertex_15_26, vector3MoreOrLessEquals(Vector3(-64.9896, 2.9426, -14.8409)));
      final vertex_15_27 = mesh_15.vertices.elementAt(27);
      expect(vertex_15_27, vector3MoreOrLessEquals(Vector3(-62.4859, 7.05807, -11.964)));
      final vertex_15_28 = mesh_15.vertices.elementAt(28);
      expect(vertex_15_28, vector3MoreOrLessEquals(Vector3(-61.3147, 6.24925, -14.5029)));
      final vertex_15_29 = mesh_15.vertices.elementAt(29);
      expect(vertex_15_29, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_30 = mesh_15.vertices.elementAt(30);
      expect(vertex_15_30, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_31 = mesh_15.vertices.elementAt(31);
      expect(vertex_15_31, vector3MoreOrLessEquals(Vector3(-66.9553, 4.53118, -18.784)));
      final vertex_15_32 = mesh_15.vertices.elementAt(32);
      expect(vertex_15_32, vector3MoreOrLessEquals(Vector3(-68.9374, 4.14017, -17.7081)));
      final vertex_15_33 = mesh_15.vertices.elementAt(33);
      expect(vertex_15_33, vector3MoreOrLessEquals(Vector3(-62.376, 11.2147, -16.8292)));
      final vertex_15_34 = mesh_15.vertices.elementAt(34);
      expect(vertex_15_34, vector3MoreOrLessEquals(Vector3(-63.8093, 13.2499, -14.8649)));
      final vertex_15_35 = mesh_15.vertices.elementAt(35);
      expect(vertex_15_35, vector3MoreOrLessEquals(Vector3(-69.118, 3.39922, -15.822)));
      final vertex_15_36 = mesh_15.vertices.elementAt(36);
      expect(vertex_15_36, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_37 = mesh_15.vertices.elementAt(37);
      expect(vertex_15_37, vector3MoreOrLessEquals(Vector3(-64.4864, 12.6721, -12.2543)));
      final vertex_15_38 = mesh_15.vertices.elementAt(38);
      expect(vertex_15_38, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_39 = mesh_15.vertices.elementAt(39);
      expect(vertex_15_39, vector3MoreOrLessEquals(Vector3(-63.8974, 9.91648, -10.9633)));
      final vertex_15_40 = mesh_15.vertices.elementAt(40);
      expect(vertex_15_40, vector3MoreOrLessEquals(Vector3(-63.8974, 9.91648, -10.9633)));
      final vertex_15_41 = mesh_15.vertices.elementAt(41);
      expect(vertex_15_41, vector3MoreOrLessEquals(Vector3(-62.4859, 7.05807, -11.964)));
      expect(mesh_15.normals.length, isZero);
      expect(mesh_15.tangents.length, isZero);
      expect(mesh_15.bitangents.length, isZero);
      expect(mesh_15.colors.length, isZero);
      expect(mesh_15.textureCoords.length, isZero);
      expect(mesh_15.uvComponents.length, isZero);
      expect(mesh_15.uvComponents, equals([]));
      expect(mesh_15.faces.length, equals(42));
      expect(mesh_15.bones.length, isZero);
      expect(mesh_15.materialIndex, equals(2));
      expect(mesh_15.name, equals('Zahn2'));
      expect(mesh_15.animMeshes.length, isZero);
      expect(mesh_15.morphingMethod, isZero);
      expect(mesh_15.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_16 = meshes.elementAt(16);
      expect(mesh_16.primitiveTypes, equals(4));
      expect(mesh_16.vertices.length, equals(44));
      final vertex_16_0 = mesh_16.vertices.elementAt(0);
      expect(vertex_16_0, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_1 = mesh_16.vertices.elementAt(1);
      expect(vertex_16_1, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_2 = mesh_16.vertices.elementAt(2);
      expect(vertex_16_2, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_3 = mesh_16.vertices.elementAt(3);
      expect(vertex_16_3, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_4 = mesh_16.vertices.elementAt(4);
      expect(vertex_16_4, vector3MoreOrLessEquals(Vector3(-56.0517, 7.21101, -23.6689)));
      final vertex_16_5 = mesh_16.vertices.elementAt(5);
      expect(vertex_16_5, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_6 = mesh_16.vertices.elementAt(6);
      expect(vertex_16_6, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_7 = mesh_16.vertices.elementAt(7);
      expect(vertex_16_7, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_8 = mesh_16.vertices.elementAt(8);
      expect(vertex_16_8, vector3MoreOrLessEquals(Vector3(-59.6895, 8.1995, -20.5285)));
      final vertex_16_9 = mesh_16.vertices.elementAt(9);
      expect(vertex_16_9, vector3MoreOrLessEquals(Vector3(-58.2127, 12.1413, -15.6345)));
      final vertex_16_10 = mesh_16.vertices.elementAt(10);
      expect(vertex_16_10, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6723, -17.902)));
      final vertex_16_11 = mesh_16.vertices.elementAt(11);
      expect(vertex_16_11, vector3MoreOrLessEquals(Vector3(-55.5099, 10.3343, -15.6905)));
      final vertex_16_12 = mesh_16.vertices.elementAt(12);
      expect(vertex_16_12, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2878, -17.4118)));
      final vertex_16_13 = mesh_16.vertices.elementAt(13);
      expect(vertex_16_13, vector3MoreOrLessEquals(Vector3(-51.7578, 12.0369, -19.5022)));
      final vertex_16_14 = mesh_16.vertices.elementAt(14);
      expect(vertex_16_14, vector3MoreOrLessEquals(Vector3(-53.534, 14.2646, -20.3877)));
      final vertex_16_15 = mesh_16.vertices.elementAt(15);
      expect(vertex_16_15, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2932, -19.4013)));
      final vertex_16_16 = mesh_16.vertices.elementAt(16);
      expect(vertex_16_16, vector3MoreOrLessEquals(Vector3(-58.7103, 14.3483, -17.286)));
      final vertex_16_17 = mesh_16.vertices.elementAt(17);
      expect(vertex_16_17, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_18 = mesh_16.vertices.elementAt(18);
      expect(vertex_16_18, vector3MoreOrLessEquals(Vector3(-59.6895, 8.1995, -20.5285)));
      final vertex_16_19 = mesh_16.vertices.elementAt(19);
      expect(vertex_16_19, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_20 = mesh_16.vertices.elementAt(20);
      expect(vertex_16_20, vector3MoreOrLessEquals(Vector3(-58.2127, 12.1413, -15.6345)));
      final vertex_16_21 = mesh_16.vertices.elementAt(21);
      expect(vertex_16_21, vector3MoreOrLessEquals(Vector3(-55.5099, 10.3343, -15.6905)));
      final vertex_16_22 = mesh_16.vertices.elementAt(22);
      expect(vertex_16_22, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_23 = mesh_16.vertices.elementAt(23);
      expect(vertex_16_23, vector3MoreOrLessEquals(Vector3(-60.2821, 9.65074, -21.8051)));
      final vertex_16_24 = mesh_16.vertices.elementAt(24);
      expect(vertex_16_24, vector3MoreOrLessEquals(Vector3(-58.7103, 14.3483, -17.286)));
      final vertex_16_25 = mesh_16.vertices.elementAt(25);
      expect(vertex_16_25, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_26 = mesh_16.vertices.elementAt(26);
      expect(vertex_16_26, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_27 = mesh_16.vertices.elementAt(27);
      expect(vertex_16_27, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2932, -19.4013)));
      final vertex_16_28 = mesh_16.vertices.elementAt(28);
      expect(vertex_16_28, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_29 = mesh_16.vertices.elementAt(29);
      expect(vertex_16_29, vector3MoreOrLessEquals(Vector3(-57.3648, 8.85803, -24.3236)));
      final vertex_16_30 = mesh_16.vertices.elementAt(30);
      expect(vertex_16_30, vector3MoreOrLessEquals(Vector3(-53.534, 14.2646, -20.3877)));
      final vertex_16_31 = mesh_16.vertices.elementAt(31);
      expect(vertex_16_31, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_32 = mesh_16.vertices.elementAt(32);
      expect(vertex_16_32, vector3MoreOrLessEquals(Vector3(-56.2969, 6.24298, -22.0232)));
      final vertex_16_33 = mesh_16.vertices.elementAt(33);
      expect(vertex_16_33, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_34 = mesh_16.vertices.elementAt(34);
      expect(vertex_16_34, vector3MoreOrLessEquals(Vector3(-55.5099, 10.3343, -15.6905)));
      final vertex_16_35 = mesh_16.vertices.elementAt(35);
      expect(vertex_16_35, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2878, -17.4118)));
      final vertex_16_36 = mesh_16.vertices.elementAt(36);
      expect(vertex_16_36, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_37 = mesh_16.vertices.elementAt(37);
      expect(vertex_16_37, vector3MoreOrLessEquals(Vector3(-56.2969, 6.24298, -22.0232)));
      final vertex_16_38 = mesh_16.vertices.elementAt(38);
      expect(vertex_16_38, vector3MoreOrLessEquals(Vector3(-56.0517, 7.21101, -23.6689)));
      final vertex_16_39 = mesh_16.vertices.elementAt(39);
      expect(vertex_16_39, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2878, -17.4118)));
      final vertex_16_40 = mesh_16.vertices.elementAt(40);
      expect(vertex_16_40, vector3MoreOrLessEquals(Vector3(-51.7578, 12.0369, -19.5022)));
      final vertex_16_41 = mesh_16.vertices.elementAt(41);
      expect(vertex_16_41, vector3MoreOrLessEquals(Vector3(-57.3648, 8.85803, -24.3236)));
      final vertex_16_42 = mesh_16.vertices.elementAt(42);
      expect(vertex_16_42, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_43 = mesh_16.vertices.elementAt(43);
      expect(vertex_16_43, vector3MoreOrLessEquals(Vector3(-53.534, 14.2646, -20.3877)));
      expect(mesh_16.normals.length, isZero);
      expect(mesh_16.tangents.length, isZero);
      expect(mesh_16.bitangents.length, isZero);
      expect(mesh_16.colors.length, isZero);
      expect(mesh_16.textureCoords.length, isZero);
      expect(mesh_16.uvComponents.length, isZero);
      expect(mesh_16.uvComponents, equals([]));
      expect(mesh_16.faces.length, equals(42));
      expect(mesh_16.bones.length, isZero);
      expect(mesh_16.materialIndex, equals(2));
      expect(mesh_16.name, equals('klZahn2'));
      expect(mesh_16.animMeshes.length, isZero);
      expect(mesh_16.morphingMethod, isZero);
      expect(mesh_16.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_17 = meshes.elementAt(17);
      expect(mesh_17.primitiveTypes, equals(4));
      expect(mesh_17.vertices.length, equals(36));
      final vertex_17_0 = mesh_17.vertices.elementAt(0);
      expect(vertex_17_0, vector3MoreOrLessEquals(Vector3(-59.467, 18.4067, -2.53898)));
      final vertex_17_1 = mesh_17.vertices.elementAt(1);
      expect(vertex_17_1, vector3MoreOrLessEquals(Vector3(-58.7436, 17.5185, -2.2717)));
      final vertex_17_2 = mesh_17.vertices.elementAt(2);
      expect(vertex_17_2, vector3MoreOrLessEquals(Vector3(-59.6705, 17.6709, -1.85303)));
      final vertex_17_3 = mesh_17.vertices.elementAt(3);
      expect(vertex_17_3, vector3MoreOrLessEquals(Vector3(-59.467, 16.6662, -1.90547)));
      final vertex_17_4 = mesh_17.vertices.elementAt(4);
      expect(vertex_17_4, vector3MoreOrLessEquals(Vector3(-59.6705, 17.6709, -1.85303)));
      final vertex_17_5 = mesh_17.vertices.elementAt(5);
      expect(vertex_17_5, vector3MoreOrLessEquals(Vector3(-60.6376, 18.1035, -2.33792)));
      final vertex_17_6 = mesh_17.vertices.elementAt(6);
      expect(vertex_17_6, vector3MoreOrLessEquals(Vector3(-59.467, 18.4067, -2.53898)));
      final vertex_17_7 = mesh_17.vertices.elementAt(7);
      expect(vertex_17_7, vector3MoreOrLessEquals(Vector3(-59.6705, 17.6709, -1.85303)));
      final vertex_17_8 = mesh_17.vertices.elementAt(8);
      expect(vertex_17_8, vector3MoreOrLessEquals(Vector3(-60.6376, 17.0278, -1.9464)));
      final vertex_17_9 = mesh_17.vertices.elementAt(9);
      expect(vertex_17_9, vector3MoreOrLessEquals(Vector3(-60.5752, 18.6909, -3.43184)));
      final vertex_17_10 = mesh_17.vertices.elementAt(10);
      expect(vertex_17_10, vector3MoreOrLessEquals(Vector3(-61.5559, 18.1542, -3.37207)));
      final vertex_17_11 = mesh_17.vertices.elementAt(11);
      expect(vertex_17_11, vector3MoreOrLessEquals(Vector3(-61.7458, 17.3119, -2.83926)));
      final vertex_17_12 = mesh_17.vertices.elementAt(12);
      expect(vertex_17_12, vector3MoreOrLessEquals(Vector3(-61.6449, 18.2623, -4.60926)));
      final vertex_17_13 = mesh_17.vertices.elementAt(13);
      expect(vertex_17_13, vector3MoreOrLessEquals(Vector3(-62.3683, 17.4101, -4.24303)));
      final vertex_17_14 = mesh_17.vertices.elementAt(14);
      expect(vertex_17_14, vector3MoreOrLessEquals(Vector3(-60.6376, 17.0278, -1.9464)));
      final vertex_17_15 = mesh_17.vertices.elementAt(15);
      expect(vertex_17_15, vector3MoreOrLessEquals(Vector3(-61.5559, 16.3241, -2.70597)));
      final vertex_17_16 = mesh_17.vertices.elementAt(16);
      expect(vertex_17_16, vector3MoreOrLessEquals(Vector3(-62.3683, 16.3344, -3.85151)));
      final vertex_17_17 = mesh_17.vertices.elementAt(17);
      expect(vertex_17_17, vector3MoreOrLessEquals(Vector3(-62.615, 16.4912, -5.0942)));
      final vertex_17_18 = mesh_17.vertices.elementAt(18);
      expect(vertex_17_18, vector3MoreOrLessEquals(Vector3(-62.2674, 17.2848, -5.62151)));
      final vertex_17_19 = mesh_17.vertices.elementAt(19);
      expect(vertex_17_19, vector3MoreOrLessEquals(Vector3(-61.3842, 17.9411, -5.71727)));
      final vertex_17_20 = mesh_17.vertices.elementAt(20);
      expect(vertex_17_20, vector3MoreOrLessEquals(Vector3(-61.4815, 16.9839, -6.44816)));
      final vertex_17_21 = mesh_17.vertices.elementAt(21);
      expect(vertex_17_21, vector3MoreOrLessEquals(Vector3(-62.205, 16.1317, -6.08192)));
      final vertex_17_22 = mesh_17.vertices.elementAt(22);
      expect(vertex_17_22, vector3MoreOrLessEquals(Vector3(-62.2674, 15.5443, -4.98801)));
      final vertex_17_23 = mesh_17.vertices.elementAt(23);
      expect(vertex_17_23, vector3MoreOrLessEquals(Vector3(-61.6449, 15.4461, -3.58423)));
      final vertex_17_24 = mesh_17.vertices.elementAt(24);
      expect(vertex_17_24, vector3MoreOrLessEquals(Vector3(-61.4815, 15.2434, -5.81466)));
      final vertex_17_25 = mesh_17.vertices.elementAt(25);
      expect(vertex_17_25, vector3MoreOrLessEquals(Vector3(-61.3842, 14.9799, -4.6395)));
      final vertex_17_26 = mesh_17.vertices.elementAt(26);
      expect(vertex_17_26, vector3MoreOrLessEquals(Vector3(-61.2781, 15.9793, -6.50059)));
      final vertex_17_27 = mesh_17.vertices.elementAt(27);
      expect(vertex_17_27, vector3MoreOrLessEquals(Vector3(-60.4743, 15.0845, -3.54331)));
      final vertex_17_28 = mesh_17.vertices.elementAt(28);
      expect(vertex_17_28, vector3MoreOrLessEquals(Vector3(-61.3842, 14.9799, -4.6395)));
      final vertex_17_29 = mesh_17.vertices.elementAt(29);
      expect(vertex_17_29, vector3MoreOrLessEquals(Vector3(-60.5752, 15.8746, -2.40682)));
      final vertex_17_30 = mesh_17.vertices.elementAt(30);
      expect(vertex_17_30, vector3MoreOrLessEquals(Vector3(-59.5644, 15.709, -2.63635)));
      final vertex_17_31 = mesh_17.vertices.elementAt(31);
      expect(vertex_17_31, vector3MoreOrLessEquals(Vector3(-59.467, 16.6662, -1.90547)));
      final vertex_17_32 = mesh_17.vertices.elementAt(32);
      expect(vertex_17_32, vector3MoreOrLessEquals(Vector3(-59.6705, 17.6709, -1.85303)));
      final vertex_17_33 = mesh_17.vertices.elementAt(33);
      expect(vertex_17_33, vector3MoreOrLessEquals(Vector3(-60.5752, 15.8746, -2.40682)));
      final vertex_17_34 = mesh_17.vertices.elementAt(34);
      expect(vertex_17_34, vector3MoreOrLessEquals(Vector3(-59.467, 16.6662, -1.90547)));
      final vertex_17_35 = mesh_17.vertices.elementAt(35);
      expect(vertex_17_35, vector3MoreOrLessEquals(Vector3(-59.5644, 15.709, -2.63635)));
      expect(mesh_17.normals.length, isZero);
      expect(mesh_17.tangents.length, isZero);
      expect(mesh_17.bitangents.length, isZero);
      expect(mesh_17.colors.length, isZero);
      expect(mesh_17.textureCoords.length, isZero);
      expect(mesh_17.uvComponents.length, isZero);
      expect(mesh_17.uvComponents, equals([]));
      expect(mesh_17.faces.length, equals(38));
      expect(mesh_17.bones.length, isZero);
      expect(mesh_17.materialIndex, equals(3));
      expect(mesh_17.name, equals('Auge'));
      expect(mesh_17.animMeshes.length, isZero);
      expect(mesh_17.morphingMethod, isZero);
      expect(mesh_17.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_18 = meshes.elementAt(18);
      expect(mesh_18.primitiveTypes, equals(4));
      expect(mesh_18.vertices.length, equals(36));
      final vertex_18_0 = mesh_18.vertices.elementAt(0);
      expect(vertex_18_0, vector3MoreOrLessEquals(Vector3(-59.6705, 17.4042, -17.8803)));
      final vertex_18_1 = mesh_18.vertices.elementAt(1);
      expect(vertex_18_1, vector3MoreOrLessEquals(Vector3(-58.7436, 17.2518, -17.4616)));
      final vertex_18_2 = mesh_18.vertices.elementAt(2);
      expect(vertex_18_2, vector3MoreOrLessEquals(Vector3(-59.467, 18.1401, -17.1944)));
      final vertex_18_3 = mesh_18.vertices.elementAt(3);
      expect(vertex_18_3, vector3MoreOrLessEquals(Vector3(-59.6705, 17.4042, -17.8803)));
      final vertex_18_4 = mesh_18.vertices.elementAt(4);
      expect(vertex_18_4, vector3MoreOrLessEquals(Vector3(-59.467, 16.3996, -17.8279)));
      final vertex_18_5 = mesh_18.vertices.elementAt(5);
      expect(vertex_18_5, vector3MoreOrLessEquals(Vector3(-59.6705, 17.4042, -17.8803)));
      final vertex_18_6 = mesh_18.vertices.elementAt(6);
      expect(vertex_18_6, vector3MoreOrLessEquals(Vector3(-59.467, 18.1401, -17.1944)));
      final vertex_18_7 = mesh_18.vertices.elementAt(7);
      expect(vertex_18_7, vector3MoreOrLessEquals(Vector3(-60.6376, 17.8368, -17.3954)));
      final vertex_18_8 = mesh_18.vertices.elementAt(8);
      expect(vertex_18_8, vector3MoreOrLessEquals(Vector3(-61.5559, 17.8876, -16.3613)));
      final vertex_18_9 = mesh_18.vertices.elementAt(9);
      expect(vertex_18_9, vector3MoreOrLessEquals(Vector3(-60.5752, 18.4242, -16.3015)));
      final vertex_18_10 = mesh_18.vertices.elementAt(10);
      expect(vertex_18_10, vector3MoreOrLessEquals(Vector3(-61.7458, 17.0452, -16.8941)));
      final vertex_18_11 = mesh_18.vertices.elementAt(11);
      expect(vertex_18_11, vector3MoreOrLessEquals(Vector3(-60.6376, 16.7611, -17.7869)));
      final vertex_18_12 = mesh_18.vertices.elementAt(12);
      expect(vertex_18_12, vector3MoreOrLessEquals(Vector3(-61.6449, 17.9957, -15.1241)));
      final vertex_18_13 = mesh_18.vertices.elementAt(13);
      expect(vertex_18_13, vector3MoreOrLessEquals(Vector3(-62.3683, 17.1434, -15.4903)));
      final vertex_18_14 = mesh_18.vertices.elementAt(14);
      expect(vertex_18_14, vector3MoreOrLessEquals(Vector3(-61.5559, 16.0575, -17.0274)));
      final vertex_18_15 = mesh_18.vertices.elementAt(15);
      expect(vertex_18_15, vector3MoreOrLessEquals(Vector3(-60.6376, 16.7611, -17.7869)));
      final vertex_18_16 = mesh_18.vertices.elementAt(16);
      expect(vertex_18_16, vector3MoreOrLessEquals(Vector3(-62.3683, 16.0677, -15.8818)));
      final vertex_18_17 = mesh_18.vertices.elementAt(17);
      expect(vertex_18_17, vector3MoreOrLessEquals(Vector3(-62.615, 16.2245, -14.6391)));
      final vertex_18_18 = mesh_18.vertices.elementAt(18);
      expect(vertex_18_18, vector3MoreOrLessEquals(Vector3(-62.2674, 17.0181, -14.1118)));
      final vertex_18_19 = mesh_18.vertices.elementAt(19);
      expect(vertex_18_19, vector3MoreOrLessEquals(Vector3(-61.3842, 17.6744, -14.0161)));
      final vertex_18_20 = mesh_18.vertices.elementAt(20);
      expect(vertex_18_20, vector3MoreOrLessEquals(Vector3(-61.4815, 16.7173, -13.2852)));
      final vertex_18_21 = mesh_18.vertices.elementAt(21);
      expect(vertex_18_21, vector3MoreOrLessEquals(Vector3(-62.205, 15.865, -13.6514)));
      final vertex_18_22 = mesh_18.vertices.elementAt(22);
      expect(vertex_18_22, vector3MoreOrLessEquals(Vector3(-62.2674, 15.2776, -14.7453)));
      final vertex_18_23 = mesh_18.vertices.elementAt(23);
      expect(vertex_18_23, vector3MoreOrLessEquals(Vector3(-61.6449, 15.1794, -16.1491)));
      final vertex_18_24 = mesh_18.vertices.elementAt(24);
      expect(vertex_18_24, vector3MoreOrLessEquals(Vector3(-61.3842, 14.7133, -15.0938)));
      final vertex_18_25 = mesh_18.vertices.elementAt(25);
      expect(vertex_18_25, vector3MoreOrLessEquals(Vector3(-61.4815, 14.9767, -13.9187)));
      final vertex_18_26 = mesh_18.vertices.elementAt(26);
      expect(vertex_18_26, vector3MoreOrLessEquals(Vector3(-61.2781, 15.7126, -13.2327)));
      final vertex_18_27 = mesh_18.vertices.elementAt(27);
      expect(vertex_18_27, vector3MoreOrLessEquals(Vector3(-61.3842, 14.7133, -15.0938)));
      final vertex_18_28 = mesh_18.vertices.elementAt(28);
      expect(vertex_18_28, vector3MoreOrLessEquals(Vector3(-60.4743, 14.8179, -16.19)));
      final vertex_18_29 = mesh_18.vertices.elementAt(29);
      expect(vertex_18_29, vector3MoreOrLessEquals(Vector3(-60.5752, 15.608, -17.3265)));
      final vertex_18_30 = mesh_18.vertices.elementAt(30);
      expect(vertex_18_30, vector3MoreOrLessEquals(Vector3(-59.5644, 15.4424, -17.097)));
      final vertex_18_31 = mesh_18.vertices.elementAt(31);
      expect(vertex_18_31, vector3MoreOrLessEquals(Vector3(-59.467, 16.3996, -17.8279)));
      final vertex_18_32 = mesh_18.vertices.elementAt(32);
      expect(vertex_18_32, vector3MoreOrLessEquals(Vector3(-59.6705, 17.4042, -17.8803)));
      final vertex_18_33 = mesh_18.vertices.elementAt(33);
      expect(vertex_18_33, vector3MoreOrLessEquals(Vector3(-59.5644, 15.4424, -17.097)));
      final vertex_18_34 = mesh_18.vertices.elementAt(34);
      expect(vertex_18_34, vector3MoreOrLessEquals(Vector3(-59.467, 16.3996, -17.8279)));
      final vertex_18_35 = mesh_18.vertices.elementAt(35);
      expect(vertex_18_35, vector3MoreOrLessEquals(Vector3(-60.5752, 15.608, -17.3265)));
      expect(mesh_18.normals.length, isZero);
      expect(mesh_18.tangents.length, isZero);
      expect(mesh_18.bitangents.length, isZero);
      expect(mesh_18.colors.length, isZero);
      expect(mesh_18.textureCoords.length, isZero);
      expect(mesh_18.uvComponents.length, isZero);
      expect(mesh_18.uvComponents, equals([]));
      expect(mesh_18.faces.length, equals(38));
      expect(mesh_18.bones.length, isZero);
      expect(mesh_18.materialIndex, equals(3));
      expect(mesh_18.name, equals('Duplicate05'));
      expect(mesh_18.animMeshes.length, isZero);
      expect(mesh_18.morphingMethod, isZero);
      expect(mesh_18.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));
    });
  });

  test('fbx', () {
    testScene('fbx/huesitos.fbx', (scene) {
      final meshes = scene.meshes;
      expect(meshes, isNotEmpty);
      expect(meshes.length, equals(1));
      final mesh_0 = meshes.elementAt(0);
      expect(mesh_0.primitiveTypes, equals(12));
      expect(mesh_0.vertices.length, equals(256));
      final vertex_0_0 = mesh_0.vertices.elementAt(0);
      expect(vertex_0_0, vector3MoreOrLessEquals(Vector3(0, 0, -1.25619)));
      final vertex_0_1 = mesh_0.vertices.elementAt(1);
      expect(vertex_0_1, vector3MoreOrLessEquals(Vector3(0.707107, 0.707107, -1.25619)));
      final vertex_0_2 = mesh_0.vertices.elementAt(2);
      expect(vertex_0_2, vector3MoreOrLessEquals(Vector3(1, -4.37114e-08, -1.25619)));
      final vertex_0_3 = mesh_0.vertices.elementAt(3);
      expect(vertex_0_3, vector3MoreOrLessEquals(Vector3(0, 0, -1.25619)));
      final vertex_0_4 = mesh_0.vertices.elementAt(4);
      expect(vertex_0_4, vector3MoreOrLessEquals(Vector3(1, -4.37114e-08, -1.25619)));
      final vertex_0_5 = mesh_0.vertices.elementAt(5);
      expect(vertex_0_5, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, -1.25619)));
      final vertex_0_6 = mesh_0.vertices.elementAt(6);
      expect(vertex_0_6, vector3MoreOrLessEquals(Vector3(0, 0, -1.25619)));
      final vertex_0_7 = mesh_0.vertices.elementAt(7);
      expect(vertex_0_7, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, -1.25619)));
      final vertex_0_8 = mesh_0.vertices.elementAt(8);
      expect(vertex_0_8, vector3MoreOrLessEquals(Vector3(-8.74228e-08, -1, -1.25619)));
      final vertex_0_9 = mesh_0.vertices.elementAt(9);
      expect(vertex_0_9, vector3MoreOrLessEquals(Vector3(0, 0, -1.25619)));
      final vertex_0_10 = mesh_0.vertices.elementAt(10);
      expect(vertex_0_10, vector3MoreOrLessEquals(Vector3(-8.74228e-08, -1, -1.25619)));
      final vertex_0_11 = mesh_0.vertices.elementAt(11);
      expect(vertex_0_11, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, -1.25619)));
      final vertex_0_12 = mesh_0.vertices.elementAt(12);
      expect(vertex_0_12, vector3MoreOrLessEquals(Vector3(0, 0, -1.25619)));
      final vertex_0_13 = mesh_0.vertices.elementAt(13);
      expect(vertex_0_13, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, -1.25619)));
      final vertex_0_14 = mesh_0.vertices.elementAt(14);
      expect(vertex_0_14, vector3MoreOrLessEquals(Vector3(-1, 1.19249e-08, -1.25619)));
      final vertex_0_15 = mesh_0.vertices.elementAt(15);
      expect(vertex_0_15, vector3MoreOrLessEquals(Vector3(0, 0, -1.25619)));
      final vertex_0_16 = mesh_0.vertices.elementAt(16);
      expect(vertex_0_16, vector3MoreOrLessEquals(Vector3(-1, 1.19249e-08, -1.25619)));
      final vertex_0_17 = mesh_0.vertices.elementAt(17);
      expect(vertex_0_17, vector3MoreOrLessEquals(Vector3(-0.707107, 0.707107, -1.25619)));
      final vertex_0_18 = mesh_0.vertices.elementAt(18);
      expect(vertex_0_18, vector3MoreOrLessEquals(Vector3(0, 0, -1.25619)));
      final vertex_0_19 = mesh_0.vertices.elementAt(19);
      expect(vertex_0_19, vector3MoreOrLessEquals(Vector3(-0.707107, 0.707107, -1.25619)));
      final vertex_0_20 = mesh_0.vertices.elementAt(20);
      expect(vertex_0_20, vector3MoreOrLessEquals(Vector3(-3.01992e-07, 1, -1.25619)));
      final vertex_0_21 = mesh_0.vertices.elementAt(21);
      expect(vertex_0_21, vector3MoreOrLessEquals(Vector3(-3.01992e-07, 1, -1.25619)));
      final vertex_0_22 = mesh_0.vertices.elementAt(22);
      expect(vertex_0_22, vector3MoreOrLessEquals(Vector3(0.707107, 0.707107, -1.25619)));
      final vertex_0_23 = mesh_0.vertices.elementAt(23);
      expect(vertex_0_23, vector3MoreOrLessEquals(Vector3(0, 0, -1.25619)));
      final vertex_0_24 = mesh_0.vertices.elementAt(24);
      expect(vertex_0_24, vector3MoreOrLessEquals(Vector3(0.707107, 0.707107, -1.25619)));
      final vertex_0_25 = mesh_0.vertices.elementAt(25);
      expect(vertex_0_25, vector3MoreOrLessEquals(Vector3(0.458787, 0.458787, -0.580846)));
      final vertex_0_26 = mesh_0.vertices.elementAt(26);
      expect(vertex_0_26, vector3MoreOrLessEquals(Vector3(0.648822, 5.20127e-07, -0.580846)));
      final vertex_0_27 = mesh_0.vertices.elementAt(27);
      expect(vertex_0_27, vector3MoreOrLessEquals(Vector3(1, -4.37114e-08, -1.25619)));
      final vertex_0_28 = mesh_0.vertices.elementAt(28);
      expect(vertex_0_28, vector3MoreOrLessEquals(Vector3(1, -4.37114e-08, -1.25619)));
      final vertex_0_29 = mesh_0.vertices.elementAt(29);
      expect(vertex_0_29, vector3MoreOrLessEquals(Vector3(0.648822, 5.20127e-07, -0.580846)));
      final vertex_0_30 = mesh_0.vertices.elementAt(30);
      expect(vertex_0_30, vector3MoreOrLessEquals(Vector3(0.458787, -0.458786, -0.580846)));
      final vertex_0_31 = mesh_0.vertices.elementAt(31);
      expect(vertex_0_31, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, -1.25619)));
      final vertex_0_32 = mesh_0.vertices.elementAt(32);
      expect(vertex_0_32, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, -1.25619)));
      final vertex_0_33 = mesh_0.vertices.elementAt(33);
      expect(vertex_0_33, vector3MoreOrLessEquals(Vector3(0.458787, -0.458786, -0.580846)));
      final vertex_0_34 = mesh_0.vertices.elementAt(34);
      expect(vertex_0_34, vector3MoreOrLessEquals(Vector3(5.15845e-08, -0.648822, -0.580846)));
      final vertex_0_35 = mesh_0.vertices.elementAt(35);
      expect(vertex_0_35, vector3MoreOrLessEquals(Vector3(-8.74228e-08, -1, -1.25619)));
      final vertex_0_36 = mesh_0.vertices.elementAt(36);
      expect(vertex_0_36, vector3MoreOrLessEquals(Vector3(-8.74228e-08, -1, -1.25619)));
      final vertex_0_37 = mesh_0.vertices.elementAt(37);
      expect(vertex_0_37, vector3MoreOrLessEquals(Vector3(5.15845e-08, -0.648822, -0.580846)));
      final vertex_0_38 = mesh_0.vertices.elementAt(38);
      expect(vertex_0_38, vector3MoreOrLessEquals(Vector3(-0.458787, -0.458786, -0.580846)));
      final vertex_0_39 = mesh_0.vertices.elementAt(39);
      expect(vertex_0_39, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, -1.25619)));
      final vertex_0_40 = mesh_0.vertices.elementAt(40);
      expect(vertex_0_40, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, -1.25619)));
      final vertex_0_41 = mesh_0.vertices.elementAt(41);
      expect(vertex_0_41, vector3MoreOrLessEquals(Vector3(-0.458787, -0.458786, -0.580846)));
      final vertex_0_42 = mesh_0.vertices.elementAt(42);
      expect(vertex_0_42, vector3MoreOrLessEquals(Vector3(-0.648822, 5.51076e-07, -0.580846)));
      final vertex_0_43 = mesh_0.vertices.elementAt(43);
      expect(vertex_0_43, vector3MoreOrLessEquals(Vector3(-1, 1.19249e-08, -1.25619)));
      final vertex_0_44 = mesh_0.vertices.elementAt(44);
      expect(vertex_0_44, vector3MoreOrLessEquals(Vector3(-1, 1.19249e-08, -1.25619)));
      final vertex_0_45 = mesh_0.vertices.elementAt(45);
      expect(vertex_0_45, vector3MoreOrLessEquals(Vector3(-0.648822, 5.51076e-07, -0.580846)));
      final vertex_0_46 = mesh_0.vertices.elementAt(46);
      expect(vertex_0_46, vector3MoreOrLessEquals(Vector3(-0.458786, 0.458787, -0.580846)));
      final vertex_0_47 = mesh_0.vertices.elementAt(47);
      expect(vertex_0_47, vector3MoreOrLessEquals(Vector3(-0.707107, 0.707107, -1.25619)));
      final vertex_0_48 = mesh_0.vertices.elementAt(48);
      expect(vertex_0_48, vector3MoreOrLessEquals(Vector3(-0.707107, 0.707107, -1.25619)));
      final vertex_0_49 = mesh_0.vertices.elementAt(49);
      expect(vertex_0_49, vector3MoreOrLessEquals(Vector3(-0.458786, 0.458787, -0.580846)));
      final vertex_0_50 = mesh_0.vertices.elementAt(50);
      expect(vertex_0_50, vector3MoreOrLessEquals(Vector3(9.12711e-07, 0.648822, -0.580846)));
      final vertex_0_51 = mesh_0.vertices.elementAt(51);
      expect(vertex_0_51, vector3MoreOrLessEquals(Vector3(-3.01992e-07, 1, -1.25619)));
      final vertex_0_52 = mesh_0.vertices.elementAt(52);
      expect(vertex_0_52, vector3MoreOrLessEquals(Vector3(0.458787, 0.458787, -0.580846)));
      final vertex_0_53 = mesh_0.vertices.elementAt(53);
      expect(vertex_0_53, vector3MoreOrLessEquals(Vector3(0.707107, 0.707107, -1.25619)));
      final vertex_0_54 = mesh_0.vertices.elementAt(54);
      expect(vertex_0_54, vector3MoreOrLessEquals(Vector3(-3.01992e-07, 1, -1.25619)));
      final vertex_0_55 = mesh_0.vertices.elementAt(55);
      expect(vertex_0_55, vector3MoreOrLessEquals(Vector3(9.12711e-07, 0.648822, -0.580846)));
      final vertex_0_56 = mesh_0.vertices.elementAt(56);
      expect(vertex_0_56, vector3MoreOrLessEquals(Vector3(0.458787, 0.458787, -0.580846)));
      final vertex_0_57 = mesh_0.vertices.elementAt(57);
      expect(vertex_0_57, vector3MoreOrLessEquals(Vector3(9.12711e-07, 0.648822, -0.580846)));
      final vertex_0_58 = mesh_0.vertices.elementAt(58);
      expect(vertex_0_58, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 0.323789)));
      final vertex_0_59 = mesh_0.vertices.elementAt(59);
      expect(vertex_0_59, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 0.323789)));
      final vertex_0_60 = mesh_0.vertices.elementAt(60);
      expect(vertex_0_60, vector3MoreOrLessEquals(Vector3(9.12711e-07, 0.648822, -0.580846)));
      final vertex_0_61 = mesh_0.vertices.elementAt(61);
      expect(vertex_0_61, vector3MoreOrLessEquals(Vector3(-0.458786, 0.458787, -0.580846)));
      final vertex_0_62 = mesh_0.vertices.elementAt(62);
      expect(vertex_0_62, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 0.323789)));
      final vertex_0_63 = mesh_0.vertices.elementAt(63);
      expect(vertex_0_63, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 0.323789)));
      final vertex_0_64 = mesh_0.vertices.elementAt(64);
      expect(vertex_0_64, vector3MoreOrLessEquals(Vector3(-0.458786, 0.458787, -0.580846)));
      final vertex_0_65 = mesh_0.vertices.elementAt(65);
      expect(vertex_0_65, vector3MoreOrLessEquals(Vector3(-0.648822, 5.51076e-07, -0.580846)));
      final vertex_0_66 = mesh_0.vertices.elementAt(66);
      expect(vertex_0_66, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 0.323789)));
      final vertex_0_67 = mesh_0.vertices.elementAt(67);
      expect(vertex_0_67, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 0.323789)));
      final vertex_0_68 = mesh_0.vertices.elementAt(68);
      expect(vertex_0_68, vector3MoreOrLessEquals(Vector3(-0.648822, 5.51076e-07, -0.580846)));
      final vertex_0_69 = mesh_0.vertices.elementAt(69);
      expect(vertex_0_69, vector3MoreOrLessEquals(Vector3(-0.458787, -0.458786, -0.580846)));
      final vertex_0_70 = mesh_0.vertices.elementAt(70);
      expect(vertex_0_70, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 0.323789)));
      final vertex_0_71 = mesh_0.vertices.elementAt(71);
      expect(vertex_0_71, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 0.323789)));
      final vertex_0_72 = mesh_0.vertices.elementAt(72);
      expect(vertex_0_72, vector3MoreOrLessEquals(Vector3(-0.458787, -0.458786, -0.580846)));
      final vertex_0_73 = mesh_0.vertices.elementAt(73);
      expect(vertex_0_73, vector3MoreOrLessEquals(Vector3(5.15845e-08, -0.648822, -0.580846)));
      final vertex_0_74 = mesh_0.vertices.elementAt(74);
      expect(vertex_0_74, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 0.323789)));
      final vertex_0_75 = mesh_0.vertices.elementAt(75);
      expect(vertex_0_75, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 0.323789)));
      final vertex_0_76 = mesh_0.vertices.elementAt(76);
      expect(vertex_0_76, vector3MoreOrLessEquals(Vector3(5.15845e-08, -0.648822, -0.580846)));
      final vertex_0_77 = mesh_0.vertices.elementAt(77);
      expect(vertex_0_77, vector3MoreOrLessEquals(Vector3(0.458787, -0.458786, -0.580846)));
      final vertex_0_78 = mesh_0.vertices.elementAt(78);
      expect(vertex_0_78, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 0.323789)));
      final vertex_0_79 = mesh_0.vertices.elementAt(79);
      expect(vertex_0_79, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 0.323789)));
      final vertex_0_80 = mesh_0.vertices.elementAt(80);
      expect(vertex_0_80, vector3MoreOrLessEquals(Vector3(0.458787, -0.458786, -0.580846)));
      final vertex_0_81 = mesh_0.vertices.elementAt(81);
      expect(vertex_0_81, vector3MoreOrLessEquals(Vector3(0.648822, 5.20127e-07, -0.580846)));
      final vertex_0_82 = mesh_0.vertices.elementAt(82);
      expect(vertex_0_82, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 0.323789)));
      final vertex_0_83 = mesh_0.vertices.elementAt(83);
      expect(vertex_0_83, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 0.323789)));
      final vertex_0_84 = mesh_0.vertices.elementAt(84);
      expect(vertex_0_84, vector3MoreOrLessEquals(Vector3(0.648822, 5.20127e-07, -0.580846)));
      final vertex_0_85 = mesh_0.vertices.elementAt(85);
      expect(vertex_0_85, vector3MoreOrLessEquals(Vector3(0.458787, 0.458787, -0.580846)));
      final vertex_0_86 = mesh_0.vertices.elementAt(86);
      expect(vertex_0_86, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 0.323789)));
      final vertex_0_87 = mesh_0.vertices.elementAt(87);
      expect(vertex_0_87, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 0.323789)));
      final vertex_0_88 = mesh_0.vertices.elementAt(88);
      expect(vertex_0_88, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 0.323789)));
      final vertex_0_89 = mesh_0.vertices.elementAt(89);
      expect(vertex_0_89, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 0.323789)));
      final vertex_0_90 = mesh_0.vertices.elementAt(90);
      expect(vertex_0_90, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 1.40239)));
      final vertex_0_91 = mesh_0.vertices.elementAt(91);
      expect(vertex_0_91, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 1.40239)));
      final vertex_0_92 = mesh_0.vertices.elementAt(92);
      expect(vertex_0_92, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 0.323789)));
      final vertex_0_93 = mesh_0.vertices.elementAt(93);
      expect(vertex_0_93, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 0.323789)));
      final vertex_0_94 = mesh_0.vertices.elementAt(94);
      expect(vertex_0_94, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 1.40239)));
      final vertex_0_95 = mesh_0.vertices.elementAt(95);
      expect(vertex_0_95, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 1.40239)));
      final vertex_0_96 = mesh_0.vertices.elementAt(96);
      expect(vertex_0_96, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 0.323789)));
      final vertex_0_97 = mesh_0.vertices.elementAt(97);
      expect(vertex_0_97, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 0.323789)));
      final vertex_0_98 = mesh_0.vertices.elementAt(98);
      expect(vertex_0_98, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 1.40239)));
      final vertex_0_99 = mesh_0.vertices.elementAt(99);
      expect(vertex_0_99, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 1.40239)));
      final vertex_0_100 = mesh_0.vertices.elementAt(100);
      expect(vertex_0_100, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 0.323789)));
      final vertex_0_101 = mesh_0.vertices.elementAt(101);
      expect(vertex_0_101, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 0.323789)));
      final vertex_0_102 = mesh_0.vertices.elementAt(102);
      expect(vertex_0_102, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 1.40239)));
      final vertex_0_103 = mesh_0.vertices.elementAt(103);
      expect(vertex_0_103, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 1.40239)));
      final vertex_0_104 = mesh_0.vertices.elementAt(104);
      expect(vertex_0_104, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 0.323789)));
      final vertex_0_105 = mesh_0.vertices.elementAt(105);
      expect(vertex_0_105, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 0.323789)));
      final vertex_0_106 = mesh_0.vertices.elementAt(106);
      expect(vertex_0_106, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 1.40239)));
      final vertex_0_107 = mesh_0.vertices.elementAt(107);
      expect(vertex_0_107, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 1.40239)));
      final vertex_0_108 = mesh_0.vertices.elementAt(108);
      expect(vertex_0_108, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 0.323789)));
      final vertex_0_109 = mesh_0.vertices.elementAt(109);
      expect(vertex_0_109, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 0.323789)));
      final vertex_0_110 = mesh_0.vertices.elementAt(110);
      expect(vertex_0_110, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 1.40239)));
      final vertex_0_111 = mesh_0.vertices.elementAt(111);
      expect(vertex_0_111, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 1.40239)));
      final vertex_0_112 = mesh_0.vertices.elementAt(112);
      expect(vertex_0_112, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 0.323789)));
      final vertex_0_113 = mesh_0.vertices.elementAt(113);
      expect(vertex_0_113, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 0.323789)));
      final vertex_0_114 = mesh_0.vertices.elementAt(114);
      expect(vertex_0_114, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 1.40239)));
      final vertex_0_115 = mesh_0.vertices.elementAt(115);
      expect(vertex_0_115, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 1.40239)));
      final vertex_0_116 = mesh_0.vertices.elementAt(116);
      expect(vertex_0_116, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 1.40239)));
      final vertex_0_117 = mesh_0.vertices.elementAt(117);
      expect(vertex_0_117, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 1.40239)));
      final vertex_0_118 = mesh_0.vertices.elementAt(118);
      expect(vertex_0_118, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 2.55058)));
      final vertex_0_119 = mesh_0.vertices.elementAt(119);
      expect(vertex_0_119, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 2.55058)));
      final vertex_0_120 = mesh_0.vertices.elementAt(120);
      expect(vertex_0_120, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 1.40239)));
      final vertex_0_121 = mesh_0.vertices.elementAt(121);
      expect(vertex_0_121, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 1.40239)));
      final vertex_0_122 = mesh_0.vertices.elementAt(122);
      expect(vertex_0_122, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 2.55058)));
      final vertex_0_123 = mesh_0.vertices.elementAt(123);
      expect(vertex_0_123, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 2.55058)));
      final vertex_0_124 = mesh_0.vertices.elementAt(124);
      expect(vertex_0_124, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 1.40239)));
      final vertex_0_125 = mesh_0.vertices.elementAt(125);
      expect(vertex_0_125, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 1.40239)));
      final vertex_0_126 = mesh_0.vertices.elementAt(126);
      expect(vertex_0_126, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 2.55058)));
      final vertex_0_127 = mesh_0.vertices.elementAt(127);
      expect(vertex_0_127, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 2.55058)));
      final vertex_0_128 = mesh_0.vertices.elementAt(128);
      expect(vertex_0_128, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 1.40239)));
      final vertex_0_129 = mesh_0.vertices.elementAt(129);
      expect(vertex_0_129, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 1.40239)));
      final vertex_0_130 = mesh_0.vertices.elementAt(130);
      expect(vertex_0_130, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 2.55058)));
      final vertex_0_131 = mesh_0.vertices.elementAt(131);
      expect(vertex_0_131, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 2.55058)));
      final vertex_0_132 = mesh_0.vertices.elementAt(132);
      expect(vertex_0_132, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 1.40239)));
      final vertex_0_133 = mesh_0.vertices.elementAt(133);
      expect(vertex_0_133, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 1.40239)));
      final vertex_0_134 = mesh_0.vertices.elementAt(134);
      expect(vertex_0_134, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 2.55058)));
      final vertex_0_135 = mesh_0.vertices.elementAt(135);
      expect(vertex_0_135, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 2.55058)));
      final vertex_0_136 = mesh_0.vertices.elementAt(136);
      expect(vertex_0_136, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 1.40239)));
      final vertex_0_137 = mesh_0.vertices.elementAt(137);
      expect(vertex_0_137, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 1.40239)));
      final vertex_0_138 = mesh_0.vertices.elementAt(138);
      expect(vertex_0_138, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 2.55058)));
      final vertex_0_139 = mesh_0.vertices.elementAt(139);
      expect(vertex_0_139, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 2.55058)));
      final vertex_0_140 = mesh_0.vertices.elementAt(140);
      expect(vertex_0_140, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 1.40239)));
      final vertex_0_141 = mesh_0.vertices.elementAt(141);
      expect(vertex_0_141, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 1.40239)));
      final vertex_0_142 = mesh_0.vertices.elementAt(142);
      expect(vertex_0_142, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 2.55058)));
      final vertex_0_143 = mesh_0.vertices.elementAt(143);
      expect(vertex_0_143, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 2.55058)));
      final vertex_0_144 = mesh_0.vertices.elementAt(144);
      expect(vertex_0_144, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 1.40239)));
      final vertex_0_145 = mesh_0.vertices.elementAt(145);
      expect(vertex_0_145, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 1.40239)));
      final vertex_0_146 = mesh_0.vertices.elementAt(146);
      expect(vertex_0_146, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 2.55058)));
      final vertex_0_147 = mesh_0.vertices.elementAt(147);
      expect(vertex_0_147, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 2.55058)));
      final vertex_0_148 = mesh_0.vertices.elementAt(148);
      expect(vertex_0_148, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 2.55058)));
      final vertex_0_149 = mesh_0.vertices.elementAt(149);
      expect(vertex_0_149, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 2.55058)));
      final vertex_0_150 = mesh_0.vertices.elementAt(150);
      expect(vertex_0_150, vector3MoreOrLessEquals(Vector3(0.723669, 0.72367, 3.75966)));
      final vertex_0_151 = mesh_0.vertices.elementAt(151);
      expect(vertex_0_151, vector3MoreOrLessEquals(Vector3(1.02342, 6.23803e-07, 3.75966)));
      final vertex_0_152 = mesh_0.vertices.elementAt(152);
      expect(vertex_0_152, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 2.55058)));
      final vertex_0_153 = mesh_0.vertices.elementAt(153);
      expect(vertex_0_153, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 2.55058)));
      final vertex_0_154 = mesh_0.vertices.elementAt(154);
      expect(vertex_0_154, vector3MoreOrLessEquals(Vector3(1.02342, 6.23803e-07, 3.75966)));
      final vertex_0_155 = mesh_0.vertices.elementAt(155);
      expect(vertex_0_155, vector3MoreOrLessEquals(Vector3(0.72367, -0.723669, 3.75966)));
      final vertex_0_156 = mesh_0.vertices.elementAt(156);
      expect(vertex_0_156, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 2.55058)));
      final vertex_0_157 = mesh_0.vertices.elementAt(157);
      expect(vertex_0_157, vector3MoreOrLessEquals(Vector3(0.707107, -0.707107, 2.55058)));
      final vertex_0_158 = mesh_0.vertices.elementAt(158);
      expect(vertex_0_158, vector3MoreOrLessEquals(Vector3(0.72367, -0.723669, 3.75966)));
      final vertex_0_159 = mesh_0.vertices.elementAt(159);
      expect(vertex_0_159, vector3MoreOrLessEquals(Vector3(-2.7286e-08, -1.02342, 3.75966)));
      final vertex_0_160 = mesh_0.vertices.elementAt(160);
      expect(vertex_0_160, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 2.55058)));
      final vertex_0_161 = mesh_0.vertices.elementAt(161);
      expect(vertex_0_161, vector3MoreOrLessEquals(Vector3(-2.38498e-08, -1, 2.55058)));
      final vertex_0_162 = mesh_0.vertices.elementAt(162);
      expect(vertex_0_162, vector3MoreOrLessEquals(Vector3(-2.7286e-08, -1.02342, 3.75966)));
      final vertex_0_163 = mesh_0.vertices.elementAt(163);
      expect(vertex_0_163, vector3MoreOrLessEquals(Vector3(-0.72367, -0.723669, 3.75966)));
      final vertex_0_164 = mesh_0.vertices.elementAt(164);
      expect(vertex_0_164, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 2.55058)));
      final vertex_0_165 = mesh_0.vertices.elementAt(165);
      expect(vertex_0_165, vector3MoreOrLessEquals(Vector3(-0.707107, -0.707107, 2.55058)));
      final vertex_0_166 = mesh_0.vertices.elementAt(166);
      expect(vertex_0_166, vector3MoreOrLessEquals(Vector3(-0.72367, -0.723669, 3.75966)));
      final vertex_0_167 = mesh_0.vertices.elementAt(167);
      expect(vertex_0_167, vector3MoreOrLessEquals(Vector3(-1.02342, 6.7262e-07, 3.75966)));
      final vertex_0_168 = mesh_0.vertices.elementAt(168);
      expect(vertex_0_168, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 2.55058)));
      final vertex_0_169 = mesh_0.vertices.elementAt(169);
      expect(vertex_0_169, vector3MoreOrLessEquals(Vector3(-1, 6.63608e-07, 2.55058)));
      final vertex_0_170 = mesh_0.vertices.elementAt(170);
      expect(vertex_0_170, vector3MoreOrLessEquals(Vector3(-1.02342, 6.7262e-07, 3.75966)));
      final vertex_0_171 = mesh_0.vertices.elementAt(171);
      expect(vertex_0_171, vector3MoreOrLessEquals(Vector3(-0.723669, 0.72367, 3.75966)));
      final vertex_0_172 = mesh_0.vertices.elementAt(172);
      expect(vertex_0_172, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 2.55058)));
      final vertex_0_173 = mesh_0.vertices.elementAt(173);
      expect(vertex_0_173, vector3MoreOrLessEquals(Vector3(-0.707106, 0.707107, 2.55058)));
      final vertex_0_174 = mesh_0.vertices.elementAt(174);
      expect(vertex_0_174, vector3MoreOrLessEquals(Vector3(-0.723669, 0.72367, 3.75966)));
      final vertex_0_175 = mesh_0.vertices.elementAt(175);
      expect(vertex_0_175, vector3MoreOrLessEquals(Vector3(1.33102e-06, 1.02342, 3.75966)));
      final vertex_0_176 = mesh_0.vertices.elementAt(176);
      expect(vertex_0_176, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 2.55058)));
      final vertex_0_177 = mesh_0.vertices.elementAt(177);
      expect(vertex_0_177, vector3MoreOrLessEquals(Vector3(1.30337e-06, 1, 2.55058)));
      final vertex_0_178 = mesh_0.vertices.elementAt(178);
      expect(vertex_0_178, vector3MoreOrLessEquals(Vector3(1.33102e-06, 1.02342, 3.75966)));
      final vertex_0_179 = mesh_0.vertices.elementAt(179);
      expect(vertex_0_179, vector3MoreOrLessEquals(Vector3(0.723669, 0.72367, 3.75966)));
      final vertex_0_180 = mesh_0.vertices.elementAt(180);
      expect(vertex_0_180, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 1.40239)));
      final vertex_0_181 = mesh_0.vertices.elementAt(181);
      expect(vertex_0_181, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 0.323789)));
      final vertex_0_182 = mesh_0.vertices.elementAt(182);
      expect(vertex_0_182, vector3MoreOrLessEquals(Vector3(2.11125, 0.460297, 0.323789)));
      final vertex_0_183 = mesh_0.vertices.elementAt(183);
      expect(vertex_0_183, vector3MoreOrLessEquals(Vector3(2.11125, 0.460297, 1.40239)));
      final vertex_0_184 = mesh_0.vertices.elementAt(184);
      expect(vertex_0_184, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 1.40239)));
      final vertex_0_185 = mesh_0.vertices.elementAt(185);
      expect(vertex_0_185, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 1.40239)));
      final vertex_0_186 = mesh_0.vertices.elementAt(186);
      expect(vertex_0_186, vector3MoreOrLessEquals(Vector3(2.11125, 0.460297, 1.40239)));
      final vertex_0_187 = mesh_0.vertices.elementAt(187);
      expect(vertex_0_187, vector3MoreOrLessEquals(Vector3(1.81836, 1.1674, 1.40239)));
      final vertex_0_188 = mesh_0.vertices.elementAt(188);
      expect(vertex_0_188, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 0.323789)));
      final vertex_0_189 = mesh_0.vertices.elementAt(189);
      expect(vertex_0_189, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 1.40239)));
      final vertex_0_190 = mesh_0.vertices.elementAt(190);
      expect(vertex_0_190, vector3MoreOrLessEquals(Vector3(1.81836, 1.1674, 1.40239)));
      final vertex_0_191 = mesh_0.vertices.elementAt(191);
      expect(vertex_0_191, vector3MoreOrLessEquals(Vector3(1.81836, 1.1674, 0.323789)));
      final vertex_0_192 = mesh_0.vertices.elementAt(192);
      expect(vertex_0_192, vector3MoreOrLessEquals(Vector3(1, 6.15908e-07, 0.323789)));
      final vertex_0_193 = mesh_0.vertices.elementAt(193);
      expect(vertex_0_193, vector3MoreOrLessEquals(Vector3(0.707106, 0.707107, 0.323789)));
      final vertex_0_194 = mesh_0.vertices.elementAt(194);
      expect(vertex_0_194, vector3MoreOrLessEquals(Vector3(1.81836, 1.1674, 0.323789)));
      final vertex_0_195 = mesh_0.vertices.elementAt(195);
      expect(vertex_0_195, vector3MoreOrLessEquals(Vector3(2.11125, 0.460297, 0.323789)));
      final vertex_0_196 = mesh_0.vertices.elementAt(196);
      expect(vertex_0_196, vector3MoreOrLessEquals(Vector3(2.11125, 0.460297, 0.323789)));
      final vertex_0_197 = mesh_0.vertices.elementAt(197);
      expect(vertex_0_197, vector3MoreOrLessEquals(Vector3(1.81836, 1.1674, 0.323789)));
      final vertex_0_198 = mesh_0.vertices.elementAt(198);
      expect(vertex_0_198, vector3MoreOrLessEquals(Vector3(3.17702, 1.86335, 0.443368)));
      final vertex_0_199 = mesh_0.vertices.elementAt(199);
      expect(vertex_0_199, vector3MoreOrLessEquals(Vector3(3.40497, 1.31303, 0.443368)));
      final vertex_0_200 = mesh_0.vertices.elementAt(200);
      expect(vertex_0_200, vector3MoreOrLessEquals(Vector3(1.81836, 1.1674, 0.323789)));
      final vertex_0_201 = mesh_0.vertices.elementAt(201);
      expect(vertex_0_201, vector3MoreOrLessEquals(Vector3(1.81836, 1.1674, 1.40239)));
      final vertex_0_202 = mesh_0.vertices.elementAt(202);
      expect(vertex_0_202, vector3MoreOrLessEquals(Vector3(3.17702, 1.86335, 1.28281)));
      final vertex_0_203 = mesh_0.vertices.elementAt(203);
      expect(vertex_0_203, vector3MoreOrLessEquals(Vector3(3.17702, 1.86335, 0.443368)));
      final vertex_0_204 = mesh_0.vertices.elementAt(204);
      expect(vertex_0_204, vector3MoreOrLessEquals(Vector3(1.81836, 1.1674, 1.40239)));
      final vertex_0_205 = mesh_0.vertices.elementAt(205);
      expect(vertex_0_205, vector3MoreOrLessEquals(Vector3(2.11125, 0.460297, 1.40239)));
      final vertex_0_206 = mesh_0.vertices.elementAt(206);
      expect(vertex_0_206, vector3MoreOrLessEquals(Vector3(3.40497, 1.31303, 1.28281)));
      final vertex_0_207 = mesh_0.vertices.elementAt(207);
      expect(vertex_0_207, vector3MoreOrLessEquals(Vector3(3.17702, 1.86335, 1.28281)));
      final vertex_0_208 = mesh_0.vertices.elementAt(208);
      expect(vertex_0_208, vector3MoreOrLessEquals(Vector3(2.11125, 0.460297, 1.40239)));
      final vertex_0_209 = mesh_0.vertices.elementAt(209);
      expect(vertex_0_209, vector3MoreOrLessEquals(Vector3(2.11125, 0.460297, 0.323789)));
      final vertex_0_210 = mesh_0.vertices.elementAt(210);
      expect(vertex_0_210, vector3MoreOrLessEquals(Vector3(3.40497, 1.31303, 0.443368)));
      final vertex_0_211 = mesh_0.vertices.elementAt(211);
      expect(vertex_0_211, vector3MoreOrLessEquals(Vector3(3.40497, 1.31303, 1.28281)));
      final vertex_0_212 = mesh_0.vertices.elementAt(212);
      expect(vertex_0_212, vector3MoreOrLessEquals(Vector3(3.40497, 1.31303, 1.28281)));
      final vertex_0_213 = mesh_0.vertices.elementAt(213);
      expect(vertex_0_213, vector3MoreOrLessEquals(Vector3(3.40497, 1.31303, 0.443368)));
      final vertex_0_214 = mesh_0.vertices.elementAt(214);
      expect(vertex_0_214, vector3MoreOrLessEquals(Vector3(4.3343, 1.77769, 0.547156)));
      final vertex_0_215 = mesh_0.vertices.elementAt(215);
      expect(vertex_0_215, vector3MoreOrLessEquals(Vector3(4.3343, 1.77769, 1.17902)));
      final vertex_0_216 = mesh_0.vertices.elementAt(216);
      expect(vertex_0_216, vector3MoreOrLessEquals(Vector3(3.17702, 1.86335, 1.28281)));
      final vertex_0_217 = mesh_0.vertices.elementAt(217);
      expect(vertex_0_217, vector3MoreOrLessEquals(Vector3(3.40497, 1.31303, 1.28281)));
      final vertex_0_218 = mesh_0.vertices.elementAt(218);
      expect(vertex_0_218, vector3MoreOrLessEquals(Vector3(4.3343, 1.77769, 1.17902)));
      final vertex_0_219 = mesh_0.vertices.elementAt(219);
      expect(vertex_0_219, vector3MoreOrLessEquals(Vector3(4.16272, 2.19193, 1.17902)));
      final vertex_0_220 = mesh_0.vertices.elementAt(220);
      expect(vertex_0_220, vector3MoreOrLessEquals(Vector3(3.17702, 1.86335, 0.443368)));
      final vertex_0_221 = mesh_0.vertices.elementAt(221);
      expect(vertex_0_221, vector3MoreOrLessEquals(Vector3(3.17702, 1.86335, 1.28281)));
      final vertex_0_222 = mesh_0.vertices.elementAt(222);
      expect(vertex_0_222, vector3MoreOrLessEquals(Vector3(4.16272, 2.19193, 1.17902)));
      final vertex_0_223 = mesh_0.vertices.elementAt(223);
      expect(vertex_0_223, vector3MoreOrLessEquals(Vector3(4.16272, 2.19193, 0.547156)));
      final vertex_0_224 = mesh_0.vertices.elementAt(224);
      expect(vertex_0_224, vector3MoreOrLessEquals(Vector3(3.40497, 1.31303, 0.443368)));
      final vertex_0_225 = mesh_0.vertices.elementAt(225);
      expect(vertex_0_225, vector3MoreOrLessEquals(Vector3(3.17702, 1.86335, 0.443368)));
      final vertex_0_226 = mesh_0.vertices.elementAt(226);
      expect(vertex_0_226, vector3MoreOrLessEquals(Vector3(4.16272, 2.19193, 0.547156)));
      final vertex_0_227 = mesh_0.vertices.elementAt(227);
      expect(vertex_0_227, vector3MoreOrLessEquals(Vector3(4.3343, 1.77769, 0.547156)));
      final vertex_0_228 = mesh_0.vertices.elementAt(228);
      expect(vertex_0_228, vector3MoreOrLessEquals(Vector3(4.3343, 1.77769, 0.547156)));
      final vertex_0_229 = mesh_0.vertices.elementAt(229);
      expect(vertex_0_229, vector3MoreOrLessEquals(Vector3(4.16272, 2.19193, 0.547156)));
      final vertex_0_230 = mesh_0.vertices.elementAt(230);
      expect(vertex_0_230, vector3MoreOrLessEquals(Vector3(4.16272, 2.19193, 1.17902)));
      final vertex_0_231 = mesh_0.vertices.elementAt(231);
      expect(vertex_0_231, vector3MoreOrLessEquals(Vector3(4.3343, 1.77769, 1.17902)));
      final vertex_0_232 = mesh_0.vertices.elementAt(232);
      expect(vertex_0_232, vector3MoreOrLessEquals(Vector3(1.02342, 6.23803e-07, 3.75966)));
      final vertex_0_233 = mesh_0.vertices.elementAt(233);
      expect(vertex_0_233, vector3MoreOrLessEquals(Vector3(0.723669, 0.72367, 3.75966)));
      final vertex_0_234 = mesh_0.vertices.elementAt(234);
      expect(vertex_0_234, vector3MoreOrLessEquals(Vector3(-1.09657e-05, -1.08266e-05, 4.18218)));
      final vertex_0_235 = mesh_0.vertices.elementAt(235);
      expect(vertex_0_235, vector3MoreOrLessEquals(Vector3(0.72367, -0.723669, 3.75966)));
      final vertex_0_236 = mesh_0.vertices.elementAt(236);
      expect(vertex_0_236, vector3MoreOrLessEquals(Vector3(1.02342, 6.23803e-07, 3.75966)));
      final vertex_0_237 = mesh_0.vertices.elementAt(237);
      expect(vertex_0_237, vector3MoreOrLessEquals(Vector3(-1.09657e-05, -1.08266e-05, 4.18218)));
      final vertex_0_238 = mesh_0.vertices.elementAt(238);
      expect(vertex_0_238, vector3MoreOrLessEquals(Vector3(-2.7286e-08, -1.02342, 3.75966)));
      final vertex_0_239 = mesh_0.vertices.elementAt(239);
      expect(vertex_0_239, vector3MoreOrLessEquals(Vector3(0.72367, -0.723669, 3.75966)));
      final vertex_0_240 = mesh_0.vertices.elementAt(240);
      expect(vertex_0_240, vector3MoreOrLessEquals(Vector3(-1.09657e-05, -1.08266e-05, 4.18218)));
      final vertex_0_241 = mesh_0.vertices.elementAt(241);
      expect(vertex_0_241, vector3MoreOrLessEquals(Vector3(-0.72367, -0.723669, 3.75966)));
      final vertex_0_242 = mesh_0.vertices.elementAt(242);
      expect(vertex_0_242, vector3MoreOrLessEquals(Vector3(-2.7286e-08, -1.02342, 3.75966)));
      final vertex_0_243 = mesh_0.vertices.elementAt(243);
      expect(vertex_0_243, vector3MoreOrLessEquals(Vector3(-1.09657e-05, -1.08266e-05, 4.18218)));
      final vertex_0_244 = mesh_0.vertices.elementAt(244);
      expect(vertex_0_244, vector3MoreOrLessEquals(Vector3(-1.02342, 6.7262e-07, 3.75966)));
      final vertex_0_245 = mesh_0.vertices.elementAt(245);
      expect(vertex_0_245, vector3MoreOrLessEquals(Vector3(-0.72367, -0.723669, 3.75966)));
      final vertex_0_246 = mesh_0.vertices.elementAt(246);
      expect(vertex_0_246, vector3MoreOrLessEquals(Vector3(-1.09657e-05, -1.08266e-05, 4.18218)));
      final vertex_0_247 = mesh_0.vertices.elementAt(247);
      expect(vertex_0_247, vector3MoreOrLessEquals(Vector3(-0.723669, 0.72367, 3.75966)));
      final vertex_0_248 = mesh_0.vertices.elementAt(248);
      expect(vertex_0_248, vector3MoreOrLessEquals(Vector3(-1.02342, 6.7262e-07, 3.75966)));
      final vertex_0_249 = mesh_0.vertices.elementAt(249);
      expect(vertex_0_249, vector3MoreOrLessEquals(Vector3(-1.09657e-05, -1.08266e-05, 4.18218)));
      final vertex_0_250 = mesh_0.vertices.elementAt(250);
      expect(vertex_0_250, vector3MoreOrLessEquals(Vector3(1.33102e-06, 1.02342, 3.75966)));
      final vertex_0_251 = mesh_0.vertices.elementAt(251);
      expect(vertex_0_251, vector3MoreOrLessEquals(Vector3(-0.723669, 0.72367, 3.75966)));
      final vertex_0_252 = mesh_0.vertices.elementAt(252);
      expect(vertex_0_252, vector3MoreOrLessEquals(Vector3(-1.09657e-05, -1.08266e-05, 4.18218)));
      final vertex_0_253 = mesh_0.vertices.elementAt(253);
      expect(vertex_0_253, vector3MoreOrLessEquals(Vector3(0.723669, 0.72367, 3.75966)));
      final vertex_0_254 = mesh_0.vertices.elementAt(254);
      expect(vertex_0_254, vector3MoreOrLessEquals(Vector3(1.33102e-06, 1.02342, 3.75966)));
      final vertex_0_255 = mesh_0.vertices.elementAt(255);
      expect(vertex_0_255, vector3MoreOrLessEquals(Vector3(-1.09657e-05, -1.08266e-05, 4.18218)));
      expect(mesh_0.normals.length, equals(256));
      final normal_0_0 = mesh_0.normals.elementAt(0);
      expect(normal_0_0, vector3MoreOrLessEquals(Vector3(0, 0, -1)));
      final normal_0_1 = mesh_0.normals.elementAt(1);
      expect(normal_0_1, vector3MoreOrLessEquals(Vector3(0.633625, 0.633625, -0.443861)));
      final normal_0_2 = mesh_0.normals.elementAt(2);
      expect(normal_0_2, vector3MoreOrLessEquals(Vector3(0.896084, 0, -0.443861)));
      final normal_0_3 = mesh_0.normals.elementAt(3);
      expect(normal_0_3, vector3MoreOrLessEquals(Vector3(0, 0, -1)));
      final normal_0_4 = mesh_0.normals.elementAt(4);
      expect(normal_0_4, vector3MoreOrLessEquals(Vector3(0.896084, 0, -0.443861)));
      final normal_0_5 = mesh_0.normals.elementAt(5);
      expect(normal_0_5, vector3MoreOrLessEquals(Vector3(0.633625, -0.633625, -0.443861)));
      final normal_0_6 = mesh_0.normals.elementAt(6);
      expect(normal_0_6, vector3MoreOrLessEquals(Vector3(0, 0, -1)));
      final normal_0_7 = mesh_0.normals.elementAt(7);
      expect(normal_0_7, vector3MoreOrLessEquals(Vector3(0.633625, -0.633625, -0.443861)));
      final normal_0_8 = mesh_0.normals.elementAt(8);
      expect(normal_0_8, vector3MoreOrLessEquals(Vector3(0, -0.896084, -0.443861)));
      final normal_0_9 = mesh_0.normals.elementAt(9);
      expect(normal_0_9, vector3MoreOrLessEquals(Vector3(0, 0, -1)));
      final normal_0_10 = mesh_0.normals.elementAt(10);
      expect(normal_0_10, vector3MoreOrLessEquals(Vector3(0, -0.896084, -0.443861)));
      final normal_0_11 = mesh_0.normals.elementAt(11);
      expect(normal_0_11, vector3MoreOrLessEquals(Vector3(-0.633625, -0.633625, -0.443861)));
      final normal_0_12 = mesh_0.normals.elementAt(12);
      expect(normal_0_12, vector3MoreOrLessEquals(Vector3(0, 0, -1)));
      final normal_0_13 = mesh_0.normals.elementAt(13);
      expect(normal_0_13, vector3MoreOrLessEquals(Vector3(-0.633625, -0.633625, -0.443861)));
      final normal_0_14 = mesh_0.normals.elementAt(14);
      expect(normal_0_14, vector3MoreOrLessEquals(Vector3(-0.896084, 0, -0.443861)));
      final normal_0_15 = mesh_0.normals.elementAt(15);
      expect(normal_0_15, vector3MoreOrLessEquals(Vector3(0, 0, -1)));
      final normal_0_16 = mesh_0.normals.elementAt(16);
      expect(normal_0_16, vector3MoreOrLessEquals(Vector3(-0.896084, 0, -0.443861)));
      final normal_0_17 = mesh_0.normals.elementAt(17);
      expect(normal_0_17, vector3MoreOrLessEquals(Vector3(-0.633625, 0.633625, -0.443861)));
      final normal_0_18 = mesh_0.normals.elementAt(18);
      expect(normal_0_18, vector3MoreOrLessEquals(Vector3(0, 0, -1)));
      final normal_0_19 = mesh_0.normals.elementAt(19);
      expect(normal_0_19, vector3MoreOrLessEquals(Vector3(-0.633625, 0.633625, -0.443861)));
      final normal_0_20 = mesh_0.normals.elementAt(20);
      expect(normal_0_20, vector3MoreOrLessEquals(Vector3(0, 0.896084, -0.443861)));
      final normal_0_21 = mesh_0.normals.elementAt(21);
      expect(normal_0_21, vector3MoreOrLessEquals(Vector3(0, 0.896084, -0.443861)));
      final normal_0_22 = mesh_0.normals.elementAt(22);
      expect(normal_0_22, vector3MoreOrLessEquals(Vector3(0.633625, 0.633625, -0.443861)));
      final normal_0_23 = mesh_0.normals.elementAt(23);
      expect(normal_0_23, vector3MoreOrLessEquals(Vector3(0, 0, -1)));
      final normal_0_24 = mesh_0.normals.elementAt(24);
      expect(normal_0_24, vector3MoreOrLessEquals(Vector3(0.633625, 0.633625, -0.443861)));
      final normal_0_25 = mesh_0.normals.elementAt(25);
      expect(normal_0_25, vector3MoreOrLessEquals(Vector3(0.705771, 0.705771, 0.0610065)));
      final normal_0_26 = mesh_0.normals.elementAt(26);
      expect(normal_0_26, vector3MoreOrLessEquals(Vector3(0.998108, 0, 0.0610065)));
      final normal_0_27 = mesh_0.normals.elementAt(27);
      expect(normal_0_27, vector3MoreOrLessEquals(Vector3(0.896084, 0, -0.443861)));
      final normal_0_28 = mesh_0.normals.elementAt(28);
      expect(normal_0_28, vector3MoreOrLessEquals(Vector3(0.896084, 0, -0.443861)));
      final normal_0_29 = mesh_0.normals.elementAt(29);
      expect(normal_0_29, vector3MoreOrLessEquals(Vector3(0.998108, 0, 0.0610065)));
      final normal_0_30 = mesh_0.normals.elementAt(30);
      expect(normal_0_30, vector3MoreOrLessEquals(Vector3(0.705771, -0.705771, 0.0610065)));
      final normal_0_31 = mesh_0.normals.elementAt(31);
      expect(normal_0_31, vector3MoreOrLessEquals(Vector3(0.633625, -0.633625, -0.443861)));
      final normal_0_32 = mesh_0.normals.elementAt(32);
      expect(normal_0_32, vector3MoreOrLessEquals(Vector3(0.633625, -0.633625, -0.443861)));
      final normal_0_33 = mesh_0.normals.elementAt(33);
      expect(normal_0_33, vector3MoreOrLessEquals(Vector3(0.705771, -0.705771, 0.0610065)));
      final normal_0_34 = mesh_0.normals.elementAt(34);
      expect(normal_0_34, vector3MoreOrLessEquals(Vector3(0, -0.998108, 0.0610065)));
      final normal_0_35 = mesh_0.normals.elementAt(35);
      expect(normal_0_35, vector3MoreOrLessEquals(Vector3(0, -0.896084, -0.443861)));
      final normal_0_36 = mesh_0.normals.elementAt(36);
      expect(normal_0_36, vector3MoreOrLessEquals(Vector3(0, -0.896084, -0.443861)));
      final normal_0_37 = mesh_0.normals.elementAt(37);
      expect(normal_0_37, vector3MoreOrLessEquals(Vector3(0, -0.998108, 0.0610065)));
      final normal_0_38 = mesh_0.normals.elementAt(38);
      expect(normal_0_38, vector3MoreOrLessEquals(Vector3(-0.705771, -0.705771, 0.0610065)));
      final normal_0_39 = mesh_0.normals.elementAt(39);
      expect(normal_0_39, vector3MoreOrLessEquals(Vector3(-0.633625, -0.633625, -0.443861)));
      final normal_0_40 = mesh_0.normals.elementAt(40);
      expect(normal_0_40, vector3MoreOrLessEquals(Vector3(-0.633625, -0.633625, -0.443861)));
      final normal_0_41 = mesh_0.normals.elementAt(41);
      expect(normal_0_41, vector3MoreOrLessEquals(Vector3(-0.705771, -0.705771, 0.0610065)));
      final normal_0_42 = mesh_0.normals.elementAt(42);
      expect(normal_0_42, vector3MoreOrLessEquals(Vector3(-0.998108, 0, 0.0610065)));
      final normal_0_43 = mesh_0.normals.elementAt(43);
      expect(normal_0_43, vector3MoreOrLessEquals(Vector3(-0.896084, 0, -0.443861)));
      final normal_0_44 = mesh_0.normals.elementAt(44);
      expect(normal_0_44, vector3MoreOrLessEquals(Vector3(-0.896084, 0, -0.443861)));
      final normal_0_45 = mesh_0.normals.elementAt(45);
      expect(normal_0_45, vector3MoreOrLessEquals(Vector3(-0.998108, 0, 0.0610065)));
      final normal_0_46 = mesh_0.normals.elementAt(46);
      expect(normal_0_46, vector3MoreOrLessEquals(Vector3(-0.705771, 0.705771, 0.0610065)));
      final normal_0_47 = mesh_0.normals.elementAt(47);
      expect(normal_0_47, vector3MoreOrLessEquals(Vector3(-0.633625, 0.633625, -0.443861)));
      final normal_0_48 = mesh_0.normals.elementAt(48);
      expect(normal_0_48, vector3MoreOrLessEquals(Vector3(-0.633625, 0.633625, -0.443861)));
      final normal_0_49 = mesh_0.normals.elementAt(49);
      expect(normal_0_49, vector3MoreOrLessEquals(Vector3(-0.705771, 0.705771, 0.0610065)));
      final normal_0_50 = mesh_0.normals.elementAt(50);
      expect(normal_0_50, vector3MoreOrLessEquals(Vector3(0, 0.998108, 0.0610065)));
      final normal_0_51 = mesh_0.normals.elementAt(51);
      expect(normal_0_51, vector3MoreOrLessEquals(Vector3(0, 0.896084, -0.443861)));
      final normal_0_52 = mesh_0.normals.elementAt(52);
      expect(normal_0_52, vector3MoreOrLessEquals(Vector3(0.705771, 0.705771, 0.0610065)));
      final normal_0_53 = mesh_0.normals.elementAt(53);
      expect(normal_0_53, vector3MoreOrLessEquals(Vector3(0.633625, 0.633625, -0.443861)));
      final normal_0_54 = mesh_0.normals.elementAt(54);
      expect(normal_0_54, vector3MoreOrLessEquals(Vector3(0, 0.896084, -0.443861)));
      final normal_0_55 = mesh_0.normals.elementAt(55);
      expect(normal_0_55, vector3MoreOrLessEquals(Vector3(0, 0.998108, 0.0610065)));
      final normal_0_56 = mesh_0.normals.elementAt(56);
      expect(normal_0_56, vector3MoreOrLessEquals(Vector3(0.705771, 0.705771, 0.0610065)));
      final normal_0_57 = mesh_0.normals.elementAt(57);
      expect(normal_0_57, vector3MoreOrLessEquals(Vector3(0, 0.998108, 0.0610065)));
      final normal_0_58 = mesh_0.normals.elementAt(58);
      expect(normal_0_58, vector3MoreOrLessEquals(Vector3(0, 0.984283, -0.176427)));
      final normal_0_59 = mesh_0.normals.elementAt(59);
      expect(normal_0_59, vector3MoreOrLessEquals(Vector3(0.314798, 0.833705, -0.453658)));
      final normal_0_60 = mesh_0.normals.elementAt(60);
      expect(normal_0_60, vector3MoreOrLessEquals(Vector3(0, 0.998108, 0.0610065)));
      final normal_0_61 = mesh_0.normals.elementAt(61);
      expect(normal_0_61, vector3MoreOrLessEquals(Vector3(-0.705771, 0.705771, 0.0610065)));
      final normal_0_62 = mesh_0.normals.elementAt(62);
      expect(normal_0_62, vector3MoreOrLessEquals(Vector3(-0.696005, 0.696005, -0.176427)));
      final normal_0_63 = mesh_0.normals.elementAt(63);
      expect(normal_0_63, vector3MoreOrLessEquals(Vector3(0, 0.984283, -0.176427)));
      final normal_0_64 = mesh_0.normals.elementAt(64);
      expect(normal_0_64, vector3MoreOrLessEquals(Vector3(-0.705771, 0.705771, 0.0610065)));
      final normal_0_65 = mesh_0.normals.elementAt(65);
      expect(normal_0_65, vector3MoreOrLessEquals(Vector3(-0.998108, 0, 0.0610065)));
      final normal_0_66 = mesh_0.normals.elementAt(66);
      expect(normal_0_66, vector3MoreOrLessEquals(Vector3(-0.984283, 0, -0.176427)));
      final normal_0_67 = mesh_0.normals.elementAt(67);
      expect(normal_0_67, vector3MoreOrLessEquals(Vector3(-0.696005, 0.696005, -0.176427)));
      final normal_0_68 = mesh_0.normals.elementAt(68);
      expect(normal_0_68, vector3MoreOrLessEquals(Vector3(-0.998108, 0, 0.0610065)));
      final normal_0_69 = mesh_0.normals.elementAt(69);
      expect(normal_0_69, vector3MoreOrLessEquals(Vector3(-0.705771, -0.705771, 0.0610065)));
      final normal_0_70 = mesh_0.normals.elementAt(70);
      expect(normal_0_70, vector3MoreOrLessEquals(Vector3(-0.696005, -0.696005, -0.176427)));
      final normal_0_71 = mesh_0.normals.elementAt(71);
      expect(normal_0_71, vector3MoreOrLessEquals(Vector3(-0.984283, 0, -0.176427)));
      final normal_0_72 = mesh_0.normals.elementAt(72);
      expect(normal_0_72, vector3MoreOrLessEquals(Vector3(-0.705771, -0.705771, 0.0610065)));
      final normal_0_73 = mesh_0.normals.elementAt(73);
      expect(normal_0_73, vector3MoreOrLessEquals(Vector3(0, -0.998108, 0.0610065)));
      final normal_0_74 = mesh_0.normals.elementAt(74);
      expect(normal_0_74, vector3MoreOrLessEquals(Vector3(0, -0.984283, -0.176427)));
      final normal_0_75 = mesh_0.normals.elementAt(75);
      expect(normal_0_75, vector3MoreOrLessEquals(Vector3(-0.696005, -0.696005, -0.176427)));
      final normal_0_76 = mesh_0.normals.elementAt(76);
      expect(normal_0_76, vector3MoreOrLessEquals(Vector3(0, -0.998108, 0.0610065)));
      final normal_0_77 = mesh_0.normals.elementAt(77);
      expect(normal_0_77, vector3MoreOrLessEquals(Vector3(0.705771, -0.705771, 0.0610065)));
      final normal_0_78 = mesh_0.normals.elementAt(78);
      expect(normal_0_78, vector3MoreOrLessEquals(Vector3(0.696005, -0.696005, -0.176427)));
      final normal_0_79 = mesh_0.normals.elementAt(79);
      expect(normal_0_79, vector3MoreOrLessEquals(Vector3(0, -0.984283, -0.176427)));
      final normal_0_80 = mesh_0.normals.elementAt(80);
      expect(normal_0_80, vector3MoreOrLessEquals(Vector3(0.705771, -0.705771, 0.0610065)));
      final normal_0_81 = mesh_0.normals.elementAt(81);
      expect(normal_0_81, vector3MoreOrLessEquals(Vector3(0.998108, 0, 0.0610065)));
      final normal_0_82 = mesh_0.normals.elementAt(82);
      expect(normal_0_82, vector3MoreOrLessEquals(Vector3(0.812128, -0.366894, -0.453658)));
      final normal_0_83 = mesh_0.normals.elementAt(83);
      expect(normal_0_83, vector3MoreOrLessEquals(Vector3(0.696005, -0.696005, -0.176427)));
      final normal_0_84 = mesh_0.normals.elementAt(84);
      expect(normal_0_84, vector3MoreOrLessEquals(Vector3(0.998108, 0, 0.0610065)));
      final normal_0_85 = mesh_0.normals.elementAt(85);
      expect(normal_0_85, vector3MoreOrLessEquals(Vector3(0.705771, 0.705771, 0.0610065)));
      final normal_0_86 = mesh_0.normals.elementAt(86);
      expect(normal_0_86, vector3MoreOrLessEquals(Vector3(0.314798, 0.833705, -0.453658)));
      final normal_0_87 = mesh_0.normals.elementAt(87);
      expect(normal_0_87, vector3MoreOrLessEquals(Vector3(0.812128, -0.366894, -0.453658)));
      final normal_0_88 = mesh_0.normals.elementAt(88);
      expect(normal_0_88, vector3MoreOrLessEquals(Vector3(0.696005, -0.696005, -0.176427)));
      final normal_0_89 = mesh_0.normals.elementAt(89);
      expect(normal_0_89, vector3MoreOrLessEquals(Vector3(0.812128, -0.366894, -0.453658)));
      final normal_0_90 = mesh_0.normals.elementAt(90);
      expect(normal_0_90, vector3MoreOrLessEquals(Vector3(0.886624, -0.367229, 0.281075)));
      final normal_0_91 = mesh_0.normals.elementAt(91);
      expect(normal_0_91, vector3MoreOrLessEquals(Vector3(0.707083, -0.707083, 0)));
      final normal_0_92 = mesh_0.normals.elementAt(92);
      expect(normal_0_92, vector3MoreOrLessEquals(Vector3(0, -0.984283, -0.176427)));
      final normal_0_93 = mesh_0.normals.elementAt(93);
      expect(normal_0_93, vector3MoreOrLessEquals(Vector3(0.696005, -0.696005, -0.176427)));
      final normal_0_94 = mesh_0.normals.elementAt(94);
      expect(normal_0_94, vector3MoreOrLessEquals(Vector3(0.707083, -0.707083, 0)));
      final normal_0_95 = mesh_0.normals.elementAt(95);
      expect(normal_0_95, vector3MoreOrLessEquals(Vector3(0, -1, 0)));
      final normal_0_96 = mesh_0.normals.elementAt(96);
      expect(normal_0_96, vector3MoreOrLessEquals(Vector3(-0.696005, -0.696005, -0.176427)));
      final normal_0_97 = mesh_0.normals.elementAt(97);
      expect(normal_0_97, vector3MoreOrLessEquals(Vector3(0, -0.984283, -0.176427)));
      final normal_0_98 = mesh_0.normals.elementAt(98);
      expect(normal_0_98, vector3MoreOrLessEquals(Vector3(0, -1, 0)));
      final normal_0_99 = mesh_0.normals.elementAt(99);
      expect(normal_0_99, vector3MoreOrLessEquals(Vector3(-0.707083, -0.707083, 0)));
      final normal_0_100 = mesh_0.normals.elementAt(100);
      expect(normal_0_100, vector3MoreOrLessEquals(Vector3(-0.984283, 0, -0.176427)));
      final normal_0_101 = mesh_0.normals.elementAt(101);
      expect(normal_0_101, vector3MoreOrLessEquals(Vector3(-0.696005, -0.696005, -0.176427)));
      final normal_0_102 = mesh_0.normals.elementAt(102);
      expect(normal_0_102, vector3MoreOrLessEquals(Vector3(-0.707083, -0.707083, 0)));
      final normal_0_103 = mesh_0.normals.elementAt(103);
      expect(normal_0_103, vector3MoreOrLessEquals(Vector3(-1, 0, 0)));
      final normal_0_104 = mesh_0.normals.elementAt(104);
      expect(normal_0_104, vector3MoreOrLessEquals(Vector3(-0.696005, 0.696005, -0.176427)));
      final normal_0_105 = mesh_0.normals.elementAt(105);
      expect(normal_0_105, vector3MoreOrLessEquals(Vector3(-0.984283, 0, -0.176427)));
      final normal_0_106 = mesh_0.normals.elementAt(106);
      expect(normal_0_106, vector3MoreOrLessEquals(Vector3(-1, 0, 0)));
      final normal_0_107 = mesh_0.normals.elementAt(107);
      expect(normal_0_107, vector3MoreOrLessEquals(Vector3(-0.707083, 0.707083, 0)));
      final normal_0_108 = mesh_0.normals.elementAt(108);
      expect(normal_0_108, vector3MoreOrLessEquals(Vector3(0, 0.984283, -0.176427)));
      final normal_0_109 = mesh_0.normals.elementAt(109);
      expect(normal_0_109, vector3MoreOrLessEquals(Vector3(-0.696005, 0.696005, -0.176427)));
      final normal_0_110 = mesh_0.normals.elementAt(110);
      expect(normal_0_110, vector3MoreOrLessEquals(Vector3(-0.707083, 0.707083, 0)));
      final normal_0_111 = mesh_0.normals.elementAt(111);
      expect(normal_0_111, vector3MoreOrLessEquals(Vector3(0, 0.999969, 0)));
      final normal_0_112 = mesh_0.normals.elementAt(112);
      expect(normal_0_112, vector3MoreOrLessEquals(Vector3(0.314798, 0.833705, -0.453658)));
      final normal_0_113 = mesh_0.normals.elementAt(113);
      expect(normal_0_113, vector3MoreOrLessEquals(Vector3(0, 0.984283, -0.176427)));
      final normal_0_114 = mesh_0.normals.elementAt(114);
      expect(normal_0_114, vector3MoreOrLessEquals(Vector3(0, 0.999969, 0)));
      final normal_0_115 = mesh_0.normals.elementAt(115);
      expect(normal_0_115, vector3MoreOrLessEquals(Vector3(0.367229, 0.886624, 0.281075)));
      final normal_0_116 = mesh_0.normals.elementAt(116);
      expect(normal_0_116, vector3MoreOrLessEquals(Vector3(0.367229, 0.886624, 0.281075)));
      final normal_0_117 = mesh_0.normals.elementAt(117);
      expect(normal_0_117, vector3MoreOrLessEquals(Vector3(0, 0.999969, 0)));
      final normal_0_118 = mesh_0.normals.elementAt(118);
      expect(normal_0_118, vector3MoreOrLessEquals(Vector3(0, 0.999939, -0.00970489)));
      final normal_0_119 = mesh_0.normals.elementAt(119);
      expect(normal_0_119, vector3MoreOrLessEquals(Vector3(0.707053, 0.707053, -0.00970489)));
      final normal_0_120 = mesh_0.normals.elementAt(120);
      expect(normal_0_120, vector3MoreOrLessEquals(Vector3(0, 0.999969, 0)));
      final normal_0_121 = mesh_0.normals.elementAt(121);
      expect(normal_0_121, vector3MoreOrLessEquals(Vector3(-0.707083, 0.707083, 0)));
      final normal_0_122 = mesh_0.normals.elementAt(122);
      expect(normal_0_122, vector3MoreOrLessEquals(Vector3(-0.707053, 0.707053, -0.00970489)));
      final normal_0_123 = mesh_0.normals.elementAt(123);
      expect(normal_0_123, vector3MoreOrLessEquals(Vector3(0, 0.999939, -0.00970489)));
      final normal_0_124 = mesh_0.normals.elementAt(124);
      expect(normal_0_124, vector3MoreOrLessEquals(Vector3(-0.707083, 0.707083, 0)));
      final normal_0_125 = mesh_0.normals.elementAt(125);
      expect(normal_0_125, vector3MoreOrLessEquals(Vector3(-1, 0, 0)));
      final normal_0_126 = mesh_0.normals.elementAt(126);
      expect(normal_0_126, vector3MoreOrLessEquals(Vector3(-0.999939, 0, -0.00970489)));
      final normal_0_127 = mesh_0.normals.elementAt(127);
      expect(normal_0_127, vector3MoreOrLessEquals(Vector3(-0.707053, 0.707053, -0.00970489)));
      final normal_0_128 = mesh_0.normals.elementAt(128);
      expect(normal_0_128, vector3MoreOrLessEquals(Vector3(-1, 0, 0)));
      final normal_0_129 = mesh_0.normals.elementAt(129);
      expect(normal_0_129, vector3MoreOrLessEquals(Vector3(-0.707083, -0.707083, 0)));
      final normal_0_130 = mesh_0.normals.elementAt(130);
      expect(normal_0_130, vector3MoreOrLessEquals(Vector3(-0.707053, -0.707053, -0.00970489)));
      final normal_0_131 = mesh_0.normals.elementAt(131);
      expect(normal_0_131, vector3MoreOrLessEquals(Vector3(-0.999939, 0, -0.00970489)));
      final normal_0_132 = mesh_0.normals.elementAt(132);
      expect(normal_0_132, vector3MoreOrLessEquals(Vector3(-0.707083, -0.707083, 0)));
      final normal_0_133 = mesh_0.normals.elementAt(133);
      expect(normal_0_133, vector3MoreOrLessEquals(Vector3(0, -1, 0)));
      final normal_0_134 = mesh_0.normals.elementAt(134);
      expect(normal_0_134, vector3MoreOrLessEquals(Vector3(0, -0.999939, -0.00970489)));
      final normal_0_135 = mesh_0.normals.elementAt(135);
      expect(normal_0_135, vector3MoreOrLessEquals(Vector3(-0.707053, -0.707053, -0.00970489)));
      final normal_0_136 = mesh_0.normals.elementAt(136);
      expect(normal_0_136, vector3MoreOrLessEquals(Vector3(0, -1, 0)));
      final normal_0_137 = mesh_0.normals.elementAt(137);
      expect(normal_0_137, vector3MoreOrLessEquals(Vector3(0.707083, -0.707083, 0)));
      final normal_0_138 = mesh_0.normals.elementAt(138);
      expect(normal_0_138, vector3MoreOrLessEquals(Vector3(0.707053, -0.707053, -0.00970489)));
      final normal_0_139 = mesh_0.normals.elementAt(139);
      expect(normal_0_139, vector3MoreOrLessEquals(Vector3(0, -0.999939, -0.00970489)));
      final normal_0_140 = mesh_0.normals.elementAt(140);
      expect(normal_0_140, vector3MoreOrLessEquals(Vector3(0.707083, -0.707083, 0)));
      final normal_0_141 = mesh_0.normals.elementAt(141);
      expect(normal_0_141, vector3MoreOrLessEquals(Vector3(0.886624, -0.367229, 0.281075)));
      final normal_0_142 = mesh_0.normals.elementAt(142);
      expect(normal_0_142, vector3MoreOrLessEquals(Vector3(0.999939, 0, -0.00970489)));
      final normal_0_143 = mesh_0.normals.elementAt(143);
      expect(normal_0_143, vector3MoreOrLessEquals(Vector3(0.707053, -0.707053, -0.00970489)));
      final normal_0_144 = mesh_0.normals.elementAt(144);
      expect(normal_0_144, vector3MoreOrLessEquals(Vector3(0.886624, -0.367229, 0.281075)));
      final normal_0_145 = mesh_0.normals.elementAt(145);
      expect(normal_0_145, vector3MoreOrLessEquals(Vector3(0.367229, 0.886624, 0.281075)));
      final normal_0_146 = mesh_0.normals.elementAt(146);
      expect(normal_0_146, vector3MoreOrLessEquals(Vector3(0.707053, 0.707053, -0.00970489)));
      final normal_0_147 = mesh_0.normals.elementAt(147);
      expect(normal_0_147, vector3MoreOrLessEquals(Vector3(0.999939, 0, -0.00970489)));
      final normal_0_148 = mesh_0.normals.elementAt(148);
      expect(normal_0_148, vector3MoreOrLessEquals(Vector3(0.999939, 0, -0.00970489)));
      final normal_0_149 = mesh_0.normals.elementAt(149);
      expect(normal_0_149, vector3MoreOrLessEquals(Vector3(0.707053, 0.707053, -0.00970489)));
      final normal_0_150 = mesh_0.normals.elementAt(150);
      expect(normal_0_150, vector3MoreOrLessEquals(Vector3(0.615253, 0.615253, 0.492782)));
      final normal_0_151 = mesh_0.normals.elementAt(151);
      expect(normal_0_151, vector3MoreOrLessEquals(Vector3(0.870113, 0, 0.492782)));
      final normal_0_152 = mesh_0.normals.elementAt(152);
      expect(normal_0_152, vector3MoreOrLessEquals(Vector3(0.707053, -0.707053, -0.00970489)));
      final normal_0_153 = mesh_0.normals.elementAt(153);
      expect(normal_0_153, vector3MoreOrLessEquals(Vector3(0.999939, 0, -0.00970489)));
      final normal_0_154 = mesh_0.normals.elementAt(154);
      expect(normal_0_154, vector3MoreOrLessEquals(Vector3(0.870113, 0, 0.492782)));
      final normal_0_155 = mesh_0.normals.elementAt(155);
      expect(normal_0_155, vector3MoreOrLessEquals(Vector3(0.615253, -0.615253, 0.492782)));
      final normal_0_156 = mesh_0.normals.elementAt(156);
      expect(normal_0_156, vector3MoreOrLessEquals(Vector3(0, -0.999939, -0.00970489)));
      final normal_0_157 = mesh_0.normals.elementAt(157);
      expect(normal_0_157, vector3MoreOrLessEquals(Vector3(0.707053, -0.707053, -0.00970489)));
      final normal_0_158 = mesh_0.normals.elementAt(158);
      expect(normal_0_158, vector3MoreOrLessEquals(Vector3(0.615253, -0.615253, 0.492782)));
      final normal_0_159 = mesh_0.normals.elementAt(159);
      expect(normal_0_159, vector3MoreOrLessEquals(Vector3(0, -0.870113, 0.492782)));
      final normal_0_160 = mesh_0.normals.elementAt(160);
      expect(normal_0_160, vector3MoreOrLessEquals(Vector3(-0.707053, -0.707053, -0.00970489)));
      final normal_0_161 = mesh_0.normals.elementAt(161);
      expect(normal_0_161, vector3MoreOrLessEquals(Vector3(0, -0.999939, -0.00970489)));
      final normal_0_162 = mesh_0.normals.elementAt(162);
      expect(normal_0_162, vector3MoreOrLessEquals(Vector3(0, -0.870113, 0.492782)));
      final normal_0_163 = mesh_0.normals.elementAt(163);
      expect(normal_0_163, vector3MoreOrLessEquals(Vector3(-0.615253, -0.615253, 0.492782)));
      final normal_0_164 = mesh_0.normals.elementAt(164);
      expect(normal_0_164, vector3MoreOrLessEquals(Vector3(-0.999939, 0, -0.00970489)));
      final normal_0_165 = mesh_0.normals.elementAt(165);
      expect(normal_0_165, vector3MoreOrLessEquals(Vector3(-0.707053, -0.707053, -0.00970489)));
      final normal_0_166 = mesh_0.normals.elementAt(166);
      expect(normal_0_166, vector3MoreOrLessEquals(Vector3(-0.615253, -0.615253, 0.492782)));
      final normal_0_167 = mesh_0.normals.elementAt(167);
      expect(normal_0_167, vector3MoreOrLessEquals(Vector3(-0.870113, 0, 0.492782)));
      final normal_0_168 = mesh_0.normals.elementAt(168);
      expect(normal_0_168, vector3MoreOrLessEquals(Vector3(-0.707053, 0.707053, -0.00970489)));
      final normal_0_169 = mesh_0.normals.elementAt(169);
      expect(normal_0_169, vector3MoreOrLessEquals(Vector3(-0.999939, 0, -0.00970489)));
      final normal_0_170 = mesh_0.normals.elementAt(170);
      expect(normal_0_170, vector3MoreOrLessEquals(Vector3(-0.870113, 0, 0.492782)));
      final normal_0_171 = mesh_0.normals.elementAt(171);
      expect(normal_0_171, vector3MoreOrLessEquals(Vector3(-0.615253, 0.615253, 0.492782)));
      final normal_0_172 = mesh_0.normals.elementAt(172);
      expect(normal_0_172, vector3MoreOrLessEquals(Vector3(0, 0.999939, -0.00970489)));
      final normal_0_173 = mesh_0.normals.elementAt(173);
      expect(normal_0_173, vector3MoreOrLessEquals(Vector3(-0.707053, 0.707053, -0.00970489)));
      final normal_0_174 = mesh_0.normals.elementAt(174);
      expect(normal_0_174, vector3MoreOrLessEquals(Vector3(-0.615253, 0.615253, 0.492782)));
      final normal_0_175 = mesh_0.normals.elementAt(175);
      expect(normal_0_175, vector3MoreOrLessEquals(Vector3(0, 0.870113, 0.492782)));
      final normal_0_176 = mesh_0.normals.elementAt(176);
      expect(normal_0_176, vector3MoreOrLessEquals(Vector3(0.707053, 0.707053, -0.00970489)));
      final normal_0_177 = mesh_0.normals.elementAt(177);
      expect(normal_0_177, vector3MoreOrLessEquals(Vector3(0, 0.999939, -0.00970489)));
      final normal_0_178 = mesh_0.normals.elementAt(178);
      expect(normal_0_178, vector3MoreOrLessEquals(Vector3(0, 0.870113, 0.492782)));
      final normal_0_179 = mesh_0.normals.elementAt(179);
      expect(normal_0_179, vector3MoreOrLessEquals(Vector3(0.615253, 0.615253, 0.492782)));
      final normal_0_180 = mesh_0.normals.elementAt(180);
      expect(normal_0_180, vector3MoreOrLessEquals(Vector3(0.886624, -0.367229, 0.281075)));
      final normal_0_181 = mesh_0.normals.elementAt(181);
      expect(normal_0_181, vector3MoreOrLessEquals(Vector3(0.812128, -0.366894, -0.453658)));
      final normal_0_182 = mesh_0.normals.elementAt(182);
      expect(normal_0_182, vector3MoreOrLessEquals(Vector3(0.358318, -0.62505, -0.693472)));
      final normal_0_183 = mesh_0.normals.elementAt(183);
      expect(normal_0_183, vector3MoreOrLessEquals(Vector3(0.358318, -0.62505, 0.693472)));
      final normal_0_184 = mesh_0.normals.elementAt(184);
      expect(normal_0_184, vector3MoreOrLessEquals(Vector3(0.367229, 0.886624, 0.281075)));
      final normal_0_185 = mesh_0.normals.elementAt(185);
      expect(normal_0_185, vector3MoreOrLessEquals(Vector3(0.886624, -0.367229, 0.281075)));
      final normal_0_186 = mesh_0.normals.elementAt(186);
      expect(normal_0_186, vector3MoreOrLessEquals(Vector3(0.358318, -0.62505, 0.693472)));
      final normal_0_187 = mesh_0.normals.elementAt(187);
      expect(normal_0_187, vector3MoreOrLessEquals(Vector3(-0.261788, 0.637349, 0.724693)));
      final normal_0_188 = mesh_0.normals.elementAt(188);
      expect(normal_0_188, vector3MoreOrLessEquals(Vector3(0.314798, 0.833705, -0.453658)));
      final normal_0_189 = mesh_0.normals.elementAt(189);
      expect(normal_0_189, vector3MoreOrLessEquals(Vector3(0.367229, 0.886624, 0.281075)));
      final normal_0_190 = mesh_0.normals.elementAt(190);
      expect(normal_0_190, vector3MoreOrLessEquals(Vector3(-0.261788, 0.637349, 0.724693)));
      final normal_0_191 = mesh_0.normals.elementAt(191);
      expect(normal_0_191, vector3MoreOrLessEquals(Vector3(-0.261788, 0.637349, -0.724693)));
      final normal_0_192 = mesh_0.normals.elementAt(192);
      expect(normal_0_192, vector3MoreOrLessEquals(Vector3(0.812128, -0.366894, -0.453658)));
      final normal_0_193 = mesh_0.normals.elementAt(193);
      expect(normal_0_193, vector3MoreOrLessEquals(Vector3(0.314798, 0.833705, -0.453658)));
      final normal_0_194 = mesh_0.normals.elementAt(194);
      expect(normal_0_194, vector3MoreOrLessEquals(Vector3(-0.261788, 0.637349, -0.724693)));
      final normal_0_195 = mesh_0.normals.elementAt(195);
      expect(normal_0_195, vector3MoreOrLessEquals(Vector3(0.358318, -0.62505, -0.693472)));
      final normal_0_196 = mesh_0.normals.elementAt(196);
      expect(normal_0_196, vector3MoreOrLessEquals(Vector3(0.358318, -0.62505, -0.693472)));
      final normal_0_197 = mesh_0.normals.elementAt(197);
      expect(normal_0_197, vector3MoreOrLessEquals(Vector3(-0.261788, 0.637349, -0.724693)));
      final normal_0_198 = mesh_0.normals.elementAt(198);
      expect(normal_0_198, vector3MoreOrLessEquals(Vector3(-0.225105, 0.687399, -0.690481)));
      final normal_0_199 = mesh_0.normals.elementAt(199);
      expect(normal_0_199, vector3MoreOrLessEquals(Vector3(0.403607, -0.569323, -0.716178)));
      final normal_0_200 = mesh_0.normals.elementAt(200);
      expect(normal_0_200, vector3MoreOrLessEquals(Vector3(-0.261788, 0.637349, -0.724693)));
      final normal_0_201 = mesh_0.normals.elementAt(201);
      expect(normal_0_201, vector3MoreOrLessEquals(Vector3(-0.261788, 0.637349, 0.724693)));
      final normal_0_202 = mesh_0.normals.elementAt(202);
      expect(normal_0_202, vector3MoreOrLessEquals(Vector3(-0.225105, 0.687399, 0.690481)));
      final normal_0_203 = mesh_0.normals.elementAt(203);
      expect(normal_0_203, vector3MoreOrLessEquals(Vector3(-0.225105, 0.687399, -0.690481)));
      final normal_0_204 = mesh_0.normals.elementAt(204);
      expect(normal_0_204, vector3MoreOrLessEquals(Vector3(-0.261788, 0.637349, 0.724693)));
      final normal_0_205 = mesh_0.normals.elementAt(205);
      expect(normal_0_205, vector3MoreOrLessEquals(Vector3(0.358318, -0.62505, 0.693472)));
      final normal_0_206 = mesh_0.normals.elementAt(206);
      expect(normal_0_206, vector3MoreOrLessEquals(Vector3(0.403607, -0.569323, 0.716178)));
      final normal_0_207 = mesh_0.normals.elementAt(207);
      expect(normal_0_207, vector3MoreOrLessEquals(Vector3(-0.225105, 0.687399, 0.690481)));
      final normal_0_208 = mesh_0.normals.elementAt(208);
      expect(normal_0_208, vector3MoreOrLessEquals(Vector3(0.358318, -0.62505, 0.693472)));
      final normal_0_209 = mesh_0.normals.elementAt(209);
      expect(normal_0_209, vector3MoreOrLessEquals(Vector3(0.358318, -0.62505, -0.693472)));
      final normal_0_210 = mesh_0.normals.elementAt(210);
      expect(normal_0_210, vector3MoreOrLessEquals(Vector3(0.403607, -0.569323, -0.716178)));
      final normal_0_211 = mesh_0.normals.elementAt(211);
      expect(normal_0_211, vector3MoreOrLessEquals(Vector3(0.403607, -0.569323, 0.716178)));
      final normal_0_212 = mesh_0.normals.elementAt(212);
      expect(normal_0_212, vector3MoreOrLessEquals(Vector3(0.403607, -0.569323, 0.716178)));
      final normal_0_213 = mesh_0.normals.elementAt(213);
      expect(normal_0_213, vector3MoreOrLessEquals(Vector3(0.403607, -0.569323, -0.716178)));
      final normal_0_214 = mesh_0.normals.elementAt(214);
      expect(normal_0_214, vector3MoreOrLessEquals(Vector3(0.788537, -0.278664, -0.548173)));
      final normal_0_215 = mesh_0.normals.elementAt(215);
      expect(normal_0_215, vector3MoreOrLessEquals(Vector3(0.788537, -0.278664, 0.548173)));
      final normal_0_216 = mesh_0.normals.elementAt(216);
      expect(normal_0_216, vector3MoreOrLessEquals(Vector3(-0.225105, 0.687399, 0.690481)));
      final normal_0_217 = mesh_0.normals.elementAt(217);
      expect(normal_0_217, vector3MoreOrLessEquals(Vector3(0.403607, -0.569323, 0.716178)));
      final normal_0_218 = mesh_0.normals.elementAt(218);
      expect(normal_0_218, vector3MoreOrLessEquals(Vector3(0.788537, -0.278664, 0.548173)));
      final normal_0_219 = mesh_0.normals.elementAt(219);
      expect(normal_0_219, vector3MoreOrLessEquals(Vector3(0.360515, 0.754631, 0.548173)));
      final normal_0_220 = mesh_0.normals.elementAt(220);
      expect(normal_0_220, vector3MoreOrLessEquals(Vector3(-0.225105, 0.687399, -0.690481)));
      final normal_0_221 = mesh_0.normals.elementAt(221);
      expect(normal_0_221, vector3MoreOrLessEquals(Vector3(-0.225105, 0.687399, 0.690481)));
      final normal_0_222 = mesh_0.normals.elementAt(222);
      expect(normal_0_222, vector3MoreOrLessEquals(Vector3(0.360515, 0.754631, 0.548173)));
      final normal_0_223 = mesh_0.normals.elementAt(223);
      expect(normal_0_223, vector3MoreOrLessEquals(Vector3(0.360515, 0.754631, -0.548173)));
      final normal_0_224 = mesh_0.normals.elementAt(224);
      expect(normal_0_224, vector3MoreOrLessEquals(Vector3(0.403607, -0.569323, -0.716178)));
      final normal_0_225 = mesh_0.normals.elementAt(225);
      expect(normal_0_225, vector3MoreOrLessEquals(Vector3(-0.225105, 0.687399, -0.690481)));
      final normal_0_226 = mesh_0.normals.elementAt(226);
      expect(normal_0_226, vector3MoreOrLessEquals(Vector3(0.360515, 0.754631, -0.548173)));
      final normal_0_227 = mesh_0.normals.elementAt(227);
      expect(normal_0_227, vector3MoreOrLessEquals(Vector3(0.788537, -0.278664, -0.548173)));
      final normal_0_228 = mesh_0.normals.elementAt(228);
      expect(normal_0_228, vector3MoreOrLessEquals(Vector3(0.788537, -0.278664, -0.548173)));
      final normal_0_229 = mesh_0.normals.elementAt(229);
      expect(normal_0_229, vector3MoreOrLessEquals(Vector3(0.360515, 0.754631, -0.548173)));
      final normal_0_230 = mesh_0.normals.elementAt(230);
      expect(normal_0_230, vector3MoreOrLessEquals(Vector3(0.360515, 0.754631, 0.548173)));
      final normal_0_231 = mesh_0.normals.elementAt(231);
      expect(normal_0_231, vector3MoreOrLessEquals(Vector3(0.788537, -0.278664, 0.548173)));
      final normal_0_232 = mesh_0.normals.elementAt(232);
      expect(normal_0_232, vector3MoreOrLessEquals(Vector3(0.870113, 0, 0.492782)));
      final normal_0_233 = mesh_0.normals.elementAt(233);
      expect(normal_0_233, vector3MoreOrLessEquals(Vector3(0.615253, 0.615253, 0.492782)));
      final normal_0_234 = mesh_0.normals.elementAt(234);
      expect(normal_0_234, vector3MoreOrLessEquals(Vector3(0, 0, 1)));
      final normal_0_235 = mesh_0.normals.elementAt(235);
      expect(normal_0_235, vector3MoreOrLessEquals(Vector3(0.615253, -0.615253, 0.492782)));
      final normal_0_236 = mesh_0.normals.elementAt(236);
      expect(normal_0_236, vector3MoreOrLessEquals(Vector3(0.870113, 0, 0.492782)));
      final normal_0_237 = mesh_0.normals.elementAt(237);
      expect(normal_0_237, vector3MoreOrLessEquals(Vector3(0, 0, 1)));
      final normal_0_238 = mesh_0.normals.elementAt(238);
      expect(normal_0_238, vector3MoreOrLessEquals(Vector3(0, -0.870113, 0.492782)));
      final normal_0_239 = mesh_0.normals.elementAt(239);
      expect(normal_0_239, vector3MoreOrLessEquals(Vector3(0.615253, -0.615253, 0.492782)));
      final normal_0_240 = mesh_0.normals.elementAt(240);
      expect(normal_0_240, vector3MoreOrLessEquals(Vector3(0, 0, 1)));
      final normal_0_241 = mesh_0.normals.elementAt(241);
      expect(normal_0_241, vector3MoreOrLessEquals(Vector3(-0.615253, -0.615253, 0.492782)));
      final normal_0_242 = mesh_0.normals.elementAt(242);
      expect(normal_0_242, vector3MoreOrLessEquals(Vector3(0, -0.870113, 0.492782)));
      final normal_0_243 = mesh_0.normals.elementAt(243);
      expect(normal_0_243, vector3MoreOrLessEquals(Vector3(0, 0, 1)));
      final normal_0_244 = mesh_0.normals.elementAt(244);
      expect(normal_0_244, vector3MoreOrLessEquals(Vector3(-0.870113, 0, 0.492782)));
      final normal_0_245 = mesh_0.normals.elementAt(245);
      expect(normal_0_245, vector3MoreOrLessEquals(Vector3(-0.615253, -0.615253, 0.492782)));
      final normal_0_246 = mesh_0.normals.elementAt(246);
      expect(normal_0_246, vector3MoreOrLessEquals(Vector3(0, 0, 1)));
      final normal_0_247 = mesh_0.normals.elementAt(247);
      expect(normal_0_247, vector3MoreOrLessEquals(Vector3(-0.615253, 0.615253, 0.492782)));
      final normal_0_248 = mesh_0.normals.elementAt(248);
      expect(normal_0_248, vector3MoreOrLessEquals(Vector3(-0.870113, 0, 0.492782)));
      final normal_0_249 = mesh_0.normals.elementAt(249);
      expect(normal_0_249, vector3MoreOrLessEquals(Vector3(0, 0, 1)));
      final normal_0_250 = mesh_0.normals.elementAt(250);
      expect(normal_0_250, vector3MoreOrLessEquals(Vector3(0, 0.870113, 0.492782)));
      final normal_0_251 = mesh_0.normals.elementAt(251);
      expect(normal_0_251, vector3MoreOrLessEquals(Vector3(-0.615253, 0.615253, 0.492782)));
      final normal_0_252 = mesh_0.normals.elementAt(252);
      expect(normal_0_252, vector3MoreOrLessEquals(Vector3(0, 0, 1)));
      final normal_0_253 = mesh_0.normals.elementAt(253);
      expect(normal_0_253, vector3MoreOrLessEquals(Vector3(0.615253, 0.615253, 0.492782)));
      final normal_0_254 = mesh_0.normals.elementAt(254);
      expect(normal_0_254, vector3MoreOrLessEquals(Vector3(0, 0.870113, 0.492782)));
      final normal_0_255 = mesh_0.normals.elementAt(255);
      expect(normal_0_255, vector3MoreOrLessEquals(Vector3(0, 0, 1)));
      expect(mesh_0.tangents.length, equals(256));
      final tangent_0_0 = mesh_0.tangents.elementAt(0);
      expect(tangent_0_0, vector3MoreOrLessEquals(Vector3(-0.923905, 0.382622, 0)));
      final tangent_0_1 = mesh_0.tangents.elementAt(1);
      expect(tangent_0_1, vector3MoreOrLessEquals(Vector3(-0.752216, 0.638676, -0.162061)));
      final tangent_0_2 = mesh_0.tangents.elementAt(2);
      expect(tangent_0_2, vector3MoreOrLessEquals(Vector3(-0.324567, 0.682196, -0.655183)));
      final tangent_0_3 = mesh_0.tangents.elementAt(3);
      expect(tangent_0_3, vector3MoreOrLessEquals(Vector3(-0.923905, 0.382622, 0)));
      final tangent_0_4 = mesh_0.tangents.elementAt(4);
      expect(tangent_0_4, vector3MoreOrLessEquals(Vector3(-0.324567, 0.682196, -0.655183)));
      final tangent_0_5 = mesh_0.tangents.elementAt(5);
      expect(tangent_0_5, vector3MoreOrLessEquals(Vector3(-0.711951, -0.253012, -0.655065)));
      final tangent_0_6 = mesh_0.tangents.elementAt(6);
      expect(tangent_0_6, vector3MoreOrLessEquals(Vector3(-0.923905, 0.382622, 0)));
      final tangent_0_7 = mesh_0.tangents.elementAt(7);
      expect(tangent_0_7, vector3MoreOrLessEquals(Vector3(-0.711951, -0.253012, -0.655065)));
      final tangent_0_8 = mesh_0.tangents.elementAt(8);
      expect(tangent_0_8, vector3MoreOrLessEquals(Vector3(-0.983521, 0.0802537, -0.162003)));
      final tangent_0_9 = mesh_0.tangents.elementAt(9);
      expect(tangent_0_9, vector3MoreOrLessEquals(Vector3(-0.923905, 0.382622, 0)));
      final tangent_0_10 = mesh_0.tangents.elementAt(10);
      expect(tangent_0_10, vector3MoreOrLessEquals(Vector3(-0.983521, 0.0802537, -0.162003)));
      final tangent_0_11 = mesh_0.tangents.elementAt(11);
      expect(tangent_0_11, vector3MoreOrLessEquals(Vector3(-0.752216, 0.638676, 0.162061)));
      final tangent_0_12 = mesh_0.tangents.elementAt(12);
      expect(tangent_0_12, vector3MoreOrLessEquals(Vector3(-0.923905, 0.382622, 0)));
      final tangent_0_13 = mesh_0.tangents.elementAt(13);
      expect(tangent_0_13, vector3MoreOrLessEquals(Vector3(-0.752216, 0.638676, 0.162061)));
      final tangent_0_14 = mesh_0.tangents.elementAt(14);
      expect(tangent_0_14, vector3MoreOrLessEquals(Vector3(-0.324567, 0.682196, 0.655183)));
      final tangent_0_15 = mesh_0.tangents.elementAt(15);
      expect(tangent_0_15, vector3MoreOrLessEquals(Vector3(-0.923905, 0.382622, 0)));
      final tangent_0_16 = mesh_0.tangents.elementAt(16);
      expect(tangent_0_16, vector3MoreOrLessEquals(Vector3(-0.324567, 0.682196, 0.655183)));
      final tangent_0_17 = mesh_0.tangents.elementAt(17);
      expect(tangent_0_17, vector3MoreOrLessEquals(Vector3(-0.711951, -0.253012, 0.655066)));
      final tangent_0_18 = mesh_0.tangents.elementAt(18);
      expect(tangent_0_18, vector3MoreOrLessEquals(Vector3(-0.923905, 0.382622, 0)));
      final tangent_0_19 = mesh_0.tangents.elementAt(19);
      expect(tangent_0_19, vector3MoreOrLessEquals(Vector3(-0.711951, -0.253012, 0.655066)));
      final tangent_0_20 = mesh_0.tangents.elementAt(20);
      expect(tangent_0_20, vector3MoreOrLessEquals(Vector3(-0.983521, 0.0802537, 0.162003)));
      final tangent_0_21 = mesh_0.tangents.elementAt(21);
      expect(tangent_0_21, vector3MoreOrLessEquals(Vector3(-0.983521, 0.0802537, 0.162003)));
      final tangent_0_22 = mesh_0.tangents.elementAt(22);
      expect(tangent_0_22, vector3MoreOrLessEquals(Vector3(-0.752216, 0.638676, -0.162061)));
      final tangent_0_23 = mesh_0.tangents.elementAt(23);
      expect(tangent_0_23, vector3MoreOrLessEquals(Vector3(-0.923905, 0.382622, 0)));
      final tangent_0_24 = mesh_0.tangents.elementAt(24);
      expect(tangent_0_24, vector3MoreOrLessEquals(Vector3(-0.707764, 0.706447, -0.00188071)));
      final tangent_0_25 = mesh_0.tangents.elementAt(25);
      expect(tangent_0_25, vector3MoreOrLessEquals(Vector3(-0.706663, 0.707488, -0.00942895)));
      final tangent_0_26 = mesh_0.tangents.elementAt(26);
      expect(tangent_0_26, vector3MoreOrLessEquals(Vector3(-0.00176815, 0.999591, 0.0285288)));
      final tangent_0_27 = mesh_0.tangents.elementAt(27);
      expect(tangent_0_27, vector3MoreOrLessEquals(Vector3(-0.0793416, 0.983897, -0.160161)));
      final tangent_0_28 = mesh_0.tangents.elementAt(28);
      expect(tangent_0_28, vector3MoreOrLessEquals(Vector3(-0.351958, -0.609264, -0.710579)));
      final tangent_0_29 = mesh_0.tangents.elementAt(29);
      expect(tangent_0_29, vector3MoreOrLessEquals(Vector3(0.0609003, -0.0589832, -0.9964)));
      final tangent_0_30 = mesh_0.tangents.elementAt(30);
      expect(tangent_0_30, vector3MoreOrLessEquals(Vector3(0.0295659, -0.0566966, -0.997954)));
      final tangent_0_31 = mesh_0.tangents.elementAt(31);
      expect(tangent_0_31, vector3MoreOrLessEquals(Vector3(-0.504253, 0.0968101, -0.858112)));
      final tangent_0_32 = mesh_0.tangents.elementAt(32);
      expect(tangent_0_32, vector3MoreOrLessEquals(Vector3(-0.504253, 0.0968101, -0.858112)));
      final tangent_0_33 = mesh_0.tangents.elementAt(33);
      expect(tangent_0_33, vector3MoreOrLessEquals(Vector3(0.0295659, -0.0566966, -0.997954)));
      final tangent_0_34 = mesh_0.tangents.elementAt(34);
      expect(tangent_0_34, vector3MoreOrLessEquals(Vector3(0.0260195, -0.060987, -0.997799)));
      final tangent_0_35 = mesh_0.tangents.elementAt(35);
      expect(tangent_0_35, vector3MoreOrLessEquals(Vector3(0.275702, 0.426642, -0.861374)));
      final tangent_0_36 = mesh_0.tangents.elementAt(36);
      expect(tangent_0_36, vector3MoreOrLessEquals(Vector3(0.985433, -0.0754932, 0.152392)));
      final tangent_0_37 = mesh_0.tangents.elementAt(37);
      expect(tangent_0_37, vector3MoreOrLessEquals(Vector3(0.999108, -0.00260061, -0.0421487)));
      final tangent_0_38 = mesh_0.tangents.elementAt(38);
      expect(tangent_0_38, vector3MoreOrLessEquals(Vector3(0.706548, -0.707567, -0.0117887)));
      final tangent_0_39 = mesh_0.tangents.elementAt(39);
      expect(tangent_0_39, vector3MoreOrLessEquals(Vector3(0.709451, -0.704722, -0.0067511)));
      final tangent_0_40 = mesh_0.tangents.elementAt(40);
      expect(tangent_0_40, vector3MoreOrLessEquals(Vector3(0.709451, -0.704722, -0.0067511)));
      final tangent_0_41 = mesh_0.tangents.elementAt(41);
      expect(tangent_0_41, vector3MoreOrLessEquals(Vector3(0.706548, -0.707567, -0.0117887)));
      final tangent_0_42 = mesh_0.tangents.elementAt(42);
      expect(tangent_0_42, vector3MoreOrLessEquals(Vector3(0.000400471, -0.999979, 0.00642073)));
      final tangent_0_43 = mesh_0.tangents.elementAt(43);
      expect(tangent_0_43, vector3MoreOrLessEquals(Vector3(-0.000129605, -1, 0.000261654)));
      final tangent_0_44 = mesh_0.tangents.elementAt(44);
      expect(tangent_0_44, vector3MoreOrLessEquals(Vector3(-0.000129605, -1, 0.000261654)));
      final tangent_0_45 = mesh_0.tangents.elementAt(45);
      expect(tangent_0_45, vector3MoreOrLessEquals(Vector3(0.000400471, -0.999979, 0.00642073)));
      final tangent_0_46 = mesh_0.tangents.elementAt(46);
      expect(tangent_0_46, vector3MoreOrLessEquals(Vector3(-0.705283, -0.708161, 0.0329276)));
      final tangent_0_47 = mesh_0.tangents.elementAt(47);
      expect(tangent_0_47, vector3MoreOrLessEquals(Vector3(-0.640796, -0.751326, -0.157765)));
      final tangent_0_48 = mesh_0.tangents.elementAt(48);
      expect(tangent_0_48, vector3MoreOrLessEquals(Vector3(-0.751434, -0.640542, 0.158281)));
      final tangent_0_49 = mesh_0.tangents.elementAt(49);
      expect(tangent_0_49, vector3MoreOrLessEquals(Vector3(-0.707743, -0.706266, -0.0169702)));
      final tangent_0_50 = mesh_0.tangents.elementAt(50);
      expect(tangent_0_50, vector3MoreOrLessEquals(Vector3(-0.999987, -0.000318734, 0.0050792)));
      final tangent_0_51 = mesh_0.tangents.elementAt(51);
      expect(tangent_0_51, vector3MoreOrLessEquals(Vector3(-0.98274, -0.0821171, -0.165765)));
      final tangent_0_52 = mesh_0.tangents.elementAt(52);
      expect(tangent_0_52, vector3MoreOrLessEquals(Vector3(-0.706663, 0.707488, -0.00942895)));
      final tangent_0_53 = mesh_0.tangents.elementAt(53);
      expect(tangent_0_53, vector3MoreOrLessEquals(Vector3(-0.707764, 0.706447, -0.00188071)));
      final tangent_0_54 = mesh_0.tangents.elementAt(54);
      expect(tangent_0_54, vector3MoreOrLessEquals(Vector3(-0.984644, 0.0774932, 0.15643)));
      final tangent_0_55 = mesh_0.tangents.elementAt(55);
      expect(tangent_0_55, vector3MoreOrLessEquals(Vector3(-0.999373, 0.00218453, -0.0353366)));
      final tangent_0_56 = mesh_0.tangents.elementAt(56);
      expect(tangent_0_56, vector3MoreOrLessEquals(Vector3(-0.708055, 0.705601, 0.0280348)));
      final tangent_0_57 = mesh_0.tangents.elementAt(57);
      expect(tangent_0_57, vector3MoreOrLessEquals(Vector3(-0.999987, -0.000318734, 0.0050792)));
      final tangent_0_58 = mesh_0.tangents.elementAt(58);
      expect(tangent_0_58, vector3MoreOrLessEquals(Vector3(-0.999566, -0.0052057, -0.0289931)));
      final tangent_0_59 = mesh_0.tangents.elementAt(59);
      expect(tangent_0_59, vector3MoreOrLessEquals(Vector3(-0.932636, 0.360493, 0.015323)));
      final tangent_0_60 = mesh_0.tangents.elementAt(60);
      expect(tangent_0_60, vector3MoreOrLessEquals(Vector3(-0.999987, -0.000318734, 0.0050792)));
      final tangent_0_61 = mesh_0.tangents.elementAt(61);
      expect(tangent_0_61, vector3MoreOrLessEquals(Vector3(-0.707743, -0.706266, -0.0169702)));
      final tangent_0_62 = mesh_0.tangents.elementAt(62);
      expect(tangent_0_62, vector3MoreOrLessEquals(Vector3(-0.705881, -0.708268, -0.00941441)));
      final tangent_0_63 = mesh_0.tangents.elementAt(63);
      expect(tangent_0_63, vector3MoreOrLessEquals(Vector3(-0.999566, -0.0052057, -0.0289931)));
      final tangent_0_64 = mesh_0.tangents.elementAt(64);
      expect(tangent_0_64, vector3MoreOrLessEquals(Vector3(-0.707743, -0.706266, -0.0169702)));
      final tangent_0_65 = mesh_0.tangents.elementAt(65);
      expect(tangent_0_65, vector3MoreOrLessEquals(Vector3(-0.00229281, -0.999308, -0.0371182)));
      final tangent_0_66 = mesh_0.tangents.elementAt(66);
      expect(tangent_0_66, vector3MoreOrLessEquals(Vector3(-0.0106983, -0.998168, 0.0595463)));
      final tangent_0_67 = mesh_0.tangents.elementAt(67);
      expect(tangent_0_67, vector3MoreOrLessEquals(Vector3(-0.705881, -0.708268, -0.00941441)));
      final tangent_0_68 = mesh_0.tangents.elementAt(68);
      expect(tangent_0_68, vector3MoreOrLessEquals(Vector3(0.000400471, -0.999979, 0.00642073)));
      final tangent_0_69 = mesh_0.tangents.elementAt(69);
      expect(tangent_0_69, vector3MoreOrLessEquals(Vector3(0.706548, -0.707567, -0.0117887)));
      final tangent_0_70 = mesh_0.tangents.elementAt(70);
      expect(tangent_0_70, vector3MoreOrLessEquals(Vector3(0.708547, -0.705565, -0.0117647)));
      final tangent_0_71 = mesh_0.tangents.elementAt(71);
      expect(tangent_0_71, vector3MoreOrLessEquals(Vector3(0.014069, -0.996827, -0.0783513)));
      final tangent_0_72 = mesh_0.tangents.elementAt(72);
      expect(tangent_0_72, vector3MoreOrLessEquals(Vector3(0.706548, -0.707567, -0.0117887)));
      final tangent_0_73 = mesh_0.tangents.elementAt(73);
      expect(tangent_0_73, vector3MoreOrLessEquals(Vector3(0.999108, -0.00260061, -0.0421487)));
      final tangent_0_74 = mesh_0.tangents.elementAt(74);
      expect(tangent_0_74, vector3MoreOrLessEquals(Vector3(0.998445, -0.00986062, 0.0548728)));
      final tangent_0_75 = mesh_0.tangents.elementAt(75);
      expect(tangent_0_75, vector3MoreOrLessEquals(Vector3(0.708547, -0.705565, -0.0117647)));
      final tangent_0_76 = mesh_0.tangents.elementAt(76);
      expect(tangent_0_76, vector3MoreOrLessEquals(Vector3(0.0260195, -0.060987, -0.997799)));
      final tangent_0_77 = mesh_0.tangents.elementAt(77);
      expect(tangent_0_77, vector3MoreOrLessEquals(Vector3(0.0295659, -0.0566966, -0.997954)));
      final tangent_0_78 = mesh_0.tangents.elementAt(78);
      expect(tangent_0_78, vector3MoreOrLessEquals(Vector3(-0.0747972, 0.174097, -0.981884)));
      final tangent_0_79 = mesh_0.tangents.elementAt(79);
      expect(tangent_0_79, vector3MoreOrLessEquals(Vector3(-0.0645474, 0.176063, -0.98226)));
      final tangent_0_80 = mesh_0.tangents.elementAt(80);
      expect(tangent_0_80, vector3MoreOrLessEquals(Vector3(0.0295659, -0.0566966, -0.997954)));
      final tangent_0_81 = mesh_0.tangents.elementAt(81);
      expect(tangent_0_81, vector3MoreOrLessEquals(Vector3(0.0609003, -0.0589832, -0.9964)));
      final tangent_0_82 = mesh_0.tangents.elementAt(82);
      expect(tangent_0_82, vector3MoreOrLessEquals(Vector3(-0.36761, 0.282012, -0.88619)));
      final tangent_0_83 = mesh_0.tangents.elementAt(83);
      expect(tangent_0_83, vector3MoreOrLessEquals(Vector3(-0.0747972, 0.174097, -0.981884)));
      final tangent_0_84 = mesh_0.tangents.elementAt(84);
      expect(tangent_0_84, vector3MoreOrLessEquals(Vector3(-0.00176815, 0.999591, 0.0285288)));
      final tangent_0_85 = mesh_0.tangents.elementAt(85);
      expect(tangent_0_85, vector3MoreOrLessEquals(Vector3(-0.706663, 0.707488, -0.00942895)));
      final tangent_0_86 = mesh_0.tangents.elementAt(86);
      expect(tangent_0_86, vector3MoreOrLessEquals(Vector3(-0.770273, 0.503701, 0.391107)));
      final tangent_0_87 = mesh_0.tangents.elementAt(87);
      expect(tangent_0_87, vector3MoreOrLessEquals(Vector3(0.19303, 0.902733, -0.384463)));
      final tangent_0_88 = mesh_0.tangents.elementAt(88);
      expect(tangent_0_88, vector3MoreOrLessEquals(Vector3(-0.0747972, 0.174097, -0.981884)));
      final tangent_0_89 = mesh_0.tangents.elementAt(89);
      expect(tangent_0_89, vector3MoreOrLessEquals(Vector3(-0.36761, 0.282012, -0.88619)));
      final tangent_0_90 = mesh_0.tangents.elementAt(90);
      expect(tangent_0_90, vector3MoreOrLessEquals(Vector3(0.261114, -0.104082, -0.95968)));
      final tangent_0_91 = mesh_0.tangents.elementAt(91);
      expect(tangent_0_91, vector3MoreOrLessEquals(Vector3(0.00237484, 0.00237486, -0.999994)));
      final tangent_0_92 = mesh_0.tangents.elementAt(92);
      expect(tangent_0_92, vector3MoreOrLessEquals(Vector3(-0.0645474, 0.176063, -0.98226)));
      final tangent_0_93 = mesh_0.tangents.elementAt(93);
      expect(tangent_0_93, vector3MoreOrLessEquals(Vector3(-0.0747972, 0.174097, -0.981884)));
      final tangent_0_94 = mesh_0.tangents.elementAt(94);
      expect(tangent_0_94, vector3MoreOrLessEquals(Vector3(0.00237484, 0.00237486, -0.999994)));
      final tangent_0_95 = mesh_0.tangents.elementAt(95);
      expect(tangent_0_95, vector3MoreOrLessEquals(Vector3(0.00283578, 0, -0.999996)));
      final tangent_0_96 = mesh_0.tangents.elementAt(96);
      expect(tangent_0_96, vector3MoreOrLessEquals(Vector3(0.708547, -0.705565, -0.0117647)));
      final tangent_0_97 = mesh_0.tangents.elementAt(97);
      expect(tangent_0_97, vector3MoreOrLessEquals(Vector3(0.998445, -0.00986062, 0.0548728)));
      final tangent_0_98 = mesh_0.tangents.elementAt(98);
      expect(tangent_0_98, vector3MoreOrLessEquals(Vector3(0.999856, 0, -0.0169504)));
      final tangent_0_99 = mesh_0.tangents.elementAt(99);
      expect(tangent_0_99, vector3MoreOrLessEquals(Vector3(0.707058, -0.707058, -0.0117965)));
      final tangent_0_100 = mesh_0.tangents.elementAt(100);
      expect(tangent_0_100, vector3MoreOrLessEquals(Vector3(0.014069, -0.996827, -0.0783513)));
      final tangent_0_101 = mesh_0.tangents.elementAt(101);
      expect(tangent_0_101, vector3MoreOrLessEquals(Vector3(0.708547, -0.705565, -0.0117647)));
      final tangent_0_102 = mesh_0.tangents.elementAt(102);
      expect(tangent_0_102, vector3MoreOrLessEquals(Vector3(0.707058, -0.707058, -0.0117965)));
      final tangent_0_103 = mesh_0.tangents.elementAt(103);
      expect(tangent_0_103, vector3MoreOrLessEquals(Vector3(0, -0.999978, -0.00664226)));
      final tangent_0_104 = mesh_0.tangents.elementAt(104);
      expect(tangent_0_104, vector3MoreOrLessEquals(Vector3(-0.705881, -0.708268, -0.00941441)));
      final tangent_0_105 = mesh_0.tangents.elementAt(105);
      expect(tangent_0_105, vector3MoreOrLessEquals(Vector3(-0.0106983, -0.998168, 0.0595463)));
      final tangent_0_106 = mesh_0.tangents.elementAt(106);
      expect(tangent_0_106, vector3MoreOrLessEquals(Vector3(0, -0.999925, -0.0122654)));
      final tangent_0_107 = mesh_0.tangents.elementAt(107);
      expect(tangent_0_107, vector3MoreOrLessEquals(Vector3(-0.707075, -0.707075, -0.00944699)));
      final tangent_0_108 = mesh_0.tangents.elementAt(108);
      expect(tangent_0_108, vector3MoreOrLessEquals(Vector3(-0.999566, -0.0052057, -0.0289931)));
      final tangent_0_109 = mesh_0.tangents.elementAt(109);
      expect(tangent_0_109, vector3MoreOrLessEquals(Vector3(-0.705881, -0.708268, -0.00941441)));
      final tangent_0_110 = mesh_0.tangents.elementAt(110);
      expect(tangent_0_110, vector3MoreOrLessEquals(Vector3(-0.707075, -0.707075, -0.00944699)));
      final tangent_0_111 = mesh_0.tangents.elementAt(111);
      expect(tangent_0_111, vector3MoreOrLessEquals(Vector3(-0.999978, -2.529e-05, -0.00662846)));
      final tangent_0_112 = mesh_0.tangents.elementAt(112);
      expect(tangent_0_112, vector3MoreOrLessEquals(Vector3(-0.934517, 0.355875, 0.00553032)));
      final tangent_0_113 = mesh_0.tangents.elementAt(113);
      expect(tangent_0_113, vector3MoreOrLessEquals(Vector3(-0.998001, 0.0111752, 0.0622061)));
      final tangent_0_114 = mesh_0.tangents.elementAt(114);
      expect(tangent_0_114, vector3MoreOrLessEquals(Vector3(-0.999951, 2.52899e-05, -0.00990718)));
      final tangent_0_115 = mesh_0.tangents.elementAt(115);
      expect(tangent_0_115, vector3MoreOrLessEquals(Vector3(-0.911436, 0.403315, -0.0813746)));
      final tangent_0_116 = mesh_0.tangents.elementAt(116);
      expect(tangent_0_116, vector3MoreOrLessEquals(Vector3(-0.911436, 0.403315, -0.0813746)));
      final tangent_0_117 = mesh_0.tangents.elementAt(117);
      expect(tangent_0_117, vector3MoreOrLessEquals(Vector3(-0.999951, 2.52899e-05, -0.00990718)));
      final tangent_0_118 = mesh_0.tangents.elementAt(118);
      expect(tangent_0_118, vector3MoreOrLessEquals(Vector3(-0.999983, -4.5596e-05, -0.00588878)));
      final tangent_0_119 = mesh_0.tangents.elementAt(119);
      expect(tangent_0_119, vector3MoreOrLessEquals(Vector3(-0.707126, 0.70708, -0.00329332)));
      final tangent_0_120 = mesh_0.tangents.elementAt(120);
      expect(tangent_0_120, vector3MoreOrLessEquals(Vector3(-0.999978, -2.529e-05, -0.00662846)));
      final tangent_0_121 = mesh_0.tangents.elementAt(121);
      expect(tangent_0_121, vector3MoreOrLessEquals(Vector3(-0.707075, -0.707075, -0.00944699)));
      final tangent_0_122 = mesh_0.tangents.elementAt(122);
      expect(tangent_0_122, vector3MoreOrLessEquals(Vector3(-0.70701, -0.70714, -0.00944702)));
      final tangent_0_123 = mesh_0.tangents.elementAt(123);
      expect(tangent_0_123, vector3MoreOrLessEquals(Vector3(-0.999943, -0.000114917, -0.0106484)));
      final tangent_0_124 = mesh_0.tangents.elementAt(124);
      expect(tangent_0_124, vector3MoreOrLessEquals(Vector3(-0.707075, -0.707075, -0.00944699)));
      final tangent_0_125 = mesh_0.tangents.elementAt(125);
      expect(tangent_0_125, vector3MoreOrLessEquals(Vector3(0, -0.999925, -0.0122654)));
      final tangent_0_126 = mesh_0.tangents.elementAt(126);
      expect(tangent_0_126, vector3MoreOrLessEquals(Vector3(6.84881e-05, -0.999966, -0.00824586)));
      final tangent_0_127 = mesh_0.tangents.elementAt(127);
      expect(tangent_0_127, vector3MoreOrLessEquals(Vector3(-0.70701, -0.70714, -0.00944702)));
      final tangent_0_128 = mesh_0.tangents.elementAt(128);
      expect(tangent_0_128, vector3MoreOrLessEquals(Vector3(0, -0.999978, -0.00664226)));
      final tangent_0_129 = mesh_0.tangents.elementAt(129);
      expect(tangent_0_129, vector3MoreOrLessEquals(Vector3(0.707058, -0.707058, -0.0117965)));
      final tangent_0_130 = mesh_0.tangents.elementAt(130);
      expect(tangent_0_130, vector3MoreOrLessEquals(Vector3(0.707139, -0.706977, -0.0117975)));
      final tangent_0_131 = mesh_0.tangents.elementAt(131);
      expect(tangent_0_131, vector3MoreOrLessEquals(Vector3(0.000115046, -0.999943, -0.0106629)));
      final tangent_0_132 = mesh_0.tangents.elementAt(132);
      expect(tangent_0_132, vector3MoreOrLessEquals(Vector3(0.707058, -0.707058, -0.0117965)));
      final tangent_0_133 = mesh_0.tangents.elementAt(133);
      expect(tangent_0_133, vector3MoreOrLessEquals(Vector3(0.999856, 0, -0.0169504)));
      final tangent_0_134 = mesh_0.tangents.elementAt(134);
      expect(tangent_0_134, vector3MoreOrLessEquals(Vector3(0.999916, 0.000113965, -0.0129326)));
      final tangent_0_135 = mesh_0.tangents.elementAt(135);
      expect(tangent_0_135, vector3MoreOrLessEquals(Vector3(0.707139, -0.706977, -0.0117975)));
      final tangent_0_136 = mesh_0.tangents.elementAt(136);
      expect(tangent_0_136, vector3MoreOrLessEquals(Vector3(0.00283578, 0, -0.999996)));
      final tangent_0_137 = mesh_0.tangents.elementAt(137);
      expect(tangent_0_137, vector3MoreOrLessEquals(Vector3(0.00237484, 0.00237486, -0.999994)));
      final tangent_0_138 = mesh_0.tangents.elementAt(138);
      expect(tangent_0_138, vector3MoreOrLessEquals(Vector3(-0.00184368, 0.0118812, -0.999928)));
      final tangent_0_139 = mesh_0.tangents.elementAt(139);
      expect(tangent_0_139, vector3MoreOrLessEquals(Vector3(-0.000872934, 0.00970501, -0.999952)));
      final tangent_0_140 = mesh_0.tangents.elementAt(140);
      expect(tangent_0_140, vector3MoreOrLessEquals(Vector3(0.00237484, 0.00237486, -0.999994)));
      final tangent_0_141 = mesh_0.tangents.elementAt(141);
      expect(tangent_0_141, vector3MoreOrLessEquals(Vector3(0.261114, -0.104082, -0.95968)));
      final tangent_0_142 = mesh_0.tangents.elementAt(142);
      expect(tangent_0_142, vector3MoreOrLessEquals(Vector3(-0.00970375, 0.0150665, -0.999839)));
      final tangent_0_143 = mesh_0.tangents.elementAt(143);
      expect(tangent_0_143, vector3MoreOrLessEquals(Vector3(-0.00184368, 0.0118812, -0.999928)));
      final tangent_0_144 = mesh_0.tangents.elementAt(144);
      expect(tangent_0_144, vector3MoreOrLessEquals(Vector3(0.296726, 0.917969, 0.263225)));
      final tangent_0_145 = mesh_0.tangents.elementAt(145);
      expect(tangent_0_145, vector3MoreOrLessEquals(Vector3(-0.911436, 0.403315, -0.0813746)));
      final tangent_0_146 = mesh_0.tangents.elementAt(146);
      expect(tangent_0_146, vector3MoreOrLessEquals(Vector3(-0.707126, 0.70708, -0.00329332)));
      final tangent_0_147 = mesh_0.tangents.elementAt(147);
      expect(tangent_0_147, vector3MoreOrLessEquals(Vector3(-1.83384e-05, 1, -0.000697921)));
      final tangent_0_148 = mesh_0.tangents.elementAt(148);
      expect(tangent_0_148, vector3MoreOrLessEquals(Vector3(-1.83384e-05, 1, -0.000697921)));
      final tangent_0_149 = mesh_0.tangents.elementAt(149);
      expect(tangent_0_149, vector3MoreOrLessEquals(Vector3(-0.707126, 0.70708, -0.00329332)));
      final tangent_0_150 = mesh_0.tangents.elementAt(150);
      expect(tangent_0_150, vector3MoreOrLessEquals(Vector3(-0.706154, 0.708055, -0.0023736)));
      final tangent_0_151 = mesh_0.tangents.elementAt(151);
      expect(tangent_0_151, vector3MoreOrLessEquals(Vector3(-0.099905, 0.979244, 0.176355)));
      final tangent_0_152 = mesh_0.tangents.elementAt(152);
      expect(tangent_0_152, vector3MoreOrLessEquals(Vector3(-0.00184368, 0.0118812, -0.999928)));
      final tangent_0_153 = mesh_0.tangents.elementAt(153);
      expect(tangent_0_153, vector3MoreOrLessEquals(Vector3(-0.00970375, 0.0150665, -0.999839)));
      final tangent_0_154 = mesh_0.tangents.elementAt(154);
      expect(tangent_0_154, vector3MoreOrLessEquals(Vector3(0.492539, 0.0302448, -0.869765)));
      final tangent_0_155 = mesh_0.tangents.elementAt(155);
      expect(tangent_0_155, vector3MoreOrLessEquals(Vector3(0.357301, -0.339508, -0.870098)));
      final tangent_0_156 = mesh_0.tangents.elementAt(156);
      expect(tangent_0_156, vector3MoreOrLessEquals(Vector3(-0.000872934, 0.00970501, -0.999952)));
      final tangent_0_157 = mesh_0.tangents.elementAt(157);
      expect(tangent_0_157, vector3MoreOrLessEquals(Vector3(-0.00184368, 0.0118812, -0.999928)));
      final tangent_0_158 = mesh_0.tangents.elementAt(158);
      expect(tangent_0_158, vector3MoreOrLessEquals(Vector3(0.357301, -0.339508, -0.870098)));
      final tangent_0_159 = mesh_0.tangents.elementAt(159);
      expect(tangent_0_159, vector3MoreOrLessEquals(Vector3(-0.00529687, -0.492757, -0.870151)));
      final tangent_0_160 = mesh_0.tangents.elementAt(160);
      expect(tangent_0_160, vector3MoreOrLessEquals(Vector3(0.707139, -0.706977, -0.0117975)));
      final tangent_0_161 = mesh_0.tangents.elementAt(161);
      expect(tangent_0_161, vector3MoreOrLessEquals(Vector3(0.999916, 0.000113965, -0.0129326)));
      final tangent_0_162 = mesh_0.tangents.elementAt(162);
      expect(tangent_0_162, vector3MoreOrLessEquals(Vector3(0.976907, -0.105314, -0.185906)));
      final tangent_0_163 = mesh_0.tangents.elementAt(163);
      expect(tangent_0_163, vector3MoreOrLessEquals(Vector3(0.70367, -0.710476, -0.00849775)));
      final tangent_0_164 = mesh_0.tangents.elementAt(164);
      expect(tangent_0_164, vector3MoreOrLessEquals(Vector3(0.000115046, -0.999943, -0.0106629)));
      final tangent_0_165 = mesh_0.tangents.elementAt(165);
      expect(tangent_0_165, vector3MoreOrLessEquals(Vector3(0.707139, -0.706977, -0.0117975)));
      final tangent_0_166 = mesh_0.tangents.elementAt(166);
      expect(tangent_0_166, vector3MoreOrLessEquals(Vector3(0.70367, -0.710476, -0.00849775)));
      final tangent_0_167 = mesh_0.tangents.elementAt(167);
      expect(tangent_0_167, vector3MoreOrLessEquals(Vector3(0.0959261, -0.98088, 0.169328)));
      final tangent_0_168 = mesh_0.tangents.elementAt(168);
      expect(tangent_0_168, vector3MoreOrLessEquals(Vector3(-0.70701, -0.70714, -0.00944702)));
      final tangent_0_169 = mesh_0.tangents.elementAt(169);
      expect(tangent_0_169, vector3MoreOrLessEquals(Vector3(6.84881e-05, -0.999966, -0.00824586)));
      final tangent_0_170 = mesh_0.tangents.elementAt(170);
      expect(tangent_0_170, vector3MoreOrLessEquals(Vector3(-0.103459, -0.977723, -0.18263)));
      final tangent_0_171 = mesh_0.tangents.elementAt(171);
      expect(tangent_0_171, vector3MoreOrLessEquals(Vector3(-0.709808, -0.704363, -0.00679961)));
      final tangent_0_172 = mesh_0.tangents.elementAt(172);
      expect(tangent_0_172, vector3MoreOrLessEquals(Vector3(-0.999943, -0.000114917, -0.0106484)));
      final tangent_0_173 = mesh_0.tangents.elementAt(173);
      expect(tangent_0_173, vector3MoreOrLessEquals(Vector3(-0.70701, -0.70714, -0.00944702)));
      final tangent_0_174 = mesh_0.tangents.elementAt(174);
      expect(tangent_0_174, vector3MoreOrLessEquals(Vector3(-0.709808, -0.704363, -0.00679961)));
      final tangent_0_175 = mesh_0.tangents.elementAt(175);
      expect(tangent_0_175, vector3MoreOrLessEquals(Vector3(-0.980878, -0.0959317, 0.169338)));
      final tangent_0_176 = mesh_0.tangents.elementAt(176);
      expect(tangent_0_176, vector3MoreOrLessEquals(Vector3(-0.707126, 0.70708, -0.00329332)));
      final tangent_0_177 = mesh_0.tangents.elementAt(177);
      expect(tangent_0_177, vector3MoreOrLessEquals(Vector3(-0.999983, -4.5596e-05, -0.00588878)));
      final tangent_0_178 = mesh_0.tangents.elementAt(178);
      expect(tangent_0_178, vector3MoreOrLessEquals(Vector3(-0.978129, 0.102524, -0.180979)));
      final tangent_0_179 = mesh_0.tangents.elementAt(179);
      expect(tangent_0_179, vector3MoreOrLessEquals(Vector3(-0.706154, 0.708055, -0.0023736)));
      final tangent_0_180 = mesh_0.tangents.elementAt(180);
      expect(tangent_0_180, vector3MoreOrLessEquals(Vector3(0.261114, -0.104082, -0.95968)));
      final tangent_0_181 = mesh_0.tangents.elementAt(181);
      expect(tangent_0_181, vector3MoreOrLessEquals(Vector3(-0.36761, 0.282012, -0.88619)));
      final tangent_0_182 = mesh_0.tangents.elementAt(182);
      expect(tangent_0_182, vector3MoreOrLessEquals(Vector3(-0.341186, 0.603735, -0.720483)));
      final tangent_0_183 = mesh_0.tangents.elementAt(183);
      expect(tangent_0_183, vector3MoreOrLessEquals(Vector3(0.348581, -0.599496, -0.720483)));
      final tangent_0_184 = mesh_0.tangents.elementAt(184);
      expect(tangent_0_184, vector3MoreOrLessEquals(Vector3(0.868225, -0.435193, 0.23831)));
      final tangent_0_185 = mesh_0.tangents.elementAt(185);
      expect(tangent_0_185, vector3MoreOrLessEquals(Vector3(-0.289176, -0.914602, -0.282631)));
      final tangent_0_186 = mesh_0.tangents.elementAt(186);
      expect(tangent_0_186, vector3MoreOrLessEquals(Vector3(0.240746, -0.655831, -0.71549)));
      final tangent_0_187 = mesh_0.tangents.elementAt(187);
      expect(tangent_0_187, vector3MoreOrLessEquals(Vector3(0.337195, -0.643237, 0.68742)));
      final tangent_0_188 = mesh_0.tangents.elementAt(188);
      expect(tangent_0_188, vector3MoreOrLessEquals(Vector3(-0.162596, -0.423516, -0.891177)));
      final tangent_0_189 = mesh_0.tangents.elementAt(189);
      expect(tangent_0_189, vector3MoreOrLessEquals(Vector3(0.105465, 0.260542, -0.959685)));
      final tangent_0_190 = mesh_0.tangents.elementAt(190);
      expect(tangent_0_190, vector3MoreOrLessEquals(Vector3(-0.279446, 0.668625, -0.689094)));
      final tangent_0_191 = mesh_0.tangents.elementAt(191);
      expect(tangent_0_191, vector3MoreOrLessEquals(Vector3(0.271212, -0.672007, -0.689094)));
      final tangent_0_192 = mesh_0.tangents.elementAt(192);
      expect(tangent_0_192, vector3MoreOrLessEquals(Vector3(0.170044, 0.892648, -0.41745)));
      final tangent_0_193 = mesh_0.tangents.elementAt(193);
      expect(tangent_0_193, vector3MoreOrLessEquals(Vector3(-0.791398, 0.494451, 0.359454)));
      final tangent_0_194 = mesh_0.tangents.elementAt(194);
      expect(tangent_0_194, vector3MoreOrLessEquals(Vector3(-0.337249, 0.643211, 0.687417)));
      final tangent_0_195 = mesh_0.tangents.elementAt(195);
      expect(tangent_0_195, vector3MoreOrLessEquals(Vector3(-0.240802, 0.655805, -0.715495)));
      final tangent_0_196 = mesh_0.tangents.elementAt(196);
      expect(tangent_0_196, vector3MoreOrLessEquals(Vector3(-0.240802, 0.655805, -0.715495)));
      final tangent_0_197 = mesh_0.tangents.elementAt(197);
      expect(tangent_0_197, vector3MoreOrLessEquals(Vector3(-0.337249, 0.643211, 0.687417)));
      final tangent_0_198 = mesh_0.tangents.elementAt(198);
      expect(tangent_0_198, vector3MoreOrLessEquals(Vector3(-0.378661, 0.591293, 0.712031)));
      final tangent_0_199 = mesh_0.tangents.elementAt(199);
      expect(tangent_0_199, vector3MoreOrLessEquals(Vector3(-0.203807, 0.707222, -0.676979)));
      final tangent_0_200 = mesh_0.tangents.elementAt(200);
      expect(tangent_0_200, vector3MoreOrLessEquals(Vector3(0.271212, -0.672007, -0.689094)));
      final tangent_0_201 = mesh_0.tangents.elementAt(201);
      expect(tangent_0_201, vector3MoreOrLessEquals(Vector3(-0.279446, 0.668625, -0.689094)));
      final tangent_0_202 = mesh_0.tangents.elementAt(202);
      expect(tangent_0_202, vector3MoreOrLessEquals(Vector3(-0.218895, 0.654856, -0.723359)));
      final tangent_0_203 = mesh_0.tangents.elementAt(203);
      expect(tangent_0_203, vector3MoreOrLessEquals(Vector3(0.210864, -0.657486, -0.723359)));
      final tangent_0_204 = mesh_0.tangents.elementAt(204);
      expect(tangent_0_204, vector3MoreOrLessEquals(Vector3(0.337195, -0.643237, 0.68742)));
      final tangent_0_205 = mesh_0.tangents.elementAt(205);
      expect(tangent_0_205, vector3MoreOrLessEquals(Vector3(0.240746, -0.655831, -0.71549)));
      final tangent_0_206 = mesh_0.tangents.elementAt(206);
      expect(tangent_0_206, vector3MoreOrLessEquals(Vector3(0.203749, -0.707249, -0.676968)));
      final tangent_0_207 = mesh_0.tangents.elementAt(207);
      expect(tangent_0_207, vector3MoreOrLessEquals(Vector3(0.3786, -0.591322, 0.71204)));
      final tangent_0_208 = mesh_0.tangents.elementAt(208);
      expect(tangent_0_208, vector3MoreOrLessEquals(Vector3(0.348581, -0.599496, -0.720483)));
      final tangent_0_209 = mesh_0.tangents.elementAt(209);
      expect(tangent_0_209, vector3MoreOrLessEquals(Vector3(-0.341186, 0.603735, -0.720483)));
      final tangent_0_210 = mesh_0.tangents.elementAt(210);
      expect(tangent_0_210, vector3MoreOrLessEquals(Vector3(-0.410585, 0.586778, -0.697934)));
      final tangent_0_211 = mesh_0.tangents.elementAt(211);
      expect(tangent_0_211, vector3MoreOrLessEquals(Vector3(0.417766, -0.581687, -0.697934)));
      final tangent_0_212 = mesh_0.tangents.elementAt(212);
      expect(tangent_0_212, vector3MoreOrLessEquals(Vector3(0.417766, -0.581687, -0.697934)));
      final tangent_0_213 = mesh_0.tangents.elementAt(213);
      expect(tangent_0_213, vector3MoreOrLessEquals(Vector3(-0.410585, 0.586778, -0.697934)));
      final tangent_0_214 = mesh_0.tangents.elementAt(214);
      expect(tangent_0_214, vector3MoreOrLessEquals(Vector3(-0.51595, 0.185139, -0.836373)));
      final tangent_0_215 = mesh_0.tangents.elementAt(215);
      expect(tangent_0_215, vector3MoreOrLessEquals(Vector3(0.51771, -0.180159, -0.836373)));
      final tangent_0_216 = mesh_0.tangents.elementAt(216);
      expect(tangent_0_216, vector3MoreOrLessEquals(Vector3(0.3786, -0.591322, 0.71204)));
      final tangent_0_217 = mesh_0.tangents.elementAt(217);
      expect(tangent_0_217, vector3MoreOrLessEquals(Vector3(0.203749, -0.707249, -0.676968)));
      final tangent_0_218 = mesh_0.tangents.elementAt(218);
      expect(tangent_0_218, vector3MoreOrLessEquals(Vector3(-0.044788, -0.915117, -0.400694)));
      final tangent_0_219 = mesh_0.tangents.elementAt(219);
      expect(tangent_0_219, vector3MoreOrLessEquals(Vector3(0.728644, -0.594802, 0.339541)));
      final tangent_0_220 = mesh_0.tangents.elementAt(220);
      expect(tangent_0_220, vector3MoreOrLessEquals(Vector3(0.210864, -0.657486, -0.723359)));
      final tangent_0_221 = mesh_0.tangents.elementAt(221);
      expect(tangent_0_221, vector3MoreOrLessEquals(Vector3(-0.218895, 0.654856, -0.723359)));
      final tangent_0_222 = mesh_0.tangents.elementAt(222);
      expect(tangent_0_222, vector3MoreOrLessEquals(Vector3(0.233902, 0.495751, -0.836374)));
      final tangent_0_223 = mesh_0.tangents.elementAt(223);
      expect(tangent_0_223, vector3MoreOrLessEquals(Vector3(-0.238678, -0.49347, -0.836374)));
      final tangent_0_224 = mesh_0.tangents.elementAt(224);
      expect(tangent_0_224, vector3MoreOrLessEquals(Vector3(-0.203807, 0.707222, -0.676979)));
      final tangent_0_225 = mesh_0.tangents.elementAt(225);
      expect(tangent_0_225, vector3MoreOrLessEquals(Vector3(-0.378661, 0.591293, 0.712031)));
      final tangent_0_226 = mesh_0.tangents.elementAt(226);
      expect(tangent_0_226, vector3MoreOrLessEquals(Vector3(-0.728669, 0.59479, 0.339508)));
      final tangent_0_227 = mesh_0.tangents.elementAt(227);
      expect(tangent_0_227, vector3MoreOrLessEquals(Vector3(0.0447593, 0.915103, -0.400728)));
      final tangent_0_228 = mesh_0.tangents.elementAt(228);
      expect(tangent_0_228, vector3MoreOrLessEquals(Vector3(0.0719945, 0.92716, -0.367685)));
      final tangent_0_229 = mesh_0.tangents.elementAt(229);
      expect(tangent_0_229, vector3MoreOrLessEquals(Vector3(-0.703117, 0.60609, 0.371863)));
      final tangent_0_230 = mesh_0.tangents.elementAt(230);
      expect(tangent_0_230, vector3MoreOrLessEquals(Vector3(-0.70651, 0.604685, -0.367696)));
      final tangent_0_231 = mesh_0.tangents.elementAt(231);
      expect(tangent_0_231, vector3MoreOrLessEquals(Vector3(0.0686017, 0.925754, 0.371851)));
      final tangent_0_232 = mesh_0.tangents.elementAt(232);
      expect(tangent_0_232, vector3MoreOrLessEquals(Vector3(0.160524, 0.94547, -0.283404)));
      final tangent_0_233 = mesh_0.tangents.elementAt(233);
      expect(tangent_0_233, vector3MoreOrLessEquals(Vector3(-0.000970146, 0.625799, -0.779984)));
      final tangent_0_234 = mesh_0.tangents.elementAt(234);
      expect(tangent_0_234, vector3MoreOrLessEquals(Vector3(0.382792, 0.923835, 0)));
      final tangent_0_235 = mesh_0.tangents.elementAt(235);
      expect(tangent_0_235, vector3MoreOrLessEquals(Vector3(0.555149, 0.782041, 0.283232)));
      final tangent_0_236 = mesh_0.tangents.elementAt(236);
      expect(tangent_0_236, vector3MoreOrLessEquals(Vector3(0.160524, 0.94547, -0.283404)));
      final tangent_0_237 = mesh_0.tangents.elementAt(237);
      expect(tangent_0_237, vector3MoreOrLessEquals(Vector3(0.382792, 0.923835, 0)));
      final tangent_0_238 = mesh_0.tangents.elementAt(238);
      expect(tangent_0_238, vector3MoreOrLessEquals(Vector3(0.443426, 0.441743, 0.779895)));
      final tangent_0_239 = mesh_0.tangents.elementAt(239);
      expect(tangent_0_239, vector3MoreOrLessEquals(Vector3(0.555149, 0.782041, 0.283232)));
      final tangent_0_240 = mesh_0.tangents.elementAt(240);
      expect(tangent_0_240, vector3MoreOrLessEquals(Vector3(0.382792, 0.923835, 0)));
      final tangent_0_241 = mesh_0.tangents.elementAt(241);
      expect(tangent_0_241, vector3MoreOrLessEquals(Vector3(0.00712129, 0.620845, 0.783901)));
      final tangent_0_242 = mesh_0.tangents.elementAt(242);
      expect(tangent_0_242, vector3MoreOrLessEquals(Vector3(0.443426, 0.441743, 0.779895)));
      final tangent_0_243 = mesh_0.tangents.elementAt(243);
      expect(tangent_0_243, vector3MoreOrLessEquals(Vector3(0.382792, 0.923835, 0)));
      final tangent_0_244 = mesh_0.tangents.elementAt(244);
      expect(tangent_0_244, vector3MoreOrLessEquals(Vector3(0.16196, 0.944462, 0.285938)));
      final tangent_0_245 = mesh_0.tangents.elementAt(245);
      expect(tangent_0_245, vector3MoreOrLessEquals(Vector3(0.00712129, 0.620845, 0.783901)));
      final tangent_0_246 = mesh_0.tangents.elementAt(246);
      expect(tangent_0_246, vector3MoreOrLessEquals(Vector3(0.382792, 0.923835, 0)));
      final tangent_0_247 = mesh_0.tangents.elementAt(247);
      expect(tangent_0_247, vector3MoreOrLessEquals(Vector3(0.553422, 0.782344, -0.285766)));
      final tangent_0_248 = mesh_0.tangents.elementAt(248);
      expect(tangent_0_248, vector3MoreOrLessEquals(Vector3(0.16196, 0.944462, 0.285938)));
      final tangent_0_249 = mesh_0.tangents.elementAt(249);
      expect(tangent_0_249, vector3MoreOrLessEquals(Vector3(0.382792, 0.923835, 0)));
      final tangent_0_250 = mesh_0.tangents.elementAt(250);
      expect(tangent_0_250, vector3MoreOrLessEquals(Vector3(0.434211, 0.443961, -0.78381)));
      final tangent_0_251 = mesh_0.tangents.elementAt(251);
      expect(tangent_0_251, vector3MoreOrLessEquals(Vector3(0.553422, 0.782344, -0.285766)));
      final tangent_0_252 = mesh_0.tangents.elementAt(252);
      expect(tangent_0_252, vector3MoreOrLessEquals(Vector3(0.382792, 0.923835, 0)));
      final tangent_0_253 = mesh_0.tangents.elementAt(253);
      expect(tangent_0_253, vector3MoreOrLessEquals(Vector3(-0.000970146, 0.625799, -0.779984)));
      final tangent_0_254 = mesh_0.tangents.elementAt(254);
      expect(tangent_0_254, vector3MoreOrLessEquals(Vector3(0.434211, 0.443961, -0.78381)));
      final tangent_0_255 = mesh_0.tangents.elementAt(255);
      expect(tangent_0_255, vector3MoreOrLessEquals(Vector3(0.382792, 0.923835, 0)));
      expect(mesh_0.bitangents.length, equals(256));
      final bitangent_0_0 = mesh_0.bitangents.elementAt(0);
      expect(bitangent_0_0, vector3MoreOrLessEquals(Vector3(0.382622, 0.923905, 0)));
      final bitangent_0_1 = mesh_0.bitangents.elementAt(1);
      expect(bitangent_0_1, vector3MoreOrLessEquals(Vector3(0.180798, 0.436565, 0.881305)));
      final bitangent_0_2 = mesh_0.bitangents.elementAt(2);
      expect(bitangent_0_2, vector3MoreOrLessEquals(Vector3(0.302801, 0.731162, 0.611306)));
      final bitangent_0_3 = mesh_0.bitangents.elementAt(3);
      expect(bitangent_0_3, vector3MoreOrLessEquals(Vector3(0.382622, 0.923905, 0)));
      final bitangent_0_4 = mesh_0.bitangents.elementAt(4);
      expect(bitangent_0_4, vector3MoreOrLessEquals(Vector3(0.302801, 0.731162, 0.611306)));
      final bitangent_0_5 = mesh_0.bitangents.elementAt(5);
      expect(bitangent_0_5, vector3MoreOrLessEquals(Vector3(0.302764, 0.731073, -0.611425)));
      final bitangent_0_6 = mesh_0.bitangents.elementAt(6);
      expect(bitangent_0_6, vector3MoreOrLessEquals(Vector3(0.382622, 0.923905, 0)));
      final bitangent_0_7 = mesh_0.bitangents.elementAt(7);
      expect(bitangent_0_7, vector3MoreOrLessEquals(Vector3(0.302764, 0.731073, -0.611425)));
      final bitangent_0_8 = mesh_0.bitangents.elementAt(8);
      expect(bitangent_0_8, vector3MoreOrLessEquals(Vector3(0.18079, 0.436547, -0.881318)));
      final bitangent_0_9 = mesh_0.bitangents.elementAt(9);
      expect(bitangent_0_9, vector3MoreOrLessEquals(Vector3(0.382622, 0.923905, 0)));
      final bitangent_0_10 = mesh_0.bitangents.elementAt(10);
      expect(bitangent_0_10, vector3MoreOrLessEquals(Vector3(0.18079, 0.436547, -0.881318)));
      final bitangent_0_11 = mesh_0.bitangents.elementAt(11);
      expect(bitangent_0_11, vector3MoreOrLessEquals(Vector3(0.180798, 0.436565, -0.881304)));
      final bitangent_0_12 = mesh_0.bitangents.elementAt(12);
      expect(bitangent_0_12, vector3MoreOrLessEquals(Vector3(0.382622, 0.923905, 0)));
      final bitangent_0_13 = mesh_0.bitangents.elementAt(13);
      expect(bitangent_0_13, vector3MoreOrLessEquals(Vector3(0.180798, 0.436565, -0.881304)));
      final bitangent_0_14 = mesh_0.bitangents.elementAt(14);
      expect(bitangent_0_14, vector3MoreOrLessEquals(Vector3(0.302801, 0.731162, -0.611306)));
      final bitangent_0_15 = mesh_0.bitangents.elementAt(15);
      expect(bitangent_0_15, vector3MoreOrLessEquals(Vector3(0.382622, 0.923905, 0)));
      final bitangent_0_16 = mesh_0.bitangents.elementAt(16);
      expect(bitangent_0_16, vector3MoreOrLessEquals(Vector3(0.302801, 0.731162, -0.611306)));
      final bitangent_0_17 = mesh_0.bitangents.elementAt(17);
      expect(bitangent_0_17, vector3MoreOrLessEquals(Vector3(0.302764, 0.731074, 0.611425)));
      final bitangent_0_18 = mesh_0.bitangents.elementAt(18);
      expect(bitangent_0_18, vector3MoreOrLessEquals(Vector3(0.382622, 0.923905, 0)));
      final bitangent_0_19 = mesh_0.bitangents.elementAt(19);
      expect(bitangent_0_19, vector3MoreOrLessEquals(Vector3(0.302764, 0.731074, 0.611425)));
      final bitangent_0_20 = mesh_0.bitangents.elementAt(20);
      expect(bitangent_0_20, vector3MoreOrLessEquals(Vector3(0.18079, 0.436547, 0.881318)));
      final bitangent_0_21 = mesh_0.bitangents.elementAt(21);
      expect(bitangent_0_21, vector3MoreOrLessEquals(Vector3(0.18079, 0.436547, 0.881318)));
      final bitangent_0_22 = mesh_0.bitangents.elementAt(22);
      expect(bitangent_0_22, vector3MoreOrLessEquals(Vector3(0.180798, 0.436565, 0.881305)));
      final bitangent_0_23 = mesh_0.bitangents.elementAt(23);
      expect(bitangent_0_23, vector3MoreOrLessEquals(Vector3(0.382622, 0.923905, 0)));
      final bitangent_0_24 = mesh_0.bitangents.elementAt(24);
      expect(bitangent_0_24, vector3MoreOrLessEquals(Vector3(0.312373, 0.315341, 0.896079)));
      final bitangent_0_25 = mesh_0.bitangents.elementAt(25);
      expect(bitangent_0_25, vector3MoreOrLessEquals(Vector3(-0.049816, -0.0364563, 0.998066)));
      final bitangent_0_26 = mesh_0.bitangents.elementAt(26);
      expect(bitangent_0_26, vector3MoreOrLessEquals(Vector3(-0.0609816, -0.0285827, 0.9977)));
      final bitangent_0_27 = mesh_0.bitangents.elementAt(27);
      expect(bitangent_0_27, vector3MoreOrLessEquals(Vector3(0.436714, 0.178735, 0.881655)));
      final bitangent_0_28 = mesh_0.bitangents.elementAt(28);
      expect(bitangent_0_28, vector3MoreOrLessEquals(Vector3(-0.270429, 0.792959, -0.545952)));
      final bitangent_0_29 = mesh_0.bitangents.elementAt(29);
      expect(bitangent_0_29, vector3MoreOrLessEquals(Vector3(0.00359836, 0.99823, -0.0588716)));
      final bitangent_0_30 = mesh_0.bitangents.elementAt(30);
      expect(bitangent_0_30, vector3MoreOrLessEquals(Vector3(0.707786, 0.70613, -0.0191481)));
      final bitangent_0_31 = mesh_0.bitangents.elementAt(31);
      expect(bitangent_0_31, vector3MoreOrLessEquals(Vector3(0.586692, 0.76754, -0.258166)));
      final bitangent_0_32 = mesh_0.bitangents.elementAt(32);
      expect(bitangent_0_32, vector3MoreOrLessEquals(Vector3(0.586692, 0.76754, -0.258166)));
      final bitangent_0_33 = mesh_0.bitangents.elementAt(33);
      expect(bitangent_0_33, vector3MoreOrLessEquals(Vector3(0.707786, 0.70613, -0.0191481)));
      final bitangent_0_34 = mesh_0.bitangents.elementAt(34);
      expect(bitangent_0_34, vector3MoreOrLessEquals(Vector3(0.999632, 0.00158736, 0.0259703)));
      final bitangent_0_35 = mesh_0.bitangents.elementAt(35);
      expect(bitangent_0_35, vector3MoreOrLessEquals(Vector3(0.961234, -0.122373, 0.247052)));
      final bitangent_0_36 = mesh_0.bitangents.elementAt(36);
      expect(bitangent_0_36, vector3MoreOrLessEquals(Vector3(-0.170064, -0.437395, 0.883031)));
      final bitangent_0_37 = mesh_0.bitangents.elementAt(37);
      expect(bitangent_0_37, vector3MoreOrLessEquals(Vector3(0.0422276, 0.0609521, 0.997218)));
      final bitangent_0_38 = mesh_0.bitangents.elementAt(38);
      expect(bitangent_0_38, vector3MoreOrLessEquals(Vector3(0.0514863, 0.0347839, 0.998041)));
      final bitangent_0_39 = mesh_0.bitangents.elementAt(39);
      expect(bitangent_0_39, vector3MoreOrLessEquals(Vector3(-0.308521, -0.319176, 0.896056)));
      final bitangent_0_40 = mesh_0.bitangents.elementAt(40);
      expect(bitangent_0_40, vector3MoreOrLessEquals(Vector3(-0.308521, -0.319176, 0.896056)));
      final bitangent_0_41 = mesh_0.bitangents.elementAt(41);
      expect(bitangent_0_41, vector3MoreOrLessEquals(Vector3(0.0514863, 0.0347839, 0.998041)));
      final bitangent_0_42 = mesh_0.bitangents.elementAt(42);
      expect(bitangent_0_42, vector3MoreOrLessEquals(Vector3(0.0610052, 0.00643301, 0.998087)));
      final bitangent_0_43 = mesh_0.bitangents.elementAt(43);
      expect(bitangent_0_43, vector3MoreOrLessEquals(Vector3(-0.443861, 0.000291991, 0.896084)));
      final bitangent_0_44 = mesh_0.bitangents.elementAt(44);
      expect(bitangent_0_44, vector3MoreOrLessEquals(Vector3(-0.443861, 0.000291991, 0.896084)));
      final bitangent_0_45 = mesh_0.bitangents.elementAt(45);
      expect(bitangent_0_45, vector3MoreOrLessEquals(Vector3(0.0610052, 0.00643301, 0.998087)));
      final bitangent_0_46 = mesh_0.bitangents.elementAt(46);
      expect(bitangent_0_46, vector3MoreOrLessEquals(Vector3(0.0664417, -0.0197875, 0.997568)));
      final bitangent_0_47 = mesh_0.bitangents.elementAt(47);
      expect(bitangent_0_47, vector3MoreOrLessEquals(Vector3(-0.433448, 0.18446, 0.882084)));
      final bitangent_0_48 = mesh_0.bitangents.elementAt(48);
      expect(bitangent_0_48, vector3MoreOrLessEquals(Vector3(-0.184021, 0.433823, 0.881991)));
      final bitangent_0_49 = mesh_0.bitangents.elementAt(49);
      expect(bitangent_0_49, vector3MoreOrLessEquals(Vector3(0.0311097, -0.055154, 0.997967)));
      final bitangent_0_50 = mesh_0.bitangents.elementAt(50);
      expect(bitangent_0_50, vector3MoreOrLessEquals(Vector3(0.00508903, -0.0610057, 0.998095)));
      final bitangent_0_51 = mesh_0.bitangents.elementAt(51);
      expect(bitangent_0_51, vector3MoreOrLessEquals(Vector3(-0.184988, 0.4362, 0.880618)));
      final bitangent_0_52 = mesh_0.bitangents.elementAt(52);
      expect(bitangent_0_52, vector3MoreOrLessEquals(Vector3(-0.049816, -0.0364563, 0.998066)));
      final bitangent_0_53 = mesh_0.bitangents.elementAt(53);
      expect(bitangent_0_53, vector3MoreOrLessEquals(Vector3(0.312373, 0.315341, 0.896079)));
      final bitangent_0_54 = mesh_0.bitangents.elementAt(54);
      expect(bitangent_0_54, vector3MoreOrLessEquals(Vector3(0.17457, 0.437045, 0.882324)));
      final bitangent_0_55 = mesh_0.bitangents.elementAt(55);
      expect(bitangent_0_55, vector3MoreOrLessEquals(Vector3(-0.035403, -0.0609683, 0.997482)));
      final bitangent_0_56 = mesh_0.bitangents.elementAt(56);
      expect(bitangent_0_56, vector3MoreOrLessEquals(Vector3(-0.0232601, -0.0629821, 0.997717)));
      final bitangent_0_57 = mesh_0.bitangents.elementAt(57);
      expect(bitangent_0_57, vector3MoreOrLessEquals(Vector3(0.00508903, -0.0610057, 0.998095)));
      final bitangent_0_58 = mesh_0.bitangents.elementAt(58);
      expect(bitangent_0_58, vector3MoreOrLessEquals(Vector3(-0.0294558, 0.176351, 0.983856)));
      final bitangent_0_59 = mesh_0.bitangents.elementAt(59);
      expect(bitangent_0_59, vector3MoreOrLessEquals(Vector3(0.176315, 0.418274, 0.891026)));
      final bitangent_0_60 = mesh_0.bitangents.elementAt(60);
      expect(bitangent_0_60, vector3MoreOrLessEquals(Vector3(0.00508903, -0.0610057, 0.998095)));
      final bitangent_0_61 = mesh_0.bitangents.elementAt(61);
      expect(bitangent_0_61, vector3MoreOrLessEquals(Vector3(0.0311097, -0.055154, 0.997967)));
      final bitangent_0_62 = mesh_0.bitangents.elementAt(62);
      expect(bitangent_0_62, vector3MoreOrLessEquals(Vector3(-0.13151, 0.117984, 0.984255)));
      final bitangent_0_63 = mesh_0.bitangents.elementAt(63);
      expect(bitangent_0_63, vector3MoreOrLessEquals(Vector3(-0.0294558, 0.176351, 0.983856)));
      final bitangent_0_64 = mesh_0.bitangents.elementAt(64);
      expect(bitangent_0_64, vector3MoreOrLessEquals(Vector3(0.0311097, -0.055154, 0.997967)));
      final bitangent_0_65 = mesh_0.bitangents.elementAt(65);
      expect(bitangent_0_65, vector3MoreOrLessEquals(Vector3(0.0609643, -0.0371879, 0.997417)));
      final bitangent_0_66 = mesh_0.bitangents.elementAt(66);
      expect(bitangent_0_66, vector3MoreOrLessEquals(Vector3(-0.176104, 0.0604979, 0.98248)));
      final bitangent_0_67 = mesh_0.bitangents.elementAt(67);
      expect(bitangent_0_67, vector3MoreOrLessEquals(Vector3(-0.13151, 0.117984, 0.984255)));
      final bitangent_0_68 = mesh_0.bitangents.elementAt(68);
      expect(bitangent_0_68, vector3MoreOrLessEquals(Vector3(0.0610052, 0.00643301, 0.998087)));
      final bitangent_0_69 = mesh_0.bitangents.elementAt(69);
      expect(bitangent_0_69, vector3MoreOrLessEquals(Vector3(0.0514863, 0.0347839, 0.998041)));
      final bitangent_0_70 = mesh_0.bitangents.elementAt(70);
      expect(bitangent_0_70, vector3MoreOrLessEquals(Vector3(-0.116293, -0.133196, 0.984229)));
      final bitangent_0_71 = mesh_0.bitangents.elementAt(71);
      expect(bitangent_0_71, vector3MoreOrLessEquals(Vector3(-0.175868, -0.079602, 0.981159)));
      final bitangent_0_72 = mesh_0.bitangents.elementAt(72);
      expect(bitangent_0_72, vector3MoreOrLessEquals(Vector3(0.0514863, 0.0347839, 0.998041)));
      final bitangent_0_73 = mesh_0.bitangents.elementAt(73);
      expect(bitangent_0_73, vector3MoreOrLessEquals(Vector3(0.0422276, 0.0609521, 0.997218)));
      final bitangent_0_74 = mesh_0.bitangents.elementAt(74);
      expect(bitangent_0_74, vector3MoreOrLessEquals(Vector3(-0.0557501, -0.176153, 0.982752)));
      final bitangent_0_75 = mesh_0.bitangents.elementAt(75);
      expect(bitangent_0_75, vector3MoreOrLessEquals(Vector3(-0.116293, -0.133196, 0.984229)));
      final bitangent_0_76 = mesh_0.bitangents.elementAt(76);
      expect(bitangent_0_76, vector3MoreOrLessEquals(Vector3(0.999632, 0.00158736, 0.0259703)));
      final bitangent_0_77 = mesh_0.bitangents.elementAt(77);
      expect(bitangent_0_77, vector3MoreOrLessEquals(Vector3(0.707786, 0.70613, -0.0191481)));
      final bitangent_0_78 = mesh_0.bitangents.elementAt(78);
      expect(bitangent_0_78, vector3MoreOrLessEquals(Vector3(0.714112, 0.696592, 0.0691129)));
      final bitangent_0_79 = mesh_0.bitangents.elementAt(79);
      expect(bitangent_0_79, vector3MoreOrLessEquals(Vector3(0.997885, 0.0113879, -0.0635329)));
      final bitangent_0_80 = mesh_0.bitangents.elementAt(80);
      expect(bitangent_0_80, vector3MoreOrLessEquals(Vector3(0.707786, 0.70613, -0.0191481)));
      final bitangent_0_81 = mesh_0.bitangents.elementAt(81);
      expect(bitangent_0_81, vector3MoreOrLessEquals(Vector3(0.00359836, 0.99823, -0.0588716)));
      final bitangent_0_82 = mesh_0.bitangents.elementAt(82);
      expect(bitangent_0_82, vector3MoreOrLessEquals(Vector3(0.453074, 0.886469, 0.0941562)));
      final bitangent_0_83 = mesh_0.bitangents.elementAt(83);
      expect(bitangent_0_83, vector3MoreOrLessEquals(Vector3(0.714112, 0.696592, 0.0691129)));
      final bitangent_0_84 = mesh_0.bitangents.elementAt(84);
      expect(bitangent_0_84, vector3MoreOrLessEquals(Vector3(-0.0609816, -0.0285827, 0.9977)));
      final bitangent_0_85 = mesh_0.bitangents.elementAt(85);
      expect(bitangent_0_85, vector3MoreOrLessEquals(Vector3(-0.049816, -0.0364563, 0.998066)));
      final bitangent_0_86 = mesh_0.bitangents.elementAt(86);
      expect(bitangent_0_86, vector3MoreOrLessEquals(Vector3(0.554575, 0.226321, 0.800745)));
      final bitangent_0_87 = mesh_0.bitangents.elementAt(87);
      expect(bitangent_0_87, vector3MoreOrLessEquals(Vector3(0.550589, 0.224664, 0.803956)));
      final bitangent_0_88 = mesh_0.bitangents.elementAt(88);
      expect(bitangent_0_88, vector3MoreOrLessEquals(Vector3(0.714112, 0.696592, 0.0691129)));
      final bitangent_0_89 = mesh_0.bitangents.elementAt(89);
      expect(bitangent_0_89, vector3MoreOrLessEquals(Vector3(0.453074, 0.886469, 0.0941562)));
      final bitangent_0_90 = mesh_0.bitangents.elementAt(90);
      expect(bitangent_0_90, vector3MoreOrLessEquals(Vector3(0.381678, 0.924268, 0.00360724)));
      final bitangent_0_91 = mesh_0.bitangents.elementAt(91);
      expect(bitangent_0_91, vector3MoreOrLessEquals(Vector3(0.707079, 0.707079, 0.00335843)));
      final bitangent_0_92 = mesh_0.bitangents.elementAt(92);
      expect(bitangent_0_92, vector3MoreOrLessEquals(Vector3(0.997885, 0.0113879, -0.0635329)));
      final bitangent_0_93 = mesh_0.bitangents.elementAt(93);
      expect(bitangent_0_93, vector3MoreOrLessEquals(Vector3(0.714112, 0.696592, 0.0691129)));
      final bitangent_0_94 = mesh_0.bitangents.elementAt(94);
      expect(bitangent_0_94, vector3MoreOrLessEquals(Vector3(0.707079, 0.707079, 0.00335843)));
      final bitangent_0_95 = mesh_0.bitangents.elementAt(95);
      expect(bitangent_0_95, vector3MoreOrLessEquals(Vector3(0.999996, 0, 0.00283578)));
      final bitangent_0_96 = mesh_0.bitangents.elementAt(96);
      expect(bitangent_0_96, vector3MoreOrLessEquals(Vector3(-0.116293, -0.133196, 0.984229)));
      final bitangent_0_97 = mesh_0.bitangents.elementAt(97);
      expect(bitangent_0_97, vector3MoreOrLessEquals(Vector3(-0.0557501, -0.176153, 0.982752)));
      final bitangent_0_98 = mesh_0.bitangents.elementAt(98);
      expect(bitangent_0_98, vector3MoreOrLessEquals(Vector3(0.0169504, 0, 0.999856)));
      final bitangent_0_99 = mesh_0.bitangents.elementAt(99);
      expect(bitangent_0_99, vector3MoreOrLessEquals(Vector3(0.00834107, -0.00834107, 0.999897)));
      final bitangent_0_100 = mesh_0.bitangents.elementAt(100);
      expect(bitangent_0_100, vector3MoreOrLessEquals(Vector3(-0.175868, -0.079602, 0.981159)));
      final bitangent_0_101 = mesh_0.bitangents.elementAt(101);
      expect(bitangent_0_101, vector3MoreOrLessEquals(Vector3(-0.116293, -0.133196, 0.984229)));
      final bitangent_0_102 = mesh_0.bitangents.elementAt(102);
      expect(bitangent_0_102, vector3MoreOrLessEquals(Vector3(0.00834107, -0.00834107, 0.999897)));
      final bitangent_0_103 = mesh_0.bitangents.elementAt(103);
      expect(bitangent_0_103, vector3MoreOrLessEquals(Vector3(0, -0.00664226, 0.999978)));
      final bitangent_0_104 = mesh_0.bitangents.elementAt(104);
      expect(bitangent_0_104, vector3MoreOrLessEquals(Vector3(-0.13151, 0.117984, 0.984255)));
      final bitangent_0_105 = mesh_0.bitangents.elementAt(105);
      expect(bitangent_0_105, vector3MoreOrLessEquals(Vector3(-0.176104, 0.0604979, 0.98248)));
      final bitangent_0_106 = mesh_0.bitangents.elementAt(106);
      expect(bitangent_0_106, vector3MoreOrLessEquals(Vector3(0, -0.0122654, 0.999925)));
      final bitangent_0_107 = mesh_0.bitangents.elementAt(107);
      expect(bitangent_0_107, vector3MoreOrLessEquals(Vector3(-0.00667981, -0.00667981, 0.999922)));
      final bitangent_0_108 = mesh_0.bitangents.elementAt(108);
      expect(bitangent_0_108, vector3MoreOrLessEquals(Vector3(-0.0294558, 0.176351, 0.983856)));
      final bitangent_0_109 = mesh_0.bitangents.elementAt(109);
      expect(bitangent_0_109, vector3MoreOrLessEquals(Vector3(-0.13151, 0.117984, 0.984255)));
      final bitangent_0_110 = mesh_0.bitangents.elementAt(110);
      expect(bitangent_0_110, vector3MoreOrLessEquals(Vector3(-0.00667981, -0.00667981, 0.999922)));
      final bitangent_0_111 = mesh_0.bitangents.elementAt(111);
      expect(bitangent_0_111, vector3MoreOrLessEquals(Vector3(-0.00662826, 0, 0.999947)));
      final bitangent_0_112 = mesh_0.bitangents.elementAt(112);
      expect(bitangent_0_112, vector3MoreOrLessEquals(Vector3(0.166056, 0.42221, 0.89114)));
      final bitangent_0_113 = mesh_0.bitangents.elementAt(113);
      expect(bitangent_0_113, vector3MoreOrLessEquals(Vector3(0.0632001, 0.176075, 0.982315)));
      final bitangent_0_114 = mesh_0.bitangents.elementAt(114);
      expect(bitangent_0_114, vector3MoreOrLessEquals(Vector3(-0.00990687, 0, 0.99992)));
      final bitangent_0_115 = mesh_0.bitangents.elementAt(115);
      expect(bitangent_0_115, vector3MoreOrLessEquals(Vector3(-0.185511, -0.226299, 0.95621)));
      final bitangent_0_116 = mesh_0.bitangents.elementAt(116);
      expect(bitangent_0_116, vector3MoreOrLessEquals(Vector3(-0.185511, -0.226299, 0.95621)));
      final bitangent_0_117 = mesh_0.bitangents.elementAt(117);
      expect(bitangent_0_117, vector3MoreOrLessEquals(Vector3(-0.00990687, 0, 0.99992)));
      final bitangent_0_118 = mesh_0.bitangents.elementAt(118);
      expect(bitangent_0_118, vector3MoreOrLessEquals(Vector3(-0.00588886, 0.00970472, 0.999922)));
      final bitangent_0_119 = mesh_0.bitangents.elementAt(119);
      expect(bitangent_0_119, vector3MoreOrLessEquals(Vector3(0.00453359, 0.00919112, 0.999918)));
      final bitangent_0_120 = mesh_0.bitangents.elementAt(120);
      expect(bitangent_0_120, vector3MoreOrLessEquals(Vector3(-0.00662826, 0, 0.999947)));
      final bitangent_0_121 = mesh_0.bitangents.elementAt(121);
      expect(bitangent_0_121, vector3MoreOrLessEquals(Vector3(-0.00667981, -0.00667981, 0.999922)));
      final bitangent_0_122 = mesh_0.bitangents.elementAt(122);
      expect(bitangent_0_122, vector3MoreOrLessEquals(Vector3(-0.0135423, 0.000181915, 0.999879)));
      final bitangent_0_123 = mesh_0.bitangents.elementAt(123);
      expect(bitangent_0_123, vector3MoreOrLessEquals(Vector3(-0.0106489, 0.00970434, 0.999882)));
      final bitangent_0_124 = mesh_0.bitangents.elementAt(124);
      expect(bitangent_0_124, vector3MoreOrLessEquals(Vector3(-0.00667981, -0.00667981, 0.999922)));
      final bitangent_0_125 = mesh_0.bitangents.elementAt(125);
      expect(bitangent_0_125, vector3MoreOrLessEquals(Vector3(0, -0.0122654, 0.999925)));
      final bitangent_0_126 = mesh_0.bitangents.elementAt(126);
      expect(bitangent_0_126, vector3MoreOrLessEquals(Vector3(-0.00970456, -0.00824602, 0.999905)));
      final bitangent_0_127 = mesh_0.bitangents.elementAt(127);
      expect(bitangent_0_127, vector3MoreOrLessEquals(Vector3(-0.0135423, 0.000181915, 0.999879)));
      final bitangent_0_128 = mesh_0.bitangents.elementAt(128);
      expect(bitangent_0_128, vector3MoreOrLessEquals(Vector3(0, -0.00664226, 0.999978)));
      final bitangent_0_129 = mesh_0.bitangents.elementAt(129);
      expect(bitangent_0_129, vector3MoreOrLessEquals(Vector3(0.00834107, -0.00834107, 0.999897)));
      final bitangent_0_130 = mesh_0.bitangents.elementAt(130);
      expect(bitangent_0_130, vector3MoreOrLessEquals(Vector3(0.00148033, -0.0152042, 0.999854)));
      final bitangent_0_131 = mesh_0.bitangents.elementAt(131);
      expect(bitangent_0_131, vector3MoreOrLessEquals(Vector3(-0.00970433, -0.0106633, 0.999882)));
      final bitangent_0_132 = mesh_0.bitangents.elementAt(132);
      expect(bitangent_0_132, vector3MoreOrLessEquals(Vector3(0.00834107, -0.00834107, 0.999897)));
      final bitangent_0_133 = mesh_0.bitangents.elementAt(133);
      expect(bitangent_0_133, vector3MoreOrLessEquals(Vector3(0.0169504, 0, 0.999856)));
      final bitangent_0_134 = mesh_0.bitangents.elementAt(134);
      expect(bitangent_0_134, vector3MoreOrLessEquals(Vector3(0.0129329, -0.00970407, 0.999855)));
      final bitangent_0_135 = mesh_0.bitangents.elementAt(135);
      expect(bitangent_0_135, vector3MoreOrLessEquals(Vector3(0.00148033, -0.0152042, 0.999854)));
      final bitangent_0_136 = mesh_0.bitangents.elementAt(136);
      expect(bitangent_0_136, vector3MoreOrLessEquals(Vector3(0.999996, 0, 0.00283578)));
      final bitangent_0_137 = mesh_0.bitangents.elementAt(137);
      expect(bitangent_0_137, vector3MoreOrLessEquals(Vector3(0.707079, 0.707079, 0.00335843)));
      final bitangent_0_138 = mesh_0.bitangents.elementAt(138);
      expect(bitangent_0_138, vector3MoreOrLessEquals(Vector3(0.707117, 0.70702, 0.00709706)));
      final bitangent_0_139 = mesh_0.bitangents.elementAt(139);
      expect(bitangent_0_139, vector3MoreOrLessEquals(Vector3(0.999986, 8.47172e-06, -0.00087288)));
      final bitangent_0_140 = mesh_0.bitangents.elementAt(140);
      expect(bitangent_0_140, vector3MoreOrLessEquals(Vector3(0.707079, 0.707079, 0.00335843)));
      final bitangent_0_141 = mesh_0.bitangents.elementAt(141);
      expect(bitangent_0_141, vector3MoreOrLessEquals(Vector3(0.381678, 0.924268, 0.00360724)));
      final bitangent_0_142 = mesh_0.bitangents.elementAt(142);
      expect(bitangent_0_142, vector3MoreOrLessEquals(Vector3(0.000146218, 0.999873, 0.0150655)));
      final bitangent_0_143 = mesh_0.bitangents.elementAt(143);
      expect(bitangent_0_143, vector3MoreOrLessEquals(Vector3(0.707117, 0.70702, 0.00709706)));
      final bitangent_0_144 = mesh_0.bitangents.elementAt(144);
      expect(bitangent_0_144, vector3MoreOrLessEquals(Vector3(-0.354683, -0.14998, 0.922859)));
      final bitangent_0_145 = mesh_0.bitangents.elementAt(145);
      expect(bitangent_0_145, vector3MoreOrLessEquals(Vector3(-0.185511, -0.226299, 0.95621)));
      final bitangent_0_146 = mesh_0.bitangents.elementAt(146);
      expect(bitangent_0_146, vector3MoreOrLessEquals(Vector3(0.00453359, 0.00919112, 0.999918)));
      final bitangent_0_147 = mesh_0.bitangents.elementAt(147);
      expect(bitangent_0_147, vector3MoreOrLessEquals(Vector3(0.00970488, 0.000698056, 0.999939)));
      final bitangent_0_148 = mesh_0.bitangents.elementAt(148);
      expect(bitangent_0_148, vector3MoreOrLessEquals(Vector3(0.00970488, 0.000698056, 0.999939)));
      final bitangent_0_149 = mesh_0.bitangents.elementAt(149);
      expect(bitangent_0_149, vector3MoreOrLessEquals(Vector3(0.00453359, 0.00919112, 0.999918)));
      final bitangent_0_150 = mesh_0.bitangents.elementAt(150);
      expect(bitangent_0_150, vector3MoreOrLessEquals(Vector3(-0.350377, -0.34652, 0.870096)));
      final bitangent_0_151 = mesh_0.bitangents.elementAt(151);
      expect(bitangent_0_151, vector3MoreOrLessEquals(Vector3(-0.482554, -0.20268, 0.852053)));
      final bitangent_0_152 = mesh_0.bitangents.elementAt(152);
      expect(bitangent_0_152, vector3MoreOrLessEquals(Vector3(0.707117, 0.70702, 0.00709706)));
      final bitangent_0_153 = mesh_0.bitangents.elementAt(153);
      expect(bitangent_0_153, vector3MoreOrLessEquals(Vector3(0.000146218, 0.999873, 0.0150655)));
      final bitangent_0_154 = mesh_0.bitangents.elementAt(154);
      expect(bitangent_0_154, vector3MoreOrLessEquals(Vector3(-0.0149041, 0.999508, 0.0263164)));
      final bitangent_0_155 = mesh_0.bitangents.elementAt(155);
      expect(bitangent_0_155, vector3MoreOrLessEquals(Vector3(0.702634, 0.711402, 0.0109469)));
      final bitangent_0_156 = mesh_0.bitangents.elementAt(156);
      expect(bitangent_0_156, vector3MoreOrLessEquals(Vector3(0.999986, 8.47172e-06, -0.00087288)));
      final bitangent_0_157 = mesh_0.bitangents.elementAt(157);
      expect(bitangent_0_157, vector3MoreOrLessEquals(Vector3(0.707117, 0.70702, 0.00709706)));
      final bitangent_0_158 = mesh_0.bitangents.elementAt(158);
      expect(bitangent_0_158, vector3MoreOrLessEquals(Vector3(0.702634, 0.711402, 0.0109469)));
      final bitangent_0_159 = mesh_0.bitangents.elementAt(159);
      expect(bitangent_0_159, vector3MoreOrLessEquals(Vector3(0.999952, -0.0026102, -0.00460888)));
      final bitangent_0_160 = mesh_0.bitangents.elementAt(160);
      expect(bitangent_0_160, vector3MoreOrLessEquals(Vector3(0.00148033, -0.0152042, 0.999854)));
      final bitangent_0_161 = mesh_0.bitangents.elementAt(161);
      expect(bitangent_0_161, vector3MoreOrLessEquals(Vector3(0.0129329, -0.00970407, 0.999855)));
      final bitangent_0_162 = mesh_0.bitangents.elementAt(162);
      expect(bitangent_0_162, vector3MoreOrLessEquals(Vector3(0.213656, 0.481403, 0.85002)));
      final bitangent_0_163 = mesh_0.bitangents.elementAt(163);
      expect(bitangent_0_163, vector3MoreOrLessEquals(Vector3(0.355338, 0.341528, 0.870058)));
      final bitangent_0_164 = mesh_0.bitangents.elementAt(164);
      expect(bitangent_0_164, vector3MoreOrLessEquals(Vector3(-0.00970433, -0.0106633, 0.999882)));
      final bitangent_0_165 = mesh_0.bitangents.elementAt(165);
      expect(bitangent_0_165, vector3MoreOrLessEquals(Vector3(0.00148033, -0.0152042, 0.999854)));
      final bitangent_0_166 = mesh_0.bitangents.elementAt(166);
      expect(bitangent_0_166, vector3MoreOrLessEquals(Vector3(0.355338, 0.341528, 0.870058)));
      final bitangent_0_167 = mesh_0.bitangents.elementAt(167);
      expect(bitangent_0_167, vector3MoreOrLessEquals(Vector3(0.48336, 0.194606, 0.853477)));
      final bitangent_0_168 = mesh_0.bitangents.elementAt(168);
      expect(bitangent_0_168, vector3MoreOrLessEquals(Vector3(-0.0135423, 0.000181915, 0.999879)));
      final bitangent_0_169 = mesh_0.bitangents.elementAt(169);
      expect(bitangent_0_169, vector3MoreOrLessEquals(Vector3(-0.00970456, -0.00824602, 0.999905)));
      final bitangent_0_170 = mesh_0.bitangents.elementAt(170);
      expect(bitangent_0_170, vector3MoreOrLessEquals(Vector3(0.481805, -0.209892, 0.85073)));
      final bitangent_0_171 = mesh_0.bitangents.elementAt(171);
      expect(bitangent_0_171, vector3MoreOrLessEquals(Vector3(0.342914, -0.353964, 0.870073)));
      final bitangent_0_172 = mesh_0.bitangents.elementAt(172);
      expect(bitangent_0_172, vector3MoreOrLessEquals(Vector3(-0.0106489, 0.00970434, 0.999882)));
      final bitangent_0_173 = mesh_0.bitangents.elementAt(173);
      expect(bitangent_0_173, vector3MoreOrLessEquals(Vector3(-0.0135423, 0.000181915, 0.999879)));
      final bitangent_0_174 = mesh_0.bitangents.elementAt(174);
      expect(bitangent_0_174, vector3MoreOrLessEquals(Vector3(0.342914, -0.353964, 0.870073)));
      final bitangent_0_175 = mesh_0.bitangents.elementAt(175);
      expect(bitangent_0_175, vector3MoreOrLessEquals(Vector3(0.194617, -0.483359, 0.853475)));
      final bitangent_0_176 = mesh_0.bitangents.elementAt(176);
      expect(bitangent_0_176, vector3MoreOrLessEquals(Vector3(0.00453359, 0.00919112, 0.999918)));
      final bitangent_0_177 = mesh_0.bitangents.elementAt(177);
      expect(bitangent_0_177, vector3MoreOrLessEquals(Vector3(-0.00588886, 0.00970472, 0.999922)));
      final bitangent_0_178 = mesh_0.bitangents.elementAt(178);
      expect(bitangent_0_178, vector3MoreOrLessEquals(Vector3(-0.207994, -0.482005, 0.851083)));
      final bitangent_0_179 = mesh_0.bitangents.elementAt(179);
      expect(bitangent_0_179, vector3MoreOrLessEquals(Vector3(-0.350377, -0.34652, 0.870096)));
      final bitangent_0_180 = mesh_0.bitangents.elementAt(180);
      expect(bitangent_0_180, vector3MoreOrLessEquals(Vector3(0.381678, 0.924268, 0.00360724)));
      final bitangent_0_181 = mesh_0.bitangents.elementAt(181);
      expect(bitangent_0_181, vector3MoreOrLessEquals(Vector3(0.453074, 0.886469, 0.0941562)));
      final bitangent_0_182 = mesh_0.bitangents.elementAt(182);
      expect(bitangent_0_182, vector3MoreOrLessEquals(Vector3(0.869011, 0.494765, 0.00307083)));
      final bitangent_0_183 = mesh_0.bitangents.elementAt(183);
      expect(bitangent_0_183, vector3MoreOrLessEquals(Vector3(0.866071, 0.499893, 0.00307031)));
      final bitangent_0_184 = mesh_0.bitangents.elementAt(184);
      expect(bitangent_0_184, vector3MoreOrLessEquals(Vector3(0.333614, 0.156522, -0.929605)));
      final bitangent_0_185 = mesh_0.bitangents.elementAt(185);
      expect(bitangent_0_185, vector3MoreOrLessEquals(Vector3(0.360862, 0.169307, -0.917102)));
      final bitangent_0_186 = mesh_0.bitangents.elementAt(186);
      expect(bitangent_0_186, vector3MoreOrLessEquals(Vector3(0.902018, 0.423324, -0.0845176)));
      final bitangent_0_187 = mesh_0.bitangents.elementAt(187);
      expect(bitangent_0_187, vector3MoreOrLessEquals(Vector3(0.904275, 0.424321, -0.0465194)));
      final bitangent_0_188 = mesh_0.bitangents.elementAt(188);
      expect(bitangent_0_188, vector3MoreOrLessEquals(Vector3(-0.93511, 0.354304, 0.00223452)));
      final bitangent_0_189 = mesh_0.bitangents.elementAt(189);
      expect(bitangent_0_189, vector3MoreOrLessEquals(Vector3(-0.924111, 0.382068, 0.00217045)));
      final bitangent_0_190 = mesh_0.bitangents.elementAt(190);
      expect(bitangent_0_190, vector3MoreOrLessEquals(Vector3(-0.923741, -0.382909, 0.003067)));
      final bitangent_0_191 = mesh_0.bitangents.elementAt(191);
      expect(bitangent_0_191, vector3MoreOrLessEquals(Vector3(-0.926191, -0.376942, 0.00306636)));
      final bitangent_0_192 = mesh_0.bitangents.elementAt(192);
      expect(bitangent_0_192, vector3MoreOrLessEquals(Vector3(0.558116, 0.261881, 0.787333)));
      final bitangent_0_193 = mesh_0.bitangents.elementAt(193);
      expect(bitangent_0_193, vector3MoreOrLessEquals(Vector3(0.52399, 0.245869, 0.815445)));
      final bitangent_0_194 = mesh_0.bitangents.elementAt(194);
      expect(bitangent_0_194, vector3MoreOrLessEquals(Vector3(0.904255, 0.42436, 0.0465607)));
      final bitangent_0_195 = mesh_0.bitangents.elementAt(195);
      expect(bitangent_0_195, vector3MoreOrLessEquals(Vector3(0.902003, 0.423364, 0.0844736)));
      final bitangent_0_196 = mesh_0.bitangents.elementAt(196);
      expect(bitangent_0_196, vector3MoreOrLessEquals(Vector3(0.902003, 0.423364, 0.0844736)));
      final bitangent_0_197 = mesh_0.bitangents.elementAt(197);
      expect(bitangent_0_197, vector3MoreOrLessEquals(Vector3(0.904255, 0.42436, 0.0465607)));
      final bitangent_0_198 = mesh_0.bitangents.elementAt(198);
      expect(bitangent_0_198, vector3MoreOrLessEquals(Vector3(0.897726, 0.42174, 0.127189)));
      final bitangent_0_199 = mesh_0.bitangents.elementAt(199);
      expect(bitangent_0_199, vector3MoreOrLessEquals(Vector3(0.891916, 0.419196, 0.169408)));
      final bitangent_0_200 = mesh_0.bitangents.elementAt(200);
      expect(bitangent_0_200, vector3MoreOrLessEquals(Vector3(-0.926191, -0.376942, 0.00306636)));
      final bitangent_0_201 = mesh_0.bitangents.elementAt(201);
      expect(bitangent_0_201, vector3MoreOrLessEquals(Vector3(-0.923741, -0.382909, 0.003067)));
      final bitangent_0_202 = mesh_0.bitangents.elementAt(202);
      expect(bitangent_0_202, vector3MoreOrLessEquals(Vector3(-0.949402, -0.313974, 0.00305693)));
      final bitangent_0_203 = mesh_0.bitangents.elementAt(203);
      expect(bitangent_0_203, vector3MoreOrLessEquals(Vector3(-0.951218, -0.308429, 0.00305554)));
      final bitangent_0_204 = mesh_0.bitangents.elementAt(204);
      expect(bitangent_0_204, vector3MoreOrLessEquals(Vector3(0.904275, 0.424321, -0.0465194)));
      final bitangent_0_205 = mesh_0.bitangents.elementAt(205);
      expect(bitangent_0_205, vector3MoreOrLessEquals(Vector3(0.902018, 0.423324, -0.0845176)));
      final bitangent_0_206 = mesh_0.bitangents.elementAt(206);
      expect(bitangent_0_206, vector3MoreOrLessEquals(Vector3(0.891929, 0.41915, -0.169452)));
      final bitangent_0_207 = mesh_0.bitangents.elementAt(207);
      expect(bitangent_0_207, vector3MoreOrLessEquals(Vector3(0.897752, 0.421699, -0.12714)));
      final bitangent_0_208 = mesh_0.bitangents.elementAt(208);
      expect(bitangent_0_208, vector3MoreOrLessEquals(Vector3(0.866071, 0.499893, 0.00307031)));
      final bitangent_0_209 = mesh_0.bitangents.elementAt(209);
      expect(bitangent_0_209, vector3MoreOrLessEquals(Vector3(0.869011, 0.494765, 0.00307083)));
      final bitangent_0_210 = mesh_0.bitangents.elementAt(210);
      expect(bitangent_0_210, vector3MoreOrLessEquals(Vector3(0.817587, 0.575743, 0.00307211)));
      final bitangent_0_211 = mesh_0.bitangents.elementAt(211);
      expect(bitangent_0_211, vector3MoreOrLessEquals(Vector3(0.813941, 0.580886, 0.00307044)));
      final bitangent_0_212 = mesh_0.bitangents.elementAt(212);
      expect(bitangent_0_212, vector3MoreOrLessEquals(Vector3(0.813941, 0.580886, 0.00307044)));
      final bitangent_0_213 = mesh_0.bitangents.elementAt(213);
      expect(bitangent_0_213, vector3MoreOrLessEquals(Vector3(0.817587, 0.575743, 0.00307211)));
      final bitangent_0_214 = mesh_0.bitangents.elementAt(214);
      expect(bitangent_0_214, vector3MoreOrLessEquals(Vector3(0.334556, 0.942341, 0.00221181)));
      final bitangent_0_215 = mesh_0.bitangents.elementAt(215);
      expect(bitangent_0_215, vector3MoreOrLessEquals(Vector3(0.331826, 0.943306, 0.00220552)));
      final bitangent_0_216 = mesh_0.bitangents.elementAt(216);
      expect(bitangent_0_216, vector3MoreOrLessEquals(Vector3(0.897752, 0.421699, -0.12714)));
      final bitangent_0_217 = mesh_0.bitangents.elementAt(217);
      expect(bitangent_0_217, vector3MoreOrLessEquals(Vector3(0.891929, 0.41915, -0.169452)));
      final bitangent_0_218 = mesh_0.bitangents.elementAt(218);
      expect(bitangent_0_218, vector3MoreOrLessEquals(Vector3(0.613302, 0.29141, -0.734084)));
      final bitangent_0_219 = mesh_0.bitangents.elementAt(219);
      expect(bitangent_0_219, vector3MoreOrLessEquals(Vector3(0.582283, 0.277014, -0.764293)));
      final bitangent_0_220 = mesh_0.bitangents.elementAt(220);
      expect(bitangent_0_220, vector3MoreOrLessEquals(Vector3(-0.951218, -0.308429, 0.00305554)));
      final bitangent_0_221 = mesh_0.bitangents.elementAt(221);
      expect(bitangent_0_221, vector3MoreOrLessEquals(Vector3(-0.949402, -0.313974, 0.00305693)));
      final bitangent_0_222 = mesh_0.bitangents.elementAt(222);
      expect(bitangent_0_222, vector3MoreOrLessEquals(Vector3(-0.902911, 0.429744, 0.00221635)));
      final bitangent_0_223 = mesh_0.bitangents.elementAt(223);
      expect(bitangent_0_223, vector3MoreOrLessEquals(Vector3(-0.901661, 0.432362, 0.00221023)));
      final bitangent_0_224 = mesh_0.bitangents.elementAt(224);
      expect(bitangent_0_224, vector3MoreOrLessEquals(Vector3(0.891916, 0.419196, 0.169408)));
      final bitangent_0_225 = mesh_0.bitangents.elementAt(225);
      expect(bitangent_0_225, vector3MoreOrLessEquals(Vector3(0.897726, 0.42174, 0.127189)));
      final bitangent_0_226 = mesh_0.bitangents.elementAt(226);
      expect(bitangent_0_226, vector3MoreOrLessEquals(Vector3(0.582251, 0.277039, 0.764307)));
      final bitangent_0_227 = mesh_0.bitangents.elementAt(227);
      expect(bitangent_0_227, vector3MoreOrLessEquals(Vector3(0.613304, 0.291453, 0.734066)));
      final bitangent_0_228 = mesh_0.bitangents.elementAt(228);
      expect(bitangent_0_228, vector3MoreOrLessEquals(Vector3(0.610705, 0.250467, 0.751162)));
      final bitangent_0_229 = mesh_0.bitangents.elementAt(229);
      expect(bitangent_0_229, vector3MoreOrLessEquals(Vector3(0.612862, 0.251368, 0.749098)));
      final bitangent_0_230 = mesh_0.bitangents.elementAt(230);
      expect(bitangent_0_230, vector3MoreOrLessEquals(Vector3(-0.608947, -0.25473, 0.751152)));
      final bitangent_0_231 = mesh_0.bitangents.elementAt(231);
      expect(bitangent_0_231, vector3MoreOrLessEquals(Vector3(-0.611096, -0.255613, 0.749108)));
      final bitangent_0_232 = mesh_0.bitangents.elementAt(232);
      expect(bitangent_0_232, vector3MoreOrLessEquals(Vector3(-0.465911, 0.325697, 0.822666)));
      final bitangent_0_233 = mesh_0.bitangents.elementAt(233);
      expect(bitangent_0_233, vector3MoreOrLessEquals(Vector3(-0.78827, 0.47941, 0.385622)));
      final bitangent_0_234 = mesh_0.bitangents.elementAt(234);
      expect(bitangent_0_234, vector3MoreOrLessEquals(Vector3(-0.923835, 0.382792, 0)));
      final bitangent_0_235 = mesh_0.bitangents.elementAt(235);
      expect(bitangent_0_235, vector3MoreOrLessEquals(Vector3(-0.559636, 0.0993084, 0.822711)));
      final bitangent_0_236 = mesh_0.bitangents.elementAt(236);
      expect(bitangent_0_236, vector3MoreOrLessEquals(Vector3(-0.465911, 0.325697, 0.822666)));
      final bitangent_0_237 = mesh_0.bitangents.elementAt(237);
      expect(bitangent_0_237, vector3MoreOrLessEquals(Vector3(-0.923835, 0.382792, 0)));
      final bitangent_0_238 = mesh_0.bitangents.elementAt(238);
      expect(bitangent_0_238, vector3MoreOrLessEquals(Vector3(-0.89628, 0.218513, 0.385831)));
      final bitangent_0_239 = mesh_0.bitangents.elementAt(239);
      expect(bitangent_0_239, vector3MoreOrLessEquals(Vector3(-0.559636, 0.0993084, 0.822711)));
      final bitangent_0_240 = mesh_0.bitangents.elementAt(240);
      expect(bitangent_0_240, vector3MoreOrLessEquals(Vector3(-0.923835, 0.382792, 0)));
      final bitangent_0_241 = mesh_0.bitangents.elementAt(241);
      expect(bitangent_0_241, vector3MoreOrLessEquals(Vector3(-0.788239, 0.485807, -0.377596)));
      final bitangent_0_242 = mesh_0.bitangents.elementAt(242);
      expect(bitangent_0_242, vector3MoreOrLessEquals(Vector3(-0.89628, 0.218513, 0.385831)));
      final bitangent_0_243 = mesh_0.bitangents.elementAt(243);
      expect(bitangent_0_243, vector3MoreOrLessEquals(Vector3(-0.923835, 0.382792, 0)));
      final bitangent_0_244 = mesh_0.bitangents.elementAt(244);
      expect(bitangent_0_244, vector3MoreOrLessEquals(Vector3(-0.465414, 0.328609, -0.821789)));
      final bitangent_0_245 = mesh_0.bitangents.elementAt(245);
      expect(bitangent_0_245, vector3MoreOrLessEquals(Vector3(-0.788239, 0.485807, -0.377596)));
      final bitangent_0_246 = mesh_0.bitangents.elementAt(246);
      expect(bitangent_0_246, vector3MoreOrLessEquals(Vector3(-0.923835, 0.382792, 0)));
      final bitangent_0_247 = mesh_0.bitangents.elementAt(247);
      expect(bitangent_0_247, vector3MoreOrLessEquals(Vector3(-0.561343, 0.0968985, -0.821834)));
      final bitangent_0_248 = mesh_0.bitangents.elementAt(248);
      expect(bitangent_0_248, vector3MoreOrLessEquals(Vector3(-0.465414, 0.328609, -0.821789)));
      final bitangent_0_249 = mesh_0.bitangents.elementAt(249);
      expect(bitangent_0_249, vector3MoreOrLessEquals(Vector3(-0.923835, 0.382792, 0)));
      final bitangent_0_250 = mesh_0.bitangents.elementAt(250);
      expect(bitangent_0_250, vector3MoreOrLessEquals(Vector3(-0.90078, 0.213972, -0.377813)));
      final bitangent_0_251 = mesh_0.bitangents.elementAt(251);
      expect(bitangent_0_251, vector3MoreOrLessEquals(Vector3(-0.561343, 0.0968985, -0.821834)));
      final bitangent_0_252 = mesh_0.bitangents.elementAt(252);
      expect(bitangent_0_252, vector3MoreOrLessEquals(Vector3(-0.923835, 0.382792, 0)));
      final bitangent_0_253 = mesh_0.bitangents.elementAt(253);
      expect(bitangent_0_253, vector3MoreOrLessEquals(Vector3(-0.78827, 0.47941, 0.385622)));
      final bitangent_0_254 = mesh_0.bitangents.elementAt(254);
      expect(bitangent_0_254, vector3MoreOrLessEquals(Vector3(-0.90078, 0.213972, -0.377813)));
      final bitangent_0_255 = mesh_0.bitangents.elementAt(255);
      expect(bitangent_0_255, vector3MoreOrLessEquals(Vector3(-0.923835, 0.382792, 0)));
      expect(mesh_0.colors.length, isZero);
      expect(mesh_0.textureCoords.length, equals(1));
      final textureCoords_0_0 = mesh_0.textureCoords.elementAt(0);
      expect(textureCoords_0_0.length, equals(256));
      final textureCoord_0_0_0 = textureCoords_0_0.elementAt(0);
      expect(textureCoord_0_0_0, vector3MoreOrLessEquals(Vector3(-0.617296, 0.98396, 0)));
      final textureCoord_0_0_1 = textureCoords_0_0.elementAt(1);
      expect(textureCoord_0_0_1, vector3MoreOrLessEquals(Vector3(-0.736438, 1.27163, 0)));
      final textureCoord_0_0_2 = textureCoords_0_0.elementAt(2);
      expect(textureCoord_0_0_2, vector3MoreOrLessEquals(Vector3(-0.904966, 1.1031, 0)));
      final textureCoord_0_0_3 = textureCoords_0_0.elementAt(3);
      expect(textureCoord_0_0_3, vector3MoreOrLessEquals(Vector3(-0.617296, 0.98396, 0)));
      final textureCoord_0_0_4 = textureCoords_0_0.elementAt(4);
      expect(textureCoord_0_0_4, vector3MoreOrLessEquals(Vector3(-0.904966, 1.1031, 0)));
      final textureCoord_0_0_5 = textureCoords_0_0.elementAt(5);
      expect(textureCoord_0_0_5, vector3MoreOrLessEquals(Vector3(-0.904982, 0.864781, 0)));
      final textureCoord_0_0_6 = textureCoords_0_0.elementAt(6);
      expect(textureCoord_0_0_6, vector3MoreOrLessEquals(Vector3(-0.617296, 0.98396, 0)));
      final textureCoord_0_0_7 = textureCoords_0_0.elementAt(7);
      expect(textureCoord_0_0_7, vector3MoreOrLessEquals(Vector3(-0.904982, 0.864781, 0)));
      final textureCoord_0_0_8 = textureCoords_0_0.elementAt(8);
      expect(textureCoord_0_0_8, vector3MoreOrLessEquals(Vector3(-0.736475, 0.696275, 0)));
      final textureCoord_0_0_9 = textureCoords_0_0.elementAt(9);
      expect(textureCoord_0_0_9, vector3MoreOrLessEquals(Vector3(-0.617296, 0.98396, 0)));
      final textureCoord_0_0_10 = textureCoords_0_0.elementAt(10);
      expect(textureCoord_0_0_10, vector3MoreOrLessEquals(Vector3(-0.736475, 0.696275, 0)));
      final textureCoord_0_0_11 = textureCoords_0_0.elementAt(11);
      expect(textureCoord_0_0_11, vector3MoreOrLessEquals(Vector3(-0.498155, 0.69629, 0)));
      final textureCoord_0_0_12 = textureCoords_0_0.elementAt(12);
      expect(textureCoord_0_0_12, vector3MoreOrLessEquals(Vector3(-0.617296, 0.98396, 0)));
      final textureCoord_0_0_13 = textureCoords_0_0.elementAt(13);
      expect(textureCoord_0_0_13, vector3MoreOrLessEquals(Vector3(-0.498155, 0.69629, 0)));
      final textureCoord_0_0_14 = textureCoords_0_0.elementAt(14);
      expect(textureCoord_0_0_14, vector3MoreOrLessEquals(Vector3(-0.329626, 0.864819, 0)));
      final textureCoord_0_0_15 = textureCoords_0_0.elementAt(15);
      expect(textureCoord_0_0_15, vector3MoreOrLessEquals(Vector3(-0.617296, 0.98396, 0)));
      final textureCoord_0_0_16 = textureCoords_0_0.elementAt(16);
      expect(textureCoord_0_0_16, vector3MoreOrLessEquals(Vector3(-0.329626, 0.864819, 0)));
      final textureCoord_0_0_17 = textureCoords_0_0.elementAt(17);
      expect(textureCoord_0_0_17, vector3MoreOrLessEquals(Vector3(-0.329611, 1.10314, 0)));
      final textureCoord_0_0_18 = textureCoords_0_0.elementAt(18);
      expect(textureCoord_0_0_18, vector3MoreOrLessEquals(Vector3(-0.617296, 0.98396, 0)));
      final textureCoord_0_0_19 = textureCoords_0_0.elementAt(19);
      expect(textureCoord_0_0_19, vector3MoreOrLessEquals(Vector3(-0.329611, 1.10314, 0)));
      final textureCoord_0_0_20 = textureCoords_0_0.elementAt(20);
      expect(textureCoord_0_0_20, vector3MoreOrLessEquals(Vector3(-0.498118, 1.27165, 0)));
      final textureCoord_0_0_21 = textureCoords_0_0.elementAt(21);
      expect(textureCoord_0_0_21, vector3MoreOrLessEquals(Vector3(-0.498118, 1.27165, 0)));
      final textureCoord_0_0_22 = textureCoords_0_0.elementAt(22);
      expect(textureCoord_0_0_22, vector3MoreOrLessEquals(Vector3(-0.736438, 1.27163, 0)));
      final textureCoord_0_0_23 = textureCoords_0_0.elementAt(23);
      expect(textureCoord_0_0_23, vector3MoreOrLessEquals(Vector3(-0.617296, 0.98396, 0)));
      final textureCoord_0_0_24 = textureCoords_0_0.elementAt(24);
      expect(textureCoord_0_0_24, vector3MoreOrLessEquals(Vector3(-0.498147, 1.27165, 0)));
      final textureCoord_0_0_25 = textureCoords_0_0.elementAt(25);
      expect(textureCoord_0_0_25, vector3MoreOrLessEquals(Vector3(-0.539346, 1.48367, 0)));
      final textureCoord_0_0_26 = textureCoords_0_0.elementAt(26);
      expect(textureCoord_0_0_26, vector3MoreOrLessEquals(Vector3(-0.693983, 1.48414, 0)));
      final textureCoord_0_0_27 = textureCoords_0_0.elementAt(27);
      expect(textureCoord_0_0_27, vector3MoreOrLessEquals(Vector3(-0.736482, 1.27238, 0)));
      final textureCoord_0_0_28 = textureCoords_0_0.elementAt(28);
      expect(textureCoord_0_0_28, vector3MoreOrLessEquals(Vector3(0.656824, -0.4803, 0)));
      final textureCoord_0_0_29 = textureCoords_0_0.elementAt(29);
      expect(textureCoord_0_0_29, vector3MoreOrLessEquals(Vector3(0.445778, -0.579241, 0)));
      final textureCoord_0_0_30 = textureCoords_0_0.elementAt(30);
      expect(textureCoord_0_0_30, vector3MoreOrLessEquals(Vector3(0.446479, -0.692158, 0)));
      final textureCoord_0_0_31 = textureCoords_0_0.elementAt(31);
      expect(textureCoord_0_0_31, vector3MoreOrLessEquals(Vector3(0.657903, -0.654335, 0)));
      final textureCoord_0_0_32 = textureCoords_0_0.elementAt(32);
      expect(textureCoord_0_0_32, vector3MoreOrLessEquals(Vector3(0.657903, -0.654335, 0)));
      final textureCoord_0_0_33 = textureCoords_0_0.elementAt(33);
      expect(textureCoord_0_0_33, vector3MoreOrLessEquals(Vector3(0.446479, -0.692158, 0)));
      final textureCoord_0_0_34 = textureCoords_0_0.elementAt(34);
      expect(textureCoord_0_0_34, vector3MoreOrLessEquals(Vector3(0.445954, -0.84671, 0)));
      final textureCoord_0_0_35 = textureCoords_0_0.elementAt(35);
      expect(textureCoord_0_0_35, vector3MoreOrLessEquals(Vector3(0.657094, -0.892538, 0)));
      final textureCoord_0_0_36 = textureCoords_0_0.elementAt(36);
      expect(textureCoord_0_0_36, vector3MoreOrLessEquals(Vector3(1.23329, -0.887343, 0)));
      final textureCoord_0_0_37 = textureCoords_0_0.elementAt(37);
      expect(textureCoord_0_0_37, vector3MoreOrLessEquals(Vector3(1.13096, -0.677021, 0)));
      final textureCoord_0_0_38 = textureCoords_0_0.elementAt(38);
      expect(textureCoord_0_0_38, vector3MoreOrLessEquals(Vector3(1.02163, -0.679442, 0)));
      final textureCoord_0_0_39 = textureCoords_0_0.elementAt(39);
      expect(textureCoord_0_0_39, vector3MoreOrLessEquals(Vector3(1.06478, -0.891075, 0)));
      final textureCoord_0_0_40 = textureCoords_0_0.elementAt(40);
      expect(textureCoord_0_0_40, vector3MoreOrLessEquals(Vector3(1.06478, -0.891075, 0)));
      final textureCoord_0_0_41 = textureCoords_0_0.elementAt(41);
      expect(textureCoord_0_0_41, vector3MoreOrLessEquals(Vector3(1.02163, -0.679442, 0)));
      final textureCoord_0_0_42 = textureCoords_0_0.elementAt(42);
      expect(textureCoord_0_0_42, vector3MoreOrLessEquals(Vector3(0.866993, -0.680391, 0)));
      final textureCoord_0_0_43 = textureCoords_0_0.elementAt(43);
      expect(textureCoord_0_0_43, vector3MoreOrLessEquals(Vector3(0.826445, -0.892538, 0)));
      final textureCoord_0_0_44 = textureCoords_0_0.elementAt(44);
      expect(textureCoord_0_0_44, vector3MoreOrLessEquals(Vector3(0.826445, -0.892538, 0)));
      final textureCoord_0_0_45 = textureCoords_0_0.elementAt(45);
      expect(textureCoord_0_0_45, vector3MoreOrLessEquals(Vector3(0.866993, -0.680391, 0)));
      final textureCoord_0_0_46 = textureCoords_0_0.elementAt(46);
      expect(textureCoord_0_0_46, vector3MoreOrLessEquals(Vector3(0.757639, -0.679311, 0)));
      final textureCoord_0_0_47 = textureCoords_0_0.elementAt(47);
      expect(textureCoord_0_0_47, vector3MoreOrLessEquals(Vector3(0.657903, -0.890874, 0)));
      final textureCoord_0_0_48 = textureCoords_0_0.elementAt(48);
      expect(textureCoord_0_0_48, vector3MoreOrLessEquals(Vector3(1.64296, -0.891078, 0)));
      final textureCoord_0_0_49 = textureCoords_0_0.elementAt(49);
      expect(textureCoord_0_0_49, vector3MoreOrLessEquals(Vector3(1.59994, -0.680045, 0)));
      final textureCoord_0_0_50 = textureCoords_0_0.elementAt(50);
      expect(textureCoord_0_0_50, vector3MoreOrLessEquals(Vector3(1.44531, -0.680992, 0)));
      final textureCoord_0_0_51 = textureCoords_0_0.elementAt(51);
      expect(textureCoord_0_0_51, vector3MoreOrLessEquals(Vector3(1.40463, -0.892538, 0)));
      final textureCoord_0_0_52 = textureCoords_0_0.elementAt(52);
      expect(textureCoord_0_0_52, vector3MoreOrLessEquals(Vector3(-0.539346, 1.48367, 0)));
      final textureCoord_0_0_53 = textureCoords_0_0.elementAt(53);
      expect(textureCoord_0_0_53, vector3MoreOrLessEquals(Vector3(-0.498147, 1.27165, 0)));
      final textureCoord_0_0_54 = textureCoords_0_0.elementAt(54);
      expect(textureCoord_0_0_54, vector3MoreOrLessEquals(Vector3(-0.329611, 1.27383, 0)));
      final textureCoord_0_0_55 = textureCoords_0_0.elementAt(55);
      expect(textureCoord_0_0_55, vector3MoreOrLessEquals(Vector3(-0.429996, 1.48508, 0)));
      final textureCoord_0_0_56 = textureCoords_0_0.elementAt(56);
      expect(textureCoord_0_0_56, vector3MoreOrLessEquals(Vector3(1.33609, -0.680579, 0)));
      final textureCoord_0_0_57 = textureCoords_0_0.elementAt(57);
      expect(textureCoord_0_0_57, vector3MoreOrLessEquals(Vector3(1.44531, -0.680992, 0)));
      final textureCoord_0_0_58 = textureCoords_0_0.elementAt(58);
      expect(textureCoord_0_0_58, vector3MoreOrLessEquals(Vector3(1.40161, -0.400564, 0)));
      final textureCoord_0_0_59 = textureCoords_0_0.elementAt(59);
      expect(textureCoord_0_0_59, vector3MoreOrLessEquals(Vector3(1.23329, -0.399928, 0)));
      final textureCoord_0_0_60 = textureCoords_0_0.elementAt(60);
      expect(textureCoord_0_0_60, vector3MoreOrLessEquals(Vector3(1.44531, -0.680992, 0)));
      final textureCoord_0_0_61 = textureCoords_0_0.elementAt(61);
      expect(textureCoord_0_0_61, vector3MoreOrLessEquals(Vector3(1.59994, -0.680045, 0)));
      final textureCoord_0_0_62 = textureCoords_0_0.elementAt(62);
      expect(textureCoord_0_0_62, vector3MoreOrLessEquals(Vector3(1.63994, -0.399105, 0)));
      final textureCoord_0_0_63 = textureCoords_0_0.elementAt(63);
      expect(textureCoord_0_0_63, vector3MoreOrLessEquals(Vector3(1.40161, -0.400564, 0)));
      final textureCoord_0_0_64 = textureCoords_0_0.elementAt(64);
      expect(textureCoord_0_0_64, vector3MoreOrLessEquals(Vector3(1.59994, -0.680045, 0)));
      final textureCoord_0_0_65 = textureCoords_0_0.elementAt(65);
      expect(textureCoord_0_0_65, vector3MoreOrLessEquals(Vector3(1.70941, -0.678293, 0)));
      final textureCoord_0_0_66 = textureCoords_0_0.elementAt(66);
      expect(textureCoord_0_0_66, vector3MoreOrLessEquals(Vector3(1.80867, -0.396404, 0)));
      final textureCoord_0_0_67 = textureCoords_0_0.elementAt(67);
      expect(textureCoord_0_0_67, vector3MoreOrLessEquals(Vector3(1.63994, -0.399105, 0)));
      final textureCoord_0_0_68 = textureCoords_0_0.elementAt(68);
      expect(textureCoord_0_0_68, vector3MoreOrLessEquals(Vector3(0.866993, -0.680391, 0)));
      final textureCoord_0_0_69 = textureCoords_0_0.elementAt(69);
      expect(textureCoord_0_0_69, vector3MoreOrLessEquals(Vector3(1.02163, -0.679442, 0)));
      final textureCoord_0_0_70 = textureCoords_0_0.elementAt(70);
      expect(textureCoord_0_0_70, vector3MoreOrLessEquals(Vector3(1.06176, -0.399141, 0)));
      final textureCoord_0_0_71 = textureCoords_0_0.elementAt(71);
      expect(textureCoord_0_0_71, vector3MoreOrLessEquals(Vector3(0.823427, -0.400603, 0)));
      final textureCoord_0_0_72 = textureCoords_0_0.elementAt(72);
      expect(textureCoord_0_0_72, vector3MoreOrLessEquals(Vector3(1.02163, -0.679442, 0)));
      final textureCoord_0_0_73 = textureCoords_0_0.elementAt(73);
      expect(textureCoord_0_0_73, vector3MoreOrLessEquals(Vector3(1.13096, -0.677021, 0)));
      final textureCoord_0_0_74 = textureCoords_0_0.elementAt(74);
      expect(textureCoord_0_0_74, vector3MoreOrLessEquals(Vector3(1.23027, -0.395409, 0)));
      final textureCoord_0_0_75 = textureCoords_0_0.elementAt(75);
      expect(textureCoord_0_0_75, vector3MoreOrLessEquals(Vector3(1.06176, -0.399141, 0)));
      final textureCoord_0_0_76 = textureCoords_0_0.elementAt(76);
      expect(textureCoord_0_0_76, vector3MoreOrLessEquals(Vector3(0.445954, -0.84671, 0)));
      final textureCoord_0_0_77 = textureCoords_0_0.elementAt(77);
      expect(textureCoord_0_0_77, vector3MoreOrLessEquals(Vector3(0.446479, -0.692158, 0)));
      final textureCoord_0_0_78 = textureCoords_0_0.elementAt(78);
      expect(textureCoord_0_0_78, vector3MoreOrLessEquals(Vector3(0.165923, -0.652826, 0)));
      final textureCoord_0_0_79 = textureCoords_0_0.elementAt(79);
      expect(textureCoord_0_0_79, vector3MoreOrLessEquals(Vector3(0.165113, -0.891029, 0)));
      final textureCoord_0_0_80 = textureCoords_0_0.elementAt(80);
      expect(textureCoord_0_0_80, vector3MoreOrLessEquals(Vector3(0.446479, -0.692158, 0)));
      final textureCoord_0_0_81 = textureCoords_0_0.elementAt(81);
      expect(textureCoord_0_0_81, vector3MoreOrLessEquals(Vector3(0.445778, -0.579241, 0)));
      final textureCoord_0_0_82 = textureCoords_0_0.elementAt(82);
      expect(textureCoord_0_0_82, vector3MoreOrLessEquals(Vector3(0.164843, -0.478791, 0)));
      final textureCoord_0_0_83 = textureCoords_0_0.elementAt(83);
      expect(textureCoord_0_0_83, vector3MoreOrLessEquals(Vector3(0.165923, -0.652826, 0)));
      final textureCoord_0_0_84 = textureCoords_0_0.elementAt(84);
      expect(textureCoord_0_0_84, vector3MoreOrLessEquals(Vector3(-0.693983, 1.48414, 0)));
      final textureCoord_0_0_85 = textureCoords_0_0.elementAt(85);
      expect(textureCoord_0_0_85, vector3MoreOrLessEquals(Vector3(-0.539346, 1.48367, 0)));
      final textureCoord_0_0_86 = textureCoords_0_0.elementAt(86);
      expect(textureCoord_0_0_86, vector3MoreOrLessEquals(Vector3(-0.496638, 1.76359, 0)));
      final textureCoord_0_0_87 = textureCoords_0_0.elementAt(87);
      expect(textureCoord_0_0_87, vector3MoreOrLessEquals(Vector3(-0.734972, 1.76432, 0)));
      final textureCoord_0_0_88 = textureCoords_0_0.elementAt(88);
      expect(textureCoord_0_0_88, vector3MoreOrLessEquals(Vector3(0.165923, -0.652826, 0)));
      final textureCoord_0_0_89 = textureCoords_0_0.elementAt(89);
      expect(textureCoord_0_0_89, vector3MoreOrLessEquals(Vector3(0.164843, -0.478791, 0)));
      final textureCoord_0_0_90 = textureCoords_0_0.elementAt(90);
      expect(textureCoord_0_0_90, vector3MoreOrLessEquals(Vector3(-0.171016, -0.477761, 0)));
      final textureCoord_0_0_91 = textureCoords_0_0.elementAt(91);
      expect(textureCoord_0_0_91, vector3MoreOrLessEquals(Vector3(-0.169937, -0.651795, 0)));
      final textureCoord_0_0_92 = textureCoords_0_0.elementAt(92);
      expect(textureCoord_0_0_92, vector3MoreOrLessEquals(Vector3(0.165113, -0.891029, 0)));
      final textureCoord_0_0_93 = textureCoords_0_0.elementAt(93);
      expect(textureCoord_0_0_93, vector3MoreOrLessEquals(Vector3(0.165923, -0.652826, 0)));
      final textureCoord_0_0_94 = textureCoords_0_0.elementAt(94);
      expect(textureCoord_0_0_94, vector3MoreOrLessEquals(Vector3(-0.169937, -0.651795, 0)));
      final textureCoord_0_0_95 = textureCoords_0_0.elementAt(95);
      expect(textureCoord_0_0_95, vector3MoreOrLessEquals(Vector3(-0.170746, -0.889998, 0)));
      final textureCoord_0_0_96 = textureCoords_0_0.elementAt(96);
      expect(textureCoord_0_0_96, vector3MoreOrLessEquals(Vector3(1.06176, -0.399141, 0)));
      final textureCoord_0_0_97 = textureCoords_0_0.elementAt(97);
      expect(textureCoord_0_0_97, vector3MoreOrLessEquals(Vector3(1.23027, -0.395409, 0)));
      final textureCoord_0_0_98 = textureCoords_0_0.elementAt(98);
      expect(textureCoord_0_0_98, vector3MoreOrLessEquals(Vector3(1.22821, -0.0595806, 0)));
      final textureCoord_0_0_99 = textureCoords_0_0.elementAt(99);
      expect(textureCoord_0_0_99, vector3MoreOrLessEquals(Vector3(1.0597, -0.0633129, 0)));
      final textureCoord_0_0_100 = textureCoords_0_0.elementAt(100);
      expect(textureCoord_0_0_100, vector3MoreOrLessEquals(Vector3(0.823427, -0.400603, 0)));
      final textureCoord_0_0_101 = textureCoords_0_0.elementAt(101);
      expect(textureCoord_0_0_101, vector3MoreOrLessEquals(Vector3(1.06176, -0.399141, 0)));
      final textureCoord_0_0_102 = textureCoords_0_0.elementAt(102);
      expect(textureCoord_0_0_102, vector3MoreOrLessEquals(Vector3(1.0597, -0.0633129, 0)));
      final textureCoord_0_0_103 = textureCoords_0_0.elementAt(103);
      expect(textureCoord_0_0_103, vector3MoreOrLessEquals(Vector3(0.821366, -0.0647753, 0)));
      final textureCoord_0_0_104 = textureCoords_0_0.elementAt(104);
      expect(textureCoord_0_0_104, vector3MoreOrLessEquals(Vector3(1.63994, -0.399105, 0)));
      final textureCoord_0_0_105 = textureCoords_0_0.elementAt(105);
      expect(textureCoord_0_0_105, vector3MoreOrLessEquals(Vector3(1.80867, -0.396404, 0)));
      final textureCoord_0_0_106 = textureCoords_0_0.elementAt(106);
      expect(textureCoord_0_0_106, vector3MoreOrLessEquals(Vector3(1.80661, -0.0605494, 0)));
      final textureCoord_0_0_107 = textureCoords_0_0.elementAt(107);
      expect(textureCoord_0_0_107, vector3MoreOrLessEquals(Vector3(1.63788, -0.0632502, 0)));
      final textureCoord_0_0_108 = textureCoords_0_0.elementAt(108);
      expect(textureCoord_0_0_108, vector3MoreOrLessEquals(Vector3(1.40161, -0.400564, 0)));
      final textureCoord_0_0_109 = textureCoords_0_0.elementAt(109);
      expect(textureCoord_0_0_109, vector3MoreOrLessEquals(Vector3(1.63994, -0.399105, 0)));
      final textureCoord_0_0_110 = textureCoords_0_0.elementAt(110);
      expect(textureCoord_0_0_110, vector3MoreOrLessEquals(Vector3(1.63788, -0.0632502, 0)));
      final textureCoord_0_0_111 = textureCoords_0_0.elementAt(111);
      expect(textureCoord_0_0_111, vector3MoreOrLessEquals(Vector3(1.39955, -0.0647097, 0)));
      final textureCoord_0_0_112 = textureCoords_0_0.elementAt(112);
      expect(textureCoord_0_0_112, vector3MoreOrLessEquals(Vector3(1.47113, 0.673469, 0)));
      final textureCoord_0_0_113 = textureCoords_0_0.elementAt(113);
      expect(textureCoord_0_0_113, vector3MoreOrLessEquals(Vector3(1.63967, 0.675651, 0)));
      final textureCoord_0_0_114 = textureCoords_0_0.elementAt(114);
      expect(textureCoord_0_0_114, vector3MoreOrLessEquals(Vector3(1.6407, 1.01148, 0)));
      final textureCoord_0_0_115 = textureCoords_0_0.elementAt(115);
      expect(textureCoord_0_0_115, vector3MoreOrLessEquals(Vector3(1.47216, 1.0093, 0)));
      final textureCoord_0_0_116 = textureCoords_0_0.elementAt(116);
      expect(textureCoord_0_0_116, vector3MoreOrLessEquals(Vector3(1.47216, 1.0093, 0)));
      final textureCoord_0_0_117 = textureCoords_0_0.elementAt(117);
      expect(textureCoord_0_0_117, vector3MoreOrLessEquals(Vector3(1.6407, 1.01148, 0)));
      final textureCoord_0_0_118 = textureCoords_0_0.elementAt(118);
      expect(textureCoord_0_0_118, vector3MoreOrLessEquals(Vector3(1.64179, 1.36898, 0)));
      final textureCoord_0_0_119 = textureCoords_0_0.elementAt(119);
      expect(textureCoord_0_0_119, vector3MoreOrLessEquals(Vector3(1.47326, 1.3668, 0)));
      final textureCoord_0_0_120 = textureCoords_0_0.elementAt(120);
      expect(textureCoord_0_0_120, vector3MoreOrLessEquals(Vector3(1.39955, -0.0647097, 0)));
      final textureCoord_0_0_121 = textureCoords_0_0.elementAt(121);
      expect(textureCoord_0_0_121, vector3MoreOrLessEquals(Vector3(1.63788, -0.0632502, 0)));
      final textureCoord_0_0_122 = textureCoords_0_0.elementAt(122);
      expect(textureCoord_0_0_122, vector3MoreOrLessEquals(Vector3(1.63569, 0.294273, 0)));
      final textureCoord_0_0_123 = textureCoords_0_0.elementAt(123);
      expect(textureCoord_0_0_123, vector3MoreOrLessEquals(Vector3(1.39736, 0.292813, 0)));
      final textureCoord_0_0_124 = textureCoords_0_0.elementAt(124);
      expect(textureCoord_0_0_124, vector3MoreOrLessEquals(Vector3(1.63788, -0.0632502, 0)));
      final textureCoord_0_0_125 = textureCoords_0_0.elementAt(125);
      expect(textureCoord_0_0_125, vector3MoreOrLessEquals(Vector3(1.80661, -0.0605494, 0)));
      final textureCoord_0_0_126 = textureCoords_0_0.elementAt(126);
      expect(textureCoord_0_0_126, vector3MoreOrLessEquals(Vector3(1.80441, 0.296973, 0)));
      final textureCoord_0_0_127 = textureCoords_0_0.elementAt(127);
      expect(textureCoord_0_0_127, vector3MoreOrLessEquals(Vector3(1.63569, 0.294273, 0)));
      final textureCoord_0_0_128 = textureCoords_0_0.elementAt(128);
      expect(textureCoord_0_0_128, vector3MoreOrLessEquals(Vector3(0.821366, -0.0647753, 0)));
      final textureCoord_0_0_129 = textureCoords_0_0.elementAt(129);
      expect(textureCoord_0_0_129, vector3MoreOrLessEquals(Vector3(1.0597, -0.0633129, 0)));
      final textureCoord_0_0_130 = textureCoords_0_0.elementAt(130);
      expect(textureCoord_0_0_130, vector3MoreOrLessEquals(Vector3(1.0575, 0.294182, 0)));
      final textureCoord_0_0_131 = textureCoords_0_0.elementAt(131);
      expect(textureCoord_0_0_131, vector3MoreOrLessEquals(Vector3(0.819172, 0.292719, 0)));
      final textureCoord_0_0_132 = textureCoords_0_0.elementAt(132);
      expect(textureCoord_0_0_132, vector3MoreOrLessEquals(Vector3(1.0597, -0.0633129, 0)));
      final textureCoord_0_0_133 = textureCoords_0_0.elementAt(133);
      expect(textureCoord_0_0_133, vector3MoreOrLessEquals(Vector3(1.22821, -0.0595806, 0)));
      final textureCoord_0_0_134 = textureCoords_0_0.elementAt(134);
      expect(textureCoord_0_0_134, vector3MoreOrLessEquals(Vector3(1.22601, 0.297914, 0)));
      final textureCoord_0_0_135 = textureCoords_0_0.elementAt(135);
      expect(textureCoord_0_0_135, vector3MoreOrLessEquals(Vector3(1.0575, 0.294182, 0)));
      final textureCoord_0_0_136 = textureCoords_0_0.elementAt(136);
      expect(textureCoord_0_0_136, vector3MoreOrLessEquals(Vector3(-0.170746, -0.889998, 0)));
      final textureCoord_0_0_137 = textureCoords_0_0.elementAt(137);
      expect(textureCoord_0_0_137, vector3MoreOrLessEquals(Vector3(-0.169937, -0.651795, 0)));
      final textureCoord_0_0_138 = textureCoords_0_0.elementAt(138);
      expect(textureCoord_0_0_138, vector3MoreOrLessEquals(Vector3(-0.527465, -0.650698, 0)));
      final textureCoord_0_0_139 = textureCoords_0_0.elementAt(139);
      expect(textureCoord_0_0_139, vector3MoreOrLessEquals(Vector3(-0.528274, -0.888901, 0)));
      final textureCoord_0_0_140 = textureCoords_0_0.elementAt(140);
      expect(textureCoord_0_0_140, vector3MoreOrLessEquals(Vector3(-0.169937, -0.651795, 0)));
      final textureCoord_0_0_141 = textureCoords_0_0.elementAt(141);
      expect(textureCoord_0_0_141, vector3MoreOrLessEquals(Vector3(-0.171016, -0.477761, 0)));
      final textureCoord_0_0_142 = textureCoords_0_0.elementAt(142);
      expect(textureCoord_0_0_142, vector3MoreOrLessEquals(Vector3(-0.528544, -0.476664, 0)));
      final textureCoord_0_0_143 = textureCoords_0_0.elementAt(143);
      expect(textureCoord_0_0_143, vector3MoreOrLessEquals(Vector3(-0.527465, -0.650698, 0)));
      final textureCoord_0_0_144 = textureCoords_0_0.elementAt(144);
      expect(textureCoord_0_0_144, vector3MoreOrLessEquals(Vector3(1.23383, 1.01003, 0)));
      final textureCoord_0_0_145 = textureCoords_0_0.elementAt(145);
      expect(textureCoord_0_0_145, vector3MoreOrLessEquals(Vector3(1.47216, 1.0093, 0)));
      final textureCoord_0_0_146 = textureCoords_0_0.elementAt(146);
      expect(textureCoord_0_0_146, vector3MoreOrLessEquals(Vector3(1.47326, 1.3668, 0)));
      final textureCoord_0_0_147 = textureCoords_0_0.elementAt(147);
      expect(textureCoord_0_0_147, vector3MoreOrLessEquals(Vector3(1.23492, 1.36753, 0)));
      final textureCoord_0_0_148 = textureCoords_0_0.elementAt(148);
      expect(textureCoord_0_0_148, vector3MoreOrLessEquals(Vector3(1.23492, 1.36753, 0)));
      final textureCoord_0_0_149 = textureCoords_0_0.elementAt(149);
      expect(textureCoord_0_0_149, vector3MoreOrLessEquals(Vector3(1.47326, 1.3668, 0)));
      final textureCoord_0_0_150 = textureCoords_0_0.elementAt(150);
      expect(textureCoord_0_0_150, vector3MoreOrLessEquals(Vector3(1.4772, 1.74314, 0)));
      final textureCoord_0_0_151 = textureCoords_0_0.elementAt(151);
      expect(textureCoord_0_0_151, vector3MoreOrLessEquals(Vector3(1.23329, 1.74389, 0)));
      final textureCoord_0_0_152 = textureCoords_0_0.elementAt(152);
      expect(textureCoord_0_0_152, vector3MoreOrLessEquals(Vector3(-0.527465, -0.650698, 0)));
      final textureCoord_0_0_153 = textureCoords_0_0.elementAt(153);
      expect(textureCoord_0_0_153, vector3MoreOrLessEquals(Vector3(-0.528544, -0.476664, 0)));
      final textureCoord_0_0_154 = textureCoords_0_0.elementAt(154);
      expect(textureCoord_0_0_154, vector3MoreOrLessEquals(Vector3(-0.904982, -0.468867, 0)));
      final textureCoord_0_0_155 = textureCoords_0_0.elementAt(155);
      expect(textureCoord_0_0_155, vector3MoreOrLessEquals(Vector3(-0.903877, -0.646978, 0)));
      final textureCoord_0_0_156 = textureCoords_0_0.elementAt(156);
      expect(textureCoord_0_0_156, vector3MoreOrLessEquals(Vector3(-0.528274, -0.888901, 0)));
      final textureCoord_0_0_157 = textureCoords_0_0.elementAt(157);
      expect(textureCoord_0_0_157, vector3MoreOrLessEquals(Vector3(-0.527465, -0.650698, 0)));
      final textureCoord_0_0_158 = textureCoords_0_0.elementAt(158);
      expect(textureCoord_0_0_158, vector3MoreOrLessEquals(Vector3(-0.903877, -0.646978, 0)));
      final textureCoord_0_0_159 = textureCoords_0_0.elementAt(159);
      expect(textureCoord_0_0_159, vector3MoreOrLessEquals(Vector3(-0.904705, -0.89076, 0)));
      final textureCoord_0_0_160 = textureCoords_0_0.elementAt(160);
      expect(textureCoord_0_0_160, vector3MoreOrLessEquals(Vector3(1.0575, 0.294182, 0)));
      final textureCoord_0_0_161 = textureCoords_0_0.elementAt(161);
      expect(textureCoord_0_0_161, vector3MoreOrLessEquals(Vector3(1.22601, 0.297914, 0)));
      final textureCoord_0_0_162 = textureCoords_0_0.elementAt(162);
      expect(textureCoord_0_0_162, vector3MoreOrLessEquals(Vector3(1.23044, 0.674363, 0)));
      final textureCoord_0_0_163 = textureCoords_0_0.elementAt(163);
      expect(textureCoord_0_0_163, vector3MoreOrLessEquals(Vector3(1.05799, 0.670543, 0)));
      final textureCoord_0_0_164 = textureCoords_0_0.elementAt(164);
      expect(textureCoord_0_0_164, vector3MoreOrLessEquals(Vector3(0.819172, 0.292719, 0)));
      final textureCoord_0_0_165 = textureCoords_0_0.elementAt(165);
      expect(textureCoord_0_0_165, vector3MoreOrLessEquals(Vector3(1.0575, 0.294182, 0)));
      final textureCoord_0_0_166 = textureCoords_0_0.elementAt(166);
      expect(textureCoord_0_0_166, vector3MoreOrLessEquals(Vector3(1.05799, 0.670543, 0)));
      final textureCoord_0_0_167 = textureCoords_0_0.elementAt(167);
      expect(textureCoord_0_0_167, vector3MoreOrLessEquals(Vector3(0.814072, 0.669047, 0)));
      final textureCoord_0_0_168 = textureCoords_0_0.elementAt(168);
      expect(textureCoord_0_0_168, vector3MoreOrLessEquals(Vector3(1.63569, 0.294273, 0)));
      final textureCoord_0_0_169 = textureCoords_0_0.elementAt(169);
      expect(textureCoord_0_0_169, vector3MoreOrLessEquals(Vector3(1.80441, 0.296973, 0)));
      final textureCoord_0_0_170 = textureCoords_0_0.elementAt(170);
      expect(textureCoord_0_0_170, vector3MoreOrLessEquals(Vector3(1.80884, 0.673469, 0)));
      final textureCoord_0_0_171 = textureCoords_0_0.elementAt(171);
      expect(textureCoord_0_0_171, vector3MoreOrLessEquals(Vector3(1.63616, 0.670705, 0)));
      final textureCoord_0_0_172 = textureCoords_0_0.elementAt(172);
      expect(textureCoord_0_0_172, vector3MoreOrLessEquals(Vector3(1.39736, 0.292813, 0)));
      final textureCoord_0_0_173 = textureCoords_0_0.elementAt(173);
      expect(textureCoord_0_0_173, vector3MoreOrLessEquals(Vector3(1.63569, 0.294273, 0)));
      final textureCoord_0_0_174 = textureCoords_0_0.elementAt(174);
      expect(textureCoord_0_0_174, vector3MoreOrLessEquals(Vector3(1.63616, 0.670705, 0)));
      final textureCoord_0_0_175 = textureCoords_0_0.elementAt(175);
      expect(textureCoord_0_0_175, vector3MoreOrLessEquals(Vector3(1.39225, 0.669212, 0)));
      final textureCoord_0_0_176 = textureCoords_0_0.elementAt(176);
      expect(textureCoord_0_0_176, vector3MoreOrLessEquals(Vector3(1.47326, 1.3668, 0)));
      final textureCoord_0_0_177 = textureCoords_0_0.elementAt(177);
      expect(textureCoord_0_0_177, vector3MoreOrLessEquals(Vector3(1.64179, 1.36898, 0)));
      final textureCoord_0_0_178 = textureCoords_0_0.elementAt(178);
      expect(textureCoord_0_0_178, vector3MoreOrLessEquals(Vector3(1.64969, 1.74538, 0)));
      final textureCoord_0_0_179 = textureCoords_0_0.elementAt(179);
      expect(textureCoord_0_0_179, vector3MoreOrLessEquals(Vector3(1.4772, 1.74314, 0)));
      final textureCoord_0_0_180 = textureCoords_0_0.elementAt(180);
      expect(textureCoord_0_0_180, vector3MoreOrLessEquals(Vector3(-0.171016, -0.477761, 0)));
      final textureCoord_0_0_181 = textureCoords_0_0.elementAt(181);
      expect(textureCoord_0_0_181, vector3MoreOrLessEquals(Vector3(0.164843, -0.478791, 0)));
      final textureCoord_0_0_182 = textureCoords_0_0.elementAt(182);
      expect(textureCoord_0_0_182, vector3MoreOrLessEquals(Vector3(0.166115, -0.104443, 0)));
      final textureCoord_0_0_183 = textureCoords_0_0.elementAt(183);
      expect(textureCoord_0_0_183, vector3MoreOrLessEquals(Vector3(-0.169745, -0.103413, 0)));
      final textureCoord_0_0_184 = textureCoords_0_0.elementAt(184);
      expect(textureCoord_0_0_184, vector3MoreOrLessEquals(Vector3(1.64969, 0.684423, 0)));
      final textureCoord_0_0_185 = textureCoords_0_0.elementAt(185);
      expect(textureCoord_0_0_185, vector3MoreOrLessEquals(Vector3(1.88777, 0.673469, 0)));
      final textureCoord_0_0_186 = textureCoords_0_0.elementAt(186);
      expect(textureCoord_0_0_186, vector3MoreOrLessEquals(Vector3(1.90498, 1.04757, 0)));
      final textureCoord_0_0_187 = textureCoords_0_0.elementAt(187);
      expect(textureCoord_0_0_187, vector3MoreOrLessEquals(Vector3(1.6669, 1.05853, 0)));
      final textureCoord_0_0_188 = textureCoords_0_0.elementAt(188);
      expect(textureCoord_0_0_188, vector3MoreOrLessEquals(Vector3(1.23329, 1.84527, 0)));
      final textureCoord_0_0_189 = textureCoords_0_0.elementAt(189);
      expect(textureCoord_0_0_189, vector3MoreOrLessEquals(Vector3(0.897426, 1.8463, 0)));
      final textureCoord_0_0_190 = textureCoords_0_0.elementAt(190);
      expect(textureCoord_0_0_190, vector3MoreOrLessEquals(Vector3(0.896272, 1.47175, 0)));
      final textureCoord_0_0_191 = textureCoords_0_0.elementAt(191);
      expect(textureCoord_0_0_191, vector3MoreOrLessEquals(Vector3(1.23213, 1.47072, 0)));
      final textureCoord_0_0_192 = textureCoords_0_0.elementAt(192);
      expect(textureCoord_0_0_192, vector3MoreOrLessEquals(Vector3(-0.169015, 0.696275, 0)));
      final textureCoord_0_0_193 = textureCoords_0_0.elementAt(193);
      expect(textureCoord_0_0_193, vector3MoreOrLessEquals(Vector3(0.0690683, 0.707239, 0)));
      final textureCoord_0_0_194 = textureCoords_0_0.elementAt(194);
      expect(textureCoord_0_0_194, vector3MoreOrLessEquals(Vector3(0.0518397, 1.08135, 0)));
      final textureCoord_0_0_195 = textureCoords_0_0.elementAt(195);
      expect(textureCoord_0_0_195, vector3MoreOrLessEquals(Vector3(-0.186243, 1.07038, 0)));
      final textureCoord_0_0_196 = textureCoords_0_0.elementAt(196);
      expect(textureCoord_0_0_196, vector3MoreOrLessEquals(Vector3(-0.186243, 1.07038, 0)));
      final textureCoord_0_0_197 = textureCoords_0_0.elementAt(197);
      expect(textureCoord_0_0_197, vector3MoreOrLessEquals(Vector3(0.0518397, 1.08135, 0)));
      final textureCoord_0_0_198 = textureCoords_0_0.elementAt(198);
      expect(textureCoord_0_0_198, vector3MoreOrLessEquals(Vector3(0.0682907, 1.55697, 0)));
      final textureCoord_0_0_199 = textureCoords_0_0.elementAt(199);
      expect(textureCoord_0_0_199, vector3MoreOrLessEquals(Vector3(-0.117002, 1.54843, 0)));
      final textureCoord_0_0_200 = textureCoords_0_0.elementAt(200);
      expect(textureCoord_0_0_200, vector3MoreOrLessEquals(Vector3(1.23213, 1.47072, 0)));
      final textureCoord_0_0_201 = textureCoords_0_0.elementAt(201);
      expect(textureCoord_0_0_201, vector3MoreOrLessEquals(Vector3(0.896272, 1.47175, 0)));
      final textureCoord_0_0_202 = textureCoords_0_0.elementAt(202);
      expect(textureCoord_0_0_202, vector3MoreOrLessEquals(Vector3(0.932427, 0.997773, 0)));
      final textureCoord_0_0_203 = textureCoords_0_0.elementAt(203);
      expect(textureCoord_0_0_203, vector3MoreOrLessEquals(Vector3(1.19382, 0.996971, 0)));
      final textureCoord_0_0_204 = textureCoords_0_0.elementAt(204);
      expect(textureCoord_0_0_204, vector3MoreOrLessEquals(Vector3(1.6669, 1.05853, 0)));
      final textureCoord_0_0_205 = textureCoords_0_0.elementAt(205);
      expect(textureCoord_0_0_205, vector3MoreOrLessEquals(Vector3(1.90498, 1.04757, 0)));
      final textureCoord_0_0_206 = textureCoords_0_0.elementAt(206);
      expect(textureCoord_0_0_206, vector3MoreOrLessEquals(Vector3(1.83572, 1.52565, 0)));
      final textureCoord_0_0_207 = textureCoords_0_0.elementAt(207);
      expect(textureCoord_0_0_207, vector3MoreOrLessEquals(Vector3(1.65043, 1.53418, 0)));
      final textureCoord_0_0_208 = textureCoords_0_0.elementAt(208);
      expect(textureCoord_0_0_208, vector3MoreOrLessEquals(Vector3(-0.169745, -0.103413, 0)));
      final textureCoord_0_0_209 = textureCoords_0_0.elementAt(209);
      expect(textureCoord_0_0_209, vector3MoreOrLessEquals(Vector3(0.166115, -0.104443, 0)));
      final textureCoord_0_0_210 = textureCoords_0_0.elementAt(210);
      expect(textureCoord_0_0_210, vector3MoreOrLessEquals(Vector3(0.129595, 0.372251, 0)));
      final textureCoord_0_0_211 = textureCoords_0_0.elementAt(211);
      expect(textureCoord_0_0_211, vector3MoreOrLessEquals(Vector3(-0.131795, 0.373053, 0)));
      final textureCoord_0_0_212 = textureCoords_0_0.elementAt(212);
      expect(textureCoord_0_0_212, vector3MoreOrLessEquals(Vector3(-0.131795, 0.373053, 0)));
      final textureCoord_0_0_213 = textureCoords_0_0.elementAt(213);
      expect(textureCoord_0_0_213, vector3MoreOrLessEquals(Vector3(0.129595, 0.372251, 0)));
      final textureCoord_0_0_214 = textureCoords_0_0.elementAt(214);
      expect(textureCoord_0_0_214, vector3MoreOrLessEquals(Vector3(0.0981477, 0.695671, 0)));
      final textureCoord_0_0_215 = textureCoords_0_0.elementAt(215);
      expect(textureCoord_0_0_215, vector3MoreOrLessEquals(Vector3(-0.0986057, 0.696275, 0)));
      final textureCoord_0_0_216 = textureCoords_0_0.elementAt(216);
      expect(textureCoord_0_0_216, vector3MoreOrLessEquals(Vector3(1.65043, 1.53418, 0)));
      final textureCoord_0_0_217 = textureCoords_0_0.elementAt(217);
      expect(textureCoord_0_0_217, vector3MoreOrLessEquals(Vector3(1.83572, 1.52565, 0)));
      final textureCoord_0_0_218 = textureCoords_0_0.elementAt(218);
      expect(textureCoord_0_0_218, vector3MoreOrLessEquals(Vector3(1.82767, 1.84961, 0)));
      final textureCoord_0_0_219 = textureCoords_0_0.elementAt(219);
      expect(textureCoord_0_0_219, vector3MoreOrLessEquals(Vector3(1.68819, 1.85603, 0)));
      final textureCoord_0_0_220 = textureCoords_0_0.elementAt(220);
      expect(textureCoord_0_0_220, vector3MoreOrLessEquals(Vector3(1.19382, 0.996971, 0)));
      final textureCoord_0_0_221 = textureCoords_0_0.elementAt(221);
      expect(textureCoord_0_0_221, vector3MoreOrLessEquals(Vector3(0.932427, 0.997773, 0)));
      final textureCoord_0_0_222 = textureCoords_0_0.elementAt(222);
      expect(textureCoord_0_0_222, vector3MoreOrLessEquals(Vector3(0.963524, 0.674967, 0)));
      final textureCoord_0_0_223 = textureCoords_0_0.elementAt(223);
      expect(textureCoord_0_0_223, vector3MoreOrLessEquals(Vector3(1.16028, 0.674363, 0)));
      final textureCoord_0_0_224 = textureCoords_0_0.elementAt(224);
      expect(textureCoord_0_0_224, vector3MoreOrLessEquals(Vector3(-0.117002, 1.54843, 0)));
      final textureCoord_0_0_225 = textureCoords_0_0.elementAt(225);
      expect(textureCoord_0_0_225, vector3MoreOrLessEquals(Vector3(0.0682907, 1.55697, 0)));
      final textureCoord_0_0_226 = textureCoords_0_0.elementAt(226);
      expect(textureCoord_0_0_226, vector3MoreOrLessEquals(Vector3(0.030512, 1.87879, 0)));
      final textureCoord_0_0_227 = textureCoords_0_0.elementAt(227);
      expect(textureCoord_0_0_227, vector3MoreOrLessEquals(Vector3(-0.108962, 1.87236, 0)));
      final textureCoord_0_0_228 = textureCoords_0_0.elementAt(228);
      expect(textureCoord_0_0_228, vector3MoreOrLessEquals(Vector3(0.657903, 0.674792, 0)));
      final textureCoord_0_0_229 = textureCoords_0_0.elementAt(229);
      expect(textureCoord_0_0_229, vector3MoreOrLessEquals(Vector3(0.797524, 0.674363, 0)));
      final textureCoord_0_0_230 = textureCoords_0_0.elementAt(230);
      expect(textureCoord_0_0_230, vector3MoreOrLessEquals(Vector3(0.798128, 0.871101, 0)));
      final textureCoord_0_0_231 = textureCoords_0_0.elementAt(231);
      expect(textureCoord_0_0_231, vector3MoreOrLessEquals(Vector3(0.658507, 0.871529, 0)));
      final textureCoord_0_0_232 = textureCoords_0_0.elementAt(232);
      expect(textureCoord_0_0_232, vector3MoreOrLessEquals(Vector3(0.485426, 0.696303, 0)));
      final textureCoord_0_0_233 = textureCoords_0_0.elementAt(233);
      expect(textureCoord_0_0_233, vector3MoreOrLessEquals(Vector3(0.657895, 0.868787, 0)));
      final textureCoord_0_0_234 = textureCoords_0_0.elementAt(234);
      expect(textureCoord_0_0_234, vector3MoreOrLessEquals(Vector3(0.361873, 0.992312, 0)));
      final textureCoord_0_0_235 = textureCoords_0_0.elementAt(235);
      expect(textureCoord_0_0_235, vector3MoreOrLessEquals(Vector3(0.241526, 0.696275, 0)));
      final textureCoord_0_0_236 = textureCoords_0_0.elementAt(236);
      expect(textureCoord_0_0_236, vector3MoreOrLessEquals(Vector3(0.485426, 0.696303, 0)));
      final textureCoord_0_0_237 = textureCoords_0_0.elementAt(237);
      expect(textureCoord_0_0_237, vector3MoreOrLessEquals(Vector3(0.361873, 0.992312, 0)));
      final textureCoord_0_0_238 = textureCoords_0_0.elementAt(238);
      expect(textureCoord_0_0_238, vector3MoreOrLessEquals(Vector3(0.0690683, 0.868718, 0)));
      final textureCoord_0_0_239 = textureCoords_0_0.elementAt(239);
      expect(textureCoord_0_0_239, vector3MoreOrLessEquals(Vector3(0.241526, 0.696275, 0)));
      final textureCoord_0_0_240 = textureCoords_0_0.elementAt(240);
      expect(textureCoord_0_0_240, vector3MoreOrLessEquals(Vector3(0.361873, 0.992312, 0)));
      final textureCoord_0_0_241 = textureCoords_0_0.elementAt(241);
      expect(textureCoord_0_0_241, vector3MoreOrLessEquals(Vector3(0.0690761, 1.11262, 0)));
      final textureCoord_0_0_242 = textureCoords_0_0.elementAt(242);
      expect(textureCoord_0_0_242, vector3MoreOrLessEquals(Vector3(0.0690683, 0.868718, 0)));
      final textureCoord_0_0_243 = textureCoords_0_0.elementAt(243);
      expect(textureCoord_0_0_243, vector3MoreOrLessEquals(Vector3(0.361873, 0.992312, 0)));
      final textureCoord_0_0_244 = textureCoords_0_0.elementAt(244);
      expect(textureCoord_0_0_244, vector3MoreOrLessEquals(Vector3(0.241545, 1.2851, 0)));
      final textureCoord_0_0_245 = textureCoords_0_0.elementAt(245);
      expect(textureCoord_0_0_245, vector3MoreOrLessEquals(Vector3(0.0690761, 1.11262, 0)));
      final textureCoord_0_0_246 = textureCoords_0_0.elementAt(246);
      expect(textureCoord_0_0_246, vector3MoreOrLessEquals(Vector3(0.361873, 0.992312, 0)));
      final textureCoord_0_0_247 = textureCoords_0_0.elementAt(247);
      expect(textureCoord_0_0_247, vector3MoreOrLessEquals(Vector3(0.485445, 1.28513, 0)));
      final textureCoord_0_0_248 = textureCoords_0_0.elementAt(248);
      expect(textureCoord_0_0_248, vector3MoreOrLessEquals(Vector3(0.241545, 1.2851, 0)));
      final textureCoord_0_0_249 = textureCoords_0_0.elementAt(249);
      expect(textureCoord_0_0_249, vector3MoreOrLessEquals(Vector3(0.361873, 0.992312, 0)));
      final textureCoord_0_0_250 = textureCoords_0_0.elementAt(250);
      expect(textureCoord_0_0_250, vector3MoreOrLessEquals(Vector3(0.657903, 1.11269, 0)));
      final textureCoord_0_0_251 = textureCoords_0_0.elementAt(251);
      expect(textureCoord_0_0_251, vector3MoreOrLessEquals(Vector3(0.485445, 1.28513, 0)));
      final textureCoord_0_0_252 = textureCoords_0_0.elementAt(252);
      expect(textureCoord_0_0_252, vector3MoreOrLessEquals(Vector3(0.361873, 0.992312, 0)));
      final textureCoord_0_0_253 = textureCoords_0_0.elementAt(253);
      expect(textureCoord_0_0_253, vector3MoreOrLessEquals(Vector3(0.657895, 0.868787, 0)));
      final textureCoord_0_0_254 = textureCoords_0_0.elementAt(254);
      expect(textureCoord_0_0_254, vector3MoreOrLessEquals(Vector3(0.657903, 1.11269, 0)));
      final textureCoord_0_0_255 = textureCoords_0_0.elementAt(255);
      expect(textureCoord_0_0_255, vector3MoreOrLessEquals(Vector3(0.361873, 0.992312, 0)));
      expect(mesh_0.uvComponents.length, equals(1));
      expect(mesh_0.uvComponents, equals([2]));
      expect(mesh_0.faces.length, equals(68));
      expect(mesh_0.bones.length, equals(9));
      expect(mesh_0.materialIndex, isZero);
      expect(mesh_0.name, equals('Cylinder'));
      expect(mesh_0.animMeshes.length, isZero);
      expect(mesh_0.morphingMethod, isZero);
      expect(mesh_0.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));
    });
  });

  test('obj', () {
    testScene('Obj/Spider/spider.obj', (scene) {
      final meshes = scene.meshes;
      expect(meshes, isNotEmpty);
      expect(meshes.length, equals(19));
      final mesh_0 = meshes.elementAt(0);
      expect(mesh_0.primitiveTypes, equals(4));
      expect(mesh_0.vertices.length, equals(240));
      final vertex_0_0 = mesh_0.vertices.elementAt(0);
      expect(vertex_0_0, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, 6.44917)));
      final vertex_0_1 = mesh_0.vertices.elementAt(1);
      expect(vertex_0_1, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_2 = mesh_0.vertices.elementAt(2);
      expect(vertex_0_2, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, 5.61962)));
      final vertex_0_3 = mesh_0.vertices.elementAt(3);
      expect(vertex_0_3, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, 3.41483)));
      final vertex_0_4 = mesh_0.vertices.elementAt(4);
      expect(vertex_0_4, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, 5.61962)));
      final vertex_0_5 = mesh_0.vertices.elementAt(5);
      expect(vertex_0_5, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, 11.4516)));
      final vertex_0_6 = mesh_0.vertices.elementAt(6);
      expect(vertex_0_6, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, 12.6327)));
      final vertex_0_7 = mesh_0.vertices.elementAt(7);
      expect(vertex_0_7, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, 11.4516)));
      final vertex_0_8 = mesh_0.vertices.elementAt(8);
      expect(vertex_0_8, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_9 = mesh_0.vertices.elementAt(9);
      expect(vertex_0_9, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, 5.61962)));
      final vertex_0_10 = mesh_0.vertices.elementAt(10);
      expect(vertex_0_10, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_11 = mesh_0.vertices.elementAt(11);
      expect(vertex_0_11, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, 11.4516)));
      final vertex_0_12 = mesh_0.vertices.elementAt(12);
      expect(vertex_0_12, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, 6.44917)));
      final vertex_0_13 = mesh_0.vertices.elementAt(13);
      expect(vertex_0_13, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, 5.61962)));
      final vertex_0_14 = mesh_0.vertices.elementAt(14);
      expect(vertex_0_14, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -0.537529)));
      final vertex_0_15 = mesh_0.vertices.elementAt(15);
      expect(vertex_0_15, vector3MoreOrLessEquals(Vector3(-8.12036, 15.6845, -10.5)));
      final vertex_0_16 = mesh_0.vertices.elementAt(16);
      expect(vertex_0_16, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -0.537529)));
      final vertex_0_17 = mesh_0.vertices.elementAt(17);
      expect(vertex_0_17, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -4.34285)));
      final vertex_0_18 = mesh_0.vertices.elementAt(18);
      expect(vertex_0_18, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, 3.41483)));
      final vertex_0_19 = mesh_0.vertices.elementAt(19);
      expect(vertex_0_19, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -4.34285)));
      final vertex_0_20 = mesh_0.vertices.elementAt(20);
      expect(vertex_0_20, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, 5.61962)));
      final vertex_0_21 = mesh_0.vertices.elementAt(21);
      expect(vertex_0_21, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -0.537529)));
      final vertex_0_22 = mesh_0.vertices.elementAt(22);
      expect(vertex_0_22, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, 5.61962)));
      final vertex_0_23 = mesh_0.vertices.elementAt(23);
      expect(vertex_0_23, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -4.34285)));
      final vertex_0_24 = mesh_0.vertices.elementAt(24);
      expect(vertex_0_24, vector3MoreOrLessEquals(Vector3(-8.12036, 15.6845, -10.5)));
      final vertex_0_25 = mesh_0.vertices.elementAt(25);
      expect(vertex_0_25, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -4.34285)));
      final vertex_0_26 = mesh_0.vertices.elementAt(26);
      expect(vertex_0_26, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -16.6571)));
      final vertex_0_27 = mesh_0.vertices.elementAt(27);
      expect(vertex_0_27, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, -26.4148)));
      final vertex_0_28 = mesh_0.vertices.elementAt(28);
      expect(vertex_0_28, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -16.6571)));
      final vertex_0_29 = mesh_0.vertices.elementAt(29);
      expect(vertex_0_29, vector3MoreOrLessEquals(Vector3(12.9532, 36.8733, -11.5)));
      final vertex_0_30 = mesh_0.vertices.elementAt(30);
      expect(vertex_0_30, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, 3.41483)));
      final vertex_0_31 = mesh_0.vertices.elementAt(31);
      expect(vertex_0_31, vector3MoreOrLessEquals(Vector3(12.9532, 36.8733, -11.5)));
      final vertex_0_32 = mesh_0.vertices.elementAt(32);
      expect(vertex_0_32, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -4.34285)));
      final vertex_0_33 = mesh_0.vertices.elementAt(33);
      expect(vertex_0_33, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -16.6571)));
      final vertex_0_34 = mesh_0.vertices.elementAt(34);
      expect(vertex_0_34, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -4.34285)));
      final vertex_0_35 = mesh_0.vertices.elementAt(35);
      expect(vertex_0_35, vector3MoreOrLessEquals(Vector3(12.9532, 36.8733, -11.5)));
      final vertex_0_36 = mesh_0.vertices.elementAt(36);
      expect(vertex_0_36, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, 3.41483)));
      final vertex_0_37 = mesh_0.vertices.elementAt(37);
      expect(vertex_0_37, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -2.73328)));
      final vertex_0_38 = mesh_0.vertices.elementAt(38);
      expect(vertex_0_38, vector3MoreOrLessEquals(Vector3(12.9532, 36.8733, -11.5)));
      final vertex_0_39 = mesh_0.vertices.elementAt(39);
      expect(vertex_0_39, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, -26.4148)));
      final vertex_0_40 = mesh_0.vertices.elementAt(40);
      expect(vertex_0_40, vector3MoreOrLessEquals(Vector3(12.9532, 36.8733, -11.5)));
      final vertex_0_41 = mesh_0.vertices.elementAt(41);
      expect(vertex_0_41, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -20.2667)));
      final vertex_0_42 = mesh_0.vertices.elementAt(42);
      expect(vertex_0_42, vector3MoreOrLessEquals(Vector3(44.3013, 33.9647, -11.5)));
      final vertex_0_43 = mesh_0.vertices.elementAt(43);
      expect(vertex_0_43, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -20.2667)));
      final vertex_0_44 = mesh_0.vertices.elementAt(44);
      expect(vertex_0_44, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -2.73328)));
      final vertex_0_45 = mesh_0.vertices.elementAt(45);
      expect(vertex_0_45, vector3MoreOrLessEquals(Vector3(12.9532, 36.8733, -11.5)));
      final vertex_0_46 = mesh_0.vertices.elementAt(46);
      expect(vertex_0_46, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -2.73328)));
      final vertex_0_47 = mesh_0.vertices.elementAt(47);
      expect(vertex_0_47, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -20.2667)));
      final vertex_0_48 = mesh_0.vertices.elementAt(48);
      expect(vertex_0_48, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, 3.41483)));
      final vertex_0_49 = mesh_0.vertices.elementAt(49);
      expect(vertex_0_49, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, 11.4516)));
      final vertex_0_50 = mesh_0.vertices.elementAt(50);
      expect(vertex_0_50, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -2.73328)));
      final vertex_0_51 = mesh_0.vertices.elementAt(51);
      expect(vertex_0_51, vector3MoreOrLessEquals(Vector3(44.3013, 33.9647, -11.5)));
      final vertex_0_52 = mesh_0.vertices.elementAt(52);
      expect(vertex_0_52, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -2.73328)));
      final vertex_0_53 = mesh_0.vertices.elementAt(53);
      expect(vertex_0_53, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, 2.68485)));
      final vertex_0_54 = mesh_0.vertices.elementAt(54);
      expect(vertex_0_54, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, 12.6327)));
      final vertex_0_55 = mesh_0.vertices.elementAt(55);
      expect(vertex_0_55, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, 2.68485)));
      final vertex_0_56 = mesh_0.vertices.elementAt(56);
      expect(vertex_0_56, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, 11.4516)));
      final vertex_0_57 = mesh_0.vertices.elementAt(57);
      expect(vertex_0_57, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -2.73328)));
      final vertex_0_58 = mesh_0.vertices.elementAt(58);
      expect(vertex_0_58, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, 11.4516)));
      final vertex_0_59 = mesh_0.vertices.elementAt(59);
      expect(vertex_0_59, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, 2.68485)));
      final vertex_0_60 = mesh_0.vertices.elementAt(60);
      expect(vertex_0_60, vector3MoreOrLessEquals(Vector3(44.3013, 33.9647, -11.5)));
      final vertex_0_61 = mesh_0.vertices.elementAt(61);
      expect(vertex_0_61, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, 2.68485)));
      final vertex_0_62 = mesh_0.vertices.elementAt(62);
      expect(vertex_0_62, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      final vertex_0_63 = mesh_0.vertices.elementAt(63);
      expect(vertex_0_63, vector3MoreOrLessEquals(Vector3(54.5036, 5.93402, -11.5)));
      final vertex_0_64 = mesh_0.vertices.elementAt(64);
      expect(vertex_0_64, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      final vertex_0_65 = mesh_0.vertices.elementAt(65);
      expect(vertex_0_65, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, 2.68485)));
      final vertex_0_66 = mesh_0.vertices.elementAt(66);
      expect(vertex_0_66, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, 12.6327)));
      final vertex_0_67 = mesh_0.vertices.elementAt(67);
      expect(vertex_0_67, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, 2.68485)));
      final vertex_0_68 = mesh_0.vertices.elementAt(68);
      expect(vertex_0_68, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, 2.68485)));
      final vertex_0_69 = mesh_0.vertices.elementAt(69);
      expect(vertex_0_69, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      final vertex_0_70 = mesh_0.vertices.elementAt(70);
      expect(vertex_0_70, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, 2.68485)));
      final vertex_0_71 = mesh_0.vertices.elementAt(71);
      expect(vertex_0_71, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, 2.68485)));
      final vertex_0_72 = mesh_0.vertices.elementAt(72);
      expect(vertex_0_72, vector3MoreOrLessEquals(Vector3(44.3013, 33.9647, -11.5)));
      final vertex_0_73 = mesh_0.vertices.elementAt(73);
      expect(vertex_0_73, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      final vertex_0_74 = mesh_0.vertices.elementAt(74);
      expect(vertex_0_74, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, -25.6848)));
      final vertex_0_75 = mesh_0.vertices.elementAt(75);
      expect(vertex_0_75, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, -35.6327)));
      final vertex_0_76 = mesh_0.vertices.elementAt(76);
      expect(vertex_0_76, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, -25.6848)));
      final vertex_0_77 = mesh_0.vertices.elementAt(77);
      expect(vertex_0_77, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, -25.6848)));
      final vertex_0_78 = mesh_0.vertices.elementAt(78);
      expect(vertex_0_78, vector3MoreOrLessEquals(Vector3(54.5036, 5.93402, -11.5)));
      final vertex_0_79 = mesh_0.vertices.elementAt(79);
      expect(vertex_0_79, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, -25.6848)));
      final vertex_0_80 = mesh_0.vertices.elementAt(80);
      expect(vertex_0_80, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      final vertex_0_81 = mesh_0.vertices.elementAt(81);
      expect(vertex_0_81, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, -25.6848)));
      final vertex_0_82 = mesh_0.vertices.elementAt(82);
      expect(vertex_0_82, vector3MoreOrLessEquals(Vector3(57.9362, 30.2765, -11.5)));
      final vertex_0_83 = mesh_0.vertices.elementAt(83);
      expect(vertex_0_83, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, -25.6848)));
      final vertex_0_84 = mesh_0.vertices.elementAt(84);
      expect(vertex_0_84, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, -26.4148)));
      final vertex_0_85 = mesh_0.vertices.elementAt(85);
      expect(vertex_0_85, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -20.2667)));
      final vertex_0_86 = mesh_0.vertices.elementAt(86);
      expect(vertex_0_86, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, -34.4516)));
      final vertex_0_87 = mesh_0.vertices.elementAt(87);
      expect(vertex_0_87, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, -35.6327)));
      final vertex_0_88 = mesh_0.vertices.elementAt(88);
      expect(vertex_0_88, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, -34.4516)));
      final vertex_0_89 = mesh_0.vertices.elementAt(89);
      expect(vertex_0_89, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, -25.6848)));
      final vertex_0_90 = mesh_0.vertices.elementAt(90);
      expect(vertex_0_90, vector3MoreOrLessEquals(Vector3(44.3013, 33.9647, -11.5)));
      final vertex_0_91 = mesh_0.vertices.elementAt(91);
      expect(vertex_0_91, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, -25.6848)));
      final vertex_0_92 = mesh_0.vertices.elementAt(92);
      expect(vertex_0_92, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -20.2667)));
      final vertex_0_93 = mesh_0.vertices.elementAt(93);
      expect(vertex_0_93, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, -34.4516)));
      final vertex_0_94 = mesh_0.vertices.elementAt(94);
      expect(vertex_0_94, vector3MoreOrLessEquals(Vector3(30.5273, 37.504, -20.2667)));
      final vertex_0_95 = mesh_0.vertices.elementAt(95);
      expect(vertex_0_95, vector3MoreOrLessEquals(Vector3(45.095, 27.7109, -25.6848)));
      final vertex_0_96 = mesh_0.vertices.elementAt(96);
      expect(vertex_0_96, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, -26.4148)));
      final vertex_0_97 = mesh_0.vertices.elementAt(97);
      expect(vertex_0_97, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, -34.4516)));
      final vertex_0_98 = mesh_0.vertices.elementAt(98);
      expect(vertex_0_98, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, -26.6196)));
      final vertex_0_99 = mesh_0.vertices.elementAt(99);
      expect(vertex_0_99, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, -27.4492)));
      final vertex_0_100 = mesh_0.vertices.elementAt(100);
      expect(vertex_0_100, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, -26.6196)));
      final vertex_0_101 = mesh_0.vertices.elementAt(101);
      expect(vertex_0_101, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, -39.8697)));
      final vertex_0_102 = mesh_0.vertices.elementAt(102);
      expect(vertex_0_102, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, -35.6327)));
      final vertex_0_103 = mesh_0.vertices.elementAt(103);
      expect(vertex_0_103, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, -39.8697)));
      final vertex_0_104 = mesh_0.vertices.elementAt(104);
      expect(vertex_0_104, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, -34.4516)));
      final vertex_0_105 = mesh_0.vertices.elementAt(105);
      expect(vertex_0_105, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, -26.6196)));
      final vertex_0_106 = mesh_0.vertices.elementAt(106);
      expect(vertex_0_106, vector3MoreOrLessEquals(Vector3(27.5208, 27.0803, -34.4516)));
      final vertex_0_107 = mesh_0.vertices.elementAt(107);
      expect(vertex_0_107, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, -39.8697)));
      final vertex_0_108 = mesh_0.vertices.elementAt(108);
      expect(vertex_0_108, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, -27.4492)));
      final vertex_0_109 = mesh_0.vertices.elementAt(109);
      expect(vertex_0_109, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, -39.8697)));
      final vertex_0_110 = mesh_0.vertices.elementAt(110);
      expect(vertex_0_110, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, -26.6196)));
      final vertex_0_111 = mesh_0.vertices.elementAt(111);
      expect(vertex_0_111, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, -26.4148)));
      final vertex_0_112 = mesh_0.vertices.elementAt(112);
      expect(vertex_0_112, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, -26.6196)));
      final vertex_0_113 = mesh_0.vertices.elementAt(113);
      expect(vertex_0_113, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, -34.4516)));
      final vertex_0_114 = mesh_0.vertices.elementAt(114);
      expect(vertex_0_114, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, -35.6327)));
      final vertex_0_115 = mesh_0.vertices.elementAt(115);
      expect(vertex_0_115, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, -34.4516)));
      final vertex_0_116 = mesh_0.vertices.elementAt(116);
      expect(vertex_0_116, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, -39.8697)));
      final vertex_0_117 = mesh_0.vertices.elementAt(117);
      expect(vertex_0_117, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, -26.6196)));
      final vertex_0_118 = mesh_0.vertices.elementAt(118);
      expect(vertex_0_118, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, -39.8697)));
      final vertex_0_119 = mesh_0.vertices.elementAt(119);
      expect(vertex_0_119, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, -34.4516)));
      final vertex_0_120 = mesh_0.vertices.elementAt(120);
      expect(vertex_0_120, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, -26.4148)));
      final vertex_0_121 = mesh_0.vertices.elementAt(121);
      expect(vertex_0_121, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, -34.4516)));
      final vertex_0_122 = mesh_0.vertices.elementAt(122);
      expect(vertex_0_122, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -20.2667)));
      final vertex_0_123 = mesh_0.vertices.elementAt(123);
      expect(vertex_0_123, vector3MoreOrLessEquals(Vector3(54.5036, 5.93402, -11.5)));
      final vertex_0_124 = mesh_0.vertices.elementAt(124);
      expect(vertex_0_124, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -20.2667)));
      final vertex_0_125 = mesh_0.vertices.elementAt(125);
      expect(vertex_0_125, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, -25.6848)));
      final vertex_0_126 = mesh_0.vertices.elementAt(126);
      expect(vertex_0_126, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, -35.6327)));
      final vertex_0_127 = mesh_0.vertices.elementAt(127);
      expect(vertex_0_127, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, -25.6848)));
      final vertex_0_128 = mesh_0.vertices.elementAt(128);
      expect(vertex_0_128, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, -34.4516)));
      final vertex_0_129 = mesh_0.vertices.elementAt(129);
      expect(vertex_0_129, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -20.2667)));
      final vertex_0_130 = mesh_0.vertices.elementAt(130);
      expect(vertex_0_130, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, -34.4516)));
      final vertex_0_131 = mesh_0.vertices.elementAt(131);
      expect(vertex_0_131, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, -25.6848)));
      final vertex_0_132 = mesh_0.vertices.elementAt(132);
      expect(vertex_0_132, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, -26.4148)));
      final vertex_0_133 = mesh_0.vertices.elementAt(133);
      expect(vertex_0_133, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -20.2667)));
      final vertex_0_134 = mesh_0.vertices.elementAt(134);
      expect(vertex_0_134, vector3MoreOrLessEquals(Vector3(32.3592, -16.4443, -11.5)));
      final vertex_0_135 = mesh_0.vertices.elementAt(135);
      expect(vertex_0_135, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, 3.41483)));
      final vertex_0_136 = mesh_0.vertices.elementAt(136);
      expect(vertex_0_136, vector3MoreOrLessEquals(Vector3(32.3592, -16.4443, -11.5)));
      final vertex_0_137 = mesh_0.vertices.elementAt(137);
      expect(vertex_0_137, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -2.73328)));
      final vertex_0_138 = mesh_0.vertices.elementAt(138);
      expect(vertex_0_138, vector3MoreOrLessEquals(Vector3(54.5036, 5.93402, -11.5)));
      final vertex_0_139 = mesh_0.vertices.elementAt(139);
      expect(vertex_0_139, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -2.73328)));
      final vertex_0_140 = mesh_0.vertices.elementAt(140);
      expect(vertex_0_140, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -20.2667)));
      final vertex_0_141 = mesh_0.vertices.elementAt(141);
      expect(vertex_0_141, vector3MoreOrLessEquals(Vector3(32.3592, -16.4443, -11.5)));
      final vertex_0_142 = mesh_0.vertices.elementAt(142);
      expect(vertex_0_142, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -20.2667)));
      final vertex_0_143 = mesh_0.vertices.elementAt(143);
      expect(vertex_0_143, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -2.73328)));
      final vertex_0_144 = mesh_0.vertices.elementAt(144);
      expect(vertex_0_144, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, -26.4148)));
      final vertex_0_145 = mesh_0.vertices.elementAt(145);
      expect(vertex_0_145, vector3MoreOrLessEquals(Vector3(32.3592, -16.4443, -11.5)));
      final vertex_0_146 = mesh_0.vertices.elementAt(146);
      expect(vertex_0_146, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -16.6571)));
      final vertex_0_147 = mesh_0.vertices.elementAt(147);
      expect(vertex_0_147, vector3MoreOrLessEquals(Vector3(-4.68149, -8.78444, -10.5)));
      final vertex_0_148 = mesh_0.vertices.elementAt(148);
      expect(vertex_0_148, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -16.6571)));
      final vertex_0_149 = mesh_0.vertices.elementAt(149);
      expect(vertex_0_149, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -4.34285)));
      final vertex_0_150 = mesh_0.vertices.elementAt(150);
      expect(vertex_0_150, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, 3.41483)));
      final vertex_0_151 = mesh_0.vertices.elementAt(151);
      expect(vertex_0_151, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -4.34285)));
      final vertex_0_152 = mesh_0.vertices.elementAt(152);
      expect(vertex_0_152, vector3MoreOrLessEquals(Vector3(32.3592, -16.4443, -11.5)));
      final vertex_0_153 = mesh_0.vertices.elementAt(153);
      expect(vertex_0_153, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -16.6571)));
      final vertex_0_154 = mesh_0.vertices.elementAt(154);
      expect(vertex_0_154, vector3MoreOrLessEquals(Vector3(32.3592, -16.4443, -11.5)));
      final vertex_0_155 = mesh_0.vertices.elementAt(155);
      expect(vertex_0_155, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -4.34285)));
      final vertex_0_156 = mesh_0.vertices.elementAt(156);
      expect(vertex_0_156, vector3MoreOrLessEquals(Vector3(-4.68149, -8.78444, -10.5)));
      final vertex_0_157 = mesh_0.vertices.elementAt(157);
      expect(vertex_0_157, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -4.34285)));
      final vertex_0_158 = mesh_0.vertices.elementAt(158);
      expect(vertex_0_158, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -0.537529)));
      final vertex_0_159 = mesh_0.vertices.elementAt(159);
      expect(vertex_0_159, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, 6.44917)));
      final vertex_0_160 = mesh_0.vertices.elementAt(160);
      expect(vertex_0_160, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -0.537529)));
      final vertex_0_161 = mesh_0.vertices.elementAt(161);
      expect(vertex_0_161, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, 5.61962)));
      final vertex_0_162 = mesh_0.vertices.elementAt(162);
      expect(vertex_0_162, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, 3.41483)));
      final vertex_0_163 = mesh_0.vertices.elementAt(163);
      expect(vertex_0_163, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, 5.61962)));
      final vertex_0_164 = mesh_0.vertices.elementAt(164);
      expect(vertex_0_164, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -4.34285)));
      final vertex_0_165 = mesh_0.vertices.elementAt(165);
      expect(vertex_0_165, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -0.537529)));
      final vertex_0_166 = mesh_0.vertices.elementAt(166);
      expect(vertex_0_166, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -4.34285)));
      final vertex_0_167 = mesh_0.vertices.elementAt(167);
      expect(vertex_0_167, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, 5.61962)));
      final vertex_0_168 = mesh_0.vertices.elementAt(168);
      expect(vertex_0_168, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, 6.44917)));
      final vertex_0_169 = mesh_0.vertices.elementAt(169);
      expect(vertex_0_169, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, 5.61962)));
      final vertex_0_170 = mesh_0.vertices.elementAt(170);
      expect(vertex_0_170, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_171 = mesh_0.vertices.elementAt(171);
      expect(vertex_0_171, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, 12.6327)));
      final vertex_0_172 = mesh_0.vertices.elementAt(172);
      expect(vertex_0_172, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_173 = mesh_0.vertices.elementAt(173);
      expect(vertex_0_173, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, 11.4516)));
      final vertex_0_174 = mesh_0.vertices.elementAt(174);
      expect(vertex_0_174, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, 3.41483)));
      final vertex_0_175 = mesh_0.vertices.elementAt(175);
      expect(vertex_0_175, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, 11.4516)));
      final vertex_0_176 = mesh_0.vertices.elementAt(176);
      expect(vertex_0_176, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, 5.61962)));
      final vertex_0_177 = mesh_0.vertices.elementAt(177);
      expect(vertex_0_177, vector3MoreOrLessEquals(Vector3(22.6562, 10.2145, 16.8697)));
      final vertex_0_178 = mesh_0.vertices.elementAt(178);
      expect(vertex_0_178, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, 5.61962)));
      final vertex_0_179 = mesh_0.vertices.elementAt(179);
      expect(vertex_0_179, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, 11.4516)));
      final vertex_0_180 = mesh_0.vertices.elementAt(180);
      expect(vertex_0_180, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, 3.41483)));
      final vertex_0_181 = mesh_0.vertices.elementAt(181);
      expect(vertex_0_181, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -2.73328)));
      final vertex_0_182 = mesh_0.vertices.elementAt(182);
      expect(vertex_0_182, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, 11.4516)));
      final vertex_0_183 = mesh_0.vertices.elementAt(183);
      expect(vertex_0_183, vector3MoreOrLessEquals(Vector3(39.1863, 16.231, 12.6327)));
      final vertex_0_184 = mesh_0.vertices.elementAt(184);
      expect(vertex_0_184, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, 11.4516)));
      final vertex_0_185 = mesh_0.vertices.elementAt(185);
      expect(vertex_0_185, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, 2.68485)));
      final vertex_0_186 = mesh_0.vertices.elementAt(186);
      expect(vertex_0_186, vector3MoreOrLessEquals(Vector3(54.5036, 5.93402, -11.5)));
      final vertex_0_187 = mesh_0.vertices.elementAt(187);
      expect(vertex_0_187, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, 2.68485)));
      final vertex_0_188 = mesh_0.vertices.elementAt(188);
      expect(vertex_0_188, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -2.73328)));
      final vertex_0_189 = mesh_0.vertices.elementAt(189);
      expect(vertex_0_189, vector3MoreOrLessEquals(Vector3(37.2238, 0.421531, 11.4516)));
      final vertex_0_190 = mesh_0.vertices.elementAt(190);
      expect(vertex_0_190, vector3MoreOrLessEquals(Vector3(46.2271, -5.63089, -2.73328)));
      final vertex_0_191 = mesh_0.vertices.elementAt(191);
      expect(vertex_0_191, vector3MoreOrLessEquals(Vector3(51.0918, 11.2349, 2.68485)));
      final vertex_0_192 = mesh_0.vertices.elementAt(192);
      expect(vertex_0_192, vector3MoreOrLessEquals(Vector3(-8.12036, 15.6845, -10.5)));
      final vertex_0_193 = mesh_0.vertices.elementAt(193);
      expect(vertex_0_193, vector3MoreOrLessEquals(Vector3(-9.87648, 2.96156, -10.5)));
      final vertex_0_194 = mesh_0.vertices.elementAt(194);
      expect(vertex_0_194, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -0.537529)));
      final vertex_0_195 = mesh_0.vertices.elementAt(195);
      expect(vertex_0_195, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, 6.44917)));
      final vertex_0_196 = mesh_0.vertices.elementAt(196);
      expect(vertex_0_196, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -0.537529)));
      final vertex_0_197 = mesh_0.vertices.elementAt(197);
      expect(vertex_0_197, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -0.537529)));
      final vertex_0_198 = mesh_0.vertices.elementAt(198);
      expect(vertex_0_198, vector3MoreOrLessEquals(Vector3(-4.68149, -8.78444, -10.5)));
      final vertex_0_199 = mesh_0.vertices.elementAt(199);
      expect(vertex_0_199, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -0.537529)));
      final vertex_0_200 = mesh_0.vertices.elementAt(200);
      expect(vertex_0_200, vector3MoreOrLessEquals(Vector3(-9.87648, 2.96156, -10.5)));
      final vertex_0_201 = mesh_0.vertices.elementAt(201);
      expect(vertex_0_201, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -0.537529)));
      final vertex_0_202 = mesh_0.vertices.elementAt(202);
      expect(vertex_0_202, vector3MoreOrLessEquals(Vector3(-9.87648, 2.96156, -10.5)));
      final vertex_0_203 = mesh_0.vertices.elementAt(203);
      expect(vertex_0_203, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -0.537529)));
      final vertex_0_204 = mesh_0.vertices.elementAt(204);
      expect(vertex_0_204, vector3MoreOrLessEquals(Vector3(-8.12036, 15.6845, -10.5)));
      final vertex_0_205 = mesh_0.vertices.elementAt(205);
      expect(vertex_0_205, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -20.4625)));
      final vertex_0_206 = mesh_0.vertices.elementAt(206);
      expect(vertex_0_206, vector3MoreOrLessEquals(Vector3(-9.87648, 2.96156, -10.5)));
      final vertex_0_207 = mesh_0.vertices.elementAt(207);
      expect(vertex_0_207, vector3MoreOrLessEquals(Vector3(-4.68149, -8.78444, -10.5)));
      final vertex_0_208 = mesh_0.vertices.elementAt(208);
      expect(vertex_0_208, vector3MoreOrLessEquals(Vector3(-9.87648, 2.96156, -10.5)));
      final vertex_0_209 = mesh_0.vertices.elementAt(209);
      expect(vertex_0_209, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -20.4625)));
      final vertex_0_210 = mesh_0.vertices.elementAt(210);
      expect(vertex_0_210, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, -27.4492)));
      final vertex_0_211 = mesh_0.vertices.elementAt(211);
      expect(vertex_0_211, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -20.4625)));
      final vertex_0_212 = mesh_0.vertices.elementAt(212);
      expect(vertex_0_212, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -20.4625)));
      final vertex_0_213 = mesh_0.vertices.elementAt(213);
      expect(vertex_0_213, vector3MoreOrLessEquals(Vector3(-9.87648, 2.96156, -10.5)));
      final vertex_0_214 = mesh_0.vertices.elementAt(214);
      expect(vertex_0_214, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -20.4625)));
      final vertex_0_215 = mesh_0.vertices.elementAt(215);
      expect(vertex_0_215, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -20.4625)));
      final vertex_0_216 = mesh_0.vertices.elementAt(216);
      expect(vertex_0_216, vector3MoreOrLessEquals(Vector3(-8.12036, 15.6845, -10.5)));
      final vertex_0_217 = mesh_0.vertices.elementAt(217);
      expect(vertex_0_217, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -16.6571)));
      final vertex_0_218 = mesh_0.vertices.elementAt(218);
      expect(vertex_0_218, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -20.4625)));
      final vertex_0_219 = mesh_0.vertices.elementAt(219);
      expect(vertex_0_219, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, -27.4492)));
      final vertex_0_220 = mesh_0.vertices.elementAt(220);
      expect(vertex_0_220, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -20.4625)));
      final vertex_0_221 = mesh_0.vertices.elementAt(221);
      expect(vertex_0_221, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, -26.6196)));
      final vertex_0_222 = mesh_0.vertices.elementAt(222);
      expect(vertex_0_222, vector3MoreOrLessEquals(Vector3(14.4023, 32.8919, -26.4148)));
      final vertex_0_223 = mesh_0.vertices.elementAt(223);
      expect(vertex_0_223, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, -26.6196)));
      final vertex_0_224 = mesh_0.vertices.elementAt(224);
      expect(vertex_0_224, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -16.6571)));
      final vertex_0_225 = mesh_0.vertices.elementAt(225);
      expect(vertex_0_225, vector3MoreOrLessEquals(Vector3(-6.44272, 10.7774, -20.4625)));
      final vertex_0_226 = mesh_0.vertices.elementAt(226);
      expect(vertex_0_226, vector3MoreOrLessEquals(Vector3(-0.88677, 23.4237, -16.6571)));
      final vertex_0_227 = mesh_0.vertices.elementAt(227);
      expect(vertex_0_227, vector3MoreOrLessEquals(Vector3(4.56831, 16.8571, -26.6196)));
      final vertex_0_228 = mesh_0.vertices.elementAt(228);
      expect(vertex_0_228, vector3MoreOrLessEquals(Vector3(30.91, -12.4628, -26.4148)));
      final vertex_0_229 = mesh_0.vertices.elementAt(229);
      expect(vertex_0_229, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -16.6571)));
      final vertex_0_230 = mesh_0.vertices.elementAt(230);
      expect(vertex_0_230, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, -26.6196)));
      final vertex_0_231 = mesh_0.vertices.elementAt(231);
      expect(vertex_0_231, vector3MoreOrLessEquals(Vector3(1.16038, 4.51268, -27.4492)));
      final vertex_0_232 = mesh_0.vertices.elementAt(232);
      expect(vertex_0_232, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, -26.6196)));
      final vertex_0_233 = mesh_0.vertices.elementAt(233);
      expect(vertex_0_233, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -20.4625)));
      final vertex_0_234 = mesh_0.vertices.elementAt(234);
      expect(vertex_0_234, vector3MoreOrLessEquals(Vector3(-4.68149, -8.78444, -10.5)));
      final vertex_0_235 = mesh_0.vertices.elementAt(235);
      expect(vertex_0_235, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -20.4625)));
      final vertex_0_236 = mesh_0.vertices.elementAt(236);
      expect(vertex_0_236, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -16.6571)));
      final vertex_0_237 = mesh_0.vertices.elementAt(237);
      expect(vertex_0_237, vector3MoreOrLessEquals(Vector3(7.83888, -6.41419, -26.6196)));
      final vertex_0_238 = mesh_0.vertices.elementAt(238);
      expect(vertex_0_238, vector3MoreOrLessEquals(Vector3(4.40512, -14.23, -16.6571)));
      final vertex_0_239 = mesh_0.vertices.elementAt(239);
      expect(vertex_0_239, vector3MoreOrLessEquals(Vector3(-4.42139, -3.60505, -20.4625)));
      expect(mesh_0.normals.length, equals(240));
      final normal_0_0 = mesh_0.normals.elementAt(0);
      expect(normal_0_0, vector3MoreOrLessEquals(Vector3(-0.537588, -0.071798, 0.840146)));
      final normal_0_1 = mesh_0.normals.elementAt(1);
      expect(normal_0_1, vector3MoreOrLessEquals(Vector3(-0.151555, -0.017111, 0.988301)));
      final normal_0_2 = mesh_0.normals.elementAt(2);
      expect(normal_0_2, vector3MoreOrLessEquals(Vector3(-0.510264, 0.347193, 0.786822)));
      final normal_0_3 = mesh_0.normals.elementAt(3);
      expect(normal_0_3, vector3MoreOrLessEquals(Vector3(-0.383883, 0.724753, 0.57216)));
      final normal_0_4 = mesh_0.normals.elementAt(4);
      expect(normal_0_4, vector3MoreOrLessEquals(Vector3(-0.510264, 0.347193, 0.786822)));
      final normal_0_5 = mesh_0.normals.elementAt(5);
      expect(normal_0_5, vector3MoreOrLessEquals(Vector3(0.006791, 0.547083, 0.837051)));
      final normal_0_6 = mesh_0.normals.elementAt(6);
      expect(normal_0_6, vector3MoreOrLessEquals(Vector3(0.441964, 0.160862, 0.882492)));
      final normal_0_7 = mesh_0.normals.elementAt(7);
      expect(normal_0_7, vector3MoreOrLessEquals(Vector3(0.006791, 0.547083, 0.837051)));
      final normal_0_8 = mesh_0.normals.elementAt(8);
      expect(normal_0_8, vector3MoreOrLessEquals(Vector3(-0.151555, -0.017111, 0.988301)));
      final normal_0_9 = mesh_0.normals.elementAt(9);
      expect(normal_0_9, vector3MoreOrLessEquals(Vector3(-0.510264, 0.347193, 0.786822)));
      final normal_0_10 = mesh_0.normals.elementAt(10);
      expect(normal_0_10, vector3MoreOrLessEquals(Vector3(-0.151555, -0.017111, 0.988301)));
      final normal_0_11 = mesh_0.normals.elementAt(11);
      expect(normal_0_11, vector3MoreOrLessEquals(Vector3(0.006791, 0.547083, 0.837051)));
      final normal_0_12 = mesh_0.normals.elementAt(12);
      expect(normal_0_12, vector3MoreOrLessEquals(Vector3(-0.537588, -0.071798, 0.840146)));
      final normal_0_13 = mesh_0.normals.elementAt(13);
      expect(normal_0_13, vector3MoreOrLessEquals(Vector3(-0.510264, 0.347193, 0.786822)));
      final normal_0_14 = mesh_0.normals.elementAt(14);
      expect(normal_0_14, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, 0.555976)));
      final normal_0_15 = mesh_0.normals.elementAt(15);
      expect(normal_0_15, vector3MoreOrLessEquals(Vector3(-0.915534, 0.40224, 0)));
      final normal_0_16 = mesh_0.normals.elementAt(16);
      expect(normal_0_16, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, 0.555976)));
      final normal_0_17 = mesh_0.normals.elementAt(17);
      expect(normal_0_17, vector3MoreOrLessEquals(Vector3(-0.710113, 0.620185, 0.333331)));
      final normal_0_18 = mesh_0.normals.elementAt(18);
      expect(normal_0_18, vector3MoreOrLessEquals(Vector3(-0.383883, 0.724753, 0.57216)));
      final normal_0_19 = mesh_0.normals.elementAt(19);
      expect(normal_0_19, vector3MoreOrLessEquals(Vector3(-0.710113, 0.620185, 0.333331)));
      final normal_0_20 = mesh_0.normals.elementAt(20);
      expect(normal_0_20, vector3MoreOrLessEquals(Vector3(-0.510264, 0.347193, 0.786822)));
      final normal_0_21 = mesh_0.normals.elementAt(21);
      expect(normal_0_21, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, 0.555976)));
      final normal_0_22 = mesh_0.normals.elementAt(22);
      expect(normal_0_22, vector3MoreOrLessEquals(Vector3(-0.510264, 0.347193, 0.786822)));
      final normal_0_23 = mesh_0.normals.elementAt(23);
      expect(normal_0_23, vector3MoreOrLessEquals(Vector3(-0.710113, 0.620185, 0.333331)));
      final normal_0_24 = mesh_0.normals.elementAt(24);
      expect(normal_0_24, vector3MoreOrLessEquals(Vector3(-0.915534, 0.40224, 0)));
      final normal_0_25 = mesh_0.normals.elementAt(25);
      expect(normal_0_25, vector3MoreOrLessEquals(Vector3(-0.710113, 0.620185, 0.333331)));
      final normal_0_26 = mesh_0.normals.elementAt(26);
      expect(normal_0_26, vector3MoreOrLessEquals(Vector3(-0.721673, 0.607891, -0.331145)));
      final normal_0_27 = mesh_0.normals.elementAt(27);
      expect(normal_0_27, vector3MoreOrLessEquals(Vector3(-0.413629, 0.701858, -0.57992)));
      final normal_0_28 = mesh_0.normals.elementAt(28);
      expect(normal_0_28, vector3MoreOrLessEquals(Vector3(-0.721673, 0.607891, -0.331145)));
      final normal_0_29 = mesh_0.normals.elementAt(29);
      expect(normal_0_29, vector3MoreOrLessEquals(Vector3(-0.409411, 0.91235, 0.000434)));
      final normal_0_30 = mesh_0.normals.elementAt(30);
      expect(normal_0_30, vector3MoreOrLessEquals(Vector3(-0.383883, 0.724753, 0.57216)));
      final normal_0_31 = mesh_0.normals.elementAt(31);
      expect(normal_0_31, vector3MoreOrLessEquals(Vector3(-0.409411, 0.91235, 0.000434)));
      final normal_0_32 = mesh_0.normals.elementAt(32);
      expect(normal_0_32, vector3MoreOrLessEquals(Vector3(-0.710113, 0.620185, 0.333331)));
      final normal_0_33 = mesh_0.normals.elementAt(33);
      expect(normal_0_33, vector3MoreOrLessEquals(Vector3(-0.721673, 0.607891, -0.331145)));
      final normal_0_34 = mesh_0.normals.elementAt(34);
      expect(normal_0_34, vector3MoreOrLessEquals(Vector3(-0.710113, 0.620185, 0.333331)));
      final normal_0_35 = mesh_0.normals.elementAt(35);
      expect(normal_0_35, vector3MoreOrLessEquals(Vector3(-0.409411, 0.91235, 0.000434)));
      final normal_0_36 = mesh_0.normals.elementAt(36);
      expect(normal_0_36, vector3MoreOrLessEquals(Vector3(-0.383883, 0.724753, 0.57216)));
      final normal_0_37 = mesh_0.normals.elementAt(37);
      expect(normal_0_37, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, 0.320355)));
      final normal_0_38 = mesh_0.normals.elementAt(38);
      expect(normal_0_38, vector3MoreOrLessEquals(Vector3(-0.409411, 0.91235, 0.000434)));
      final normal_0_39 = mesh_0.normals.elementAt(39);
      expect(normal_0_39, vector3MoreOrLessEquals(Vector3(-0.413629, 0.701858, -0.57992)));
      final normal_0_40 = mesh_0.normals.elementAt(40);
      expect(normal_0_40, vector3MoreOrLessEquals(Vector3(-0.409411, 0.91235, 0.000434)));
      final normal_0_41 = mesh_0.normals.elementAt(41);
      expect(normal_0_41, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, -0.320355)));
      final normal_0_42 = mesh_0.normals.elementAt(42);
      expect(normal_0_42, vector3MoreOrLessEquals(Vector3(0.339768, 0.940509, 0)));
      final normal_0_43 = mesh_0.normals.elementAt(43);
      expect(normal_0_43, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, -0.320355)));
      final normal_0_44 = mesh_0.normals.elementAt(44);
      expect(normal_0_44, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, 0.320355)));
      final normal_0_45 = mesh_0.normals.elementAt(45);
      expect(normal_0_45, vector3MoreOrLessEquals(Vector3(-0.409411, 0.91235, 0.000434)));
      final normal_0_46 = mesh_0.normals.elementAt(46);
      expect(normal_0_46, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, 0.320355)));
      final normal_0_47 = mesh_0.normals.elementAt(47);
      expect(normal_0_47, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, -0.320355)));
      final normal_0_48 = mesh_0.normals.elementAt(48);
      expect(normal_0_48, vector3MoreOrLessEquals(Vector3(-0.383883, 0.724753, 0.57216)));
      final normal_0_49 = mesh_0.normals.elementAt(49);
      expect(normal_0_49, vector3MoreOrLessEquals(Vector3(0.006791, 0.547083, 0.837051)));
      final normal_0_50 = mesh_0.normals.elementAt(50);
      expect(normal_0_50, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, 0.320355)));
      final normal_0_51 = mesh_0.normals.elementAt(51);
      expect(normal_0_51, vector3MoreOrLessEquals(Vector3(0.339768, 0.940509, 0)));
      final normal_0_52 = mesh_0.normals.elementAt(52);
      expect(normal_0_52, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, 0.320355)));
      final normal_0_53 = mesh_0.normals.elementAt(53);
      expect(normal_0_53, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, 0.621345)));
      final normal_0_54 = mesh_0.normals.elementAt(54);
      expect(normal_0_54, vector3MoreOrLessEquals(Vector3(0.441964, 0.160862, 0.882492)));
      final normal_0_55 = mesh_0.normals.elementAt(55);
      expect(normal_0_55, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, 0.621345)));
      final normal_0_56 = mesh_0.normals.elementAt(56);
      expect(normal_0_56, vector3MoreOrLessEquals(Vector3(0.006791, 0.547083, 0.837051)));
      final normal_0_57 = mesh_0.normals.elementAt(57);
      expect(normal_0_57, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, 0.320355)));
      final normal_0_58 = mesh_0.normals.elementAt(58);
      expect(normal_0_58, vector3MoreOrLessEquals(Vector3(0.006791, 0.547083, 0.837051)));
      final normal_0_59 = mesh_0.normals.elementAt(59);
      expect(normal_0_59, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, 0.621345)));
      final normal_0_60 = mesh_0.normals.elementAt(60);
      expect(normal_0_60, vector3MoreOrLessEquals(Vector3(0.339768, 0.940509, 0)));
      final normal_0_61 = mesh_0.normals.elementAt(61);
      expect(normal_0_61, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, 0.621345)));
      final normal_0_62 = mesh_0.normals.elementAt(62);
      expect(normal_0_62, vector3MoreOrLessEquals(Vector3(0.881337, 0.472488, 0)));
      final normal_0_63 = mesh_0.normals.elementAt(63);
      expect(normal_0_63, vector3MoreOrLessEquals(Vector3(0.942952, -0.33293, 0)));
      final normal_0_64 = mesh_0.normals.elementAt(64);
      expect(normal_0_64, vector3MoreOrLessEquals(Vector3(0.881337, 0.472488, 0)));
      final normal_0_65 = mesh_0.normals.elementAt(65);
      expect(normal_0_65, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, 0.599242)));
      final normal_0_66 = mesh_0.normals.elementAt(66);
      expect(normal_0_66, vector3MoreOrLessEquals(Vector3(0.441964, 0.160862, 0.882492)));
      final normal_0_67 = mesh_0.normals.elementAt(67);
      expect(normal_0_67, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, 0.599242)));
      final normal_0_68 = mesh_0.normals.elementAt(68);
      expect(normal_0_68, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, 0.621345)));
      final normal_0_69 = mesh_0.normals.elementAt(69);
      expect(normal_0_69, vector3MoreOrLessEquals(Vector3(0.881337, 0.472488, 0)));
      final normal_0_70 = mesh_0.normals.elementAt(70);
      expect(normal_0_70, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, 0.621345)));
      final normal_0_71 = mesh_0.normals.elementAt(71);
      expect(normal_0_71, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, 0.599242)));
      final normal_0_72 = mesh_0.normals.elementAt(72);
      expect(normal_0_72, vector3MoreOrLessEquals(Vector3(0.339768, 0.940509, 0)));
      final normal_0_73 = mesh_0.normals.elementAt(73);
      expect(normal_0_73, vector3MoreOrLessEquals(Vector3(0.881337, 0.472488, 0)));
      final normal_0_74 = mesh_0.normals.elementAt(74);
      expect(normal_0_74, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, -0.621345)));
      final normal_0_75 = mesh_0.normals.elementAt(75);
      expect(normal_0_75, vector3MoreOrLessEquals(Vector3(0.441964, 0.160862, -0.882492)));
      final normal_0_76 = mesh_0.normals.elementAt(76);
      expect(normal_0_76, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, -0.621345)));
      final normal_0_77 = mesh_0.normals.elementAt(77);
      expect(normal_0_77, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, -0.599242)));
      final normal_0_78 = mesh_0.normals.elementAt(78);
      expect(normal_0_78, vector3MoreOrLessEquals(Vector3(0.942952, -0.33293, 0)));
      final normal_0_79 = mesh_0.normals.elementAt(79);
      expect(normal_0_79, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, -0.599242)));
      final normal_0_80 = mesh_0.normals.elementAt(80);
      expect(normal_0_80, vector3MoreOrLessEquals(Vector3(0.881337, 0.472488, 0)));
      final normal_0_81 = mesh_0.normals.elementAt(81);
      expect(normal_0_81, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, -0.621345)));
      final normal_0_82 = mesh_0.normals.elementAt(82);
      expect(normal_0_82, vector3MoreOrLessEquals(Vector3(0.881337, 0.472488, 0)));
      final normal_0_83 = mesh_0.normals.elementAt(83);
      expect(normal_0_83, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, -0.599242)));
      final normal_0_84 = mesh_0.normals.elementAt(84);
      expect(normal_0_84, vector3MoreOrLessEquals(Vector3(-0.413629, 0.701858, -0.57992)));
      final normal_0_85 = mesh_0.normals.elementAt(85);
      expect(normal_0_85, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, -0.320355)));
      final normal_0_86 = mesh_0.normals.elementAt(86);
      expect(normal_0_86, vector3MoreOrLessEquals(Vector3(-0.012521, 0.539701, -0.841764)));
      final normal_0_87 = mesh_0.normals.elementAt(87);
      expect(normal_0_87, vector3MoreOrLessEquals(Vector3(0.441964, 0.160862, -0.882492)));
      final normal_0_88 = mesh_0.normals.elementAt(88);
      expect(normal_0_88, vector3MoreOrLessEquals(Vector3(-0.012521, 0.539701, -0.841764)));
      final normal_0_89 = mesh_0.normals.elementAt(89);
      expect(normal_0_89, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, -0.621345)));
      final normal_0_90 = mesh_0.normals.elementAt(90);
      expect(normal_0_90, vector3MoreOrLessEquals(Vector3(0.339768, 0.940509, 0)));
      final normal_0_91 = mesh_0.normals.elementAt(91);
      expect(normal_0_91, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, -0.621345)));
      final normal_0_92 = mesh_0.normals.elementAt(92);
      expect(normal_0_92, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, -0.320355)));
      final normal_0_93 = mesh_0.normals.elementAt(93);
      expect(normal_0_93, vector3MoreOrLessEquals(Vector3(-0.012521, 0.539701, -0.841764)));
      final normal_0_94 = mesh_0.normals.elementAt(94);
      expect(normal_0_94, vector3MoreOrLessEquals(Vector3(0.132323, 0.93801, -0.320355)));
      final normal_0_95 = mesh_0.normals.elementAt(95);
      expect(normal_0_95, vector3MoreOrLessEquals(Vector3(0.481852, 0.617859, -0.621345)));
      final normal_0_96 = mesh_0.normals.elementAt(96);
      expect(normal_0_96, vector3MoreOrLessEquals(Vector3(-0.413629, 0.701858, -0.57992)));
      final normal_0_97 = mesh_0.normals.elementAt(97);
      expect(normal_0_97, vector3MoreOrLessEquals(Vector3(-0.012521, 0.539701, -0.841764)));
      final normal_0_98 = mesh_0.normals.elementAt(98);
      expect(normal_0_98, vector3MoreOrLessEquals(Vector3(-0.544858, 0.327294, -0.772016)));
      final normal_0_99 = mesh_0.normals.elementAt(99);
      expect(normal_0_99, vector3MoreOrLessEquals(Vector3(-0.561303, -0.075179, -0.824189)));
      final normal_0_100 = mesh_0.normals.elementAt(100);
      expect(normal_0_100, vector3MoreOrLessEquals(Vector3(-0.544858, 0.327294, -0.772016)));
      final normal_0_101 = mesh_0.normals.elementAt(101);
      expect(normal_0_101, vector3MoreOrLessEquals(Vector3(-0.195775, -0.027076, -0.980275)));
      final normal_0_102 = mesh_0.normals.elementAt(102);
      expect(normal_0_102, vector3MoreOrLessEquals(Vector3(0.441964, 0.160862, -0.882492)));
      final normal_0_103 = mesh_0.normals.elementAt(103);
      expect(normal_0_103, vector3MoreOrLessEquals(Vector3(-0.195775, -0.027076, -0.980275)));
      final normal_0_104 = mesh_0.normals.elementAt(104);
      expect(normal_0_104, vector3MoreOrLessEquals(Vector3(-0.012521, 0.539701, -0.841764)));
      final normal_0_105 = mesh_0.normals.elementAt(105);
      expect(normal_0_105, vector3MoreOrLessEquals(Vector3(-0.544858, 0.327294, -0.772016)));
      final normal_0_106 = mesh_0.normals.elementAt(106);
      expect(normal_0_106, vector3MoreOrLessEquals(Vector3(-0.012521, 0.539701, -0.841764)));
      final normal_0_107 = mesh_0.normals.elementAt(107);
      expect(normal_0_107, vector3MoreOrLessEquals(Vector3(-0.195775, -0.027076, -0.980275)));
      final normal_0_108 = mesh_0.normals.elementAt(108);
      expect(normal_0_108, vector3MoreOrLessEquals(Vector3(-0.561303, -0.075179, -0.824189)));
      final normal_0_109 = mesh_0.normals.elementAt(109);
      expect(normal_0_109, vector3MoreOrLessEquals(Vector3(-0.195775, -0.027076, -0.980275)));
      final normal_0_110 = mesh_0.normals.elementAt(110);
      expect(normal_0_110, vector3MoreOrLessEquals(Vector3(-0.299847, -0.529265, -0.793707)));
      final normal_0_111 = mesh_0.normals.elementAt(111);
      expect(normal_0_111, vector3MoreOrLessEquals(Vector3(0.144885, -0.802478, -0.578824)));
      final normal_0_112 = mesh_0.normals.elementAt(112);
      expect(normal_0_112, vector3MoreOrLessEquals(Vector3(-0.299847, -0.529265, -0.793707)));
      final normal_0_113 = mesh_0.normals.elementAt(113);
      expect(normal_0_113, vector3MoreOrLessEquals(Vector3(0.343163, -0.42037, -0.839957)));
      final normal_0_114 = mesh_0.normals.elementAt(114);
      expect(normal_0_114, vector3MoreOrLessEquals(Vector3(0.441964, 0.160862, -0.882492)));
      final normal_0_115 = mesh_0.normals.elementAt(115);
      expect(normal_0_115, vector3MoreOrLessEquals(Vector3(0.343163, -0.42037, -0.839957)));
      final normal_0_116 = mesh_0.normals.elementAt(116);
      expect(normal_0_116, vector3MoreOrLessEquals(Vector3(-0.195775, -0.027076, -0.980275)));
      final normal_0_117 = mesh_0.normals.elementAt(117);
      expect(normal_0_117, vector3MoreOrLessEquals(Vector3(-0.299847, -0.529265, -0.793707)));
      final normal_0_118 = mesh_0.normals.elementAt(118);
      expect(normal_0_118, vector3MoreOrLessEquals(Vector3(-0.195775, -0.027076, -0.980275)));
      final normal_0_119 = mesh_0.normals.elementAt(119);
      expect(normal_0_119, vector3MoreOrLessEquals(Vector3(0.343163, -0.42037, -0.839957)));
      final normal_0_120 = mesh_0.normals.elementAt(120);
      expect(normal_0_120, vector3MoreOrLessEquals(Vector3(0.144885, -0.802478, -0.578824)));
      final normal_0_121 = mesh_0.normals.elementAt(121);
      expect(normal_0_121, vector3MoreOrLessEquals(Vector3(0.343163, -0.42037, -0.839957)));
      final normal_0_122 = mesh_0.normals.elementAt(122);
      expect(normal_0_122, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, -0.320355)));
      final normal_0_123 = mesh_0.normals.elementAt(123);
      expect(normal_0_123, vector3MoreOrLessEquals(Vector3(0.942952, -0.33293, 0)));
      final normal_0_124 = mesh_0.normals.elementAt(124);
      expect(normal_0_124, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, -0.320355)));
      final normal_0_125 = mesh_0.normals.elementAt(125);
      expect(normal_0_125, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, -0.599242)));
      final normal_0_126 = mesh_0.normals.elementAt(126);
      expect(normal_0_126, vector3MoreOrLessEquals(Vector3(0.441964, 0.160862, -0.882492)));
      final normal_0_127 = mesh_0.normals.elementAt(127);
      expect(normal_0_127, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, -0.599242)));
      final normal_0_128 = mesh_0.normals.elementAt(128);
      expect(normal_0_128, vector3MoreOrLessEquals(Vector3(0.343163, -0.42037, -0.839957)));
      final normal_0_129 = mesh_0.normals.elementAt(129);
      expect(normal_0_129, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, -0.320355)));
      final normal_0_130 = mesh_0.normals.elementAt(130);
      expect(normal_0_130, vector3MoreOrLessEquals(Vector3(0.343163, -0.42037, -0.839957)));
      final normal_0_131 = mesh_0.normals.elementAt(131);
      expect(normal_0_131, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, -0.599242)));
      final normal_0_132 = mesh_0.normals.elementAt(132);
      expect(normal_0_132, vector3MoreOrLessEquals(Vector3(0.144885, -0.802478, -0.578824)));
      final normal_0_133 = mesh_0.normals.elementAt(133);
      expect(normal_0_133, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, -0.320355)));
      final normal_0_134 = mesh_0.normals.elementAt(134);
      expect(normal_0_134, vector3MoreOrLessEquals(Vector3(0.260986, -0.965343, 0.000322)));
      final normal_0_135 = mesh_0.normals.elementAt(135);
      expect(normal_0_135, vector3MoreOrLessEquals(Vector3(0.173226, -0.803252, 0.569894)));
      final normal_0_136 = mesh_0.normals.elementAt(136);
      expect(normal_0_136, vector3MoreOrLessEquals(Vector3(0.260986, -0.965343, 0.000322)));
      final normal_0_137 = mesh_0.normals.elementAt(137);
      expect(normal_0_137, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, 0.320355)));
      final normal_0_138 = mesh_0.normals.elementAt(138);
      expect(normal_0_138, vector3MoreOrLessEquals(Vector3(0.942952, -0.33293, 0)));
      final normal_0_139 = mesh_0.normals.elementAt(139);
      expect(normal_0_139, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, 0.320355)));
      final normal_0_140 = mesh_0.normals.elementAt(140);
      expect(normal_0_140, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, -0.320355)));
      final normal_0_141 = mesh_0.normals.elementAt(141);
      expect(normal_0_141, vector3MoreOrLessEquals(Vector3(0.260986, -0.965343, 0.000322)));
      final normal_0_142 = mesh_0.normals.elementAt(142);
      expect(normal_0_142, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, -0.320355)));
      final normal_0_143 = mesh_0.normals.elementAt(143);
      expect(normal_0_143, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, 0.320355)));
      final normal_0_144 = mesh_0.normals.elementAt(144);
      expect(normal_0_144, vector3MoreOrLessEquals(Vector3(0.144885, -0.802478, -0.578824)));
      final normal_0_145 = mesh_0.normals.elementAt(145);
      expect(normal_0_145, vector3MoreOrLessEquals(Vector3(0.260986, -0.965343, 0.000322)));
      final normal_0_146 = mesh_0.normals.elementAt(146);
      expect(normal_0_146, vector3MoreOrLessEquals(Vector3(-0.34623, -0.872998, -0.34351)));
      final normal_0_147 = mesh_0.normals.elementAt(147);
      expect(normal_0_147, vector3MoreOrLessEquals(Vector3(-0.769195, -0.639014, 0)));
      final normal_0_148 = mesh_0.normals.elementAt(148);
      expect(normal_0_148, vector3MoreOrLessEquals(Vector3(-0.34623, -0.872998, -0.34351)));
      final normal_0_149 = mesh_0.normals.elementAt(149);
      expect(normal_0_149, vector3MoreOrLessEquals(Vector3(-0.334289, -0.877615, 0.343575)));
      final normal_0_150 = mesh_0.normals.elementAt(150);
      expect(normal_0_150, vector3MoreOrLessEquals(Vector3(0.173226, -0.803252, 0.569894)));
      final normal_0_151 = mesh_0.normals.elementAt(151);
      expect(normal_0_151, vector3MoreOrLessEquals(Vector3(-0.334289, -0.877615, 0.343575)));
      final normal_0_152 = mesh_0.normals.elementAt(152);
      expect(normal_0_152, vector3MoreOrLessEquals(Vector3(0.260986, -0.965343, 0.000322)));
      final normal_0_153 = mesh_0.normals.elementAt(153);
      expect(normal_0_153, vector3MoreOrLessEquals(Vector3(-0.34623, -0.872998, -0.34351)));
      final normal_0_154 = mesh_0.normals.elementAt(154);
      expect(normal_0_154, vector3MoreOrLessEquals(Vector3(0.260986, -0.965343, 0.000322)));
      final normal_0_155 = mesh_0.normals.elementAt(155);
      expect(normal_0_155, vector3MoreOrLessEquals(Vector3(-0.334289, -0.877615, 0.343575)));
      final normal_0_156 = mesh_0.normals.elementAt(156);
      expect(normal_0_156, vector3MoreOrLessEquals(Vector3(-0.769195, -0.639014, 0)));
      final normal_0_157 = mesh_0.normals.elementAt(157);
      expect(normal_0_157, vector3MoreOrLessEquals(Vector3(-0.334289, -0.877615, 0.343575)));
      final normal_0_158 = mesh_0.normals.elementAt(158);
      expect(normal_0_158, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, 0.555976)));
      final normal_0_159 = mesh_0.normals.elementAt(159);
      expect(normal_0_159, vector3MoreOrLessEquals(Vector3(-0.537588, -0.071798, 0.840146)));
      final normal_0_160 = mesh_0.normals.elementAt(160);
      expect(normal_0_160, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, 0.555976)));
      final normal_0_161 = mesh_0.normals.elementAt(161);
      expect(normal_0_161, vector3MoreOrLessEquals(Vector3(-0.264904, -0.527345, 0.8073)));
      final normal_0_162 = mesh_0.normals.elementAt(162);
      expect(normal_0_162, vector3MoreOrLessEquals(Vector3(0.173226, -0.803252, 0.569894)));
      final normal_0_163 = mesh_0.normals.elementAt(163);
      expect(normal_0_163, vector3MoreOrLessEquals(Vector3(-0.264904, -0.527345, 0.8073)));
      final normal_0_164 = mesh_0.normals.elementAt(164);
      expect(normal_0_164, vector3MoreOrLessEquals(Vector3(-0.334289, -0.877615, 0.343575)));
      final normal_0_165 = mesh_0.normals.elementAt(165);
      expect(normal_0_165, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, 0.555976)));
      final normal_0_166 = mesh_0.normals.elementAt(166);
      expect(normal_0_166, vector3MoreOrLessEquals(Vector3(-0.334289, -0.877615, 0.343575)));
      final normal_0_167 = mesh_0.normals.elementAt(167);
      expect(normal_0_167, vector3MoreOrLessEquals(Vector3(-0.264904, -0.527345, 0.8073)));
      final normal_0_168 = mesh_0.normals.elementAt(168);
      expect(normal_0_168, vector3MoreOrLessEquals(Vector3(-0.537588, -0.071798, 0.840146)));
      final normal_0_169 = mesh_0.normals.elementAt(169);
      expect(normal_0_169, vector3MoreOrLessEquals(Vector3(-0.264904, -0.527345, 0.8073)));
      final normal_0_170 = mesh_0.normals.elementAt(170);
      expect(normal_0_170, vector3MoreOrLessEquals(Vector3(-0.151555, -0.017111, 0.988301)));
      final normal_0_171 = mesh_0.normals.elementAt(171);
      expect(normal_0_171, vector3MoreOrLessEquals(Vector3(0.441964, 0.160862, 0.882492)));
      final normal_0_172 = mesh_0.normals.elementAt(172);
      expect(normal_0_172, vector3MoreOrLessEquals(Vector3(-0.151555, -0.017111, 0.988301)));
      final normal_0_173 = mesh_0.normals.elementAt(173);
      expect(normal_0_173, vector3MoreOrLessEquals(Vector3(0.359321, -0.41399, 0.836362)));
      final normal_0_174 = mesh_0.normals.elementAt(174);
      expect(normal_0_174, vector3MoreOrLessEquals(Vector3(0.173226, -0.803252, 0.569894)));
      final normal_0_175 = mesh_0.normals.elementAt(175);
      expect(normal_0_175, vector3MoreOrLessEquals(Vector3(0.359321, -0.41399, 0.836362)));
      final normal_0_176 = mesh_0.normals.elementAt(176);
      expect(normal_0_176, vector3MoreOrLessEquals(Vector3(-0.264904, -0.527345, 0.8073)));
      final normal_0_177 = mesh_0.normals.elementAt(177);
      expect(normal_0_177, vector3MoreOrLessEquals(Vector3(-0.151555, -0.017111, 0.988301)));
      final normal_0_178 = mesh_0.normals.elementAt(178);
      expect(normal_0_178, vector3MoreOrLessEquals(Vector3(-0.264904, -0.527345, 0.8073)));
      final normal_0_179 = mesh_0.normals.elementAt(179);
      expect(normal_0_179, vector3MoreOrLessEquals(Vector3(0.359321, -0.41399, 0.836362)));
      final normal_0_180 = mesh_0.normals.elementAt(180);
      expect(normal_0_180, vector3MoreOrLessEquals(Vector3(0.173226, -0.803252, 0.569894)));
      final normal_0_181 = mesh_0.normals.elementAt(181);
      expect(normal_0_181, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, 0.320355)));
      final normal_0_182 = mesh_0.normals.elementAt(182);
      expect(normal_0_182, vector3MoreOrLessEquals(Vector3(0.359321, -0.41399, 0.836362)));
      final normal_0_183 = mesh_0.normals.elementAt(183);
      expect(normal_0_183, vector3MoreOrLessEquals(Vector3(0.441964, 0.160862, 0.882492)));
      final normal_0_184 = mesh_0.normals.elementAt(184);
      expect(normal_0_184, vector3MoreOrLessEquals(Vector3(0.359321, -0.41399, 0.836362)));
      final normal_0_185 = mesh_0.normals.elementAt(185);
      expect(normal_0_185, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, 0.599242)));
      final normal_0_186 = mesh_0.normals.elementAt(186);
      expect(normal_0_186, vector3MoreOrLessEquals(Vector3(0.942952, -0.33293, 0)));
      final normal_0_187 = mesh_0.normals.elementAt(187);
      expect(normal_0_187, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, 0.599242)));
      final normal_0_188 = mesh_0.normals.elementAt(188);
      expect(normal_0_188, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, 0.320355)));
      final normal_0_189 = mesh_0.normals.elementAt(189);
      expect(normal_0_189, vector3MoreOrLessEquals(Vector3(0.359321, -0.41399, 0.836362)));
      final normal_0_190 = mesh_0.normals.elementAt(190);
      expect(normal_0_190, vector3MoreOrLessEquals(Vector3(0.704306, -0.633502, 0.320355)));
      final normal_0_191 = mesh_0.normals.elementAt(191);
      expect(normal_0_191, vector3MoreOrLessEquals(Vector3(0.795204, -0.092522, 0.599242)));
      final normal_0_192 = mesh_0.normals.elementAt(192);
      expect(normal_0_192, vector3MoreOrLessEquals(Vector3(-0.915534, 0.40224, 0)));
      final normal_0_193 = mesh_0.normals.elementAt(193);
      expect(normal_0_193, vector3MoreOrLessEquals(Vector3(-0.990268, -0.139173, 0)));
      final normal_0_194 = mesh_0.normals.elementAt(194);
      expect(normal_0_194, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, 0.555976)));
      final normal_0_195 = mesh_0.normals.elementAt(195);
      expect(normal_0_195, vector3MoreOrLessEquals(Vector3(-0.537588, -0.071798, 0.840146)));
      final normal_0_196 = mesh_0.normals.elementAt(196);
      expect(normal_0_196, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, 0.555976)));
      final normal_0_197 = mesh_0.normals.elementAt(197);
      expect(normal_0_197, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, 0.555976)));
      final normal_0_198 = mesh_0.normals.elementAt(198);
      expect(normal_0_198, vector3MoreOrLessEquals(Vector3(-0.769195, -0.639014, 0)));
      final normal_0_199 = mesh_0.normals.elementAt(199);
      expect(normal_0_199, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, 0.555976)));
      final normal_0_200 = mesh_0.normals.elementAt(200);
      expect(normal_0_200, vector3MoreOrLessEquals(Vector3(-0.990268, -0.139173, 0)));
      final normal_0_201 = mesh_0.normals.elementAt(201);
      expect(normal_0_201, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, 0.555976)));
      final normal_0_202 = mesh_0.normals.elementAt(202);
      expect(normal_0_202, vector3MoreOrLessEquals(Vector3(-0.990268, -0.139173, 0)));
      final normal_0_203 = mesh_0.normals.elementAt(203);
      expect(normal_0_203, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, 0.555976)));
      final normal_0_204 = mesh_0.normals.elementAt(204);
      expect(normal_0_204, vector3MoreOrLessEquals(Vector3(-0.915534, 0.40224, 0)));
      final normal_0_205 = mesh_0.normals.elementAt(205);
      expect(normal_0_205, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, -0.555976)));
      final normal_0_206 = mesh_0.normals.elementAt(206);
      expect(normal_0_206, vector3MoreOrLessEquals(Vector3(-0.990268, -0.139173, 0)));
      final normal_0_207 = mesh_0.normals.elementAt(207);
      expect(normal_0_207, vector3MoreOrLessEquals(Vector3(-0.769195, -0.639014, 0)));
      final normal_0_208 = mesh_0.normals.elementAt(208);
      expect(normal_0_208, vector3MoreOrLessEquals(Vector3(-0.990268, -0.139173, 0)));
      final normal_0_209 = mesh_0.normals.elementAt(209);
      expect(normal_0_209, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, -0.555976)));
      final normal_0_210 = mesh_0.normals.elementAt(210);
      expect(normal_0_210, vector3MoreOrLessEquals(Vector3(-0.561303, -0.075179, -0.824189)));
      final normal_0_211 = mesh_0.normals.elementAt(211);
      expect(normal_0_211, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, -0.555976)));
      final normal_0_212 = mesh_0.normals.elementAt(212);
      expect(normal_0_212, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, -0.555976)));
      final normal_0_213 = mesh_0.normals.elementAt(213);
      expect(normal_0_213, vector3MoreOrLessEquals(Vector3(-0.990268, -0.139173, 0)));
      final normal_0_214 = mesh_0.normals.elementAt(214);
      expect(normal_0_214, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, -0.555976)));
      final normal_0_215 = mesh_0.normals.elementAt(215);
      expect(normal_0_215, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, -0.555976)));
      final normal_0_216 = mesh_0.normals.elementAt(216);
      expect(normal_0_216, vector3MoreOrLessEquals(Vector3(-0.915534, 0.40224, 0)));
      final normal_0_217 = mesh_0.normals.elementAt(217);
      expect(normal_0_217, vector3MoreOrLessEquals(Vector3(-0.721673, 0.607891, -0.331145)));
      final normal_0_218 = mesh_0.normals.elementAt(218);
      expect(normal_0_218, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, -0.555976)));
      final normal_0_219 = mesh_0.normals.elementAt(219);
      expect(normal_0_219, vector3MoreOrLessEquals(Vector3(-0.561303, -0.075179, -0.824189)));
      final normal_0_220 = mesh_0.normals.elementAt(220);
      expect(normal_0_220, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, -0.555976)));
      final normal_0_221 = mesh_0.normals.elementAt(221);
      expect(normal_0_221, vector3MoreOrLessEquals(Vector3(-0.544858, 0.327294, -0.772016)));
      final normal_0_222 = mesh_0.normals.elementAt(222);
      expect(normal_0_222, vector3MoreOrLessEquals(Vector3(-0.413629, 0.701858, -0.57992)));
      final normal_0_223 = mesh_0.normals.elementAt(223);
      expect(normal_0_223, vector3MoreOrLessEquals(Vector3(-0.544858, 0.327294, -0.772016)));
      final normal_0_224 = mesh_0.normals.elementAt(224);
      expect(normal_0_224, vector3MoreOrLessEquals(Vector3(-0.721673, 0.607891, -0.331145)));
      final normal_0_225 = mesh_0.normals.elementAt(225);
      expect(normal_0_225, vector3MoreOrLessEquals(Vector3(-0.810413, 0.184718, -0.555976)));
      final normal_0_226 = mesh_0.normals.elementAt(226);
      expect(normal_0_226, vector3MoreOrLessEquals(Vector3(-0.721673, 0.607891, -0.331145)));
      final normal_0_227 = mesh_0.normals.elementAt(227);
      expect(normal_0_227, vector3MoreOrLessEquals(Vector3(-0.544858, 0.327294, -0.772016)));
      final normal_0_228 = mesh_0.normals.elementAt(228);
      expect(normal_0_228, vector3MoreOrLessEquals(Vector3(0.144885, -0.802478, -0.578824)));
      final normal_0_229 = mesh_0.normals.elementAt(229);
      expect(normal_0_229, vector3MoreOrLessEquals(Vector3(-0.34623, -0.872998, -0.34351)));
      final normal_0_230 = mesh_0.normals.elementAt(230);
      expect(normal_0_230, vector3MoreOrLessEquals(Vector3(-0.299847, -0.529265, -0.793707)));
      final normal_0_231 = mesh_0.normals.elementAt(231);
      expect(normal_0_231, vector3MoreOrLessEquals(Vector3(-0.561303, -0.075179, -0.824189)));
      final normal_0_232 = mesh_0.normals.elementAt(232);
      expect(normal_0_232, vector3MoreOrLessEquals(Vector3(-0.299847, -0.529265, -0.793707)));
      final normal_0_233 = mesh_0.normals.elementAt(233);
      expect(normal_0_233, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, -0.555976)));
      final normal_0_234 = mesh_0.normals.elementAt(234);
      expect(normal_0_234, vector3MoreOrLessEquals(Vector3(-0.769195, -0.639014, 0)));
      final normal_0_235 = mesh_0.normals.elementAt(235);
      expect(normal_0_235, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, -0.555976)));
      final normal_0_236 = mesh_0.normals.elementAt(236);
      expect(normal_0_236, vector3MoreOrLessEquals(Vector3(-0.34623, -0.872998, -0.34351)));
      final normal_0_237 = mesh_0.normals.elementAt(237);
      expect(normal_0_237, vector3MoreOrLessEquals(Vector3(-0.299847, -0.529265, -0.793707)));
      final normal_0_238 = mesh_0.normals.elementAt(238);
      expect(normal_0_238, vector3MoreOrLessEquals(Vector3(-0.34623, -0.872998, -0.34351)));
      final normal_0_239 = mesh_0.normals.elementAt(239);
      expect(normal_0_239, vector3MoreOrLessEquals(Vector3(-0.728104, -0.400942, -0.555976)));
      expect(mesh_0.tangents.length, isZero);
      expect(mesh_0.bitangents.length, isZero);
      expect(mesh_0.colors.length, isZero);
      expect(mesh_0.textureCoords.length, equals(1));
      final textureCoords_0_0 = mesh_0.textureCoords.elementAt(0);
      expect(textureCoords_0_0.length, equals(240));
      final textureCoord_0_0_0 = textureCoords_0_0.elementAt(0);
      expect(textureCoord_0_0_0, vector3MoreOrLessEquals(Vector3(0.186192, 0.222718, 0)));
      final textureCoord_0_0_1 = textureCoords_0_0.elementAt(1);
      expect(textureCoord_0_0_1, vector3MoreOrLessEquals(Vector3(0.50318, 0.039063, 0)));
      final textureCoord_0_0_2 = textureCoords_0_0.elementAt(2);
      expect(textureCoord_0_0_2, vector3MoreOrLessEquals(Vector3(0.236448, 0.237339, 0)));
      final textureCoord_0_0_3 = textureCoords_0_0.elementAt(3);
      expect(textureCoord_0_0_3, vector3MoreOrLessEquals(Vector3(0.381464, 0.276197, 0)));
      final textureCoord_0_0_4 = textureCoords_0_0.elementAt(4);
      expect(textureCoord_0_0_4, vector3MoreOrLessEquals(Vector3(0.236448, 0.237339, 0)));
      final textureCoord_0_0_5 = textureCoords_0_0.elementAt(5);
      expect(textureCoord_0_0_5, vector3MoreOrLessEquals(Vector3(0.574917, 0.134554, 0)));
      final textureCoord_0_0_6 = textureCoords_0_0.elementAt(6);
      expect(textureCoord_0_0_6, vector3MoreOrLessEquals(Vector3(0.746941, 0.113737, 0)));
      final textureCoord_0_0_7 = textureCoords_0_0.elementAt(7);
      expect(textureCoord_0_0_7, vector3MoreOrLessEquals(Vector3(0.574917, 0.134554, 0)));
      final textureCoord_0_0_8 = textureCoords_0_0.elementAt(8);
      expect(textureCoord_0_0_8, vector3MoreOrLessEquals(Vector3(0.50318, 0.039063, 0)));
      final textureCoord_0_0_9 = textureCoords_0_0.elementAt(9);
      expect(textureCoord_0_0_9, vector3MoreOrLessEquals(Vector3(0.236448, 0.237339, 0)));
      final textureCoord_0_0_10 = textureCoords_0_0.elementAt(10);
      expect(textureCoord_0_0_10, vector3MoreOrLessEquals(Vector3(0.50318, 0.039063, 0)));
      final textureCoord_0_0_11 = textureCoords_0_0.elementAt(11);
      expect(textureCoord_0_0_11, vector3MoreOrLessEquals(Vector3(0.574917, 0.134554, 0)));
      final textureCoord_0_0_12 = textureCoords_0_0.elementAt(12);
      expect(textureCoord_0_0_12, vector3MoreOrLessEquals(Vector3(0.186192, 0.222718, 0)));
      final textureCoord_0_0_13 = textureCoords_0_0.elementAt(13);
      expect(textureCoord_0_0_13, vector3MoreOrLessEquals(Vector3(0.236448, 0.237339, 0)));
      final textureCoord_0_0_14 = textureCoords_0_0.elementAt(14);
      expect(textureCoord_0_0_14, vector3MoreOrLessEquals(Vector3(0.074073, 0.345855, 0)));
      final textureCoord_0_0_15 = textureCoords_0_0.elementAt(15);
      expect(textureCoord_0_0_15, vector3MoreOrLessEquals(Vector3(0.049334, 0.521438, 0)));
      final textureCoord_0_0_16 = textureCoords_0_0.elementAt(16);
      expect(textureCoord_0_0_16, vector3MoreOrLessEquals(Vector3(0.074073, 0.345855, 0)));
      final textureCoord_0_0_17 = textureCoords_0_0.elementAt(17);
      expect(textureCoord_0_0_17, vector3MoreOrLessEquals(Vector3(0.156004, 0.412922, 0)));
      final textureCoord_0_0_18 = textureCoords_0_0.elementAt(18);
      expect(textureCoord_0_0_18, vector3MoreOrLessEquals(Vector3(0.381464, 0.276197, 0)));
      final textureCoord_0_0_19 = textureCoords_0_0.elementAt(19);
      expect(textureCoord_0_0_19, vector3MoreOrLessEquals(Vector3(0.156004, 0.412922, 0)));
      final textureCoord_0_0_20 = textureCoords_0_0.elementAt(20);
      expect(textureCoord_0_0_20, vector3MoreOrLessEquals(Vector3(0.236448, 0.237339, 0)));
      final textureCoord_0_0_21 = textureCoords_0_0.elementAt(21);
      expect(textureCoord_0_0_21, vector3MoreOrLessEquals(Vector3(0.074073, 0.345855, 0)));
      final textureCoord_0_0_22 = textureCoords_0_0.elementAt(22);
      expect(textureCoord_0_0_22, vector3MoreOrLessEquals(Vector3(0.236448, 0.237339, 0)));
      final textureCoord_0_0_23 = textureCoords_0_0.elementAt(23);
      expect(textureCoord_0_0_23, vector3MoreOrLessEquals(Vector3(0.156004, 0.412922, 0)));
      final textureCoord_0_0_24 = textureCoords_0_0.elementAt(24);
      expect(textureCoord_0_0_24, vector3MoreOrLessEquals(Vector3(0.049334, 0.521438, 0)));
      final textureCoord_0_0_25 = textureCoords_0_0.elementAt(25);
      expect(textureCoord_0_0_25, vector3MoreOrLessEquals(Vector3(0.156004, 0.412922, 0)));
      final textureCoord_0_0_26 = textureCoords_0_0.elementAt(26);
      expect(textureCoord_0_0_26, vector3MoreOrLessEquals(Vector3(0.156004, 0.629954, 0)));
      final textureCoord_0_0_27 = textureCoords_0_0.elementAt(27);
      expect(textureCoord_0_0_27, vector3MoreOrLessEquals(Vector3(0.381464, 0.801928, 0)));
      final textureCoord_0_0_28 = textureCoords_0_0.elementAt(28);
      expect(textureCoord_0_0_28, vector3MoreOrLessEquals(Vector3(0.156004, 0.629954, 0)));
      final textureCoord_0_0_29 = textureCoords_0_0.elementAt(29);
      expect(textureCoord_0_0_29, vector3MoreOrLessEquals(Vector3(0.360095, 0.539063, 0)));
      final textureCoord_0_0_30 = textureCoords_0_0.elementAt(30);
      expect(textureCoord_0_0_30, vector3MoreOrLessEquals(Vector3(0.381464, 0.276197, 0)));
      final textureCoord_0_0_31 = textureCoords_0_0.elementAt(31);
      expect(textureCoord_0_0_31, vector3MoreOrLessEquals(Vector3(0.360095, 0.539063, 0)));
      final textureCoord_0_0_32 = textureCoords_0_0.elementAt(32);
      expect(textureCoord_0_0_32, vector3MoreOrLessEquals(Vector3(0.156004, 0.412922, 0)));
      final textureCoord_0_0_33 = textureCoords_0_0.elementAt(33);
      expect(textureCoord_0_0_33, vector3MoreOrLessEquals(Vector3(0.156004, 0.629954, 0)));
      final textureCoord_0_0_34 = textureCoords_0_0.elementAt(34);
      expect(textureCoord_0_0_34, vector3MoreOrLessEquals(Vector3(0.156004, 0.412922, 0)));
      final textureCoord_0_0_35 = textureCoords_0_0.elementAt(35);
      expect(textureCoord_0_0_35, vector3MoreOrLessEquals(Vector3(0.360095, 0.539063, 0)));
      final textureCoord_0_0_36 = textureCoords_0_0.elementAt(36);
      expect(textureCoord_0_0_36, vector3MoreOrLessEquals(Vector3(0.381464, 0.276197, 0)));
      final textureCoord_0_0_37 = textureCoords_0_0.elementAt(37);
      expect(textureCoord_0_0_37, vector3MoreOrLessEquals(Vector3(0.619252, 0.384554, 0)));
      final textureCoord_0_0_38 = textureCoords_0_0.elementAt(38);
      expect(textureCoord_0_0_38, vector3MoreOrLessEquals(Vector3(0.360095, 0.539063, 0)));
      final textureCoord_0_0_39 = textureCoords_0_0.elementAt(39);
      expect(textureCoord_0_0_39, vector3MoreOrLessEquals(Vector3(0.381464, 0.801928, 0)));
      final textureCoord_0_0_40 = textureCoords_0_0.elementAt(40);
      expect(textureCoord_0_0_40, vector3MoreOrLessEquals(Vector3(0.360095, 0.539063, 0)));
      final textureCoord_0_0_41 = textureCoords_0_0.elementAt(41);
      expect(textureCoord_0_0_41, vector3MoreOrLessEquals(Vector3(0.619252, 0.693571, 0)));
      final textureCoord_0_0_42 = textureCoords_0_0.elementAt(42);
      expect(textureCoord_0_0_42, vector3MoreOrLessEquals(Vector3(0.822369, 0.539063, 0)));
      final textureCoord_0_0_43 = textureCoords_0_0.elementAt(43);
      expect(textureCoord_0_0_43, vector3MoreOrLessEquals(Vector3(0.619252, 0.693571, 0)));
      final textureCoord_0_0_44 = textureCoords_0_0.elementAt(44);
      expect(textureCoord_0_0_44, vector3MoreOrLessEquals(Vector3(0.619252, 0.384554, 0)));
      final textureCoord_0_0_45 = textureCoords_0_0.elementAt(45);
      expect(textureCoord_0_0_45, vector3MoreOrLessEquals(Vector3(0.360095, 0.539063, 0)));
      final textureCoord_0_0_46 = textureCoords_0_0.elementAt(46);
      expect(textureCoord_0_0_46, vector3MoreOrLessEquals(Vector3(0.619252, 0.384554, 0)));
      final textureCoord_0_0_47 = textureCoords_0_0.elementAt(47);
      expect(textureCoord_0_0_47, vector3MoreOrLessEquals(Vector3(0.619252, 0.693571, 0)));
      final textureCoord_0_0_48 = textureCoords_0_0.elementAt(48);
      expect(textureCoord_0_0_48, vector3MoreOrLessEquals(Vector3(0.381464, 0.276197, 0)));
      final textureCoord_0_0_49 = textureCoords_0_0.elementAt(49);
      expect(textureCoord_0_0_49, vector3MoreOrLessEquals(Vector3(0.574917, 0.134554, 0)));
      final textureCoord_0_0_50 = textureCoords_0_0.elementAt(50);
      expect(textureCoord_0_0_50, vector3MoreOrLessEquals(Vector3(0.619252, 0.384554, 0)));
      final textureCoord_0_0_51 = textureCoords_0_0.elementAt(51);
      expect(textureCoord_0_0_51, vector3MoreOrLessEquals(Vector3(0.822369, 0.539063, 0)));
      final textureCoord_0_0_52 = textureCoords_0_0.elementAt(52);
      expect(textureCoord_0_0_52, vector3MoreOrLessEquals(Vector3(0.619252, 0.384554, 0)));
      final textureCoord_0_0_53 = textureCoords_0_0.elementAt(53);
      expect(textureCoord_0_0_53, vector3MoreOrLessEquals(Vector3(0.834074, 0.289063, 0)));
      final textureCoord_0_0_54 = textureCoords_0_0.elementAt(54);
      expect(textureCoord_0_0_54, vector3MoreOrLessEquals(Vector3(0.746941, 0.113737, 0)));
      final textureCoord_0_0_55 = textureCoords_0_0.elementAt(55);
      expect(textureCoord_0_0_55, vector3MoreOrLessEquals(Vector3(0.834074, 0.289063, 0)));
      final textureCoord_0_0_56 = textureCoords_0_0.elementAt(56);
      expect(textureCoord_0_0_56, vector3MoreOrLessEquals(Vector3(0.574917, 0.134554, 0)));
      final textureCoord_0_0_57 = textureCoords_0_0.elementAt(57);
      expect(textureCoord_0_0_57, vector3MoreOrLessEquals(Vector3(0.619252, 0.384554, 0)));
      final textureCoord_0_0_58 = textureCoords_0_0.elementAt(58);
      expect(textureCoord_0_0_58, vector3MoreOrLessEquals(Vector3(0.574917, 0.134554, 0)));
      final textureCoord_0_0_59 = textureCoords_0_0.elementAt(59);
      expect(textureCoord_0_0_59, vector3MoreOrLessEquals(Vector3(0.834074, 0.289063, 0)));
      final textureCoord_0_0_60 = textureCoords_0_0.elementAt(60);
      expect(textureCoord_0_0_60, vector3MoreOrLessEquals(Vector3(0.822369, 0.539063, 0)));
      final textureCoord_0_0_61 = textureCoords_0_0.elementAt(61);
      expect(textureCoord_0_0_61, vector3MoreOrLessEquals(Vector3(0.834074, 0.289063, 0)));
      final textureCoord_0_0_62 = textureCoords_0_0.elementAt(62);
      expect(textureCoord_0_0_62, vector3MoreOrLessEquals(Vector3(1.02344, 0.539063, 0)));
      final textureCoord_0_0_63 = textureCoords_0_0.elementAt(63);
      expect(textureCoord_0_0_63, vector3MoreOrLessEquals(Vector3(0.972818, 0.539063, 0)));
      final textureCoord_0_0_64 = textureCoords_0_0.elementAt(64);
      expect(textureCoord_0_0_64, vector3MoreOrLessEquals(Vector3(1.02344, 0.539063, 0)));
      final textureCoord_0_0_65 = textureCoords_0_0.elementAt(65);
      expect(textureCoord_0_0_65, vector3MoreOrLessEquals(Vector3(0.922506, 0.289063, 0)));
      final textureCoord_0_0_66 = textureCoords_0_0.elementAt(66);
      expect(textureCoord_0_0_66, vector3MoreOrLessEquals(Vector3(0.746941, 0.113737, 0)));
      final textureCoord_0_0_67 = textureCoords_0_0.elementAt(67);
      expect(textureCoord_0_0_67, vector3MoreOrLessEquals(Vector3(0.922506, 0.289063, 0)));
      final textureCoord_0_0_68 = textureCoords_0_0.elementAt(68);
      expect(textureCoord_0_0_68, vector3MoreOrLessEquals(Vector3(0.834074, 0.289063, 0)));
      final textureCoord_0_0_69 = textureCoords_0_0.elementAt(69);
      expect(textureCoord_0_0_69, vector3MoreOrLessEquals(Vector3(1.02344, 0.539063, 0)));
      final textureCoord_0_0_70 = textureCoords_0_0.elementAt(70);
      expect(textureCoord_0_0_70, vector3MoreOrLessEquals(Vector3(0.834074, 0.289063, 0)));
      final textureCoord_0_0_71 = textureCoords_0_0.elementAt(71);
      expect(textureCoord_0_0_71, vector3MoreOrLessEquals(Vector3(0.922506, 0.289063, 0)));
      final textureCoord_0_0_72 = textureCoords_0_0.elementAt(72);
      expect(textureCoord_0_0_72, vector3MoreOrLessEquals(Vector3(0.822369, 0.539063, 0)));
      final textureCoord_0_0_73 = textureCoords_0_0.elementAt(73);
      expect(textureCoord_0_0_73, vector3MoreOrLessEquals(Vector3(1.02344, 0.539063, 0)));
      final textureCoord_0_0_74 = textureCoords_0_0.elementAt(74);
      expect(textureCoord_0_0_74, vector3MoreOrLessEquals(Vector3(0.834074, 0.789063, 0)));
      final textureCoord_0_0_75 = textureCoords_0_0.elementAt(75);
      expect(textureCoord_0_0_75, vector3MoreOrLessEquals(Vector3(0.746941, 0.964388, 0)));
      final textureCoord_0_0_76 = textureCoords_0_0.elementAt(76);
      expect(textureCoord_0_0_76, vector3MoreOrLessEquals(Vector3(0.834074, 0.789063, 0)));
      final textureCoord_0_0_77 = textureCoords_0_0.elementAt(77);
      expect(textureCoord_0_0_77, vector3MoreOrLessEquals(Vector3(0.922506, 0.789063, 0)));
      final textureCoord_0_0_78 = textureCoords_0_0.elementAt(78);
      expect(textureCoord_0_0_78, vector3MoreOrLessEquals(Vector3(0.972818, 0.539063, 0)));
      final textureCoord_0_0_79 = textureCoords_0_0.elementAt(79);
      expect(textureCoord_0_0_79, vector3MoreOrLessEquals(Vector3(0.922506, 0.789063, 0)));
      final textureCoord_0_0_80 = textureCoords_0_0.elementAt(80);
      expect(textureCoord_0_0_80, vector3MoreOrLessEquals(Vector3(1.02344, 0.539063, 0)));
      final textureCoord_0_0_81 = textureCoords_0_0.elementAt(81);
      expect(textureCoord_0_0_81, vector3MoreOrLessEquals(Vector3(0.834074, 0.789063, 0)));
      final textureCoord_0_0_82 = textureCoords_0_0.elementAt(82);
      expect(textureCoord_0_0_82, vector3MoreOrLessEquals(Vector3(1.02344, 0.539063, 0)));
      final textureCoord_0_0_83 = textureCoords_0_0.elementAt(83);
      expect(textureCoord_0_0_83, vector3MoreOrLessEquals(Vector3(0.922506, 0.789063, 0)));
      final textureCoord_0_0_84 = textureCoords_0_0.elementAt(84);
      expect(textureCoord_0_0_84, vector3MoreOrLessEquals(Vector3(0.381464, 0.801928, 0)));
      final textureCoord_0_0_85 = textureCoords_0_0.elementAt(85);
      expect(textureCoord_0_0_85, vector3MoreOrLessEquals(Vector3(0.619252, 0.693571, 0)));
      final textureCoord_0_0_86 = textureCoords_0_0.elementAt(86);
      expect(textureCoord_0_0_86, vector3MoreOrLessEquals(Vector3(0.574917, 0.943571, 0)));
      final textureCoord_0_0_87 = textureCoords_0_0.elementAt(87);
      expect(textureCoord_0_0_87, vector3MoreOrLessEquals(Vector3(0.746941, 0.964388, 0)));
      final textureCoord_0_0_88 = textureCoords_0_0.elementAt(88);
      expect(textureCoord_0_0_88, vector3MoreOrLessEquals(Vector3(0.574917, 0.943571, 0)));
      final textureCoord_0_0_89 = textureCoords_0_0.elementAt(89);
      expect(textureCoord_0_0_89, vector3MoreOrLessEquals(Vector3(0.834074, 0.789063, 0)));
      final textureCoord_0_0_90 = textureCoords_0_0.elementAt(90);
      expect(textureCoord_0_0_90, vector3MoreOrLessEquals(Vector3(0.822369, 0.539063, 0)));
      final textureCoord_0_0_91 = textureCoords_0_0.elementAt(91);
      expect(textureCoord_0_0_91, vector3MoreOrLessEquals(Vector3(0.834074, 0.789063, 0)));
      final textureCoord_0_0_92 = textureCoords_0_0.elementAt(92);
      expect(textureCoord_0_0_92, vector3MoreOrLessEquals(Vector3(0.619252, 0.693571, 0)));
      final textureCoord_0_0_93 = textureCoords_0_0.elementAt(93);
      expect(textureCoord_0_0_93, vector3MoreOrLessEquals(Vector3(0.574917, 0.943571, 0)));
      final textureCoord_0_0_94 = textureCoords_0_0.elementAt(94);
      expect(textureCoord_0_0_94, vector3MoreOrLessEquals(Vector3(0.619252, 0.693571, 0)));
      final textureCoord_0_0_95 = textureCoords_0_0.elementAt(95);
      expect(textureCoord_0_0_95, vector3MoreOrLessEquals(Vector3(0.834074, 0.789063, 0)));
      final textureCoord_0_0_96 = textureCoords_0_0.elementAt(96);
      expect(textureCoord_0_0_96, vector3MoreOrLessEquals(Vector3(0.381464, 0.801928, 0)));
      final textureCoord_0_0_97 = textureCoords_0_0.elementAt(97);
      expect(textureCoord_0_0_97, vector3MoreOrLessEquals(Vector3(0.574917, 0.943571, 0)));
      final textureCoord_0_0_98 = textureCoords_0_0.elementAt(98);
      expect(textureCoord_0_0_98, vector3MoreOrLessEquals(Vector3(0.236448, 0.805537, 0)));
      final textureCoord_0_0_99 = textureCoords_0_0.elementAt(99);
      expect(textureCoord_0_0_99, vector3MoreOrLessEquals(Vector3(0.186192, 0.820158, 0)));
      final textureCoord_0_0_100 = textureCoords_0_0.elementAt(100);
      expect(textureCoord_0_0_100, vector3MoreOrLessEquals(Vector3(0.236448, 0.805537, 0)));
      final textureCoord_0_0_101 = textureCoords_0_0.elementAt(101);
      expect(textureCoord_0_0_101, vector3MoreOrLessEquals(Vector3(0.50318, 1.03906, 0)));
      final textureCoord_0_0_102 = textureCoords_0_0.elementAt(102);
      expect(textureCoord_0_0_102, vector3MoreOrLessEquals(Vector3(0.746941, 0.964388, 0)));
      final textureCoord_0_0_103 = textureCoords_0_0.elementAt(103);
      expect(textureCoord_0_0_103, vector3MoreOrLessEquals(Vector3(0.50318, 1.03906, 0)));
      final textureCoord_0_0_104 = textureCoords_0_0.elementAt(104);
      expect(textureCoord_0_0_104, vector3MoreOrLessEquals(Vector3(0.574917, 0.943571, 0)));
      final textureCoord_0_0_105 = textureCoords_0_0.elementAt(105);
      expect(textureCoord_0_0_105, vector3MoreOrLessEquals(Vector3(0.236448, 0.805537, 0)));
      final textureCoord_0_0_106 = textureCoords_0_0.elementAt(106);
      expect(textureCoord_0_0_106, vector3MoreOrLessEquals(Vector3(0.574917, 0.943571, 0)));
      final textureCoord_0_0_107 = textureCoords_0_0.elementAt(107);
      expect(textureCoord_0_0_107, vector3MoreOrLessEquals(Vector3(0.50318, 1.03906, 0)));
      final textureCoord_0_0_108 = textureCoords_0_0.elementAt(108);
      expect(textureCoord_0_0_108, vector3MoreOrLessEquals(Vector3(0.186192, 0.820158, 0)));
      final textureCoord_0_0_109 = textureCoords_0_0.elementAt(109);
      expect(textureCoord_0_0_109, vector3MoreOrLessEquals(Vector3(0.50318, 1.03906, 0)));
      final textureCoord_0_0_110 = textureCoords_0_0.elementAt(110);
      expect(textureCoord_0_0_110, vector3MoreOrLessEquals(Vector3(0.284677, 0.805537, 0)));
      final textureCoord_0_0_111 = textureCoords_0_0.elementAt(111);
      expect(textureCoord_0_0_111, vector3MoreOrLessEquals(Vector3(0.624896, 0.801928, 0)));
      final textureCoord_0_0_112 = textureCoords_0_0.elementAt(112);
      expect(textureCoord_0_0_112, vector3MoreOrLessEquals(Vector3(0.284677, 0.805537, 0)));
      final textureCoord_0_0_113 = textureCoords_0_0.elementAt(113);
      expect(textureCoord_0_0_113, vector3MoreOrLessEquals(Vector3(0.718002, 0.943571, 0)));
      final textureCoord_0_0_114 = textureCoords_0_0.elementAt(114);
      expect(textureCoord_0_0_114, vector3MoreOrLessEquals(Vector3(0.746941, 0.964388, 0)));
      final textureCoord_0_0_115 = textureCoords_0_0.elementAt(115);
      expect(textureCoord_0_0_115, vector3MoreOrLessEquals(Vector3(0.718002, 0.943571, 0)));
      final textureCoord_0_0_116 = textureCoords_0_0.elementAt(116);
      expect(textureCoord_0_0_116, vector3MoreOrLessEquals(Vector3(0.50318, 1.03906, 0)));
      final textureCoord_0_0_117 = textureCoords_0_0.elementAt(117);
      expect(textureCoord_0_0_117, vector3MoreOrLessEquals(Vector3(0.284677, 0.805537, 0)));
      final textureCoord_0_0_118 = textureCoords_0_0.elementAt(118);
      expect(textureCoord_0_0_118, vector3MoreOrLessEquals(Vector3(0.50318, 1.03906, 0)));
      final textureCoord_0_0_119 = textureCoords_0_0.elementAt(119);
      expect(textureCoord_0_0_119, vector3MoreOrLessEquals(Vector3(0.718002, 0.943571, 0)));
      final textureCoord_0_0_120 = textureCoords_0_0.elementAt(120);
      expect(textureCoord_0_0_120, vector3MoreOrLessEquals(Vector3(0.624896, 0.801928, 0)));
      final textureCoord_0_0_121 = textureCoords_0_0.elementAt(121);
      expect(textureCoord_0_0_121, vector3MoreOrLessEquals(Vector3(0.718002, 0.943571, 0)));
      final textureCoord_0_0_122 = textureCoords_0_0.elementAt(122);
      expect(textureCoord_0_0_122, vector3MoreOrLessEquals(Vector3(0.850769, 0.693571, 0)));
      final textureCoord_0_0_123 = textureCoords_0_0.elementAt(123);
      expect(textureCoord_0_0_123, vector3MoreOrLessEquals(Vector3(0.972818, 0.539063, 0)));
      final textureCoord_0_0_124 = textureCoords_0_0.elementAt(124);
      expect(textureCoord_0_0_124, vector3MoreOrLessEquals(Vector3(0.850769, 0.693571, 0)));
      final textureCoord_0_0_125 = textureCoords_0_0.elementAt(125);
      expect(textureCoord_0_0_125, vector3MoreOrLessEquals(Vector3(0.922506, 0.789063, 0)));
      final textureCoord_0_0_126 = textureCoords_0_0.elementAt(126);
      expect(textureCoord_0_0_126, vector3MoreOrLessEquals(Vector3(0.746941, 0.964388, 0)));
      final textureCoord_0_0_127 = textureCoords_0_0.elementAt(127);
      expect(textureCoord_0_0_127, vector3MoreOrLessEquals(Vector3(0.922506, 0.789063, 0)));
      final textureCoord_0_0_128 = textureCoords_0_0.elementAt(128);
      expect(textureCoord_0_0_128, vector3MoreOrLessEquals(Vector3(0.718002, 0.943571, 0)));
      final textureCoord_0_0_129 = textureCoords_0_0.elementAt(129);
      expect(textureCoord_0_0_129, vector3MoreOrLessEquals(Vector3(0.850769, 0.693571, 0)));
      final textureCoord_0_0_130 = textureCoords_0_0.elementAt(130);
      expect(textureCoord_0_0_130, vector3MoreOrLessEquals(Vector3(0.718002, 0.943571, 0)));
      final textureCoord_0_0_131 = textureCoords_0_0.elementAt(131);
      expect(textureCoord_0_0_131, vector3MoreOrLessEquals(Vector3(0.922506, 0.789063, 0)));
      final textureCoord_0_0_132 = textureCoords_0_0.elementAt(132);
      expect(textureCoord_0_0_132, vector3MoreOrLessEquals(Vector3(0.624896, 0.801928, 0)));
      final textureCoord_0_0_133 = textureCoords_0_0.elementAt(133);
      expect(textureCoord_0_0_133, vector3MoreOrLessEquals(Vector3(0.850769, 0.693571, 0)));
      final textureCoord_0_0_134 = textureCoords_0_0.elementAt(134);
      expect(textureCoord_0_0_134, vector3MoreOrLessEquals(Vector3(0.646266, 0.539063, 0)));
      final textureCoord_0_0_135 = textureCoords_0_0.elementAt(135);
      expect(textureCoord_0_0_135, vector3MoreOrLessEquals(Vector3(0.624896, 0.276197, 0)));
      final textureCoord_0_0_136 = textureCoords_0_0.elementAt(136);
      expect(textureCoord_0_0_136, vector3MoreOrLessEquals(Vector3(0.646266, 0.539063, 0)));
      final textureCoord_0_0_137 = textureCoords_0_0.elementAt(137);
      expect(textureCoord_0_0_137, vector3MoreOrLessEquals(Vector3(0.850769, 0.384554, 0)));
      final textureCoord_0_0_138 = textureCoords_0_0.elementAt(138);
      expect(textureCoord_0_0_138, vector3MoreOrLessEquals(Vector3(0.972818, 0.539063, 0)));
      final textureCoord_0_0_139 = textureCoords_0_0.elementAt(139);
      expect(textureCoord_0_0_139, vector3MoreOrLessEquals(Vector3(0.850769, 0.384554, 0)));
      final textureCoord_0_0_140 = textureCoords_0_0.elementAt(140);
      expect(textureCoord_0_0_140, vector3MoreOrLessEquals(Vector3(0.850769, 0.693571, 0)));
      final textureCoord_0_0_141 = textureCoords_0_0.elementAt(141);
      expect(textureCoord_0_0_141, vector3MoreOrLessEquals(Vector3(0.646266, 0.539063, 0)));
      final textureCoord_0_0_142 = textureCoords_0_0.elementAt(142);
      expect(textureCoord_0_0_142, vector3MoreOrLessEquals(Vector3(0.850769, 0.693571, 0)));
      final textureCoord_0_0_143 = textureCoords_0_0.elementAt(143);
      expect(textureCoord_0_0_143, vector3MoreOrLessEquals(Vector3(0.850769, 0.384554, 0)));
      final textureCoord_0_0_144 = textureCoords_0_0.elementAt(144);
      expect(textureCoord_0_0_144, vector3MoreOrLessEquals(Vector3(0.624896, 0.801928, 0)));
      final textureCoord_0_0_145 = textureCoords_0_0.elementAt(145);
      expect(textureCoord_0_0_145, vector3MoreOrLessEquals(Vector3(0.646266, 0.539063, 0)));
      final textureCoord_0_0_146 = textureCoords_0_0.elementAt(146);
      expect(textureCoord_0_0_146, vector3MoreOrLessEquals(Vector3(0.234041, 0.629954, 0)));
      final textureCoord_0_0_147 = textureCoords_0_0.elementAt(147);
      expect(textureCoord_0_0_147, vector3MoreOrLessEquals(Vector3(0.100045, 0.521438, 0)));
      final textureCoord_0_0_148 = textureCoords_0_0.elementAt(148);
      expect(textureCoord_0_0_148, vector3MoreOrLessEquals(Vector3(0.234041, 0.629954, 0)));
      final textureCoord_0_0_149 = textureCoords_0_0.elementAt(149);
      expect(textureCoord_0_0_149, vector3MoreOrLessEquals(Vector3(0.234041, 0.412922, 0)));
      final textureCoord_0_0_150 = textureCoords_0_0.elementAt(150);
      expect(textureCoord_0_0_150, vector3MoreOrLessEquals(Vector3(0.624896, 0.276197, 0)));
      final textureCoord_0_0_151 = textureCoords_0_0.elementAt(151);
      expect(textureCoord_0_0_151, vector3MoreOrLessEquals(Vector3(0.234041, 0.412922, 0)));
      final textureCoord_0_0_152 = textureCoords_0_0.elementAt(152);
      expect(textureCoord_0_0_152, vector3MoreOrLessEquals(Vector3(0.646266, 0.539063, 0)));
      final textureCoord_0_0_153 = textureCoords_0_0.elementAt(153);
      expect(textureCoord_0_0_153, vector3MoreOrLessEquals(Vector3(0.234041, 0.629954, 0)));
      final textureCoord_0_0_154 = textureCoords_0_0.elementAt(154);
      expect(textureCoord_0_0_154, vector3MoreOrLessEquals(Vector3(0.646266, 0.539063, 0)));
      final textureCoord_0_0_155 = textureCoords_0_0.elementAt(155);
      expect(textureCoord_0_0_155, vector3MoreOrLessEquals(Vector3(0.234041, 0.412922, 0)));
      final textureCoord_0_0_156 = textureCoords_0_0.elementAt(156);
      expect(textureCoord_0_0_156, vector3MoreOrLessEquals(Vector3(0.100045, 0.521438, 0)));
      final textureCoord_0_0_157 = textureCoords_0_0.elementAt(157);
      expect(textureCoord_0_0_157, vector3MoreOrLessEquals(Vector3(0.234041, 0.412922, 0)));
      final textureCoord_0_0_158 = textureCoords_0_0.elementAt(158);
      expect(textureCoord_0_0_158, vector3MoreOrLessEquals(Vector3(0.103881, 0.345855, 0)));
      final textureCoord_0_0_159 = textureCoords_0_0.elementAt(159);
      expect(textureCoord_0_0_159, vector3MoreOrLessEquals(Vector3(0.186192, 0.222718, 0)));
      final textureCoord_0_0_160 = textureCoords_0_0.elementAt(160);
      expect(textureCoord_0_0_160, vector3MoreOrLessEquals(Vector3(0.103881, 0.345855, 0)));
      final textureCoord_0_0_161 = textureCoords_0_0.elementAt(161);
      expect(textureCoord_0_0_161, vector3MoreOrLessEquals(Vector3(0.284677, 0.237339, 0)));
      final textureCoord_0_0_162 = textureCoords_0_0.elementAt(162);
      expect(textureCoord_0_0_162, vector3MoreOrLessEquals(Vector3(0.624896, 0.276197, 0)));
      final textureCoord_0_0_163 = textureCoords_0_0.elementAt(163);
      expect(textureCoord_0_0_163, vector3MoreOrLessEquals(Vector3(0.284677, 0.237339, 0)));
      final textureCoord_0_0_164 = textureCoords_0_0.elementAt(164);
      expect(textureCoord_0_0_164, vector3MoreOrLessEquals(Vector3(0.234041, 0.412922, 0)));
      final textureCoord_0_0_165 = textureCoords_0_0.elementAt(165);
      expect(textureCoord_0_0_165, vector3MoreOrLessEquals(Vector3(0.103881, 0.345855, 0)));
      final textureCoord_0_0_166 = textureCoords_0_0.elementAt(166);
      expect(textureCoord_0_0_166, vector3MoreOrLessEquals(Vector3(0.234041, 0.412922, 0)));
      final textureCoord_0_0_167 = textureCoords_0_0.elementAt(167);
      expect(textureCoord_0_0_167, vector3MoreOrLessEquals(Vector3(0.284677, 0.237339, 0)));
      final textureCoord_0_0_168 = textureCoords_0_0.elementAt(168);
      expect(textureCoord_0_0_168, vector3MoreOrLessEquals(Vector3(0.186192, 0.222718, 0)));
      final textureCoord_0_0_169 = textureCoords_0_0.elementAt(169);
      expect(textureCoord_0_0_169, vector3MoreOrLessEquals(Vector3(0.284677, 0.237339, 0)));
      final textureCoord_0_0_170 = textureCoords_0_0.elementAt(170);
      expect(textureCoord_0_0_170, vector3MoreOrLessEquals(Vector3(0.50318, 0.039063, 0)));
      final textureCoord_0_0_171 = textureCoords_0_0.elementAt(171);
      expect(textureCoord_0_0_171, vector3MoreOrLessEquals(Vector3(0.746941, 0.113737, 0)));
      final textureCoord_0_0_172 = textureCoords_0_0.elementAt(172);
      expect(textureCoord_0_0_172, vector3MoreOrLessEquals(Vector3(0.50318, 0.039063, 0)));
      final textureCoord_0_0_173 = textureCoords_0_0.elementAt(173);
      expect(textureCoord_0_0_173, vector3MoreOrLessEquals(Vector3(0.718002, 0.134554, 0)));
      final textureCoord_0_0_174 = textureCoords_0_0.elementAt(174);
      expect(textureCoord_0_0_174, vector3MoreOrLessEquals(Vector3(0.624896, 0.276197, 0)));
      final textureCoord_0_0_175 = textureCoords_0_0.elementAt(175);
      expect(textureCoord_0_0_175, vector3MoreOrLessEquals(Vector3(0.718002, 0.134554, 0)));
      final textureCoord_0_0_176 = textureCoords_0_0.elementAt(176);
      expect(textureCoord_0_0_176, vector3MoreOrLessEquals(Vector3(0.284677, 0.237339, 0)));
      final textureCoord_0_0_177 = textureCoords_0_0.elementAt(177);
      expect(textureCoord_0_0_177, vector3MoreOrLessEquals(Vector3(0.50318, 0.039063, 0)));
      final textureCoord_0_0_178 = textureCoords_0_0.elementAt(178);
      expect(textureCoord_0_0_178, vector3MoreOrLessEquals(Vector3(0.284677, 0.237339, 0)));
      final textureCoord_0_0_179 = textureCoords_0_0.elementAt(179);
      expect(textureCoord_0_0_179, vector3MoreOrLessEquals(Vector3(0.718002, 0.134554, 0)));
      final textureCoord_0_0_180 = textureCoords_0_0.elementAt(180);
      expect(textureCoord_0_0_180, vector3MoreOrLessEquals(Vector3(0.624896, 0.276197, 0)));
      final textureCoord_0_0_181 = textureCoords_0_0.elementAt(181);
      expect(textureCoord_0_0_181, vector3MoreOrLessEquals(Vector3(0.850769, 0.384554, 0)));
      final textureCoord_0_0_182 = textureCoords_0_0.elementAt(182);
      expect(textureCoord_0_0_182, vector3MoreOrLessEquals(Vector3(0.718002, 0.134554, 0)));
      final textureCoord_0_0_183 = textureCoords_0_0.elementAt(183);
      expect(textureCoord_0_0_183, vector3MoreOrLessEquals(Vector3(0.746941, 0.113737, 0)));
      final textureCoord_0_0_184 = textureCoords_0_0.elementAt(184);
      expect(textureCoord_0_0_184, vector3MoreOrLessEquals(Vector3(0.718002, 0.134554, 0)));
      final textureCoord_0_0_185 = textureCoords_0_0.elementAt(185);
      expect(textureCoord_0_0_185, vector3MoreOrLessEquals(Vector3(0.922506, 0.289063, 0)));
      final textureCoord_0_0_186 = textureCoords_0_0.elementAt(186);
      expect(textureCoord_0_0_186, vector3MoreOrLessEquals(Vector3(0.972818, 0.539063, 0)));
      final textureCoord_0_0_187 = textureCoords_0_0.elementAt(187);
      expect(textureCoord_0_0_187, vector3MoreOrLessEquals(Vector3(0.922506, 0.289063, 0)));
      final textureCoord_0_0_188 = textureCoords_0_0.elementAt(188);
      expect(textureCoord_0_0_188, vector3MoreOrLessEquals(Vector3(0.850769, 0.384554, 0)));
      final textureCoord_0_0_189 = textureCoords_0_0.elementAt(189);
      expect(textureCoord_0_0_189, vector3MoreOrLessEquals(Vector3(0.718002, 0.134554, 0)));
      final textureCoord_0_0_190 = textureCoords_0_0.elementAt(190);
      expect(textureCoord_0_0_190, vector3MoreOrLessEquals(Vector3(0.850769, 0.384554, 0)));
      final textureCoord_0_0_191 = textureCoords_0_0.elementAt(191);
      expect(textureCoord_0_0_191, vector3MoreOrLessEquals(Vector3(0.922506, 0.289063, 0)));
      final textureCoord_0_0_192 = textureCoords_0_0.elementAt(192);
      expect(textureCoord_0_0_192, vector3MoreOrLessEquals(Vector3(0.049334, 0.521438, 0)));
      final textureCoord_0_0_193 = textureCoords_0_0.elementAt(193);
      expect(textureCoord_0_0_193, vector3MoreOrLessEquals(Vector3(0.023438, 0.521438, 0)));
      final textureCoord_0_0_194 = textureCoords_0_0.elementAt(194);
      expect(textureCoord_0_0_194, vector3MoreOrLessEquals(Vector3(0.074073, 0.345855, 0)));
      final textureCoord_0_0_195 = textureCoords_0_0.elementAt(195);
      expect(textureCoord_0_0_195, vector3MoreOrLessEquals(Vector3(0.186192, 0.222718, 0)));
      final textureCoord_0_0_196 = textureCoords_0_0.elementAt(196);
      expect(textureCoord_0_0_196, vector3MoreOrLessEquals(Vector3(0.074073, 0.345855, 0)));
      final textureCoord_0_0_197 = textureCoords_0_0.elementAt(197);
      expect(textureCoord_0_0_197, vector3MoreOrLessEquals(Vector3(0.103881, 0.345855, 0)));
      final textureCoord_0_0_198 = textureCoords_0_0.elementAt(198);
      expect(textureCoord_0_0_198, vector3MoreOrLessEquals(Vector3(0.100045, 0.521438, 0)));
      final textureCoord_0_0_199 = textureCoords_0_0.elementAt(199);
      expect(textureCoord_0_0_199, vector3MoreOrLessEquals(Vector3(0.103881, 0.345855, 0)));
      final textureCoord_0_0_200 = textureCoords_0_0.elementAt(200);
      expect(textureCoord_0_0_200, vector3MoreOrLessEquals(Vector3(0.023438, 0.521438, 0)));
      final textureCoord_0_0_201 = textureCoords_0_0.elementAt(201);
      expect(textureCoord_0_0_201, vector3MoreOrLessEquals(Vector3(0.074073, 0.345855, 0)));
      final textureCoord_0_0_202 = textureCoords_0_0.elementAt(202);
      expect(textureCoord_0_0_202, vector3MoreOrLessEquals(Vector3(0.023438, 0.521438, 0)));
      final textureCoord_0_0_203 = textureCoords_0_0.elementAt(203);
      expect(textureCoord_0_0_203, vector3MoreOrLessEquals(Vector3(0.103881, 0.345855, 0)));
      final textureCoord_0_0_204 = textureCoords_0_0.elementAt(204);
      expect(textureCoord_0_0_204, vector3MoreOrLessEquals(Vector3(0.049334, 0.521438, 0)));
      final textureCoord_0_0_205 = textureCoords_0_0.elementAt(205);
      expect(textureCoord_0_0_205, vector3MoreOrLessEquals(Vector3(0.074073, 0.697021, 0)));
      final textureCoord_0_0_206 = textureCoords_0_0.elementAt(206);
      expect(textureCoord_0_0_206, vector3MoreOrLessEquals(Vector3(0.023438, 0.521438, 0)));
      final textureCoord_0_0_207 = textureCoords_0_0.elementAt(207);
      expect(textureCoord_0_0_207, vector3MoreOrLessEquals(Vector3(0.100045, 0.521438, 0)));
      final textureCoord_0_0_208 = textureCoords_0_0.elementAt(208);
      expect(textureCoord_0_0_208, vector3MoreOrLessEquals(Vector3(0.023438, 0.521438, 0)));
      final textureCoord_0_0_209 = textureCoords_0_0.elementAt(209);
      expect(textureCoord_0_0_209, vector3MoreOrLessEquals(Vector3(0.103881, 0.697021, 0)));
      final textureCoord_0_0_210 = textureCoords_0_0.elementAt(210);
      expect(textureCoord_0_0_210, vector3MoreOrLessEquals(Vector3(0.186192, 0.820158, 0)));
      final textureCoord_0_0_211 = textureCoords_0_0.elementAt(211);
      expect(textureCoord_0_0_211, vector3MoreOrLessEquals(Vector3(0.103881, 0.697021, 0)));
      final textureCoord_0_0_212 = textureCoords_0_0.elementAt(212);
      expect(textureCoord_0_0_212, vector3MoreOrLessEquals(Vector3(0.074073, 0.697021, 0)));
      final textureCoord_0_0_213 = textureCoords_0_0.elementAt(213);
      expect(textureCoord_0_0_213, vector3MoreOrLessEquals(Vector3(0.023438, 0.521438, 0)));
      final textureCoord_0_0_214 = textureCoords_0_0.elementAt(214);
      expect(textureCoord_0_0_214, vector3MoreOrLessEquals(Vector3(0.074073, 0.697021, 0)));
      final textureCoord_0_0_215 = textureCoords_0_0.elementAt(215);
      expect(textureCoord_0_0_215, vector3MoreOrLessEquals(Vector3(0.103881, 0.697021, 0)));
      final textureCoord_0_0_216 = textureCoords_0_0.elementAt(216);
      expect(textureCoord_0_0_216, vector3MoreOrLessEquals(Vector3(0.049334, 0.521438, 0)));
      final textureCoord_0_0_217 = textureCoords_0_0.elementAt(217);
      expect(textureCoord_0_0_217, vector3MoreOrLessEquals(Vector3(0.156004, 0.629954, 0)));
      final textureCoord_0_0_218 = textureCoords_0_0.elementAt(218);
      expect(textureCoord_0_0_218, vector3MoreOrLessEquals(Vector3(0.074073, 0.697021, 0)));
      final textureCoord_0_0_219 = textureCoords_0_0.elementAt(219);
      expect(textureCoord_0_0_219, vector3MoreOrLessEquals(Vector3(0.186192, 0.820158, 0)));
      final textureCoord_0_0_220 = textureCoords_0_0.elementAt(220);
      expect(textureCoord_0_0_220, vector3MoreOrLessEquals(Vector3(0.074073, 0.697021, 0)));
      final textureCoord_0_0_221 = textureCoords_0_0.elementAt(221);
      expect(textureCoord_0_0_221, vector3MoreOrLessEquals(Vector3(0.236448, 0.805537, 0)));
      final textureCoord_0_0_222 = textureCoords_0_0.elementAt(222);
      expect(textureCoord_0_0_222, vector3MoreOrLessEquals(Vector3(0.381464, 0.801928, 0)));
      final textureCoord_0_0_223 = textureCoords_0_0.elementAt(223);
      expect(textureCoord_0_0_223, vector3MoreOrLessEquals(Vector3(0.236448, 0.805537, 0)));
      final textureCoord_0_0_224 = textureCoords_0_0.elementAt(224);
      expect(textureCoord_0_0_224, vector3MoreOrLessEquals(Vector3(0.156004, 0.629954, 0)));
      final textureCoord_0_0_225 = textureCoords_0_0.elementAt(225);
      expect(textureCoord_0_0_225, vector3MoreOrLessEquals(Vector3(0.074073, 0.697021, 0)));
      final textureCoord_0_0_226 = textureCoords_0_0.elementAt(226);
      expect(textureCoord_0_0_226, vector3MoreOrLessEquals(Vector3(0.156004, 0.629954, 0)));
      final textureCoord_0_0_227 = textureCoords_0_0.elementAt(227);
      expect(textureCoord_0_0_227, vector3MoreOrLessEquals(Vector3(0.236448, 0.805537, 0)));
      final textureCoord_0_0_228 = textureCoords_0_0.elementAt(228);
      expect(textureCoord_0_0_228, vector3MoreOrLessEquals(Vector3(0.624896, 0.801928, 0)));
      final textureCoord_0_0_229 = textureCoords_0_0.elementAt(229);
      expect(textureCoord_0_0_229, vector3MoreOrLessEquals(Vector3(0.234041, 0.629954, 0)));
      final textureCoord_0_0_230 = textureCoords_0_0.elementAt(230);
      expect(textureCoord_0_0_230, vector3MoreOrLessEquals(Vector3(0.284677, 0.805537, 0)));
      final textureCoord_0_0_231 = textureCoords_0_0.elementAt(231);
      expect(textureCoord_0_0_231, vector3MoreOrLessEquals(Vector3(0.186192, 0.820158, 0)));
      final textureCoord_0_0_232 = textureCoords_0_0.elementAt(232);
      expect(textureCoord_0_0_232, vector3MoreOrLessEquals(Vector3(0.284677, 0.805537, 0)));
      final textureCoord_0_0_233 = textureCoords_0_0.elementAt(233);
      expect(textureCoord_0_0_233, vector3MoreOrLessEquals(Vector3(0.103881, 0.697021, 0)));
      final textureCoord_0_0_234 = textureCoords_0_0.elementAt(234);
      expect(textureCoord_0_0_234, vector3MoreOrLessEquals(Vector3(0.100045, 0.521438, 0)));
      final textureCoord_0_0_235 = textureCoords_0_0.elementAt(235);
      expect(textureCoord_0_0_235, vector3MoreOrLessEquals(Vector3(0.103881, 0.697021, 0)));
      final textureCoord_0_0_236 = textureCoords_0_0.elementAt(236);
      expect(textureCoord_0_0_236, vector3MoreOrLessEquals(Vector3(0.234041, 0.629954, 0)));
      final textureCoord_0_0_237 = textureCoords_0_0.elementAt(237);
      expect(textureCoord_0_0_237, vector3MoreOrLessEquals(Vector3(0.284677, 0.805537, 0)));
      final textureCoord_0_0_238 = textureCoords_0_0.elementAt(238);
      expect(textureCoord_0_0_238, vector3MoreOrLessEquals(Vector3(0.234041, 0.629954, 0)));
      final textureCoord_0_0_239 = textureCoords_0_0.elementAt(239);
      expect(textureCoord_0_0_239, vector3MoreOrLessEquals(Vector3(0.103881, 0.697021, 0)));
      expect(mesh_0.uvComponents.length, equals(1));
      expect(mesh_0.uvComponents, equals([2]));
      expect(mesh_0.faces.length, equals(80));
      expect(mesh_0.bones.length, isZero);
      expect(mesh_0.materialIndex, equals(3));
      expect(mesh_0.name, equals('HLeib01'));
      expect(mesh_0.animMeshes.length, isZero);
      expect(mesh_0.morphingMethod, isZero);
      expect(mesh_0.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_1 = meshes.elementAt(1);
      expect(mesh_1.primitiveTypes, equals(4));
      expect(mesh_1.vertices.length, equals(180));
      final vertex_1_0 = mesh_1.vertices.elementAt(0);
      expect(vertex_1_0, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, 9.43077)));
      final vertex_1_1 = mesh_1.vertices.elementAt(1);
      expect(vertex_1_1, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, 3.08142)));
      final vertex_1_2 = mesh_1.vertices.elementAt(2);
      expect(vertex_1_2, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, 8.47976)));
      final vertex_1_3 = mesh_1.vertices.elementAt(3);
      expect(vertex_1_3, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -3.12269)));
      final vertex_1_4 = mesh_1.vertices.elementAt(4);
      expect(vertex_1_4, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, 8.47976)));
      final vertex_1_5 = mesh_1.vertices.elementAt(5);
      expect(vertex_1_5, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, 0.583091)));
      final vertex_1_6 = mesh_1.vertices.elementAt(6);
      expect(vertex_1_6, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, 1.12772)));
      final vertex_1_7 = mesh_1.vertices.elementAt(7);
      expect(vertex_1_7, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, 0.583091)));
      final vertex_1_8 = mesh_1.vertices.elementAt(8);
      expect(vertex_1_8, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, 3.08142)));
      final vertex_1_9 = mesh_1.vertices.elementAt(9);
      expect(vertex_1_9, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, 8.47976)));
      final vertex_1_10 = mesh_1.vertices.elementAt(10);
      expect(vertex_1_10, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, 3.08142)));
      final vertex_1_11 = mesh_1.vertices.elementAt(11);
      expect(vertex_1_11, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, 0.583091)));
      final vertex_1_12 = mesh_1.vertices.elementAt(12);
      expect(vertex_1_12, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, 9.43077)));
      final vertex_1_13 = mesh_1.vertices.elementAt(13);
      expect(vertex_1_13, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, 8.47976)));
      final vertex_1_14 = mesh_1.vertices.elementAt(14);
      expect(vertex_1_14, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, 1.42112)));
      final vertex_1_15 = mesh_1.vertices.elementAt(15);
      expect(vertex_1_15, vector3MoreOrLessEquals(Vector3(-44.8447, 15.2285, -10)));
      final vertex_1_16 = mesh_1.vertices.elementAt(16);
      expect(vertex_1_16, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, 1.42112)));
      final vertex_1_17 = mesh_1.vertices.elementAt(17);
      expect(vertex_1_17, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -2.94136)));
      final vertex_1_18 = mesh_1.vertices.elementAt(18);
      expect(vertex_1_18, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -3.12269)));
      final vertex_1_19 = mesh_1.vertices.elementAt(19);
      expect(vertex_1_19, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -2.94136)));
      final vertex_1_20 = mesh_1.vertices.elementAt(20);
      expect(vertex_1_20, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, 8.47976)));
      final vertex_1_21 = mesh_1.vertices.elementAt(21);
      expect(vertex_1_21, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, 1.42112)));
      final vertex_1_22 = mesh_1.vertices.elementAt(22);
      expect(vertex_1_22, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, 8.47976)));
      final vertex_1_23 = mesh_1.vertices.elementAt(23);
      expect(vertex_1_23, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -2.94136)));
      final vertex_1_24 = mesh_1.vertices.elementAt(24);
      expect(vertex_1_24, vector3MoreOrLessEquals(Vector3(-44.8447, 15.2285, -10)));
      final vertex_1_25 = mesh_1.vertices.elementAt(25);
      expect(vertex_1_25, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -2.94136)));
      final vertex_1_26 = mesh_1.vertices.elementAt(26);
      expect(vertex_1_26, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -17.0586)));
      final vertex_1_27 = mesh_1.vertices.elementAt(27);
      expect(vertex_1_27, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -16.8773)));
      final vertex_1_28 = mesh_1.vertices.elementAt(28);
      expect(vertex_1_28, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -17.0586)));
      final vertex_1_29 = mesh_1.vertices.elementAt(29);
      expect(vertex_1_29, vector3MoreOrLessEquals(Vector3(-23.7785, 14.1423, -10)));
      final vertex_1_30 = mesh_1.vertices.elementAt(30);
      expect(vertex_1_30, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -3.12269)));
      final vertex_1_31 = mesh_1.vertices.elementAt(31);
      expect(vertex_1_31, vector3MoreOrLessEquals(Vector3(-23.7785, 14.1423, -10)));
      final vertex_1_32 = mesh_1.vertices.elementAt(32);
      expect(vertex_1_32, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -2.94136)));
      final vertex_1_33 = mesh_1.vertices.elementAt(33);
      expect(vertex_1_33, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -17.0586)));
      final vertex_1_34 = mesh_1.vertices.elementAt(34);
      expect(vertex_1_34, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -2.94136)));
      final vertex_1_35 = mesh_1.vertices.elementAt(35);
      expect(vertex_1_35, vector3MoreOrLessEquals(Vector3(-23.7785, 14.1423, -10)));
      final vertex_1_36 = mesh_1.vertices.elementAt(36);
      expect(vertex_1_36, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -3.12269)));
      final vertex_1_37 = mesh_1.vertices.elementAt(37);
      expect(vertex_1_37, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -5.95762)));
      final vertex_1_38 = mesh_1.vertices.elementAt(38);
      expect(vertex_1_38, vector3MoreOrLessEquals(Vector3(-23.7785, 14.1423, -10)));
      final vertex_1_39 = mesh_1.vertices.elementAt(39);
      expect(vertex_1_39, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -16.8773)));
      final vertex_1_40 = mesh_1.vertices.elementAt(40);
      expect(vertex_1_40, vector3MoreOrLessEquals(Vector3(-23.7785, 14.1423, -10)));
      final vertex_1_41 = mesh_1.vertices.elementAt(41);
      expect(vertex_1_41, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -14.0424)));
      final vertex_1_42 = mesh_1.vertices.elementAt(42);
      expect(vertex_1_42, vector3MoreOrLessEquals(Vector3(-1.33709, 1.10811, -10)));
      final vertex_1_43 = mesh_1.vertices.elementAt(43);
      expect(vertex_1_43, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -14.0424)));
      final vertex_1_44 = mesh_1.vertices.elementAt(44);
      expect(vertex_1_44, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -5.95762)));
      final vertex_1_45 = mesh_1.vertices.elementAt(45);
      expect(vertex_1_45, vector3MoreOrLessEquals(Vector3(-23.7785, 14.1423, -10)));
      final vertex_1_46 = mesh_1.vertices.elementAt(46);
      expect(vertex_1_46, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -5.95762)));
      final vertex_1_47 = mesh_1.vertices.elementAt(47);
      expect(vertex_1_47, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -14.0424)));
      final vertex_1_48 = mesh_1.vertices.elementAt(48);
      expect(vertex_1_48, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -3.12269)));
      final vertex_1_49 = mesh_1.vertices.elementAt(49);
      expect(vertex_1_49, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, 0.583091)));
      final vertex_1_50 = mesh_1.vertices.elementAt(50);
      expect(vertex_1_50, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -5.95762)));
      final vertex_1_51 = mesh_1.vertices.elementAt(51);
      expect(vertex_1_51, vector3MoreOrLessEquals(Vector3(-1.33709, 1.10811, -10)));
      final vertex_1_52 = mesh_1.vertices.elementAt(52);
      expect(vertex_1_52, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -5.95762)));
      final vertex_1_53 = mesh_1.vertices.elementAt(53);
      expect(vertex_1_53, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -0.594703)));
      final vertex_1_54 = mesh_1.vertices.elementAt(54);
      expect(vertex_1_54, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, 1.12772)));
      final vertex_1_55 = mesh_1.vertices.elementAt(55);
      expect(vertex_1_55, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -0.594703)));
      final vertex_1_56 = mesh_1.vertices.elementAt(56);
      expect(vertex_1_56, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, 0.583091)));
      final vertex_1_57 = mesh_1.vertices.elementAt(57);
      expect(vertex_1_57, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -5.95762)));
      final vertex_1_58 = mesh_1.vertices.elementAt(58);
      expect(vertex_1_58, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, 0.583091)));
      final vertex_1_59 = mesh_1.vertices.elementAt(59);
      expect(vertex_1_59, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -0.594703)));
      final vertex_1_60 = mesh_1.vertices.elementAt(60);
      expect(vertex_1_60, vector3MoreOrLessEquals(Vector3(-1.33709, 1.10811, -10)));
      final vertex_1_61 = mesh_1.vertices.elementAt(61);
      expect(vertex_1_61, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -0.594703)));
      final vertex_1_62 = mesh_1.vertices.elementAt(62);
      expect(vertex_1_62, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_63 = mesh_1.vertices.elementAt(63);
      expect(vertex_1_63, vector3MoreOrLessEquals(Vector3(-6.30518, -14.1821, -10)));
      final vertex_1_64 = mesh_1.vertices.elementAt(64);
      expect(vertex_1_64, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_65 = mesh_1.vertices.elementAt(65);
      expect(vertex_1_65, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -0.594703)));
      final vertex_1_66 = mesh_1.vertices.elementAt(66);
      expect(vertex_1_66, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, 1.12772)));
      final vertex_1_67 = mesh_1.vertices.elementAt(67);
      expect(vertex_1_67, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -0.594703)));
      final vertex_1_68 = mesh_1.vertices.elementAt(68);
      expect(vertex_1_68, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -0.594703)));
      final vertex_1_69 = mesh_1.vertices.elementAt(69);
      expect(vertex_1_69, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_70 = mesh_1.vertices.elementAt(70);
      expect(vertex_1_70, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -0.594703)));
      final vertex_1_71 = mesh_1.vertices.elementAt(71);
      expect(vertex_1_71, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -0.594703)));
      final vertex_1_72 = mesh_1.vertices.elementAt(72);
      expect(vertex_1_72, vector3MoreOrLessEquals(Vector3(-1.33709, 1.10811, -10)));
      final vertex_1_73 = mesh_1.vertices.elementAt(73);
      expect(vertex_1_73, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_74 = mesh_1.vertices.elementAt(74);
      expect(vertex_1_74, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -19.4053)));
      final vertex_1_75 = mesh_1.vertices.elementAt(75);
      expect(vertex_1_75, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, -21.1277)));
      final vertex_1_76 = mesh_1.vertices.elementAt(76);
      expect(vertex_1_76, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -19.4053)));
      final vertex_1_77 = mesh_1.vertices.elementAt(77);
      expect(vertex_1_77, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -19.4053)));
      final vertex_1_78 = mesh_1.vertices.elementAt(78);
      expect(vertex_1_78, vector3MoreOrLessEquals(Vector3(-6.30518, -14.1821, -10)));
      final vertex_1_79 = mesh_1.vertices.elementAt(79);
      expect(vertex_1_79, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -19.4053)));
      final vertex_1_80 = mesh_1.vertices.elementAt(80);
      expect(vertex_1_80, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_81 = mesh_1.vertices.elementAt(81);
      expect(vertex_1_81, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -19.4053)));
      final vertex_1_82 = mesh_1.vertices.elementAt(82);
      expect(vertex_1_82, vector3MoreOrLessEquals(Vector3(-0.419668, -7.6422, -10)));
      final vertex_1_83 = mesh_1.vertices.elementAt(83);
      expect(vertex_1_83, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -19.4053)));
      final vertex_1_84 = mesh_1.vertices.elementAt(84);
      expect(vertex_1_84, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -16.8773)));
      final vertex_1_85 = mesh_1.vertices.elementAt(85);
      expect(vertex_1_85, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -14.0424)));
      final vertex_1_86 = mesh_1.vertices.elementAt(86);
      expect(vertex_1_86, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, -20.5831)));
      final vertex_1_87 = mesh_1.vertices.elementAt(87);
      expect(vertex_1_87, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, -21.1277)));
      final vertex_1_88 = mesh_1.vertices.elementAt(88);
      expect(vertex_1_88, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, -20.5831)));
      final vertex_1_89 = mesh_1.vertices.elementAt(89);
      expect(vertex_1_89, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -19.4053)));
      final vertex_1_90 = mesh_1.vertices.elementAt(90);
      expect(vertex_1_90, vector3MoreOrLessEquals(Vector3(-1.33709, 1.10811, -10)));
      final vertex_1_91 = mesh_1.vertices.elementAt(91);
      expect(vertex_1_91, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -19.4053)));
      final vertex_1_92 = mesh_1.vertices.elementAt(92);
      expect(vertex_1_92, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -14.0424)));
      final vertex_1_93 = mesh_1.vertices.elementAt(93);
      expect(vertex_1_93, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, -20.5831)));
      final vertex_1_94 = mesh_1.vertices.elementAt(94);
      expect(vertex_1_94, vector3MoreOrLessEquals(Vector3(-8.4323, 6.44505, -14.0424)));
      final vertex_1_95 = mesh_1.vertices.elementAt(95);
      expect(vertex_1_95, vector3MoreOrLessEquals(Vector3(-3.30927, -1.73522, -19.4053)));
      final vertex_1_96 = mesh_1.vertices.elementAt(96);
      expect(vertex_1_96, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -16.8773)));
      final vertex_1_97 = mesh_1.vertices.elementAt(97);
      expect(vertex_1_97, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, -20.5831)));
      final vertex_1_98 = mesh_1.vertices.elementAt(98);
      expect(vertex_1_98, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, -28.4798)));
      final vertex_1_99 = mesh_1.vertices.elementAt(99);
      expect(vertex_1_99, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, -29.4308)));
      final vertex_1_100 = mesh_1.vertices.elementAt(100);
      expect(vertex_1_100, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, -28.4798)));
      final vertex_1_101 = mesh_1.vertices.elementAt(101);
      expect(vertex_1_101, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, -23.0814)));
      final vertex_1_102 = mesh_1.vertices.elementAt(102);
      expect(vertex_1_102, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, -21.1277)));
      final vertex_1_103 = mesh_1.vertices.elementAt(103);
      expect(vertex_1_103, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, -23.0814)));
      final vertex_1_104 = mesh_1.vertices.elementAt(104);
      expect(vertex_1_104, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, -20.5831)));
      final vertex_1_105 = mesh_1.vertices.elementAt(105);
      expect(vertex_1_105, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, -28.4798)));
      final vertex_1_106 = mesh_1.vertices.elementAt(106);
      expect(vertex_1_106, vector3MoreOrLessEquals(Vector3(-18.8264, 5.43588, -20.5831)));
      final vertex_1_107 = mesh_1.vertices.elementAt(107);
      expect(vertex_1_107, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, -23.0814)));
      final vertex_1_108 = mesh_1.vertices.elementAt(108);
      expect(vertex_1_108, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, -29.4308)));
      final vertex_1_109 = mesh_1.vertices.elementAt(109);
      expect(vertex_1_109, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, -23.0814)));
      final vertex_1_110 = mesh_1.vertices.elementAt(110);
      expect(vertex_1_110, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, -28.4798)));
      final vertex_1_111 = mesh_1.vertices.elementAt(111);
      expect(vertex_1_111, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -16.8773)));
      final vertex_1_112 = mesh_1.vertices.elementAt(112);
      expect(vertex_1_112, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, -28.4798)));
      final vertex_1_113 = mesh_1.vertices.elementAt(113);
      expect(vertex_1_113, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, -20.5831)));
      final vertex_1_114 = mesh_1.vertices.elementAt(114);
      expect(vertex_1_114, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, -21.1277)));
      final vertex_1_115 = mesh_1.vertices.elementAt(115);
      expect(vertex_1_115, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, -20.5831)));
      final vertex_1_116 = mesh_1.vertices.elementAt(116);
      expect(vertex_1_116, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, -23.0814)));
      final vertex_1_117 = mesh_1.vertices.elementAt(117);
      expect(vertex_1_117, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, -28.4798)));
      final vertex_1_118 = mesh_1.vertices.elementAt(118);
      expect(vertex_1_118, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, -23.0814)));
      final vertex_1_119 = mesh_1.vertices.elementAt(119);
      expect(vertex_1_119, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, -20.5831)));
      final vertex_1_120 = mesh_1.vertices.elementAt(120);
      expect(vertex_1_120, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, -21.1277)));
      final vertex_1_121 = mesh_1.vertices.elementAt(121);
      expect(vertex_1_121, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -19.4053)));
      final vertex_1_122 = mesh_1.vertices.elementAt(122);
      expect(vertex_1_122, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, -20.5831)));
      final vertex_1_123 = mesh_1.vertices.elementAt(123);
      expect(vertex_1_123, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, 9.43077)));
      final vertex_1_124 = mesh_1.vertices.elementAt(124);
      expect(vertex_1_124, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, 1.42112)));
      final vertex_1_125 = mesh_1.vertices.elementAt(125);
      expect(vertex_1_125, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, 8.47976)));
      final vertex_1_126 = mesh_1.vertices.elementAt(126);
      expect(vertex_1_126, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, 9.43077)));
      final vertex_1_127 = mesh_1.vertices.elementAt(127);
      expect(vertex_1_127, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, 8.47976)));
      final vertex_1_128 = mesh_1.vertices.elementAt(128);
      expect(vertex_1_128, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, 3.08142)));
      final vertex_1_129 = mesh_1.vertices.elementAt(129);
      expect(vertex_1_129, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, 1.12772)));
      final vertex_1_130 = mesh_1.vertices.elementAt(130);
      expect(vertex_1_130, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, 3.08142)));
      final vertex_1_131 = mesh_1.vertices.elementAt(131);
      expect(vertex_1_131, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, 0.583091)));
      final vertex_1_132 = mesh_1.vertices.elementAt(132);
      expect(vertex_1_132, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -3.12269)));
      final vertex_1_133 = mesh_1.vertices.elementAt(133);
      expect(vertex_1_133, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, 0.583091)));
      final vertex_1_134 = mesh_1.vertices.elementAt(134);
      expect(vertex_1_134, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, 8.47976)));
      final vertex_1_135 = mesh_1.vertices.elementAt(135);
      expect(vertex_1_135, vector3MoreOrLessEquals(Vector3(-27.9502, 1.30302, 3.08142)));
      final vertex_1_136 = mesh_1.vertices.elementAt(136);
      expect(vertex_1_136, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, 8.47976)));
      final vertex_1_137 = mesh_1.vertices.elementAt(137);
      expect(vertex_1_137, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, 0.583091)));
      final vertex_1_138 = mesh_1.vertices.elementAt(138);
      expect(vertex_1_138, vector3MoreOrLessEquals(Vector3(-11.2213, -4.13255, 1.12772)));
      final vertex_1_139 = mesh_1.vertices.elementAt(139);
      expect(vertex_1_139, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, 0.583091)));
      final vertex_1_140 = mesh_1.vertices.elementAt(140);
      expect(vertex_1_140, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -0.594703)));
      final vertex_1_141 = mesh_1.vertices.elementAt(141);
      expect(vertex_1_141, vector3MoreOrLessEquals(Vector3(-44.8447, 15.2285, -10)));
      final vertex_1_142 = mesh_1.vertices.elementAt(142);
      expect(vertex_1_142, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_143 = mesh_1.vertices.elementAt(143);
      expect(vertex_1_143, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, 1.42112)));
      final vertex_1_144 = mesh_1.vertices.elementAt(144);
      expect(vertex_1_144, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, 9.43077)));
      final vertex_1_145 = mesh_1.vertices.elementAt(145);
      expect(vertex_1_145, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, 1.42112)));
      final vertex_1_146 = mesh_1.vertices.elementAt(146);
      expect(vertex_1_146, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, 1.42112)));
      final vertex_1_147 = mesh_1.vertices.elementAt(147);
      expect(vertex_1_147, vector3MoreOrLessEquals(Vector3(-51.6476, -5.70869, -10)));
      final vertex_1_148 = mesh_1.vertices.elementAt(148);
      expect(vertex_1_148, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, 1.42112)));
      final vertex_1_149 = mesh_1.vertices.elementAt(149);
      expect(vertex_1_149, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_150 = mesh_1.vertices.elementAt(150);
      expect(vertex_1_150, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, 1.42112)));
      final vertex_1_151 = mesh_1.vertices.elementAt(151);
      expect(vertex_1_151, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_152 = mesh_1.vertices.elementAt(152);
      expect(vertex_1_152, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, 1.42112)));
      final vertex_1_153 = mesh_1.vertices.elementAt(153);
      expect(vertex_1_153, vector3MoreOrLessEquals(Vector3(-44.8447, 15.2285, -10)));
      final vertex_1_154 = mesh_1.vertices.elementAt(154);
      expect(vertex_1_154, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, -21.4211)));
      final vertex_1_155 = mesh_1.vertices.elementAt(155);
      expect(vertex_1_155, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_156 = mesh_1.vertices.elementAt(156);
      expect(vertex_1_156, vector3MoreOrLessEquals(Vector3(-51.6476, -5.70869, -10)));
      final vertex_1_157 = mesh_1.vertices.elementAt(157);
      expect(vertex_1_157, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_158 = mesh_1.vertices.elementAt(158);
      expect(vertex_1_158, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, -21.4211)));
      final vertex_1_159 = mesh_1.vertices.elementAt(159);
      expect(vertex_1_159, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, -29.4308)));
      final vertex_1_160 = mesh_1.vertices.elementAt(160);
      expect(vertex_1_160, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, -21.4211)));
      final vertex_1_161 = mesh_1.vertices.elementAt(161);
      expect(vertex_1_161, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, -21.4211)));
      final vertex_1_162 = mesh_1.vertices.elementAt(162);
      expect(vertex_1_162, vector3MoreOrLessEquals(Vector3(-50.637, 8.97539, -10)));
      final vertex_1_163 = mesh_1.vertices.elementAt(163);
      expect(vertex_1_163, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, -21.4211)));
      final vertex_1_164 = mesh_1.vertices.elementAt(164);
      expect(vertex_1_164, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, -21.4211)));
      final vertex_1_165 = mesh_1.vertices.elementAt(165);
      expect(vertex_1_165, vector3MoreOrLessEquals(Vector3(-44.8447, 15.2285, -10)));
      final vertex_1_166 = mesh_1.vertices.elementAt(166);
      expect(vertex_1_166, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -17.0586)));
      final vertex_1_167 = mesh_1.vertices.elementAt(167);
      expect(vertex_1_167, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, -21.4211)));
      final vertex_1_168 = mesh_1.vertices.elementAt(168);
      expect(vertex_1_168, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, -29.4308)));
      final vertex_1_169 = mesh_1.vertices.elementAt(169);
      expect(vertex_1_169, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, -21.4211)));
      final vertex_1_170 = mesh_1.vertices.elementAt(170);
      expect(vertex_1_170, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, -28.4798)));
      final vertex_1_171 = mesh_1.vertices.elementAt(171);
      expect(vertex_1_171, vector3MoreOrLessEquals(Vector3(-24.4015, 12.2247, -16.8773)));
      final vertex_1_172 = mesh_1.vertices.elementAt(172);
      expect(vertex_1_172, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, -28.4798)));
      final vertex_1_173 = mesh_1.vertices.elementAt(173);
      expect(vertex_1_173, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -17.0586)));
      final vertex_1_174 = mesh_1.vertices.elementAt(174);
      expect(vertex_1_174, vector3MoreOrLessEquals(Vector3(-44.882, 11.8872, -21.4211)));
      final vertex_1_175 = mesh_1.vertices.elementAt(175);
      expect(vertex_1_175, vector3MoreOrLessEquals(Vector3(-35.5702, 16.5986, -17.0586)));
      final vertex_1_176 = mesh_1.vertices.elementAt(176);
      expect(vertex_1_176, vector3MoreOrLessEquals(Vector3(-32.6259, 10.8602, -28.4798)));
      final vertex_1_177 = mesh_1.vertices.elementAt(177);
      expect(vertex_1_177, vector3MoreOrLessEquals(Vector3(-41.8566, -0.754846, -29.4308)));
      final vertex_1_178 = mesh_1.vertices.elementAt(178);
      expect(vertex_1_178, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, -28.4798)));
      final vertex_1_179 = mesh_1.vertices.elementAt(179);
      expect(vertex_1_179, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, -21.4211)));
      expect(mesh_1.normals.length, equals(180));
      final normal_1_0 = mesh_1.normals.elementAt(0);
      expect(normal_1_0, vector3MoreOrLessEquals(Vector3(-0.236279, 0.029185, 0.971247)));
      final normal_1_1 = mesh_1.normals.elementAt(1);
      expect(normal_1_1, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, 0.940913)));
      final normal_1_2 = mesh_1.normals.elementAt(2);
      expect(normal_1_2, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, 0.838838)));
      final normal_1_3 = mesh_1.normals.elementAt(3);
      expect(normal_1_3, vector3MoreOrLessEquals(Vector3(0.401159, 0.816009, 0.416173)));
      final normal_1_4 = mesh_1.normals.elementAt(4);
      expect(normal_1_4, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, 0.838838)));
      final normal_1_5 = mesh_1.normals.elementAt(5);
      expect(normal_1_5, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, 0.849571)));
      final normal_1_6 = mesh_1.normals.elementAt(6);
      expect(normal_1_6, vector3MoreOrLessEquals(Vector3(0.126098, -0.040972, 0.991171)));
      final normal_1_7 = mesh_1.normals.elementAt(7);
      expect(normal_1_7, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, 0.849571)));
      final normal_1_8 = mesh_1.normals.elementAt(8);
      expect(normal_1_8, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, 0.940913)));
      final normal_1_9 = mesh_1.normals.elementAt(9);
      expect(normal_1_9, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, 0.838838)));
      final normal_1_10 = mesh_1.normals.elementAt(10);
      expect(normal_1_10, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, 0.940913)));
      final normal_1_11 = mesh_1.normals.elementAt(11);
      expect(normal_1_11, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, 0.849571)));
      final normal_1_12 = mesh_1.normals.elementAt(12);
      expect(normal_1_12, vector3MoreOrLessEquals(Vector3(-0.236279, 0.029185, 0.971247)));
      final normal_1_13 = mesh_1.normals.elementAt(13);
      expect(normal_1_13, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, 0.838838)));
      final normal_1_14 = mesh_1.normals.elementAt(14);
      expect(normal_1_14, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, 0.506218)));
      final normal_1_15 = mesh_1.normals.elementAt(15);
      expect(normal_1_15, vector3MoreOrLessEquals(Vector3(-0.47891, 0.877864, 0)));
      final normal_1_16 = mesh_1.normals.elementAt(16);
      expect(normal_1_16, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, 0.506218)));
      final normal_1_17 = mesh_1.normals.elementAt(17);
      expect(normal_1_17, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, 0.242645)));
      final normal_1_18 = mesh_1.normals.elementAt(18);
      expect(normal_1_18, vector3MoreOrLessEquals(Vector3(0.401159, 0.816009, 0.416173)));
      final normal_1_19 = mesh_1.normals.elementAt(19);
      expect(normal_1_19, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, 0.242645)));
      final normal_1_20 = mesh_1.normals.elementAt(20);
      expect(normal_1_20, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, 0.838838)));
      final normal_1_21 = mesh_1.normals.elementAt(21);
      expect(normal_1_21, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, 0.506218)));
      final normal_1_22 = mesh_1.normals.elementAt(22);
      expect(normal_1_22, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, 0.838838)));
      final normal_1_23 = mesh_1.normals.elementAt(23);
      expect(normal_1_23, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, 0.242645)));
      final normal_1_24 = mesh_1.normals.elementAt(24);
      expect(normal_1_24, vector3MoreOrLessEquals(Vector3(-0.47891, 0.877864, 0)));
      final normal_1_25 = mesh_1.normals.elementAt(25);
      expect(normal_1_25, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, 0.242645)));
      final normal_1_26 = mesh_1.normals.elementAt(26);
      expect(normal_1_26, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, -0.242645)));
      final normal_1_27 = mesh_1.normals.elementAt(27);
      expect(normal_1_27, vector3MoreOrLessEquals(Vector3(0.401159, 0.816009, -0.416173)));
      final normal_1_28 = mesh_1.normals.elementAt(28);
      expect(normal_1_28, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, -0.242645)));
      final normal_1_29 = mesh_1.normals.elementAt(29);
      expect(normal_1_29, vector3MoreOrLessEquals(Vector3(0.360915, 0.932599, 0)));
      final normal_1_30 = mesh_1.normals.elementAt(30);
      expect(normal_1_30, vector3MoreOrLessEquals(Vector3(0.401159, 0.816009, 0.416173)));
      final normal_1_31 = mesh_1.normals.elementAt(31);
      expect(normal_1_31, vector3MoreOrLessEquals(Vector3(0.360915, 0.932599, 0)));
      final normal_1_32 = mesh_1.normals.elementAt(32);
      expect(normal_1_32, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, 0.242645)));
      final normal_1_33 = mesh_1.normals.elementAt(33);
      expect(normal_1_33, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, -0.242645)));
      final normal_1_34 = mesh_1.normals.elementAt(34);
      expect(normal_1_34, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, 0.242645)));
      final normal_1_35 = mesh_1.normals.elementAt(35);
      expect(normal_1_35, vector3MoreOrLessEquals(Vector3(0.360915, 0.932599, 0)));
      final normal_1_36 = mesh_1.normals.elementAt(36);
      expect(normal_1_36, vector3MoreOrLessEquals(Vector3(0.401159, 0.816009, 0.416173)));
      final normal_1_37 = mesh_1.normals.elementAt(37);
      expect(normal_1_37, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, 0.343038)));
      final normal_1_38 = mesh_1.normals.elementAt(38);
      expect(normal_1_38, vector3MoreOrLessEquals(Vector3(0.360915, 0.932599, 0)));
      final normal_1_39 = mesh_1.normals.elementAt(39);
      expect(normal_1_39, vector3MoreOrLessEquals(Vector3(0.401159, 0.816009, -0.416173)));
      final normal_1_40 = mesh_1.normals.elementAt(40);
      expect(normal_1_40, vector3MoreOrLessEquals(Vector3(0.360915, 0.932599, 0)));
      final normal_1_41 = mesh_1.normals.elementAt(41);
      expect(normal_1_41, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, -0.343038)));
      final normal_1_42 = mesh_1.normals.elementAt(42);
      expect(normal_1_42, vector3MoreOrLessEquals(Vector3(0.861265, 0.508156, 0)));
      final normal_1_43 = mesh_1.normals.elementAt(43);
      expect(normal_1_43, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, -0.343038)));
      final normal_1_44 = mesh_1.normals.elementAt(44);
      expect(normal_1_44, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, 0.343038)));
      final normal_1_45 = mesh_1.normals.elementAt(45);
      expect(normal_1_45, vector3MoreOrLessEquals(Vector3(0.360915, 0.932599, 0)));
      final normal_1_46 = mesh_1.normals.elementAt(46);
      expect(normal_1_46, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, 0.343038)));
      final normal_1_47 = mesh_1.normals.elementAt(47);
      expect(normal_1_47, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, -0.343038)));
      final normal_1_48 = mesh_1.normals.elementAt(48);
      expect(normal_1_48, vector3MoreOrLessEquals(Vector3(0.401159, 0.816009, 0.416173)));
      final normal_1_49 = mesh_1.normals.elementAt(49);
      expect(normal_1_49, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, 0.849571)));
      final normal_1_50 = mesh_1.normals.elementAt(50);
      expect(normal_1_50, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, 0.343038)));
      final normal_1_51 = mesh_1.normals.elementAt(51);
      expect(normal_1_51, vector3MoreOrLessEquals(Vector3(0.861265, 0.508156, 0)));
      final normal_1_52 = mesh_1.normals.elementAt(52);
      expect(normal_1_52, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, 0.343038)));
      final normal_1_53 = mesh_1.normals.elementAt(53);
      expect(normal_1_53, vector3MoreOrLessEquals(Vector3(0.64791, 0.246087, 0.72087)));
      final normal_1_54 = mesh_1.normals.elementAt(54);
      expect(normal_1_54, vector3MoreOrLessEquals(Vector3(0.126098, -0.040972, 0.991171)));
      final normal_1_55 = mesh_1.normals.elementAt(55);
      expect(normal_1_55, vector3MoreOrLessEquals(Vector3(0.64791, 0.246087, 0.72087)));
      final normal_1_56 = mesh_1.normals.elementAt(56);
      expect(normal_1_56, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, 0.849571)));
      final normal_1_57 = mesh_1.normals.elementAt(57);
      expect(normal_1_57, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, 0.343038)));
      final normal_1_58 = mesh_1.normals.elementAt(58);
      expect(normal_1_58, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, 0.849571)));
      final normal_1_59 = mesh_1.normals.elementAt(59);
      expect(normal_1_59, vector3MoreOrLessEquals(Vector3(0.64791, 0.246087, 0.72087)));
      final normal_1_60 = mesh_1.normals.elementAt(60);
      expect(normal_1_60, vector3MoreOrLessEquals(Vector3(0.861265, 0.508156, 0)));
      final normal_1_61 = mesh_1.normals.elementAt(61);
      expect(normal_1_61, vector3MoreOrLessEquals(Vector3(0.64791, 0.246087, 0.72087)));
      final normal_1_62 = mesh_1.normals.elementAt(62);
      expect(normal_1_62, vector3MoreOrLessEquals(Vector3(0.951057, -0.309017, 0)));
      final normal_1_63 = mesh_1.normals.elementAt(63);
      expect(normal_1_63, vector3MoreOrLessEquals(Vector3(0.743317, -0.66894, 0)));
      final normal_1_64 = mesh_1.normals.elementAt(64);
      expect(normal_1_64, vector3MoreOrLessEquals(Vector3(0.951057, -0.309017, 0)));
      final normal_1_65 = mesh_1.normals.elementAt(65);
      expect(normal_1_65, vector3MoreOrLessEquals(Vector3(0.535463, -0.362827, 0.762651)));
      final normal_1_66 = mesh_1.normals.elementAt(66);
      expect(normal_1_66, vector3MoreOrLessEquals(Vector3(0.126098, -0.040972, 0.991171)));
      final normal_1_67 = mesh_1.normals.elementAt(67);
      expect(normal_1_67, vector3MoreOrLessEquals(Vector3(0.535463, -0.362827, 0.762651)));
      final normal_1_68 = mesh_1.normals.elementAt(68);
      expect(normal_1_68, vector3MoreOrLessEquals(Vector3(0.64791, 0.246087, 0.72087)));
      final normal_1_69 = mesh_1.normals.elementAt(69);
      expect(normal_1_69, vector3MoreOrLessEquals(Vector3(0.951057, -0.309017, 0)));
      final normal_1_70 = mesh_1.normals.elementAt(70);
      expect(normal_1_70, vector3MoreOrLessEquals(Vector3(0.64791, 0.246087, 0.72087)));
      final normal_1_71 = mesh_1.normals.elementAt(71);
      expect(normal_1_71, vector3MoreOrLessEquals(Vector3(0.535463, -0.362827, 0.762651)));
      final normal_1_72 = mesh_1.normals.elementAt(72);
      expect(normal_1_72, vector3MoreOrLessEquals(Vector3(0.861265, 0.508156, 0)));
      final normal_1_73 = mesh_1.normals.elementAt(73);
      expect(normal_1_73, vector3MoreOrLessEquals(Vector3(0.951057, -0.309017, 0)));
      final normal_1_74 = mesh_1.normals.elementAt(74);
      expect(normal_1_74, vector3MoreOrLessEquals(Vector3(0.64791, 0.246086, -0.72087)));
      final normal_1_75 = mesh_1.normals.elementAt(75);
      expect(normal_1_75, vector3MoreOrLessEquals(Vector3(0.126098, -0.040972, -0.991171)));
      final normal_1_76 = mesh_1.normals.elementAt(76);
      expect(normal_1_76, vector3MoreOrLessEquals(Vector3(0.64791, 0.246086, -0.72087)));
      final normal_1_77 = mesh_1.normals.elementAt(77);
      expect(normal_1_77, vector3MoreOrLessEquals(Vector3(0.535463, -0.362827, -0.762651)));
      final normal_1_78 = mesh_1.normals.elementAt(78);
      expect(normal_1_78, vector3MoreOrLessEquals(Vector3(0.743317, -0.66894, 0)));
      final normal_1_79 = mesh_1.normals.elementAt(79);
      expect(normal_1_79, vector3MoreOrLessEquals(Vector3(0.535463, -0.362827, -0.762651)));
      final normal_1_80 = mesh_1.normals.elementAt(80);
      expect(normal_1_80, vector3MoreOrLessEquals(Vector3(0.951057, -0.309017, 0)));
      final normal_1_81 = mesh_1.normals.elementAt(81);
      expect(normal_1_81, vector3MoreOrLessEquals(Vector3(0.64791, 0.246086, -0.72087)));
      final normal_1_82 = mesh_1.normals.elementAt(82);
      expect(normal_1_82, vector3MoreOrLessEquals(Vector3(0.951057, -0.309017, 0)));
      final normal_1_83 = mesh_1.normals.elementAt(83);
      expect(normal_1_83, vector3MoreOrLessEquals(Vector3(0.535463, -0.362827, -0.762651)));
      final normal_1_84 = mesh_1.normals.elementAt(84);
      expect(normal_1_84, vector3MoreOrLessEquals(Vector3(0.401159, 0.816009, -0.416173)));
      final normal_1_85 = mesh_1.normals.elementAt(85);
      expect(normal_1_85, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, -0.343038)));
      final normal_1_86 = mesh_1.normals.elementAt(86);
      expect(normal_1_86, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, -0.849571)));
      final normal_1_87 = mesh_1.normals.elementAt(87);
      expect(normal_1_87, vector3MoreOrLessEquals(Vector3(0.126098, -0.040972, -0.991171)));
      final normal_1_88 = mesh_1.normals.elementAt(88);
      expect(normal_1_88, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, -0.849571)));
      final normal_1_89 = mesh_1.normals.elementAt(89);
      expect(normal_1_89, vector3MoreOrLessEquals(Vector3(0.64791, 0.246086, -0.72087)));
      final normal_1_90 = mesh_1.normals.elementAt(90);
      expect(normal_1_90, vector3MoreOrLessEquals(Vector3(0.861265, 0.508156, 0)));
      final normal_1_91 = mesh_1.normals.elementAt(91);
      expect(normal_1_91, vector3MoreOrLessEquals(Vector3(0.64791, 0.246086, -0.72087)));
      final normal_1_92 = mesh_1.normals.elementAt(92);
      expect(normal_1_92, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, -0.343038)));
      final normal_1_93 = mesh_1.normals.elementAt(93);
      expect(normal_1_93, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, -0.849571)));
      final normal_1_94 = mesh_1.normals.elementAt(94);
      expect(normal_1_94, vector3MoreOrLessEquals(Vector3(0.494411, 0.798675, -0.343038)));
      final normal_1_95 = mesh_1.normals.elementAt(95);
      expect(normal_1_95, vector3MoreOrLessEquals(Vector3(0.64791, 0.246086, -0.72087)));
      final normal_1_96 = mesh_1.normals.elementAt(96);
      expect(normal_1_96, vector3MoreOrLessEquals(Vector3(0.401159, 0.816009, -0.416173)));
      final normal_1_97 = mesh_1.normals.elementAt(97);
      expect(normal_1_97, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, -0.849571)));
      final normal_1_98 = mesh_1.normals.elementAt(98);
      expect(normal_1_98, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, -0.838838)));
      final normal_1_99 = mesh_1.normals.elementAt(99);
      expect(normal_1_99, vector3MoreOrLessEquals(Vector3(-0.236279, 0.029185, -0.971247)));
      final normal_1_100 = mesh_1.normals.elementAt(100);
      expect(normal_1_100, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, -0.838838)));
      final normal_1_101 = mesh_1.normals.elementAt(101);
      expect(normal_1_101, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, -0.940913)));
      final normal_1_102 = mesh_1.normals.elementAt(102);
      expect(normal_1_102, vector3MoreOrLessEquals(Vector3(0.126098, -0.040972, -0.991171)));
      final normal_1_103 = mesh_1.normals.elementAt(103);
      expect(normal_1_103, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, -0.940913)));
      final normal_1_104 = mesh_1.normals.elementAt(104);
      expect(normal_1_104, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, -0.849571)));
      final normal_1_105 = mesh_1.normals.elementAt(105);
      expect(normal_1_105, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, -0.838838)));
      final normal_1_106 = mesh_1.normals.elementAt(106);
      expect(normal_1_106, vector3MoreOrLessEquals(Vector3(0.362076, 0.383575, -0.849571)));
      final normal_1_107 = mesh_1.normals.elementAt(107);
      expect(normal_1_107, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, -0.940913)));
      final normal_1_108 = mesh_1.normals.elementAt(108);
      expect(normal_1_108, vector3MoreOrLessEquals(Vector3(-0.236279, 0.029185, -0.971247)));
      final normal_1_109 = mesh_1.normals.elementAt(109);
      expect(normal_1_109, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, -0.940913)));
      final normal_1_110 = mesh_1.normals.elementAt(110);
      expect(normal_1_110, vector3MoreOrLessEquals(Vector3(0.132934, -0.415219, -0.899956)));
      final normal_1_111 = mesh_1.normals.elementAt(111);
      expect(normal_1_111, vector3MoreOrLessEquals(Vector3(0.188857, -0.970911, -0.147192)));
      final normal_1_112 = mesh_1.normals.elementAt(112);
      expect(normal_1_112, vector3MoreOrLessEquals(Vector3(0.132934, -0.415219, -0.899956)));
      final normal_1_113 = mesh_1.normals.elementAt(113);
      expect(normal_1_113, vector3MoreOrLessEquals(Vector3(0.199321, -0.435181, -0.878003)));
      final normal_1_114 = mesh_1.normals.elementAt(114);
      expect(normal_1_114, vector3MoreOrLessEquals(Vector3(0.126098, -0.040972, -0.991171)));
      final normal_1_115 = mesh_1.normals.elementAt(115);
      expect(normal_1_115, vector3MoreOrLessEquals(Vector3(0.199321, -0.435181, -0.878003)));
      final normal_1_116 = mesh_1.normals.elementAt(116);
      expect(normal_1_116, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, -0.940913)));
      final normal_1_117 = mesh_1.normals.elementAt(117);
      expect(normal_1_117, vector3MoreOrLessEquals(Vector3(0.132934, -0.415219, -0.899956)));
      final normal_1_118 = mesh_1.normals.elementAt(118);
      expect(normal_1_118, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, -0.940913)));
      final normal_1_119 = mesh_1.normals.elementAt(119);
      expect(normal_1_119, vector3MoreOrLessEquals(Vector3(0.199321, -0.435181, -0.878003)));
      final normal_1_120 = mesh_1.normals.elementAt(120);
      expect(normal_1_120, vector3MoreOrLessEquals(Vector3(0.126098, -0.040972, -0.991171)));
      final normal_1_121 = mesh_1.normals.elementAt(121);
      expect(normal_1_121, vector3MoreOrLessEquals(Vector3(0.535463, -0.362827, -0.762651)));
      final normal_1_122 = mesh_1.normals.elementAt(122);
      expect(normal_1_122, vector3MoreOrLessEquals(Vector3(0.199321, -0.435181, -0.878003)));
      final normal_1_123 = mesh_1.normals.elementAt(123);
      expect(normal_1_123, vector3MoreOrLessEquals(Vector3(-0.236279, 0.029185, 0.971247)));
      final normal_1_124 = mesh_1.normals.elementAt(124);
      expect(normal_1_124, vector3MoreOrLessEquals(Vector3(-0.862018, 0.083023, 0.500032)));
      final normal_1_125 = mesh_1.normals.elementAt(125);
      expect(normal_1_125, vector3MoreOrLessEquals(Vector3(0.132934, -0.415219, 0.899956)));
      final normal_1_126 = mesh_1.normals.elementAt(126);
      expect(normal_1_126, vector3MoreOrLessEquals(Vector3(-0.236279, 0.029185, 0.971247)));
      final normal_1_127 = mesh_1.normals.elementAt(127);
      expect(normal_1_127, vector3MoreOrLessEquals(Vector3(0.132934, -0.415219, 0.899956)));
      final normal_1_128 = mesh_1.normals.elementAt(128);
      expect(normal_1_128, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, 0.940913)));
      final normal_1_129 = mesh_1.normals.elementAt(129);
      expect(normal_1_129, vector3MoreOrLessEquals(Vector3(0.126098, -0.040972, 0.991171)));
      final normal_1_130 = mesh_1.normals.elementAt(130);
      expect(normal_1_130, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, 0.940913)));
      final normal_1_131 = mesh_1.normals.elementAt(131);
      expect(normal_1_131, vector3MoreOrLessEquals(Vector3(0.199321, -0.435181, 0.878002)));
      final normal_1_132 = mesh_1.normals.elementAt(132);
      expect(normal_1_132, vector3MoreOrLessEquals(Vector3(0.188857, -0.970911, 0.147192)));
      final normal_1_133 = mesh_1.normals.elementAt(133);
      expect(normal_1_133, vector3MoreOrLessEquals(Vector3(0.199321, -0.435181, 0.878002)));
      final normal_1_134 = mesh_1.normals.elementAt(134);
      expect(normal_1_134, vector3MoreOrLessEquals(Vector3(0.132934, -0.415219, 0.899956)));
      final normal_1_135 = mesh_1.normals.elementAt(135);
      expect(normal_1_135, vector3MoreOrLessEquals(Vector3(0.320907, -0.108176, 0.940913)));
      final normal_1_136 = mesh_1.normals.elementAt(136);
      expect(normal_1_136, vector3MoreOrLessEquals(Vector3(0.132934, -0.415219, 0.899956)));
      final normal_1_137 = mesh_1.normals.elementAt(137);
      expect(normal_1_137, vector3MoreOrLessEquals(Vector3(0.199321, -0.435181, 0.878002)));
      final normal_1_138 = mesh_1.normals.elementAt(138);
      expect(normal_1_138, vector3MoreOrLessEquals(Vector3(0.126098, -0.040972, 0.991171)));
      final normal_1_139 = mesh_1.normals.elementAt(139);
      expect(normal_1_139, vector3MoreOrLessEquals(Vector3(0.199321, -0.435181, 0.878002)));
      final normal_1_140 = mesh_1.normals.elementAt(140);
      expect(normal_1_140, vector3MoreOrLessEquals(Vector3(0.535463, -0.362827, 0.762651)));
      final normal_1_141 = mesh_1.normals.elementAt(141);
      expect(normal_1_141, vector3MoreOrLessEquals(Vector3(-0.47891, 0.877864, 0)));
      final normal_1_142 = mesh_1.normals.elementAt(142);
      expect(normal_1_142, vector3MoreOrLessEquals(Vector3(-0.930205, 0.36704, 0)));
      final normal_1_143 = mesh_1.normals.elementAt(143);
      expect(normal_1_143, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, 0.506218)));
      final normal_1_144 = mesh_1.normals.elementAt(144);
      expect(normal_1_144, vector3MoreOrLessEquals(Vector3(-0.236279, 0.029185, 0.971247)));
      final normal_1_145 = mesh_1.normals.elementAt(145);
      expect(normal_1_145, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, 0.506218)));
      final normal_1_146 = mesh_1.normals.elementAt(146);
      expect(normal_1_146, vector3MoreOrLessEquals(Vector3(-0.862018, 0.083023, 0.500032)));
      final normal_1_147 = mesh_1.normals.elementAt(147);
      expect(normal_1_147, vector3MoreOrLessEquals(Vector3(-0.99764, 0.068658, 0)));
      final normal_1_148 = mesh_1.normals.elementAt(148);
      expect(normal_1_148, vector3MoreOrLessEquals(Vector3(-0.862018, 0.083023, 0.500032)));
      final normal_1_149 = mesh_1.normals.elementAt(149);
      expect(normal_1_149, vector3MoreOrLessEquals(Vector3(-0.930205, 0.36704, 0)));
      final normal_1_150 = mesh_1.normals.elementAt(150);
      expect(normal_1_150, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, 0.506218)));
      final normal_1_151 = mesh_1.normals.elementAt(151);
      expect(normal_1_151, vector3MoreOrLessEquals(Vector3(-0.930205, 0.36704, 0)));
      final normal_1_152 = mesh_1.normals.elementAt(152);
      expect(normal_1_152, vector3MoreOrLessEquals(Vector3(-0.862018, 0.083023, 0.500032)));
      final normal_1_153 = mesh_1.normals.elementAt(153);
      expect(normal_1_153, vector3MoreOrLessEquals(Vector3(-0.47891, 0.877864, 0)));
      final normal_1_154 = mesh_1.normals.elementAt(154);
      expect(normal_1_154, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, -0.506218)));
      final normal_1_155 = mesh_1.normals.elementAt(155);
      expect(normal_1_155, vector3MoreOrLessEquals(Vector3(-0.930205, 0.36704, 0)));
      final normal_1_156 = mesh_1.normals.elementAt(156);
      expect(normal_1_156, vector3MoreOrLessEquals(Vector3(-0.99764, 0.068658, 0)));
      final normal_1_157 = mesh_1.normals.elementAt(157);
      expect(normal_1_157, vector3MoreOrLessEquals(Vector3(-0.930205, 0.36704, 0)));
      final normal_1_158 = mesh_1.normals.elementAt(158);
      expect(normal_1_158, vector3MoreOrLessEquals(Vector3(-0.862018, 0.083023, -0.500032)));
      final normal_1_159 = mesh_1.normals.elementAt(159);
      expect(normal_1_159, vector3MoreOrLessEquals(Vector3(-0.236279, 0.029185, -0.971247)));
      final normal_1_160 = mesh_1.normals.elementAt(160);
      expect(normal_1_160, vector3MoreOrLessEquals(Vector3(-0.862018, 0.083023, -0.500032)));
      final normal_1_161 = mesh_1.normals.elementAt(161);
      expect(normal_1_161, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, -0.506218)));
      final normal_1_162 = mesh_1.normals.elementAt(162);
      expect(normal_1_162, vector3MoreOrLessEquals(Vector3(-0.930205, 0.36704, 0)));
      final normal_1_163 = mesh_1.normals.elementAt(163);
      expect(normal_1_163, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, -0.506218)));
      final normal_1_164 = mesh_1.normals.elementAt(164);
      expect(normal_1_164, vector3MoreOrLessEquals(Vector3(-0.862018, 0.083023, -0.500032)));
      final normal_1_165 = mesh_1.normals.elementAt(165);
      expect(normal_1_165, vector3MoreOrLessEquals(Vector3(-0.47891, 0.877864, 0)));
      final normal_1_166 = mesh_1.normals.elementAt(166);
      expect(normal_1_166, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, -0.242645)));
      final normal_1_167 = mesh_1.normals.elementAt(167);
      expect(normal_1_167, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, -0.506218)));
      final normal_1_168 = mesh_1.normals.elementAt(168);
      expect(normal_1_168, vector3MoreOrLessEquals(Vector3(-0.236279, 0.029185, -0.971247)));
      final normal_1_169 = mesh_1.normals.elementAt(169);
      expect(normal_1_169, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, -0.506218)));
      final normal_1_170 = mesh_1.normals.elementAt(170);
      expect(normal_1_170, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, -0.838838)));
      final normal_1_171 = mesh_1.normals.elementAt(171);
      expect(normal_1_171, vector3MoreOrLessEquals(Vector3(0.401159, 0.816009, -0.416173)));
      final normal_1_172 = mesh_1.normals.elementAt(172);
      expect(normal_1_172, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, -0.838838)));
      final normal_1_173 = mesh_1.normals.elementAt(173);
      expect(normal_1_173, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, -0.242645)));
      final normal_1_174 = mesh_1.normals.elementAt(174);
      expect(normal_1_174, vector3MoreOrLessEquals(Vector3(-0.604687, 0.614896, -0.506218)));
      final normal_1_175 = mesh_1.normals.elementAt(175);
      expect(normal_1_175, vector3MoreOrLessEquals(Vector3(0.038576, 0.969348, -0.242645)));
      final normal_1_176 = mesh_1.normals.elementAt(176);
      expect(normal_1_176, vector3MoreOrLessEquals(Vector3(0.232851, 0.492069, -0.838838)));
      final normal_1_177 = mesh_1.normals.elementAt(177);
      expect(normal_1_177, vector3MoreOrLessEquals(Vector3(-0.236279, 0.029185, -0.971247)));
      final normal_1_178 = mesh_1.normals.elementAt(178);
      expect(normal_1_178, vector3MoreOrLessEquals(Vector3(0.132934, -0.415219, -0.899956)));
      final normal_1_179 = mesh_1.normals.elementAt(179);
      expect(normal_1_179, vector3MoreOrLessEquals(Vector3(-0.862018, 0.083023, -0.500032)));
      expect(mesh_1.tangents.length, isZero);
      expect(mesh_1.bitangents.length, isZero);
      expect(mesh_1.colors.length, isZero);
      expect(mesh_1.textureCoords.length, equals(1));
      final textureCoords_1_0 = mesh_1.textureCoords.elementAt(0);
      expect(textureCoords_1_0.length, equals(180));
      final textureCoord_1_0_0 = textureCoords_1_0.elementAt(0);
      expect(textureCoord_1_0_0, vector3MoreOrLessEquals(Vector3(-0.065871, -0.410016, 0)));
      final textureCoord_1_0_1 = textureCoords_1_0.elementAt(1);
      expect(textureCoord_1_0_1, vector3MoreOrLessEquals(Vector3(0.403088, -0.109437, 0)));
      final textureCoord_1_0_2 = textureCoords_1_0.elementAt(2);
      expect(textureCoord_1_0_2, vector3MoreOrLessEquals(Vector3(0.127441, -0.364995, 0)));
      final textureCoord_1_0_3 = textureCoords_1_0.elementAt(3);
      expect(textureCoord_1_0_3, vector3MoreOrLessEquals(Vector3(0.403088, 0.184267, 0)));
      final textureCoord_1_0_4 = textureCoords_1_0.elementAt(4);
      expect(textureCoord_1_0_4, vector3MoreOrLessEquals(Vector3(0.127441, -0.364995, 0)));
      final textureCoord_1_0_5 = textureCoords_1_0.elementAt(5);
      expect(textureCoord_1_0_5, vector3MoreOrLessEquals(Vector3(0.678735, 0.008835, 0)));
      final textureCoord_1_0_6 = textureCoords_1_0.elementAt(6);
      expect(textureCoord_1_0_6, vector3MoreOrLessEquals(Vector3(1.05829, -0.016948, 0)));
      final textureCoord_1_0_7 = textureCoords_1_0.elementAt(7);
      expect(textureCoord_1_0_7, vector3MoreOrLessEquals(Vector3(0.678735, 0.008835, 0)));
      final textureCoord_1_0_8 = textureCoords_1_0.elementAt(8);
      expect(textureCoord_1_0_8, vector3MoreOrLessEquals(Vector3(0.403088, -0.109437, 0)));
      final textureCoord_1_0_9 = textureCoords_1_0.elementAt(9);
      expect(textureCoord_1_0_9, vector3MoreOrLessEquals(Vector3(0.127441, -0.364995, 0)));
      final textureCoord_1_0_10 = textureCoords_1_0.elementAt(10);
      expect(textureCoord_1_0_10, vector3MoreOrLessEquals(Vector3(0.403088, -0.109437, 0)));
      final textureCoord_1_0_11 = textureCoords_1_0.elementAt(11);
      expect(textureCoord_1_0_11, vector3MoreOrLessEquals(Vector3(0.678735, 0.008835, 0)));
      final textureCoord_1_0_12 = textureCoords_1_0.elementAt(12);
      expect(textureCoord_1_0_12, vector3MoreOrLessEquals(Vector3(-0.065871, -0.410016, 0)));
      final textureCoord_1_0_13 = textureCoords_1_0.elementAt(13);
      expect(textureCoord_1_0_13, vector3MoreOrLessEquals(Vector3(0.127441, -0.364995, 0)));
      final textureCoord_1_0_14 = textureCoords_1_0.elementAt(14);
      expect(textureCoord_1_0_14, vector3MoreOrLessEquals(Vector3(-0.318566, -0.030837, 0)));
      final textureCoord_1_0_15 = textureCoords_1_0.elementAt(15);
      expect(textureCoord_1_0_15, vector3MoreOrLessEquals(Vector3(-0.355704, 0.50984, 0)));
      final textureCoord_1_0_16 = textureCoords_1_0.elementAt(16);
      expect(textureCoord_1_0_16, vector3MoreOrLessEquals(Vector3(-0.318566, -0.030837, 0)));
      final textureCoord_1_0_17 = textureCoords_1_0.elementAt(17);
      expect(textureCoord_1_0_17, vector3MoreOrLessEquals(Vector3(-0.042919, 0.175683, 0)));
      final textureCoord_1_0_18 = textureCoords_1_0.elementAt(18);
      expect(textureCoord_1_0_18, vector3MoreOrLessEquals(Vector3(0.403088, 0.184267, 0)));
      final textureCoord_1_0_19 = textureCoords_1_0.elementAt(19);
      expect(textureCoord_1_0_19, vector3MoreOrLessEquals(Vector3(-0.042919, 0.175683, 0)));
      final textureCoord_1_0_20 = textureCoords_1_0.elementAt(20);
      expect(textureCoord_1_0_20, vector3MoreOrLessEquals(Vector3(0.127441, -0.364995, 0)));
      final textureCoord_1_0_21 = textureCoords_1_0.elementAt(21);
      expect(textureCoord_1_0_21, vector3MoreOrLessEquals(Vector3(-0.318566, -0.030837, 0)));
      final textureCoord_1_0_22 = textureCoords_1_0.elementAt(22);
      expect(textureCoord_1_0_22, vector3MoreOrLessEquals(Vector3(0.127441, -0.364995, 0)));
      final textureCoord_1_0_23 = textureCoords_1_0.elementAt(23);
      expect(textureCoord_1_0_23, vector3MoreOrLessEquals(Vector3(-0.042919, 0.175683, 0)));
      final textureCoord_1_0_24 = textureCoords_1_0.elementAt(24);
      expect(textureCoord_1_0_24, vector3MoreOrLessEquals(Vector3(-0.355704, 0.50984, 0)));
      final textureCoord_1_0_25 = textureCoords_1_0.elementAt(25);
      expect(textureCoord_1_0_25, vector3MoreOrLessEquals(Vector3(-0.042919, 0.175683, 0)));
      final textureCoord_1_0_26 = textureCoords_1_0.elementAt(26);
      expect(textureCoord_1_0_26, vector3MoreOrLessEquals(Vector3(-0.042919, 0.843998, 0)));
      final textureCoord_1_0_27 = textureCoords_1_0.elementAt(27);
      expect(textureCoord_1_0_27, vector3MoreOrLessEquals(Vector3(0.403088, 0.835414, 0)));
      final textureCoord_1_0_28 = textureCoords_1_0.elementAt(28);
      expect(textureCoord_1_0_28, vector3MoreOrLessEquals(Vector3(-0.042919, 0.843998, 0)));
      final textureCoord_1_0_29 = textureCoords_1_0.elementAt(29);
      expect(textureCoord_1_0_29, vector3MoreOrLessEquals(Vector3(0.403088, 0.50984, 0)));
      final textureCoord_1_0_30 = textureCoords_1_0.elementAt(30);
      expect(textureCoord_1_0_30, vector3MoreOrLessEquals(Vector3(0.403088, 0.184267, 0)));
      final textureCoord_1_0_31 = textureCoords_1_0.elementAt(31);
      expect(textureCoord_1_0_31, vector3MoreOrLessEquals(Vector3(0.403088, 0.50984, 0)));
      final textureCoord_1_0_32 = textureCoords_1_0.elementAt(32);
      expect(textureCoord_1_0_32, vector3MoreOrLessEquals(Vector3(-0.042919, 0.175683, 0)));
      final textureCoord_1_0_33 = textureCoords_1_0.elementAt(33);
      expect(textureCoord_1_0_33, vector3MoreOrLessEquals(Vector3(-0.042919, 0.843998, 0)));
      final textureCoord_1_0_34 = textureCoords_1_0.elementAt(34);
      expect(textureCoord_1_0_34, vector3MoreOrLessEquals(Vector3(-0.042919, 0.175683, 0)));
      final textureCoord_1_0_35 = textureCoords_1_0.elementAt(35);
      expect(textureCoord_1_0_35, vector3MoreOrLessEquals(Vector3(0.403088, 0.50984, 0)));
      final textureCoord_1_0_36 = textureCoords_1_0.elementAt(36);
      expect(textureCoord_1_0_36, vector3MoreOrLessEquals(Vector3(0.403088, 0.184267, 0)));
      final textureCoord_1_0_37 = textureCoords_1_0.elementAt(37);
      expect(textureCoord_1_0_37, vector3MoreOrLessEquals(Vector3(1.03534, 0.318473, 0)));
      final textureCoord_1_0_38 = textureCoords_1_0.elementAt(38);
      expect(textureCoord_1_0_38, vector3MoreOrLessEquals(Vector3(0.403088, 0.50984, 0)));
      final textureCoord_1_0_39 = textureCoords_1_0.elementAt(39);
      expect(textureCoord_1_0_39, vector3MoreOrLessEquals(Vector3(0.403088, 0.835414, 0)));
      final textureCoord_1_0_40 = textureCoords_1_0.elementAt(40);
      expect(textureCoord_1_0_40, vector3MoreOrLessEquals(Vector3(0.403088, 0.50984, 0)));
      final textureCoord_1_0_41 = textureCoords_1_0.elementAt(41);
      expect(textureCoord_1_0_41, vector3MoreOrLessEquals(Vector3(1.03534, 0.701207, 0)));
      final textureCoord_1_0_42 = textureCoords_1_0.elementAt(42);
      expect(textureCoord_1_0_42, vector3MoreOrLessEquals(Vector3(1.34812, 0.50984, 0)));
      final textureCoord_1_0_43 = textureCoords_1_0.elementAt(43);
      expect(textureCoord_1_0_43, vector3MoreOrLessEquals(Vector3(1.03534, 0.701207, 0)));
      final textureCoord_1_0_44 = textureCoords_1_0.elementAt(44);
      expect(textureCoord_1_0_44, vector3MoreOrLessEquals(Vector3(1.03534, 0.318473, 0)));
      final textureCoord_1_0_45 = textureCoords_1_0.elementAt(45);
      expect(textureCoord_1_0_45, vector3MoreOrLessEquals(Vector3(0.403088, 0.50984, 0)));
      final textureCoord_1_0_46 = textureCoords_1_0.elementAt(46);
      expect(textureCoord_1_0_46, vector3MoreOrLessEquals(Vector3(1.03534, 0.318473, 0)));
      final textureCoord_1_0_47 = textureCoords_1_0.elementAt(47);
      expect(textureCoord_1_0_47, vector3MoreOrLessEquals(Vector3(1.03534, 0.701207, 0)));
      final textureCoord_1_0_48 = textureCoords_1_0.elementAt(48);
      expect(textureCoord_1_0_48, vector3MoreOrLessEquals(Vector3(0.403088, 0.184267, 0)));
      final textureCoord_1_0_49 = textureCoords_1_0.elementAt(49);
      expect(textureCoord_1_0_49, vector3MoreOrLessEquals(Vector3(0.678735, 0.008835, 0)));
      final textureCoord_1_0_50 = textureCoords_1_0.elementAt(50);
      expect(textureCoord_1_0_50, vector3MoreOrLessEquals(Vector3(1.03534, 0.318473, 0)));
      final textureCoord_1_0_51 = textureCoords_1_0.elementAt(51);
      expect(textureCoord_1_0_51, vector3MoreOrLessEquals(Vector3(1.34812, 0.50984, 0)));
      final textureCoord_1_0_52 = textureCoords_1_0.elementAt(52);
      expect(textureCoord_1_0_52, vector3MoreOrLessEquals(Vector3(1.03534, 0.318473, 0)));
      final textureCoord_1_0_53 = textureCoords_1_0.elementAt(53);
      expect(textureCoord_1_0_53, vector3MoreOrLessEquals(Vector3(1.31098, 0.064592, 0)));
      final textureCoord_1_0_54 = textureCoords_1_0.elementAt(54);
      expect(textureCoord_1_0_54, vector3MoreOrLessEquals(Vector3(1.05829, -0.016948, 0)));
      final textureCoord_1_0_55 = textureCoords_1_0.elementAt(55);
      expect(textureCoord_1_0_55, vector3MoreOrLessEquals(Vector3(1.31098, 0.064592, 0)));
      final textureCoord_1_0_56 = textureCoords_1_0.elementAt(56);
      expect(textureCoord_1_0_56, vector3MoreOrLessEquals(Vector3(0.678735, 0.008835, 0)));
      final textureCoord_1_0_57 = textureCoords_1_0.elementAt(57);
      expect(textureCoord_1_0_57, vector3MoreOrLessEquals(Vector3(1.03534, 0.318473, 0)));
      final textureCoord_1_0_58 = textureCoords_1_0.elementAt(58);
      expect(textureCoord_1_0_58, vector3MoreOrLessEquals(Vector3(0.678735, 0.008835, 0)));
      final textureCoord_1_0_59 = textureCoords_1_0.elementAt(59);
      expect(textureCoord_1_0_59, vector3MoreOrLessEquals(Vector3(1.31098, 0.064592, 0)));
      final textureCoord_1_0_60 = textureCoords_1_0.elementAt(60);
      expect(textureCoord_1_0_60, vector3MoreOrLessEquals(Vector3(1.34812, 0.50984, 0)));
      final textureCoord_1_0_61 = textureCoords_1_0.elementAt(61);
      expect(textureCoord_1_0_61, vector3MoreOrLessEquals(Vector3(1.31098, 0.064592, 0)));
      final textureCoord_1_0_62 = textureCoords_1_0.elementAt(62);
      expect(textureCoord_1_0_62, vector3MoreOrLessEquals(Vector3(1.48134, 0.50984, 0)));
      final textureCoord_1_0_63 = textureCoords_1_0.elementAt(63);
      expect(textureCoord_1_0_63, vector3MoreOrLessEquals(Vector3(1.34812, 0.50984, 0)));
      final textureCoord_1_0_64 = textureCoords_1_0.elementAt(64);
      expect(textureCoord_1_0_64, vector3MoreOrLessEquals(Vector3(1.48134, 0.50984, 0)));
      final textureCoord_1_0_65 = textureCoords_1_0.elementAt(65);
      expect(textureCoord_1_0_65, vector3MoreOrLessEquals(Vector3(1.31098, 0.064592, 0)));
      final textureCoord_1_0_66 = textureCoords_1_0.elementAt(66);
      expect(textureCoord_1_0_66, vector3MoreOrLessEquals(Vector3(1.05829, -0.016948, 0)));
      final textureCoord_1_0_67 = textureCoords_1_0.elementAt(67);
      expect(textureCoord_1_0_67, vector3MoreOrLessEquals(Vector3(1.31098, 0.064592, 0)));
      final textureCoord_1_0_68 = textureCoords_1_0.elementAt(68);
      expect(textureCoord_1_0_68, vector3MoreOrLessEquals(Vector3(1.31098, 0.064592, 0)));
      final textureCoord_1_0_69 = textureCoords_1_0.elementAt(69);
      expect(textureCoord_1_0_69, vector3MoreOrLessEquals(Vector3(1.48134, 0.50984, 0)));
      final textureCoord_1_0_70 = textureCoords_1_0.elementAt(70);
      expect(textureCoord_1_0_70, vector3MoreOrLessEquals(Vector3(1.31098, 0.064592, 0)));
      final textureCoord_1_0_71 = textureCoords_1_0.elementAt(71);
      expect(textureCoord_1_0_71, vector3MoreOrLessEquals(Vector3(1.31098, 0.064592, 0)));
      final textureCoord_1_0_72 = textureCoords_1_0.elementAt(72);
      expect(textureCoord_1_0_72, vector3MoreOrLessEquals(Vector3(1.34812, 0.50984, 0)));
      final textureCoord_1_0_73 = textureCoords_1_0.elementAt(73);
      expect(textureCoord_1_0_73, vector3MoreOrLessEquals(Vector3(1.48134, 0.50984, 0)));
      final textureCoord_1_0_74 = textureCoords_1_0.elementAt(74);
      expect(textureCoord_1_0_74, vector3MoreOrLessEquals(Vector3(1.31098, 0.955089, 0)));
      final textureCoord_1_0_75 = textureCoords_1_0.elementAt(75);
      expect(textureCoord_1_0_75, vector3MoreOrLessEquals(Vector3(1.05829, 1.03663, 0)));
      final textureCoord_1_0_76 = textureCoords_1_0.elementAt(76);
      expect(textureCoord_1_0_76, vector3MoreOrLessEquals(Vector3(1.31098, 0.955089, 0)));
      final textureCoord_1_0_77 = textureCoords_1_0.elementAt(77);
      expect(textureCoord_1_0_77, vector3MoreOrLessEquals(Vector3(1.31098, 0.955089, 0)));
      final textureCoord_1_0_78 = textureCoords_1_0.elementAt(78);
      expect(textureCoord_1_0_78, vector3MoreOrLessEquals(Vector3(1.34812, 0.50984, 0)));
      final textureCoord_1_0_79 = textureCoords_1_0.elementAt(79);
      expect(textureCoord_1_0_79, vector3MoreOrLessEquals(Vector3(1.31098, 0.955089, 0)));
      final textureCoord_1_0_80 = textureCoords_1_0.elementAt(80);
      expect(textureCoord_1_0_80, vector3MoreOrLessEquals(Vector3(1.48134, 0.50984, 0)));
      final textureCoord_1_0_81 = textureCoords_1_0.elementAt(81);
      expect(textureCoord_1_0_81, vector3MoreOrLessEquals(Vector3(1.31098, 0.955089, 0)));
      final textureCoord_1_0_82 = textureCoords_1_0.elementAt(82);
      expect(textureCoord_1_0_82, vector3MoreOrLessEquals(Vector3(1.48134, 0.50984, 0)));
      final textureCoord_1_0_83 = textureCoords_1_0.elementAt(83);
      expect(textureCoord_1_0_83, vector3MoreOrLessEquals(Vector3(1.31098, 0.955089, 0)));
      final textureCoord_1_0_84 = textureCoords_1_0.elementAt(84);
      expect(textureCoord_1_0_84, vector3MoreOrLessEquals(Vector3(0.403088, 0.835414, 0)));
      final textureCoord_1_0_85 = textureCoords_1_0.elementAt(85);
      expect(textureCoord_1_0_85, vector3MoreOrLessEquals(Vector3(1.03534, 0.701207, 0)));
      final textureCoord_1_0_86 = textureCoords_1_0.elementAt(86);
      expect(textureCoord_1_0_86, vector3MoreOrLessEquals(Vector3(0.678735, 1.01085, 0)));
      final textureCoord_1_0_87 = textureCoords_1_0.elementAt(87);
      expect(textureCoord_1_0_87, vector3MoreOrLessEquals(Vector3(1.05829, 1.03663, 0)));
      final textureCoord_1_0_88 = textureCoords_1_0.elementAt(88);
      expect(textureCoord_1_0_88, vector3MoreOrLessEquals(Vector3(0.678735, 1.01085, 0)));
      final textureCoord_1_0_89 = textureCoords_1_0.elementAt(89);
      expect(textureCoord_1_0_89, vector3MoreOrLessEquals(Vector3(1.31098, 0.955089, 0)));
      final textureCoord_1_0_90 = textureCoords_1_0.elementAt(90);
      expect(textureCoord_1_0_90, vector3MoreOrLessEquals(Vector3(1.34812, 0.50984, 0)));
      final textureCoord_1_0_91 = textureCoords_1_0.elementAt(91);
      expect(textureCoord_1_0_91, vector3MoreOrLessEquals(Vector3(1.31098, 0.955089, 0)));
      final textureCoord_1_0_92 = textureCoords_1_0.elementAt(92);
      expect(textureCoord_1_0_92, vector3MoreOrLessEquals(Vector3(1.03534, 0.701207, 0)));
      final textureCoord_1_0_93 = textureCoords_1_0.elementAt(93);
      expect(textureCoord_1_0_93, vector3MoreOrLessEquals(Vector3(0.678735, 1.01085, 0)));
      final textureCoord_1_0_94 = textureCoords_1_0.elementAt(94);
      expect(textureCoord_1_0_94, vector3MoreOrLessEquals(Vector3(1.03534, 0.701207, 0)));
      final textureCoord_1_0_95 = textureCoords_1_0.elementAt(95);
      expect(textureCoord_1_0_95, vector3MoreOrLessEquals(Vector3(1.31098, 0.955089, 0)));
      final textureCoord_1_0_96 = textureCoords_1_0.elementAt(96);
      expect(textureCoord_1_0_96, vector3MoreOrLessEquals(Vector3(0.403088, 0.835414, 0)));
      final textureCoord_1_0_97 = textureCoords_1_0.elementAt(97);
      expect(textureCoord_1_0_97, vector3MoreOrLessEquals(Vector3(0.678735, 1.01085, 0)));
      final textureCoord_1_0_98 = textureCoords_1_0.elementAt(98);
      expect(textureCoord_1_0_98, vector3MoreOrLessEquals(Vector3(0.127441, 1.38468, 0)));
      final textureCoord_1_0_99 = textureCoords_1_0.elementAt(99);
      expect(textureCoord_1_0_99, vector3MoreOrLessEquals(Vector3(-0.065871, 1.4297, 0)));
      final textureCoord_1_0_100 = textureCoords_1_0.elementAt(100);
      expect(textureCoord_1_0_100, vector3MoreOrLessEquals(Vector3(0.127441, 1.38468, 0)));
      final textureCoord_1_0_101 = textureCoords_1_0.elementAt(101);
      expect(textureCoord_1_0_101, vector3MoreOrLessEquals(Vector3(0.403088, 1.12912, 0)));
      final textureCoord_1_0_102 = textureCoords_1_0.elementAt(102);
      expect(textureCoord_1_0_102, vector3MoreOrLessEquals(Vector3(1.05829, 1.03663, 0)));
      final textureCoord_1_0_103 = textureCoords_1_0.elementAt(103);
      expect(textureCoord_1_0_103, vector3MoreOrLessEquals(Vector3(0.403088, 1.12912, 0)));
      final textureCoord_1_0_104 = textureCoords_1_0.elementAt(104);
      expect(textureCoord_1_0_104, vector3MoreOrLessEquals(Vector3(0.678735, 1.01085, 0)));
      final textureCoord_1_0_105 = textureCoords_1_0.elementAt(105);
      expect(textureCoord_1_0_105, vector3MoreOrLessEquals(Vector3(0.127441, 1.38468, 0)));
      final textureCoord_1_0_106 = textureCoords_1_0.elementAt(106);
      expect(textureCoord_1_0_106, vector3MoreOrLessEquals(Vector3(0.678735, 1.01085, 0)));
      final textureCoord_1_0_107 = textureCoords_1_0.elementAt(107);
      expect(textureCoord_1_0_107, vector3MoreOrLessEquals(Vector3(0.403088, 1.12912, 0)));
      final textureCoord_1_0_108 = textureCoords_1_0.elementAt(108);
      expect(textureCoord_1_0_108, vector3MoreOrLessEquals(Vector3(-0.065871, 1.4297, 0)));
      final textureCoord_1_0_109 = textureCoords_1_0.elementAt(109);
      expect(textureCoord_1_0_109, vector3MoreOrLessEquals(Vector3(0.403088, 1.12912, 0)));
      final textureCoord_1_0_110 = textureCoords_1_0.elementAt(110);
      expect(textureCoord_1_0_110, vector3MoreOrLessEquals(Vector3(0.127441, 1.38468, 0)));
      final textureCoord_1_0_111 = textureCoords_1_0.elementAt(111);
      expect(textureCoord_1_0_111, vector3MoreOrLessEquals(Vector3(0.403088, 0.835414, 0)));
      final textureCoord_1_0_112 = textureCoords_1_0.elementAt(112);
      expect(textureCoord_1_0_112, vector3MoreOrLessEquals(Vector3(0.127441, 1.38468, 0)));
      final textureCoord_1_0_113 = textureCoords_1_0.elementAt(113);
      expect(textureCoord_1_0_113, vector3MoreOrLessEquals(Vector3(0.678735, 1.01085, 0)));
      final textureCoord_1_0_114 = textureCoords_1_0.elementAt(114);
      expect(textureCoord_1_0_114, vector3MoreOrLessEquals(Vector3(1.05829, 1.03663, 0)));
      final textureCoord_1_0_115 = textureCoords_1_0.elementAt(115);
      expect(textureCoord_1_0_115, vector3MoreOrLessEquals(Vector3(0.678735, 1.01085, 0)));
      final textureCoord_1_0_116 = textureCoords_1_0.elementAt(116);
      expect(textureCoord_1_0_116, vector3MoreOrLessEquals(Vector3(0.403088, 1.12912, 0)));
      final textureCoord_1_0_117 = textureCoords_1_0.elementAt(117);
      expect(textureCoord_1_0_117, vector3MoreOrLessEquals(Vector3(0.127441, 1.38468, 0)));
      final textureCoord_1_0_118 = textureCoords_1_0.elementAt(118);
      expect(textureCoord_1_0_118, vector3MoreOrLessEquals(Vector3(0.403088, 1.12912, 0)));
      final textureCoord_1_0_119 = textureCoords_1_0.elementAt(119);
      expect(textureCoord_1_0_119, vector3MoreOrLessEquals(Vector3(0.678735, 1.01085, 0)));
      final textureCoord_1_0_120 = textureCoords_1_0.elementAt(120);
      expect(textureCoord_1_0_120, vector3MoreOrLessEquals(Vector3(1.05829, 1.03663, 0)));
      final textureCoord_1_0_121 = textureCoords_1_0.elementAt(121);
      expect(textureCoord_1_0_121, vector3MoreOrLessEquals(Vector3(1.31098, 0.955089, 0)));
      final textureCoord_1_0_122 = textureCoords_1_0.elementAt(122);
      expect(textureCoord_1_0_122, vector3MoreOrLessEquals(Vector3(0.678735, 1.01085, 0)));
      final textureCoord_1_0_123 = textureCoords_1_0.elementAt(123);
      expect(textureCoord_1_0_123, vector3MoreOrLessEquals(Vector3(-0.065871, -0.410016, 0)));
      final textureCoord_1_0_124 = textureCoords_1_0.elementAt(124);
      expect(textureCoord_1_0_124, vector3MoreOrLessEquals(Vector3(-0.318566, -0.030837, 0)));
      final textureCoord_1_0_125 = textureCoords_1_0.elementAt(125);
      expect(textureCoord_1_0_125, vector3MoreOrLessEquals(Vector3(0.127441, -0.364995, 0)));
      final textureCoord_1_0_126 = textureCoords_1_0.elementAt(126);
      expect(textureCoord_1_0_126, vector3MoreOrLessEquals(Vector3(-0.065871, -0.410016, 0)));
      final textureCoord_1_0_127 = textureCoords_1_0.elementAt(127);
      expect(textureCoord_1_0_127, vector3MoreOrLessEquals(Vector3(0.127441, -0.364995, 0)));
      final textureCoord_1_0_128 = textureCoords_1_0.elementAt(128);
      expect(textureCoord_1_0_128, vector3MoreOrLessEquals(Vector3(0.403088, -0.109437, 0)));
      final textureCoord_1_0_129 = textureCoords_1_0.elementAt(129);
      expect(textureCoord_1_0_129, vector3MoreOrLessEquals(Vector3(1.05829, -0.016948, 0)));
      final textureCoord_1_0_130 = textureCoords_1_0.elementAt(130);
      expect(textureCoord_1_0_130, vector3MoreOrLessEquals(Vector3(0.403088, -0.109437, 0)));
      final textureCoord_1_0_131 = textureCoords_1_0.elementAt(131);
      expect(textureCoord_1_0_131, vector3MoreOrLessEquals(Vector3(0.678735, 0.008835, 0)));
      final textureCoord_1_0_132 = textureCoords_1_0.elementAt(132);
      expect(textureCoord_1_0_132, vector3MoreOrLessEquals(Vector3(0.403088, 0.184267, 0)));
      final textureCoord_1_0_133 = textureCoords_1_0.elementAt(133);
      expect(textureCoord_1_0_133, vector3MoreOrLessEquals(Vector3(0.678735, 0.008835, 0)));
      final textureCoord_1_0_134 = textureCoords_1_0.elementAt(134);
      expect(textureCoord_1_0_134, vector3MoreOrLessEquals(Vector3(0.127441, -0.364995, 0)));
      final textureCoord_1_0_135 = textureCoords_1_0.elementAt(135);
      expect(textureCoord_1_0_135, vector3MoreOrLessEquals(Vector3(0.403088, -0.109437, 0)));
      final textureCoord_1_0_136 = textureCoords_1_0.elementAt(136);
      expect(textureCoord_1_0_136, vector3MoreOrLessEquals(Vector3(0.127441, -0.364995, 0)));
      final textureCoord_1_0_137 = textureCoords_1_0.elementAt(137);
      expect(textureCoord_1_0_137, vector3MoreOrLessEquals(Vector3(0.678735, 0.008835, 0)));
      final textureCoord_1_0_138 = textureCoords_1_0.elementAt(138);
      expect(textureCoord_1_0_138, vector3MoreOrLessEquals(Vector3(1.05829, -0.016948, 0)));
      final textureCoord_1_0_139 = textureCoords_1_0.elementAt(139);
      expect(textureCoord_1_0_139, vector3MoreOrLessEquals(Vector3(0.678735, 0.008835, 0)));
      final textureCoord_1_0_140 = textureCoords_1_0.elementAt(140);
      expect(textureCoord_1_0_140, vector3MoreOrLessEquals(Vector3(1.31098, 0.064592, 0)));
      final textureCoord_1_0_141 = textureCoords_1_0.elementAt(141);
      expect(textureCoord_1_0_141, vector3MoreOrLessEquals(Vector3(-0.355704, 0.50984, 0)));
      final textureCoord_1_0_142 = textureCoords_1_0.elementAt(142);
      expect(textureCoord_1_0_142, vector3MoreOrLessEquals(Vector3(-0.488925, 0.50984, 0)));
      final textureCoord_1_0_143 = textureCoords_1_0.elementAt(143);
      expect(textureCoord_1_0_143, vector3MoreOrLessEquals(Vector3(-0.318566, -0.030837, 0)));
      final textureCoord_1_0_144 = textureCoords_1_0.elementAt(144);
      expect(textureCoord_1_0_144, vector3MoreOrLessEquals(Vector3(-0.065871, -0.410016, 0)));
      final textureCoord_1_0_145 = textureCoords_1_0.elementAt(145);
      expect(textureCoord_1_0_145, vector3MoreOrLessEquals(Vector3(-0.318566, -0.030837, 0)));
      final textureCoord_1_0_146 = textureCoords_1_0.elementAt(146);
      expect(textureCoord_1_0_146, vector3MoreOrLessEquals(Vector3(-0.318566, -0.030837, 0)));
      final textureCoord_1_0_147 = textureCoords_1_0.elementAt(147);
      expect(textureCoord_1_0_147, vector3MoreOrLessEquals(Vector3(-0.355704, 0.50984, 0)));
      final textureCoord_1_0_148 = textureCoords_1_0.elementAt(148);
      expect(textureCoord_1_0_148, vector3MoreOrLessEquals(Vector3(-0.318566, -0.030837, 0)));
      final textureCoord_1_0_149 = textureCoords_1_0.elementAt(149);
      expect(textureCoord_1_0_149, vector3MoreOrLessEquals(Vector3(-0.488925, 0.50984, 0)));
      final textureCoord_1_0_150 = textureCoords_1_0.elementAt(150);
      expect(textureCoord_1_0_150, vector3MoreOrLessEquals(Vector3(-0.318566, -0.030837, 0)));
      final textureCoord_1_0_151 = textureCoords_1_0.elementAt(151);
      expect(textureCoord_1_0_151, vector3MoreOrLessEquals(Vector3(-0.488925, 0.50984, 0)));
      final textureCoord_1_0_152 = textureCoords_1_0.elementAt(152);
      expect(textureCoord_1_0_152, vector3MoreOrLessEquals(Vector3(-0.318566, -0.030837, 0)));
      final textureCoord_1_0_153 = textureCoords_1_0.elementAt(153);
      expect(textureCoord_1_0_153, vector3MoreOrLessEquals(Vector3(-0.355704, 0.50984, 0)));
      final textureCoord_1_0_154 = textureCoords_1_0.elementAt(154);
      expect(textureCoord_1_0_154, vector3MoreOrLessEquals(Vector3(-0.318566, 1.05052, 0)));
      final textureCoord_1_0_155 = textureCoords_1_0.elementAt(155);
      expect(textureCoord_1_0_155, vector3MoreOrLessEquals(Vector3(-0.488925, 0.50984, 0)));
      final textureCoord_1_0_156 = textureCoords_1_0.elementAt(156);
      expect(textureCoord_1_0_156, vector3MoreOrLessEquals(Vector3(-0.355704, 0.50984, 0)));
      final textureCoord_1_0_157 = textureCoords_1_0.elementAt(157);
      expect(textureCoord_1_0_157, vector3MoreOrLessEquals(Vector3(-0.488925, 0.50984, 0)));
      final textureCoord_1_0_158 = textureCoords_1_0.elementAt(158);
      expect(textureCoord_1_0_158, vector3MoreOrLessEquals(Vector3(-0.318566, 1.05052, 0)));
      final textureCoord_1_0_159 = textureCoords_1_0.elementAt(159);
      expect(textureCoord_1_0_159, vector3MoreOrLessEquals(Vector3(-0.065871, 1.4297, 0)));
      final textureCoord_1_0_160 = textureCoords_1_0.elementAt(160);
      expect(textureCoord_1_0_160, vector3MoreOrLessEquals(Vector3(-0.318566, 1.05052, 0)));
      final textureCoord_1_0_161 = textureCoords_1_0.elementAt(161);
      expect(textureCoord_1_0_161, vector3MoreOrLessEquals(Vector3(-0.318566, 1.05052, 0)));
      final textureCoord_1_0_162 = textureCoords_1_0.elementAt(162);
      expect(textureCoord_1_0_162, vector3MoreOrLessEquals(Vector3(-0.488925, 0.50984, 0)));
      final textureCoord_1_0_163 = textureCoords_1_0.elementAt(163);
      expect(textureCoord_1_0_163, vector3MoreOrLessEquals(Vector3(-0.318566, 1.05052, 0)));
      final textureCoord_1_0_164 = textureCoords_1_0.elementAt(164);
      expect(textureCoord_1_0_164, vector3MoreOrLessEquals(Vector3(-0.318566, 1.05052, 0)));
      final textureCoord_1_0_165 = textureCoords_1_0.elementAt(165);
      expect(textureCoord_1_0_165, vector3MoreOrLessEquals(Vector3(-0.355704, 0.50984, 0)));
      final textureCoord_1_0_166 = textureCoords_1_0.elementAt(166);
      expect(textureCoord_1_0_166, vector3MoreOrLessEquals(Vector3(-0.042919, 0.843998, 0)));
      final textureCoord_1_0_167 = textureCoords_1_0.elementAt(167);
      expect(textureCoord_1_0_167, vector3MoreOrLessEquals(Vector3(-0.318566, 1.05052, 0)));
      final textureCoord_1_0_168 = textureCoords_1_0.elementAt(168);
      expect(textureCoord_1_0_168, vector3MoreOrLessEquals(Vector3(-0.065871, 1.4297, 0)));
      final textureCoord_1_0_169 = textureCoords_1_0.elementAt(169);
      expect(textureCoord_1_0_169, vector3MoreOrLessEquals(Vector3(-0.318566, 1.05052, 0)));
      final textureCoord_1_0_170 = textureCoords_1_0.elementAt(170);
      expect(textureCoord_1_0_170, vector3MoreOrLessEquals(Vector3(0.127441, 1.38468, 0)));
      final textureCoord_1_0_171 = textureCoords_1_0.elementAt(171);
      expect(textureCoord_1_0_171, vector3MoreOrLessEquals(Vector3(0.403088, 0.835414, 0)));
      final textureCoord_1_0_172 = textureCoords_1_0.elementAt(172);
      expect(textureCoord_1_0_172, vector3MoreOrLessEquals(Vector3(0.127441, 1.38468, 0)));
      final textureCoord_1_0_173 = textureCoords_1_0.elementAt(173);
      expect(textureCoord_1_0_173, vector3MoreOrLessEquals(Vector3(-0.042919, 0.843998, 0)));
      final textureCoord_1_0_174 = textureCoords_1_0.elementAt(174);
      expect(textureCoord_1_0_174, vector3MoreOrLessEquals(Vector3(-0.318566, 1.05052, 0)));
      final textureCoord_1_0_175 = textureCoords_1_0.elementAt(175);
      expect(textureCoord_1_0_175, vector3MoreOrLessEquals(Vector3(-0.042919, 0.843998, 0)));
      final textureCoord_1_0_176 = textureCoords_1_0.elementAt(176);
      expect(textureCoord_1_0_176, vector3MoreOrLessEquals(Vector3(0.127441, 1.38468, 0)));
      final textureCoord_1_0_177 = textureCoords_1_0.elementAt(177);
      expect(textureCoord_1_0_177, vector3MoreOrLessEquals(Vector3(-0.065871, 1.4297, 0)));
      final textureCoord_1_0_178 = textureCoords_1_0.elementAt(178);
      expect(textureCoord_1_0_178, vector3MoreOrLessEquals(Vector3(0.127441, 1.38468, 0)));
      final textureCoord_1_0_179 = textureCoords_1_0.elementAt(179);
      expect(textureCoord_1_0_179, vector3MoreOrLessEquals(Vector3(-0.318566, 1.05052, 0)));
      expect(mesh_1.uvComponents.length, equals(1));
      expect(mesh_1.uvComponents, equals([2]));
      expect(mesh_1.faces.length, equals(60));
      expect(mesh_1.bones.length, isZero);
      expect(mesh_1.materialIndex, equals(1));
      expect(mesh_1.name, equals('OK'));
      expect(mesh_1.animMeshes.length, isZero);
      expect(mesh_1.morphingMethod, isZero);
      expect(mesh_1.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_2 = meshes.elementAt(2);
      expect(mesh_2.primitiveTypes, equals(4));
      expect(mesh_2.vertices.length, equals(294));
      final vertex_2_0 = mesh_2.vertices.elementAt(0);
      expect(vertex_2_0, vector3MoreOrLessEquals(Vector3(-40.6715, -3.47289, -21.3692)));
      final vertex_2_1 = mesh_2.vertices.elementAt(1);
      expect(vertex_2_1, vector3MoreOrLessEquals(Vector3(-41.9633, -2.24616, -18.4852)));
      final vertex_2_2 = mesh_2.vertices.elementAt(2);
      expect(vertex_2_2, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_3 = mesh_2.vertices.elementAt(3);
      expect(vertex_2_3, vector3MoreOrLessEquals(Vector3(-87.6058, -39.9835, -104.352)));
      final vertex_2_4 = mesh_2.vertices.elementAt(4);
      expect(vertex_2_4, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_5 = mesh_2.vertices.elementAt(5);
      expect(vertex_2_5, vector3MoreOrLessEquals(Vector3(-87.9502, -39.4551, -104.26)));
      final vertex_2_6 = mesh_2.vertices.elementAt(6);
      expect(vertex_2_6, vector3MoreOrLessEquals(Vector3(-40.6715, -3.47289, -21.3692)));
      final vertex_2_7 = mesh_2.vertices.elementAt(7);
      expect(vertex_2_7, vector3MoreOrLessEquals(Vector3(-47.0984, 7.38926, -39.585)));
      final vertex_2_8 = mesh_2.vertices.elementAt(8);
      expect(vertex_2_8, vector3MoreOrLessEquals(Vector3(-47.1467, 8.70439, -37.6816)));
      final vertex_2_9 = mesh_2.vertices.elementAt(9);
      expect(vertex_2_9, vector3MoreOrLessEquals(Vector3(-40.6715, -3.47289, -21.3692)));
      final vertex_2_10 = mesh_2.vertices.elementAt(10);
      expect(vertex_2_10, vector3MoreOrLessEquals(Vector3(-47.1467, 8.70439, -37.6816)));
      final vertex_2_11 = mesh_2.vertices.elementAt(11);
      expect(vertex_2_11, vector3MoreOrLessEquals(Vector3(-41.9633, -2.24616, -18.4852)));
      final vertex_2_12 = mesh_2.vertices.elementAt(12);
      expect(vertex_2_12, vector3MoreOrLessEquals(Vector3(-47.0984, 7.38926, -39.585)));
      final vertex_2_13 = mesh_2.vertices.elementAt(13);
      expect(vertex_2_13, vector3MoreOrLessEquals(Vector3(-55.4437, 28.017, -51.0206)));
      final vertex_2_14 = mesh_2.vertices.elementAt(14);
      expect(vertex_2_14, vector3MoreOrLessEquals(Vector3(-47.1467, 8.70439, -37.6816)));
      final vertex_2_15 = mesh_2.vertices.elementAt(15);
      expect(vertex_2_15, vector3MoreOrLessEquals(Vector3(-55.4437, 28.017, -51.0206)));
      final vertex_2_16 = mesh_2.vertices.elementAt(16);
      expect(vertex_2_16, vector3MoreOrLessEquals(Vector3(-55.8051, 29.5003, -50.3606)));
      final vertex_2_17 = mesh_2.vertices.elementAt(17);
      expect(vertex_2_17, vector3MoreOrLessEquals(Vector3(-47.1467, 8.70439, -37.6816)));
      final vertex_2_18 = mesh_2.vertices.elementAt(18);
      expect(vertex_2_18, vector3MoreOrLessEquals(Vector3(-55.4437, 28.017, -51.0206)));
      final vertex_2_19 = mesh_2.vertices.elementAt(19);
      expect(vertex_2_19, vector3MoreOrLessEquals(Vector3(-56.413, 27.5188, -54.6021)));
      final vertex_2_20 = mesh_2.vertices.elementAt(20);
      expect(vertex_2_20, vector3MoreOrLessEquals(Vector3(-57.933, 29.2079, -55.0394)));
      final vertex_2_21 = mesh_2.vertices.elementAt(21);
      expect(vertex_2_21, vector3MoreOrLessEquals(Vector3(-55.4437, 28.017, -51.0206)));
      final vertex_2_22 = mesh_2.vertices.elementAt(22);
      expect(vertex_2_22, vector3MoreOrLessEquals(Vector3(-57.933, 29.2079, -55.0394)));
      final vertex_2_23 = mesh_2.vertices.elementAt(23);
      expect(vertex_2_23, vector3MoreOrLessEquals(Vector3(-55.8051, 29.5003, -50.3606)));
      final vertex_2_24 = mesh_2.vertices.elementAt(24);
      expect(vertex_2_24, vector3MoreOrLessEquals(Vector3(-56.413, 27.5188, -54.6021)));
      final vertex_2_25 = mesh_2.vertices.elementAt(25);
      expect(vertex_2_25, vector3MoreOrLessEquals(Vector3(-67.985, 13.4356, -79.0204)));
      final vertex_2_26 = mesh_2.vertices.elementAt(26);
      expect(vertex_2_26, vector3MoreOrLessEquals(Vector3(-57.933, 29.2079, -55.0394)));
      final vertex_2_27 = mesh_2.vertices.elementAt(27);
      expect(vertex_2_27, vector3MoreOrLessEquals(Vector3(-67.985, 13.4356, -79.0204)));
      final vertex_2_28 = mesh_2.vertices.elementAt(28);
      expect(vertex_2_28, vector3MoreOrLessEquals(Vector3(-69.8936, 14.1058, -80.1441)));
      final vertex_2_29 = mesh_2.vertices.elementAt(29);
      expect(vertex_2_29, vector3MoreOrLessEquals(Vector3(-57.933, 29.2079, -55.0394)));
      final vertex_2_30 = mesh_2.vertices.elementAt(30);
      expect(vertex_2_30, vector3MoreOrLessEquals(Vector3(-67.985, 13.4356, -79.0204)));
      final vertex_2_31 = mesh_2.vertices.elementAt(31);
      expect(vertex_2_31, vector3MoreOrLessEquals(Vector3(-81.6783, -31.3792, -101.292)));
      final vertex_2_32 = mesh_2.vertices.elementAt(32);
      expect(vertex_2_32, vector3MoreOrLessEquals(Vector3(-82.7785, -29.8435, -101.267)));
      final vertex_2_33 = mesh_2.vertices.elementAt(33);
      expect(vertex_2_33, vector3MoreOrLessEquals(Vector3(-67.985, 13.4356, -79.0204)));
      final vertex_2_34 = mesh_2.vertices.elementAt(34);
      expect(vertex_2_34, vector3MoreOrLessEquals(Vector3(-82.7785, -29.8435, -101.267)));
      final vertex_2_35 = mesh_2.vertices.elementAt(35);
      expect(vertex_2_35, vector3MoreOrLessEquals(Vector3(-69.8936, 14.1058, -80.1441)));
      final vertex_2_36 = mesh_2.vertices.elementAt(36);
      expect(vertex_2_36, vector3MoreOrLessEquals(Vector3(-81.6783, -31.3792, -101.292)));
      final vertex_2_37 = mesh_2.vertices.elementAt(37);
      expect(vertex_2_37, vector3MoreOrLessEquals(Vector3(-87.6058, -39.9835, -104.352)));
      final vertex_2_38 = mesh_2.vertices.elementAt(38);
      expect(vertex_2_38, vector3MoreOrLessEquals(Vector3(-82.7785, -29.8435, -101.267)));
      final vertex_2_39 = mesh_2.vertices.elementAt(39);
      expect(vertex_2_39, vector3MoreOrLessEquals(Vector3(-87.6058, -39.9835, -104.352)));
      final vertex_2_40 = mesh_2.vertices.elementAt(40);
      expect(vertex_2_40, vector3MoreOrLessEquals(Vector3(-87.9502, -39.4551, -104.26)));
      final vertex_2_41 = mesh_2.vertices.elementAt(41);
      expect(vertex_2_41, vector3MoreOrLessEquals(Vector3(-82.7785, -29.8435, -101.267)));
      final vertex_2_42 = mesh_2.vertices.elementAt(42);
      expect(vertex_2_42, vector3MoreOrLessEquals(Vector3(-41.9633, -2.24616, -18.4852)));
      final vertex_2_43 = mesh_2.vertices.elementAt(43);
      expect(vertex_2_43, vector3MoreOrLessEquals(Vector3(-45.2746, -1.92132, -17.5626)));
      final vertex_2_44 = mesh_2.vertices.elementAt(44);
      expect(vertex_2_44, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_45 = mesh_2.vertices.elementAt(45);
      expect(vertex_2_45, vector3MoreOrLessEquals(Vector3(-87.9502, -39.4551, -104.26)));
      final vertex_2_46 = mesh_2.vertices.elementAt(46);
      expect(vertex_2_46, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_47 = mesh_2.vertices.elementAt(47);
      expect(vertex_2_47, vector3MoreOrLessEquals(Vector3(-88.235, -39.3502, -103.866)));
      final vertex_2_48 = mesh_2.vertices.elementAt(48);
      expect(vertex_2_48, vector3MoreOrLessEquals(Vector3(-41.9633, -2.24616, -18.4852)));
      final vertex_2_49 = mesh_2.vertices.elementAt(49);
      expect(vertex_2_49, vector3MoreOrLessEquals(Vector3(-47.1467, 8.70439, -37.6816)));
      final vertex_2_50 = mesh_2.vertices.elementAt(50);
      expect(vertex_2_50, vector3MoreOrLessEquals(Vector3(-45.2746, -1.92132, -17.5626)));
      final vertex_2_51 = mesh_2.vertices.elementAt(51);
      expect(vertex_2_51, vector3MoreOrLessEquals(Vector3(-47.1467, 8.70439, -37.6816)));
      final vertex_2_52 = mesh_2.vertices.elementAt(52);
      expect(vertex_2_52, vector3MoreOrLessEquals(Vector3(-48.8624, 8.96432, -36.1507)));
      final vertex_2_53 = mesh_2.vertices.elementAt(53);
      expect(vertex_2_53, vector3MoreOrLessEquals(Vector3(-45.2746, -1.92132, -17.5626)));
      final vertex_2_54 = mesh_2.vertices.elementAt(54);
      expect(vertex_2_54, vector3MoreOrLessEquals(Vector3(-47.1467, 8.70439, -37.6816)));
      final vertex_2_55 = mesh_2.vertices.elementAt(55);
      expect(vertex_2_55, vector3MoreOrLessEquals(Vector3(-55.8051, 29.5003, -50.3606)));
      final vertex_2_56 = mesh_2.vertices.elementAt(56);
      expect(vertex_2_56, vector3MoreOrLessEquals(Vector3(-56.925, 29.8275, -49.5558)));
      final vertex_2_57 = mesh_2.vertices.elementAt(57);
      expect(vertex_2_57, vector3MoreOrLessEquals(Vector3(-47.1467, 8.70439, -37.6816)));
      final vertex_2_58 = mesh_2.vertices.elementAt(58);
      expect(vertex_2_58, vector3MoreOrLessEquals(Vector3(-56.925, 29.8275, -49.5558)));
      final vertex_2_59 = mesh_2.vertices.elementAt(59);
      expect(vertex_2_59, vector3MoreOrLessEquals(Vector3(-48.8624, 8.96432, -36.1507)));
      final vertex_2_60 = mesh_2.vertices.elementAt(60);
      expect(vertex_2_60, vector3MoreOrLessEquals(Vector3(-55.8051, 29.5003, -50.3606)));
      final vertex_2_61 = mesh_2.vertices.elementAt(61);
      expect(vertex_2_61, vector3MoreOrLessEquals(Vector3(-57.933, 29.2079, -55.0394)));
      final vertex_2_62 = mesh_2.vertices.elementAt(62);
      expect(vertex_2_62, vector3MoreOrLessEquals(Vector3(-56.925, 29.8275, -49.5558)));
      final vertex_2_63 = mesh_2.vertices.elementAt(63);
      expect(vertex_2_63, vector3MoreOrLessEquals(Vector3(-57.933, 29.2079, -55.0394)));
      final vertex_2_64 = mesh_2.vertices.elementAt(64);
      expect(vertex_2_64, vector3MoreOrLessEquals(Vector3(-60.0122, 29.5602, -54.0867)));
      final vertex_2_65 = mesh_2.vertices.elementAt(65);
      expect(vertex_2_65, vector3MoreOrLessEquals(Vector3(-56.925, 29.8275, -49.5558)));
      final vertex_2_66 = mesh_2.vertices.elementAt(66);
      expect(vertex_2_66, vector3MoreOrLessEquals(Vector3(-57.933, 29.2079, -55.0394)));
      final vertex_2_67 = mesh_2.vertices.elementAt(67);
      expect(vertex_2_67, vector3MoreOrLessEquals(Vector3(-69.8936, 14.1058, -80.1441)));
      final vertex_2_68 = mesh_2.vertices.elementAt(68);
      expect(vertex_2_68, vector3MoreOrLessEquals(Vector3(-72.0687, 14.2065, -79.3609)));
      final vertex_2_69 = mesh_2.vertices.elementAt(69);
      expect(vertex_2_69, vector3MoreOrLessEquals(Vector3(-57.933, 29.2079, -55.0394)));
      final vertex_2_70 = mesh_2.vertices.elementAt(70);
      expect(vertex_2_70, vector3MoreOrLessEquals(Vector3(-72.0687, 14.2065, -79.3609)));
      final vertex_2_71 = mesh_2.vertices.elementAt(71);
      expect(vertex_2_71, vector3MoreOrLessEquals(Vector3(-60.0122, 29.5602, -54.0867)));
      final vertex_2_72 = mesh_2.vertices.elementAt(72);
      expect(vertex_2_72, vector3MoreOrLessEquals(Vector3(-69.8936, 14.1058, -80.1441)));
      final vertex_2_73 = mesh_2.vertices.elementAt(73);
      expect(vertex_2_73, vector3MoreOrLessEquals(Vector3(-82.7785, -29.8435, -101.267)));
      final vertex_2_74 = mesh_2.vertices.elementAt(74);
      expect(vertex_2_74, vector3MoreOrLessEquals(Vector3(-72.0687, 14.2065, -79.3609)));
      final vertex_2_75 = mesh_2.vertices.elementAt(75);
      expect(vertex_2_75, vector3MoreOrLessEquals(Vector3(-82.7785, -29.8435, -101.267)));
      final vertex_2_76 = mesh_2.vertices.elementAt(76);
      expect(vertex_2_76, vector3MoreOrLessEquals(Vector3(-83.4747, -29.5186, -100.471)));
      final vertex_2_77 = mesh_2.vertices.elementAt(77);
      expect(vertex_2_77, vector3MoreOrLessEquals(Vector3(-72.0687, 14.2065, -79.3609)));
      final vertex_2_78 = mesh_2.vertices.elementAt(78);
      expect(vertex_2_78, vector3MoreOrLessEquals(Vector3(-82.7785, -29.8435, -101.267)));
      final vertex_2_79 = mesh_2.vertices.elementAt(79);
      expect(vertex_2_79, vector3MoreOrLessEquals(Vector3(-87.9502, -39.4551, -104.26)));
      final vertex_2_80 = mesh_2.vertices.elementAt(80);
      expect(vertex_2_80, vector3MoreOrLessEquals(Vector3(-88.235, -39.3502, -103.866)));
      final vertex_2_81 = mesh_2.vertices.elementAt(81);
      expect(vertex_2_81, vector3MoreOrLessEquals(Vector3(-82.7785, -29.8435, -101.267)));
      final vertex_2_82 = mesh_2.vertices.elementAt(82);
      expect(vertex_2_82, vector3MoreOrLessEquals(Vector3(-88.235, -39.3502, -103.866)));
      final vertex_2_83 = mesh_2.vertices.elementAt(83);
      expect(vertex_2_83, vector3MoreOrLessEquals(Vector3(-83.4747, -29.5186, -100.471)));
      final vertex_2_84 = mesh_2.vertices.elementAt(84);
      expect(vertex_2_84, vector3MoreOrLessEquals(Vector3(-45.2746, -1.92132, -17.5626)));
      final vertex_2_85 = mesh_2.vertices.elementAt(85);
      expect(vertex_2_85, vector3MoreOrLessEquals(Vector3(-48.1119, -2.74297, -19.296)));
      final vertex_2_86 = mesh_2.vertices.elementAt(86);
      expect(vertex_2_86, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_87 = mesh_2.vertices.elementAt(87);
      expect(vertex_2_87, vector3MoreOrLessEquals(Vector3(-88.235, -39.3502, -103.866)));
      final vertex_2_88 = mesh_2.vertices.elementAt(88);
      expect(vertex_2_88, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_89 = mesh_2.vertices.elementAt(89);
      expect(vertex_2_89, vector3MoreOrLessEquals(Vector3(-88.2457, -39.7477, -103.466)));
      final vertex_2_90 = mesh_2.vertices.elementAt(90);
      expect(vertex_2_90, vector3MoreOrLessEquals(Vector3(-45.2746, -1.92132, -17.5626)));
      final vertex_2_91 = mesh_2.vertices.elementAt(91);
      expect(vertex_2_91, vector3MoreOrLessEquals(Vector3(-48.8624, 8.96432, -36.1507)));
      final vertex_2_92 = mesh_2.vertices.elementAt(92);
      expect(vertex_2_92, vector3MoreOrLessEquals(Vector3(-50.9535, 7.97335, -36.1451)));
      final vertex_2_93 = mesh_2.vertices.elementAt(93);
      expect(vertex_2_93, vector3MoreOrLessEquals(Vector3(-45.2746, -1.92132, -17.5626)));
      final vertex_2_94 = mesh_2.vertices.elementAt(94);
      expect(vertex_2_94, vector3MoreOrLessEquals(Vector3(-50.9535, 7.97335, -36.1451)));
      final vertex_2_95 = mesh_2.vertices.elementAt(95);
      expect(vertex_2_95, vector3MoreOrLessEquals(Vector3(-48.1119, -2.74297, -19.296)));
      final vertex_2_96 = mesh_2.vertices.elementAt(96);
      expect(vertex_2_96, vector3MoreOrLessEquals(Vector3(-48.8624, 8.96432, -36.1507)));
      final vertex_2_97 = mesh_2.vertices.elementAt(97);
      expect(vertex_2_97, vector3MoreOrLessEquals(Vector3(-56.925, 29.8275, -49.5558)));
      final vertex_2_98 = mesh_2.vertices.elementAt(98);
      expect(vertex_2_98, vector3MoreOrLessEquals(Vector3(-50.9535, 7.97335, -36.1451)));
      final vertex_2_99 = mesh_2.vertices.elementAt(99);
      expect(vertex_2_99, vector3MoreOrLessEquals(Vector3(-56.925, 29.8275, -49.5558)));
      final vertex_2_100 = mesh_2.vertices.elementAt(100);
      expect(vertex_2_100, vector3MoreOrLessEquals(Vector3(-57.9601, 28.752, -49.2124)));
      final vertex_2_101 = mesh_2.vertices.elementAt(101);
      expect(vertex_2_101, vector3MoreOrLessEquals(Vector3(-50.9535, 7.97335, -36.1451)));
      final vertex_2_102 = mesh_2.vertices.elementAt(102);
      expect(vertex_2_102, vector3MoreOrLessEquals(Vector3(-56.925, 29.8275, -49.5558)));
      final vertex_2_103 = mesh_2.vertices.elementAt(103);
      expect(vertex_2_103, vector3MoreOrLessEquals(Vector3(-60.0122, 29.5602, -54.0867)));
      final vertex_2_104 = mesh_2.vertices.elementAt(104);
      expect(vertex_2_104, vector3MoreOrLessEquals(Vector3(-61.0849, 28.3104, -52.4613)));
      final vertex_2_105 = mesh_2.vertices.elementAt(105);
      expect(vertex_2_105, vector3MoreOrLessEquals(Vector3(-56.925, 29.8275, -49.5558)));
      final vertex_2_106 = mesh_2.vertices.elementAt(106);
      expect(vertex_2_106, vector3MoreOrLessEquals(Vector3(-61.0849, 28.3104, -52.4613)));
      final vertex_2_107 = mesh_2.vertices.elementAt(107);
      expect(vertex_2_107, vector3MoreOrLessEquals(Vector3(-57.9601, 28.752, -49.2124)));
      final vertex_2_108 = mesh_2.vertices.elementAt(108);
      expect(vertex_2_108, vector3MoreOrLessEquals(Vector3(-60.0122, 29.5602, -54.0867)));
      final vertex_2_109 = mesh_2.vertices.elementAt(109);
      expect(vertex_2_109, vector3MoreOrLessEquals(Vector3(-72.0687, 14.2065, -79.3609)));
      final vertex_2_110 = mesh_2.vertices.elementAt(110);
      expect(vertex_2_110, vector3MoreOrLessEquals(Vector3(-61.0849, 28.3104, -52.4613)));
      final vertex_2_111 = mesh_2.vertices.elementAt(111);
      expect(vertex_2_111, vector3MoreOrLessEquals(Vector3(-72.0687, 14.2065, -79.3609)));
      final vertex_2_112 = mesh_2.vertices.elementAt(112);
      expect(vertex_2_112, vector3MoreOrLessEquals(Vector3(-72.8725, 13.6618, -77.2604)));
      final vertex_2_113 = mesh_2.vertices.elementAt(113);
      expect(vertex_2_113, vector3MoreOrLessEquals(Vector3(-61.0849, 28.3104, -52.4613)));
      final vertex_2_114 = mesh_2.vertices.elementAt(114);
      expect(vertex_2_114, vector3MoreOrLessEquals(Vector3(-72.0687, 14.2065, -79.3609)));
      final vertex_2_115 = mesh_2.vertices.elementAt(115);
      expect(vertex_2_115, vector3MoreOrLessEquals(Vector3(-83.4747, -29.5186, -100.471)));
      final vertex_2_116 = mesh_2.vertices.elementAt(116);
      expect(vertex_2_116, vector3MoreOrLessEquals(Vector3(-83.2428, -30.649, -99.5034)));
      final vertex_2_117 = mesh_2.vertices.elementAt(117);
      expect(vertex_2_117, vector3MoreOrLessEquals(Vector3(-72.0687, 14.2065, -79.3609)));
      final vertex_2_118 = mesh_2.vertices.elementAt(118);
      expect(vertex_2_118, vector3MoreOrLessEquals(Vector3(-83.2428, -30.649, -99.5034)));
      final vertex_2_119 = mesh_2.vertices.elementAt(119);
      expect(vertex_2_119, vector3MoreOrLessEquals(Vector3(-72.8725, 13.6618, -77.2604)));
      final vertex_2_120 = mesh_2.vertices.elementAt(120);
      expect(vertex_2_120, vector3MoreOrLessEquals(Vector3(-83.4747, -29.5186, -100.471)));
      final vertex_2_121 = mesh_2.vertices.elementAt(121);
      expect(vertex_2_121, vector3MoreOrLessEquals(Vector3(-88.235, -39.3502, -103.866)));
      final vertex_2_122 = mesh_2.vertices.elementAt(122);
      expect(vertex_2_122, vector3MoreOrLessEquals(Vector3(-83.2428, -30.649, -99.5034)));
      final vertex_2_123 = mesh_2.vertices.elementAt(123);
      expect(vertex_2_123, vector3MoreOrLessEquals(Vector3(-88.235, -39.3502, -103.866)));
      final vertex_2_124 = mesh_2.vertices.elementAt(124);
      expect(vertex_2_124, vector3MoreOrLessEquals(Vector3(-88.2457, -39.7477, -103.466)));
      final vertex_2_125 = mesh_2.vertices.elementAt(125);
      expect(vertex_2_125, vector3MoreOrLessEquals(Vector3(-83.2428, -30.649, -99.5034)));
      final vertex_2_126 = mesh_2.vertices.elementAt(126);
      expect(vertex_2_126, vector3MoreOrLessEquals(Vector3(-48.1119, -2.74297, -19.296)));
      final vertex_2_127 = mesh_2.vertices.elementAt(127);
      expect(vertex_2_127, vector3MoreOrLessEquals(Vector3(-48.3386, -4.0924, -22.3802)));
      final vertex_2_128 = mesh_2.vertices.elementAt(128);
      expect(vertex_2_128, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_129 = mesh_2.vertices.elementAt(129);
      expect(vertex_2_129, vector3MoreOrLessEquals(Vector3(-88.2457, -39.7477, -103.466)));
      final vertex_2_130 = mesh_2.vertices.elementAt(130);
      expect(vertex_2_130, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_131 = mesh_2.vertices.elementAt(131);
      expect(vertex_2_131, vector3MoreOrLessEquals(Vector3(-87.9744, -40.3484, -103.362)));
      final vertex_2_132 = mesh_2.vertices.elementAt(132);
      expect(vertex_2_132, vector3MoreOrLessEquals(Vector3(-48.1119, -2.74297, -19.296)));
      final vertex_2_133 = mesh_2.vertices.elementAt(133);
      expect(vertex_2_133, vector3MoreOrLessEquals(Vector3(-50.9535, 7.97335, -36.1451)));
      final vertex_2_134 = mesh_2.vertices.elementAt(134);
      expect(vertex_2_134, vector3MoreOrLessEquals(Vector3(-48.3386, -4.0924, -22.3802)));
      final vertex_2_135 = mesh_2.vertices.elementAt(135);
      expect(vertex_2_135, vector3MoreOrLessEquals(Vector3(-50.9535, 7.97335, -36.1451)));
      final vertex_2_136 = mesh_2.vertices.elementAt(136);
      expect(vertex_2_136, vector3MoreOrLessEquals(Vector3(-51.8454, 6.4777, -37.669)));
      final vertex_2_137 = mesh_2.vertices.elementAt(137);
      expect(vertex_2_137, vector3MoreOrLessEquals(Vector3(-48.3386, -4.0924, -22.3802)));
      final vertex_2_138 = mesh_2.vertices.elementAt(138);
      expect(vertex_2_138, vector3MoreOrLessEquals(Vector3(-50.9535, 7.97335, -36.1451)));
      final vertex_2_139 = mesh_2.vertices.elementAt(139);
      expect(vertex_2_139, vector3MoreOrLessEquals(Vector3(-57.9601, 28.752, -49.2124)));
      final vertex_2_140 = mesh_2.vertices.elementAt(140);
      expect(vertex_2_140, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_141 = mesh_2.vertices.elementAt(141);
      expect(vertex_2_141, vector3MoreOrLessEquals(Vector3(-50.9535, 7.97335, -36.1451)));
      final vertex_2_142 = mesh_2.vertices.elementAt(142);
      expect(vertex_2_142, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_143 = mesh_2.vertices.elementAt(143);
      expect(vertex_2_143, vector3MoreOrLessEquals(Vector3(-51.8454, 6.4777, -37.669)));
      final vertex_2_144 = mesh_2.vertices.elementAt(144);
      expect(vertex_2_144, vector3MoreOrLessEquals(Vector3(-57.9601, 28.752, -49.2124)));
      final vertex_2_145 = mesh_2.vertices.elementAt(145);
      expect(vertex_2_145, vector3MoreOrLessEquals(Vector3(-61.0849, 28.3104, -52.4613)));
      final vertex_2_146 = mesh_2.vertices.elementAt(146);
      expect(vertex_2_146, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_147 = mesh_2.vertices.elementAt(147);
      expect(vertex_2_147, vector3MoreOrLessEquals(Vector3(-61.0849, 28.3104, -52.4613)));
      final vertex_2_148 = mesh_2.vertices.elementAt(148);
      expect(vertex_2_148, vector3MoreOrLessEquals(Vector3(-60.3433, 26.3996, -51.3871)));
      final vertex_2_149 = mesh_2.vertices.elementAt(149);
      expect(vertex_2_149, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_150 = mesh_2.vertices.elementAt(150);
      expect(vertex_2_150, vector3MoreOrLessEquals(Vector3(-61.0849, 28.3104, -52.4613)));
      final vertex_2_151 = mesh_2.vertices.elementAt(151);
      expect(vertex_2_151, vector3MoreOrLessEquals(Vector3(-72.8725, 13.6618, -77.2604)));
      final vertex_2_152 = mesh_2.vertices.elementAt(152);
      expect(vertex_2_152, vector3MoreOrLessEquals(Vector3(-71.6997, 12.8818, -75.4244)));
      final vertex_2_153 = mesh_2.vertices.elementAt(153);
      expect(vertex_2_153, vector3MoreOrLessEquals(Vector3(-61.0849, 28.3104, -52.4613)));
      final vertex_2_154 = mesh_2.vertices.elementAt(154);
      expect(vertex_2_154, vector3MoreOrLessEquals(Vector3(-71.6997, 12.8818, -75.4244)));
      final vertex_2_155 = mesh_2.vertices.elementAt(155);
      expect(vertex_2_155, vector3MoreOrLessEquals(Vector3(-60.3433, 26.3996, -51.3871)));
      final vertex_2_156 = mesh_2.vertices.elementAt(156);
      expect(vertex_2_156, vector3MoreOrLessEquals(Vector3(-72.8725, 13.6618, -77.2604)));
      final vertex_2_157 = mesh_2.vertices.elementAt(157);
      expect(vertex_2_157, vector3MoreOrLessEquals(Vector3(-83.2428, -30.649, -99.5034)));
      final vertex_2_158 = mesh_2.vertices.elementAt(158);
      expect(vertex_2_158, vector3MoreOrLessEquals(Vector3(-71.6997, 12.8818, -75.4244)));
      final vertex_2_159 = mesh_2.vertices.elementAt(159);
      expect(vertex_2_159, vector3MoreOrLessEquals(Vector3(-83.2428, -30.649, -99.5034)));
      final vertex_2_160 = mesh_2.vertices.elementAt(160);
      expect(vertex_2_160, vector3MoreOrLessEquals(Vector3(-82.2572, -32.3836, -99.0929)));
      final vertex_2_161 = mesh_2.vertices.elementAt(161);
      expect(vertex_2_161, vector3MoreOrLessEquals(Vector3(-71.6997, 12.8818, -75.4244)));
      final vertex_2_162 = mesh_2.vertices.elementAt(162);
      expect(vertex_2_162, vector3MoreOrLessEquals(Vector3(-83.2428, -30.649, -99.5034)));
      final vertex_2_163 = mesh_2.vertices.elementAt(163);
      expect(vertex_2_163, vector3MoreOrLessEquals(Vector3(-88.2457, -39.7477, -103.466)));
      final vertex_2_164 = mesh_2.vertices.elementAt(164);
      expect(vertex_2_164, vector3MoreOrLessEquals(Vector3(-87.9744, -40.3484, -103.362)));
      final vertex_2_165 = mesh_2.vertices.elementAt(165);
      expect(vertex_2_165, vector3MoreOrLessEquals(Vector3(-83.2428, -30.649, -99.5034)));
      final vertex_2_166 = mesh_2.vertices.elementAt(166);
      expect(vertex_2_166, vector3MoreOrLessEquals(Vector3(-87.9744, -40.3484, -103.362)));
      final vertex_2_167 = mesh_2.vertices.elementAt(167);
      expect(vertex_2_167, vector3MoreOrLessEquals(Vector3(-82.2572, -32.3836, -99.0929)));
      final vertex_2_168 = mesh_2.vertices.elementAt(168);
      expect(vertex_2_168, vector3MoreOrLessEquals(Vector3(-48.3386, -4.0924, -22.3802)));
      final vertex_2_169 = mesh_2.vertices.elementAt(169);
      expect(vertex_2_169, vector3MoreOrLessEquals(Vector3(-45.784, -4.95347, -24.4927)));
      final vertex_2_170 = mesh_2.vertices.elementAt(170);
      expect(vertex_2_170, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_171 = mesh_2.vertices.elementAt(171);
      expect(vertex_2_171, vector3MoreOrLessEquals(Vector3(-87.9744, -40.3484, -103.362)));
      final vertex_2_172 = mesh_2.vertices.elementAt(172);
      expect(vertex_2_172, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_173 = mesh_2.vertices.elementAt(173);
      expect(vertex_2_173, vector3MoreOrLessEquals(Vector3(-87.6253, -40.6998, -103.631)));
      final vertex_2_174 = mesh_2.vertices.elementAt(174);
      expect(vertex_2_174, vector3MoreOrLessEquals(Vector3(-48.3386, -4.0924, -22.3802)));
      final vertex_2_175 = mesh_2.vertices.elementAt(175);
      expect(vertex_2_175, vector3MoreOrLessEquals(Vector3(-51.8454, 6.4777, -37.669)));
      final vertex_2_176 = mesh_2.vertices.elementAt(176);
      expect(vertex_2_176, vector3MoreOrLessEquals(Vector3(-50.8665, 5.60359, -39.5749)));
      final vertex_2_177 = mesh_2.vertices.elementAt(177);
      expect(vertex_2_177, vector3MoreOrLessEquals(Vector3(-48.3386, -4.0924, -22.3802)));
      final vertex_2_178 = mesh_2.vertices.elementAt(178);
      expect(vertex_2_178, vector3MoreOrLessEquals(Vector3(-50.8665, 5.60359, -39.5749)));
      final vertex_2_179 = mesh_2.vertices.elementAt(179);
      expect(vertex_2_179, vector3MoreOrLessEquals(Vector3(-45.784, -4.95347, -24.4927)));
      final vertex_2_180 = mesh_2.vertices.elementAt(180);
      expect(vertex_2_180, vector3MoreOrLessEquals(Vector3(-51.8454, 6.4777, -37.669)));
      final vertex_2_181 = mesh_2.vertices.elementAt(181);
      expect(vertex_2_181, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_182 = mesh_2.vertices.elementAt(182);
      expect(vertex_2_182, vector3MoreOrLessEquals(Vector3(-50.8665, 5.60359, -39.5749)));
      final vertex_2_183 = mesh_2.vertices.elementAt(183);
      expect(vertex_2_183, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_184 = mesh_2.vertices.elementAt(184);
      expect(vertex_2_184, vector3MoreOrLessEquals(Vector3(-57.309, 26.0791, -50.4018)));
      final vertex_2_185 = mesh_2.vertices.elementAt(185);
      expect(vertex_2_185, vector3MoreOrLessEquals(Vector3(-50.8665, 5.60359, -39.5749)));
      final vertex_2_186 = mesh_2.vertices.elementAt(186);
      expect(vertex_2_186, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_187 = mesh_2.vertices.elementAt(187);
      expect(vertex_2_187, vector3MoreOrLessEquals(Vector3(-60.3433, 26.3996, -51.3871)));
      final vertex_2_188 = mesh_2.vertices.elementAt(188);
      expect(vertex_2_188, vector3MoreOrLessEquals(Vector3(-58.346, 25.2666, -51.6732)));
      final vertex_2_189 = mesh_2.vertices.elementAt(189);
      expect(vertex_2_189, vector3MoreOrLessEquals(Vector3(-58.131, 27.0838, -49.5889)));
      final vertex_2_190 = mesh_2.vertices.elementAt(190);
      expect(vertex_2_190, vector3MoreOrLessEquals(Vector3(-58.346, 25.2666, -51.6732)));
      final vertex_2_191 = mesh_2.vertices.elementAt(191);
      expect(vertex_2_191, vector3MoreOrLessEquals(Vector3(-57.309, 26.0791, -50.4018)));
      final vertex_2_192 = mesh_2.vertices.elementAt(192);
      expect(vertex_2_192, vector3MoreOrLessEquals(Vector3(-60.3433, 26.3996, -51.3871)));
      final vertex_2_193 = mesh_2.vertices.elementAt(193);
      expect(vertex_2_193, vector3MoreOrLessEquals(Vector3(-71.6997, 12.8818, -75.4244)));
      final vertex_2_194 = mesh_2.vertices.elementAt(194);
      expect(vertex_2_194, vector3MoreOrLessEquals(Vector3(-58.346, 25.2666, -51.6732)));
      final vertex_2_195 = mesh_2.vertices.elementAt(195);
      expect(vertex_2_195, vector3MoreOrLessEquals(Vector3(-71.6997, 12.8818, -75.4244)));
      final vertex_2_196 = mesh_2.vertices.elementAt(196);
      expect(vertex_2_196, vector3MoreOrLessEquals(Vector3(-69.4333, 12.454, -75.2354)));
      final vertex_2_197 = mesh_2.vertices.elementAt(197);
      expect(vertex_2_197, vector3MoreOrLessEquals(Vector3(-58.346, 25.2666, -51.6732)));
      final vertex_2_198 = mesh_2.vertices.elementAt(198);
      expect(vertex_2_198, vector3MoreOrLessEquals(Vector3(-71.6997, 12.8818, -75.4244)));
      final vertex_2_199 = mesh_2.vertices.elementAt(199);
      expect(vertex_2_199, vector3MoreOrLessEquals(Vector3(-82.2572, -32.3836, -99.0929)));
      final vertex_2_200 = mesh_2.vertices.elementAt(200);
      expect(vertex_2_200, vector3MoreOrLessEquals(Vector3(-81.2603, -33.4162, -99.5484)));
      final vertex_2_201 = mesh_2.vertices.elementAt(201);
      expect(vertex_2_201, vector3MoreOrLessEquals(Vector3(-71.6997, 12.8818, -75.4244)));
      final vertex_2_202 = mesh_2.vertices.elementAt(202);
      expect(vertex_2_202, vector3MoreOrLessEquals(Vector3(-81.2603, -33.4162, -99.5484)));
      final vertex_2_203 = mesh_2.vertices.elementAt(203);
      expect(vertex_2_203, vector3MoreOrLessEquals(Vector3(-69.4333, 12.454, -75.2354)));
      final vertex_2_204 = mesh_2.vertices.elementAt(204);
      expect(vertex_2_204, vector3MoreOrLessEquals(Vector3(-82.2572, -32.3836, -99.0929)));
      final vertex_2_205 = mesh_2.vertices.elementAt(205);
      expect(vertex_2_205, vector3MoreOrLessEquals(Vector3(-87.9744, -40.3484, -103.362)));
      final vertex_2_206 = mesh_2.vertices.elementAt(206);
      expect(vertex_2_206, vector3MoreOrLessEquals(Vector3(-81.2603, -33.4162, -99.5484)));
      final vertex_2_207 = mesh_2.vertices.elementAt(207);
      expect(vertex_2_207, vector3MoreOrLessEquals(Vector3(-87.9744, -40.3484, -103.362)));
      final vertex_2_208 = mesh_2.vertices.elementAt(208);
      expect(vertex_2_208, vector3MoreOrLessEquals(Vector3(-87.6253, -40.6998, -103.631)));
      final vertex_2_209 = mesh_2.vertices.elementAt(209);
      expect(vertex_2_209, vector3MoreOrLessEquals(Vector3(-81.2603, -33.4162, -99.5484)));
      final vertex_2_210 = mesh_2.vertices.elementAt(210);
      expect(vertex_2_210, vector3MoreOrLessEquals(Vector3(-45.784, -4.95347, -24.4927)));
      final vertex_2_211 = mesh_2.vertices.elementAt(211);
      expect(vertex_2_211, vector3MoreOrLessEquals(Vector3(-42.3719, -4.67776, -24.0427)));
      final vertex_2_212 = mesh_2.vertices.elementAt(212);
      expect(vertex_2_212, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_213 = mesh_2.vertices.elementAt(213);
      expect(vertex_2_213, vector3MoreOrLessEquals(Vector3(-87.6253, -40.6998, -103.631)));
      final vertex_2_214 = mesh_2.vertices.elementAt(214);
      expect(vertex_2_214, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_215 = mesh_2.vertices.elementAt(215);
      expect(vertex_2_215, vector3MoreOrLessEquals(Vector3(-87.4612, -40.5375, -104.072)));
      final vertex_2_216 = mesh_2.vertices.elementAt(216);
      expect(vertex_2_216, vector3MoreOrLessEquals(Vector3(-45.784, -4.95347, -24.4927)));
      final vertex_2_217 = mesh_2.vertices.elementAt(217);
      expect(vertex_2_217, vector3MoreOrLessEquals(Vector3(-50.8665, 5.60359, -39.5749)));
      final vertex_2_218 = mesh_2.vertices.elementAt(218);
      expect(vertex_2_218, vector3MoreOrLessEquals(Vector3(-42.3719, -4.67776, -24.0427)));
      final vertex_2_219 = mesh_2.vertices.elementAt(219);
      expect(vertex_2_219, vector3MoreOrLessEquals(Vector3(-50.8665, 5.60359, -39.5749)));
      final vertex_2_220 = mesh_2.vertices.elementAt(220);
      expect(vertex_2_220, vector3MoreOrLessEquals(Vector3(-48.7538, 6.00928, -40.4276)));
      final vertex_2_221 = mesh_2.vertices.elementAt(221);
      expect(vertex_2_221, vector3MoreOrLessEquals(Vector3(-42.3719, -4.67776, -24.0427)));
      final vertex_2_222 = mesh_2.vertices.elementAt(222);
      expect(vertex_2_222, vector3MoreOrLessEquals(Vector3(-50.8665, 5.60359, -39.5749)));
      final vertex_2_223 = mesh_2.vertices.elementAt(223);
      expect(vertex_2_223, vector3MoreOrLessEquals(Vector3(-57.309, 26.0791, -50.4018)));
      final vertex_2_224 = mesh_2.vertices.elementAt(224);
      expect(vertex_2_224, vector3MoreOrLessEquals(Vector3(-56.113, 26.4944, -51.039)));
      final vertex_2_225 = mesh_2.vertices.elementAt(225);
      expect(vertex_2_225, vector3MoreOrLessEquals(Vector3(-50.8665, 5.60359, -39.5749)));
      final vertex_2_226 = mesh_2.vertices.elementAt(226);
      expect(vertex_2_226, vector3MoreOrLessEquals(Vector3(-56.113, 26.4944, -51.039)));
      final vertex_2_227 = mesh_2.vertices.elementAt(227);
      expect(vertex_2_227, vector3MoreOrLessEquals(Vector3(-48.7538, 6.00928, -40.4276)));
      final vertex_2_228 = mesh_2.vertices.elementAt(228);
      expect(vertex_2_228, vector3MoreOrLessEquals(Vector3(-57.309, 26.0791, -50.4018)));
      final vertex_2_229 = mesh_2.vertices.elementAt(229);
      expect(vertex_2_229, vector3MoreOrLessEquals(Vector3(-58.346, 25.2666, -51.6732)));
      final vertex_2_230 = mesh_2.vertices.elementAt(230);
      expect(vertex_2_230, vector3MoreOrLessEquals(Vector3(-56.113, 26.4944, -51.039)));
      final vertex_2_231 = mesh_2.vertices.elementAt(231);
      expect(vertex_2_231, vector3MoreOrLessEquals(Vector3(-58.346, 25.2666, -51.6732)));
      final vertex_2_232 = mesh_2.vertices.elementAt(232);
      expect(vertex_2_232, vector3MoreOrLessEquals(Vector3(-56.5968, 25.7647, -53.104)));
      final vertex_2_233 = mesh_2.vertices.elementAt(233);
      expect(vertex_2_233, vector3MoreOrLessEquals(Vector3(-56.113, 26.4944, -51.039)));
      final vertex_2_234 = mesh_2.vertices.elementAt(234);
      expect(vertex_2_234, vector3MoreOrLessEquals(Vector3(-58.346, 25.2666, -51.6732)));
      final vertex_2_235 = mesh_2.vertices.elementAt(235);
      expect(vertex_2_235, vector3MoreOrLessEquals(Vector3(-69.4333, 12.454, -75.2354)));
      final vertex_2_236 = mesh_2.vertices.elementAt(236);
      expect(vertex_2_236, vector3MoreOrLessEquals(Vector3(-67.7802, 12.7004, -76.8358)));
      final vertex_2_237 = mesh_2.vertices.elementAt(237);
      expect(vertex_2_237, vector3MoreOrLessEquals(Vector3(-58.346, 25.2666, -51.6732)));
      final vertex_2_238 = mesh_2.vertices.elementAt(238);
      expect(vertex_2_238, vector3MoreOrLessEquals(Vector3(-67.7802, 12.7004, -76.8358)));
      final vertex_2_239 = mesh_2.vertices.elementAt(239);
      expect(vertex_2_239, vector3MoreOrLessEquals(Vector3(-56.5968, 25.7647, -53.104)));
      final vertex_2_240 = mesh_2.vertices.elementAt(240);
      expect(vertex_2_240, vector3MoreOrLessEquals(Vector3(-69.4333, 12.454, -75.2354)));
      final vertex_2_241 = mesh_2.vertices.elementAt(241);
      expect(vertex_2_241, vector3MoreOrLessEquals(Vector3(-81.2603, -33.4162, -99.5484)));
      final vertex_2_242 = mesh_2.vertices.elementAt(242);
      expect(vertex_2_242, vector3MoreOrLessEquals(Vector3(-67.7802, 12.7004, -76.8358)));
      final vertex_2_243 = mesh_2.vertices.elementAt(243);
      expect(vertex_2_243, vector3MoreOrLessEquals(Vector3(-81.2603, -33.4162, -99.5484)));
      final vertex_2_244 = mesh_2.vertices.elementAt(244);
      expect(vertex_2_244, vector3MoreOrLessEquals(Vector3(-81.0026, -32.9692, -100.527)));
      final vertex_2_245 = mesh_2.vertices.elementAt(245);
      expect(vertex_2_245, vector3MoreOrLessEquals(Vector3(-67.7802, 12.7004, -76.8358)));
      final vertex_2_246 = mesh_2.vertices.elementAt(246);
      expect(vertex_2_246, vector3MoreOrLessEquals(Vector3(-81.2603, -33.4162, -99.5484)));
      final vertex_2_247 = mesh_2.vertices.elementAt(247);
      expect(vertex_2_247, vector3MoreOrLessEquals(Vector3(-87.6253, -40.6998, -103.631)));
      final vertex_2_248 = mesh_2.vertices.elementAt(248);
      expect(vertex_2_248, vector3MoreOrLessEquals(Vector3(-87.4612, -40.5375, -104.072)));
      final vertex_2_249 = mesh_2.vertices.elementAt(249);
      expect(vertex_2_249, vector3MoreOrLessEquals(Vector3(-81.2603, -33.4162, -99.5484)));
      final vertex_2_250 = mesh_2.vertices.elementAt(250);
      expect(vertex_2_250, vector3MoreOrLessEquals(Vector3(-87.4612, -40.5375, -104.072)));
      final vertex_2_251 = mesh_2.vertices.elementAt(251);
      expect(vertex_2_251, vector3MoreOrLessEquals(Vector3(-81.0026, -32.9692, -100.527)));
      final vertex_2_252 = mesh_2.vertices.elementAt(252);
      expect(vertex_2_252, vector3MoreOrLessEquals(Vector3(-42.3719, -4.67776, -24.0427)));
      final vertex_2_253 = mesh_2.vertices.elementAt(253);
      expect(vertex_2_253, vector3MoreOrLessEquals(Vector3(-40.6715, -3.47289, -21.3692)));
      final vertex_2_254 = mesh_2.vertices.elementAt(254);
      expect(vertex_2_254, vector3MoreOrLessEquals(Vector3(-44.6451, -3.44384, -21.0898)));
      final vertex_2_255 = mesh_2.vertices.elementAt(255);
      expect(vertex_2_255, vector3MoreOrLessEquals(Vector3(-87.4612, -40.5375, -104.072)));
      final vertex_2_256 = mesh_2.vertices.elementAt(256);
      expect(vertex_2_256, vector3MoreOrLessEquals(Vector3(-87.871, -40.0175, -103.858)));
      final vertex_2_257 = mesh_2.vertices.elementAt(257);
      expect(vertex_2_257, vector3MoreOrLessEquals(Vector3(-87.6058, -39.9835, -104.352)));
      final vertex_2_258 = mesh_2.vertices.elementAt(258);
      expect(vertex_2_258, vector3MoreOrLessEquals(Vector3(-42.3719, -4.67776, -24.0427)));
      final vertex_2_259 = mesh_2.vertices.elementAt(259);
      expect(vertex_2_259, vector3MoreOrLessEquals(Vector3(-48.7538, 6.00928, -40.4276)));
      final vertex_2_260 = mesh_2.vertices.elementAt(260);
      expect(vertex_2_260, vector3MoreOrLessEquals(Vector3(-47.0984, 7.38926, -39.585)));
      final vertex_2_261 = mesh_2.vertices.elementAt(261);
      expect(vertex_2_261, vector3MoreOrLessEquals(Vector3(-42.3719, -4.67776, -24.0427)));
      final vertex_2_262 = mesh_2.vertices.elementAt(262);
      expect(vertex_2_262, vector3MoreOrLessEquals(Vector3(-47.0984, 7.38926, -39.585)));
      final vertex_2_263 = mesh_2.vertices.elementAt(263);
      expect(vertex_2_263, vector3MoreOrLessEquals(Vector3(-40.6715, -3.47289, -21.3692)));
      final vertex_2_264 = mesh_2.vertices.elementAt(264);
      expect(vertex_2_264, vector3MoreOrLessEquals(Vector3(-48.7538, 6.00928, -40.4276)));
      final vertex_2_265 = mesh_2.vertices.elementAt(265);
      expect(vertex_2_265, vector3MoreOrLessEquals(Vector3(-56.113, 26.4944, -51.039)));
      final vertex_2_266 = mesh_2.vertices.elementAt(266);
      expect(vertex_2_266, vector3MoreOrLessEquals(Vector3(-47.0984, 7.38926, -39.585)));
      final vertex_2_267 = mesh_2.vertices.elementAt(267);
      expect(vertex_2_267, vector3MoreOrLessEquals(Vector3(-56.113, 26.4944, -51.039)));
      final vertex_2_268 = mesh_2.vertices.elementAt(268);
      expect(vertex_2_268, vector3MoreOrLessEquals(Vector3(-55.4437, 28.017, -51.0206)));
      final vertex_2_269 = mesh_2.vertices.elementAt(269);
      expect(vertex_2_269, vector3MoreOrLessEquals(Vector3(-47.0984, 7.38926, -39.585)));
      final vertex_2_270 = mesh_2.vertices.elementAt(270);
      expect(vertex_2_270, vector3MoreOrLessEquals(Vector3(-56.113, 26.4944, -51.039)));
      final vertex_2_271 = mesh_2.vertices.elementAt(271);
      expect(vertex_2_271, vector3MoreOrLessEquals(Vector3(-56.5968, 25.7647, -53.104)));
      final vertex_2_272 = mesh_2.vertices.elementAt(272);
      expect(vertex_2_272, vector3MoreOrLessEquals(Vector3(-56.413, 27.5188, -54.6021)));
      final vertex_2_273 = mesh_2.vertices.elementAt(273);
      expect(vertex_2_273, vector3MoreOrLessEquals(Vector3(-56.113, 26.4944, -51.039)));
      final vertex_2_274 = mesh_2.vertices.elementAt(274);
      expect(vertex_2_274, vector3MoreOrLessEquals(Vector3(-56.413, 27.5188, -54.6021)));
      final vertex_2_275 = mesh_2.vertices.elementAt(275);
      expect(vertex_2_275, vector3MoreOrLessEquals(Vector3(-55.4437, 28.017, -51.0206)));
      final vertex_2_276 = mesh_2.vertices.elementAt(276);
      expect(vertex_2_276, vector3MoreOrLessEquals(Vector3(-56.5968, 25.7647, -53.104)));
      final vertex_2_277 = mesh_2.vertices.elementAt(277);
      expect(vertex_2_277, vector3MoreOrLessEquals(Vector3(-67.7802, 12.7004, -76.8358)));
      final vertex_2_278 = mesh_2.vertices.elementAt(278);
      expect(vertex_2_278, vector3MoreOrLessEquals(Vector3(-56.413, 27.5188, -54.6021)));
      final vertex_2_279 = mesh_2.vertices.elementAt(279);
      expect(vertex_2_279, vector3MoreOrLessEquals(Vector3(-67.7802, 12.7004, -76.8358)));
      final vertex_2_280 = mesh_2.vertices.elementAt(280);
      expect(vertex_2_280, vector3MoreOrLessEquals(Vector3(-67.985, 13.4356, -79.0204)));
      final vertex_2_281 = mesh_2.vertices.elementAt(281);
      expect(vertex_2_281, vector3MoreOrLessEquals(Vector3(-56.413, 27.5188, -54.6021)));
      final vertex_2_282 = mesh_2.vertices.elementAt(282);
      expect(vertex_2_282, vector3MoreOrLessEquals(Vector3(-67.7802, 12.7004, -76.8358)));
      final vertex_2_283 = mesh_2.vertices.elementAt(283);
      expect(vertex_2_283, vector3MoreOrLessEquals(Vector3(-81.0026, -32.9692, -100.527)));
      final vertex_2_284 = mesh_2.vertices.elementAt(284);
      expect(vertex_2_284, vector3MoreOrLessEquals(Vector3(-81.6783, -31.3792, -101.292)));
      final vertex_2_285 = mesh_2.vertices.elementAt(285);
      expect(vertex_2_285, vector3MoreOrLessEquals(Vector3(-67.7802, 12.7004, -76.8358)));
      final vertex_2_286 = mesh_2.vertices.elementAt(286);
      expect(vertex_2_286, vector3MoreOrLessEquals(Vector3(-81.6783, -31.3792, -101.292)));
      final vertex_2_287 = mesh_2.vertices.elementAt(287);
      expect(vertex_2_287, vector3MoreOrLessEquals(Vector3(-67.985, 13.4356, -79.0204)));
      final vertex_2_288 = mesh_2.vertices.elementAt(288);
      expect(vertex_2_288, vector3MoreOrLessEquals(Vector3(-81.0026, -32.9692, -100.527)));
      final vertex_2_289 = mesh_2.vertices.elementAt(289);
      expect(vertex_2_289, vector3MoreOrLessEquals(Vector3(-87.4612, -40.5375, -104.072)));
      final vertex_2_290 = mesh_2.vertices.elementAt(290);
      expect(vertex_2_290, vector3MoreOrLessEquals(Vector3(-81.6783, -31.3792, -101.292)));
      final vertex_2_291 = mesh_2.vertices.elementAt(291);
      expect(vertex_2_291, vector3MoreOrLessEquals(Vector3(-87.4612, -40.5375, -104.072)));
      final vertex_2_292 = mesh_2.vertices.elementAt(292);
      expect(vertex_2_292, vector3MoreOrLessEquals(Vector3(-87.6058, -39.9835, -104.352)));
      final vertex_2_293 = mesh_2.vertices.elementAt(293);
      expect(vertex_2_293, vector3MoreOrLessEquals(Vector3(-81.6783, -31.3792, -101.292)));
      expect(mesh_2.normals.length, equals(294));
      final normal_2_0 = mesh_2.normals.elementAt(0);
      expect(normal_2_0, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_1 = mesh_2.normals.elementAt(1);
      expect(normal_2_1, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_2 = mesh_2.normals.elementAt(2);
      expect(normal_2_2, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_3 = mesh_2.normals.elementAt(3);
      expect(normal_2_3, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_4 = mesh_2.normals.elementAt(4);
      expect(normal_2_4, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_5 = mesh_2.normals.elementAt(5);
      expect(normal_2_5, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_6 = mesh_2.normals.elementAt(6);
      expect(normal_2_6, vector3MoreOrLessEquals(Vector3(0.956336, 0.228461, -0.182283)));
      final normal_2_7 = mesh_2.normals.elementAt(7);
      expect(normal_2_7, vector3MoreOrLessEquals(Vector3(0.833901, -0.104561, -0.541919)));
      final normal_2_8 = mesh_2.normals.elementAt(8);
      expect(normal_2_8, vector3MoreOrLessEquals(Vector3(0.7678, 0.601842, 0.219702)));
      final normal_2_9 = mesh_2.normals.elementAt(9);
      expect(normal_2_9, vector3MoreOrLessEquals(Vector3(0.956336, 0.228461, -0.182283)));
      final normal_2_10 = mesh_2.normals.elementAt(10);
      expect(normal_2_10, vector3MoreOrLessEquals(Vector3(0.7678, 0.601842, 0.219702)));
      final normal_2_11 = mesh_2.normals.elementAt(11);
      expect(normal_2_11, vector3MoreOrLessEquals(Vector3(0.546124, 0.782549, 0.29894)));
      final normal_2_12 = mesh_2.normals.elementAt(12);
      expect(normal_2_12, vector3MoreOrLessEquals(Vector3(0.833901, -0.104561, -0.541919)));
      final normal_2_13 = mesh_2.normals.elementAt(13);
      expect(normal_2_13, vector3MoreOrLessEquals(Vector3(0.910925, 0.174919, -0.373656)));
      final normal_2_14 = mesh_2.normals.elementAt(14);
      expect(normal_2_14, vector3MoreOrLessEquals(Vector3(0.7678, 0.601842, 0.219702)));
      final normal_2_15 = mesh_2.normals.elementAt(15);
      expect(normal_2_15, vector3MoreOrLessEquals(Vector3(0.910925, 0.174919, -0.373656)));
      final normal_2_16 = mesh_2.normals.elementAt(16);
      expect(normal_2_16, vector3MoreOrLessEquals(Vector3(0.748758, 0.661676, -0.039313)));
      final normal_2_17 = mesh_2.normals.elementAt(17);
      expect(normal_2_17, vector3MoreOrLessEquals(Vector3(0.7678, 0.601842, 0.219702)));
      final normal_2_18 = mesh_2.normals.elementAt(18);
      expect(normal_2_18, vector3MoreOrLessEquals(Vector3(0.910925, 0.174919, -0.373656)));
      final normal_2_19 = mesh_2.normals.elementAt(19);
      expect(normal_2_19, vector3MoreOrLessEquals(Vector3(0.949258, -0.047485, -0.310893)));
      final normal_2_20 = mesh_2.normals.elementAt(20);
      expect(normal_2_20, vector3MoreOrLessEquals(Vector3(0.406836, 0.80226, -0.436879)));
      final normal_2_21 = mesh_2.normals.elementAt(21);
      expect(normal_2_21, vector3MoreOrLessEquals(Vector3(0.910925, 0.174919, -0.373656)));
      final normal_2_22 = mesh_2.normals.elementAt(22);
      expect(normal_2_22, vector3MoreOrLessEquals(Vector3(0.406836, 0.80226, -0.436879)));
      final normal_2_23 = mesh_2.normals.elementAt(23);
      expect(normal_2_23, vector3MoreOrLessEquals(Vector3(0.748758, 0.661676, -0.039313)));
      final normal_2_24 = mesh_2.normals.elementAt(24);
      expect(normal_2_24, vector3MoreOrLessEquals(Vector3(0.949258, -0.047485, -0.310893)));
      final normal_2_25 = mesh_2.normals.elementAt(25);
      expect(normal_2_25, vector3MoreOrLessEquals(Vector3(0.769156, 0.182669, -0.612398)));
      final normal_2_26 = mesh_2.normals.elementAt(26);
      expect(normal_2_26, vector3MoreOrLessEquals(Vector3(0.406836, 0.80226, -0.436879)));
      final normal_2_27 = mesh_2.normals.elementAt(27);
      expect(normal_2_27, vector3MoreOrLessEquals(Vector3(0.769156, 0.182669, -0.612398)));
      final normal_2_28 = mesh_2.normals.elementAt(28);
      expect(normal_2_28, vector3MoreOrLessEquals(Vector3(0.199512, 0.609083, -0.767602)));
      final normal_2_29 = mesh_2.normals.elementAt(29);
      expect(normal_2_29, vector3MoreOrLessEquals(Vector3(0.406836, 0.80226, -0.436879)));
      final normal_2_30 = mesh_2.normals.elementAt(30);
      expect(normal_2_30, vector3MoreOrLessEquals(Vector3(0.769156, 0.182669, -0.612398)));
      final normal_2_31 = mesh_2.normals.elementAt(31);
      expect(normal_2_31, vector3MoreOrLessEquals(Vector3(0.667603, 0.001959, -0.744515)));
      final normal_2_32 = mesh_2.normals.elementAt(32);
      expect(normal_2_32, vector3MoreOrLessEquals(Vector3(-0.099388, 0.414937, -0.904405)));
      final normal_2_33 = mesh_2.normals.elementAt(33);
      expect(normal_2_33, vector3MoreOrLessEquals(Vector3(0.769156, 0.182669, -0.612398)));
      final normal_2_34 = mesh_2.normals.elementAt(34);
      expect(normal_2_34, vector3MoreOrLessEquals(Vector3(-0.099388, 0.414937, -0.904405)));
      final normal_2_35 = mesh_2.normals.elementAt(35);
      expect(normal_2_35, vector3MoreOrLessEquals(Vector3(0.199512, 0.609083, -0.767602)));
      final normal_2_36 = mesh_2.normals.elementAt(36);
      expect(normal_2_36, vector3MoreOrLessEquals(Vector3(0.667603, 0.001959, -0.744515)));
      final normal_2_37 = mesh_2.normals.elementAt(37);
      expect(normal_2_37, vector3MoreOrLessEquals(Vector3(0.352774, 0.079499, -0.932325)));
      final normal_2_38 = mesh_2.normals.elementAt(38);
      expect(normal_2_38, vector3MoreOrLessEquals(Vector3(-0.099388, 0.414937, -0.904405)));
      final normal_2_39 = mesh_2.normals.elementAt(39);
      expect(normal_2_39, vector3MoreOrLessEquals(Vector3(0.352774, 0.079499, -0.932325)));
      final normal_2_40 = mesh_2.normals.elementAt(40);
      expect(normal_2_40, vector3MoreOrLessEquals(Vector3(-0.283318, 0.420843, -0.861755)));
      final normal_2_41 = mesh_2.normals.elementAt(41);
      expect(normal_2_41, vector3MoreOrLessEquals(Vector3(-0.099388, 0.414937, -0.904405)));
      final normal_2_42 = mesh_2.normals.elementAt(42);
      expect(normal_2_42, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_43 = mesh_2.normals.elementAt(43);
      expect(normal_2_43, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_44 = mesh_2.normals.elementAt(44);
      expect(normal_2_44, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_45 = mesh_2.normals.elementAt(45);
      expect(normal_2_45, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_46 = mesh_2.normals.elementAt(46);
      expect(normal_2_46, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_47 = mesh_2.normals.elementAt(47);
      expect(normal_2_47, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_48 = mesh_2.normals.elementAt(48);
      expect(normal_2_48, vector3MoreOrLessEquals(Vector3(0.546124, 0.782549, 0.29894)));
      final normal_2_49 = mesh_2.normals.elementAt(49);
      expect(normal_2_49, vector3MoreOrLessEquals(Vector3(0.7678, 0.601842, 0.219702)));
      final normal_2_50 = mesh_2.normals.elementAt(50);
      expect(normal_2_50, vector3MoreOrLessEquals(Vector3(-0.057479, 0.857527, 0.511218)));
      final normal_2_51 = mesh_2.normals.elementAt(51);
      expect(normal_2_51, vector3MoreOrLessEquals(Vector3(0.7678, 0.601842, 0.219702)));
      final normal_2_52 = mesh_2.normals.elementAt(52);
      expect(normal_2_52, vector3MoreOrLessEquals(Vector3(0.131724, 0.743022, 0.656177)));
      final normal_2_53 = mesh_2.normals.elementAt(53);
      expect(normal_2_53, vector3MoreOrLessEquals(Vector3(-0.057479, 0.857527, 0.511218)));
      final normal_2_54 = mesh_2.normals.elementAt(54);
      expect(normal_2_54, vector3MoreOrLessEquals(Vector3(0.7678, 0.601842, 0.219702)));
      final normal_2_55 = mesh_2.normals.elementAt(55);
      expect(normal_2_55, vector3MoreOrLessEquals(Vector3(0.748758, 0.661676, -0.039313)));
      final normal_2_56 = mesh_2.normals.elementAt(56);
      expect(normal_2_56, vector3MoreOrLessEquals(Vector3(-0.005809, 0.859552, 0.511016)));
      final normal_2_57 = mesh_2.normals.elementAt(57);
      expect(normal_2_57, vector3MoreOrLessEquals(Vector3(0.7678, 0.601842, 0.219702)));
      final normal_2_58 = mesh_2.normals.elementAt(58);
      expect(normal_2_58, vector3MoreOrLessEquals(Vector3(-0.005809, 0.859552, 0.511016)));
      final normal_2_59 = mesh_2.normals.elementAt(59);
      expect(normal_2_59, vector3MoreOrLessEquals(Vector3(0.131724, 0.743022, 0.656177)));
      final normal_2_60 = mesh_2.normals.elementAt(60);
      expect(normal_2_60, vector3MoreOrLessEquals(Vector3(0.748758, 0.661676, -0.039313)));
      final normal_2_61 = mesh_2.normals.elementAt(61);
      expect(normal_2_61, vector3MoreOrLessEquals(Vector3(0.406836, 0.80226, -0.436879)));
      final normal_2_62 = mesh_2.normals.elementAt(62);
      expect(normal_2_62, vector3MoreOrLessEquals(Vector3(-0.005809, 0.859552, 0.511016)));
      final normal_2_63 = mesh_2.normals.elementAt(63);
      expect(normal_2_63, vector3MoreOrLessEquals(Vector3(0.406836, 0.80226, -0.436879)));
      final normal_2_64 = mesh_2.normals.elementAt(64);
      expect(normal_2_64, vector3MoreOrLessEquals(Vector3(-0.350571, 0.931431, -0.097655)));
      final normal_2_65 = mesh_2.normals.elementAt(65);
      expect(normal_2_65, vector3MoreOrLessEquals(Vector3(-0.005809, 0.859552, 0.511016)));
      final normal_2_66 = mesh_2.normals.elementAt(66);
      expect(normal_2_66, vector3MoreOrLessEquals(Vector3(0.406836, 0.80226, -0.436879)));
      final normal_2_67 = mesh_2.normals.elementAt(67);
      expect(normal_2_67, vector3MoreOrLessEquals(Vector3(0.199512, 0.609083, -0.767602)));
      final normal_2_68 = mesh_2.normals.elementAt(68);
      expect(normal_2_68, vector3MoreOrLessEquals(Vector3(-0.647693, 0.664816, -0.372173)));
      final normal_2_69 = mesh_2.normals.elementAt(69);
      expect(normal_2_69, vector3MoreOrLessEquals(Vector3(0.406836, 0.80226, -0.436879)));
      final normal_2_70 = mesh_2.normals.elementAt(70);
      expect(normal_2_70, vector3MoreOrLessEquals(Vector3(-0.647693, 0.664816, -0.372173)));
      final normal_2_71 = mesh_2.normals.elementAt(71);
      expect(normal_2_71, vector3MoreOrLessEquals(Vector3(-0.350571, 0.931431, -0.097655)));
      final normal_2_72 = mesh_2.normals.elementAt(72);
      expect(normal_2_72, vector3MoreOrLessEquals(Vector3(0.199512, 0.609083, -0.767602)));
      final normal_2_73 = mesh_2.normals.elementAt(73);
      expect(normal_2_73, vector3MoreOrLessEquals(Vector3(-0.099388, 0.414937, -0.904405)));
      final normal_2_74 = mesh_2.normals.elementAt(74);
      expect(normal_2_74, vector3MoreOrLessEquals(Vector3(-0.647693, 0.664816, -0.372173)));
      final normal_2_75 = mesh_2.normals.elementAt(75);
      expect(normal_2_75, vector3MoreOrLessEquals(Vector3(-0.099388, 0.414937, -0.904405)));
      final normal_2_76 = mesh_2.normals.elementAt(76);
      expect(normal_2_76, vector3MoreOrLessEquals(Vector3(-0.898309, 0.404808, -0.170794)));
      final normal_2_77 = mesh_2.normals.elementAt(77);
      expect(normal_2_77, vector3MoreOrLessEquals(Vector3(-0.647693, 0.664816, -0.372173)));
      final normal_2_78 = mesh_2.normals.elementAt(78);
      expect(normal_2_78, vector3MoreOrLessEquals(Vector3(-0.099388, 0.414937, -0.904405)));
      final normal_2_79 = mesh_2.normals.elementAt(79);
      expect(normal_2_79, vector3MoreOrLessEquals(Vector3(-0.283318, 0.420843, -0.861755)));
      final normal_2_80 = mesh_2.normals.elementAt(80);
      expect(normal_2_80, vector3MoreOrLessEquals(Vector3(-0.866249, 0.480043, -0.138459)));
      final normal_2_81 = mesh_2.normals.elementAt(81);
      expect(normal_2_81, vector3MoreOrLessEquals(Vector3(-0.099388, 0.414937, -0.904405)));
      final normal_2_82 = mesh_2.normals.elementAt(82);
      expect(normal_2_82, vector3MoreOrLessEquals(Vector3(-0.866249, 0.480043, -0.138459)));
      final normal_2_83 = mesh_2.normals.elementAt(83);
      expect(normal_2_83, vector3MoreOrLessEquals(Vector3(-0.898309, 0.404808, -0.170794)));
      final normal_2_84 = mesh_2.normals.elementAt(84);
      expect(normal_2_84, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_85 = mesh_2.normals.elementAt(85);
      expect(normal_2_85, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_86 = mesh_2.normals.elementAt(86);
      expect(normal_2_86, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_87 = mesh_2.normals.elementAt(87);
      expect(normal_2_87, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_88 = mesh_2.normals.elementAt(88);
      expect(normal_2_88, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_89 = mesh_2.normals.elementAt(89);
      expect(normal_2_89, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_90 = mesh_2.normals.elementAt(90);
      expect(normal_2_90, vector3MoreOrLessEquals(Vector3(-0.057479, 0.857527, 0.511218)));
      final normal_2_91 = mesh_2.normals.elementAt(91);
      expect(normal_2_91, vector3MoreOrLessEquals(Vector3(0.131724, 0.743022, 0.656177)));
      final normal_2_92 = mesh_2.normals.elementAt(92);
      expect(normal_2_92, vector3MoreOrLessEquals(Vector3(-0.715121, 0.36025, 0.599018)));
      final normal_2_93 = mesh_2.normals.elementAt(93);
      expect(normal_2_93, vector3MoreOrLessEquals(Vector3(-0.057479, 0.857527, 0.511218)));
      final normal_2_94 = mesh_2.normals.elementAt(94);
      expect(normal_2_94, vector3MoreOrLessEquals(Vector3(-0.715121, 0.36025, 0.599018)));
      final normal_2_95 = mesh_2.normals.elementAt(95);
      expect(normal_2_95, vector3MoreOrLessEquals(Vector3(-0.866625, 0.34177, 0.36353)));
      final normal_2_96 = mesh_2.normals.elementAt(96);
      expect(normal_2_96, vector3MoreOrLessEquals(Vector3(0.131724, 0.743022, 0.656177)));
      final normal_2_97 = mesh_2.normals.elementAt(97);
      expect(normal_2_97, vector3MoreOrLessEquals(Vector3(-0.005809, 0.859552, 0.511016)));
      final normal_2_98 = mesh_2.normals.elementAt(98);
      expect(normal_2_98, vector3MoreOrLessEquals(Vector3(-0.715121, 0.36025, 0.599018)));
      final normal_2_99 = mesh_2.normals.elementAt(99);
      expect(normal_2_99, vector3MoreOrLessEquals(Vector3(-0.005809, 0.859552, 0.511016)));
      final normal_2_100 = mesh_2.normals.elementAt(100);
      expect(normal_2_100, vector3MoreOrLessEquals(Vector3(-0.662377, 0.297013, 0.68778)));
      final normal_2_101 = mesh_2.normals.elementAt(101);
      expect(normal_2_101, vector3MoreOrLessEquals(Vector3(-0.715121, 0.36025, 0.599018)));
      final normal_2_102 = mesh_2.normals.elementAt(102);
      expect(normal_2_102, vector3MoreOrLessEquals(Vector3(-0.005809, 0.859552, 0.511016)));
      final normal_2_103 = mesh_2.normals.elementAt(103);
      expect(normal_2_103, vector3MoreOrLessEquals(Vector3(-0.350571, 0.931431, -0.097655)));
      final normal_2_104 = mesh_2.normals.elementAt(104);
      expect(normal_2_104, vector3MoreOrLessEquals(Vector3(-0.811725, 0.388839, 0.435782)));
      final normal_2_105 = mesh_2.normals.elementAt(105);
      expect(normal_2_105, vector3MoreOrLessEquals(Vector3(-0.005809, 0.859552, 0.511016)));
      final normal_2_106 = mesh_2.normals.elementAt(106);
      expect(normal_2_106, vector3MoreOrLessEquals(Vector3(-0.811725, 0.388839, 0.435782)));
      final normal_2_107 = mesh_2.normals.elementAt(107);
      expect(normal_2_107, vector3MoreOrLessEquals(Vector3(-0.662377, 0.297013, 0.68778)));
      final normal_2_108 = mesh_2.normals.elementAt(108);
      expect(normal_2_108, vector3MoreOrLessEquals(Vector3(-0.350571, 0.931431, -0.097655)));
      final normal_2_109 = mesh_2.normals.elementAt(109);
      expect(normal_2_109, vector3MoreOrLessEquals(Vector3(-0.647693, 0.664816, -0.372173)));
      final normal_2_110 = mesh_2.normals.elementAt(110);
      expect(normal_2_110, vector3MoreOrLessEquals(Vector3(-0.811725, 0.388839, 0.435782)));
      final normal_2_111 = mesh_2.normals.elementAt(111);
      expect(normal_2_111, vector3MoreOrLessEquals(Vector3(-0.647693, 0.664816, -0.372173)));
      final normal_2_112 = mesh_2.normals.elementAt(112);
      expect(normal_2_112, vector3MoreOrLessEquals(Vector3(-0.950899, 0.243388, 0.19119)));
      final normal_2_113 = mesh_2.normals.elementAt(113);
      expect(normal_2_113, vector3MoreOrLessEquals(Vector3(-0.811725, 0.388839, 0.435782)));
      final normal_2_114 = mesh_2.normals.elementAt(114);
      expect(normal_2_114, vector3MoreOrLessEquals(Vector3(-0.647693, 0.664816, -0.372173)));
      final normal_2_115 = mesh_2.normals.elementAt(115);
      expect(normal_2_115, vector3MoreOrLessEquals(Vector3(-0.898309, 0.404808, -0.170794)));
      final normal_2_116 = mesh_2.normals.elementAt(116);
      expect(normal_2_116, vector3MoreOrLessEquals(Vector3(-0.846773, 0.078043, 0.526199)));
      final normal_2_117 = mesh_2.normals.elementAt(117);
      expect(normal_2_117, vector3MoreOrLessEquals(Vector3(-0.647693, 0.664816, -0.372173)));
      final normal_2_118 = mesh_2.normals.elementAt(118);
      expect(normal_2_118, vector3MoreOrLessEquals(Vector3(-0.846773, 0.078043, 0.526199)));
      final normal_2_119 = mesh_2.normals.elementAt(119);
      expect(normal_2_119, vector3MoreOrLessEquals(Vector3(-0.950899, 0.243388, 0.19119)));
      final normal_2_120 = mesh_2.normals.elementAt(120);
      expect(normal_2_120, vector3MoreOrLessEquals(Vector3(-0.898309, 0.404808, -0.170794)));
      final normal_2_121 = mesh_2.normals.elementAt(121);
      expect(normal_2_121, vector3MoreOrLessEquals(Vector3(-0.866249, 0.480043, -0.138459)));
      final normal_2_122 = mesh_2.normals.elementAt(122);
      expect(normal_2_122, vector3MoreOrLessEquals(Vector3(-0.846773, 0.078043, 0.526199)));
      final normal_2_123 = mesh_2.normals.elementAt(123);
      expect(normal_2_123, vector3MoreOrLessEquals(Vector3(-0.866249, 0.480043, -0.138459)));
      final normal_2_124 = mesh_2.normals.elementAt(124);
      expect(normal_2_124, vector3MoreOrLessEquals(Vector3(-0.759416, 0.14095, 0.635154)));
      final normal_2_125 = mesh_2.normals.elementAt(125);
      expect(normal_2_125, vector3MoreOrLessEquals(Vector3(-0.846773, 0.078043, 0.526199)));
      final normal_2_126 = mesh_2.normals.elementAt(126);
      expect(normal_2_126, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_127 = mesh_2.normals.elementAt(127);
      expect(normal_2_127, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_128 = mesh_2.normals.elementAt(128);
      expect(normal_2_128, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_129 = mesh_2.normals.elementAt(129);
      expect(normal_2_129, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_130 = mesh_2.normals.elementAt(130);
      expect(normal_2_130, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_131 = mesh_2.normals.elementAt(131);
      expect(normal_2_131, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_132 = mesh_2.normals.elementAt(132);
      expect(normal_2_132, vector3MoreOrLessEquals(Vector3(-0.866625, 0.34177, 0.36353)));
      final normal_2_133 = mesh_2.normals.elementAt(133);
      expect(normal_2_133, vector3MoreOrLessEquals(Vector3(-0.715121, 0.36025, 0.599018)));
      final normal_2_134 = mesh_2.normals.elementAt(134);
      expect(normal_2_134, vector3MoreOrLessEquals(Vector3(-0.940011, -0.340515, -0.020693)));
      final normal_2_135 = mesh_2.normals.elementAt(135);
      expect(normal_2_135, vector3MoreOrLessEquals(Vector3(-0.715121, 0.36025, 0.599018)));
      final normal_2_136 = mesh_2.normals.elementAt(136);
      expect(normal_2_136, vector3MoreOrLessEquals(Vector3(-0.9724, -0.204991, 0.11143)));
      final normal_2_137 = mesh_2.normals.elementAt(137);
      expect(normal_2_137, vector3MoreOrLessEquals(Vector3(-0.940011, -0.340515, -0.020693)));
      final normal_2_138 = mesh_2.normals.elementAt(138);
      expect(normal_2_138, vector3MoreOrLessEquals(Vector3(-0.715121, 0.36025, 0.599018)));
      final normal_2_139 = mesh_2.normals.elementAt(139);
      expect(normal_2_139, vector3MoreOrLessEquals(Vector3(-0.662377, 0.297013, 0.68778)));
      final normal_2_140 = mesh_2.normals.elementAt(140);
      expect(normal_2_140, vector3MoreOrLessEquals(Vector3(-0.81703, -0.331766, 0.471585)));
      final normal_2_141 = mesh_2.normals.elementAt(141);
      expect(normal_2_141, vector3MoreOrLessEquals(Vector3(-0.715121, 0.36025, 0.599018)));
      final normal_2_142 = mesh_2.normals.elementAt(142);
      expect(normal_2_142, vector3MoreOrLessEquals(Vector3(-0.81703, -0.331766, 0.471585)));
      final normal_2_143 = mesh_2.normals.elementAt(143);
      expect(normal_2_143, vector3MoreOrLessEquals(Vector3(-0.9724, -0.204991, 0.11143)));
      final normal_2_144 = mesh_2.normals.elementAt(144);
      expect(normal_2_144, vector3MoreOrLessEquals(Vector3(-0.662377, 0.297013, 0.68778)));
      final normal_2_145 = mesh_2.normals.elementAt(145);
      expect(normal_2_145, vector3MoreOrLessEquals(Vector3(-0.811725, 0.388839, 0.435782)));
      final normal_2_146 = mesh_2.normals.elementAt(146);
      expect(normal_2_146, vector3MoreOrLessEquals(Vector3(-0.81703, -0.331766, 0.471585)));
      final normal_2_147 = mesh_2.normals.elementAt(147);
      expect(normal_2_147, vector3MoreOrLessEquals(Vector3(-0.811725, 0.388839, 0.435782)));
      final normal_2_148 = mesh_2.normals.elementAt(148);
      expect(normal_2_148, vector3MoreOrLessEquals(Vector3(-0.6167, -0.385898, 0.686122)));
      final normal_2_149 = mesh_2.normals.elementAt(149);
      expect(normal_2_149, vector3MoreOrLessEquals(Vector3(-0.81703, -0.331766, 0.471585)));
      final normal_2_150 = mesh_2.normals.elementAt(150);
      expect(normal_2_150, vector3MoreOrLessEquals(Vector3(-0.811725, 0.388839, 0.435782)));
      final normal_2_151 = mesh_2.normals.elementAt(151);
      expect(normal_2_151, vector3MoreOrLessEquals(Vector3(-0.950899, 0.243388, 0.19119)));
      final normal_2_152 = mesh_2.normals.elementAt(152);
      expect(normal_2_152, vector3MoreOrLessEquals(Vector3(-0.565415, -0.413211, 0.713837)));
      final normal_2_153 = mesh_2.normals.elementAt(153);
      expect(normal_2_153, vector3MoreOrLessEquals(Vector3(-0.811725, 0.388839, 0.435782)));
      final normal_2_154 = mesh_2.normals.elementAt(154);
      expect(normal_2_154, vector3MoreOrLessEquals(Vector3(-0.565415, -0.413211, 0.713837)));
      final normal_2_155 = mesh_2.normals.elementAt(155);
      expect(normal_2_155, vector3MoreOrLessEquals(Vector3(-0.6167, -0.385898, 0.686122)));
      final normal_2_156 = mesh_2.normals.elementAt(156);
      expect(normal_2_156, vector3MoreOrLessEquals(Vector3(-0.950899, 0.243388, 0.19119)));
      final normal_2_157 = mesh_2.normals.elementAt(157);
      expect(normal_2_157, vector3MoreOrLessEquals(Vector3(-0.846773, 0.078043, 0.526199)));
      final normal_2_158 = mesh_2.normals.elementAt(158);
      expect(normal_2_158, vector3MoreOrLessEquals(Vector3(-0.565415, -0.413211, 0.713837)));
      final normal_2_159 = mesh_2.normals.elementAt(159);
      expect(normal_2_159, vector3MoreOrLessEquals(Vector3(-0.846773, 0.078043, 0.526199)));
      final normal_2_160 = mesh_2.normals.elementAt(160);
      expect(normal_2_160, vector3MoreOrLessEquals(Vector3(-0.342437, -0.316577, 0.884599)));
      final normal_2_161 = mesh_2.normals.elementAt(161);
      expect(normal_2_161, vector3MoreOrLessEquals(Vector3(-0.565415, -0.413211, 0.713837)));
      final normal_2_162 = mesh_2.normals.elementAt(162);
      expect(normal_2_162, vector3MoreOrLessEquals(Vector3(-0.846773, 0.078043, 0.526199)));
      final normal_2_163 = mesh_2.normals.elementAt(163);
      expect(normal_2_163, vector3MoreOrLessEquals(Vector3(-0.759416, 0.14095, 0.635154)));
      final normal_2_164 = mesh_2.normals.elementAt(164);
      expect(normal_2_164, vector3MoreOrLessEquals(Vector3(-0.263317, -0.310224, 0.913469)));
      final normal_2_165 = mesh_2.normals.elementAt(165);
      expect(normal_2_165, vector3MoreOrLessEquals(Vector3(-0.846773, 0.078043, 0.526199)));
      final normal_2_166 = mesh_2.normals.elementAt(166);
      expect(normal_2_166, vector3MoreOrLessEquals(Vector3(-0.263317, -0.310224, 0.913469)));
      final normal_2_167 = mesh_2.normals.elementAt(167);
      expect(normal_2_167, vector3MoreOrLessEquals(Vector3(-0.342437, -0.316577, 0.884599)));
      final normal_2_168 = mesh_2.normals.elementAt(168);
      expect(normal_2_168, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_169 = mesh_2.normals.elementAt(169);
      expect(normal_2_169, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_170 = mesh_2.normals.elementAt(170);
      expect(normal_2_170, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_171 = mesh_2.normals.elementAt(171);
      expect(normal_2_171, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_172 = mesh_2.normals.elementAt(172);
      expect(normal_2_172, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_173 = mesh_2.normals.elementAt(173);
      expect(normal_2_173, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_174 = mesh_2.normals.elementAt(174);
      expect(normal_2_174, vector3MoreOrLessEquals(Vector3(-0.940011, -0.340515, -0.020693)));
      final normal_2_175 = mesh_2.normals.elementAt(175);
      expect(normal_2_175, vector3MoreOrLessEquals(Vector3(-0.9724, -0.204991, 0.11143)));
      final normal_2_176 = mesh_2.normals.elementAt(176);
      expect(normal_2_176, vector3MoreOrLessEquals(Vector3(-0.492073, -0.67728, -0.546952)));
      final normal_2_177 = mesh_2.normals.elementAt(177);
      expect(normal_2_177, vector3MoreOrLessEquals(Vector3(-0.940011, -0.340515, -0.020693)));
      final normal_2_178 = mesh_2.normals.elementAt(178);
      expect(normal_2_178, vector3MoreOrLessEquals(Vector3(-0.492073, -0.67728, -0.546952)));
      final normal_2_179 = mesh_2.normals.elementAt(179);
      expect(normal_2_179, vector3MoreOrLessEquals(Vector3(-0.216535, -0.832588, -0.509814)));
      final normal_2_180 = mesh_2.normals.elementAt(180);
      expect(normal_2_180, vector3MoreOrLessEquals(Vector3(-0.9724, -0.204991, 0.11143)));
      final normal_2_181 = mesh_2.normals.elementAt(181);
      expect(normal_2_181, vector3MoreOrLessEquals(Vector3(-0.81703, -0.331766, 0.471585)));
      final normal_2_182 = mesh_2.normals.elementAt(182);
      expect(normal_2_182, vector3MoreOrLessEquals(Vector3(-0.492073, -0.67728, -0.546952)));
      final normal_2_183 = mesh_2.normals.elementAt(183);
      expect(normal_2_183, vector3MoreOrLessEquals(Vector3(-0.81703, -0.331766, 0.471585)));
      final normal_2_184 = mesh_2.normals.elementAt(184);
      expect(normal_2_184, vector3MoreOrLessEquals(Vector3(-0.336313, -0.936688, -0.09751)));
      final normal_2_185 = mesh_2.normals.elementAt(185);
      expect(normal_2_185, vector3MoreOrLessEquals(Vector3(-0.492073, -0.67728, -0.546952)));
      final normal_2_186 = mesh_2.normals.elementAt(186);
      expect(normal_2_186, vector3MoreOrLessEquals(Vector3(-0.81703, -0.331766, 0.471585)));
      final normal_2_187 = mesh_2.normals.elementAt(187);
      expect(normal_2_187, vector3MoreOrLessEquals(Vector3(-0.6167, -0.385898, 0.686122)));
      final normal_2_188 = mesh_2.normals.elementAt(188);
      expect(normal_2_188, vector3MoreOrLessEquals(Vector3(0.085084, -0.882948, 0.461697)));
      final normal_2_189 = mesh_2.normals.elementAt(189);
      expect(normal_2_189, vector3MoreOrLessEquals(Vector3(-0.81703, -0.331766, 0.471585)));
      final normal_2_190 = mesh_2.normals.elementAt(190);
      expect(normal_2_190, vector3MoreOrLessEquals(Vector3(0.085084, -0.882948, 0.461697)));
      final normal_2_191 = mesh_2.normals.elementAt(191);
      expect(normal_2_191, vector3MoreOrLessEquals(Vector3(-0.336313, -0.936688, -0.09751)));
      final normal_2_192 = mesh_2.normals.elementAt(192);
      expect(normal_2_192, vector3MoreOrLessEquals(Vector3(-0.6167, -0.385898, 0.686122)));
      final normal_2_193 = mesh_2.normals.elementAt(193);
      expect(normal_2_193, vector3MoreOrLessEquals(Vector3(-0.565415, -0.413211, 0.713837)));
      final normal_2_194 = mesh_2.normals.elementAt(194);
      expect(normal_2_194, vector3MoreOrLessEquals(Vector3(0.085084, -0.882948, 0.461697)));
      final normal_2_195 = mesh_2.normals.elementAt(195);
      expect(normal_2_195, vector3MoreOrLessEquals(Vector3(-0.565415, -0.413211, 0.713837)));
      final normal_2_196 = mesh_2.normals.elementAt(196);
      expect(normal_2_196, vector3MoreOrLessEquals(Vector3(0.196057, -0.733951, 0.650291)));
      final normal_2_197 = mesh_2.normals.elementAt(197);
      expect(normal_2_197, vector3MoreOrLessEquals(Vector3(0.085084, -0.882948, 0.461697)));
      final normal_2_198 = mesh_2.normals.elementAt(198);
      expect(normal_2_198, vector3MoreOrLessEquals(Vector3(-0.565415, -0.413211, 0.713837)));
      final normal_2_199 = mesh_2.normals.elementAt(199);
      expect(normal_2_199, vector3MoreOrLessEquals(Vector3(-0.342437, -0.316577, 0.884599)));
      final normal_2_200 = mesh_2.normals.elementAt(200);
      expect(normal_2_200, vector3MoreOrLessEquals(Vector3(0.454815, -0.615703, 0.64347)));
      final normal_2_201 = mesh_2.normals.elementAt(201);
      expect(normal_2_201, vector3MoreOrLessEquals(Vector3(-0.565415, -0.413211, 0.713837)));
      final normal_2_202 = mesh_2.normals.elementAt(202);
      expect(normal_2_202, vector3MoreOrLessEquals(Vector3(0.454815, -0.615703, 0.64347)));
      final normal_2_203 = mesh_2.normals.elementAt(203);
      expect(normal_2_203, vector3MoreOrLessEquals(Vector3(0.196057, -0.733951, 0.650291)));
      final normal_2_204 = mesh_2.normals.elementAt(204);
      expect(normal_2_204, vector3MoreOrLessEquals(Vector3(-0.342437, -0.316577, 0.884599)));
      final normal_2_205 = mesh_2.normals.elementAt(205);
      expect(normal_2_205, vector3MoreOrLessEquals(Vector3(-0.263317, -0.310224, 0.913469)));
      final normal_2_206 = mesh_2.normals.elementAt(206);
      expect(normal_2_206, vector3MoreOrLessEquals(Vector3(0.454815, -0.615703, 0.64347)));
      final normal_2_207 = mesh_2.normals.elementAt(207);
      expect(normal_2_207, vector3MoreOrLessEquals(Vector3(-0.263317, -0.310224, 0.913469)));
      final normal_2_208 = mesh_2.normals.elementAt(208);
      expect(normal_2_208, vector3MoreOrLessEquals(Vector3(0.489338, -0.710824, 0.50525)));
      final normal_2_209 = mesh_2.normals.elementAt(209);
      expect(normal_2_209, vector3MoreOrLessEquals(Vector3(0.454815, -0.615703, 0.64347)));
      final normal_2_210 = mesh_2.normals.elementAt(210);
      expect(normal_2_210, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_211 = mesh_2.normals.elementAt(211);
      expect(normal_2_211, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_212 = mesh_2.normals.elementAt(212);
      expect(normal_2_212, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_213 = mesh_2.normals.elementAt(213);
      expect(normal_2_213, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_214 = mesh_2.normals.elementAt(214);
      expect(normal_2_214, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_215 = mesh_2.normals.elementAt(215);
      expect(normal_2_215, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_216 = mesh_2.normals.elementAt(216);
      expect(normal_2_216, vector3MoreOrLessEquals(Vector3(-0.216535, -0.832588, -0.509814)));
      final normal_2_217 = mesh_2.normals.elementAt(217);
      expect(normal_2_217, vector3MoreOrLessEquals(Vector3(-0.492073, -0.67728, -0.546952)));
      final normal_2_218 = mesh_2.normals.elementAt(218);
      expect(normal_2_218, vector3MoreOrLessEquals(Vector3(0.458185, -0.654603, -0.6013)));
      final normal_2_219 = mesh_2.normals.elementAt(219);
      expect(normal_2_219, vector3MoreOrLessEquals(Vector3(-0.492073, -0.67728, -0.546952)));
      final normal_2_220 = mesh_2.normals.elementAt(220);
      expect(normal_2_220, vector3MoreOrLessEquals(Vector3(0.273617, -0.575276, -0.770838)));
      final normal_2_221 = mesh_2.normals.elementAt(221);
      expect(normal_2_221, vector3MoreOrLessEquals(Vector3(0.458185, -0.654603, -0.6013)));
      final normal_2_222 = mesh_2.normals.elementAt(222);
      expect(normal_2_222, vector3MoreOrLessEquals(Vector3(-0.492073, -0.67728, -0.546952)));
      final normal_2_223 = mesh_2.normals.elementAt(223);
      expect(normal_2_223, vector3MoreOrLessEquals(Vector3(-0.336313, -0.936688, -0.09751)));
      final normal_2_224 = mesh_2.normals.elementAt(224);
      expect(normal_2_224, vector3MoreOrLessEquals(Vector3(0.557258, -0.641859, -0.526765)));
      final normal_2_225 = mesh_2.normals.elementAt(225);
      expect(normal_2_225, vector3MoreOrLessEquals(Vector3(-0.492073, -0.67728, -0.546952)));
      final normal_2_226 = mesh_2.normals.elementAt(226);
      expect(normal_2_226, vector3MoreOrLessEquals(Vector3(0.557258, -0.641859, -0.526765)));
      final normal_2_227 = mesh_2.normals.elementAt(227);
      expect(normal_2_227, vector3MoreOrLessEquals(Vector3(0.273617, -0.575276, -0.770838)));
      final normal_2_228 = mesh_2.normals.elementAt(228);
      expect(normal_2_228, vector3MoreOrLessEquals(Vector3(-0.336313, -0.936688, -0.09751)));
      final normal_2_229 = mesh_2.normals.elementAt(229);
      expect(normal_2_229, vector3MoreOrLessEquals(Vector3(0.085084, -0.882948, 0.461697)));
      final normal_2_230 = mesh_2.normals.elementAt(230);
      expect(normal_2_230, vector3MoreOrLessEquals(Vector3(0.557258, -0.641859, -0.526765)));
      final normal_2_231 = mesh_2.normals.elementAt(231);
      expect(normal_2_231, vector3MoreOrLessEquals(Vector3(0.085084, -0.882948, 0.461697)));
      final normal_2_232 = mesh_2.normals.elementAt(232);
      expect(normal_2_232, vector3MoreOrLessEquals(Vector3(0.770791, -0.636825, 0.018306)));
      final normal_2_233 = mesh_2.normals.elementAt(233);
      expect(normal_2_233, vector3MoreOrLessEquals(Vector3(0.557258, -0.641859, -0.526765)));
      final normal_2_234 = mesh_2.normals.elementAt(234);
      expect(normal_2_234, vector3MoreOrLessEquals(Vector3(0.085084, -0.882948, 0.461697)));
      final normal_2_235 = mesh_2.normals.elementAt(235);
      expect(normal_2_235, vector3MoreOrLessEquals(Vector3(0.196057, -0.733951, 0.650291)));
      final normal_2_236 = mesh_2.normals.elementAt(236);
      expect(normal_2_236, vector3MoreOrLessEquals(Vector3(0.873238, -0.487283, 0.00317)));
      final normal_2_237 = mesh_2.normals.elementAt(237);
      expect(normal_2_237, vector3MoreOrLessEquals(Vector3(0.085084, -0.882948, 0.461697)));
      final normal_2_238 = mesh_2.normals.elementAt(238);
      expect(normal_2_238, vector3MoreOrLessEquals(Vector3(0.873238, -0.487283, 0.00317)));
      final normal_2_239 = mesh_2.normals.elementAt(239);
      expect(normal_2_239, vector3MoreOrLessEquals(Vector3(0.770791, -0.636825, 0.018306)));
      final normal_2_240 = mesh_2.normals.elementAt(240);
      expect(normal_2_240, vector3MoreOrLessEquals(Vector3(0.196057, -0.733951, 0.650291)));
      final normal_2_241 = mesh_2.normals.elementAt(241);
      expect(normal_2_241, vector3MoreOrLessEquals(Vector3(0.454815, -0.615703, 0.64347)));
      final normal_2_242 = mesh_2.normals.elementAt(242);
      expect(normal_2_242, vector3MoreOrLessEquals(Vector3(0.873238, -0.487283, 0.00317)));
      final normal_2_243 = mesh_2.normals.elementAt(243);
      expect(normal_2_243, vector3MoreOrLessEquals(Vector3(0.454815, -0.615703, 0.64347)));
      final normal_2_244 = mesh_2.normals.elementAt(244);
      expect(normal_2_244, vector3MoreOrLessEquals(Vector3(0.87876, -0.285726, -0.382285)));
      final normal_2_245 = mesh_2.normals.elementAt(245);
      expect(normal_2_245, vector3MoreOrLessEquals(Vector3(0.873238, -0.487283, 0.00317)));
      final normal_2_246 = mesh_2.normals.elementAt(246);
      expect(normal_2_246, vector3MoreOrLessEquals(Vector3(0.454815, -0.615703, 0.64347)));
      final normal_2_247 = mesh_2.normals.elementAt(247);
      expect(normal_2_247, vector3MoreOrLessEquals(Vector3(0.489338, -0.710824, 0.50525)));
      final normal_2_248 = mesh_2.normals.elementAt(248);
      expect(normal_2_248, vector3MoreOrLessEquals(Vector3(0.775252, -0.453136, -0.44006)));
      final normal_2_249 = mesh_2.normals.elementAt(249);
      expect(normal_2_249, vector3MoreOrLessEquals(Vector3(0.454815, -0.615703, 0.64347)));
      final normal_2_250 = mesh_2.normals.elementAt(250);
      expect(normal_2_250, vector3MoreOrLessEquals(Vector3(0.775252, -0.453136, -0.44006)));
      final normal_2_251 = mesh_2.normals.elementAt(251);
      expect(normal_2_251, vector3MoreOrLessEquals(Vector3(0.87876, -0.285726, -0.382285)));
      final normal_2_252 = mesh_2.normals.elementAt(252);
      expect(normal_2_252, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_253 = mesh_2.normals.elementAt(253);
      expect(normal_2_253, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_254 = mesh_2.normals.elementAt(254);
      expect(normal_2_254, vector3MoreOrLessEquals(Vector3(0.021383, -0.916512, 0.399436)));
      final normal_2_255 = mesh_2.normals.elementAt(255);
      expect(normal_2_255, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_256 = mesh_2.normals.elementAt(256);
      expect(normal_2_256, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_257 = mesh_2.normals.elementAt(257);
      expect(normal_2_257, vector3MoreOrLessEquals(Vector3(-0.781862, -0.431561, -0.449942)));
      final normal_2_258 = mesh_2.normals.elementAt(258);
      expect(normal_2_258, vector3MoreOrLessEquals(Vector3(0.458185, -0.654603, -0.6013)));
      final normal_2_259 = mesh_2.normals.elementAt(259);
      expect(normal_2_259, vector3MoreOrLessEquals(Vector3(0.273617, -0.575276, -0.770838)));
      final normal_2_260 = mesh_2.normals.elementAt(260);
      expect(normal_2_260, vector3MoreOrLessEquals(Vector3(0.833901, -0.104561, -0.541919)));
      final normal_2_261 = mesh_2.normals.elementAt(261);
      expect(normal_2_261, vector3MoreOrLessEquals(Vector3(0.458185, -0.654603, -0.6013)));
      final normal_2_262 = mesh_2.normals.elementAt(262);
      expect(normal_2_262, vector3MoreOrLessEquals(Vector3(0.833901, -0.104561, -0.541919)));
      final normal_2_263 = mesh_2.normals.elementAt(263);
      expect(normal_2_263, vector3MoreOrLessEquals(Vector3(0.956336, 0.228461, -0.182283)));
      final normal_2_264 = mesh_2.normals.elementAt(264);
      expect(normal_2_264, vector3MoreOrLessEquals(Vector3(0.273617, -0.575276, -0.770838)));
      final normal_2_265 = mesh_2.normals.elementAt(265);
      expect(normal_2_265, vector3MoreOrLessEquals(Vector3(0.557258, -0.641859, -0.526765)));
      final normal_2_266 = mesh_2.normals.elementAt(266);
      expect(normal_2_266, vector3MoreOrLessEquals(Vector3(0.833901, -0.104561, -0.541919)));
      final normal_2_267 = mesh_2.normals.elementAt(267);
      expect(normal_2_267, vector3MoreOrLessEquals(Vector3(0.557258, -0.641859, -0.526765)));
      final normal_2_268 = mesh_2.normals.elementAt(268);
      expect(normal_2_268, vector3MoreOrLessEquals(Vector3(0.910925, 0.174919, -0.373656)));
      final normal_2_269 = mesh_2.normals.elementAt(269);
      expect(normal_2_269, vector3MoreOrLessEquals(Vector3(0.833901, -0.104561, -0.541919)));
      final normal_2_270 = mesh_2.normals.elementAt(270);
      expect(normal_2_270, vector3MoreOrLessEquals(Vector3(0.557258, -0.641859, -0.526765)));
      final normal_2_271 = mesh_2.normals.elementAt(271);
      expect(normal_2_271, vector3MoreOrLessEquals(Vector3(0.770791, -0.636825, 0.018306)));
      final normal_2_272 = mesh_2.normals.elementAt(272);
      expect(normal_2_272, vector3MoreOrLessEquals(Vector3(0.949258, -0.047485, -0.310893)));
      final normal_2_273 = mesh_2.normals.elementAt(273);
      expect(normal_2_273, vector3MoreOrLessEquals(Vector3(0.557258, -0.641859, -0.526765)));
      final normal_2_274 = mesh_2.normals.elementAt(274);
      expect(normal_2_274, vector3MoreOrLessEquals(Vector3(0.949258, -0.047485, -0.310893)));
      final normal_2_275 = mesh_2.normals.elementAt(275);
      expect(normal_2_275, vector3MoreOrLessEquals(Vector3(0.910925, 0.174919, -0.373656)));
      final normal_2_276 = mesh_2.normals.elementAt(276);
      expect(normal_2_276, vector3MoreOrLessEquals(Vector3(0.770791, -0.636825, 0.018306)));
      final normal_2_277 = mesh_2.normals.elementAt(277);
      expect(normal_2_277, vector3MoreOrLessEquals(Vector3(0.873238, -0.487283, 0.00317)));
      final normal_2_278 = mesh_2.normals.elementAt(278);
      expect(normal_2_278, vector3MoreOrLessEquals(Vector3(0.949258, -0.047485, -0.310893)));
      final normal_2_279 = mesh_2.normals.elementAt(279);
      expect(normal_2_279, vector3MoreOrLessEquals(Vector3(0.873238, -0.487283, 0.00317)));
      final normal_2_280 = mesh_2.normals.elementAt(280);
      expect(normal_2_280, vector3MoreOrLessEquals(Vector3(0.769156, 0.182669, -0.612398)));
      final normal_2_281 = mesh_2.normals.elementAt(281);
      expect(normal_2_281, vector3MoreOrLessEquals(Vector3(0.949258, -0.047485, -0.310893)));
      final normal_2_282 = mesh_2.normals.elementAt(282);
      expect(normal_2_282, vector3MoreOrLessEquals(Vector3(0.873238, -0.487283, 0.00317)));
      final normal_2_283 = mesh_2.normals.elementAt(283);
      expect(normal_2_283, vector3MoreOrLessEquals(Vector3(0.87876, -0.285726, -0.382285)));
      final normal_2_284 = mesh_2.normals.elementAt(284);
      expect(normal_2_284, vector3MoreOrLessEquals(Vector3(0.667603, 0.001959, -0.744515)));
      final normal_2_285 = mesh_2.normals.elementAt(285);
      expect(normal_2_285, vector3MoreOrLessEquals(Vector3(0.873238, -0.487283, 0.00317)));
      final normal_2_286 = mesh_2.normals.elementAt(286);
      expect(normal_2_286, vector3MoreOrLessEquals(Vector3(0.667603, 0.001959, -0.744515)));
      final normal_2_287 = mesh_2.normals.elementAt(287);
      expect(normal_2_287, vector3MoreOrLessEquals(Vector3(0.769156, 0.182669, -0.612398)));
      final normal_2_288 = mesh_2.normals.elementAt(288);
      expect(normal_2_288, vector3MoreOrLessEquals(Vector3(0.87876, -0.285726, -0.382285)));
      final normal_2_289 = mesh_2.normals.elementAt(289);
      expect(normal_2_289, vector3MoreOrLessEquals(Vector3(0.775252, -0.453136, -0.44006)));
      final normal_2_290 = mesh_2.normals.elementAt(290);
      expect(normal_2_290, vector3MoreOrLessEquals(Vector3(0.667603, 0.001959, -0.744515)));
      final normal_2_291 = mesh_2.normals.elementAt(291);
      expect(normal_2_291, vector3MoreOrLessEquals(Vector3(0.775252, -0.453136, -0.44006)));
      final normal_2_292 = mesh_2.normals.elementAt(292);
      expect(normal_2_292, vector3MoreOrLessEquals(Vector3(0.352774, 0.079499, -0.932325)));
      final normal_2_293 = mesh_2.normals.elementAt(293);
      expect(normal_2_293, vector3MoreOrLessEquals(Vector3(0.667603, 0.001959, -0.744515)));
      expect(mesh_2.tangents.length, isZero);
      expect(mesh_2.bitangents.length, isZero);
      expect(mesh_2.colors.length, isZero);
      expect(mesh_2.textureCoords.length, equals(1));
      final textureCoords_2_0 = mesh_2.textureCoords.elementAt(0);
      expect(textureCoords_2_0.length, equals(294));
      final textureCoord_2_0_0 = textureCoords_2_0.elementAt(0);
      expect(textureCoord_2_0_0, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_1 = textureCoords_2_0.elementAt(1);
      expect(textureCoord_2_0_1, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_2 = textureCoords_2_0.elementAt(2);
      expect(textureCoord_2_0_2, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_3 = textureCoords_2_0.elementAt(3);
      expect(textureCoord_2_0_3, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_4 = textureCoords_2_0.elementAt(4);
      expect(textureCoord_2_0_4, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_5 = textureCoords_2_0.elementAt(5);
      expect(textureCoord_2_0_5, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_6 = textureCoords_2_0.elementAt(6);
      expect(textureCoord_2_0_6, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_2_0_7 = textureCoords_2_0.elementAt(7);
      expect(textureCoord_2_0_7, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_2_0_8 = textureCoords_2_0.elementAt(8);
      expect(textureCoord_2_0_8, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_2_0_9 = textureCoords_2_0.elementAt(9);
      expect(textureCoord_2_0_9, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_2_0_10 = textureCoords_2_0.elementAt(10);
      expect(textureCoord_2_0_10, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_2_0_11 = textureCoords_2_0.elementAt(11);
      expect(textureCoord_2_0_11, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_2_0_12 = textureCoords_2_0.elementAt(12);
      expect(textureCoord_2_0_12, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_2_0_13 = textureCoords_2_0.elementAt(13);
      expect(textureCoord_2_0_13, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_2_0_14 = textureCoords_2_0.elementAt(14);
      expect(textureCoord_2_0_14, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_2_0_15 = textureCoords_2_0.elementAt(15);
      expect(textureCoord_2_0_15, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_2_0_16 = textureCoords_2_0.elementAt(16);
      expect(textureCoord_2_0_16, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_2_0_17 = textureCoords_2_0.elementAt(17);
      expect(textureCoord_2_0_17, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_2_0_18 = textureCoords_2_0.elementAt(18);
      expect(textureCoord_2_0_18, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_2_0_19 = textureCoords_2_0.elementAt(19);
      expect(textureCoord_2_0_19, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_2_0_20 = textureCoords_2_0.elementAt(20);
      expect(textureCoord_2_0_20, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_2_0_21 = textureCoords_2_0.elementAt(21);
      expect(textureCoord_2_0_21, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_2_0_22 = textureCoords_2_0.elementAt(22);
      expect(textureCoord_2_0_22, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_2_0_23 = textureCoords_2_0.elementAt(23);
      expect(textureCoord_2_0_23, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_2_0_24 = textureCoords_2_0.elementAt(24);
      expect(textureCoord_2_0_24, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_2_0_25 = textureCoords_2_0.elementAt(25);
      expect(textureCoord_2_0_25, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_2_0_26 = textureCoords_2_0.elementAt(26);
      expect(textureCoord_2_0_26, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_2_0_27 = textureCoords_2_0.elementAt(27);
      expect(textureCoord_2_0_27, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_2_0_28 = textureCoords_2_0.elementAt(28);
      expect(textureCoord_2_0_28, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_2_0_29 = textureCoords_2_0.elementAt(29);
      expect(textureCoord_2_0_29, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_2_0_30 = textureCoords_2_0.elementAt(30);
      expect(textureCoord_2_0_30, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_2_0_31 = textureCoords_2_0.elementAt(31);
      expect(textureCoord_2_0_31, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_2_0_32 = textureCoords_2_0.elementAt(32);
      expect(textureCoord_2_0_32, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_2_0_33 = textureCoords_2_0.elementAt(33);
      expect(textureCoord_2_0_33, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_2_0_34 = textureCoords_2_0.elementAt(34);
      expect(textureCoord_2_0_34, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_2_0_35 = textureCoords_2_0.elementAt(35);
      expect(textureCoord_2_0_35, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_2_0_36 = textureCoords_2_0.elementAt(36);
      expect(textureCoord_2_0_36, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_2_0_37 = textureCoords_2_0.elementAt(37);
      expect(textureCoord_2_0_37, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_38 = textureCoords_2_0.elementAt(38);
      expect(textureCoord_2_0_38, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_2_0_39 = textureCoords_2_0.elementAt(39);
      expect(textureCoord_2_0_39, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_40 = textureCoords_2_0.elementAt(40);
      expect(textureCoord_2_0_40, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_2_0_41 = textureCoords_2_0.elementAt(41);
      expect(textureCoord_2_0_41, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_2_0_42 = textureCoords_2_0.elementAt(42);
      expect(textureCoord_2_0_42, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_43 = textureCoords_2_0.elementAt(43);
      expect(textureCoord_2_0_43, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_44 = textureCoords_2_0.elementAt(44);
      expect(textureCoord_2_0_44, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_45 = textureCoords_2_0.elementAt(45);
      expect(textureCoord_2_0_45, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_46 = textureCoords_2_0.elementAt(46);
      expect(textureCoord_2_0_46, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_47 = textureCoords_2_0.elementAt(47);
      expect(textureCoord_2_0_47, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_48 = textureCoords_2_0.elementAt(48);
      expect(textureCoord_2_0_48, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_2_0_49 = textureCoords_2_0.elementAt(49);
      expect(textureCoord_2_0_49, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_2_0_50 = textureCoords_2_0.elementAt(50);
      expect(textureCoord_2_0_50, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_2_0_51 = textureCoords_2_0.elementAt(51);
      expect(textureCoord_2_0_51, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_2_0_52 = textureCoords_2_0.elementAt(52);
      expect(textureCoord_2_0_52, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_2_0_53 = textureCoords_2_0.elementAt(53);
      expect(textureCoord_2_0_53, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_2_0_54 = textureCoords_2_0.elementAt(54);
      expect(textureCoord_2_0_54, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_2_0_55 = textureCoords_2_0.elementAt(55);
      expect(textureCoord_2_0_55, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_2_0_56 = textureCoords_2_0.elementAt(56);
      expect(textureCoord_2_0_56, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_2_0_57 = textureCoords_2_0.elementAt(57);
      expect(textureCoord_2_0_57, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_2_0_58 = textureCoords_2_0.elementAt(58);
      expect(textureCoord_2_0_58, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_2_0_59 = textureCoords_2_0.elementAt(59);
      expect(textureCoord_2_0_59, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_2_0_60 = textureCoords_2_0.elementAt(60);
      expect(textureCoord_2_0_60, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_2_0_61 = textureCoords_2_0.elementAt(61);
      expect(textureCoord_2_0_61, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_2_0_62 = textureCoords_2_0.elementAt(62);
      expect(textureCoord_2_0_62, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_2_0_63 = textureCoords_2_0.elementAt(63);
      expect(textureCoord_2_0_63, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_2_0_64 = textureCoords_2_0.elementAt(64);
      expect(textureCoord_2_0_64, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_2_0_65 = textureCoords_2_0.elementAt(65);
      expect(textureCoord_2_0_65, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_2_0_66 = textureCoords_2_0.elementAt(66);
      expect(textureCoord_2_0_66, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_2_0_67 = textureCoords_2_0.elementAt(67);
      expect(textureCoord_2_0_67, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_2_0_68 = textureCoords_2_0.elementAt(68);
      expect(textureCoord_2_0_68, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_2_0_69 = textureCoords_2_0.elementAt(69);
      expect(textureCoord_2_0_69, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_2_0_70 = textureCoords_2_0.elementAt(70);
      expect(textureCoord_2_0_70, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_2_0_71 = textureCoords_2_0.elementAt(71);
      expect(textureCoord_2_0_71, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_2_0_72 = textureCoords_2_0.elementAt(72);
      expect(textureCoord_2_0_72, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_2_0_73 = textureCoords_2_0.elementAt(73);
      expect(textureCoord_2_0_73, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_2_0_74 = textureCoords_2_0.elementAt(74);
      expect(textureCoord_2_0_74, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_2_0_75 = textureCoords_2_0.elementAt(75);
      expect(textureCoord_2_0_75, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_2_0_76 = textureCoords_2_0.elementAt(76);
      expect(textureCoord_2_0_76, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_2_0_77 = textureCoords_2_0.elementAt(77);
      expect(textureCoord_2_0_77, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_2_0_78 = textureCoords_2_0.elementAt(78);
      expect(textureCoord_2_0_78, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_2_0_79 = textureCoords_2_0.elementAt(79);
      expect(textureCoord_2_0_79, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_2_0_80 = textureCoords_2_0.elementAt(80);
      expect(textureCoord_2_0_80, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_2_0_81 = textureCoords_2_0.elementAt(81);
      expect(textureCoord_2_0_81, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_2_0_82 = textureCoords_2_0.elementAt(82);
      expect(textureCoord_2_0_82, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_2_0_83 = textureCoords_2_0.elementAt(83);
      expect(textureCoord_2_0_83, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_2_0_84 = textureCoords_2_0.elementAt(84);
      expect(textureCoord_2_0_84, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_85 = textureCoords_2_0.elementAt(85);
      expect(textureCoord_2_0_85, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_86 = textureCoords_2_0.elementAt(86);
      expect(textureCoord_2_0_86, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_87 = textureCoords_2_0.elementAt(87);
      expect(textureCoord_2_0_87, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_88 = textureCoords_2_0.elementAt(88);
      expect(textureCoord_2_0_88, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_89 = textureCoords_2_0.elementAt(89);
      expect(textureCoord_2_0_89, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_90 = textureCoords_2_0.elementAt(90);
      expect(textureCoord_2_0_90, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_2_0_91 = textureCoords_2_0.elementAt(91);
      expect(textureCoord_2_0_91, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_2_0_92 = textureCoords_2_0.elementAt(92);
      expect(textureCoord_2_0_92, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_2_0_93 = textureCoords_2_0.elementAt(93);
      expect(textureCoord_2_0_93, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_2_0_94 = textureCoords_2_0.elementAt(94);
      expect(textureCoord_2_0_94, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_2_0_95 = textureCoords_2_0.elementAt(95);
      expect(textureCoord_2_0_95, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_2_0_96 = textureCoords_2_0.elementAt(96);
      expect(textureCoord_2_0_96, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_2_0_97 = textureCoords_2_0.elementAt(97);
      expect(textureCoord_2_0_97, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_2_0_98 = textureCoords_2_0.elementAt(98);
      expect(textureCoord_2_0_98, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_2_0_99 = textureCoords_2_0.elementAt(99);
      expect(textureCoord_2_0_99, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_2_0_100 = textureCoords_2_0.elementAt(100);
      expect(textureCoord_2_0_100, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_2_0_101 = textureCoords_2_0.elementAt(101);
      expect(textureCoord_2_0_101, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_2_0_102 = textureCoords_2_0.elementAt(102);
      expect(textureCoord_2_0_102, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_2_0_103 = textureCoords_2_0.elementAt(103);
      expect(textureCoord_2_0_103, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_2_0_104 = textureCoords_2_0.elementAt(104);
      expect(textureCoord_2_0_104, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_2_0_105 = textureCoords_2_0.elementAt(105);
      expect(textureCoord_2_0_105, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_2_0_106 = textureCoords_2_0.elementAt(106);
      expect(textureCoord_2_0_106, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_2_0_107 = textureCoords_2_0.elementAt(107);
      expect(textureCoord_2_0_107, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_2_0_108 = textureCoords_2_0.elementAt(108);
      expect(textureCoord_2_0_108, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_2_0_109 = textureCoords_2_0.elementAt(109);
      expect(textureCoord_2_0_109, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_2_0_110 = textureCoords_2_0.elementAt(110);
      expect(textureCoord_2_0_110, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_2_0_111 = textureCoords_2_0.elementAt(111);
      expect(textureCoord_2_0_111, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_2_0_112 = textureCoords_2_0.elementAt(112);
      expect(textureCoord_2_0_112, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_2_0_113 = textureCoords_2_0.elementAt(113);
      expect(textureCoord_2_0_113, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_2_0_114 = textureCoords_2_0.elementAt(114);
      expect(textureCoord_2_0_114, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_2_0_115 = textureCoords_2_0.elementAt(115);
      expect(textureCoord_2_0_115, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_2_0_116 = textureCoords_2_0.elementAt(116);
      expect(textureCoord_2_0_116, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_2_0_117 = textureCoords_2_0.elementAt(117);
      expect(textureCoord_2_0_117, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_2_0_118 = textureCoords_2_0.elementAt(118);
      expect(textureCoord_2_0_118, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_2_0_119 = textureCoords_2_0.elementAt(119);
      expect(textureCoord_2_0_119, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_2_0_120 = textureCoords_2_0.elementAt(120);
      expect(textureCoord_2_0_120, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_2_0_121 = textureCoords_2_0.elementAt(121);
      expect(textureCoord_2_0_121, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_2_0_122 = textureCoords_2_0.elementAt(122);
      expect(textureCoord_2_0_122, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_2_0_123 = textureCoords_2_0.elementAt(123);
      expect(textureCoord_2_0_123, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_2_0_124 = textureCoords_2_0.elementAt(124);
      expect(textureCoord_2_0_124, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_2_0_125 = textureCoords_2_0.elementAt(125);
      expect(textureCoord_2_0_125, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_2_0_126 = textureCoords_2_0.elementAt(126);
      expect(textureCoord_2_0_126, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_127 = textureCoords_2_0.elementAt(127);
      expect(textureCoord_2_0_127, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_128 = textureCoords_2_0.elementAt(128);
      expect(textureCoord_2_0_128, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_129 = textureCoords_2_0.elementAt(129);
      expect(textureCoord_2_0_129, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_130 = textureCoords_2_0.elementAt(130);
      expect(textureCoord_2_0_130, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_131 = textureCoords_2_0.elementAt(131);
      expect(textureCoord_2_0_131, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_132 = textureCoords_2_0.elementAt(132);
      expect(textureCoord_2_0_132, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_2_0_133 = textureCoords_2_0.elementAt(133);
      expect(textureCoord_2_0_133, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_2_0_134 = textureCoords_2_0.elementAt(134);
      expect(textureCoord_2_0_134, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_2_0_135 = textureCoords_2_0.elementAt(135);
      expect(textureCoord_2_0_135, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_2_0_136 = textureCoords_2_0.elementAt(136);
      expect(textureCoord_2_0_136, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_2_0_137 = textureCoords_2_0.elementAt(137);
      expect(textureCoord_2_0_137, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_2_0_138 = textureCoords_2_0.elementAt(138);
      expect(textureCoord_2_0_138, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_2_0_139 = textureCoords_2_0.elementAt(139);
      expect(textureCoord_2_0_139, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_2_0_140 = textureCoords_2_0.elementAt(140);
      expect(textureCoord_2_0_140, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_2_0_141 = textureCoords_2_0.elementAt(141);
      expect(textureCoord_2_0_141, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_2_0_142 = textureCoords_2_0.elementAt(142);
      expect(textureCoord_2_0_142, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_2_0_143 = textureCoords_2_0.elementAt(143);
      expect(textureCoord_2_0_143, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_2_0_144 = textureCoords_2_0.elementAt(144);
      expect(textureCoord_2_0_144, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_2_0_145 = textureCoords_2_0.elementAt(145);
      expect(textureCoord_2_0_145, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_2_0_146 = textureCoords_2_0.elementAt(146);
      expect(textureCoord_2_0_146, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_2_0_147 = textureCoords_2_0.elementAt(147);
      expect(textureCoord_2_0_147, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_2_0_148 = textureCoords_2_0.elementAt(148);
      expect(textureCoord_2_0_148, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_2_0_149 = textureCoords_2_0.elementAt(149);
      expect(textureCoord_2_0_149, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_2_0_150 = textureCoords_2_0.elementAt(150);
      expect(textureCoord_2_0_150, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_2_0_151 = textureCoords_2_0.elementAt(151);
      expect(textureCoord_2_0_151, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_2_0_152 = textureCoords_2_0.elementAt(152);
      expect(textureCoord_2_0_152, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_2_0_153 = textureCoords_2_0.elementAt(153);
      expect(textureCoord_2_0_153, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_2_0_154 = textureCoords_2_0.elementAt(154);
      expect(textureCoord_2_0_154, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_2_0_155 = textureCoords_2_0.elementAt(155);
      expect(textureCoord_2_0_155, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_2_0_156 = textureCoords_2_0.elementAt(156);
      expect(textureCoord_2_0_156, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_2_0_157 = textureCoords_2_0.elementAt(157);
      expect(textureCoord_2_0_157, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_2_0_158 = textureCoords_2_0.elementAt(158);
      expect(textureCoord_2_0_158, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_2_0_159 = textureCoords_2_0.elementAt(159);
      expect(textureCoord_2_0_159, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_2_0_160 = textureCoords_2_0.elementAt(160);
      expect(textureCoord_2_0_160, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_2_0_161 = textureCoords_2_0.elementAt(161);
      expect(textureCoord_2_0_161, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_2_0_162 = textureCoords_2_0.elementAt(162);
      expect(textureCoord_2_0_162, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_2_0_163 = textureCoords_2_0.elementAt(163);
      expect(textureCoord_2_0_163, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_2_0_164 = textureCoords_2_0.elementAt(164);
      expect(textureCoord_2_0_164, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_2_0_165 = textureCoords_2_0.elementAt(165);
      expect(textureCoord_2_0_165, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_2_0_166 = textureCoords_2_0.elementAt(166);
      expect(textureCoord_2_0_166, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_2_0_167 = textureCoords_2_0.elementAt(167);
      expect(textureCoord_2_0_167, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_2_0_168 = textureCoords_2_0.elementAt(168);
      expect(textureCoord_2_0_168, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_169 = textureCoords_2_0.elementAt(169);
      expect(textureCoord_2_0_169, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_170 = textureCoords_2_0.elementAt(170);
      expect(textureCoord_2_0_170, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_171 = textureCoords_2_0.elementAt(171);
      expect(textureCoord_2_0_171, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_172 = textureCoords_2_0.elementAt(172);
      expect(textureCoord_2_0_172, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_173 = textureCoords_2_0.elementAt(173);
      expect(textureCoord_2_0_173, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_174 = textureCoords_2_0.elementAt(174);
      expect(textureCoord_2_0_174, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_2_0_175 = textureCoords_2_0.elementAt(175);
      expect(textureCoord_2_0_175, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_2_0_176 = textureCoords_2_0.elementAt(176);
      expect(textureCoord_2_0_176, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_2_0_177 = textureCoords_2_0.elementAt(177);
      expect(textureCoord_2_0_177, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_2_0_178 = textureCoords_2_0.elementAt(178);
      expect(textureCoord_2_0_178, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_2_0_179 = textureCoords_2_0.elementAt(179);
      expect(textureCoord_2_0_179, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_2_0_180 = textureCoords_2_0.elementAt(180);
      expect(textureCoord_2_0_180, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_2_0_181 = textureCoords_2_0.elementAt(181);
      expect(textureCoord_2_0_181, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_2_0_182 = textureCoords_2_0.elementAt(182);
      expect(textureCoord_2_0_182, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_2_0_183 = textureCoords_2_0.elementAt(183);
      expect(textureCoord_2_0_183, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_2_0_184 = textureCoords_2_0.elementAt(184);
      expect(textureCoord_2_0_184, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_2_0_185 = textureCoords_2_0.elementAt(185);
      expect(textureCoord_2_0_185, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_2_0_186 = textureCoords_2_0.elementAt(186);
      expect(textureCoord_2_0_186, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_2_0_187 = textureCoords_2_0.elementAt(187);
      expect(textureCoord_2_0_187, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_2_0_188 = textureCoords_2_0.elementAt(188);
      expect(textureCoord_2_0_188, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_2_0_189 = textureCoords_2_0.elementAt(189);
      expect(textureCoord_2_0_189, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_2_0_190 = textureCoords_2_0.elementAt(190);
      expect(textureCoord_2_0_190, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_2_0_191 = textureCoords_2_0.elementAt(191);
      expect(textureCoord_2_0_191, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_2_0_192 = textureCoords_2_0.elementAt(192);
      expect(textureCoord_2_0_192, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_2_0_193 = textureCoords_2_0.elementAt(193);
      expect(textureCoord_2_0_193, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_2_0_194 = textureCoords_2_0.elementAt(194);
      expect(textureCoord_2_0_194, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_2_0_195 = textureCoords_2_0.elementAt(195);
      expect(textureCoord_2_0_195, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_2_0_196 = textureCoords_2_0.elementAt(196);
      expect(textureCoord_2_0_196, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_2_0_197 = textureCoords_2_0.elementAt(197);
      expect(textureCoord_2_0_197, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_2_0_198 = textureCoords_2_0.elementAt(198);
      expect(textureCoord_2_0_198, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_2_0_199 = textureCoords_2_0.elementAt(199);
      expect(textureCoord_2_0_199, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_2_0_200 = textureCoords_2_0.elementAt(200);
      expect(textureCoord_2_0_200, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_2_0_201 = textureCoords_2_0.elementAt(201);
      expect(textureCoord_2_0_201, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_2_0_202 = textureCoords_2_0.elementAt(202);
      expect(textureCoord_2_0_202, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_2_0_203 = textureCoords_2_0.elementAt(203);
      expect(textureCoord_2_0_203, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_2_0_204 = textureCoords_2_0.elementAt(204);
      expect(textureCoord_2_0_204, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_2_0_205 = textureCoords_2_0.elementAt(205);
      expect(textureCoord_2_0_205, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_2_0_206 = textureCoords_2_0.elementAt(206);
      expect(textureCoord_2_0_206, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_2_0_207 = textureCoords_2_0.elementAt(207);
      expect(textureCoord_2_0_207, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_2_0_208 = textureCoords_2_0.elementAt(208);
      expect(textureCoord_2_0_208, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_2_0_209 = textureCoords_2_0.elementAt(209);
      expect(textureCoord_2_0_209, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_2_0_210 = textureCoords_2_0.elementAt(210);
      expect(textureCoord_2_0_210, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_211 = textureCoords_2_0.elementAt(211);
      expect(textureCoord_2_0_211, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_212 = textureCoords_2_0.elementAt(212);
      expect(textureCoord_2_0_212, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_213 = textureCoords_2_0.elementAt(213);
      expect(textureCoord_2_0_213, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_214 = textureCoords_2_0.elementAt(214);
      expect(textureCoord_2_0_214, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_215 = textureCoords_2_0.elementAt(215);
      expect(textureCoord_2_0_215, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_216 = textureCoords_2_0.elementAt(216);
      expect(textureCoord_2_0_216, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_2_0_217 = textureCoords_2_0.elementAt(217);
      expect(textureCoord_2_0_217, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_2_0_218 = textureCoords_2_0.elementAt(218);
      expect(textureCoord_2_0_218, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_2_0_219 = textureCoords_2_0.elementAt(219);
      expect(textureCoord_2_0_219, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_2_0_220 = textureCoords_2_0.elementAt(220);
      expect(textureCoord_2_0_220, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_2_0_221 = textureCoords_2_0.elementAt(221);
      expect(textureCoord_2_0_221, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_2_0_222 = textureCoords_2_0.elementAt(222);
      expect(textureCoord_2_0_222, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_2_0_223 = textureCoords_2_0.elementAt(223);
      expect(textureCoord_2_0_223, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_2_0_224 = textureCoords_2_0.elementAt(224);
      expect(textureCoord_2_0_224, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_2_0_225 = textureCoords_2_0.elementAt(225);
      expect(textureCoord_2_0_225, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_2_0_226 = textureCoords_2_0.elementAt(226);
      expect(textureCoord_2_0_226, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_2_0_227 = textureCoords_2_0.elementAt(227);
      expect(textureCoord_2_0_227, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_2_0_228 = textureCoords_2_0.elementAt(228);
      expect(textureCoord_2_0_228, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_2_0_229 = textureCoords_2_0.elementAt(229);
      expect(textureCoord_2_0_229, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_2_0_230 = textureCoords_2_0.elementAt(230);
      expect(textureCoord_2_0_230, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_2_0_231 = textureCoords_2_0.elementAt(231);
      expect(textureCoord_2_0_231, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_2_0_232 = textureCoords_2_0.elementAt(232);
      expect(textureCoord_2_0_232, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_2_0_233 = textureCoords_2_0.elementAt(233);
      expect(textureCoord_2_0_233, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_2_0_234 = textureCoords_2_0.elementAt(234);
      expect(textureCoord_2_0_234, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_2_0_235 = textureCoords_2_0.elementAt(235);
      expect(textureCoord_2_0_235, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_2_0_236 = textureCoords_2_0.elementAt(236);
      expect(textureCoord_2_0_236, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_2_0_237 = textureCoords_2_0.elementAt(237);
      expect(textureCoord_2_0_237, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_2_0_238 = textureCoords_2_0.elementAt(238);
      expect(textureCoord_2_0_238, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_2_0_239 = textureCoords_2_0.elementAt(239);
      expect(textureCoord_2_0_239, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_2_0_240 = textureCoords_2_0.elementAt(240);
      expect(textureCoord_2_0_240, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_2_0_241 = textureCoords_2_0.elementAt(241);
      expect(textureCoord_2_0_241, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_2_0_242 = textureCoords_2_0.elementAt(242);
      expect(textureCoord_2_0_242, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_2_0_243 = textureCoords_2_0.elementAt(243);
      expect(textureCoord_2_0_243, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_2_0_244 = textureCoords_2_0.elementAt(244);
      expect(textureCoord_2_0_244, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_2_0_245 = textureCoords_2_0.elementAt(245);
      expect(textureCoord_2_0_245, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_2_0_246 = textureCoords_2_0.elementAt(246);
      expect(textureCoord_2_0_246, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_2_0_247 = textureCoords_2_0.elementAt(247);
      expect(textureCoord_2_0_247, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_2_0_248 = textureCoords_2_0.elementAt(248);
      expect(textureCoord_2_0_248, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_2_0_249 = textureCoords_2_0.elementAt(249);
      expect(textureCoord_2_0_249, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_2_0_250 = textureCoords_2_0.elementAt(250);
      expect(textureCoord_2_0_250, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_2_0_251 = textureCoords_2_0.elementAt(251);
      expect(textureCoord_2_0_251, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_2_0_252 = textureCoords_2_0.elementAt(252);
      expect(textureCoord_2_0_252, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_253 = textureCoords_2_0.elementAt(253);
      expect(textureCoord_2_0_253, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_254 = textureCoords_2_0.elementAt(254);
      expect(textureCoord_2_0_254, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_255 = textureCoords_2_0.elementAt(255);
      expect(textureCoord_2_0_255, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_256 = textureCoords_2_0.elementAt(256);
      expect(textureCoord_2_0_256, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_257 = textureCoords_2_0.elementAt(257);
      expect(textureCoord_2_0_257, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_2_0_258 = textureCoords_2_0.elementAt(258);
      expect(textureCoord_2_0_258, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_2_0_259 = textureCoords_2_0.elementAt(259);
      expect(textureCoord_2_0_259, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_2_0_260 = textureCoords_2_0.elementAt(260);
      expect(textureCoord_2_0_260, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_2_0_261 = textureCoords_2_0.elementAt(261);
      expect(textureCoord_2_0_261, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_2_0_262 = textureCoords_2_0.elementAt(262);
      expect(textureCoord_2_0_262, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_2_0_263 = textureCoords_2_0.elementAt(263);
      expect(textureCoord_2_0_263, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_2_0_264 = textureCoords_2_0.elementAt(264);
      expect(textureCoord_2_0_264, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_2_0_265 = textureCoords_2_0.elementAt(265);
      expect(textureCoord_2_0_265, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_2_0_266 = textureCoords_2_0.elementAt(266);
      expect(textureCoord_2_0_266, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_2_0_267 = textureCoords_2_0.elementAt(267);
      expect(textureCoord_2_0_267, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_2_0_268 = textureCoords_2_0.elementAt(268);
      expect(textureCoord_2_0_268, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_2_0_269 = textureCoords_2_0.elementAt(269);
      expect(textureCoord_2_0_269, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_2_0_270 = textureCoords_2_0.elementAt(270);
      expect(textureCoord_2_0_270, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_2_0_271 = textureCoords_2_0.elementAt(271);
      expect(textureCoord_2_0_271, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_2_0_272 = textureCoords_2_0.elementAt(272);
      expect(textureCoord_2_0_272, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_2_0_273 = textureCoords_2_0.elementAt(273);
      expect(textureCoord_2_0_273, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_2_0_274 = textureCoords_2_0.elementAt(274);
      expect(textureCoord_2_0_274, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_2_0_275 = textureCoords_2_0.elementAt(275);
      expect(textureCoord_2_0_275, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_2_0_276 = textureCoords_2_0.elementAt(276);
      expect(textureCoord_2_0_276, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_2_0_277 = textureCoords_2_0.elementAt(277);
      expect(textureCoord_2_0_277, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_2_0_278 = textureCoords_2_0.elementAt(278);
      expect(textureCoord_2_0_278, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_2_0_279 = textureCoords_2_0.elementAt(279);
      expect(textureCoord_2_0_279, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_2_0_280 = textureCoords_2_0.elementAt(280);
      expect(textureCoord_2_0_280, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_2_0_281 = textureCoords_2_0.elementAt(281);
      expect(textureCoord_2_0_281, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_2_0_282 = textureCoords_2_0.elementAt(282);
      expect(textureCoord_2_0_282, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_2_0_283 = textureCoords_2_0.elementAt(283);
      expect(textureCoord_2_0_283, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_2_0_284 = textureCoords_2_0.elementAt(284);
      expect(textureCoord_2_0_284, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_2_0_285 = textureCoords_2_0.elementAt(285);
      expect(textureCoord_2_0_285, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_2_0_286 = textureCoords_2_0.elementAt(286);
      expect(textureCoord_2_0_286, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_2_0_287 = textureCoords_2_0.elementAt(287);
      expect(textureCoord_2_0_287, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_2_0_288 = textureCoords_2_0.elementAt(288);
      expect(textureCoord_2_0_288, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_2_0_289 = textureCoords_2_0.elementAt(289);
      expect(textureCoord_2_0_289, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_2_0_290 = textureCoords_2_0.elementAt(290);
      expect(textureCoord_2_0_290, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_2_0_291 = textureCoords_2_0.elementAt(291);
      expect(textureCoord_2_0_291, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_2_0_292 = textureCoords_2_0.elementAt(292);
      expect(textureCoord_2_0_292, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_2_0_293 = textureCoords_2_0.elementAt(293);
      expect(textureCoord_2_0_293, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      expect(mesh_2.uvComponents.length, equals(1));
      expect(mesh_2.uvComponents, equals([2]));
      expect(mesh_2.faces.length, equals(98));
      expect(mesh_2.bones.length, isZero);
      expect(mesh_2.materialIndex, equals(4));
      expect(mesh_2.name, equals('Bein1Li'));
      expect(mesh_2.animMeshes.length, isZero);
      expect(mesh_2.morphingMethod, isZero);
      expect(mesh_2.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_3 = meshes.elementAt(3);
      expect(mesh_3.primitiveTypes, equals(4));
      expect(mesh_3.vertices.length, equals(294));
      final vertex_3_0 = mesh_3.vertices.elementAt(0);
      expect(vertex_3_0, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_1 = mesh_3.vertices.elementAt(1);
      expect(vertex_3_1, vector3MoreOrLessEquals(Vector3(-42.838, -1.82275, -1.17338)));
      final vertex_3_2 = mesh_3.vertices.elementAt(2);
      expect(vertex_3_2, vector3MoreOrLessEquals(Vector3(-41.9601, -3.15467, 1.81762)));
      final vertex_3_3 = mesh_3.vertices.elementAt(3);
      expect(vertex_3_3, vector3MoreOrLessEquals(Vector3(-92.2904, -39.2116, 57.3825)));
      final vertex_3_4 = mesh_3.vertices.elementAt(4);
      expect(vertex_3_4, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_5 = mesh_3.vertices.elementAt(5);
      expect(vertex_3_5, vector3MoreOrLessEquals(Vector3(-91.9595, -39.7327, 57.5408)));
      final vertex_3_6 = mesh_3.vertices.elementAt(6);
      expect(vertex_3_6, vector3MoreOrLessEquals(Vector3(-49.3681, 8.47676, 19.0859)));
      final vertex_3_7 = mesh_3.vertices.elementAt(7);
      expect(vertex_3_7, vector3MoreOrLessEquals(Vector3(-49.1963, 7.80456, 21.2935)));
      final vertex_3_8 = mesh_3.vertices.elementAt(8);
      expect(vertex_3_8, vector3MoreOrLessEquals(Vector3(-41.9601, -3.15467, 1.81762)));
      final vertex_3_9 = mesh_3.vertices.elementAt(9);
      expect(vertex_3_9, vector3MoreOrLessEquals(Vector3(-42.838, -1.82275, -1.17338)));
      final vertex_3_10 = mesh_3.vertices.elementAt(10);
      expect(vertex_3_10, vector3MoreOrLessEquals(Vector3(-49.3681, 8.47676, 19.0859)));
      final vertex_3_11 = mesh_3.vertices.elementAt(11);
      expect(vertex_3_11, vector3MoreOrLessEquals(Vector3(-41.9601, -3.15467, 1.81762)));
      final vertex_3_12 = mesh_3.vertices.elementAt(12);
      expect(vertex_3_12, vector3MoreOrLessEquals(Vector3(-49.3681, 8.47676, 19.0859)));
      final vertex_3_13 = mesh_3.vertices.elementAt(13);
      expect(vertex_3_13, vector3MoreOrLessEquals(Vector3(-54.2547, 27.2729, 30.4489)));
      final vertex_3_14 = mesh_3.vertices.elementAt(14);
      expect(vertex_3_14, vector3MoreOrLessEquals(Vector3(-49.1963, 7.80456, 21.2935)));
      final vertex_3_15 = mesh_3.vertices.elementAt(15);
      expect(vertex_3_15, vector3MoreOrLessEquals(Vector3(-49.3681, 8.47676, 19.0859)));
      final vertex_3_16 = mesh_3.vertices.elementAt(16);
      expect(vertex_3_16, vector3MoreOrLessEquals(Vector3(-54.9258, 28.3424, 29.3661)));
      final vertex_3_17 = mesh_3.vertices.elementAt(17);
      expect(vertex_3_17, vector3MoreOrLessEquals(Vector3(-54.2547, 27.2729, 30.4489)));
      final vertex_3_18 = mesh_3.vertices.elementAt(18);
      expect(vertex_3_18, vector3MoreOrLessEquals(Vector3(-57.455, 28.7062, 33.8355)));
      final vertex_3_19 = mesh_3.vertices.elementAt(19);
      expect(vertex_3_19, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_20 = mesh_3.vertices.elementAt(20);
      expect(vertex_3_20, vector3MoreOrLessEquals(Vector3(-54.2547, 27.2729, 30.4489)));
      final vertex_3_21 = mesh_3.vertices.elementAt(21);
      expect(vertex_3_21, vector3MoreOrLessEquals(Vector3(-54.9258, 28.3424, 29.3661)));
      final vertex_3_22 = mesh_3.vertices.elementAt(22);
      expect(vertex_3_22, vector3MoreOrLessEquals(Vector3(-57.455, 28.7062, 33.8355)));
      final vertex_3_23 = mesh_3.vertices.elementAt(23);
      expect(vertex_3_23, vector3MoreOrLessEquals(Vector3(-54.2547, 27.2729, 30.4489)));
      final vertex_3_24 = mesh_3.vertices.elementAt(24);
      expect(vertex_3_24, vector3MoreOrLessEquals(Vector3(-57.455, 28.7062, 33.8355)));
      final vertex_3_25 = mesh_3.vertices.elementAt(25);
      expect(vertex_3_25, vector3MoreOrLessEquals(Vector3(-67.4683, 9.10906, 43.4964)));
      final vertex_3_26 = mesh_3.vertices.elementAt(26);
      expect(vertex_3_26, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_27 = mesh_3.vertices.elementAt(27);
      expect(vertex_3_27, vector3MoreOrLessEquals(Vector3(-57.455, 28.7062, 33.8355)));
      final vertex_3_28 = mesh_3.vertices.elementAt(28);
      expect(vertex_3_28, vector3MoreOrLessEquals(Vector3(-69.612, 9.45497, 44.2965)));
      final vertex_3_29 = mesh_3.vertices.elementAt(29);
      expect(vertex_3_29, vector3MoreOrLessEquals(Vector3(-67.4683, 9.10906, 43.4964)));
      final vertex_3_30 = mesh_3.vertices.elementAt(30);
      expect(vertex_3_30, vector3MoreOrLessEquals(Vector3(-87.0142, -30.5141, 52.422)));
      final vertex_3_31 = mesh_3.vertices.elementAt(31);
      expect(vertex_3_31, vector3MoreOrLessEquals(Vector3(-85.9715, -32.0747, 52.6385)));
      final vertex_3_32 = mesh_3.vertices.elementAt(32);
      expect(vertex_3_32, vector3MoreOrLessEquals(Vector3(-67.4683, 9.10906, 43.4964)));
      final vertex_3_33 = mesh_3.vertices.elementAt(33);
      expect(vertex_3_33, vector3MoreOrLessEquals(Vector3(-69.612, 9.45497, 44.2965)));
      final vertex_3_34 = mesh_3.vertices.elementAt(34);
      expect(vertex_3_34, vector3MoreOrLessEquals(Vector3(-87.0142, -30.5141, 52.422)));
      final vertex_3_35 = mesh_3.vertices.elementAt(35);
      expect(vertex_3_35, vector3MoreOrLessEquals(Vector3(-67.4683, 9.10906, 43.4964)));
      final vertex_3_36 = mesh_3.vertices.elementAt(36);
      expect(vertex_3_36, vector3MoreOrLessEquals(Vector3(-87.0142, -30.5141, 52.422)));
      final vertex_3_37 = mesh_3.vertices.elementAt(37);
      expect(vertex_3_37, vector3MoreOrLessEquals(Vector3(-91.9595, -39.7327, 57.5408)));
      final vertex_3_38 = mesh_3.vertices.elementAt(38);
      expect(vertex_3_38, vector3MoreOrLessEquals(Vector3(-85.9715, -32.0747, 52.6385)));
      final vertex_3_39 = mesh_3.vertices.elementAt(39);
      expect(vertex_3_39, vector3MoreOrLessEquals(Vector3(-87.0142, -30.5141, 52.422)));
      final vertex_3_40 = mesh_3.vertices.elementAt(40);
      expect(vertex_3_40, vector3MoreOrLessEquals(Vector3(-92.2904, -39.2116, 57.3825)));
      final vertex_3_41 = mesh_3.vertices.elementAt(41);
      expect(vertex_3_41, vector3MoreOrLessEquals(Vector3(-91.9595, -39.7327, 57.5408)));
      final vertex_3_42 = mesh_3.vertices.elementAt(42);
      expect(vertex_3_42, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_43 = mesh_3.vertices.elementAt(43);
      expect(vertex_3_43, vector3MoreOrLessEquals(Vector3(-45.9887, -1.45013, -2.53574)));
      final vertex_3_44 = mesh_3.vertices.elementAt(44);
      expect(vertex_3_44, vector3MoreOrLessEquals(Vector3(-42.838, -1.82275, -1.17338)));
      final vertex_3_45 = mesh_3.vertices.elementAt(45);
      expect(vertex_3_45, vector3MoreOrLessEquals(Vector3(-92.6001, -39.1617, 56.9964)));
      final vertex_3_46 = mesh_3.vertices.elementAt(46);
      expect(vertex_3_46, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_47 = mesh_3.vertices.elementAt(47);
      expect(vertex_3_47, vector3MoreOrLessEquals(Vector3(-92.2904, -39.2116, 57.3825)));
      final vertex_3_48 = mesh_3.vertices.elementAt(48);
      expect(vertex_3_48, vector3MoreOrLessEquals(Vector3(-45.9887, -1.45013, -2.53574)));
      final vertex_3_49 = mesh_3.vertices.elementAt(49);
      expect(vertex_3_49, vector3MoreOrLessEquals(Vector3(-49.3681, 8.47676, 19.0859)));
      final vertex_3_50 = mesh_3.vertices.elementAt(50);
      expect(vertex_3_50, vector3MoreOrLessEquals(Vector3(-42.838, -1.82275, -1.17338)));
      final vertex_3_51 = mesh_3.vertices.elementAt(51);
      expect(vertex_3_51, vector3MoreOrLessEquals(Vector3(-45.9887, -1.45013, -2.53574)));
      final vertex_3_52 = mesh_3.vertices.elementAt(52);
      expect(vertex_3_52, vector3MoreOrLessEquals(Vector3(-50.885, 7.78515, 17.481)));
      final vertex_3_53 = mesh_3.vertices.elementAt(53);
      expect(vertex_3_53, vector3MoreOrLessEquals(Vector3(-49.3681, 8.47676, 19.0859)));
      final vertex_3_54 = mesh_3.vertices.elementAt(54);
      expect(vertex_3_54, vector3MoreOrLessEquals(Vector3(-55.9834, 28.0877, 28.4576)));
      final vertex_3_55 = mesh_3.vertices.elementAt(55);
      expect(vertex_3_55, vector3MoreOrLessEquals(Vector3(-54.9258, 28.3424, 29.3661)));
      final vertex_3_56 = mesh_3.vertices.elementAt(56);
      expect(vertex_3_56, vector3MoreOrLessEquals(Vector3(-49.3681, 8.47676, 19.0859)));
      final vertex_3_57 = mesh_3.vertices.elementAt(57);
      expect(vertex_3_57, vector3MoreOrLessEquals(Vector3(-50.885, 7.78515, 17.481)));
      final vertex_3_58 = mesh_3.vertices.elementAt(58);
      expect(vertex_3_58, vector3MoreOrLessEquals(Vector3(-55.9834, 28.0877, 28.4576)));
      final vertex_3_59 = mesh_3.vertices.elementAt(59);
      expect(vertex_3_59, vector3MoreOrLessEquals(Vector3(-49.3681, 8.47676, 19.0859)));
      final vertex_3_60 = mesh_3.vertices.elementAt(60);
      expect(vertex_3_60, vector3MoreOrLessEquals(Vector3(-55.9834, 28.0877, 28.4576)));
      final vertex_3_61 = mesh_3.vertices.elementAt(61);
      expect(vertex_3_61, vector3MoreOrLessEquals(Vector3(-57.455, 28.7062, 33.8355)));
      final vertex_3_62 = mesh_3.vertices.elementAt(62);
      expect(vertex_3_62, vector3MoreOrLessEquals(Vector3(-54.9258, 28.3424, 29.3661)));
      final vertex_3_63 = mesh_3.vertices.elementAt(63);
      expect(vertex_3_63, vector3MoreOrLessEquals(Vector3(-55.9834, 28.0877, 28.4576)));
      final vertex_3_64 = mesh_3.vertices.elementAt(64);
      expect(vertex_3_64, vector3MoreOrLessEquals(Vector3(-59.4156, 28.147, 32.741)));
      final vertex_3_65 = mesh_3.vertices.elementAt(65);
      expect(vertex_3_65, vector3MoreOrLessEquals(Vector3(-57.455, 28.7062, 33.8355)));
      final vertex_3_66 = mesh_3.vertices.elementAt(66);
      expect(vertex_3_66, vector3MoreOrLessEquals(Vector3(-71.6158, 8.68279, 43.4344)));
      final vertex_3_67 = mesh_3.vertices.elementAt(67);
      expect(vertex_3_67, vector3MoreOrLessEquals(Vector3(-69.612, 9.45497, 44.2965)));
      final vertex_3_68 = mesh_3.vertices.elementAt(68);
      expect(vertex_3_68, vector3MoreOrLessEquals(Vector3(-57.455, 28.7062, 33.8355)));
      final vertex_3_69 = mesh_3.vertices.elementAt(69);
      expect(vertex_3_69, vector3MoreOrLessEquals(Vector3(-59.4156, 28.147, 32.741)));
      final vertex_3_70 = mesh_3.vertices.elementAt(70);
      expect(vertex_3_70, vector3MoreOrLessEquals(Vector3(-71.6158, 8.68279, 43.4344)));
      final vertex_3_71 = mesh_3.vertices.elementAt(71);
      expect(vertex_3_71, vector3MoreOrLessEquals(Vector3(-57.455, 28.7062, 33.8355)));
      final vertex_3_72 = mesh_3.vertices.elementAt(72);
      expect(vertex_3_72, vector3MoreOrLessEquals(Vector3(-71.6158, 8.68279, 43.4344)));
      final vertex_3_73 = mesh_3.vertices.elementAt(73);
      expect(vertex_3_73, vector3MoreOrLessEquals(Vector3(-87.0142, -30.5141, 52.422)));
      final vertex_3_74 = mesh_3.vertices.elementAt(74);
      expect(vertex_3_74, vector3MoreOrLessEquals(Vector3(-69.612, 9.45497, 44.2965)));
      final vertex_3_75 = mesh_3.vertices.elementAt(75);
      expect(vertex_3_75, vector3MoreOrLessEquals(Vector3(-71.6158, 8.68279, 43.4344)));
      final vertex_3_76 = mesh_3.vertices.elementAt(76);
      expect(vertex_3_76, vector3MoreOrLessEquals(Vector3(-87.7561, -30.2962, 51.631)));
      final vertex_3_77 = mesh_3.vertices.elementAt(77);
      expect(vertex_3_77, vector3MoreOrLessEquals(Vector3(-87.0142, -30.5141, 52.422)));
      final vertex_3_78 = mesh_3.vertices.elementAt(78);
      expect(vertex_3_78, vector3MoreOrLessEquals(Vector3(-92.6001, -39.1617, 56.9964)));
      final vertex_3_79 = mesh_3.vertices.elementAt(79);
      expect(vertex_3_79, vector3MoreOrLessEquals(Vector3(-92.2904, -39.2116, 57.3825)));
      final vertex_3_80 = mesh_3.vertices.elementAt(80);
      expect(vertex_3_80, vector3MoreOrLessEquals(Vector3(-87.0142, -30.5141, 52.422)));
      final vertex_3_81 = mesh_3.vertices.elementAt(81);
      expect(vertex_3_81, vector3MoreOrLessEquals(Vector3(-87.7561, -30.2962, 51.631)));
      final vertex_3_82 = mesh_3.vertices.elementAt(82);
      expect(vertex_3_82, vector3MoreOrLessEquals(Vector3(-92.6001, -39.1617, 56.9964)));
      final vertex_3_83 = mesh_3.vertices.elementAt(83);
      expect(vertex_3_83, vector3MoreOrLessEquals(Vector3(-87.0142, -30.5141, 52.422)));
      final vertex_3_84 = mesh_3.vertices.elementAt(84);
      expect(vertex_3_84, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_85 = mesh_3.vertices.elementAt(85);
      expect(vertex_3_85, vector3MoreOrLessEquals(Vector3(-49.0396, -2.31741, -1.24353)));
      final vertex_3_86 = mesh_3.vertices.elementAt(86);
      expect(vertex_3_86, vector3MoreOrLessEquals(Vector3(-45.9887, -1.45013, -2.53574)));
      final vertex_3_87 = mesh_3.vertices.elementAt(87);
      expect(vertex_3_87, vector3MoreOrLessEquals(Vector3(-92.6552, -39.6206, 56.6732)));
      final vertex_3_88 = mesh_3.vertices.elementAt(88);
      expect(vertex_3_88, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_89 = mesh_3.vertices.elementAt(89);
      expect(vertex_3_89, vector3MoreOrLessEquals(Vector3(-92.6001, -39.1617, 56.9964)));
      final vertex_3_90 = mesh_3.vertices.elementAt(90);
      expect(vertex_3_90, vector3MoreOrLessEquals(Vector3(-52.6046, 6.25055, 17.6873)));
      final vertex_3_91 = mesh_3.vertices.elementAt(91);
      expect(vertex_3_91, vector3MoreOrLessEquals(Vector3(-50.885, 7.78515, 17.481)));
      final vertex_3_92 = mesh_3.vertices.elementAt(92);
      expect(vertex_3_92, vector3MoreOrLessEquals(Vector3(-45.9887, -1.45013, -2.53574)));
      final vertex_3_93 = mesh_3.vertices.elementAt(93);
      expect(vertex_3_93, vector3MoreOrLessEquals(Vector3(-49.0396, -2.31741, -1.24353)));
      final vertex_3_94 = mesh_3.vertices.elementAt(94);
      expect(vertex_3_94, vector3MoreOrLessEquals(Vector3(-52.6046, 6.25055, 17.6873)));
      final vertex_3_95 = mesh_3.vertices.elementAt(95);
      expect(vertex_3_95, vector3MoreOrLessEquals(Vector3(-45.9887, -1.45013, -2.53574)));
      final vertex_3_96 = mesh_3.vertices.elementAt(96);
      expect(vertex_3_96, vector3MoreOrLessEquals(Vector3(-52.6046, 6.25055, 17.6873)));
      final vertex_3_97 = mesh_3.vertices.elementAt(97);
      expect(vertex_3_97, vector3MoreOrLessEquals(Vector3(-55.9834, 28.0877, 28.4576)));
      final vertex_3_98 = mesh_3.vertices.elementAt(98);
      expect(vertex_3_98, vector3MoreOrLessEquals(Vector3(-50.885, 7.78515, 17.481)));
      final vertex_3_99 = mesh_3.vertices.elementAt(99);
      expect(vertex_3_99, vector3MoreOrLessEquals(Vector3(-52.6046, 6.25055, 17.6873)));
      final vertex_3_100 = mesh_3.vertices.elementAt(100);
      expect(vertex_3_100, vector3MoreOrLessEquals(Vector3(-56.6312, 26.7007, 28.4076)));
      final vertex_3_101 = mesh_3.vertices.elementAt(101);
      expect(vertex_3_101, vector3MoreOrLessEquals(Vector3(-55.9834, 28.0877, 28.4576)));
      final vertex_3_102 = mesh_3.vertices.elementAt(102);
      expect(vertex_3_102, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_103 = mesh_3.vertices.elementAt(103);
      expect(vertex_3_103, vector3MoreOrLessEquals(Vector3(-59.4156, 28.147, 32.741)));
      final vertex_3_104 = mesh_3.vertices.elementAt(104);
      expect(vertex_3_104, vector3MoreOrLessEquals(Vector3(-55.9834, 28.0877, 28.4576)));
      final vertex_3_105 = mesh_3.vertices.elementAt(105);
      expect(vertex_3_105, vector3MoreOrLessEquals(Vector3(-56.6312, 26.7007, 28.4076)));
      final vertex_3_106 = mesh_3.vertices.elementAt(106);
      expect(vertex_3_106, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_107 = mesh_3.vertices.elementAt(107);
      expect(vertex_3_107, vector3MoreOrLessEquals(Vector3(-55.9834, 28.0877, 28.4576)));
      final vertex_3_108 = mesh_3.vertices.elementAt(108);
      expect(vertex_3_108, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_109 = mesh_3.vertices.elementAt(109);
      expect(vertex_3_109, vector3MoreOrLessEquals(Vector3(-71.6158, 8.68279, 43.4344)));
      final vertex_3_110 = mesh_3.vertices.elementAt(110);
      expect(vertex_3_110, vector3MoreOrLessEquals(Vector3(-59.4156, 28.147, 32.741)));
      final vertex_3_111 = mesh_3.vertices.elementAt(111);
      expect(vertex_3_111, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_112 = mesh_3.vertices.elementAt(112);
      expect(vertex_3_112, vector3MoreOrLessEquals(Vector3(-71.9709, 7.37398, 41.5594)));
      final vertex_3_113 = mesh_3.vertices.elementAt(113);
      expect(vertex_3_113, vector3MoreOrLessEquals(Vector3(-71.6158, 8.68279, 43.4344)));
      final vertex_3_114 = mesh_3.vertices.elementAt(114);
      expect(vertex_3_114, vector3MoreOrLessEquals(Vector3(-87.6385, -31.585, 50.8611)));
      final vertex_3_115 = mesh_3.vertices.elementAt(115);
      expect(vertex_3_115, vector3MoreOrLessEquals(Vector3(-87.7561, -30.2962, 51.631)));
      final vertex_3_116 = mesh_3.vertices.elementAt(116);
      expect(vertex_3_116, vector3MoreOrLessEquals(Vector3(-71.6158, 8.68279, 43.4344)));
      final vertex_3_117 = mesh_3.vertices.elementAt(117);
      expect(vertex_3_117, vector3MoreOrLessEquals(Vector3(-71.9709, 7.37398, 41.5594)));
      final vertex_3_118 = mesh_3.vertices.elementAt(118);
      expect(vertex_3_118, vector3MoreOrLessEquals(Vector3(-87.6385, -31.585, 50.8611)));
      final vertex_3_119 = mesh_3.vertices.elementAt(119);
      expect(vertex_3_119, vector3MoreOrLessEquals(Vector3(-71.6158, 8.68279, 43.4344)));
      final vertex_3_120 = mesh_3.vertices.elementAt(120);
      expect(vertex_3_120, vector3MoreOrLessEquals(Vector3(-87.6385, -31.585, 50.8611)));
      final vertex_3_121 = mesh_3.vertices.elementAt(121);
      expect(vertex_3_121, vector3MoreOrLessEquals(Vector3(-92.6001, -39.1617, 56.9964)));
      final vertex_3_122 = mesh_3.vertices.elementAt(122);
      expect(vertex_3_122, vector3MoreOrLessEquals(Vector3(-87.7561, -30.2962, 51.631)));
      final vertex_3_123 = mesh_3.vertices.elementAt(123);
      expect(vertex_3_123, vector3MoreOrLessEquals(Vector3(-87.6385, -31.585, 50.8611)));
      final vertex_3_124 = mesh_3.vertices.elementAt(124);
      expect(vertex_3_124, vector3MoreOrLessEquals(Vector3(-92.6552, -39.6206, 56.6732)));
      final vertex_3_125 = mesh_3.vertices.elementAt(125);
      expect(vertex_3_125, vector3MoreOrLessEquals(Vector3(-92.6001, -39.1617, 56.9964)));
      final vertex_3_126 = mesh_3.vertices.elementAt(126);
      expect(vertex_3_126, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_127 = mesh_3.vertices.elementAt(127);
      expect(vertex_3_127, vector3MoreOrLessEquals(Vector3(-49.6933, -3.77151, 1.73014)));
      final vertex_3_128 = mesh_3.vertices.elementAt(128);
      expect(vertex_3_128, vector3MoreOrLessEquals(Vector3(-49.0396, -2.31741, -1.24353)));
      final vertex_3_129 = mesh_3.vertices.elementAt(129);
      expect(vertex_3_129, vector3MoreOrLessEquals(Vector3(-92.4144, -40.2427, 56.6563)));
      final vertex_3_130 = mesh_3.vertices.elementAt(130);
      expect(vertex_3_130, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_131 = mesh_3.vertices.elementAt(131);
      expect(vertex_3_131, vector3MoreOrLessEquals(Vector3(-92.6552, -39.6206, 56.6732)));
      final vertex_3_132 = mesh_3.vertices.elementAt(132);
      expect(vertex_3_132, vector3MoreOrLessEquals(Vector3(-49.6933, -3.77151, 1.73014)));
      final vertex_3_133 = mesh_3.vertices.elementAt(133);
      expect(vertex_3_133, vector3MoreOrLessEquals(Vector3(-52.6046, 6.25055, 17.6873)));
      final vertex_3_134 = mesh_3.vertices.elementAt(134);
      expect(vertex_3_134, vector3MoreOrLessEquals(Vector3(-49.0396, -2.31741, -1.24353)));
      final vertex_3_135 = mesh_3.vertices.elementAt(135);
      expect(vertex_3_135, vector3MoreOrLessEquals(Vector3(-49.6933, -3.77151, 1.73014)));
      final vertex_3_136 = mesh_3.vertices.elementAt(136);
      expect(vertex_3_136, vector3MoreOrLessEquals(Vector3(-53.2322, 5.02854, 19.5495)));
      final vertex_3_137 = mesh_3.vertices.elementAt(137);
      expect(vertex_3_137, vector3MoreOrLessEquals(Vector3(-52.6046, 6.25055, 17.6873)));
      final vertex_3_138 = mesh_3.vertices.elementAt(138);
      expect(vertex_3_138, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_139 = mesh_3.vertices.elementAt(139);
      expect(vertex_3_139, vector3MoreOrLessEquals(Vector3(-56.6312, 26.7007, 28.4076)));
      final vertex_3_140 = mesh_3.vertices.elementAt(140);
      expect(vertex_3_140, vector3MoreOrLessEquals(Vector3(-52.6046, 6.25055, 17.6873)));
      final vertex_3_141 = mesh_3.vertices.elementAt(141);
      expect(vertex_3_141, vector3MoreOrLessEquals(Vector3(-53.2322, 5.02854, 19.5495)));
      final vertex_3_142 = mesh_3.vertices.elementAt(142);
      expect(vertex_3_142, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_143 = mesh_3.vertices.elementAt(143);
      expect(vertex_3_143, vector3MoreOrLessEquals(Vector3(-52.6046, 6.25055, 17.6873)));
      final vertex_3_144 = mesh_3.vertices.elementAt(144);
      expect(vertex_3_144, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_145 = mesh_3.vertices.elementAt(145);
      expect(vertex_3_145, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_146 = mesh_3.vertices.elementAt(146);
      expect(vertex_3_146, vector3MoreOrLessEquals(Vector3(-56.6312, 26.7007, 28.4076)));
      final vertex_3_147 = mesh_3.vertices.elementAt(147);
      expect(vertex_3_147, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_148 = mesh_3.vertices.elementAt(148);
      expect(vertex_3_148, vector3MoreOrLessEquals(Vector3(-58.5252, 24.4246, 31.0863)));
      final vertex_3_149 = mesh_3.vertices.elementAt(149);
      expect(vertex_3_149, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_150 = mesh_3.vertices.elementAt(150);
      expect(vertex_3_150, vector3MoreOrLessEquals(Vector3(-70.41, 6.51407, 40.0833)));
      final vertex_3_151 = mesh_3.vertices.elementAt(151);
      expect(vertex_3_151, vector3MoreOrLessEquals(Vector3(-71.9709, 7.37398, 41.5594)));
      final vertex_3_152 = mesh_3.vertices.elementAt(152);
      expect(vertex_3_152, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_153 = mesh_3.vertices.elementAt(153);
      expect(vertex_3_153, vector3MoreOrLessEquals(Vector3(-58.5252, 24.4246, 31.0863)));
      final vertex_3_154 = mesh_3.vertices.elementAt(154);
      expect(vertex_3_154, vector3MoreOrLessEquals(Vector3(-70.41, 6.51407, 40.0833)));
      final vertex_3_155 = mesh_3.vertices.elementAt(155);
      expect(vertex_3_155, vector3MoreOrLessEquals(Vector3(-59.8919, 26.2415, 31.5174)));
      final vertex_3_156 = mesh_3.vertices.elementAt(156);
      expect(vertex_3_156, vector3MoreOrLessEquals(Vector3(-70.41, 6.51407, 40.0833)));
      final vertex_3_157 = mesh_3.vertices.elementAt(157);
      expect(vertex_3_157, vector3MoreOrLessEquals(Vector3(-87.6385, -31.585, 50.8611)));
      final vertex_3_158 = mesh_3.vertices.elementAt(158);
      expect(vertex_3_158, vector3MoreOrLessEquals(Vector3(-71.9709, 7.37398, 41.5594)));
      final vertex_3_159 = mesh_3.vertices.elementAt(159);
      expect(vertex_3_159, vector3MoreOrLessEquals(Vector3(-70.41, 6.51407, 40.0833)));
      final vertex_3_160 = mesh_3.vertices.elementAt(160);
      expect(vertex_3_160, vector3MoreOrLessEquals(Vector3(-86.7501, -33.41, 50.692)));
      final vertex_3_161 = mesh_3.vertices.elementAt(161);
      expect(vertex_3_161, vector3MoreOrLessEquals(Vector3(-87.6385, -31.585, 50.8611)));
      final vertex_3_162 = mesh_3.vertices.elementAt(162);
      expect(vertex_3_162, vector3MoreOrLessEquals(Vector3(-92.4144, -40.2427, 56.6563)));
      final vertex_3_163 = mesh_3.vertices.elementAt(163);
      expect(vertex_3_163, vector3MoreOrLessEquals(Vector3(-92.6552, -39.6206, 56.6732)));
      final vertex_3_164 = mesh_3.vertices.elementAt(164);
      expect(vertex_3_164, vector3MoreOrLessEquals(Vector3(-87.6385, -31.585, 50.8611)));
      final vertex_3_165 = mesh_3.vertices.elementAt(165);
      expect(vertex_3_165, vector3MoreOrLessEquals(Vector3(-86.7501, -33.41, 50.692)));
      final vertex_3_166 = mesh_3.vertices.elementAt(166);
      expect(vertex_3_166, vector3MoreOrLessEquals(Vector3(-92.4144, -40.2427, 56.6563)));
      final vertex_3_167 = mesh_3.vertices.elementAt(167);
      expect(vertex_3_167, vector3MoreOrLessEquals(Vector3(-87.6385, -31.585, 50.8611)));
      final vertex_3_168 = mesh_3.vertices.elementAt(168);
      expect(vertex_3_168, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_169 = mesh_3.vertices.elementAt(169);
      expect(vertex_3_169, vector3MoreOrLessEquals(Vector3(-47.4576, -4.71747, 4.14606)));
      final vertex_3_170 = mesh_3.vertices.elementAt(170);
      expect(vertex_3_170, vector3MoreOrLessEquals(Vector3(-49.6933, -3.77151, 1.73014)));
      final vertex_3_171 = mesh_3.vertices.elementAt(171);
      expect(vertex_3_171, vector3MoreOrLessEquals(Vector3(-92.0589, -40.5596, 56.9584)));
      final vertex_3_172 = mesh_3.vertices.elementAt(172);
      expect(vertex_3_172, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_173 = mesh_3.vertices.elementAt(173);
      expect(vertex_3_173, vector3MoreOrLessEquals(Vector3(-92.4144, -40.2427, 56.6563)));
      final vertex_3_174 = mesh_3.vertices.elementAt(174);
      expect(vertex_3_174, vector3MoreOrLessEquals(Vector3(-52.295, 5.03929, 21.6653)));
      final vertex_3_175 = mesh_3.vertices.elementAt(175);
      expect(vertex_3_175, vector3MoreOrLessEquals(Vector3(-53.2322, 5.02854, 19.5495)));
      final vertex_3_176 = mesh_3.vertices.elementAt(176);
      expect(vertex_3_176, vector3MoreOrLessEquals(Vector3(-49.6933, -3.77151, 1.73014)));
      final vertex_3_177 = mesh_3.vertices.elementAt(177);
      expect(vertex_3_177, vector3MoreOrLessEquals(Vector3(-47.4576, -4.71747, 4.14606)));
      final vertex_3_178 = mesh_3.vertices.elementAt(178);
      expect(vertex_3_178, vector3MoreOrLessEquals(Vector3(-52.295, 5.03929, 21.6653)));
      final vertex_3_179 = mesh_3.vertices.elementAt(179);
      expect(vertex_3_179, vector3MoreOrLessEquals(Vector3(-49.6933, -3.77151, 1.73014)));
      final vertex_3_180 = mesh_3.vertices.elementAt(180);
      expect(vertex_3_180, vector3MoreOrLessEquals(Vector3(-52.295, 5.03929, 21.6653)));
      final vertex_3_181 = mesh_3.vertices.elementAt(181);
      expect(vertex_3_181, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_182 = mesh_3.vertices.elementAt(182);
      expect(vertex_3_182, vector3MoreOrLessEquals(Vector3(-53.2322, 5.02854, 19.5495)));
      final vertex_3_183 = mesh_3.vertices.elementAt(183);
      expect(vertex_3_183, vector3MoreOrLessEquals(Vector3(-52.295, 5.03929, 21.6653)));
      final vertex_3_184 = mesh_3.vertices.elementAt(184);
      expect(vertex_3_184, vector3MoreOrLessEquals(Vector3(-55.422, 24.7735, 30.3588)));
      final vertex_3_185 = mesh_3.vertices.elementAt(185);
      expect(vertex_3_185, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_186 = mesh_3.vertices.elementAt(186);
      expect(vertex_3_186, vector3MoreOrLessEquals(Vector3(-56.3447, 24.0645, 31.7721)));
      final vertex_3_187 = mesh_3.vertices.elementAt(187);
      expect(vertex_3_187, vector3MoreOrLessEquals(Vector3(-58.5252, 24.4246, 31.0863)));
      final vertex_3_188 = mesh_3.vertices.elementAt(188);
      expect(vertex_3_188, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_189 = mesh_3.vertices.elementAt(189);
      expect(vertex_3_189, vector3MoreOrLessEquals(Vector3(-55.422, 24.7735, 30.3588)));
      final vertex_3_190 = mesh_3.vertices.elementAt(190);
      expect(vertex_3_190, vector3MoreOrLessEquals(Vector3(-56.3447, 24.0645, 31.7721)));
      final vertex_3_191 = mesh_3.vertices.elementAt(191);
      expect(vertex_3_191, vector3MoreOrLessEquals(Vector3(-56.3814, 25.2257, 29.2537)));
      final vertex_3_192 = mesh_3.vertices.elementAt(192);
      expect(vertex_3_192, vector3MoreOrLessEquals(Vector3(-56.3447, 24.0645, 31.7721)));
      final vertex_3_193 = mesh_3.vertices.elementAt(193);
      expect(vertex_3_193, vector3MoreOrLessEquals(Vector3(-70.41, 6.51407, 40.0833)));
      final vertex_3_194 = mesh_3.vertices.elementAt(194);
      expect(vertex_3_194, vector3MoreOrLessEquals(Vector3(-58.5252, 24.4246, 31.0863)));
      final vertex_3_195 = mesh_3.vertices.elementAt(195);
      expect(vertex_3_195, vector3MoreOrLessEquals(Vector3(-56.3447, 24.0645, 31.7721)));
      final vertex_3_196 = mesh_3.vertices.elementAt(196);
      expect(vertex_3_196, vector3MoreOrLessEquals(Vector3(-68.1082, 6.7506, 40.1178)));
      final vertex_3_197 = mesh_3.vertices.elementAt(197);
      expect(vertex_3_197, vector3MoreOrLessEquals(Vector3(-70.41, 6.51407, 40.0833)));
      final vertex_3_198 = mesh_3.vertices.elementAt(198);
      expect(vertex_3_198, vector3MoreOrLessEquals(Vector3(-85.7597, -34.397, 51.2511)));
      final vertex_3_199 = mesh_3.vertices.elementAt(199);
      expect(vertex_3_199, vector3MoreOrLessEquals(Vector3(-86.7501, -33.41, 50.692)));
      final vertex_3_200 = mesh_3.vertices.elementAt(200);
      expect(vertex_3_200, vector3MoreOrLessEquals(Vector3(-70.41, 6.51407, 40.0833)));
      final vertex_3_201 = mesh_3.vertices.elementAt(201);
      expect(vertex_3_201, vector3MoreOrLessEquals(Vector3(-68.1082, 6.7506, 40.1178)));
      final vertex_3_202 = mesh_3.vertices.elementAt(202);
      expect(vertex_3_202, vector3MoreOrLessEquals(Vector3(-85.7597, -34.397, 51.2511)));
      final vertex_3_203 = mesh_3.vertices.elementAt(203);
      expect(vertex_3_203, vector3MoreOrLessEquals(Vector3(-70.41, 6.51407, 40.0833)));
      final vertex_3_204 = mesh_3.vertices.elementAt(204);
      expect(vertex_3_204, vector3MoreOrLessEquals(Vector3(-85.7597, -34.397, 51.2511)));
      final vertex_3_205 = mesh_3.vertices.elementAt(205);
      expect(vertex_3_205, vector3MoreOrLessEquals(Vector3(-92.4144, -40.2427, 56.6563)));
      final vertex_3_206 = mesh_3.vertices.elementAt(206);
      expect(vertex_3_206, vector3MoreOrLessEquals(Vector3(-86.7501, -33.41, 50.692)));
      final vertex_3_207 = mesh_3.vertices.elementAt(207);
      expect(vertex_3_207, vector3MoreOrLessEquals(Vector3(-85.7597, -34.397, 51.2511)));
      final vertex_3_208 = mesh_3.vertices.elementAt(208);
      expect(vertex_3_208, vector3MoreOrLessEquals(Vector3(-92.0589, -40.5596, 56.9584)));
      final vertex_3_209 = mesh_3.vertices.elementAt(209);
      expect(vertex_3_209, vector3MoreOrLessEquals(Vector3(-92.4144, -40.2427, 56.6563)));
      final vertex_3_210 = mesh_3.vertices.elementAt(210);
      expect(vertex_3_210, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_211 = mesh_3.vertices.elementAt(211);
      expect(vertex_3_211, vector3MoreOrLessEquals(Vector3(-44.016, -4.44295, 4.18499)));
      final vertex_3_212 = mesh_3.vertices.elementAt(212);
      expect(vertex_3_212, vector3MoreOrLessEquals(Vector3(-47.4576, -4.71747, 4.14606)));
      final vertex_3_213 = mesh_3.vertices.elementAt(213);
      expect(vertex_3_213, vector3MoreOrLessEquals(Vector3(-91.8565, -40.3327, 57.3521)));
      final vertex_3_214 = mesh_3.vertices.elementAt(214);
      expect(vertex_3_214, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_215 = mesh_3.vertices.elementAt(215);
      expect(vertex_3_215, vector3MoreOrLessEquals(Vector3(-92.0589, -40.5596, 56.9584)));
      final vertex_3_216 = mesh_3.vertices.elementAt(216);
      expect(vertex_3_216, vector3MoreOrLessEquals(Vector3(-44.016, -4.44295, 4.18499)));
      final vertex_3_217 = mesh_3.vertices.elementAt(217);
      expect(vertex_3_217, vector3MoreOrLessEquals(Vector3(-52.295, 5.03929, 21.6653)));
      final vertex_3_218 = mesh_3.vertices.elementAt(218);
      expect(vertex_3_218, vector3MoreOrLessEquals(Vector3(-47.4576, -4.71747, 4.14606)));
      final vertex_3_219 = mesh_3.vertices.elementAt(219);
      expect(vertex_3_219, vector3MoreOrLessEquals(Vector3(-44.016, -4.44295, 4.18499)));
      final vertex_3_220 = mesh_3.vertices.elementAt(220);
      expect(vertex_3_220, vector3MoreOrLessEquals(Vector3(-50.4989, 6.27475, 22.4414)));
      final vertex_3_221 = mesh_3.vertices.elementAt(221);
      expect(vertex_3_221, vector3MoreOrLessEquals(Vector3(-52.295, 5.03929, 21.6653)));
      final vertex_3_222 = mesh_3.vertices.elementAt(222);
      expect(vertex_3_222, vector3MoreOrLessEquals(Vector3(-54.4755, 25.6846, 30.8906)));
      final vertex_3_223 = mesh_3.vertices.elementAt(223);
      expect(vertex_3_223, vector3MoreOrLessEquals(Vector3(-55.422, 24.7735, 30.3588)));
      final vertex_3_224 = mesh_3.vertices.elementAt(224);
      expect(vertex_3_224, vector3MoreOrLessEquals(Vector3(-52.295, 5.03929, 21.6653)));
      final vertex_3_225 = mesh_3.vertices.elementAt(225);
      expect(vertex_3_225, vector3MoreOrLessEquals(Vector3(-50.4989, 6.27475, 22.4414)));
      final vertex_3_226 = mesh_3.vertices.elementAt(226);
      expect(vertex_3_226, vector3MoreOrLessEquals(Vector3(-54.4755, 25.6846, 30.8906)));
      final vertex_3_227 = mesh_3.vertices.elementAt(227);
      expect(vertex_3_227, vector3MoreOrLessEquals(Vector3(-52.295, 5.03929, 21.6653)));
      final vertex_3_228 = mesh_3.vertices.elementAt(228);
      expect(vertex_3_228, vector3MoreOrLessEquals(Vector3(-54.4755, 25.6846, 30.8906)));
      final vertex_3_229 = mesh_3.vertices.elementAt(229);
      expect(vertex_3_229, vector3MoreOrLessEquals(Vector3(-56.3447, 24.0645, 31.7721)));
      final vertex_3_230 = mesh_3.vertices.elementAt(230);
      expect(vertex_3_230, vector3MoreOrLessEquals(Vector3(-55.422, 24.7735, 30.3588)));
      final vertex_3_231 = mesh_3.vertices.elementAt(231);
      expect(vertex_3_231, vector3MoreOrLessEquals(Vector3(-54.4755, 25.6846, 30.8906)));
      final vertex_3_232 = mesh_3.vertices.elementAt(232);
      expect(vertex_3_232, vector3MoreOrLessEquals(Vector3(-54.9923, 25.4323, 33.0586)));
      final vertex_3_233 = mesh_3.vertices.elementAt(233);
      expect(vertex_3_233, vector3MoreOrLessEquals(Vector3(-56.3447, 24.0645, 31.7721)));
      final vertex_3_234 = mesh_3.vertices.elementAt(234);
      expect(vertex_3_234, vector3MoreOrLessEquals(Vector3(-66.7991, 7.9055, 41.6367)));
      final vertex_3_235 = mesh_3.vertices.elementAt(235);
      expect(vertex_3_235, vector3MoreOrLessEquals(Vector3(-68.1082, 6.7506, 40.1178)));
      final vertex_3_236 = mesh_3.vertices.elementAt(236);
      expect(vertex_3_236, vector3MoreOrLessEquals(Vector3(-56.3447, 24.0645, 31.7721)));
      final vertex_3_237 = mesh_3.vertices.elementAt(237);
      expect(vertex_3_237, vector3MoreOrLessEquals(Vector3(-54.9923, 25.4323, 33.0586)));
      final vertex_3_238 = mesh_3.vertices.elementAt(238);
      expect(vertex_3_238, vector3MoreOrLessEquals(Vector3(-66.7991, 7.9055, 41.6367)));
      final vertex_3_239 = mesh_3.vertices.elementAt(239);
      expect(vertex_3_239, vector3MoreOrLessEquals(Vector3(-56.3447, 24.0645, 31.7721)));
      final vertex_3_240 = mesh_3.vertices.elementAt(240);
      expect(vertex_3_240, vector3MoreOrLessEquals(Vector3(-66.7991, 7.9055, 41.6367)));
      final vertex_3_241 = mesh_3.vertices.elementAt(241);
      expect(vertex_3_241, vector3MoreOrLessEquals(Vector3(-85.7597, -34.397, 51.2511)));
      final vertex_3_242 = mesh_3.vertices.elementAt(242);
      expect(vertex_3_242, vector3MoreOrLessEquals(Vector3(-68.1082, 6.7506, 40.1178)));
      final vertex_3_243 = mesh_3.vertices.elementAt(243);
      expect(vertex_3_243, vector3MoreOrLessEquals(Vector3(-66.7991, 7.9055, 41.6367)));
      final vertex_3_244 = mesh_3.vertices.elementAt(244);
      expect(vertex_3_244, vector3MoreOrLessEquals(Vector3(-85.4132, -33.8027, 52.1173)));
      final vertex_3_245 = mesh_3.vertices.elementAt(245);
      expect(vertex_3_245, vector3MoreOrLessEquals(Vector3(-85.7597, -34.397, 51.2511)));
      final vertex_3_246 = mesh_3.vertices.elementAt(246);
      expect(vertex_3_246, vector3MoreOrLessEquals(Vector3(-91.8565, -40.3327, 57.3521)));
      final vertex_3_247 = mesh_3.vertices.elementAt(247);
      expect(vertex_3_247, vector3MoreOrLessEquals(Vector3(-92.0589, -40.5596, 56.9584)));
      final vertex_3_248 = mesh_3.vertices.elementAt(248);
      expect(vertex_3_248, vector3MoreOrLessEquals(Vector3(-85.7597, -34.397, 51.2511)));
      final vertex_3_249 = mesh_3.vertices.elementAt(249);
      expect(vertex_3_249, vector3MoreOrLessEquals(Vector3(-85.4132, -33.8027, 52.1173)));
      final vertex_3_250 = mesh_3.vertices.elementAt(250);
      expect(vertex_3_250, vector3MoreOrLessEquals(Vector3(-91.8565, -40.3327, 57.3521)));
      final vertex_3_251 = mesh_3.vertices.elementAt(251);
      expect(vertex_3_251, vector3MoreOrLessEquals(Vector3(-85.7597, -34.397, 51.2511)));
      final vertex_3_252 = mesh_3.vertices.elementAt(252);
      expect(vertex_3_252, vector3MoreOrLessEquals(Vector3(-45.8562, -3.09668, 0.989461)));
      final vertex_3_253 = mesh_3.vertices.elementAt(253);
      expect(vertex_3_253, vector3MoreOrLessEquals(Vector3(-41.9601, -3.15467, 1.81762)));
      final vertex_3_254 = mesh_3.vertices.elementAt(254);
      expect(vertex_3_254, vector3MoreOrLessEquals(Vector3(-44.016, -4.44295, 4.18499)));
      final vertex_3_255 = mesh_3.vertices.elementAt(255);
      expect(vertex_3_255, vector3MoreOrLessEquals(Vector3(-91.9595, -39.7327, 57.5408)));
      final vertex_3_256 = mesh_3.vertices.elementAt(256);
      expect(vertex_3_256, vector3MoreOrLessEquals(Vector3(-92.2621, -39.8374, 57.0799)));
      final vertex_3_257 = mesh_3.vertices.elementAt(257);
      expect(vertex_3_257, vector3MoreOrLessEquals(Vector3(-91.8565, -40.3327, 57.3521)));
      final vertex_3_258 = mesh_3.vertices.elementAt(258);
      expect(vertex_3_258, vector3MoreOrLessEquals(Vector3(-49.1963, 7.80456, 21.2935)));
      final vertex_3_259 = mesh_3.vertices.elementAt(259);
      expect(vertex_3_259, vector3MoreOrLessEquals(Vector3(-50.4989, 6.27475, 22.4414)));
      final vertex_3_260 = mesh_3.vertices.elementAt(260);
      expect(vertex_3_260, vector3MoreOrLessEquals(Vector3(-44.016, -4.44295, 4.18499)));
      final vertex_3_261 = mesh_3.vertices.elementAt(261);
      expect(vertex_3_261, vector3MoreOrLessEquals(Vector3(-41.9601, -3.15467, 1.81762)));
      final vertex_3_262 = mesh_3.vertices.elementAt(262);
      expect(vertex_3_262, vector3MoreOrLessEquals(Vector3(-49.1963, 7.80456, 21.2935)));
      final vertex_3_263 = mesh_3.vertices.elementAt(263);
      expect(vertex_3_263, vector3MoreOrLessEquals(Vector3(-44.016, -4.44295, 4.18499)));
      final vertex_3_264 = mesh_3.vertices.elementAt(264);
      expect(vertex_3_264, vector3MoreOrLessEquals(Vector3(-49.1963, 7.80456, 21.2935)));
      final vertex_3_265 = mesh_3.vertices.elementAt(265);
      expect(vertex_3_265, vector3MoreOrLessEquals(Vector3(-54.4755, 25.6846, 30.8906)));
      final vertex_3_266 = mesh_3.vertices.elementAt(266);
      expect(vertex_3_266, vector3MoreOrLessEquals(Vector3(-50.4989, 6.27475, 22.4414)));
      final vertex_3_267 = mesh_3.vertices.elementAt(267);
      expect(vertex_3_267, vector3MoreOrLessEquals(Vector3(-49.1963, 7.80456, 21.2935)));
      final vertex_3_268 = mesh_3.vertices.elementAt(268);
      expect(vertex_3_268, vector3MoreOrLessEquals(Vector3(-54.2547, 27.2729, 30.4489)));
      final vertex_3_269 = mesh_3.vertices.elementAt(269);
      expect(vertex_3_269, vector3MoreOrLessEquals(Vector3(-54.4755, 25.6846, 30.8906)));
      final vertex_3_270 = mesh_3.vertices.elementAt(270);
      expect(vertex_3_270, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_271 = mesh_3.vertices.elementAt(271);
      expect(vertex_3_271, vector3MoreOrLessEquals(Vector3(-54.9923, 25.4323, 33.0586)));
      final vertex_3_272 = mesh_3.vertices.elementAt(272);
      expect(vertex_3_272, vector3MoreOrLessEquals(Vector3(-54.4755, 25.6846, 30.8906)));
      final vertex_3_273 = mesh_3.vertices.elementAt(273);
      expect(vertex_3_273, vector3MoreOrLessEquals(Vector3(-54.2547, 27.2729, 30.4489)));
      final vertex_3_274 = mesh_3.vertices.elementAt(274);
      expect(vertex_3_274, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_275 = mesh_3.vertices.elementAt(275);
      expect(vertex_3_275, vector3MoreOrLessEquals(Vector3(-54.4755, 25.6846, 30.8906)));
      final vertex_3_276 = mesh_3.vertices.elementAt(276);
      expect(vertex_3_276, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_277 = mesh_3.vertices.elementAt(277);
      expect(vertex_3_277, vector3MoreOrLessEquals(Vector3(-66.7991, 7.9055, 41.6367)));
      final vertex_3_278 = mesh_3.vertices.elementAt(278);
      expect(vertex_3_278, vector3MoreOrLessEquals(Vector3(-54.9923, 25.4323, 33.0586)));
      final vertex_3_279 = mesh_3.vertices.elementAt(279);
      expect(vertex_3_279, vector3MoreOrLessEquals(Vector3(-55.4865, 27.4981, 33.9769)));
      final vertex_3_280 = mesh_3.vertices.elementAt(280);
      expect(vertex_3_280, vector3MoreOrLessEquals(Vector3(-67.4683, 9.10906, 43.4964)));
      final vertex_3_281 = mesh_3.vertices.elementAt(281);
      expect(vertex_3_281, vector3MoreOrLessEquals(Vector3(-66.7991, 7.9055, 41.6367)));
      final vertex_3_282 = mesh_3.vertices.elementAt(282);
      expect(vertex_3_282, vector3MoreOrLessEquals(Vector3(-85.9715, -32.0747, 52.6385)));
      final vertex_3_283 = mesh_3.vertices.elementAt(283);
      expect(vertex_3_283, vector3MoreOrLessEquals(Vector3(-85.4132, -33.8027, 52.1173)));
      final vertex_3_284 = mesh_3.vertices.elementAt(284);
      expect(vertex_3_284, vector3MoreOrLessEquals(Vector3(-66.7991, 7.9055, 41.6367)));
      final vertex_3_285 = mesh_3.vertices.elementAt(285);
      expect(vertex_3_285, vector3MoreOrLessEquals(Vector3(-67.4683, 9.10906, 43.4964)));
      final vertex_3_286 = mesh_3.vertices.elementAt(286);
      expect(vertex_3_286, vector3MoreOrLessEquals(Vector3(-85.9715, -32.0747, 52.6385)));
      final vertex_3_287 = mesh_3.vertices.elementAt(287);
      expect(vertex_3_287, vector3MoreOrLessEquals(Vector3(-66.7991, 7.9055, 41.6367)));
      final vertex_3_288 = mesh_3.vertices.elementAt(288);
      expect(vertex_3_288, vector3MoreOrLessEquals(Vector3(-85.9715, -32.0747, 52.6385)));
      final vertex_3_289 = mesh_3.vertices.elementAt(289);
      expect(vertex_3_289, vector3MoreOrLessEquals(Vector3(-91.8565, -40.3327, 57.3521)));
      final vertex_3_290 = mesh_3.vertices.elementAt(290);
      expect(vertex_3_290, vector3MoreOrLessEquals(Vector3(-85.4132, -33.8027, 52.1173)));
      final vertex_3_291 = mesh_3.vertices.elementAt(291);
      expect(vertex_3_291, vector3MoreOrLessEquals(Vector3(-85.9715, -32.0747, 52.6385)));
      final vertex_3_292 = mesh_3.vertices.elementAt(292);
      expect(vertex_3_292, vector3MoreOrLessEquals(Vector3(-91.9595, -39.7327, 57.5408)));
      final vertex_3_293 = mesh_3.vertices.elementAt(293);
      expect(vertex_3_293, vector3MoreOrLessEquals(Vector3(-91.8565, -40.3327, 57.3521)));
      expect(mesh_3.normals.length, equals(294));
      final normal_3_0 = mesh_3.normals.elementAt(0);
      expect(normal_3_0, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_1 = mesh_3.normals.elementAt(1);
      expect(normal_3_1, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_2 = mesh_3.normals.elementAt(2);
      expect(normal_3_2, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_3 = mesh_3.normals.elementAt(3);
      expect(normal_3_3, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_4 = mesh_3.normals.elementAt(4);
      expect(normal_3_4, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_5 = mesh_3.normals.elementAt(5);
      expect(normal_3_5, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_6 = mesh_3.normals.elementAt(6);
      expect(normal_3_6, vector3MoreOrLessEquals(Vector3(0.698983, 0.632728, -0.333285)));
      final normal_3_7 = mesh_3.normals.elementAt(7);
      expect(normal_3_7, vector3MoreOrLessEquals(Vector3(0.918945, -0.018611, 0.393945)));
      final normal_3_8 = mesh_3.normals.elementAt(8);
      expect(normal_3_8, vector3MoreOrLessEquals(Vector3(0.946923, 0.242706, 0.210787)));
      final normal_3_9 = mesh_3.normals.elementAt(9);
      expect(normal_3_9, vector3MoreOrLessEquals(Vector3(0.597706, 0.775902, -0.201801)));
      final normal_3_10 = mesh_3.normals.elementAt(10);
      expect(normal_3_10, vector3MoreOrLessEquals(Vector3(0.698983, 0.632728, -0.333285)));
      final normal_3_11 = mesh_3.normals.elementAt(11);
      expect(normal_3_11, vector3MoreOrLessEquals(Vector3(0.946923, 0.242706, 0.210787)));
      final normal_3_12 = mesh_3.normals.elementAt(12);
      expect(normal_3_12, vector3MoreOrLessEquals(Vector3(0.698983, 0.632728, -0.333285)));
      final normal_3_13 = mesh_3.normals.elementAt(13);
      expect(normal_3_13, vector3MoreOrLessEquals(Vector3(0.898457, 0.395975, 0.189682)));
      final normal_3_14 = mesh_3.normals.elementAt(14);
      expect(normal_3_14, vector3MoreOrLessEquals(Vector3(0.918945, -0.018611, 0.393945)));
      final normal_3_15 = mesh_3.normals.elementAt(15);
      expect(normal_3_15, vector3MoreOrLessEquals(Vector3(0.698983, 0.632728, -0.333285)));
      final normal_3_16 = mesh_3.normals.elementAt(16);
      expect(normal_3_16, vector3MoreOrLessEquals(Vector3(0.584977, 0.777578, -0.230597)));
      final normal_3_17 = mesh_3.normals.elementAt(17);
      expect(normal_3_17, vector3MoreOrLessEquals(Vector3(0.898457, 0.395975, 0.189682)));
      final normal_3_18 = mesh_3.normals.elementAt(18);
      expect(normal_3_18, vector3MoreOrLessEquals(Vector3(0.061121, 0.865503, 0.497161)));
      final normal_3_19 = mesh_3.normals.elementAt(19);
      expect(normal_3_19, vector3MoreOrLessEquals(Vector3(0.814891, 0.173456, 0.553052)));
      final normal_3_20 = mesh_3.normals.elementAt(20);
      expect(normal_3_20, vector3MoreOrLessEquals(Vector3(0.898457, 0.395975, 0.189682)));
      final normal_3_21 = mesh_3.normals.elementAt(21);
      expect(normal_3_21, vector3MoreOrLessEquals(Vector3(0.584977, 0.777578, -0.230597)));
      final normal_3_22 = mesh_3.normals.elementAt(22);
      expect(normal_3_22, vector3MoreOrLessEquals(Vector3(0.061121, 0.865503, 0.497161)));
      final normal_3_23 = mesh_3.normals.elementAt(23);
      expect(normal_3_23, vector3MoreOrLessEquals(Vector3(0.898457, 0.395975, 0.189682)));
      final normal_3_24 = mesh_3.normals.elementAt(24);
      expect(normal_3_24, vector3MoreOrLessEquals(Vector3(0.061121, 0.865503, 0.497161)));
      final normal_3_25 = mesh_3.normals.elementAt(25);
      expect(normal_3_25, vector3MoreOrLessEquals(Vector3(0.488324, 0.052196, 0.8711)));
      final normal_3_26 = mesh_3.normals.elementAt(26);
      expect(normal_3_26, vector3MoreOrLessEquals(Vector3(0.814891, 0.173456, 0.553052)));
      final normal_3_27 = mesh_3.normals.elementAt(27);
      expect(normal_3_27, vector3MoreOrLessEquals(Vector3(0.061121, 0.865503, 0.497161)));
      final normal_3_28 = mesh_3.normals.elementAt(28);
      expect(normal_3_28, vector3MoreOrLessEquals(Vector3(-0.073338, 0.372458, 0.925147)));
      final normal_3_29 = mesh_3.normals.elementAt(29);
      expect(normal_3_29, vector3MoreOrLessEquals(Vector3(0.488324, 0.052196, 0.8711)));
      final normal_3_30 = mesh_3.normals.elementAt(30);
      expect(normal_3_30, vector3MoreOrLessEquals(Vector3(-0.168557, 0.420636, 0.891433)));
      final normal_3_31 = mesh_3.normals.elementAt(31);
      expect(normal_3_31, vector3MoreOrLessEquals(Vector3(0.562606, 0.01165, 0.826643)));
      final normal_3_32 = mesh_3.normals.elementAt(32);
      expect(normal_3_32, vector3MoreOrLessEquals(Vector3(0.488324, 0.052196, 0.8711)));
      final normal_3_33 = mesh_3.normals.elementAt(33);
      expect(normal_3_33, vector3MoreOrLessEquals(Vector3(-0.073338, 0.372458, 0.925147)));
      final normal_3_34 = mesh_3.normals.elementAt(34);
      expect(normal_3_34, vector3MoreOrLessEquals(Vector3(-0.168557, 0.420636, 0.891433)));
      final normal_3_35 = mesh_3.normals.elementAt(35);
      expect(normal_3_35, vector3MoreOrLessEquals(Vector3(0.488324, 0.052196, 0.8711)));
      final normal_3_36 = mesh_3.normals.elementAt(36);
      expect(normal_3_36, vector3MoreOrLessEquals(Vector3(-0.168557, 0.420636, 0.891433)));
      final normal_3_37 = mesh_3.normals.elementAt(37);
      expect(normal_3_37, vector3MoreOrLessEquals(Vector3(0.424549, 0.220069, 0.878253)));
      final normal_3_38 = mesh_3.normals.elementAt(38);
      expect(normal_3_38, vector3MoreOrLessEquals(Vector3(0.562606, 0.01165, 0.826643)));
      final normal_3_39 = mesh_3.normals.elementAt(39);
      expect(normal_3_39, vector3MoreOrLessEquals(Vector3(-0.168557, 0.420636, 0.891433)));
      final normal_3_40 = mesh_3.normals.elementAt(40);
      expect(normal_3_40, vector3MoreOrLessEquals(Vector3(-0.202274, 0.574889, 0.792835)));
      final normal_3_41 = mesh_3.normals.elementAt(41);
      expect(normal_3_41, vector3MoreOrLessEquals(Vector3(0.424549, 0.220069, 0.878253)));
      final normal_3_42 = mesh_3.normals.elementAt(42);
      expect(normal_3_42, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_43 = mesh_3.normals.elementAt(43);
      expect(normal_3_43, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_44 = mesh_3.normals.elementAt(44);
      expect(normal_3_44, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_45 = mesh_3.normals.elementAt(45);
      expect(normal_3_45, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_46 = mesh_3.normals.elementAt(46);
      expect(normal_3_46, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_47 = mesh_3.normals.elementAt(47);
      expect(normal_3_47, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_48 = mesh_3.normals.elementAt(48);
      expect(normal_3_48, vector3MoreOrLessEquals(Vector3(-0.201495, 0.870711, -0.448622)));
      final normal_3_49 = mesh_3.normals.elementAt(49);
      expect(normal_3_49, vector3MoreOrLessEquals(Vector3(0.698983, 0.632728, -0.333285)));
      final normal_3_50 = mesh_3.normals.elementAt(50);
      expect(normal_3_50, vector3MoreOrLessEquals(Vector3(0.597706, 0.775902, -0.201801)));
      final normal_3_51 = mesh_3.normals.elementAt(51);
      expect(normal_3_51, vector3MoreOrLessEquals(Vector3(-0.201495, 0.870711, -0.448622)));
      final normal_3_52 = mesh_3.normals.elementAt(52);
      expect(normal_3_52, vector3MoreOrLessEquals(Vector3(-0.147519, 0.700066, -0.698674)));
      final normal_3_53 = mesh_3.normals.elementAt(53);
      expect(normal_3_53, vector3MoreOrLessEquals(Vector3(0.698983, 0.632728, -0.333285)));
      final normal_3_54 = mesh_3.normals.elementAt(54);
      expect(normal_3_54, vector3MoreOrLessEquals(Vector3(-0.247406, 0.680029, -0.690182)));
      final normal_3_55 = mesh_3.normals.elementAt(55);
      expect(normal_3_55, vector3MoreOrLessEquals(Vector3(0.584977, 0.777578, -0.230597)));
      final normal_3_56 = mesh_3.normals.elementAt(56);
      expect(normal_3_56, vector3MoreOrLessEquals(Vector3(0.698983, 0.632728, -0.333285)));
      final normal_3_57 = mesh_3.normals.elementAt(57);
      expect(normal_3_57, vector3MoreOrLessEquals(Vector3(-0.147519, 0.700066, -0.698674)));
      final normal_3_58 = mesh_3.normals.elementAt(58);
      expect(normal_3_58, vector3MoreOrLessEquals(Vector3(-0.247406, 0.680029, -0.690182)));
      final normal_3_59 = mesh_3.normals.elementAt(59);
      expect(normal_3_59, vector3MoreOrLessEquals(Vector3(0.698983, 0.632728, -0.333285)));
      final normal_3_60 = mesh_3.normals.elementAt(60);
      expect(normal_3_60, vector3MoreOrLessEquals(Vector3(-0.247406, 0.680029, -0.690182)));
      final normal_3_61 = mesh_3.normals.elementAt(61);
      expect(normal_3_61, vector3MoreOrLessEquals(Vector3(0.061121, 0.865503, 0.497161)));
      final normal_3_62 = mesh_3.normals.elementAt(62);
      expect(normal_3_62, vector3MoreOrLessEquals(Vector3(0.584977, 0.777578, -0.230597)));
      final normal_3_63 = mesh_3.normals.elementAt(63);
      expect(normal_3_63, vector3MoreOrLessEquals(Vector3(-0.247406, 0.680029, -0.690182)));
      final normal_3_64 = mesh_3.normals.elementAt(64);
      expect(normal_3_64, vector3MoreOrLessEquals(Vector3(-0.659229, 0.74269, -0.117596)));
      final normal_3_65 = mesh_3.normals.elementAt(65);
      expect(normal_3_65, vector3MoreOrLessEquals(Vector3(0.061121, 0.865503, 0.497161)));
      final normal_3_66 = mesh_3.normals.elementAt(66);
      expect(normal_3_66, vector3MoreOrLessEquals(Vector3(-0.823828, 0.514402, 0.238115)));
      final normal_3_67 = mesh_3.normals.elementAt(67);
      expect(normal_3_67, vector3MoreOrLessEquals(Vector3(-0.073338, 0.372458, 0.925147)));
      final normal_3_68 = mesh_3.normals.elementAt(68);
      expect(normal_3_68, vector3MoreOrLessEquals(Vector3(0.061121, 0.865503, 0.497161)));
      final normal_3_69 = mesh_3.normals.elementAt(69);
      expect(normal_3_69, vector3MoreOrLessEquals(Vector3(-0.659229, 0.74269, -0.117596)));
      final normal_3_70 = mesh_3.normals.elementAt(70);
      expect(normal_3_70, vector3MoreOrLessEquals(Vector3(-0.823828, 0.514402, 0.238115)));
      final normal_3_71 = mesh_3.normals.elementAt(71);
      expect(normal_3_71, vector3MoreOrLessEquals(Vector3(0.061121, 0.865503, 0.497161)));
      final normal_3_72 = mesh_3.normals.elementAt(72);
      expect(normal_3_72, vector3MoreOrLessEquals(Vector3(-0.823828, 0.514402, 0.238115)));
      final normal_3_73 = mesh_3.normals.elementAt(73);
      expect(normal_3_73, vector3MoreOrLessEquals(Vector3(-0.168557, 0.420636, 0.891433)));
      final normal_3_74 = mesh_3.normals.elementAt(74);
      expect(normal_3_74, vector3MoreOrLessEquals(Vector3(-0.073338, 0.372458, 0.925147)));
      final normal_3_75 = mesh_3.normals.elementAt(75);
      expect(normal_3_75, vector3MoreOrLessEquals(Vector3(-0.823828, 0.514402, 0.238115)));
      final normal_3_76 = mesh_3.normals.elementAt(76);
      expect(normal_3_76, vector3MoreOrLessEquals(Vector3(-0.880755, 0.462224, 0.103053)));
      final normal_3_77 = mesh_3.normals.elementAt(77);
      expect(normal_3_77, vector3MoreOrLessEquals(Vector3(-0.168557, 0.420636, 0.891433)));
      final normal_3_78 = mesh_3.normals.elementAt(78);
      expect(normal_3_78, vector3MoreOrLessEquals(Vector3(-0.835446, 0.538148, 0.111476)));
      final normal_3_79 = mesh_3.normals.elementAt(79);
      expect(normal_3_79, vector3MoreOrLessEquals(Vector3(-0.202274, 0.574889, 0.792835)));
      final normal_3_80 = mesh_3.normals.elementAt(80);
      expect(normal_3_80, vector3MoreOrLessEquals(Vector3(-0.168557, 0.420636, 0.891433)));
      final normal_3_81 = mesh_3.normals.elementAt(81);
      expect(normal_3_81, vector3MoreOrLessEquals(Vector3(-0.880755, 0.462224, 0.103053)));
      final normal_3_82 = mesh_3.normals.elementAt(82);
      expect(normal_3_82, vector3MoreOrLessEquals(Vector3(-0.835446, 0.538148, 0.111476)));
      final normal_3_83 = mesh_3.normals.elementAt(83);
      expect(normal_3_83, vector3MoreOrLessEquals(Vector3(-0.168557, 0.420636, 0.891433)));
      final normal_3_84 = mesh_3.normals.elementAt(84);
      expect(normal_3_84, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_85 = mesh_3.normals.elementAt(85);
      expect(normal_3_85, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_86 = mesh_3.normals.elementAt(86);
      expect(normal_3_86, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_87 = mesh_3.normals.elementAt(87);
      expect(normal_3_87, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_88 = mesh_3.normals.elementAt(88);
      expect(normal_3_88, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_89 = mesh_3.normals.elementAt(89);
      expect(normal_3_89, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_90 = mesh_3.normals.elementAt(90);
      expect(normal_3_90, vector3MoreOrLessEquals(Vector3(-0.835433, 0.291149, -0.466138)));
      final normal_3_91 = mesh_3.normals.elementAt(91);
      expect(normal_3_91, vector3MoreOrLessEquals(Vector3(-0.147519, 0.700066, -0.698674)));
      final normal_3_92 = mesh_3.normals.elementAt(92);
      expect(normal_3_92, vector3MoreOrLessEquals(Vector3(-0.201495, 0.870711, -0.448622)));
      final normal_3_93 = mesh_3.normals.elementAt(93);
      expect(normal_3_93, vector3MoreOrLessEquals(Vector3(-0.799017, 0.476863, -0.366296)));
      final normal_3_94 = mesh_3.normals.elementAt(94);
      expect(normal_3_94, vector3MoreOrLessEquals(Vector3(-0.835433, 0.291149, -0.466138)));
      final normal_3_95 = mesh_3.normals.elementAt(95);
      expect(normal_3_95, vector3MoreOrLessEquals(Vector3(-0.201495, 0.870711, -0.448622)));
      final normal_3_96 = mesh_3.normals.elementAt(96);
      expect(normal_3_96, vector3MoreOrLessEquals(Vector3(-0.835433, 0.291149, -0.466138)));
      final normal_3_97 = mesh_3.normals.elementAt(97);
      expect(normal_3_97, vector3MoreOrLessEquals(Vector3(-0.247406, 0.680029, -0.690182)));
      final normal_3_98 = mesh_3.normals.elementAt(98);
      expect(normal_3_98, vector3MoreOrLessEquals(Vector3(-0.147519, 0.700066, -0.698674)));
      final normal_3_99 = mesh_3.normals.elementAt(99);
      expect(normal_3_99, vector3MoreOrLessEquals(Vector3(-0.835433, 0.291149, -0.466138)));
      final normal_3_100 = mesh_3.normals.elementAt(100);
      expect(normal_3_100, vector3MoreOrLessEquals(Vector3(-0.796565, -0.008375, -0.604495)));
      final normal_3_101 = mesh_3.normals.elementAt(101);
      expect(normal_3_101, vector3MoreOrLessEquals(Vector3(-0.247406, 0.680029, -0.690182)));
      final normal_3_102 = mesh_3.normals.elementAt(102);
      expect(normal_3_102, vector3MoreOrLessEquals(Vector3(-0.746076, 0.124458, -0.654126)));
      final normal_3_103 = mesh_3.normals.elementAt(103);
      expect(normal_3_103, vector3MoreOrLessEquals(Vector3(-0.659229, 0.74269, -0.117596)));
      final normal_3_104 = mesh_3.normals.elementAt(104);
      expect(normal_3_104, vector3MoreOrLessEquals(Vector3(-0.247406, 0.680029, -0.690182)));
      final normal_3_105 = mesh_3.normals.elementAt(105);
      expect(normal_3_105, vector3MoreOrLessEquals(Vector3(-0.796565, -0.008375, -0.604495)));
      final normal_3_106 = mesh_3.normals.elementAt(106);
      expect(normal_3_106, vector3MoreOrLessEquals(Vector3(-0.746076, 0.124458, -0.654126)));
      final normal_3_107 = mesh_3.normals.elementAt(107);
      expect(normal_3_107, vector3MoreOrLessEquals(Vector3(-0.247406, 0.680029, -0.690182)));
      final normal_3_108 = mesh_3.normals.elementAt(108);
      expect(normal_3_108, vector3MoreOrLessEquals(Vector3(-0.746076, 0.124458, -0.654126)));
      final normal_3_109 = mesh_3.normals.elementAt(109);
      expect(normal_3_109, vector3MoreOrLessEquals(Vector3(-0.823828, 0.514402, 0.238115)));
      final normal_3_110 = mesh_3.normals.elementAt(110);
      expect(normal_3_110, vector3MoreOrLessEquals(Vector3(-0.659229, 0.74269, -0.117596)));
      final normal_3_111 = mesh_3.normals.elementAt(111);
      expect(normal_3_111, vector3MoreOrLessEquals(Vector3(-0.746076, 0.124458, -0.654126)));
      final normal_3_112 = mesh_3.normals.elementAt(112);
      expect(normal_3_112, vector3MoreOrLessEquals(Vector3(-0.847027, 0.257512, -0.465008)));
      final normal_3_113 = mesh_3.normals.elementAt(113);
      expect(normal_3_113, vector3MoreOrLessEquals(Vector3(-0.823828, 0.514402, 0.238115)));
      final normal_3_114 = mesh_3.normals.elementAt(114);
      expect(normal_3_114, vector3MoreOrLessEquals(Vector3(-0.774335, 0.094113, -0.625738)));
      final normal_3_115 = mesh_3.normals.elementAt(115);
      expect(normal_3_115, vector3MoreOrLessEquals(Vector3(-0.880755, 0.462224, 0.103053)));
      final normal_3_116 = mesh_3.normals.elementAt(116);
      expect(normal_3_116, vector3MoreOrLessEquals(Vector3(-0.823828, 0.514402, 0.238115)));
      final normal_3_117 = mesh_3.normals.elementAt(117);
      expect(normal_3_117, vector3MoreOrLessEquals(Vector3(-0.847027, 0.257512, -0.465008)));
      final normal_3_118 = mesh_3.normals.elementAt(118);
      expect(normal_3_118, vector3MoreOrLessEquals(Vector3(-0.774335, 0.094113, -0.625738)));
      final normal_3_119 = mesh_3.normals.elementAt(119);
      expect(normal_3_119, vector3MoreOrLessEquals(Vector3(-0.823828, 0.514402, 0.238115)));
      final normal_3_120 = mesh_3.normals.elementAt(120);
      expect(normal_3_120, vector3MoreOrLessEquals(Vector3(-0.774335, 0.094113, -0.625738)));
      final normal_3_121 = mesh_3.normals.elementAt(121);
      expect(normal_3_121, vector3MoreOrLessEquals(Vector3(-0.835446, 0.538148, 0.111476)));
      final normal_3_122 = mesh_3.normals.elementAt(122);
      expect(normal_3_122, vector3MoreOrLessEquals(Vector3(-0.880755, 0.462224, 0.103053)));
      final normal_3_123 = mesh_3.normals.elementAt(123);
      expect(normal_3_123, vector3MoreOrLessEquals(Vector3(-0.774335, 0.094113, -0.625738)));
      final normal_3_124 = mesh_3.normals.elementAt(124);
      expect(normal_3_124, vector3MoreOrLessEquals(Vector3(-0.799434, 0.067311, -0.596971)));
      final normal_3_125 = mesh_3.normals.elementAt(125);
      expect(normal_3_125, vector3MoreOrLessEquals(Vector3(-0.835446, 0.538148, 0.111476)));
      final normal_3_126 = mesh_3.normals.elementAt(126);
      expect(normal_3_126, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_127 = mesh_3.normals.elementAt(127);
      expect(normal_3_127, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_128 = mesh_3.normals.elementAt(128);
      expect(normal_3_128, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_129 = mesh_3.normals.elementAt(129);
      expect(normal_3_129, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_130 = mesh_3.normals.elementAt(130);
      expect(normal_3_130, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_131 = mesh_3.normals.elementAt(131);
      expect(normal_3_131, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_132 = mesh_3.normals.elementAt(132);
      expect(normal_3_132, vector3MoreOrLessEquals(Vector3(-0.914826, -0.403289, 0.02124)));
      final normal_3_133 = mesh_3.normals.elementAt(133);
      expect(normal_3_133, vector3MoreOrLessEquals(Vector3(-0.835433, 0.291149, -0.466138)));
      final normal_3_134 = mesh_3.normals.elementAt(134);
      expect(normal_3_134, vector3MoreOrLessEquals(Vector3(-0.799017, 0.476863, -0.366296)));
      final normal_3_135 = mesh_3.normals.elementAt(135);
      expect(normal_3_135, vector3MoreOrLessEquals(Vector3(-0.914826, -0.403289, 0.02124)));
      final normal_3_136 = mesh_3.normals.elementAt(136);
      expect(normal_3_136, vector3MoreOrLessEquals(Vector3(-0.960708, -0.276547, 0.02372)));
      final normal_3_137 = mesh_3.normals.elementAt(137);
      expect(normal_3_137, vector3MoreOrLessEquals(Vector3(-0.835433, 0.291149, -0.466138)));
      final normal_3_138 = mesh_3.normals.elementAt(138);
      expect(normal_3_138, vector3MoreOrLessEquals(Vector3(-0.776094, -0.562737, -0.284613)));
      final normal_3_139 = mesh_3.normals.elementAt(139);
      expect(normal_3_139, vector3MoreOrLessEquals(Vector3(-0.796565, -0.008375, -0.604495)));
      final normal_3_140 = mesh_3.normals.elementAt(140);
      expect(normal_3_140, vector3MoreOrLessEquals(Vector3(-0.835433, 0.291149, -0.466138)));
      final normal_3_141 = mesh_3.normals.elementAt(141);
      expect(normal_3_141, vector3MoreOrLessEquals(Vector3(-0.960708, -0.276547, 0.02372)));
      final normal_3_142 = mesh_3.normals.elementAt(142);
      expect(normal_3_142, vector3MoreOrLessEquals(Vector3(-0.776094, -0.562737, -0.284613)));
      final normal_3_143 = mesh_3.normals.elementAt(143);
      expect(normal_3_143, vector3MoreOrLessEquals(Vector3(-0.835433, 0.291149, -0.466138)));
      final normal_3_144 = mesh_3.normals.elementAt(144);
      expect(normal_3_144, vector3MoreOrLessEquals(Vector3(-0.776094, -0.562737, -0.284613)));
      final normal_3_145 = mesh_3.normals.elementAt(145);
      expect(normal_3_145, vector3MoreOrLessEquals(Vector3(-0.746076, 0.124458, -0.654126)));
      final normal_3_146 = mesh_3.normals.elementAt(146);
      expect(normal_3_146, vector3MoreOrLessEquals(Vector3(-0.796565, -0.008375, -0.604495)));
      final normal_3_147 = mesh_3.normals.elementAt(147);
      expect(normal_3_147, vector3MoreOrLessEquals(Vector3(-0.776094, -0.562737, -0.284613)));
      final normal_3_148 = mesh_3.normals.elementAt(148);
      expect(normal_3_148, vector3MoreOrLessEquals(Vector3(-0.248105, -0.514857, -0.820589)));
      final normal_3_149 = mesh_3.normals.elementAt(149);
      expect(normal_3_149, vector3MoreOrLessEquals(Vector3(-0.746076, 0.124458, -0.654126)));
      final normal_3_150 = mesh_3.normals.elementAt(150);
      expect(normal_3_150, vector3MoreOrLessEquals(Vector3(-0.231599, -0.234207, -0.944198)));
      final normal_3_151 = mesh_3.normals.elementAt(151);
      expect(normal_3_151, vector3MoreOrLessEquals(Vector3(-0.847027, 0.257512, -0.465008)));
      final normal_3_152 = mesh_3.normals.elementAt(152);
      expect(normal_3_152, vector3MoreOrLessEquals(Vector3(-0.746076, 0.124458, -0.654126)));
      final normal_3_153 = mesh_3.normals.elementAt(153);
      expect(normal_3_153, vector3MoreOrLessEquals(Vector3(-0.248105, -0.514857, -0.820589)));
      final normal_3_154 = mesh_3.normals.elementAt(154);
      expect(normal_3_154, vector3MoreOrLessEquals(Vector3(-0.231599, -0.234207, -0.944198)));
      final normal_3_155 = mesh_3.normals.elementAt(155);
      expect(normal_3_155, vector3MoreOrLessEquals(Vector3(-0.746076, 0.124458, -0.654126)));
      final normal_3_156 = mesh_3.normals.elementAt(156);
      expect(normal_3_156, vector3MoreOrLessEquals(Vector3(-0.231599, -0.234207, -0.944198)));
      final normal_3_157 = mesh_3.normals.elementAt(157);
      expect(normal_3_157, vector3MoreOrLessEquals(Vector3(-0.774335, 0.094113, -0.625738)));
      final normal_3_158 = mesh_3.normals.elementAt(158);
      expect(normal_3_158, vector3MoreOrLessEquals(Vector3(-0.847027, 0.257512, -0.465008)));
      final normal_3_159 = mesh_3.normals.elementAt(159);
      expect(normal_3_159, vector3MoreOrLessEquals(Vector3(-0.231599, -0.234207, -0.944198)));
      final normal_3_160 = mesh_3.normals.elementAt(160);
      expect(normal_3_160, vector3MoreOrLessEquals(Vector3(-0.23595, -0.324119, -0.916119)));
      final normal_3_161 = mesh_3.normals.elementAt(161);
      expect(normal_3_161, vector3MoreOrLessEquals(Vector3(-0.774335, 0.094113, -0.625738)));
      final normal_3_162 = mesh_3.normals.elementAt(162);
      expect(normal_3_162, vector3MoreOrLessEquals(Vector3(-0.342337, -0.448272, -0.825747)));
      final normal_3_163 = mesh_3.normals.elementAt(163);
      expect(normal_3_163, vector3MoreOrLessEquals(Vector3(-0.799434, 0.067311, -0.596971)));
      final normal_3_164 = mesh_3.normals.elementAt(164);
      expect(normal_3_164, vector3MoreOrLessEquals(Vector3(-0.774335, 0.094113, -0.625738)));
      final normal_3_165 = mesh_3.normals.elementAt(165);
      expect(normal_3_165, vector3MoreOrLessEquals(Vector3(-0.23595, -0.324119, -0.916119)));
      final normal_3_166 = mesh_3.normals.elementAt(166);
      expect(normal_3_166, vector3MoreOrLessEquals(Vector3(-0.342337, -0.448272, -0.825747)));
      final normal_3_167 = mesh_3.normals.elementAt(167);
      expect(normal_3_167, vector3MoreOrLessEquals(Vector3(-0.774335, 0.094113, -0.625738)));
      final normal_3_168 = mesh_3.normals.elementAt(168);
      expect(normal_3_168, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_169 = mesh_3.normals.elementAt(169);
      expect(normal_3_169, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_170 = mesh_3.normals.elementAt(170);
      expect(normal_3_170, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_171 = mesh_3.normals.elementAt(171);
      expect(normal_3_171, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_172 = mesh_3.normals.elementAt(172);
      expect(normal_3_172, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_173 = mesh_3.normals.elementAt(173);
      expect(normal_3_173, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_174 = mesh_3.normals.elementAt(174);
      expect(normal_3_174, vector3MoreOrLessEquals(Vector3(-0.389047, -0.677991, 0.623675)));
      final normal_3_175 = mesh_3.normals.elementAt(175);
      expect(normal_3_175, vector3MoreOrLessEquals(Vector3(-0.960708, -0.276547, 0.02372)));
      final normal_3_176 = mesh_3.normals.elementAt(176);
      expect(normal_3_176, vector3MoreOrLessEquals(Vector3(-0.914826, -0.403289, 0.02124)));
      final normal_3_177 = mesh_3.normals.elementAt(177);
      expect(normal_3_177, vector3MoreOrLessEquals(Vector3(-0.286549, -0.868467, 0.404542)));
      final normal_3_178 = mesh_3.normals.elementAt(178);
      expect(normal_3_178, vector3MoreOrLessEquals(Vector3(-0.389047, -0.677991, 0.623675)));
      final normal_3_179 = mesh_3.normals.elementAt(179);
      expect(normal_3_179, vector3MoreOrLessEquals(Vector3(-0.914826, -0.403289, 0.02124)));
      final normal_3_180 = mesh_3.normals.elementAt(180);
      expect(normal_3_180, vector3MoreOrLessEquals(Vector3(-0.389047, -0.677991, 0.623675)));
      final normal_3_181 = mesh_3.normals.elementAt(181);
      expect(normal_3_181, vector3MoreOrLessEquals(Vector3(-0.776094, -0.562737, -0.284613)));
      final normal_3_182 = mesh_3.normals.elementAt(182);
      expect(normal_3_182, vector3MoreOrLessEquals(Vector3(-0.960708, -0.276547, 0.02372)));
      final normal_3_183 = mesh_3.normals.elementAt(183);
      expect(normal_3_183, vector3MoreOrLessEquals(Vector3(-0.389047, -0.677991, 0.623675)));
      final normal_3_184 = mesh_3.normals.elementAt(184);
      expect(normal_3_184, vector3MoreOrLessEquals(Vector3(-0.058292, -0.911347, 0.407491)));
      final normal_3_185 = mesh_3.normals.elementAt(185);
      expect(normal_3_185, vector3MoreOrLessEquals(Vector3(-0.776094, -0.562737, -0.284613)));
      final normal_3_186 = mesh_3.normals.elementAt(186);
      expect(normal_3_186, vector3MoreOrLessEquals(Vector3(0.455951, -0.795072, -0.399962)));
      final normal_3_187 = mesh_3.normals.elementAt(187);
      expect(normal_3_187, vector3MoreOrLessEquals(Vector3(-0.248105, -0.514857, -0.820589)));
      final normal_3_188 = mesh_3.normals.elementAt(188);
      expect(normal_3_188, vector3MoreOrLessEquals(Vector3(-0.776094, -0.562737, -0.284613)));
      final normal_3_189 = mesh_3.normals.elementAt(189);
      expect(normal_3_189, vector3MoreOrLessEquals(Vector3(-0.058292, -0.911347, 0.407491)));
      final normal_3_190 = mesh_3.normals.elementAt(190);
      expect(normal_3_190, vector3MoreOrLessEquals(Vector3(0.455951, -0.795072, -0.399962)));
      final normal_3_191 = mesh_3.normals.elementAt(191);
      expect(normal_3_191, vector3MoreOrLessEquals(Vector3(-0.776094, -0.562737, -0.284613)));
      final normal_3_192 = mesh_3.normals.elementAt(192);
      expect(normal_3_192, vector3MoreOrLessEquals(Vector3(0.455951, -0.795072, -0.399962)));
      final normal_3_193 = mesh_3.normals.elementAt(193);
      expect(normal_3_193, vector3MoreOrLessEquals(Vector3(-0.231599, -0.234207, -0.944198)));
      final normal_3_194 = mesh_3.normals.elementAt(194);
      expect(normal_3_194, vector3MoreOrLessEquals(Vector3(-0.248105, -0.514857, -0.820589)));
      final normal_3_195 = mesh_3.normals.elementAt(195);
      expect(normal_3_195, vector3MoreOrLessEquals(Vector3(0.455951, -0.795072, -0.399962)));
      final normal_3_196 = mesh_3.normals.elementAt(196);
      expect(normal_3_196, vector3MoreOrLessEquals(Vector3(0.489715, -0.524665, -0.696352)));
      final normal_3_197 = mesh_3.normals.elementAt(197);
      expect(normal_3_197, vector3MoreOrLessEquals(Vector3(-0.231599, -0.234207, -0.944198)));
      final normal_3_198 = mesh_3.normals.elementAt(198);
      expect(normal_3_198, vector3MoreOrLessEquals(Vector3(0.515843, -0.63658, -0.5733)));
      final normal_3_199 = mesh_3.normals.elementAt(199);
      expect(normal_3_199, vector3MoreOrLessEquals(Vector3(-0.23595, -0.324119, -0.916119)));
      final normal_3_200 = mesh_3.normals.elementAt(200);
      expect(normal_3_200, vector3MoreOrLessEquals(Vector3(-0.231599, -0.234207, -0.944198)));
      final normal_3_201 = mesh_3.normals.elementAt(201);
      expect(normal_3_201, vector3MoreOrLessEquals(Vector3(0.489715, -0.524665, -0.696352)));
      final normal_3_202 = mesh_3.normals.elementAt(202);
      expect(normal_3_202, vector3MoreOrLessEquals(Vector3(0.515843, -0.63658, -0.5733)));
      final normal_3_203 = mesh_3.normals.elementAt(203);
      expect(normal_3_203, vector3MoreOrLessEquals(Vector3(-0.231599, -0.234207, -0.944198)));
      final normal_3_204 = mesh_3.normals.elementAt(204);
      expect(normal_3_204, vector3MoreOrLessEquals(Vector3(0.515843, -0.63658, -0.5733)));
      final normal_3_205 = mesh_3.normals.elementAt(205);
      expect(normal_3_205, vector3MoreOrLessEquals(Vector3(-0.342337, -0.448272, -0.825747)));
      final normal_3_206 = mesh_3.normals.elementAt(206);
      expect(normal_3_206, vector3MoreOrLessEquals(Vector3(-0.23595, -0.324119, -0.916119)));
      final normal_3_207 = mesh_3.normals.elementAt(207);
      expect(normal_3_207, vector3MoreOrLessEquals(Vector3(0.515843, -0.63658, -0.5733)));
      final normal_3_208 = mesh_3.normals.elementAt(208);
      expect(normal_3_208, vector3MoreOrLessEquals(Vector3(0.423912, -0.809501, -0.40621)));
      final normal_3_209 = mesh_3.normals.elementAt(209);
      expect(normal_3_209, vector3MoreOrLessEquals(Vector3(-0.342337, -0.448272, -0.825747)));
      final normal_3_210 = mesh_3.normals.elementAt(210);
      expect(normal_3_210, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_211 = mesh_3.normals.elementAt(211);
      expect(normal_3_211, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_212 = mesh_3.normals.elementAt(212);
      expect(normal_3_212, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_213 = mesh_3.normals.elementAt(213);
      expect(normal_3_213, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_214 = mesh_3.normals.elementAt(214);
      expect(normal_3_214, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_215 = mesh_3.normals.elementAt(215);
      expect(normal_3_215, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_216 = mesh_3.normals.elementAt(216);
      expect(normal_3_216, vector3MoreOrLessEquals(Vector3(0.535603, -0.635581, 0.556027)));
      final normal_3_217 = mesh_3.normals.elementAt(217);
      expect(normal_3_217, vector3MoreOrLessEquals(Vector3(-0.389047, -0.677991, 0.623675)));
      final normal_3_218 = mesh_3.normals.elementAt(218);
      expect(normal_3_218, vector3MoreOrLessEquals(Vector3(-0.286549, -0.868467, 0.404542)));
      final normal_3_219 = mesh_3.normals.elementAt(219);
      expect(normal_3_219, vector3MoreOrLessEquals(Vector3(0.535603, -0.635581, 0.556027)));
      final normal_3_220 = mesh_3.normals.elementAt(220);
      expect(normal_3_220, vector3MoreOrLessEquals(Vector3(0.490862, -0.467516, 0.735176)));
      final normal_3_221 = mesh_3.normals.elementAt(221);
      expect(normal_3_221, vector3MoreOrLessEquals(Vector3(-0.389047, -0.677991, 0.623675)));
      final normal_3_222 = mesh_3.normals.elementAt(222);
      expect(normal_3_222, vector3MoreOrLessEquals(Vector3(0.731377, -0.368576, 0.573793)));
      final normal_3_223 = mesh_3.normals.elementAt(223);
      expect(normal_3_223, vector3MoreOrLessEquals(Vector3(-0.058292, -0.911347, 0.407491)));
      final normal_3_224 = mesh_3.normals.elementAt(224);
      expect(normal_3_224, vector3MoreOrLessEquals(Vector3(-0.389047, -0.677991, 0.623675)));
      final normal_3_225 = mesh_3.normals.elementAt(225);
      expect(normal_3_225, vector3MoreOrLessEquals(Vector3(0.490862, -0.467516, 0.735176)));
      final normal_3_226 = mesh_3.normals.elementAt(226);
      expect(normal_3_226, vector3MoreOrLessEquals(Vector3(0.731377, -0.368576, 0.573793)));
      final normal_3_227 = mesh_3.normals.elementAt(227);
      expect(normal_3_227, vector3MoreOrLessEquals(Vector3(-0.389047, -0.677991, 0.623675)));
      final normal_3_228 = mesh_3.normals.elementAt(228);
      expect(normal_3_228, vector3MoreOrLessEquals(Vector3(0.731377, -0.368576, 0.573793)));
      final normal_3_229 = mesh_3.normals.elementAt(229);
      expect(normal_3_229, vector3MoreOrLessEquals(Vector3(0.455951, -0.795072, -0.399962)));
      final normal_3_230 = mesh_3.normals.elementAt(230);
      expect(normal_3_230, vector3MoreOrLessEquals(Vector3(-0.058292, -0.911347, 0.407491)));
      final normal_3_231 = mesh_3.normals.elementAt(231);
      expect(normal_3_231, vector3MoreOrLessEquals(Vector3(0.731377, -0.368576, 0.573793)));
      final normal_3_232 = mesh_3.normals.elementAt(232);
      expect(normal_3_232, vector3MoreOrLessEquals(Vector3(0.890119, -0.387697, 0.239538)));
      final normal_3_233 = mesh_3.normals.elementAt(233);
      expect(normal_3_233, vector3MoreOrLessEquals(Vector3(0.455951, -0.795072, -0.399962)));
      final normal_3_234 = mesh_3.normals.elementAt(234);
      expect(normal_3_234, vector3MoreOrLessEquals(Vector3(0.88363, -0.40412, 0.236399)));
      final normal_3_235 = mesh_3.normals.elementAt(235);
      expect(normal_3_235, vector3MoreOrLessEquals(Vector3(0.489715, -0.524665, -0.696352)));
      final normal_3_236 = mesh_3.normals.elementAt(236);
      expect(normal_3_236, vector3MoreOrLessEquals(Vector3(0.455951, -0.795072, -0.399962)));
      final normal_3_237 = mesh_3.normals.elementAt(237);
      expect(normal_3_237, vector3MoreOrLessEquals(Vector3(0.890119, -0.387697, 0.239538)));
      final normal_3_238 = mesh_3.normals.elementAt(238);
      expect(normal_3_238, vector3MoreOrLessEquals(Vector3(0.88363, -0.40412, 0.236399)));
      final normal_3_239 = mesh_3.normals.elementAt(239);
      expect(normal_3_239, vector3MoreOrLessEquals(Vector3(0.455951, -0.795072, -0.399962)));
      final normal_3_240 = mesh_3.normals.elementAt(240);
      expect(normal_3_240, vector3MoreOrLessEquals(Vector3(0.88363, -0.40412, 0.236399)));
      final normal_3_241 = mesh_3.normals.elementAt(241);
      expect(normal_3_241, vector3MoreOrLessEquals(Vector3(0.515843, -0.63658, -0.5733)));
      final normal_3_242 = mesh_3.normals.elementAt(242);
      expect(normal_3_242, vector3MoreOrLessEquals(Vector3(0.489715, -0.524665, -0.696352)));
      final normal_3_243 = mesh_3.normals.elementAt(243);
      expect(normal_3_243, vector3MoreOrLessEquals(Vector3(0.88363, -0.40412, 0.236399)));
      final normal_3_244 = mesh_3.normals.elementAt(244);
      expect(normal_3_244, vector3MoreOrLessEquals(Vector3(0.822699, -0.32454, 0.466733)));
      final normal_3_245 = mesh_3.normals.elementAt(245);
      expect(normal_3_245, vector3MoreOrLessEquals(Vector3(0.515843, -0.63658, -0.5733)));
      final normal_3_246 = mesh_3.normals.elementAt(246);
      expect(normal_3_246, vector3MoreOrLessEquals(Vector3(0.789247, -0.408589, 0.458414)));
      final normal_3_247 = mesh_3.normals.elementAt(247);
      expect(normal_3_247, vector3MoreOrLessEquals(Vector3(0.423912, -0.809501, -0.40621)));
      final normal_3_248 = mesh_3.normals.elementAt(248);
      expect(normal_3_248, vector3MoreOrLessEquals(Vector3(0.515843, -0.63658, -0.5733)));
      final normal_3_249 = mesh_3.normals.elementAt(249);
      expect(normal_3_249, vector3MoreOrLessEquals(Vector3(0.822699, -0.32454, 0.466733)));
      final normal_3_250 = mesh_3.normals.elementAt(250);
      expect(normal_3_250, vector3MoreOrLessEquals(Vector3(0.789247, -0.408589, 0.458414)));
      final normal_3_251 = mesh_3.normals.elementAt(251);
      expect(normal_3_251, vector3MoreOrLessEquals(Vector3(0.515843, -0.63658, -0.5733)));
      final normal_3_252 = mesh_3.normals.elementAt(252);
      expect(normal_3_252, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_253 = mesh_3.normals.elementAt(253);
      expect(normal_3_253, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_254 = mesh_3.normals.elementAt(254);
      expect(normal_3_254, vector3MoreOrLessEquals(Vector3(0.076768, -0.902254, -0.424317)));
      final normal_3_255 = mesh_3.normals.elementAt(255);
      expect(normal_3_255, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_256 = mesh_3.normals.elementAt(256);
      expect(normal_3_256, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_257 = mesh_3.normals.elementAt(257);
      expect(normal_3_257, vector3MoreOrLessEquals(Vector3(-0.760858, -0.310029, 0.570067)));
      final normal_3_258 = mesh_3.normals.elementAt(258);
      expect(normal_3_258, vector3MoreOrLessEquals(Vector3(0.918945, -0.018611, 0.393945)));
      final normal_3_259 = mesh_3.normals.elementAt(259);
      expect(normal_3_259, vector3MoreOrLessEquals(Vector3(0.490862, -0.467516, 0.735176)));
      final normal_3_260 = mesh_3.normals.elementAt(260);
      expect(normal_3_260, vector3MoreOrLessEquals(Vector3(0.535603, -0.635581, 0.556027)));
      final normal_3_261 = mesh_3.normals.elementAt(261);
      expect(normal_3_261, vector3MoreOrLessEquals(Vector3(0.946923, 0.242706, 0.210787)));
      final normal_3_262 = mesh_3.normals.elementAt(262);
      expect(normal_3_262, vector3MoreOrLessEquals(Vector3(0.918945, -0.018611, 0.393945)));
      final normal_3_263 = mesh_3.normals.elementAt(263);
      expect(normal_3_263, vector3MoreOrLessEquals(Vector3(0.535603, -0.635581, 0.556027)));
      final normal_3_264 = mesh_3.normals.elementAt(264);
      expect(normal_3_264, vector3MoreOrLessEquals(Vector3(0.918945, -0.018611, 0.393945)));
      final normal_3_265 = mesh_3.normals.elementAt(265);
      expect(normal_3_265, vector3MoreOrLessEquals(Vector3(0.731377, -0.368576, 0.573793)));
      final normal_3_266 = mesh_3.normals.elementAt(266);
      expect(normal_3_266, vector3MoreOrLessEquals(Vector3(0.490862, -0.467516, 0.735176)));
      final normal_3_267 = mesh_3.normals.elementAt(267);
      expect(normal_3_267, vector3MoreOrLessEquals(Vector3(0.918945, -0.018611, 0.393945)));
      final normal_3_268 = mesh_3.normals.elementAt(268);
      expect(normal_3_268, vector3MoreOrLessEquals(Vector3(0.898457, 0.395975, 0.189682)));
      final normal_3_269 = mesh_3.normals.elementAt(269);
      expect(normal_3_269, vector3MoreOrLessEquals(Vector3(0.731377, -0.368576, 0.573793)));
      final normal_3_270 = mesh_3.normals.elementAt(270);
      expect(normal_3_270, vector3MoreOrLessEquals(Vector3(0.814891, 0.173456, 0.553052)));
      final normal_3_271 = mesh_3.normals.elementAt(271);
      expect(normal_3_271, vector3MoreOrLessEquals(Vector3(0.890119, -0.387697, 0.239538)));
      final normal_3_272 = mesh_3.normals.elementAt(272);
      expect(normal_3_272, vector3MoreOrLessEquals(Vector3(0.731377, -0.368576, 0.573793)));
      final normal_3_273 = mesh_3.normals.elementAt(273);
      expect(normal_3_273, vector3MoreOrLessEquals(Vector3(0.898457, 0.395975, 0.189682)));
      final normal_3_274 = mesh_3.normals.elementAt(274);
      expect(normal_3_274, vector3MoreOrLessEquals(Vector3(0.814891, 0.173456, 0.553052)));
      final normal_3_275 = mesh_3.normals.elementAt(275);
      expect(normal_3_275, vector3MoreOrLessEquals(Vector3(0.731377, -0.368576, 0.573793)));
      final normal_3_276 = mesh_3.normals.elementAt(276);
      expect(normal_3_276, vector3MoreOrLessEquals(Vector3(0.814891, 0.173456, 0.553052)));
      final normal_3_277 = mesh_3.normals.elementAt(277);
      expect(normal_3_277, vector3MoreOrLessEquals(Vector3(0.88363, -0.40412, 0.236399)));
      final normal_3_278 = mesh_3.normals.elementAt(278);
      expect(normal_3_278, vector3MoreOrLessEquals(Vector3(0.890119, -0.387697, 0.239538)));
      final normal_3_279 = mesh_3.normals.elementAt(279);
      expect(normal_3_279, vector3MoreOrLessEquals(Vector3(0.814891, 0.173456, 0.553052)));
      final normal_3_280 = mesh_3.normals.elementAt(280);
      expect(normal_3_280, vector3MoreOrLessEquals(Vector3(0.488324, 0.052196, 0.8711)));
      final normal_3_281 = mesh_3.normals.elementAt(281);
      expect(normal_3_281, vector3MoreOrLessEquals(Vector3(0.88363, -0.40412, 0.236399)));
      final normal_3_282 = mesh_3.normals.elementAt(282);
      expect(normal_3_282, vector3MoreOrLessEquals(Vector3(0.562606, 0.01165, 0.826643)));
      final normal_3_283 = mesh_3.normals.elementAt(283);
      expect(normal_3_283, vector3MoreOrLessEquals(Vector3(0.822699, -0.32454, 0.466733)));
      final normal_3_284 = mesh_3.normals.elementAt(284);
      expect(normal_3_284, vector3MoreOrLessEquals(Vector3(0.88363, -0.40412, 0.236399)));
      final normal_3_285 = mesh_3.normals.elementAt(285);
      expect(normal_3_285, vector3MoreOrLessEquals(Vector3(0.488324, 0.052196, 0.8711)));
      final normal_3_286 = mesh_3.normals.elementAt(286);
      expect(normal_3_286, vector3MoreOrLessEquals(Vector3(0.562606, 0.01165, 0.826643)));
      final normal_3_287 = mesh_3.normals.elementAt(287);
      expect(normal_3_287, vector3MoreOrLessEquals(Vector3(0.88363, -0.40412, 0.236399)));
      final normal_3_288 = mesh_3.normals.elementAt(288);
      expect(normal_3_288, vector3MoreOrLessEquals(Vector3(0.562606, 0.01165, 0.826643)));
      final normal_3_289 = mesh_3.normals.elementAt(289);
      expect(normal_3_289, vector3MoreOrLessEquals(Vector3(0.789247, -0.408589, 0.458414)));
      final normal_3_290 = mesh_3.normals.elementAt(290);
      expect(normal_3_290, vector3MoreOrLessEquals(Vector3(0.822699, -0.32454, 0.466733)));
      final normal_3_291 = mesh_3.normals.elementAt(291);
      expect(normal_3_291, vector3MoreOrLessEquals(Vector3(0.562606, 0.01165, 0.826643)));
      final normal_3_292 = mesh_3.normals.elementAt(292);
      expect(normal_3_292, vector3MoreOrLessEquals(Vector3(0.424549, 0.220069, 0.878253)));
      final normal_3_293 = mesh_3.normals.elementAt(293);
      expect(normal_3_293, vector3MoreOrLessEquals(Vector3(0.789247, -0.408589, 0.458414)));
      expect(mesh_3.tangents.length, isZero);
      expect(mesh_3.bitangents.length, isZero);
      expect(mesh_3.colors.length, isZero);
      expect(mesh_3.textureCoords.length, equals(1));
      final textureCoords_3_0 = mesh_3.textureCoords.elementAt(0);
      expect(textureCoords_3_0.length, equals(294));
      final textureCoord_3_0_0 = textureCoords_3_0.elementAt(0);
      expect(textureCoord_3_0_0, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_1 = textureCoords_3_0.elementAt(1);
      expect(textureCoord_3_0_1, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_2 = textureCoords_3_0.elementAt(2);
      expect(textureCoord_3_0_2, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_3 = textureCoords_3_0.elementAt(3);
      expect(textureCoord_3_0_3, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_4 = textureCoords_3_0.elementAt(4);
      expect(textureCoord_3_0_4, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_5 = textureCoords_3_0.elementAt(5);
      expect(textureCoord_3_0_5, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_6 = textureCoords_3_0.elementAt(6);
      expect(textureCoord_3_0_6, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_3_0_7 = textureCoords_3_0.elementAt(7);
      expect(textureCoord_3_0_7, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_3_0_8 = textureCoords_3_0.elementAt(8);
      expect(textureCoord_3_0_8, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_3_0_9 = textureCoords_3_0.elementAt(9);
      expect(textureCoord_3_0_9, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_3_0_10 = textureCoords_3_0.elementAt(10);
      expect(textureCoord_3_0_10, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_3_0_11 = textureCoords_3_0.elementAt(11);
      expect(textureCoord_3_0_11, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_3_0_12 = textureCoords_3_0.elementAt(12);
      expect(textureCoord_3_0_12, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_3_0_13 = textureCoords_3_0.elementAt(13);
      expect(textureCoord_3_0_13, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_3_0_14 = textureCoords_3_0.elementAt(14);
      expect(textureCoord_3_0_14, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_3_0_15 = textureCoords_3_0.elementAt(15);
      expect(textureCoord_3_0_15, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_3_0_16 = textureCoords_3_0.elementAt(16);
      expect(textureCoord_3_0_16, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_3_0_17 = textureCoords_3_0.elementAt(17);
      expect(textureCoord_3_0_17, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_3_0_18 = textureCoords_3_0.elementAt(18);
      expect(textureCoord_3_0_18, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_3_0_19 = textureCoords_3_0.elementAt(19);
      expect(textureCoord_3_0_19, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_3_0_20 = textureCoords_3_0.elementAt(20);
      expect(textureCoord_3_0_20, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_3_0_21 = textureCoords_3_0.elementAt(21);
      expect(textureCoord_3_0_21, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_3_0_22 = textureCoords_3_0.elementAt(22);
      expect(textureCoord_3_0_22, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_3_0_23 = textureCoords_3_0.elementAt(23);
      expect(textureCoord_3_0_23, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_3_0_24 = textureCoords_3_0.elementAt(24);
      expect(textureCoord_3_0_24, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_3_0_25 = textureCoords_3_0.elementAt(25);
      expect(textureCoord_3_0_25, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_3_0_26 = textureCoords_3_0.elementAt(26);
      expect(textureCoord_3_0_26, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_3_0_27 = textureCoords_3_0.elementAt(27);
      expect(textureCoord_3_0_27, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_3_0_28 = textureCoords_3_0.elementAt(28);
      expect(textureCoord_3_0_28, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_3_0_29 = textureCoords_3_0.elementAt(29);
      expect(textureCoord_3_0_29, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_3_0_30 = textureCoords_3_0.elementAt(30);
      expect(textureCoord_3_0_30, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_3_0_31 = textureCoords_3_0.elementAt(31);
      expect(textureCoord_3_0_31, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_3_0_32 = textureCoords_3_0.elementAt(32);
      expect(textureCoord_3_0_32, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_3_0_33 = textureCoords_3_0.elementAt(33);
      expect(textureCoord_3_0_33, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_3_0_34 = textureCoords_3_0.elementAt(34);
      expect(textureCoord_3_0_34, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_3_0_35 = textureCoords_3_0.elementAt(35);
      expect(textureCoord_3_0_35, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_3_0_36 = textureCoords_3_0.elementAt(36);
      expect(textureCoord_3_0_36, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_3_0_37 = textureCoords_3_0.elementAt(37);
      expect(textureCoord_3_0_37, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_38 = textureCoords_3_0.elementAt(38);
      expect(textureCoord_3_0_38, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_3_0_39 = textureCoords_3_0.elementAt(39);
      expect(textureCoord_3_0_39, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_3_0_40 = textureCoords_3_0.elementAt(40);
      expect(textureCoord_3_0_40, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_3_0_41 = textureCoords_3_0.elementAt(41);
      expect(textureCoord_3_0_41, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_42 = textureCoords_3_0.elementAt(42);
      expect(textureCoord_3_0_42, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_43 = textureCoords_3_0.elementAt(43);
      expect(textureCoord_3_0_43, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_44 = textureCoords_3_0.elementAt(44);
      expect(textureCoord_3_0_44, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_45 = textureCoords_3_0.elementAt(45);
      expect(textureCoord_3_0_45, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_46 = textureCoords_3_0.elementAt(46);
      expect(textureCoord_3_0_46, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_47 = textureCoords_3_0.elementAt(47);
      expect(textureCoord_3_0_47, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_48 = textureCoords_3_0.elementAt(48);
      expect(textureCoord_3_0_48, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_3_0_49 = textureCoords_3_0.elementAt(49);
      expect(textureCoord_3_0_49, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_3_0_50 = textureCoords_3_0.elementAt(50);
      expect(textureCoord_3_0_50, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_3_0_51 = textureCoords_3_0.elementAt(51);
      expect(textureCoord_3_0_51, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_3_0_52 = textureCoords_3_0.elementAt(52);
      expect(textureCoord_3_0_52, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_3_0_53 = textureCoords_3_0.elementAt(53);
      expect(textureCoord_3_0_53, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_3_0_54 = textureCoords_3_0.elementAt(54);
      expect(textureCoord_3_0_54, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_3_0_55 = textureCoords_3_0.elementAt(55);
      expect(textureCoord_3_0_55, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_3_0_56 = textureCoords_3_0.elementAt(56);
      expect(textureCoord_3_0_56, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_3_0_57 = textureCoords_3_0.elementAt(57);
      expect(textureCoord_3_0_57, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_3_0_58 = textureCoords_3_0.elementAt(58);
      expect(textureCoord_3_0_58, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_3_0_59 = textureCoords_3_0.elementAt(59);
      expect(textureCoord_3_0_59, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_3_0_60 = textureCoords_3_0.elementAt(60);
      expect(textureCoord_3_0_60, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_3_0_61 = textureCoords_3_0.elementAt(61);
      expect(textureCoord_3_0_61, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_3_0_62 = textureCoords_3_0.elementAt(62);
      expect(textureCoord_3_0_62, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_3_0_63 = textureCoords_3_0.elementAt(63);
      expect(textureCoord_3_0_63, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_3_0_64 = textureCoords_3_0.elementAt(64);
      expect(textureCoord_3_0_64, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_3_0_65 = textureCoords_3_0.elementAt(65);
      expect(textureCoord_3_0_65, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_3_0_66 = textureCoords_3_0.elementAt(66);
      expect(textureCoord_3_0_66, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_3_0_67 = textureCoords_3_0.elementAt(67);
      expect(textureCoord_3_0_67, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_3_0_68 = textureCoords_3_0.elementAt(68);
      expect(textureCoord_3_0_68, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_3_0_69 = textureCoords_3_0.elementAt(69);
      expect(textureCoord_3_0_69, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_3_0_70 = textureCoords_3_0.elementAt(70);
      expect(textureCoord_3_0_70, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_3_0_71 = textureCoords_3_0.elementAt(71);
      expect(textureCoord_3_0_71, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_3_0_72 = textureCoords_3_0.elementAt(72);
      expect(textureCoord_3_0_72, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_3_0_73 = textureCoords_3_0.elementAt(73);
      expect(textureCoord_3_0_73, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_3_0_74 = textureCoords_3_0.elementAt(74);
      expect(textureCoord_3_0_74, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_3_0_75 = textureCoords_3_0.elementAt(75);
      expect(textureCoord_3_0_75, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_3_0_76 = textureCoords_3_0.elementAt(76);
      expect(textureCoord_3_0_76, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_3_0_77 = textureCoords_3_0.elementAt(77);
      expect(textureCoord_3_0_77, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_3_0_78 = textureCoords_3_0.elementAt(78);
      expect(textureCoord_3_0_78, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_3_0_79 = textureCoords_3_0.elementAt(79);
      expect(textureCoord_3_0_79, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_3_0_80 = textureCoords_3_0.elementAt(80);
      expect(textureCoord_3_0_80, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_3_0_81 = textureCoords_3_0.elementAt(81);
      expect(textureCoord_3_0_81, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_3_0_82 = textureCoords_3_0.elementAt(82);
      expect(textureCoord_3_0_82, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_3_0_83 = textureCoords_3_0.elementAt(83);
      expect(textureCoord_3_0_83, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_3_0_84 = textureCoords_3_0.elementAt(84);
      expect(textureCoord_3_0_84, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_85 = textureCoords_3_0.elementAt(85);
      expect(textureCoord_3_0_85, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_86 = textureCoords_3_0.elementAt(86);
      expect(textureCoord_3_0_86, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_87 = textureCoords_3_0.elementAt(87);
      expect(textureCoord_3_0_87, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_88 = textureCoords_3_0.elementAt(88);
      expect(textureCoord_3_0_88, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_89 = textureCoords_3_0.elementAt(89);
      expect(textureCoord_3_0_89, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_90 = textureCoords_3_0.elementAt(90);
      expect(textureCoord_3_0_90, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_3_0_91 = textureCoords_3_0.elementAt(91);
      expect(textureCoord_3_0_91, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_3_0_92 = textureCoords_3_0.elementAt(92);
      expect(textureCoord_3_0_92, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_3_0_93 = textureCoords_3_0.elementAt(93);
      expect(textureCoord_3_0_93, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_3_0_94 = textureCoords_3_0.elementAt(94);
      expect(textureCoord_3_0_94, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_3_0_95 = textureCoords_3_0.elementAt(95);
      expect(textureCoord_3_0_95, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_3_0_96 = textureCoords_3_0.elementAt(96);
      expect(textureCoord_3_0_96, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_3_0_97 = textureCoords_3_0.elementAt(97);
      expect(textureCoord_3_0_97, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_3_0_98 = textureCoords_3_0.elementAt(98);
      expect(textureCoord_3_0_98, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_3_0_99 = textureCoords_3_0.elementAt(99);
      expect(textureCoord_3_0_99, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_3_0_100 = textureCoords_3_0.elementAt(100);
      expect(textureCoord_3_0_100, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_3_0_101 = textureCoords_3_0.elementAt(101);
      expect(textureCoord_3_0_101, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_3_0_102 = textureCoords_3_0.elementAt(102);
      expect(textureCoord_3_0_102, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_3_0_103 = textureCoords_3_0.elementAt(103);
      expect(textureCoord_3_0_103, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_3_0_104 = textureCoords_3_0.elementAt(104);
      expect(textureCoord_3_0_104, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_3_0_105 = textureCoords_3_0.elementAt(105);
      expect(textureCoord_3_0_105, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_3_0_106 = textureCoords_3_0.elementAt(106);
      expect(textureCoord_3_0_106, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_3_0_107 = textureCoords_3_0.elementAt(107);
      expect(textureCoord_3_0_107, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_3_0_108 = textureCoords_3_0.elementAt(108);
      expect(textureCoord_3_0_108, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_3_0_109 = textureCoords_3_0.elementAt(109);
      expect(textureCoord_3_0_109, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_3_0_110 = textureCoords_3_0.elementAt(110);
      expect(textureCoord_3_0_110, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_3_0_111 = textureCoords_3_0.elementAt(111);
      expect(textureCoord_3_0_111, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_3_0_112 = textureCoords_3_0.elementAt(112);
      expect(textureCoord_3_0_112, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_3_0_113 = textureCoords_3_0.elementAt(113);
      expect(textureCoord_3_0_113, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_3_0_114 = textureCoords_3_0.elementAt(114);
      expect(textureCoord_3_0_114, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_3_0_115 = textureCoords_3_0.elementAt(115);
      expect(textureCoord_3_0_115, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_3_0_116 = textureCoords_3_0.elementAt(116);
      expect(textureCoord_3_0_116, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_3_0_117 = textureCoords_3_0.elementAt(117);
      expect(textureCoord_3_0_117, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_3_0_118 = textureCoords_3_0.elementAt(118);
      expect(textureCoord_3_0_118, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_3_0_119 = textureCoords_3_0.elementAt(119);
      expect(textureCoord_3_0_119, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_3_0_120 = textureCoords_3_0.elementAt(120);
      expect(textureCoord_3_0_120, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_3_0_121 = textureCoords_3_0.elementAt(121);
      expect(textureCoord_3_0_121, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_3_0_122 = textureCoords_3_0.elementAt(122);
      expect(textureCoord_3_0_122, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_3_0_123 = textureCoords_3_0.elementAt(123);
      expect(textureCoord_3_0_123, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_3_0_124 = textureCoords_3_0.elementAt(124);
      expect(textureCoord_3_0_124, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_3_0_125 = textureCoords_3_0.elementAt(125);
      expect(textureCoord_3_0_125, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_3_0_126 = textureCoords_3_0.elementAt(126);
      expect(textureCoord_3_0_126, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_127 = textureCoords_3_0.elementAt(127);
      expect(textureCoord_3_0_127, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_128 = textureCoords_3_0.elementAt(128);
      expect(textureCoord_3_0_128, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_129 = textureCoords_3_0.elementAt(129);
      expect(textureCoord_3_0_129, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_130 = textureCoords_3_0.elementAt(130);
      expect(textureCoord_3_0_130, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_131 = textureCoords_3_0.elementAt(131);
      expect(textureCoord_3_0_131, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_132 = textureCoords_3_0.elementAt(132);
      expect(textureCoord_3_0_132, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_3_0_133 = textureCoords_3_0.elementAt(133);
      expect(textureCoord_3_0_133, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_3_0_134 = textureCoords_3_0.elementAt(134);
      expect(textureCoord_3_0_134, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_3_0_135 = textureCoords_3_0.elementAt(135);
      expect(textureCoord_3_0_135, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_3_0_136 = textureCoords_3_0.elementAt(136);
      expect(textureCoord_3_0_136, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_3_0_137 = textureCoords_3_0.elementAt(137);
      expect(textureCoord_3_0_137, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_3_0_138 = textureCoords_3_0.elementAt(138);
      expect(textureCoord_3_0_138, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_3_0_139 = textureCoords_3_0.elementAt(139);
      expect(textureCoord_3_0_139, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_3_0_140 = textureCoords_3_0.elementAt(140);
      expect(textureCoord_3_0_140, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_3_0_141 = textureCoords_3_0.elementAt(141);
      expect(textureCoord_3_0_141, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_3_0_142 = textureCoords_3_0.elementAt(142);
      expect(textureCoord_3_0_142, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_3_0_143 = textureCoords_3_0.elementAt(143);
      expect(textureCoord_3_0_143, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_3_0_144 = textureCoords_3_0.elementAt(144);
      expect(textureCoord_3_0_144, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_3_0_145 = textureCoords_3_0.elementAt(145);
      expect(textureCoord_3_0_145, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_3_0_146 = textureCoords_3_0.elementAt(146);
      expect(textureCoord_3_0_146, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_3_0_147 = textureCoords_3_0.elementAt(147);
      expect(textureCoord_3_0_147, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_3_0_148 = textureCoords_3_0.elementAt(148);
      expect(textureCoord_3_0_148, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_3_0_149 = textureCoords_3_0.elementAt(149);
      expect(textureCoord_3_0_149, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_3_0_150 = textureCoords_3_0.elementAt(150);
      expect(textureCoord_3_0_150, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_3_0_151 = textureCoords_3_0.elementAt(151);
      expect(textureCoord_3_0_151, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_3_0_152 = textureCoords_3_0.elementAt(152);
      expect(textureCoord_3_0_152, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_3_0_153 = textureCoords_3_0.elementAt(153);
      expect(textureCoord_3_0_153, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_3_0_154 = textureCoords_3_0.elementAt(154);
      expect(textureCoord_3_0_154, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_3_0_155 = textureCoords_3_0.elementAt(155);
      expect(textureCoord_3_0_155, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_3_0_156 = textureCoords_3_0.elementAt(156);
      expect(textureCoord_3_0_156, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_3_0_157 = textureCoords_3_0.elementAt(157);
      expect(textureCoord_3_0_157, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_3_0_158 = textureCoords_3_0.elementAt(158);
      expect(textureCoord_3_0_158, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_3_0_159 = textureCoords_3_0.elementAt(159);
      expect(textureCoord_3_0_159, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_3_0_160 = textureCoords_3_0.elementAt(160);
      expect(textureCoord_3_0_160, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_3_0_161 = textureCoords_3_0.elementAt(161);
      expect(textureCoord_3_0_161, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_3_0_162 = textureCoords_3_0.elementAt(162);
      expect(textureCoord_3_0_162, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_3_0_163 = textureCoords_3_0.elementAt(163);
      expect(textureCoord_3_0_163, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_3_0_164 = textureCoords_3_0.elementAt(164);
      expect(textureCoord_3_0_164, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_3_0_165 = textureCoords_3_0.elementAt(165);
      expect(textureCoord_3_0_165, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_3_0_166 = textureCoords_3_0.elementAt(166);
      expect(textureCoord_3_0_166, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_3_0_167 = textureCoords_3_0.elementAt(167);
      expect(textureCoord_3_0_167, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_3_0_168 = textureCoords_3_0.elementAt(168);
      expect(textureCoord_3_0_168, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_169 = textureCoords_3_0.elementAt(169);
      expect(textureCoord_3_0_169, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_170 = textureCoords_3_0.elementAt(170);
      expect(textureCoord_3_0_170, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_171 = textureCoords_3_0.elementAt(171);
      expect(textureCoord_3_0_171, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_172 = textureCoords_3_0.elementAt(172);
      expect(textureCoord_3_0_172, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_173 = textureCoords_3_0.elementAt(173);
      expect(textureCoord_3_0_173, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_174 = textureCoords_3_0.elementAt(174);
      expect(textureCoord_3_0_174, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_3_0_175 = textureCoords_3_0.elementAt(175);
      expect(textureCoord_3_0_175, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_3_0_176 = textureCoords_3_0.elementAt(176);
      expect(textureCoord_3_0_176, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_3_0_177 = textureCoords_3_0.elementAt(177);
      expect(textureCoord_3_0_177, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_3_0_178 = textureCoords_3_0.elementAt(178);
      expect(textureCoord_3_0_178, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_3_0_179 = textureCoords_3_0.elementAt(179);
      expect(textureCoord_3_0_179, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_3_0_180 = textureCoords_3_0.elementAt(180);
      expect(textureCoord_3_0_180, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_3_0_181 = textureCoords_3_0.elementAt(181);
      expect(textureCoord_3_0_181, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_3_0_182 = textureCoords_3_0.elementAt(182);
      expect(textureCoord_3_0_182, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_3_0_183 = textureCoords_3_0.elementAt(183);
      expect(textureCoord_3_0_183, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_3_0_184 = textureCoords_3_0.elementAt(184);
      expect(textureCoord_3_0_184, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_3_0_185 = textureCoords_3_0.elementAt(185);
      expect(textureCoord_3_0_185, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_3_0_186 = textureCoords_3_0.elementAt(186);
      expect(textureCoord_3_0_186, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_3_0_187 = textureCoords_3_0.elementAt(187);
      expect(textureCoord_3_0_187, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_3_0_188 = textureCoords_3_0.elementAt(188);
      expect(textureCoord_3_0_188, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_3_0_189 = textureCoords_3_0.elementAt(189);
      expect(textureCoord_3_0_189, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_3_0_190 = textureCoords_3_0.elementAt(190);
      expect(textureCoord_3_0_190, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_3_0_191 = textureCoords_3_0.elementAt(191);
      expect(textureCoord_3_0_191, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_3_0_192 = textureCoords_3_0.elementAt(192);
      expect(textureCoord_3_0_192, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_3_0_193 = textureCoords_3_0.elementAt(193);
      expect(textureCoord_3_0_193, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_3_0_194 = textureCoords_3_0.elementAt(194);
      expect(textureCoord_3_0_194, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_3_0_195 = textureCoords_3_0.elementAt(195);
      expect(textureCoord_3_0_195, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_3_0_196 = textureCoords_3_0.elementAt(196);
      expect(textureCoord_3_0_196, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_3_0_197 = textureCoords_3_0.elementAt(197);
      expect(textureCoord_3_0_197, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_3_0_198 = textureCoords_3_0.elementAt(198);
      expect(textureCoord_3_0_198, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_3_0_199 = textureCoords_3_0.elementAt(199);
      expect(textureCoord_3_0_199, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_3_0_200 = textureCoords_3_0.elementAt(200);
      expect(textureCoord_3_0_200, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_3_0_201 = textureCoords_3_0.elementAt(201);
      expect(textureCoord_3_0_201, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_3_0_202 = textureCoords_3_0.elementAt(202);
      expect(textureCoord_3_0_202, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_3_0_203 = textureCoords_3_0.elementAt(203);
      expect(textureCoord_3_0_203, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_3_0_204 = textureCoords_3_0.elementAt(204);
      expect(textureCoord_3_0_204, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_3_0_205 = textureCoords_3_0.elementAt(205);
      expect(textureCoord_3_0_205, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_3_0_206 = textureCoords_3_0.elementAt(206);
      expect(textureCoord_3_0_206, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_3_0_207 = textureCoords_3_0.elementAt(207);
      expect(textureCoord_3_0_207, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_3_0_208 = textureCoords_3_0.elementAt(208);
      expect(textureCoord_3_0_208, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_3_0_209 = textureCoords_3_0.elementAt(209);
      expect(textureCoord_3_0_209, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_3_0_210 = textureCoords_3_0.elementAt(210);
      expect(textureCoord_3_0_210, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_211 = textureCoords_3_0.elementAt(211);
      expect(textureCoord_3_0_211, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_212 = textureCoords_3_0.elementAt(212);
      expect(textureCoord_3_0_212, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_213 = textureCoords_3_0.elementAt(213);
      expect(textureCoord_3_0_213, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_214 = textureCoords_3_0.elementAt(214);
      expect(textureCoord_3_0_214, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_215 = textureCoords_3_0.elementAt(215);
      expect(textureCoord_3_0_215, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_216 = textureCoords_3_0.elementAt(216);
      expect(textureCoord_3_0_216, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_3_0_217 = textureCoords_3_0.elementAt(217);
      expect(textureCoord_3_0_217, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_3_0_218 = textureCoords_3_0.elementAt(218);
      expect(textureCoord_3_0_218, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_3_0_219 = textureCoords_3_0.elementAt(219);
      expect(textureCoord_3_0_219, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_3_0_220 = textureCoords_3_0.elementAt(220);
      expect(textureCoord_3_0_220, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_3_0_221 = textureCoords_3_0.elementAt(221);
      expect(textureCoord_3_0_221, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_3_0_222 = textureCoords_3_0.elementAt(222);
      expect(textureCoord_3_0_222, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_3_0_223 = textureCoords_3_0.elementAt(223);
      expect(textureCoord_3_0_223, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_3_0_224 = textureCoords_3_0.elementAt(224);
      expect(textureCoord_3_0_224, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_3_0_225 = textureCoords_3_0.elementAt(225);
      expect(textureCoord_3_0_225, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_3_0_226 = textureCoords_3_0.elementAt(226);
      expect(textureCoord_3_0_226, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_3_0_227 = textureCoords_3_0.elementAt(227);
      expect(textureCoord_3_0_227, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_3_0_228 = textureCoords_3_0.elementAt(228);
      expect(textureCoord_3_0_228, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_3_0_229 = textureCoords_3_0.elementAt(229);
      expect(textureCoord_3_0_229, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_3_0_230 = textureCoords_3_0.elementAt(230);
      expect(textureCoord_3_0_230, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_3_0_231 = textureCoords_3_0.elementAt(231);
      expect(textureCoord_3_0_231, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_3_0_232 = textureCoords_3_0.elementAt(232);
      expect(textureCoord_3_0_232, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_3_0_233 = textureCoords_3_0.elementAt(233);
      expect(textureCoord_3_0_233, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_3_0_234 = textureCoords_3_0.elementAt(234);
      expect(textureCoord_3_0_234, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_3_0_235 = textureCoords_3_0.elementAt(235);
      expect(textureCoord_3_0_235, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_3_0_236 = textureCoords_3_0.elementAt(236);
      expect(textureCoord_3_0_236, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_3_0_237 = textureCoords_3_0.elementAt(237);
      expect(textureCoord_3_0_237, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_3_0_238 = textureCoords_3_0.elementAt(238);
      expect(textureCoord_3_0_238, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_3_0_239 = textureCoords_3_0.elementAt(239);
      expect(textureCoord_3_0_239, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_3_0_240 = textureCoords_3_0.elementAt(240);
      expect(textureCoord_3_0_240, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_3_0_241 = textureCoords_3_0.elementAt(241);
      expect(textureCoord_3_0_241, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_3_0_242 = textureCoords_3_0.elementAt(242);
      expect(textureCoord_3_0_242, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_3_0_243 = textureCoords_3_0.elementAt(243);
      expect(textureCoord_3_0_243, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_3_0_244 = textureCoords_3_0.elementAt(244);
      expect(textureCoord_3_0_244, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_3_0_245 = textureCoords_3_0.elementAt(245);
      expect(textureCoord_3_0_245, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_3_0_246 = textureCoords_3_0.elementAt(246);
      expect(textureCoord_3_0_246, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_3_0_247 = textureCoords_3_0.elementAt(247);
      expect(textureCoord_3_0_247, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_3_0_248 = textureCoords_3_0.elementAt(248);
      expect(textureCoord_3_0_248, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_3_0_249 = textureCoords_3_0.elementAt(249);
      expect(textureCoord_3_0_249, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_3_0_250 = textureCoords_3_0.elementAt(250);
      expect(textureCoord_3_0_250, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_3_0_251 = textureCoords_3_0.elementAt(251);
      expect(textureCoord_3_0_251, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_3_0_252 = textureCoords_3_0.elementAt(252);
      expect(textureCoord_3_0_252, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_253 = textureCoords_3_0.elementAt(253);
      expect(textureCoord_3_0_253, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_254 = textureCoords_3_0.elementAt(254);
      expect(textureCoord_3_0_254, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_255 = textureCoords_3_0.elementAt(255);
      expect(textureCoord_3_0_255, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_256 = textureCoords_3_0.elementAt(256);
      expect(textureCoord_3_0_256, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_257 = textureCoords_3_0.elementAt(257);
      expect(textureCoord_3_0_257, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_3_0_258 = textureCoords_3_0.elementAt(258);
      expect(textureCoord_3_0_258, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_3_0_259 = textureCoords_3_0.elementAt(259);
      expect(textureCoord_3_0_259, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_3_0_260 = textureCoords_3_0.elementAt(260);
      expect(textureCoord_3_0_260, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_3_0_261 = textureCoords_3_0.elementAt(261);
      expect(textureCoord_3_0_261, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_3_0_262 = textureCoords_3_0.elementAt(262);
      expect(textureCoord_3_0_262, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_3_0_263 = textureCoords_3_0.elementAt(263);
      expect(textureCoord_3_0_263, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_3_0_264 = textureCoords_3_0.elementAt(264);
      expect(textureCoord_3_0_264, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_3_0_265 = textureCoords_3_0.elementAt(265);
      expect(textureCoord_3_0_265, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_3_0_266 = textureCoords_3_0.elementAt(266);
      expect(textureCoord_3_0_266, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_3_0_267 = textureCoords_3_0.elementAt(267);
      expect(textureCoord_3_0_267, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_3_0_268 = textureCoords_3_0.elementAt(268);
      expect(textureCoord_3_0_268, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_3_0_269 = textureCoords_3_0.elementAt(269);
      expect(textureCoord_3_0_269, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_3_0_270 = textureCoords_3_0.elementAt(270);
      expect(textureCoord_3_0_270, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_3_0_271 = textureCoords_3_0.elementAt(271);
      expect(textureCoord_3_0_271, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_3_0_272 = textureCoords_3_0.elementAt(272);
      expect(textureCoord_3_0_272, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_3_0_273 = textureCoords_3_0.elementAt(273);
      expect(textureCoord_3_0_273, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_3_0_274 = textureCoords_3_0.elementAt(274);
      expect(textureCoord_3_0_274, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_3_0_275 = textureCoords_3_0.elementAt(275);
      expect(textureCoord_3_0_275, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_3_0_276 = textureCoords_3_0.elementAt(276);
      expect(textureCoord_3_0_276, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_3_0_277 = textureCoords_3_0.elementAt(277);
      expect(textureCoord_3_0_277, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_3_0_278 = textureCoords_3_0.elementAt(278);
      expect(textureCoord_3_0_278, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_3_0_279 = textureCoords_3_0.elementAt(279);
      expect(textureCoord_3_0_279, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_3_0_280 = textureCoords_3_0.elementAt(280);
      expect(textureCoord_3_0_280, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_3_0_281 = textureCoords_3_0.elementAt(281);
      expect(textureCoord_3_0_281, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_3_0_282 = textureCoords_3_0.elementAt(282);
      expect(textureCoord_3_0_282, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_3_0_283 = textureCoords_3_0.elementAt(283);
      expect(textureCoord_3_0_283, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_3_0_284 = textureCoords_3_0.elementAt(284);
      expect(textureCoord_3_0_284, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_3_0_285 = textureCoords_3_0.elementAt(285);
      expect(textureCoord_3_0_285, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_3_0_286 = textureCoords_3_0.elementAt(286);
      expect(textureCoord_3_0_286, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_3_0_287 = textureCoords_3_0.elementAt(287);
      expect(textureCoord_3_0_287, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_3_0_288 = textureCoords_3_0.elementAt(288);
      expect(textureCoord_3_0_288, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_3_0_289 = textureCoords_3_0.elementAt(289);
      expect(textureCoord_3_0_289, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_3_0_290 = textureCoords_3_0.elementAt(290);
      expect(textureCoord_3_0_290, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_3_0_291 = textureCoords_3_0.elementAt(291);
      expect(textureCoord_3_0_291, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_3_0_292 = textureCoords_3_0.elementAt(292);
      expect(textureCoord_3_0_292, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_3_0_293 = textureCoords_3_0.elementAt(293);
      expect(textureCoord_3_0_293, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      expect(mesh_3.uvComponents.length, equals(1));
      expect(mesh_3.uvComponents, equals([2]));
      expect(mesh_3.faces.length, equals(98));
      expect(mesh_3.bones.length, isZero);
      expect(mesh_3.materialIndex, equals(4));
      expect(mesh_3.name, equals('Bein1Re'));
      expect(mesh_3.animMeshes.length, isZero);
      expect(mesh_3.morphingMethod, isZero);
      expect(mesh_3.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_4 = meshes.elementAt(4);
      expect(mesh_4.primitiveTypes, equals(4));
      expect(mesh_4.vertices.length, equals(294));
      final vertex_4_0 = mesh_4.vertices.elementAt(0);
      expect(vertex_4_0, vector3MoreOrLessEquals(Vector3(-32.5358, -3.15467, -19.1625)));
      final vertex_4_1 = mesh_4.vertices.elementAt(1);
      expect(vertex_4_1, vector3MoreOrLessEquals(Vector3(-34.3837, -1.82275, -16.6522)));
      final vertex_4_2 = mesh_4.vertices.elementAt(2);
      expect(vertex_4_2, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_3 = mesh_4.vertices.elementAt(3);
      expect(vertex_4_3, vector3MoreOrLessEquals(Vector3(-43.3858, -41.5832, -95.2187)));
      final vertex_4_4 = mesh_4.vertices.elementAt(4);
      expect(vertex_4_4, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_5 = mesh_4.vertices.elementAt(5);
      expect(vertex_4_5, vector3MoreOrLessEquals(Vector3(-43.6942, -41.0689, -95.4345)));
      final vertex_4_6 = mesh_4.vertices.elementAt(6);
      expect(vertex_4_6, vector3MoreOrLessEquals(Vector3(-32.5358, -3.15467, -19.1625)));
      final vertex_4_7 = mesh_4.vertices.elementAt(7);
      expect(vertex_4_7, vector3MoreOrLessEquals(Vector3(-35.099, 7.80456, -38.9793)));
      final vertex_4_8 = mesh_4.vertices.elementAt(8);
      expect(vertex_4_8, vector3MoreOrLessEquals(Vector3(-36.3516, 8.47676, -37.1534)));
      final vertex_4_9 = mesh_4.vertices.elementAt(9);
      expect(vertex_4_9, vector3MoreOrLessEquals(Vector3(-32.5358, -3.15467, -19.1625)));
      final vertex_4_10 = mesh_4.vertices.elementAt(10);
      expect(vertex_4_10, vector3MoreOrLessEquals(Vector3(-36.3516, 8.47676, -37.1534)));
      final vertex_4_11 = mesh_4.vertices.elementAt(11);
      expect(vertex_4_11, vector3MoreOrLessEquals(Vector3(-34.3837, -1.82275, -16.6522)));
      final vertex_4_12 = mesh_4.vertices.elementAt(12);
      expect(vertex_4_12, vector3MoreOrLessEquals(Vector3(-35.099, 7.80456, -38.9793)));
      final vertex_4_13 = mesh_4.vertices.elementAt(13);
      expect(vertex_4_13, vector3MoreOrLessEquals(Vector3(-37.5541, 27.2729, -51.6328)));
      final vertex_4_14 = mesh_4.vertices.elementAt(14);
      expect(vertex_4_14, vector3MoreOrLessEquals(Vector3(-36.3516, 8.47676, -37.1534)));
      final vertex_4_15 = mesh_4.vertices.elementAt(15);
      expect(vertex_4_15, vector3MoreOrLessEquals(Vector3(-37.5541, 27.2729, -51.6328)));
      final vertex_4_16 = mesh_4.vertices.elementAt(16);
      expect(vertex_4_16, vector3MoreOrLessEquals(Vector3(-38.6766, 28.3424, -51.0306)));
      final vertex_4_17 = mesh_4.vertices.elementAt(17);
      expect(vertex_4_17, vector3MoreOrLessEquals(Vector3(-36.3516, 8.47676, -37.1534)));
      final vertex_4_18 = mesh_4.vertices.elementAt(18);
      expect(vertex_4_18, vector3MoreOrLessEquals(Vector3(-37.5541, 27.2729, -51.6328)));
      final vertex_4_19 = mesh_4.vertices.elementAt(19);
      expect(vertex_4_19, vector3MoreOrLessEquals(Vector3(-36.8568, 27.4981, -55.3041)));
      final vertex_4_20 = mesh_4.vertices.elementAt(20);
      expect(vertex_4_20, vector3MoreOrLessEquals(Vector3(-38.6323, 28.7062, -56.1659)));
      final vertex_4_21 = mesh_4.vertices.elementAt(21);
      expect(vertex_4_21, vector3MoreOrLessEquals(Vector3(-37.5541, 27.2729, -51.6328)));
      final vertex_4_22 = mesh_4.vertices.elementAt(22);
      expect(vertex_4_22, vector3MoreOrLessEquals(Vector3(-38.6323, 28.7062, -56.1659)));
      final vertex_4_23 = mesh_4.vertices.elementAt(23);
      expect(vertex_4_23, vector3MoreOrLessEquals(Vector3(-38.6766, 28.3424, -51.0306)));
      final vertex_4_24 = mesh_4.vertices.elementAt(24);
      expect(vertex_4_24, vector3MoreOrLessEquals(Vector3(-36.8568, 27.4981, -55.3041)));
      final vertex_4_25 = mesh_4.vertices.elementAt(25);
      expect(vertex_4_25, vector3MoreOrLessEquals(Vector3(-39.3216, 4.10906, -79.2096)));
      final vertex_4_26 = mesh_4.vertices.elementAt(26);
      expect(vertex_4_26, vector3MoreOrLessEquals(Vector3(-38.6323, 28.7062, -56.1659)));
      final vertex_4_27 = mesh_4.vertices.elementAt(27);
      expect(vertex_4_27, vector3MoreOrLessEquals(Vector3(-39.3216, 4.10906, -79.2096)));
      final vertex_4_28 = mesh_4.vertices.elementAt(28);
      expect(vertex_4_28, vector3MoreOrLessEquals(Vector3(-40.778, 4.45497, -80.9743)));
      final vertex_4_29 = mesh_4.vertices.elementAt(29);
      expect(vertex_4_29, vector3MoreOrLessEquals(Vector3(-38.6323, 28.7062, -56.1659)));
      final vertex_4_30 = mesh_4.vertices.elementAt(30);
      expect(vertex_4_30, vector3MoreOrLessEquals(Vector3(-39.3216, 4.10906, -79.2096)));
      final vertex_4_31 = mesh_4.vertices.elementAt(31);
      expect(vertex_4_31, vector3MoreOrLessEquals(Vector3(-40.8771, -32.4266, -89.8897)));
      final vertex_4_32 = mesh_4.vertices.elementAt(32);
      expect(vertex_4_32, vector3MoreOrLessEquals(Vector3(-41.6864, -30.9586, -90.7611)));
      final vertex_4_33 = mesh_4.vertices.elementAt(33);
      expect(vertex_4_33, vector3MoreOrLessEquals(Vector3(-39.3216, 4.10906, -79.2096)));
      final vertex_4_34 = mesh_4.vertices.elementAt(34);
      expect(vertex_4_34, vector3MoreOrLessEquals(Vector3(-41.6864, -30.9586, -90.7611)));
      final vertex_4_35 = mesh_4.vertices.elementAt(35);
      expect(vertex_4_35, vector3MoreOrLessEquals(Vector3(-40.778, 4.45497, -80.9743)));
      final vertex_4_36 = mesh_4.vertices.elementAt(36);
      expect(vertex_4_36, vector3MoreOrLessEquals(Vector3(-40.8771, -32.4266, -89.8897)));
      final vertex_4_37 = mesh_4.vertices.elementAt(37);
      expect(vertex_4_37, vector3MoreOrLessEquals(Vector3(-43.3858, -41.5832, -95.2187)));
      final vertex_4_38 = mesh_4.vertices.elementAt(38);
      expect(vertex_4_38, vector3MoreOrLessEquals(Vector3(-41.6864, -30.9586, -90.7611)));
      final vertex_4_39 = mesh_4.vertices.elementAt(39);
      expect(vertex_4_39, vector3MoreOrLessEquals(Vector3(-43.3858, -41.5832, -95.2187)));
      final vertex_4_40 = mesh_4.vertices.elementAt(40);
      expect(vertex_4_40, vector3MoreOrLessEquals(Vector3(-43.6942, -41.0689, -95.4345)));
      final vertex_4_41 = mesh_4.vertices.elementAt(41);
      expect(vertex_4_41, vector3MoreOrLessEquals(Vector3(-41.6864, -30.9586, -90.7611)));
      final vertex_4_42 = mesh_4.vertices.elementAt(42);
      expect(vertex_4_42, vector3MoreOrLessEquals(Vector3(-34.3837, -1.82275, -16.6522)));
      final vertex_4_43 = mesh_4.vertices.elementAt(43);
      expect(vertex_4_43, vector3MoreOrLessEquals(Vector3(-37.8103, -1.45013, -16.4496)));
      final vertex_4_44 = mesh_4.vertices.elementAt(44);
      expect(vertex_4_44, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_45 = mesh_4.vertices.elementAt(45);
      expect(vertex_4_45, vector3MoreOrLessEquals(Vector3(-43.6942, -41.0689, -95.4345)));
      final vertex_4_46 = mesh_4.vertices.elementAt(46);
      expect(vertex_4_46, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_47 = mesh_4.vertices.elementAt(47);
      expect(vertex_4_47, vector3MoreOrLessEquals(Vector3(-44.1677, -40.9461, -95.3437)));
      final vertex_4_48 = mesh_4.vertices.elementAt(48);
      expect(vertex_4_48, vector3MoreOrLessEquals(Vector3(-34.3837, -1.82275, -16.6522)));
      final vertex_4_49 = mesh_4.vertices.elementAt(49);
      expect(vertex_4_49, vector3MoreOrLessEquals(Vector3(-36.3516, 8.47676, -37.1534)));
      final vertex_4_50 = mesh_4.vertices.elementAt(50);
      expect(vertex_4_50, vector3MoreOrLessEquals(Vector3(-37.8103, -1.45013, -16.4496)));
      final vertex_4_51 = mesh_4.vertices.elementAt(51);
      expect(vertex_4_51, vector3MoreOrLessEquals(Vector3(-36.3516, 8.47676, -37.1534)));
      final vertex_4_52 = mesh_4.vertices.elementAt(52);
      expect(vertex_4_52, vector3MoreOrLessEquals(Vector3(-38.4677, 7.78515, -36.5219)));
      final vertex_4_53 = mesh_4.vertices.elementAt(53);
      expect(vertex_4_53, vector3MoreOrLessEquals(Vector3(-37.8103, -1.45013, -16.4496)));
      final vertex_4_54 = mesh_4.vertices.elementAt(54);
      expect(vertex_4_54, vector3MoreOrLessEquals(Vector3(-36.3516, 8.47676, -37.1534)));
      final vertex_4_55 = mesh_4.vertices.elementAt(55);
      expect(vertex_4_55, vector3MoreOrLessEquals(Vector3(-38.6766, 28.3424, -51.0306)));
      final vertex_4_56 = mesh_4.vertices.elementAt(56);
      expect(vertex_4_56, vector3MoreOrLessEquals(Vector3(-40.0468, 28.0877, -50.7727)));
      final vertex_4_57 = mesh_4.vertices.elementAt(57);
      expect(vertex_4_57, vector3MoreOrLessEquals(Vector3(-36.3516, 8.47676, -37.1534)));
      final vertex_4_58 = mesh_4.vertices.elementAt(58);
      expect(vertex_4_58, vector3MoreOrLessEquals(Vector3(-40.0468, 28.0877, -50.7727)));
      final vertex_4_59 = mesh_4.vertices.elementAt(59);
      expect(vertex_4_59, vector3MoreOrLessEquals(Vector3(-38.4677, 7.78515, -36.5219)));
      final vertex_4_60 = mesh_4.vertices.elementAt(60);
      expect(vertex_4_60, vector3MoreOrLessEquals(Vector3(-38.6766, 28.3424, -51.0306)));
      final vertex_4_61 = mesh_4.vertices.elementAt(61);
      expect(vertex_4_61, vector3MoreOrLessEquals(Vector3(-38.6323, 28.7062, -56.1659)));
      final vertex_4_62 = mesh_4.vertices.elementAt(62);
      expect(vertex_4_62, vector3MoreOrLessEquals(Vector3(-40.0468, 28.0877, -50.7727)));
      final vertex_4_63 = mesh_4.vertices.elementAt(63);
      expect(vertex_4_63, vector3MoreOrLessEquals(Vector3(-38.6323, 28.7062, -56.1659)));
      final vertex_4_64 = mesh_4.vertices.elementAt(64);
      expect(vertex_4_64, vector3MoreOrLessEquals(Vector3(-40.8775, 28.147, -56.1983)));
      final vertex_4_65 = mesh_4.vertices.elementAt(65);
      expect(vertex_4_65, vector3MoreOrLessEquals(Vector3(-40.0468, 28.0877, -50.7727)));
      final vertex_4_66 = mesh_4.vertices.elementAt(66);
      expect(vertex_4_66, vector3MoreOrLessEquals(Vector3(-38.6323, 28.7062, -56.1659)));
      final vertex_4_67 = mesh_4.vertices.elementAt(67);
      expect(vertex_4_67, vector3MoreOrLessEquals(Vector3(-40.778, 4.45497, -80.9743)));
      final vertex_4_68 = mesh_4.vertices.elementAt(68);
      expect(vertex_4_68, vector3MoreOrLessEquals(Vector3(-42.9444, 3.68279, -81.2297)));
      final vertex_4_69 = mesh_4.vertices.elementAt(69);
      expect(vertex_4_69, vector3MoreOrLessEquals(Vector3(-38.6323, 28.7062, -56.1659)));
      final vertex_4_70 = mesh_4.vertices.elementAt(70);
      expect(vertex_4_70, vector3MoreOrLessEquals(Vector3(-42.9444, 3.68279, -81.2297)));
      final vertex_4_71 = mesh_4.vertices.elementAt(71);
      expect(vertex_4_71, vector3MoreOrLessEquals(Vector3(-40.8775, 28.147, -56.1983)));
      final vertex_4_72 = mesh_4.vertices.elementAt(72);
      expect(vertex_4_72, vector3MoreOrLessEquals(Vector3(-40.778, 4.45497, -80.9743)));
      final vertex_4_73 = mesh_4.vertices.elementAt(73);
      expect(vertex_4_73, vector3MoreOrLessEquals(Vector3(-41.6864, -30.9586, -90.7611)));
      final vertex_4_74 = mesh_4.vertices.elementAt(74);
      expect(vertex_4_74, vector3MoreOrLessEquals(Vector3(-42.9444, 3.68279, -81.2297)));
      final vertex_4_75 = mesh_4.vertices.elementAt(75);
      expect(vertex_4_75, vector3MoreOrLessEquals(Vector3(-41.6864, -30.9586, -90.7611)));
      final vertex_4_76 = mesh_4.vertices.elementAt(76);
      expect(vertex_4_76, vector3MoreOrLessEquals(Vector3(-42.7306, -30.6049, -90.67)));
      final vertex_4_77 = mesh_4.vertices.elementAt(77);
      expect(vertex_4_77, vector3MoreOrLessEquals(Vector3(-42.9444, 3.68279, -81.2297)));
      final vertex_4_78 = mesh_4.vertices.elementAt(78);
      expect(vertex_4_78, vector3MoreOrLessEquals(Vector3(-41.6864, -30.9586, -90.7611)));
      final vertex_4_79 = mesh_4.vertices.elementAt(79);
      expect(vertex_4_79, vector3MoreOrLessEquals(Vector3(-43.6942, -41.0689, -95.4345)));
      final vertex_4_80 = mesh_4.vertices.elementAt(80);
      expect(vertex_4_80, vector3MoreOrLessEquals(Vector3(-44.1677, -40.9461, -95.3437)));
      final vertex_4_81 = mesh_4.vertices.elementAt(81);
      expect(vertex_4_81, vector3MoreOrLessEquals(Vector3(-41.6864, -30.9586, -90.7611)));
      final vertex_4_82 = mesh_4.vertices.elementAt(82);
      expect(vertex_4_82, vector3MoreOrLessEquals(Vector3(-44.1677, -40.9461, -95.3437)));
      final vertex_4_83 = mesh_4.vertices.elementAt(83);
      expect(vertex_4_83, vector3MoreOrLessEquals(Vector3(-42.7306, -30.6049, -90.67)));
      final vertex_4_84 = mesh_4.vertices.elementAt(84);
      expect(vertex_4_84, vector3MoreOrLessEquals(Vector3(-37.8103, -1.45013, -16.4496)));
      final vertex_4_85 = mesh_4.vertices.elementAt(85);
      expect(vertex_4_85, vector3MoreOrLessEquals(Vector3(-40.2353, -2.31741, -18.7073)));
      final vertex_4_86 = mesh_4.vertices.elementAt(86);
      expect(vertex_4_86, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_87 = mesh_4.vertices.elementAt(87);
      expect(vertex_4_87, vector3MoreOrLessEquals(Vector3(-44.1677, -40.9461, -95.3437)));
      final vertex_4_88 = mesh_4.vertices.elementAt(88);
      expect(vertex_4_88, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_89 = mesh_4.vertices.elementAt(89);
      expect(vertex_4_89, vector3MoreOrLessEquals(Vector3(-44.4495, -41.3072, -95.0147)));
      final vertex_4_90 = mesh_4.vertices.elementAt(90);
      expect(vertex_4_90, vector3MoreOrLessEquals(Vector3(-37.8103, -1.45013, -16.4496)));
      final vertex_4_91 = mesh_4.vertices.elementAt(91);
      expect(vertex_4_91, vector3MoreOrLessEquals(Vector3(-38.4677, 7.78515, -36.5219)));
      final vertex_4_92 = mesh_4.vertices.elementAt(92);
      expect(vertex_4_92, vector3MoreOrLessEquals(Vector3(-39.8538, 6.25055, -37.5604)));
      final vertex_4_93 = mesh_4.vertices.elementAt(93);
      expect(vertex_4_93, vector3MoreOrLessEquals(Vector3(-37.8103, -1.45013, -16.4496)));
      final vertex_4_94 = mesh_4.vertices.elementAt(94);
      expect(vertex_4_94, vector3MoreOrLessEquals(Vector3(-39.8538, 6.25055, -37.5604)));
      final vertex_4_95 = mesh_4.vertices.elementAt(95);
      expect(vertex_4_95, vector3MoreOrLessEquals(Vector3(-40.2353, -2.31741, -18.7073)));
      final vertex_4_96 = mesh_4.vertices.elementAt(96);
      expect(vertex_4_96, vector3MoreOrLessEquals(Vector3(-38.4677, 7.78515, -36.5219)));
      final vertex_4_97 = mesh_4.vertices.elementAt(97);
      expect(vertex_4_97, vector3MoreOrLessEquals(Vector3(-40.0468, 28.0877, -50.7727)));
      final vertex_4_98 = mesh_4.vertices.elementAt(98);
      expect(vertex_4_98, vector3MoreOrLessEquals(Vector3(-39.8538, 6.25055, -37.5604)));
      final vertex_4_99 = mesh_4.vertices.elementAt(99);
      expect(vertex_4_99, vector3MoreOrLessEquals(Vector3(-40.0468, 28.0877, -50.7727)));
      final vertex_4_100 = mesh_4.vertices.elementAt(100);
      expect(vertex_4_100, vector3MoreOrLessEquals(Vector3(-40.6329, 26.7007, -51.0533)));
      final vertex_4_101 = mesh_4.vertices.elementAt(101);
      expect(vertex_4_101, vector3MoreOrLessEquals(Vector3(-39.8538, 6.25055, -37.5604)));
      final vertex_4_102 = mesh_4.vertices.elementAt(102);
      expect(vertex_4_102, vector3MoreOrLessEquals(Vector3(-40.0468, 28.0877, -50.7727)));
      final vertex_4_103 = mesh_4.vertices.elementAt(103);
      expect(vertex_4_103, vector3MoreOrLessEquals(Vector3(-40.8775, 28.147, -56.1983)));
      final vertex_4_104 = mesh_4.vertices.elementAt(104);
      expect(vertex_4_104, vector3MoreOrLessEquals(Vector3(-41.9018, 26.2415, -55.3768)));
      final vertex_4_105 = mesh_4.vertices.elementAt(105);
      expect(vertex_4_105, vector3MoreOrLessEquals(Vector3(-40.0468, 28.0877, -50.7727)));
      final vertex_4_106 = mesh_4.vertices.elementAt(106);
      expect(vertex_4_106, vector3MoreOrLessEquals(Vector3(-41.9018, 26.2415, -55.3768)));
      final vertex_4_107 = mesh_4.vertices.elementAt(107);
      expect(vertex_4_107, vector3MoreOrLessEquals(Vector3(-40.6329, 26.7007, -51.0533)));
      final vertex_4_108 = mesh_4.vertices.elementAt(108);
      expect(vertex_4_108, vector3MoreOrLessEquals(Vector3(-40.8775, 28.147, -56.1983)));
      final vertex_4_109 = mesh_4.vertices.elementAt(109);
      expect(vertex_4_109, vector3MoreOrLessEquals(Vector3(-42.9444, 3.68279, -81.2297)));
      final vertex_4_110 = mesh_4.vertices.elementAt(110);
      expect(vertex_4_110, vector3MoreOrLessEquals(Vector3(-41.9018, 26.2415, -55.3768)));
      final vertex_4_111 = mesh_4.vertices.elementAt(111);
      expect(vertex_4_111, vector3MoreOrLessEquals(Vector3(-42.9444, 3.68279, -81.2297)));
      final vertex_4_112 = mesh_4.vertices.elementAt(112);
      expect(vertex_4_112, vector3MoreOrLessEquals(Vector3(-44.1895, 2.37398, -79.7834)));
      final vertex_4_113 = mesh_4.vertices.elementAt(113);
      expect(vertex_4_113, vector3MoreOrLessEquals(Vector3(-41.9018, 26.2415, -55.3768)));
      final vertex_4_114 = mesh_4.vertices.elementAt(114);
      expect(vertex_4_114, vector3MoreOrLessEquals(Vector3(-42.9444, 3.68279, -81.2297)));
      final vertex_4_115 = mesh_4.vertices.elementAt(115);
      expect(vertex_4_115, vector3MoreOrLessEquals(Vector3(-42.7306, -30.6049, -90.67)));
      final vertex_4_116 = mesh_4.vertices.elementAt(116);
      expect(vertex_4_116, vector3MoreOrLessEquals(Vector3(-43.2233, -31.6319, -89.6851)));
      final vertex_4_117 = mesh_4.vertices.elementAt(117);
      expect(vertex_4_117, vector3MoreOrLessEquals(Vector3(-42.9444, 3.68279, -81.2297)));
      final vertex_4_118 = mesh_4.vertices.elementAt(118);
      expect(vertex_4_118, vector3MoreOrLessEquals(Vector3(-43.2233, -31.6319, -89.6851)));
      final vertex_4_119 = mesh_4.vertices.elementAt(119);
      expect(vertex_4_119, vector3MoreOrLessEquals(Vector3(-44.1895, 2.37398, -79.7834)));
      final vertex_4_120 = mesh_4.vertices.elementAt(120);
      expect(vertex_4_120, vector3MoreOrLessEquals(Vector3(-42.7306, -30.6049, -90.67)));
      final vertex_4_121 = mesh_4.vertices.elementAt(121);
      expect(vertex_4_121, vector3MoreOrLessEquals(Vector3(-44.1677, -40.9461, -95.3437)));
      final vertex_4_122 = mesh_4.vertices.elementAt(122);
      expect(vertex_4_122, vector3MoreOrLessEquals(Vector3(-43.2233, -31.6319, -89.6851)));
      final vertex_4_123 = mesh_4.vertices.elementAt(123);
      expect(vertex_4_123, vector3MoreOrLessEquals(Vector3(-44.1677, -40.9461, -95.3437)));
      final vertex_4_124 = mesh_4.vertices.elementAt(124);
      expect(vertex_4_124, vector3MoreOrLessEquals(Vector3(-44.4495, -41.3072, -95.0147)));
      final vertex_4_125 = mesh_4.vertices.elementAt(125);
      expect(vertex_4_125, vector3MoreOrLessEquals(Vector3(-43.2233, -31.6319, -89.6851)));
      final vertex_4_126 = mesh_4.vertices.elementAt(126);
      expect(vertex_4_126, vector3MoreOrLessEquals(Vector3(-40.2353, -2.31741, -18.7073)));
      final vertex_4_127 = mesh_4.vertices.elementAt(127);
      expect(vertex_4_127, vector3MoreOrLessEquals(Vector3(-39.8325, -3.77151, -21.7252)));
      final vertex_4_128 = mesh_4.vertices.elementAt(128);
      expect(vertex_4_128, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_129 = mesh_4.vertices.elementAt(129);
      expect(vertex_4_129, vector3MoreOrLessEquals(Vector3(-44.4495, -41.3072, -95.0147)));
      final vertex_4_130 = mesh_4.vertices.elementAt(130);
      expect(vertex_4_130, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_131 = mesh_4.vertices.elementAt(131);
      expect(vertex_4_131, vector3MoreOrLessEquals(Vector3(-44.3276, -41.8803, -94.6953)));
      final vertex_4_132 = mesh_4.vertices.elementAt(132);
      expect(vertex_4_132, vector3MoreOrLessEquals(Vector3(-40.2353, -2.31741, -18.7073)));
      final vertex_4_133 = mesh_4.vertices.elementAt(133);
      expect(vertex_4_133, vector3MoreOrLessEquals(Vector3(-39.8538, 6.25055, -37.5604)));
      final vertex_4_134 = mesh_4.vertices.elementAt(134);
      expect(vertex_4_134, vector3MoreOrLessEquals(Vector3(-39.8325, -3.77151, -21.7252)));
      final vertex_4_135 = mesh_4.vertices.elementAt(135);
      expect(vertex_4_135, vector3MoreOrLessEquals(Vector3(-39.8538, 6.25055, -37.5604)));
      final vertex_4_136 = mesh_4.vertices.elementAt(136);
      expect(vertex_4_136, vector3MoreOrLessEquals(Vector3(-39.4662, 5.02854, -39.4869)));
      final vertex_4_137 = mesh_4.vertices.elementAt(137);
      expect(vertex_4_137, vector3MoreOrLessEquals(Vector3(-39.8325, -3.77151, -21.7252)));
      final vertex_4_138 = mesh_4.vertices.elementAt(138);
      expect(vertex_4_138, vector3MoreOrLessEquals(Vector3(-39.8538, 6.25055, -37.5604)));
      final vertex_4_139 = mesh_4.vertices.elementAt(139);
      expect(vertex_4_139, vector3MoreOrLessEquals(Vector3(-40.6329, 26.7007, -51.0533)));
      final vertex_4_140 = mesh_4.vertices.elementAt(140);
      expect(vertex_4_140, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_141 = mesh_4.vertices.elementAt(141);
      expect(vertex_4_141, vector3MoreOrLessEquals(Vector3(-39.8538, 6.25055, -37.5604)));
      final vertex_4_142 = mesh_4.vertices.elementAt(142);
      expect(vertex_4_142, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_143 = mesh_4.vertices.elementAt(143);
      expect(vertex_4_143, vector3MoreOrLessEquals(Vector3(-39.4662, 5.02854, -39.4869)));
      final vertex_4_144 = mesh_4.vertices.elementAt(144);
      expect(vertex_4_144, vector3MoreOrLessEquals(Vector3(-40.6329, 26.7007, -51.0533)));
      final vertex_4_145 = mesh_4.vertices.elementAt(145);
      expect(vertex_4_145, vector3MoreOrLessEquals(Vector3(-41.9018, 26.2415, -55.3768)));
      final vertex_4_146 = mesh_4.vertices.elementAt(146);
      expect(vertex_4_146, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_147 = mesh_4.vertices.elementAt(147);
      expect(vertex_4_147, vector3MoreOrLessEquals(Vector3(-41.9018, 26.2415, -55.3768)));
      final vertex_4_148 = mesh_4.vertices.elementAt(148);
      expect(vertex_4_148, vector3MoreOrLessEquals(Vector3(-40.9338, 24.4246, -54.3201)));
      final vertex_4_149 = mesh_4.vertices.elementAt(149);
      expect(vertex_4_149, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_150 = mesh_4.vertices.elementAt(150);
      expect(vertex_4_150, vector3MoreOrLessEquals(Vector3(-41.9018, 26.2415, -55.3768)));
      final vertex_4_151 = mesh_4.vertices.elementAt(151);
      expect(vertex_4_151, vector3MoreOrLessEquals(Vector3(-44.1895, 2.37398, -79.7834)));
      final vertex_4_152 = mesh_4.vertices.elementAt(152);
      expect(vertex_4_152, vector3MoreOrLessEquals(Vector3(-43.5756, 1.51407, -77.7246)));
      final vertex_4_153 = mesh_4.vertices.elementAt(153);
      expect(vertex_4_153, vector3MoreOrLessEquals(Vector3(-41.9018, 26.2415, -55.3768)));
      final vertex_4_154 = mesh_4.vertices.elementAt(154);
      expect(vertex_4_154, vector3MoreOrLessEquals(Vector3(-43.5756, 1.51407, -77.7246)));
      final vertex_4_155 = mesh_4.vertices.elementAt(155);
      expect(vertex_4_155, vector3MoreOrLessEquals(Vector3(-40.9338, 24.4246, -54.3201)));
      final vertex_4_156 = mesh_4.vertices.elementAt(156);
      expect(vertex_4_156, vector3MoreOrLessEquals(Vector3(-44.1895, 2.37398, -79.7834)));
      final vertex_4_157 = mesh_4.vertices.elementAt(157);
      expect(vertex_4_157, vector3MoreOrLessEquals(Vector3(-43.2233, -31.6319, -89.6851)));
      final vertex_4_158 = mesh_4.vertices.elementAt(158);
      expect(vertex_4_158, vector3MoreOrLessEquals(Vector3(-43.5756, 1.51407, -77.7246)));
      final vertex_4_159 = mesh_4.vertices.elementAt(159);
      expect(vertex_4_159, vector3MoreOrLessEquals(Vector3(-43.2233, -31.6319, -89.6851)));
      final vertex_4_160 = mesh_4.vertices.elementAt(160);
      expect(vertex_4_160, vector3MoreOrLessEquals(Vector3(-42.7935, -33.2662, -88.548)));
      final vertex_4_161 = mesh_4.vertices.elementAt(161);
      expect(vertex_4_161, vector3MoreOrLessEquals(Vector3(-43.5756, 1.51407, -77.7246)));
      final vertex_4_162 = mesh_4.vertices.elementAt(162);
      expect(vertex_4_162, vector3MoreOrLessEquals(Vector3(-43.2233, -31.6319, -89.6851)));
      final vertex_4_163 = mesh_4.vertices.elementAt(163);
      expect(vertex_4_163, vector3MoreOrLessEquals(Vector3(-44.4495, -41.3072, -95.0147)));
      final vertex_4_164 = mesh_4.vertices.elementAt(164);
      expect(vertex_4_164, vector3MoreOrLessEquals(Vector3(-44.3276, -41.8803, -94.6953)));
      final vertex_4_165 = mesh_4.vertices.elementAt(165);
      expect(vertex_4_165, vector3MoreOrLessEquals(Vector3(-43.2233, -31.6319, -89.6851)));
      final vertex_4_166 = mesh_4.vertices.elementAt(166);
      expect(vertex_4_166, vector3MoreOrLessEquals(Vector3(-44.3276, -41.8803, -94.6953)));
      final vertex_4_167 = mesh_4.vertices.elementAt(167);
      expect(vertex_4_167, vector3MoreOrLessEquals(Vector3(-42.7935, -33.2662, -88.548)));
      final vertex_4_168 = mesh_4.vertices.elementAt(168);
      expect(vertex_4_168, vector3MoreOrLessEquals(Vector3(-39.8325, -3.77151, -21.7252)));
      final vertex_4_169 = mesh_4.vertices.elementAt(169);
      expect(vertex_4_169, vector3MoreOrLessEquals(Vector3(-36.9054, -4.71747, -23.2308)));
      final vertex_4_170 = mesh_4.vertices.elementAt(170);
      expect(vertex_4_170, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_171 = mesh_4.vertices.elementAt(171);
      expect(vertex_4_171, vector3MoreOrLessEquals(Vector3(-44.3276, -41.8803, -94.6953)));
      final vertex_4_172 = mesh_4.vertices.elementAt(172);
      expect(vertex_4_172, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_173 = mesh_4.vertices.elementAt(173);
      expect(vertex_4_173, vector3MoreOrLessEquals(Vector3(-43.8937, -42.2338, -94.6259)));
      final vertex_4_174 = mesh_4.vertices.elementAt(174);
      expect(vertex_4_174, vector3MoreOrLessEquals(Vector3(-39.8325, -3.77151, -21.7252)));
      final vertex_4_175 = mesh_4.vertices.elementAt(175);
      expect(vertex_4_175, vector3MoreOrLessEquals(Vector3(-39.4662, 5.02854, -39.4869)));
      final vertex_4_176 = mesh_4.vertices.elementAt(176);
      expect(vertex_4_176, vector3MoreOrLessEquals(Vector3(-37.5967, 5.03929, -40.8506)));
      final vertex_4_177 = mesh_4.vertices.elementAt(177);
      expect(vertex_4_177, vector3MoreOrLessEquals(Vector3(-39.8325, -3.77151, -21.7252)));
      final vertex_4_178 = mesh_4.vertices.elementAt(178);
      expect(vertex_4_178, vector3MoreOrLessEquals(Vector3(-37.5967, 5.03929, -40.8506)));
      final vertex_4_179 = mesh_4.vertices.elementAt(179);
      expect(vertex_4_179, vector3MoreOrLessEquals(Vector3(-36.9054, -4.71747, -23.2308)));
      final vertex_4_180 = mesh_4.vertices.elementAt(180);
      expect(vertex_4_180, vector3MoreOrLessEquals(Vector3(-39.4662, 5.02854, -39.4869)));
      final vertex_4_181 = mesh_4.vertices.elementAt(181);
      expect(vertex_4_181, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_182 = mesh_4.vertices.elementAt(182);
      expect(vertex_4_182, vector3MoreOrLessEquals(Vector3(-37.5967, 5.03929, -40.8506)));
      final vertex_4_183 = mesh_4.vertices.elementAt(183);
      expect(vertex_4_183, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_184 = mesh_4.vertices.elementAt(184);
      expect(vertex_4_184, vector3MoreOrLessEquals(Vector3(-38.6101, 24.7735, -52.1384)));
      final vertex_4_185 = mesh_4.vertices.elementAt(185);
      expect(vertex_4_185, vector3MoreOrLessEquals(Vector3(-37.5967, 5.03929, -40.8506)));
      final vertex_4_186 = mesh_4.vertices.elementAt(186);
      expect(vertex_4_186, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_187 = mesh_4.vertices.elementAt(187);
      expect(vertex_4_187, vector3MoreOrLessEquals(Vector3(-40.9338, 24.4246, -54.3201)));
      final vertex_4_188 = mesh_4.vertices.elementAt(188);
      expect(vertex_4_188, vector3MoreOrLessEquals(Vector3(-38.7024, 24.0645, -53.8238)));
      final vertex_4_189 = mesh_4.vertices.elementAt(189);
      expect(vertex_4_189, vector3MoreOrLessEquals(Vector3(-39.9935, 25.2257, -51.6611)));
      final vertex_4_190 = mesh_4.vertices.elementAt(190);
      expect(vertex_4_190, vector3MoreOrLessEquals(Vector3(-38.7024, 24.0645, -53.8238)));
      final vertex_4_191 = mesh_4.vertices.elementAt(191);
      expect(vertex_4_191, vector3MoreOrLessEquals(Vector3(-38.6101, 24.7735, -52.1384)));
      final vertex_4_192 = mesh_4.vertices.elementAt(192);
      expect(vertex_4_192, vector3MoreOrLessEquals(Vector3(-40.9338, 24.4246, -54.3201)));
      final vertex_4_193 = mesh_4.vertices.elementAt(193);
      expect(vertex_4_193, vector3MoreOrLessEquals(Vector3(-43.5756, 1.51407, -77.7246)));
      final vertex_4_194 = mesh_4.vertices.elementAt(194);
      expect(vertex_4_194, vector3MoreOrLessEquals(Vector3(-38.7024, 24.0645, -53.8238)));
      final vertex_4_195 = mesh_4.vertices.elementAt(195);
      expect(vertex_4_195, vector3MoreOrLessEquals(Vector3(-43.5756, 1.51407, -77.7246)));
      final vertex_4_196 = mesh_4.vertices.elementAt(196);
      expect(vertex_4_196, vector3MoreOrLessEquals(Vector3(-41.5651, 1.7506, -76.6036)));
      final vertex_4_197 = mesh_4.vertices.elementAt(197);
      expect(vertex_4_197, vector3MoreOrLessEquals(Vector3(-38.7024, 24.0645, -53.8238)));
      final vertex_4_198 = mesh_4.vertices.elementAt(198);
      expect(vertex_4_198, vector3MoreOrLessEquals(Vector3(-43.5756, 1.51407, -77.7246)));
      final vertex_4_199 = mesh_4.vertices.elementAt(199);
      expect(vertex_4_199, vector3MoreOrLessEquals(Vector3(-42.7935, -33.2662, -88.548)));
      final vertex_4_200 = mesh_4.vertices.elementAt(200);
      expect(vertex_4_200, vector3MoreOrLessEquals(Vector3(-41.7649, -34.2772, -88.115)));
      final vertex_4_201 = mesh_4.vertices.elementAt(201);
      expect(vertex_4_201, vector3MoreOrLessEquals(Vector3(-43.5756, 1.51407, -77.7246)));
      final vertex_4_202 = mesh_4.vertices.elementAt(202);
      expect(vertex_4_202, vector3MoreOrLessEquals(Vector3(-41.7649, -34.2772, -88.115)));
      final vertex_4_203 = mesh_4.vertices.elementAt(203);
      expect(vertex_4_203, vector3MoreOrLessEquals(Vector3(-41.5651, 1.7506, -76.6036)));
      final vertex_4_204 = mesh_4.vertices.elementAt(204);
      expect(vertex_4_204, vector3MoreOrLessEquals(Vector3(-42.7935, -33.2662, -88.548)));
      final vertex_4_205 = mesh_4.vertices.elementAt(205);
      expect(vertex_4_205, vector3MoreOrLessEquals(Vector3(-44.3276, -41.8803, -94.6953)));
      final vertex_4_206 = mesh_4.vertices.elementAt(206);
      expect(vertex_4_206, vector3MoreOrLessEquals(Vector3(-41.7649, -34.2772, -88.115)));
      final vertex_4_207 = mesh_4.vertices.elementAt(207);
      expect(vertex_4_207, vector3MoreOrLessEquals(Vector3(-44.3276, -41.8803, -94.6953)));
      final vertex_4_208 = mesh_4.vertices.elementAt(208);
      expect(vertex_4_208, vector3MoreOrLessEquals(Vector3(-43.8937, -42.2338, -94.6259)));
      final vertex_4_209 = mesh_4.vertices.elementAt(209);
      expect(vertex_4_209, vector3MoreOrLessEquals(Vector3(-41.7649, -34.2772, -88.115)));
      final vertex_4_210 = mesh_4.vertices.elementAt(210);
      expect(vertex_4_210, vector3MoreOrLessEquals(Vector3(-36.9054, -4.71747, -23.2308)));
      final vertex_4_211 = mesh_4.vertices.elementAt(211);
      expect(vertex_4_211, vector3MoreOrLessEquals(Vector3(-33.658, -4.44295, -22.0903)));
      final vertex_4_212 = mesh_4.vertices.elementAt(212);
      expect(vertex_4_212, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_213 = mesh_4.vertices.elementAt(213);
      expect(vertex_4_213, vector3MoreOrLessEquals(Vector3(-43.8937, -42.2338, -94.6259)));
      final vertex_4_214 = mesh_4.vertices.elementAt(214);
      expect(vertex_4_214, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_215 = mesh_4.vertices.elementAt(215);
      expect(vertex_4_215, vector3MoreOrLessEquals(Vector3(-43.4746, -42.1016, -94.8589)));
      final vertex_4_216 = mesh_4.vertices.elementAt(216);
      expect(vertex_4_216, vector3MoreOrLessEquals(Vector3(-36.9054, -4.71747, -23.2308)));
      final vertex_4_217 = mesh_4.vertices.elementAt(217);
      expect(vertex_4_217, vector3MoreOrLessEquals(Vector3(-37.5967, 5.03929, -40.8506)));
      final vertex_4_218 = mesh_4.vertices.elementAt(218);
      expect(vertex_4_218, vector3MoreOrLessEquals(Vector3(-33.658, -4.44295, -22.0903)));
      final vertex_4_219 = mesh_4.vertices.elementAt(219);
      expect(vertex_4_219, vector3MoreOrLessEquals(Vector3(-37.5967, 5.03929, -40.8506)));
      final vertex_4_220 = mesh_4.vertices.elementAt(220);
      expect(vertex_4_220, vector3MoreOrLessEquals(Vector3(-35.6531, 6.27475, -40.6247)));
      final vertex_4_221 = mesh_4.vertices.elementAt(221);
      expect(vertex_4_221, vector3MoreOrLessEquals(Vector3(-33.658, -4.44295, -22.0903)));
      final vertex_4_222 = mesh_4.vertices.elementAt(222);
      expect(vertex_4_222, vector3MoreOrLessEquals(Vector3(-37.5967, 5.03929, -40.8506)));
      final vertex_4_223 = mesh_4.vertices.elementAt(223);
      expect(vertex_4_223, vector3MoreOrLessEquals(Vector3(-38.6101, 24.7735, -52.1384)));
      final vertex_4_224 = mesh_4.vertices.elementAt(224);
      expect(vertex_4_224, vector3MoreOrLessEquals(Vector3(-37.5244, 25.6846, -52.1258)));
      final vertex_4_225 = mesh_4.vertices.elementAt(225);
      expect(vertex_4_225, vector3MoreOrLessEquals(Vector3(-37.5967, 5.03929, -40.8506)));
      final vertex_4_226 = mesh_4.vertices.elementAt(226);
      expect(vertex_4_226, vector3MoreOrLessEquals(Vector3(-37.5244, 25.6846, -52.1258)));
      final vertex_4_227 = mesh_4.vertices.elementAt(227);
      expect(vertex_4_227, vector3MoreOrLessEquals(Vector3(-35.6531, 6.27475, -40.6247)));
      final vertex_4_228 = mesh_4.vertices.elementAt(228);
      expect(vertex_4_228, vector3MoreOrLessEquals(Vector3(-38.6101, 24.7735, -52.1384)));
      final vertex_4_229 = mesh_4.vertices.elementAt(229);
      expect(vertex_4_229, vector3MoreOrLessEquals(Vector3(-38.7024, 24.0645, -53.8238)));
      final vertex_4_230 = mesh_4.vertices.elementAt(230);
      expect(vertex_4_230, vector3MoreOrLessEquals(Vector3(-37.5244, 25.6846, -52.1258)));
      final vertex_4_231 = mesh_4.vertices.elementAt(231);
      expect(vertex_4_231, vector3MoreOrLessEquals(Vector3(-38.7024, 24.0645, -53.8238)));
      final vertex_4_232 = mesh_4.vertices.elementAt(232);
      expect(vertex_4_232, vector3MoreOrLessEquals(Vector3(-36.888, 25.4323, -54.2617)));
      final vertex_4_233 = mesh_4.vertices.elementAt(233);
      expect(vertex_4_233, vector3MoreOrLessEquals(Vector3(-37.5244, 25.6846, -52.1258)));
      final vertex_4_234 = mesh_4.vertices.elementAt(234);
      expect(vertex_4_234, vector3MoreOrLessEquals(Vector3(-38.7024, 24.0645, -53.8238)));
      final vertex_4_235 = mesh_4.vertices.elementAt(235);
      expect(vertex_4_235, vector3MoreOrLessEquals(Vector3(-41.5651, 1.7506, -76.6036)));
      final vertex_4_236 = mesh_4.vertices.elementAt(236);
      expect(vertex_4_236, vector3MoreOrLessEquals(Vector3(-39.6719, 2.9055, -77.2645)));
      final vertex_4_237 = mesh_4.vertices.elementAt(237);
      expect(vertex_4_237, vector3MoreOrLessEquals(Vector3(-38.7024, 24.0645, -53.8238)));
      final vertex_4_238 = mesh_4.vertices.elementAt(238);
      expect(vertex_4_238, vector3MoreOrLessEquals(Vector3(-39.6719, 2.9055, -77.2645)));
      final vertex_4_239 = mesh_4.vertices.elementAt(239);
      expect(vertex_4_239, vector3MoreOrLessEquals(Vector3(-36.888, 25.4323, -54.2617)));
      final vertex_4_240 = mesh_4.vertices.elementAt(240);
      expect(vertex_4_240, vector3MoreOrLessEquals(Vector3(-41.5651, 1.7506, -76.6036)));
      final vertex_4_241 = mesh_4.vertices.elementAt(241);
      expect(vertex_4_241, vector3MoreOrLessEquals(Vector3(-41.7649, -34.2772, -88.115)));
      final vertex_4_242 = mesh_4.vertices.elementAt(242);
      expect(vertex_4_242, vector3MoreOrLessEquals(Vector3(-39.6719, 2.9055, -77.2645)));
      final vertex_4_243 = mesh_4.vertices.elementAt(243);
      expect(vertex_4_243, vector3MoreOrLessEquals(Vector3(-41.7649, -34.2772, -88.115)));
      final vertex_4_244 = mesh_4.vertices.elementAt(244);
      expect(vertex_4_244, vector3MoreOrLessEquals(Vector3(-40.9121, -33.9035, -88.7121)));
      final vertex_4_245 = mesh_4.vertices.elementAt(245);
      expect(vertex_4_245, vector3MoreOrLessEquals(Vector3(-39.6719, 2.9055, -77.2645)));
      final vertex_4_246 = mesh_4.vertices.elementAt(246);
      expect(vertex_4_246, vector3MoreOrLessEquals(Vector3(-41.7649, -34.2772, -88.115)));
      final vertex_4_247 = mesh_4.vertices.elementAt(247);
      expect(vertex_4_247, vector3MoreOrLessEquals(Vector3(-43.8937, -42.2338, -94.6259)));
      final vertex_4_248 = mesh_4.vertices.elementAt(248);
      expect(vertex_4_248, vector3MoreOrLessEquals(Vector3(-43.4746, -42.1016, -94.8589)));
      final vertex_4_249 = mesh_4.vertices.elementAt(249);
      expect(vertex_4_249, vector3MoreOrLessEquals(Vector3(-41.7649, -34.2772, -88.115)));
      final vertex_4_250 = mesh_4.vertices.elementAt(250);
      expect(vertex_4_250, vector3MoreOrLessEquals(Vector3(-43.4746, -42.1016, -94.8589)));
      final vertex_4_251 = mesh_4.vertices.elementAt(251);
      expect(vertex_4_251, vector3MoreOrLessEquals(Vector3(-40.9121, -33.9035, -88.7121)));
      final vertex_4_252 = mesh_4.vertices.elementAt(252);
      expect(vertex_4_252, vector3MoreOrLessEquals(Vector3(-33.658, -4.44295, -22.0903)));
      final vertex_4_253 = mesh_4.vertices.elementAt(253);
      expect(vertex_4_253, vector3MoreOrLessEquals(Vector3(-32.5358, -3.15467, -19.1625)));
      final vertex_4_254 = mesh_4.vertices.elementAt(254);
      expect(vertex_4_254, vector3MoreOrLessEquals(Vector3(-36.4802, -3.09668, -19.7169)));
      final vertex_4_255 = mesh_4.vertices.elementAt(255);
      expect(vertex_4_255, vector3MoreOrLessEquals(Vector3(-43.4746, -42.1016, -94.8589)));
      final vertex_4_256 = mesh_4.vertices.elementAt(256);
      expect(vertex_4_256, vector3MoreOrLessEquals(Vector3(-43.9133, -41.5887, -95.0274)));
      final vertex_4_257 = mesh_4.vertices.elementAt(257);
      expect(vertex_4_257, vector3MoreOrLessEquals(Vector3(-43.3858, -41.5832, -95.2187)));
      final vertex_4_258 = mesh_4.vertices.elementAt(258);
      expect(vertex_4_258, vector3MoreOrLessEquals(Vector3(-33.658, -4.44295, -22.0903)));
      final vertex_4_259 = mesh_4.vertices.elementAt(259);
      expect(vertex_4_259, vector3MoreOrLessEquals(Vector3(-35.6531, 6.27475, -40.6247)));
      final vertex_4_260 = mesh_4.vertices.elementAt(260);
      expect(vertex_4_260, vector3MoreOrLessEquals(Vector3(-35.099, 7.80456, -38.9793)));
      final vertex_4_261 = mesh_4.vertices.elementAt(261);
      expect(vertex_4_261, vector3MoreOrLessEquals(Vector3(-33.658, -4.44295, -22.0903)));
      final vertex_4_262 = mesh_4.vertices.elementAt(262);
      expect(vertex_4_262, vector3MoreOrLessEquals(Vector3(-35.099, 7.80456, -38.9793)));
      final vertex_4_263 = mesh_4.vertices.elementAt(263);
      expect(vertex_4_263, vector3MoreOrLessEquals(Vector3(-32.5358, -3.15467, -19.1625)));
      final vertex_4_264 = mesh_4.vertices.elementAt(264);
      expect(vertex_4_264, vector3MoreOrLessEquals(Vector3(-35.6531, 6.27475, -40.6247)));
      final vertex_4_265 = mesh_4.vertices.elementAt(265);
      expect(vertex_4_265, vector3MoreOrLessEquals(Vector3(-37.5244, 25.6846, -52.1258)));
      final vertex_4_266 = mesh_4.vertices.elementAt(266);
      expect(vertex_4_266, vector3MoreOrLessEquals(Vector3(-35.099, 7.80456, -38.9793)));
      final vertex_4_267 = mesh_4.vertices.elementAt(267);
      expect(vertex_4_267, vector3MoreOrLessEquals(Vector3(-37.5244, 25.6846, -52.1258)));
      final vertex_4_268 = mesh_4.vertices.elementAt(268);
      expect(vertex_4_268, vector3MoreOrLessEquals(Vector3(-37.5541, 27.2729, -51.6328)));
      final vertex_4_269 = mesh_4.vertices.elementAt(269);
      expect(vertex_4_269, vector3MoreOrLessEquals(Vector3(-35.099, 7.80456, -38.9793)));
      final vertex_4_270 = mesh_4.vertices.elementAt(270);
      expect(vertex_4_270, vector3MoreOrLessEquals(Vector3(-37.5244, 25.6846, -52.1258)));
      final vertex_4_271 = mesh_4.vertices.elementAt(271);
      expect(vertex_4_271, vector3MoreOrLessEquals(Vector3(-36.888, 25.4323, -54.2617)));
      final vertex_4_272 = mesh_4.vertices.elementAt(272);
      expect(vertex_4_272, vector3MoreOrLessEquals(Vector3(-36.8568, 27.4981, -55.3041)));
      final vertex_4_273 = mesh_4.vertices.elementAt(273);
      expect(vertex_4_273, vector3MoreOrLessEquals(Vector3(-37.5244, 25.6846, -52.1258)));
      final vertex_4_274 = mesh_4.vertices.elementAt(274);
      expect(vertex_4_274, vector3MoreOrLessEquals(Vector3(-36.8568, 27.4981, -55.3041)));
      final vertex_4_275 = mesh_4.vertices.elementAt(275);
      expect(vertex_4_275, vector3MoreOrLessEquals(Vector3(-37.5541, 27.2729, -51.6328)));
      final vertex_4_276 = mesh_4.vertices.elementAt(276);
      expect(vertex_4_276, vector3MoreOrLessEquals(Vector3(-36.888, 25.4323, -54.2617)));
      final vertex_4_277 = mesh_4.vertices.elementAt(277);
      expect(vertex_4_277, vector3MoreOrLessEquals(Vector3(-39.6719, 2.9055, -77.2645)));
      final vertex_4_278 = mesh_4.vertices.elementAt(278);
      expect(vertex_4_278, vector3MoreOrLessEquals(Vector3(-36.8568, 27.4981, -55.3041)));
      final vertex_4_279 = mesh_4.vertices.elementAt(279);
      expect(vertex_4_279, vector3MoreOrLessEquals(Vector3(-39.6719, 2.9055, -77.2645)));
      final vertex_4_280 = mesh_4.vertices.elementAt(280);
      expect(vertex_4_280, vector3MoreOrLessEquals(Vector3(-39.3216, 4.10906, -79.2096)));
      final vertex_4_281 = mesh_4.vertices.elementAt(281);
      expect(vertex_4_281, vector3MoreOrLessEquals(Vector3(-36.8568, 27.4981, -55.3041)));
      final vertex_4_282 = mesh_4.vertices.elementAt(282);
      expect(vertex_4_282, vector3MoreOrLessEquals(Vector3(-39.6719, 2.9055, -77.2645)));
      final vertex_4_283 = mesh_4.vertices.elementAt(283);
      expect(vertex_4_283, vector3MoreOrLessEquals(Vector3(-40.9121, -33.9035, -88.7121)));
      final vertex_4_284 = mesh_4.vertices.elementAt(284);
      expect(vertex_4_284, vector3MoreOrLessEquals(Vector3(-40.8771, -32.4266, -89.8897)));
      final vertex_4_285 = mesh_4.vertices.elementAt(285);
      expect(vertex_4_285, vector3MoreOrLessEquals(Vector3(-39.6719, 2.9055, -77.2645)));
      final vertex_4_286 = mesh_4.vertices.elementAt(286);
      expect(vertex_4_286, vector3MoreOrLessEquals(Vector3(-40.8771, -32.4266, -89.8897)));
      final vertex_4_287 = mesh_4.vertices.elementAt(287);
      expect(vertex_4_287, vector3MoreOrLessEquals(Vector3(-39.3216, 4.10906, -79.2096)));
      final vertex_4_288 = mesh_4.vertices.elementAt(288);
      expect(vertex_4_288, vector3MoreOrLessEquals(Vector3(-40.9121, -33.9035, -88.7121)));
      final vertex_4_289 = mesh_4.vertices.elementAt(289);
      expect(vertex_4_289, vector3MoreOrLessEquals(Vector3(-43.4746, -42.1016, -94.8589)));
      final vertex_4_290 = mesh_4.vertices.elementAt(290);
      expect(vertex_4_290, vector3MoreOrLessEquals(Vector3(-40.8771, -32.4266, -89.8897)));
      final vertex_4_291 = mesh_4.vertices.elementAt(291);
      expect(vertex_4_291, vector3MoreOrLessEquals(Vector3(-43.4746, -42.1016, -94.8589)));
      final vertex_4_292 = mesh_4.vertices.elementAt(292);
      expect(vertex_4_292, vector3MoreOrLessEquals(Vector3(-43.3858, -41.5832, -95.2187)));
      final vertex_4_293 = mesh_4.vertices.elementAt(293);
      expect(vertex_4_293, vector3MoreOrLessEquals(Vector3(-40.8771, -32.4266, -89.8897)));
      expect(mesh_4.normals.length, equals(294));
      final normal_4_0 = mesh_4.normals.elementAt(0);
      expect(normal_4_0, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_1 = mesh_4.normals.elementAt(1);
      expect(normal_4_1, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_2 = mesh_4.normals.elementAt(2);
      expect(normal_4_2, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_3 = mesh_4.normals.elementAt(3);
      expect(normal_4_3, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_4 = mesh_4.normals.elementAt(4);
      expect(normal_4_4, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_5 = mesh_4.normals.elementAt(5);
      expect(normal_4_5, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_6 = mesh_4.normals.elementAt(6);
      expect(normal_4_6, vector3MoreOrLessEquals(Vector3(0.918806, 0.383987, 0.091372)));
      final normal_4_7 = mesh_4.normals.elementAt(7);
      expect(normal_4_7, vector3MoreOrLessEquals(Vector3(0.993163, 0.114096, -0.024688)));
      final normal_4_8 = mesh_4.normals.elementAt(8);
      expect(normal_4_8, vector3MoreOrLessEquals(Vector3(0.434383, 0.709098, 0.55542)));
      final normal_4_9 = mesh_4.normals.elementAt(9);
      expect(normal_4_9, vector3MoreOrLessEquals(Vector3(0.918806, 0.383987, 0.091372)));
      final normal_4_10 = mesh_4.normals.elementAt(10);
      expect(normal_4_10, vector3MoreOrLessEquals(Vector3(0.434383, 0.709098, 0.55542)));
      final normal_4_11 = mesh_4.normals.elementAt(11);
      expect(normal_4_11, vector3MoreOrLessEquals(Vector3(0.471863, 0.805177, 0.359216)));
      final normal_4_12 = mesh_4.normals.elementAt(12);
      expect(normal_4_12, vector3MoreOrLessEquals(Vector3(0.993163, 0.114096, -0.024688)));
      final normal_4_13 = mesh_4.normals.elementAt(13);
      expect(normal_4_13, vector3MoreOrLessEquals(Vector3(0.868051, 0.441893, 0.226313)));
      final normal_4_14 = mesh_4.normals.elementAt(14);
      expect(normal_4_14, vector3MoreOrLessEquals(Vector3(0.434383, 0.709098, 0.55542)));
      final normal_4_15 = mesh_4.normals.elementAt(15);
      expect(normal_4_15, vector3MoreOrLessEquals(Vector3(0.868051, 0.441893, 0.226313)));
      final normal_4_16 = mesh_4.normals.elementAt(16);
      expect(normal_4_16, vector3MoreOrLessEquals(Vector3(0.386966, 0.811178, 0.438461)));
      final normal_4_17 = mesh_4.normals.elementAt(17);
      expect(normal_4_17, vector3MoreOrLessEquals(Vector3(0.434383, 0.709098, 0.55542)));
      final normal_4_18 = mesh_4.normals.elementAt(18);
      expect(normal_4_18, vector3MoreOrLessEquals(Vector3(0.868051, 0.441893, 0.226313)));
      final normal_4_19 = mesh_4.normals.elementAt(19);
      expect(normal_4_19, vector3MoreOrLessEquals(Vector3(0.971729, 0.236044, 0.005163)));
      final normal_4_20 = mesh_4.normals.elementAt(20);
      expect(normal_4_20, vector3MoreOrLessEquals(Vector3(0.277939, 0.903859, -0.325252)));
      final normal_4_21 = mesh_4.normals.elementAt(21);
      expect(normal_4_21, vector3MoreOrLessEquals(Vector3(0.868051, 0.441893, 0.226313)));
      final normal_4_22 = mesh_4.normals.elementAt(22);
      expect(normal_4_22, vector3MoreOrLessEquals(Vector3(0.277939, 0.903859, -0.325252)));
      final normal_4_23 = mesh_4.normals.elementAt(23);
      expect(normal_4_23, vector3MoreOrLessEquals(Vector3(0.386966, 0.811178, 0.438461)));
      final normal_4_24 = mesh_4.normals.elementAt(24);
      expect(normal_4_24, vector3MoreOrLessEquals(Vector3(0.971729, 0.236044, 0.005163)));
      final normal_4_25 = mesh_4.normals.elementAt(25);
      expect(normal_4_25, vector3MoreOrLessEquals(Vector3(0.907561, 0.183989, -0.377467)));
      final normal_4_26 = mesh_4.normals.elementAt(26);
      expect(normal_4_26, vector3MoreOrLessEquals(Vector3(0.277939, 0.903859, -0.325252)));
      final normal_4_27 = mesh_4.normals.elementAt(27);
      expect(normal_4_27, vector3MoreOrLessEquals(Vector3(0.907561, 0.183989, -0.377467)));
      final normal_4_28 = mesh_4.normals.elementAt(28);
      expect(normal_4_28, vector3MoreOrLessEquals(Vector3(0.389798, 0.45768, -0.799116)));
      final normal_4_29 = mesh_4.normals.elementAt(29);
      expect(normal_4_29, vector3MoreOrLessEquals(Vector3(0.277939, 0.903859, -0.325252)));
      final normal_4_30 = mesh_4.normals.elementAt(30);
      expect(normal_4_30, vector3MoreOrLessEquals(Vector3(0.907561, 0.183989, -0.377467)));
      final normal_4_31 = mesh_4.normals.elementAt(31);
      expect(normal_4_31, vector3MoreOrLessEquals(Vector3(0.974181, -0.045977, -0.221037)));
      final normal_4_32 = mesh_4.normals.elementAt(32);
      expect(normal_4_32, vector3MoreOrLessEquals(Vector3(0.441749, 0.266583, -0.856616)));
      final normal_4_33 = mesh_4.normals.elementAt(33);
      expect(normal_4_33, vector3MoreOrLessEquals(Vector3(0.907561, 0.183989, -0.377467)));
      final normal_4_34 = mesh_4.normals.elementAt(34);
      expect(normal_4_34, vector3MoreOrLessEquals(Vector3(0.441749, 0.266583, -0.856616)));
      final normal_4_35 = mesh_4.normals.elementAt(35);
      expect(normal_4_35, vector3MoreOrLessEquals(Vector3(0.389798, 0.45768, -0.799116)));
      final normal_4_36 = mesh_4.normals.elementAt(36);
      expect(normal_4_36, vector3MoreOrLessEquals(Vector3(0.974181, -0.045977, -0.221037)));
      final normal_4_37 = mesh_4.normals.elementAt(37);
      expect(normal_4_37, vector3MoreOrLessEquals(Vector3(0.886674, 0.017475, -0.462065)));
      final normal_4_38 = mesh_4.normals.elementAt(38);
      expect(normal_4_38, vector3MoreOrLessEquals(Vector3(0.441749, 0.266583, -0.856616)));
      final normal_4_39 = mesh_4.normals.elementAt(39);
      expect(normal_4_39, vector3MoreOrLessEquals(Vector3(0.886674, 0.017475, -0.462065)));
      final normal_4_40 = mesh_4.normals.elementAt(40);
      expect(normal_4_40, vector3MoreOrLessEquals(Vector3(0.372092, 0.327554, -0.868479)));
      final normal_4_41 = mesh_4.normals.elementAt(41);
      expect(normal_4_41, vector3MoreOrLessEquals(Vector3(0.441749, 0.266583, -0.856616)));
      final normal_4_42 = mesh_4.normals.elementAt(42);
      expect(normal_4_42, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_43 = mesh_4.normals.elementAt(43);
      expect(normal_4_43, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_44 = mesh_4.normals.elementAt(44);
      expect(normal_4_44, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_45 = mesh_4.normals.elementAt(45);
      expect(normal_4_45, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_46 = mesh_4.normals.elementAt(46);
      expect(normal_4_46, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_47 = mesh_4.normals.elementAt(47);
      expect(normal_4_47, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_48 = mesh_4.normals.elementAt(48);
      expect(normal_4_48, vector3MoreOrLessEquals(Vector3(0.471863, 0.805177, 0.359216)));
      final normal_4_49 = mesh_4.normals.elementAt(49);
      expect(normal_4_49, vector3MoreOrLessEquals(Vector3(0.434383, 0.709098, 0.55542)));
      final normal_4_50 = mesh_4.normals.elementAt(50);
      expect(normal_4_50, vector3MoreOrLessEquals(Vector3(-0.38508, 0.834046, 0.395071)));
      final normal_4_51 = mesh_4.normals.elementAt(51);
      expect(normal_4_51, vector3MoreOrLessEquals(Vector3(0.434383, 0.709098, 0.55542)));
      final normal_4_52 = mesh_4.normals.elementAt(52);
      expect(normal_4_52, vector3MoreOrLessEquals(Vector3(-0.476106, 0.659961, 0.581185)));
      final normal_4_53 = mesh_4.normals.elementAt(53);
      expect(normal_4_53, vector3MoreOrLessEquals(Vector3(-0.38508, 0.834046, 0.395071)));
      final normal_4_54 = mesh_4.normals.elementAt(54);
      expect(normal_4_54, vector3MoreOrLessEquals(Vector3(0.434383, 0.709098, 0.55542)));
      final normal_4_55 = mesh_4.normals.elementAt(55);
      expect(normal_4_55, vector3MoreOrLessEquals(Vector3(0.386966, 0.811178, 0.438461)));
      final normal_4_56 = mesh_4.normals.elementAt(56);
      expect(normal_4_56, vector3MoreOrLessEquals(Vector3(-0.556161, 0.685573, 0.469761)));
      final normal_4_57 = mesh_4.normals.elementAt(57);
      expect(normal_4_57, vector3MoreOrLessEquals(Vector3(0.434383, 0.709098, 0.55542)));
      final normal_4_58 = mesh_4.normals.elementAt(58);
      expect(normal_4_58, vector3MoreOrLessEquals(Vector3(-0.556161, 0.685573, 0.469761)));
      final normal_4_59 = mesh_4.normals.elementAt(59);
      expect(normal_4_59, vector3MoreOrLessEquals(Vector3(-0.476106, 0.659961, 0.581185)));
      final normal_4_60 = mesh_4.normals.elementAt(60);
      expect(normal_4_60, vector3MoreOrLessEquals(Vector3(0.386966, 0.811178, 0.438461)));
      final normal_4_61 = mesh_4.normals.elementAt(61);
      expect(normal_4_61, vector3MoreOrLessEquals(Vector3(0.277939, 0.903859, -0.325252)));
      final normal_4_62 = mesh_4.normals.elementAt(62);
      expect(normal_4_62, vector3MoreOrLessEquals(Vector3(-0.556161, 0.685573, 0.469761)));
      final normal_4_63 = mesh_4.normals.elementAt(63);
      expect(normal_4_63, vector3MoreOrLessEquals(Vector3(0.277939, 0.903859, -0.325252)));
      final normal_4_64 = mesh_4.normals.elementAt(64);
      expect(normal_4_64, vector3MoreOrLessEquals(Vector3(-0.626859, 0.745436, -0.226656)));
      final normal_4_65 = mesh_4.normals.elementAt(65);
      expect(normal_4_65, vector3MoreOrLessEquals(Vector3(-0.556161, 0.685573, 0.469761)));
      final normal_4_66 = mesh_4.normals.elementAt(66);
      expect(normal_4_66, vector3MoreOrLessEquals(Vector3(0.277939, 0.903859, -0.325252)));
      final normal_4_67 = mesh_4.normals.elementAt(67);
      expect(normal_4_67, vector3MoreOrLessEquals(Vector3(0.389798, 0.45768, -0.799116)));
      final normal_4_68 = mesh_4.normals.elementAt(68);
      expect(normal_4_68, vector3MoreOrLessEquals(Vector3(-0.554271, 0.436146, -0.708915)));
      final normal_4_69 = mesh_4.normals.elementAt(69);
      expect(normal_4_69, vector3MoreOrLessEquals(Vector3(0.277939, 0.903859, -0.325252)));
      final normal_4_70 = mesh_4.normals.elementAt(70);
      expect(normal_4_70, vector3MoreOrLessEquals(Vector3(-0.554271, 0.436146, -0.708915)));
      final normal_4_71 = mesh_4.normals.elementAt(71);
      expect(normal_4_71, vector3MoreOrLessEquals(Vector3(-0.626859, 0.745436, -0.226656)));
      final normal_4_72 = mesh_4.normals.elementAt(72);
      expect(normal_4_72, vector3MoreOrLessEquals(Vector3(0.389798, 0.45768, -0.799116)));
      final normal_4_73 = mesh_4.normals.elementAt(73);
      expect(normal_4_73, vector3MoreOrLessEquals(Vector3(0.441749, 0.266583, -0.856616)));
      final normal_4_74 = mesh_4.normals.elementAt(74);
      expect(normal_4_74, vector3MoreOrLessEquals(Vector3(-0.554271, 0.436146, -0.708915)));
      final normal_4_75 = mesh_4.normals.elementAt(75);
      expect(normal_4_75, vector3MoreOrLessEquals(Vector3(0.441749, 0.266583, -0.856616)));
      final normal_4_76 = mesh_4.normals.elementAt(76);
      expect(normal_4_76, vector3MoreOrLessEquals(Vector3(-0.561559, 0.310302, -0.767049)));
      final normal_4_77 = mesh_4.normals.elementAt(77);
      expect(normal_4_77, vector3MoreOrLessEquals(Vector3(-0.554271, 0.436146, -0.708915)));
      final normal_4_78 = mesh_4.normals.elementAt(78);
      expect(normal_4_78, vector3MoreOrLessEquals(Vector3(0.441749, 0.266583, -0.856616)));
      final normal_4_79 = mesh_4.normals.elementAt(79);
      expect(normal_4_79, vector3MoreOrLessEquals(Vector3(0.372092, 0.327554, -0.868479)));
      final normal_4_80 = mesh_4.normals.elementAt(80);
      expect(normal_4_80, vector3MoreOrLessEquals(Vector3(-0.54381, 0.416915, -0.728322)));
      final normal_4_81 = mesh_4.normals.elementAt(81);
      expect(normal_4_81, vector3MoreOrLessEquals(Vector3(0.441749, 0.266583, -0.856616)));
      final normal_4_82 = mesh_4.normals.elementAt(82);
      expect(normal_4_82, vector3MoreOrLessEquals(Vector3(-0.54381, 0.416915, -0.728322)));
      final normal_4_83 = mesh_4.normals.elementAt(83);
      expect(normal_4_83, vector3MoreOrLessEquals(Vector3(-0.561559, 0.310302, -0.767049)));
      final normal_4_84 = mesh_4.normals.elementAt(84);
      expect(normal_4_84, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_85 = mesh_4.normals.elementAt(85);
      expect(normal_4_85, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_86 = mesh_4.normals.elementAt(86);
      expect(normal_4_86, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_87 = mesh_4.normals.elementAt(87);
      expect(normal_4_87, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_88 = mesh_4.normals.elementAt(88);
      expect(normal_4_88, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_89 = mesh_4.normals.elementAt(89);
      expect(normal_4_89, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_90 = mesh_4.normals.elementAt(90);
      expect(normal_4_90, vector3MoreOrLessEquals(Vector3(-0.38508, 0.834046, 0.395071)));
      final normal_4_91 = mesh_4.normals.elementAt(91);
      expect(normal_4_91, vector3MoreOrLessEquals(Vector3(-0.476106, 0.659961, 0.581185)));
      final normal_4_92 = mesh_4.normals.elementAt(92);
      expect(normal_4_92, vector3MoreOrLessEquals(Vector3(-0.974714, 0.176358, 0.137223)));
      final normal_4_93 = mesh_4.normals.elementAt(93);
      expect(normal_4_93, vector3MoreOrLessEquals(Vector3(-0.38508, 0.834046, 0.395071)));
      final normal_4_94 = mesh_4.normals.elementAt(94);
      expect(normal_4_94, vector3MoreOrLessEquals(Vector3(-0.974714, 0.176358, 0.137223)));
      final normal_4_95 = mesh_4.normals.elementAt(95);
      expect(normal_4_95, vector3MoreOrLessEquals(Vector3(-0.917252, 0.369282, 0.149263)));
      final normal_4_96 = mesh_4.normals.elementAt(96);
      expect(normal_4_96, vector3MoreOrLessEquals(Vector3(-0.476106, 0.659961, 0.581185)));
      final normal_4_97 = mesh_4.normals.elementAt(97);
      expect(normal_4_97, vector3MoreOrLessEquals(Vector3(-0.556161, 0.685573, 0.469761)));
      final normal_4_98 = mesh_4.normals.elementAt(98);
      expect(normal_4_98, vector3MoreOrLessEquals(Vector3(-0.974714, 0.176358, 0.137223)));
      final normal_4_99 = mesh_4.normals.elementAt(99);
      expect(normal_4_99, vector3MoreOrLessEquals(Vector3(-0.556161, 0.685573, 0.469761)));
      final normal_4_100 = mesh_4.normals.elementAt(100);
      expect(normal_4_100, vector3MoreOrLessEquals(Vector3(-0.982764, -0.036304, 0.181267)));
      final normal_4_101 = mesh_4.normals.elementAt(101);
      expect(normal_4_101, vector3MoreOrLessEquals(Vector3(-0.974714, 0.176358, 0.137223)));
      final normal_4_102 = mesh_4.normals.elementAt(102);
      expect(normal_4_102, vector3MoreOrLessEquals(Vector3(-0.556161, 0.685573, 0.469761)));
      final normal_4_103 = mesh_4.normals.elementAt(103);
      expect(normal_4_103, vector3MoreOrLessEquals(Vector3(-0.626859, 0.745436, -0.226656)));
      final normal_4_104 = mesh_4.normals.elementAt(104);
      expect(normal_4_104, vector3MoreOrLessEquals(Vector3(-0.987205, 0.070377, 0.143084)));
      final normal_4_105 = mesh_4.normals.elementAt(105);
      expect(normal_4_105, vector3MoreOrLessEquals(Vector3(-0.556161, 0.685573, 0.469761)));
      final normal_4_106 = mesh_4.normals.elementAt(106);
      expect(normal_4_106, vector3MoreOrLessEquals(Vector3(-0.987205, 0.070377, 0.143084)));
      final normal_4_107 = mesh_4.normals.elementAt(107);
      expect(normal_4_107, vector3MoreOrLessEquals(Vector3(-0.982764, -0.036304, 0.181267)));
      final normal_4_108 = mesh_4.normals.elementAt(108);
      expect(normal_4_108, vector3MoreOrLessEquals(Vector3(-0.626859, 0.745436, -0.226656)));
      final normal_4_109 = mesh_4.normals.elementAt(109);
      expect(normal_4_109, vector3MoreOrLessEquals(Vector3(-0.554271, 0.436146, -0.708915)));
      final normal_4_110 = mesh_4.normals.elementAt(110);
      expect(normal_4_110, vector3MoreOrLessEquals(Vector3(-0.987205, 0.070377, 0.143084)));
      final normal_4_111 = mesh_4.normals.elementAt(111);
      expect(normal_4_111, vector3MoreOrLessEquals(Vector3(-0.554271, 0.436146, -0.708915)));
      final normal_4_112 = mesh_4.normals.elementAt(112);
      expect(normal_4_112, vector3MoreOrLessEquals(Vector3(-0.988708, 0.090661, -0.119319)));
      final normal_4_113 = mesh_4.normals.elementAt(113);
      expect(normal_4_113, vector3MoreOrLessEquals(Vector3(-0.987205, 0.070377, 0.143084)));
      final normal_4_114 = mesh_4.normals.elementAt(114);
      expect(normal_4_114, vector3MoreOrLessEquals(Vector3(-0.554271, 0.436146, -0.708915)));
      final normal_4_115 = mesh_4.normals.elementAt(115);
      expect(normal_4_115, vector3MoreOrLessEquals(Vector3(-0.561559, 0.310302, -0.767049)));
      final normal_4_116 = mesh_4.normals.elementAt(116);
      expect(normal_4_116, vector3MoreOrLessEquals(Vector3(-0.995465, 0.069805, -0.064628)));
      final normal_4_117 = mesh_4.normals.elementAt(117);
      expect(normal_4_117, vector3MoreOrLessEquals(Vector3(-0.554271, 0.436146, -0.708915)));
      final normal_4_118 = mesh_4.normals.elementAt(118);
      expect(normal_4_118, vector3MoreOrLessEquals(Vector3(-0.995465, 0.069805, -0.064628)));
      final normal_4_119 = mesh_4.normals.elementAt(119);
      expect(normal_4_119, vector3MoreOrLessEquals(Vector3(-0.988708, 0.090661, -0.119319)));
      final normal_4_120 = mesh_4.normals.elementAt(120);
      expect(normal_4_120, vector3MoreOrLessEquals(Vector3(-0.561559, 0.310302, -0.767049)));
      final normal_4_121 = mesh_4.normals.elementAt(121);
      expect(normal_4_121, vector3MoreOrLessEquals(Vector3(-0.54381, 0.416915, -0.728322)));
      final normal_4_122 = mesh_4.normals.elementAt(122);
      expect(normal_4_122, vector3MoreOrLessEquals(Vector3(-0.995465, 0.069805, -0.064628)));
      final normal_4_123 = mesh_4.normals.elementAt(123);
      expect(normal_4_123, vector3MoreOrLessEquals(Vector3(-0.54381, 0.416915, -0.728322)));
      final normal_4_124 = mesh_4.normals.elementAt(124);
      expect(normal_4_124, vector3MoreOrLessEquals(Vector3(-0.986899, 0.153108, -0.050882)));
      final normal_4_125 = mesh_4.normals.elementAt(125);
      expect(normal_4_125, vector3MoreOrLessEquals(Vector3(-0.995465, 0.069805, -0.064628)));
      final normal_4_126 = mesh_4.normals.elementAt(126);
      expect(normal_4_126, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_127 = mesh_4.normals.elementAt(127);
      expect(normal_4_127, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_128 = mesh_4.normals.elementAt(128);
      expect(normal_4_128, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_129 = mesh_4.normals.elementAt(129);
      expect(normal_4_129, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_130 = mesh_4.normals.elementAt(130);
      expect(normal_4_130, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_131 = mesh_4.normals.elementAt(131);
      expect(normal_4_131, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_132 = mesh_4.normals.elementAt(132);
      expect(normal_4_132, vector3MoreOrLessEquals(Vector3(-0.917252, 0.369282, 0.149263)));
      final normal_4_133 = mesh_4.normals.elementAt(133);
      expect(normal_4_133, vector3MoreOrLessEquals(Vector3(-0.974714, 0.176358, 0.137223)));
      final normal_4_134 = mesh_4.normals.elementAt(134);
      expect(normal_4_134, vector3MoreOrLessEquals(Vector3(-0.785702, -0.546219, -0.290374)));
      final normal_4_135 = mesh_4.normals.elementAt(135);
      expect(normal_4_135, vector3MoreOrLessEquals(Vector3(-0.974714, 0.176358, 0.137223)));
      final normal_4_136 = mesh_4.normals.elementAt(136);
      expect(normal_4_136, vector3MoreOrLessEquals(Vector3(-0.802167, -0.447423, -0.3954)));
      final normal_4_137 = mesh_4.normals.elementAt(137);
      expect(normal_4_137, vector3MoreOrLessEquals(Vector3(-0.785702, -0.546219, -0.290374)));
      final normal_4_138 = mesh_4.normals.elementAt(138);
      expect(normal_4_138, vector3MoreOrLessEquals(Vector3(-0.974714, 0.176358, 0.137223)));
      final normal_4_139 = mesh_4.normals.elementAt(139);
      expect(normal_4_139, vector3MoreOrLessEquals(Vector3(-0.982764, -0.036304, 0.181267)));
      final normal_4_140 = mesh_4.normals.elementAt(140);
      expect(normal_4_140, vector3MoreOrLessEquals(Vector3(-0.7883, -0.609188, -0.086443)));
      final normal_4_141 = mesh_4.normals.elementAt(141);
      expect(normal_4_141, vector3MoreOrLessEquals(Vector3(-0.974714, 0.176358, 0.137223)));
      final normal_4_142 = mesh_4.normals.elementAt(142);
      expect(normal_4_142, vector3MoreOrLessEquals(Vector3(-0.7883, -0.609188, -0.086443)));
      final normal_4_143 = mesh_4.normals.elementAt(143);
      expect(normal_4_143, vector3MoreOrLessEquals(Vector3(-0.802167, -0.447423, -0.3954)));
      final normal_4_144 = mesh_4.normals.elementAt(144);
      expect(normal_4_144, vector3MoreOrLessEquals(Vector3(-0.982764, -0.036304, 0.181267)));
      final normal_4_145 = mesh_4.normals.elementAt(145);
      expect(normal_4_145, vector3MoreOrLessEquals(Vector3(-0.987205, 0.070377, 0.143084)));
      final normal_4_146 = mesh_4.normals.elementAt(146);
      expect(normal_4_146, vector3MoreOrLessEquals(Vector3(-0.7883, -0.609188, -0.086443)));
      final normal_4_147 = mesh_4.normals.elementAt(147);
      expect(normal_4_147, vector3MoreOrLessEquals(Vector3(-0.987205, 0.070377, 0.143084)));
      final normal_4_148 = mesh_4.normals.elementAt(148);
      expect(normal_4_148, vector3MoreOrLessEquals(Vector3(-0.635308, -0.586832, 0.502008)));
      final normal_4_149 = mesh_4.normals.elementAt(149);
      expect(normal_4_149, vector3MoreOrLessEquals(Vector3(-0.7883, -0.609188, -0.086443)));
      final normal_4_150 = mesh_4.normals.elementAt(150);
      expect(normal_4_150, vector3MoreOrLessEquals(Vector3(-0.987205, 0.070377, 0.143084)));
      final normal_4_151 = mesh_4.normals.elementAt(151);
      expect(normal_4_151, vector3MoreOrLessEquals(Vector3(-0.988708, 0.090661, -0.119319)));
      final normal_4_152 = mesh_4.normals.elementAt(152);
      expect(normal_4_152, vector3MoreOrLessEquals(Vector3(-0.74892, -0.342648, 0.567196)));
      final normal_4_153 = mesh_4.normals.elementAt(153);
      expect(normal_4_153, vector3MoreOrLessEquals(Vector3(-0.987205, 0.070377, 0.143084)));
      final normal_4_154 = mesh_4.normals.elementAt(154);
      expect(normal_4_154, vector3MoreOrLessEquals(Vector3(-0.74892, -0.342648, 0.567196)));
      final normal_4_155 = mesh_4.normals.elementAt(155);
      expect(normal_4_155, vector3MoreOrLessEquals(Vector3(-0.635308, -0.586832, 0.502008)));
      final normal_4_156 = mesh_4.normals.elementAt(156);
      expect(normal_4_156, vector3MoreOrLessEquals(Vector3(-0.988708, 0.090661, -0.119319)));
      final normal_4_157 = mesh_4.normals.elementAt(157);
      expect(normal_4_157, vector3MoreOrLessEquals(Vector3(-0.995465, 0.069805, -0.064628)));
      final normal_4_158 = mesh_4.normals.elementAt(158);
      expect(normal_4_158, vector3MoreOrLessEquals(Vector3(-0.74892, -0.342648, 0.567196)));
      final normal_4_159 = mesh_4.normals.elementAt(159);
      expect(normal_4_159, vector3MoreOrLessEquals(Vector3(-0.995465, 0.069805, -0.064628)));
      final normal_4_160 = mesh_4.normals.elementAt(160);
      expect(normal_4_160, vector3MoreOrLessEquals(Vector3(-0.829075, -0.19982, 0.522213)));
      final normal_4_161 = mesh_4.normals.elementAt(161);
      expect(normal_4_161, vector3MoreOrLessEquals(Vector3(-0.74892, -0.342648, 0.567196)));
      final normal_4_162 = mesh_4.normals.elementAt(162);
      expect(normal_4_162, vector3MoreOrLessEquals(Vector3(-0.995465, 0.069805, -0.064628)));
      final normal_4_163 = mesh_4.normals.elementAt(163);
      expect(normal_4_163, vector3MoreOrLessEquals(Vector3(-0.986899, 0.153108, -0.050882)));
      final normal_4_164 = mesh_4.normals.elementAt(164);
      expect(normal_4_164, vector3MoreOrLessEquals(Vector3(-0.811409, -0.243593, 0.531299)));
      final normal_4_165 = mesh_4.normals.elementAt(165);
      expect(normal_4_165, vector3MoreOrLessEquals(Vector3(-0.995465, 0.069805, -0.064628)));
      final normal_4_166 = mesh_4.normals.elementAt(166);
      expect(normal_4_166, vector3MoreOrLessEquals(Vector3(-0.811409, -0.243593, 0.531299)));
      final normal_4_167 = mesh_4.normals.elementAt(167);
      expect(normal_4_167, vector3MoreOrLessEquals(Vector3(-0.829075, -0.19982, 0.522213)));
      final normal_4_168 = mesh_4.normals.elementAt(168);
      expect(normal_4_168, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_169 = mesh_4.normals.elementAt(169);
      expect(normal_4_169, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_170 = mesh_4.normals.elementAt(170);
      expect(normal_4_170, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_171 = mesh_4.normals.elementAt(171);
      expect(normal_4_171, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_172 = mesh_4.normals.elementAt(172);
      expect(normal_4_172, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_173 = mesh_4.normals.elementAt(173);
      expect(normal_4_173, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_174 = mesh_4.normals.elementAt(174);
      expect(normal_4_174, vector3MoreOrLessEquals(Vector3(-0.785702, -0.546219, -0.290374)));
      final normal_4_175 = mesh_4.normals.elementAt(175);
      expect(normal_4_175, vector3MoreOrLessEquals(Vector3(-0.802167, -0.447423, -0.3954)));
      final normal_4_176 = mesh_4.normals.elementAt(176);
      expect(normal_4_176, vector3MoreOrLessEquals(Vector3(-0.029726, -0.712976, -0.700558)));
      final normal_4_177 = mesh_4.normals.elementAt(177);
      expect(normal_4_177, vector3MoreOrLessEquals(Vector3(-0.785702, -0.546219, -0.290374)));
      final normal_4_178 = mesh_4.normals.elementAt(178);
      expect(normal_4_178, vector3MoreOrLessEquals(Vector3(-0.029726, -0.712976, -0.700558)));
      final normal_4_179 = mesh_4.normals.elementAt(179);
      expect(normal_4_179, vector3MoreOrLessEquals(Vector3(-0.121255, -0.870385, -0.477207)));
      final normal_4_180 = mesh_4.normals.elementAt(180);
      expect(normal_4_180, vector3MoreOrLessEquals(Vector3(-0.802167, -0.447423, -0.3954)));
      final normal_4_181 = mesh_4.normals.elementAt(181);
      expect(normal_4_181, vector3MoreOrLessEquals(Vector3(-0.7883, -0.609188, -0.086443)));
      final normal_4_182 = mesh_4.normals.elementAt(182);
      expect(normal_4_182, vector3MoreOrLessEquals(Vector3(-0.029726, -0.712976, -0.700558)));
      final normal_4_183 = mesh_4.normals.elementAt(183);
      expect(normal_4_183, vector3MoreOrLessEquals(Vector3(-0.7883, -0.609188, -0.086443)));
      final normal_4_184 = mesh_4.normals.elementAt(184);
      expect(normal_4_184, vector3MoreOrLessEquals(Vector3(0.151176, -0.929851, -0.335445)));
      final normal_4_185 = mesh_4.normals.elementAt(185);
      expect(normal_4_185, vector3MoreOrLessEquals(Vector3(-0.029726, -0.712976, -0.700558)));
      final normal_4_186 = mesh_4.normals.elementAt(186);
      expect(normal_4_186, vector3MoreOrLessEquals(Vector3(-0.7883, -0.609188, -0.086443)));
      final normal_4_187 = mesh_4.normals.elementAt(187);
      expect(normal_4_187, vector3MoreOrLessEquals(Vector3(-0.635308, -0.586832, 0.502008)));
      final normal_4_188 = mesh_4.normals.elementAt(188);
      expect(normal_4_188, vector3MoreOrLessEquals(Vector3(0.202841, -0.825731, 0.526331)));
      final normal_4_189 = mesh_4.normals.elementAt(189);
      expect(normal_4_189, vector3MoreOrLessEquals(Vector3(-0.7883, -0.609188, -0.086443)));
      final normal_4_190 = mesh_4.normals.elementAt(190);
      expect(normal_4_190, vector3MoreOrLessEquals(Vector3(0.202841, -0.825731, 0.526331)));
      final normal_4_191 = mesh_4.normals.elementAt(191);
      expect(normal_4_191, vector3MoreOrLessEquals(Vector3(0.151176, -0.929851, -0.335445)));
      final normal_4_192 = mesh_4.normals.elementAt(192);
      expect(normal_4_192, vector3MoreOrLessEquals(Vector3(-0.635308, -0.586832, 0.502008)));
      final normal_4_193 = mesh_4.normals.elementAt(193);
      expect(normal_4_193, vector3MoreOrLessEquals(Vector3(-0.74892, -0.342648, 0.567196)));
      final normal_4_194 = mesh_4.normals.elementAt(194);
      expect(normal_4_194, vector3MoreOrLessEquals(Vector3(0.202841, -0.825731, 0.526331)));
      final normal_4_195 = mesh_4.normals.elementAt(195);
      expect(normal_4_195, vector3MoreOrLessEquals(Vector3(-0.74892, -0.342648, 0.567196)));
      final normal_4_196 = mesh_4.normals.elementAt(196);
      expect(normal_4_196, vector3MoreOrLessEquals(Vector3(0.080914, -0.528183, 0.845266)));
      final normal_4_197 = mesh_4.normals.elementAt(197);
      expect(normal_4_197, vector3MoreOrLessEquals(Vector3(0.202841, -0.825731, 0.526331)));
      final normal_4_198 = mesh_4.normals.elementAt(198);
      expect(normal_4_198, vector3MoreOrLessEquals(Vector3(-0.74892, -0.342648, 0.567196)));
      final normal_4_199 = mesh_4.normals.elementAt(199);
      expect(normal_4_199, vector3MoreOrLessEquals(Vector3(-0.829075, -0.19982, 0.522213)));
      final normal_4_200 = mesh_4.normals.elementAt(200);
      expect(normal_4_200, vector3MoreOrLessEquals(Vector3(0.010675, -0.474241, 0.88033)));
      final normal_4_201 = mesh_4.normals.elementAt(201);
      expect(normal_4_201, vector3MoreOrLessEquals(Vector3(-0.74892, -0.342648, 0.567196)));
      final normal_4_202 = mesh_4.normals.elementAt(202);
      expect(normal_4_202, vector3MoreOrLessEquals(Vector3(0.010675, -0.474241, 0.88033)));
      final normal_4_203 = mesh_4.normals.elementAt(203);
      expect(normal_4_203, vector3MoreOrLessEquals(Vector3(0.080914, -0.528183, 0.845266)));
      final normal_4_204 = mesh_4.normals.elementAt(204);
      expect(normal_4_204, vector3MoreOrLessEquals(Vector3(-0.829075, -0.19982, 0.522213)));
      final normal_4_205 = mesh_4.normals.elementAt(205);
      expect(normal_4_205, vector3MoreOrLessEquals(Vector3(-0.811409, -0.243593, 0.531299)));
      final normal_4_206 = mesh_4.normals.elementAt(206);
      expect(normal_4_206, vector3MoreOrLessEquals(Vector3(0.010675, -0.474241, 0.88033)));
      final normal_4_207 = mesh_4.normals.elementAt(207);
      expect(normal_4_207, vector3MoreOrLessEquals(Vector3(-0.811409, -0.243593, 0.531299)));
      final normal_4_208 = mesh_4.normals.elementAt(208);
      expect(normal_4_208, vector3MoreOrLessEquals(Vector3(0.014489, -0.635546, 0.771927)));
      final normal_4_209 = mesh_4.normals.elementAt(209);
      expect(normal_4_209, vector3MoreOrLessEquals(Vector3(0.010675, -0.474241, 0.88033)));
      final normal_4_210 = mesh_4.normals.elementAt(210);
      expect(normal_4_210, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_211 = mesh_4.normals.elementAt(211);
      expect(normal_4_211, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_212 = mesh_4.normals.elementAt(212);
      expect(normal_4_212, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_213 = mesh_4.normals.elementAt(213);
      expect(normal_4_213, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_214 = mesh_4.normals.elementAt(214);
      expect(normal_4_214, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_215 = mesh_4.normals.elementAt(215);
      expect(normal_4_215, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_216 = mesh_4.normals.elementAt(216);
      expect(normal_4_216, vector3MoreOrLessEquals(Vector3(-0.121255, -0.870385, -0.477207)));
      final normal_4_217 = mesh_4.normals.elementAt(217);
      expect(normal_4_217, vector3MoreOrLessEquals(Vector3(-0.029726, -0.712976, -0.700558)));
      final normal_4_218 = mesh_4.normals.elementAt(218);
      expect(normal_4_218, vector3MoreOrLessEquals(Vector3(0.742724, -0.545146, -0.388814)));
      final normal_4_219 = mesh_4.normals.elementAt(219);
      expect(normal_4_219, vector3MoreOrLessEquals(Vector3(-0.029726, -0.712976, -0.700558)));
      final normal_4_220 = mesh_4.normals.elementAt(220);
      expect(normal_4_220, vector3MoreOrLessEquals(Vector3(0.78651, -0.383302, -0.484233)));
      final normal_4_221 = mesh_4.normals.elementAt(221);
      expect(normal_4_221, vector3MoreOrLessEquals(Vector3(0.742724, -0.545146, -0.388814)));
      final normal_4_222 = mesh_4.normals.elementAt(222);
      expect(normal_4_222, vector3MoreOrLessEquals(Vector3(-0.029726, -0.712976, -0.700558)));
      final normal_4_223 = mesh_4.normals.elementAt(223);
      expect(normal_4_223, vector3MoreOrLessEquals(Vector3(0.151176, -0.929851, -0.335445)));
      final normal_4_224 = mesh_4.normals.elementAt(224);
      expect(normal_4_224, vector3MoreOrLessEquals(Vector3(0.920594, -0.358142, -0.155695)));
      final normal_4_225 = mesh_4.normals.elementAt(225);
      expect(normal_4_225, vector3MoreOrLessEquals(Vector3(-0.029726, -0.712976, -0.700558)));
      final normal_4_226 = mesh_4.normals.elementAt(226);
      expect(normal_4_226, vector3MoreOrLessEquals(Vector3(0.920594, -0.358142, -0.155695)));
      final normal_4_227 = mesh_4.normals.elementAt(227);
      expect(normal_4_227, vector3MoreOrLessEquals(Vector3(0.78651, -0.383302, -0.484233)));
      final normal_4_228 = mesh_4.normals.elementAt(228);
      expect(normal_4_228, vector3MoreOrLessEquals(Vector3(0.151176, -0.929851, -0.335445)));
      final normal_4_229 = mesh_4.normals.elementAt(229);
      expect(normal_4_229, vector3MoreOrLessEquals(Vector3(0.202841, -0.825731, 0.526331)));
      final normal_4_230 = mesh_4.normals.elementAt(230);
      expect(normal_4_230, vector3MoreOrLessEquals(Vector3(0.920594, -0.358142, -0.155695)));
      final normal_4_231 = mesh_4.normals.elementAt(231);
      expect(normal_4_231, vector3MoreOrLessEquals(Vector3(0.202841, -0.825731, 0.526331)));
      final normal_4_232 = mesh_4.normals.elementAt(232);
      expect(normal_4_232, vector3MoreOrLessEquals(Vector3(0.889767, -0.359426, 0.281297)));
      final normal_4_233 = mesh_4.normals.elementAt(233);
      expect(normal_4_233, vector3MoreOrLessEquals(Vector3(0.920594, -0.358142, -0.155695)));
      final normal_4_234 = mesh_4.normals.elementAt(234);
      expect(normal_4_234, vector3MoreOrLessEquals(Vector3(0.202841, -0.825731, 0.526331)));
      final normal_4_235 = mesh_4.normals.elementAt(235);
      expect(normal_4_235, vector3MoreOrLessEquals(Vector3(0.080914, -0.528183, 0.845266)));
      final normal_4_236 = mesh_4.normals.elementAt(236);
      expect(normal_4_236, vector3MoreOrLessEquals(Vector3(0.873005, -0.294226, 0.388965)));
      final normal_4_237 = mesh_4.normals.elementAt(237);
      expect(normal_4_237, vector3MoreOrLessEquals(Vector3(0.202841, -0.825731, 0.526331)));
      final normal_4_238 = mesh_4.normals.elementAt(238);
      expect(normal_4_238, vector3MoreOrLessEquals(Vector3(0.873005, -0.294226, 0.388965)));
      final normal_4_239 = mesh_4.normals.elementAt(239);
      expect(normal_4_239, vector3MoreOrLessEquals(Vector3(0.889767, -0.359426, 0.281297)));
      final normal_4_240 = mesh_4.normals.elementAt(240);
      expect(normal_4_240, vector3MoreOrLessEquals(Vector3(0.080914, -0.528183, 0.845266)));
      final normal_4_241 = mesh_4.normals.elementAt(241);
      expect(normal_4_241, vector3MoreOrLessEquals(Vector3(0.010675, -0.474241, 0.88033)));
      final normal_4_242 = mesh_4.normals.elementAt(242);
      expect(normal_4_242, vector3MoreOrLessEquals(Vector3(0.873005, -0.294226, 0.388965)));
      final normal_4_243 = mesh_4.normals.elementAt(243);
      expect(normal_4_243, vector3MoreOrLessEquals(Vector3(0.010675, -0.474241, 0.88033)));
      final normal_4_244 = mesh_4.normals.elementAt(244);
      expect(normal_4_244, vector3MoreOrLessEquals(Vector3(0.907656, -0.29173, 0.301752)));
      final normal_4_245 = mesh_4.normals.elementAt(245);
      expect(normal_4_245, vector3MoreOrLessEquals(Vector3(0.873005, -0.294226, 0.388965)));
      final normal_4_246 = mesh_4.normals.elementAt(246);
      expect(normal_4_246, vector3MoreOrLessEquals(Vector3(0.010675, -0.474241, 0.88033)));
      final normal_4_247 = mesh_4.normals.elementAt(247);
      expect(normal_4_247, vector3MoreOrLessEquals(Vector3(0.014489, -0.635546, 0.771927)));
      final normal_4_248 = mesh_4.normals.elementAt(248);
      expect(normal_4_248, vector3MoreOrLessEquals(Vector3(0.863097, -0.445709, 0.237502)));
      final normal_4_249 = mesh_4.normals.elementAt(249);
      expect(normal_4_249, vector3MoreOrLessEquals(Vector3(0.010675, -0.474241, 0.88033)));
      final normal_4_250 = mesh_4.normals.elementAt(250);
      expect(normal_4_250, vector3MoreOrLessEquals(Vector3(0.863097, -0.445709, 0.237502)));
      final normal_4_251 = mesh_4.normals.elementAt(251);
      expect(normal_4_251, vector3MoreOrLessEquals(Vector3(0.907656, -0.29173, 0.301752)));
      final normal_4_252 = mesh_4.normals.elementAt(252);
      expect(normal_4_252, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_253 = mesh_4.normals.elementAt(253);
      expect(normal_4_253, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_254 = mesh_4.normals.elementAt(254);
      expect(normal_4_254, vector3MoreOrLessEquals(Vector3(-0.072988, -0.902254, 0.424984)));
      final normal_4_255 = mesh_4.normals.elementAt(255);
      expect(normal_4_255, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_256 = mesh_4.normals.elementAt(256);
      expect(normal_4_256, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_257 = mesh_4.normals.elementAt(257);
      expect(normal_4_257, vector3MoreOrLessEquals(Vector3(-0.288148, -0.512224, -0.809072)));
      final normal_4_258 = mesh_4.normals.elementAt(258);
      expect(normal_4_258, vector3MoreOrLessEquals(Vector3(0.742724, -0.545146, -0.388814)));
      final normal_4_259 = mesh_4.normals.elementAt(259);
      expect(normal_4_259, vector3MoreOrLessEquals(Vector3(0.78651, -0.383302, -0.484233)));
      final normal_4_260 = mesh_4.normals.elementAt(260);
      expect(normal_4_260, vector3MoreOrLessEquals(Vector3(0.993163, 0.114096, -0.024688)));
      final normal_4_261 = mesh_4.normals.elementAt(261);
      expect(normal_4_261, vector3MoreOrLessEquals(Vector3(0.742724, -0.545146, -0.388814)));
      final normal_4_262 = mesh_4.normals.elementAt(262);
      expect(normal_4_262, vector3MoreOrLessEquals(Vector3(0.993163, 0.114096, -0.024688)));
      final normal_4_263 = mesh_4.normals.elementAt(263);
      expect(normal_4_263, vector3MoreOrLessEquals(Vector3(0.918806, 0.383987, 0.091372)));
      final normal_4_264 = mesh_4.normals.elementAt(264);
      expect(normal_4_264, vector3MoreOrLessEquals(Vector3(0.78651, -0.383302, -0.484233)));
      final normal_4_265 = mesh_4.normals.elementAt(265);
      expect(normal_4_265, vector3MoreOrLessEquals(Vector3(0.920594, -0.358142, -0.155695)));
      final normal_4_266 = mesh_4.normals.elementAt(266);
      expect(normal_4_266, vector3MoreOrLessEquals(Vector3(0.993163, 0.114096, -0.024688)));
      final normal_4_267 = mesh_4.normals.elementAt(267);
      expect(normal_4_267, vector3MoreOrLessEquals(Vector3(0.920594, -0.358142, -0.155695)));
      final normal_4_268 = mesh_4.normals.elementAt(268);
      expect(normal_4_268, vector3MoreOrLessEquals(Vector3(0.868051, 0.441893, 0.226313)));
      final normal_4_269 = mesh_4.normals.elementAt(269);
      expect(normal_4_269, vector3MoreOrLessEquals(Vector3(0.993163, 0.114096, -0.024688)));
      final normal_4_270 = mesh_4.normals.elementAt(270);
      expect(normal_4_270, vector3MoreOrLessEquals(Vector3(0.920594, -0.358142, -0.155695)));
      final normal_4_271 = mesh_4.normals.elementAt(271);
      expect(normal_4_271, vector3MoreOrLessEquals(Vector3(0.889767, -0.359426, 0.281297)));
      final normal_4_272 = mesh_4.normals.elementAt(272);
      expect(normal_4_272, vector3MoreOrLessEquals(Vector3(0.971729, 0.236044, 0.005163)));
      final normal_4_273 = mesh_4.normals.elementAt(273);
      expect(normal_4_273, vector3MoreOrLessEquals(Vector3(0.920594, -0.358142, -0.155695)));
      final normal_4_274 = mesh_4.normals.elementAt(274);
      expect(normal_4_274, vector3MoreOrLessEquals(Vector3(0.971729, 0.236044, 0.005163)));
      final normal_4_275 = mesh_4.normals.elementAt(275);
      expect(normal_4_275, vector3MoreOrLessEquals(Vector3(0.868051, 0.441893, 0.226313)));
      final normal_4_276 = mesh_4.normals.elementAt(276);
      expect(normal_4_276, vector3MoreOrLessEquals(Vector3(0.889767, -0.359426, 0.281297)));
      final normal_4_277 = mesh_4.normals.elementAt(277);
      expect(normal_4_277, vector3MoreOrLessEquals(Vector3(0.873005, -0.294226, 0.388965)));
      final normal_4_278 = mesh_4.normals.elementAt(278);
      expect(normal_4_278, vector3MoreOrLessEquals(Vector3(0.971729, 0.236044, 0.005163)));
      final normal_4_279 = mesh_4.normals.elementAt(279);
      expect(normal_4_279, vector3MoreOrLessEquals(Vector3(0.873005, -0.294226, 0.388965)));
      final normal_4_280 = mesh_4.normals.elementAt(280);
      expect(normal_4_280, vector3MoreOrLessEquals(Vector3(0.907561, 0.183989, -0.377467)));
      final normal_4_281 = mesh_4.normals.elementAt(281);
      expect(normal_4_281, vector3MoreOrLessEquals(Vector3(0.971729, 0.236044, 0.005163)));
      final normal_4_282 = mesh_4.normals.elementAt(282);
      expect(normal_4_282, vector3MoreOrLessEquals(Vector3(0.873005, -0.294226, 0.388965)));
      final normal_4_283 = mesh_4.normals.elementAt(283);
      expect(normal_4_283, vector3MoreOrLessEquals(Vector3(0.907656, -0.29173, 0.301752)));
      final normal_4_284 = mesh_4.normals.elementAt(284);
      expect(normal_4_284, vector3MoreOrLessEquals(Vector3(0.974181, -0.045977, -0.221037)));
      final normal_4_285 = mesh_4.normals.elementAt(285);
      expect(normal_4_285, vector3MoreOrLessEquals(Vector3(0.873005, -0.294226, 0.388965)));
      final normal_4_286 = mesh_4.normals.elementAt(286);
      expect(normal_4_286, vector3MoreOrLessEquals(Vector3(0.974181, -0.045977, -0.221037)));
      final normal_4_287 = mesh_4.normals.elementAt(287);
      expect(normal_4_287, vector3MoreOrLessEquals(Vector3(0.907561, 0.183989, -0.377467)));
      final normal_4_288 = mesh_4.normals.elementAt(288);
      expect(normal_4_288, vector3MoreOrLessEquals(Vector3(0.907656, -0.29173, 0.301752)));
      final normal_4_289 = mesh_4.normals.elementAt(289);
      expect(normal_4_289, vector3MoreOrLessEquals(Vector3(0.863097, -0.445709, 0.237502)));
      final normal_4_290 = mesh_4.normals.elementAt(290);
      expect(normal_4_290, vector3MoreOrLessEquals(Vector3(0.974181, -0.045977, -0.221037)));
      final normal_4_291 = mesh_4.normals.elementAt(291);
      expect(normal_4_291, vector3MoreOrLessEquals(Vector3(0.863097, -0.445709, 0.237502)));
      final normal_4_292 = mesh_4.normals.elementAt(292);
      expect(normal_4_292, vector3MoreOrLessEquals(Vector3(0.886674, 0.017475, -0.462065)));
      final normal_4_293 = mesh_4.normals.elementAt(293);
      expect(normal_4_293, vector3MoreOrLessEquals(Vector3(0.974181, -0.045977, -0.221037)));
      expect(mesh_4.tangents.length, isZero);
      expect(mesh_4.bitangents.length, isZero);
      expect(mesh_4.colors.length, isZero);
      expect(mesh_4.textureCoords.length, equals(1));
      final textureCoords_4_0 = mesh_4.textureCoords.elementAt(0);
      expect(textureCoords_4_0.length, equals(294));
      final textureCoord_4_0_0 = textureCoords_4_0.elementAt(0);
      expect(textureCoord_4_0_0, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_1 = textureCoords_4_0.elementAt(1);
      expect(textureCoord_4_0_1, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_2 = textureCoords_4_0.elementAt(2);
      expect(textureCoord_4_0_2, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_3 = textureCoords_4_0.elementAt(3);
      expect(textureCoord_4_0_3, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_4 = textureCoords_4_0.elementAt(4);
      expect(textureCoord_4_0_4, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_5 = textureCoords_4_0.elementAt(5);
      expect(textureCoord_4_0_5, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_6 = textureCoords_4_0.elementAt(6);
      expect(textureCoord_4_0_6, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_4_0_7 = textureCoords_4_0.elementAt(7);
      expect(textureCoord_4_0_7, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_4_0_8 = textureCoords_4_0.elementAt(8);
      expect(textureCoord_4_0_8, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_4_0_9 = textureCoords_4_0.elementAt(9);
      expect(textureCoord_4_0_9, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_4_0_10 = textureCoords_4_0.elementAt(10);
      expect(textureCoord_4_0_10, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_4_0_11 = textureCoords_4_0.elementAt(11);
      expect(textureCoord_4_0_11, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_4_0_12 = textureCoords_4_0.elementAt(12);
      expect(textureCoord_4_0_12, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_4_0_13 = textureCoords_4_0.elementAt(13);
      expect(textureCoord_4_0_13, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_4_0_14 = textureCoords_4_0.elementAt(14);
      expect(textureCoord_4_0_14, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_4_0_15 = textureCoords_4_0.elementAt(15);
      expect(textureCoord_4_0_15, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_4_0_16 = textureCoords_4_0.elementAt(16);
      expect(textureCoord_4_0_16, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_4_0_17 = textureCoords_4_0.elementAt(17);
      expect(textureCoord_4_0_17, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_4_0_18 = textureCoords_4_0.elementAt(18);
      expect(textureCoord_4_0_18, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_4_0_19 = textureCoords_4_0.elementAt(19);
      expect(textureCoord_4_0_19, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_4_0_20 = textureCoords_4_0.elementAt(20);
      expect(textureCoord_4_0_20, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_4_0_21 = textureCoords_4_0.elementAt(21);
      expect(textureCoord_4_0_21, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_4_0_22 = textureCoords_4_0.elementAt(22);
      expect(textureCoord_4_0_22, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_4_0_23 = textureCoords_4_0.elementAt(23);
      expect(textureCoord_4_0_23, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_4_0_24 = textureCoords_4_0.elementAt(24);
      expect(textureCoord_4_0_24, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_4_0_25 = textureCoords_4_0.elementAt(25);
      expect(textureCoord_4_0_25, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_4_0_26 = textureCoords_4_0.elementAt(26);
      expect(textureCoord_4_0_26, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_4_0_27 = textureCoords_4_0.elementAt(27);
      expect(textureCoord_4_0_27, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_4_0_28 = textureCoords_4_0.elementAt(28);
      expect(textureCoord_4_0_28, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_4_0_29 = textureCoords_4_0.elementAt(29);
      expect(textureCoord_4_0_29, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_4_0_30 = textureCoords_4_0.elementAt(30);
      expect(textureCoord_4_0_30, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_4_0_31 = textureCoords_4_0.elementAt(31);
      expect(textureCoord_4_0_31, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_4_0_32 = textureCoords_4_0.elementAt(32);
      expect(textureCoord_4_0_32, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_4_0_33 = textureCoords_4_0.elementAt(33);
      expect(textureCoord_4_0_33, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_4_0_34 = textureCoords_4_0.elementAt(34);
      expect(textureCoord_4_0_34, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_4_0_35 = textureCoords_4_0.elementAt(35);
      expect(textureCoord_4_0_35, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_4_0_36 = textureCoords_4_0.elementAt(36);
      expect(textureCoord_4_0_36, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_4_0_37 = textureCoords_4_0.elementAt(37);
      expect(textureCoord_4_0_37, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_38 = textureCoords_4_0.elementAt(38);
      expect(textureCoord_4_0_38, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_4_0_39 = textureCoords_4_0.elementAt(39);
      expect(textureCoord_4_0_39, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_40 = textureCoords_4_0.elementAt(40);
      expect(textureCoord_4_0_40, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_4_0_41 = textureCoords_4_0.elementAt(41);
      expect(textureCoord_4_0_41, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_4_0_42 = textureCoords_4_0.elementAt(42);
      expect(textureCoord_4_0_42, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_43 = textureCoords_4_0.elementAt(43);
      expect(textureCoord_4_0_43, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_44 = textureCoords_4_0.elementAt(44);
      expect(textureCoord_4_0_44, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_45 = textureCoords_4_0.elementAt(45);
      expect(textureCoord_4_0_45, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_46 = textureCoords_4_0.elementAt(46);
      expect(textureCoord_4_0_46, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_47 = textureCoords_4_0.elementAt(47);
      expect(textureCoord_4_0_47, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_48 = textureCoords_4_0.elementAt(48);
      expect(textureCoord_4_0_48, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_4_0_49 = textureCoords_4_0.elementAt(49);
      expect(textureCoord_4_0_49, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_4_0_50 = textureCoords_4_0.elementAt(50);
      expect(textureCoord_4_0_50, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_4_0_51 = textureCoords_4_0.elementAt(51);
      expect(textureCoord_4_0_51, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_4_0_52 = textureCoords_4_0.elementAt(52);
      expect(textureCoord_4_0_52, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_4_0_53 = textureCoords_4_0.elementAt(53);
      expect(textureCoord_4_0_53, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_4_0_54 = textureCoords_4_0.elementAt(54);
      expect(textureCoord_4_0_54, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_4_0_55 = textureCoords_4_0.elementAt(55);
      expect(textureCoord_4_0_55, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_4_0_56 = textureCoords_4_0.elementAt(56);
      expect(textureCoord_4_0_56, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_4_0_57 = textureCoords_4_0.elementAt(57);
      expect(textureCoord_4_0_57, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_4_0_58 = textureCoords_4_0.elementAt(58);
      expect(textureCoord_4_0_58, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_4_0_59 = textureCoords_4_0.elementAt(59);
      expect(textureCoord_4_0_59, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_4_0_60 = textureCoords_4_0.elementAt(60);
      expect(textureCoord_4_0_60, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_4_0_61 = textureCoords_4_0.elementAt(61);
      expect(textureCoord_4_0_61, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_4_0_62 = textureCoords_4_0.elementAt(62);
      expect(textureCoord_4_0_62, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_4_0_63 = textureCoords_4_0.elementAt(63);
      expect(textureCoord_4_0_63, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_4_0_64 = textureCoords_4_0.elementAt(64);
      expect(textureCoord_4_0_64, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_4_0_65 = textureCoords_4_0.elementAt(65);
      expect(textureCoord_4_0_65, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_4_0_66 = textureCoords_4_0.elementAt(66);
      expect(textureCoord_4_0_66, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_4_0_67 = textureCoords_4_0.elementAt(67);
      expect(textureCoord_4_0_67, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_4_0_68 = textureCoords_4_0.elementAt(68);
      expect(textureCoord_4_0_68, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_4_0_69 = textureCoords_4_0.elementAt(69);
      expect(textureCoord_4_0_69, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_4_0_70 = textureCoords_4_0.elementAt(70);
      expect(textureCoord_4_0_70, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_4_0_71 = textureCoords_4_0.elementAt(71);
      expect(textureCoord_4_0_71, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_4_0_72 = textureCoords_4_0.elementAt(72);
      expect(textureCoord_4_0_72, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_4_0_73 = textureCoords_4_0.elementAt(73);
      expect(textureCoord_4_0_73, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_4_0_74 = textureCoords_4_0.elementAt(74);
      expect(textureCoord_4_0_74, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_4_0_75 = textureCoords_4_0.elementAt(75);
      expect(textureCoord_4_0_75, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_4_0_76 = textureCoords_4_0.elementAt(76);
      expect(textureCoord_4_0_76, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_4_0_77 = textureCoords_4_0.elementAt(77);
      expect(textureCoord_4_0_77, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_4_0_78 = textureCoords_4_0.elementAt(78);
      expect(textureCoord_4_0_78, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_4_0_79 = textureCoords_4_0.elementAt(79);
      expect(textureCoord_4_0_79, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_4_0_80 = textureCoords_4_0.elementAt(80);
      expect(textureCoord_4_0_80, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_4_0_81 = textureCoords_4_0.elementAt(81);
      expect(textureCoord_4_0_81, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_4_0_82 = textureCoords_4_0.elementAt(82);
      expect(textureCoord_4_0_82, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_4_0_83 = textureCoords_4_0.elementAt(83);
      expect(textureCoord_4_0_83, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_4_0_84 = textureCoords_4_0.elementAt(84);
      expect(textureCoord_4_0_84, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_85 = textureCoords_4_0.elementAt(85);
      expect(textureCoord_4_0_85, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_86 = textureCoords_4_0.elementAt(86);
      expect(textureCoord_4_0_86, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_87 = textureCoords_4_0.elementAt(87);
      expect(textureCoord_4_0_87, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_88 = textureCoords_4_0.elementAt(88);
      expect(textureCoord_4_0_88, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_89 = textureCoords_4_0.elementAt(89);
      expect(textureCoord_4_0_89, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_90 = textureCoords_4_0.elementAt(90);
      expect(textureCoord_4_0_90, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_4_0_91 = textureCoords_4_0.elementAt(91);
      expect(textureCoord_4_0_91, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_4_0_92 = textureCoords_4_0.elementAt(92);
      expect(textureCoord_4_0_92, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_4_0_93 = textureCoords_4_0.elementAt(93);
      expect(textureCoord_4_0_93, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_4_0_94 = textureCoords_4_0.elementAt(94);
      expect(textureCoord_4_0_94, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_4_0_95 = textureCoords_4_0.elementAt(95);
      expect(textureCoord_4_0_95, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_4_0_96 = textureCoords_4_0.elementAt(96);
      expect(textureCoord_4_0_96, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_4_0_97 = textureCoords_4_0.elementAt(97);
      expect(textureCoord_4_0_97, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_4_0_98 = textureCoords_4_0.elementAt(98);
      expect(textureCoord_4_0_98, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_4_0_99 = textureCoords_4_0.elementAt(99);
      expect(textureCoord_4_0_99, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_4_0_100 = textureCoords_4_0.elementAt(100);
      expect(textureCoord_4_0_100, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_4_0_101 = textureCoords_4_0.elementAt(101);
      expect(textureCoord_4_0_101, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_4_0_102 = textureCoords_4_0.elementAt(102);
      expect(textureCoord_4_0_102, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_4_0_103 = textureCoords_4_0.elementAt(103);
      expect(textureCoord_4_0_103, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_4_0_104 = textureCoords_4_0.elementAt(104);
      expect(textureCoord_4_0_104, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_4_0_105 = textureCoords_4_0.elementAt(105);
      expect(textureCoord_4_0_105, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_4_0_106 = textureCoords_4_0.elementAt(106);
      expect(textureCoord_4_0_106, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_4_0_107 = textureCoords_4_0.elementAt(107);
      expect(textureCoord_4_0_107, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_4_0_108 = textureCoords_4_0.elementAt(108);
      expect(textureCoord_4_0_108, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_4_0_109 = textureCoords_4_0.elementAt(109);
      expect(textureCoord_4_0_109, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_4_0_110 = textureCoords_4_0.elementAt(110);
      expect(textureCoord_4_0_110, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_4_0_111 = textureCoords_4_0.elementAt(111);
      expect(textureCoord_4_0_111, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_4_0_112 = textureCoords_4_0.elementAt(112);
      expect(textureCoord_4_0_112, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_4_0_113 = textureCoords_4_0.elementAt(113);
      expect(textureCoord_4_0_113, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_4_0_114 = textureCoords_4_0.elementAt(114);
      expect(textureCoord_4_0_114, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_4_0_115 = textureCoords_4_0.elementAt(115);
      expect(textureCoord_4_0_115, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_4_0_116 = textureCoords_4_0.elementAt(116);
      expect(textureCoord_4_0_116, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_4_0_117 = textureCoords_4_0.elementAt(117);
      expect(textureCoord_4_0_117, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_4_0_118 = textureCoords_4_0.elementAt(118);
      expect(textureCoord_4_0_118, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_4_0_119 = textureCoords_4_0.elementAt(119);
      expect(textureCoord_4_0_119, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_4_0_120 = textureCoords_4_0.elementAt(120);
      expect(textureCoord_4_0_120, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_4_0_121 = textureCoords_4_0.elementAt(121);
      expect(textureCoord_4_0_121, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_4_0_122 = textureCoords_4_0.elementAt(122);
      expect(textureCoord_4_0_122, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_4_0_123 = textureCoords_4_0.elementAt(123);
      expect(textureCoord_4_0_123, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_4_0_124 = textureCoords_4_0.elementAt(124);
      expect(textureCoord_4_0_124, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_4_0_125 = textureCoords_4_0.elementAt(125);
      expect(textureCoord_4_0_125, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_4_0_126 = textureCoords_4_0.elementAt(126);
      expect(textureCoord_4_0_126, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_127 = textureCoords_4_0.elementAt(127);
      expect(textureCoord_4_0_127, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_128 = textureCoords_4_0.elementAt(128);
      expect(textureCoord_4_0_128, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_129 = textureCoords_4_0.elementAt(129);
      expect(textureCoord_4_0_129, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_130 = textureCoords_4_0.elementAt(130);
      expect(textureCoord_4_0_130, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_131 = textureCoords_4_0.elementAt(131);
      expect(textureCoord_4_0_131, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_132 = textureCoords_4_0.elementAt(132);
      expect(textureCoord_4_0_132, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_4_0_133 = textureCoords_4_0.elementAt(133);
      expect(textureCoord_4_0_133, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_4_0_134 = textureCoords_4_0.elementAt(134);
      expect(textureCoord_4_0_134, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_4_0_135 = textureCoords_4_0.elementAt(135);
      expect(textureCoord_4_0_135, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_4_0_136 = textureCoords_4_0.elementAt(136);
      expect(textureCoord_4_0_136, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_4_0_137 = textureCoords_4_0.elementAt(137);
      expect(textureCoord_4_0_137, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_4_0_138 = textureCoords_4_0.elementAt(138);
      expect(textureCoord_4_0_138, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_4_0_139 = textureCoords_4_0.elementAt(139);
      expect(textureCoord_4_0_139, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_4_0_140 = textureCoords_4_0.elementAt(140);
      expect(textureCoord_4_0_140, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_4_0_141 = textureCoords_4_0.elementAt(141);
      expect(textureCoord_4_0_141, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_4_0_142 = textureCoords_4_0.elementAt(142);
      expect(textureCoord_4_0_142, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_4_0_143 = textureCoords_4_0.elementAt(143);
      expect(textureCoord_4_0_143, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_4_0_144 = textureCoords_4_0.elementAt(144);
      expect(textureCoord_4_0_144, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_4_0_145 = textureCoords_4_0.elementAt(145);
      expect(textureCoord_4_0_145, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_4_0_146 = textureCoords_4_0.elementAt(146);
      expect(textureCoord_4_0_146, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_4_0_147 = textureCoords_4_0.elementAt(147);
      expect(textureCoord_4_0_147, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_4_0_148 = textureCoords_4_0.elementAt(148);
      expect(textureCoord_4_0_148, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_4_0_149 = textureCoords_4_0.elementAt(149);
      expect(textureCoord_4_0_149, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_4_0_150 = textureCoords_4_0.elementAt(150);
      expect(textureCoord_4_0_150, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_4_0_151 = textureCoords_4_0.elementAt(151);
      expect(textureCoord_4_0_151, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_4_0_152 = textureCoords_4_0.elementAt(152);
      expect(textureCoord_4_0_152, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_4_0_153 = textureCoords_4_0.elementAt(153);
      expect(textureCoord_4_0_153, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_4_0_154 = textureCoords_4_0.elementAt(154);
      expect(textureCoord_4_0_154, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_4_0_155 = textureCoords_4_0.elementAt(155);
      expect(textureCoord_4_0_155, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_4_0_156 = textureCoords_4_0.elementAt(156);
      expect(textureCoord_4_0_156, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_4_0_157 = textureCoords_4_0.elementAt(157);
      expect(textureCoord_4_0_157, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_4_0_158 = textureCoords_4_0.elementAt(158);
      expect(textureCoord_4_0_158, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_4_0_159 = textureCoords_4_0.elementAt(159);
      expect(textureCoord_4_0_159, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_4_0_160 = textureCoords_4_0.elementAt(160);
      expect(textureCoord_4_0_160, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_4_0_161 = textureCoords_4_0.elementAt(161);
      expect(textureCoord_4_0_161, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_4_0_162 = textureCoords_4_0.elementAt(162);
      expect(textureCoord_4_0_162, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_4_0_163 = textureCoords_4_0.elementAt(163);
      expect(textureCoord_4_0_163, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_4_0_164 = textureCoords_4_0.elementAt(164);
      expect(textureCoord_4_0_164, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_4_0_165 = textureCoords_4_0.elementAt(165);
      expect(textureCoord_4_0_165, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_4_0_166 = textureCoords_4_0.elementAt(166);
      expect(textureCoord_4_0_166, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_4_0_167 = textureCoords_4_0.elementAt(167);
      expect(textureCoord_4_0_167, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_4_0_168 = textureCoords_4_0.elementAt(168);
      expect(textureCoord_4_0_168, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_169 = textureCoords_4_0.elementAt(169);
      expect(textureCoord_4_0_169, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_170 = textureCoords_4_0.elementAt(170);
      expect(textureCoord_4_0_170, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_171 = textureCoords_4_0.elementAt(171);
      expect(textureCoord_4_0_171, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_172 = textureCoords_4_0.elementAt(172);
      expect(textureCoord_4_0_172, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_173 = textureCoords_4_0.elementAt(173);
      expect(textureCoord_4_0_173, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_174 = textureCoords_4_0.elementAt(174);
      expect(textureCoord_4_0_174, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_4_0_175 = textureCoords_4_0.elementAt(175);
      expect(textureCoord_4_0_175, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_4_0_176 = textureCoords_4_0.elementAt(176);
      expect(textureCoord_4_0_176, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_4_0_177 = textureCoords_4_0.elementAt(177);
      expect(textureCoord_4_0_177, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_4_0_178 = textureCoords_4_0.elementAt(178);
      expect(textureCoord_4_0_178, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_4_0_179 = textureCoords_4_0.elementAt(179);
      expect(textureCoord_4_0_179, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_4_0_180 = textureCoords_4_0.elementAt(180);
      expect(textureCoord_4_0_180, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_4_0_181 = textureCoords_4_0.elementAt(181);
      expect(textureCoord_4_0_181, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_4_0_182 = textureCoords_4_0.elementAt(182);
      expect(textureCoord_4_0_182, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_4_0_183 = textureCoords_4_0.elementAt(183);
      expect(textureCoord_4_0_183, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_4_0_184 = textureCoords_4_0.elementAt(184);
      expect(textureCoord_4_0_184, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_4_0_185 = textureCoords_4_0.elementAt(185);
      expect(textureCoord_4_0_185, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_4_0_186 = textureCoords_4_0.elementAt(186);
      expect(textureCoord_4_0_186, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_4_0_187 = textureCoords_4_0.elementAt(187);
      expect(textureCoord_4_0_187, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_4_0_188 = textureCoords_4_0.elementAt(188);
      expect(textureCoord_4_0_188, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_4_0_189 = textureCoords_4_0.elementAt(189);
      expect(textureCoord_4_0_189, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_4_0_190 = textureCoords_4_0.elementAt(190);
      expect(textureCoord_4_0_190, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_4_0_191 = textureCoords_4_0.elementAt(191);
      expect(textureCoord_4_0_191, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_4_0_192 = textureCoords_4_0.elementAt(192);
      expect(textureCoord_4_0_192, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_4_0_193 = textureCoords_4_0.elementAt(193);
      expect(textureCoord_4_0_193, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_4_0_194 = textureCoords_4_0.elementAt(194);
      expect(textureCoord_4_0_194, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_4_0_195 = textureCoords_4_0.elementAt(195);
      expect(textureCoord_4_0_195, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_4_0_196 = textureCoords_4_0.elementAt(196);
      expect(textureCoord_4_0_196, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_4_0_197 = textureCoords_4_0.elementAt(197);
      expect(textureCoord_4_0_197, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_4_0_198 = textureCoords_4_0.elementAt(198);
      expect(textureCoord_4_0_198, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_4_0_199 = textureCoords_4_0.elementAt(199);
      expect(textureCoord_4_0_199, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_4_0_200 = textureCoords_4_0.elementAt(200);
      expect(textureCoord_4_0_200, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_4_0_201 = textureCoords_4_0.elementAt(201);
      expect(textureCoord_4_0_201, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_4_0_202 = textureCoords_4_0.elementAt(202);
      expect(textureCoord_4_0_202, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_4_0_203 = textureCoords_4_0.elementAt(203);
      expect(textureCoord_4_0_203, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_4_0_204 = textureCoords_4_0.elementAt(204);
      expect(textureCoord_4_0_204, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_4_0_205 = textureCoords_4_0.elementAt(205);
      expect(textureCoord_4_0_205, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_4_0_206 = textureCoords_4_0.elementAt(206);
      expect(textureCoord_4_0_206, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_4_0_207 = textureCoords_4_0.elementAt(207);
      expect(textureCoord_4_0_207, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_4_0_208 = textureCoords_4_0.elementAt(208);
      expect(textureCoord_4_0_208, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_4_0_209 = textureCoords_4_0.elementAt(209);
      expect(textureCoord_4_0_209, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_4_0_210 = textureCoords_4_0.elementAt(210);
      expect(textureCoord_4_0_210, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_211 = textureCoords_4_0.elementAt(211);
      expect(textureCoord_4_0_211, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_212 = textureCoords_4_0.elementAt(212);
      expect(textureCoord_4_0_212, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_213 = textureCoords_4_0.elementAt(213);
      expect(textureCoord_4_0_213, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_214 = textureCoords_4_0.elementAt(214);
      expect(textureCoord_4_0_214, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_215 = textureCoords_4_0.elementAt(215);
      expect(textureCoord_4_0_215, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_216 = textureCoords_4_0.elementAt(216);
      expect(textureCoord_4_0_216, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_4_0_217 = textureCoords_4_0.elementAt(217);
      expect(textureCoord_4_0_217, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_4_0_218 = textureCoords_4_0.elementAt(218);
      expect(textureCoord_4_0_218, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_4_0_219 = textureCoords_4_0.elementAt(219);
      expect(textureCoord_4_0_219, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_4_0_220 = textureCoords_4_0.elementAt(220);
      expect(textureCoord_4_0_220, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_4_0_221 = textureCoords_4_0.elementAt(221);
      expect(textureCoord_4_0_221, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_4_0_222 = textureCoords_4_0.elementAt(222);
      expect(textureCoord_4_0_222, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_4_0_223 = textureCoords_4_0.elementAt(223);
      expect(textureCoord_4_0_223, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_4_0_224 = textureCoords_4_0.elementAt(224);
      expect(textureCoord_4_0_224, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_4_0_225 = textureCoords_4_0.elementAt(225);
      expect(textureCoord_4_0_225, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_4_0_226 = textureCoords_4_0.elementAt(226);
      expect(textureCoord_4_0_226, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_4_0_227 = textureCoords_4_0.elementAt(227);
      expect(textureCoord_4_0_227, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_4_0_228 = textureCoords_4_0.elementAt(228);
      expect(textureCoord_4_0_228, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_4_0_229 = textureCoords_4_0.elementAt(229);
      expect(textureCoord_4_0_229, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_4_0_230 = textureCoords_4_0.elementAt(230);
      expect(textureCoord_4_0_230, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_4_0_231 = textureCoords_4_0.elementAt(231);
      expect(textureCoord_4_0_231, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_4_0_232 = textureCoords_4_0.elementAt(232);
      expect(textureCoord_4_0_232, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_4_0_233 = textureCoords_4_0.elementAt(233);
      expect(textureCoord_4_0_233, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_4_0_234 = textureCoords_4_0.elementAt(234);
      expect(textureCoord_4_0_234, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_4_0_235 = textureCoords_4_0.elementAt(235);
      expect(textureCoord_4_0_235, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_4_0_236 = textureCoords_4_0.elementAt(236);
      expect(textureCoord_4_0_236, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_4_0_237 = textureCoords_4_0.elementAt(237);
      expect(textureCoord_4_0_237, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_4_0_238 = textureCoords_4_0.elementAt(238);
      expect(textureCoord_4_0_238, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_4_0_239 = textureCoords_4_0.elementAt(239);
      expect(textureCoord_4_0_239, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_4_0_240 = textureCoords_4_0.elementAt(240);
      expect(textureCoord_4_0_240, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_4_0_241 = textureCoords_4_0.elementAt(241);
      expect(textureCoord_4_0_241, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_4_0_242 = textureCoords_4_0.elementAt(242);
      expect(textureCoord_4_0_242, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_4_0_243 = textureCoords_4_0.elementAt(243);
      expect(textureCoord_4_0_243, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_4_0_244 = textureCoords_4_0.elementAt(244);
      expect(textureCoord_4_0_244, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_4_0_245 = textureCoords_4_0.elementAt(245);
      expect(textureCoord_4_0_245, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_4_0_246 = textureCoords_4_0.elementAt(246);
      expect(textureCoord_4_0_246, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_4_0_247 = textureCoords_4_0.elementAt(247);
      expect(textureCoord_4_0_247, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_4_0_248 = textureCoords_4_0.elementAt(248);
      expect(textureCoord_4_0_248, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_4_0_249 = textureCoords_4_0.elementAt(249);
      expect(textureCoord_4_0_249, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_4_0_250 = textureCoords_4_0.elementAt(250);
      expect(textureCoord_4_0_250, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_4_0_251 = textureCoords_4_0.elementAt(251);
      expect(textureCoord_4_0_251, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_4_0_252 = textureCoords_4_0.elementAt(252);
      expect(textureCoord_4_0_252, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_253 = textureCoords_4_0.elementAt(253);
      expect(textureCoord_4_0_253, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_254 = textureCoords_4_0.elementAt(254);
      expect(textureCoord_4_0_254, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_255 = textureCoords_4_0.elementAt(255);
      expect(textureCoord_4_0_255, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_256 = textureCoords_4_0.elementAt(256);
      expect(textureCoord_4_0_256, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_257 = textureCoords_4_0.elementAt(257);
      expect(textureCoord_4_0_257, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_4_0_258 = textureCoords_4_0.elementAt(258);
      expect(textureCoord_4_0_258, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_4_0_259 = textureCoords_4_0.elementAt(259);
      expect(textureCoord_4_0_259, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_4_0_260 = textureCoords_4_0.elementAt(260);
      expect(textureCoord_4_0_260, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_4_0_261 = textureCoords_4_0.elementAt(261);
      expect(textureCoord_4_0_261, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_4_0_262 = textureCoords_4_0.elementAt(262);
      expect(textureCoord_4_0_262, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_4_0_263 = textureCoords_4_0.elementAt(263);
      expect(textureCoord_4_0_263, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_4_0_264 = textureCoords_4_0.elementAt(264);
      expect(textureCoord_4_0_264, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_4_0_265 = textureCoords_4_0.elementAt(265);
      expect(textureCoord_4_0_265, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_4_0_266 = textureCoords_4_0.elementAt(266);
      expect(textureCoord_4_0_266, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_4_0_267 = textureCoords_4_0.elementAt(267);
      expect(textureCoord_4_0_267, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_4_0_268 = textureCoords_4_0.elementAt(268);
      expect(textureCoord_4_0_268, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_4_0_269 = textureCoords_4_0.elementAt(269);
      expect(textureCoord_4_0_269, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_4_0_270 = textureCoords_4_0.elementAt(270);
      expect(textureCoord_4_0_270, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_4_0_271 = textureCoords_4_0.elementAt(271);
      expect(textureCoord_4_0_271, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_4_0_272 = textureCoords_4_0.elementAt(272);
      expect(textureCoord_4_0_272, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_4_0_273 = textureCoords_4_0.elementAt(273);
      expect(textureCoord_4_0_273, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_4_0_274 = textureCoords_4_0.elementAt(274);
      expect(textureCoord_4_0_274, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_4_0_275 = textureCoords_4_0.elementAt(275);
      expect(textureCoord_4_0_275, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_4_0_276 = textureCoords_4_0.elementAt(276);
      expect(textureCoord_4_0_276, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_4_0_277 = textureCoords_4_0.elementAt(277);
      expect(textureCoord_4_0_277, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_4_0_278 = textureCoords_4_0.elementAt(278);
      expect(textureCoord_4_0_278, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_4_0_279 = textureCoords_4_0.elementAt(279);
      expect(textureCoord_4_0_279, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_4_0_280 = textureCoords_4_0.elementAt(280);
      expect(textureCoord_4_0_280, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_4_0_281 = textureCoords_4_0.elementAt(281);
      expect(textureCoord_4_0_281, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_4_0_282 = textureCoords_4_0.elementAt(282);
      expect(textureCoord_4_0_282, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_4_0_283 = textureCoords_4_0.elementAt(283);
      expect(textureCoord_4_0_283, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_4_0_284 = textureCoords_4_0.elementAt(284);
      expect(textureCoord_4_0_284, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_4_0_285 = textureCoords_4_0.elementAt(285);
      expect(textureCoord_4_0_285, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_4_0_286 = textureCoords_4_0.elementAt(286);
      expect(textureCoord_4_0_286, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_4_0_287 = textureCoords_4_0.elementAt(287);
      expect(textureCoord_4_0_287, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_4_0_288 = textureCoords_4_0.elementAt(288);
      expect(textureCoord_4_0_288, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_4_0_289 = textureCoords_4_0.elementAt(289);
      expect(textureCoord_4_0_289, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_4_0_290 = textureCoords_4_0.elementAt(290);
      expect(textureCoord_4_0_290, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_4_0_291 = textureCoords_4_0.elementAt(291);
      expect(textureCoord_4_0_291, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_4_0_292 = textureCoords_4_0.elementAt(292);
      expect(textureCoord_4_0_292, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_4_0_293 = textureCoords_4_0.elementAt(293);
      expect(textureCoord_4_0_293, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      expect(mesh_4.uvComponents.length, equals(1));
      expect(mesh_4.uvComponents, equals([2]));
      expect(mesh_4.faces.length, equals(98));
      expect(mesh_4.bones.length, isZero);
      expect(mesh_4.materialIndex, equals(4));
      expect(mesh_4.name, equals('Bein2Li'));
      expect(mesh_4.animMeshes.length, isZero);
      expect(mesh_4.morphingMethod, isZero);
      expect(mesh_4.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_5 = meshes.elementAt(5);
      expect(mesh_5.primitiveTypes, equals(4));
      expect(mesh_5.vertices.length, equals(294));
      final vertex_5_0 = mesh_5.vertices.elementAt(0);
      expect(vertex_5_0, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_1 = mesh_5.vertices.elementAt(1);
      expect(vertex_5_1, vector3MoreOrLessEquals(Vector3(-34.5024, -1.65542, -5.0322)));
      final vertex_5_2 = mesh_5.vertices.elementAt(2);
      expect(vertex_5_2, vector3MoreOrLessEquals(Vector3(-32.2028, -2.60241, -2.72874)));
      final vertex_5_3 = mesh_5.vertices.elementAt(3);
      expect(vertex_5_3, vector3MoreOrLessEquals(Vector3(-28.6964, -38.6124, 75.6981)));
      final vertex_5_4 = mesh_5.vertices.elementAt(4);
      expect(vertex_5_4, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_5 = mesh_5.vertices.elementAt(5);
      expect(vertex_5_5, vector3MoreOrLessEquals(Vector3(-28.3272, -39.1319, 75.6947)));
      final vertex_5_6 = mesh_5.vertices.elementAt(6);
      expect(vertex_5_6, vector3MoreOrLessEquals(Vector3(-36.1079, 8.51989, 15.5624)));
      final vertex_5_7 = mesh_5.vertices.elementAt(7);
      expect(vertex_5_7, vector3MoreOrLessEquals(Vector3(-34.5764, 8.10736, 17.2474)));
      final vertex_5_8 = mesh_5.vertices.elementAt(8);
      expect(vertex_5_8, vector3MoreOrLessEquals(Vector3(-32.2028, -2.60241, -2.72874)));
      final vertex_5_9 = mesh_5.vertices.elementAt(9);
      expect(vertex_5_9, vector3MoreOrLessEquals(Vector3(-34.5024, -1.65542, -5.0322)));
      final vertex_5_10 = mesh_5.vertices.elementAt(10);
      expect(vertex_5_10, vector3MoreOrLessEquals(Vector3(-36.1079, 8.51989, 15.5624)));
      final vertex_5_11 = mesh_5.vertices.elementAt(11);
      expect(vertex_5_11, vector3MoreOrLessEquals(Vector3(-32.2028, -2.60241, -2.72874)));
      final vertex_5_12 = mesh_5.vertices.elementAt(12);
      expect(vertex_5_12, vector3MoreOrLessEquals(Vector3(-36.1079, 8.51989, 15.5624)));
      final vertex_5_13 = mesh_5.vertices.elementAt(13);
      expect(vertex_5_13, vector3MoreOrLessEquals(Vector3(-39.059, 27.0856, 30.0882)));
      final vertex_5_14 = mesh_5.vertices.elementAt(14);
      expect(vertex_5_14, vector3MoreOrLessEquals(Vector3(-34.5764, 8.10736, 17.2474)));
      final vertex_5_15 = mesh_5.vertices.elementAt(15);
      expect(vertex_5_15, vector3MoreOrLessEquals(Vector3(-36.1079, 8.51989, 15.5624)));
      final vertex_5_16 = mesh_5.vertices.elementAt(16);
      expect(vertex_5_16, vector3MoreOrLessEquals(Vector3(-40.4062, 27.9341, 29.6066)));
      final vertex_5_17 = mesh_5.vertices.elementAt(17);
      expect(vertex_5_17, vector3MoreOrLessEquals(Vector3(-39.059, 27.0856, 30.0882)));
      final vertex_5_18 = mesh_5.vertices.elementAt(18);
      expect(vertex_5_18, vector3MoreOrLessEquals(Vector3(-39.8973, 28.3933, 34.7092)));
      final vertex_5_19 = mesh_5.vertices.elementAt(19);
      expect(vertex_5_19, vector3MoreOrLessEquals(Vector3(-38.0373, 27.4945, 33.6665)));
      final vertex_5_20 = mesh_5.vertices.elementAt(20);
      expect(vertex_5_20, vector3MoreOrLessEquals(Vector3(-39.059, 27.0856, 30.0882)));
      final vertex_5_21 = mesh_5.vertices.elementAt(21);
      expect(vertex_5_21, vector3MoreOrLessEquals(Vector3(-40.4062, 27.9341, 29.6066)));
      final vertex_5_22 = mesh_5.vertices.elementAt(22);
      expect(vertex_5_22, vector3MoreOrLessEquals(Vector3(-39.8973, 28.3933, 34.7092)));
      final vertex_5_23 = mesh_5.vertices.elementAt(23);
      expect(vertex_5_23, vector3MoreOrLessEquals(Vector3(-39.059, 27.0856, 30.0882)));
      final vertex_5_24 = mesh_5.vertices.elementAt(24);
      expect(vertex_5_24, vector3MoreOrLessEquals(Vector3(-39.8973, 28.3933, 34.7092)));
      final vertex_5_25 = mesh_5.vertices.elementAt(25);
      expect(vertex_5_25, vector3MoreOrLessEquals(Vector3(-34.5404, 17.3149, 46.759)));
      final vertex_5_26 = mesh_5.vertices.elementAt(26);
      expect(vertex_5_26, vector3MoreOrLessEquals(Vector3(-38.0373, 27.4945, 33.6665)));
      final vertex_5_27 = mesh_5.vertices.elementAt(27);
      expect(vertex_5_27, vector3MoreOrLessEquals(Vector3(-39.8973, 28.3933, 34.7092)));
      final vertex_5_28 = mesh_5.vertices.elementAt(28);
      expect(vertex_5_28, vector3MoreOrLessEquals(Vector3(-35.8452, 17.4361, 48.6662)));
      final vertex_5_29 = mesh_5.vertices.elementAt(29);
      expect(vertex_5_29, vector3MoreOrLessEquals(Vector3(-34.5404, 17.3149, 46.759)));
      final vertex_5_30 = mesh_5.vertices.elementAt(30);
      expect(vertex_5_30, vector3MoreOrLessEquals(Vector3(-28.9666, -31.8704, 66.6116)));
      final vertex_5_31 = mesh_5.vertices.elementAt(31);
      expect(vertex_5_31, vector3MoreOrLessEquals(Vector3(-28.0087, -33.484, 66.3923)));
      final vertex_5_32 = mesh_5.vertices.elementAt(32);
      expect(vertex_5_32, vector3MoreOrLessEquals(Vector3(-34.5404, 17.3149, 46.759)));
      final vertex_5_33 = mesh_5.vertices.elementAt(33);
      expect(vertex_5_33, vector3MoreOrLessEquals(Vector3(-35.8452, 17.4361, 48.6662)));
      final vertex_5_34 = mesh_5.vertices.elementAt(34);
      expect(vertex_5_34, vector3MoreOrLessEquals(Vector3(-28.9666, -31.8704, 66.6116)));
      final vertex_5_35 = mesh_5.vertices.elementAt(35);
      expect(vertex_5_35, vector3MoreOrLessEquals(Vector3(-34.5404, 17.3149, 46.759)));
      final vertex_5_36 = mesh_5.vertices.elementAt(36);
      expect(vertex_5_36, vector3MoreOrLessEquals(Vector3(-28.9666, -31.8704, 66.6116)));
      final vertex_5_37 = mesh_5.vertices.elementAt(37);
      expect(vertex_5_37, vector3MoreOrLessEquals(Vector3(-28.3272, -39.1319, 75.6947)));
      final vertex_5_38 = mesh_5.vertices.elementAt(38);
      expect(vertex_5_38, vector3MoreOrLessEquals(Vector3(-28.0087, -33.484, 66.3923)));
      final vertex_5_39 = mesh_5.vertices.elementAt(39);
      expect(vertex_5_39, vector3MoreOrLessEquals(Vector3(-28.9666, -31.8704, 66.6116)));
      final vertex_5_40 = mesh_5.vertices.elementAt(40);
      expect(vertex_5_40, vector3MoreOrLessEquals(Vector3(-28.6964, -38.6124, 75.6981)));
      final vertex_5_41 = mesh_5.vertices.elementAt(41);
      expect(vertex_5_41, vector3MoreOrLessEquals(Vector3(-28.3272, -39.1319, 75.6947)));
      final vertex_5_42 = mesh_5.vertices.elementAt(42);
      expect(vertex_5_42, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_43 = mesh_5.vertices.elementAt(43);
      expect(vertex_5_43, vector3MoreOrLessEquals(Vector3(-37.9441, -1.8839, -4.87553)));
      final vertex_5_44 = mesh_5.vertices.elementAt(44);
      expect(vertex_5_44, vector3MoreOrLessEquals(Vector3(-34.5024, -1.65542, -5.0322)));
      final vertex_5_45 = mesh_5.vertices.elementAt(45);
      expect(vertex_5_45, vector3MoreOrLessEquals(Vector3(-29.1907, -38.5984, 75.6444)));
      final vertex_5_46 = mesh_5.vertices.elementAt(46);
      expect(vertex_5_46, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_47 = mesh_5.vertices.elementAt(47);
      expect(vertex_5_47, vector3MoreOrLessEquals(Vector3(-28.6964, -38.6124, 75.6981)));
      final vertex_5_48 = mesh_5.vertices.elementAt(48);
      expect(vertex_5_48, vector3MoreOrLessEquals(Vector3(-37.9441, -1.8839, -4.87553)));
      final vertex_5_49 = mesh_5.vertices.elementAt(49);
      expect(vertex_5_49, vector3MoreOrLessEquals(Vector3(-36.1079, 8.51989, 15.5624)));
      final vertex_5_50 = mesh_5.vertices.elementAt(50);
      expect(vertex_5_50, vector3MoreOrLessEquals(Vector3(-34.5024, -1.65542, -5.0322)));
      final vertex_5_51 = mesh_5.vertices.elementAt(51);
      expect(vertex_5_51, vector3MoreOrLessEquals(Vector3(-37.9441, -1.8839, -4.87553)));
      final vertex_5_52 = mesh_5.vertices.elementAt(52);
      expect(vertex_5_52, vector3MoreOrLessEquals(Vector3(-38.1253, 7.46189, 15.1556)));
      final vertex_5_53 = mesh_5.vertices.elementAt(53);
      expect(vertex_5_53, vector3MoreOrLessEquals(Vector3(-36.1079, 8.51989, 15.5624)));
      final vertex_5_54 = mesh_5.vertices.elementAt(54);
      expect(vertex_5_54, vector3MoreOrLessEquals(Vector3(-41.7305, 27.442, 29.4933)));
      final vertex_5_55 = mesh_5.vertices.elementAt(55);
      expect(vertex_5_55, vector3MoreOrLessEquals(Vector3(-40.4062, 27.9341, 29.6066)));
      final vertex_5_56 = mesh_5.vertices.elementAt(56);
      expect(vertex_5_56, vector3MoreOrLessEquals(Vector3(-36.1079, 8.51989, 15.5624)));
      final vertex_5_57 = mesh_5.vertices.elementAt(57);
      expect(vertex_5_57, vector3MoreOrLessEquals(Vector3(-38.1253, 7.46189, 15.1556)));
      final vertex_5_58 = mesh_5.vertices.elementAt(58);
      expect(vertex_5_58, vector3MoreOrLessEquals(Vector3(-41.7305, 27.442, 29.4933)));
      final vertex_5_59 = mesh_5.vertices.elementAt(59);
      expect(vertex_5_59, vector3MoreOrLessEquals(Vector3(-36.1079, 8.51989, 15.5624)));
      final vertex_5_60 = mesh_5.vertices.elementAt(60);
      expect(vertex_5_60, vector3MoreOrLessEquals(Vector3(-41.7305, 27.442, 29.4933)));
      final vertex_5_61 = mesh_5.vertices.elementAt(61);
      expect(vertex_5_61, vector3MoreOrLessEquals(Vector3(-39.8973, 28.3933, 34.7092)));
      final vertex_5_62 = mesh_5.vertices.elementAt(62);
      expect(vertex_5_62, vector3MoreOrLessEquals(Vector3(-40.4062, 27.9341, 29.6066)));
      final vertex_5_63 = mesh_5.vertices.elementAt(63);
      expect(vertex_5_63, vector3MoreOrLessEquals(Vector3(-41.7305, 27.442, 29.4933)));
      final vertex_5_64 = mesh_5.vertices.elementAt(64);
      expect(vertex_5_64, vector3MoreOrLessEquals(Vector3(-41.9958, 27.4554, 34.9761)));
      final vertex_5_65 = mesh_5.vertices.elementAt(65);
      expect(vertex_5_65, vector3MoreOrLessEquals(Vector3(-39.8973, 28.3933, 34.7092)));
      final vertex_5_66 = mesh_5.vertices.elementAt(66);
      expect(vertex_5_66, vector3MoreOrLessEquals(Vector3(-37.8067, 16.3061, 49.1466)));
      final vertex_5_67 = mesh_5.vertices.elementAt(67);
      expect(vertex_5_67, vector3MoreOrLessEquals(Vector3(-35.8452, 17.4361, 48.6662)));
      final vertex_5_68 = mesh_5.vertices.elementAt(68);
      expect(vertex_5_68, vector3MoreOrLessEquals(Vector3(-39.8973, 28.3933, 34.7092)));
      final vertex_5_69 = mesh_5.vertices.elementAt(69);
      expect(vertex_5_69, vector3MoreOrLessEquals(Vector3(-41.9958, 27.4554, 34.9761)));
      final vertex_5_70 = mesh_5.vertices.elementAt(70);
      expect(vertex_5_70, vector3MoreOrLessEquals(Vector3(-37.8067, 16.3061, 49.1466)));
      final vertex_5_71 = mesh_5.vertices.elementAt(71);
      expect(vertex_5_71, vector3MoreOrLessEquals(Vector3(-39.8973, 28.3933, 34.7092)));
      final vertex_5_72 = mesh_5.vertices.elementAt(72);
      expect(vertex_5_72, vector3MoreOrLessEquals(Vector3(-37.8067, 16.3061, 49.1466)));
      final vertex_5_73 = mesh_5.vertices.elementAt(73);
      expect(vertex_5_73, vector3MoreOrLessEquals(Vector3(-28.9666, -31.8704, 66.6116)));
      final vertex_5_74 = mesh_5.vertices.elementAt(74);
      expect(vertex_5_74, vector3MoreOrLessEquals(Vector3(-35.8452, 17.4361, 48.6662)));
      final vertex_5_75 = mesh_5.vertices.elementAt(75);
      expect(vertex_5_75, vector3MoreOrLessEquals(Vector3(-37.8067, 16.3061, 49.1466)));
      final vertex_5_76 = mesh_5.vertices.elementAt(76);
      expect(vertex_5_76, vector3MoreOrLessEquals(Vector3(-30.06, -31.7149, 66.5499)));
      final vertex_5_77 = mesh_5.vertices.elementAt(77);
      expect(vertex_5_77, vector3MoreOrLessEquals(Vector3(-28.9666, -31.8704, 66.6116)));
      final vertex_5_78 = mesh_5.vertices.elementAt(78);
      expect(vertex_5_78, vector3MoreOrLessEquals(Vector3(-29.1907, -38.5984, 75.6444)));
      final vertex_5_79 = mesh_5.vertices.elementAt(79);
      expect(vertex_5_79, vector3MoreOrLessEquals(Vector3(-28.6964, -38.6124, 75.6981)));
      final vertex_5_80 = mesh_5.vertices.elementAt(80);
      expect(vertex_5_80, vector3MoreOrLessEquals(Vector3(-28.9666, -31.8704, 66.6116)));
      final vertex_5_81 = mesh_5.vertices.elementAt(81);
      expect(vertex_5_81, vector3MoreOrLessEquals(Vector3(-30.06, -31.7149, 66.5499)));
      final vertex_5_82 = mesh_5.vertices.elementAt(82);
      expect(vertex_5_82, vector3MoreOrLessEquals(Vector3(-29.1907, -38.5984, 75.6444)));
      final vertex_5_83 = mesh_5.vertices.elementAt(83);
      expect(vertex_5_83, vector3MoreOrLessEquals(Vector3(-28.9666, -31.8704, 66.6116)));
      final vertex_5_84 = mesh_5.vertices.elementAt(84);
      expect(vertex_5_84, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_85 = mesh_5.vertices.elementAt(85);
      expect(vertex_5_85, vector3MoreOrLessEquals(Vector3(-39.9361, -3.11581, -2.37666)));
      final vertex_5_86 = mesh_5.vertices.elementAt(86);
      expect(vertex_5_86, vector3MoreOrLessEquals(Vector3(-37.9441, -1.8839, -4.87553)));
      final vertex_5_87 = mesh_5.vertices.elementAt(87);
      expect(vertex_5_87, vector3MoreOrLessEquals(Vector3(-29.4379, -39.1005, 75.5741)));
      final vertex_5_88 = mesh_5.vertices.elementAt(88);
      expect(vertex_5_88, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_89 = mesh_5.vertices.elementAt(89);
      expect(vertex_5_89, vector3MoreOrLessEquals(Vector3(-29.1907, -38.5984, 75.6444)));
      final vertex_5_90 = mesh_5.vertices.elementAt(90);
      expect(vertex_5_90, vector3MoreOrLessEquals(Vector3(-39.1095, 5.73008, 16.3333)));
      final vertex_5_91 = mesh_5.vertices.elementAt(91);
      expect(vertex_5_91, vector3MoreOrLessEquals(Vector3(-38.1253, 7.46189, 15.1556)));
      final vertex_5_92 = mesh_5.vertices.elementAt(92);
      expect(vertex_5_92, vector3MoreOrLessEquals(Vector3(-37.9441, -1.8839, -4.87553)));
      final vertex_5_93 = mesh_5.vertices.elementAt(93);
      expect(vertex_5_93, vector3MoreOrLessEquals(Vector3(-39.9361, -3.11581, -2.37666)));
      final vertex_5_94 = mesh_5.vertices.elementAt(94);
      expect(vertex_5_94, vector3MoreOrLessEquals(Vector3(-39.1095, 5.73008, 16.3333)));
      final vertex_5_95 = mesh_5.vertices.elementAt(95);
      expect(vertex_5_95, vector3MoreOrLessEquals(Vector3(-37.9441, -1.8839, -4.87553)));
      final vertex_5_96 = mesh_5.vertices.elementAt(96);
      expect(vertex_5_96, vector3MoreOrLessEquals(Vector3(-39.1095, 5.73008, 16.3333)));
      final vertex_5_97 = mesh_5.vertices.elementAt(97);
      expect(vertex_5_97, vector3MoreOrLessEquals(Vector3(-41.7305, 27.442, 29.4933)));
      final vertex_5_98 = mesh_5.vertices.elementAt(98);
      expect(vertex_5_98, vector3MoreOrLessEquals(Vector3(-38.1253, 7.46189, 15.1556)));
      final vertex_5_99 = mesh_5.vertices.elementAt(99);
      expect(vertex_5_99, vector3MoreOrLessEquals(Vector3(-39.1095, 5.73008, 16.3333)));
      final vertex_5_100 = mesh_5.vertices.elementAt(100);
      expect(vertex_5_100, vector3MoreOrLessEquals(Vector3(-42.0347, 25.9799, 29.8337)));
      final vertex_5_101 = mesh_5.vertices.elementAt(101);
      expect(vertex_5_101, vector3MoreOrLessEquals(Vector3(-41.7305, 27.442, 29.4933)));
      final vertex_5_102 = mesh_5.vertices.elementAt(102);
      expect(vertex_5_102, vector3MoreOrLessEquals(Vector3(-42.7527, 25.387, 34.2662)));
      final vertex_5_103 = mesh_5.vertices.elementAt(103);
      expect(vertex_5_103, vector3MoreOrLessEquals(Vector3(-41.9958, 27.4554, 34.9761)));
      final vertex_5_104 = mesh_5.vertices.elementAt(104);
      expect(vertex_5_104, vector3MoreOrLessEquals(Vector3(-41.7305, 27.442, 29.4933)));
      final vertex_5_105 = mesh_5.vertices.elementAt(105);
      expect(vertex_5_105, vector3MoreOrLessEquals(Vector3(-42.0347, 25.9799, 29.8337)));
      final vertex_5_106 = mesh_5.vertices.elementAt(106);
      expect(vertex_5_106, vector3MoreOrLessEquals(Vector3(-42.7527, 25.387, 34.2662)));
      final vertex_5_107 = mesh_5.vertices.elementAt(107);
      expect(vertex_5_107, vector3MoreOrLessEquals(Vector3(-41.7305, 27.442, 29.4933)));
      final vertex_5_108 = mesh_5.vertices.elementAt(108);
      expect(vertex_5_108, vector3MoreOrLessEquals(Vector3(-42.7527, 25.387, 34.2662)));
      final vertex_5_109 = mesh_5.vertices.elementAt(109);
      expect(vertex_5_109, vector3MoreOrLessEquals(Vector3(-37.8067, 16.3061, 49.1466)));
      final vertex_5_110 = mesh_5.vertices.elementAt(110);
      expect(vertex_5_110, vector3MoreOrLessEquals(Vector3(-41.9958, 27.4554, 34.9761)));
      final vertex_5_111 = mesh_5.vertices.elementAt(111);
      expect(vertex_5_111, vector3MoreOrLessEquals(Vector3(-42.7527, 25.387, 34.2662)));
      final vertex_5_112 = mesh_5.vertices.elementAt(112);
      expect(vertex_5_112, vector3MoreOrLessEquals(Vector3(-38.9477, 14.7759, 47.8385)));
      final vertex_5_113 = mesh_5.vertices.elementAt(113);
      expect(vertex_5_113, vector3MoreOrLessEquals(Vector3(-37.8067, 16.3061, 49.1466)));
      final vertex_5_114 = mesh_5.vertices.elementAt(114);
      expect(vertex_5_114, vector3MoreOrLessEquals(Vector3(-30.4656, -33.1345, 66.2537)));
      final vertex_5_115 = mesh_5.vertices.elementAt(115);
      expect(vertex_5_115, vector3MoreOrLessEquals(Vector3(-30.06, -31.7149, 66.5499)));
      final vertex_5_116 = mesh_5.vertices.elementAt(116);
      expect(vertex_5_116, vector3MoreOrLessEquals(Vector3(-37.8067, 16.3061, 49.1466)));
      final vertex_5_117 = mesh_5.vertices.elementAt(117);
      expect(vertex_5_117, vector3MoreOrLessEquals(Vector3(-38.9477, 14.7759, 47.8385)));
      final vertex_5_118 = mesh_5.vertices.elementAt(118);
      expect(vertex_5_118, vector3MoreOrLessEquals(Vector3(-30.4656, -33.1345, 66.2537)));
      final vertex_5_119 = mesh_5.vertices.elementAt(119);
      expect(vertex_5_119, vector3MoreOrLessEquals(Vector3(-37.8067, 16.3061, 49.1466)));
      final vertex_5_120 = mesh_5.vertices.elementAt(120);
      expect(vertex_5_120, vector3MoreOrLessEquals(Vector3(-30.4656, -33.1345, 66.2537)));
      final vertex_5_121 = mesh_5.vertices.elementAt(121);
      expect(vertex_5_121, vector3MoreOrLessEquals(Vector3(-29.1907, -38.5984, 75.6444)));
      final vertex_5_122 = mesh_5.vertices.elementAt(122);
      expect(vertex_5_122, vector3MoreOrLessEquals(Vector3(-30.06, -31.7149, 66.5499)));
      final vertex_5_123 = mesh_5.vertices.elementAt(123);
      expect(vertex_5_123, vector3MoreOrLessEquals(Vector3(-30.4656, -33.1345, 66.2537)));
      final vertex_5_124 = mesh_5.vertices.elementAt(124);
      expect(vertex_5_124, vector3MoreOrLessEquals(Vector3(-29.4379, -39.1005, 75.5741)));
      final vertex_5_125 = mesh_5.vertices.elementAt(125);
      expect(vertex_5_125, vector3MoreOrLessEquals(Vector3(-29.1907, -38.5984, 75.6444)));
      final vertex_5_126 = mesh_5.vertices.elementAt(126);
      expect(vertex_5_126, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_127 = mesh_5.vertices.elementAt(127);
      expect(vertex_5_127, vector3MoreOrLessEquals(Vector3(-38.9784, -4.42348, 0.582626)));
      final vertex_5_128 = mesh_5.vertices.elementAt(128);
      expect(vertex_5_128, vector3MoreOrLessEquals(Vector3(-39.9361, -3.11581, -2.37666)));
      final vertex_5_129 = mesh_5.vertices.elementAt(129);
      expect(vertex_5_129, vector3MoreOrLessEquals(Vector3(-29.2519, -39.7405, 75.5401)));
      final vertex_5_130 = mesh_5.vertices.elementAt(130);
      expect(vertex_5_130, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_131 = mesh_5.vertices.elementAt(131);
      expect(vertex_5_131, vector3MoreOrLessEquals(Vector3(-29.4379, -39.1005, 75.5741)));
      final vertex_5_132 = mesh_5.vertices.elementAt(132);
      expect(vertex_5_132, vector3MoreOrLessEquals(Vector3(-38.9784, -4.42348, 0.582626)));
      final vertex_5_133 = mesh_5.vertices.elementAt(133);
      expect(vertex_5_133, vector3MoreOrLessEquals(Vector3(-39.1095, 5.73008, 16.3333)));
      final vertex_5_134 = mesh_5.vertices.elementAt(134);
      expect(vertex_5_134, vector3MoreOrLessEquals(Vector3(-39.9361, -3.11581, -2.37666)));
      final vertex_5_135 = mesh_5.vertices.elementAt(135);
      expect(vertex_5_135, vector3MoreOrLessEquals(Vector3(-38.9784, -4.42348, 0.582626)));
      final vertex_5_136 = mesh_5.vertices.elementAt(136);
      expect(vertex_5_136, vector3MoreOrLessEquals(Vector3(-38.3193, 4.62854, 18.2087)));
      final vertex_5_137 = mesh_5.vertices.elementAt(137);
      expect(vertex_5_137, vector3MoreOrLessEquals(Vector3(-39.1095, 5.73008, 16.3333)));
      final vertex_5_138 = mesh_5.vertices.elementAt(138);
      expect(vertex_5_138, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_139 = mesh_5.vertices.elementAt(139);
      expect(vertex_5_139, vector3MoreOrLessEquals(Vector3(-42.0347, 25.9799, 29.8337)));
      final vertex_5_140 = mesh_5.vertices.elementAt(140);
      expect(vertex_5_140, vector3MoreOrLessEquals(Vector3(-39.1095, 5.73008, 16.3333)));
      final vertex_5_141 = mesh_5.vertices.elementAt(141);
      expect(vertex_5_141, vector3MoreOrLessEquals(Vector3(-38.3193, 4.62854, 18.2087)));
      final vertex_5_142 = mesh_5.vertices.elementAt(142);
      expect(vertex_5_142, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_143 = mesh_5.vertices.elementAt(143);
      expect(vertex_5_143, vector3MoreOrLessEquals(Vector3(-39.1095, 5.73008, 16.3333)));
      final vertex_5_144 = mesh_5.vertices.elementAt(144);
      expect(vertex_5_144, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_145 = mesh_5.vertices.elementAt(145);
      expect(vertex_5_145, vector3MoreOrLessEquals(Vector3(-42.7527, 25.387, 34.2662)));
      final vertex_5_146 = mesh_5.vertices.elementAt(146);
      expect(vertex_5_146, vector3MoreOrLessEquals(Vector3(-42.0347, 25.9799, 29.8337)));
      final vertex_5_147 = mesh_5.vertices.elementAt(147);
      expect(vertex_5_147, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_148 = mesh_5.vertices.elementAt(148);
      expect(vertex_5_148, vector3MoreOrLessEquals(Vector3(-41.5979, 23.7457, 33.114)));
      final vertex_5_149 = mesh_5.vertices.elementAt(149);
      expect(vertex_5_149, vector3MoreOrLessEquals(Vector3(-42.7527, 25.387, 34.2662)));
      final vertex_5_150 = mesh_5.vertices.elementAt(150);
      expect(vertex_5_150, vector3MoreOrLessEquals(Vector3(-38.4091, 13.9977, 45.7268)));
      final vertex_5_151 = mesh_5.vertices.elementAt(151);
      expect(vertex_5_151, vector3MoreOrLessEquals(Vector3(-38.9477, 14.7759, 47.8385)));
      final vertex_5_152 = mesh_5.vertices.elementAt(152);
      expect(vertex_5_152, vector3MoreOrLessEquals(Vector3(-42.7527, 25.387, 34.2662)));
      final vertex_5_153 = mesh_5.vertices.elementAt(153);
      expect(vertex_5_153, vector3MoreOrLessEquals(Vector3(-41.5979, 23.7457, 33.114)));
      final vertex_5_154 = mesh_5.vertices.elementAt(154);
      expect(vertex_5_154, vector3MoreOrLessEquals(Vector3(-38.4091, 13.9977, 45.7268)));
      final vertex_5_155 = mesh_5.vertices.elementAt(155);
      expect(vertex_5_155, vector3MoreOrLessEquals(Vector3(-42.7527, 25.387, 34.2662)));
      final vertex_5_156 = mesh_5.vertices.elementAt(156);
      expect(vertex_5_156, vector3MoreOrLessEquals(Vector3(-38.4091, 13.9977, 45.7268)));
      final vertex_5_157 = mesh_5.vertices.elementAt(157);
      expect(vertex_5_157, vector3MoreOrLessEquals(Vector3(-30.4656, -33.1345, 66.2537)));
      final vertex_5_158 = mesh_5.vertices.elementAt(158);
      expect(vertex_5_158, vector3MoreOrLessEquals(Vector3(-38.9477, 14.7759, 47.8385)));
      final vertex_5_159 = mesh_5.vertices.elementAt(159);
      expect(vertex_5_159, vector3MoreOrLessEquals(Vector3(-38.4091, 13.9977, 45.7268)));
      final vertex_5_160 = mesh_5.vertices.elementAt(160);
      expect(vertex_5_160, vector3MoreOrLessEquals(Vector3(-29.878, -35.0603, 65.9459)));
      final vertex_5_161 = mesh_5.vertices.elementAt(161);
      expect(vertex_5_161, vector3MoreOrLessEquals(Vector3(-30.4656, -33.1345, 66.2537)));
      final vertex_5_162 = mesh_5.vertices.elementAt(162);
      expect(vertex_5_162, vector3MoreOrLessEquals(Vector3(-29.2519, -39.7405, 75.5401)));
      final vertex_5_163 = mesh_5.vertices.elementAt(163);
      expect(vertex_5_163, vector3MoreOrLessEquals(Vector3(-29.4379, -39.1005, 75.5741)));
      final vertex_5_164 = mesh_5.vertices.elementAt(164);
      expect(vertex_5_164, vector3MoreOrLessEquals(Vector3(-30.4656, -33.1345, 66.2537)));
      final vertex_5_165 = mesh_5.vertices.elementAt(165);
      expect(vertex_5_165, vector3MoreOrLessEquals(Vector3(-29.878, -35.0603, 65.9459)));
      final vertex_5_166 = mesh_5.vertices.elementAt(166);
      expect(vertex_5_166, vector3MoreOrLessEquals(Vector3(-29.2519, -39.7405, 75.5401)));
      final vertex_5_167 = mesh_5.vertices.elementAt(167);
      expect(vertex_5_167, vector3MoreOrLessEquals(Vector3(-30.4656, -33.1345, 66.2537)));
      final vertex_5_168 = mesh_5.vertices.elementAt(168);
      expect(vertex_5_168, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_169 = mesh_5.vertices.elementAt(169);
      expect(vertex_5_169, vector3MoreOrLessEquals(Vector3(-35.7923, -4.82223, 1.77398)));
      final vertex_5_170 = mesh_5.vertices.elementAt(170);
      expect(vertex_5_170, vector3MoreOrLessEquals(Vector3(-38.9784, -4.42348, 0.582626)));
      final vertex_5_171 = mesh_5.vertices.elementAt(171);
      expect(vertex_5_171, vector3MoreOrLessEquals(Vector3(-28.7727, -40.0365, 75.5681)));
      final vertex_5_172 = mesh_5.vertices.elementAt(172);
      expect(vertex_5_172, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_173 = mesh_5.vertices.elementAt(173);
      expect(vertex_5_173, vector3MoreOrLessEquals(Vector3(-29.2519, -39.7405, 75.5401)));
      final vertex_5_174 = mesh_5.vertices.elementAt(174);
      expect(vertex_5_174, vector3MoreOrLessEquals(Vector3(-36.3498, 4.98674, 19.3696)));
      final vertex_5_175 = mesh_5.vertices.elementAt(175);
      expect(vertex_5_175, vector3MoreOrLessEquals(Vector3(-38.3193, 4.62854, 18.2087)));
      final vertex_5_176 = mesh_5.vertices.elementAt(176);
      expect(vertex_5_176, vector3MoreOrLessEquals(Vector3(-38.9784, -4.42348, 0.582626)));
      final vertex_5_177 = mesh_5.vertices.elementAt(177);
      expect(vertex_5_177, vector3MoreOrLessEquals(Vector3(-35.7923, -4.82223, 1.77398)));
      final vertex_5_178 = mesh_5.vertices.elementAt(178);
      expect(vertex_5_178, vector3MoreOrLessEquals(Vector3(-36.3498, 4.98674, 19.3696)));
      final vertex_5_179 = mesh_5.vertices.elementAt(179);
      expect(vertex_5_179, vector3MoreOrLessEquals(Vector3(-38.9784, -4.42348, 0.582626)));
      final vertex_5_180 = mesh_5.vertices.elementAt(180);
      expect(vertex_5_180, vector3MoreOrLessEquals(Vector3(-36.3498, 4.98674, 19.3696)));
      final vertex_5_181 = mesh_5.vertices.elementAt(181);
      expect(vertex_5_181, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_182 = mesh_5.vertices.elementAt(182);
      expect(vertex_5_182, vector3MoreOrLessEquals(Vector3(-38.3193, 4.62854, 18.2087)));
      final vertex_5_183 = mesh_5.vertices.elementAt(183);
      expect(vertex_5_183, vector3MoreOrLessEquals(Vector3(-36.3498, 4.98674, 19.3696)));
      final vertex_5_184 = mesh_5.vertices.elementAt(184);
      expect(vertex_5_184, vector3MoreOrLessEquals(Vector3(-39.6072, 24.451, 30.7014)));
      final vertex_5_185 = mesh_5.vertices.elementAt(185);
      expect(vertex_5_185, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_186 = mesh_5.vertices.elementAt(186);
      expect(vertex_5_186, vector3MoreOrLessEquals(Vector3(-39.401, 23.7674, 32.3872)));
      final vertex_5_187 = mesh_5.vertices.elementAt(187);
      expect(vertex_5_187, vector3MoreOrLessEquals(Vector3(-41.5979, 23.7457, 33.114)));
      final vertex_5_188 = mesh_5.vertices.elementAt(188);
      expect(vertex_5_188, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_189 = mesh_5.vertices.elementAt(189);
      expect(vertex_5_189, vector3MoreOrLessEquals(Vector3(-39.6072, 24.451, 30.7014)));
      final vertex_5_190 = mesh_5.vertices.elementAt(190);
      expect(vertex_5_190, vector3MoreOrLessEquals(Vector3(-39.401, 23.7674, 32.3872)));
      final vertex_5_191 = mesh_5.vertices.elementAt(191);
      expect(vertex_5_191, vector3MoreOrLessEquals(Vector3(-41.0898, 24.6488, 30.3713)));
      final vertex_5_192 = mesh_5.vertices.elementAt(192);
      expect(vertex_5_192, vector3MoreOrLessEquals(Vector3(-39.401, 23.7674, 32.3872)));
      final vertex_5_193 = mesh_5.vertices.elementAt(193);
      expect(vertex_5_193, vector3MoreOrLessEquals(Vector3(-38.4091, 13.9977, 45.7268)));
      final vertex_5_194 = mesh_5.vertices.elementAt(194);
      expect(vertex_5_194, vector3MoreOrLessEquals(Vector3(-41.5979, 23.7457, 33.114)));
      final vertex_5_195 = mesh_5.vertices.elementAt(195);
      expect(vertex_5_195, vector3MoreOrLessEquals(Vector3(-39.401, 23.7674, 32.3872)));
      final vertex_5_196 = mesh_5.vertices.elementAt(196);
      expect(vertex_5_196, vector3MoreOrLessEquals(Vector3(-36.5964, 14.5575, 44.4017)));
      final vertex_5_197 = mesh_5.vertices.elementAt(197);
      expect(vertex_5_197, vector3MoreOrLessEquals(Vector3(-38.4091, 13.9977, 45.7268)));
      final vertex_5_198 = mesh_5.vertices.elementAt(198);
      expect(vertex_5_198, vector3MoreOrLessEquals(Vector3(-28.7396, -36.0421, 65.8585)));
      final vertex_5_199 = mesh_5.vertices.elementAt(199);
      expect(vertex_5_199, vector3MoreOrLessEquals(Vector3(-29.878, -35.0603, 65.9459)));
      final vertex_5_200 = mesh_5.vertices.elementAt(200);
      expect(vertex_5_200, vector3MoreOrLessEquals(Vector3(-38.4091, 13.9977, 45.7268)));
      final vertex_5_201 = mesh_5.vertices.elementAt(201);
      expect(vertex_5_201, vector3MoreOrLessEquals(Vector3(-36.5964, 14.5575, 44.4017)));
      final vertex_5_202 = mesh_5.vertices.elementAt(202);
      expect(vertex_5_202, vector3MoreOrLessEquals(Vector3(-28.7396, -36.0421, 65.8585)));
      final vertex_5_203 = mesh_5.vertices.elementAt(203);
      expect(vertex_5_203, vector3MoreOrLessEquals(Vector3(-38.4091, 13.9977, 45.7268)));
      final vertex_5_204 = mesh_5.vertices.elementAt(204);
      expect(vertex_5_204, vector3MoreOrLessEquals(Vector3(-28.7396, -36.0421, 65.8585)));
      final vertex_5_205 = mesh_5.vertices.elementAt(205);
      expect(vertex_5_205, vector3MoreOrLessEquals(Vector3(-29.2519, -39.7405, 75.5401)));
      final vertex_5_206 = mesh_5.vertices.elementAt(206);
      expect(vertex_5_206, vector3MoreOrLessEquals(Vector3(-29.878, -35.0603, 65.9459)));
      final vertex_5_207 = mesh_5.vertices.elementAt(207);
      expect(vertex_5_207, vector3MoreOrLessEquals(Vector3(-28.7396, -36.0421, 65.8585)));
      final vertex_5_208 = mesh_5.vertices.elementAt(208);
      expect(vertex_5_208, vector3MoreOrLessEquals(Vector3(-28.7727, -40.0365, 75.5681)));
      final vertex_5_209 = mesh_5.vertices.elementAt(209);
      expect(vertex_5_209, vector3MoreOrLessEquals(Vector3(-29.2519, -39.7405, 75.5401)));
      final vertex_5_210 = mesh_5.vertices.elementAt(210);
      expect(vertex_5_210, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_211 = mesh_5.vertices.elementAt(211);
      expect(vertex_5_211, vector3MoreOrLessEquals(Vector3(-32.7769, -4.01178, 0.300282)));
      final vertex_5_212 = mesh_5.vertices.elementAt(212);
      expect(vertex_5_212, vector3MoreOrLessEquals(Vector3(-35.7923, -4.82223, 1.77398)));
      final vertex_5_213 = mesh_5.vertices.elementAt(213);
      expect(vertex_5_213, vector3MoreOrLessEquals(Vector3(-28.3611, -39.7656, 75.6369)));
      final vertex_5_214 = mesh_5.vertices.elementAt(214);
      expect(vertex_5_214, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_215 = mesh_5.vertices.elementAt(215);
      expect(vertex_5_215, vector3MoreOrLessEquals(Vector3(-28.7727, -40.0365, 75.5681)));
      final vertex_5_216 = mesh_5.vertices.elementAt(216);
      expect(vertex_5_216, vector3MoreOrLessEquals(Vector3(-32.7769, -4.01178, 0.300282)));
      final vertex_5_217 = mesh_5.vertices.elementAt(217);
      expect(vertex_5_217, vector3MoreOrLessEquals(Vector3(-36.3498, 4.98674, 19.3696)));
      final vertex_5_218 = mesh_5.vertices.elementAt(218);
      expect(vertex_5_218, vector3MoreOrLessEquals(Vector3(-35.7923, -4.82223, 1.77398)));
      final vertex_5_219 = mesh_5.vertices.elementAt(219);
      expect(vertex_5_219, vector3MoreOrLessEquals(Vector3(-32.7769, -4.01178, 0.300282)));
      final vertex_5_220 = mesh_5.vertices.elementAt(220);
      expect(vertex_5_220, vector3MoreOrLessEquals(Vector3(-34.6841, 6.53497, 18.9417)));
      final vertex_5_221 = mesh_5.vertices.elementAt(221);
      expect(vertex_5_221, vector3MoreOrLessEquals(Vector3(-36.3498, 4.98674, 19.3696)));
      final vertex_5_222 = mesh_5.vertices.elementAt(222);
      expect(vertex_5_222, vector3MoreOrLessEquals(Vector3(-38.7034, 25.5355, 30.5754)));
      final vertex_5_223 = mesh_5.vertices.elementAt(223);
      expect(vertex_5_223, vector3MoreOrLessEquals(Vector3(-39.6072, 24.451, 30.7014)));
      final vertex_5_224 = mesh_5.vertices.elementAt(224);
      expect(vertex_5_224, vector3MoreOrLessEquals(Vector3(-36.3498, 4.98674, 19.3696)));
      final vertex_5_225 = mesh_5.vertices.elementAt(225);
      expect(vertex_5_225, vector3MoreOrLessEquals(Vector3(-34.6841, 6.53497, 18.9417)));
      final vertex_5_226 = mesh_5.vertices.elementAt(226);
      expect(vertex_5_226, vector3MoreOrLessEquals(Vector3(-38.7034, 25.5355, 30.5754)));
      final vertex_5_227 = mesh_5.vertices.elementAt(227);
      expect(vertex_5_227, vector3MoreOrLessEquals(Vector3(-36.3498, 4.98674, 19.3696)));
      final vertex_5_228 = mesh_5.vertices.elementAt(228);
      expect(vertex_5_228, vector3MoreOrLessEquals(Vector3(-38.7034, 25.5355, 30.5754)));
      final vertex_5_229 = mesh_5.vertices.elementAt(229);
      expect(vertex_5_229, vector3MoreOrLessEquals(Vector3(-39.401, 23.7674, 32.3872)));
      final vertex_5_230 = mesh_5.vertices.elementAt(230);
      expect(vertex_5_230, vector3MoreOrLessEquals(Vector3(-39.6072, 24.451, 30.7014)));
      final vertex_5_231 = mesh_5.vertices.elementAt(231);
      expect(vertex_5_231, vector3MoreOrLessEquals(Vector3(-38.7034, 25.5355, 30.5754)));
      final vertex_5_232 = mesh_5.vertices.elementAt(232);
      expect(vertex_5_232, vector3MoreOrLessEquals(Vector3(-37.8164, 25.4358, 32.6331)));
      final vertex_5_233 = mesh_5.vertices.elementAt(233);
      expect(vertex_5_233, vector3MoreOrLessEquals(Vector3(-39.401, 23.7674, 32.3872)));
      final vertex_5_234 = mesh_5.vertices.elementAt(234);
      expect(vertex_5_234, vector3MoreOrLessEquals(Vector3(-34.8747, 16.0338, 44.8611)));
      final vertex_5_235 = mesh_5.vertices.elementAt(235);
      expect(vertex_5_235, vector3MoreOrLessEquals(Vector3(-36.5964, 14.5575, 44.4017)));
      final vertex_5_236 = mesh_5.vertices.elementAt(236);
      expect(vertex_5_236, vector3MoreOrLessEquals(Vector3(-39.401, 23.7674, 32.3872)));
      final vertex_5_237 = mesh_5.vertices.elementAt(237);
      expect(vertex_5_237, vector3MoreOrLessEquals(Vector3(-37.8164, 25.4358, 32.6331)));
      final vertex_5_238 = mesh_5.vertices.elementAt(238);
      expect(vertex_5_238, vector3MoreOrLessEquals(Vector3(-34.8747, 16.0338, 44.8611)));
      final vertex_5_239 = mesh_5.vertices.elementAt(239);
      expect(vertex_5_239, vector3MoreOrLessEquals(Vector3(-39.401, 23.7674, 32.3872)));
      final vertex_5_240 = mesh_5.vertices.elementAt(240);
      expect(vertex_5_240, vector3MoreOrLessEquals(Vector3(-34.8747, 16.0338, 44.8611)));
      final vertex_5_241 = mesh_5.vertices.elementAt(241);
      expect(vertex_5_241, vector3MoreOrLessEquals(Vector3(-28.7396, -36.0421, 65.8585)));
      final vertex_5_242 = mesh_5.vertices.elementAt(242);
      expect(vertex_5_242, vector3MoreOrLessEquals(Vector3(-36.5964, 14.5575, 44.4017)));
      final vertex_5_243 = mesh_5.vertices.elementAt(243);
      expect(vertex_5_243, vector3MoreOrLessEquals(Vector3(-34.8747, 16.0338, 44.8611)));
      final vertex_5_244 = mesh_5.vertices.elementAt(244);
      expect(vertex_5_244, vector3MoreOrLessEquals(Vector3(-27.9077, -35.3406, 66.0571)));
      final vertex_5_245 = mesh_5.vertices.elementAt(245);
      expect(vertex_5_245, vector3MoreOrLessEquals(Vector3(-28.7396, -36.0421, 65.8585)));
      final vertex_5_246 = mesh_5.vertices.elementAt(246);
      expect(vertex_5_246, vector3MoreOrLessEquals(Vector3(-28.3611, -39.7656, 75.6369)));
      final vertex_5_247 = mesh_5.vertices.elementAt(247);
      expect(vertex_5_247, vector3MoreOrLessEquals(Vector3(-28.7727, -40.0365, 75.5681)));
      final vertex_5_248 = mesh_5.vertices.elementAt(248);
      expect(vertex_5_248, vector3MoreOrLessEquals(Vector3(-28.7396, -36.0421, 65.8585)));
      final vertex_5_249 = mesh_5.vertices.elementAt(249);
      expect(vertex_5_249, vector3MoreOrLessEquals(Vector3(-27.9077, -35.3406, 66.0571)));
      final vertex_5_250 = mesh_5.vertices.elementAt(250);
      expect(vertex_5_250, vector3MoreOrLessEquals(Vector3(-28.3611, -39.7656, 75.6369)));
      final vertex_5_251 = mesh_5.vertices.elementAt(251);
      expect(vertex_5_251, vector3MoreOrLessEquals(Vector3(-28.7396, -36.0421, 65.8585)));
      final vertex_5_252 = mesh_5.vertices.elementAt(252);
      expect(vertex_5_252, vector3MoreOrLessEquals(Vector3(-36.019, -3.21642, -1.76516)));
      final vertex_5_253 = mesh_5.vertices.elementAt(253);
      expect(vertex_5_253, vector3MoreOrLessEquals(Vector3(-32.2028, -2.60241, -2.72874)));
      final vertex_5_254 = mesh_5.vertices.elementAt(254);
      expect(vertex_5_254, vector3MoreOrLessEquals(Vector3(-32.7769, -4.01178, 0.300282)));
      final vertex_5_255 = mesh_5.vertices.elementAt(255);
      expect(vertex_5_255, vector3MoreOrLessEquals(Vector3(-28.3272, -39.1319, 75.6947)));
      final vertex_5_256 = mesh_5.vertices.elementAt(256);
      expect(vertex_5_256, vector3MoreOrLessEquals(Vector3(-28.8625, -39.2837, 75.6223)));
      final vertex_5_257 = mesh_5.vertices.elementAt(257);
      expect(vertex_5_257, vector3MoreOrLessEquals(Vector3(-28.3611, -39.7656, 75.6369)));
      final vertex_5_258 = mesh_5.vertices.elementAt(258);
      expect(vertex_5_258, vector3MoreOrLessEquals(Vector3(-34.5764, 8.10736, 17.2474)));
      final vertex_5_259 = mesh_5.vertices.elementAt(259);
      expect(vertex_5_259, vector3MoreOrLessEquals(Vector3(-34.6841, 6.53497, 18.9417)));
      final vertex_5_260 = mesh_5.vertices.elementAt(260);
      expect(vertex_5_260, vector3MoreOrLessEquals(Vector3(-32.7769, -4.01178, 0.300282)));
      final vertex_5_261 = mesh_5.vertices.elementAt(261);
      expect(vertex_5_261, vector3MoreOrLessEquals(Vector3(-32.2028, -2.60241, -2.72874)));
      final vertex_5_262 = mesh_5.vertices.elementAt(262);
      expect(vertex_5_262, vector3MoreOrLessEquals(Vector3(-34.5764, 8.10736, 17.2474)));
      final vertex_5_263 = mesh_5.vertices.elementAt(263);
      expect(vertex_5_263, vector3MoreOrLessEquals(Vector3(-32.7769, -4.01178, 0.300282)));
      final vertex_5_264 = mesh_5.vertices.elementAt(264);
      expect(vertex_5_264, vector3MoreOrLessEquals(Vector3(-34.5764, 8.10736, 17.2474)));
      final vertex_5_265 = mesh_5.vertices.elementAt(265);
      expect(vertex_5_265, vector3MoreOrLessEquals(Vector3(-38.7034, 25.5355, 30.5754)));
      final vertex_5_266 = mesh_5.vertices.elementAt(266);
      expect(vertex_5_266, vector3MoreOrLessEquals(Vector3(-34.6841, 6.53497, 18.9417)));
      final vertex_5_267 = mesh_5.vertices.elementAt(267);
      expect(vertex_5_267, vector3MoreOrLessEquals(Vector3(-34.5764, 8.10736, 17.2474)));
      final vertex_5_268 = mesh_5.vertices.elementAt(268);
      expect(vertex_5_268, vector3MoreOrLessEquals(Vector3(-39.059, 27.0856, 30.0882)));
      final vertex_5_269 = mesh_5.vertices.elementAt(269);
      expect(vertex_5_269, vector3MoreOrLessEquals(Vector3(-38.7034, 25.5355, 30.5754)));
      final vertex_5_270 = mesh_5.vertices.elementAt(270);
      expect(vertex_5_270, vector3MoreOrLessEquals(Vector3(-38.0373, 27.4945, 33.6665)));
      final vertex_5_271 = mesh_5.vertices.elementAt(271);
      expect(vertex_5_271, vector3MoreOrLessEquals(Vector3(-37.8164, 25.4358, 32.6331)));
      final vertex_5_272 = mesh_5.vertices.elementAt(272);
      expect(vertex_5_272, vector3MoreOrLessEquals(Vector3(-38.7034, 25.5355, 30.5754)));
      final vertex_5_273 = mesh_5.vertices.elementAt(273);
      expect(vertex_5_273, vector3MoreOrLessEquals(Vector3(-39.059, 27.0856, 30.0882)));
      final vertex_5_274 = mesh_5.vertices.elementAt(274);
      expect(vertex_5_274, vector3MoreOrLessEquals(Vector3(-38.0373, 27.4945, 33.6665)));
      final vertex_5_275 = mesh_5.vertices.elementAt(275);
      expect(vertex_5_275, vector3MoreOrLessEquals(Vector3(-38.7034, 25.5355, 30.5754)));
      final vertex_5_276 = mesh_5.vertices.elementAt(276);
      expect(vertex_5_276, vector3MoreOrLessEquals(Vector3(-38.0373, 27.4945, 33.6665)));
      final vertex_5_277 = mesh_5.vertices.elementAt(277);
      expect(vertex_5_277, vector3MoreOrLessEquals(Vector3(-34.8747, 16.0338, 44.8611)));
      final vertex_5_278 = mesh_5.vertices.elementAt(278);
      expect(vertex_5_278, vector3MoreOrLessEquals(Vector3(-37.8164, 25.4358, 32.6331)));
      final vertex_5_279 = mesh_5.vertices.elementAt(279);
      expect(vertex_5_279, vector3MoreOrLessEquals(Vector3(-38.0373, 27.4945, 33.6665)));
      final vertex_5_280 = mesh_5.vertices.elementAt(280);
      expect(vertex_5_280, vector3MoreOrLessEquals(Vector3(-34.5404, 17.3149, 46.759)));
      final vertex_5_281 = mesh_5.vertices.elementAt(281);
      expect(vertex_5_281, vector3MoreOrLessEquals(Vector3(-34.8747, 16.0338, 44.8611)));
      final vertex_5_282 = mesh_5.vertices.elementAt(282);
      expect(vertex_5_282, vector3MoreOrLessEquals(Vector3(-28.0087, -33.484, 66.3923)));
      final vertex_5_283 = mesh_5.vertices.elementAt(283);
      expect(vertex_5_283, vector3MoreOrLessEquals(Vector3(-27.9077, -35.3406, 66.0571)));
      final vertex_5_284 = mesh_5.vertices.elementAt(284);
      expect(vertex_5_284, vector3MoreOrLessEquals(Vector3(-34.8747, 16.0338, 44.8611)));
      final vertex_5_285 = mesh_5.vertices.elementAt(285);
      expect(vertex_5_285, vector3MoreOrLessEquals(Vector3(-34.5404, 17.3149, 46.759)));
      final vertex_5_286 = mesh_5.vertices.elementAt(286);
      expect(vertex_5_286, vector3MoreOrLessEquals(Vector3(-28.0087, -33.484, 66.3923)));
      final vertex_5_287 = mesh_5.vertices.elementAt(287);
      expect(vertex_5_287, vector3MoreOrLessEquals(Vector3(-34.8747, 16.0338, 44.8611)));
      final vertex_5_288 = mesh_5.vertices.elementAt(288);
      expect(vertex_5_288, vector3MoreOrLessEquals(Vector3(-28.0087, -33.484, 66.3923)));
      final vertex_5_289 = mesh_5.vertices.elementAt(289);
      expect(vertex_5_289, vector3MoreOrLessEquals(Vector3(-28.3611, -39.7656, 75.6369)));
      final vertex_5_290 = mesh_5.vertices.elementAt(290);
      expect(vertex_5_290, vector3MoreOrLessEquals(Vector3(-27.9077, -35.3406, 66.0571)));
      final vertex_5_291 = mesh_5.vertices.elementAt(291);
      expect(vertex_5_291, vector3MoreOrLessEquals(Vector3(-28.0087, -33.484, 66.3923)));
      final vertex_5_292 = mesh_5.vertices.elementAt(292);
      expect(vertex_5_292, vector3MoreOrLessEquals(Vector3(-28.3272, -39.1319, 75.6947)));
      final vertex_5_293 = mesh_5.vertices.elementAt(293);
      expect(vertex_5_293, vector3MoreOrLessEquals(Vector3(-28.3611, -39.7656, 75.6369)));
      expect(mesh_5.normals.length, equals(294));
      final normal_5_0 = mesh_5.normals.elementAt(0);
      expect(normal_5_0, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_1 = mesh_5.normals.elementAt(1);
      expect(normal_5_1, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_2 = mesh_5.normals.elementAt(2);
      expect(normal_5_2, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_3 = mesh_5.normals.elementAt(3);
      expect(normal_5_3, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_4 = mesh_5.normals.elementAt(4);
      expect(normal_5_4, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_5 = mesh_5.normals.elementAt(5);
      expect(normal_5_5, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_6 = mesh_5.normals.elementAt(6);
      expect(normal_5_6, vector3MoreOrLessEquals(Vector3(0.245131, 0.76326, -0.597783)));
      final normal_5_7 = mesh_5.normals.elementAt(7);
      expect(normal_5_7, vector3MoreOrLessEquals(Vector3(0.955445, 0.284327, -0.079261)));
      final normal_5_8 = mesh_5.normals.elementAt(8);
      expect(normal_5_8, vector3MoreOrLessEquals(Vector3(0.823805, 0.535171, -0.186913)));
      final normal_5_9 = mesh_5.normals.elementAt(9);
      expect(normal_5_9, vector3MoreOrLessEquals(Vector3(0.285353, 0.867913, -0.406571)));
      final normal_5_10 = mesh_5.normals.elementAt(10);
      expect(normal_5_10, vector3MoreOrLessEquals(Vector3(0.245131, 0.76326, -0.597783)));
      final normal_5_11 = mesh_5.normals.elementAt(11);
      expect(normal_5_11, vector3MoreOrLessEquals(Vector3(0.823805, 0.535171, -0.186913)));
      final normal_5_12 = mesh_5.normals.elementAt(12);
      expect(normal_5_12, vector3MoreOrLessEquals(Vector3(0.245131, 0.76326, -0.597783)));
      final normal_5_13 = mesh_5.normals.elementAt(13);
      expect(normal_5_13, vector3MoreOrLessEquals(Vector3(0.75015, 0.580981, -0.315809)));
      final normal_5_14 = mesh_5.normals.elementAt(14);
      expect(normal_5_14, vector3MoreOrLessEquals(Vector3(0.955445, 0.284327, -0.079261)));
      final normal_5_15 = mesh_5.normals.elementAt(15);
      expect(normal_5_15, vector3MoreOrLessEquals(Vector3(0.245131, 0.76326, -0.597783)));
      final normal_5_16 = mesh_5.normals.elementAt(16);
      expect(normal_5_16, vector3MoreOrLessEquals(Vector3(0.193001, 0.857724, -0.476509)));
      final normal_5_17 = mesh_5.normals.elementAt(17);
      expect(normal_5_17, vector3MoreOrLessEquals(Vector3(0.75015, 0.580981, -0.315809)));
      final normal_5_18 = mesh_5.normals.elementAt(18);
      expect(normal_5_18, vector3MoreOrLessEquals(Vector3(0.122062, 0.961258, 0.247151)));
      final normal_5_19 = mesh_5.normals.elementAt(19);
      expect(normal_5_19, vector3MoreOrLessEquals(Vector3(0.890764, 0.429947, -0.147257)));
      final normal_5_20 = mesh_5.normals.elementAt(20);
      expect(normal_5_20, vector3MoreOrLessEquals(Vector3(0.75015, 0.580981, -0.315809)));
      final normal_5_21 = mesh_5.normals.elementAt(21);
      expect(normal_5_21, vector3MoreOrLessEquals(Vector3(0.193001, 0.857724, -0.476509)));
      final normal_5_22 = mesh_5.normals.elementAt(22);
      expect(normal_5_22, vector3MoreOrLessEquals(Vector3(0.122062, 0.961258, 0.247151)));
      final normal_5_23 = mesh_5.normals.elementAt(23);
      expect(normal_5_23, vector3MoreOrLessEquals(Vector3(0.75015, 0.580981, -0.315809)));
      final normal_5_24 = mesh_5.normals.elementAt(24);
      expect(normal_5_24, vector3MoreOrLessEquals(Vector3(0.122062, 0.961258, 0.247151)));
      final normal_5_25 = mesh_5.normals.elementAt(25);
      expect(normal_5_25, vector3MoreOrLessEquals(Vector3(0.86936, 0.404802, 0.283458)));
      final normal_5_26 = mesh_5.normals.elementAt(26);
      expect(normal_5_26, vector3MoreOrLessEquals(Vector3(0.890764, 0.429947, -0.147257)));
      final normal_5_27 = mesh_5.normals.elementAt(27);
      expect(normal_5_27, vector3MoreOrLessEquals(Vector3(0.122062, 0.961258, 0.247151)));
      final normal_5_28 = mesh_5.normals.elementAt(28);
      expect(normal_5_28, vector3MoreOrLessEquals(Vector3(0.342558, 0.602318, 0.721018)));
      final normal_5_29 = mesh_5.normals.elementAt(29);
      expect(normal_5_29, vector3MoreOrLessEquals(Vector3(0.86936, 0.404802, 0.283458)));
      final normal_5_30 = mesh_5.normals.elementAt(30);
      expect(normal_5_30, vector3MoreOrLessEquals(Vector3(0.449593, 0.557051, 0.698255)));
      final normal_5_31 = mesh_5.normals.elementAt(31);
      expect(normal_5_31, vector3MoreOrLessEquals(Vector3(0.979971, 0.160598, 0.117751)));
      final normal_5_32 = mesh_5.normals.elementAt(32);
      expect(normal_5_32, vector3MoreOrLessEquals(Vector3(0.86936, 0.404802, 0.283458)));
      final normal_5_33 = mesh_5.normals.elementAt(33);
      expect(normal_5_33, vector3MoreOrLessEquals(Vector3(0.342558, 0.602318, 0.721018)));
      final normal_5_34 = mesh_5.normals.elementAt(34);
      expect(normal_5_34, vector3MoreOrLessEquals(Vector3(0.449593, 0.557051, 0.698255)));
      final normal_5_35 = mesh_5.normals.elementAt(35);
      expect(normal_5_35, vector3MoreOrLessEquals(Vector3(0.86936, 0.404802, 0.283458)));
      final normal_5_36 = mesh_5.normals.elementAt(36);
      expect(normal_5_36, vector3MoreOrLessEquals(Vector3(0.449593, 0.557051, 0.698255)));
      final normal_5_37 = mesh_5.normals.elementAt(37);
      expect(normal_5_37, vector3MoreOrLessEquals(Vector3(0.912952, 0.330027, 0.240004)));
      final normal_5_38 = mesh_5.normals.elementAt(38);
      expect(normal_5_38, vector3MoreOrLessEquals(Vector3(0.979971, 0.160598, 0.117751)));
      final normal_5_39 = mesh_5.normals.elementAt(39);
      expect(normal_5_39, vector3MoreOrLessEquals(Vector3(0.449593, 0.557051, 0.698255)));
      final normal_5_40 = mesh_5.normals.elementAt(40);
      expect(normal_5_40, vector3MoreOrLessEquals(Vector3(0.39696, 0.742707, 0.539267)));
      final normal_5_41 = mesh_5.normals.elementAt(41);
      expect(normal_5_41, vector3MoreOrLessEquals(Vector3(0.912952, 0.330027, 0.240004)));
      final normal_5_42 = mesh_5.normals.elementAt(42);
      expect(normal_5_42, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_43 = mesh_5.normals.elementAt(43);
      expect(normal_5_43, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_44 = mesh_5.normals.elementAt(44);
      expect(normal_5_44, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_45 = mesh_5.normals.elementAt(45);
      expect(normal_5_45, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_46 = mesh_5.normals.elementAt(46);
      expect(normal_5_46, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_47 = mesh_5.normals.elementAt(47);
      expect(normal_5_47, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_48 = mesh_5.normals.elementAt(48);
      expect(normal_5_48, vector3MoreOrLessEquals(Vector3(-0.562652, 0.747701, -0.352655)));
      final normal_5_49 = mesh_5.normals.elementAt(49);
      expect(normal_5_49, vector3MoreOrLessEquals(Vector3(0.245131, 0.76326, -0.597783)));
      final normal_5_50 = mesh_5.normals.elementAt(50);
      expect(normal_5_50, vector3MoreOrLessEquals(Vector3(0.285353, 0.867913, -0.406571)));
      final normal_5_51 = mesh_5.normals.elementAt(51);
      expect(normal_5_51, vector3MoreOrLessEquals(Vector3(-0.562652, 0.747701, -0.352655)));
      final normal_5_52 = mesh_5.normals.elementAt(52);
      expect(normal_5_52, vector3MoreOrLessEquals(Vector3(-0.640733, 0.557163, -0.528234)));
      final normal_5_53 = mesh_5.normals.elementAt(53);
      expect(normal_5_53, vector3MoreOrLessEquals(Vector3(0.245131, 0.76326, -0.597783)));
      final normal_5_54 = mesh_5.normals.elementAt(54);
      expect(normal_5_54, vector3MoreOrLessEquals(Vector3(-0.712118, 0.570582, -0.409053)));
      final normal_5_55 = mesh_5.normals.elementAt(55);
      expect(normal_5_55, vector3MoreOrLessEquals(Vector3(0.193001, 0.857724, -0.476509)));
      final normal_5_56 = mesh_5.normals.elementAt(56);
      expect(normal_5_56, vector3MoreOrLessEquals(Vector3(0.245131, 0.76326, -0.597783)));
      final normal_5_57 = mesh_5.normals.elementAt(57);
      expect(normal_5_57, vector3MoreOrLessEquals(Vector3(-0.640733, 0.557163, -0.528234)));
      final normal_5_58 = mesh_5.normals.elementAt(58);
      expect(normal_5_58, vector3MoreOrLessEquals(Vector3(-0.712118, 0.570582, -0.409053)));
      final normal_5_59 = mesh_5.normals.elementAt(59);
      expect(normal_5_59, vector3MoreOrLessEquals(Vector3(0.245131, 0.76326, -0.597783)));
      final normal_5_60 = mesh_5.normals.elementAt(60);
      expect(normal_5_60, vector3MoreOrLessEquals(Vector3(-0.712118, 0.570582, -0.409053)));
      final normal_5_61 = mesh_5.normals.elementAt(61);
      expect(normal_5_61, vector3MoreOrLessEquals(Vector3(0.122062, 0.961258, 0.247151)));
      final normal_5_62 = mesh_5.normals.elementAt(62);
      expect(normal_5_62, vector3MoreOrLessEquals(Vector3(0.193001, 0.857724, -0.476509)));
      final normal_5_63 = mesh_5.normals.elementAt(63);
      expect(normal_5_63, vector3MoreOrLessEquals(Vector3(-0.712118, 0.570582, -0.409053)));
      final normal_5_64 = mesh_5.normals.elementAt(64);
      expect(normal_5_64, vector3MoreOrLessEquals(Vector3(-0.719414, 0.632988, 0.285953)));
      final normal_5_65 = mesh_5.normals.elementAt(65);
      expect(normal_5_65, vector3MoreOrLessEquals(Vector3(0.122062, 0.961258, 0.247151)));
      final normal_5_66 = mesh_5.normals.elementAt(66);
      expect(normal_5_66, vector3MoreOrLessEquals(Vector3(-0.541635, 0.392908, 0.743139)));
      final normal_5_67 = mesh_5.normals.elementAt(67);
      expect(normal_5_67, vector3MoreOrLessEquals(Vector3(0.342558, 0.602318, 0.721018)));
      final normal_5_68 = mesh_5.normals.elementAt(68);
      expect(normal_5_68, vector3MoreOrLessEquals(Vector3(0.122062, 0.961258, 0.247151)));
      final normal_5_69 = mesh_5.normals.elementAt(69);
      expect(normal_5_69, vector3MoreOrLessEquals(Vector3(-0.719414, 0.632988, 0.285953)));
      final normal_5_70 = mesh_5.normals.elementAt(70);
      expect(normal_5_70, vector3MoreOrLessEquals(Vector3(-0.541635, 0.392908, 0.743139)));
      final normal_5_71 = mesh_5.normals.elementAt(71);
      expect(normal_5_71, vector3MoreOrLessEquals(Vector3(0.122062, 0.961258, 0.247151)));
      final normal_5_72 = mesh_5.normals.elementAt(72);
      expect(normal_5_72, vector3MoreOrLessEquals(Vector3(-0.541635, 0.392908, 0.743139)));
      final normal_5_73 = mesh_5.normals.elementAt(73);
      expect(normal_5_73, vector3MoreOrLessEquals(Vector3(0.449593, 0.557051, 0.698255)));
      final normal_5_74 = mesh_5.normals.elementAt(74);
      expect(normal_5_74, vector3MoreOrLessEquals(Vector3(0.342558, 0.602318, 0.721018)));
      final normal_5_75 = mesh_5.normals.elementAt(75);
      expect(normal_5_75, vector3MoreOrLessEquals(Vector3(-0.541635, 0.392908, 0.743139)));
      final normal_5_76 = mesh_5.normals.elementAt(76);
      expect(normal_5_76, vector3MoreOrLessEquals(Vector3(-0.506872, 0.445328, 0.738081)));
      final normal_5_77 = mesh_5.normals.elementAt(77);
      expect(normal_5_77, vector3MoreOrLessEquals(Vector3(0.449593, 0.557051, 0.698255)));
      final normal_5_78 = mesh_5.normals.elementAt(78);
      expect(normal_5_78, vector3MoreOrLessEquals(Vector3(-0.530036, 0.658014, 0.534864)));
      final normal_5_79 = mesh_5.normals.elementAt(79);
      expect(normal_5_79, vector3MoreOrLessEquals(Vector3(0.39696, 0.742707, 0.539267)));
      final normal_5_80 = mesh_5.normals.elementAt(80);
      expect(normal_5_80, vector3MoreOrLessEquals(Vector3(0.449593, 0.557051, 0.698255)));
      final normal_5_81 = mesh_5.normals.elementAt(81);
      expect(normal_5_81, vector3MoreOrLessEquals(Vector3(-0.506872, 0.445328, 0.738081)));
      final normal_5_82 = mesh_5.normals.elementAt(82);
      expect(normal_5_82, vector3MoreOrLessEquals(Vector3(-0.530036, 0.658014, 0.534864)));
      final normal_5_83 = mesh_5.normals.elementAt(83);
      expect(normal_5_83, vector3MoreOrLessEquals(Vector3(0.449593, 0.557051, 0.698255)));
      final normal_5_84 = mesh_5.normals.elementAt(84);
      expect(normal_5_84, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_85 = mesh_5.normals.elementAt(85);
      expect(normal_5_85, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_86 = mesh_5.normals.elementAt(86);
      expect(normal_5_86, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_87 = mesh_5.normals.elementAt(87);
      expect(normal_5_87, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_88 = mesh_5.normals.elementAt(88);
      expect(normal_5_88, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_89 = mesh_5.normals.elementAt(89);
      expect(normal_5_89, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_90 = mesh_5.normals.elementAt(90);
      expect(normal_5_90, vector3MoreOrLessEquals(Vector3(-0.999398, 0.002857, -0.034586)));
      final normal_5_91 = mesh_5.normals.elementAt(91);
      expect(normal_5_91, vector3MoreOrLessEquals(Vector3(-0.640733, 0.557163, -0.528234)));
      final normal_5_92 = mesh_5.normals.elementAt(92);
      expect(normal_5_92, vector3MoreOrLessEquals(Vector3(-0.562652, 0.747701, -0.352655)));
      final normal_5_93 = mesh_5.normals.elementAt(93);
      expect(normal_5_93, vector3MoreOrLessEquals(Vector3(-0.977859, 0.202556, -0.052566)));
      final normal_5_94 = mesh_5.normals.elementAt(94);
      expect(normal_5_94, vector3MoreOrLessEquals(Vector3(-0.999398, 0.002857, -0.034586)));
      final normal_5_95 = mesh_5.normals.elementAt(95);
      expect(normal_5_95, vector3MoreOrLessEquals(Vector3(-0.562652, 0.747701, -0.352655)));
      final normal_5_96 = mesh_5.normals.elementAt(96);
      expect(normal_5_96, vector3MoreOrLessEquals(Vector3(-0.999398, 0.002857, -0.034586)));
      final normal_5_97 = mesh_5.normals.elementAt(97);
      expect(normal_5_97, vector3MoreOrLessEquals(Vector3(-0.712118, 0.570582, -0.409053)));
      final normal_5_98 = mesh_5.normals.elementAt(98);
      expect(normal_5_98, vector3MoreOrLessEquals(Vector3(-0.640733, 0.557163, -0.528234)));
      final normal_5_99 = mesh_5.normals.elementAt(99);
      expect(normal_5_99, vector3MoreOrLessEquals(Vector3(-0.999398, 0.002857, -0.034586)));
      final normal_5_100 = mesh_5.normals.elementAt(100);
      expect(normal_5_100, vector3MoreOrLessEquals(Vector3(-0.974887, -0.208763, -0.077548)));
      final normal_5_101 = mesh_5.normals.elementAt(101);
      expect(normal_5_101, vector3MoreOrLessEquals(Vector3(-0.712118, 0.570582, -0.409053)));
      final normal_5_102 = mesh_5.normals.elementAt(102);
      expect(normal_5_102, vector3MoreOrLessEquals(Vector3(-0.990809, -0.134971, -0.008911)));
      final normal_5_103 = mesh_5.normals.elementAt(103);
      expect(normal_5_103, vector3MoreOrLessEquals(Vector3(-0.719414, 0.632988, 0.285953)));
      final normal_5_104 = mesh_5.normals.elementAt(104);
      expect(normal_5_104, vector3MoreOrLessEquals(Vector3(-0.712118, 0.570582, -0.409053)));
      final normal_5_105 = mesh_5.normals.elementAt(105);
      expect(normal_5_105, vector3MoreOrLessEquals(Vector3(-0.974887, -0.208763, -0.077548)));
      final normal_5_106 = mesh_5.normals.elementAt(106);
      expect(normal_5_106, vector3MoreOrLessEquals(Vector3(-0.990809, -0.134971, -0.008911)));
      final normal_5_107 = mesh_5.normals.elementAt(107);
      expect(normal_5_107, vector3MoreOrLessEquals(Vector3(-0.712118, 0.570582, -0.409053)));
      final normal_5_108 = mesh_5.normals.elementAt(108);
      expect(normal_5_108, vector3MoreOrLessEquals(Vector3(-0.990809, -0.134971, -0.008911)));
      final normal_5_109 = mesh_5.normals.elementAt(109);
      expect(normal_5_109, vector3MoreOrLessEquals(Vector3(-0.541635, 0.392908, 0.743139)));
      final normal_5_110 = mesh_5.normals.elementAt(110);
      expect(normal_5_110, vector3MoreOrLessEquals(Vector3(-0.719414, 0.632988, 0.285953)));
      final normal_5_111 = mesh_5.normals.elementAt(111);
      expect(normal_5_111, vector3MoreOrLessEquals(Vector3(-0.990809, -0.134971, -0.008911)));
      final normal_5_112 = mesh_5.normals.elementAt(112);
      expect(normal_5_112, vector3MoreOrLessEquals(Vector3(-0.971468, -0.084083, 0.221765)));
      final normal_5_113 = mesh_5.normals.elementAt(113);
      expect(normal_5_113, vector3MoreOrLessEquals(Vector3(-0.541635, 0.392908, 0.743139)));
      final normal_5_114 = mesh_5.normals.elementAt(114);
      expect(normal_5_114, vector3MoreOrLessEquals(Vector3(-0.983987, -0.035832, 0.174602)));
      final normal_5_115 = mesh_5.normals.elementAt(115);
      expect(normal_5_115, vector3MoreOrLessEquals(Vector3(-0.506872, 0.445328, 0.738081)));
      final normal_5_116 = mesh_5.normals.elementAt(116);
      expect(normal_5_116, vector3MoreOrLessEquals(Vector3(-0.541635, 0.392908, 0.743139)));
      final normal_5_117 = mesh_5.normals.elementAt(117);
      expect(normal_5_117, vector3MoreOrLessEquals(Vector3(-0.971468, -0.084083, 0.221765)));
      final normal_5_118 = mesh_5.normals.elementAt(118);
      expect(normal_5_118, vector3MoreOrLessEquals(Vector3(-0.983987, -0.035832, 0.174602)));
      final normal_5_119 = mesh_5.normals.elementAt(119);
      expect(normal_5_119, vector3MoreOrLessEquals(Vector3(-0.541635, 0.392908, 0.743139)));
      final normal_5_120 = mesh_5.normals.elementAt(120);
      expect(normal_5_120, vector3MoreOrLessEquals(Vector3(-0.983987, -0.035832, 0.174602)));
      final normal_5_121 = mesh_5.normals.elementAt(121);
      expect(normal_5_121, vector3MoreOrLessEquals(Vector3(-0.530036, 0.658014, 0.534864)));
      final normal_5_122 = mesh_5.normals.elementAt(122);
      expect(normal_5_122, vector3MoreOrLessEquals(Vector3(-0.506872, 0.445328, 0.738081)));
      final normal_5_123 = mesh_5.normals.elementAt(123);
      expect(normal_5_123, vector3MoreOrLessEquals(Vector3(-0.983987, -0.035832, 0.174602)));
      final normal_5_124 = mesh_5.normals.elementAt(124);
      expect(normal_5_124, vector3MoreOrLessEquals(Vector3(-0.98793, 0.055655, 0.144559)));
      final normal_5_125 = mesh_5.normals.elementAt(125);
      expect(normal_5_125, vector3MoreOrLessEquals(Vector3(-0.530036, 0.658014, 0.534864)));
      final normal_5_126 = mesh_5.normals.elementAt(126);
      expect(normal_5_126, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_127 = mesh_5.normals.elementAt(127);
      expect(normal_5_127, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_128 = mesh_5.normals.elementAt(128);
      expect(normal_5_128, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_129 = mesh_5.normals.elementAt(129);
      expect(normal_5_129, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_130 = mesh_5.normals.elementAt(130);
      expect(normal_5_130, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_131 = mesh_5.normals.elementAt(131);
      expect(normal_5_131, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_132 = mesh_5.normals.elementAt(132);
      expect(normal_5_132, vector3MoreOrLessEquals(Vector3(-0.644785, -0.668339, 0.370912)));
      final normal_5_133 = mesh_5.normals.elementAt(133);
      expect(normal_5_133, vector3MoreOrLessEquals(Vector3(-0.999398, 0.002857, -0.034586)));
      final normal_5_134 = mesh_5.normals.elementAt(134);
      expect(normal_5_134, vector3MoreOrLessEquals(Vector3(-0.977859, 0.202556, -0.052566)));
      final normal_5_135 = mesh_5.normals.elementAt(135);
      expect(normal_5_135, vector3MoreOrLessEquals(Vector3(-0.644785, -0.668339, 0.370912)));
      final normal_5_136 = mesh_5.normals.elementAt(136);
      expect(normal_5_136, vector3MoreOrLessEquals(Vector3(-0.667256, -0.57198, 0.477084)));
      final normal_5_137 = mesh_5.normals.elementAt(137);
      expect(normal_5_137, vector3MoreOrLessEquals(Vector3(-0.999398, 0.002857, -0.034586)));
      final normal_5_138 = mesh_5.normals.elementAt(138);
      expect(normal_5_138, vector3MoreOrLessEquals(Vector3(-0.657389, -0.734501, 0.168369)));
      final normal_5_139 = mesh_5.normals.elementAt(139);
      expect(normal_5_139, vector3MoreOrLessEquals(Vector3(-0.974887, -0.208763, -0.077548)));
      final normal_5_140 = mesh_5.normals.elementAt(140);
      expect(normal_5_140, vector3MoreOrLessEquals(Vector3(-0.999398, 0.002857, -0.034586)));
      final normal_5_141 = mesh_5.normals.elementAt(141);
      expect(normal_5_141, vector3MoreOrLessEquals(Vector3(-0.667256, -0.57198, 0.477084)));
      final normal_5_142 = mesh_5.normals.elementAt(142);
      expect(normal_5_142, vector3MoreOrLessEquals(Vector3(-0.657389, -0.734501, 0.168369)));
      final normal_5_143 = mesh_5.normals.elementAt(143);
      expect(normal_5_143, vector3MoreOrLessEquals(Vector3(-0.999398, 0.002857, -0.034586)));
      final normal_5_144 = mesh_5.normals.elementAt(144);
      expect(normal_5_144, vector3MoreOrLessEquals(Vector3(-0.657389, -0.734501, 0.168369)));
      final normal_5_145 = mesh_5.normals.elementAt(145);
      expect(normal_5_145, vector3MoreOrLessEquals(Vector3(-0.990809, -0.134971, -0.008911)));
      final normal_5_146 = mesh_5.normals.elementAt(146);
      expect(normal_5_146, vector3MoreOrLessEquals(Vector3(-0.974887, -0.208763, -0.077548)));
      final normal_5_147 = mesh_5.normals.elementAt(147);
      expect(normal_5_147, vector3MoreOrLessEquals(Vector3(-0.657389, -0.734501, 0.168369)));
      final normal_5_148 = mesh_5.normals.elementAt(148);
      expect(normal_5_148, vector3MoreOrLessEquals(Vector3(-0.560535, -0.736307, -0.379015)));
      final normal_5_149 = mesh_5.normals.elementAt(149);
      expect(normal_5_149, vector3MoreOrLessEquals(Vector3(-0.990809, -0.134971, -0.008911)));
      final normal_5_150 = mesh_5.normals.elementAt(150);
      expect(normal_5_150, vector3MoreOrLessEquals(Vector3(-0.692904, -0.540327, -0.477421)));
      final normal_5_151 = mesh_5.normals.elementAt(151);
      expect(normal_5_151, vector3MoreOrLessEquals(Vector3(-0.971468, -0.084083, 0.221765)));
      final normal_5_152 = mesh_5.normals.elementAt(152);
      expect(normal_5_152, vector3MoreOrLessEquals(Vector3(-0.990809, -0.134971, -0.008911)));
      final normal_5_153 = mesh_5.normals.elementAt(153);
      expect(normal_5_153, vector3MoreOrLessEquals(Vector3(-0.560535, -0.736307, -0.379015)));
      final normal_5_154 = mesh_5.normals.elementAt(154);
      expect(normal_5_154, vector3MoreOrLessEquals(Vector3(-0.692904, -0.540327, -0.477421)));
      final normal_5_155 = mesh_5.normals.elementAt(155);
      expect(normal_5_155, vector3MoreOrLessEquals(Vector3(-0.990809, -0.134971, -0.008911)));
      final normal_5_156 = mesh_5.normals.elementAt(156);
      expect(normal_5_156, vector3MoreOrLessEquals(Vector3(-0.692904, -0.540327, -0.477421)));
      final normal_5_157 = mesh_5.normals.elementAt(157);
      expect(normal_5_157, vector3MoreOrLessEquals(Vector3(-0.983987, -0.035832, 0.174602)));
      final normal_5_158 = mesh_5.normals.elementAt(158);
      expect(normal_5_158, vector3MoreOrLessEquals(Vector3(-0.971468, -0.084083, 0.221765)));
      final normal_5_159 = mesh_5.normals.elementAt(159);
      expect(normal_5_159, vector3MoreOrLessEquals(Vector3(-0.692904, -0.540327, -0.477421)));
      final normal_5_160 = mesh_5.normals.elementAt(160);
      expect(normal_5_160, vector3MoreOrLessEquals(Vector3(-0.805447, -0.450708, -0.38486)));
      final normal_5_161 = mesh_5.normals.elementAt(161);
      expect(normal_5_161, vector3MoreOrLessEquals(Vector3(-0.983987, -0.035832, 0.174602)));
      final normal_5_162 = mesh_5.normals.elementAt(162);
      expect(normal_5_162, vector3MoreOrLessEquals(Vector3(-0.807097, -0.552297, -0.208715)));
      final normal_5_163 = mesh_5.normals.elementAt(163);
      expect(normal_5_163, vector3MoreOrLessEquals(Vector3(-0.98793, 0.055655, 0.144559)));
      final normal_5_164 = mesh_5.normals.elementAt(164);
      expect(normal_5_164, vector3MoreOrLessEquals(Vector3(-0.983987, -0.035832, 0.174602)));
      final normal_5_165 = mesh_5.normals.elementAt(165);
      expect(normal_5_165, vector3MoreOrLessEquals(Vector3(-0.805447, -0.450708, -0.38486)));
      final normal_5_166 = mesh_5.normals.elementAt(166);
      expect(normal_5_166, vector3MoreOrLessEquals(Vector3(-0.807097, -0.552297, -0.208715)));
      final normal_5_167 = mesh_5.normals.elementAt(167);
      expect(normal_5_167, vector3MoreOrLessEquals(Vector3(-0.983987, -0.035832, 0.174602)));
      final normal_5_168 = mesh_5.normals.elementAt(168);
      expect(normal_5_168, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_169 = mesh_5.normals.elementAt(169);
      expect(normal_5_169, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_170 = mesh_5.normals.elementAt(170);
      expect(normal_5_170, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_171 = mesh_5.normals.elementAt(171);
      expect(normal_5_171, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_172 = mesh_5.normals.elementAt(172);
      expect(normal_5_172, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_173 = mesh_5.normals.elementAt(173);
      expect(normal_5_173, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_174 = mesh_5.normals.elementAt(174);
      expect(normal_5_174, vector3MoreOrLessEquals(Vector3(0.166809, -0.694562, 0.699828)));
      final normal_5_175 = mesh_5.normals.elementAt(175);
      expect(normal_5_175, vector3MoreOrLessEquals(Vector3(-0.667256, -0.57198, 0.477084)));
      final normal_5_176 = mesh_5.normals.elementAt(176);
      expect(normal_5_176, vector3MoreOrLessEquals(Vector3(-0.644785, -0.668339, 0.370912)));
      final normal_5_177 = mesh_5.normals.elementAt(177);
      expect(normal_5_177, vector3MoreOrLessEquals(Vector3(0.081505, -0.869441, 0.487268)));
      final normal_5_178 = mesh_5.normals.elementAt(178);
      expect(normal_5_178, vector3MoreOrLessEquals(Vector3(0.166809, -0.694562, 0.699828)));
      final normal_5_179 = mesh_5.normals.elementAt(179);
      expect(normal_5_179, vector3MoreOrLessEquals(Vector3(-0.644785, -0.668339, 0.370912)));
      final normal_5_180 = mesh_5.normals.elementAt(180);
      expect(normal_5_180, vector3MoreOrLessEquals(Vector3(0.166809, -0.694562, 0.699828)));
      final normal_5_181 = mesh_5.normals.elementAt(181);
      expect(normal_5_181, vector3MoreOrLessEquals(Vector3(-0.657389, -0.734501, 0.168369)));
      final normal_5_182 = mesh_5.normals.elementAt(182);
      expect(normal_5_182, vector3MoreOrLessEquals(Vector3(-0.667256, -0.57198, 0.477084)));
      final normal_5_183 = mesh_5.normals.elementAt(183);
      expect(normal_5_183, vector3MoreOrLessEquals(Vector3(0.166809, -0.694562, 0.699828)));
      final normal_5_184 = mesh_5.normals.elementAt(184);
      expect(normal_5_184, vector3MoreOrLessEquals(Vector3(0.34406, -0.883528, 0.317807)));
      final normal_5_185 = mesh_5.normals.elementAt(185);
      expect(normal_5_185, vector3MoreOrLessEquals(Vector3(-0.657389, -0.734501, 0.168369)));
      final normal_5_186 = mesh_5.normals.elementAt(186);
      expect(normal_5_186, vector3MoreOrLessEquals(Vector3(0.303265, -0.806548, -0.507455)));
      final normal_5_187 = mesh_5.normals.elementAt(187);
      expect(normal_5_187, vector3MoreOrLessEquals(Vector3(-0.560535, -0.736307, -0.379015)));
      final normal_5_188 = mesh_5.normals.elementAt(188);
      expect(normal_5_188, vector3MoreOrLessEquals(Vector3(-0.657389, -0.734501, 0.168369)));
      final normal_5_189 = mesh_5.normals.elementAt(189);
      expect(normal_5_189, vector3MoreOrLessEquals(Vector3(0.34406, -0.883528, 0.317807)));
      final normal_5_190 = mesh_5.normals.elementAt(190);
      expect(normal_5_190, vector3MoreOrLessEquals(Vector3(0.303265, -0.806548, -0.507455)));
      final normal_5_191 = mesh_5.normals.elementAt(191);
      expect(normal_5_191, vector3MoreOrLessEquals(Vector3(-0.657389, -0.734501, 0.168369)));
      final normal_5_192 = mesh_5.normals.elementAt(192);
      expect(normal_5_192, vector3MoreOrLessEquals(Vector3(0.303265, -0.806548, -0.507455)));
      final normal_5_193 = mesh_5.normals.elementAt(193);
      expect(normal_5_193, vector3MoreOrLessEquals(Vector3(-0.692904, -0.540327, -0.477421)));
      final normal_5_194 = mesh_5.normals.elementAt(194);
      expect(normal_5_194, vector3MoreOrLessEquals(Vector3(-0.560535, -0.736307, -0.379015)));
      final normal_5_195 = mesh_5.normals.elementAt(195);
      expect(normal_5_195, vector3MoreOrLessEquals(Vector3(0.303265, -0.806548, -0.507455)));
      final normal_5_196 = mesh_5.normals.elementAt(196);
      expect(normal_5_196, vector3MoreOrLessEquals(Vector3(0.132506, -0.587487, -0.798312)));
      final normal_5_197 = mesh_5.normals.elementAt(197);
      expect(normal_5_197, vector3MoreOrLessEquals(Vector3(-0.692904, -0.540327, -0.477421)));
      final normal_5_198 = mesh_5.normals.elementAt(198);
      expect(normal_5_198, vector3MoreOrLessEquals(Vector3(0.02261, -0.69363, -0.719976)));
      final normal_5_199 = mesh_5.normals.elementAt(199);
      expect(normal_5_199, vector3MoreOrLessEquals(Vector3(-0.805447, -0.450708, -0.38486)));
      final normal_5_200 = mesh_5.normals.elementAt(200);
      expect(normal_5_200, vector3MoreOrLessEquals(Vector3(-0.692904, -0.540327, -0.477421)));
      final normal_5_201 = mesh_5.normals.elementAt(201);
      expect(normal_5_201, vector3MoreOrLessEquals(Vector3(0.132506, -0.587487, -0.798312)));
      final normal_5_202 = mesh_5.normals.elementAt(202);
      expect(normal_5_202, vector3MoreOrLessEquals(Vector3(0.02261, -0.69363, -0.719976)));
      final normal_5_203 = mesh_5.normals.elementAt(203);
      expect(normal_5_203, vector3MoreOrLessEquals(Vector3(-0.692904, -0.540327, -0.477421)));
      final normal_5_204 = mesh_5.normals.elementAt(204);
      expect(normal_5_204, vector3MoreOrLessEquals(Vector3(0.02261, -0.69363, -0.719976)));
      final normal_5_205 = mesh_5.normals.elementAt(205);
      expect(normal_5_205, vector3MoreOrLessEquals(Vector3(-0.807097, -0.552297, -0.208715)));
      final normal_5_206 = mesh_5.normals.elementAt(206);
      expect(normal_5_206, vector3MoreOrLessEquals(Vector3(-0.805447, -0.450708, -0.38486)));
      final normal_5_207 = mesh_5.normals.elementAt(207);
      expect(normal_5_207, vector3MoreOrLessEquals(Vector3(0.02261, -0.69363, -0.719976)));
      final normal_5_208 = mesh_5.normals.elementAt(208);
      expect(normal_5_208, vector3MoreOrLessEquals(Vector3(0.0451, -0.923914, -0.379933)));
      final normal_5_209 = mesh_5.normals.elementAt(209);
      expect(normal_5_209, vector3MoreOrLessEquals(Vector3(-0.807097, -0.552297, -0.208715)));
      final normal_5_210 = mesh_5.normals.elementAt(210);
      expect(normal_5_210, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_211 = mesh_5.normals.elementAt(211);
      expect(normal_5_211, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_212 = mesh_5.normals.elementAt(212);
      expect(normal_5_212, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_213 = mesh_5.normals.elementAt(213);
      expect(normal_5_213, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_214 = mesh_5.normals.elementAt(214);
      expect(normal_5_214, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_215 = mesh_5.normals.elementAt(215);
      expect(normal_5_215, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_216 = mesh_5.normals.elementAt(216);
      expect(normal_5_216, vector3MoreOrLessEquals(Vector3(0.862122, -0.401541, 0.309048)));
      final normal_5_217 = mesh_5.normals.elementAt(217);
      expect(normal_5_217, vector3MoreOrLessEquals(Vector3(0.166809, -0.694562, 0.699828)));
      final normal_5_218 = mesh_5.normals.elementAt(218);
      expect(normal_5_218, vector3MoreOrLessEquals(Vector3(0.081505, -0.869441, 0.487268)));
      final normal_5_219 = mesh_5.normals.elementAt(219);
      expect(normal_5_219, vector3MoreOrLessEquals(Vector3(0.862122, -0.401541, 0.309048)));
      final normal_5_220 = mesh_5.normals.elementAt(220);
      expect(normal_5_220, vector3MoreOrLessEquals(Vector3(0.886724, -0.232862, 0.399368)));
      final normal_5_221 = mesh_5.normals.elementAt(221);
      expect(normal_5_221, vector3MoreOrLessEquals(Vector3(0.166809, -0.694562, 0.699828)));
      final normal_5_222 = mesh_5.normals.elementAt(222);
      expect(normal_5_222, vector3MoreOrLessEquals(Vector3(0.979859, -0.190892, 0.058615)));
      final normal_5_223 = mesh_5.normals.elementAt(223);
      expect(normal_5_223, vector3MoreOrLessEquals(Vector3(0.34406, -0.883528, 0.317807)));
      final normal_5_224 = mesh_5.normals.elementAt(224);
      expect(normal_5_224, vector3MoreOrLessEquals(Vector3(0.166809, -0.694562, 0.699828)));
      final normal_5_225 = mesh_5.normals.elementAt(225);
      expect(normal_5_225, vector3MoreOrLessEquals(Vector3(0.886724, -0.232862, 0.399368)));
      final normal_5_226 = mesh_5.normals.elementAt(226);
      expect(normal_5_226, vector3MoreOrLessEquals(Vector3(0.979859, -0.190892, 0.058615)));
      final normal_5_227 = mesh_5.normals.elementAt(227);
      expect(normal_5_227, vector3MoreOrLessEquals(Vector3(0.166809, -0.694562, 0.699828)));
      final normal_5_228 = mesh_5.normals.elementAt(228);
      expect(normal_5_228, vector3MoreOrLessEquals(Vector3(0.979859, -0.190892, 0.058615)));
      final normal_5_229 = mesh_5.normals.elementAt(229);
      expect(normal_5_229, vector3MoreOrLessEquals(Vector3(0.303265, -0.806548, -0.507455)));
      final normal_5_230 = mesh_5.normals.elementAt(230);
      expect(normal_5_230, vector3MoreOrLessEquals(Vector3(0.34406, -0.883528, 0.317807)));
      final normal_5_231 = mesh_5.normals.elementAt(231);
      expect(normal_5_231, vector3MoreOrLessEquals(Vector3(0.979859, -0.190892, 0.058615)));
      final normal_5_232 = mesh_5.normals.elementAt(232);
      expect(normal_5_232, vector3MoreOrLessEquals(Vector3(0.901262, -0.198277, -0.385245)));
      final normal_5_233 = mesh_5.normals.elementAt(233);
      expect(normal_5_233, vector3MoreOrLessEquals(Vector3(0.303265, -0.806548, -0.507455)));
      final normal_5_234 = mesh_5.normals.elementAt(234);
      expect(normal_5_234, vector3MoreOrLessEquals(Vector3(0.854374, -0.181939, -0.486768)));
      final normal_5_235 = mesh_5.normals.elementAt(235);
      expect(normal_5_235, vector3MoreOrLessEquals(Vector3(0.132506, -0.587487, -0.798312)));
      final normal_5_236 = mesh_5.normals.elementAt(236);
      expect(normal_5_236, vector3MoreOrLessEquals(Vector3(0.303265, -0.806548, -0.507455)));
      final normal_5_237 = mesh_5.normals.elementAt(237);
      expect(normal_5_237, vector3MoreOrLessEquals(Vector3(0.901262, -0.198277, -0.385245)));
      final normal_5_238 = mesh_5.normals.elementAt(238);
      expect(normal_5_238, vector3MoreOrLessEquals(Vector3(0.854374, -0.181939, -0.486768)));
      final normal_5_239 = mesh_5.normals.elementAt(239);
      expect(normal_5_239, vector3MoreOrLessEquals(Vector3(0.303265, -0.806548, -0.507455)));
      final normal_5_240 = mesh_5.normals.elementAt(240);
      expect(normal_5_240, vector3MoreOrLessEquals(Vector3(0.854374, -0.181939, -0.486768)));
      final normal_5_241 = mesh_5.normals.elementAt(241);
      expect(normal_5_241, vector3MoreOrLessEquals(Vector3(0.02261, -0.69363, -0.719976)));
      final normal_5_242 = mesh_5.normals.elementAt(242);
      expect(normal_5_242, vector3MoreOrLessEquals(Vector3(0.132506, -0.587487, -0.798312)));
      final normal_5_243 = mesh_5.normals.elementAt(243);
      expect(normal_5_243, vector3MoreOrLessEquals(Vector3(0.854374, -0.181939, -0.486768)));
      final normal_5_244 = mesh_5.normals.elementAt(244);
      expect(normal_5_244, vector3MoreOrLessEquals(Vector3(0.901238, -0.252507, -0.352151)));
      final normal_5_245 = mesh_5.normals.elementAt(245);
      expect(normal_5_245, vector3MoreOrLessEquals(Vector3(0.02261, -0.69363, -0.719976)));
      final normal_5_246 = mesh_5.normals.elementAt(246);
      expect(normal_5_246, vector3MoreOrLessEquals(Vector3(0.898278, -0.412999, -0.150093)));
      final normal_5_247 = mesh_5.normals.elementAt(247);
      expect(normal_5_247, vector3MoreOrLessEquals(Vector3(0.0451, -0.923914, -0.379933)));
      final normal_5_248 = mesh_5.normals.elementAt(248);
      expect(normal_5_248, vector3MoreOrLessEquals(Vector3(0.02261, -0.69363, -0.719976)));
      final normal_5_249 = mesh_5.normals.elementAt(249);
      expect(normal_5_249, vector3MoreOrLessEquals(Vector3(0.901238, -0.252507, -0.352151)));
      final normal_5_250 = mesh_5.normals.elementAt(250);
      expect(normal_5_250, vector3MoreOrLessEquals(Vector3(0.898278, -0.412999, -0.150093)));
      final normal_5_251 = mesh_5.normals.elementAt(251);
      expect(normal_5_251, vector3MoreOrLessEquals(Vector3(0.02261, -0.69363, -0.719976)));
      final normal_5_252 = mesh_5.normals.elementAt(252);
      expect(normal_5_252, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_253 = mesh_5.normals.elementAt(253);
      expect(normal_5_253, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_254 = mesh_5.normals.elementAt(254);
      expect(normal_5_254, vector3MoreOrLessEquals(Vector3(0.041443, -0.908865, -0.415027)));
      final normal_5_255 = mesh_5.normals.elementAt(255);
      expect(normal_5_255, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_256 = mesh_5.normals.elementAt(256);
      expect(normal_5_256, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_257 = mesh_5.normals.elementAt(257);
      expect(normal_5_257, vector3MoreOrLessEquals(Vector3(-0.109957, -0.084548, 0.990334)));
      final normal_5_258 = mesh_5.normals.elementAt(258);
      expect(normal_5_258, vector3MoreOrLessEquals(Vector3(0.955445, 0.284327, -0.079261)));
      final normal_5_259 = mesh_5.normals.elementAt(259);
      expect(normal_5_259, vector3MoreOrLessEquals(Vector3(0.886724, -0.232862, 0.399368)));
      final normal_5_260 = mesh_5.normals.elementAt(260);
      expect(normal_5_260, vector3MoreOrLessEquals(Vector3(0.862122, -0.401541, 0.309048)));
      final normal_5_261 = mesh_5.normals.elementAt(261);
      expect(normal_5_261, vector3MoreOrLessEquals(Vector3(0.823805, 0.535171, -0.186913)));
      final normal_5_262 = mesh_5.normals.elementAt(262);
      expect(normal_5_262, vector3MoreOrLessEquals(Vector3(0.955445, 0.284327, -0.079261)));
      final normal_5_263 = mesh_5.normals.elementAt(263);
      expect(normal_5_263, vector3MoreOrLessEquals(Vector3(0.862122, -0.401541, 0.309048)));
      final normal_5_264 = mesh_5.normals.elementAt(264);
      expect(normal_5_264, vector3MoreOrLessEquals(Vector3(0.955445, 0.284327, -0.079261)));
      final normal_5_265 = mesh_5.normals.elementAt(265);
      expect(normal_5_265, vector3MoreOrLessEquals(Vector3(0.979859, -0.190892, 0.058615)));
      final normal_5_266 = mesh_5.normals.elementAt(266);
      expect(normal_5_266, vector3MoreOrLessEquals(Vector3(0.886724, -0.232862, 0.399368)));
      final normal_5_267 = mesh_5.normals.elementAt(267);
      expect(normal_5_267, vector3MoreOrLessEquals(Vector3(0.955445, 0.284327, -0.079261)));
      final normal_5_268 = mesh_5.normals.elementAt(268);
      expect(normal_5_268, vector3MoreOrLessEquals(Vector3(0.75015, 0.580981, -0.315809)));
      final normal_5_269 = mesh_5.normals.elementAt(269);
      expect(normal_5_269, vector3MoreOrLessEquals(Vector3(0.979859, -0.190892, 0.058615)));
      final normal_5_270 = mesh_5.normals.elementAt(270);
      expect(normal_5_270, vector3MoreOrLessEquals(Vector3(0.890764, 0.429947, -0.147257)));
      final normal_5_271 = mesh_5.normals.elementAt(271);
      expect(normal_5_271, vector3MoreOrLessEquals(Vector3(0.901262, -0.198277, -0.385245)));
      final normal_5_272 = mesh_5.normals.elementAt(272);
      expect(normal_5_272, vector3MoreOrLessEquals(Vector3(0.979859, -0.190892, 0.058615)));
      final normal_5_273 = mesh_5.normals.elementAt(273);
      expect(normal_5_273, vector3MoreOrLessEquals(Vector3(0.75015, 0.580981, -0.315809)));
      final normal_5_274 = mesh_5.normals.elementAt(274);
      expect(normal_5_274, vector3MoreOrLessEquals(Vector3(0.890764, 0.429947, -0.147257)));
      final normal_5_275 = mesh_5.normals.elementAt(275);
      expect(normal_5_275, vector3MoreOrLessEquals(Vector3(0.979859, -0.190892, 0.058615)));
      final normal_5_276 = mesh_5.normals.elementAt(276);
      expect(normal_5_276, vector3MoreOrLessEquals(Vector3(0.890764, 0.429947, -0.147257)));
      final normal_5_277 = mesh_5.normals.elementAt(277);
      expect(normal_5_277, vector3MoreOrLessEquals(Vector3(0.854374, -0.181939, -0.486768)));
      final normal_5_278 = mesh_5.normals.elementAt(278);
      expect(normal_5_278, vector3MoreOrLessEquals(Vector3(0.901262, -0.198277, -0.385245)));
      final normal_5_279 = mesh_5.normals.elementAt(279);
      expect(normal_5_279, vector3MoreOrLessEquals(Vector3(0.890764, 0.429947, -0.147257)));
      final normal_5_280 = mesh_5.normals.elementAt(280);
      expect(normal_5_280, vector3MoreOrLessEquals(Vector3(0.86936, 0.404802, 0.283458)));
      final normal_5_281 = mesh_5.normals.elementAt(281);
      expect(normal_5_281, vector3MoreOrLessEquals(Vector3(0.854374, -0.181939, -0.486768)));
      final normal_5_282 = mesh_5.normals.elementAt(282);
      expect(normal_5_282, vector3MoreOrLessEquals(Vector3(0.979971, 0.160598, 0.117751)));
      final normal_5_283 = mesh_5.normals.elementAt(283);
      expect(normal_5_283, vector3MoreOrLessEquals(Vector3(0.901238, -0.252507, -0.352151)));
      final normal_5_284 = mesh_5.normals.elementAt(284);
      expect(normal_5_284, vector3MoreOrLessEquals(Vector3(0.854374, -0.181939, -0.486768)));
      final normal_5_285 = mesh_5.normals.elementAt(285);
      expect(normal_5_285, vector3MoreOrLessEquals(Vector3(0.86936, 0.404802, 0.283458)));
      final normal_5_286 = mesh_5.normals.elementAt(286);
      expect(normal_5_286, vector3MoreOrLessEquals(Vector3(0.979971, 0.160598, 0.117751)));
      final normal_5_287 = mesh_5.normals.elementAt(287);
      expect(normal_5_287, vector3MoreOrLessEquals(Vector3(0.854374, -0.181939, -0.486768)));
      final normal_5_288 = mesh_5.normals.elementAt(288);
      expect(normal_5_288, vector3MoreOrLessEquals(Vector3(0.979971, 0.160598, 0.117751)));
      final normal_5_289 = mesh_5.normals.elementAt(289);
      expect(normal_5_289, vector3MoreOrLessEquals(Vector3(0.898278, -0.412999, -0.150093)));
      final normal_5_290 = mesh_5.normals.elementAt(290);
      expect(normal_5_290, vector3MoreOrLessEquals(Vector3(0.901238, -0.252507, -0.352151)));
      final normal_5_291 = mesh_5.normals.elementAt(291);
      expect(normal_5_291, vector3MoreOrLessEquals(Vector3(0.979971, 0.160598, 0.117751)));
      final normal_5_292 = mesh_5.normals.elementAt(292);
      expect(normal_5_292, vector3MoreOrLessEquals(Vector3(0.912952, 0.330027, 0.240004)));
      final normal_5_293 = mesh_5.normals.elementAt(293);
      expect(normal_5_293, vector3MoreOrLessEquals(Vector3(0.898278, -0.412999, -0.150093)));
      expect(mesh_5.tangents.length, isZero);
      expect(mesh_5.bitangents.length, isZero);
      expect(mesh_5.colors.length, isZero);
      expect(mesh_5.textureCoords.length, equals(1));
      final textureCoords_5_0 = mesh_5.textureCoords.elementAt(0);
      expect(textureCoords_5_0.length, equals(294));
      final textureCoord_5_0_0 = textureCoords_5_0.elementAt(0);
      expect(textureCoord_5_0_0, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_1 = textureCoords_5_0.elementAt(1);
      expect(textureCoord_5_0_1, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_2 = textureCoords_5_0.elementAt(2);
      expect(textureCoord_5_0_2, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_3 = textureCoords_5_0.elementAt(3);
      expect(textureCoord_5_0_3, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_4 = textureCoords_5_0.elementAt(4);
      expect(textureCoord_5_0_4, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_5 = textureCoords_5_0.elementAt(5);
      expect(textureCoord_5_0_5, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_6 = textureCoords_5_0.elementAt(6);
      expect(textureCoord_5_0_6, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_5_0_7 = textureCoords_5_0.elementAt(7);
      expect(textureCoord_5_0_7, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_5_0_8 = textureCoords_5_0.elementAt(8);
      expect(textureCoord_5_0_8, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_5_0_9 = textureCoords_5_0.elementAt(9);
      expect(textureCoord_5_0_9, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_5_0_10 = textureCoords_5_0.elementAt(10);
      expect(textureCoord_5_0_10, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_5_0_11 = textureCoords_5_0.elementAt(11);
      expect(textureCoord_5_0_11, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_5_0_12 = textureCoords_5_0.elementAt(12);
      expect(textureCoord_5_0_12, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_5_0_13 = textureCoords_5_0.elementAt(13);
      expect(textureCoord_5_0_13, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_5_0_14 = textureCoords_5_0.elementAt(14);
      expect(textureCoord_5_0_14, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_5_0_15 = textureCoords_5_0.elementAt(15);
      expect(textureCoord_5_0_15, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_5_0_16 = textureCoords_5_0.elementAt(16);
      expect(textureCoord_5_0_16, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_5_0_17 = textureCoords_5_0.elementAt(17);
      expect(textureCoord_5_0_17, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_5_0_18 = textureCoords_5_0.elementAt(18);
      expect(textureCoord_5_0_18, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_5_0_19 = textureCoords_5_0.elementAt(19);
      expect(textureCoord_5_0_19, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_5_0_20 = textureCoords_5_0.elementAt(20);
      expect(textureCoord_5_0_20, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_5_0_21 = textureCoords_5_0.elementAt(21);
      expect(textureCoord_5_0_21, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_5_0_22 = textureCoords_5_0.elementAt(22);
      expect(textureCoord_5_0_22, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_5_0_23 = textureCoords_5_0.elementAt(23);
      expect(textureCoord_5_0_23, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_5_0_24 = textureCoords_5_0.elementAt(24);
      expect(textureCoord_5_0_24, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_5_0_25 = textureCoords_5_0.elementAt(25);
      expect(textureCoord_5_0_25, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_5_0_26 = textureCoords_5_0.elementAt(26);
      expect(textureCoord_5_0_26, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_5_0_27 = textureCoords_5_0.elementAt(27);
      expect(textureCoord_5_0_27, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_5_0_28 = textureCoords_5_0.elementAt(28);
      expect(textureCoord_5_0_28, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_5_0_29 = textureCoords_5_0.elementAt(29);
      expect(textureCoord_5_0_29, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_5_0_30 = textureCoords_5_0.elementAt(30);
      expect(textureCoord_5_0_30, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_5_0_31 = textureCoords_5_0.elementAt(31);
      expect(textureCoord_5_0_31, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_5_0_32 = textureCoords_5_0.elementAt(32);
      expect(textureCoord_5_0_32, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_5_0_33 = textureCoords_5_0.elementAt(33);
      expect(textureCoord_5_0_33, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_5_0_34 = textureCoords_5_0.elementAt(34);
      expect(textureCoord_5_0_34, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_5_0_35 = textureCoords_5_0.elementAt(35);
      expect(textureCoord_5_0_35, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_5_0_36 = textureCoords_5_0.elementAt(36);
      expect(textureCoord_5_0_36, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_5_0_37 = textureCoords_5_0.elementAt(37);
      expect(textureCoord_5_0_37, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_38 = textureCoords_5_0.elementAt(38);
      expect(textureCoord_5_0_38, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_5_0_39 = textureCoords_5_0.elementAt(39);
      expect(textureCoord_5_0_39, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_5_0_40 = textureCoords_5_0.elementAt(40);
      expect(textureCoord_5_0_40, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_5_0_41 = textureCoords_5_0.elementAt(41);
      expect(textureCoord_5_0_41, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_42 = textureCoords_5_0.elementAt(42);
      expect(textureCoord_5_0_42, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_43 = textureCoords_5_0.elementAt(43);
      expect(textureCoord_5_0_43, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_44 = textureCoords_5_0.elementAt(44);
      expect(textureCoord_5_0_44, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_45 = textureCoords_5_0.elementAt(45);
      expect(textureCoord_5_0_45, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_46 = textureCoords_5_0.elementAt(46);
      expect(textureCoord_5_0_46, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_47 = textureCoords_5_0.elementAt(47);
      expect(textureCoord_5_0_47, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_48 = textureCoords_5_0.elementAt(48);
      expect(textureCoord_5_0_48, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_5_0_49 = textureCoords_5_0.elementAt(49);
      expect(textureCoord_5_0_49, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_5_0_50 = textureCoords_5_0.elementAt(50);
      expect(textureCoord_5_0_50, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_5_0_51 = textureCoords_5_0.elementAt(51);
      expect(textureCoord_5_0_51, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_5_0_52 = textureCoords_5_0.elementAt(52);
      expect(textureCoord_5_0_52, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_5_0_53 = textureCoords_5_0.elementAt(53);
      expect(textureCoord_5_0_53, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_5_0_54 = textureCoords_5_0.elementAt(54);
      expect(textureCoord_5_0_54, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_5_0_55 = textureCoords_5_0.elementAt(55);
      expect(textureCoord_5_0_55, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_5_0_56 = textureCoords_5_0.elementAt(56);
      expect(textureCoord_5_0_56, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_5_0_57 = textureCoords_5_0.elementAt(57);
      expect(textureCoord_5_0_57, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_5_0_58 = textureCoords_5_0.elementAt(58);
      expect(textureCoord_5_0_58, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_5_0_59 = textureCoords_5_0.elementAt(59);
      expect(textureCoord_5_0_59, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_5_0_60 = textureCoords_5_0.elementAt(60);
      expect(textureCoord_5_0_60, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_5_0_61 = textureCoords_5_0.elementAt(61);
      expect(textureCoord_5_0_61, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_5_0_62 = textureCoords_5_0.elementAt(62);
      expect(textureCoord_5_0_62, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_5_0_63 = textureCoords_5_0.elementAt(63);
      expect(textureCoord_5_0_63, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_5_0_64 = textureCoords_5_0.elementAt(64);
      expect(textureCoord_5_0_64, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_5_0_65 = textureCoords_5_0.elementAt(65);
      expect(textureCoord_5_0_65, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_5_0_66 = textureCoords_5_0.elementAt(66);
      expect(textureCoord_5_0_66, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_5_0_67 = textureCoords_5_0.elementAt(67);
      expect(textureCoord_5_0_67, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_5_0_68 = textureCoords_5_0.elementAt(68);
      expect(textureCoord_5_0_68, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_5_0_69 = textureCoords_5_0.elementAt(69);
      expect(textureCoord_5_0_69, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_5_0_70 = textureCoords_5_0.elementAt(70);
      expect(textureCoord_5_0_70, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_5_0_71 = textureCoords_5_0.elementAt(71);
      expect(textureCoord_5_0_71, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_5_0_72 = textureCoords_5_0.elementAt(72);
      expect(textureCoord_5_0_72, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_5_0_73 = textureCoords_5_0.elementAt(73);
      expect(textureCoord_5_0_73, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_5_0_74 = textureCoords_5_0.elementAt(74);
      expect(textureCoord_5_0_74, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_5_0_75 = textureCoords_5_0.elementAt(75);
      expect(textureCoord_5_0_75, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_5_0_76 = textureCoords_5_0.elementAt(76);
      expect(textureCoord_5_0_76, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_5_0_77 = textureCoords_5_0.elementAt(77);
      expect(textureCoord_5_0_77, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_5_0_78 = textureCoords_5_0.elementAt(78);
      expect(textureCoord_5_0_78, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_5_0_79 = textureCoords_5_0.elementAt(79);
      expect(textureCoord_5_0_79, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_5_0_80 = textureCoords_5_0.elementAt(80);
      expect(textureCoord_5_0_80, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_5_0_81 = textureCoords_5_0.elementAt(81);
      expect(textureCoord_5_0_81, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_5_0_82 = textureCoords_5_0.elementAt(82);
      expect(textureCoord_5_0_82, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_5_0_83 = textureCoords_5_0.elementAt(83);
      expect(textureCoord_5_0_83, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_5_0_84 = textureCoords_5_0.elementAt(84);
      expect(textureCoord_5_0_84, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_85 = textureCoords_5_0.elementAt(85);
      expect(textureCoord_5_0_85, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_86 = textureCoords_5_0.elementAt(86);
      expect(textureCoord_5_0_86, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_87 = textureCoords_5_0.elementAt(87);
      expect(textureCoord_5_0_87, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_88 = textureCoords_5_0.elementAt(88);
      expect(textureCoord_5_0_88, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_89 = textureCoords_5_0.elementAt(89);
      expect(textureCoord_5_0_89, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_90 = textureCoords_5_0.elementAt(90);
      expect(textureCoord_5_0_90, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_5_0_91 = textureCoords_5_0.elementAt(91);
      expect(textureCoord_5_0_91, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_5_0_92 = textureCoords_5_0.elementAt(92);
      expect(textureCoord_5_0_92, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_5_0_93 = textureCoords_5_0.elementAt(93);
      expect(textureCoord_5_0_93, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_5_0_94 = textureCoords_5_0.elementAt(94);
      expect(textureCoord_5_0_94, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_5_0_95 = textureCoords_5_0.elementAt(95);
      expect(textureCoord_5_0_95, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_5_0_96 = textureCoords_5_0.elementAt(96);
      expect(textureCoord_5_0_96, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_5_0_97 = textureCoords_5_0.elementAt(97);
      expect(textureCoord_5_0_97, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_5_0_98 = textureCoords_5_0.elementAt(98);
      expect(textureCoord_5_0_98, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_5_0_99 = textureCoords_5_0.elementAt(99);
      expect(textureCoord_5_0_99, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_5_0_100 = textureCoords_5_0.elementAt(100);
      expect(textureCoord_5_0_100, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_5_0_101 = textureCoords_5_0.elementAt(101);
      expect(textureCoord_5_0_101, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_5_0_102 = textureCoords_5_0.elementAt(102);
      expect(textureCoord_5_0_102, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_5_0_103 = textureCoords_5_0.elementAt(103);
      expect(textureCoord_5_0_103, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_5_0_104 = textureCoords_5_0.elementAt(104);
      expect(textureCoord_5_0_104, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_5_0_105 = textureCoords_5_0.elementAt(105);
      expect(textureCoord_5_0_105, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_5_0_106 = textureCoords_5_0.elementAt(106);
      expect(textureCoord_5_0_106, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_5_0_107 = textureCoords_5_0.elementAt(107);
      expect(textureCoord_5_0_107, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_5_0_108 = textureCoords_5_0.elementAt(108);
      expect(textureCoord_5_0_108, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_5_0_109 = textureCoords_5_0.elementAt(109);
      expect(textureCoord_5_0_109, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_5_0_110 = textureCoords_5_0.elementAt(110);
      expect(textureCoord_5_0_110, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_5_0_111 = textureCoords_5_0.elementAt(111);
      expect(textureCoord_5_0_111, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_5_0_112 = textureCoords_5_0.elementAt(112);
      expect(textureCoord_5_0_112, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_5_0_113 = textureCoords_5_0.elementAt(113);
      expect(textureCoord_5_0_113, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_5_0_114 = textureCoords_5_0.elementAt(114);
      expect(textureCoord_5_0_114, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_5_0_115 = textureCoords_5_0.elementAt(115);
      expect(textureCoord_5_0_115, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_5_0_116 = textureCoords_5_0.elementAt(116);
      expect(textureCoord_5_0_116, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_5_0_117 = textureCoords_5_0.elementAt(117);
      expect(textureCoord_5_0_117, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_5_0_118 = textureCoords_5_0.elementAt(118);
      expect(textureCoord_5_0_118, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_5_0_119 = textureCoords_5_0.elementAt(119);
      expect(textureCoord_5_0_119, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_5_0_120 = textureCoords_5_0.elementAt(120);
      expect(textureCoord_5_0_120, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_5_0_121 = textureCoords_5_0.elementAt(121);
      expect(textureCoord_5_0_121, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_5_0_122 = textureCoords_5_0.elementAt(122);
      expect(textureCoord_5_0_122, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_5_0_123 = textureCoords_5_0.elementAt(123);
      expect(textureCoord_5_0_123, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_5_0_124 = textureCoords_5_0.elementAt(124);
      expect(textureCoord_5_0_124, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_5_0_125 = textureCoords_5_0.elementAt(125);
      expect(textureCoord_5_0_125, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_5_0_126 = textureCoords_5_0.elementAt(126);
      expect(textureCoord_5_0_126, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_127 = textureCoords_5_0.elementAt(127);
      expect(textureCoord_5_0_127, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_128 = textureCoords_5_0.elementAt(128);
      expect(textureCoord_5_0_128, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_129 = textureCoords_5_0.elementAt(129);
      expect(textureCoord_5_0_129, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_130 = textureCoords_5_0.elementAt(130);
      expect(textureCoord_5_0_130, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_131 = textureCoords_5_0.elementAt(131);
      expect(textureCoord_5_0_131, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_132 = textureCoords_5_0.elementAt(132);
      expect(textureCoord_5_0_132, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_5_0_133 = textureCoords_5_0.elementAt(133);
      expect(textureCoord_5_0_133, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_5_0_134 = textureCoords_5_0.elementAt(134);
      expect(textureCoord_5_0_134, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_5_0_135 = textureCoords_5_0.elementAt(135);
      expect(textureCoord_5_0_135, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_5_0_136 = textureCoords_5_0.elementAt(136);
      expect(textureCoord_5_0_136, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_5_0_137 = textureCoords_5_0.elementAt(137);
      expect(textureCoord_5_0_137, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_5_0_138 = textureCoords_5_0.elementAt(138);
      expect(textureCoord_5_0_138, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_5_0_139 = textureCoords_5_0.elementAt(139);
      expect(textureCoord_5_0_139, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_5_0_140 = textureCoords_5_0.elementAt(140);
      expect(textureCoord_5_0_140, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_5_0_141 = textureCoords_5_0.elementAt(141);
      expect(textureCoord_5_0_141, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_5_0_142 = textureCoords_5_0.elementAt(142);
      expect(textureCoord_5_0_142, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_5_0_143 = textureCoords_5_0.elementAt(143);
      expect(textureCoord_5_0_143, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_5_0_144 = textureCoords_5_0.elementAt(144);
      expect(textureCoord_5_0_144, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_5_0_145 = textureCoords_5_0.elementAt(145);
      expect(textureCoord_5_0_145, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_5_0_146 = textureCoords_5_0.elementAt(146);
      expect(textureCoord_5_0_146, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_5_0_147 = textureCoords_5_0.elementAt(147);
      expect(textureCoord_5_0_147, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_5_0_148 = textureCoords_5_0.elementAt(148);
      expect(textureCoord_5_0_148, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_5_0_149 = textureCoords_5_0.elementAt(149);
      expect(textureCoord_5_0_149, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_5_0_150 = textureCoords_5_0.elementAt(150);
      expect(textureCoord_5_0_150, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_5_0_151 = textureCoords_5_0.elementAt(151);
      expect(textureCoord_5_0_151, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_5_0_152 = textureCoords_5_0.elementAt(152);
      expect(textureCoord_5_0_152, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_5_0_153 = textureCoords_5_0.elementAt(153);
      expect(textureCoord_5_0_153, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_5_0_154 = textureCoords_5_0.elementAt(154);
      expect(textureCoord_5_0_154, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_5_0_155 = textureCoords_5_0.elementAt(155);
      expect(textureCoord_5_0_155, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_5_0_156 = textureCoords_5_0.elementAt(156);
      expect(textureCoord_5_0_156, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_5_0_157 = textureCoords_5_0.elementAt(157);
      expect(textureCoord_5_0_157, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_5_0_158 = textureCoords_5_0.elementAt(158);
      expect(textureCoord_5_0_158, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_5_0_159 = textureCoords_5_0.elementAt(159);
      expect(textureCoord_5_0_159, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_5_0_160 = textureCoords_5_0.elementAt(160);
      expect(textureCoord_5_0_160, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_5_0_161 = textureCoords_5_0.elementAt(161);
      expect(textureCoord_5_0_161, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_5_0_162 = textureCoords_5_0.elementAt(162);
      expect(textureCoord_5_0_162, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_5_0_163 = textureCoords_5_0.elementAt(163);
      expect(textureCoord_5_0_163, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_5_0_164 = textureCoords_5_0.elementAt(164);
      expect(textureCoord_5_0_164, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_5_0_165 = textureCoords_5_0.elementAt(165);
      expect(textureCoord_5_0_165, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_5_0_166 = textureCoords_5_0.elementAt(166);
      expect(textureCoord_5_0_166, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_5_0_167 = textureCoords_5_0.elementAt(167);
      expect(textureCoord_5_0_167, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_5_0_168 = textureCoords_5_0.elementAt(168);
      expect(textureCoord_5_0_168, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_169 = textureCoords_5_0.elementAt(169);
      expect(textureCoord_5_0_169, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_170 = textureCoords_5_0.elementAt(170);
      expect(textureCoord_5_0_170, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_171 = textureCoords_5_0.elementAt(171);
      expect(textureCoord_5_0_171, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_172 = textureCoords_5_0.elementAt(172);
      expect(textureCoord_5_0_172, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_173 = textureCoords_5_0.elementAt(173);
      expect(textureCoord_5_0_173, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_174 = textureCoords_5_0.elementAt(174);
      expect(textureCoord_5_0_174, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_5_0_175 = textureCoords_5_0.elementAt(175);
      expect(textureCoord_5_0_175, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_5_0_176 = textureCoords_5_0.elementAt(176);
      expect(textureCoord_5_0_176, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_5_0_177 = textureCoords_5_0.elementAt(177);
      expect(textureCoord_5_0_177, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_5_0_178 = textureCoords_5_0.elementAt(178);
      expect(textureCoord_5_0_178, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_5_0_179 = textureCoords_5_0.elementAt(179);
      expect(textureCoord_5_0_179, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_5_0_180 = textureCoords_5_0.elementAt(180);
      expect(textureCoord_5_0_180, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_5_0_181 = textureCoords_5_0.elementAt(181);
      expect(textureCoord_5_0_181, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_5_0_182 = textureCoords_5_0.elementAt(182);
      expect(textureCoord_5_0_182, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_5_0_183 = textureCoords_5_0.elementAt(183);
      expect(textureCoord_5_0_183, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_5_0_184 = textureCoords_5_0.elementAt(184);
      expect(textureCoord_5_0_184, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_5_0_185 = textureCoords_5_0.elementAt(185);
      expect(textureCoord_5_0_185, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_5_0_186 = textureCoords_5_0.elementAt(186);
      expect(textureCoord_5_0_186, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_5_0_187 = textureCoords_5_0.elementAt(187);
      expect(textureCoord_5_0_187, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_5_0_188 = textureCoords_5_0.elementAt(188);
      expect(textureCoord_5_0_188, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_5_0_189 = textureCoords_5_0.elementAt(189);
      expect(textureCoord_5_0_189, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_5_0_190 = textureCoords_5_0.elementAt(190);
      expect(textureCoord_5_0_190, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_5_0_191 = textureCoords_5_0.elementAt(191);
      expect(textureCoord_5_0_191, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_5_0_192 = textureCoords_5_0.elementAt(192);
      expect(textureCoord_5_0_192, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_5_0_193 = textureCoords_5_0.elementAt(193);
      expect(textureCoord_5_0_193, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_5_0_194 = textureCoords_5_0.elementAt(194);
      expect(textureCoord_5_0_194, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_5_0_195 = textureCoords_5_0.elementAt(195);
      expect(textureCoord_5_0_195, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_5_0_196 = textureCoords_5_0.elementAt(196);
      expect(textureCoord_5_0_196, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_5_0_197 = textureCoords_5_0.elementAt(197);
      expect(textureCoord_5_0_197, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_5_0_198 = textureCoords_5_0.elementAt(198);
      expect(textureCoord_5_0_198, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_5_0_199 = textureCoords_5_0.elementAt(199);
      expect(textureCoord_5_0_199, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_5_0_200 = textureCoords_5_0.elementAt(200);
      expect(textureCoord_5_0_200, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_5_0_201 = textureCoords_5_0.elementAt(201);
      expect(textureCoord_5_0_201, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_5_0_202 = textureCoords_5_0.elementAt(202);
      expect(textureCoord_5_0_202, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_5_0_203 = textureCoords_5_0.elementAt(203);
      expect(textureCoord_5_0_203, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_5_0_204 = textureCoords_5_0.elementAt(204);
      expect(textureCoord_5_0_204, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_5_0_205 = textureCoords_5_0.elementAt(205);
      expect(textureCoord_5_0_205, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_5_0_206 = textureCoords_5_0.elementAt(206);
      expect(textureCoord_5_0_206, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_5_0_207 = textureCoords_5_0.elementAt(207);
      expect(textureCoord_5_0_207, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_5_0_208 = textureCoords_5_0.elementAt(208);
      expect(textureCoord_5_0_208, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_5_0_209 = textureCoords_5_0.elementAt(209);
      expect(textureCoord_5_0_209, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_5_0_210 = textureCoords_5_0.elementAt(210);
      expect(textureCoord_5_0_210, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_211 = textureCoords_5_0.elementAt(211);
      expect(textureCoord_5_0_211, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_212 = textureCoords_5_0.elementAt(212);
      expect(textureCoord_5_0_212, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_213 = textureCoords_5_0.elementAt(213);
      expect(textureCoord_5_0_213, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_214 = textureCoords_5_0.elementAt(214);
      expect(textureCoord_5_0_214, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_215 = textureCoords_5_0.elementAt(215);
      expect(textureCoord_5_0_215, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_216 = textureCoords_5_0.elementAt(216);
      expect(textureCoord_5_0_216, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_5_0_217 = textureCoords_5_0.elementAt(217);
      expect(textureCoord_5_0_217, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_5_0_218 = textureCoords_5_0.elementAt(218);
      expect(textureCoord_5_0_218, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_5_0_219 = textureCoords_5_0.elementAt(219);
      expect(textureCoord_5_0_219, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_5_0_220 = textureCoords_5_0.elementAt(220);
      expect(textureCoord_5_0_220, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_5_0_221 = textureCoords_5_0.elementAt(221);
      expect(textureCoord_5_0_221, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_5_0_222 = textureCoords_5_0.elementAt(222);
      expect(textureCoord_5_0_222, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_5_0_223 = textureCoords_5_0.elementAt(223);
      expect(textureCoord_5_0_223, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_5_0_224 = textureCoords_5_0.elementAt(224);
      expect(textureCoord_5_0_224, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_5_0_225 = textureCoords_5_0.elementAt(225);
      expect(textureCoord_5_0_225, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_5_0_226 = textureCoords_5_0.elementAt(226);
      expect(textureCoord_5_0_226, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_5_0_227 = textureCoords_5_0.elementAt(227);
      expect(textureCoord_5_0_227, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_5_0_228 = textureCoords_5_0.elementAt(228);
      expect(textureCoord_5_0_228, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_5_0_229 = textureCoords_5_0.elementAt(229);
      expect(textureCoord_5_0_229, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_5_0_230 = textureCoords_5_0.elementAt(230);
      expect(textureCoord_5_0_230, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_5_0_231 = textureCoords_5_0.elementAt(231);
      expect(textureCoord_5_0_231, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_5_0_232 = textureCoords_5_0.elementAt(232);
      expect(textureCoord_5_0_232, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_5_0_233 = textureCoords_5_0.elementAt(233);
      expect(textureCoord_5_0_233, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_5_0_234 = textureCoords_5_0.elementAt(234);
      expect(textureCoord_5_0_234, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_5_0_235 = textureCoords_5_0.elementAt(235);
      expect(textureCoord_5_0_235, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_5_0_236 = textureCoords_5_0.elementAt(236);
      expect(textureCoord_5_0_236, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_5_0_237 = textureCoords_5_0.elementAt(237);
      expect(textureCoord_5_0_237, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_5_0_238 = textureCoords_5_0.elementAt(238);
      expect(textureCoord_5_0_238, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_5_0_239 = textureCoords_5_0.elementAt(239);
      expect(textureCoord_5_0_239, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_5_0_240 = textureCoords_5_0.elementAt(240);
      expect(textureCoord_5_0_240, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_5_0_241 = textureCoords_5_0.elementAt(241);
      expect(textureCoord_5_0_241, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_5_0_242 = textureCoords_5_0.elementAt(242);
      expect(textureCoord_5_0_242, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_5_0_243 = textureCoords_5_0.elementAt(243);
      expect(textureCoord_5_0_243, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_5_0_244 = textureCoords_5_0.elementAt(244);
      expect(textureCoord_5_0_244, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_5_0_245 = textureCoords_5_0.elementAt(245);
      expect(textureCoord_5_0_245, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_5_0_246 = textureCoords_5_0.elementAt(246);
      expect(textureCoord_5_0_246, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_5_0_247 = textureCoords_5_0.elementAt(247);
      expect(textureCoord_5_0_247, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_5_0_248 = textureCoords_5_0.elementAt(248);
      expect(textureCoord_5_0_248, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_5_0_249 = textureCoords_5_0.elementAt(249);
      expect(textureCoord_5_0_249, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_5_0_250 = textureCoords_5_0.elementAt(250);
      expect(textureCoord_5_0_250, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_5_0_251 = textureCoords_5_0.elementAt(251);
      expect(textureCoord_5_0_251, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_5_0_252 = textureCoords_5_0.elementAt(252);
      expect(textureCoord_5_0_252, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_253 = textureCoords_5_0.elementAt(253);
      expect(textureCoord_5_0_253, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_254 = textureCoords_5_0.elementAt(254);
      expect(textureCoord_5_0_254, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_255 = textureCoords_5_0.elementAt(255);
      expect(textureCoord_5_0_255, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_256 = textureCoords_5_0.elementAt(256);
      expect(textureCoord_5_0_256, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_257 = textureCoords_5_0.elementAt(257);
      expect(textureCoord_5_0_257, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_5_0_258 = textureCoords_5_0.elementAt(258);
      expect(textureCoord_5_0_258, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_5_0_259 = textureCoords_5_0.elementAt(259);
      expect(textureCoord_5_0_259, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_5_0_260 = textureCoords_5_0.elementAt(260);
      expect(textureCoord_5_0_260, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_5_0_261 = textureCoords_5_0.elementAt(261);
      expect(textureCoord_5_0_261, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_5_0_262 = textureCoords_5_0.elementAt(262);
      expect(textureCoord_5_0_262, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_5_0_263 = textureCoords_5_0.elementAt(263);
      expect(textureCoord_5_0_263, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_5_0_264 = textureCoords_5_0.elementAt(264);
      expect(textureCoord_5_0_264, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_5_0_265 = textureCoords_5_0.elementAt(265);
      expect(textureCoord_5_0_265, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_5_0_266 = textureCoords_5_0.elementAt(266);
      expect(textureCoord_5_0_266, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_5_0_267 = textureCoords_5_0.elementAt(267);
      expect(textureCoord_5_0_267, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_5_0_268 = textureCoords_5_0.elementAt(268);
      expect(textureCoord_5_0_268, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_5_0_269 = textureCoords_5_0.elementAt(269);
      expect(textureCoord_5_0_269, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_5_0_270 = textureCoords_5_0.elementAt(270);
      expect(textureCoord_5_0_270, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_5_0_271 = textureCoords_5_0.elementAt(271);
      expect(textureCoord_5_0_271, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_5_0_272 = textureCoords_5_0.elementAt(272);
      expect(textureCoord_5_0_272, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_5_0_273 = textureCoords_5_0.elementAt(273);
      expect(textureCoord_5_0_273, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_5_0_274 = textureCoords_5_0.elementAt(274);
      expect(textureCoord_5_0_274, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_5_0_275 = textureCoords_5_0.elementAt(275);
      expect(textureCoord_5_0_275, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_5_0_276 = textureCoords_5_0.elementAt(276);
      expect(textureCoord_5_0_276, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_5_0_277 = textureCoords_5_0.elementAt(277);
      expect(textureCoord_5_0_277, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_5_0_278 = textureCoords_5_0.elementAt(278);
      expect(textureCoord_5_0_278, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_5_0_279 = textureCoords_5_0.elementAt(279);
      expect(textureCoord_5_0_279, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_5_0_280 = textureCoords_5_0.elementAt(280);
      expect(textureCoord_5_0_280, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_5_0_281 = textureCoords_5_0.elementAt(281);
      expect(textureCoord_5_0_281, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_5_0_282 = textureCoords_5_0.elementAt(282);
      expect(textureCoord_5_0_282, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_5_0_283 = textureCoords_5_0.elementAt(283);
      expect(textureCoord_5_0_283, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_5_0_284 = textureCoords_5_0.elementAt(284);
      expect(textureCoord_5_0_284, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_5_0_285 = textureCoords_5_0.elementAt(285);
      expect(textureCoord_5_0_285, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_5_0_286 = textureCoords_5_0.elementAt(286);
      expect(textureCoord_5_0_286, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_5_0_287 = textureCoords_5_0.elementAt(287);
      expect(textureCoord_5_0_287, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_5_0_288 = textureCoords_5_0.elementAt(288);
      expect(textureCoord_5_0_288, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_5_0_289 = textureCoords_5_0.elementAt(289);
      expect(textureCoord_5_0_289, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_5_0_290 = textureCoords_5_0.elementAt(290);
      expect(textureCoord_5_0_290, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_5_0_291 = textureCoords_5_0.elementAt(291);
      expect(textureCoord_5_0_291, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_5_0_292 = textureCoords_5_0.elementAt(292);
      expect(textureCoord_5_0_292, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_5_0_293 = textureCoords_5_0.elementAt(293);
      expect(textureCoord_5_0_293, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      expect(mesh_5.uvComponents.length, equals(1));
      expect(mesh_5.uvComponents, equals([2]));
      expect(mesh_5.faces.length, equals(98));
      expect(mesh_5.bones.length, isZero);
      expect(mesh_5.materialIndex, equals(4));
      expect(mesh_5.name, equals('Bein2Re'));
      expect(mesh_5.animMeshes.length, isZero);
      expect(mesh_5.morphingMethod, isZero);
      expect(mesh_5.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_6 = meshes.elementAt(6);
      expect(mesh_6.primitiveTypes, equals(4));
      expect(mesh_6.vertices.length, equals(294));
      final vertex_6_0 = mesh_6.vertices.elementAt(0);
      expect(vertex_6_0, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_1 = mesh_6.vertices.elementAt(1);
      expect(vertex_6_1, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -5.88753)));
      final vertex_6_2 = mesh_6.vertices.elementAt(2);
      expect(vertex_6_2, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -4.81347)));
      final vertex_6_3 = mesh_6.vertices.elementAt(3);
      expect(vertex_6_3, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, 86.5102)));
      final vertex_6_4 = mesh_6.vertices.elementAt(4);
      expect(vertex_6_4, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_5 = mesh_6.vertices.elementAt(5);
      expect(vertex_6_5, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, 86.1982)));
      final vertex_6_6 = mesh_6.vertices.elementAt(6);
      expect(vertex_6_6, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, 11.176)));
      final vertex_6_7 = mesh_6.vertices.elementAt(7);
      expect(vertex_6_7, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, 12.4635)));
      final vertex_6_8 = mesh_6.vertices.elementAt(8);
      expect(vertex_6_8, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -4.81347)));
      final vertex_6_9 = mesh_6.vertices.elementAt(9);
      expect(vertex_6_9, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -5.88753)));
      final vertex_6_10 = mesh_6.vertices.elementAt(10);
      expect(vertex_6_10, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, 11.176)));
      final vertex_6_11 = mesh_6.vertices.elementAt(11);
      expect(vertex_6_11, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -4.81347)));
      final vertex_6_12 = mesh_6.vertices.elementAt(12);
      expect(vertex_6_12, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, 11.176)));
      final vertex_6_13 = mesh_6.vertices.elementAt(13);
      expect(vertex_6_13, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, 26.4104)));
      final vertex_6_14 = mesh_6.vertices.elementAt(14);
      expect(vertex_6_14, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, 12.4635)));
      final vertex_6_15 = mesh_6.vertices.elementAt(15);
      expect(vertex_6_15, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, 11.176)));
      final vertex_6_16 = mesh_6.vertices.elementAt(16);
      expect(vertex_6_16, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, 26.2119)));
      final vertex_6_17 = mesh_6.vertices.elementAt(17);
      expect(vertex_6_17, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, 26.4104)));
      final vertex_6_18 = mesh_6.vertices.elementAt(18);
      expect(vertex_6_18, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, 30.9928)));
      final vertex_6_19 = mesh_6.vertices.elementAt(19);
      expect(vertex_6_19, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, 29.5956)));
      final vertex_6_20 = mesh_6.vertices.elementAt(20);
      expect(vertex_6_20, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, 26.4104)));
      final vertex_6_21 = mesh_6.vertices.elementAt(21);
      expect(vertex_6_21, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, 26.2119)));
      final vertex_6_22 = mesh_6.vertices.elementAt(22);
      expect(vertex_6_22, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, 30.9928)));
      final vertex_6_23 = mesh_6.vertices.elementAt(23);
      expect(vertex_6_23, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, 26.4104)));
      final vertex_6_24 = mesh_6.vertices.elementAt(24);
      expect(vertex_6_24, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, 30.9928)));
      final vertex_6_25 = mesh_6.vertices.elementAt(25);
      expect(vertex_6_25, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, 54.8821)));
      final vertex_6_26 = mesh_6.vertices.elementAt(26);
      expect(vertex_6_26, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, 29.5956)));
      final vertex_6_27 = mesh_6.vertices.elementAt(27);
      expect(vertex_6_27, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, 30.9928)));
      final vertex_6_28 = mesh_6.vertices.elementAt(28);
      expect(vertex_6_28, vector3MoreOrLessEquals(Vector3(-1.5147, 14.1058, 57.0357)));
      final vertex_6_29 = mesh_6.vertices.elementAt(29);
      expect(vertex_6_29, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, 54.8821)));
      final vertex_6_30 = mesh_6.vertices.elementAt(30);
      expect(vertex_6_30, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, 80.768)));
      final vertex_6_31 = mesh_6.vertices.elementAt(31);
      expect(vertex_6_31, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, 79.7065)));
      final vertex_6_32 = mesh_6.vertices.elementAt(32);
      expect(vertex_6_32, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, 54.8821)));
      final vertex_6_33 = mesh_6.vertices.elementAt(33);
      expect(vertex_6_33, vector3MoreOrLessEquals(Vector3(-1.5147, 14.1058, 57.0357)));
      final vertex_6_34 = mesh_6.vertices.elementAt(34);
      expect(vertex_6_34, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, 80.768)));
      final vertex_6_35 = mesh_6.vertices.elementAt(35);
      expect(vertex_6_35, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, 54.8821)));
      final vertex_6_36 = mesh_6.vertices.elementAt(36);
      expect(vertex_6_36, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, 80.768)));
      final vertex_6_37 = mesh_6.vertices.elementAt(37);
      expect(vertex_6_37, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, 86.1982)));
      final vertex_6_38 = mesh_6.vertices.elementAt(38);
      expect(vertex_6_38, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, 79.7065)));
      final vertex_6_39 = mesh_6.vertices.elementAt(39);
      expect(vertex_6_39, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, 80.768)));
      final vertex_6_40 = mesh_6.vertices.elementAt(40);
      expect(vertex_6_40, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, 86.5102)));
      final vertex_6_41 = mesh_6.vertices.elementAt(41);
      expect(vertex_6_41, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, 86.1982)));
      final vertex_6_42 = mesh_6.vertices.elementAt(42);
      expect(vertex_6_42, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_43 = mesh_6.vertices.elementAt(43);
      expect(vertex_6_43, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -4.14655)));
      final vertex_6_44 = mesh_6.vertices.elementAt(44);
      expect(vertex_6_44, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -5.88753)));
      final vertex_6_45 = mesh_6.vertices.elementAt(45);
      expect(vertex_6_45, vector3MoreOrLessEquals(Vector3(4.58777, -39.3502, 86.6912)));
      final vertex_6_46 = mesh_6.vertices.elementAt(46);
      expect(vertex_6_46, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_47 = mesh_6.vertices.elementAt(47);
      expect(vertex_6_47, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, 86.5102)));
      final vertex_6_48 = mesh_6.vertices.elementAt(48);
      expect(vertex_6_48, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -4.14655)));
      final vertex_6_49 = mesh_6.vertices.elementAt(49);
      expect(vertex_6_49, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, 11.176)));
      final vertex_6_50 = mesh_6.vertices.elementAt(50);
      expect(vertex_6_50, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -5.88753)));
      final vertex_6_51 = mesh_6.vertices.elementAt(51);
      expect(vertex_6_51, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -4.14655)));
      final vertex_6_52 = mesh_6.vertices.elementAt(52);
      expect(vertex_6_52, vector3MoreOrLessEquals(Vector3(-18.5514, 8.96432, 11.3467)));
      final vertex_6_53 = mesh_6.vertices.elementAt(53);
      expect(vertex_6_53, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, 11.176)));
      final vertex_6_54 = mesh_6.vertices.elementAt(54);
      expect(vertex_6_54, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, 26.4584)));
      final vertex_6_55 = mesh_6.vertices.elementAt(55);
      expect(vertex_6_55, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, 26.2119)));
      final vertex_6_56 = mesh_6.vertices.elementAt(56);
      expect(vertex_6_56, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, 11.176)));
      final vertex_6_57 = mesh_6.vertices.elementAt(57);
      expect(vertex_6_57, vector3MoreOrLessEquals(Vector3(-18.5514, 8.96432, 11.3467)));
      final vertex_6_58 = mesh_6.vertices.elementAt(58);
      expect(vertex_6_58, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, 26.4584)));
      final vertex_6_59 = mesh_6.vertices.elementAt(59);
      expect(vertex_6_59, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, 11.176)));
      final vertex_6_60 = mesh_6.vertices.elementAt(60);
      expect(vertex_6_60, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, 26.4584)));
      final vertex_6_61 = mesh_6.vertices.elementAt(61);
      expect(vertex_6_61, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, 30.9928)));
      final vertex_6_62 = mesh_6.vertices.elementAt(62);
      expect(vertex_6_62, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, 26.2119)));
      final vertex_6_63 = mesh_6.vertices.elementAt(63);
      expect(vertex_6_63, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, 26.4584)));
      final vertex_6_64 = mesh_6.vertices.elementAt(64);
      expect(vertex_6_64, vector3MoreOrLessEquals(Vector3(-13.3946, 29.5602, 31.8266)));
      final vertex_6_65 = mesh_6.vertices.elementAt(65);
      expect(vertex_6_65, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, 30.9928)));
      final vertex_6_66 = mesh_6.vertices.elementAt(66);
      expect(vertex_6_66, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, 58.0563)));
      final vertex_6_67 = mesh_6.vertices.elementAt(67);
      expect(vertex_6_67, vector3MoreOrLessEquals(Vector3(-1.5147, 14.1058, 57.0357)));
      final vertex_6_68 = mesh_6.vertices.elementAt(68);
      expect(vertex_6_68, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, 30.9928)));
      final vertex_6_69 = mesh_6.vertices.elementAt(69);
      expect(vertex_6_69, vector3MoreOrLessEquals(Vector3(-13.3946, 29.5602, 31.8266)));
      final vertex_6_70 = mesh_6.vertices.elementAt(70);
      expect(vertex_6_70, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, 58.0563)));
      final vertex_6_71 = mesh_6.vertices.elementAt(71);
      expect(vertex_6_71, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, 30.9928)));
      final vertex_6_72 = mesh_6.vertices.elementAt(72);
      expect(vertex_6_72, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, 58.0563)));
      final vertex_6_73 = mesh_6.vertices.elementAt(73);
      expect(vertex_6_73, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, 80.768)));
      final vertex_6_74 = mesh_6.vertices.elementAt(74);
      expect(vertex_6_74, vector3MoreOrLessEquals(Vector3(-1.5147, 14.1058, 57.0357)));
      final vertex_6_75 = mesh_6.vertices.elementAt(75);
      expect(vertex_6_75, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, 58.0563)));
      final vertex_6_76 = mesh_6.vertices.elementAt(76);
      expect(vertex_6_76, vector3MoreOrLessEquals(Vector3(2.445, -29.5186, 81.251)));
      final vertex_6_77 = mesh_6.vertices.elementAt(77);
      expect(vertex_6_77, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, 80.768)));
      final vertex_6_78 = mesh_6.vertices.elementAt(78);
      expect(vertex_6_78, vector3MoreOrLessEquals(Vector3(4.58777, -39.3502, 86.6912)));
      final vertex_6_79 = mesh_6.vertices.elementAt(79);
      expect(vertex_6_79, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, 86.5102)));
      final vertex_6_80 = mesh_6.vertices.elementAt(80);
      expect(vertex_6_80, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, 80.768)));
      final vertex_6_81 = mesh_6.vertices.elementAt(81);
      expect(vertex_6_81, vector3MoreOrLessEquals(Vector3(2.445, -29.5186, 81.251)));
      final vertex_6_82 = mesh_6.vertices.elementAt(82);
      expect(vertex_6_82, vector3MoreOrLessEquals(Vector3(4.58777, -39.3502, 86.6912)));
      final vertex_6_83 = mesh_6.vertices.elementAt(83);
      expect(vertex_6_83, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, 80.768)));
      final vertex_6_84 = mesh_6.vertices.elementAt(84);
      expect(vertex_6_84, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_85 = mesh_6.vertices.elementAt(85);
      expect(vertex_6_85, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -0.901443)));
      final vertex_6_86 = mesh_6.vertices.elementAt(86);
      expect(vertex_6_86, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -4.14655)));
      final vertex_6_87 = mesh_6.vertices.elementAt(87);
      expect(vertex_6_87, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, 86.6049)));
      final vertex_6_88 = mesh_6.vertices.elementAt(88);
      expect(vertex_6_88, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_89 = mesh_6.vertices.elementAt(89);
      expect(vertex_6_89, vector3MoreOrLessEquals(Vector3(4.58777, -39.3502, 86.6912)));
      final vertex_6_90 = mesh_6.vertices.elementAt(90);
      expect(vertex_6_90, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, 12.847)));
      final vertex_6_91 = mesh_6.vertices.elementAt(91);
      expect(vertex_6_91, vector3MoreOrLessEquals(Vector3(-18.5514, 8.96432, 11.3467)));
      final vertex_6_92 = mesh_6.vertices.elementAt(92);
      expect(vertex_6_92, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -4.14655)));
      final vertex_6_93 = mesh_6.vertices.elementAt(93);
      expect(vertex_6_93, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -0.901443)));
      final vertex_6_94 = mesh_6.vertices.elementAt(94);
      expect(vertex_6_94, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, 12.847)));
      final vertex_6_95 = mesh_6.vertices.elementAt(95);
      expect(vertex_6_95, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -4.14655)));
      final vertex_6_96 = mesh_6.vertices.elementAt(96);
      expect(vertex_6_96, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, 12.847)));
      final vertex_6_97 = mesh_6.vertices.elementAt(97);
      expect(vertex_6_97, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, 26.4584)));
      final vertex_6_98 = mesh_6.vertices.elementAt(98);
      expect(vertex_6_98, vector3MoreOrLessEquals(Vector3(-18.5514, 8.96432, 11.3467)));
      final vertex_6_99 = mesh_6.vertices.elementAt(99);
      expect(vertex_6_99, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, 12.847)));
      final vertex_6_100 = mesh_6.vertices.elementAt(100);
      expect(vertex_6_100, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, 26.9645)));
      final vertex_6_101 = mesh_6.vertices.elementAt(101);
      expect(vertex_6_101, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, 26.4584)));
      final vertex_6_102 = mesh_6.vertices.elementAt(102);
      expect(vertex_6_102, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, 31.4691)));
      final vertex_6_103 = mesh_6.vertices.elementAt(103);
      expect(vertex_6_103, vector3MoreOrLessEquals(Vector3(-13.3946, 29.5602, 31.8266)));
      final vertex_6_104 = mesh_6.vertices.elementAt(104);
      expect(vertex_6_104, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, 26.4584)));
      final vertex_6_105 = mesh_6.vertices.elementAt(105);
      expect(vertex_6_105, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, 26.9645)));
      final vertex_6_106 = mesh_6.vertices.elementAt(106);
      expect(vertex_6_106, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, 31.4691)));
      final vertex_6_107 = mesh_6.vertices.elementAt(107);
      expect(vertex_6_107, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, 26.4584)));
      final vertex_6_108 = mesh_6.vertices.elementAt(108);
      expect(vertex_6_108, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, 31.4691)));
      final vertex_6_109 = mesh_6.vertices.elementAt(109);
      expect(vertex_6_109, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, 58.0563)));
      final vertex_6_110 = mesh_6.vertices.elementAt(110);
      expect(vertex_6_110, vector3MoreOrLessEquals(Vector3(-13.3946, 29.5602, 31.8266)));
      final vertex_6_111 = mesh_6.vertices.elementAt(111);
      expect(vertex_6_111, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, 31.4691)));
      final vertex_6_112 = mesh_6.vertices.elementAt(112);
      expect(vertex_6_112, vector3MoreOrLessEquals(Vector3(-5.65842, 13.6618, 57.1753)));
      final vertex_6_113 = mesh_6.vertices.elementAt(113);
      expect(vertex_6_113, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, 58.0563)));
      final vertex_6_114 = mesh_6.vertices.elementAt(114);
      expect(vertex_6_114, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, 80.7919)));
      final vertex_6_115 = mesh_6.vertices.elementAt(115);
      expect(vertex_6_115, vector3MoreOrLessEquals(Vector3(2.445, -29.5186, 81.251)));
      final vertex_6_116 = mesh_6.vertices.elementAt(116);
      expect(vertex_6_116, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, 58.0563)));
      final vertex_6_117 = mesh_6.vertices.elementAt(117);
      expect(vertex_6_117, vector3MoreOrLessEquals(Vector3(-5.65842, 13.6618, 57.1753)));
      final vertex_6_118 = mesh_6.vertices.elementAt(118);
      expect(vertex_6_118, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, 80.7919)));
      final vertex_6_119 = mesh_6.vertices.elementAt(119);
      expect(vertex_6_119, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, 58.0563)));
      final vertex_6_120 = mesh_6.vertices.elementAt(120);
      expect(vertex_6_120, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, 80.7919)));
      final vertex_6_121 = mesh_6.vertices.elementAt(121);
      expect(vertex_6_121, vector3MoreOrLessEquals(Vector3(4.58777, -39.3502, 86.6912)));
      final vertex_6_122 = mesh_6.vertices.elementAt(122);
      expect(vertex_6_122, vector3MoreOrLessEquals(Vector3(2.445, -29.5186, 81.251)));
      final vertex_6_123 = mesh_6.vertices.elementAt(123);
      expect(vertex_6_123, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, 80.7919)));
      final vertex_6_124 = mesh_6.vertices.elementAt(124);
      expect(vertex_6_124, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, 86.6049)));
      final vertex_6_125 = mesh_6.vertices.elementAt(125);
      expect(vertex_6_125, vector3MoreOrLessEquals(Vector3(4.58777, -39.3502, 86.6912)));
      final vertex_6_126 = mesh_6.vertices.elementAt(126);
      expect(vertex_6_126, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_127 = mesh_6.vertices.elementAt(127);
      expect(vertex_6_127, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, 1.40408)));
      final vertex_6_128 = mesh_6.vertices.elementAt(128);
      expect(vertex_6_128, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -0.901443)));
      final vertex_6_129 = mesh_6.vertices.elementAt(129);
      expect(vertex_6_129, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, 86.3163)));
      final vertex_6_130 = mesh_6.vertices.elementAt(130);
      expect(vertex_6_130, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_131 = mesh_6.vertices.elementAt(131);
      expect(vertex_6_131, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, 86.6049)));
      final vertex_6_132 = mesh_6.vertices.elementAt(132);
      expect(vertex_6_132, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, 1.40408)));
      final vertex_6_133 = mesh_6.vertices.elementAt(133);
      expect(vertex_6_133, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, 12.847)));
      final vertex_6_134 = mesh_6.vertices.elementAt(134);
      expect(vertex_6_134, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -0.901443)));
      final vertex_6_135 = mesh_6.vertices.elementAt(135);
      expect(vertex_6_135, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, 1.40408)));
      final vertex_6_136 = mesh_6.vertices.elementAt(136);
      expect(vertex_6_136, vector3MoreOrLessEquals(Vector3(-19.5314, 6.4777, 14.5472)));
      final vertex_6_137 = mesh_6.vertices.elementAt(137);
      expect(vertex_6_137, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, 12.847)));
      final vertex_6_138 = mesh_6.vertices.elementAt(138);
      expect(vertex_6_138, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_139 = mesh_6.vertices.elementAt(139);
      expect(vertex_6_139, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, 26.9645)));
      final vertex_6_140 = mesh_6.vertices.elementAt(140);
      expect(vertex_6_140, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, 12.847)));
      final vertex_6_141 = mesh_6.vertices.elementAt(141);
      expect(vertex_6_141, vector3MoreOrLessEquals(Vector3(-19.5314, 6.4777, 14.5472)));
      final vertex_6_142 = mesh_6.vertices.elementAt(142);
      expect(vertex_6_142, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_143 = mesh_6.vertices.elementAt(143);
      expect(vertex_6_143, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, 12.847)));
      final vertex_6_144 = mesh_6.vertices.elementAt(144);
      expect(vertex_6_144, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_145 = mesh_6.vertices.elementAt(145);
      expect(vertex_6_145, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, 31.4691)));
      final vertex_6_146 = mesh_6.vertices.elementAt(146);
      expect(vertex_6_146, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, 26.9645)));
      final vertex_6_147 = mesh_6.vertices.elementAt(147);
      expect(vertex_6_147, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_148 = mesh_6.vertices.elementAt(148);
      expect(vertex_6_148, vector3MoreOrLessEquals(Vector3(-15.5666, 26.3996, 30.1895)));
      final vertex_6_149 = mesh_6.vertices.elementAt(149);
      expect(vertex_6_149, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, 31.4691)));
      final vertex_6_150 = mesh_6.vertices.elementAt(150);
      expect(vertex_6_150, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, 55.0563)));
      final vertex_6_151 = mesh_6.vertices.elementAt(151);
      expect(vertex_6_151, vector3MoreOrLessEquals(Vector3(-5.65842, 13.6618, 57.1753)));
      final vertex_6_152 = mesh_6.vertices.elementAt(152);
      expect(vertex_6_152, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, 31.4691)));
      final vertex_6_153 = mesh_6.vertices.elementAt(153);
      expect(vertex_6_153, vector3MoreOrLessEquals(Vector3(-15.5666, 26.3996, 30.1895)));
      final vertex_6_154 = mesh_6.vertices.elementAt(154);
      expect(vertex_6_154, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, 55.0563)));
      final vertex_6_155 = mesh_6.vertices.elementAt(155);
      expect(vertex_6_155, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, 31.4691)));
      final vertex_6_156 = mesh_6.vertices.elementAt(156);
      expect(vertex_6_156, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, 55.0563)));
      final vertex_6_157 = mesh_6.vertices.elementAt(157);
      expect(vertex_6_157, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, 80.7919)));
      final vertex_6_158 = mesh_6.vertices.elementAt(158);
      expect(vertex_6_158, vector3MoreOrLessEquals(Vector3(-5.65842, 13.6618, 57.1753)));
      final vertex_6_159 = mesh_6.vertices.elementAt(159);
      expect(vertex_6_159, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, 55.0563)));
      final vertex_6_160 = mesh_6.vertices.elementAt(160);
      expect(vertex_6_160, vector3MoreOrLessEquals(Vector3(1.40262, -32.3836, 79.7363)));
      final vertex_6_161 = mesh_6.vertices.elementAt(161);
      expect(vertex_6_161, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, 80.7919)));
      final vertex_6_162 = mesh_6.vertices.elementAt(162);
      expect(vertex_6_162, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, 86.3163)));
      final vertex_6_163 = mesh_6.vertices.elementAt(163);
      expect(vertex_6_163, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, 86.6049)));
      final vertex_6_164 = mesh_6.vertices.elementAt(164);
      expect(vertex_6_164, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, 80.7919)));
      final vertex_6_165 = mesh_6.vertices.elementAt(165);
      expect(vertex_6_165, vector3MoreOrLessEquals(Vector3(1.40262, -32.3836, 79.7363)));
      final vertex_6_166 = mesh_6.vertices.elementAt(166);
      expect(vertex_6_166, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, 86.3163)));
      final vertex_6_167 = mesh_6.vertices.elementAt(167);
      expect(vertex_6_167, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, 80.7919)));
      final vertex_6_168 = mesh_6.vertices.elementAt(168);
      expect(vertex_6_168, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_169 = mesh_6.vertices.elementAt(169);
      expect(vertex_6_169, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, 1.03395)));
      final vertex_6_170 = mesh_6.vertices.elementAt(170);
      expect(vertex_6_170, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, 1.40408)));
      final vertex_6_171 = mesh_6.vertices.elementAt(171);
      expect(vertex_6_171, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, 86.0428)));
      final vertex_6_172 = mesh_6.vertices.elementAt(172);
      expect(vertex_6_172, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_173 = mesh_6.vertices.elementAt(173);
      expect(vertex_6_173, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, 86.3163)));
      final vertex_6_174 = mesh_6.vertices.elementAt(174);
      expect(vertex_6_174, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, 15.167)));
      final vertex_6_175 = mesh_6.vertices.elementAt(175);
      expect(vertex_6_175, vector3MoreOrLessEquals(Vector3(-19.5314, 6.4777, 14.5472)));
      final vertex_6_176 = mesh_6.vertices.elementAt(176);
      expect(vertex_6_176, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, 1.40408)));
      final vertex_6_177 = mesh_6.vertices.elementAt(177);
      expect(vertex_6_177, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, 1.03395)));
      final vertex_6_178 = mesh_6.vertices.elementAt(178);
      expect(vertex_6_178, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, 15.167)));
      final vertex_6_179 = mesh_6.vertices.elementAt(179);
      expect(vertex_6_179, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, 1.40408)));
      final vertex_6_180 = mesh_6.vertices.elementAt(180);
      expect(vertex_6_180, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, 15.167)));
      final vertex_6_181 = mesh_6.vertices.elementAt(181);
      expect(vertex_6_181, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_182 = mesh_6.vertices.elementAt(182);
      expect(vertex_6_182, vector3MoreOrLessEquals(Vector3(-19.5314, 6.4777, 14.5472)));
      final vertex_6_183 = mesh_6.vertices.elementAt(183);
      expect(vertex_6_183, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, 15.167)));
      final vertex_6_184 = mesh_6.vertices.elementAt(184);
      expect(vertex_6_184, vector3MoreOrLessEquals(Vector3(-14.1676, 26.0791, 27.3223)));
      final vertex_6_185 = mesh_6.vertices.elementAt(185);
      expect(vertex_6_185, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_186 = mesh_6.vertices.elementAt(186);
      expect(vertex_6_186, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, 28.9514)));
      final vertex_6_187 = mesh_6.vertices.elementAt(187);
      expect(vertex_6_187, vector3MoreOrLessEquals(Vector3(-15.5666, 26.3996, 30.1895)));
      final vertex_6_188 = mesh_6.vertices.elementAt(188);
      expect(vertex_6_188, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_189 = mesh_6.vertices.elementAt(189);
      expect(vertex_6_189, vector3MoreOrLessEquals(Vector3(-14.1676, 26.0791, 27.3223)));
      final vertex_6_190 = mesh_6.vertices.elementAt(190);
      expect(vertex_6_190, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, 28.9514)));
      final vertex_6_191 = mesh_6.vertices.elementAt(191);
      expect(vertex_6_191, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, 27.3489)));
      final vertex_6_192 = mesh_6.vertices.elementAt(192);
      expect(vertex_6_192, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, 28.9514)));
      final vertex_6_193 = mesh_6.vertices.elementAt(193);
      expect(vertex_6_193, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, 55.0563)));
      final vertex_6_194 = mesh_6.vertices.elementAt(194);
      expect(vertex_6_194, vector3MoreOrLessEquals(Vector3(-15.5666, 26.3996, 30.1895)));
      final vertex_6_195 = mesh_6.vertices.elementAt(195);
      expect(vertex_6_195, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, 28.9514)));
      final vertex_6_196 = mesh_6.vertices.elementAt(196);
      expect(vertex_6_196, vector3MoreOrLessEquals(Vector3(-4.72603, 12.454, 53.2947)));
      final vertex_6_197 = mesh_6.vertices.elementAt(197);
      expect(vertex_6_197, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, 55.0563)));
      final vertex_6_198 = mesh_6.vertices.elementAt(198);
      expect(vertex_6_198, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, 78.8791)));
      final vertex_6_199 = mesh_6.vertices.elementAt(199);
      expect(vertex_6_199, vector3MoreOrLessEquals(Vector3(1.40262, -32.3836, 79.7363)));
      final vertex_6_200 = mesh_6.vertices.elementAt(200);
      expect(vertex_6_200, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, 55.0563)));
      final vertex_6_201 = mesh_6.vertices.elementAt(201);
      expect(vertex_6_201, vector3MoreOrLessEquals(Vector3(-4.72603, 12.454, 53.2947)));
      final vertex_6_202 = mesh_6.vertices.elementAt(202);
      expect(vertex_6_202, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, 78.8791)));
      final vertex_6_203 = mesh_6.vertices.elementAt(203);
      expect(vertex_6_203, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, 55.0563)));
      final vertex_6_204 = mesh_6.vertices.elementAt(204);
      expect(vertex_6_204, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, 78.8791)));
      final vertex_6_205 = mesh_6.vertices.elementAt(205);
      expect(vertex_6_205, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, 86.3163)));
      final vertex_6_206 = mesh_6.vertices.elementAt(206);
      expect(vertex_6_206, vector3MoreOrLessEquals(Vector3(1.40262, -32.3836, 79.7363)));
      final vertex_6_207 = mesh_6.vertices.elementAt(207);
      expect(vertex_6_207, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, 78.8791)));
      final vertex_6_208 = mesh_6.vertices.elementAt(208);
      expect(vertex_6_208, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, 86.0428)));
      final vertex_6_209 = mesh_6.vertices.elementAt(209);
      expect(vertex_6_209, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, 86.3163)));
      final vertex_6_210 = mesh_6.vertices.elementAt(210);
      expect(vertex_6_210, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_211 = mesh_6.vertices.elementAt(211);
      expect(vertex_6_211, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -1.73312)));
      final vertex_6_212 = mesh_6.vertices.elementAt(212);
      expect(vertex_6_212, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, 1.03395)));
      final vertex_6_213 = mesh_6.vertices.elementAt(213);
      expect(vertex_6_213, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, 85.9902)));
      final vertex_6_214 = mesh_6.vertices.elementAt(214);
      expect(vertex_6_214, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_215 = mesh_6.vertices.elementAt(215);
      expect(vertex_6_215, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, 86.0428)));
      final vertex_6_216 = mesh_6.vertices.elementAt(216);
      expect(vertex_6_216, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -1.73312)));
      final vertex_6_217 = mesh_6.vertices.elementAt(217);
      expect(vertex_6_217, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, 15.167)));
      final vertex_6_218 = mesh_6.vertices.elementAt(218);
      expect(vertex_6_218, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, 1.03395)));
      final vertex_6_219 = mesh_6.vertices.elementAt(219);
      expect(vertex_6_219, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -1.73312)));
      final vertex_6_220 = mesh_6.vertices.elementAt(220);
      expect(vertex_6_220, vector3MoreOrLessEquals(Vector3(-15.3994, 6.00928, 14.2396)));
      final vertex_6_221 = mesh_6.vertices.elementAt(221);
      expect(vertex_6_221, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, 15.167)));
      final vertex_6_222 = mesh_6.vertices.elementAt(222);
      expect(vertex_6_222, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, 26.9046)));
      final vertex_6_223 = mesh_6.vertices.elementAt(223);
      expect(vertex_6_223, vector3MoreOrLessEquals(Vector3(-14.1676, 26.0791, 27.3223)));
      final vertex_6_224 = mesh_6.vertices.elementAt(224);
      expect(vertex_6_224, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, 15.167)));
      final vertex_6_225 = mesh_6.vertices.elementAt(225);
      expect(vertex_6_225, vector3MoreOrLessEquals(Vector3(-15.3994, 6.00928, 14.2396)));
      final vertex_6_226 = mesh_6.vertices.elementAt(226);
      expect(vertex_6_226, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, 26.9046)));
      final vertex_6_227 = mesh_6.vertices.elementAt(227);
      expect(vertex_6_227, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, 15.167)));
      final vertex_6_228 = mesh_6.vertices.elementAt(228);
      expect(vertex_6_228, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, 26.9046)));
      final vertex_6_229 = mesh_6.vertices.elementAt(229);
      expect(vertex_6_229, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, 28.9514)));
      final vertex_6_230 = mesh_6.vertices.elementAt(230);
      expect(vertex_6_230, vector3MoreOrLessEquals(Vector3(-14.1676, 26.0791, 27.3223)));
      final vertex_6_231 = mesh_6.vertices.elementAt(231);
      expect(vertex_6_231, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, 26.9046)));
      final vertex_6_232 = mesh_6.vertices.elementAt(232);
      expect(vertex_6_232, vector3MoreOrLessEquals(Vector3(-11.729, 25.7647, 28.6871)));
      final vertex_6_233 = mesh_6.vertices.elementAt(233);
      expect(vertex_6_233, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, 28.9514)));
      final vertex_6_234 = mesh_6.vertices.elementAt(234);
      expect(vertex_6_234, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, 53.2173)));
      final vertex_6_235 = mesh_6.vertices.elementAt(235);
      expect(vertex_6_235, vector3MoreOrLessEquals(Vector3(-4.72603, 12.454, 53.2947)));
      final vertex_6_236 = mesh_6.vertices.elementAt(236);
      expect(vertex_6_236, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, 28.9514)));
      final vertex_6_237 = mesh_6.vertices.elementAt(237);
      expect(vertex_6_237, vector3MoreOrLessEquals(Vector3(-11.729, 25.7647, 28.6871)));
      final vertex_6_238 = mesh_6.vertices.elementAt(238);
      expect(vertex_6_238, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, 53.2173)));
      final vertex_6_239 = mesh_6.vertices.elementAt(239);
      expect(vertex_6_239, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, 28.9514)));
      final vertex_6_240 = mesh_6.vertices.elementAt(240);
      expect(vertex_6_240, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, 53.2173)));
      final vertex_6_241 = mesh_6.vertices.elementAt(241);
      expect(vertex_6_241, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, 78.8791)));
      final vertex_6_242 = mesh_6.vertices.elementAt(242);
      expect(vertex_6_242, vector3MoreOrLessEquals(Vector3(-4.72603, 12.454, 53.2947)));
      final vertex_6_243 = mesh_6.vertices.elementAt(243);
      expect(vertex_6_243, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, 53.2173)));
      final vertex_6_244 = mesh_6.vertices.elementAt(244);
      expect(vertex_6_244, vector3MoreOrLessEquals(Vector3(3.09747, -32.9692, 78.8659)));
      final vertex_6_245 = mesh_6.vertices.elementAt(245);
      expect(vertex_6_245, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, 78.8791)));
      final vertex_6_246 = mesh_6.vertices.elementAt(246);
      expect(vertex_6_246, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, 85.9902)));
      final vertex_6_247 = mesh_6.vertices.elementAt(247);
      expect(vertex_6_247, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, 86.0428)));
      final vertex_6_248 = mesh_6.vertices.elementAt(248);
      expect(vertex_6_248, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, 78.8791)));
      final vertex_6_249 = mesh_6.vertices.elementAt(249);
      expect(vertex_6_249, vector3MoreOrLessEquals(Vector3(3.09747, -32.9692, 78.8659)));
      final vertex_6_250 = mesh_6.vertices.elementAt(250);
      expect(vertex_6_250, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, 85.9902)));
      final vertex_6_251 = mesh_6.vertices.elementAt(251);
      expect(vertex_6_251, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, 78.8791)));
      final vertex_6_252 = mesh_6.vertices.elementAt(252);
      expect(vertex_6_252, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -2.14914)));
      final vertex_6_253 = mesh_6.vertices.elementAt(253);
      expect(vertex_6_253, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -4.81347)));
      final vertex_6_254 = mesh_6.vertices.elementAt(254);
      expect(vertex_6_254, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -1.73312)));
      final vertex_6_255 = mesh_6.vertices.elementAt(255);
      expect(vertex_6_255, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, 86.1982)));
      final vertex_6_256 = mesh_6.vertices.elementAt(256);
      expect(vertex_6_256, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, 86.3362)));
      final vertex_6_257 = mesh_6.vertices.elementAt(257);
      expect(vertex_6_257, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, 85.9902)));
      final vertex_6_258 = mesh_6.vertices.elementAt(258);
      expect(vertex_6_258, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, 12.4635)));
      final vertex_6_259 = mesh_6.vertices.elementAt(259);
      expect(vertex_6_259, vector3MoreOrLessEquals(Vector3(-15.3994, 6.00928, 14.2396)));
      final vertex_6_260 = mesh_6.vertices.elementAt(260);
      expect(vertex_6_260, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -1.73312)));
      final vertex_6_261 = mesh_6.vertices.elementAt(261);
      expect(vertex_6_261, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -4.81347)));
      final vertex_6_262 = mesh_6.vertices.elementAt(262);
      expect(vertex_6_262, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, 12.4635)));
      final vertex_6_263 = mesh_6.vertices.elementAt(263);
      expect(vertex_6_263, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -1.73312)));
      final vertex_6_264 = mesh_6.vertices.elementAt(264);
      expect(vertex_6_264, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, 12.4635)));
      final vertex_6_265 = mesh_6.vertices.elementAt(265);
      expect(vertex_6_265, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, 26.9046)));
      final vertex_6_266 = mesh_6.vertices.elementAt(266);
      expect(vertex_6_266, vector3MoreOrLessEquals(Vector3(-15.3994, 6.00928, 14.2396)));
      final vertex_6_267 = mesh_6.vertices.elementAt(267);
      expect(vertex_6_267, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, 12.4635)));
      final vertex_6_268 = mesh_6.vertices.elementAt(268);
      expect(vertex_6_268, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, 26.4104)));
      final vertex_6_269 = mesh_6.vertices.elementAt(269);
      expect(vertex_6_269, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, 26.9046)));
      final vertex_6_270 = mesh_6.vertices.elementAt(270);
      expect(vertex_6_270, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, 29.5956)));
      final vertex_6_271 = mesh_6.vertices.elementAt(271);
      expect(vertex_6_271, vector3MoreOrLessEquals(Vector3(-11.729, 25.7647, 28.6871)));
      final vertex_6_272 = mesh_6.vertices.elementAt(272);
      expect(vertex_6_272, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, 26.9046)));
      final vertex_6_273 = mesh_6.vertices.elementAt(273);
      expect(vertex_6_273, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, 26.4104)));
      final vertex_6_274 = mesh_6.vertices.elementAt(274);
      expect(vertex_6_274, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, 29.5956)));
      final vertex_6_275 = mesh_6.vertices.elementAt(275);
      expect(vertex_6_275, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, 26.9046)));
      final vertex_6_276 = mesh_6.vertices.elementAt(276);
      expect(vertex_6_276, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, 29.5956)));
      final vertex_6_277 = mesh_6.vertices.elementAt(277);
      expect(vertex_6_277, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, 53.2173)));
      final vertex_6_278 = mesh_6.vertices.elementAt(278);
      expect(vertex_6_278, vector3MoreOrLessEquals(Vector3(-11.729, 25.7647, 28.6871)));
      final vertex_6_279 = mesh_6.vertices.elementAt(279);
      expect(vertex_6_279, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, 29.5956)));
      final vertex_6_280 = mesh_6.vertices.elementAt(280);
      expect(vertex_6_280, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, 54.8821)));
      final vertex_6_281 = mesh_6.vertices.elementAt(281);
      expect(vertex_6_281, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, 53.2173)));
      final vertex_6_282 = mesh_6.vertices.elementAt(282);
      expect(vertex_6_282, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, 79.7065)));
      final vertex_6_283 = mesh_6.vertices.elementAt(283);
      expect(vertex_6_283, vector3MoreOrLessEquals(Vector3(3.09747, -32.9692, 78.8659)));
      final vertex_6_284 = mesh_6.vertices.elementAt(284);
      expect(vertex_6_284, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, 53.2173)));
      final vertex_6_285 = mesh_6.vertices.elementAt(285);
      expect(vertex_6_285, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, 54.8821)));
      final vertex_6_286 = mesh_6.vertices.elementAt(286);
      expect(vertex_6_286, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, 79.7065)));
      final vertex_6_287 = mesh_6.vertices.elementAt(287);
      expect(vertex_6_287, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, 53.2173)));
      final vertex_6_288 = mesh_6.vertices.elementAt(288);
      expect(vertex_6_288, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, 79.7065)));
      final vertex_6_289 = mesh_6.vertices.elementAt(289);
      expect(vertex_6_289, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, 85.9902)));
      final vertex_6_290 = mesh_6.vertices.elementAt(290);
      expect(vertex_6_290, vector3MoreOrLessEquals(Vector3(3.09747, -32.9692, 78.8659)));
      final vertex_6_291 = mesh_6.vertices.elementAt(291);
      expect(vertex_6_291, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, 79.7065)));
      final vertex_6_292 = mesh_6.vertices.elementAt(292);
      expect(vertex_6_292, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, 86.1982)));
      final vertex_6_293 = mesh_6.vertices.elementAt(293);
      expect(vertex_6_293, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, 85.9902)));
      expect(mesh_6.normals.length, equals(294));
      final normal_6_0 = mesh_6.normals.elementAt(0);
      expect(normal_6_0, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_1 = mesh_6.normals.elementAt(1);
      expect(normal_6_1, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_2 = mesh_6.normals.elementAt(2);
      expect(normal_6_2, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_3 = mesh_6.normals.elementAt(3);
      expect(normal_6_3, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_4 = mesh_6.normals.elementAt(4);
      expect(normal_6_4, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_5 = mesh_6.normals.elementAt(5);
      expect(normal_6_5, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_6 = mesh_6.normals.elementAt(6);
      expect(normal_6_6, vector3MoreOrLessEquals(Vector3(0.375319, 0.601842, -0.704927)));
      final normal_6_7 = mesh_6.normals.elementAt(7);
      expect(normal_6_7, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, -0.223412)));
      final normal_6_8 = mesh_6.normals.elementAt(8);
      expect(normal_6_8, vector3MoreOrLessEquals(Vector3(0.795449, 0.228463, -0.561307)));
      final normal_6_9 = mesh_6.normals.elementAt(9);
      expect(normal_6_9, vector3MoreOrLessEquals(Vector3(0.164332, 0.782548, -0.600511)));
      final normal_6_10 = mesh_6.normals.elementAt(10);
      expect(normal_6_10, vector3MoreOrLessEquals(Vector3(0.375319, 0.601842, -0.704927)));
      final normal_6_11 = mesh_6.normals.elementAt(11);
      expect(normal_6_11, vector3MoreOrLessEquals(Vector3(0.795449, 0.228463, -0.561307)));
      final normal_6_12 = mesh_6.normals.elementAt(12);
      expect(normal_6_12, vector3MoreOrLessEquals(Vector3(0.375319, 0.601842, -0.704927)));
      final normal_6_13 = mesh_6.normals.elementAt(13);
      expect(normal_6_13, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, -0.395701)));
      final normal_6_14 = mesh_6.normals.elementAt(14);
      expect(normal_6_14, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, -0.223412)));
      final normal_6_15 = mesh_6.normals.elementAt(15);
      expect(normal_6_15, vector3MoreOrLessEquals(Vector3(0.375319, 0.601842, -0.704927)));
      final normal_6_16 = mesh_6.normals.elementAt(16);
      expect(normal_6_16, vector3MoreOrLessEquals(Vector3(0.548411, 0.661676, -0.511303)));
      final normal_6_17 = mesh_6.normals.elementAt(17);
      expect(normal_6_17, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, -0.395701)));
      final normal_6_18 = mesh_6.normals.elementAt(18);
      expect(normal_6_18, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, 0.010829)));
      final normal_6_19 = mesh_6.normals.elementAt(19);
      expect(normal_6_19, vector3MoreOrLessEquals(Vector3(0.883048, -0.047484, -0.466875)));
      final normal_6_20 = mesh_6.normals.elementAt(20);
      expect(normal_6_20, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, -0.395701)));
      final normal_6_21 = mesh_6.normals.elementAt(21);
      expect(normal_6_21, vector3MoreOrLessEquals(Vector3(0.548411, 0.661676, -0.511303)));
      final normal_6_22 = mesh_6.normals.elementAt(22);
      expect(normal_6_22, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, 0.010829)));
      final normal_6_23 = mesh_6.normals.elementAt(23);
      expect(normal_6_23, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, -0.395701)));
      final normal_6_24 = mesh_6.normals.elementAt(24);
      expect(normal_6_24, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, 0.010829)));
      final normal_6_25 = mesh_6.normals.elementAt(25);
      expect(normal_6_25, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, -0.167289)));
      final normal_6_26 = mesh_6.normals.elementAt(26);
      expect(normal_6_26, vector3MoreOrLessEquals(Vector3(0.883048, -0.047484, -0.466875)));
      final normal_6_27 = mesh_6.normals.elementAt(27);
      expect(normal_6_27, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, 0.010829)));
      final normal_6_28 = mesh_6.normals.elementAt(28);
      expect(normal_6_28, vector3MoreOrLessEquals(Vector3(0.695006, 0.600563, 0.395335)));
      final normal_6_29 = mesh_6.normals.elementAt(29);
      expect(normal_6_29, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, -0.167289)));
      final normal_6_30 = mesh_6.normals.elementAt(30);
      expect(normal_6_30, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, 0.460397)));
      final normal_6_31 = mesh_6.normals.elementAt(31);
      expect(normal_6_31, vector3MoreOrLessEquals(Vector3(0.950455, -0.06233, -0.304551)));
      final normal_6_32 = mesh_6.normals.elementAt(32);
      expect(normal_6_32, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, -0.167289)));
      final normal_6_33 = mesh_6.normals.elementAt(33);
      expect(normal_6_33, vector3MoreOrLessEquals(Vector3(0.695006, 0.600563, 0.395335)));
      final normal_6_34 = mesh_6.normals.elementAt(34);
      expect(normal_6_34, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, 0.460397)));
      final normal_6_35 = mesh_6.normals.elementAt(35);
      expect(normal_6_35, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, -0.167289)));
      final normal_6_36 = mesh_6.normals.elementAt(36);
      expect(normal_6_36, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, 0.460397)));
      final normal_6_37 = mesh_6.normals.elementAt(37);
      expect(normal_6_37, vector3MoreOrLessEquals(Vector3(0.989975, 0.079498, -0.116747)));
      final normal_6_38 = mesh_6.normals.elementAt(38);
      expect(normal_6_38, vector3MoreOrLessEquals(Vector3(0.950455, -0.06233, -0.304551)));
      final normal_6_39 = mesh_6.normals.elementAt(39);
      expect(normal_6_39, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, 0.460397)));
      final normal_6_40 = mesh_6.normals.elementAt(40);
      expect(normal_6_40, vector3MoreOrLessEquals(Vector3(0.767612, 0.420846, 0.483385)));
      final normal_6_41 = mesh_6.normals.elementAt(41);
      expect(normal_6_41, vector3MoreOrLessEquals(Vector3(0.989975, 0.079498, -0.116747)));
      final normal_6_42 = mesh_6.normals.elementAt(42);
      expect(normal_6_42, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_43 = mesh_6.normals.elementAt(43);
      expect(normal_6_43, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_44 = mesh_6.normals.elementAt(44);
      expect(normal_6_44, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_45 = mesh_6.normals.elementAt(45);
      expect(normal_6_45, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_46 = mesh_6.normals.elementAt(46);
      expect(normal_6_46, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_47 = mesh_6.normals.elementAt(47);
      expect(normal_6_47, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_48 = mesh_6.normals.elementAt(48);
      expect(normal_6_48, vector3MoreOrLessEquals(Vector3(-0.407667, 0.857527, -0.313775)));
      final normal_6_49 = mesh_6.normals.elementAt(49);
      expect(normal_6_49, vector3MoreOrLessEquals(Vector3(0.375319, 0.601842, -0.704927)));
      final normal_6_50 = mesh_6.normals.elementAt(50);
      expect(normal_6_50, vector3MoreOrLessEquals(Vector3(0.164332, 0.782548, -0.600511)));
      final normal_6_51 = mesh_6.normals.elementAt(51);
      expect(normal_6_51, vector3MoreOrLessEquals(Vector3(-0.407667, 0.857527, -0.313775)));
      final normal_6_52 = mesh_6.normals.elementAt(52);
      expect(normal_6_52, vector3MoreOrLessEquals(Vector3(-0.380509, 0.743022, -0.550574)));
      final normal_6_53 = mesh_6.normals.elementAt(53);
      expect(normal_6_53, vector3MoreOrLessEquals(Vector3(0.375319, 0.601842, -0.704927)));
      final normal_6_54 = mesh_6.normals.elementAt(54);
      expect(normal_6_54, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, -0.350803)));
      final normal_6_55 = mesh_6.normals.elementAt(55);
      expect(normal_6_55, vector3MoreOrLessEquals(Vector3(0.548411, 0.661676, -0.511303)));
      final normal_6_56 = mesh_6.normals.elementAt(56);
      expect(normal_6_56, vector3MoreOrLessEquals(Vector3(0.375319, 0.601842, -0.704927)));
      final normal_6_57 = mesh_6.normals.elementAt(57);
      expect(normal_6_57, vector3MoreOrLessEquals(Vector3(-0.380509, 0.743022, -0.550574)));
      final normal_6_58 = mesh_6.normals.elementAt(58);
      expect(normal_6_58, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, -0.350803)));
      final normal_6_59 = mesh_6.normals.elementAt(59);
      expect(normal_6_59, vector3MoreOrLessEquals(Vector3(0.375319, 0.601842, -0.704927)));
      final normal_6_60 = mesh_6.normals.elementAt(60);
      expect(normal_6_60, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, -0.350803)));
      final normal_6_61 = mesh_6.normals.elementAt(61);
      expect(normal_6_61, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, 0.010829)));
      final normal_6_62 = mesh_6.normals.elementAt(62);
      expect(normal_6_62, vector3MoreOrLessEquals(Vector3(0.548411, 0.661676, -0.511303)));
      final normal_6_63 = mesh_6.normals.elementAt(63);
      expect(normal_6_63, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, -0.350803)));
      final normal_6_64 = mesh_6.normals.elementAt(64);
      expect(normal_6_64, vector3MoreOrLessEquals(Vector3(-0.173281, 0.931431, 0.320017)));
      final normal_6_65 = mesh_6.normals.elementAt(65);
      expect(normal_6_65, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, 0.010829)));
      final normal_6_66 = mesh_6.normals.elementAt(66);
      expect(normal_6_66, vector3MoreOrLessEquals(Vector3(-0.088344, 0.681833, 0.726154)));
      final normal_6_67 = mesh_6.normals.elementAt(67);
      expect(normal_6_67, vector3MoreOrLessEquals(Vector3(0.695006, 0.600563, 0.395335)));
      final normal_6_68 = mesh_6.normals.elementAt(68);
      expect(normal_6_68, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, 0.010829)));
      final normal_6_69 = mesh_6.normals.elementAt(69);
      expect(normal_6_69, vector3MoreOrLessEquals(Vector3(-0.173281, 0.931431, 0.320017)));
      final normal_6_70 = mesh_6.normals.elementAt(70);
      expect(normal_6_70, vector3MoreOrLessEquals(Vector3(-0.088344, 0.681833, 0.726154)));
      final normal_6_71 = mesh_6.normals.elementAt(71);
      expect(normal_6_71, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, 0.010829)));
      final normal_6_72 = mesh_6.normals.elementAt(72);
      expect(normal_6_72, vector3MoreOrLessEquals(Vector3(-0.088344, 0.681833, 0.726154)));
      final normal_6_73 = mesh_6.normals.elementAt(73);
      expect(normal_6_73, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, 0.460397)));
      final normal_6_74 = mesh_6.normals.elementAt(74);
      expect(normal_6_74, vector3MoreOrLessEquals(Vector3(0.695006, 0.600563, 0.395335)));
      final normal_6_75 = mesh_6.normals.elementAt(75);
      expect(normal_6_75, vector3MoreOrLessEquals(Vector3(-0.088344, 0.681833, 0.726154)));
      final normal_6_76 = mesh_6.normals.elementAt(76);
      expect(normal_6_76, vector3MoreOrLessEquals(Vector3(-0.097862, 0.460784, 0.8821)));
      final normal_6_77 = mesh_6.normals.elementAt(77);
      expect(normal_6_77, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, 0.460397)));
      final normal_6_78 = mesh_6.normals.elementAt(78);
      expect(normal_6_78, vector3MoreOrLessEquals(Vector3(-0.075217, 0.480042, 0.874015)));
      final normal_6_79 = mesh_6.normals.elementAt(79);
      expect(normal_6_79, vector3MoreOrLessEquals(Vector3(0.767612, 0.420846, 0.483385)));
      final normal_6_80 = mesh_6.normals.elementAt(80);
      expect(normal_6_80, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, 0.460397)));
      final normal_6_81 = mesh_6.normals.elementAt(81);
      expect(normal_6_81, vector3MoreOrLessEquals(Vector3(-0.097862, 0.460784, 0.8821)));
      final normal_6_82 = mesh_6.normals.elementAt(82);
      expect(normal_6_82, vector3MoreOrLessEquals(Vector3(-0.075217, 0.480042, 0.874015)));
      final normal_6_83 = mesh_6.normals.elementAt(83);
      expect(normal_6_83, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, 0.460397)));
      final normal_6_84 = mesh_6.normals.elementAt(84);
      expect(normal_6_84, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_85 = mesh_6.normals.elementAt(85);
      expect(normal_6_85, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_86 = mesh_6.normals.elementAt(86);
      expect(normal_6_86, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_87 = mesh_6.normals.elementAt(87);
      expect(normal_6_87, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_88 = mesh_6.normals.elementAt(88);
      expect(normal_6_88, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_89 = mesh_6.normals.elementAt(89);
      expect(normal_6_89, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_90 = mesh_6.normals.elementAt(90);
      expect(normal_6_90, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, 0.098302)));
      final normal_6_91 = mesh_6.normals.elementAt(91);
      expect(normal_6_91, vector3MoreOrLessEquals(Vector3(-0.380509, 0.743022, -0.550574)));
      final normal_6_92 = mesh_6.normals.elementAt(92);
      expect(normal_6_92, vector3MoreOrLessEquals(Vector3(-0.407667, 0.857527, -0.313775)));
      final normal_6_93 = mesh_6.normals.elementAt(93);
      expect(normal_6_93, vector3MoreOrLessEquals(Vector3(-0.86351, 0.341772, 0.370868)));
      final normal_6_94 = mesh_6.normals.elementAt(94);
      expect(normal_6_94, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, 0.098302)));
      final normal_6_95 = mesh_6.normals.elementAt(95);
      expect(normal_6_95, vector3MoreOrLessEquals(Vector3(-0.407667, 0.857527, -0.313775)));
      final normal_6_96 = mesh_6.normals.elementAt(96);
      expect(normal_6_96, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, 0.098302)));
      final normal_6_97 = mesh_6.normals.elementAt(97);
      expect(normal_6_97, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, -0.350803)));
      final normal_6_98 = mesh_6.normals.elementAt(98);
      expect(normal_6_98, vector3MoreOrLessEquals(Vector3(-0.380509, 0.743022, -0.550574)));
      final normal_6_99 = mesh_6.normals.elementAt(99);
      expect(normal_6_99, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, 0.098302)));
      final normal_6_100 = mesh_6.normals.elementAt(100);
      expect(normal_6_100, vector3MoreOrLessEquals(Vector3(-0.954873, 0.297012, -0.001297)));
      final normal_6_101 = mesh_6.normals.elementAt(101);
      expect(normal_6_101, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, -0.350803)));
      final normal_6_102 = mesh_6.normals.elementAt(102);
      expect(normal_6_102, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, 0.281187)));
      final normal_6_103 = mesh_6.normals.elementAt(103);
      expect(normal_6_103, vector3MoreOrLessEquals(Vector3(-0.173281, 0.931431, 0.320017)));
      final normal_6_104 = mesh_6.normals.elementAt(104);
      expect(normal_6_104, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, -0.350803)));
      final normal_6_105 = mesh_6.normals.elementAt(105);
      expect(normal_6_105, vector3MoreOrLessEquals(Vector3(-0.954873, 0.297012, -0.001297)));
      final normal_6_106 = mesh_6.normals.elementAt(106);
      expect(normal_6_106, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, 0.281187)));
      final normal_6_107 = mesh_6.normals.elementAt(107);
      expect(normal_6_107, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, -0.350803)));
      final normal_6_108 = mesh_6.normals.elementAt(108);
      expect(normal_6_108, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, 0.281187)));
      final normal_6_109 = mesh_6.normals.elementAt(109);
      expect(normal_6_109, vector3MoreOrLessEquals(Vector3(-0.088344, 0.681833, 0.726154)));
      final normal_6_110 = mesh_6.normals.elementAt(110);
      expect(normal_6_110, vector3MoreOrLessEquals(Vector3(-0.173281, 0.931431, 0.320017)));
      final normal_6_111 = mesh_6.normals.elementAt(111);
      expect(normal_6_111, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, 0.281187)));
      final normal_6_112 = mesh_6.normals.elementAt(112);
      expect(normal_6_112, vector3MoreOrLessEquals(Vector3(-0.798205, 0.258643, 0.544033)));
      final normal_6_113 = mesh_6.normals.elementAt(113);
      expect(normal_6_113, vector3MoreOrLessEquals(Vector3(-0.088344, 0.681833, 0.726154)));
      final normal_6_114 = mesh_6.normals.elementAt(114);
      expect(normal_6_114, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, 0.54097)));
      final normal_6_115 = mesh_6.normals.elementAt(115);
      expect(normal_6_115, vector3MoreOrLessEquals(Vector3(-0.097862, 0.460784, 0.8821)));
      final normal_6_116 = mesh_6.normals.elementAt(116);
      expect(normal_6_116, vector3MoreOrLessEquals(Vector3(-0.088344, 0.681833, 0.726154)));
      final normal_6_117 = mesh_6.normals.elementAt(117);
      expect(normal_6_117, vector3MoreOrLessEquals(Vector3(-0.798205, 0.258643, 0.544033)));
      final normal_6_118 = mesh_6.normals.elementAt(118);
      expect(normal_6_118, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, 0.54097)));
      final normal_6_119 = mesh_6.normals.elementAt(119);
      expect(normal_6_119, vector3MoreOrLessEquals(Vector3(-0.088344, 0.681833, 0.726154)));
      final normal_6_120 = mesh_6.normals.elementAt(120);
      expect(normal_6_120, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, 0.54097)));
      final normal_6_121 = mesh_6.normals.elementAt(121);
      expect(normal_6_121, vector3MoreOrLessEquals(Vector3(-0.075217, 0.480042, 0.874015)));
      final normal_6_122 = mesh_6.normals.elementAt(122);
      expect(normal_6_122, vector3MoreOrLessEquals(Vector3(-0.097862, 0.460784, 0.8821)));
      final normal_6_123 = mesh_6.normals.elementAt(123);
      expect(normal_6_123, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, 0.54097)));
      final normal_6_124 = mesh_6.normals.elementAt(124);
      expect(normal_6_124, vector3MoreOrLessEquals(Vector3(-0.800009, 0.140946, 0.583197)));
      final normal_6_125 = mesh_6.normals.elementAt(125);
      expect(normal_6_125, vector3MoreOrLessEquals(Vector3(-0.075217, 0.480042, 0.874015)));
      final normal_6_126 = mesh_6.normals.elementAt(126);
      expect(normal_6_126, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_127 = mesh_6.normals.elementAt(127);
      expect(normal_6_127, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_128 = mesh_6.normals.elementAt(128);
      expect(normal_6_128, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_129 = mesh_6.normals.elementAt(129);
      expect(normal_6_129, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_130 = mesh_6.normals.elementAt(130);
      expect(normal_6_130, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_131 = mesh_6.normals.elementAt(131);
      expect(normal_6_131, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_132 = mesh_6.normals.elementAt(132);
      expect(normal_6_132, vector3MoreOrLessEquals(Vector3(-0.638103, -0.340513, 0.690562)));
      final normal_6_133 = mesh_6.normals.elementAt(133);
      expect(normal_6_133, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, 0.098302)));
      final normal_6_134 = mesh_6.normals.elementAt(134);
      expect(normal_6_134, vector3MoreOrLessEquals(Vector3(-0.86351, 0.341772, 0.370868)));
      final normal_6_135 = mesh_6.normals.elementAt(135);
      expect(normal_6_135, vector3MoreOrLessEquals(Vector3(-0.638103, -0.340513, 0.690562)));
      final normal_6_136 = mesh_6.normals.elementAt(136);
      expect(normal_6_136, vector3MoreOrLessEquals(Vector3(-0.755642, -0.204991, 0.62208)));
      final normal_6_137 = mesh_6.normals.elementAt(137);
      expect(normal_6_137, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, 0.098302)));
      final normal_6_138 = mesh_6.normals.elementAt(138);
      expect(normal_6_138, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, 0.260133)));
      final normal_6_139 = mesh_6.normals.elementAt(139);
      expect(normal_6_139, vector3MoreOrLessEquals(Vector3(-0.954873, 0.297012, -0.001297)));
      final normal_6_140 = mesh_6.normals.elementAt(140);
      expect(normal_6_140, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, 0.098302)));
      final normal_6_141 = mesh_6.normals.elementAt(141);
      expect(normal_6_141, vector3MoreOrLessEquals(Vector3(-0.755642, -0.204991, 0.62208)));
      final normal_6_142 = mesh_6.normals.elementAt(142);
      expect(normal_6_142, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, 0.260133)));
      final normal_6_143 = mesh_6.normals.elementAt(143);
      expect(normal_6_143, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, 0.098302)));
      final normal_6_144 = mesh_6.normals.elementAt(144);
      expect(normal_6_144, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, 0.260133)));
      final normal_6_145 = mesh_6.normals.elementAt(145);
      expect(normal_6_145, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, 0.281187)));
      final normal_6_146 = mesh_6.normals.elementAt(146);
      expect(normal_6_146, vector3MoreOrLessEquals(Vector3(-0.954873, 0.297012, -0.001297)));
      final normal_6_147 = mesh_6.normals.elementAt(147);
      expect(normal_6_147, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, 0.260133)));
      final normal_6_148 = mesh_6.normals.elementAt(148);
      expect(normal_6_148, vector3MoreOrLessEquals(Vector3(-0.92195, -0.385899, -0.033004)));
      final normal_6_149 = mesh_6.normals.elementAt(149);
      expect(normal_6_149, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, 0.281187)));
      final normal_6_150 = mesh_6.normals.elementAt(150);
      expect(normal_6_150, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, -0.024508)));
      final normal_6_151 = mesh_6.normals.elementAt(151);
      expect(normal_6_151, vector3MoreOrLessEquals(Vector3(-0.798205, 0.258643, 0.544033)));
      final normal_6_152 = mesh_6.normals.elementAt(152);
      expect(normal_6_152, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, 0.281187)));
      final normal_6_153 = mesh_6.normals.elementAt(153);
      expect(normal_6_153, vector3MoreOrLessEquals(Vector3(-0.92195, -0.385899, -0.033004)));
      final normal_6_154 = mesh_6.normals.elementAt(154);
      expect(normal_6_154, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, -0.024508)));
      final normal_6_155 = mesh_6.normals.elementAt(155);
      expect(normal_6_155, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, 0.281187)));
      final normal_6_156 = mesh_6.normals.elementAt(156);
      expect(normal_6_156, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, -0.024508)));
      final normal_6_157 = mesh_6.normals.elementAt(157);
      expect(normal_6_157, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, 0.54097)));
      final normal_6_158 = mesh_6.normals.elementAt(158);
      expect(normal_6_158, vector3MoreOrLessEquals(Vector3(-0.798205, 0.258643, 0.544033)));
      final normal_6_159 = mesh_6.normals.elementAt(159);
      expect(normal_6_159, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, -0.024508)));
      final normal_6_160 = mesh_6.normals.elementAt(160);
      expect(normal_6_160, vector3MoreOrLessEquals(Vector3(-0.971643, -0.23638, 0.005919)));
      final normal_6_161 = mesh_6.normals.elementAt(161);
      expect(normal_6_161, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, 0.54097)));
      final normal_6_162 = mesh_6.normals.elementAt(162);
      expect(normal_6_162, vector3MoreOrLessEquals(Vector3(-0.950036, -0.310227, 0.034503)));
      final normal_6_163 = mesh_6.normals.elementAt(163);
      expect(normal_6_163, vector3MoreOrLessEquals(Vector3(-0.800009, 0.140946, 0.583197)));
      final normal_6_164 = mesh_6.normals.elementAt(164);
      expect(normal_6_164, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, 0.54097)));
      final normal_6_165 = mesh_6.normals.elementAt(165);
      expect(normal_6_165, vector3MoreOrLessEquals(Vector3(-0.971643, -0.23638, 0.005919)));
      final normal_6_166 = mesh_6.normals.elementAt(166);
      expect(normal_6_166, vector3MoreOrLessEquals(Vector3(-0.950036, -0.310227, 0.034503)));
      final normal_6_167 = mesh_6.normals.elementAt(167);
      expect(normal_6_167, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, 0.54097)));
      final normal_6_168 = mesh_6.normals.elementAt(168);
      expect(normal_6_168, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_169 = mesh_6.normals.elementAt(169);
      expect(normal_6_169, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_170 = mesh_6.normals.elementAt(170);
      expect(normal_6_170, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_171 = mesh_6.normals.elementAt(171);
      expect(normal_6_171, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_172 = mesh_6.normals.elementAt(172);
      expect(normal_6_172, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_173 = mesh_6.normals.elementAt(173);
      expect(normal_6_173, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_174 = mesh_6.normals.elementAt(174);
      expect(normal_6_174, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, 0.733912)));
      final normal_6_175 = mesh_6.normals.elementAt(175);
      expect(normal_6_175, vector3MoreOrLessEquals(Vector3(-0.755642, -0.204991, 0.62208)));
      final normal_6_176 = mesh_6.normals.elementAt(176);
      expect(normal_6_176, vector3MoreOrLessEquals(Vector3(-0.638103, -0.340513, 0.690562)));
      final normal_6_177 = mesh_6.normals.elementAt(177);
      expect(normal_6_177, vector3MoreOrLessEquals(Vector3(0.21631, -0.832587, 0.50991)));
      final normal_6_178 = mesh_6.normals.elementAt(178);
      expect(normal_6_178, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, 0.733912)));
      final normal_6_179 = mesh_6.normals.elementAt(179);
      expect(normal_6_179, vector3MoreOrLessEquals(Vector3(-0.638103, -0.340513, 0.690562)));
      final normal_6_180 = mesh_6.normals.elementAt(180);
      expect(normal_6_180, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, 0.733912)));
      final normal_6_181 = mesh_6.normals.elementAt(181);
      expect(normal_6_181, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, 0.260133)));
      final normal_6_182 = mesh_6.normals.elementAt(182);
      expect(normal_6_182, vector3MoreOrLessEquals(Vector3(-0.755642, -0.204991, 0.62208)));
      final normal_6_183 = mesh_6.normals.elementAt(183);
      expect(normal_6_183, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, 0.733912)));
      final normal_6_184 = mesh_6.normals.elementAt(184);
      expect(normal_6_184, vector3MoreOrLessEquals(Vector3(-0.163481, -0.936688, 0.309662)));
      final normal_6_185 = mesh_6.normals.elementAt(185);
      expect(normal_6_185, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, 0.260133)));
      final normal_6_186 = mesh_6.normals.elementAt(186);
      expect(normal_6_186, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, -0.381925)));
      final normal_6_187 = mesh_6.normals.elementAt(187);
      expect(normal_6_187, vector3MoreOrLessEquals(Vector3(-0.92195, -0.385899, -0.033004)));
      final normal_6_188 = mesh_6.normals.elementAt(188);
      expect(normal_6_188, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, 0.260133)));
      final normal_6_189 = mesh_6.normals.elementAt(189);
      expect(normal_6_189, vector3MoreOrLessEquals(Vector3(-0.163481, -0.936688, 0.309662)));
      final normal_6_190 = mesh_6.normals.elementAt(190);
      expect(normal_6_190, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, -0.381925)));
      final normal_6_191 = mesh_6.normals.elementAt(191);
      expect(normal_6_191, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, 0.260133)));
      final normal_6_192 = mesh_6.normals.elementAt(192);
      expect(normal_6_192, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, -0.381925)));
      final normal_6_193 = mesh_6.normals.elementAt(193);
      expect(normal_6_193, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, -0.024508)));
      final normal_6_194 = mesh_6.normals.elementAt(194);
      expect(normal_6_194, vector3MoreOrLessEquals(Vector3(-0.92195, -0.385899, -0.033004)));
      final normal_6_195 = mesh_6.normals.elementAt(195);
      expect(normal_6_195, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, -0.381925)));
      final normal_6_196 = mesh_6.normals.elementAt(196);
      expect(normal_6_196, vector3MoreOrLessEquals(Vector3(-0.334489, -0.728676, -0.597619)));
      final normal_6_197 = mesh_6.normals.elementAt(197);
      expect(normal_6_197, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, -0.024508)));
      final normal_6_198 = mesh_6.normals.elementAt(198);
      expect(normal_6_198, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, -0.685741)));
      final normal_6_199 = mesh_6.normals.elementAt(199);
      expect(normal_6_199, vector3MoreOrLessEquals(Vector3(-0.971643, -0.23638, 0.005919)));
      final normal_6_200 = mesh_6.normals.elementAt(200);
      expect(normal_6_200, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, -0.024508)));
      final normal_6_201 = mesh_6.normals.elementAt(201);
      expect(normal_6_201, vector3MoreOrLessEquals(Vector3(-0.334489, -0.728676, -0.597619)));
      final normal_6_202 = mesh_6.normals.elementAt(202);
      expect(normal_6_202, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, -0.685741)));
      final normal_6_203 = mesh_6.normals.elementAt(203);
      expect(normal_6_203, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, -0.024508)));
      final normal_6_204 = mesh_6.normals.elementAt(204);
      expect(normal_6_204, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, -0.685741)));
      final normal_6_205 = mesh_6.normals.elementAt(205);
      expect(normal_6_205, vector3MoreOrLessEquals(Vector3(-0.950036, -0.310227, 0.034503)));
      final normal_6_206 = mesh_6.normals.elementAt(206);
      expect(normal_6_206, vector3MoreOrLessEquals(Vector3(-0.971643, -0.23638, 0.005919)));
      final normal_6_207 = mesh_6.normals.elementAt(207);
      expect(normal_6_207, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, -0.685741)));
      final normal_6_208 = mesh_6.normals.elementAt(208);
      expect(normal_6_208, vector3MoreOrLessEquals(Vector3(-0.371857, -0.710825, -0.597035)));
      final normal_6_209 = mesh_6.normals.elementAt(209);
      expect(normal_6_209, vector3MoreOrLessEquals(Vector3(-0.950036, -0.310227, 0.034503)));
      final normal_6_210 = mesh_6.normals.elementAt(210);
      expect(normal_6_210, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_211 = mesh_6.normals.elementAt(211);
      expect(normal_6_211, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_212 = mesh_6.normals.elementAt(212);
      expect(normal_6_212, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_213 = mesh_6.normals.elementAt(213);
      expect(normal_6_213, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_214 = mesh_6.normals.elementAt(214);
      expect(normal_6_214, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_215 = mesh_6.normals.elementAt(215);
      expect(normal_6_215, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_216 = mesh_6.normals.elementAt(216);
      expect(normal_6_216, vector3MoreOrLessEquals(Vector3(0.750822, -0.654602, 0.088107)));
      final normal_6_217 = mesh_6.normals.elementAt(217);
      expect(normal_6_217, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, 0.733912)));
      final normal_6_218 = mesh_6.normals.elementAt(218);
      expect(normal_6_218, vector3MoreOrLessEquals(Vector3(0.21631, -0.832587, 0.50991)));
      final normal_6_219 = mesh_6.normals.elementAt(219);
      expect(normal_6_219, vector3MoreOrLessEquals(Vector3(0.750822, -0.654602, 0.088107)));
      final normal_6_220 = mesh_6.normals.elementAt(220);
      expect(normal_6_220, vector3MoreOrLessEquals(Vector3(0.744565, -0.575276, 0.338646)));
      final normal_6_221 = mesh_6.normals.elementAt(221);
      expect(normal_6_221, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, 0.733912)));
      final normal_6_222 = mesh_6.normals.elementAt(222);
      expect(normal_6_222, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, -0.034936)));
      final normal_6_223 = mesh_6.normals.elementAt(223);
      expect(normal_6_223, vector3MoreOrLessEquals(Vector3(-0.163481, -0.936688, 0.309662)));
      final normal_6_224 = mesh_6.normals.elementAt(224);
      expect(normal_6_224, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, 0.733912)));
      final normal_6_225 = mesh_6.normals.elementAt(225);
      expect(normal_6_225, vector3MoreOrLessEquals(Vector3(0.744565, -0.575276, 0.338646)));
      final normal_6_226 = mesh_6.normals.elementAt(226);
      expect(normal_6_226, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, -0.034936)));
      final normal_6_227 = mesh_6.normals.elementAt(227);
      expect(normal_6_227, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, 0.733912)));
      final normal_6_228 = mesh_6.normals.elementAt(228);
      expect(normal_6_228, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, -0.034936)));
      final normal_6_229 = mesh_6.normals.elementAt(229);
      expect(normal_6_229, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, -0.381925)));
      final normal_6_230 = mesh_6.normals.elementAt(230);
      expect(normal_6_230, vector3MoreOrLessEquals(Vector3(-0.163481, -0.936688, 0.309662)));
      final normal_6_231 = mesh_6.normals.elementAt(231);
      expect(normal_6_231, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, -0.034936)));
      final normal_6_232 = mesh_6.normals.elementAt(232);
      expect(normal_6_232, vector3MoreOrLessEquals(Vector3(0.522268, -0.636825, -0.567176)));
      final normal_6_233 = mesh_6.normals.elementAt(233);
      expect(normal_6_233, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, -0.381925)));
      final normal_6_234 = mesh_6.normals.elementAt(234);
      expect(normal_6_234, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, -0.665842)));
      final normal_6_235 = mesh_6.normals.elementAt(235);
      expect(normal_6_235, vector3MoreOrLessEquals(Vector3(-0.334489, -0.728676, -0.597619)));
      final normal_6_236 = mesh_6.normals.elementAt(236);
      expect(normal_6_236, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, -0.381925)));
      final normal_6_237 = mesh_6.normals.elementAt(237);
      expect(normal_6_237, vector3MoreOrLessEquals(Vector3(0.522268, -0.636825, -0.567176)));
      final normal_6_238 = mesh_6.normals.elementAt(238);
      expect(normal_6_238, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, -0.665842)));
      final normal_6_239 = mesh_6.normals.elementAt(239);
      expect(normal_6_239, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, -0.381925)));
      final normal_6_240 = mesh_6.normals.elementAt(240);
      expect(normal_6_240, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, -0.665842)));
      final normal_6_241 = mesh_6.normals.elementAt(241);
      expect(normal_6_241, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, -0.685741)));
      final normal_6_242 = mesh_6.normals.elementAt(242);
      expect(normal_6_242, vector3MoreOrLessEquals(Vector3(-0.334489, -0.728676, -0.597619)));
      final normal_6_243 = mesh_6.normals.elementAt(243);
      expect(normal_6_243, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, -0.665842)));
      final normal_6_244 = mesh_6.normals.elementAt(244);
      expect(normal_6_244, vector3MoreOrLessEquals(Vector3(0.641037, -0.375221, -0.669538)));
      final normal_6_245 = mesh_6.normals.elementAt(245);
      expect(normal_6_245, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, -0.685741)));
      final normal_6_246 = mesh_6.normals.elementAt(246);
      expect(normal_6_246, vector3MoreOrLessEquals(Vector3(0.614542, -0.453134, -0.645761)));
      final normal_6_247 = mesh_6.normals.elementAt(247);
      expect(normal_6_247, vector3MoreOrLessEquals(Vector3(-0.371857, -0.710825, -0.597035)));
      final normal_6_248 = mesh_6.normals.elementAt(248);
      expect(normal_6_248, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, -0.685741)));
      final normal_6_249 = mesh_6.normals.elementAt(249);
      expect(normal_6_249, vector3MoreOrLessEquals(Vector3(0.641037, -0.375221, -0.669538)));
      final normal_6_250 = mesh_6.normals.elementAt(250);
      expect(normal_6_250, vector3MoreOrLessEquals(Vector3(0.614542, -0.453134, -0.645761)));
      final normal_6_251 = mesh_6.normals.elementAt(251);
      expect(normal_6_251, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, -0.685741)));
      final normal_6_252 = mesh_6.normals.elementAt(252);
      expect(normal_6_252, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_253 = mesh_6.normals.elementAt(253);
      expect(normal_6_253, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_254 = mesh_6.normals.elementAt(254);
      expect(normal_6_254, vector3MoreOrLessEquals(Vector3(-0.272473, -0.916512, -0.292854)));
      final normal_6_255 = mesh_6.normals.elementAt(255);
      expect(normal_6_255, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_256 = mesh_6.normals.elementAt(256);
      expect(normal_6_256, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_257 = mesh_6.normals.elementAt(257);
      expect(normal_6_257, vector3MoreOrLessEquals(Vector3(0.247462, -0.431597, 0.86746)));
      final normal_6_258 = mesh_6.normals.elementAt(258);
      expect(normal_6_258, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, -0.223412)));
      final normal_6_259 = mesh_6.normals.elementAt(259);
      expect(normal_6_259, vector3MoreOrLessEquals(Vector3(0.744565, -0.575276, 0.338646)));
      final normal_6_260 = mesh_6.normals.elementAt(260);
      expect(normal_6_260, vector3MoreOrLessEquals(Vector3(0.750822, -0.654602, 0.088107)));
      final normal_6_261 = mesh_6.normals.elementAt(261);
      expect(normal_6_261, vector3MoreOrLessEquals(Vector3(0.795449, 0.228463, -0.561307)));
      final normal_6_262 = mesh_6.normals.elementAt(262);
      expect(normal_6_262, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, -0.223412)));
      final normal_6_263 = mesh_6.normals.elementAt(263);
      expect(normal_6_263, vector3MoreOrLessEquals(Vector3(0.750822, -0.654602, 0.088107)));
      final normal_6_264 = mesh_6.normals.elementAt(264);
      expect(normal_6_264, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, -0.223412)));
      final normal_6_265 = mesh_6.normals.elementAt(265);
      expect(normal_6_265, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, -0.034936)));
      final normal_6_266 = mesh_6.normals.elementAt(266);
      expect(normal_6_266, vector3MoreOrLessEquals(Vector3(0.744565, -0.575276, 0.338646)));
      final normal_6_267 = mesh_6.normals.elementAt(267);
      expect(normal_6_267, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, -0.223412)));
      final normal_6_268 = mesh_6.normals.elementAt(268);
      expect(normal_6_268, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, -0.395701)));
      final normal_6_269 = mesh_6.normals.elementAt(269);
      expect(normal_6_269, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, -0.034936)));
      final normal_6_270 = mesh_6.normals.elementAt(270);
      expect(normal_6_270, vector3MoreOrLessEquals(Vector3(0.883048, -0.047484, -0.466875)));
      final normal_6_271 = mesh_6.normals.elementAt(271);
      expect(normal_6_271, vector3MoreOrLessEquals(Vector3(0.522268, -0.636825, -0.567176)));
      final normal_6_272 = mesh_6.normals.elementAt(272);
      expect(normal_6_272, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, -0.034936)));
      final normal_6_273 = mesh_6.normals.elementAt(273);
      expect(normal_6_273, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, -0.395701)));
      final normal_6_274 = mesh_6.normals.elementAt(274);
      expect(normal_6_274, vector3MoreOrLessEquals(Vector3(0.883048, -0.047484, -0.466875)));
      final normal_6_275 = mesh_6.normals.elementAt(275);
      expect(normal_6_275, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, -0.034936)));
      final normal_6_276 = mesh_6.normals.elementAt(276);
      expect(normal_6_276, vector3MoreOrLessEquals(Vector3(0.883048, -0.047484, -0.466875)));
      final normal_6_277 = mesh_6.normals.elementAt(277);
      expect(normal_6_277, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, -0.665842)));
      final normal_6_278 = mesh_6.normals.elementAt(278);
      expect(normal_6_278, vector3MoreOrLessEquals(Vector3(0.522268, -0.636825, -0.567176)));
      final normal_6_279 = mesh_6.normals.elementAt(279);
      expect(normal_6_279, vector3MoreOrLessEquals(Vector3(0.883048, -0.047484, -0.466875)));
      final normal_6_280 = mesh_6.normals.elementAt(280);
      expect(normal_6_280, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, -0.167289)));
      final normal_6_281 = mesh_6.normals.elementAt(281);
      expect(normal_6_281, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, -0.665842)));
      final normal_6_282 = mesh_6.normals.elementAt(282);
      expect(normal_6_282, vector3MoreOrLessEquals(Vector3(0.950455, -0.06233, -0.304551)));
      final normal_6_283 = mesh_6.normals.elementAt(283);
      expect(normal_6_283, vector3MoreOrLessEquals(Vector3(0.641037, -0.375221, -0.669538)));
      final normal_6_284 = mesh_6.normals.elementAt(284);
      expect(normal_6_284, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, -0.665842)));
      final normal_6_285 = mesh_6.normals.elementAt(285);
      expect(normal_6_285, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, -0.167289)));
      final normal_6_286 = mesh_6.normals.elementAt(286);
      expect(normal_6_286, vector3MoreOrLessEquals(Vector3(0.950455, -0.06233, -0.304551)));
      final normal_6_287 = mesh_6.normals.elementAt(287);
      expect(normal_6_287, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, -0.665842)));
      final normal_6_288 = mesh_6.normals.elementAt(288);
      expect(normal_6_288, vector3MoreOrLessEquals(Vector3(0.950455, -0.06233, -0.304551)));
      final normal_6_289 = mesh_6.normals.elementAt(289);
      expect(normal_6_289, vector3MoreOrLessEquals(Vector3(0.614542, -0.453134, -0.645761)));
      final normal_6_290 = mesh_6.normals.elementAt(290);
      expect(normal_6_290, vector3MoreOrLessEquals(Vector3(0.641037, -0.375221, -0.669538)));
      final normal_6_291 = mesh_6.normals.elementAt(291);
      expect(normal_6_291, vector3MoreOrLessEquals(Vector3(0.950455, -0.06233, -0.304551)));
      final normal_6_292 = mesh_6.normals.elementAt(292);
      expect(normal_6_292, vector3MoreOrLessEquals(Vector3(0.989975, 0.079498, -0.116747)));
      final normal_6_293 = mesh_6.normals.elementAt(293);
      expect(normal_6_293, vector3MoreOrLessEquals(Vector3(0.614542, -0.453134, -0.645761)));
      expect(mesh_6.tangents.length, isZero);
      expect(mesh_6.bitangents.length, isZero);
      expect(mesh_6.colors.length, isZero);
      expect(mesh_6.textureCoords.length, equals(1));
      final textureCoords_6_0 = mesh_6.textureCoords.elementAt(0);
      expect(textureCoords_6_0.length, equals(294));
      final textureCoord_6_0_0 = textureCoords_6_0.elementAt(0);
      expect(textureCoord_6_0_0, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_1 = textureCoords_6_0.elementAt(1);
      expect(textureCoord_6_0_1, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_2 = textureCoords_6_0.elementAt(2);
      expect(textureCoord_6_0_2, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_3 = textureCoords_6_0.elementAt(3);
      expect(textureCoord_6_0_3, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_4 = textureCoords_6_0.elementAt(4);
      expect(textureCoord_6_0_4, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_5 = textureCoords_6_0.elementAt(5);
      expect(textureCoord_6_0_5, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_6 = textureCoords_6_0.elementAt(6);
      expect(textureCoord_6_0_6, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_6_0_7 = textureCoords_6_0.elementAt(7);
      expect(textureCoord_6_0_7, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_6_0_8 = textureCoords_6_0.elementAt(8);
      expect(textureCoord_6_0_8, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_6_0_9 = textureCoords_6_0.elementAt(9);
      expect(textureCoord_6_0_9, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_6_0_10 = textureCoords_6_0.elementAt(10);
      expect(textureCoord_6_0_10, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_6_0_11 = textureCoords_6_0.elementAt(11);
      expect(textureCoord_6_0_11, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_6_0_12 = textureCoords_6_0.elementAt(12);
      expect(textureCoord_6_0_12, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_6_0_13 = textureCoords_6_0.elementAt(13);
      expect(textureCoord_6_0_13, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_6_0_14 = textureCoords_6_0.elementAt(14);
      expect(textureCoord_6_0_14, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_6_0_15 = textureCoords_6_0.elementAt(15);
      expect(textureCoord_6_0_15, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_6_0_16 = textureCoords_6_0.elementAt(16);
      expect(textureCoord_6_0_16, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_6_0_17 = textureCoords_6_0.elementAt(17);
      expect(textureCoord_6_0_17, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_6_0_18 = textureCoords_6_0.elementAt(18);
      expect(textureCoord_6_0_18, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_6_0_19 = textureCoords_6_0.elementAt(19);
      expect(textureCoord_6_0_19, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_6_0_20 = textureCoords_6_0.elementAt(20);
      expect(textureCoord_6_0_20, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_6_0_21 = textureCoords_6_0.elementAt(21);
      expect(textureCoord_6_0_21, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_6_0_22 = textureCoords_6_0.elementAt(22);
      expect(textureCoord_6_0_22, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_6_0_23 = textureCoords_6_0.elementAt(23);
      expect(textureCoord_6_0_23, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_6_0_24 = textureCoords_6_0.elementAt(24);
      expect(textureCoord_6_0_24, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_6_0_25 = textureCoords_6_0.elementAt(25);
      expect(textureCoord_6_0_25, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_6_0_26 = textureCoords_6_0.elementAt(26);
      expect(textureCoord_6_0_26, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_6_0_27 = textureCoords_6_0.elementAt(27);
      expect(textureCoord_6_0_27, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_6_0_28 = textureCoords_6_0.elementAt(28);
      expect(textureCoord_6_0_28, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_6_0_29 = textureCoords_6_0.elementAt(29);
      expect(textureCoord_6_0_29, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_6_0_30 = textureCoords_6_0.elementAt(30);
      expect(textureCoord_6_0_30, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_6_0_31 = textureCoords_6_0.elementAt(31);
      expect(textureCoord_6_0_31, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_6_0_32 = textureCoords_6_0.elementAt(32);
      expect(textureCoord_6_0_32, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_6_0_33 = textureCoords_6_0.elementAt(33);
      expect(textureCoord_6_0_33, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_6_0_34 = textureCoords_6_0.elementAt(34);
      expect(textureCoord_6_0_34, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_6_0_35 = textureCoords_6_0.elementAt(35);
      expect(textureCoord_6_0_35, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_6_0_36 = textureCoords_6_0.elementAt(36);
      expect(textureCoord_6_0_36, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_6_0_37 = textureCoords_6_0.elementAt(37);
      expect(textureCoord_6_0_37, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_38 = textureCoords_6_0.elementAt(38);
      expect(textureCoord_6_0_38, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_6_0_39 = textureCoords_6_0.elementAt(39);
      expect(textureCoord_6_0_39, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_6_0_40 = textureCoords_6_0.elementAt(40);
      expect(textureCoord_6_0_40, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_6_0_41 = textureCoords_6_0.elementAt(41);
      expect(textureCoord_6_0_41, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_42 = textureCoords_6_0.elementAt(42);
      expect(textureCoord_6_0_42, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_43 = textureCoords_6_0.elementAt(43);
      expect(textureCoord_6_0_43, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_44 = textureCoords_6_0.elementAt(44);
      expect(textureCoord_6_0_44, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_45 = textureCoords_6_0.elementAt(45);
      expect(textureCoord_6_0_45, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_46 = textureCoords_6_0.elementAt(46);
      expect(textureCoord_6_0_46, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_47 = textureCoords_6_0.elementAt(47);
      expect(textureCoord_6_0_47, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_48 = textureCoords_6_0.elementAt(48);
      expect(textureCoord_6_0_48, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_6_0_49 = textureCoords_6_0.elementAt(49);
      expect(textureCoord_6_0_49, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_6_0_50 = textureCoords_6_0.elementAt(50);
      expect(textureCoord_6_0_50, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_6_0_51 = textureCoords_6_0.elementAt(51);
      expect(textureCoord_6_0_51, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_6_0_52 = textureCoords_6_0.elementAt(52);
      expect(textureCoord_6_0_52, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_6_0_53 = textureCoords_6_0.elementAt(53);
      expect(textureCoord_6_0_53, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_6_0_54 = textureCoords_6_0.elementAt(54);
      expect(textureCoord_6_0_54, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_6_0_55 = textureCoords_6_0.elementAt(55);
      expect(textureCoord_6_0_55, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_6_0_56 = textureCoords_6_0.elementAt(56);
      expect(textureCoord_6_0_56, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_6_0_57 = textureCoords_6_0.elementAt(57);
      expect(textureCoord_6_0_57, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_6_0_58 = textureCoords_6_0.elementAt(58);
      expect(textureCoord_6_0_58, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_6_0_59 = textureCoords_6_0.elementAt(59);
      expect(textureCoord_6_0_59, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_6_0_60 = textureCoords_6_0.elementAt(60);
      expect(textureCoord_6_0_60, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_6_0_61 = textureCoords_6_0.elementAt(61);
      expect(textureCoord_6_0_61, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_6_0_62 = textureCoords_6_0.elementAt(62);
      expect(textureCoord_6_0_62, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_6_0_63 = textureCoords_6_0.elementAt(63);
      expect(textureCoord_6_0_63, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_6_0_64 = textureCoords_6_0.elementAt(64);
      expect(textureCoord_6_0_64, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_6_0_65 = textureCoords_6_0.elementAt(65);
      expect(textureCoord_6_0_65, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_6_0_66 = textureCoords_6_0.elementAt(66);
      expect(textureCoord_6_0_66, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_6_0_67 = textureCoords_6_0.elementAt(67);
      expect(textureCoord_6_0_67, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_6_0_68 = textureCoords_6_0.elementAt(68);
      expect(textureCoord_6_0_68, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_6_0_69 = textureCoords_6_0.elementAt(69);
      expect(textureCoord_6_0_69, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_6_0_70 = textureCoords_6_0.elementAt(70);
      expect(textureCoord_6_0_70, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_6_0_71 = textureCoords_6_0.elementAt(71);
      expect(textureCoord_6_0_71, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_6_0_72 = textureCoords_6_0.elementAt(72);
      expect(textureCoord_6_0_72, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_6_0_73 = textureCoords_6_0.elementAt(73);
      expect(textureCoord_6_0_73, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_6_0_74 = textureCoords_6_0.elementAt(74);
      expect(textureCoord_6_0_74, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_6_0_75 = textureCoords_6_0.elementAt(75);
      expect(textureCoord_6_0_75, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_6_0_76 = textureCoords_6_0.elementAt(76);
      expect(textureCoord_6_0_76, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_6_0_77 = textureCoords_6_0.elementAt(77);
      expect(textureCoord_6_0_77, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_6_0_78 = textureCoords_6_0.elementAt(78);
      expect(textureCoord_6_0_78, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_6_0_79 = textureCoords_6_0.elementAt(79);
      expect(textureCoord_6_0_79, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_6_0_80 = textureCoords_6_0.elementAt(80);
      expect(textureCoord_6_0_80, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_6_0_81 = textureCoords_6_0.elementAt(81);
      expect(textureCoord_6_0_81, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_6_0_82 = textureCoords_6_0.elementAt(82);
      expect(textureCoord_6_0_82, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_6_0_83 = textureCoords_6_0.elementAt(83);
      expect(textureCoord_6_0_83, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_6_0_84 = textureCoords_6_0.elementAt(84);
      expect(textureCoord_6_0_84, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_85 = textureCoords_6_0.elementAt(85);
      expect(textureCoord_6_0_85, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_86 = textureCoords_6_0.elementAt(86);
      expect(textureCoord_6_0_86, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_87 = textureCoords_6_0.elementAt(87);
      expect(textureCoord_6_0_87, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_88 = textureCoords_6_0.elementAt(88);
      expect(textureCoord_6_0_88, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_89 = textureCoords_6_0.elementAt(89);
      expect(textureCoord_6_0_89, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_90 = textureCoords_6_0.elementAt(90);
      expect(textureCoord_6_0_90, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_6_0_91 = textureCoords_6_0.elementAt(91);
      expect(textureCoord_6_0_91, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_6_0_92 = textureCoords_6_0.elementAt(92);
      expect(textureCoord_6_0_92, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_6_0_93 = textureCoords_6_0.elementAt(93);
      expect(textureCoord_6_0_93, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_6_0_94 = textureCoords_6_0.elementAt(94);
      expect(textureCoord_6_0_94, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_6_0_95 = textureCoords_6_0.elementAt(95);
      expect(textureCoord_6_0_95, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_6_0_96 = textureCoords_6_0.elementAt(96);
      expect(textureCoord_6_0_96, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_6_0_97 = textureCoords_6_0.elementAt(97);
      expect(textureCoord_6_0_97, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_6_0_98 = textureCoords_6_0.elementAt(98);
      expect(textureCoord_6_0_98, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_6_0_99 = textureCoords_6_0.elementAt(99);
      expect(textureCoord_6_0_99, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_6_0_100 = textureCoords_6_0.elementAt(100);
      expect(textureCoord_6_0_100, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_6_0_101 = textureCoords_6_0.elementAt(101);
      expect(textureCoord_6_0_101, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_6_0_102 = textureCoords_6_0.elementAt(102);
      expect(textureCoord_6_0_102, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_6_0_103 = textureCoords_6_0.elementAt(103);
      expect(textureCoord_6_0_103, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_6_0_104 = textureCoords_6_0.elementAt(104);
      expect(textureCoord_6_0_104, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_6_0_105 = textureCoords_6_0.elementAt(105);
      expect(textureCoord_6_0_105, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_6_0_106 = textureCoords_6_0.elementAt(106);
      expect(textureCoord_6_0_106, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_6_0_107 = textureCoords_6_0.elementAt(107);
      expect(textureCoord_6_0_107, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_6_0_108 = textureCoords_6_0.elementAt(108);
      expect(textureCoord_6_0_108, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_6_0_109 = textureCoords_6_0.elementAt(109);
      expect(textureCoord_6_0_109, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_6_0_110 = textureCoords_6_0.elementAt(110);
      expect(textureCoord_6_0_110, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_6_0_111 = textureCoords_6_0.elementAt(111);
      expect(textureCoord_6_0_111, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_6_0_112 = textureCoords_6_0.elementAt(112);
      expect(textureCoord_6_0_112, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_6_0_113 = textureCoords_6_0.elementAt(113);
      expect(textureCoord_6_0_113, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_6_0_114 = textureCoords_6_0.elementAt(114);
      expect(textureCoord_6_0_114, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_6_0_115 = textureCoords_6_0.elementAt(115);
      expect(textureCoord_6_0_115, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_6_0_116 = textureCoords_6_0.elementAt(116);
      expect(textureCoord_6_0_116, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_6_0_117 = textureCoords_6_0.elementAt(117);
      expect(textureCoord_6_0_117, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_6_0_118 = textureCoords_6_0.elementAt(118);
      expect(textureCoord_6_0_118, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_6_0_119 = textureCoords_6_0.elementAt(119);
      expect(textureCoord_6_0_119, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_6_0_120 = textureCoords_6_0.elementAt(120);
      expect(textureCoord_6_0_120, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_6_0_121 = textureCoords_6_0.elementAt(121);
      expect(textureCoord_6_0_121, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_6_0_122 = textureCoords_6_0.elementAt(122);
      expect(textureCoord_6_0_122, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_6_0_123 = textureCoords_6_0.elementAt(123);
      expect(textureCoord_6_0_123, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_6_0_124 = textureCoords_6_0.elementAt(124);
      expect(textureCoord_6_0_124, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_6_0_125 = textureCoords_6_0.elementAt(125);
      expect(textureCoord_6_0_125, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_6_0_126 = textureCoords_6_0.elementAt(126);
      expect(textureCoord_6_0_126, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_127 = textureCoords_6_0.elementAt(127);
      expect(textureCoord_6_0_127, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_128 = textureCoords_6_0.elementAt(128);
      expect(textureCoord_6_0_128, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_129 = textureCoords_6_0.elementAt(129);
      expect(textureCoord_6_0_129, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_130 = textureCoords_6_0.elementAt(130);
      expect(textureCoord_6_0_130, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_131 = textureCoords_6_0.elementAt(131);
      expect(textureCoord_6_0_131, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_132 = textureCoords_6_0.elementAt(132);
      expect(textureCoord_6_0_132, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_6_0_133 = textureCoords_6_0.elementAt(133);
      expect(textureCoord_6_0_133, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_6_0_134 = textureCoords_6_0.elementAt(134);
      expect(textureCoord_6_0_134, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_6_0_135 = textureCoords_6_0.elementAt(135);
      expect(textureCoord_6_0_135, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_6_0_136 = textureCoords_6_0.elementAt(136);
      expect(textureCoord_6_0_136, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_6_0_137 = textureCoords_6_0.elementAt(137);
      expect(textureCoord_6_0_137, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_6_0_138 = textureCoords_6_0.elementAt(138);
      expect(textureCoord_6_0_138, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_6_0_139 = textureCoords_6_0.elementAt(139);
      expect(textureCoord_6_0_139, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_6_0_140 = textureCoords_6_0.elementAt(140);
      expect(textureCoord_6_0_140, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_6_0_141 = textureCoords_6_0.elementAt(141);
      expect(textureCoord_6_0_141, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_6_0_142 = textureCoords_6_0.elementAt(142);
      expect(textureCoord_6_0_142, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_6_0_143 = textureCoords_6_0.elementAt(143);
      expect(textureCoord_6_0_143, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_6_0_144 = textureCoords_6_0.elementAt(144);
      expect(textureCoord_6_0_144, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_6_0_145 = textureCoords_6_0.elementAt(145);
      expect(textureCoord_6_0_145, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_6_0_146 = textureCoords_6_0.elementAt(146);
      expect(textureCoord_6_0_146, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_6_0_147 = textureCoords_6_0.elementAt(147);
      expect(textureCoord_6_0_147, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_6_0_148 = textureCoords_6_0.elementAt(148);
      expect(textureCoord_6_0_148, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_6_0_149 = textureCoords_6_0.elementAt(149);
      expect(textureCoord_6_0_149, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_6_0_150 = textureCoords_6_0.elementAt(150);
      expect(textureCoord_6_0_150, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_6_0_151 = textureCoords_6_0.elementAt(151);
      expect(textureCoord_6_0_151, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_6_0_152 = textureCoords_6_0.elementAt(152);
      expect(textureCoord_6_0_152, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_6_0_153 = textureCoords_6_0.elementAt(153);
      expect(textureCoord_6_0_153, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_6_0_154 = textureCoords_6_0.elementAt(154);
      expect(textureCoord_6_0_154, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_6_0_155 = textureCoords_6_0.elementAt(155);
      expect(textureCoord_6_0_155, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_6_0_156 = textureCoords_6_0.elementAt(156);
      expect(textureCoord_6_0_156, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_6_0_157 = textureCoords_6_0.elementAt(157);
      expect(textureCoord_6_0_157, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_6_0_158 = textureCoords_6_0.elementAt(158);
      expect(textureCoord_6_0_158, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_6_0_159 = textureCoords_6_0.elementAt(159);
      expect(textureCoord_6_0_159, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_6_0_160 = textureCoords_6_0.elementAt(160);
      expect(textureCoord_6_0_160, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_6_0_161 = textureCoords_6_0.elementAt(161);
      expect(textureCoord_6_0_161, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_6_0_162 = textureCoords_6_0.elementAt(162);
      expect(textureCoord_6_0_162, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_6_0_163 = textureCoords_6_0.elementAt(163);
      expect(textureCoord_6_0_163, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_6_0_164 = textureCoords_6_0.elementAt(164);
      expect(textureCoord_6_0_164, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_6_0_165 = textureCoords_6_0.elementAt(165);
      expect(textureCoord_6_0_165, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_6_0_166 = textureCoords_6_0.elementAt(166);
      expect(textureCoord_6_0_166, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_6_0_167 = textureCoords_6_0.elementAt(167);
      expect(textureCoord_6_0_167, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_6_0_168 = textureCoords_6_0.elementAt(168);
      expect(textureCoord_6_0_168, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_169 = textureCoords_6_0.elementAt(169);
      expect(textureCoord_6_0_169, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_170 = textureCoords_6_0.elementAt(170);
      expect(textureCoord_6_0_170, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_171 = textureCoords_6_0.elementAt(171);
      expect(textureCoord_6_0_171, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_172 = textureCoords_6_0.elementAt(172);
      expect(textureCoord_6_0_172, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_173 = textureCoords_6_0.elementAt(173);
      expect(textureCoord_6_0_173, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_174 = textureCoords_6_0.elementAt(174);
      expect(textureCoord_6_0_174, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_6_0_175 = textureCoords_6_0.elementAt(175);
      expect(textureCoord_6_0_175, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_6_0_176 = textureCoords_6_0.elementAt(176);
      expect(textureCoord_6_0_176, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_6_0_177 = textureCoords_6_0.elementAt(177);
      expect(textureCoord_6_0_177, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_6_0_178 = textureCoords_6_0.elementAt(178);
      expect(textureCoord_6_0_178, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_6_0_179 = textureCoords_6_0.elementAt(179);
      expect(textureCoord_6_0_179, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_6_0_180 = textureCoords_6_0.elementAt(180);
      expect(textureCoord_6_0_180, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_6_0_181 = textureCoords_6_0.elementAt(181);
      expect(textureCoord_6_0_181, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_6_0_182 = textureCoords_6_0.elementAt(182);
      expect(textureCoord_6_0_182, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_6_0_183 = textureCoords_6_0.elementAt(183);
      expect(textureCoord_6_0_183, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_6_0_184 = textureCoords_6_0.elementAt(184);
      expect(textureCoord_6_0_184, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_6_0_185 = textureCoords_6_0.elementAt(185);
      expect(textureCoord_6_0_185, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_6_0_186 = textureCoords_6_0.elementAt(186);
      expect(textureCoord_6_0_186, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_6_0_187 = textureCoords_6_0.elementAt(187);
      expect(textureCoord_6_0_187, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_6_0_188 = textureCoords_6_0.elementAt(188);
      expect(textureCoord_6_0_188, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_6_0_189 = textureCoords_6_0.elementAt(189);
      expect(textureCoord_6_0_189, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_6_0_190 = textureCoords_6_0.elementAt(190);
      expect(textureCoord_6_0_190, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_6_0_191 = textureCoords_6_0.elementAt(191);
      expect(textureCoord_6_0_191, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_6_0_192 = textureCoords_6_0.elementAt(192);
      expect(textureCoord_6_0_192, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_6_0_193 = textureCoords_6_0.elementAt(193);
      expect(textureCoord_6_0_193, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_6_0_194 = textureCoords_6_0.elementAt(194);
      expect(textureCoord_6_0_194, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_6_0_195 = textureCoords_6_0.elementAt(195);
      expect(textureCoord_6_0_195, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_6_0_196 = textureCoords_6_0.elementAt(196);
      expect(textureCoord_6_0_196, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_6_0_197 = textureCoords_6_0.elementAt(197);
      expect(textureCoord_6_0_197, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_6_0_198 = textureCoords_6_0.elementAt(198);
      expect(textureCoord_6_0_198, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_6_0_199 = textureCoords_6_0.elementAt(199);
      expect(textureCoord_6_0_199, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_6_0_200 = textureCoords_6_0.elementAt(200);
      expect(textureCoord_6_0_200, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_6_0_201 = textureCoords_6_0.elementAt(201);
      expect(textureCoord_6_0_201, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_6_0_202 = textureCoords_6_0.elementAt(202);
      expect(textureCoord_6_0_202, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_6_0_203 = textureCoords_6_0.elementAt(203);
      expect(textureCoord_6_0_203, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_6_0_204 = textureCoords_6_0.elementAt(204);
      expect(textureCoord_6_0_204, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_6_0_205 = textureCoords_6_0.elementAt(205);
      expect(textureCoord_6_0_205, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_6_0_206 = textureCoords_6_0.elementAt(206);
      expect(textureCoord_6_0_206, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_6_0_207 = textureCoords_6_0.elementAt(207);
      expect(textureCoord_6_0_207, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_6_0_208 = textureCoords_6_0.elementAt(208);
      expect(textureCoord_6_0_208, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_6_0_209 = textureCoords_6_0.elementAt(209);
      expect(textureCoord_6_0_209, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_6_0_210 = textureCoords_6_0.elementAt(210);
      expect(textureCoord_6_0_210, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_211 = textureCoords_6_0.elementAt(211);
      expect(textureCoord_6_0_211, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_212 = textureCoords_6_0.elementAt(212);
      expect(textureCoord_6_0_212, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_213 = textureCoords_6_0.elementAt(213);
      expect(textureCoord_6_0_213, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_214 = textureCoords_6_0.elementAt(214);
      expect(textureCoord_6_0_214, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_215 = textureCoords_6_0.elementAt(215);
      expect(textureCoord_6_0_215, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_216 = textureCoords_6_0.elementAt(216);
      expect(textureCoord_6_0_216, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_6_0_217 = textureCoords_6_0.elementAt(217);
      expect(textureCoord_6_0_217, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_6_0_218 = textureCoords_6_0.elementAt(218);
      expect(textureCoord_6_0_218, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_6_0_219 = textureCoords_6_0.elementAt(219);
      expect(textureCoord_6_0_219, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_6_0_220 = textureCoords_6_0.elementAt(220);
      expect(textureCoord_6_0_220, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_6_0_221 = textureCoords_6_0.elementAt(221);
      expect(textureCoord_6_0_221, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_6_0_222 = textureCoords_6_0.elementAt(222);
      expect(textureCoord_6_0_222, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_6_0_223 = textureCoords_6_0.elementAt(223);
      expect(textureCoord_6_0_223, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_6_0_224 = textureCoords_6_0.elementAt(224);
      expect(textureCoord_6_0_224, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_6_0_225 = textureCoords_6_0.elementAt(225);
      expect(textureCoord_6_0_225, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_6_0_226 = textureCoords_6_0.elementAt(226);
      expect(textureCoord_6_0_226, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_6_0_227 = textureCoords_6_0.elementAt(227);
      expect(textureCoord_6_0_227, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_6_0_228 = textureCoords_6_0.elementAt(228);
      expect(textureCoord_6_0_228, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_6_0_229 = textureCoords_6_0.elementAt(229);
      expect(textureCoord_6_0_229, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_6_0_230 = textureCoords_6_0.elementAt(230);
      expect(textureCoord_6_0_230, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_6_0_231 = textureCoords_6_0.elementAt(231);
      expect(textureCoord_6_0_231, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_6_0_232 = textureCoords_6_0.elementAt(232);
      expect(textureCoord_6_0_232, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_6_0_233 = textureCoords_6_0.elementAt(233);
      expect(textureCoord_6_0_233, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_6_0_234 = textureCoords_6_0.elementAt(234);
      expect(textureCoord_6_0_234, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_6_0_235 = textureCoords_6_0.elementAt(235);
      expect(textureCoord_6_0_235, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_6_0_236 = textureCoords_6_0.elementAt(236);
      expect(textureCoord_6_0_236, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_6_0_237 = textureCoords_6_0.elementAt(237);
      expect(textureCoord_6_0_237, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_6_0_238 = textureCoords_6_0.elementAt(238);
      expect(textureCoord_6_0_238, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_6_0_239 = textureCoords_6_0.elementAt(239);
      expect(textureCoord_6_0_239, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_6_0_240 = textureCoords_6_0.elementAt(240);
      expect(textureCoord_6_0_240, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_6_0_241 = textureCoords_6_0.elementAt(241);
      expect(textureCoord_6_0_241, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_6_0_242 = textureCoords_6_0.elementAt(242);
      expect(textureCoord_6_0_242, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_6_0_243 = textureCoords_6_0.elementAt(243);
      expect(textureCoord_6_0_243, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_6_0_244 = textureCoords_6_0.elementAt(244);
      expect(textureCoord_6_0_244, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_6_0_245 = textureCoords_6_0.elementAt(245);
      expect(textureCoord_6_0_245, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_6_0_246 = textureCoords_6_0.elementAt(246);
      expect(textureCoord_6_0_246, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_6_0_247 = textureCoords_6_0.elementAt(247);
      expect(textureCoord_6_0_247, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_6_0_248 = textureCoords_6_0.elementAt(248);
      expect(textureCoord_6_0_248, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_6_0_249 = textureCoords_6_0.elementAt(249);
      expect(textureCoord_6_0_249, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_6_0_250 = textureCoords_6_0.elementAt(250);
      expect(textureCoord_6_0_250, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_6_0_251 = textureCoords_6_0.elementAt(251);
      expect(textureCoord_6_0_251, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_6_0_252 = textureCoords_6_0.elementAt(252);
      expect(textureCoord_6_0_252, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_253 = textureCoords_6_0.elementAt(253);
      expect(textureCoord_6_0_253, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_254 = textureCoords_6_0.elementAt(254);
      expect(textureCoord_6_0_254, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_255 = textureCoords_6_0.elementAt(255);
      expect(textureCoord_6_0_255, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_256 = textureCoords_6_0.elementAt(256);
      expect(textureCoord_6_0_256, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_257 = textureCoords_6_0.elementAt(257);
      expect(textureCoord_6_0_257, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_6_0_258 = textureCoords_6_0.elementAt(258);
      expect(textureCoord_6_0_258, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_6_0_259 = textureCoords_6_0.elementAt(259);
      expect(textureCoord_6_0_259, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_6_0_260 = textureCoords_6_0.elementAt(260);
      expect(textureCoord_6_0_260, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_6_0_261 = textureCoords_6_0.elementAt(261);
      expect(textureCoord_6_0_261, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_6_0_262 = textureCoords_6_0.elementAt(262);
      expect(textureCoord_6_0_262, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_6_0_263 = textureCoords_6_0.elementAt(263);
      expect(textureCoord_6_0_263, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_6_0_264 = textureCoords_6_0.elementAt(264);
      expect(textureCoord_6_0_264, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_6_0_265 = textureCoords_6_0.elementAt(265);
      expect(textureCoord_6_0_265, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_6_0_266 = textureCoords_6_0.elementAt(266);
      expect(textureCoord_6_0_266, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_6_0_267 = textureCoords_6_0.elementAt(267);
      expect(textureCoord_6_0_267, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_6_0_268 = textureCoords_6_0.elementAt(268);
      expect(textureCoord_6_0_268, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_6_0_269 = textureCoords_6_0.elementAt(269);
      expect(textureCoord_6_0_269, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_6_0_270 = textureCoords_6_0.elementAt(270);
      expect(textureCoord_6_0_270, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_6_0_271 = textureCoords_6_0.elementAt(271);
      expect(textureCoord_6_0_271, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_6_0_272 = textureCoords_6_0.elementAt(272);
      expect(textureCoord_6_0_272, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_6_0_273 = textureCoords_6_0.elementAt(273);
      expect(textureCoord_6_0_273, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_6_0_274 = textureCoords_6_0.elementAt(274);
      expect(textureCoord_6_0_274, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_6_0_275 = textureCoords_6_0.elementAt(275);
      expect(textureCoord_6_0_275, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_6_0_276 = textureCoords_6_0.elementAt(276);
      expect(textureCoord_6_0_276, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_6_0_277 = textureCoords_6_0.elementAt(277);
      expect(textureCoord_6_0_277, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_6_0_278 = textureCoords_6_0.elementAt(278);
      expect(textureCoord_6_0_278, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_6_0_279 = textureCoords_6_0.elementAt(279);
      expect(textureCoord_6_0_279, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_6_0_280 = textureCoords_6_0.elementAt(280);
      expect(textureCoord_6_0_280, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_6_0_281 = textureCoords_6_0.elementAt(281);
      expect(textureCoord_6_0_281, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_6_0_282 = textureCoords_6_0.elementAt(282);
      expect(textureCoord_6_0_282, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_6_0_283 = textureCoords_6_0.elementAt(283);
      expect(textureCoord_6_0_283, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_6_0_284 = textureCoords_6_0.elementAt(284);
      expect(textureCoord_6_0_284, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_6_0_285 = textureCoords_6_0.elementAt(285);
      expect(textureCoord_6_0_285, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_6_0_286 = textureCoords_6_0.elementAt(286);
      expect(textureCoord_6_0_286, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_6_0_287 = textureCoords_6_0.elementAt(287);
      expect(textureCoord_6_0_287, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_6_0_288 = textureCoords_6_0.elementAt(288);
      expect(textureCoord_6_0_288, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_6_0_289 = textureCoords_6_0.elementAt(289);
      expect(textureCoord_6_0_289, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_6_0_290 = textureCoords_6_0.elementAt(290);
      expect(textureCoord_6_0_290, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_6_0_291 = textureCoords_6_0.elementAt(291);
      expect(textureCoord_6_0_291, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_6_0_292 = textureCoords_6_0.elementAt(292);
      expect(textureCoord_6_0_292, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_6_0_293 = textureCoords_6_0.elementAt(293);
      expect(textureCoord_6_0_293, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      expect(mesh_6.uvComponents.length, equals(1));
      expect(mesh_6.uvComponents, equals([2]));
      expect(mesh_6.faces.length, equals(98));
      expect(mesh_6.bones.length, isZero);
      expect(mesh_6.materialIndex, equals(4));
      expect(mesh_6.name, equals('Bein3Re'));
      expect(mesh_6.animMeshes.length, isZero);
      expect(mesh_6.morphingMethod, isZero);
      expect(mesh_6.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_7 = meshes.elementAt(7);
      expect(mesh_7.primitiveTypes, equals(4));
      expect(mesh_7.vertices.length, equals(294));
      final vertex_7_0 = mesh_7.vertices.elementAt(0);
      expect(vertex_7_0, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -15.1865)));
      final vertex_7_1 = mesh_7.vertices.elementAt(1);
      expect(vertex_7_1, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -14.1125)));
      final vertex_7_2 = mesh_7.vertices.elementAt(2);
      expect(vertex_7_2, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_3 = mesh_7.vertices.elementAt(3);
      expect(vertex_7_3, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, -106.198)));
      final vertex_7_4 = mesh_7.vertices.elementAt(4);
      expect(vertex_7_4, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_5 = mesh_7.vertices.elementAt(5);
      expect(vertex_7_5, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, -106.51)));
      final vertex_7_6 = mesh_7.vertices.elementAt(6);
      expect(vertex_7_6, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -15.1865)));
      final vertex_7_7 = mesh_7.vertices.elementAt(7);
      expect(vertex_7_7, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, -32.4635)));
      final vertex_7_8 = mesh_7.vertices.elementAt(8);
      expect(vertex_7_8, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, -31.176)));
      final vertex_7_9 = mesh_7.vertices.elementAt(9);
      expect(vertex_7_9, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -15.1865)));
      final vertex_7_10 = mesh_7.vertices.elementAt(10);
      expect(vertex_7_10, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, -31.176)));
      final vertex_7_11 = mesh_7.vertices.elementAt(11);
      expect(vertex_7_11, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -14.1125)));
      final vertex_7_12 = mesh_7.vertices.elementAt(12);
      expect(vertex_7_12, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, -32.4635)));
      final vertex_7_13 = mesh_7.vertices.elementAt(13);
      expect(vertex_7_13, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, -46.4104)));
      final vertex_7_14 = mesh_7.vertices.elementAt(14);
      expect(vertex_7_14, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, -31.176)));
      final vertex_7_15 = mesh_7.vertices.elementAt(15);
      expect(vertex_7_15, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, -46.4104)));
      final vertex_7_16 = mesh_7.vertices.elementAt(16);
      expect(vertex_7_16, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, -46.2119)));
      final vertex_7_17 = mesh_7.vertices.elementAt(17);
      expect(vertex_7_17, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, -31.176)));
      final vertex_7_18 = mesh_7.vertices.elementAt(18);
      expect(vertex_7_18, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, -46.4104)));
      final vertex_7_19 = mesh_7.vertices.elementAt(19);
      expect(vertex_7_19, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, -49.5956)));
      final vertex_7_20 = mesh_7.vertices.elementAt(20);
      expect(vertex_7_20, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, -50.9928)));
      final vertex_7_21 = mesh_7.vertices.elementAt(21);
      expect(vertex_7_21, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, -46.4104)));
      final vertex_7_22 = mesh_7.vertices.elementAt(22);
      expect(vertex_7_22, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, -50.9928)));
      final vertex_7_23 = mesh_7.vertices.elementAt(23);
      expect(vertex_7_23, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, -46.2119)));
      final vertex_7_24 = mesh_7.vertices.elementAt(24);
      expect(vertex_7_24, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, -49.5956)));
      final vertex_7_25 = mesh_7.vertices.elementAt(25);
      expect(vertex_7_25, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, -74.8821)));
      final vertex_7_26 = mesh_7.vertices.elementAt(26);
      expect(vertex_7_26, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, -50.9928)));
      final vertex_7_27 = mesh_7.vertices.elementAt(27);
      expect(vertex_7_27, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, -74.8821)));
      final vertex_7_28 = mesh_7.vertices.elementAt(28);
      expect(vertex_7_28, vector3MoreOrLessEquals(Vector3(-1.5147, 14.1058, -77.0357)));
      final vertex_7_29 = mesh_7.vertices.elementAt(29);
      expect(vertex_7_29, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, -50.9928)));
      final vertex_7_30 = mesh_7.vertices.elementAt(30);
      expect(vertex_7_30, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, -74.8821)));
      final vertex_7_31 = mesh_7.vertices.elementAt(31);
      expect(vertex_7_31, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, -99.7065)));
      final vertex_7_32 = mesh_7.vertices.elementAt(32);
      expect(vertex_7_32, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, -100.768)));
      final vertex_7_33 = mesh_7.vertices.elementAt(33);
      expect(vertex_7_33, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, -74.8821)));
      final vertex_7_34 = mesh_7.vertices.elementAt(34);
      expect(vertex_7_34, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, -100.768)));
      final vertex_7_35 = mesh_7.vertices.elementAt(35);
      expect(vertex_7_35, vector3MoreOrLessEquals(Vector3(-1.5147, 14.1058, -77.0357)));
      final vertex_7_36 = mesh_7.vertices.elementAt(36);
      expect(vertex_7_36, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, -99.7065)));
      final vertex_7_37 = mesh_7.vertices.elementAt(37);
      expect(vertex_7_37, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, -106.198)));
      final vertex_7_38 = mesh_7.vertices.elementAt(38);
      expect(vertex_7_38, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, -100.768)));
      final vertex_7_39 = mesh_7.vertices.elementAt(39);
      expect(vertex_7_39, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, -106.198)));
      final vertex_7_40 = mesh_7.vertices.elementAt(40);
      expect(vertex_7_40, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, -106.51)));
      final vertex_7_41 = mesh_7.vertices.elementAt(41);
      expect(vertex_7_41, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, -100.768)));
      final vertex_7_42 = mesh_7.vertices.elementAt(42);
      expect(vertex_7_42, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -14.1125)));
      final vertex_7_43 = mesh_7.vertices.elementAt(43);
      expect(vertex_7_43, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -15.8535)));
      final vertex_7_44 = mesh_7.vertices.elementAt(44);
      expect(vertex_7_44, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_45 = mesh_7.vertices.elementAt(45);
      expect(vertex_7_45, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, -106.51)));
      final vertex_7_46 = mesh_7.vertices.elementAt(46);
      expect(vertex_7_46, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_47 = mesh_7.vertices.elementAt(47);
      expect(vertex_7_47, vector3MoreOrLessEquals(Vector3(4.58776, -39.3502, -106.691)));
      final vertex_7_48 = mesh_7.vertices.elementAt(48);
      expect(vertex_7_48, vector3MoreOrLessEquals(Vector3(-26.4664, -2.24616, -14.1125)));
      final vertex_7_49 = mesh_7.vertices.elementAt(49);
      expect(vertex_7_49, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, -31.176)));
      final vertex_7_50 = mesh_7.vertices.elementAt(50);
      expect(vertex_7_50, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -15.8535)));
      final vertex_7_51 = mesh_7.vertices.elementAt(51);
      expect(vertex_7_51, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, -31.176)));
      final vertex_7_52 = mesh_7.vertices.elementAt(52);
      expect(vertex_7_52, vector3MoreOrLessEquals(Vector3(-18.5514, 8.96432, -31.3467)));
      final vertex_7_53 = mesh_7.vertices.elementAt(53);
      expect(vertex_7_53, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -15.8535)));
      final vertex_7_54 = mesh_7.vertices.elementAt(54);
      expect(vertex_7_54, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, -31.176)));
      final vertex_7_55 = mesh_7.vertices.elementAt(55);
      expect(vertex_7_55, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, -46.2119)));
      final vertex_7_56 = mesh_7.vertices.elementAt(56);
      expect(vertex_7_56, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, -46.4584)));
      final vertex_7_57 = mesh_7.vertices.elementAt(57);
      expect(vertex_7_57, vector3MoreOrLessEquals(Vector3(-16.2584, 8.70439, -31.176)));
      final vertex_7_58 = mesh_7.vertices.elementAt(58);
      expect(vertex_7_58, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, -46.4584)));
      final vertex_7_59 = mesh_7.vertices.elementAt(59);
      expect(vertex_7_59, vector3MoreOrLessEquals(Vector3(-18.5514, 8.96432, -31.3467)));
      final vertex_7_60 = mesh_7.vertices.elementAt(60);
      expect(vertex_7_60, vector3MoreOrLessEquals(Vector3(-13.1525, 29.5003, -46.2119)));
      final vertex_7_61 = mesh_7.vertices.elementAt(61);
      expect(vertex_7_61, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, -50.9928)));
      final vertex_7_62 = mesh_7.vertices.elementAt(62);
      expect(vertex_7_62, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, -46.4584)));
      final vertex_7_63 = mesh_7.vertices.elementAt(63);
      expect(vertex_7_63, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, -50.9928)));
      final vertex_7_64 = mesh_7.vertices.elementAt(64);
      expect(vertex_7_64, vector3MoreOrLessEquals(Vector3(-13.3946, 29.5602, -51.8266)));
      final vertex_7_65 = mesh_7.vertices.elementAt(65);
      expect(vertex_7_65, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, -46.4584)));
      final vertex_7_66 = mesh_7.vertices.elementAt(66);
      expect(vertex_7_66, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, -50.9928)));
      final vertex_7_67 = mesh_7.vertices.elementAt(67);
      expect(vertex_7_67, vector3MoreOrLessEquals(Vector3(-1.5147, 14.1058, -77.0357)));
      final vertex_7_68 = mesh_7.vertices.elementAt(68);
      expect(vertex_7_68, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, -78.0563)));
      final vertex_7_69 = mesh_7.vertices.elementAt(69);
      expect(vertex_7_69, vector3MoreOrLessEquals(Vector3(-11.265, 29.2079, -50.9928)));
      final vertex_7_70 = mesh_7.vertices.elementAt(70);
      expect(vertex_7_70, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, -78.0563)));
      final vertex_7_71 = mesh_7.vertices.elementAt(71);
      expect(vertex_7_71, vector3MoreOrLessEquals(Vector3(-13.3946, 29.5602, -51.8266)));
      final vertex_7_72 = mesh_7.vertices.elementAt(72);
      expect(vertex_7_72, vector3MoreOrLessEquals(Vector3(-1.5147, 14.1058, -77.0357)));
      final vertex_7_73 = mesh_7.vertices.elementAt(73);
      expect(vertex_7_73, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, -100.768)));
      final vertex_7_74 = mesh_7.vertices.elementAt(74);
      expect(vertex_7_74, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, -78.0563)));
      final vertex_7_75 = mesh_7.vertices.elementAt(75);
      expect(vertex_7_75, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, -100.768)));
      final vertex_7_76 = mesh_7.vertices.elementAt(76);
      expect(vertex_7_76, vector3MoreOrLessEquals(Vector3(2.445, -29.5186, -101.251)));
      final vertex_7_77 = mesh_7.vertices.elementAt(77);
      expect(vertex_7_77, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, -78.0563)));
      final vertex_7_78 = mesh_7.vertices.elementAt(78);
      expect(vertex_7_78, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, -100.768)));
      final vertex_7_79 = mesh_7.vertices.elementAt(79);
      expect(vertex_7_79, vector3MoreOrLessEquals(Vector3(5.03911, -39.4551, -106.51)));
      final vertex_7_80 = mesh_7.vertices.elementAt(80);
      expect(vertex_7_80, vector3MoreOrLessEquals(Vector3(4.58776, -39.3502, -106.691)));
      final vertex_7_81 = mesh_7.vertices.elementAt(81);
      expect(vertex_7_81, vector3MoreOrLessEquals(Vector3(3.38557, -29.8435, -100.768)));
      final vertex_7_82 = mesh_7.vertices.elementAt(82);
      expect(vertex_7_82, vector3MoreOrLessEquals(Vector3(4.58776, -39.3502, -106.691)));
      final vertex_7_83 = mesh_7.vertices.elementAt(83);
      expect(vertex_7_83, vector3MoreOrLessEquals(Vector3(2.445, -29.5186, -101.251)));
      final vertex_7_84 = mesh_7.vertices.elementAt(84);
      expect(vertex_7_84, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -15.8535)));
      final vertex_7_85 = mesh_7.vertices.elementAt(85);
      expect(vertex_7_85, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -19.0986)));
      final vertex_7_86 = mesh_7.vertices.elementAt(86);
      expect(vertex_7_86, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_87 = mesh_7.vertices.elementAt(87);
      expect(vertex_7_87, vector3MoreOrLessEquals(Vector3(4.58776, -39.3502, -106.691)));
      final vertex_7_88 = mesh_7.vertices.elementAt(88);
      expect(vertex_7_88, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_89 = mesh_7.vertices.elementAt(89);
      expect(vertex_7_89, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, -106.605)));
      final vertex_7_90 = mesh_7.vertices.elementAt(90);
      expect(vertex_7_90, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -15.8535)));
      final vertex_7_91 = mesh_7.vertices.elementAt(91);
      expect(vertex_7_91, vector3MoreOrLessEquals(Vector3(-18.5514, 8.96432, -31.3467)));
      final vertex_7_92 = mesh_7.vertices.elementAt(92);
      expect(vertex_7_92, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, -32.847)));
      final vertex_7_93 = mesh_7.vertices.elementAt(93);
      expect(vertex_7_93, vector3MoreOrLessEquals(Vector3(-29.4303, -1.92132, -15.8535)));
      final vertex_7_94 = mesh_7.vertices.elementAt(94);
      expect(vertex_7_94, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, -32.847)));
      final vertex_7_95 = mesh_7.vertices.elementAt(95);
      expect(vertex_7_95, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -19.0986)));
      final vertex_7_96 = mesh_7.vertices.elementAt(96);
      expect(vertex_7_96, vector3MoreOrLessEquals(Vector3(-18.5514, 8.96432, -31.3467)));
      final vertex_7_97 = mesh_7.vertices.elementAt(97);
      expect(vertex_7_97, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, -46.4584)));
      final vertex_7_98 = mesh_7.vertices.elementAt(98);
      expect(vertex_7_98, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, -32.847)));
      final vertex_7_99 = mesh_7.vertices.elementAt(99);
      expect(vertex_7_99, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, -46.4584)));
      final vertex_7_100 = mesh_7.vertices.elementAt(100);
      expect(vertex_7_100, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, -46.9645)));
      final vertex_7_101 = mesh_7.vertices.elementAt(101);
      expect(vertex_7_101, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, -32.847)));
      final vertex_7_102 = mesh_7.vertices.elementAt(102);
      expect(vertex_7_102, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, -46.4584)));
      final vertex_7_103 = mesh_7.vertices.elementAt(103);
      expect(vertex_7_103, vector3MoreOrLessEquals(Vector3(-13.3946, 29.5602, -51.8266)));
      final vertex_7_104 = mesh_7.vertices.elementAt(104);
      expect(vertex_7_104, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, -51.4691)));
      final vertex_7_105 = mesh_7.vertices.elementAt(105);
      expect(vertex_7_105, vector3MoreOrLessEquals(Vector3(-14.5093, 29.8275, -46.4584)));
      final vertex_7_106 = mesh_7.vertices.elementAt(106);
      expect(vertex_7_106, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, -51.4691)));
      final vertex_7_107 = mesh_7.vertices.elementAt(107);
      expect(vertex_7_107, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, -46.9645)));
      final vertex_7_108 = mesh_7.vertices.elementAt(108);
      expect(vertex_7_108, vector3MoreOrLessEquals(Vector3(-13.3946, 29.5602, -51.8266)));
      final vertex_7_109 = mesh_7.vertices.elementAt(109);
      expect(vertex_7_109, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, -78.0563)));
      final vertex_7_110 = mesh_7.vertices.elementAt(110);
      expect(vertex_7_110, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, -51.4691)));
      final vertex_7_111 = mesh_7.vertices.elementAt(111);
      expect(vertex_7_111, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, -78.0563)));
      final vertex_7_112 = mesh_7.vertices.elementAt(112);
      expect(vertex_7_112, vector3MoreOrLessEquals(Vector3(-5.65842, 13.6618, -77.1753)));
      final vertex_7_113 = mesh_7.vertices.elementAt(113);
      expect(vertex_7_113, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, -51.4691)));
      final vertex_7_114 = mesh_7.vertices.elementAt(114);
      expect(vertex_7_114, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, -78.0563)));
      final vertex_7_115 = mesh_7.vertices.elementAt(115);
      expect(vertex_7_115, vector3MoreOrLessEquals(Vector3(2.445, -29.5186, -101.251)));
      final vertex_7_116 = mesh_7.vertices.elementAt(116);
      expect(vertex_7_116, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, -100.792)));
      final vertex_7_117 = mesh_7.vertices.elementAt(117);
      expect(vertex_7_117, vector3MoreOrLessEquals(Vector3(-3.58909, 14.2065, -78.0563)));
      final vertex_7_118 = mesh_7.vertices.elementAt(118);
      expect(vertex_7_118, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, -100.792)));
      final vertex_7_119 = mesh_7.vertices.elementAt(119);
      expect(vertex_7_119, vector3MoreOrLessEquals(Vector3(-5.65842, 13.6618, -77.1753)));
      final vertex_7_120 = mesh_7.vertices.elementAt(120);
      expect(vertex_7_120, vector3MoreOrLessEquals(Vector3(2.445, -29.5186, -101.251)));
      final vertex_7_121 = mesh_7.vertices.elementAt(121);
      expect(vertex_7_121, vector3MoreOrLessEquals(Vector3(4.58776, -39.3502, -106.691)));
      final vertex_7_122 = mesh_7.vertices.elementAt(122);
      expect(vertex_7_122, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, -100.792)));
      final vertex_7_123 = mesh_7.vertices.elementAt(123);
      expect(vertex_7_123, vector3MoreOrLessEquals(Vector3(4.58776, -39.3502, -106.691)));
      final vertex_7_124 = mesh_7.vertices.elementAt(124);
      expect(vertex_7_124, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, -106.605)));
      final vertex_7_125 = mesh_7.vertices.elementAt(125);
      expect(vertex_7_125, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, -100.792)));
      final vertex_7_126 = mesh_7.vertices.elementAt(126);
      expect(vertex_7_126, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -19.0986)));
      final vertex_7_127 = mesh_7.vertices.elementAt(127);
      expect(vertex_7_127, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, -21.4041)));
      final vertex_7_128 = mesh_7.vertices.elementAt(128);
      expect(vertex_7_128, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_129 = mesh_7.vertices.elementAt(129);
      expect(vertex_7_129, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, -106.605)));
      final vertex_7_130 = mesh_7.vertices.elementAt(130);
      expect(vertex_7_130, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_131 = mesh_7.vertices.elementAt(131);
      expect(vertex_7_131, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, -106.316)));
      final vertex_7_132 = mesh_7.vertices.elementAt(132);
      expect(vertex_7_132, vector3MoreOrLessEquals(Vector3(-30.1543, -2.74297, -19.0986)));
      final vertex_7_133 = mesh_7.vertices.elementAt(133);
      expect(vertex_7_133, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, -32.847)));
      final vertex_7_134 = mesh_7.vertices.elementAt(134);
      expect(vertex_7_134, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, -21.4041)));
      final vertex_7_135 = mesh_7.vertices.elementAt(135);
      expect(vertex_7_135, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, -32.847)));
      final vertex_7_136 = mesh_7.vertices.elementAt(136);
      expect(vertex_7_136, vector3MoreOrLessEquals(Vector3(-19.5314, 6.4777, -34.5472)));
      final vertex_7_137 = mesh_7.vertices.elementAt(137);
      expect(vertex_7_137, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, -21.4041)));
      final vertex_7_138 = mesh_7.vertices.elementAt(138);
      expect(vertex_7_138, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, -32.847)));
      final vertex_7_139 = mesh_7.vertices.elementAt(139);
      expect(vertex_7_139, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, -46.9645)));
      final vertex_7_140 = mesh_7.vertices.elementAt(140);
      expect(vertex_7_140, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_141 = mesh_7.vertices.elementAt(141);
      expect(vertex_7_141, vector3MoreOrLessEquals(Vector3(-20.0081, 7.97335, -32.847)));
      final vertex_7_142 = mesh_7.vertices.elementAt(142);
      expect(vertex_7_142, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_143 = mesh_7.vertices.elementAt(143);
      expect(vertex_7_143, vector3MoreOrLessEquals(Vector3(-19.5314, 6.4777, -34.5472)));
      final vertex_7_144 = mesh_7.vertices.elementAt(144);
      expect(vertex_7_144, vector3MoreOrLessEquals(Vector3(-15.4755, 28.752, -46.9645)));
      final vertex_7_145 = mesh_7.vertices.elementAt(145);
      expect(vertex_7_145, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, -51.4691)));
      final vertex_7_146 = mesh_7.vertices.elementAt(146);
      expect(vertex_7_146, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_147 = mesh_7.vertices.elementAt(147);
      expect(vertex_7_147, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, -51.4691)));
      final vertex_7_148 = mesh_7.vertices.elementAt(148);
      expect(vertex_7_148, vector3MoreOrLessEquals(Vector3(-15.5666, 26.3996, -50.1895)));
      final vertex_7_149 = mesh_7.vertices.elementAt(149);
      expect(vertex_7_149, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_150 = mesh_7.vertices.elementAt(150);
      expect(vertex_7_150, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, -51.4691)));
      final vertex_7_151 = mesh_7.vertices.elementAt(151);
      expect(vertex_7_151, vector3MoreOrLessEquals(Vector3(-5.65842, 13.6618, -77.1753)));
      final vertex_7_152 = mesh_7.vertices.elementAt(152);
      expect(vertex_7_152, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, -75.0563)));
      final vertex_7_153 = mesh_7.vertices.elementAt(153);
      expect(vertex_7_153, vector3MoreOrLessEquals(Vector3(-15.309, 28.3104, -51.4691)));
      final vertex_7_154 = mesh_7.vertices.elementAt(154);
      expect(vertex_7_154, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, -75.0563)));
      final vertex_7_155 = mesh_7.vertices.elementAt(155);
      expect(vertex_7_155, vector3MoreOrLessEquals(Vector3(-15.5666, 26.3996, -50.1895)));
      final vertex_7_156 = mesh_7.vertices.elementAt(156);
      expect(vertex_7_156, vector3MoreOrLessEquals(Vector3(-5.65842, 13.6618, -77.1753)));
      final vertex_7_157 = mesh_7.vertices.elementAt(157);
      expect(vertex_7_157, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, -100.792)));
      final vertex_7_158 = mesh_7.vertices.elementAt(158);
      expect(vertex_7_158, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, -75.0563)));
      final vertex_7_159 = mesh_7.vertices.elementAt(159);
      expect(vertex_7_159, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, -100.792)));
      final vertex_7_160 = mesh_7.vertices.elementAt(160);
      expect(vertex_7_160, vector3MoreOrLessEquals(Vector3(1.40262, -32.3836, -99.7363)));
      final vertex_7_161 = mesh_7.vertices.elementAt(161);
      expect(vertex_7_161, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, -75.0563)));
      final vertex_7_162 = mesh_7.vertices.elementAt(162);
      expect(vertex_7_162, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, -100.792)));
      final vertex_7_163 = mesh_7.vertices.elementAt(163);
      expect(vertex_7_163, vector3MoreOrLessEquals(Vector3(4.19709, -39.7477, -106.605)));
      final vertex_7_164 = mesh_7.vertices.elementAt(164);
      expect(vertex_7_164, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, -106.316)));
      final vertex_7_165 = mesh_7.vertices.elementAt(165);
      expect(vertex_7_165, vector3MoreOrLessEquals(Vector3(1.56249, -30.649, -100.792)));
      final vertex_7_166 = mesh_7.vertices.elementAt(166);
      expect(vertex_7_166, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, -106.316)));
      final vertex_7_167 = mesh_7.vertices.elementAt(167);
      expect(vertex_7_167, vector3MoreOrLessEquals(Vector3(1.40262, -32.3836, -99.7363)));
      final vertex_7_168 = mesh_7.vertices.elementAt(168);
      expect(vertex_7_168, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, -21.4041)));
      final vertex_7_169 = mesh_7.vertices.elementAt(169);
      expect(vertex_7_169, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, -21.034)));
      final vertex_7_170 = mesh_7.vertices.elementAt(170);
      expect(vertex_7_170, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_171 = mesh_7.vertices.elementAt(171);
      expect(vertex_7_171, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, -106.316)));
      final vertex_7_172 = mesh_7.vertices.elementAt(172);
      expect(vertex_7_172, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_173 = mesh_7.vertices.elementAt(173);
      expect(vertex_7_173, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, -106.043)));
      final vertex_7_174 = mesh_7.vertices.elementAt(174);
      expect(vertex_7_174, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, -21.4041)));
      final vertex_7_175 = mesh_7.vertices.elementAt(175);
      expect(vertex_7_175, vector3MoreOrLessEquals(Vector3(-19.5314, 6.4777, -34.5472)));
      final vertex_7_176 = mesh_7.vertices.elementAt(176);
      expect(vertex_7_176, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, -35.167)));
      final vertex_7_177 = mesh_7.vertices.elementAt(177);
      expect(vertex_7_177, vector3MoreOrLessEquals(Vector3(-28.0933, -4.0924, -21.4041)));
      final vertex_7_178 = mesh_7.vertices.elementAt(178);
      expect(vertex_7_178, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, -35.167)));
      final vertex_7_179 = mesh_7.vertices.elementAt(179);
      expect(vertex_7_179, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, -21.034)));
      final vertex_7_180 = mesh_7.vertices.elementAt(180);
      expect(vertex_7_180, vector3MoreOrLessEquals(Vector3(-19.5314, 6.4777, -34.5472)));
      final vertex_7_181 = mesh_7.vertices.elementAt(181);
      expect(vertex_7_181, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_182 = mesh_7.vertices.elementAt(182);
      expect(vertex_7_182, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, -35.167)));
      final vertex_7_183 = mesh_7.vertices.elementAt(183);
      expect(vertex_7_183, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_184 = mesh_7.vertices.elementAt(184);
      expect(vertex_7_184, vector3MoreOrLessEquals(Vector3(-14.1676, 26.0791, -47.3223)));
      final vertex_7_185 = mesh_7.vertices.elementAt(185);
      expect(vertex_7_185, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, -35.167)));
      final vertex_7_186 = mesh_7.vertices.elementAt(186);
      expect(vertex_7_186, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_187 = mesh_7.vertices.elementAt(187);
      expect(vertex_7_187, vector3MoreOrLessEquals(Vector3(-15.5666, 26.3996, -50.1895)));
      final vertex_7_188 = mesh_7.vertices.elementAt(188);
      expect(vertex_7_188, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, -48.9514)));
      final vertex_7_189 = mesh_7.vertices.elementAt(189);
      expect(vertex_7_189, vector3MoreOrLessEquals(Vector3(-15.3234, 27.0838, -47.3489)));
      final vertex_7_190 = mesh_7.vertices.elementAt(190);
      expect(vertex_7_190, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, -48.9514)));
      final vertex_7_191 = mesh_7.vertices.elementAt(191);
      expect(vertex_7_191, vector3MoreOrLessEquals(Vector3(-14.1676, 26.0791, -47.3223)));
      final vertex_7_192 = mesh_7.vertices.elementAt(192);
      expect(vertex_7_192, vector3MoreOrLessEquals(Vector3(-15.5666, 26.3996, -50.1895)));
      final vertex_7_193 = mesh_7.vertices.elementAt(193);
      expect(vertex_7_193, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, -75.0563)));
      final vertex_7_194 = mesh_7.vertices.elementAt(194);
      expect(vertex_7_194, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, -48.9514)));
      final vertex_7_195 = mesh_7.vertices.elementAt(195);
      expect(vertex_7_195, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, -75.0563)));
      final vertex_7_196 = mesh_7.vertices.elementAt(196);
      expect(vertex_7_196, vector3MoreOrLessEquals(Vector3(-4.72603, 12.454, -73.2947)));
      final vertex_7_197 = mesh_7.vertices.elementAt(197);
      expect(vertex_7_197, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, -48.9514)));
      final vertex_7_198 = mesh_7.vertices.elementAt(198);
      expect(vertex_7_198, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, -75.0563)));
      final vertex_7_199 = mesh_7.vertices.elementAt(199);
      expect(vertex_7_199, vector3MoreOrLessEquals(Vector3(1.40262, -32.3836, -99.7363)));
      final vertex_7_200 = mesh_7.vertices.elementAt(200);
      expect(vertex_7_200, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, -98.8791)));
      final vertex_7_201 = mesh_7.vertices.elementAt(201);
      expect(vertex_7_201, vector3MoreOrLessEquals(Vector3(-6.16439, 12.8818, -75.0563)));
      final vertex_7_202 = mesh_7.vertices.elementAt(202);
      expect(vertex_7_202, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, -98.8791)));
      final vertex_7_203 = mesh_7.vertices.elementAt(203);
      expect(vertex_7_203, vector3MoreOrLessEquals(Vector3(-4.72603, 12.454, -73.2947)));
      final vertex_7_204 = mesh_7.vertices.elementAt(204);
      expect(vertex_7_204, vector3MoreOrLessEquals(Vector3(1.40262, -32.3836, -99.7363)));
      final vertex_7_205 = mesh_7.vertices.elementAt(205);
      expect(vertex_7_205, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, -106.316)));
      final vertex_7_206 = mesh_7.vertices.elementAt(206);
      expect(vertex_7_206, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, -98.8791)));
      final vertex_7_207 = mesh_7.vertices.elementAt(207);
      expect(vertex_7_207, vector3MoreOrLessEquals(Vector3(4.16131, -40.3484, -106.316)));
      final vertex_7_208 = mesh_7.vertices.elementAt(208);
      expect(vertex_7_208, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, -106.043)));
      final vertex_7_209 = mesh_7.vertices.elementAt(209);
      expect(vertex_7_209, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, -98.8791)));
      final vertex_7_210 = mesh_7.vertices.elementAt(210);
      expect(vertex_7_210, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, -21.034)));
      final vertex_7_211 = mesh_7.vertices.elementAt(211);
      expect(vertex_7_211, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -18.2669)));
      final vertex_7_212 = mesh_7.vertices.elementAt(212);
      expect(vertex_7_212, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_213 = mesh_7.vertices.elementAt(213);
      expect(vertex_7_213, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, -106.043)));
      final vertex_7_214 = mesh_7.vertices.elementAt(214);
      expect(vertex_7_214, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_215 = mesh_7.vertices.elementAt(215);
      expect(vertex_7_215, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, -105.99)));
      final vertex_7_216 = mesh_7.vertices.elementAt(216);
      expect(vertex_7_216, vector3MoreOrLessEquals(Vector3(-24.7991, -4.95347, -21.034)));
      final vertex_7_217 = mesh_7.vertices.elementAt(217);
      expect(vertex_7_217, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, -35.167)));
      final vertex_7_218 = mesh_7.vertices.elementAt(218);
      expect(vertex_7_218, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -18.2669)));
      final vertex_7_219 = mesh_7.vertices.elementAt(219);
      expect(vertex_7_219, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, -35.167)));
      final vertex_7_220 = mesh_7.vertices.elementAt(220);
      expect(vertex_7_220, vector3MoreOrLessEquals(Vector3(-15.3994, 6.00928, -34.2396)));
      final vertex_7_221 = mesh_7.vertices.elementAt(221);
      expect(vertex_7_221, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -18.2669)));
      final vertex_7_222 = mesh_7.vertices.elementAt(222);
      expect(vertex_7_222, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, -35.167)));
      final vertex_7_223 = mesh_7.vertices.elementAt(223);
      expect(vertex_7_223, vector3MoreOrLessEquals(Vector3(-14.1676, 26.0791, -47.3223)));
      final vertex_7_224 = mesh_7.vertices.elementAt(224);
      expect(vertex_7_224, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, -46.9046)));
      final vertex_7_225 = mesh_7.vertices.elementAt(225);
      expect(vertex_7_225, vector3MoreOrLessEquals(Vector3(-17.4804, 5.60359, -35.167)));
      final vertex_7_226 = mesh_7.vertices.elementAt(226);
      expect(vertex_7_226, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, -46.9046)));
      final vertex_7_227 = mesh_7.vertices.elementAt(227);
      expect(vertex_7_227, vector3MoreOrLessEquals(Vector3(-15.3994, 6.00928, -34.2396)));
      final vertex_7_228 = mesh_7.vertices.elementAt(228);
      expect(vertex_7_228, vector3MoreOrLessEquals(Vector3(-14.1676, 26.0791, -47.3223)));
      final vertex_7_229 = mesh_7.vertices.elementAt(229);
      expect(vertex_7_229, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, -48.9514)));
      final vertex_7_230 = mesh_7.vertices.elementAt(230);
      expect(vertex_7_230, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, -46.9046)));
      final vertex_7_231 = mesh_7.vertices.elementAt(231);
      expect(vertex_7_231, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, -48.9514)));
      final vertex_7_232 = mesh_7.vertices.elementAt(232);
      expect(vertex_7_232, vector3MoreOrLessEquals(Vector3(-11.729, 25.7647, -48.6871)));
      final vertex_7_233 = mesh_7.vertices.elementAt(233);
      expect(vertex_7_233, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, -46.9046)));
      final vertex_7_234 = mesh_7.vertices.elementAt(234);
      expect(vertex_7_234, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, -48.9514)));
      final vertex_7_235 = mesh_7.vertices.elementAt(235);
      expect(vertex_7_235, vector3MoreOrLessEquals(Vector3(-4.72603, 12.454, -73.2947)));
      final vertex_7_236 = mesh_7.vertices.elementAt(236);
      expect(vertex_7_236, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, -73.2173)));
      final vertex_7_237 = mesh_7.vertices.elementAt(237);
      expect(vertex_7_237, vector3MoreOrLessEquals(Vector3(-13.9733, 25.2666, -48.9514)));
      final vertex_7_238 = mesh_7.vertices.elementAt(238);
      expect(vertex_7_238, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, -73.2173)));
      final vertex_7_239 = mesh_7.vertices.elementAt(239);
      expect(vertex_7_239, vector3MoreOrLessEquals(Vector3(-11.729, 25.7647, -48.6871)));
      final vertex_7_240 = mesh_7.vertices.elementAt(240);
      expect(vertex_7_240, vector3MoreOrLessEquals(Vector3(-4.72603, 12.454, -73.2947)));
      final vertex_7_241 = mesh_7.vertices.elementAt(241);
      expect(vertex_7_241, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, -98.8791)));
      final vertex_7_242 = mesh_7.vertices.elementAt(242);
      expect(vertex_7_242, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, -73.2173)));
      final vertex_7_243 = mesh_7.vertices.elementAt(243);
      expect(vertex_7_243, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, -98.8791)));
      final vertex_7_244 = mesh_7.vertices.elementAt(244);
      expect(vertex_7_244, vector3MoreOrLessEquals(Vector3(3.09747, -32.9692, -98.8659)));
      final vertex_7_245 = mesh_7.vertices.elementAt(245);
      expect(vertex_7_245, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, -73.2173)));
      final vertex_7_246 = mesh_7.vertices.elementAt(246);
      expect(vertex_7_246, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, -98.8791)));
      final vertex_7_247 = mesh_7.vertices.elementAt(247);
      expect(vertex_7_247, vector3MoreOrLessEquals(Vector3(4.50732, -40.6998, -106.043)));
      final vertex_7_248 = mesh_7.vertices.elementAt(248);
      expect(vertex_7_248, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, -105.99)));
      final vertex_7_249 = mesh_7.vertices.elementAt(249);
      expect(vertex_7_249, vector3MoreOrLessEquals(Vector3(2.08576, -33.4162, -98.8791)));
      final vertex_7_250 = mesh_7.vertices.elementAt(250);
      expect(vertex_7_250, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, -105.99)));
      final vertex_7_251 = mesh_7.vertices.elementAt(251);
      expect(vertex_7_251, vector3MoreOrLessEquals(Vector3(3.09747, -32.9692, -98.8659)));
      final vertex_7_252 = mesh_7.vertices.elementAt(252);
      expect(vertex_7_252, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -18.2669)));
      final vertex_7_253 = mesh_7.vertices.elementAt(253);
      expect(vertex_7_253, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -15.1865)));
      final vertex_7_254 = mesh_7.vertices.elementAt(254);
      expect(vertex_7_254, vector3MoreOrLessEquals(Vector3(-26.4558, -3.44384, -17.8509)));
      final vertex_7_255 = mesh_7.vertices.elementAt(255);
      expect(vertex_7_255, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, -105.99)));
      final vertex_7_256 = mesh_7.vertices.elementAt(256);
      expect(vertex_7_256, vector3MoreOrLessEquals(Vector3(4.66834, -40.0175, -106.336)));
      final vertex_7_257 = mesh_7.vertices.elementAt(257);
      expect(vertex_7_257, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, -106.198)));
      final vertex_7_258 = mesh_7.vertices.elementAt(258);
      expect(vertex_7_258, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -18.2669)));
      final vertex_7_259 = mesh_7.vertices.elementAt(259);
      expect(vertex_7_259, vector3MoreOrLessEquals(Vector3(-15.3994, 6.00928, -34.2396)));
      final vertex_7_260 = mesh_7.vertices.elementAt(260);
      expect(vertex_7_260, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, -32.4635)));
      final vertex_7_261 = mesh_7.vertices.elementAt(261);
      expect(vertex_7_261, vector3MoreOrLessEquals(Vector3(-22.7525, -4.67776, -18.2669)));
      final vertex_7_262 = mesh_7.vertices.elementAt(262);
      expect(vertex_7_262, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, -32.4635)));
      final vertex_7_263 = mesh_7.vertices.elementAt(263);
      expect(vertex_7_263, vector3MoreOrLessEquals(Vector3(-23.4945, -3.47289, -15.1865)));
      final vertex_7_264 = mesh_7.vertices.elementAt(264);
      expect(vertex_7_264, vector3MoreOrLessEquals(Vector3(-15.3994, 6.00928, -34.2396)));
      final vertex_7_265 = mesh_7.vertices.elementAt(265);
      expect(vertex_7_265, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, -46.9046)));
      final vertex_7_266 = mesh_7.vertices.elementAt(266);
      expect(vertex_7_266, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, -32.4635)));
      final vertex_7_267 = mesh_7.vertices.elementAt(267);
      expect(vertex_7_267, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, -46.9046)));
      final vertex_7_268 = mesh_7.vertices.elementAt(268);
      expect(vertex_7_268, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, -46.4104)));
      final vertex_7_269 = mesh_7.vertices.elementAt(269);
      expect(vertex_7_269, vector3MoreOrLessEquals(Vector3(-14.8556, 7.38926, -32.4635)));
      final vertex_7_270 = mesh_7.vertices.elementAt(270);
      expect(vertex_7_270, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, -46.9046)));
      final vertex_7_271 = mesh_7.vertices.elementAt(271);
      expect(vertex_7_271, vector3MoreOrLessEquals(Vector3(-11.729, 25.7647, -48.6871)));
      final vertex_7_272 = mesh_7.vertices.elementAt(272);
      expect(vertex_7_272, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, -49.5956)));
      final vertex_7_273 = mesh_7.vertices.elementAt(273);
      expect(vertex_7_273, vector3MoreOrLessEquals(Vector3(-12.8784, 26.4944, -46.9046)));
      final vertex_7_274 = mesh_7.vertices.elementAt(274);
      expect(vertex_7_274, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, -49.5956)));
      final vertex_7_275 = mesh_7.vertices.elementAt(275);
      expect(vertex_7_275, vector3MoreOrLessEquals(Vector3(-12.4267, 28.017, -46.4104)));
      final vertex_7_276 = mesh_7.vertices.elementAt(276);
      expect(vertex_7_276, vector3MoreOrLessEquals(Vector3(-11.729, 25.7647, -48.6871)));
      final vertex_7_277 = mesh_7.vertices.elementAt(277);
      expect(vertex_7_277, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, -73.2173)));
      final vertex_7_278 = mesh_7.vertices.elementAt(278);
      expect(vertex_7_278, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, -49.5956)));
      final vertex_7_279 = mesh_7.vertices.elementAt(279);
      expect(vertex_7_279, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, -73.2173)));
      final vertex_7_280 = mesh_7.vertices.elementAt(280);
      expect(vertex_7_280, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, -74.8821)));
      final vertex_7_281 = mesh_7.vertices.elementAt(281);
      expect(vertex_7_281, vector3MoreOrLessEquals(Vector3(-10.5237, 27.5188, -49.5956)));
      final vertex_7_282 = mesh_7.vertices.elementAt(282);
      expect(vertex_7_282, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, -73.2173)));
      final vertex_7_283 = mesh_7.vertices.elementAt(283);
      expect(vertex_7_283, vector3MoreOrLessEquals(Vector3(3.09747, -32.9692, -98.8659)));
      final vertex_7_284 = mesh_7.vertices.elementAt(284);
      expect(vertex_7_284, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, -99.7065)));
      final vertex_7_285 = mesh_7.vertices.elementAt(285);
      expect(vertex_7_285, vector3MoreOrLessEquals(Vector3(-2.42644, 12.7004, -73.2173)));
      final vertex_7_286 = mesh_7.vertices.elementAt(286);
      expect(vertex_7_286, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, -99.7065)));
      final vertex_7_287 = mesh_7.vertices.elementAt(287);
      expect(vertex_7_287, vector3MoreOrLessEquals(Vector3(-0.997257, 13.4356, -74.8821)));
      final vertex_7_288 = mesh_7.vertices.elementAt(288);
      expect(vertex_7_288, vector3MoreOrLessEquals(Vector3(3.09747, -32.9692, -98.8659)));
      final vertex_7_289 = mesh_7.vertices.elementAt(289);
      expect(vertex_7_289, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, -105.99)));
      final vertex_7_290 = mesh_7.vertices.elementAt(290);
      expect(vertex_7_290, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, -99.7065)));
      final vertex_7_291 = mesh_7.vertices.elementAt(291);
      expect(vertex_7_291, vector3MoreOrLessEquals(Vector3(4.97457, -40.5375, -105.99)));
      final vertex_7_292 = mesh_7.vertices.elementAt(292);
      expect(vertex_7_292, vector3MoreOrLessEquals(Vector3(5.21123, -39.9835, -106.198)));
      final vertex_7_293 = mesh_7.vertices.elementAt(293);
      expect(vertex_7_293, vector3MoreOrLessEquals(Vector3(3.67597, -31.3792, -99.7065)));
      expect(mesh_7.normals.length, equals(294));
      final normal_7_0 = mesh_7.normals.elementAt(0);
      expect(normal_7_0, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_1 = mesh_7.normals.elementAt(1);
      expect(normal_7_1, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_2 = mesh_7.normals.elementAt(2);
      expect(normal_7_2, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_3 = mesh_7.normals.elementAt(3);
      expect(normal_7_3, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_4 = mesh_7.normals.elementAt(4);
      expect(normal_7_4, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_5 = mesh_7.normals.elementAt(5);
      expect(normal_7_5, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_6 = mesh_7.normals.elementAt(6);
      expect(normal_7_6, vector3MoreOrLessEquals(Vector3(0.795449, 0.228463, 0.561307)));
      final normal_7_7 = mesh_7.normals.elementAt(7);
      expect(normal_7_7, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, 0.223412)));
      final normal_7_8 = mesh_7.normals.elementAt(8);
      expect(normal_7_8, vector3MoreOrLessEquals(Vector3(0.375318, 0.601842, 0.704927)));
      final normal_7_9 = mesh_7.normals.elementAt(9);
      expect(normal_7_9, vector3MoreOrLessEquals(Vector3(0.795449, 0.228463, 0.561307)));
      final normal_7_10 = mesh_7.normals.elementAt(10);
      expect(normal_7_10, vector3MoreOrLessEquals(Vector3(0.375318, 0.601842, 0.704927)));
      final normal_7_11 = mesh_7.normals.elementAt(11);
      expect(normal_7_11, vector3MoreOrLessEquals(Vector3(0.164332, 0.782548, 0.600511)));
      final normal_7_12 = mesh_7.normals.elementAt(12);
      expect(normal_7_12, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, 0.223412)));
      final normal_7_13 = mesh_7.normals.elementAt(13);
      expect(normal_7_13, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, 0.395701)));
      final normal_7_14 = mesh_7.normals.elementAt(14);
      expect(normal_7_14, vector3MoreOrLessEquals(Vector3(0.375318, 0.601842, 0.704927)));
      final normal_7_15 = mesh_7.normals.elementAt(15);
      expect(normal_7_15, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, 0.395701)));
      final normal_7_16 = mesh_7.normals.elementAt(16);
      expect(normal_7_16, vector3MoreOrLessEquals(Vector3(0.54841, 0.661676, 0.511303)));
      final normal_7_17 = mesh_7.normals.elementAt(17);
      expect(normal_7_17, vector3MoreOrLessEquals(Vector3(0.375318, 0.601842, 0.704927)));
      final normal_7_18 = mesh_7.normals.elementAt(18);
      expect(normal_7_18, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, 0.395701)));
      final normal_7_19 = mesh_7.normals.elementAt(19);
      expect(normal_7_19, vector3MoreOrLessEquals(Vector3(0.883047, -0.047485, 0.466875)));
      final normal_7_20 = mesh_7.normals.elementAt(20);
      expect(normal_7_20, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, -0.010829)));
      final normal_7_21 = mesh_7.normals.elementAt(21);
      expect(normal_7_21, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, 0.395701)));
      final normal_7_22 = mesh_7.normals.elementAt(22);
      expect(normal_7_22, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, -0.010829)));
      final normal_7_23 = mesh_7.normals.elementAt(23);
      expect(normal_7_23, vector3MoreOrLessEquals(Vector3(0.54841, 0.661676, 0.511303)));
      final normal_7_24 = mesh_7.normals.elementAt(24);
      expect(normal_7_24, vector3MoreOrLessEquals(Vector3(0.883047, -0.047485, 0.466875)));
      final normal_7_25 = mesh_7.normals.elementAt(25);
      expect(normal_7_25, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, 0.167289)));
      final normal_7_26 = mesh_7.normals.elementAt(26);
      expect(normal_7_26, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, -0.010829)));
      final normal_7_27 = mesh_7.normals.elementAt(27);
      expect(normal_7_27, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, 0.167289)));
      final normal_7_28 = mesh_7.normals.elementAt(28);
      expect(normal_7_28, vector3MoreOrLessEquals(Vector3(0.695006, 0.600564, -0.395336)));
      final normal_7_29 = mesh_7.normals.elementAt(29);
      expect(normal_7_29, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, -0.010829)));
      final normal_7_30 = mesh_7.normals.elementAt(30);
      expect(normal_7_30, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, 0.167289)));
      final normal_7_31 = mesh_7.normals.elementAt(31);
      expect(normal_7_31, vector3MoreOrLessEquals(Vector3(0.950454, -0.06233, 0.304551)));
      final normal_7_32 = mesh_7.normals.elementAt(32);
      expect(normal_7_32, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, -0.460397)));
      final normal_7_33 = mesh_7.normals.elementAt(33);
      expect(normal_7_33, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, 0.167289)));
      final normal_7_34 = mesh_7.normals.elementAt(34);
      expect(normal_7_34, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, -0.460397)));
      final normal_7_35 = mesh_7.normals.elementAt(35);
      expect(normal_7_35, vector3MoreOrLessEquals(Vector3(0.695006, 0.600564, -0.395336)));
      final normal_7_36 = mesh_7.normals.elementAt(36);
      expect(normal_7_36, vector3MoreOrLessEquals(Vector3(0.950454, -0.06233, 0.304551)));
      final normal_7_37 = mesh_7.normals.elementAt(37);
      expect(normal_7_37, vector3MoreOrLessEquals(Vector3(0.989975, 0.079498, 0.116747)));
      final normal_7_38 = mesh_7.normals.elementAt(38);
      expect(normal_7_38, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, -0.460397)));
      final normal_7_39 = mesh_7.normals.elementAt(39);
      expect(normal_7_39, vector3MoreOrLessEquals(Vector3(0.989975, 0.079498, 0.116747)));
      final normal_7_40 = mesh_7.normals.elementAt(40);
      expect(normal_7_40, vector3MoreOrLessEquals(Vector3(0.767611, 0.420846, -0.483385)));
      final normal_7_41 = mesh_7.normals.elementAt(41);
      expect(normal_7_41, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, -0.460397)));
      final normal_7_42 = mesh_7.normals.elementAt(42);
      expect(normal_7_42, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_43 = mesh_7.normals.elementAt(43);
      expect(normal_7_43, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_44 = mesh_7.normals.elementAt(44);
      expect(normal_7_44, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_45 = mesh_7.normals.elementAt(45);
      expect(normal_7_45, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_46 = mesh_7.normals.elementAt(46);
      expect(normal_7_46, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_47 = mesh_7.normals.elementAt(47);
      expect(normal_7_47, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_48 = mesh_7.normals.elementAt(48);
      expect(normal_7_48, vector3MoreOrLessEquals(Vector3(0.164332, 0.782548, 0.600511)));
      final normal_7_49 = mesh_7.normals.elementAt(49);
      expect(normal_7_49, vector3MoreOrLessEquals(Vector3(0.375318, 0.601842, 0.704927)));
      final normal_7_50 = mesh_7.normals.elementAt(50);
      expect(normal_7_50, vector3MoreOrLessEquals(Vector3(-0.407667, 0.857527, 0.313775)));
      final normal_7_51 = mesh_7.normals.elementAt(51);
      expect(normal_7_51, vector3MoreOrLessEquals(Vector3(0.375318, 0.601842, 0.704927)));
      final normal_7_52 = mesh_7.normals.elementAt(52);
      expect(normal_7_52, vector3MoreOrLessEquals(Vector3(-0.380509, 0.743022, 0.550574)));
      final normal_7_53 = mesh_7.normals.elementAt(53);
      expect(normal_7_53, vector3MoreOrLessEquals(Vector3(-0.407667, 0.857527, 0.313775)));
      final normal_7_54 = mesh_7.normals.elementAt(54);
      expect(normal_7_54, vector3MoreOrLessEquals(Vector3(0.375318, 0.601842, 0.704927)));
      final normal_7_55 = mesh_7.normals.elementAt(55);
      expect(normal_7_55, vector3MoreOrLessEquals(Vector3(0.54841, 0.661676, 0.511303)));
      final normal_7_56 = mesh_7.normals.elementAt(56);
      expect(normal_7_56, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, 0.350803)));
      final normal_7_57 = mesh_7.normals.elementAt(57);
      expect(normal_7_57, vector3MoreOrLessEquals(Vector3(0.375318, 0.601842, 0.704927)));
      final normal_7_58 = mesh_7.normals.elementAt(58);
      expect(normal_7_58, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, 0.350803)));
      final normal_7_59 = mesh_7.normals.elementAt(59);
      expect(normal_7_59, vector3MoreOrLessEquals(Vector3(-0.380509, 0.743022, 0.550574)));
      final normal_7_60 = mesh_7.normals.elementAt(60);
      expect(normal_7_60, vector3MoreOrLessEquals(Vector3(0.54841, 0.661676, 0.511303)));
      final normal_7_61 = mesh_7.normals.elementAt(61);
      expect(normal_7_61, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, -0.010829)));
      final normal_7_62 = mesh_7.normals.elementAt(62);
      expect(normal_7_62, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, 0.350803)));
      final normal_7_63 = mesh_7.normals.elementAt(63);
      expect(normal_7_63, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, -0.010829)));
      final normal_7_64 = mesh_7.normals.elementAt(64);
      expect(normal_7_64, vector3MoreOrLessEquals(Vector3(-0.173281, 0.931431, -0.320017)));
      final normal_7_65 = mesh_7.normals.elementAt(65);
      expect(normal_7_65, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, 0.350803)));
      final normal_7_66 = mesh_7.normals.elementAt(66);
      expect(normal_7_66, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, -0.010829)));
      final normal_7_67 = mesh_7.normals.elementAt(67);
      expect(normal_7_67, vector3MoreOrLessEquals(Vector3(0.695006, 0.600564, -0.395336)));
      final normal_7_68 = mesh_7.normals.elementAt(68);
      expect(normal_7_68, vector3MoreOrLessEquals(Vector3(-0.088345, 0.681833, -0.726154)));
      final normal_7_69 = mesh_7.normals.elementAt(69);
      expect(normal_7_69, vector3MoreOrLessEquals(Vector3(0.596875, 0.802261, -0.010829)));
      final normal_7_70 = mesh_7.normals.elementAt(70);
      expect(normal_7_70, vector3MoreOrLessEquals(Vector3(-0.088345, 0.681833, -0.726154)));
      final normal_7_71 = mesh_7.normals.elementAt(71);
      expect(normal_7_71, vector3MoreOrLessEquals(Vector3(-0.173281, 0.931431, -0.320017)));
      final normal_7_72 = mesh_7.normals.elementAt(72);
      expect(normal_7_72, vector3MoreOrLessEquals(Vector3(0.695006, 0.600564, -0.395336)));
      final normal_7_73 = mesh_7.normals.elementAt(73);
      expect(normal_7_73, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, -0.460397)));
      final normal_7_74 = mesh_7.normals.elementAt(74);
      expect(normal_7_74, vector3MoreOrLessEquals(Vector3(-0.088345, 0.681833, -0.726154)));
      final normal_7_75 = mesh_7.normals.elementAt(75);
      expect(normal_7_75, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, -0.460397)));
      final normal_7_76 = mesh_7.normals.elementAt(76);
      expect(normal_7_76, vector3MoreOrLessEquals(Vector3(-0.097862, 0.460784, -0.8821)));
      final normal_7_77 = mesh_7.normals.elementAt(77);
      expect(normal_7_77, vector3MoreOrLessEquals(Vector3(-0.088345, 0.681833, -0.726154)));
      final normal_7_78 = mesh_7.normals.elementAt(78);
      expect(normal_7_78, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, -0.460397)));
      final normal_7_79 = mesh_7.normals.elementAt(79);
      expect(normal_7_79, vector3MoreOrLessEquals(Vector3(0.767611, 0.420846, -0.483385)));
      final normal_7_80 = mesh_7.normals.elementAt(80);
      expect(normal_7_80, vector3MoreOrLessEquals(Vector3(-0.075217, 0.480042, -0.874015)));
      final normal_7_81 = mesh_7.normals.elementAt(81);
      expect(normal_7_81, vector3MoreOrLessEquals(Vector3(0.804391, 0.375485, -0.460397)));
      final normal_7_82 = mesh_7.normals.elementAt(82);
      expect(normal_7_82, vector3MoreOrLessEquals(Vector3(-0.075217, 0.480042, -0.874015)));
      final normal_7_83 = mesh_7.normals.elementAt(83);
      expect(normal_7_83, vector3MoreOrLessEquals(Vector3(-0.097862, 0.460784, -0.8821)));
      final normal_7_84 = mesh_7.normals.elementAt(84);
      expect(normal_7_84, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_85 = mesh_7.normals.elementAt(85);
      expect(normal_7_85, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_86 = mesh_7.normals.elementAt(86);
      expect(normal_7_86, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_87 = mesh_7.normals.elementAt(87);
      expect(normal_7_87, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_88 = mesh_7.normals.elementAt(88);
      expect(normal_7_88, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_89 = mesh_7.normals.elementAt(89);
      expect(normal_7_89, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_90 = mesh_7.normals.elementAt(90);
      expect(normal_7_90, vector3MoreOrLessEquals(Vector3(-0.407667, 0.857527, 0.313775)));
      final normal_7_91 = mesh_7.normals.elementAt(91);
      expect(normal_7_91, vector3MoreOrLessEquals(Vector3(-0.380509, 0.743022, 0.550574)));
      final normal_7_92 = mesh_7.normals.elementAt(92);
      expect(normal_7_92, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, -0.098302)));
      final normal_7_93 = mesh_7.normals.elementAt(93);
      expect(normal_7_93, vector3MoreOrLessEquals(Vector3(-0.407667, 0.857527, 0.313775)));
      final normal_7_94 = mesh_7.normals.elementAt(94);
      expect(normal_7_94, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, -0.098302)));
      final normal_7_95 = mesh_7.normals.elementAt(95);
      expect(normal_7_95, vector3MoreOrLessEquals(Vector3(-0.86351, 0.341772, -0.370868)));
      final normal_7_96 = mesh_7.normals.elementAt(96);
      expect(normal_7_96, vector3MoreOrLessEquals(Vector3(-0.380509, 0.743022, 0.550574)));
      final normal_7_97 = mesh_7.normals.elementAt(97);
      expect(normal_7_97, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, 0.350803)));
      final normal_7_98 = mesh_7.normals.elementAt(98);
      expect(normal_7_98, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, -0.098302)));
      final normal_7_99 = mesh_7.normals.elementAt(99);
      expect(normal_7_99, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, 0.350803)));
      final normal_7_100 = mesh_7.normals.elementAt(100);
      expect(normal_7_100, vector3MoreOrLessEquals(Vector3(-0.954873, 0.297012, 0.001297)));
      final normal_7_101 = mesh_7.normals.elementAt(101);
      expect(normal_7_101, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, -0.098302)));
      final normal_7_102 = mesh_7.normals.elementAt(102);
      expect(normal_7_102, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, 0.350803)));
      final normal_7_103 = mesh_7.normals.elementAt(103);
      expect(normal_7_103, vector3MoreOrLessEquals(Vector3(-0.173281, 0.931431, -0.320017)));
      final normal_7_104 = mesh_7.normals.elementAt(104);
      expect(normal_7_104, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, -0.281187)));
      final normal_7_105 = mesh_7.normals.elementAt(105);
      expect(normal_7_105, vector3MoreOrLessEquals(Vector3(-0.371629, 0.859552, 0.350803)));
      final normal_7_106 = mesh_7.normals.elementAt(106);
      expect(normal_7_106, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, -0.281187)));
      final normal_7_107 = mesh_7.normals.elementAt(107);
      expect(normal_7_107, vector3MoreOrLessEquals(Vector3(-0.954873, 0.297012, 0.001297)));
      final normal_7_108 = mesh_7.normals.elementAt(108);
      expect(normal_7_108, vector3MoreOrLessEquals(Vector3(-0.173281, 0.931431, -0.320017)));
      final normal_7_109 = mesh_7.normals.elementAt(109);
      expect(normal_7_109, vector3MoreOrLessEquals(Vector3(-0.088345, 0.681833, -0.726154)));
      final normal_7_110 = mesh_7.normals.elementAt(110);
      expect(normal_7_110, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, -0.281187)));
      final normal_7_111 = mesh_7.normals.elementAt(111);
      expect(normal_7_111, vector3MoreOrLessEquals(Vector3(-0.088345, 0.681833, -0.726154)));
      final normal_7_112 = mesh_7.normals.elementAt(112);
      expect(normal_7_112, vector3MoreOrLessEquals(Vector3(-0.798205, 0.258643, -0.544033)));
      final normal_7_113 = mesh_7.normals.elementAt(113);
      expect(normal_7_113, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, -0.281187)));
      final normal_7_114 = mesh_7.normals.elementAt(114);
      expect(normal_7_114, vector3MoreOrLessEquals(Vector3(-0.088345, 0.681833, -0.726154)));
      final normal_7_115 = mesh_7.normals.elementAt(115);
      expect(normal_7_115, vector3MoreOrLessEquals(Vector3(-0.097862, 0.460784, -0.8821)));
      final normal_7_116 = mesh_7.normals.elementAt(116);
      expect(normal_7_116, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, -0.54097)));
      final normal_7_117 = mesh_7.normals.elementAt(117);
      expect(normal_7_117, vector3MoreOrLessEquals(Vector3(-0.088345, 0.681833, -0.726154)));
      final normal_7_118 = mesh_7.normals.elementAt(118);
      expect(normal_7_118, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, -0.54097)));
      final normal_7_119 = mesh_7.normals.elementAt(119);
      expect(normal_7_119, vector3MoreOrLessEquals(Vector3(-0.798205, 0.258643, -0.544033)));
      final normal_7_120 = mesh_7.normals.elementAt(120);
      expect(normal_7_120, vector3MoreOrLessEquals(Vector3(-0.097862, 0.460784, -0.8821)));
      final normal_7_121 = mesh_7.normals.elementAt(121);
      expect(normal_7_121, vector3MoreOrLessEquals(Vector3(-0.075217, 0.480042, -0.874015)));
      final normal_7_122 = mesh_7.normals.elementAt(122);
      expect(normal_7_122, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, -0.54097)));
      final normal_7_123 = mesh_7.normals.elementAt(123);
      expect(normal_7_123, vector3MoreOrLessEquals(Vector3(-0.075217, 0.480042, -0.874015)));
      final normal_7_124 = mesh_7.normals.elementAt(124);
      expect(normal_7_124, vector3MoreOrLessEquals(Vector3(-0.80001, 0.140945, -0.583196)));
      final normal_7_125 = mesh_7.normals.elementAt(125);
      expect(normal_7_125, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, -0.54097)));
      final normal_7_126 = mesh_7.normals.elementAt(126);
      expect(normal_7_126, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_127 = mesh_7.normals.elementAt(127);
      expect(normal_7_127, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_128 = mesh_7.normals.elementAt(128);
      expect(normal_7_128, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_129 = mesh_7.normals.elementAt(129);
      expect(normal_7_129, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_130 = mesh_7.normals.elementAt(130);
      expect(normal_7_130, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_131 = mesh_7.normals.elementAt(131);
      expect(normal_7_131, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_132 = mesh_7.normals.elementAt(132);
      expect(normal_7_132, vector3MoreOrLessEquals(Vector3(-0.86351, 0.341772, -0.370868)));
      final normal_7_133 = mesh_7.normals.elementAt(133);
      expect(normal_7_133, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, -0.098302)));
      final normal_7_134 = mesh_7.normals.elementAt(134);
      expect(normal_7_134, vector3MoreOrLessEquals(Vector3(-0.638103, -0.340513, -0.690562)));
      final normal_7_135 = mesh_7.normals.elementAt(135);
      expect(normal_7_135, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, -0.098302)));
      final normal_7_136 = mesh_7.normals.elementAt(136);
      expect(normal_7_136, vector3MoreOrLessEquals(Vector3(-0.755642, -0.204991, -0.622081)));
      final normal_7_137 = mesh_7.normals.elementAt(137);
      expect(normal_7_137, vector3MoreOrLessEquals(Vector3(-0.638103, -0.340513, -0.690562)));
      final normal_7_138 = mesh_7.normals.elementAt(138);
      expect(normal_7_138, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, -0.098302)));
      final normal_7_139 = mesh_7.normals.elementAt(139);
      expect(normal_7_139, vector3MoreOrLessEquals(Vector3(-0.954873, 0.297012, 0.001297)));
      final normal_7_140 = mesh_7.normals.elementAt(140);
      expect(normal_7_140, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, -0.260133)));
      final normal_7_141 = mesh_7.normals.elementAt(141);
      expect(normal_7_141, vector3MoreOrLessEquals(Vector3(-0.927662, 0.36025, -0.098302)));
      final normal_7_142 = mesh_7.normals.elementAt(142);
      expect(normal_7_142, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, -0.260133)));
      final normal_7_143 = mesh_7.normals.elementAt(143);
      expect(normal_7_143, vector3MoreOrLessEquals(Vector3(-0.755642, -0.204991, -0.622081)));
      final normal_7_144 = mesh_7.normals.elementAt(144);
      expect(normal_7_144, vector3MoreOrLessEquals(Vector3(-0.954873, 0.297012, 0.001297)));
      final normal_7_145 = mesh_7.normals.elementAt(145);
      expect(normal_7_145, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, -0.281187)));
      final normal_7_146 = mesh_7.normals.elementAt(146);
      expect(normal_7_146, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, -0.260133)));
      final normal_7_147 = mesh_7.normals.elementAt(147);
      expect(normal_7_147, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, -0.281187)));
      final normal_7_148 = mesh_7.normals.elementAt(148);
      expect(normal_7_148, vector3MoreOrLessEquals(Vector3(-0.92195, -0.385899, 0.033004)));
      final normal_7_149 = mesh_7.normals.elementAt(149);
      expect(normal_7_149, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, -0.260133)));
      final normal_7_150 = mesh_7.normals.elementAt(150);
      expect(normal_7_150, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, -0.281187)));
      final normal_7_151 = mesh_7.normals.elementAt(151);
      expect(normal_7_151, vector3MoreOrLessEquals(Vector3(-0.798205, 0.258643, -0.544033)));
      final normal_7_152 = mesh_7.normals.elementAt(152);
      expect(normal_7_152, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, 0.024508)));
      final normal_7_153 = mesh_7.normals.elementAt(153);
      expect(normal_7_153, vector3MoreOrLessEquals(Vector3(-0.877348, 0.388838, -0.281187)));
      final normal_7_154 = mesh_7.normals.elementAt(154);
      expect(normal_7_154, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, 0.024508)));
      final normal_7_155 = mesh_7.normals.elementAt(155);
      expect(normal_7_155, vector3MoreOrLessEquals(Vector3(-0.92195, -0.385899, 0.033004)));
      final normal_7_156 = mesh_7.normals.elementAt(156);
      expect(normal_7_156, vector3MoreOrLessEquals(Vector3(-0.798205, 0.258643, -0.544033)));
      final normal_7_157 = mesh_7.normals.elementAt(157);
      expect(normal_7_157, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, -0.54097)));
      final normal_7_158 = mesh_7.normals.elementAt(158);
      expect(normal_7_158, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, 0.024508)));
      final normal_7_159 = mesh_7.normals.elementAt(159);
      expect(normal_7_159, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, -0.54097)));
      final normal_7_160 = mesh_7.normals.elementAt(160);
      expect(normal_7_160, vector3MoreOrLessEquals(Vector3(-0.971643, -0.23638, -0.005919)));
      final normal_7_161 = mesh_7.normals.elementAt(161);
      expect(normal_7_161, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, 0.024508)));
      final normal_7_162 = mesh_7.normals.elementAt(162);
      expect(normal_7_162, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, -0.54097)));
      final normal_7_163 = mesh_7.normals.elementAt(163);
      expect(normal_7_163, vector3MoreOrLessEquals(Vector3(-0.80001, 0.140945, -0.583196)));
      final normal_7_164 = mesh_7.normals.elementAt(164);
      expect(normal_7_164, vector3MoreOrLessEquals(Vector3(-0.950036, -0.310227, -0.034503)));
      final normal_7_165 = mesh_7.normals.elementAt(165);
      expect(normal_7_165, vector3MoreOrLessEquals(Vector3(-0.830945, 0.129933, -0.54097)));
      final normal_7_166 = mesh_7.normals.elementAt(166);
      expect(normal_7_166, vector3MoreOrLessEquals(Vector3(-0.950036, -0.310227, -0.034503)));
      final normal_7_167 = mesh_7.normals.elementAt(167);
      expect(normal_7_167, vector3MoreOrLessEquals(Vector3(-0.971643, -0.23638, -0.005919)));
      final normal_7_168 = mesh_7.normals.elementAt(168);
      expect(normal_7_168, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_169 = mesh_7.normals.elementAt(169);
      expect(normal_7_169, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_170 = mesh_7.normals.elementAt(170);
      expect(normal_7_170, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_171 = mesh_7.normals.elementAt(171);
      expect(normal_7_171, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_172 = mesh_7.normals.elementAt(172);
      expect(normal_7_172, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_173 = mesh_7.normals.elementAt(173);
      expect(normal_7_173, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_174 = mesh_7.normals.elementAt(174);
      expect(normal_7_174, vector3MoreOrLessEquals(Vector3(-0.638103, -0.340513, -0.690562)));
      final normal_7_175 = mesh_7.normals.elementAt(175);
      expect(normal_7_175, vector3MoreOrLessEquals(Vector3(-0.755642, -0.204991, -0.622081)));
      final normal_7_176 = mesh_7.normals.elementAt(176);
      expect(normal_7_176, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, -0.733912)));
      final normal_7_177 = mesh_7.normals.elementAt(177);
      expect(normal_7_177, vector3MoreOrLessEquals(Vector3(-0.638103, -0.340513, -0.690562)));
      final normal_7_178 = mesh_7.normals.elementAt(178);
      expect(normal_7_178, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, -0.733912)));
      final normal_7_179 = mesh_7.normals.elementAt(179);
      expect(normal_7_179, vector3MoreOrLessEquals(Vector3(0.21631, -0.832587, -0.50991)));
      final normal_7_180 = mesh_7.normals.elementAt(180);
      expect(normal_7_180, vector3MoreOrLessEquals(Vector3(-0.755642, -0.204991, -0.622081)));
      final normal_7_181 = mesh_7.normals.elementAt(181);
      expect(normal_7_181, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, -0.260133)));
      final normal_7_182 = mesh_7.normals.elementAt(182);
      expect(normal_7_182, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, -0.733912)));
      final normal_7_183 = mesh_7.normals.elementAt(183);
      expect(normal_7_183, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, -0.260133)));
      final normal_7_184 = mesh_7.normals.elementAt(184);
      expect(normal_7_184, vector3MoreOrLessEquals(Vector3(-0.163481, -0.936687, -0.309662)));
      final normal_7_185 = mesh_7.normals.elementAt(185);
      expect(normal_7_185, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, -0.733912)));
      final normal_7_186 = mesh_7.normals.elementAt(186);
      expect(normal_7_186, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, -0.260133)));
      final normal_7_187 = mesh_7.normals.elementAt(187);
      expect(normal_7_187, vector3MoreOrLessEquals(Vector3(-0.92195, -0.385899, 0.033004)));
      final normal_7_188 = mesh_7.normals.elementAt(188);
      expect(normal_7_188, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, 0.381925)));
      final normal_7_189 = mesh_7.normals.elementAt(189);
      expect(normal_7_189, vector3MoreOrLessEquals(Vector3(-0.906786, -0.331767, -0.260133)));
      final normal_7_190 = mesh_7.normals.elementAt(190);
      expect(normal_7_190, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, 0.381925)));
      final normal_7_191 = mesh_7.normals.elementAt(191);
      expect(normal_7_191, vector3MoreOrLessEquals(Vector3(-0.163481, -0.936687, -0.309662)));
      final normal_7_192 = mesh_7.normals.elementAt(192);
      expect(normal_7_192, vector3MoreOrLessEquals(Vector3(-0.92195, -0.385899, 0.033004)));
      final normal_7_193 = mesh_7.normals.elementAt(193);
      expect(normal_7_193, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, 0.024508)));
      final normal_7_194 = mesh_7.normals.elementAt(194);
      expect(normal_7_194, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, 0.381925)));
      final normal_7_195 = mesh_7.normals.elementAt(195);
      expect(normal_7_195, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, 0.024508)));
      final normal_7_196 = mesh_7.normals.elementAt(196);
      expect(normal_7_196, vector3MoreOrLessEquals(Vector3(-0.334488, -0.728676, 0.59762)));
      final normal_7_197 = mesh_7.normals.elementAt(197);
      expect(normal_7_197, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, 0.381925)));
      final normal_7_198 = mesh_7.normals.elementAt(198);
      expect(normal_7_198, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, 0.024508)));
      final normal_7_199 = mesh_7.normals.elementAt(199);
      expect(normal_7_199, vector3MoreOrLessEquals(Vector3(-0.971643, -0.23638, -0.005919)));
      final normal_7_200 = mesh_7.normals.elementAt(200);
      expect(normal_7_200, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, 0.685741)));
      final normal_7_201 = mesh_7.normals.elementAt(201);
      expect(normal_7_201, vector3MoreOrLessEquals(Vector3(-0.932303, -0.360848, 0.024508)));
      final normal_7_202 = mesh_7.normals.elementAt(202);
      expect(normal_7_202, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, 0.685741)));
      final normal_7_203 = mesh_7.normals.elementAt(203);
      expect(normal_7_203, vector3MoreOrLessEquals(Vector3(-0.334488, -0.728676, 0.59762)));
      final normal_7_204 = mesh_7.normals.elementAt(204);
      expect(normal_7_204, vector3MoreOrLessEquals(Vector3(-0.971643, -0.23638, -0.005919)));
      final normal_7_205 = mesh_7.normals.elementAt(205);
      expect(normal_7_205, vector3MoreOrLessEquals(Vector3(-0.950036, -0.310227, -0.034503)));
      final normal_7_206 = mesh_7.normals.elementAt(206);
      expect(normal_7_206, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, 0.685741)));
      final normal_7_207 = mesh_7.normals.elementAt(207);
      expect(normal_7_207, vector3MoreOrLessEquals(Vector3(-0.950036, -0.310227, -0.034503)));
      final normal_7_208 = mesh_7.normals.elementAt(208);
      expect(normal_7_208, vector3MoreOrLessEquals(Vector3(-0.371857, -0.710825, 0.597035)));
      final normal_7_209 = mesh_7.normals.elementAt(209);
      expect(normal_7_209, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, 0.685741)));
      final normal_7_210 = mesh_7.normals.elementAt(210);
      expect(normal_7_210, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_211 = mesh_7.normals.elementAt(211);
      expect(normal_7_211, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_212 = mesh_7.normals.elementAt(212);
      expect(normal_7_212, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_213 = mesh_7.normals.elementAt(213);
      expect(normal_7_213, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_214 = mesh_7.normals.elementAt(214);
      expect(normal_7_214, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_215 = mesh_7.normals.elementAt(215);
      expect(normal_7_215, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_216 = mesh_7.normals.elementAt(216);
      expect(normal_7_216, vector3MoreOrLessEquals(Vector3(0.21631, -0.832587, -0.50991)));
      final normal_7_217 = mesh_7.normals.elementAt(217);
      expect(normal_7_217, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, -0.733912)));
      final normal_7_218 = mesh_7.normals.elementAt(218);
      expect(normal_7_218, vector3MoreOrLessEquals(Vector3(0.750822, -0.654602, -0.088107)));
      final normal_7_219 = mesh_7.normals.elementAt(219);
      expect(normal_7_219, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, -0.733912)));
      final normal_7_220 = mesh_7.normals.elementAt(220);
      expect(normal_7_220, vector3MoreOrLessEquals(Vector3(0.744565, -0.575276, -0.338646)));
      final normal_7_221 = mesh_7.normals.elementAt(221);
      expect(normal_7_221, vector3MoreOrLessEquals(Vector3(0.750822, -0.654602, -0.088107)));
      final normal_7_222 = mesh_7.normals.elementAt(222);
      expect(normal_7_222, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, -0.733912)));
      final normal_7_223 = mesh_7.normals.elementAt(223);
      expect(normal_7_223, vector3MoreOrLessEquals(Vector3(-0.163481, -0.936687, -0.309662)));
      final normal_7_224 = mesh_7.normals.elementAt(224);
      expect(normal_7_224, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, 0.034936)));
      final normal_7_225 = mesh_7.normals.elementAt(225);
      expect(normal_7_225, vector3MoreOrLessEquals(Vector3(0.051621, -0.67728, -0.733912)));
      final normal_7_226 = mesh_7.normals.elementAt(226);
      expect(normal_7_226, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, 0.034936)));
      final normal_7_227 = mesh_7.normals.elementAt(227);
      expect(normal_7_227, vector3MoreOrLessEquals(Vector3(0.744565, -0.575276, -0.338646)));
      final normal_7_228 = mesh_7.normals.elementAt(228);
      expect(normal_7_228, vector3MoreOrLessEquals(Vector3(-0.163481, -0.936687, -0.309662)));
      final normal_7_229 = mesh_7.normals.elementAt(229);
      expect(normal_7_229, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, 0.381925)));
      final normal_7_230 = mesh_7.normals.elementAt(230);
      expect(normal_7_230, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, 0.034936)));
      final normal_7_231 = mesh_7.normals.elementAt(231);
      expect(normal_7_231, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, 0.381925)));
      final normal_7_232 = mesh_7.normals.elementAt(232);
      expect(normal_7_232, vector3MoreOrLessEquals(Vector3(0.522268, -0.636825, 0.567177)));
      final normal_7_233 = mesh_7.normals.elementAt(233);
      expect(normal_7_233, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, 0.034936)));
      final normal_7_234 = mesh_7.normals.elementAt(234);
      expect(normal_7_234, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, 0.381925)));
      final normal_7_235 = mesh_7.normals.elementAt(235);
      expect(normal_7_235, vector3MoreOrLessEquals(Vector3(-0.334488, -0.728676, 0.59762)));
      final normal_7_236 = mesh_7.normals.elementAt(236);
      expect(normal_7_236, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, 0.665842)));
      final normal_7_237 = mesh_7.normals.elementAt(237);
      expect(normal_7_237, vector3MoreOrLessEquals(Vector3(-0.273013, -0.882948, 0.381925)));
      final normal_7_238 = mesh_7.normals.elementAt(238);
      expect(normal_7_238, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, 0.665842)));
      final normal_7_239 = mesh_7.normals.elementAt(239);
      expect(normal_7_239, vector3MoreOrLessEquals(Vector3(0.522268, -0.636825, 0.567177)));
      final normal_7_240 = mesh_7.normals.elementAt(240);
      expect(normal_7_240, vector3MoreOrLessEquals(Vector3(-0.334488, -0.728676, 0.59762)));
      final normal_7_241 = mesh_7.normals.elementAt(241);
      expect(normal_7_241, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, 0.685741)));
      final normal_7_242 = mesh_7.normals.elementAt(242);
      expect(normal_7_242, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, 0.665842)));
      final normal_7_243 = mesh_7.normals.elementAt(243);
      expect(normal_7_243, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, 0.685741)));
      final normal_7_244 = mesh_7.normals.elementAt(244);
      expect(normal_7_244, vector3MoreOrLessEquals(Vector3(0.641037, -0.375221, 0.669538)));
      final normal_7_245 = mesh_7.normals.elementAt(245);
      expect(normal_7_245, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, 0.665842)));
      final normal_7_246 = mesh_7.normals.elementAt(246);
      expect(normal_7_246, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, 0.685741)));
      final normal_7_247 = mesh_7.normals.elementAt(247);
      expect(normal_7_247, vector3MoreOrLessEquals(Vector3(-0.371857, -0.710825, 0.597035)));
      final normal_7_248 = mesh_7.normals.elementAt(248);
      expect(normal_7_248, vector3MoreOrLessEquals(Vector3(0.614542, -0.453134, 0.645761)));
      final normal_7_249 = mesh_7.normals.elementAt(249);
      expect(normal_7_249, vector3MoreOrLessEquals(Vector3(-0.408235, -0.60258, 0.685741)));
      final normal_7_250 = mesh_7.normals.elementAt(250);
      expect(normal_7_250, vector3MoreOrLessEquals(Vector3(0.614542, -0.453134, 0.645761)));
      final normal_7_251 = mesh_7.normals.elementAt(251);
      expect(normal_7_251, vector3MoreOrLessEquals(Vector3(0.641037, -0.375221, 0.669538)));
      final normal_7_252 = mesh_7.normals.elementAt(252);
      expect(normal_7_252, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_253 = mesh_7.normals.elementAt(253);
      expect(normal_7_253, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_254 = mesh_7.normals.elementAt(254);
      expect(normal_7_254, vector3MoreOrLessEquals(Vector3(-0.272476, -0.916512, 0.292854)));
      final normal_7_255 = mesh_7.normals.elementAt(255);
      expect(normal_7_255, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_256 = mesh_7.normals.elementAt(256);
      expect(normal_7_256, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_257 = mesh_7.normals.elementAt(257);
      expect(normal_7_257, vector3MoreOrLessEquals(Vector3(0.247445, -0.431549, -0.867488)));
      final normal_7_258 = mesh_7.normals.elementAt(258);
      expect(normal_7_258, vector3MoreOrLessEquals(Vector3(0.750822, -0.654602, -0.088107)));
      final normal_7_259 = mesh_7.normals.elementAt(259);
      expect(normal_7_259, vector3MoreOrLessEquals(Vector3(0.744565, -0.575276, -0.338646)));
      final normal_7_260 = mesh_7.normals.elementAt(260);
      expect(normal_7_260, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, 0.223412)));
      final normal_7_261 = mesh_7.normals.elementAt(261);
      expect(normal_7_261, vector3MoreOrLessEquals(Vector3(0.750822, -0.654602, -0.088107)));
      final normal_7_262 = mesh_7.normals.elementAt(262);
      expect(normal_7_262, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, 0.223412)));
      final normal_7_263 = mesh_7.normals.elementAt(263);
      expect(normal_7_263, vector3MoreOrLessEquals(Vector3(0.795449, 0.228463, 0.561307)));
      final normal_7_264 = mesh_7.normals.elementAt(264);
      expect(normal_7_264, vector3MoreOrLessEquals(Vector3(0.744565, -0.575276, -0.338646)));
      final normal_7_265 = mesh_7.normals.elementAt(265);
      expect(normal_7_265, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, 0.034936)));
      final normal_7_266 = mesh_7.normals.elementAt(266);
      expect(normal_7_266, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, 0.223412)));
      final normal_7_267 = mesh_7.normals.elementAt(267);
      expect(normal_7_267, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, 0.034936)));
      final normal_7_268 = mesh_7.normals.elementAt(268);
      expect(normal_7_268, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, 0.395701)));
      final normal_7_269 = mesh_7.normals.elementAt(269);
      expect(normal_7_269, vector3MoreOrLessEquals(Vector3(0.9691, -0.104559, 0.223412)));
      final normal_7_270 = mesh_7.normals.elementAt(270);
      expect(normal_7_270, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, 0.034936)));
      final normal_7_271 = mesh_7.normals.elementAt(271);
      expect(normal_7_271, vector3MoreOrLessEquals(Vector3(0.522268, -0.636825, 0.567177)));
      final normal_7_272 = mesh_7.normals.elementAt(272);
      expect(normal_7_272, vector3MoreOrLessEquals(Vector3(0.883047, -0.047485, 0.466875)));
      final normal_7_273 = mesh_7.normals.elementAt(273);
      expect(normal_7_273, vector3MoreOrLessEquals(Vector3(0.766027, -0.641859, 0.034936)));
      final normal_7_274 = mesh_7.normals.elementAt(274);
      expect(normal_7_274, vector3MoreOrLessEquals(Vector3(0.883047, -0.047485, 0.466875)));
      final normal_7_275 = mesh_7.normals.elementAt(275);
      expect(normal_7_275, vector3MoreOrLessEquals(Vector3(0.901567, 0.174919, 0.395701)));
      final normal_7_276 = mesh_7.normals.elementAt(276);
      expect(normal_7_276, vector3MoreOrLessEquals(Vector3(0.522268, -0.636825, 0.567177)));
      final normal_7_277 = mesh_7.normals.elementAt(277);
      expect(normal_7_277, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, 0.665842)));
      final normal_7_278 = mesh_7.normals.elementAt(278);
      expect(normal_7_278, vector3MoreOrLessEquals(Vector3(0.883047, -0.047485, 0.466875)));
      final normal_7_279 = mesh_7.normals.elementAt(279);
      expect(normal_7_279, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, 0.665842)));
      final normal_7_280 = mesh_7.normals.elementAt(280);
      expect(normal_7_280, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, 0.167289)));
      final normal_7_281 = mesh_7.normals.elementAt(281);
      expect(normal_7_281, vector3MoreOrLessEquals(Vector3(0.883047, -0.047485, 0.466875)));
      final normal_7_282 = mesh_7.normals.elementAt(282);
      expect(normal_7_282, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, 0.665842)));
      final normal_7_283 = mesh_7.normals.elementAt(283);
      expect(normal_7_283, vector3MoreOrLessEquals(Vector3(0.641037, -0.375221, 0.669538)));
      final normal_7_284 = mesh_7.normals.elementAt(284);
      expect(normal_7_284, vector3MoreOrLessEquals(Vector3(0.950454, -0.06233, 0.304551)));
      final normal_7_285 = mesh_7.normals.elementAt(285);
      expect(normal_7_285, vector3MoreOrLessEquals(Vector3(0.527667, -0.527467, 0.665842)));
      final normal_7_286 = mesh_7.normals.elementAt(286);
      expect(normal_7_286, vector3MoreOrLessEquals(Vector3(0.950454, -0.06233, 0.304551)));
      final normal_7_287 = mesh_7.normals.elementAt(287);
      expect(normal_7_287, vector3MoreOrLessEquals(Vector3(0.975847, 0.140489, 0.167289)));
      final normal_7_288 = mesh_7.normals.elementAt(288);
      expect(normal_7_288, vector3MoreOrLessEquals(Vector3(0.641037, -0.375221, 0.669538)));
      final normal_7_289 = mesh_7.normals.elementAt(289);
      expect(normal_7_289, vector3MoreOrLessEquals(Vector3(0.614542, -0.453134, 0.645761)));
      final normal_7_290 = mesh_7.normals.elementAt(290);
      expect(normal_7_290, vector3MoreOrLessEquals(Vector3(0.950454, -0.06233, 0.304551)));
      final normal_7_291 = mesh_7.normals.elementAt(291);
      expect(normal_7_291, vector3MoreOrLessEquals(Vector3(0.614542, -0.453134, 0.645761)));
      final normal_7_292 = mesh_7.normals.elementAt(292);
      expect(normal_7_292, vector3MoreOrLessEquals(Vector3(0.989975, 0.079498, 0.116747)));
      final normal_7_293 = mesh_7.normals.elementAt(293);
      expect(normal_7_293, vector3MoreOrLessEquals(Vector3(0.950454, -0.06233, 0.304551)));
      expect(mesh_7.tangents.length, isZero);
      expect(mesh_7.bitangents.length, isZero);
      expect(mesh_7.colors.length, isZero);
      expect(mesh_7.textureCoords.length, equals(1));
      final textureCoords_7_0 = mesh_7.textureCoords.elementAt(0);
      expect(textureCoords_7_0.length, equals(294));
      final textureCoord_7_0_0 = textureCoords_7_0.elementAt(0);
      expect(textureCoord_7_0_0, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_1 = textureCoords_7_0.elementAt(1);
      expect(textureCoord_7_0_1, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_2 = textureCoords_7_0.elementAt(2);
      expect(textureCoord_7_0_2, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_3 = textureCoords_7_0.elementAt(3);
      expect(textureCoord_7_0_3, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_4 = textureCoords_7_0.elementAt(4);
      expect(textureCoord_7_0_4, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_5 = textureCoords_7_0.elementAt(5);
      expect(textureCoord_7_0_5, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_6 = textureCoords_7_0.elementAt(6);
      expect(textureCoord_7_0_6, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_7_0_7 = textureCoords_7_0.elementAt(7);
      expect(textureCoord_7_0_7, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_7_0_8 = textureCoords_7_0.elementAt(8);
      expect(textureCoord_7_0_8, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_7_0_9 = textureCoords_7_0.elementAt(9);
      expect(textureCoord_7_0_9, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_7_0_10 = textureCoords_7_0.elementAt(10);
      expect(textureCoord_7_0_10, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_7_0_11 = textureCoords_7_0.elementAt(11);
      expect(textureCoord_7_0_11, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_7_0_12 = textureCoords_7_0.elementAt(12);
      expect(textureCoord_7_0_12, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_7_0_13 = textureCoords_7_0.elementAt(13);
      expect(textureCoord_7_0_13, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_7_0_14 = textureCoords_7_0.elementAt(14);
      expect(textureCoord_7_0_14, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_7_0_15 = textureCoords_7_0.elementAt(15);
      expect(textureCoord_7_0_15, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_7_0_16 = textureCoords_7_0.elementAt(16);
      expect(textureCoord_7_0_16, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_7_0_17 = textureCoords_7_0.elementAt(17);
      expect(textureCoord_7_0_17, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_7_0_18 = textureCoords_7_0.elementAt(18);
      expect(textureCoord_7_0_18, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_7_0_19 = textureCoords_7_0.elementAt(19);
      expect(textureCoord_7_0_19, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_7_0_20 = textureCoords_7_0.elementAt(20);
      expect(textureCoord_7_0_20, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_7_0_21 = textureCoords_7_0.elementAt(21);
      expect(textureCoord_7_0_21, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_7_0_22 = textureCoords_7_0.elementAt(22);
      expect(textureCoord_7_0_22, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_7_0_23 = textureCoords_7_0.elementAt(23);
      expect(textureCoord_7_0_23, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_7_0_24 = textureCoords_7_0.elementAt(24);
      expect(textureCoord_7_0_24, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_7_0_25 = textureCoords_7_0.elementAt(25);
      expect(textureCoord_7_0_25, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_7_0_26 = textureCoords_7_0.elementAt(26);
      expect(textureCoord_7_0_26, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_7_0_27 = textureCoords_7_0.elementAt(27);
      expect(textureCoord_7_0_27, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_7_0_28 = textureCoords_7_0.elementAt(28);
      expect(textureCoord_7_0_28, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_7_0_29 = textureCoords_7_0.elementAt(29);
      expect(textureCoord_7_0_29, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_7_0_30 = textureCoords_7_0.elementAt(30);
      expect(textureCoord_7_0_30, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_7_0_31 = textureCoords_7_0.elementAt(31);
      expect(textureCoord_7_0_31, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_7_0_32 = textureCoords_7_0.elementAt(32);
      expect(textureCoord_7_0_32, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_7_0_33 = textureCoords_7_0.elementAt(33);
      expect(textureCoord_7_0_33, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_7_0_34 = textureCoords_7_0.elementAt(34);
      expect(textureCoord_7_0_34, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_7_0_35 = textureCoords_7_0.elementAt(35);
      expect(textureCoord_7_0_35, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_7_0_36 = textureCoords_7_0.elementAt(36);
      expect(textureCoord_7_0_36, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_7_0_37 = textureCoords_7_0.elementAt(37);
      expect(textureCoord_7_0_37, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_38 = textureCoords_7_0.elementAt(38);
      expect(textureCoord_7_0_38, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_7_0_39 = textureCoords_7_0.elementAt(39);
      expect(textureCoord_7_0_39, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_40 = textureCoords_7_0.elementAt(40);
      expect(textureCoord_7_0_40, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_7_0_41 = textureCoords_7_0.elementAt(41);
      expect(textureCoord_7_0_41, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_7_0_42 = textureCoords_7_0.elementAt(42);
      expect(textureCoord_7_0_42, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_43 = textureCoords_7_0.elementAt(43);
      expect(textureCoord_7_0_43, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_44 = textureCoords_7_0.elementAt(44);
      expect(textureCoord_7_0_44, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_45 = textureCoords_7_0.elementAt(45);
      expect(textureCoord_7_0_45, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_46 = textureCoords_7_0.elementAt(46);
      expect(textureCoord_7_0_46, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_47 = textureCoords_7_0.elementAt(47);
      expect(textureCoord_7_0_47, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_48 = textureCoords_7_0.elementAt(48);
      expect(textureCoord_7_0_48, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_7_0_49 = textureCoords_7_0.elementAt(49);
      expect(textureCoord_7_0_49, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_7_0_50 = textureCoords_7_0.elementAt(50);
      expect(textureCoord_7_0_50, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_7_0_51 = textureCoords_7_0.elementAt(51);
      expect(textureCoord_7_0_51, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_7_0_52 = textureCoords_7_0.elementAt(52);
      expect(textureCoord_7_0_52, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_7_0_53 = textureCoords_7_0.elementAt(53);
      expect(textureCoord_7_0_53, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_7_0_54 = textureCoords_7_0.elementAt(54);
      expect(textureCoord_7_0_54, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_7_0_55 = textureCoords_7_0.elementAt(55);
      expect(textureCoord_7_0_55, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_7_0_56 = textureCoords_7_0.elementAt(56);
      expect(textureCoord_7_0_56, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_7_0_57 = textureCoords_7_0.elementAt(57);
      expect(textureCoord_7_0_57, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_7_0_58 = textureCoords_7_0.elementAt(58);
      expect(textureCoord_7_0_58, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_7_0_59 = textureCoords_7_0.elementAt(59);
      expect(textureCoord_7_0_59, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_7_0_60 = textureCoords_7_0.elementAt(60);
      expect(textureCoord_7_0_60, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_7_0_61 = textureCoords_7_0.elementAt(61);
      expect(textureCoord_7_0_61, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_7_0_62 = textureCoords_7_0.elementAt(62);
      expect(textureCoord_7_0_62, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_7_0_63 = textureCoords_7_0.elementAt(63);
      expect(textureCoord_7_0_63, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_7_0_64 = textureCoords_7_0.elementAt(64);
      expect(textureCoord_7_0_64, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_7_0_65 = textureCoords_7_0.elementAt(65);
      expect(textureCoord_7_0_65, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_7_0_66 = textureCoords_7_0.elementAt(66);
      expect(textureCoord_7_0_66, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_7_0_67 = textureCoords_7_0.elementAt(67);
      expect(textureCoord_7_0_67, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_7_0_68 = textureCoords_7_0.elementAt(68);
      expect(textureCoord_7_0_68, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_7_0_69 = textureCoords_7_0.elementAt(69);
      expect(textureCoord_7_0_69, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_7_0_70 = textureCoords_7_0.elementAt(70);
      expect(textureCoord_7_0_70, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_7_0_71 = textureCoords_7_0.elementAt(71);
      expect(textureCoord_7_0_71, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_7_0_72 = textureCoords_7_0.elementAt(72);
      expect(textureCoord_7_0_72, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_7_0_73 = textureCoords_7_0.elementAt(73);
      expect(textureCoord_7_0_73, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_7_0_74 = textureCoords_7_0.elementAt(74);
      expect(textureCoord_7_0_74, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_7_0_75 = textureCoords_7_0.elementAt(75);
      expect(textureCoord_7_0_75, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_7_0_76 = textureCoords_7_0.elementAt(76);
      expect(textureCoord_7_0_76, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_7_0_77 = textureCoords_7_0.elementAt(77);
      expect(textureCoord_7_0_77, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_7_0_78 = textureCoords_7_0.elementAt(78);
      expect(textureCoord_7_0_78, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_7_0_79 = textureCoords_7_0.elementAt(79);
      expect(textureCoord_7_0_79, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_7_0_80 = textureCoords_7_0.elementAt(80);
      expect(textureCoord_7_0_80, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_7_0_81 = textureCoords_7_0.elementAt(81);
      expect(textureCoord_7_0_81, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_7_0_82 = textureCoords_7_0.elementAt(82);
      expect(textureCoord_7_0_82, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_7_0_83 = textureCoords_7_0.elementAt(83);
      expect(textureCoord_7_0_83, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_7_0_84 = textureCoords_7_0.elementAt(84);
      expect(textureCoord_7_0_84, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_85 = textureCoords_7_0.elementAt(85);
      expect(textureCoord_7_0_85, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_86 = textureCoords_7_0.elementAt(86);
      expect(textureCoord_7_0_86, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_87 = textureCoords_7_0.elementAt(87);
      expect(textureCoord_7_0_87, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_88 = textureCoords_7_0.elementAt(88);
      expect(textureCoord_7_0_88, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_89 = textureCoords_7_0.elementAt(89);
      expect(textureCoord_7_0_89, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_90 = textureCoords_7_0.elementAt(90);
      expect(textureCoord_7_0_90, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_7_0_91 = textureCoords_7_0.elementAt(91);
      expect(textureCoord_7_0_91, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_7_0_92 = textureCoords_7_0.elementAt(92);
      expect(textureCoord_7_0_92, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_7_0_93 = textureCoords_7_0.elementAt(93);
      expect(textureCoord_7_0_93, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_7_0_94 = textureCoords_7_0.elementAt(94);
      expect(textureCoord_7_0_94, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_7_0_95 = textureCoords_7_0.elementAt(95);
      expect(textureCoord_7_0_95, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_7_0_96 = textureCoords_7_0.elementAt(96);
      expect(textureCoord_7_0_96, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_7_0_97 = textureCoords_7_0.elementAt(97);
      expect(textureCoord_7_0_97, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_7_0_98 = textureCoords_7_0.elementAt(98);
      expect(textureCoord_7_0_98, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_7_0_99 = textureCoords_7_0.elementAt(99);
      expect(textureCoord_7_0_99, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_7_0_100 = textureCoords_7_0.elementAt(100);
      expect(textureCoord_7_0_100, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_7_0_101 = textureCoords_7_0.elementAt(101);
      expect(textureCoord_7_0_101, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_7_0_102 = textureCoords_7_0.elementAt(102);
      expect(textureCoord_7_0_102, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_7_0_103 = textureCoords_7_0.elementAt(103);
      expect(textureCoord_7_0_103, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_7_0_104 = textureCoords_7_0.elementAt(104);
      expect(textureCoord_7_0_104, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_7_0_105 = textureCoords_7_0.elementAt(105);
      expect(textureCoord_7_0_105, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_7_0_106 = textureCoords_7_0.elementAt(106);
      expect(textureCoord_7_0_106, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_7_0_107 = textureCoords_7_0.elementAt(107);
      expect(textureCoord_7_0_107, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_7_0_108 = textureCoords_7_0.elementAt(108);
      expect(textureCoord_7_0_108, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_7_0_109 = textureCoords_7_0.elementAt(109);
      expect(textureCoord_7_0_109, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_7_0_110 = textureCoords_7_0.elementAt(110);
      expect(textureCoord_7_0_110, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_7_0_111 = textureCoords_7_0.elementAt(111);
      expect(textureCoord_7_0_111, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_7_0_112 = textureCoords_7_0.elementAt(112);
      expect(textureCoord_7_0_112, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_7_0_113 = textureCoords_7_0.elementAt(113);
      expect(textureCoord_7_0_113, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_7_0_114 = textureCoords_7_0.elementAt(114);
      expect(textureCoord_7_0_114, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_7_0_115 = textureCoords_7_0.elementAt(115);
      expect(textureCoord_7_0_115, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_7_0_116 = textureCoords_7_0.elementAt(116);
      expect(textureCoord_7_0_116, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_7_0_117 = textureCoords_7_0.elementAt(117);
      expect(textureCoord_7_0_117, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_7_0_118 = textureCoords_7_0.elementAt(118);
      expect(textureCoord_7_0_118, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_7_0_119 = textureCoords_7_0.elementAt(119);
      expect(textureCoord_7_0_119, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_7_0_120 = textureCoords_7_0.elementAt(120);
      expect(textureCoord_7_0_120, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_7_0_121 = textureCoords_7_0.elementAt(121);
      expect(textureCoord_7_0_121, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_7_0_122 = textureCoords_7_0.elementAt(122);
      expect(textureCoord_7_0_122, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_7_0_123 = textureCoords_7_0.elementAt(123);
      expect(textureCoord_7_0_123, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_7_0_124 = textureCoords_7_0.elementAt(124);
      expect(textureCoord_7_0_124, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_7_0_125 = textureCoords_7_0.elementAt(125);
      expect(textureCoord_7_0_125, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_7_0_126 = textureCoords_7_0.elementAt(126);
      expect(textureCoord_7_0_126, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_127 = textureCoords_7_0.elementAt(127);
      expect(textureCoord_7_0_127, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_128 = textureCoords_7_0.elementAt(128);
      expect(textureCoord_7_0_128, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_129 = textureCoords_7_0.elementAt(129);
      expect(textureCoord_7_0_129, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_130 = textureCoords_7_0.elementAt(130);
      expect(textureCoord_7_0_130, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_131 = textureCoords_7_0.elementAt(131);
      expect(textureCoord_7_0_131, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_132 = textureCoords_7_0.elementAt(132);
      expect(textureCoord_7_0_132, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_7_0_133 = textureCoords_7_0.elementAt(133);
      expect(textureCoord_7_0_133, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_7_0_134 = textureCoords_7_0.elementAt(134);
      expect(textureCoord_7_0_134, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_7_0_135 = textureCoords_7_0.elementAt(135);
      expect(textureCoord_7_0_135, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_7_0_136 = textureCoords_7_0.elementAt(136);
      expect(textureCoord_7_0_136, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_7_0_137 = textureCoords_7_0.elementAt(137);
      expect(textureCoord_7_0_137, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_7_0_138 = textureCoords_7_0.elementAt(138);
      expect(textureCoord_7_0_138, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_7_0_139 = textureCoords_7_0.elementAt(139);
      expect(textureCoord_7_0_139, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_7_0_140 = textureCoords_7_0.elementAt(140);
      expect(textureCoord_7_0_140, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_7_0_141 = textureCoords_7_0.elementAt(141);
      expect(textureCoord_7_0_141, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_7_0_142 = textureCoords_7_0.elementAt(142);
      expect(textureCoord_7_0_142, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_7_0_143 = textureCoords_7_0.elementAt(143);
      expect(textureCoord_7_0_143, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_7_0_144 = textureCoords_7_0.elementAt(144);
      expect(textureCoord_7_0_144, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_7_0_145 = textureCoords_7_0.elementAt(145);
      expect(textureCoord_7_0_145, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_7_0_146 = textureCoords_7_0.elementAt(146);
      expect(textureCoord_7_0_146, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_7_0_147 = textureCoords_7_0.elementAt(147);
      expect(textureCoord_7_0_147, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_7_0_148 = textureCoords_7_0.elementAt(148);
      expect(textureCoord_7_0_148, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_7_0_149 = textureCoords_7_0.elementAt(149);
      expect(textureCoord_7_0_149, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_7_0_150 = textureCoords_7_0.elementAt(150);
      expect(textureCoord_7_0_150, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_7_0_151 = textureCoords_7_0.elementAt(151);
      expect(textureCoord_7_0_151, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_7_0_152 = textureCoords_7_0.elementAt(152);
      expect(textureCoord_7_0_152, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_7_0_153 = textureCoords_7_0.elementAt(153);
      expect(textureCoord_7_0_153, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_7_0_154 = textureCoords_7_0.elementAt(154);
      expect(textureCoord_7_0_154, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_7_0_155 = textureCoords_7_0.elementAt(155);
      expect(textureCoord_7_0_155, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_7_0_156 = textureCoords_7_0.elementAt(156);
      expect(textureCoord_7_0_156, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_7_0_157 = textureCoords_7_0.elementAt(157);
      expect(textureCoord_7_0_157, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_7_0_158 = textureCoords_7_0.elementAt(158);
      expect(textureCoord_7_0_158, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_7_0_159 = textureCoords_7_0.elementAt(159);
      expect(textureCoord_7_0_159, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_7_0_160 = textureCoords_7_0.elementAt(160);
      expect(textureCoord_7_0_160, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_7_0_161 = textureCoords_7_0.elementAt(161);
      expect(textureCoord_7_0_161, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_7_0_162 = textureCoords_7_0.elementAt(162);
      expect(textureCoord_7_0_162, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_7_0_163 = textureCoords_7_0.elementAt(163);
      expect(textureCoord_7_0_163, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_7_0_164 = textureCoords_7_0.elementAt(164);
      expect(textureCoord_7_0_164, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_7_0_165 = textureCoords_7_0.elementAt(165);
      expect(textureCoord_7_0_165, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_7_0_166 = textureCoords_7_0.elementAt(166);
      expect(textureCoord_7_0_166, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_7_0_167 = textureCoords_7_0.elementAt(167);
      expect(textureCoord_7_0_167, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_7_0_168 = textureCoords_7_0.elementAt(168);
      expect(textureCoord_7_0_168, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_169 = textureCoords_7_0.elementAt(169);
      expect(textureCoord_7_0_169, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_170 = textureCoords_7_0.elementAt(170);
      expect(textureCoord_7_0_170, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_171 = textureCoords_7_0.elementAt(171);
      expect(textureCoord_7_0_171, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_172 = textureCoords_7_0.elementAt(172);
      expect(textureCoord_7_0_172, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_173 = textureCoords_7_0.elementAt(173);
      expect(textureCoord_7_0_173, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_174 = textureCoords_7_0.elementAt(174);
      expect(textureCoord_7_0_174, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_7_0_175 = textureCoords_7_0.elementAt(175);
      expect(textureCoord_7_0_175, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_7_0_176 = textureCoords_7_0.elementAt(176);
      expect(textureCoord_7_0_176, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_7_0_177 = textureCoords_7_0.elementAt(177);
      expect(textureCoord_7_0_177, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_7_0_178 = textureCoords_7_0.elementAt(178);
      expect(textureCoord_7_0_178, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_7_0_179 = textureCoords_7_0.elementAt(179);
      expect(textureCoord_7_0_179, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_7_0_180 = textureCoords_7_0.elementAt(180);
      expect(textureCoord_7_0_180, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_7_0_181 = textureCoords_7_0.elementAt(181);
      expect(textureCoord_7_0_181, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_7_0_182 = textureCoords_7_0.elementAt(182);
      expect(textureCoord_7_0_182, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_7_0_183 = textureCoords_7_0.elementAt(183);
      expect(textureCoord_7_0_183, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_7_0_184 = textureCoords_7_0.elementAt(184);
      expect(textureCoord_7_0_184, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_7_0_185 = textureCoords_7_0.elementAt(185);
      expect(textureCoord_7_0_185, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_7_0_186 = textureCoords_7_0.elementAt(186);
      expect(textureCoord_7_0_186, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_7_0_187 = textureCoords_7_0.elementAt(187);
      expect(textureCoord_7_0_187, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_7_0_188 = textureCoords_7_0.elementAt(188);
      expect(textureCoord_7_0_188, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_7_0_189 = textureCoords_7_0.elementAt(189);
      expect(textureCoord_7_0_189, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_7_0_190 = textureCoords_7_0.elementAt(190);
      expect(textureCoord_7_0_190, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_7_0_191 = textureCoords_7_0.elementAt(191);
      expect(textureCoord_7_0_191, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_7_0_192 = textureCoords_7_0.elementAt(192);
      expect(textureCoord_7_0_192, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_7_0_193 = textureCoords_7_0.elementAt(193);
      expect(textureCoord_7_0_193, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_7_0_194 = textureCoords_7_0.elementAt(194);
      expect(textureCoord_7_0_194, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_7_0_195 = textureCoords_7_0.elementAt(195);
      expect(textureCoord_7_0_195, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_7_0_196 = textureCoords_7_0.elementAt(196);
      expect(textureCoord_7_0_196, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_7_0_197 = textureCoords_7_0.elementAt(197);
      expect(textureCoord_7_0_197, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_7_0_198 = textureCoords_7_0.elementAt(198);
      expect(textureCoord_7_0_198, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_7_0_199 = textureCoords_7_0.elementAt(199);
      expect(textureCoord_7_0_199, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_7_0_200 = textureCoords_7_0.elementAt(200);
      expect(textureCoord_7_0_200, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_7_0_201 = textureCoords_7_0.elementAt(201);
      expect(textureCoord_7_0_201, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_7_0_202 = textureCoords_7_0.elementAt(202);
      expect(textureCoord_7_0_202, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_7_0_203 = textureCoords_7_0.elementAt(203);
      expect(textureCoord_7_0_203, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_7_0_204 = textureCoords_7_0.elementAt(204);
      expect(textureCoord_7_0_204, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_7_0_205 = textureCoords_7_0.elementAt(205);
      expect(textureCoord_7_0_205, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_7_0_206 = textureCoords_7_0.elementAt(206);
      expect(textureCoord_7_0_206, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_7_0_207 = textureCoords_7_0.elementAt(207);
      expect(textureCoord_7_0_207, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_7_0_208 = textureCoords_7_0.elementAt(208);
      expect(textureCoord_7_0_208, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_7_0_209 = textureCoords_7_0.elementAt(209);
      expect(textureCoord_7_0_209, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_7_0_210 = textureCoords_7_0.elementAt(210);
      expect(textureCoord_7_0_210, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_211 = textureCoords_7_0.elementAt(211);
      expect(textureCoord_7_0_211, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_212 = textureCoords_7_0.elementAt(212);
      expect(textureCoord_7_0_212, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_213 = textureCoords_7_0.elementAt(213);
      expect(textureCoord_7_0_213, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_214 = textureCoords_7_0.elementAt(214);
      expect(textureCoord_7_0_214, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_215 = textureCoords_7_0.elementAt(215);
      expect(textureCoord_7_0_215, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_216 = textureCoords_7_0.elementAt(216);
      expect(textureCoord_7_0_216, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_7_0_217 = textureCoords_7_0.elementAt(217);
      expect(textureCoord_7_0_217, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_7_0_218 = textureCoords_7_0.elementAt(218);
      expect(textureCoord_7_0_218, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_7_0_219 = textureCoords_7_0.elementAt(219);
      expect(textureCoord_7_0_219, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_7_0_220 = textureCoords_7_0.elementAt(220);
      expect(textureCoord_7_0_220, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_7_0_221 = textureCoords_7_0.elementAt(221);
      expect(textureCoord_7_0_221, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_7_0_222 = textureCoords_7_0.elementAt(222);
      expect(textureCoord_7_0_222, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_7_0_223 = textureCoords_7_0.elementAt(223);
      expect(textureCoord_7_0_223, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_7_0_224 = textureCoords_7_0.elementAt(224);
      expect(textureCoord_7_0_224, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_7_0_225 = textureCoords_7_0.elementAt(225);
      expect(textureCoord_7_0_225, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_7_0_226 = textureCoords_7_0.elementAt(226);
      expect(textureCoord_7_0_226, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_7_0_227 = textureCoords_7_0.elementAt(227);
      expect(textureCoord_7_0_227, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_7_0_228 = textureCoords_7_0.elementAt(228);
      expect(textureCoord_7_0_228, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_7_0_229 = textureCoords_7_0.elementAt(229);
      expect(textureCoord_7_0_229, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_7_0_230 = textureCoords_7_0.elementAt(230);
      expect(textureCoord_7_0_230, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_7_0_231 = textureCoords_7_0.elementAt(231);
      expect(textureCoord_7_0_231, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_7_0_232 = textureCoords_7_0.elementAt(232);
      expect(textureCoord_7_0_232, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_7_0_233 = textureCoords_7_0.elementAt(233);
      expect(textureCoord_7_0_233, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_7_0_234 = textureCoords_7_0.elementAt(234);
      expect(textureCoord_7_0_234, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_7_0_235 = textureCoords_7_0.elementAt(235);
      expect(textureCoord_7_0_235, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_7_0_236 = textureCoords_7_0.elementAt(236);
      expect(textureCoord_7_0_236, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_7_0_237 = textureCoords_7_0.elementAt(237);
      expect(textureCoord_7_0_237, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_7_0_238 = textureCoords_7_0.elementAt(238);
      expect(textureCoord_7_0_238, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_7_0_239 = textureCoords_7_0.elementAt(239);
      expect(textureCoord_7_0_239, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_7_0_240 = textureCoords_7_0.elementAt(240);
      expect(textureCoord_7_0_240, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_7_0_241 = textureCoords_7_0.elementAt(241);
      expect(textureCoord_7_0_241, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_7_0_242 = textureCoords_7_0.elementAt(242);
      expect(textureCoord_7_0_242, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_7_0_243 = textureCoords_7_0.elementAt(243);
      expect(textureCoord_7_0_243, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_7_0_244 = textureCoords_7_0.elementAt(244);
      expect(textureCoord_7_0_244, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_7_0_245 = textureCoords_7_0.elementAt(245);
      expect(textureCoord_7_0_245, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_7_0_246 = textureCoords_7_0.elementAt(246);
      expect(textureCoord_7_0_246, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_7_0_247 = textureCoords_7_0.elementAt(247);
      expect(textureCoord_7_0_247, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_7_0_248 = textureCoords_7_0.elementAt(248);
      expect(textureCoord_7_0_248, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_7_0_249 = textureCoords_7_0.elementAt(249);
      expect(textureCoord_7_0_249, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_7_0_250 = textureCoords_7_0.elementAt(250);
      expect(textureCoord_7_0_250, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_7_0_251 = textureCoords_7_0.elementAt(251);
      expect(textureCoord_7_0_251, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_7_0_252 = textureCoords_7_0.elementAt(252);
      expect(textureCoord_7_0_252, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_253 = textureCoords_7_0.elementAt(253);
      expect(textureCoord_7_0_253, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_254 = textureCoords_7_0.elementAt(254);
      expect(textureCoord_7_0_254, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_255 = textureCoords_7_0.elementAt(255);
      expect(textureCoord_7_0_255, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_256 = textureCoords_7_0.elementAt(256);
      expect(textureCoord_7_0_256, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_257 = textureCoords_7_0.elementAt(257);
      expect(textureCoord_7_0_257, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_7_0_258 = textureCoords_7_0.elementAt(258);
      expect(textureCoord_7_0_258, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_7_0_259 = textureCoords_7_0.elementAt(259);
      expect(textureCoord_7_0_259, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_7_0_260 = textureCoords_7_0.elementAt(260);
      expect(textureCoord_7_0_260, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_7_0_261 = textureCoords_7_0.elementAt(261);
      expect(textureCoord_7_0_261, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_7_0_262 = textureCoords_7_0.elementAt(262);
      expect(textureCoord_7_0_262, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_7_0_263 = textureCoords_7_0.elementAt(263);
      expect(textureCoord_7_0_263, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_7_0_264 = textureCoords_7_0.elementAt(264);
      expect(textureCoord_7_0_264, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_7_0_265 = textureCoords_7_0.elementAt(265);
      expect(textureCoord_7_0_265, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_7_0_266 = textureCoords_7_0.elementAt(266);
      expect(textureCoord_7_0_266, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_7_0_267 = textureCoords_7_0.elementAt(267);
      expect(textureCoord_7_0_267, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_7_0_268 = textureCoords_7_0.elementAt(268);
      expect(textureCoord_7_0_268, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_7_0_269 = textureCoords_7_0.elementAt(269);
      expect(textureCoord_7_0_269, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_7_0_270 = textureCoords_7_0.elementAt(270);
      expect(textureCoord_7_0_270, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_7_0_271 = textureCoords_7_0.elementAt(271);
      expect(textureCoord_7_0_271, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_7_0_272 = textureCoords_7_0.elementAt(272);
      expect(textureCoord_7_0_272, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_7_0_273 = textureCoords_7_0.elementAt(273);
      expect(textureCoord_7_0_273, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_7_0_274 = textureCoords_7_0.elementAt(274);
      expect(textureCoord_7_0_274, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_7_0_275 = textureCoords_7_0.elementAt(275);
      expect(textureCoord_7_0_275, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_7_0_276 = textureCoords_7_0.elementAt(276);
      expect(textureCoord_7_0_276, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_7_0_277 = textureCoords_7_0.elementAt(277);
      expect(textureCoord_7_0_277, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_7_0_278 = textureCoords_7_0.elementAt(278);
      expect(textureCoord_7_0_278, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_7_0_279 = textureCoords_7_0.elementAt(279);
      expect(textureCoord_7_0_279, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_7_0_280 = textureCoords_7_0.elementAt(280);
      expect(textureCoord_7_0_280, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_7_0_281 = textureCoords_7_0.elementAt(281);
      expect(textureCoord_7_0_281, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_7_0_282 = textureCoords_7_0.elementAt(282);
      expect(textureCoord_7_0_282, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_7_0_283 = textureCoords_7_0.elementAt(283);
      expect(textureCoord_7_0_283, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_7_0_284 = textureCoords_7_0.elementAt(284);
      expect(textureCoord_7_0_284, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_7_0_285 = textureCoords_7_0.elementAt(285);
      expect(textureCoord_7_0_285, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_7_0_286 = textureCoords_7_0.elementAt(286);
      expect(textureCoord_7_0_286, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_7_0_287 = textureCoords_7_0.elementAt(287);
      expect(textureCoord_7_0_287, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_7_0_288 = textureCoords_7_0.elementAt(288);
      expect(textureCoord_7_0_288, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_7_0_289 = textureCoords_7_0.elementAt(289);
      expect(textureCoord_7_0_289, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_7_0_290 = textureCoords_7_0.elementAt(290);
      expect(textureCoord_7_0_290, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_7_0_291 = textureCoords_7_0.elementAt(291);
      expect(textureCoord_7_0_291, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_7_0_292 = textureCoords_7_0.elementAt(292);
      expect(textureCoord_7_0_292, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_7_0_293 = textureCoords_7_0.elementAt(293);
      expect(textureCoord_7_0_293, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      expect(mesh_7.uvComponents.length, equals(1));
      expect(mesh_7.uvComponents, equals([2]));
      expect(mesh_7.faces.length, equals(98));
      expect(mesh_7.bones.length, isZero);
      expect(mesh_7.materialIndex, equals(4));
      expect(mesh_7.name, equals('Bein3Li'));
      expect(mesh_7.animMeshes.length, isZero);
      expect(mesh_7.morphingMethod, isZero);
      expect(mesh_7.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_8 = meshes.elementAt(8);
      expect(mesh_8.primitiveTypes, equals(4));
      expect(mesh_8.vertices.length, equals(294));
      final vertex_8_0 = mesh_8.vertices.elementAt(0);
      expect(vertex_8_0, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_1 = mesh_8.vertices.elementAt(1);
      expect(vertex_8_1, vector3MoreOrLessEquals(Vector3(-14.1027, -6.07578, -7.12446)));
      final vertex_8_2 = mesh_8.vertices.elementAt(2);
      expect(vertex_8_2, vector3MoreOrLessEquals(Vector3(-11.2052, -7.28023, -5.84188)));
      final vertex_8_3 = mesh_8.vertices.elementAt(3);
      expect(vertex_8_3, vector3MoreOrLessEquals(Vector3(19.7499, -37.6075, 68.3299)));
      final vertex_8_4 = mesh_8.vertices.elementAt(4);
      expect(vertex_8_4, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_5 = mesh_8.vertices.elementAt(5);
      expect(vertex_8_5, vector3MoreOrLessEquals(Vector3(19.8971, -38.1552, 68.0391)));
      final vertex_8_6 = mesh_8.vertices.elementAt(6);
      expect(vertex_8_6, vector3MoreOrLessEquals(Vector3(-4.90751, 6.09364, 10.1268)));
      final vertex_8_7 = mesh_8.vertices.elementAt(7);
      expect(vertex_8_7, vector3MoreOrLessEquals(Vector3(-2.87765, 5.5176, 11.0769)));
      final vertex_8_8 = mesh_8.vertices.elementAt(8);
      expect(vertex_8_8, vector3MoreOrLessEquals(Vector3(-11.2052, -7.28023, -5.84188)));
      final vertex_8_9 = mesh_8.vertices.elementAt(9);
      expect(vertex_8_9, vector3MoreOrLessEquals(Vector3(-14.1027, -6.07578, -7.12446)));
      final vertex_8_10 = mesh_8.vertices.elementAt(10);
      expect(vertex_8_10, vector3MoreOrLessEquals(Vector3(-4.90751, 6.09364, 10.1268)));
      final vertex_8_11 = mesh_8.vertices.elementAt(11);
      expect(vertex_8_11, vector3MoreOrLessEquals(Vector3(-11.2052, -7.28023, -5.84188)));
      final vertex_8_12 = mesh_8.vertices.elementAt(12);
      expect(vertex_8_12, vector3MoreOrLessEquals(Vector3(-4.90751, 6.09364, 10.1268)));
      final vertex_8_13 = mesh_8.vertices.elementAt(13);
      expect(vertex_8_13, vector3MoreOrLessEquals(Vector3(1.74567, 26.1369, 21.0078)));
      final vertex_8_14 = mesh_8.vertices.elementAt(14);
      expect(vertex_8_14, vector3MoreOrLessEquals(Vector3(-2.87765, 5.5176, 11.0769)));
      final vertex_8_15 = mesh_8.vertices.elementAt(15);
      expect(vertex_8_15, vector3MoreOrLessEquals(Vector3(-4.90751, 6.09364, 10.1268)));
      final vertex_8_16 = mesh_8.vertices.elementAt(16);
      expect(vertex_8_16, vector3MoreOrLessEquals(Vector3(0.474552, 27.2094, 20.9797)));
      final vertex_8_17 = mesh_8.vertices.elementAt(17);
      expect(vertex_8_17, vector3MoreOrLessEquals(Vector3(1.74567, 26.1369, 21.0078)));
      final vertex_8_18 = mesh_8.vertices.elementAt(18);
      expect(vertex_8_18, vector3MoreOrLessEquals(Vector3(3.23343, 28.024, 25.2494)));
      final vertex_8_19 = mesh_8.vertices.elementAt(19);
      expect(vertex_8_19, vector3MoreOrLessEquals(Vector3(4.28245, 26.6477, 23.7131)));
      final vertex_8_20 = mesh_8.vertices.elementAt(20);
      expect(vertex_8_20, vector3MoreOrLessEquals(Vector3(1.74567, 26.1369, 21.0078)));
      final vertex_8_21 = mesh_8.vertices.elementAt(21);
      expect(vertex_8_21, vector3MoreOrLessEquals(Vector3(0.474552, 27.2094, 20.9797)));
      final vertex_8_22 = mesh_8.vertices.elementAt(22);
      expect(vertex_8_22, vector3MoreOrLessEquals(Vector3(3.23343, 28.024, 25.2494)));
      final vertex_8_23 = mesh_8.vertices.elementAt(23);
      expect(vertex_8_23, vector3MoreOrLessEquals(Vector3(1.74567, 26.1369, 21.0078)));
      final vertex_8_24 = mesh_8.vertices.elementAt(24);
      expect(vertex_8_24, vector3MoreOrLessEquals(Vector3(3.23343, 28.024, 25.2494)));
      final vertex_8_25 = mesh_8.vertices.elementAt(25);
      expect(vertex_8_25, vector3MoreOrLessEquals(Vector3(14.8602, 5.64247, 47.619)));
      final vertex_8_26 = mesh_8.vertices.elementAt(26);
      expect(vertex_8_26, vector3MoreOrLessEquals(Vector3(4.28245, 26.6477, 23.7131)));
      final vertex_8_27 = mesh_8.vertices.elementAt(27);
      expect(vertex_8_27, vector3MoreOrLessEquals(Vector3(3.23343, 28.024, 25.2494)));
      final vertex_8_28 = mesh_8.vertices.elementAt(28);
      expect(vertex_8_28, vector3MoreOrLessEquals(Vector3(14.5603, 6.22359, 49.8387)));
      final vertex_8_29 = mesh_8.vertices.elementAt(29);
      expect(vertex_8_29, vector3MoreOrLessEquals(Vector3(14.8602, 5.64247, 47.619)));
      final vertex_8_30 = mesh_8.vertices.elementAt(30);
      expect(vertex_8_30, vector3MoreOrLessEquals(Vector3(18.9761, -28.0781, 62.2734)));
      final vertex_8_31 = mesh_8.vertices.elementAt(31);
      expect(vertex_8_31, vector3MoreOrLessEquals(Vector3(19.2007, -29.6602, 61.2654)));
      final vertex_8_32 = mesh_8.vertices.elementAt(32);
      expect(vertex_8_32, vector3MoreOrLessEquals(Vector3(14.8602, 5.64247, 47.619)));
      final vertex_8_33 = mesh_8.vertices.elementAt(33);
      expect(vertex_8_33, vector3MoreOrLessEquals(Vector3(14.5603, 6.22359, 49.8387)));
      final vertex_8_34 = mesh_8.vertices.elementAt(34);
      expect(vertex_8_34, vector3MoreOrLessEquals(Vector3(18.9761, -28.0781, 62.2734)));
      final vertex_8_35 = mesh_8.vertices.elementAt(35);
      expect(vertex_8_35, vector3MoreOrLessEquals(Vector3(14.8602, 5.64247, 47.619)));
      final vertex_8_36 = mesh_8.vertices.elementAt(36);
      expect(vertex_8_36, vector3MoreOrLessEquals(Vector3(18.9761, -28.0781, 62.2734)));
      final vertex_8_37 = mesh_8.vertices.elementAt(37);
      expect(vertex_8_37, vector3MoreOrLessEquals(Vector3(19.8971, -38.1552, 68.0391)));
      final vertex_8_38 = mesh_8.vertices.elementAt(38);
      expect(vertex_8_38, vector3MoreOrLessEquals(Vector3(19.2007, -29.6602, 61.2654)));
      final vertex_8_39 = mesh_8.vertices.elementAt(39);
      expect(vertex_8_39, vector3MoreOrLessEquals(Vector3(18.9761, -28.0781, 62.2734)));
      final vertex_8_40 = mesh_8.vertices.elementAt(40);
      expect(vertex_8_40, vector3MoreOrLessEquals(Vector3(19.7499, -37.6075, 68.3299)));
      final vertex_8_41 = mesh_8.vertices.elementAt(41);
      expect(vertex_8_41, vector3MoreOrLessEquals(Vector3(19.8971, -38.1552, 68.0391)));
      final vertex_8_42 = mesh_8.vertices.elementAt(42);
      expect(vertex_8_42, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_43 = mesh_8.vertices.elementAt(43);
      expect(vertex_8_43, vector3MoreOrLessEquals(Vector3(-17.116, -5.53336, -5.52842)));
      final vertex_8_44 = mesh_8.vertices.elementAt(44);
      expect(vertex_8_44, vector3MoreOrLessEquals(Vector3(-14.1027, -6.07578, -7.12446)));
      final vertex_8_45 = mesh_8.vertices.elementAt(45);
      expect(vertex_8_45, vector3MoreOrLessEquals(Vector3(19.3002, -37.4672, 68.49)));
      final vertex_8_46 = mesh_8.vertices.elementAt(46);
      expect(vertex_8_46, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_47 = mesh_8.vertices.elementAt(47);
      expect(vertex_8_47, vector3MoreOrLessEquals(Vector3(19.7499, -37.6075, 68.3299)));
      final vertex_8_48 = mesh_8.vertices.elementAt(48);
      expect(vertex_8_48, vector3MoreOrLessEquals(Vector3(-17.116, -5.53336, -5.52842)));
      final vertex_8_49 = mesh_8.vertices.elementAt(49);
      expect(vertex_8_49, vector3MoreOrLessEquals(Vector3(-4.90751, 6.09364, 10.1268)));
      final vertex_8_50 = mesh_8.vertices.elementAt(50);
      expect(vertex_8_50, vector3MoreOrLessEquals(Vector3(-14.1027, -6.07578, -7.12446)));
      final vertex_8_51 = mesh_8.vertices.elementAt(51);
      expect(vertex_8_51, vector3MoreOrLessEquals(Vector3(-17.116, -5.53336, -5.52842)));
      final vertex_8_52 = mesh_8.vertices.elementAt(52);
      expect(vertex_8_52, vector3MoreOrLessEquals(Vector3(-7.03667, 5.46706, 10.7817)));
      final vertex_8_53 = mesh_8.vertices.elementAt(53);
      expect(vertex_8_53, vector3MoreOrLessEquals(Vector3(-4.90751, 6.09364, 10.1268)));
      final vertex_8_54 = mesh_8.vertices.elementAt(54);
      expect(vertex_8_54, vector3MoreOrLessEquals(Vector3(-0.824137, 27.0092, 21.5109)));
      final vertex_8_55 = mesh_8.vertices.elementAt(55);
      expect(vertex_8_55, vector3MoreOrLessEquals(Vector3(0.474552, 27.2094, 20.9797)));
      final vertex_8_56 = mesh_8.vertices.elementAt(56);
      expect(vertex_8_56, vector3MoreOrLessEquals(Vector3(-4.90751, 6.09364, 10.1268)));
      final vertex_8_57 = mesh_8.vertices.elementAt(57);
      expect(vertex_8_57, vector3MoreOrLessEquals(Vector3(-7.03667, 5.46706, 10.7817)));
      final vertex_8_58 = mesh_8.vertices.elementAt(58);
      expect(vertex_8_58, vector3MoreOrLessEquals(Vector3(-0.824137, 27.0092, 21.5109)));
      final vertex_8_59 = mesh_8.vertices.elementAt(59);
      expect(vertex_8_59, vector3MoreOrLessEquals(Vector3(-4.90751, 6.09364, 10.1268)));
      final vertex_8_60 = mesh_8.vertices.elementAt(60);
      expect(vertex_8_60, vector3MoreOrLessEquals(Vector3(-0.824137, 27.0092, 21.5109)));
      final vertex_8_61 = mesh_8.vertices.elementAt(61);
      expect(vertex_8_61, vector3MoreOrLessEquals(Vector3(3.23343, 28.024, 25.2494)));
      final vertex_8_62 = mesh_8.vertices.elementAt(62);
      expect(vertex_8_62, vector3MoreOrLessEquals(Vector3(0.474552, 27.2094, 20.9797)));
      final vertex_8_63 = mesh_8.vertices.elementAt(63);
      expect(vertex_8_63, vector3MoreOrLessEquals(Vector3(-0.824137, 27.0092, 21.5109)));
      final vertex_8_64 = mesh_8.vertices.elementAt(64);
      expect(vertex_8_64, vector3MoreOrLessEquals(Vector3(1.34655, 27.5951, 26.5185)));
      final vertex_8_65 = mesh_8.vertices.elementAt(65);
      expect(vertex_8_65, vector3MoreOrLessEquals(Vector3(3.23343, 28.024, 25.2494)));
      final vertex_8_66 = mesh_8.vertices.elementAt(66);
      expect(vertex_8_66, vector3MoreOrLessEquals(Vector3(12.8583, 5.59827, 51.2765)));
      final vertex_8_67 = mesh_8.vertices.elementAt(67);
      expect(vertex_8_67, vector3MoreOrLessEquals(Vector3(14.5603, 6.22359, 49.8387)));
      final vertex_8_68 = mesh_8.vertices.elementAt(68);
      expect(vertex_8_68, vector3MoreOrLessEquals(Vector3(3.23343, 28.024, 25.2494)));
      final vertex_8_69 = mesh_8.vertices.elementAt(69);
      expect(vertex_8_69, vector3MoreOrLessEquals(Vector3(1.34655, 27.5951, 26.5185)));
      final vertex_8_70 = mesh_8.vertices.elementAt(70);
      expect(vertex_8_70, vector3MoreOrLessEquals(Vector3(12.8583, 5.59827, 51.2765)));
      final vertex_8_71 = mesh_8.vertices.elementAt(71);
      expect(vertex_8_71, vector3MoreOrLessEquals(Vector3(3.23343, 28.024, 25.2494)));
      final vertex_8_72 = mesh_8.vertices.elementAt(72);
      expect(vertex_8_72, vector3MoreOrLessEquals(Vector3(12.8583, 5.59827, 51.2765)));
      final vertex_8_73 = mesh_8.vertices.elementAt(73);
      expect(vertex_8_73, vector3MoreOrLessEquals(Vector3(18.9761, -28.0781, 62.2734)));
      final vertex_8_74 = mesh_8.vertices.elementAt(74);
      expect(vertex_8_74, vector3MoreOrLessEquals(Vector3(14.5603, 6.22359, 49.8387)));
      final vertex_8_75 = mesh_8.vertices.elementAt(75);
      expect(vertex_8_75, vector3MoreOrLessEquals(Vector3(12.8583, 5.59827, 51.2765)));
      final vertex_8_76 = mesh_8.vertices.elementAt(76);
      expect(vertex_8_76, vector3MoreOrLessEquals(Vector3(18.0423, -27.6766, 62.7098)));
      final vertex_8_77 = mesh_8.vertices.elementAt(77);
      expect(vertex_8_77, vector3MoreOrLessEquals(Vector3(18.9761, -28.0781, 62.2734)));
      final vertex_8_78 = mesh_8.vertices.elementAt(78);
      expect(vertex_8_78, vector3MoreOrLessEquals(Vector3(19.3002, -37.4672, 68.49)));
      final vertex_8_79 = mesh_8.vertices.elementAt(79);
      expect(vertex_8_79, vector3MoreOrLessEquals(Vector3(19.7499, -37.6075, 68.3299)));
      final vertex_8_80 = mesh_8.vertices.elementAt(80);
      expect(vertex_8_80, vector3MoreOrLessEquals(Vector3(18.9761, -28.0781, 62.2734)));
      final vertex_8_81 = mesh_8.vertices.elementAt(81);
      expect(vertex_8_81, vector3MoreOrLessEquals(Vector3(18.0423, -27.6766, 62.7098)));
      final vertex_8_82 = mesh_8.vertices.elementAt(82);
      expect(vertex_8_82, vector3MoreOrLessEquals(Vector3(19.3002, -37.4672, 68.49)));
      final vertex_8_83 = mesh_8.vertices.elementAt(83);
      expect(vertex_8_83, vector3MoreOrLessEquals(Vector3(18.9761, -28.0781, 62.2734)));
      final vertex_8_84 = mesh_8.vertices.elementAt(84);
      expect(vertex_8_84, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_85 = mesh_8.vertices.elementAt(85);
      expect(vertex_8_85, vector3MoreOrLessEquals(Vector3(-17.976, -6.06143, -2.25557)));
      final vertex_8_86 = mesh_8.vertices.elementAt(86);
      expect(vertex_8_86, vector3MoreOrLessEquals(Vector3(-17.116, -5.53336, -5.52842)));
      final vertex_8_87 = mesh_8.vertices.elementAt(87);
      expect(vertex_8_87, vector3MoreOrLessEquals(Vector3(18.8869, -37.8399, 68.3988)));
      final vertex_8_88 = mesh_8.vertices.elementAt(88);
      expect(vertex_8_88, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_89 = mesh_8.vertices.elementAt(89);
      expect(vertex_8_89, vector3MoreOrLessEquals(Vector3(19.3002, -37.4672, 68.49)));
      final vertex_8_90 = mesh_8.vertices.elementAt(90);
      expect(vertex_8_90, vector3MoreOrLessEquals(Vector3(-7.66182, 4.10971, 12.5486)));
      final vertex_8_91 = mesh_8.vertices.elementAt(91);
      expect(vertex_8_91, vector3MoreOrLessEquals(Vector3(-7.03667, 5.46706, 10.7817)));
      final vertex_8_92 = mesh_8.vertices.elementAt(92);
      expect(vertex_8_92, vector3MoreOrLessEquals(Vector3(-17.116, -5.53336, -5.52842)));
      final vertex_8_93 = mesh_8.vertices.elementAt(93);
      expect(vertex_8_93, vector3MoreOrLessEquals(Vector3(-17.976, -6.06143, -2.25557)));
      final vertex_8_94 = mesh_8.vertices.elementAt(94);
      expect(vertex_8_94, vector3MoreOrLessEquals(Vector3(-7.66182, 4.10971, 12.5486)));
      final vertex_8_95 = mesh_8.vertices.elementAt(95);
      expect(vertex_8_95, vector3MoreOrLessEquals(Vector3(-17.116, -5.53336, -5.52842)));
      final vertex_8_96 = mesh_8.vertices.elementAt(96);
      expect(vertex_8_96, vector3MoreOrLessEquals(Vector3(-7.66182, 4.10971, 12.5486)));
      final vertex_8_97 = mesh_8.vertices.elementAt(97);
      expect(vertex_8_97, vector3MoreOrLessEquals(Vector3(-0.824137, 27.0092, 21.5109)));
      final vertex_8_98 = mesh_8.vertices.elementAt(98);
      expect(vertex_8_98, vector3MoreOrLessEquals(Vector3(-7.03667, 5.46706, 10.7817)));
      final vertex_8_99 = mesh_8.vertices.elementAt(99);
      expect(vertex_8_99, vector3MoreOrLessEquals(Vector3(-7.66182, 4.10971, 12.5486)));
      final vertex_8_100 = mesh_8.vertices.elementAt(100);
      expect(vertex_8_100, vector3MoreOrLessEquals(Vector3(-1.17244, 25.687, 22.2014)));
      final vertex_8_101 = mesh_8.vertices.elementAt(101);
      expect(vertex_8_101, vector3MoreOrLessEquals(Vector3(-0.824137, 27.0092, 21.5109)));
      final vertex_8_102 = mesh_8.vertices.elementAt(102);
      expect(vertex_8_102, vector3MoreOrLessEquals(Vector3(0.042627, 25.6839, 26.5647)));
      final vertex_8_103 = mesh_8.vertices.elementAt(103);
      expect(vertex_8_103, vector3MoreOrLessEquals(Vector3(1.34655, 27.5951, 26.5185)));
      final vertex_8_104 = mesh_8.vertices.elementAt(104);
      expect(vertex_8_104, vector3MoreOrLessEquals(Vector3(-0.824137, 27.0092, 21.5109)));
      final vertex_8_105 = mesh_8.vertices.elementAt(105);
      expect(vertex_8_105, vector3MoreOrLessEquals(Vector3(-1.17244, 25.687, 22.2014)));
      final vertex_8_106 = mesh_8.vertices.elementAt(106);
      expect(vertex_8_106, vector3MoreOrLessEquals(Vector3(0.042627, 25.6839, 26.5647)));
      final vertex_8_107 = mesh_8.vertices.elementAt(107);
      expect(vertex_8_107, vector3MoreOrLessEquals(Vector3(-0.824137, 27.0092, 21.5109)));
      final vertex_8_108 = mesh_8.vertices.elementAt(108);
      expect(vertex_8_108, vector3MoreOrLessEquals(Vector3(0.042627, 25.6839, 26.5647)));
      final vertex_8_109 = mesh_8.vertices.elementAt(109);
      expect(vertex_8_109, vector3MoreOrLessEquals(Vector3(12.8583, 5.59827, 51.2765)));
      final vertex_8_110 = mesh_8.vertices.elementAt(110);
      expect(vertex_8_110, vector3MoreOrLessEquals(Vector3(1.34655, 27.5951, 26.5185)));
      final vertex_8_111 = mesh_8.vertices.elementAt(111);
      expect(vertex_8_111, vector3MoreOrLessEquals(Vector3(0.042627, 25.6839, 26.5647)));
      final vertex_8_112 = mesh_8.vertices.elementAt(112);
      expect(vertex_8_112, vector3MoreOrLessEquals(Vector3(11.0361, 4.23739, 50.8497)));
      final vertex_8_113 = mesh_8.vertices.elementAt(113);
      expect(vertex_8_113, vector3MoreOrLessEquals(Vector3(12.8583, 5.59827, 51.2765)));
      final vertex_8_114 = mesh_8.vertices.elementAt(114);
      expect(vertex_8_114, vector3MoreOrLessEquals(Vector3(17.1025, -28.758, 62.2462)));
      final vertex_8_115 = mesh_8.vertices.elementAt(115);
      expect(vertex_8_115, vector3MoreOrLessEquals(Vector3(18.0423, -27.6766, 62.7098)));
      final vertex_8_116 = mesh_8.vertices.elementAt(116);
      expect(vertex_8_116, vector3MoreOrLessEquals(Vector3(12.8583, 5.59827, 51.2765)));
      final vertex_8_117 = mesh_8.vertices.elementAt(117);
      expect(vertex_8_117, vector3MoreOrLessEquals(Vector3(11.0361, 4.23739, 50.8497)));
      final vertex_8_118 = mesh_8.vertices.elementAt(118);
      expect(vertex_8_118, vector3MoreOrLessEquals(Vector3(17.1025, -28.758, 62.2462)));
      final vertex_8_119 = mesh_8.vertices.elementAt(119);
      expect(vertex_8_119, vector3MoreOrLessEquals(Vector3(12.8583, 5.59827, 51.2765)));
      final vertex_8_120 = mesh_8.vertices.elementAt(120);
      expect(vertex_8_120, vector3MoreOrLessEquals(Vector3(17.1025, -28.758, 62.2462)));
      final vertex_8_121 = mesh_8.vertices.elementAt(121);
      expect(vertex_8_121, vector3MoreOrLessEquals(Vector3(19.3002, -37.4672, 68.49)));
      final vertex_8_122 = mesh_8.vertices.elementAt(122);
      expect(vertex_8_122, vector3MoreOrLessEquals(Vector3(18.0423, -27.6766, 62.7098)));
      final vertex_8_123 = mesh_8.vertices.elementAt(123);
      expect(vertex_8_123, vector3MoreOrLessEquals(Vector3(17.1025, -28.758, 62.2462)));
      final vertex_8_124 = mesh_8.vertices.elementAt(124);
      expect(vertex_8_124, vector3MoreOrLessEquals(Vector3(18.8869, -37.8399, 68.3988)));
      final vertex_8_125 = mesh_8.vertices.elementAt(125);
      expect(vertex_8_125, vector3MoreOrLessEquals(Vector3(19.3002, -37.4672, 68.49)));
      final vertex_8_126 = mesh_8.vertices.elementAt(126);
      expect(vertex_8_126, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_127 = mesh_8.vertices.elementAt(127);
      expect(vertex_8_127, vector3MoreOrLessEquals(Vector3(-16.0352, -7.26234, 0.229479)));
      final vertex_8_128 = mesh_8.vertices.elementAt(128);
      expect(vertex_8_128, vector3MoreOrLessEquals(Vector3(-17.976, -6.06143, -2.25557)));
      final vertex_8_129 = mesh_8.vertices.elementAt(129);
      expect(vertex_8_129, vector3MoreOrLessEquals(Vector3(18.821, -38.4449, 68.1251)));
      final vertex_8_130 = mesh_8.vertices.elementAt(130);
      expect(vertex_8_130, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_131 = mesh_8.vertices.elementAt(131);
      expect(vertex_8_131, vector3MoreOrLessEquals(Vector3(18.8869, -37.8399, 68.3988)));
      final vertex_8_132 = mesh_8.vertices.elementAt(132);
      expect(vertex_8_132, vector3MoreOrLessEquals(Vector3(-16.0352, -7.26234, 0.229479)));
      final vertex_8_133 = mesh_8.vertices.elementAt(133);
      expect(vertex_8_133, vector3MoreOrLessEquals(Vector3(-7.66182, 4.10971, 12.5486)));
      final vertex_8_134 = mesh_8.vertices.elementAt(134);
      expect(vertex_8_134, vector3MoreOrLessEquals(Vector3(-17.976, -6.06143, -2.25557)));
      final vertex_8_135 = mesh_8.vertices.elementAt(135);
      expect(vertex_8_135, vector3MoreOrLessEquals(Vector3(-16.0352, -7.26234, 0.229479)));
      final vertex_8_136 = mesh_8.vertices.elementAt(136);
      expect(vertex_8_136, vector3MoreOrLessEquals(Vector3(-6.31225, 3.04369, 14.0968)));
      final vertex_8_137 = mesh_8.vertices.elementAt(137);
      expect(vertex_8_137, vector3MoreOrLessEquals(Vector3(-7.66182, 4.10971, 12.5486)));
      final vertex_8_138 = mesh_8.vertices.elementAt(138);
      expect(vertex_8_138, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_139 = mesh_8.vertices.elementAt(139);
      expect(vertex_8_139, vector3MoreOrLessEquals(Vector3(-1.17244, 25.687, 22.2014)));
      final vertex_8_140 = mesh_8.vertices.elementAt(140);
      expect(vertex_8_140, vector3MoreOrLessEquals(Vector3(-7.66182, 4.10971, 12.5486)));
      final vertex_8_141 = mesh_8.vertices.elementAt(141);
      expect(vertex_8_141, vector3MoreOrLessEquals(Vector3(-6.31225, 3.04369, 14.0968)));
      final vertex_8_142 = mesh_8.vertices.elementAt(142);
      expect(vertex_8_142, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_143 = mesh_8.vertices.elementAt(143);
      expect(vertex_8_143, vector3MoreOrLessEquals(Vector3(-7.66182, 4.10971, 12.5486)));
      final vertex_8_144 = mesh_8.vertices.elementAt(144);
      expect(vertex_8_144, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_145 = mesh_8.vertices.elementAt(145);
      expect(vertex_8_145, vector3MoreOrLessEquals(Vector3(0.042627, 25.6839, 26.5647)));
      final vertex_8_146 = mesh_8.vertices.elementAt(146);
      expect(vertex_8_146, vector3MoreOrLessEquals(Vector3(-1.17244, 25.687, 22.2014)));
      final vertex_8_147 = mesh_8.vertices.elementAt(147);
      expect(vertex_8_147, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_148 = mesh_8.vertices.elementAt(148);
      expect(vertex_8_148, vector3MoreOrLessEquals(Vector3(0.303562, 23.7297, 25.3531)));
      final vertex_8_149 = mesh_8.vertices.elementAt(149);
      expect(vertex_8_149, vector3MoreOrLessEquals(Vector3(0.042627, 25.6839, 26.5647)));
      final vertex_8_150 = mesh_8.vertices.elementAt(150);
      expect(vertex_8_150, vector3MoreOrLessEquals(Vector3(10.4657, 3.16569, 48.8797)));
      final vertex_8_151 = mesh_8.vertices.elementAt(151);
      expect(vertex_8_151, vector3MoreOrLessEquals(Vector3(11.0361, 4.23739, 50.8497)));
      final vertex_8_152 = mesh_8.vertices.elementAt(152);
      expect(vertex_8_152, vector3MoreOrLessEquals(Vector3(0.042627, 25.6839, 26.5647)));
      final vertex_8_153 = mesh_8.vertices.elementAt(153);
      expect(vertex_8_153, vector3MoreOrLessEquals(Vector3(0.303562, 23.7297, 25.3531)));
      final vertex_8_154 = mesh_8.vertices.elementAt(154);
      expect(vertex_8_154, vector3MoreOrLessEquals(Vector3(10.4657, 3.16569, 48.8797)));
      final vertex_8_155 = mesh_8.vertices.elementAt(155);
      expect(vertex_8_155, vector3MoreOrLessEquals(Vector3(0.042627, 25.6839, 26.5647)));
      final vertex_8_156 = mesh_8.vertices.elementAt(156);
      expect(vertex_8_156, vector3MoreOrLessEquals(Vector3(10.4657, 3.16569, 48.8797)));
      final vertex_8_157 = mesh_8.vertices.elementAt(157);
      expect(vertex_8_157, vector3MoreOrLessEquals(Vector3(17.1025, -28.758, 62.2462)));
      final vertex_8_158 = mesh_8.vertices.elementAt(158);
      expect(vertex_8_158, vector3MoreOrLessEquals(Vector3(11.0361, 4.23739, 50.8497)));
      final vertex_8_159 = mesh_8.vertices.elementAt(159);
      expect(vertex_8_159, vector3MoreOrLessEquals(Vector3(10.4657, 3.16569, 48.8797)));
      final vertex_8_160 = mesh_8.vertices.elementAt(160);
      expect(vertex_8_160, vector3MoreOrLessEquals(Vector3(16.8644, -30.508, 61.2315)));
      final vertex_8_161 = mesh_8.vertices.elementAt(161);
      expect(vertex_8_161, vector3MoreOrLessEquals(Vector3(17.1025, -28.758, 62.2462)));
      final vertex_8_162 = mesh_8.vertices.elementAt(162);
      expect(vertex_8_162, vector3MoreOrLessEquals(Vector3(18.821, -38.4449, 68.1251)));
      final vertex_8_163 = mesh_8.vertices.elementAt(163);
      expect(vertex_8_163, vector3MoreOrLessEquals(Vector3(18.8869, -37.8399, 68.3988)));
      final vertex_8_164 = mesh_8.vertices.elementAt(164);
      expect(vertex_8_164, vector3MoreOrLessEquals(Vector3(17.1025, -28.758, 62.2462)));
      final vertex_8_165 = mesh_8.vertices.elementAt(165);
      expect(vertex_8_165, vector3MoreOrLessEquals(Vector3(16.8644, -30.508, 61.2315)));
      final vertex_8_166 = mesh_8.vertices.elementAt(166);
      expect(vertex_8_166, vector3MoreOrLessEquals(Vector3(18.821, -38.4449, 68.1251)));
      final vertex_8_167 = mesh_8.vertices.elementAt(167);
      expect(vertex_8_167, vector3MoreOrLessEquals(Vector3(17.1025, -28.758, 62.2462)));
      final vertex_8_168 = mesh_8.vertices.elementAt(168);
      expect(vertex_8_168, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_169 = mesh_8.vertices.elementAt(169);
      expect(vertex_8_169, vector3MoreOrLessEquals(Vector3(-12.755, -8.2318, 0.055506)));
      final vertex_8_170 = mesh_8.vertices.elementAt(170);
      expect(vertex_8_170, vector3MoreOrLessEquals(Vector3(-16.0352, -7.26234, 0.229479)));
      final vertex_8_171 = mesh_8.vertices.elementAt(171);
      expect(vertex_8_171, vector3MoreOrLessEquals(Vector3(19.1522, -38.8267, 67.8748)));
      final vertex_8_172 = mesh_8.vertices.elementAt(172);
      expect(vertex_8_172, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_173 = mesh_8.vertices.elementAt(173);
      expect(vertex_8_173, vector3MoreOrLessEquals(Vector3(18.821, -38.4449, 68.1251)));
      final vertex_8_174 = mesh_8.vertices.elementAt(174);
      expect(vertex_8_174, vector3MoreOrLessEquals(Vector3(-4.00416, 3.07172, 14.2606)));
      final vertex_8_175 = mesh_8.vertices.elementAt(175);
      expect(vertex_8_175, vector3MoreOrLessEquals(Vector3(-6.31225, 3.04369, 14.0968)));
      final vertex_8_176 = mesh_8.vertices.elementAt(176);
      expect(vertex_8_176, vector3MoreOrLessEquals(Vector3(-16.0352, -7.26234, 0.229479)));
      final vertex_8_177 = mesh_8.vertices.elementAt(177);
      expect(vertex_8_177, vector3MoreOrLessEquals(Vector3(-12.755, -8.2318, 0.055506)));
      final vertex_8_178 = mesh_8.vertices.elementAt(178);
      expect(vertex_8_178, vector3MoreOrLessEquals(Vector3(-4.00416, 3.07172, 14.2606)));
      final vertex_8_179 = mesh_8.vertices.elementAt(179);
      expect(vertex_8_179, vector3MoreOrLessEquals(Vector3(-16.0352, -7.26234, 0.229479)));
      final vertex_8_180 = mesh_8.vertices.elementAt(180);
      expect(vertex_8_180, vector3MoreOrLessEquals(Vector3(-4.00416, 3.07172, 14.2606)));
      final vertex_8_181 = mesh_8.vertices.elementAt(181);
      expect(vertex_8_181, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_182 = mesh_8.vertices.elementAt(182);
      expect(vertex_8_182, vector3MoreOrLessEquals(Vector3(-6.31225, 3.04369, 14.0968)));
      final vertex_8_183 = mesh_8.vertices.elementAt(183);
      expect(vertex_8_183, vector3MoreOrLessEquals(Vector3(-4.00416, 3.07172, 14.2606)));
      final vertex_8_184 = mesh_8.vertices.elementAt(184);
      expect(vertex_8_184, vector3MoreOrLessEquals(Vector3(1.11807, 23.7546, 22.252)));
      final vertex_8_185 = mesh_8.vertices.elementAt(185);
      expect(vertex_8_185, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_186 = mesh_8.vertices.elementAt(186);
      expect(vertex_8_186, vector3MoreOrLessEquals(Vector3(1.93285, 23.2039, 23.7963)));
      final vertex_8_187 = mesh_8.vertices.elementAt(187);
      expect(vertex_8_187, vector3MoreOrLessEquals(Vector3(0.303562, 23.7297, 25.3531)));
      final vertex_8_188 = mesh_8.vertices.elementAt(188);
      expect(vertex_8_188, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_189 = mesh_8.vertices.elementAt(189);
      expect(vertex_8_189, vector3MoreOrLessEquals(Vector3(1.11807, 23.7546, 22.252)));
      final vertex_8_190 = mesh_8.vertices.elementAt(190);
      expect(vertex_8_190, vector3MoreOrLessEquals(Vector3(1.93285, 23.2039, 23.7963)));
      final vertex_8_191 = mesh_8.vertices.elementAt(191);
      expect(vertex_8_191, vector3MoreOrLessEquals(Vector3(-0.308071, 24.2386, 22.5312)));
      final vertex_8_192 = mesh_8.vertices.elementAt(192);
      expect(vertex_8_192, vector3MoreOrLessEquals(Vector3(1.93285, 23.2039, 23.7963)));
      final vertex_8_193 = mesh_8.vertices.elementAt(193);
      expect(vertex_8_193, vector3MoreOrLessEquals(Vector3(10.4657, 3.16569, 48.8797)));
      final vertex_8_194 = mesh_8.vertices.elementAt(194);
      expect(vertex_8_194, vector3MoreOrLessEquals(Vector3(0.303562, 23.7297, 25.3531)));
      final vertex_8_195 = mesh_8.vertices.elementAt(195);
      expect(vertex_8_195, vector3MoreOrLessEquals(Vector3(1.93285, 23.2039, 23.7963)));
      final vertex_8_196 = mesh_8.vertices.elementAt(196);
      expect(vertex_8_196, vector3MoreOrLessEquals(Vector3(11.5766, 3.19019, 46.8499)));
      final vertex_8_197 = mesh_8.vertices.elementAt(197);
      expect(vertex_8_197, vector3MoreOrLessEquals(Vector3(10.4657, 3.16569, 48.8797)));
      final vertex_8_198 = mesh_8.vertices.elementAt(198);
      expect(vertex_8_198, vector3MoreOrLessEquals(Vector3(17.5072, -31.6087, 60.4299)));
      final vertex_8_199 = mesh_8.vertices.elementAt(199);
      expect(vertex_8_199, vector3MoreOrLessEquals(Vector3(16.8644, -30.508, 61.2315)));
      final vertex_8_200 = mesh_8.vertices.elementAt(200);
      expect(vertex_8_200, vector3MoreOrLessEquals(Vector3(10.4657, 3.16569, 48.8797)));
      final vertex_8_201 = mesh_8.vertices.elementAt(201);
      expect(vertex_8_201, vector3MoreOrLessEquals(Vector3(11.5766, 3.19019, 46.8499)));
      final vertex_8_202 = mesh_8.vertices.elementAt(202);
      expect(vertex_8_202, vector3MoreOrLessEquals(Vector3(17.5072, -31.6087, 60.4299)));
      final vertex_8_203 = mesh_8.vertices.elementAt(203);
      expect(vertex_8_203, vector3MoreOrLessEquals(Vector3(10.4657, 3.16569, 48.8797)));
      final vertex_8_204 = mesh_8.vertices.elementAt(204);
      expect(vertex_8_204, vector3MoreOrLessEquals(Vector3(17.5072, -31.6087, 60.4299)));
      final vertex_8_205 = mesh_8.vertices.elementAt(205);
      expect(vertex_8_205, vector3MoreOrLessEquals(Vector3(18.821, -38.4449, 68.1251)));
      final vertex_8_206 = mesh_8.vertices.elementAt(206);
      expect(vertex_8_206, vector3MoreOrLessEquals(Vector3(16.8644, -30.508, 61.2315)));
      final vertex_8_207 = mesh_8.vertices.elementAt(207);
      expect(vertex_8_207, vector3MoreOrLessEquals(Vector3(17.5072, -31.6087, 60.4299)));
      final vertex_8_208 = mesh_8.vertices.elementAt(208);
      expect(vertex_8_208, vector3MoreOrLessEquals(Vector3(19.1522, -38.8267, 67.8748)));
      final vertex_8_209 = mesh_8.vertices.elementAt(209);
      expect(vertex_8_209, vector3MoreOrLessEquals(Vector3(18.821, -38.4449, 68.1251)));
      final vertex_8_210 = mesh_8.vertices.elementAt(210);
      expect(vertex_8_210, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_211 = mesh_8.vertices.elementAt(211);
      expect(vertex_8_211, vector3MoreOrLessEquals(Vector3(-10.6055, -8.23976, -2.6465)));
      final vertex_8_212 = mesh_8.vertices.elementAt(212);
      expect(vertex_8_212, vector3MoreOrLessEquals(Vector3(-12.755, -8.2318, 0.055506)));
      final vertex_8_213 = mesh_8.vertices.elementAt(213);
      expect(vertex_8_213, vector3MoreOrLessEquals(Vector3(19.6311, -38.6978, 67.8366)));
      final vertex_8_214 = mesh_8.vertices.elementAt(214);
      expect(vertex_8_214, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_215 = mesh_8.vertices.elementAt(215);
      expect(vertex_8_215, vector3MoreOrLessEquals(Vector3(19.1522, -38.8267, 67.8748)));
      final vertex_8_216 = mesh_8.vertices.elementAt(216);
      expect(vertex_8_216, vector3MoreOrLessEquals(Vector3(-10.6055, -8.23976, -2.6465)));
      final vertex_8_217 = mesh_8.vertices.elementAt(217);
      expect(vertex_8_217, vector3MoreOrLessEquals(Vector3(-4.00416, 3.07172, 14.2606)));
      final vertex_8_218 = mesh_8.vertices.elementAt(218);
      expect(vertex_8_218, vector3MoreOrLessEquals(Vector3(-12.755, -8.2318, 0.055506)));
      final vertex_8_219 = mesh_8.vertices.elementAt(219);
      expect(vertex_8_219, vector3MoreOrLessEquals(Vector3(-10.6055, -8.23976, -2.6465)));
      final vertex_8_220 = mesh_8.vertices.elementAt(220);
      expect(vertex_8_220, vector3MoreOrLessEquals(Vector3(-2.47562, 4.17273, 12.9166)));
      final vertex_8_221 = mesh_8.vertices.elementAt(221);
      expect(vertex_8_221, vector3MoreOrLessEquals(Vector3(-4.00416, 3.07172, 14.2606)));
      final vertex_8_222 = mesh_8.vertices.elementAt(222);
      expect(vertex_8_222, vector3MoreOrLessEquals(Vector3(2.03204, 24.5994, 21.574)));
      final vertex_8_223 = mesh_8.vertices.elementAt(223);
      expect(vertex_8_223, vector3MoreOrLessEquals(Vector3(1.11807, 23.7546, 22.252)));
      final vertex_8_224 = mesh_8.vertices.elementAt(224);
      expect(vertex_8_224, vector3MoreOrLessEquals(Vector3(-4.00416, 3.07172, 14.2606)));
      final vertex_8_225 = mesh_8.vertices.elementAt(225);
      expect(vertex_8_225, vector3MoreOrLessEquals(Vector3(-2.47562, 4.17273, 12.9166)));
      final vertex_8_226 = mesh_8.vertices.elementAt(226);
      expect(vertex_8_226, vector3MoreOrLessEquals(Vector3(2.03204, 24.5994, 21.574)));
      final vertex_8_227 = mesh_8.vertices.elementAt(227);
      expect(vertex_8_227, vector3MoreOrLessEquals(Vector3(-4.00416, 3.07172, 14.2606)));
      final vertex_8_228 = mesh_8.vertices.elementAt(228);
      expect(vertex_8_228, vector3MoreOrLessEquals(Vector3(2.03204, 24.5994, 21.574)));
      final vertex_8_229 = mesh_8.vertices.elementAt(229);
      expect(vertex_8_229, vector3MoreOrLessEquals(Vector3(1.93285, 23.2039, 23.7963)));
      final vertex_8_230 = mesh_8.vertices.elementAt(230);
      expect(vertex_8_230, vector3MoreOrLessEquals(Vector3(1.11807, 23.7546, 22.252)));
      final vertex_8_231 = mesh_8.vertices.elementAt(231);
      expect(vertex_8_231, vector3MoreOrLessEquals(Vector3(2.03204, 24.5994, 21.574)));
      final vertex_8_232 = mesh_8.vertices.elementAt(232);
      expect(vertex_8_232, vector3MoreOrLessEquals(Vector3(3.70363, 24.5026, 23.0664)));
      final vertex_8_233 = mesh_8.vertices.elementAt(233);
      expect(vertex_8_233, vector3MoreOrLessEquals(Vector3(1.93285, 23.2039, 23.7963)));
      final vertex_8_234 = mesh_8.vertices.elementAt(234);
      expect(vertex_8_234, vector3MoreOrLessEquals(Vector3(13.5324, 4.29248, 46.2889)));
      final vertex_8_235 = mesh_8.vertices.elementAt(235);
      expect(vertex_8_235, vector3MoreOrLessEquals(Vector3(11.5766, 3.19019, 46.8499)));
      final vertex_8_236 = mesh_8.vertices.elementAt(236);
      expect(vertex_8_236, vector3MoreOrLessEquals(Vector3(1.93285, 23.2039, 23.7963)));
      final vertex_8_237 = mesh_8.vertices.elementAt(237);
      expect(vertex_8_237, vector3MoreOrLessEquals(Vector3(3.70363, 24.5026, 23.0664)));
      final vertex_8_238 = mesh_8.vertices.elementAt(238);
      expect(vertex_8_238, vector3MoreOrLessEquals(Vector3(13.5324, 4.29248, 46.2889)));
      final vertex_8_239 = mesh_8.vertices.elementAt(239);
      expect(vertex_8_239, vector3MoreOrLessEquals(Vector3(1.93285, 23.2039, 23.7963)));
      final vertex_8_240 = mesh_8.vertices.elementAt(240);
      expect(vertex_8_240, vector3MoreOrLessEquals(Vector3(13.5324, 4.29248, 46.2889)));
      final vertex_8_241 = mesh_8.vertices.elementAt(241);
      expect(vertex_8_241, vector3MoreOrLessEquals(Vector3(17.5072, -31.6087, 60.4299)));
      final vertex_8_242 = mesh_8.vertices.elementAt(242);
      expect(vertex_8_242, vector3MoreOrLessEquals(Vector3(11.5766, 3.19019, 46.8499)));
      final vertex_8_243 = mesh_8.vertices.elementAt(243);
      expect(vertex_8_243, vector3MoreOrLessEquals(Vector3(13.5324, 4.29248, 46.2889)));
      final vertex_8_244 = mesh_8.vertices.elementAt(244);
      expect(vertex_8_244, vector3MoreOrLessEquals(Vector3(18.5469, -31.2314, 60.445)));
      final vertex_8_245 = mesh_8.vertices.elementAt(245);
      expect(vertex_8_245, vector3MoreOrLessEquals(Vector3(17.5072, -31.6087, 60.4299)));
      final vertex_8_246 = mesh_8.vertices.elementAt(246);
      expect(vertex_8_246, vector3MoreOrLessEquals(Vector3(19.6311, -38.6978, 67.8366)));
      final vertex_8_247 = mesh_8.vertices.elementAt(247);
      expect(vertex_8_247, vector3MoreOrLessEquals(Vector3(19.1522, -38.8267, 67.8748)));
      final vertex_8_248 = mesh_8.vertices.elementAt(248);
      expect(vertex_8_248, vector3MoreOrLessEquals(Vector3(17.5072, -31.6087, 60.4299)));
      final vertex_8_249 = mesh_8.vertices.elementAt(249);
      expect(vertex_8_249, vector3MoreOrLessEquals(Vector3(18.5469, -31.2314, 60.445)));
      final vertex_8_250 = mesh_8.vertices.elementAt(250);
      expect(vertex_8_250, vector3MoreOrLessEquals(Vector3(19.6311, -38.6978, 67.8366)));
      final vertex_8_251 = mesh_8.vertices.elementAt(251);
      expect(vertex_8_251, vector3MoreOrLessEquals(Vector3(17.5072, -31.6087, 60.4299)));
      final vertex_8_252 = mesh_8.vertices.elementAt(252);
      expect(vertex_8_252, vector3MoreOrLessEquals(Vector3(-14.2565, -6.95494, -3.30169)));
      final vertex_8_253 = mesh_8.vertices.elementAt(253);
      expect(vertex_8_253, vector3MoreOrLessEquals(Vector3(-11.2052, -7.28023, -5.84188)));
      final vertex_8_254 = mesh_8.vertices.elementAt(254);
      expect(vertex_8_254, vector3MoreOrLessEquals(Vector3(-10.6055, -8.23976, -2.6465)));
      final vertex_8_255 = mesh_8.vertices.elementAt(255);
      expect(vertex_8_255, vector3MoreOrLessEquals(Vector3(19.8971, -38.1552, 68.0391)));
      final vertex_8_256 = mesh_8.vertices.elementAt(256);
      expect(vertex_8_256, vector3MoreOrLessEquals(Vector3(19.3484, -38.1485, 68.1563)));
      final vertex_8_257 = mesh_8.vertices.elementAt(257);
      expect(vertex_8_257, vector3MoreOrLessEquals(Vector3(19.6311, -38.6978, 67.8366)));
      final vertex_8_258 = mesh_8.vertices.elementAt(258);
      expect(vertex_8_258, vector3MoreOrLessEquals(Vector3(-2.87765, 5.5176, 11.0769)));
      final vertex_8_259 = mesh_8.vertices.elementAt(259);
      expect(vertex_8_259, vector3MoreOrLessEquals(Vector3(-2.47562, 4.17273, 12.9166)));
      final vertex_8_260 = mesh_8.vertices.elementAt(260);
      expect(vertex_8_260, vector3MoreOrLessEquals(Vector3(-10.6055, -8.23976, -2.6465)));
      final vertex_8_261 = mesh_8.vertices.elementAt(261);
      expect(vertex_8_261, vector3MoreOrLessEquals(Vector3(-11.2052, -7.28023, -5.84188)));
      final vertex_8_262 = mesh_8.vertices.elementAt(262);
      expect(vertex_8_262, vector3MoreOrLessEquals(Vector3(-2.87765, 5.5176, 11.0769)));
      final vertex_8_263 = mesh_8.vertices.elementAt(263);
      expect(vertex_8_263, vector3MoreOrLessEquals(Vector3(-10.6055, -8.23976, -2.6465)));
      final vertex_8_264 = mesh_8.vertices.elementAt(264);
      expect(vertex_8_264, vector3MoreOrLessEquals(Vector3(-2.87765, 5.5176, 11.0769)));
      final vertex_8_265 = mesh_8.vertices.elementAt(265);
      expect(vertex_8_265, vector3MoreOrLessEquals(Vector3(2.03204, 24.5994, 21.574)));
      final vertex_8_266 = mesh_8.vertices.elementAt(266);
      expect(vertex_8_266, vector3MoreOrLessEquals(Vector3(-2.47562, 4.17273, 12.9166)));
      final vertex_8_267 = mesh_8.vertices.elementAt(267);
      expect(vertex_8_267, vector3MoreOrLessEquals(Vector3(-2.87765, 5.5176, 11.0769)));
      final vertex_8_268 = mesh_8.vertices.elementAt(268);
      expect(vertex_8_268, vector3MoreOrLessEquals(Vector3(1.74567, 26.1369, 21.0078)));
      final vertex_8_269 = mesh_8.vertices.elementAt(269);
      expect(vertex_8_269, vector3MoreOrLessEquals(Vector3(2.03204, 24.5994, 21.574)));
      final vertex_8_270 = mesh_8.vertices.elementAt(270);
      expect(vertex_8_270, vector3MoreOrLessEquals(Vector3(4.28245, 26.6477, 23.7131)));
      final vertex_8_271 = mesh_8.vertices.elementAt(271);
      expect(vertex_8_271, vector3MoreOrLessEquals(Vector3(3.70363, 24.5026, 23.0664)));
      final vertex_8_272 = mesh_8.vertices.elementAt(272);
      expect(vertex_8_272, vector3MoreOrLessEquals(Vector3(2.03204, 24.5994, 21.574)));
      final vertex_8_273 = mesh_8.vertices.elementAt(273);
      expect(vertex_8_273, vector3MoreOrLessEquals(Vector3(1.74567, 26.1369, 21.0078)));
      final vertex_8_274 = mesh_8.vertices.elementAt(274);
      expect(vertex_8_274, vector3MoreOrLessEquals(Vector3(4.28245, 26.6477, 23.7131)));
      final vertex_8_275 = mesh_8.vertices.elementAt(275);
      expect(vertex_8_275, vector3MoreOrLessEquals(Vector3(2.03204, 24.5994, 21.574)));
      final vertex_8_276 = mesh_8.vertices.elementAt(276);
      expect(vertex_8_276, vector3MoreOrLessEquals(Vector3(4.28245, 26.6477, 23.7131)));
      final vertex_8_277 = mesh_8.vertices.elementAt(277);
      expect(vertex_8_277, vector3MoreOrLessEquals(Vector3(13.5324, 4.29248, 46.2889)));
      final vertex_8_278 = mesh_8.vertices.elementAt(278);
      expect(vertex_8_278, vector3MoreOrLessEquals(Vector3(3.70363, 24.5026, 23.0664)));
      final vertex_8_279 = mesh_8.vertices.elementAt(279);
      expect(vertex_8_279, vector3MoreOrLessEquals(Vector3(4.28245, 26.6477, 23.7131)));
      final vertex_8_280 = mesh_8.vertices.elementAt(280);
      expect(vertex_8_280, vector3MoreOrLessEquals(Vector3(14.8602, 5.64247, 47.619)));
      final vertex_8_281 = mesh_8.vertices.elementAt(281);
      expect(vertex_8_281, vector3MoreOrLessEquals(Vector3(13.5324, 4.29248, 46.2889)));
      final vertex_8_282 = mesh_8.vertices.elementAt(282);
      expect(vertex_8_282, vector3MoreOrLessEquals(Vector3(19.2007, -29.6602, 61.2654)));
      final vertex_8_283 = mesh_8.vertices.elementAt(283);
      expect(vertex_8_283, vector3MoreOrLessEquals(Vector3(18.5469, -31.2314, 60.445)));
      final vertex_8_284 = mesh_8.vertices.elementAt(284);
      expect(vertex_8_284, vector3MoreOrLessEquals(Vector3(13.5324, 4.29248, 46.2889)));
      final vertex_8_285 = mesh_8.vertices.elementAt(285);
      expect(vertex_8_285, vector3MoreOrLessEquals(Vector3(14.8602, 5.64247, 47.619)));
      final vertex_8_286 = mesh_8.vertices.elementAt(286);
      expect(vertex_8_286, vector3MoreOrLessEquals(Vector3(19.2007, -29.6602, 61.2654)));
      final vertex_8_287 = mesh_8.vertices.elementAt(287);
      expect(vertex_8_287, vector3MoreOrLessEquals(Vector3(13.5324, 4.29248, 46.2889)));
      final vertex_8_288 = mesh_8.vertices.elementAt(288);
      expect(vertex_8_288, vector3MoreOrLessEquals(Vector3(19.2007, -29.6602, 61.2654)));
      final vertex_8_289 = mesh_8.vertices.elementAt(289);
      expect(vertex_8_289, vector3MoreOrLessEquals(Vector3(19.6311, -38.6978, 67.8366)));
      final vertex_8_290 = mesh_8.vertices.elementAt(290);
      expect(vertex_8_290, vector3MoreOrLessEquals(Vector3(18.5469, -31.2314, 60.445)));
      final vertex_8_291 = mesh_8.vertices.elementAt(291);
      expect(vertex_8_291, vector3MoreOrLessEquals(Vector3(19.2007, -29.6602, 61.2654)));
      final vertex_8_292 = mesh_8.vertices.elementAt(292);
      expect(vertex_8_292, vector3MoreOrLessEquals(Vector3(19.8971, -38.1552, 68.0391)));
      final vertex_8_293 = mesh_8.vertices.elementAt(293);
      expect(vertex_8_293, vector3MoreOrLessEquals(Vector3(19.6311, -38.6978, 67.8366)));
      expect(mesh_8.normals.length, equals(294));
      final normal_8_0 = mesh_8.normals.elementAt(0);
      expect(normal_8_0, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_1 = mesh_8.normals.elementAt(1);
      expect(normal_8_1, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_2 = mesh_8.normals.elementAt(2);
      expect(normal_8_2, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_3 = mesh_8.normals.elementAt(3);
      expect(normal_8_3, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_4 = mesh_8.normals.elementAt(4);
      expect(normal_8_4, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_5 = mesh_8.normals.elementAt(5);
      expect(normal_8_5, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_6 = mesh_8.normals.elementAt(6);
      expect(normal_8_6, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, -0.77149)));
      final normal_8_7 = mesh_8.normals.elementAt(7);
      expect(normal_8_7, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, -0.514517)));
      final normal_8_8 = mesh_8.normals.elementAt(8);
      expect(normal_8_8, vector3MoreOrLessEquals(Vector3(0.730773, 0.32289, -0.601426)));
      final normal_8_9 = mesh_8.normals.elementAt(9);
      expect(normal_8_9, vector3MoreOrLessEquals(Vector3(0.209807, 0.742786, -0.635807)));
      final normal_8_10 = mesh_8.normals.elementAt(10);
      expect(normal_8_10, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, -0.77149)));
      final normal_8_11 = mesh_8.normals.elementAt(11);
      expect(normal_8_11, vector3MoreOrLessEquals(Vector3(0.730773, 0.32289, -0.601426)));
      final normal_8_12 = mesh_8.normals.elementAt(12);
      expect(normal_8_12, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, -0.77149)));
      final normal_8_13 = mesh_8.normals.elementAt(13);
      expect(normal_8_13, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, -0.69454)));
      final normal_8_14 = mesh_8.normals.elementAt(14);
      expect(normal_8_14, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, -0.514517)));
      final normal_8_15 = mesh_8.normals.elementAt(15);
      expect(normal_8_15, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, -0.77149)));
      final normal_8_16 = mesh_8.normals.elementAt(16);
      expect(normal_8_16, vector3MoreOrLessEquals(Vector3(0.095819, 0.746431, -0.658528)));
      final normal_8_17 = mesh_8.normals.elementAt(17);
      expect(normal_8_17, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, -0.69454)));
      final normal_8_18 = mesh_8.normals.elementAt(18);
      expect(normal_8_18, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, 0.03336)));
      final normal_8_19 = mesh_8.normals.elementAt(19);
      expect(normal_8_19, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, -0.541146)));
      final normal_8_20 = mesh_8.normals.elementAt(20);
      expect(normal_8_20, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, -0.69454)));
      final normal_8_21 = mesh_8.normals.elementAt(21);
      expect(normal_8_21, vector3MoreOrLessEquals(Vector3(0.095819, 0.746431, -0.658528)));
      final normal_8_22 = mesh_8.normals.elementAt(22);
      expect(normal_8_22, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, 0.03336)));
      final normal_8_23 = mesh_8.normals.elementAt(23);
      expect(normal_8_23, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, -0.69454)));
      final normal_8_24 = mesh_8.normals.elementAt(24);
      expect(normal_8_24, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, 0.03336)));
      final normal_8_25 = mesh_8.normals.elementAt(25);
      expect(normal_8_25, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, -0.179176)));
      final normal_8_26 = mesh_8.normals.elementAt(26);
      expect(normal_8_26, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, -0.541146)));
      final normal_8_27 = mesh_8.normals.elementAt(27);
      expect(normal_8_27, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, 0.03336)));
      final normal_8_28 = mesh_8.normals.elementAt(28);
      expect(normal_8_28, vector3MoreOrLessEquals(Vector3(0.754037, 0.504418, 0.420704)));
      final normal_8_29 = mesh_8.normals.elementAt(29);
      expect(normal_8_29, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, -0.179176)));
      final normal_8_30 = mesh_8.normals.elementAt(30);
      expect(normal_8_30, vector3MoreOrLessEquals(Vector3(0.828561, 0.31659, 0.461798)));
      final normal_8_31 = mesh_8.normals.elementAt(31);
      expect(normal_8_31, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, -0.322182)));
      final normal_8_32 = mesh_8.normals.elementAt(32);
      expect(normal_8_32, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, -0.179176)));
      final normal_8_33 = mesh_8.normals.elementAt(33);
      expect(normal_8_33, vector3MoreOrLessEquals(Vector3(0.754037, 0.504418, 0.420704)));
      final normal_8_34 = mesh_8.normals.elementAt(34);
      expect(normal_8_34, vector3MoreOrLessEquals(Vector3(0.828561, 0.31659, 0.461798)));
      final normal_8_35 = mesh_8.normals.elementAt(35);
      expect(normal_8_35, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, -0.179176)));
      final normal_8_36 = mesh_8.normals.elementAt(36);
      expect(normal_8_36, vector3MoreOrLessEquals(Vector3(0.828561, 0.31659, 0.461798)));
      final normal_8_37 = mesh_8.normals.elementAt(37);
      expect(normal_8_37, vector3MoreOrLessEquals(Vector3(0.996799, 0.009221, -0.079417)));
      final normal_8_38 = mesh_8.normals.elementAt(38);
      expect(normal_8_38, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, -0.322182)));
      final normal_8_39 = mesh_8.normals.elementAt(39);
      expect(normal_8_39, vector3MoreOrLessEquals(Vector3(0.828561, 0.31659, 0.461798)));
      final normal_8_40 = mesh_8.normals.elementAt(40);
      expect(normal_8_40, vector3MoreOrLessEquals(Vector3(0.775768, 0.382141, 0.502148)));
      final normal_8_41 = mesh_8.normals.elementAt(41);
      expect(normal_8_41, vector3MoreOrLessEquals(Vector3(0.996799, 0.009221, -0.079417)));
      final normal_8_42 = mesh_8.normals.elementAt(42);
      expect(normal_8_42, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_43 = mesh_8.normals.elementAt(43);
      expect(normal_8_43, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_44 = mesh_8.normals.elementAt(44);
      expect(normal_8_44, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_45 = mesh_8.normals.elementAt(45);
      expect(normal_8_45, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_46 = mesh_8.normals.elementAt(46);
      expect(normal_8_46, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_47 = mesh_8.normals.elementAt(47);
      expect(normal_8_47, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_48 = mesh_8.normals.elementAt(48);
      expect(normal_8_48, vector3MoreOrLessEquals(Vector3(-0.535922, 0.815786, -0.217442)));
      final normal_8_49 = mesh_8.normals.elementAt(49);
      expect(normal_8_49, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, -0.77149)));
      final normal_8_50 = mesh_8.normals.elementAt(50);
      expect(normal_8_50, vector3MoreOrLessEquals(Vector3(0.209807, 0.742786, -0.635807)));
      final normal_8_51 = mesh_8.normals.elementAt(51);
      expect(normal_8_51, vector3MoreOrLessEquals(Vector3(-0.535922, 0.815786, -0.217442)));
      final normal_8_52 = mesh_8.normals.elementAt(52);
      expect(normal_8_52, vector3MoreOrLessEquals(Vector3(-0.711742, 0.631198, -0.308241)));
      final normal_8_53 = mesh_8.normals.elementAt(53);
      expect(normal_8_53, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, -0.77149)));
      final normal_8_54 = mesh_8.normals.elementAt(54);
      expect(normal_8_54, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, -0.174754)));
      final normal_8_55 = mesh_8.normals.elementAt(55);
      expect(normal_8_55, vector3MoreOrLessEquals(Vector3(0.095819, 0.746431, -0.658528)));
      final normal_8_56 = mesh_8.normals.elementAt(56);
      expect(normal_8_56, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, -0.77149)));
      final normal_8_57 = mesh_8.normals.elementAt(57);
      expect(normal_8_57, vector3MoreOrLessEquals(Vector3(-0.711742, 0.631198, -0.308241)));
      final normal_8_58 = mesh_8.normals.elementAt(58);
      expect(normal_8_58, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, -0.174754)));
      final normal_8_59 = mesh_8.normals.elementAt(59);
      expect(normal_8_59, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, -0.77149)));
      final normal_8_60 = mesh_8.normals.elementAt(60);
      expect(normal_8_60, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, -0.174754)));
      final normal_8_61 = mesh_8.normals.elementAt(61);
      expect(normal_8_61, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, 0.03336)));
      final normal_8_62 = mesh_8.normals.elementAt(62);
      expect(normal_8_62, vector3MoreOrLessEquals(Vector3(0.095819, 0.746431, -0.658528)));
      final normal_8_63 = mesh_8.normals.elementAt(63);
      expect(normal_8_63, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, -0.174754)));
      final normal_8_64 = mesh_8.normals.elementAt(64);
      expect(normal_8_64, vector3MoreOrLessEquals(Vector3(-0.411496, 0.796168, 0.443607)));
      final normal_8_65 = mesh_8.normals.elementAt(65);
      expect(normal_8_65, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, 0.03336)));
      final normal_8_66 = mesh_8.normals.elementAt(66);
      expect(normal_8_66, vector3MoreOrLessEquals(Vector3(-0.094379, 0.527301, 0.844421)));
      final normal_8_67 = mesh_8.normals.elementAt(67);
      expect(normal_8_67, vector3MoreOrLessEquals(Vector3(0.754037, 0.504418, 0.420704)));
      final normal_8_68 = mesh_8.normals.elementAt(68);
      expect(normal_8_68, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, 0.03336)));
      final normal_8_69 = mesh_8.normals.elementAt(69);
      expect(normal_8_69, vector3MoreOrLessEquals(Vector3(-0.411496, 0.796168, 0.443607)));
      final normal_8_70 = mesh_8.normals.elementAt(70);
      expect(normal_8_70, vector3MoreOrLessEquals(Vector3(-0.094379, 0.527301, 0.844421)));
      final normal_8_71 = mesh_8.normals.elementAt(71);
      expect(normal_8_71, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, 0.03336)));
      final normal_8_72 = mesh_8.normals.elementAt(72);
      expect(normal_8_72, vector3MoreOrLessEquals(Vector3(-0.094379, 0.527301, 0.844421)));
      final normal_8_73 = mesh_8.normals.elementAt(73);
      expect(normal_8_73, vector3MoreOrLessEquals(Vector3(0.828561, 0.31659, 0.461798)));
      final normal_8_74 = mesh_8.normals.elementAt(74);
      expect(normal_8_74, vector3MoreOrLessEquals(Vector3(0.754037, 0.504418, 0.420704)));
      final normal_8_75 = mesh_8.normals.elementAt(75);
      expect(normal_8_75, vector3MoreOrLessEquals(Vector3(-0.094379, 0.527301, 0.844421)));
      final normal_8_76 = mesh_8.normals.elementAt(76);
      expect(normal_8_76, vector3MoreOrLessEquals(Vector3(-0.069752, 0.407704, 0.910446)));
      final normal_8_77 = mesh_8.normals.elementAt(77);
      expect(normal_8_77, vector3MoreOrLessEquals(Vector3(0.828561, 0.31659, 0.461798)));
      final normal_8_78 = mesh_8.normals.elementAt(78);
      expect(normal_8_78, vector3MoreOrLessEquals(Vector3(-0.075227, 0.509317, 0.857284)));
      final normal_8_79 = mesh_8.normals.elementAt(79);
      expect(normal_8_79, vector3MoreOrLessEquals(Vector3(0.775768, 0.382141, 0.502148)));
      final normal_8_80 = mesh_8.normals.elementAt(80);
      expect(normal_8_80, vector3MoreOrLessEquals(Vector3(0.828561, 0.31659, 0.461798)));
      final normal_8_81 = mesh_8.normals.elementAt(81);
      expect(normal_8_81, vector3MoreOrLessEquals(Vector3(-0.069752, 0.407704, 0.910446)));
      final normal_8_82 = mesh_8.normals.elementAt(82);
      expect(normal_8_82, vector3MoreOrLessEquals(Vector3(-0.075227, 0.509317, 0.857284)));
      final normal_8_83 = mesh_8.normals.elementAt(83);
      expect(normal_8_83, vector3MoreOrLessEquals(Vector3(0.828561, 0.31659, 0.461798)));
      final normal_8_84 = mesh_8.normals.elementAt(84);
      expect(normal_8_84, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_85 = mesh_8.normals.elementAt(85);
      expect(normal_8_85, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_86 = mesh_8.normals.elementAt(86);
      expect(normal_8_86, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_87 = mesh_8.normals.elementAt(87);
      expect(normal_8_87, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_88 = mesh_8.normals.elementAt(88);
      expect(normal_8_88, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_89 = mesh_8.normals.elementAt(89);
      expect(normal_8_89, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_90 = mesh_8.normals.elementAt(90);
      expect(normal_8_90, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, 0.379522)));
      final normal_8_91 = mesh_8.normals.elementAt(91);
      expect(normal_8_91, vector3MoreOrLessEquals(Vector3(-0.711742, 0.631198, -0.308241)));
      final normal_8_92 = mesh_8.normals.elementAt(92);
      expect(normal_8_92, vector3MoreOrLessEquals(Vector3(-0.535922, 0.815786, -0.217442)));
      final normal_8_93 = mesh_8.normals.elementAt(93);
      expect(normal_8_93, vector3MoreOrLessEquals(Vector3(-0.856971, 0.404836, 0.318918)));
      final normal_8_94 = mesh_8.normals.elementAt(94);
      expect(normal_8_94, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, 0.379522)));
      final normal_8_95 = mesh_8.normals.elementAt(95);
      expect(normal_8_95, vector3MoreOrLessEquals(Vector3(-0.535922, 0.815786, -0.217442)));
      final normal_8_96 = mesh_8.normals.elementAt(96);
      expect(normal_8_96, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, 0.379522)));
      final normal_8_97 = mesh_8.normals.elementAt(97);
      expect(normal_8_97, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, -0.174754)));
      final normal_8_98 = mesh_8.normals.elementAt(98);
      expect(normal_8_98, vector3MoreOrLessEquals(Vector3(-0.711742, 0.631198, -0.308241)));
      final normal_8_99 = mesh_8.normals.elementAt(99);
      expect(normal_8_99, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, 0.379522)));
      final normal_8_100 = mesh_8.normals.elementAt(100);
      expect(normal_8_100, vector3MoreOrLessEquals(Vector3(-0.929488, 0.002263, 0.368846)));
      final normal_8_101 = mesh_8.normals.elementAt(101);
      expect(normal_8_101, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, -0.174754)));
      final normal_8_102 = mesh_8.normals.elementAt(102);
      expect(normal_8_102, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, 0.392239)));
      final normal_8_103 = mesh_8.normals.elementAt(103);
      expect(normal_8_103, vector3MoreOrLessEquals(Vector3(-0.411496, 0.796168, 0.443607)));
      final normal_8_104 = mesh_8.normals.elementAt(104);
      expect(normal_8_104, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, -0.174754)));
      final normal_8_105 = mesh_8.normals.elementAt(105);
      expect(normal_8_105, vector3MoreOrLessEquals(Vector3(-0.929488, 0.002263, 0.368846)));
      final normal_8_106 = mesh_8.normals.elementAt(106);
      expect(normal_8_106, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, 0.392239)));
      final normal_8_107 = mesh_8.normals.elementAt(107);
      expect(normal_8_107, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, -0.174754)));
      final normal_8_108 = mesh_8.normals.elementAt(108);
      expect(normal_8_108, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, 0.392239)));
      final normal_8_109 = mesh_8.normals.elementAt(109);
      expect(normal_8_109, vector3MoreOrLessEquals(Vector3(-0.094379, 0.527301, 0.844421)));
      final normal_8_110 = mesh_8.normals.elementAt(110);
      expect(normal_8_110, vector3MoreOrLessEquals(Vector3(-0.411496, 0.796168, 0.443607)));
      final normal_8_111 = mesh_8.normals.elementAt(111);
      expect(normal_8_111, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, 0.392239)));
      final normal_8_112 = mesh_8.normals.elementAt(112);
      expect(normal_8_112, vector3MoreOrLessEquals(Vector3(-0.775244, 0.155507, 0.612221)));
      final normal_8_113 = mesh_8.normals.elementAt(113);
      expect(normal_8_113, vector3MoreOrLessEquals(Vector3(-0.094379, 0.527301, 0.844421)));
      final normal_8_114 = mesh_8.normals.elementAt(114);
      expect(normal_8_114, vector3MoreOrLessEquals(Vector3(-0.809953, 0.130294, 0.571839)));
      final normal_8_115 = mesh_8.normals.elementAt(115);
      expect(normal_8_115, vector3MoreOrLessEquals(Vector3(-0.069752, 0.407704, 0.910446)));
      final normal_8_116 = mesh_8.normals.elementAt(116);
      expect(normal_8_116, vector3MoreOrLessEquals(Vector3(-0.094379, 0.527301, 0.844421)));
      final normal_8_117 = mesh_8.normals.elementAt(117);
      expect(normal_8_117, vector3MoreOrLessEquals(Vector3(-0.775244, 0.155507, 0.612221)));
      final normal_8_118 = mesh_8.normals.elementAt(118);
      expect(normal_8_118, vector3MoreOrLessEquals(Vector3(-0.809953, 0.130294, 0.571839)));
      final normal_8_119 = mesh_8.normals.elementAt(119);
      expect(normal_8_119, vector3MoreOrLessEquals(Vector3(-0.094379, 0.527301, 0.844421)));
      final normal_8_120 = mesh_8.normals.elementAt(120);
      expect(normal_8_120, vector3MoreOrLessEquals(Vector3(-0.809953, 0.130294, 0.571839)));
      final normal_8_121 = mesh_8.normals.elementAt(121);
      expect(normal_8_121, vector3MoreOrLessEquals(Vector3(-0.075227, 0.509317, 0.857284)));
      final normal_8_122 = mesh_8.normals.elementAt(122);
      expect(normal_8_122, vector3MoreOrLessEquals(Vector3(-0.069752, 0.407704, 0.910446)));
      final normal_8_123 = mesh_8.normals.elementAt(123);
      expect(normal_8_123, vector3MoreOrLessEquals(Vector3(-0.809953, 0.130294, 0.571839)));
      final normal_8_124 = mesh_8.normals.elementAt(124);
      expect(normal_8_124, vector3MoreOrLessEquals(Vector3(-0.80997, 0.211451, 0.547026)));
      final normal_8_125 = mesh_8.normals.elementAt(125);
      expect(normal_8_125, vector3MoreOrLessEquals(Vector3(-0.075227, 0.509317, 0.857284)));
      final normal_8_126 = mesh_8.normals.elementAt(126);
      expect(normal_8_126, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_127 = mesh_8.normals.elementAt(127);
      expect(normal_8_127, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_128 = mesh_8.normals.elementAt(128);
      expect(normal_8_128, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_129 = mesh_8.normals.elementAt(129);
      expect(normal_8_129, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_130 = mesh_8.normals.elementAt(130);
      expect(normal_8_130, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_131 = mesh_8.normals.elementAt(131);
      expect(normal_8_131, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_132 = mesh_8.normals.elementAt(132);
      expect(normal_8_132, vector3MoreOrLessEquals(Vector3(-0.512438, -0.473965, 0.716075)));
      final normal_8_133 = mesh_8.normals.elementAt(133);
      expect(normal_8_133, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, 0.379522)));
      final normal_8_134 = mesh_8.normals.elementAt(134);
      expect(normal_8_134, vector3MoreOrLessEquals(Vector3(-0.856971, 0.404836, 0.318918)));
      final normal_8_135 = mesh_8.normals.elementAt(135);
      expect(normal_8_135, vector3MoreOrLessEquals(Vector3(-0.512438, -0.473965, 0.716075)));
      final normal_8_136 = mesh_8.normals.elementAt(136);
      expect(normal_8_136, vector3MoreOrLessEquals(Vector3(-0.470746, -0.365488, 0.803005)));
      final normal_8_137 = mesh_8.normals.elementAt(137);
      expect(normal_8_137, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, 0.379522)));
      final normal_8_138 = mesh_8.normals.elementAt(138);
      expect(normal_8_138, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, 0.55203)));
      final normal_8_139 = mesh_8.normals.elementAt(139);
      expect(normal_8_139, vector3MoreOrLessEquals(Vector3(-0.929488, 0.002263, 0.368846)));
      final normal_8_140 = mesh_8.normals.elementAt(140);
      expect(normal_8_140, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, 0.379522)));
      final normal_8_141 = mesh_8.normals.elementAt(141);
      expect(normal_8_141, vector3MoreOrLessEquals(Vector3(-0.470746, -0.365488, 0.803005)));
      final normal_8_142 = mesh_8.normals.elementAt(142);
      expect(normal_8_142, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, 0.55203)));
      final normal_8_143 = mesh_8.normals.elementAt(143);
      expect(normal_8_143, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, 0.379522)));
      final normal_8_144 = mesh_8.normals.elementAt(144);
      expect(normal_8_144, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, 0.55203)));
      final normal_8_145 = mesh_8.normals.elementAt(145);
      expect(normal_8_145, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, 0.392239)));
      final normal_8_146 = mesh_8.normals.elementAt(146);
      expect(normal_8_146, vector3MoreOrLessEquals(Vector3(-0.929488, 0.002263, 0.368846)));
      final normal_8_147 = mesh_8.normals.elementAt(147);
      expect(normal_8_147, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, 0.55203)));
      final normal_8_148 = mesh_8.normals.elementAt(148);
      expect(normal_8_148, vector3MoreOrLessEquals(Vector3(-0.804795, -0.592927, -0.027236)));
      final normal_8_149 = mesh_8.normals.elementAt(149);
      expect(normal_8_149, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, 0.392239)));
      final normal_8_150 = mesh_8.normals.elementAt(150);
      expect(normal_8_150, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, -0.047865)));
      final normal_8_151 = mesh_8.normals.elementAt(151);
      expect(normal_8_151, vector3MoreOrLessEquals(Vector3(-0.775244, 0.155507, 0.612221)));
      final normal_8_152 = mesh_8.normals.elementAt(152);
      expect(normal_8_152, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, 0.392239)));
      final normal_8_153 = mesh_8.normals.elementAt(153);
      expect(normal_8_153, vector3MoreOrLessEquals(Vector3(-0.804795, -0.592927, -0.027236)));
      final normal_8_154 = mesh_8.normals.elementAt(154);
      expect(normal_8_154, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, -0.047865)));
      final normal_8_155 = mesh_8.normals.elementAt(155);
      expect(normal_8_155, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, 0.392239)));
      final normal_8_156 = mesh_8.normals.elementAt(156);
      expect(normal_8_156, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, -0.047865)));
      final normal_8_157 = mesh_8.normals.elementAt(157);
      expect(normal_8_157, vector3MoreOrLessEquals(Vector3(-0.809953, 0.130294, 0.571839)));
      final normal_8_158 = mesh_8.normals.elementAt(158);
      expect(normal_8_158, vector3MoreOrLessEquals(Vector3(-0.775244, 0.155507, 0.612221)));
      final normal_8_159 = mesh_8.normals.elementAt(159);
      expect(normal_8_159, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, -0.047865)));
      final normal_8_160 = mesh_8.normals.elementAt(160);
      expect(normal_8_160, vector3MoreOrLessEquals(Vector3(-0.979826, -0.199093, 0.017388)));
      final normal_8_161 = mesh_8.normals.elementAt(161);
      expect(normal_8_161, vector3MoreOrLessEquals(Vector3(-0.809953, 0.130294, 0.571839)));
      final normal_8_162 = mesh_8.normals.elementAt(162);
      expect(normal_8_162, vector3MoreOrLessEquals(Vector3(-0.96966, -0.244405, 0.004995)));
      final normal_8_163 = mesh_8.normals.elementAt(163);
      expect(normal_8_163, vector3MoreOrLessEquals(Vector3(-0.80997, 0.211451, 0.547026)));
      final normal_8_164 = mesh_8.normals.elementAt(164);
      expect(normal_8_164, vector3MoreOrLessEquals(Vector3(-0.809953, 0.130294, 0.571839)));
      final normal_8_165 = mesh_8.normals.elementAt(165);
      expect(normal_8_165, vector3MoreOrLessEquals(Vector3(-0.979826, -0.199093, 0.017388)));
      final normal_8_166 = mesh_8.normals.elementAt(166);
      expect(normal_8_166, vector3MoreOrLessEquals(Vector3(-0.96966, -0.244405, 0.004995)));
      final normal_8_167 = mesh_8.normals.elementAt(167);
      expect(normal_8_167, vector3MoreOrLessEquals(Vector3(-0.809953, 0.130294, 0.571839)));
      final normal_8_168 = mesh_8.normals.elementAt(168);
      expect(normal_8_168, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_169 = mesh_8.normals.elementAt(169);
      expect(normal_8_169, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_170 = mesh_8.normals.elementAt(170);
      expect(normal_8_170, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_171 = mesh_8.normals.elementAt(171);
      expect(normal_8_171, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_172 = mesh_8.normals.elementAt(172);
      expect(normal_8_172, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_173 = mesh_8.normals.elementAt(173);
      expect(normal_8_173, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_174 = mesh_8.normals.elementAt(174);
      expect(normal_8_174, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, 0.681045)));
      final normal_8_175 = mesh_8.normals.elementAt(175);
      expect(normal_8_175, vector3MoreOrLessEquals(Vector3(-0.470746, -0.365488, 0.803005)));
      final normal_8_176 = mesh_8.normals.elementAt(176);
      expect(normal_8_176, vector3MoreOrLessEquals(Vector3(-0.512438, -0.473965, 0.716075)));
      final normal_8_177 = mesh_8.normals.elementAt(177);
      expect(normal_8_177, vector3MoreOrLessEquals(Vector3(0.150051, -0.816598, 0.557361)));
      final normal_8_178 = mesh_8.normals.elementAt(178);
      expect(normal_8_178, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, 0.681045)));
      final normal_8_179 = mesh_8.normals.elementAt(179);
      expect(normal_8_179, vector3MoreOrLessEquals(Vector3(-0.512438, -0.473965, 0.716075)));
      final normal_8_180 = mesh_8.normals.elementAt(180);
      expect(normal_8_180, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, 0.681045)));
      final normal_8_181 = mesh_8.normals.elementAt(181);
      expect(normal_8_181, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, 0.55203)));
      final normal_8_182 = mesh_8.normals.elementAt(182);
      expect(normal_8_182, vector3MoreOrLessEquals(Vector3(-0.470746, -0.365488, 0.803005)));
      final normal_8_183 = mesh_8.normals.elementAt(183);
      expect(normal_8_183, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, 0.681045)));
      final normal_8_184 = mesh_8.normals.elementAt(184);
      expect(normal_8_184, vector3MoreOrLessEquals(Vector3(0.305963, -0.903395, 0.300439)));
      final normal_8_185 = mesh_8.normals.elementAt(185);
      expect(normal_8_185, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, 0.55203)));
      final normal_8_186 = mesh_8.normals.elementAt(186);
      expect(normal_8_186, vector3MoreOrLessEquals(Vector3(-0.106894, -0.8791, -0.464497)));
      final normal_8_187 = mesh_8.normals.elementAt(187);
      expect(normal_8_187, vector3MoreOrLessEquals(Vector3(-0.804795, -0.592927, -0.027236)));
      final normal_8_188 = mesh_8.normals.elementAt(188);
      expect(normal_8_188, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, 0.55203)));
      final normal_8_189 = mesh_8.normals.elementAt(189);
      expect(normal_8_189, vector3MoreOrLessEquals(Vector3(0.305963, -0.903395, 0.300439)));
      final normal_8_190 = mesh_8.normals.elementAt(190);
      expect(normal_8_190, vector3MoreOrLessEquals(Vector3(-0.106894, -0.8791, -0.464497)));
      final normal_8_191 = mesh_8.normals.elementAt(191);
      expect(normal_8_191, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, 0.55203)));
      final normal_8_192 = mesh_8.normals.elementAt(192);
      expect(normal_8_192, vector3MoreOrLessEquals(Vector3(-0.106894, -0.8791, -0.464497)));
      final normal_8_193 = mesh_8.normals.elementAt(193);
      expect(normal_8_193, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, -0.047865)));
      final normal_8_194 = mesh_8.normals.elementAt(194);
      expect(normal_8_194, vector3MoreOrLessEquals(Vector3(-0.804795, -0.592927, -0.027236)));
      final normal_8_195 = mesh_8.normals.elementAt(195);
      expect(normal_8_195, vector3MoreOrLessEquals(Vector3(-0.106894, -0.8791, -0.464497)));
      final normal_8_196 = mesh_8.normals.elementAt(196);
      expect(normal_8_196, vector3MoreOrLessEquals(Vector3(-0.379304, -0.604701, -0.700332)));
      final normal_8_197 = mesh_8.normals.elementAt(197);
      expect(normal_8_197, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, -0.047865)));
      final normal_8_198 = mesh_8.normals.elementAt(198);
      expect(normal_8_198, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, -0.698527)));
      final normal_8_199 = mesh_8.normals.elementAt(199);
      expect(normal_8_199, vector3MoreOrLessEquals(Vector3(-0.979826, -0.199093, 0.017388)));
      final normal_8_200 = mesh_8.normals.elementAt(200);
      expect(normal_8_200, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, -0.047865)));
      final normal_8_201 = mesh_8.normals.elementAt(201);
      expect(normal_8_201, vector3MoreOrLessEquals(Vector3(-0.379304, -0.604701, -0.700332)));
      final normal_8_202 = mesh_8.normals.elementAt(202);
      expect(normal_8_202, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, -0.698527)));
      final normal_8_203 = mesh_8.normals.elementAt(203);
      expect(normal_8_203, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, -0.047865)));
      final normal_8_204 = mesh_8.normals.elementAt(204);
      expect(normal_8_204, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, -0.698527)));
      final normal_8_205 = mesh_8.normals.elementAt(205);
      expect(normal_8_205, vector3MoreOrLessEquals(Vector3(-0.96966, -0.244405, 0.004995)));
      final normal_8_206 = mesh_8.normals.elementAt(206);
      expect(normal_8_206, vector3MoreOrLessEquals(Vector3(-0.979826, -0.199093, 0.017388)));
      final normal_8_207 = mesh_8.normals.elementAt(207);
      expect(normal_8_207, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, -0.698527)));
      final normal_8_208 = mesh_8.normals.elementAt(208);
      expect(normal_8_208, vector3MoreOrLessEquals(Vector3(-0.396771, -0.701295, -0.592249)));
      final normal_8_209 = mesh_8.normals.elementAt(209);
      expect(normal_8_209, vector3MoreOrLessEquals(Vector3(-0.96966, -0.244405, 0.004995)));
      final normal_8_210 = mesh_8.normals.elementAt(210);
      expect(normal_8_210, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_211 = mesh_8.normals.elementAt(211);
      expect(normal_8_211, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_212 = mesh_8.normals.elementAt(212);
      expect(normal_8_212, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_213 = mesh_8.normals.elementAt(213);
      expect(normal_8_213, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_214 = mesh_8.normals.elementAt(214);
      expect(normal_8_214, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_215 = mesh_8.normals.elementAt(215);
      expect(normal_8_215, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_216 = mesh_8.normals.elementAt(216);
      expect(normal_8_216, vector3MoreOrLessEquals(Vector3(0.835906, -0.548834, -0.006518)));
      final normal_8_217 = mesh_8.normals.elementAt(217);
      expect(normal_8_217, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, 0.681045)));
      final normal_8_218 = mesh_8.normals.elementAt(218);
      expect(normal_8_218, vector3MoreOrLessEquals(Vector3(0.150051, -0.816598, 0.557361)));
      final normal_8_219 = mesh_8.normals.elementAt(219);
      expect(normal_8_219, vector3MoreOrLessEquals(Vector3(0.835906, -0.548834, -0.006518)));
      final normal_8_220 = mesh_8.normals.elementAt(220);
      expect(normal_8_220, vector3MoreOrLessEquals(Vector3(0.923602, -0.381844, 0.033966)));
      final normal_8_221 = mesh_8.normals.elementAt(221);
      expect(normal_8_221, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, 0.681045)));
      final normal_8_222 = mesh_8.normals.elementAt(222);
      expect(normal_8_222, vector3MoreOrLessEquals(Vector3(0.863214, -0.393372, -0.316418)));
      final normal_8_223 = mesh_8.normals.elementAt(223);
      expect(normal_8_223, vector3MoreOrLessEquals(Vector3(0.305963, -0.903395, 0.300439)));
      final normal_8_224 = mesh_8.normals.elementAt(224);
      expect(normal_8_224, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, 0.681045)));
      final normal_8_225 = mesh_8.normals.elementAt(225);
      expect(normal_8_225, vector3MoreOrLessEquals(Vector3(0.923602, -0.381844, 0.033966)));
      final normal_8_226 = mesh_8.normals.elementAt(226);
      expect(normal_8_226, vector3MoreOrLessEquals(Vector3(0.863214, -0.393372, -0.316418)));
      final normal_8_227 = mesh_8.normals.elementAt(227);
      expect(normal_8_227, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, 0.681045)));
      final normal_8_228 = mesh_8.normals.elementAt(228);
      expect(normal_8_228, vector3MoreOrLessEquals(Vector3(0.863214, -0.393372, -0.316418)));
      final normal_8_229 = mesh_8.normals.elementAt(229);
      expect(normal_8_229, vector3MoreOrLessEquals(Vector3(-0.106894, -0.8791, -0.464497)));
      final normal_8_230 = mesh_8.normals.elementAt(230);
      expect(normal_8_230, vector3MoreOrLessEquals(Vector3(0.305963, -0.903395, 0.300439)));
      final normal_8_231 = mesh_8.normals.elementAt(231);
      expect(normal_8_231, vector3MoreOrLessEquals(Vector3(0.863214, -0.393372, -0.316418)));
      final normal_8_232 = mesh_8.normals.elementAt(232);
      expect(normal_8_232, vector3MoreOrLessEquals(Vector3(0.6055, -0.431678, -0.668598)));
      final normal_8_233 = mesh_8.normals.elementAt(233);
      expect(normal_8_233, vector3MoreOrLessEquals(Vector3(-0.106894, -0.8791, -0.464497)));
      final normal_8_234 = mesh_8.normals.elementAt(234);
      expect(normal_8_234, vector3MoreOrLessEquals(Vector3(0.534229, -0.375452, -0.757387)));
      final normal_8_235 = mesh_8.normals.elementAt(235);
      expect(normal_8_235, vector3MoreOrLessEquals(Vector3(-0.379304, -0.604701, -0.700332)));
      final normal_8_236 = mesh_8.normals.elementAt(236);
      expect(normal_8_236, vector3MoreOrLessEquals(Vector3(-0.106894, -0.8791, -0.464497)));
      final normal_8_237 = mesh_8.normals.elementAt(237);
      expect(normal_8_237, vector3MoreOrLessEquals(Vector3(0.6055, -0.431678, -0.668598)));
      final normal_8_238 = mesh_8.normals.elementAt(238);
      expect(normal_8_238, vector3MoreOrLessEquals(Vector3(0.534229, -0.375452, -0.757387)));
      final normal_8_239 = mesh_8.normals.elementAt(239);
      expect(normal_8_239, vector3MoreOrLessEquals(Vector3(-0.106894, -0.8791, -0.464497)));
      final normal_8_240 = mesh_8.normals.elementAt(240);
      expect(normal_8_240, vector3MoreOrLessEquals(Vector3(0.534229, -0.375452, -0.757387)));
      final normal_8_241 = mesh_8.normals.elementAt(241);
      expect(normal_8_241, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, -0.698527)));
      final normal_8_242 = mesh_8.normals.elementAt(242);
      expect(normal_8_242, vector3MoreOrLessEquals(Vector3(-0.379304, -0.604701, -0.700332)));
      final normal_8_243 = mesh_8.normals.elementAt(243);
      expect(normal_8_243, vector3MoreOrLessEquals(Vector3(0.534229, -0.375452, -0.757387)));
      final normal_8_244 = mesh_8.normals.elementAt(244);
      expect(normal_8_244, vector3MoreOrLessEquals(Vector3(0.609831, -0.367158, -0.702354)));
      final normal_8_245 = mesh_8.normals.elementAt(245);
      expect(normal_8_245, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, -0.698527)));
      final normal_8_246 = mesh_8.normals.elementAt(246);
      expect(normal_8_246, vector3MoreOrLessEquals(Vector3(0.606094, -0.512127, -0.608586)));
      final normal_8_247 = mesh_8.normals.elementAt(247);
      expect(normal_8_247, vector3MoreOrLessEquals(Vector3(-0.396771, -0.701295, -0.592249)));
      final normal_8_248 = mesh_8.normals.elementAt(248);
      expect(normal_8_248, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, -0.698527)));
      final normal_8_249 = mesh_8.normals.elementAt(249);
      expect(normal_8_249, vector3MoreOrLessEquals(Vector3(0.609831, -0.367158, -0.702354)));
      final normal_8_250 = mesh_8.normals.elementAt(250);
      expect(normal_8_250, vector3MoreOrLessEquals(Vector3(0.606094, -0.512127, -0.608586)));
      final normal_8_251 = mesh_8.normals.elementAt(251);
      expect(normal_8_251, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, -0.698527)));
      final normal_8_252 = mesh_8.normals.elementAt(252);
      expect(normal_8_252, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_253 = mesh_8.normals.elementAt(253);
      expect(normal_8_253, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_254 = mesh_8.normals.elementAt(254);
      expect(normal_8_254, vector3MoreOrLessEquals(Vector3(-0.287103, -0.930941, -0.225656)));
      final normal_8_255 = mesh_8.normals.elementAt(255);
      expect(normal_8_255, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_256 = mesh_8.normals.elementAt(256);
      expect(normal_8_256, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_257 = mesh_8.normals.elementAt(257);
      expect(normal_8_257, vector3MoreOrLessEquals(Vector3(0.184368, -0.421801, 0.887746)));
      final normal_8_258 = mesh_8.normals.elementAt(258);
      expect(normal_8_258, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, -0.514517)));
      final normal_8_259 = mesh_8.normals.elementAt(259);
      expect(normal_8_259, vector3MoreOrLessEquals(Vector3(0.923602, -0.381844, 0.033966)));
      final normal_8_260 = mesh_8.normals.elementAt(260);
      expect(normal_8_260, vector3MoreOrLessEquals(Vector3(0.835906, -0.548834, -0.006518)));
      final normal_8_261 = mesh_8.normals.elementAt(261);
      expect(normal_8_261, vector3MoreOrLessEquals(Vector3(0.730773, 0.32289, -0.601426)));
      final normal_8_262 = mesh_8.normals.elementAt(262);
      expect(normal_8_262, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, -0.514517)));
      final normal_8_263 = mesh_8.normals.elementAt(263);
      expect(normal_8_263, vector3MoreOrLessEquals(Vector3(0.835906, -0.548834, -0.006518)));
      final normal_8_264 = mesh_8.normals.elementAt(264);
      expect(normal_8_264, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, -0.514517)));
      final normal_8_265 = mesh_8.normals.elementAt(265);
      expect(normal_8_265, vector3MoreOrLessEquals(Vector3(0.863214, -0.393372, -0.316418)));
      final normal_8_266 = mesh_8.normals.elementAt(266);
      expect(normal_8_266, vector3MoreOrLessEquals(Vector3(0.923602, -0.381844, 0.033966)));
      final normal_8_267 = mesh_8.normals.elementAt(267);
      expect(normal_8_267, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, -0.514517)));
      final normal_8_268 = mesh_8.normals.elementAt(268);
      expect(normal_8_268, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, -0.69454)));
      final normal_8_269 = mesh_8.normals.elementAt(269);
      expect(normal_8_269, vector3MoreOrLessEquals(Vector3(0.863214, -0.393372, -0.316418)));
      final normal_8_270 = mesh_8.normals.elementAt(270);
      expect(normal_8_270, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, -0.541146)));
      final normal_8_271 = mesh_8.normals.elementAt(271);
      expect(normal_8_271, vector3MoreOrLessEquals(Vector3(0.6055, -0.431678, -0.668598)));
      final normal_8_272 = mesh_8.normals.elementAt(272);
      expect(normal_8_272, vector3MoreOrLessEquals(Vector3(0.863214, -0.393372, -0.316418)));
      final normal_8_273 = mesh_8.normals.elementAt(273);
      expect(normal_8_273, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, -0.69454)));
      final normal_8_274 = mesh_8.normals.elementAt(274);
      expect(normal_8_274, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, -0.541146)));
      final normal_8_275 = mesh_8.normals.elementAt(275);
      expect(normal_8_275, vector3MoreOrLessEquals(Vector3(0.863214, -0.393372, -0.316418)));
      final normal_8_276 = mesh_8.normals.elementAt(276);
      expect(normal_8_276, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, -0.541146)));
      final normal_8_277 = mesh_8.normals.elementAt(277);
      expect(normal_8_277, vector3MoreOrLessEquals(Vector3(0.534229, -0.375452, -0.757387)));
      final normal_8_278 = mesh_8.normals.elementAt(278);
      expect(normal_8_278, vector3MoreOrLessEquals(Vector3(0.6055, -0.431678, -0.668598)));
      final normal_8_279 = mesh_8.normals.elementAt(279);
      expect(normal_8_279, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, -0.541146)));
      final normal_8_280 = mesh_8.normals.elementAt(280);
      expect(normal_8_280, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, -0.179176)));
      final normal_8_281 = mesh_8.normals.elementAt(281);
      expect(normal_8_281, vector3MoreOrLessEquals(Vector3(0.534229, -0.375452, -0.757387)));
      final normal_8_282 = mesh_8.normals.elementAt(282);
      expect(normal_8_282, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, -0.322182)));
      final normal_8_283 = mesh_8.normals.elementAt(283);
      expect(normal_8_283, vector3MoreOrLessEquals(Vector3(0.609831, -0.367158, -0.702354)));
      final normal_8_284 = mesh_8.normals.elementAt(284);
      expect(normal_8_284, vector3MoreOrLessEquals(Vector3(0.534229, -0.375452, -0.757387)));
      final normal_8_285 = mesh_8.normals.elementAt(285);
      expect(normal_8_285, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, -0.179176)));
      final normal_8_286 = mesh_8.normals.elementAt(286);
      expect(normal_8_286, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, -0.322182)));
      final normal_8_287 = mesh_8.normals.elementAt(287);
      expect(normal_8_287, vector3MoreOrLessEquals(Vector3(0.534229, -0.375452, -0.757387)));
      final normal_8_288 = mesh_8.normals.elementAt(288);
      expect(normal_8_288, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, -0.322182)));
      final normal_8_289 = mesh_8.normals.elementAt(289);
      expect(normal_8_289, vector3MoreOrLessEquals(Vector3(0.606094, -0.512127, -0.608586)));
      final normal_8_290 = mesh_8.normals.elementAt(290);
      expect(normal_8_290, vector3MoreOrLessEquals(Vector3(0.609831, -0.367158, -0.702354)));
      final normal_8_291 = mesh_8.normals.elementAt(291);
      expect(normal_8_291, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, -0.322182)));
      final normal_8_292 = mesh_8.normals.elementAt(292);
      expect(normal_8_292, vector3MoreOrLessEquals(Vector3(0.996799, 0.009221, -0.079417)));
      final normal_8_293 = mesh_8.normals.elementAt(293);
      expect(normal_8_293, vector3MoreOrLessEquals(Vector3(0.606094, -0.512127, -0.608586)));
      expect(mesh_8.tangents.length, isZero);
      expect(mesh_8.bitangents.length, isZero);
      expect(mesh_8.colors.length, isZero);
      expect(mesh_8.textureCoords.length, equals(1));
      final textureCoords_8_0 = mesh_8.textureCoords.elementAt(0);
      expect(textureCoords_8_0.length, equals(294));
      final textureCoord_8_0_0 = textureCoords_8_0.elementAt(0);
      expect(textureCoord_8_0_0, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_1 = textureCoords_8_0.elementAt(1);
      expect(textureCoord_8_0_1, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_2 = textureCoords_8_0.elementAt(2);
      expect(textureCoord_8_0_2, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_3 = textureCoords_8_0.elementAt(3);
      expect(textureCoord_8_0_3, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_4 = textureCoords_8_0.elementAt(4);
      expect(textureCoord_8_0_4, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_5 = textureCoords_8_0.elementAt(5);
      expect(textureCoord_8_0_5, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_6 = textureCoords_8_0.elementAt(6);
      expect(textureCoord_8_0_6, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_8_0_7 = textureCoords_8_0.elementAt(7);
      expect(textureCoord_8_0_7, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_8_0_8 = textureCoords_8_0.elementAt(8);
      expect(textureCoord_8_0_8, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_8_0_9 = textureCoords_8_0.elementAt(9);
      expect(textureCoord_8_0_9, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_8_0_10 = textureCoords_8_0.elementAt(10);
      expect(textureCoord_8_0_10, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_8_0_11 = textureCoords_8_0.elementAt(11);
      expect(textureCoord_8_0_11, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_8_0_12 = textureCoords_8_0.elementAt(12);
      expect(textureCoord_8_0_12, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_8_0_13 = textureCoords_8_0.elementAt(13);
      expect(textureCoord_8_0_13, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_8_0_14 = textureCoords_8_0.elementAt(14);
      expect(textureCoord_8_0_14, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_8_0_15 = textureCoords_8_0.elementAt(15);
      expect(textureCoord_8_0_15, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_8_0_16 = textureCoords_8_0.elementAt(16);
      expect(textureCoord_8_0_16, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_8_0_17 = textureCoords_8_0.elementAt(17);
      expect(textureCoord_8_0_17, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_8_0_18 = textureCoords_8_0.elementAt(18);
      expect(textureCoord_8_0_18, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_8_0_19 = textureCoords_8_0.elementAt(19);
      expect(textureCoord_8_0_19, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_8_0_20 = textureCoords_8_0.elementAt(20);
      expect(textureCoord_8_0_20, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_8_0_21 = textureCoords_8_0.elementAt(21);
      expect(textureCoord_8_0_21, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_8_0_22 = textureCoords_8_0.elementAt(22);
      expect(textureCoord_8_0_22, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_8_0_23 = textureCoords_8_0.elementAt(23);
      expect(textureCoord_8_0_23, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_8_0_24 = textureCoords_8_0.elementAt(24);
      expect(textureCoord_8_0_24, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_8_0_25 = textureCoords_8_0.elementAt(25);
      expect(textureCoord_8_0_25, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_8_0_26 = textureCoords_8_0.elementAt(26);
      expect(textureCoord_8_0_26, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_8_0_27 = textureCoords_8_0.elementAt(27);
      expect(textureCoord_8_0_27, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_8_0_28 = textureCoords_8_0.elementAt(28);
      expect(textureCoord_8_0_28, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_8_0_29 = textureCoords_8_0.elementAt(29);
      expect(textureCoord_8_0_29, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_8_0_30 = textureCoords_8_0.elementAt(30);
      expect(textureCoord_8_0_30, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_8_0_31 = textureCoords_8_0.elementAt(31);
      expect(textureCoord_8_0_31, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_8_0_32 = textureCoords_8_0.elementAt(32);
      expect(textureCoord_8_0_32, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_8_0_33 = textureCoords_8_0.elementAt(33);
      expect(textureCoord_8_0_33, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_8_0_34 = textureCoords_8_0.elementAt(34);
      expect(textureCoord_8_0_34, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_8_0_35 = textureCoords_8_0.elementAt(35);
      expect(textureCoord_8_0_35, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_8_0_36 = textureCoords_8_0.elementAt(36);
      expect(textureCoord_8_0_36, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_8_0_37 = textureCoords_8_0.elementAt(37);
      expect(textureCoord_8_0_37, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_38 = textureCoords_8_0.elementAt(38);
      expect(textureCoord_8_0_38, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_8_0_39 = textureCoords_8_0.elementAt(39);
      expect(textureCoord_8_0_39, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_8_0_40 = textureCoords_8_0.elementAt(40);
      expect(textureCoord_8_0_40, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_8_0_41 = textureCoords_8_0.elementAt(41);
      expect(textureCoord_8_0_41, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_42 = textureCoords_8_0.elementAt(42);
      expect(textureCoord_8_0_42, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_43 = textureCoords_8_0.elementAt(43);
      expect(textureCoord_8_0_43, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_44 = textureCoords_8_0.elementAt(44);
      expect(textureCoord_8_0_44, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_45 = textureCoords_8_0.elementAt(45);
      expect(textureCoord_8_0_45, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_46 = textureCoords_8_0.elementAt(46);
      expect(textureCoord_8_0_46, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_47 = textureCoords_8_0.elementAt(47);
      expect(textureCoord_8_0_47, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_48 = textureCoords_8_0.elementAt(48);
      expect(textureCoord_8_0_48, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_8_0_49 = textureCoords_8_0.elementAt(49);
      expect(textureCoord_8_0_49, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_8_0_50 = textureCoords_8_0.elementAt(50);
      expect(textureCoord_8_0_50, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_8_0_51 = textureCoords_8_0.elementAt(51);
      expect(textureCoord_8_0_51, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_8_0_52 = textureCoords_8_0.elementAt(52);
      expect(textureCoord_8_0_52, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_8_0_53 = textureCoords_8_0.elementAt(53);
      expect(textureCoord_8_0_53, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_8_0_54 = textureCoords_8_0.elementAt(54);
      expect(textureCoord_8_0_54, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_8_0_55 = textureCoords_8_0.elementAt(55);
      expect(textureCoord_8_0_55, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_8_0_56 = textureCoords_8_0.elementAt(56);
      expect(textureCoord_8_0_56, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_8_0_57 = textureCoords_8_0.elementAt(57);
      expect(textureCoord_8_0_57, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_8_0_58 = textureCoords_8_0.elementAt(58);
      expect(textureCoord_8_0_58, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_8_0_59 = textureCoords_8_0.elementAt(59);
      expect(textureCoord_8_0_59, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_8_0_60 = textureCoords_8_0.elementAt(60);
      expect(textureCoord_8_0_60, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_8_0_61 = textureCoords_8_0.elementAt(61);
      expect(textureCoord_8_0_61, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_8_0_62 = textureCoords_8_0.elementAt(62);
      expect(textureCoord_8_0_62, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_8_0_63 = textureCoords_8_0.elementAt(63);
      expect(textureCoord_8_0_63, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_8_0_64 = textureCoords_8_0.elementAt(64);
      expect(textureCoord_8_0_64, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_8_0_65 = textureCoords_8_0.elementAt(65);
      expect(textureCoord_8_0_65, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_8_0_66 = textureCoords_8_0.elementAt(66);
      expect(textureCoord_8_0_66, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_8_0_67 = textureCoords_8_0.elementAt(67);
      expect(textureCoord_8_0_67, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_8_0_68 = textureCoords_8_0.elementAt(68);
      expect(textureCoord_8_0_68, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_8_0_69 = textureCoords_8_0.elementAt(69);
      expect(textureCoord_8_0_69, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_8_0_70 = textureCoords_8_0.elementAt(70);
      expect(textureCoord_8_0_70, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_8_0_71 = textureCoords_8_0.elementAt(71);
      expect(textureCoord_8_0_71, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_8_0_72 = textureCoords_8_0.elementAt(72);
      expect(textureCoord_8_0_72, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_8_0_73 = textureCoords_8_0.elementAt(73);
      expect(textureCoord_8_0_73, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_8_0_74 = textureCoords_8_0.elementAt(74);
      expect(textureCoord_8_0_74, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_8_0_75 = textureCoords_8_0.elementAt(75);
      expect(textureCoord_8_0_75, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_8_0_76 = textureCoords_8_0.elementAt(76);
      expect(textureCoord_8_0_76, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_8_0_77 = textureCoords_8_0.elementAt(77);
      expect(textureCoord_8_0_77, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_8_0_78 = textureCoords_8_0.elementAt(78);
      expect(textureCoord_8_0_78, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_8_0_79 = textureCoords_8_0.elementAt(79);
      expect(textureCoord_8_0_79, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_8_0_80 = textureCoords_8_0.elementAt(80);
      expect(textureCoord_8_0_80, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_8_0_81 = textureCoords_8_0.elementAt(81);
      expect(textureCoord_8_0_81, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_8_0_82 = textureCoords_8_0.elementAt(82);
      expect(textureCoord_8_0_82, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_8_0_83 = textureCoords_8_0.elementAt(83);
      expect(textureCoord_8_0_83, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_8_0_84 = textureCoords_8_0.elementAt(84);
      expect(textureCoord_8_0_84, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_85 = textureCoords_8_0.elementAt(85);
      expect(textureCoord_8_0_85, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_86 = textureCoords_8_0.elementAt(86);
      expect(textureCoord_8_0_86, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_87 = textureCoords_8_0.elementAt(87);
      expect(textureCoord_8_0_87, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_88 = textureCoords_8_0.elementAt(88);
      expect(textureCoord_8_0_88, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_89 = textureCoords_8_0.elementAt(89);
      expect(textureCoord_8_0_89, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_90 = textureCoords_8_0.elementAt(90);
      expect(textureCoord_8_0_90, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_8_0_91 = textureCoords_8_0.elementAt(91);
      expect(textureCoord_8_0_91, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_8_0_92 = textureCoords_8_0.elementAt(92);
      expect(textureCoord_8_0_92, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_8_0_93 = textureCoords_8_0.elementAt(93);
      expect(textureCoord_8_0_93, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_8_0_94 = textureCoords_8_0.elementAt(94);
      expect(textureCoord_8_0_94, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_8_0_95 = textureCoords_8_0.elementAt(95);
      expect(textureCoord_8_0_95, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_8_0_96 = textureCoords_8_0.elementAt(96);
      expect(textureCoord_8_0_96, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_8_0_97 = textureCoords_8_0.elementAt(97);
      expect(textureCoord_8_0_97, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_8_0_98 = textureCoords_8_0.elementAt(98);
      expect(textureCoord_8_0_98, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_8_0_99 = textureCoords_8_0.elementAt(99);
      expect(textureCoord_8_0_99, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_8_0_100 = textureCoords_8_0.elementAt(100);
      expect(textureCoord_8_0_100, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_8_0_101 = textureCoords_8_0.elementAt(101);
      expect(textureCoord_8_0_101, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_8_0_102 = textureCoords_8_0.elementAt(102);
      expect(textureCoord_8_0_102, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_8_0_103 = textureCoords_8_0.elementAt(103);
      expect(textureCoord_8_0_103, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_8_0_104 = textureCoords_8_0.elementAt(104);
      expect(textureCoord_8_0_104, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_8_0_105 = textureCoords_8_0.elementAt(105);
      expect(textureCoord_8_0_105, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_8_0_106 = textureCoords_8_0.elementAt(106);
      expect(textureCoord_8_0_106, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_8_0_107 = textureCoords_8_0.elementAt(107);
      expect(textureCoord_8_0_107, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_8_0_108 = textureCoords_8_0.elementAt(108);
      expect(textureCoord_8_0_108, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_8_0_109 = textureCoords_8_0.elementAt(109);
      expect(textureCoord_8_0_109, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_8_0_110 = textureCoords_8_0.elementAt(110);
      expect(textureCoord_8_0_110, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_8_0_111 = textureCoords_8_0.elementAt(111);
      expect(textureCoord_8_0_111, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_8_0_112 = textureCoords_8_0.elementAt(112);
      expect(textureCoord_8_0_112, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_8_0_113 = textureCoords_8_0.elementAt(113);
      expect(textureCoord_8_0_113, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_8_0_114 = textureCoords_8_0.elementAt(114);
      expect(textureCoord_8_0_114, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_8_0_115 = textureCoords_8_0.elementAt(115);
      expect(textureCoord_8_0_115, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_8_0_116 = textureCoords_8_0.elementAt(116);
      expect(textureCoord_8_0_116, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_8_0_117 = textureCoords_8_0.elementAt(117);
      expect(textureCoord_8_0_117, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_8_0_118 = textureCoords_8_0.elementAt(118);
      expect(textureCoord_8_0_118, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_8_0_119 = textureCoords_8_0.elementAt(119);
      expect(textureCoord_8_0_119, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_8_0_120 = textureCoords_8_0.elementAt(120);
      expect(textureCoord_8_0_120, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_8_0_121 = textureCoords_8_0.elementAt(121);
      expect(textureCoord_8_0_121, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_8_0_122 = textureCoords_8_0.elementAt(122);
      expect(textureCoord_8_0_122, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_8_0_123 = textureCoords_8_0.elementAt(123);
      expect(textureCoord_8_0_123, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_8_0_124 = textureCoords_8_0.elementAt(124);
      expect(textureCoord_8_0_124, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_8_0_125 = textureCoords_8_0.elementAt(125);
      expect(textureCoord_8_0_125, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_8_0_126 = textureCoords_8_0.elementAt(126);
      expect(textureCoord_8_0_126, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_127 = textureCoords_8_0.elementAt(127);
      expect(textureCoord_8_0_127, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_128 = textureCoords_8_0.elementAt(128);
      expect(textureCoord_8_0_128, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_129 = textureCoords_8_0.elementAt(129);
      expect(textureCoord_8_0_129, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_130 = textureCoords_8_0.elementAt(130);
      expect(textureCoord_8_0_130, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_131 = textureCoords_8_0.elementAt(131);
      expect(textureCoord_8_0_131, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_132 = textureCoords_8_0.elementAt(132);
      expect(textureCoord_8_0_132, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_8_0_133 = textureCoords_8_0.elementAt(133);
      expect(textureCoord_8_0_133, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_8_0_134 = textureCoords_8_0.elementAt(134);
      expect(textureCoord_8_0_134, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_8_0_135 = textureCoords_8_0.elementAt(135);
      expect(textureCoord_8_0_135, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_8_0_136 = textureCoords_8_0.elementAt(136);
      expect(textureCoord_8_0_136, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_8_0_137 = textureCoords_8_0.elementAt(137);
      expect(textureCoord_8_0_137, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_8_0_138 = textureCoords_8_0.elementAt(138);
      expect(textureCoord_8_0_138, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_8_0_139 = textureCoords_8_0.elementAt(139);
      expect(textureCoord_8_0_139, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_8_0_140 = textureCoords_8_0.elementAt(140);
      expect(textureCoord_8_0_140, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_8_0_141 = textureCoords_8_0.elementAt(141);
      expect(textureCoord_8_0_141, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_8_0_142 = textureCoords_8_0.elementAt(142);
      expect(textureCoord_8_0_142, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_8_0_143 = textureCoords_8_0.elementAt(143);
      expect(textureCoord_8_0_143, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_8_0_144 = textureCoords_8_0.elementAt(144);
      expect(textureCoord_8_0_144, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_8_0_145 = textureCoords_8_0.elementAt(145);
      expect(textureCoord_8_0_145, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_8_0_146 = textureCoords_8_0.elementAt(146);
      expect(textureCoord_8_0_146, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_8_0_147 = textureCoords_8_0.elementAt(147);
      expect(textureCoord_8_0_147, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_8_0_148 = textureCoords_8_0.elementAt(148);
      expect(textureCoord_8_0_148, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_8_0_149 = textureCoords_8_0.elementAt(149);
      expect(textureCoord_8_0_149, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_8_0_150 = textureCoords_8_0.elementAt(150);
      expect(textureCoord_8_0_150, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_8_0_151 = textureCoords_8_0.elementAt(151);
      expect(textureCoord_8_0_151, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_8_0_152 = textureCoords_8_0.elementAt(152);
      expect(textureCoord_8_0_152, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_8_0_153 = textureCoords_8_0.elementAt(153);
      expect(textureCoord_8_0_153, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_8_0_154 = textureCoords_8_0.elementAt(154);
      expect(textureCoord_8_0_154, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_8_0_155 = textureCoords_8_0.elementAt(155);
      expect(textureCoord_8_0_155, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_8_0_156 = textureCoords_8_0.elementAt(156);
      expect(textureCoord_8_0_156, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_8_0_157 = textureCoords_8_0.elementAt(157);
      expect(textureCoord_8_0_157, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_8_0_158 = textureCoords_8_0.elementAt(158);
      expect(textureCoord_8_0_158, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_8_0_159 = textureCoords_8_0.elementAt(159);
      expect(textureCoord_8_0_159, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_8_0_160 = textureCoords_8_0.elementAt(160);
      expect(textureCoord_8_0_160, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_8_0_161 = textureCoords_8_0.elementAt(161);
      expect(textureCoord_8_0_161, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_8_0_162 = textureCoords_8_0.elementAt(162);
      expect(textureCoord_8_0_162, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_8_0_163 = textureCoords_8_0.elementAt(163);
      expect(textureCoord_8_0_163, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_8_0_164 = textureCoords_8_0.elementAt(164);
      expect(textureCoord_8_0_164, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_8_0_165 = textureCoords_8_0.elementAt(165);
      expect(textureCoord_8_0_165, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_8_0_166 = textureCoords_8_0.elementAt(166);
      expect(textureCoord_8_0_166, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_8_0_167 = textureCoords_8_0.elementAt(167);
      expect(textureCoord_8_0_167, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_8_0_168 = textureCoords_8_0.elementAt(168);
      expect(textureCoord_8_0_168, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_169 = textureCoords_8_0.elementAt(169);
      expect(textureCoord_8_0_169, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_170 = textureCoords_8_0.elementAt(170);
      expect(textureCoord_8_0_170, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_171 = textureCoords_8_0.elementAt(171);
      expect(textureCoord_8_0_171, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_172 = textureCoords_8_0.elementAt(172);
      expect(textureCoord_8_0_172, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_173 = textureCoords_8_0.elementAt(173);
      expect(textureCoord_8_0_173, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_174 = textureCoords_8_0.elementAt(174);
      expect(textureCoord_8_0_174, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_8_0_175 = textureCoords_8_0.elementAt(175);
      expect(textureCoord_8_0_175, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_8_0_176 = textureCoords_8_0.elementAt(176);
      expect(textureCoord_8_0_176, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_8_0_177 = textureCoords_8_0.elementAt(177);
      expect(textureCoord_8_0_177, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_8_0_178 = textureCoords_8_0.elementAt(178);
      expect(textureCoord_8_0_178, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_8_0_179 = textureCoords_8_0.elementAt(179);
      expect(textureCoord_8_0_179, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_8_0_180 = textureCoords_8_0.elementAt(180);
      expect(textureCoord_8_0_180, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_8_0_181 = textureCoords_8_0.elementAt(181);
      expect(textureCoord_8_0_181, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_8_0_182 = textureCoords_8_0.elementAt(182);
      expect(textureCoord_8_0_182, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_8_0_183 = textureCoords_8_0.elementAt(183);
      expect(textureCoord_8_0_183, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_8_0_184 = textureCoords_8_0.elementAt(184);
      expect(textureCoord_8_0_184, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_8_0_185 = textureCoords_8_0.elementAt(185);
      expect(textureCoord_8_0_185, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_8_0_186 = textureCoords_8_0.elementAt(186);
      expect(textureCoord_8_0_186, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_8_0_187 = textureCoords_8_0.elementAt(187);
      expect(textureCoord_8_0_187, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_8_0_188 = textureCoords_8_0.elementAt(188);
      expect(textureCoord_8_0_188, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_8_0_189 = textureCoords_8_0.elementAt(189);
      expect(textureCoord_8_0_189, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_8_0_190 = textureCoords_8_0.elementAt(190);
      expect(textureCoord_8_0_190, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_8_0_191 = textureCoords_8_0.elementAt(191);
      expect(textureCoord_8_0_191, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_8_0_192 = textureCoords_8_0.elementAt(192);
      expect(textureCoord_8_0_192, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_8_0_193 = textureCoords_8_0.elementAt(193);
      expect(textureCoord_8_0_193, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_8_0_194 = textureCoords_8_0.elementAt(194);
      expect(textureCoord_8_0_194, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_8_0_195 = textureCoords_8_0.elementAt(195);
      expect(textureCoord_8_0_195, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_8_0_196 = textureCoords_8_0.elementAt(196);
      expect(textureCoord_8_0_196, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_8_0_197 = textureCoords_8_0.elementAt(197);
      expect(textureCoord_8_0_197, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_8_0_198 = textureCoords_8_0.elementAt(198);
      expect(textureCoord_8_0_198, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_8_0_199 = textureCoords_8_0.elementAt(199);
      expect(textureCoord_8_0_199, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_8_0_200 = textureCoords_8_0.elementAt(200);
      expect(textureCoord_8_0_200, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_8_0_201 = textureCoords_8_0.elementAt(201);
      expect(textureCoord_8_0_201, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_8_0_202 = textureCoords_8_0.elementAt(202);
      expect(textureCoord_8_0_202, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_8_0_203 = textureCoords_8_0.elementAt(203);
      expect(textureCoord_8_0_203, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_8_0_204 = textureCoords_8_0.elementAt(204);
      expect(textureCoord_8_0_204, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_8_0_205 = textureCoords_8_0.elementAt(205);
      expect(textureCoord_8_0_205, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_8_0_206 = textureCoords_8_0.elementAt(206);
      expect(textureCoord_8_0_206, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_8_0_207 = textureCoords_8_0.elementAt(207);
      expect(textureCoord_8_0_207, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_8_0_208 = textureCoords_8_0.elementAt(208);
      expect(textureCoord_8_0_208, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_8_0_209 = textureCoords_8_0.elementAt(209);
      expect(textureCoord_8_0_209, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_8_0_210 = textureCoords_8_0.elementAt(210);
      expect(textureCoord_8_0_210, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_211 = textureCoords_8_0.elementAt(211);
      expect(textureCoord_8_0_211, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_212 = textureCoords_8_0.elementAt(212);
      expect(textureCoord_8_0_212, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_213 = textureCoords_8_0.elementAt(213);
      expect(textureCoord_8_0_213, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_214 = textureCoords_8_0.elementAt(214);
      expect(textureCoord_8_0_214, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_215 = textureCoords_8_0.elementAt(215);
      expect(textureCoord_8_0_215, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_216 = textureCoords_8_0.elementAt(216);
      expect(textureCoord_8_0_216, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_8_0_217 = textureCoords_8_0.elementAt(217);
      expect(textureCoord_8_0_217, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_8_0_218 = textureCoords_8_0.elementAt(218);
      expect(textureCoord_8_0_218, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_8_0_219 = textureCoords_8_0.elementAt(219);
      expect(textureCoord_8_0_219, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_8_0_220 = textureCoords_8_0.elementAt(220);
      expect(textureCoord_8_0_220, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_8_0_221 = textureCoords_8_0.elementAt(221);
      expect(textureCoord_8_0_221, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_8_0_222 = textureCoords_8_0.elementAt(222);
      expect(textureCoord_8_0_222, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_8_0_223 = textureCoords_8_0.elementAt(223);
      expect(textureCoord_8_0_223, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_8_0_224 = textureCoords_8_0.elementAt(224);
      expect(textureCoord_8_0_224, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_8_0_225 = textureCoords_8_0.elementAt(225);
      expect(textureCoord_8_0_225, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_8_0_226 = textureCoords_8_0.elementAt(226);
      expect(textureCoord_8_0_226, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_8_0_227 = textureCoords_8_0.elementAt(227);
      expect(textureCoord_8_0_227, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_8_0_228 = textureCoords_8_0.elementAt(228);
      expect(textureCoord_8_0_228, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_8_0_229 = textureCoords_8_0.elementAt(229);
      expect(textureCoord_8_0_229, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_8_0_230 = textureCoords_8_0.elementAt(230);
      expect(textureCoord_8_0_230, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_8_0_231 = textureCoords_8_0.elementAt(231);
      expect(textureCoord_8_0_231, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_8_0_232 = textureCoords_8_0.elementAt(232);
      expect(textureCoord_8_0_232, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_8_0_233 = textureCoords_8_0.elementAt(233);
      expect(textureCoord_8_0_233, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_8_0_234 = textureCoords_8_0.elementAt(234);
      expect(textureCoord_8_0_234, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_8_0_235 = textureCoords_8_0.elementAt(235);
      expect(textureCoord_8_0_235, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_8_0_236 = textureCoords_8_0.elementAt(236);
      expect(textureCoord_8_0_236, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_8_0_237 = textureCoords_8_0.elementAt(237);
      expect(textureCoord_8_0_237, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_8_0_238 = textureCoords_8_0.elementAt(238);
      expect(textureCoord_8_0_238, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_8_0_239 = textureCoords_8_0.elementAt(239);
      expect(textureCoord_8_0_239, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_8_0_240 = textureCoords_8_0.elementAt(240);
      expect(textureCoord_8_0_240, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_8_0_241 = textureCoords_8_0.elementAt(241);
      expect(textureCoord_8_0_241, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_8_0_242 = textureCoords_8_0.elementAt(242);
      expect(textureCoord_8_0_242, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_8_0_243 = textureCoords_8_0.elementAt(243);
      expect(textureCoord_8_0_243, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_8_0_244 = textureCoords_8_0.elementAt(244);
      expect(textureCoord_8_0_244, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_8_0_245 = textureCoords_8_0.elementAt(245);
      expect(textureCoord_8_0_245, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_8_0_246 = textureCoords_8_0.elementAt(246);
      expect(textureCoord_8_0_246, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_8_0_247 = textureCoords_8_0.elementAt(247);
      expect(textureCoord_8_0_247, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_8_0_248 = textureCoords_8_0.elementAt(248);
      expect(textureCoord_8_0_248, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_8_0_249 = textureCoords_8_0.elementAt(249);
      expect(textureCoord_8_0_249, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_8_0_250 = textureCoords_8_0.elementAt(250);
      expect(textureCoord_8_0_250, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_8_0_251 = textureCoords_8_0.elementAt(251);
      expect(textureCoord_8_0_251, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_8_0_252 = textureCoords_8_0.elementAt(252);
      expect(textureCoord_8_0_252, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_253 = textureCoords_8_0.elementAt(253);
      expect(textureCoord_8_0_253, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_254 = textureCoords_8_0.elementAt(254);
      expect(textureCoord_8_0_254, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_255 = textureCoords_8_0.elementAt(255);
      expect(textureCoord_8_0_255, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_256 = textureCoords_8_0.elementAt(256);
      expect(textureCoord_8_0_256, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_257 = textureCoords_8_0.elementAt(257);
      expect(textureCoord_8_0_257, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_8_0_258 = textureCoords_8_0.elementAt(258);
      expect(textureCoord_8_0_258, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_8_0_259 = textureCoords_8_0.elementAt(259);
      expect(textureCoord_8_0_259, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_8_0_260 = textureCoords_8_0.elementAt(260);
      expect(textureCoord_8_0_260, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_8_0_261 = textureCoords_8_0.elementAt(261);
      expect(textureCoord_8_0_261, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_8_0_262 = textureCoords_8_0.elementAt(262);
      expect(textureCoord_8_0_262, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_8_0_263 = textureCoords_8_0.elementAt(263);
      expect(textureCoord_8_0_263, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_8_0_264 = textureCoords_8_0.elementAt(264);
      expect(textureCoord_8_0_264, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_8_0_265 = textureCoords_8_0.elementAt(265);
      expect(textureCoord_8_0_265, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_8_0_266 = textureCoords_8_0.elementAt(266);
      expect(textureCoord_8_0_266, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_8_0_267 = textureCoords_8_0.elementAt(267);
      expect(textureCoord_8_0_267, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_8_0_268 = textureCoords_8_0.elementAt(268);
      expect(textureCoord_8_0_268, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_8_0_269 = textureCoords_8_0.elementAt(269);
      expect(textureCoord_8_0_269, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_8_0_270 = textureCoords_8_0.elementAt(270);
      expect(textureCoord_8_0_270, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_8_0_271 = textureCoords_8_0.elementAt(271);
      expect(textureCoord_8_0_271, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_8_0_272 = textureCoords_8_0.elementAt(272);
      expect(textureCoord_8_0_272, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_8_0_273 = textureCoords_8_0.elementAt(273);
      expect(textureCoord_8_0_273, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_8_0_274 = textureCoords_8_0.elementAt(274);
      expect(textureCoord_8_0_274, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_8_0_275 = textureCoords_8_0.elementAt(275);
      expect(textureCoord_8_0_275, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_8_0_276 = textureCoords_8_0.elementAt(276);
      expect(textureCoord_8_0_276, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_8_0_277 = textureCoords_8_0.elementAt(277);
      expect(textureCoord_8_0_277, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_8_0_278 = textureCoords_8_0.elementAt(278);
      expect(textureCoord_8_0_278, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_8_0_279 = textureCoords_8_0.elementAt(279);
      expect(textureCoord_8_0_279, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_8_0_280 = textureCoords_8_0.elementAt(280);
      expect(textureCoord_8_0_280, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_8_0_281 = textureCoords_8_0.elementAt(281);
      expect(textureCoord_8_0_281, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_8_0_282 = textureCoords_8_0.elementAt(282);
      expect(textureCoord_8_0_282, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_8_0_283 = textureCoords_8_0.elementAt(283);
      expect(textureCoord_8_0_283, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_8_0_284 = textureCoords_8_0.elementAt(284);
      expect(textureCoord_8_0_284, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_8_0_285 = textureCoords_8_0.elementAt(285);
      expect(textureCoord_8_0_285, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_8_0_286 = textureCoords_8_0.elementAt(286);
      expect(textureCoord_8_0_286, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_8_0_287 = textureCoords_8_0.elementAt(287);
      expect(textureCoord_8_0_287, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_8_0_288 = textureCoords_8_0.elementAt(288);
      expect(textureCoord_8_0_288, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_8_0_289 = textureCoords_8_0.elementAt(289);
      expect(textureCoord_8_0_289, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_8_0_290 = textureCoords_8_0.elementAt(290);
      expect(textureCoord_8_0_290, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_8_0_291 = textureCoords_8_0.elementAt(291);
      expect(textureCoord_8_0_291, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_8_0_292 = textureCoords_8_0.elementAt(292);
      expect(textureCoord_8_0_292, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_8_0_293 = textureCoords_8_0.elementAt(293);
      expect(textureCoord_8_0_293, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      expect(mesh_8.uvComponents.length, equals(1));
      expect(mesh_8.uvComponents, equals([2]));
      expect(mesh_8.faces.length, equals(98));
      expect(mesh_8.bones.length, isZero);
      expect(mesh_8.materialIndex, equals(4));
      expect(mesh_8.name, equals('Bein4Re'));
      expect(mesh_8.animMeshes.length, isZero);
      expect(mesh_8.morphingMethod, isZero);
      expect(mesh_8.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_9 = meshes.elementAt(9);
      expect(mesh_9.primitiveTypes, equals(4));
      expect(mesh_9.vertices.length, equals(294));
      final vertex_9_0 = mesh_9.vertices.elementAt(0);
      expect(vertex_9_0, vector3MoreOrLessEquals(Vector3(-12.5385, -7.28023, -13.4915)));
      final vertex_9_1 = mesh_9.vertices.elementAt(1);
      expect(vertex_9_1, vector3MoreOrLessEquals(Vector3(-15.436, -6.07578, -12.2089)));
      final vertex_9_2 = mesh_9.vertices.elementAt(2);
      expect(vertex_9_2, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_3 = mesh_9.vertices.elementAt(3);
      expect(vertex_9_3, vector3MoreOrLessEquals(Vector3(18.5638, -38.1552, -87.3725)));
      final vertex_9_4 = mesh_9.vertices.elementAt(4);
      expect(vertex_9_4, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_5 = mesh_9.vertices.elementAt(5);
      expect(vertex_9_5, vector3MoreOrLessEquals(Vector3(18.4165, -37.6075, -87.6633)));
      final vertex_9_6 = mesh_9.vertices.elementAt(6);
      expect(vertex_9_6, vector3MoreOrLessEquals(Vector3(-12.5385, -7.28023, -13.4915)));
      final vertex_9_7 = mesh_9.vertices.elementAt(7);
      expect(vertex_9_7, vector3MoreOrLessEquals(Vector3(-4.21098, 5.5176, -30.4103)));
      final vertex_9_8 = mesh_9.vertices.elementAt(8);
      expect(vertex_9_8, vector3MoreOrLessEquals(Vector3(-6.24084, 6.09364, -29.4602)));
      final vertex_9_9 = mesh_9.vertices.elementAt(9);
      expect(vertex_9_9, vector3MoreOrLessEquals(Vector3(-12.5385, -7.28023, -13.4915)));
      final vertex_9_10 = mesh_9.vertices.elementAt(10);
      expect(vertex_9_10, vector3MoreOrLessEquals(Vector3(-6.24084, 6.09364, -29.4602)));
      final vertex_9_11 = mesh_9.vertices.elementAt(11);
      expect(vertex_9_11, vector3MoreOrLessEquals(Vector3(-15.436, -6.07578, -12.2089)));
      final vertex_9_12 = mesh_9.vertices.elementAt(12);
      expect(vertex_9_12, vector3MoreOrLessEquals(Vector3(-4.21098, 5.5176, -30.4103)));
      final vertex_9_13 = mesh_9.vertices.elementAt(13);
      expect(vertex_9_13, vector3MoreOrLessEquals(Vector3(0.412342, 26.1369, -40.3411)));
      final vertex_9_14 = mesh_9.vertices.elementAt(14);
      expect(vertex_9_14, vector3MoreOrLessEquals(Vector3(-6.24084, 6.09364, -29.4602)));
      final vertex_9_15 = mesh_9.vertices.elementAt(15);
      expect(vertex_9_15, vector3MoreOrLessEquals(Vector3(0.412342, 26.1369, -40.3411)));
      final vertex_9_16 = mesh_9.vertices.elementAt(16);
      expect(vertex_9_16, vector3MoreOrLessEquals(Vector3(-0.85878, 27.2094, -40.313)));
      final vertex_9_17 = mesh_9.vertices.elementAt(17);
      expect(vertex_9_17, vector3MoreOrLessEquals(Vector3(-6.24084, 6.09364, -29.4602)));
      final vertex_9_18 = mesh_9.vertices.elementAt(18);
      expect(vertex_9_18, vector3MoreOrLessEquals(Vector3(0.412342, 26.1369, -40.3411)));
      final vertex_9_19 = mesh_9.vertices.elementAt(19);
      expect(vertex_9_19, vector3MoreOrLessEquals(Vector3(2.94912, 26.6477, -43.0465)));
      final vertex_9_20 = mesh_9.vertices.elementAt(20);
      expect(vertex_9_20, vector3MoreOrLessEquals(Vector3(1.9001, 28.024, -44.5828)));
      final vertex_9_21 = mesh_9.vertices.elementAt(21);
      expect(vertex_9_21, vector3MoreOrLessEquals(Vector3(0.412342, 26.1369, -40.3411)));
      final vertex_9_22 = mesh_9.vertices.elementAt(22);
      expect(vertex_9_22, vector3MoreOrLessEquals(Vector3(1.9001, 28.024, -44.5828)));
      final vertex_9_23 = mesh_9.vertices.elementAt(23);
      expect(vertex_9_23, vector3MoreOrLessEquals(Vector3(-0.85878, 27.2094, -40.313)));
      final vertex_9_24 = mesh_9.vertices.elementAt(24);
      expect(vertex_9_24, vector3MoreOrLessEquals(Vector3(2.94912, 26.6477, -43.0465)));
      final vertex_9_25 = mesh_9.vertices.elementAt(25);
      expect(vertex_9_25, vector3MoreOrLessEquals(Vector3(13.5269, 5.64247, -66.9523)));
      final vertex_9_26 = mesh_9.vertices.elementAt(26);
      expect(vertex_9_26, vector3MoreOrLessEquals(Vector3(1.9001, 28.024, -44.5828)));
      final vertex_9_27 = mesh_9.vertices.elementAt(27);
      expect(vertex_9_27, vector3MoreOrLessEquals(Vector3(13.5269, 5.64247, -66.9523)));
      final vertex_9_28 = mesh_9.vertices.elementAt(28);
      expect(vertex_9_28, vector3MoreOrLessEquals(Vector3(13.2269, 6.22359, -69.172)));
      final vertex_9_29 = mesh_9.vertices.elementAt(29);
      expect(vertex_9_29, vector3MoreOrLessEquals(Vector3(1.9001, 28.024, -44.5828)));
      final vertex_9_30 = mesh_9.vertices.elementAt(30);
      expect(vertex_9_30, vector3MoreOrLessEquals(Vector3(13.5269, 5.64247, -66.9523)));
      final vertex_9_31 = mesh_9.vertices.elementAt(31);
      expect(vertex_9_31, vector3MoreOrLessEquals(Vector3(17.8673, -29.6602, -80.5987)));
      final vertex_9_32 = mesh_9.vertices.elementAt(32);
      expect(vertex_9_32, vector3MoreOrLessEquals(Vector3(17.6427, -28.0781, -81.6067)));
      final vertex_9_33 = mesh_9.vertices.elementAt(33);
      expect(vertex_9_33, vector3MoreOrLessEquals(Vector3(13.5269, 5.64247, -66.9523)));
      final vertex_9_34 = mesh_9.vertices.elementAt(34);
      expect(vertex_9_34, vector3MoreOrLessEquals(Vector3(17.6427, -28.0781, -81.6067)));
      final vertex_9_35 = mesh_9.vertices.elementAt(35);
      expect(vertex_9_35, vector3MoreOrLessEquals(Vector3(13.2269, 6.22359, -69.172)));
      final vertex_9_36 = mesh_9.vertices.elementAt(36);
      expect(vertex_9_36, vector3MoreOrLessEquals(Vector3(17.8673, -29.6602, -80.5987)));
      final vertex_9_37 = mesh_9.vertices.elementAt(37);
      expect(vertex_9_37, vector3MoreOrLessEquals(Vector3(18.5638, -38.1552, -87.3725)));
      final vertex_9_38 = mesh_9.vertices.elementAt(38);
      expect(vertex_9_38, vector3MoreOrLessEquals(Vector3(17.6427, -28.0781, -81.6067)));
      final vertex_9_39 = mesh_9.vertices.elementAt(39);
      expect(vertex_9_39, vector3MoreOrLessEquals(Vector3(18.5638, -38.1552, -87.3725)));
      final vertex_9_40 = mesh_9.vertices.elementAt(40);
      expect(vertex_9_40, vector3MoreOrLessEquals(Vector3(18.4165, -37.6075, -87.6633)));
      final vertex_9_41 = mesh_9.vertices.elementAt(41);
      expect(vertex_9_41, vector3MoreOrLessEquals(Vector3(17.6427, -28.0781, -81.6067)));
      final vertex_9_42 = mesh_9.vertices.elementAt(42);
      expect(vertex_9_42, vector3MoreOrLessEquals(Vector3(-15.436, -6.07578, -12.2089)));
      final vertex_9_43 = mesh_9.vertices.elementAt(43);
      expect(vertex_9_43, vector3MoreOrLessEquals(Vector3(-18.4493, -5.53336, -13.8049)));
      final vertex_9_44 = mesh_9.vertices.elementAt(44);
      expect(vertex_9_44, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_45 = mesh_9.vertices.elementAt(45);
      expect(vertex_9_45, vector3MoreOrLessEquals(Vector3(18.4165, -37.6075, -87.6633)));
      final vertex_9_46 = mesh_9.vertices.elementAt(46);
      expect(vertex_9_46, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_47 = mesh_9.vertices.elementAt(47);
      expect(vertex_9_47, vector3MoreOrLessEquals(Vector3(17.9669, -37.4672, -87.8233)));
      final vertex_9_48 = mesh_9.vertices.elementAt(48);
      expect(vertex_9_48, vector3MoreOrLessEquals(Vector3(-15.436, -6.07578, -12.2089)));
      final vertex_9_49 = mesh_9.vertices.elementAt(49);
      expect(vertex_9_49, vector3MoreOrLessEquals(Vector3(-6.24084, 6.09364, -29.4602)));
      final vertex_9_50 = mesh_9.vertices.elementAt(50);
      expect(vertex_9_50, vector3MoreOrLessEquals(Vector3(-18.4493, -5.53336, -13.8049)));
      final vertex_9_51 = mesh_9.vertices.elementAt(51);
      expect(vertex_9_51, vector3MoreOrLessEquals(Vector3(-6.24084, 6.09364, -29.4602)));
      final vertex_9_52 = mesh_9.vertices.elementAt(52);
      expect(vertex_9_52, vector3MoreOrLessEquals(Vector3(-8.37001, 5.46706, -30.1151)));
      final vertex_9_53 = mesh_9.vertices.elementAt(53);
      expect(vertex_9_53, vector3MoreOrLessEquals(Vector3(-18.4493, -5.53336, -13.8049)));
      final vertex_9_54 = mesh_9.vertices.elementAt(54);
      expect(vertex_9_54, vector3MoreOrLessEquals(Vector3(-6.24084, 6.09364, -29.4602)));
      final vertex_9_55 = mesh_9.vertices.elementAt(55);
      expect(vertex_9_55, vector3MoreOrLessEquals(Vector3(-0.85878, 27.2094, -40.313)));
      final vertex_9_56 = mesh_9.vertices.elementAt(56);
      expect(vertex_9_56, vector3MoreOrLessEquals(Vector3(-2.15747, 27.0092, -40.8442)));
      final vertex_9_57 = mesh_9.vertices.elementAt(57);
      expect(vertex_9_57, vector3MoreOrLessEquals(Vector3(-6.24084, 6.09364, -29.4602)));
      final vertex_9_58 = mesh_9.vertices.elementAt(58);
      expect(vertex_9_58, vector3MoreOrLessEquals(Vector3(-2.15747, 27.0092, -40.8442)));
      final vertex_9_59 = mesh_9.vertices.elementAt(59);
      expect(vertex_9_59, vector3MoreOrLessEquals(Vector3(-8.37001, 5.46706, -30.1151)));
      final vertex_9_60 = mesh_9.vertices.elementAt(60);
      expect(vertex_9_60, vector3MoreOrLessEquals(Vector3(-0.85878, 27.2094, -40.313)));
      final vertex_9_61 = mesh_9.vertices.elementAt(61);
      expect(vertex_9_61, vector3MoreOrLessEquals(Vector3(1.9001, 28.024, -44.5828)));
      final vertex_9_62 = mesh_9.vertices.elementAt(62);
      expect(vertex_9_62, vector3MoreOrLessEquals(Vector3(-2.15747, 27.0092, -40.8442)));
      final vertex_9_63 = mesh_9.vertices.elementAt(63);
      expect(vertex_9_63, vector3MoreOrLessEquals(Vector3(1.9001, 28.024, -44.5828)));
      final vertex_9_64 = mesh_9.vertices.elementAt(64);
      expect(vertex_9_64, vector3MoreOrLessEquals(Vector3(0.013222, 27.5951, -45.8518)));
      final vertex_9_65 = mesh_9.vertices.elementAt(65);
      expect(vertex_9_65, vector3MoreOrLessEquals(Vector3(-2.15747, 27.0092, -40.8442)));
      final vertex_9_66 = mesh_9.vertices.elementAt(66);
      expect(vertex_9_66, vector3MoreOrLessEquals(Vector3(1.9001, 28.024, -44.5828)));
      final vertex_9_67 = mesh_9.vertices.elementAt(67);
      expect(vertex_9_67, vector3MoreOrLessEquals(Vector3(13.2269, 6.22359, -69.172)));
      final vertex_9_68 = mesh_9.vertices.elementAt(68);
      expect(vertex_9_68, vector3MoreOrLessEquals(Vector3(11.525, 5.59827, -70.6098)));
      final vertex_9_69 = mesh_9.vertices.elementAt(69);
      expect(vertex_9_69, vector3MoreOrLessEquals(Vector3(1.9001, 28.024, -44.5828)));
      final vertex_9_70 = mesh_9.vertices.elementAt(70);
      expect(vertex_9_70, vector3MoreOrLessEquals(Vector3(11.525, 5.59827, -70.6098)));
      final vertex_9_71 = mesh_9.vertices.elementAt(71);
      expect(vertex_9_71, vector3MoreOrLessEquals(Vector3(0.013222, 27.5951, -45.8518)));
      final vertex_9_72 = mesh_9.vertices.elementAt(72);
      expect(vertex_9_72, vector3MoreOrLessEquals(Vector3(13.2269, 6.22359, -69.172)));
      final vertex_9_73 = mesh_9.vertices.elementAt(73);
      expect(vertex_9_73, vector3MoreOrLessEquals(Vector3(17.6427, -28.0781, -81.6067)));
      final vertex_9_74 = mesh_9.vertices.elementAt(74);
      expect(vertex_9_74, vector3MoreOrLessEquals(Vector3(11.525, 5.59827, -70.6098)));
      final vertex_9_75 = mesh_9.vertices.elementAt(75);
      expect(vertex_9_75, vector3MoreOrLessEquals(Vector3(17.6427, -28.0781, -81.6067)));
      final vertex_9_76 = mesh_9.vertices.elementAt(76);
      expect(vertex_9_76, vector3MoreOrLessEquals(Vector3(16.7089, -27.6766, -82.0432)));
      final vertex_9_77 = mesh_9.vertices.elementAt(77);
      expect(vertex_9_77, vector3MoreOrLessEquals(Vector3(11.525, 5.59827, -70.6098)));
      final vertex_9_78 = mesh_9.vertices.elementAt(78);
      expect(vertex_9_78, vector3MoreOrLessEquals(Vector3(17.6427, -28.0781, -81.6067)));
      final vertex_9_79 = mesh_9.vertices.elementAt(79);
      expect(vertex_9_79, vector3MoreOrLessEquals(Vector3(18.4165, -37.6075, -87.6633)));
      final vertex_9_80 = mesh_9.vertices.elementAt(80);
      expect(vertex_9_80, vector3MoreOrLessEquals(Vector3(17.9669, -37.4672, -87.8233)));
      final vertex_9_81 = mesh_9.vertices.elementAt(81);
      expect(vertex_9_81, vector3MoreOrLessEquals(Vector3(17.6427, -28.0781, -81.6067)));
      final vertex_9_82 = mesh_9.vertices.elementAt(82);
      expect(vertex_9_82, vector3MoreOrLessEquals(Vector3(17.9669, -37.4672, -87.8233)));
      final vertex_9_83 = mesh_9.vertices.elementAt(83);
      expect(vertex_9_83, vector3MoreOrLessEquals(Vector3(16.7089, -27.6766, -82.0432)));
      final vertex_9_84 = mesh_9.vertices.elementAt(84);
      expect(vertex_9_84, vector3MoreOrLessEquals(Vector3(-18.4493, -5.53336, -13.8049)));
      final vertex_9_85 = mesh_9.vertices.elementAt(85);
      expect(vertex_9_85, vector3MoreOrLessEquals(Vector3(-19.3093, -6.06143, -17.0778)));
      final vertex_9_86 = mesh_9.vertices.elementAt(86);
      expect(vertex_9_86, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_87 = mesh_9.vertices.elementAt(87);
      expect(vertex_9_87, vector3MoreOrLessEquals(Vector3(17.9669, -37.4672, -87.8233)));
      final vertex_9_88 = mesh_9.vertices.elementAt(88);
      expect(vertex_9_88, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_89 = mesh_9.vertices.elementAt(89);
      expect(vertex_9_89, vector3MoreOrLessEquals(Vector3(17.5535, -37.8399, -87.7321)));
      final vertex_9_90 = mesh_9.vertices.elementAt(90);
      expect(vertex_9_90, vector3MoreOrLessEquals(Vector3(-18.4493, -5.53336, -13.8049)));
      final vertex_9_91 = mesh_9.vertices.elementAt(91);
      expect(vertex_9_91, vector3MoreOrLessEquals(Vector3(-8.37001, 5.46706, -30.1151)));
      final vertex_9_92 = mesh_9.vertices.elementAt(92);
      expect(vertex_9_92, vector3MoreOrLessEquals(Vector3(-8.99515, 4.10971, -31.8819)));
      final vertex_9_93 = mesh_9.vertices.elementAt(93);
      expect(vertex_9_93, vector3MoreOrLessEquals(Vector3(-18.4493, -5.53336, -13.8049)));
      final vertex_9_94 = mesh_9.vertices.elementAt(94);
      expect(vertex_9_94, vector3MoreOrLessEquals(Vector3(-8.99515, 4.10971, -31.8819)));
      final vertex_9_95 = mesh_9.vertices.elementAt(95);
      expect(vertex_9_95, vector3MoreOrLessEquals(Vector3(-19.3093, -6.06143, -17.0778)));
      final vertex_9_96 = mesh_9.vertices.elementAt(96);
      expect(vertex_9_96, vector3MoreOrLessEquals(Vector3(-8.37001, 5.46706, -30.1151)));
      final vertex_9_97 = mesh_9.vertices.elementAt(97);
      expect(vertex_9_97, vector3MoreOrLessEquals(Vector3(-2.15747, 27.0092, -40.8442)));
      final vertex_9_98 = mesh_9.vertices.elementAt(98);
      expect(vertex_9_98, vector3MoreOrLessEquals(Vector3(-8.99515, 4.10971, -31.8819)));
      final vertex_9_99 = mesh_9.vertices.elementAt(99);
      expect(vertex_9_99, vector3MoreOrLessEquals(Vector3(-2.15747, 27.0092, -40.8442)));
      final vertex_9_100 = mesh_9.vertices.elementAt(100);
      expect(vertex_9_100, vector3MoreOrLessEquals(Vector3(-2.50577, 25.687, -41.5347)));
      final vertex_9_101 = mesh_9.vertices.elementAt(101);
      expect(vertex_9_101, vector3MoreOrLessEquals(Vector3(-8.99515, 4.10971, -31.8819)));
      final vertex_9_102 = mesh_9.vertices.elementAt(102);
      expect(vertex_9_102, vector3MoreOrLessEquals(Vector3(-2.15747, 27.0092, -40.8442)));
      final vertex_9_103 = mesh_9.vertices.elementAt(103);
      expect(vertex_9_103, vector3MoreOrLessEquals(Vector3(0.013222, 27.5951, -45.8518)));
      final vertex_9_104 = mesh_9.vertices.elementAt(104);
      expect(vertex_9_104, vector3MoreOrLessEquals(Vector3(-1.2907, 25.6839, -45.898)));
      final vertex_9_105 = mesh_9.vertices.elementAt(105);
      expect(vertex_9_105, vector3MoreOrLessEquals(Vector3(-2.15747, 27.0092, -40.8442)));
      final vertex_9_106 = mesh_9.vertices.elementAt(106);
      expect(vertex_9_106, vector3MoreOrLessEquals(Vector3(-1.2907, 25.6839, -45.898)));
      final vertex_9_107 = mesh_9.vertices.elementAt(107);
      expect(vertex_9_107, vector3MoreOrLessEquals(Vector3(-2.50577, 25.687, -41.5347)));
      final vertex_9_108 = mesh_9.vertices.elementAt(108);
      expect(vertex_9_108, vector3MoreOrLessEquals(Vector3(0.013222, 27.5951, -45.8518)));
      final vertex_9_109 = mesh_9.vertices.elementAt(109);
      expect(vertex_9_109, vector3MoreOrLessEquals(Vector3(11.525, 5.59827, -70.6098)));
      final vertex_9_110 = mesh_9.vertices.elementAt(110);
      expect(vertex_9_110, vector3MoreOrLessEquals(Vector3(-1.2907, 25.6839, -45.898)));
      final vertex_9_111 = mesh_9.vertices.elementAt(111);
      expect(vertex_9_111, vector3MoreOrLessEquals(Vector3(11.525, 5.59827, -70.6098)));
      final vertex_9_112 = mesh_9.vertices.elementAt(112);
      expect(vertex_9_112, vector3MoreOrLessEquals(Vector3(9.70273, 4.23739, -70.183)));
      final vertex_9_113 = mesh_9.vertices.elementAt(113);
      expect(vertex_9_113, vector3MoreOrLessEquals(Vector3(-1.2907, 25.6839, -45.898)));
      final vertex_9_114 = mesh_9.vertices.elementAt(114);
      expect(vertex_9_114, vector3MoreOrLessEquals(Vector3(11.525, 5.59827, -70.6098)));
      final vertex_9_115 = mesh_9.vertices.elementAt(115);
      expect(vertex_9_115, vector3MoreOrLessEquals(Vector3(16.7089, -27.6766, -82.0432)));
      final vertex_9_116 = mesh_9.vertices.elementAt(116);
      expect(vertex_9_116, vector3MoreOrLessEquals(Vector3(15.7692, -28.758, -81.5795)));
      final vertex_9_117 = mesh_9.vertices.elementAt(117);
      expect(vertex_9_117, vector3MoreOrLessEquals(Vector3(11.525, 5.59827, -70.6098)));
      final vertex_9_118 = mesh_9.vertices.elementAt(118);
      expect(vertex_9_118, vector3MoreOrLessEquals(Vector3(15.7692, -28.758, -81.5795)));
      final vertex_9_119 = mesh_9.vertices.elementAt(119);
      expect(vertex_9_119, vector3MoreOrLessEquals(Vector3(9.70273, 4.23739, -70.183)));
      final vertex_9_120 = mesh_9.vertices.elementAt(120);
      expect(vertex_9_120, vector3MoreOrLessEquals(Vector3(16.7089, -27.6766, -82.0432)));
      final vertex_9_121 = mesh_9.vertices.elementAt(121);
      expect(vertex_9_121, vector3MoreOrLessEquals(Vector3(17.9669, -37.4672, -87.8233)));
      final vertex_9_122 = mesh_9.vertices.elementAt(122);
      expect(vertex_9_122, vector3MoreOrLessEquals(Vector3(15.7692, -28.758, -81.5795)));
      final vertex_9_123 = mesh_9.vertices.elementAt(123);
      expect(vertex_9_123, vector3MoreOrLessEquals(Vector3(17.9669, -37.4672, -87.8233)));
      final vertex_9_124 = mesh_9.vertices.elementAt(124);
      expect(vertex_9_124, vector3MoreOrLessEquals(Vector3(17.5535, -37.8399, -87.7321)));
      final vertex_9_125 = mesh_9.vertices.elementAt(125);
      expect(vertex_9_125, vector3MoreOrLessEquals(Vector3(15.7692, -28.758, -81.5795)));
      final vertex_9_126 = mesh_9.vertices.elementAt(126);
      expect(vertex_9_126, vector3MoreOrLessEquals(Vector3(-19.3093, -6.06143, -17.0778)));
      final vertex_9_127 = mesh_9.vertices.elementAt(127);
      expect(vertex_9_127, vector3MoreOrLessEquals(Vector3(-17.3685, -7.26234, -19.5628)));
      final vertex_9_128 = mesh_9.vertices.elementAt(128);
      expect(vertex_9_128, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_129 = mesh_9.vertices.elementAt(129);
      expect(vertex_9_129, vector3MoreOrLessEquals(Vector3(17.5535, -37.8399, -87.7321)));
      final vertex_9_130 = mesh_9.vertices.elementAt(130);
      expect(vertex_9_130, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_131 = mesh_9.vertices.elementAt(131);
      expect(vertex_9_131, vector3MoreOrLessEquals(Vector3(17.4877, -38.4449, -87.4584)));
      final vertex_9_132 = mesh_9.vertices.elementAt(132);
      expect(vertex_9_132, vector3MoreOrLessEquals(Vector3(-19.3093, -6.06143, -17.0778)));
      final vertex_9_133 = mesh_9.vertices.elementAt(133);
      expect(vertex_9_133, vector3MoreOrLessEquals(Vector3(-8.99515, 4.10971, -31.8819)));
      final vertex_9_134 = mesh_9.vertices.elementAt(134);
      expect(vertex_9_134, vector3MoreOrLessEquals(Vector3(-17.3685, -7.26234, -19.5628)));
      final vertex_9_135 = mesh_9.vertices.elementAt(135);
      expect(vertex_9_135, vector3MoreOrLessEquals(Vector3(-8.99515, 4.10971, -31.8819)));
      final vertex_9_136 = mesh_9.vertices.elementAt(136);
      expect(vertex_9_136, vector3MoreOrLessEquals(Vector3(-7.64558, 3.04369, -33.4301)));
      final vertex_9_137 = mesh_9.vertices.elementAt(137);
      expect(vertex_9_137, vector3MoreOrLessEquals(Vector3(-17.3685, -7.26234, -19.5628)));
      final vertex_9_138 = mesh_9.vertices.elementAt(138);
      expect(vertex_9_138, vector3MoreOrLessEquals(Vector3(-8.99515, 4.10971, -31.8819)));
      final vertex_9_139 = mesh_9.vertices.elementAt(139);
      expect(vertex_9_139, vector3MoreOrLessEquals(Vector3(-2.50577, 25.687, -41.5347)));
      final vertex_9_140 = mesh_9.vertices.elementAt(140);
      expect(vertex_9_140, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_141 = mesh_9.vertices.elementAt(141);
      expect(vertex_9_141, vector3MoreOrLessEquals(Vector3(-8.99515, 4.10971, -31.8819)));
      final vertex_9_142 = mesh_9.vertices.elementAt(142);
      expect(vertex_9_142, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_143 = mesh_9.vertices.elementAt(143);
      expect(vertex_9_143, vector3MoreOrLessEquals(Vector3(-7.64558, 3.04369, -33.4301)));
      final vertex_9_144 = mesh_9.vertices.elementAt(144);
      expect(vertex_9_144, vector3MoreOrLessEquals(Vector3(-2.50577, 25.687, -41.5347)));
      final vertex_9_145 = mesh_9.vertices.elementAt(145);
      expect(vertex_9_145, vector3MoreOrLessEquals(Vector3(-1.2907, 25.6839, -45.898)));
      final vertex_9_146 = mesh_9.vertices.elementAt(146);
      expect(vertex_9_146, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_147 = mesh_9.vertices.elementAt(147);
      expect(vertex_9_147, vector3MoreOrLessEquals(Vector3(-1.2907, 25.6839, -45.898)));
      final vertex_9_148 = mesh_9.vertices.elementAt(148);
      expect(vertex_9_148, vector3MoreOrLessEquals(Vector3(-1.02977, 23.7297, -44.6865)));
      final vertex_9_149 = mesh_9.vertices.elementAt(149);
      expect(vertex_9_149, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_150 = mesh_9.vertices.elementAt(150);
      expect(vertex_9_150, vector3MoreOrLessEquals(Vector3(-1.2907, 25.6839, -45.898)));
      final vertex_9_151 = mesh_9.vertices.elementAt(151);
      expect(vertex_9_151, vector3MoreOrLessEquals(Vector3(9.70273, 4.23739, -70.183)));
      final vertex_9_152 = mesh_9.vertices.elementAt(152);
      expect(vertex_9_152, vector3MoreOrLessEquals(Vector3(9.13232, 3.16569, -68.2131)));
      final vertex_9_153 = mesh_9.vertices.elementAt(153);
      expect(vertex_9_153, vector3MoreOrLessEquals(Vector3(-1.2907, 25.6839, -45.898)));
      final vertex_9_154 = mesh_9.vertices.elementAt(154);
      expect(vertex_9_154, vector3MoreOrLessEquals(Vector3(9.13232, 3.16569, -68.2131)));
      final vertex_9_155 = mesh_9.vertices.elementAt(155);
      expect(vertex_9_155, vector3MoreOrLessEquals(Vector3(-1.02977, 23.7297, -44.6865)));
      final vertex_9_156 = mesh_9.vertices.elementAt(156);
      expect(vertex_9_156, vector3MoreOrLessEquals(Vector3(9.70273, 4.23739, -70.183)));
      final vertex_9_157 = mesh_9.vertices.elementAt(157);
      expect(vertex_9_157, vector3MoreOrLessEquals(Vector3(15.7692, -28.758, -81.5795)));
      final vertex_9_158 = mesh_9.vertices.elementAt(158);
      expect(vertex_9_158, vector3MoreOrLessEquals(Vector3(9.13232, 3.16569, -68.2131)));
      final vertex_9_159 = mesh_9.vertices.elementAt(159);
      expect(vertex_9_159, vector3MoreOrLessEquals(Vector3(15.7692, -28.758, -81.5795)));
      final vertex_9_160 = mesh_9.vertices.elementAt(160);
      expect(vertex_9_160, vector3MoreOrLessEquals(Vector3(15.5311, -30.508, -80.5649)));
      final vertex_9_161 = mesh_9.vertices.elementAt(161);
      expect(vertex_9_161, vector3MoreOrLessEquals(Vector3(9.13232, 3.16569, -68.2131)));
      final vertex_9_162 = mesh_9.vertices.elementAt(162);
      expect(vertex_9_162, vector3MoreOrLessEquals(Vector3(15.7692, -28.758, -81.5795)));
      final vertex_9_163 = mesh_9.vertices.elementAt(163);
      expect(vertex_9_163, vector3MoreOrLessEquals(Vector3(17.5535, -37.8399, -87.7321)));
      final vertex_9_164 = mesh_9.vertices.elementAt(164);
      expect(vertex_9_164, vector3MoreOrLessEquals(Vector3(17.4877, -38.4449, -87.4584)));
      final vertex_9_165 = mesh_9.vertices.elementAt(165);
      expect(vertex_9_165, vector3MoreOrLessEquals(Vector3(15.7692, -28.758, -81.5795)));
      final vertex_9_166 = mesh_9.vertices.elementAt(166);
      expect(vertex_9_166, vector3MoreOrLessEquals(Vector3(17.4877, -38.4449, -87.4584)));
      final vertex_9_167 = mesh_9.vertices.elementAt(167);
      expect(vertex_9_167, vector3MoreOrLessEquals(Vector3(15.5311, -30.508, -80.5649)));
      final vertex_9_168 = mesh_9.vertices.elementAt(168);
      expect(vertex_9_168, vector3MoreOrLessEquals(Vector3(-17.3685, -7.26234, -19.5628)));
      final vertex_9_169 = mesh_9.vertices.elementAt(169);
      expect(vertex_9_169, vector3MoreOrLessEquals(Vector3(-14.0883, -8.2318, -19.3888)));
      final vertex_9_170 = mesh_9.vertices.elementAt(170);
      expect(vertex_9_170, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_171 = mesh_9.vertices.elementAt(171);
      expect(vertex_9_171, vector3MoreOrLessEquals(Vector3(17.4877, -38.4449, -87.4584)));
      final vertex_9_172 = mesh_9.vertices.elementAt(172);
      expect(vertex_9_172, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_173 = mesh_9.vertices.elementAt(173);
      expect(vertex_9_173, vector3MoreOrLessEquals(Vector3(17.8189, -38.8267, -87.2082)));
      final vertex_9_174 = mesh_9.vertices.elementAt(174);
      expect(vertex_9_174, vector3MoreOrLessEquals(Vector3(-17.3685, -7.26234, -19.5628)));
      final vertex_9_175 = mesh_9.vertices.elementAt(175);
      expect(vertex_9_175, vector3MoreOrLessEquals(Vector3(-7.64558, 3.04369, -33.4301)));
      final vertex_9_176 = mesh_9.vertices.elementAt(176);
      expect(vertex_9_176, vector3MoreOrLessEquals(Vector3(-5.33749, 3.07172, -33.5939)));
      final vertex_9_177 = mesh_9.vertices.elementAt(177);
      expect(vertex_9_177, vector3MoreOrLessEquals(Vector3(-17.3685, -7.26234, -19.5628)));
      final vertex_9_178 = mesh_9.vertices.elementAt(178);
      expect(vertex_9_178, vector3MoreOrLessEquals(Vector3(-5.33749, 3.07172, -33.5939)));
      final vertex_9_179 = mesh_9.vertices.elementAt(179);
      expect(vertex_9_179, vector3MoreOrLessEquals(Vector3(-14.0883, -8.2318, -19.3888)));
      final vertex_9_180 = mesh_9.vertices.elementAt(180);
      expect(vertex_9_180, vector3MoreOrLessEquals(Vector3(-7.64558, 3.04369, -33.4301)));
      final vertex_9_181 = mesh_9.vertices.elementAt(181);
      expect(vertex_9_181, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_182 = mesh_9.vertices.elementAt(182);
      expect(vertex_9_182, vector3MoreOrLessEquals(Vector3(-5.33749, 3.07172, -33.5939)));
      final vertex_9_183 = mesh_9.vertices.elementAt(183);
      expect(vertex_9_183, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_184 = mesh_9.vertices.elementAt(184);
      expect(vertex_9_184, vector3MoreOrLessEquals(Vector3(-0.215265, 23.7546, -41.5854)));
      final vertex_9_185 = mesh_9.vertices.elementAt(185);
      expect(vertex_9_185, vector3MoreOrLessEquals(Vector3(-5.33749, 3.07172, -33.5939)));
      final vertex_9_186 = mesh_9.vertices.elementAt(186);
      expect(vertex_9_186, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_187 = mesh_9.vertices.elementAt(187);
      expect(vertex_9_187, vector3MoreOrLessEquals(Vector3(-1.02977, 23.7297, -44.6865)));
      final vertex_9_188 = mesh_9.vertices.elementAt(188);
      expect(vertex_9_188, vector3MoreOrLessEquals(Vector3(0.599522, 23.2039, -43.1296)));
      final vertex_9_189 = mesh_9.vertices.elementAt(189);
      expect(vertex_9_189, vector3MoreOrLessEquals(Vector3(-1.6414, 24.2386, -41.8646)));
      final vertex_9_190 = mesh_9.vertices.elementAt(190);
      expect(vertex_9_190, vector3MoreOrLessEquals(Vector3(0.599522, 23.2039, -43.1296)));
      final vertex_9_191 = mesh_9.vertices.elementAt(191);
      expect(vertex_9_191, vector3MoreOrLessEquals(Vector3(-0.215265, 23.7546, -41.5854)));
      final vertex_9_192 = mesh_9.vertices.elementAt(192);
      expect(vertex_9_192, vector3MoreOrLessEquals(Vector3(-1.02977, 23.7297, -44.6865)));
      final vertex_9_193 = mesh_9.vertices.elementAt(193);
      expect(vertex_9_193, vector3MoreOrLessEquals(Vector3(9.13232, 3.16569, -68.2131)));
      final vertex_9_194 = mesh_9.vertices.elementAt(194);
      expect(vertex_9_194, vector3MoreOrLessEquals(Vector3(0.599522, 23.2039, -43.1296)));
      final vertex_9_195 = mesh_9.vertices.elementAt(195);
      expect(vertex_9_195, vector3MoreOrLessEquals(Vector3(9.13232, 3.16569, -68.2131)));
      final vertex_9_196 = mesh_9.vertices.elementAt(196);
      expect(vertex_9_196, vector3MoreOrLessEquals(Vector3(10.2433, 3.19019, -66.1832)));
      final vertex_9_197 = mesh_9.vertices.elementAt(197);
      expect(vertex_9_197, vector3MoreOrLessEquals(Vector3(0.599522, 23.2039, -43.1296)));
      final vertex_9_198 = mesh_9.vertices.elementAt(198);
      expect(vertex_9_198, vector3MoreOrLessEquals(Vector3(9.13232, 3.16569, -68.2131)));
      final vertex_9_199 = mesh_9.vertices.elementAt(199);
      expect(vertex_9_199, vector3MoreOrLessEquals(Vector3(15.5311, -30.508, -80.5649)));
      final vertex_9_200 = mesh_9.vertices.elementAt(200);
      expect(vertex_9_200, vector3MoreOrLessEquals(Vector3(16.1739, -31.6087, -79.7632)));
      final vertex_9_201 = mesh_9.vertices.elementAt(201);
      expect(vertex_9_201, vector3MoreOrLessEquals(Vector3(9.13232, 3.16569, -68.2131)));
      final vertex_9_202 = mesh_9.vertices.elementAt(202);
      expect(vertex_9_202, vector3MoreOrLessEquals(Vector3(16.1739, -31.6087, -79.7632)));
      final vertex_9_203 = mesh_9.vertices.elementAt(203);
      expect(vertex_9_203, vector3MoreOrLessEquals(Vector3(10.2433, 3.19019, -66.1832)));
      final vertex_9_204 = mesh_9.vertices.elementAt(204);
      expect(vertex_9_204, vector3MoreOrLessEquals(Vector3(15.5311, -30.508, -80.5649)));
      final vertex_9_205 = mesh_9.vertices.elementAt(205);
      expect(vertex_9_205, vector3MoreOrLessEquals(Vector3(17.4877, -38.4449, -87.4584)));
      final vertex_9_206 = mesh_9.vertices.elementAt(206);
      expect(vertex_9_206, vector3MoreOrLessEquals(Vector3(16.1739, -31.6087, -79.7632)));
      final vertex_9_207 = mesh_9.vertices.elementAt(207);
      expect(vertex_9_207, vector3MoreOrLessEquals(Vector3(17.4877, -38.4449, -87.4584)));
      final vertex_9_208 = mesh_9.vertices.elementAt(208);
      expect(vertex_9_208, vector3MoreOrLessEquals(Vector3(17.8189, -38.8267, -87.2082)));
      final vertex_9_209 = mesh_9.vertices.elementAt(209);
      expect(vertex_9_209, vector3MoreOrLessEquals(Vector3(16.1739, -31.6087, -79.7632)));
      final vertex_9_210 = mesh_9.vertices.elementAt(210);
      expect(vertex_9_210, vector3MoreOrLessEquals(Vector3(-14.0883, -8.2318, -19.3888)));
      final vertex_9_211 = mesh_9.vertices.elementAt(211);
      expect(vertex_9_211, vector3MoreOrLessEquals(Vector3(-11.9388, -8.23976, -16.6868)));
      final vertex_9_212 = mesh_9.vertices.elementAt(212);
      expect(vertex_9_212, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_213 = mesh_9.vertices.elementAt(213);
      expect(vertex_9_213, vector3MoreOrLessEquals(Vector3(17.8189, -38.8267, -87.2082)));
      final vertex_9_214 = mesh_9.vertices.elementAt(214);
      expect(vertex_9_214, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_215 = mesh_9.vertices.elementAt(215);
      expect(vertex_9_215, vector3MoreOrLessEquals(Vector3(18.2978, -38.6978, -87.17)));
      final vertex_9_216 = mesh_9.vertices.elementAt(216);
      expect(vertex_9_216, vector3MoreOrLessEquals(Vector3(-14.0883, -8.2318, -19.3888)));
      final vertex_9_217 = mesh_9.vertices.elementAt(217);
      expect(vertex_9_217, vector3MoreOrLessEquals(Vector3(-5.33749, 3.07172, -33.5939)));
      final vertex_9_218 = mesh_9.vertices.elementAt(218);
      expect(vertex_9_218, vector3MoreOrLessEquals(Vector3(-11.9388, -8.23976, -16.6868)));
      final vertex_9_219 = mesh_9.vertices.elementAt(219);
      expect(vertex_9_219, vector3MoreOrLessEquals(Vector3(-5.33749, 3.07172, -33.5939)));
      final vertex_9_220 = mesh_9.vertices.elementAt(220);
      expect(vertex_9_220, vector3MoreOrLessEquals(Vector3(-3.80895, 4.17273, -32.25)));
      final vertex_9_221 = mesh_9.vertices.elementAt(221);
      expect(vertex_9_221, vector3MoreOrLessEquals(Vector3(-11.9388, -8.23976, -16.6868)));
      final vertex_9_222 = mesh_9.vertices.elementAt(222);
      expect(vertex_9_222, vector3MoreOrLessEquals(Vector3(-5.33749, 3.07172, -33.5939)));
      final vertex_9_223 = mesh_9.vertices.elementAt(223);
      expect(vertex_9_223, vector3MoreOrLessEquals(Vector3(-0.215265, 23.7546, -41.5854)));
      final vertex_9_224 = mesh_9.vertices.elementAt(224);
      expect(vertex_9_224, vector3MoreOrLessEquals(Vector3(0.698708, 24.5994, -40.9074)));
      final vertex_9_225 = mesh_9.vertices.elementAt(225);
      expect(vertex_9_225, vector3MoreOrLessEquals(Vector3(-5.33749, 3.07172, -33.5939)));
      final vertex_9_226 = mesh_9.vertices.elementAt(226);
      expect(vertex_9_226, vector3MoreOrLessEquals(Vector3(0.698708, 24.5994, -40.9074)));
      final vertex_9_227 = mesh_9.vertices.elementAt(227);
      expect(vertex_9_227, vector3MoreOrLessEquals(Vector3(-3.80895, 4.17273, -32.25)));
      final vertex_9_228 = mesh_9.vertices.elementAt(228);
      expect(vertex_9_228, vector3MoreOrLessEquals(Vector3(-0.215265, 23.7546, -41.5854)));
      final vertex_9_229 = mesh_9.vertices.elementAt(229);
      expect(vertex_9_229, vector3MoreOrLessEquals(Vector3(0.599522, 23.2039, -43.1296)));
      final vertex_9_230 = mesh_9.vertices.elementAt(230);
      expect(vertex_9_230, vector3MoreOrLessEquals(Vector3(0.698708, 24.5994, -40.9074)));
      final vertex_9_231 = mesh_9.vertices.elementAt(231);
      expect(vertex_9_231, vector3MoreOrLessEquals(Vector3(0.599522, 23.2039, -43.1296)));
      final vertex_9_232 = mesh_9.vertices.elementAt(232);
      expect(vertex_9_232, vector3MoreOrLessEquals(Vector3(2.3703, 24.5026, -42.3997)));
      final vertex_9_233 = mesh_9.vertices.elementAt(233);
      expect(vertex_9_233, vector3MoreOrLessEquals(Vector3(0.698708, 24.5994, -40.9074)));
      final vertex_9_234 = mesh_9.vertices.elementAt(234);
      expect(vertex_9_234, vector3MoreOrLessEquals(Vector3(0.599522, 23.2039, -43.1296)));
      final vertex_9_235 = mesh_9.vertices.elementAt(235);
      expect(vertex_9_235, vector3MoreOrLessEquals(Vector3(10.2433, 3.19019, -66.1832)));
      final vertex_9_236 = mesh_9.vertices.elementAt(236);
      expect(vertex_9_236, vector3MoreOrLessEquals(Vector3(12.199, 4.29248, -65.6222)));
      final vertex_9_237 = mesh_9.vertices.elementAt(237);
      expect(vertex_9_237, vector3MoreOrLessEquals(Vector3(0.599522, 23.2039, -43.1296)));
      final vertex_9_238 = mesh_9.vertices.elementAt(238);
      expect(vertex_9_238, vector3MoreOrLessEquals(Vector3(12.199, 4.29248, -65.6222)));
      final vertex_9_239 = mesh_9.vertices.elementAt(239);
      expect(vertex_9_239, vector3MoreOrLessEquals(Vector3(2.3703, 24.5026, -42.3997)));
      final vertex_9_240 = mesh_9.vertices.elementAt(240);
      expect(vertex_9_240, vector3MoreOrLessEquals(Vector3(10.2433, 3.19019, -66.1832)));
      final vertex_9_241 = mesh_9.vertices.elementAt(241);
      expect(vertex_9_241, vector3MoreOrLessEquals(Vector3(16.1739, -31.6087, -79.7632)));
      final vertex_9_242 = mesh_9.vertices.elementAt(242);
      expect(vertex_9_242, vector3MoreOrLessEquals(Vector3(12.199, 4.29248, -65.6222)));
      final vertex_9_243 = mesh_9.vertices.elementAt(243);
      expect(vertex_9_243, vector3MoreOrLessEquals(Vector3(16.1739, -31.6087, -79.7632)));
      final vertex_9_244 = mesh_9.vertices.elementAt(244);
      expect(vertex_9_244, vector3MoreOrLessEquals(Vector3(17.2136, -31.2314, -79.7783)));
      final vertex_9_245 = mesh_9.vertices.elementAt(245);
      expect(vertex_9_245, vector3MoreOrLessEquals(Vector3(12.199, 4.29248, -65.6222)));
      final vertex_9_246 = mesh_9.vertices.elementAt(246);
      expect(vertex_9_246, vector3MoreOrLessEquals(Vector3(16.1739, -31.6087, -79.7632)));
      final vertex_9_247 = mesh_9.vertices.elementAt(247);
      expect(vertex_9_247, vector3MoreOrLessEquals(Vector3(17.8189, -38.8267, -87.2082)));
      final vertex_9_248 = mesh_9.vertices.elementAt(248);
      expect(vertex_9_248, vector3MoreOrLessEquals(Vector3(18.2978, -38.6978, -87.17)));
      final vertex_9_249 = mesh_9.vertices.elementAt(249);
      expect(vertex_9_249, vector3MoreOrLessEquals(Vector3(16.1739, -31.6087, -79.7632)));
      final vertex_9_250 = mesh_9.vertices.elementAt(250);
      expect(vertex_9_250, vector3MoreOrLessEquals(Vector3(18.2978, -38.6978, -87.17)));
      final vertex_9_251 = mesh_9.vertices.elementAt(251);
      expect(vertex_9_251, vector3MoreOrLessEquals(Vector3(17.2136, -31.2314, -79.7783)));
      final vertex_9_252 = mesh_9.vertices.elementAt(252);
      expect(vertex_9_252, vector3MoreOrLessEquals(Vector3(-11.9388, -8.23976, -16.6868)));
      final vertex_9_253 = mesh_9.vertices.elementAt(253);
      expect(vertex_9_253, vector3MoreOrLessEquals(Vector3(-12.5385, -7.28023, -13.4915)));
      final vertex_9_254 = mesh_9.vertices.elementAt(254);
      expect(vertex_9_254, vector3MoreOrLessEquals(Vector3(-15.5898, -6.95494, -16.0316)));
      final vertex_9_255 = mesh_9.vertices.elementAt(255);
      expect(vertex_9_255, vector3MoreOrLessEquals(Vector3(18.2978, -38.6978, -87.17)));
      final vertex_9_256 = mesh_9.vertices.elementAt(256);
      expect(vertex_9_256, vector3MoreOrLessEquals(Vector3(18.015, -38.1485, -87.4896)));
      final vertex_9_257 = mesh_9.vertices.elementAt(257);
      expect(vertex_9_257, vector3MoreOrLessEquals(Vector3(18.5638, -38.1552, -87.3725)));
      final vertex_9_258 = mesh_9.vertices.elementAt(258);
      expect(vertex_9_258, vector3MoreOrLessEquals(Vector3(-11.9388, -8.23976, -16.6868)));
      final vertex_9_259 = mesh_9.vertices.elementAt(259);
      expect(vertex_9_259, vector3MoreOrLessEquals(Vector3(-3.80895, 4.17273, -32.25)));
      final vertex_9_260 = mesh_9.vertices.elementAt(260);
      expect(vertex_9_260, vector3MoreOrLessEquals(Vector3(-4.21098, 5.5176, -30.4103)));
      final vertex_9_261 = mesh_9.vertices.elementAt(261);
      expect(vertex_9_261, vector3MoreOrLessEquals(Vector3(-11.9388, -8.23976, -16.6868)));
      final vertex_9_262 = mesh_9.vertices.elementAt(262);
      expect(vertex_9_262, vector3MoreOrLessEquals(Vector3(-4.21098, 5.5176, -30.4103)));
      final vertex_9_263 = mesh_9.vertices.elementAt(263);
      expect(vertex_9_263, vector3MoreOrLessEquals(Vector3(-12.5385, -7.28023, -13.4915)));
      final vertex_9_264 = mesh_9.vertices.elementAt(264);
      expect(vertex_9_264, vector3MoreOrLessEquals(Vector3(-3.80895, 4.17273, -32.25)));
      final vertex_9_265 = mesh_9.vertices.elementAt(265);
      expect(vertex_9_265, vector3MoreOrLessEquals(Vector3(0.698708, 24.5994, -40.9074)));
      final vertex_9_266 = mesh_9.vertices.elementAt(266);
      expect(vertex_9_266, vector3MoreOrLessEquals(Vector3(-4.21098, 5.5176, -30.4103)));
      final vertex_9_267 = mesh_9.vertices.elementAt(267);
      expect(vertex_9_267, vector3MoreOrLessEquals(Vector3(0.698708, 24.5994, -40.9074)));
      final vertex_9_268 = mesh_9.vertices.elementAt(268);
      expect(vertex_9_268, vector3MoreOrLessEquals(Vector3(0.412342, 26.1369, -40.3411)));
      final vertex_9_269 = mesh_9.vertices.elementAt(269);
      expect(vertex_9_269, vector3MoreOrLessEquals(Vector3(-4.21098, 5.5176, -30.4103)));
      final vertex_9_270 = mesh_9.vertices.elementAt(270);
      expect(vertex_9_270, vector3MoreOrLessEquals(Vector3(0.698708, 24.5994, -40.9074)));
      final vertex_9_271 = mesh_9.vertices.elementAt(271);
      expect(vertex_9_271, vector3MoreOrLessEquals(Vector3(2.3703, 24.5026, -42.3997)));
      final vertex_9_272 = mesh_9.vertices.elementAt(272);
      expect(vertex_9_272, vector3MoreOrLessEquals(Vector3(2.94912, 26.6477, -43.0465)));
      final vertex_9_273 = mesh_9.vertices.elementAt(273);
      expect(vertex_9_273, vector3MoreOrLessEquals(Vector3(0.698708, 24.5994, -40.9074)));
      final vertex_9_274 = mesh_9.vertices.elementAt(274);
      expect(vertex_9_274, vector3MoreOrLessEquals(Vector3(2.94912, 26.6477, -43.0465)));
      final vertex_9_275 = mesh_9.vertices.elementAt(275);
      expect(vertex_9_275, vector3MoreOrLessEquals(Vector3(0.412342, 26.1369, -40.3411)));
      final vertex_9_276 = mesh_9.vertices.elementAt(276);
      expect(vertex_9_276, vector3MoreOrLessEquals(Vector3(2.3703, 24.5026, -42.3997)));
      final vertex_9_277 = mesh_9.vertices.elementAt(277);
      expect(vertex_9_277, vector3MoreOrLessEquals(Vector3(12.199, 4.29248, -65.6222)));
      final vertex_9_278 = mesh_9.vertices.elementAt(278);
      expect(vertex_9_278, vector3MoreOrLessEquals(Vector3(2.94912, 26.6477, -43.0465)));
      final vertex_9_279 = mesh_9.vertices.elementAt(279);
      expect(vertex_9_279, vector3MoreOrLessEquals(Vector3(12.199, 4.29248, -65.6222)));
      final vertex_9_280 = mesh_9.vertices.elementAt(280);
      expect(vertex_9_280, vector3MoreOrLessEquals(Vector3(13.5269, 5.64247, -66.9523)));
      final vertex_9_281 = mesh_9.vertices.elementAt(281);
      expect(vertex_9_281, vector3MoreOrLessEquals(Vector3(2.94912, 26.6477, -43.0465)));
      final vertex_9_282 = mesh_9.vertices.elementAt(282);
      expect(vertex_9_282, vector3MoreOrLessEquals(Vector3(12.199, 4.29248, -65.6222)));
      final vertex_9_283 = mesh_9.vertices.elementAt(283);
      expect(vertex_9_283, vector3MoreOrLessEquals(Vector3(17.2136, -31.2314, -79.7783)));
      final vertex_9_284 = mesh_9.vertices.elementAt(284);
      expect(vertex_9_284, vector3MoreOrLessEquals(Vector3(17.8673, -29.6602, -80.5987)));
      final vertex_9_285 = mesh_9.vertices.elementAt(285);
      expect(vertex_9_285, vector3MoreOrLessEquals(Vector3(12.199, 4.29248, -65.6222)));
      final vertex_9_286 = mesh_9.vertices.elementAt(286);
      expect(vertex_9_286, vector3MoreOrLessEquals(Vector3(17.8673, -29.6602, -80.5987)));
      final vertex_9_287 = mesh_9.vertices.elementAt(287);
      expect(vertex_9_287, vector3MoreOrLessEquals(Vector3(13.5269, 5.64247, -66.9523)));
      final vertex_9_288 = mesh_9.vertices.elementAt(288);
      expect(vertex_9_288, vector3MoreOrLessEquals(Vector3(17.2136, -31.2314, -79.7783)));
      final vertex_9_289 = mesh_9.vertices.elementAt(289);
      expect(vertex_9_289, vector3MoreOrLessEquals(Vector3(18.2978, -38.6978, -87.17)));
      final vertex_9_290 = mesh_9.vertices.elementAt(290);
      expect(vertex_9_290, vector3MoreOrLessEquals(Vector3(17.8673, -29.6602, -80.5987)));
      final vertex_9_291 = mesh_9.vertices.elementAt(291);
      expect(vertex_9_291, vector3MoreOrLessEquals(Vector3(18.2978, -38.6978, -87.17)));
      final vertex_9_292 = mesh_9.vertices.elementAt(292);
      expect(vertex_9_292, vector3MoreOrLessEquals(Vector3(18.5638, -38.1552, -87.3725)));
      final vertex_9_293 = mesh_9.vertices.elementAt(293);
      expect(vertex_9_293, vector3MoreOrLessEquals(Vector3(17.8673, -29.6602, -80.5987)));
      expect(mesh_9.normals.length, equals(294));
      final normal_9_0 = mesh_9.normals.elementAt(0);
      expect(normal_9_0, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_1 = mesh_9.normals.elementAt(1);
      expect(normal_9_1, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_2 = mesh_9.normals.elementAt(2);
      expect(normal_9_2, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_3 = mesh_9.normals.elementAt(3);
      expect(normal_9_3, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_4 = mesh_9.normals.elementAt(4);
      expect(normal_9_4, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_5 = mesh_9.normals.elementAt(5);
      expect(normal_9_5, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_6 = mesh_9.normals.elementAt(6);
      expect(normal_9_6, vector3MoreOrLessEquals(Vector3(0.730773, 0.32289, 0.601426)));
      final normal_9_7 = mesh_9.normals.elementAt(7);
      expect(normal_9_7, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, 0.514517)));
      final normal_9_8 = mesh_9.normals.elementAt(8);
      expect(normal_9_8, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, 0.77149)));
      final normal_9_9 = mesh_9.normals.elementAt(9);
      expect(normal_9_9, vector3MoreOrLessEquals(Vector3(0.730773, 0.32289, 0.601426)));
      final normal_9_10 = mesh_9.normals.elementAt(10);
      expect(normal_9_10, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, 0.77149)));
      final normal_9_11 = mesh_9.normals.elementAt(11);
      expect(normal_9_11, vector3MoreOrLessEquals(Vector3(0.209807, 0.742786, 0.635807)));
      final normal_9_12 = mesh_9.normals.elementAt(12);
      expect(normal_9_12, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, 0.514517)));
      final normal_9_13 = mesh_9.normals.elementAt(13);
      expect(normal_9_13, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, 0.69454)));
      final normal_9_14 = mesh_9.normals.elementAt(14);
      expect(normal_9_14, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, 0.77149)));
      final normal_9_15 = mesh_9.normals.elementAt(15);
      expect(normal_9_15, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, 0.69454)));
      final normal_9_16 = mesh_9.normals.elementAt(16);
      expect(normal_9_16, vector3MoreOrLessEquals(Vector3(0.095818, 0.746431, 0.658528)));
      final normal_9_17 = mesh_9.normals.elementAt(17);
      expect(normal_9_17, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, 0.77149)));
      final normal_9_18 = mesh_9.normals.elementAt(18);
      expect(normal_9_18, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, 0.69454)));
      final normal_9_19 = mesh_9.normals.elementAt(19);
      expect(normal_9_19, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, 0.541145)));
      final normal_9_20 = mesh_9.normals.elementAt(20);
      expect(normal_9_20, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, -0.03336)));
      final normal_9_21 = mesh_9.normals.elementAt(21);
      expect(normal_9_21, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, 0.69454)));
      final normal_9_22 = mesh_9.normals.elementAt(22);
      expect(normal_9_22, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, -0.03336)));
      final normal_9_23 = mesh_9.normals.elementAt(23);
      expect(normal_9_23, vector3MoreOrLessEquals(Vector3(0.095818, 0.746431, 0.658528)));
      final normal_9_24 = mesh_9.normals.elementAt(24);
      expect(normal_9_24, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, 0.541145)));
      final normal_9_25 = mesh_9.normals.elementAt(25);
      expect(normal_9_25, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, 0.179175)));
      final normal_9_26 = mesh_9.normals.elementAt(26);
      expect(normal_9_26, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, -0.03336)));
      final normal_9_27 = mesh_9.normals.elementAt(27);
      expect(normal_9_27, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, 0.179175)));
      final normal_9_28 = mesh_9.normals.elementAt(28);
      expect(normal_9_28, vector3MoreOrLessEquals(Vector3(0.754037, 0.504418, -0.420704)));
      final normal_9_29 = mesh_9.normals.elementAt(29);
      expect(normal_9_29, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, -0.03336)));
      final normal_9_30 = mesh_9.normals.elementAt(30);
      expect(normal_9_30, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, 0.179175)));
      final normal_9_31 = mesh_9.normals.elementAt(31);
      expect(normal_9_31, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, 0.322182)));
      final normal_9_32 = mesh_9.normals.elementAt(32);
      expect(normal_9_32, vector3MoreOrLessEquals(Vector3(0.82856, 0.31659, -0.461799)));
      final normal_9_33 = mesh_9.normals.elementAt(33);
      expect(normal_9_33, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, 0.179175)));
      final normal_9_34 = mesh_9.normals.elementAt(34);
      expect(normal_9_34, vector3MoreOrLessEquals(Vector3(0.82856, 0.31659, -0.461799)));
      final normal_9_35 = mesh_9.normals.elementAt(35);
      expect(normal_9_35, vector3MoreOrLessEquals(Vector3(0.754037, 0.504418, -0.420704)));
      final normal_9_36 = mesh_9.normals.elementAt(36);
      expect(normal_9_36, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, 0.322182)));
      final normal_9_37 = mesh_9.normals.elementAt(37);
      expect(normal_9_37, vector3MoreOrLessEquals(Vector3(0.996799, 0.009221, 0.079417)));
      final normal_9_38 = mesh_9.normals.elementAt(38);
      expect(normal_9_38, vector3MoreOrLessEquals(Vector3(0.82856, 0.31659, -0.461799)));
      final normal_9_39 = mesh_9.normals.elementAt(39);
      expect(normal_9_39, vector3MoreOrLessEquals(Vector3(0.996799, 0.009221, 0.079417)));
      final normal_9_40 = mesh_9.normals.elementAt(40);
      expect(normal_9_40, vector3MoreOrLessEquals(Vector3(0.775768, 0.382141, -0.502148)));
      final normal_9_41 = mesh_9.normals.elementAt(41);
      expect(normal_9_41, vector3MoreOrLessEquals(Vector3(0.82856, 0.31659, -0.461799)));
      final normal_9_42 = mesh_9.normals.elementAt(42);
      expect(normal_9_42, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_43 = mesh_9.normals.elementAt(43);
      expect(normal_9_43, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_44 = mesh_9.normals.elementAt(44);
      expect(normal_9_44, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_45 = mesh_9.normals.elementAt(45);
      expect(normal_9_45, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_46 = mesh_9.normals.elementAt(46);
      expect(normal_9_46, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_47 = mesh_9.normals.elementAt(47);
      expect(normal_9_47, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_48 = mesh_9.normals.elementAt(48);
      expect(normal_9_48, vector3MoreOrLessEquals(Vector3(0.209807, 0.742786, 0.635807)));
      final normal_9_49 = mesh_9.normals.elementAt(49);
      expect(normal_9_49, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, 0.77149)));
      final normal_9_50 = mesh_9.normals.elementAt(50);
      expect(normal_9_50, vector3MoreOrLessEquals(Vector3(-0.535922, 0.815786, 0.217442)));
      final normal_9_51 = mesh_9.normals.elementAt(51);
      expect(normal_9_51, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, 0.77149)));
      final normal_9_52 = mesh_9.normals.elementAt(52);
      expect(normal_9_52, vector3MoreOrLessEquals(Vector3(-0.711742, 0.631198, 0.308241)));
      final normal_9_53 = mesh_9.normals.elementAt(53);
      expect(normal_9_53, vector3MoreOrLessEquals(Vector3(-0.535922, 0.815786, 0.217442)));
      final normal_9_54 = mesh_9.normals.elementAt(54);
      expect(normal_9_54, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, 0.77149)));
      final normal_9_55 = mesh_9.normals.elementAt(55);
      expect(normal_9_55, vector3MoreOrLessEquals(Vector3(0.095818, 0.746431, 0.658528)));
      final normal_9_56 = mesh_9.normals.elementAt(56);
      expect(normal_9_56, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, 0.174754)));
      final normal_9_57 = mesh_9.normals.elementAt(57);
      expect(normal_9_57, vector3MoreOrLessEquals(Vector3(0.074051, 0.631917, 0.77149)));
      final normal_9_58 = mesh_9.normals.elementAt(58);
      expect(normal_9_58, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, 0.174754)));
      final normal_9_59 = mesh_9.normals.elementAt(59);
      expect(normal_9_59, vector3MoreOrLessEquals(Vector3(-0.711742, 0.631198, 0.308241)));
      final normal_9_60 = mesh_9.normals.elementAt(60);
      expect(normal_9_60, vector3MoreOrLessEquals(Vector3(0.095818, 0.746431, 0.658528)));
      final normal_9_61 = mesh_9.normals.elementAt(61);
      expect(normal_9_61, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, -0.03336)));
      final normal_9_62 = mesh_9.normals.elementAt(62);
      expect(normal_9_62, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, 0.174754)));
      final normal_9_63 = mesh_9.normals.elementAt(63);
      expect(normal_9_63, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, -0.03336)));
      final normal_9_64 = mesh_9.normals.elementAt(64);
      expect(normal_9_64, vector3MoreOrLessEquals(Vector3(-0.411496, 0.796168, -0.443607)));
      final normal_9_65 = mesh_9.normals.elementAt(65);
      expect(normal_9_65, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, 0.174754)));
      final normal_9_66 = mesh_9.normals.elementAt(66);
      expect(normal_9_66, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, -0.03336)));
      final normal_9_67 = mesh_9.normals.elementAt(67);
      expect(normal_9_67, vector3MoreOrLessEquals(Vector3(0.754037, 0.504418, -0.420704)));
      final normal_9_68 = mesh_9.normals.elementAt(68);
      expect(normal_9_68, vector3MoreOrLessEquals(Vector3(-0.09438, 0.527301, -0.844421)));
      final normal_9_69 = mesh_9.normals.elementAt(69);
      expect(normal_9_69, vector3MoreOrLessEquals(Vector3(0.408064, 0.912344, -0.03336)));
      final normal_9_70 = mesh_9.normals.elementAt(70);
      expect(normal_9_70, vector3MoreOrLessEquals(Vector3(-0.09438, 0.527301, -0.844421)));
      final normal_9_71 = mesh_9.normals.elementAt(71);
      expect(normal_9_71, vector3MoreOrLessEquals(Vector3(-0.411496, 0.796168, -0.443607)));
      final normal_9_72 = mesh_9.normals.elementAt(72);
      expect(normal_9_72, vector3MoreOrLessEquals(Vector3(0.754037, 0.504418, -0.420704)));
      final normal_9_73 = mesh_9.normals.elementAt(73);
      expect(normal_9_73, vector3MoreOrLessEquals(Vector3(0.82856, 0.31659, -0.461799)));
      final normal_9_74 = mesh_9.normals.elementAt(74);
      expect(normal_9_74, vector3MoreOrLessEquals(Vector3(-0.09438, 0.527301, -0.844421)));
      final normal_9_75 = mesh_9.normals.elementAt(75);
      expect(normal_9_75, vector3MoreOrLessEquals(Vector3(0.82856, 0.31659, -0.461799)));
      final normal_9_76 = mesh_9.normals.elementAt(76);
      expect(normal_9_76, vector3MoreOrLessEquals(Vector3(-0.069752, 0.407704, -0.910446)));
      final normal_9_77 = mesh_9.normals.elementAt(77);
      expect(normal_9_77, vector3MoreOrLessEquals(Vector3(-0.09438, 0.527301, -0.844421)));
      final normal_9_78 = mesh_9.normals.elementAt(78);
      expect(normal_9_78, vector3MoreOrLessEquals(Vector3(0.82856, 0.31659, -0.461799)));
      final normal_9_79 = mesh_9.normals.elementAt(79);
      expect(normal_9_79, vector3MoreOrLessEquals(Vector3(0.775768, 0.382141, -0.502148)));
      final normal_9_80 = mesh_9.normals.elementAt(80);
      expect(normal_9_80, vector3MoreOrLessEquals(Vector3(-0.075227, 0.509317, -0.857285)));
      final normal_9_81 = mesh_9.normals.elementAt(81);
      expect(normal_9_81, vector3MoreOrLessEquals(Vector3(0.82856, 0.31659, -0.461799)));
      final normal_9_82 = mesh_9.normals.elementAt(82);
      expect(normal_9_82, vector3MoreOrLessEquals(Vector3(-0.075227, 0.509317, -0.857285)));
      final normal_9_83 = mesh_9.normals.elementAt(83);
      expect(normal_9_83, vector3MoreOrLessEquals(Vector3(-0.069752, 0.407704, -0.910446)));
      final normal_9_84 = mesh_9.normals.elementAt(84);
      expect(normal_9_84, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_85 = mesh_9.normals.elementAt(85);
      expect(normal_9_85, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_86 = mesh_9.normals.elementAt(86);
      expect(normal_9_86, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_87 = mesh_9.normals.elementAt(87);
      expect(normal_9_87, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_88 = mesh_9.normals.elementAt(88);
      expect(normal_9_88, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_89 = mesh_9.normals.elementAt(89);
      expect(normal_9_89, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_90 = mesh_9.normals.elementAt(90);
      expect(normal_9_90, vector3MoreOrLessEquals(Vector3(-0.535922, 0.815786, 0.217442)));
      final normal_9_91 = mesh_9.normals.elementAt(91);
      expect(normal_9_91, vector3MoreOrLessEquals(Vector3(-0.711742, 0.631198, 0.308241)));
      final normal_9_92 = mesh_9.normals.elementAt(92);
      expect(normal_9_92, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, -0.379522)));
      final normal_9_93 = mesh_9.normals.elementAt(93);
      expect(normal_9_93, vector3MoreOrLessEquals(Vector3(-0.535922, 0.815786, 0.217442)));
      final normal_9_94 = mesh_9.normals.elementAt(94);
      expect(normal_9_94, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, -0.379522)));
      final normal_9_95 = mesh_9.normals.elementAt(95);
      expect(normal_9_95, vector3MoreOrLessEquals(Vector3(-0.856971, 0.404836, -0.318918)));
      final normal_9_96 = mesh_9.normals.elementAt(96);
      expect(normal_9_96, vector3MoreOrLessEquals(Vector3(-0.711742, 0.631198, 0.308241)));
      final normal_9_97 = mesh_9.normals.elementAt(97);
      expect(normal_9_97, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, 0.174754)));
      final normal_9_98 = mesh_9.normals.elementAt(98);
      expect(normal_9_98, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, -0.379522)));
      final normal_9_99 = mesh_9.normals.elementAt(99);
      expect(normal_9_99, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, 0.174754)));
      final normal_9_100 = mesh_9.normals.elementAt(100);
      expect(normal_9_100, vector3MoreOrLessEquals(Vector3(-0.929488, 0.002263, -0.368845)));
      final normal_9_101 = mesh_9.normals.elementAt(101);
      expect(normal_9_101, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, -0.379522)));
      final normal_9_102 = mesh_9.normals.elementAt(102);
      expect(normal_9_102, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, 0.174754)));
      final normal_9_103 = mesh_9.normals.elementAt(103);
      expect(normal_9_103, vector3MoreOrLessEquals(Vector3(-0.411496, 0.796168, -0.443607)));
      final normal_9_104 = mesh_9.normals.elementAt(104);
      expect(normal_9_104, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, -0.392239)));
      final normal_9_105 = mesh_9.normals.elementAt(105);
      expect(normal_9_105, vector3MoreOrLessEquals(Vector3(-0.720586, 0.670982, 0.174754)));
      final normal_9_106 = mesh_9.normals.elementAt(106);
      expect(normal_9_106, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, -0.392239)));
      final normal_9_107 = mesh_9.normals.elementAt(107);
      expect(normal_9_107, vector3MoreOrLessEquals(Vector3(-0.929488, 0.002263, -0.368845)));
      final normal_9_108 = mesh_9.normals.elementAt(108);
      expect(normal_9_108, vector3MoreOrLessEquals(Vector3(-0.411496, 0.796168, -0.443607)));
      final normal_9_109 = mesh_9.normals.elementAt(109);
      expect(normal_9_109, vector3MoreOrLessEquals(Vector3(-0.09438, 0.527301, -0.844421)));
      final normal_9_110 = mesh_9.normals.elementAt(110);
      expect(normal_9_110, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, -0.392239)));
      final normal_9_111 = mesh_9.normals.elementAt(111);
      expect(normal_9_111, vector3MoreOrLessEquals(Vector3(-0.09438, 0.527301, -0.844421)));
      final normal_9_112 = mesh_9.normals.elementAt(112);
      expect(normal_9_112, vector3MoreOrLessEquals(Vector3(-0.775244, 0.155506, -0.612221)));
      final normal_9_113 = mesh_9.normals.elementAt(113);
      expect(normal_9_113, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, -0.392239)));
      final normal_9_114 = mesh_9.normals.elementAt(114);
      expect(normal_9_114, vector3MoreOrLessEquals(Vector3(-0.09438, 0.527301, -0.844421)));
      final normal_9_115 = mesh_9.normals.elementAt(115);
      expect(normal_9_115, vector3MoreOrLessEquals(Vector3(-0.069752, 0.407704, -0.910446)));
      final normal_9_116 = mesh_9.normals.elementAt(116);
      expect(normal_9_116, vector3MoreOrLessEquals(Vector3(-0.809952, 0.130294, -0.571839)));
      final normal_9_117 = mesh_9.normals.elementAt(117);
      expect(normal_9_117, vector3MoreOrLessEquals(Vector3(-0.09438, 0.527301, -0.844421)));
      final normal_9_118 = mesh_9.normals.elementAt(118);
      expect(normal_9_118, vector3MoreOrLessEquals(Vector3(-0.809952, 0.130294, -0.571839)));
      final normal_9_119 = mesh_9.normals.elementAt(119);
      expect(normal_9_119, vector3MoreOrLessEquals(Vector3(-0.775244, 0.155506, -0.612221)));
      final normal_9_120 = mesh_9.normals.elementAt(120);
      expect(normal_9_120, vector3MoreOrLessEquals(Vector3(-0.069752, 0.407704, -0.910446)));
      final normal_9_121 = mesh_9.normals.elementAt(121);
      expect(normal_9_121, vector3MoreOrLessEquals(Vector3(-0.075227, 0.509317, -0.857285)));
      final normal_9_122 = mesh_9.normals.elementAt(122);
      expect(normal_9_122, vector3MoreOrLessEquals(Vector3(-0.809952, 0.130294, -0.571839)));
      final normal_9_123 = mesh_9.normals.elementAt(123);
      expect(normal_9_123, vector3MoreOrLessEquals(Vector3(-0.075227, 0.509317, -0.857285)));
      final normal_9_124 = mesh_9.normals.elementAt(124);
      expect(normal_9_124, vector3MoreOrLessEquals(Vector3(-0.809969, 0.21145, -0.547027)));
      final normal_9_125 = mesh_9.normals.elementAt(125);
      expect(normal_9_125, vector3MoreOrLessEquals(Vector3(-0.809952, 0.130294, -0.571839)));
      final normal_9_126 = mesh_9.normals.elementAt(126);
      expect(normal_9_126, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_127 = mesh_9.normals.elementAt(127);
      expect(normal_9_127, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_128 = mesh_9.normals.elementAt(128);
      expect(normal_9_128, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_129 = mesh_9.normals.elementAt(129);
      expect(normal_9_129, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_130 = mesh_9.normals.elementAt(130);
      expect(normal_9_130, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_131 = mesh_9.normals.elementAt(131);
      expect(normal_9_131, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_132 = mesh_9.normals.elementAt(132);
      expect(normal_9_132, vector3MoreOrLessEquals(Vector3(-0.856971, 0.404836, -0.318918)));
      final normal_9_133 = mesh_9.normals.elementAt(133);
      expect(normal_9_133, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, -0.379522)));
      final normal_9_134 = mesh_9.normals.elementAt(134);
      expect(normal_9_134, vector3MoreOrLessEquals(Vector3(-0.512438, -0.473965, -0.716075)));
      final normal_9_135 = mesh_9.normals.elementAt(135);
      expect(normal_9_135, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, -0.379522)));
      final normal_9_136 = mesh_9.normals.elementAt(136);
      expect(normal_9_136, vector3MoreOrLessEquals(Vector3(-0.470746, -0.365488, -0.803005)));
      final normal_9_137 = mesh_9.normals.elementAt(137);
      expect(normal_9_137, vector3MoreOrLessEquals(Vector3(-0.512438, -0.473965, -0.716075)));
      final normal_9_138 = mesh_9.normals.elementAt(138);
      expect(normal_9_138, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, -0.379522)));
      final normal_9_139 = mesh_9.normals.elementAt(139);
      expect(normal_9_139, vector3MoreOrLessEquals(Vector3(-0.929488, 0.002263, -0.368845)));
      final normal_9_140 = mesh_9.normals.elementAt(140);
      expect(normal_9_140, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, -0.55203)));
      final normal_9_141 = mesh_9.normals.elementAt(141);
      expect(normal_9_141, vector3MoreOrLessEquals(Vector3(-0.899322, 0.217218, -0.379522)));
      final normal_9_142 = mesh_9.normals.elementAt(142);
      expect(normal_9_142, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, -0.55203)));
      final normal_9_143 = mesh_9.normals.elementAt(143);
      expect(normal_9_143, vector3MoreOrLessEquals(Vector3(-0.470746, -0.365488, -0.803005)));
      final normal_9_144 = mesh_9.normals.elementAt(144);
      expect(normal_9_144, vector3MoreOrLessEquals(Vector3(-0.929488, 0.002263, -0.368845)));
      final normal_9_145 = mesh_9.normals.elementAt(145);
      expect(normal_9_145, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, -0.392239)));
      final normal_9_146 = mesh_9.normals.elementAt(146);
      expect(normal_9_146, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, -0.55203)));
      final normal_9_147 = mesh_9.normals.elementAt(147);
      expect(normal_9_147, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, -0.392239)));
      final normal_9_148 = mesh_9.normals.elementAt(148);
      expect(normal_9_148, vector3MoreOrLessEquals(Vector3(-0.804795, -0.592928, 0.027236)));
      final normal_9_149 = mesh_9.normals.elementAt(149);
      expect(normal_9_149, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, -0.55203)));
      final normal_9_150 = mesh_9.normals.elementAt(150);
      expect(normal_9_150, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, -0.392239)));
      final normal_9_151 = mesh_9.normals.elementAt(151);
      expect(normal_9_151, vector3MoreOrLessEquals(Vector3(-0.775244, 0.155506, -0.612221)));
      final normal_9_152 = mesh_9.normals.elementAt(152);
      expect(normal_9_152, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, 0.047865)));
      final normal_9_153 = mesh_9.normals.elementAt(153);
      expect(normal_9_153, vector3MoreOrLessEquals(Vector3(-0.91302, 0.111991, -0.392239)));
      final normal_9_154 = mesh_9.normals.elementAt(154);
      expect(normal_9_154, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, 0.047865)));
      final normal_9_155 = mesh_9.normals.elementAt(155);
      expect(normal_9_155, vector3MoreOrLessEquals(Vector3(-0.804795, -0.592928, 0.027236)));
      final normal_9_156 = mesh_9.normals.elementAt(156);
      expect(normal_9_156, vector3MoreOrLessEquals(Vector3(-0.775244, 0.155506, -0.612221)));
      final normal_9_157 = mesh_9.normals.elementAt(157);
      expect(normal_9_157, vector3MoreOrLessEquals(Vector3(-0.809952, 0.130294, -0.571839)));
      final normal_9_158 = mesh_9.normals.elementAt(158);
      expect(normal_9_158, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, 0.047865)));
      final normal_9_159 = mesh_9.normals.elementAt(159);
      expect(normal_9_159, vector3MoreOrLessEquals(Vector3(-0.809952, 0.130294, -0.571839)));
      final normal_9_160 = mesh_9.normals.elementAt(160);
      expect(normal_9_160, vector3MoreOrLessEquals(Vector3(-0.979826, -0.199093, -0.017388)));
      final normal_9_161 = mesh_9.normals.elementAt(161);
      expect(normal_9_161, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, 0.047865)));
      final normal_9_162 = mesh_9.normals.elementAt(162);
      expect(normal_9_162, vector3MoreOrLessEquals(Vector3(-0.809952, 0.130294, -0.571839)));
      final normal_9_163 = mesh_9.normals.elementAt(163);
      expect(normal_9_163, vector3MoreOrLessEquals(Vector3(-0.809969, 0.21145, -0.547027)));
      final normal_9_164 = mesh_9.normals.elementAt(164);
      expect(normal_9_164, vector3MoreOrLessEquals(Vector3(-0.96966, -0.244405, -0.004995)));
      final normal_9_165 = mesh_9.normals.elementAt(165);
      expect(normal_9_165, vector3MoreOrLessEquals(Vector3(-0.809952, 0.130294, -0.571839)));
      final normal_9_166 = mesh_9.normals.elementAt(166);
      expect(normal_9_166, vector3MoreOrLessEquals(Vector3(-0.96966, -0.244405, -0.004995)));
      final normal_9_167 = mesh_9.normals.elementAt(167);
      expect(normal_9_167, vector3MoreOrLessEquals(Vector3(-0.979826, -0.199093, -0.017388)));
      final normal_9_168 = mesh_9.normals.elementAt(168);
      expect(normal_9_168, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_169 = mesh_9.normals.elementAt(169);
      expect(normal_9_169, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_170 = mesh_9.normals.elementAt(170);
      expect(normal_9_170, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_171 = mesh_9.normals.elementAt(171);
      expect(normal_9_171, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_172 = mesh_9.normals.elementAt(172);
      expect(normal_9_172, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_173 = mesh_9.normals.elementAt(173);
      expect(normal_9_173, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_174 = mesh_9.normals.elementAt(174);
      expect(normal_9_174, vector3MoreOrLessEquals(Vector3(-0.512438, -0.473965, -0.716075)));
      final normal_9_175 = mesh_9.normals.elementAt(175);
      expect(normal_9_175, vector3MoreOrLessEquals(Vector3(-0.470746, -0.365488, -0.803005)));
      final normal_9_176 = mesh_9.normals.elementAt(176);
      expect(normal_9_176, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, -0.681045)));
      final normal_9_177 = mesh_9.normals.elementAt(177);
      expect(normal_9_177, vector3MoreOrLessEquals(Vector3(-0.512438, -0.473965, -0.716075)));
      final normal_9_178 = mesh_9.normals.elementAt(178);
      expect(normal_9_178, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, -0.681045)));
      final normal_9_179 = mesh_9.normals.elementAt(179);
      expect(normal_9_179, vector3MoreOrLessEquals(Vector3(0.150051, -0.816598, -0.557361)));
      final normal_9_180 = mesh_9.normals.elementAt(180);
      expect(normal_9_180, vector3MoreOrLessEquals(Vector3(-0.470746, -0.365488, -0.803005)));
      final normal_9_181 = mesh_9.normals.elementAt(181);
      expect(normal_9_181, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, -0.55203)));
      final normal_9_182 = mesh_9.normals.elementAt(182);
      expect(normal_9_182, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, -0.681045)));
      final normal_9_183 = mesh_9.normals.elementAt(183);
      expect(normal_9_183, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, -0.55203)));
      final normal_9_184 = mesh_9.normals.elementAt(184);
      expect(normal_9_184, vector3MoreOrLessEquals(Vector3(0.305964, -0.903395, -0.300439)));
      final normal_9_185 = mesh_9.normals.elementAt(185);
      expect(normal_9_185, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, -0.681045)));
      final normal_9_186 = mesh_9.normals.elementAt(186);
      expect(normal_9_186, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, -0.55203)));
      final normal_9_187 = mesh_9.normals.elementAt(187);
      expect(normal_9_187, vector3MoreOrLessEquals(Vector3(-0.804795, -0.592928, 0.027236)));
      final normal_9_188 = mesh_9.normals.elementAt(188);
      expect(normal_9_188, vector3MoreOrLessEquals(Vector3(-0.106895, -0.8791, 0.464496)));
      final normal_9_189 = mesh_9.normals.elementAt(189);
      expect(normal_9_189, vector3MoreOrLessEquals(Vector3(-0.622708, -0.554524, -0.55203)));
      final normal_9_190 = mesh_9.normals.elementAt(190);
      expect(normal_9_190, vector3MoreOrLessEquals(Vector3(-0.106895, -0.8791, 0.464496)));
      final normal_9_191 = mesh_9.normals.elementAt(191);
      expect(normal_9_191, vector3MoreOrLessEquals(Vector3(0.305964, -0.903395, -0.300439)));
      final normal_9_192 = mesh_9.normals.elementAt(192);
      expect(normal_9_192, vector3MoreOrLessEquals(Vector3(-0.804795, -0.592928, 0.027236)));
      final normal_9_193 = mesh_9.normals.elementAt(193);
      expect(normal_9_193, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, 0.047865)));
      final normal_9_194 = mesh_9.normals.elementAt(194);
      expect(normal_9_194, vector3MoreOrLessEquals(Vector3(-0.106895, -0.8791, 0.464496)));
      final normal_9_195 = mesh_9.normals.elementAt(195);
      expect(normal_9_195, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, 0.047865)));
      final normal_9_196 = mesh_9.normals.elementAt(196);
      expect(normal_9_196, vector3MoreOrLessEquals(Vector3(-0.379305, -0.604701, 0.700332)));
      final normal_9_197 = mesh_9.normals.elementAt(197);
      expect(normal_9_197, vector3MoreOrLessEquals(Vector3(-0.106895, -0.8791, 0.464496)));
      final normal_9_198 = mesh_9.normals.elementAt(198);
      expect(normal_9_198, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, 0.047865)));
      final normal_9_199 = mesh_9.normals.elementAt(199);
      expect(normal_9_199, vector3MoreOrLessEquals(Vector3(-0.979826, -0.199093, -0.017388)));
      final normal_9_200 = mesh_9.normals.elementAt(200);
      expect(normal_9_200, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, 0.698527)));
      final normal_9_201 = mesh_9.normals.elementAt(201);
      expect(normal_9_201, vector3MoreOrLessEquals(Vector3(-0.935688, -0.349566, 0.047865)));
      final normal_9_202 = mesh_9.normals.elementAt(202);
      expect(normal_9_202, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, 0.698527)));
      final normal_9_203 = mesh_9.normals.elementAt(203);
      expect(normal_9_203, vector3MoreOrLessEquals(Vector3(-0.379305, -0.604701, 0.700332)));
      final normal_9_204 = mesh_9.normals.elementAt(204);
      expect(normal_9_204, vector3MoreOrLessEquals(Vector3(-0.979826, -0.199093, -0.017388)));
      final normal_9_205 = mesh_9.normals.elementAt(205);
      expect(normal_9_205, vector3MoreOrLessEquals(Vector3(-0.96966, -0.244405, -0.004995)));
      final normal_9_206 = mesh_9.normals.elementAt(206);
      expect(normal_9_206, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, 0.698527)));
      final normal_9_207 = mesh_9.normals.elementAt(207);
      expect(normal_9_207, vector3MoreOrLessEquals(Vector3(-0.96966, -0.244405, -0.004995)));
      final normal_9_208 = mesh_9.normals.elementAt(208);
      expect(normal_9_208, vector3MoreOrLessEquals(Vector3(-0.396771, -0.701294, 0.592249)));
      final normal_9_209 = mesh_9.normals.elementAt(209);
      expect(normal_9_209, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, 0.698527)));
      final normal_9_210 = mesh_9.normals.elementAt(210);
      expect(normal_9_210, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_211 = mesh_9.normals.elementAt(211);
      expect(normal_9_211, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_212 = mesh_9.normals.elementAt(212);
      expect(normal_9_212, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_213 = mesh_9.normals.elementAt(213);
      expect(normal_9_213, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_214 = mesh_9.normals.elementAt(214);
      expect(normal_9_214, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_215 = mesh_9.normals.elementAt(215);
      expect(normal_9_215, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_216 = mesh_9.normals.elementAt(216);
      expect(normal_9_216, vector3MoreOrLessEquals(Vector3(0.150051, -0.816598, -0.557361)));
      final normal_9_217 = mesh_9.normals.elementAt(217);
      expect(normal_9_217, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, -0.681045)));
      final normal_9_218 = mesh_9.normals.elementAt(218);
      expect(normal_9_218, vector3MoreOrLessEquals(Vector3(0.835906, -0.548834, 0.006518)));
      final normal_9_219 = mesh_9.normals.elementAt(219);
      expect(normal_9_219, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, -0.681045)));
      final normal_9_220 = mesh_9.normals.elementAt(220);
      expect(normal_9_220, vector3MoreOrLessEquals(Vector3(0.923602, -0.381844, -0.033966)));
      final normal_9_221 = mesh_9.normals.elementAt(221);
      expect(normal_9_221, vector3MoreOrLessEquals(Vector3(0.835906, -0.548834, 0.006518)));
      final normal_9_222 = mesh_9.normals.elementAt(222);
      expect(normal_9_222, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, -0.681045)));
      final normal_9_223 = mesh_9.normals.elementAt(223);
      expect(normal_9_223, vector3MoreOrLessEquals(Vector3(0.305964, -0.903395, -0.300439)));
      final normal_9_224 = mesh_9.normals.elementAt(224);
      expect(normal_9_224, vector3MoreOrLessEquals(Vector3(0.863214, -0.393373, 0.316418)));
      final normal_9_225 = mesh_9.normals.elementAt(225);
      expect(normal_9_225, vector3MoreOrLessEquals(Vector3(0.34603, -0.645322, -0.681045)));
      final normal_9_226 = mesh_9.normals.elementAt(226);
      expect(normal_9_226, vector3MoreOrLessEquals(Vector3(0.863214, -0.393373, 0.316418)));
      final normal_9_227 = mesh_9.normals.elementAt(227);
      expect(normal_9_227, vector3MoreOrLessEquals(Vector3(0.923602, -0.381844, -0.033966)));
      final normal_9_228 = mesh_9.normals.elementAt(228);
      expect(normal_9_228, vector3MoreOrLessEquals(Vector3(0.305964, -0.903395, -0.300439)));
      final normal_9_229 = mesh_9.normals.elementAt(229);
      expect(normal_9_229, vector3MoreOrLessEquals(Vector3(-0.106895, -0.8791, 0.464496)));
      final normal_9_230 = mesh_9.normals.elementAt(230);
      expect(normal_9_230, vector3MoreOrLessEquals(Vector3(0.863214, -0.393373, 0.316418)));
      final normal_9_231 = mesh_9.normals.elementAt(231);
      expect(normal_9_231, vector3MoreOrLessEquals(Vector3(-0.106895, -0.8791, 0.464496)));
      final normal_9_232 = mesh_9.normals.elementAt(232);
      expect(normal_9_232, vector3MoreOrLessEquals(Vector3(0.6055, -0.431679, 0.668598)));
      final normal_9_233 = mesh_9.normals.elementAt(233);
      expect(normal_9_233, vector3MoreOrLessEquals(Vector3(0.863214, -0.393373, 0.316418)));
      final normal_9_234 = mesh_9.normals.elementAt(234);
      expect(normal_9_234, vector3MoreOrLessEquals(Vector3(-0.106895, -0.8791, 0.464496)));
      final normal_9_235 = mesh_9.normals.elementAt(235);
      expect(normal_9_235, vector3MoreOrLessEquals(Vector3(-0.379305, -0.604701, 0.700332)));
      final normal_9_236 = mesh_9.normals.elementAt(236);
      expect(normal_9_236, vector3MoreOrLessEquals(Vector3(0.53423, -0.375452, 0.757387)));
      final normal_9_237 = mesh_9.normals.elementAt(237);
      expect(normal_9_237, vector3MoreOrLessEquals(Vector3(-0.106895, -0.8791, 0.464496)));
      final normal_9_238 = mesh_9.normals.elementAt(238);
      expect(normal_9_238, vector3MoreOrLessEquals(Vector3(0.53423, -0.375452, 0.757387)));
      final normal_9_239 = mesh_9.normals.elementAt(239);
      expect(normal_9_239, vector3MoreOrLessEquals(Vector3(0.6055, -0.431679, 0.668598)));
      final normal_9_240 = mesh_9.normals.elementAt(240);
      expect(normal_9_240, vector3MoreOrLessEquals(Vector3(-0.379305, -0.604701, 0.700332)));
      final normal_9_241 = mesh_9.normals.elementAt(241);
      expect(normal_9_241, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, 0.698527)));
      final normal_9_242 = mesh_9.normals.elementAt(242);
      expect(normal_9_242, vector3MoreOrLessEquals(Vector3(0.53423, -0.375452, 0.757387)));
      final normal_9_243 = mesh_9.normals.elementAt(243);
      expect(normal_9_243, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, 0.698527)));
      final normal_9_244 = mesh_9.normals.elementAt(244);
      expect(normal_9_244, vector3MoreOrLessEquals(Vector3(0.609831, -0.367158, 0.702354)));
      final normal_9_245 = mesh_9.normals.elementAt(245);
      expect(normal_9_245, vector3MoreOrLessEquals(Vector3(0.53423, -0.375452, 0.757387)));
      final normal_9_246 = mesh_9.normals.elementAt(246);
      expect(normal_9_246, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, 0.698527)));
      final normal_9_247 = mesh_9.normals.elementAt(247);
      expect(normal_9_247, vector3MoreOrLessEquals(Vector3(-0.396771, -0.701294, 0.592249)));
      final normal_9_248 = mesh_9.normals.elementAt(248);
      expect(normal_9_248, vector3MoreOrLessEquals(Vector3(0.606094, -0.512126, 0.608586)));
      final normal_9_249 = mesh_9.normals.elementAt(249);
      expect(normal_9_249, vector3MoreOrLessEquals(Vector3(-0.457451, -0.550271, 0.698527)));
      final normal_9_250 = mesh_9.normals.elementAt(250);
      expect(normal_9_250, vector3MoreOrLessEquals(Vector3(0.606094, -0.512126, 0.608586)));
      final normal_9_251 = mesh_9.normals.elementAt(251);
      expect(normal_9_251, vector3MoreOrLessEquals(Vector3(0.609831, -0.367158, 0.702354)));
      final normal_9_252 = mesh_9.normals.elementAt(252);
      expect(normal_9_252, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_253 = mesh_9.normals.elementAt(253);
      expect(normal_9_253, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_254 = mesh_9.normals.elementAt(254);
      expect(normal_9_254, vector3MoreOrLessEquals(Vector3(-0.287104, -0.930941, 0.225655)));
      final normal_9_255 = mesh_9.normals.elementAt(255);
      expect(normal_9_255, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_256 = mesh_9.normals.elementAt(256);
      expect(normal_9_256, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_257 = mesh_9.normals.elementAt(257);
      expect(normal_9_257, vector3MoreOrLessEquals(Vector3(0.184384, -0.421751, -0.887766)));
      final normal_9_258 = mesh_9.normals.elementAt(258);
      expect(normal_9_258, vector3MoreOrLessEquals(Vector3(0.835906, -0.548834, 0.006518)));
      final normal_9_259 = mesh_9.normals.elementAt(259);
      expect(normal_9_259, vector3MoreOrLessEquals(Vector3(0.923602, -0.381844, -0.033966)));
      final normal_9_260 = mesh_9.normals.elementAt(260);
      expect(normal_9_260, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, 0.514517)));
      final normal_9_261 = mesh_9.normals.elementAt(261);
      expect(normal_9_261, vector3MoreOrLessEquals(Vector3(0.835906, -0.548834, 0.006518)));
      final normal_9_262 = mesh_9.normals.elementAt(262);
      expect(normal_9_262, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, 0.514517)));
      final normal_9_263 = mesh_9.normals.elementAt(263);
      expect(normal_9_263, vector3MoreOrLessEquals(Vector3(0.730773, 0.32289, 0.601426)));
      final normal_9_264 = mesh_9.normals.elementAt(264);
      expect(normal_9_264, vector3MoreOrLessEquals(Vector3(0.923602, -0.381844, -0.033966)));
      final normal_9_265 = mesh_9.normals.elementAt(265);
      expect(normal_9_265, vector3MoreOrLessEquals(Vector3(0.863214, -0.393373, 0.316418)));
      final normal_9_266 = mesh_9.normals.elementAt(266);
      expect(normal_9_266, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, 0.514517)));
      final normal_9_267 = mesh_9.normals.elementAt(267);
      expect(normal_9_267, vector3MoreOrLessEquals(Vector3(0.863214, -0.393373, 0.316418)));
      final normal_9_268 = mesh_9.normals.elementAt(268);
      expect(normal_9_268, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, 0.69454)));
      final normal_9_269 = mesh_9.normals.elementAt(269);
      expect(normal_9_269, vector3MoreOrLessEquals(Vector3(0.855333, 0.060647, 0.514517)));
      final normal_9_270 = mesh_9.normals.elementAt(270);
      expect(normal_9_270, vector3MoreOrLessEquals(Vector3(0.863214, -0.393373, 0.316418)));
      final normal_9_271 = mesh_9.normals.elementAt(271);
      expect(normal_9_271, vector3MoreOrLessEquals(Vector3(0.6055, -0.431679, 0.668598)));
      final normal_9_272 = mesh_9.normals.elementAt(272);
      expect(normal_9_272, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, 0.541145)));
      final normal_9_273 = mesh_9.normals.elementAt(273);
      expect(normal_9_273, vector3MoreOrLessEquals(Vector3(0.863214, -0.393373, 0.316418)));
      final normal_9_274 = mesh_9.normals.elementAt(274);
      expect(normal_9_274, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, 0.541145)));
      final normal_9_275 = mesh_9.normals.elementAt(275);
      expect(normal_9_275, vector3MoreOrLessEquals(Vector3(0.616222, 0.371327, 0.69454)));
      final normal_9_276 = mesh_9.normals.elementAt(276);
      expect(normal_9_276, vector3MoreOrLessEquals(Vector3(0.6055, -0.431679, 0.668598)));
      final normal_9_277 = mesh_9.normals.elementAt(277);
      expect(normal_9_277, vector3MoreOrLessEquals(Vector3(0.53423, -0.375452, 0.757387)));
      final normal_9_278 = mesh_9.normals.elementAt(278);
      expect(normal_9_278, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, 0.541145)));
      final normal_9_279 = mesh_9.normals.elementAt(279);
      expect(normal_9_279, vector3MoreOrLessEquals(Vector3(0.53423, -0.375452, 0.757387)));
      final normal_9_280 = mesh_9.normals.elementAt(280);
      expect(normal_9_280, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, 0.179175)));
      final normal_9_281 = mesh_9.normals.elementAt(281);
      expect(normal_9_281, vector3MoreOrLessEquals(Vector3(0.821336, 0.180467, 0.541145)));
      final normal_9_282 = mesh_9.normals.elementAt(282);
      expect(normal_9_282, vector3MoreOrLessEquals(Vector3(0.53423, -0.375452, 0.757387)));
      final normal_9_283 = mesh_9.normals.elementAt(283);
      expect(normal_9_283, vector3MoreOrLessEquals(Vector3(0.609831, -0.367158, 0.702354)));
      final normal_9_284 = mesh_9.normals.elementAt(284);
      expect(normal_9_284, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, 0.322182)));
      final normal_9_285 = mesh_9.normals.elementAt(285);
      expect(normal_9_285, vector3MoreOrLessEquals(Vector3(0.53423, -0.375452, 0.757387)));
      final normal_9_286 = mesh_9.normals.elementAt(286);
      expect(normal_9_286, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, 0.322182)));
      final normal_9_287 = mesh_9.normals.elementAt(287);
      expect(normal_9_287, vector3MoreOrLessEquals(Vector3(0.969682, 0.16617, 0.179175)));
      final normal_9_288 = mesh_9.normals.elementAt(288);
      expect(normal_9_288, vector3MoreOrLessEquals(Vector3(0.609831, -0.367158, 0.702354)));
      final normal_9_289 = mesh_9.normals.elementAt(289);
      expect(normal_9_289, vector3MoreOrLessEquals(Vector3(0.606094, -0.512126, 0.608586)));
      final normal_9_290 = mesh_9.normals.elementAt(290);
      expect(normal_9_290, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, 0.322182)));
      final normal_9_291 = mesh_9.normals.elementAt(291);
      expect(normal_9_291, vector3MoreOrLessEquals(Vector3(0.606094, -0.512126, 0.608586)));
      final normal_9_292 = mesh_9.normals.elementAt(292);
      expect(normal_9_292, vector3MoreOrLessEquals(Vector3(0.996799, 0.009221, 0.079417)));
      final normal_9_293 = mesh_9.normals.elementAt(293);
      expect(normal_9_293, vector3MoreOrLessEquals(Vector3(0.943283, -0.080094, 0.322182)));
      expect(mesh_9.tangents.length, isZero);
      expect(mesh_9.bitangents.length, isZero);
      expect(mesh_9.colors.length, isZero);
      expect(mesh_9.textureCoords.length, equals(1));
      final textureCoords_9_0 = mesh_9.textureCoords.elementAt(0);
      expect(textureCoords_9_0.length, equals(294));
      final textureCoord_9_0_0 = textureCoords_9_0.elementAt(0);
      expect(textureCoord_9_0_0, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_1 = textureCoords_9_0.elementAt(1);
      expect(textureCoord_9_0_1, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_2 = textureCoords_9_0.elementAt(2);
      expect(textureCoord_9_0_2, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_3 = textureCoords_9_0.elementAt(3);
      expect(textureCoord_9_0_3, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_4 = textureCoords_9_0.elementAt(4);
      expect(textureCoord_9_0_4, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_5 = textureCoords_9_0.elementAt(5);
      expect(textureCoord_9_0_5, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_6 = textureCoords_9_0.elementAt(6);
      expect(textureCoord_9_0_6, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_9_0_7 = textureCoords_9_0.elementAt(7);
      expect(textureCoord_9_0_7, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_9_0_8 = textureCoords_9_0.elementAt(8);
      expect(textureCoord_9_0_8, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_9_0_9 = textureCoords_9_0.elementAt(9);
      expect(textureCoord_9_0_9, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_9_0_10 = textureCoords_9_0.elementAt(10);
      expect(textureCoord_9_0_10, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_9_0_11 = textureCoords_9_0.elementAt(11);
      expect(textureCoord_9_0_11, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_9_0_12 = textureCoords_9_0.elementAt(12);
      expect(textureCoord_9_0_12, vector3MoreOrLessEquals(Vector3(0, 0.166667, 0)));
      final textureCoord_9_0_13 = textureCoords_9_0.elementAt(13);
      expect(textureCoord_9_0_13, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_9_0_14 = textureCoords_9_0.elementAt(14);
      expect(textureCoord_9_0_14, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_9_0_15 = textureCoords_9_0.elementAt(15);
      expect(textureCoord_9_0_15, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_9_0_16 = textureCoords_9_0.elementAt(16);
      expect(textureCoord_9_0_16, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_9_0_17 = textureCoords_9_0.elementAt(17);
      expect(textureCoord_9_0_17, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_9_0_18 = textureCoords_9_0.elementAt(18);
      expect(textureCoord_9_0_18, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_9_0_19 = textureCoords_9_0.elementAt(19);
      expect(textureCoord_9_0_19, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_9_0_20 = textureCoords_9_0.elementAt(20);
      expect(textureCoord_9_0_20, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_9_0_21 = textureCoords_9_0.elementAt(21);
      expect(textureCoord_9_0_21, vector3MoreOrLessEquals(Vector3(0, 0.333333, 0)));
      final textureCoord_9_0_22 = textureCoords_9_0.elementAt(22);
      expect(textureCoord_9_0_22, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_9_0_23 = textureCoords_9_0.elementAt(23);
      expect(textureCoord_9_0_23, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_9_0_24 = textureCoords_9_0.elementAt(24);
      expect(textureCoord_9_0_24, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_9_0_25 = textureCoords_9_0.elementAt(25);
      expect(textureCoord_9_0_25, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_9_0_26 = textureCoords_9_0.elementAt(26);
      expect(textureCoord_9_0_26, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_9_0_27 = textureCoords_9_0.elementAt(27);
      expect(textureCoord_9_0_27, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_9_0_28 = textureCoords_9_0.elementAt(28);
      expect(textureCoord_9_0_28, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_9_0_29 = textureCoords_9_0.elementAt(29);
      expect(textureCoord_9_0_29, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_9_0_30 = textureCoords_9_0.elementAt(30);
      expect(textureCoord_9_0_30, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_9_0_31 = textureCoords_9_0.elementAt(31);
      expect(textureCoord_9_0_31, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_9_0_32 = textureCoords_9_0.elementAt(32);
      expect(textureCoord_9_0_32, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_9_0_33 = textureCoords_9_0.elementAt(33);
      expect(textureCoord_9_0_33, vector3MoreOrLessEquals(Vector3(0, 0.666667, 0)));
      final textureCoord_9_0_34 = textureCoords_9_0.elementAt(34);
      expect(textureCoord_9_0_34, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_9_0_35 = textureCoords_9_0.elementAt(35);
      expect(textureCoord_9_0_35, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_9_0_36 = textureCoords_9_0.elementAt(36);
      expect(textureCoord_9_0_36, vector3MoreOrLessEquals(Vector3(0, 0.833333, 0)));
      final textureCoord_9_0_37 = textureCoords_9_0.elementAt(37);
      expect(textureCoord_9_0_37, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_38 = textureCoords_9_0.elementAt(38);
      expect(textureCoord_9_0_38, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_9_0_39 = textureCoords_9_0.elementAt(39);
      expect(textureCoord_9_0_39, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_40 = textureCoords_9_0.elementAt(40);
      expect(textureCoord_9_0_40, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_9_0_41 = textureCoords_9_0.elementAt(41);
      expect(textureCoord_9_0_41, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_9_0_42 = textureCoords_9_0.elementAt(42);
      expect(textureCoord_9_0_42, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_43 = textureCoords_9_0.elementAt(43);
      expect(textureCoord_9_0_43, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_44 = textureCoords_9_0.elementAt(44);
      expect(textureCoord_9_0_44, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_45 = textureCoords_9_0.elementAt(45);
      expect(textureCoord_9_0_45, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_46 = textureCoords_9_0.elementAt(46);
      expect(textureCoord_9_0_46, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_47 = textureCoords_9_0.elementAt(47);
      expect(textureCoord_9_0_47, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_48 = textureCoords_9_0.elementAt(48);
      expect(textureCoord_9_0_48, vector3MoreOrLessEquals(Vector3(0.142857, 0, 0)));
      final textureCoord_9_0_49 = textureCoords_9_0.elementAt(49);
      expect(textureCoord_9_0_49, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_9_0_50 = textureCoords_9_0.elementAt(50);
      expect(textureCoord_9_0_50, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_9_0_51 = textureCoords_9_0.elementAt(51);
      expect(textureCoord_9_0_51, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_9_0_52 = textureCoords_9_0.elementAt(52);
      expect(textureCoord_9_0_52, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_9_0_53 = textureCoords_9_0.elementAt(53);
      expect(textureCoord_9_0_53, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_9_0_54 = textureCoords_9_0.elementAt(54);
      expect(textureCoord_9_0_54, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_9_0_55 = textureCoords_9_0.elementAt(55);
      expect(textureCoord_9_0_55, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_9_0_56 = textureCoords_9_0.elementAt(56);
      expect(textureCoord_9_0_56, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_9_0_57 = textureCoords_9_0.elementAt(57);
      expect(textureCoord_9_0_57, vector3MoreOrLessEquals(Vector3(0.142857, 0.166667, 0)));
      final textureCoord_9_0_58 = textureCoords_9_0.elementAt(58);
      expect(textureCoord_9_0_58, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_9_0_59 = textureCoords_9_0.elementAt(59);
      expect(textureCoord_9_0_59, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_9_0_60 = textureCoords_9_0.elementAt(60);
      expect(textureCoord_9_0_60, vector3MoreOrLessEquals(Vector3(0.142857, 0.333333, 0)));
      final textureCoord_9_0_61 = textureCoords_9_0.elementAt(61);
      expect(textureCoord_9_0_61, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_9_0_62 = textureCoords_9_0.elementAt(62);
      expect(textureCoord_9_0_62, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_9_0_63 = textureCoords_9_0.elementAt(63);
      expect(textureCoord_9_0_63, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_9_0_64 = textureCoords_9_0.elementAt(64);
      expect(textureCoord_9_0_64, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_9_0_65 = textureCoords_9_0.elementAt(65);
      expect(textureCoord_9_0_65, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_9_0_66 = textureCoords_9_0.elementAt(66);
      expect(textureCoord_9_0_66, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_9_0_67 = textureCoords_9_0.elementAt(67);
      expect(textureCoord_9_0_67, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_9_0_68 = textureCoords_9_0.elementAt(68);
      expect(textureCoord_9_0_68, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_9_0_69 = textureCoords_9_0.elementAt(69);
      expect(textureCoord_9_0_69, vector3MoreOrLessEquals(Vector3(0.142857, 0.5, 0)));
      final textureCoord_9_0_70 = textureCoords_9_0.elementAt(70);
      expect(textureCoord_9_0_70, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_9_0_71 = textureCoords_9_0.elementAt(71);
      expect(textureCoord_9_0_71, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_9_0_72 = textureCoords_9_0.elementAt(72);
      expect(textureCoord_9_0_72, vector3MoreOrLessEquals(Vector3(0.142857, 0.666667, 0)));
      final textureCoord_9_0_73 = textureCoords_9_0.elementAt(73);
      expect(textureCoord_9_0_73, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_9_0_74 = textureCoords_9_0.elementAt(74);
      expect(textureCoord_9_0_74, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_9_0_75 = textureCoords_9_0.elementAt(75);
      expect(textureCoord_9_0_75, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_9_0_76 = textureCoords_9_0.elementAt(76);
      expect(textureCoord_9_0_76, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_9_0_77 = textureCoords_9_0.elementAt(77);
      expect(textureCoord_9_0_77, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_9_0_78 = textureCoords_9_0.elementAt(78);
      expect(textureCoord_9_0_78, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_9_0_79 = textureCoords_9_0.elementAt(79);
      expect(textureCoord_9_0_79, vector3MoreOrLessEquals(Vector3(0.142857, 1, 0)));
      final textureCoord_9_0_80 = textureCoords_9_0.elementAt(80);
      expect(textureCoord_9_0_80, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_9_0_81 = textureCoords_9_0.elementAt(81);
      expect(textureCoord_9_0_81, vector3MoreOrLessEquals(Vector3(0.142857, 0.833333, 0)));
      final textureCoord_9_0_82 = textureCoords_9_0.elementAt(82);
      expect(textureCoord_9_0_82, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_9_0_83 = textureCoords_9_0.elementAt(83);
      expect(textureCoord_9_0_83, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_9_0_84 = textureCoords_9_0.elementAt(84);
      expect(textureCoord_9_0_84, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_85 = textureCoords_9_0.elementAt(85);
      expect(textureCoord_9_0_85, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_86 = textureCoords_9_0.elementAt(86);
      expect(textureCoord_9_0_86, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_87 = textureCoords_9_0.elementAt(87);
      expect(textureCoord_9_0_87, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_88 = textureCoords_9_0.elementAt(88);
      expect(textureCoord_9_0_88, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_89 = textureCoords_9_0.elementAt(89);
      expect(textureCoord_9_0_89, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_90 = textureCoords_9_0.elementAt(90);
      expect(textureCoord_9_0_90, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_9_0_91 = textureCoords_9_0.elementAt(91);
      expect(textureCoord_9_0_91, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_9_0_92 = textureCoords_9_0.elementAt(92);
      expect(textureCoord_9_0_92, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_9_0_93 = textureCoords_9_0.elementAt(93);
      expect(textureCoord_9_0_93, vector3MoreOrLessEquals(Vector3(0.285714, 0, 0)));
      final textureCoord_9_0_94 = textureCoords_9_0.elementAt(94);
      expect(textureCoord_9_0_94, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_9_0_95 = textureCoords_9_0.elementAt(95);
      expect(textureCoord_9_0_95, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_9_0_96 = textureCoords_9_0.elementAt(96);
      expect(textureCoord_9_0_96, vector3MoreOrLessEquals(Vector3(0.285714, 0.166667, 0)));
      final textureCoord_9_0_97 = textureCoords_9_0.elementAt(97);
      expect(textureCoord_9_0_97, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_9_0_98 = textureCoords_9_0.elementAt(98);
      expect(textureCoord_9_0_98, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_9_0_99 = textureCoords_9_0.elementAt(99);
      expect(textureCoord_9_0_99, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_9_0_100 = textureCoords_9_0.elementAt(100);
      expect(textureCoord_9_0_100, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_9_0_101 = textureCoords_9_0.elementAt(101);
      expect(textureCoord_9_0_101, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_9_0_102 = textureCoords_9_0.elementAt(102);
      expect(textureCoord_9_0_102, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_9_0_103 = textureCoords_9_0.elementAt(103);
      expect(textureCoord_9_0_103, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_9_0_104 = textureCoords_9_0.elementAt(104);
      expect(textureCoord_9_0_104, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_9_0_105 = textureCoords_9_0.elementAt(105);
      expect(textureCoord_9_0_105, vector3MoreOrLessEquals(Vector3(0.285714, 0.333333, 0)));
      final textureCoord_9_0_106 = textureCoords_9_0.elementAt(106);
      expect(textureCoord_9_0_106, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_9_0_107 = textureCoords_9_0.elementAt(107);
      expect(textureCoord_9_0_107, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_9_0_108 = textureCoords_9_0.elementAt(108);
      expect(textureCoord_9_0_108, vector3MoreOrLessEquals(Vector3(0.285714, 0.5, 0)));
      final textureCoord_9_0_109 = textureCoords_9_0.elementAt(109);
      expect(textureCoord_9_0_109, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_9_0_110 = textureCoords_9_0.elementAt(110);
      expect(textureCoord_9_0_110, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_9_0_111 = textureCoords_9_0.elementAt(111);
      expect(textureCoord_9_0_111, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_9_0_112 = textureCoords_9_0.elementAt(112);
      expect(textureCoord_9_0_112, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_9_0_113 = textureCoords_9_0.elementAt(113);
      expect(textureCoord_9_0_113, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_9_0_114 = textureCoords_9_0.elementAt(114);
      expect(textureCoord_9_0_114, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_9_0_115 = textureCoords_9_0.elementAt(115);
      expect(textureCoord_9_0_115, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_9_0_116 = textureCoords_9_0.elementAt(116);
      expect(textureCoord_9_0_116, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_9_0_117 = textureCoords_9_0.elementAt(117);
      expect(textureCoord_9_0_117, vector3MoreOrLessEquals(Vector3(0.285714, 0.666667, 0)));
      final textureCoord_9_0_118 = textureCoords_9_0.elementAt(118);
      expect(textureCoord_9_0_118, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_9_0_119 = textureCoords_9_0.elementAt(119);
      expect(textureCoord_9_0_119, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_9_0_120 = textureCoords_9_0.elementAt(120);
      expect(textureCoord_9_0_120, vector3MoreOrLessEquals(Vector3(0.285714, 0.833333, 0)));
      final textureCoord_9_0_121 = textureCoords_9_0.elementAt(121);
      expect(textureCoord_9_0_121, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_9_0_122 = textureCoords_9_0.elementAt(122);
      expect(textureCoord_9_0_122, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_9_0_123 = textureCoords_9_0.elementAt(123);
      expect(textureCoord_9_0_123, vector3MoreOrLessEquals(Vector3(0.285714, 1, 0)));
      final textureCoord_9_0_124 = textureCoords_9_0.elementAt(124);
      expect(textureCoord_9_0_124, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_9_0_125 = textureCoords_9_0.elementAt(125);
      expect(textureCoord_9_0_125, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_9_0_126 = textureCoords_9_0.elementAt(126);
      expect(textureCoord_9_0_126, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_127 = textureCoords_9_0.elementAt(127);
      expect(textureCoord_9_0_127, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_128 = textureCoords_9_0.elementAt(128);
      expect(textureCoord_9_0_128, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_129 = textureCoords_9_0.elementAt(129);
      expect(textureCoord_9_0_129, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_130 = textureCoords_9_0.elementAt(130);
      expect(textureCoord_9_0_130, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_131 = textureCoords_9_0.elementAt(131);
      expect(textureCoord_9_0_131, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_132 = textureCoords_9_0.elementAt(132);
      expect(textureCoord_9_0_132, vector3MoreOrLessEquals(Vector3(0.428571, 0, 0)));
      final textureCoord_9_0_133 = textureCoords_9_0.elementAt(133);
      expect(textureCoord_9_0_133, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_9_0_134 = textureCoords_9_0.elementAt(134);
      expect(textureCoord_9_0_134, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_9_0_135 = textureCoords_9_0.elementAt(135);
      expect(textureCoord_9_0_135, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_9_0_136 = textureCoords_9_0.elementAt(136);
      expect(textureCoord_9_0_136, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_9_0_137 = textureCoords_9_0.elementAt(137);
      expect(textureCoord_9_0_137, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_9_0_138 = textureCoords_9_0.elementAt(138);
      expect(textureCoord_9_0_138, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_9_0_139 = textureCoords_9_0.elementAt(139);
      expect(textureCoord_9_0_139, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_9_0_140 = textureCoords_9_0.elementAt(140);
      expect(textureCoord_9_0_140, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_9_0_141 = textureCoords_9_0.elementAt(141);
      expect(textureCoord_9_0_141, vector3MoreOrLessEquals(Vector3(0.428571, 0.166667, 0)));
      final textureCoord_9_0_142 = textureCoords_9_0.elementAt(142);
      expect(textureCoord_9_0_142, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_9_0_143 = textureCoords_9_0.elementAt(143);
      expect(textureCoord_9_0_143, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_9_0_144 = textureCoords_9_0.elementAt(144);
      expect(textureCoord_9_0_144, vector3MoreOrLessEquals(Vector3(0.428571, 0.333333, 0)));
      final textureCoord_9_0_145 = textureCoords_9_0.elementAt(145);
      expect(textureCoord_9_0_145, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_9_0_146 = textureCoords_9_0.elementAt(146);
      expect(textureCoord_9_0_146, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_9_0_147 = textureCoords_9_0.elementAt(147);
      expect(textureCoord_9_0_147, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_9_0_148 = textureCoords_9_0.elementAt(148);
      expect(textureCoord_9_0_148, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_9_0_149 = textureCoords_9_0.elementAt(149);
      expect(textureCoord_9_0_149, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_9_0_150 = textureCoords_9_0.elementAt(150);
      expect(textureCoord_9_0_150, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_9_0_151 = textureCoords_9_0.elementAt(151);
      expect(textureCoord_9_0_151, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_9_0_152 = textureCoords_9_0.elementAt(152);
      expect(textureCoord_9_0_152, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_9_0_153 = textureCoords_9_0.elementAt(153);
      expect(textureCoord_9_0_153, vector3MoreOrLessEquals(Vector3(0.428571, 0.5, 0)));
      final textureCoord_9_0_154 = textureCoords_9_0.elementAt(154);
      expect(textureCoord_9_0_154, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_9_0_155 = textureCoords_9_0.elementAt(155);
      expect(textureCoord_9_0_155, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_9_0_156 = textureCoords_9_0.elementAt(156);
      expect(textureCoord_9_0_156, vector3MoreOrLessEquals(Vector3(0.428571, 0.666667, 0)));
      final textureCoord_9_0_157 = textureCoords_9_0.elementAt(157);
      expect(textureCoord_9_0_157, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_9_0_158 = textureCoords_9_0.elementAt(158);
      expect(textureCoord_9_0_158, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_9_0_159 = textureCoords_9_0.elementAt(159);
      expect(textureCoord_9_0_159, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_9_0_160 = textureCoords_9_0.elementAt(160);
      expect(textureCoord_9_0_160, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_9_0_161 = textureCoords_9_0.elementAt(161);
      expect(textureCoord_9_0_161, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_9_0_162 = textureCoords_9_0.elementAt(162);
      expect(textureCoord_9_0_162, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_9_0_163 = textureCoords_9_0.elementAt(163);
      expect(textureCoord_9_0_163, vector3MoreOrLessEquals(Vector3(0.428571, 1, 0)));
      final textureCoord_9_0_164 = textureCoords_9_0.elementAt(164);
      expect(textureCoord_9_0_164, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_9_0_165 = textureCoords_9_0.elementAt(165);
      expect(textureCoord_9_0_165, vector3MoreOrLessEquals(Vector3(0.428571, 0.833333, 0)));
      final textureCoord_9_0_166 = textureCoords_9_0.elementAt(166);
      expect(textureCoord_9_0_166, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_9_0_167 = textureCoords_9_0.elementAt(167);
      expect(textureCoord_9_0_167, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_9_0_168 = textureCoords_9_0.elementAt(168);
      expect(textureCoord_9_0_168, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_169 = textureCoords_9_0.elementAt(169);
      expect(textureCoord_9_0_169, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_170 = textureCoords_9_0.elementAt(170);
      expect(textureCoord_9_0_170, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_171 = textureCoords_9_0.elementAt(171);
      expect(textureCoord_9_0_171, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_172 = textureCoords_9_0.elementAt(172);
      expect(textureCoord_9_0_172, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_173 = textureCoords_9_0.elementAt(173);
      expect(textureCoord_9_0_173, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_174 = textureCoords_9_0.elementAt(174);
      expect(textureCoord_9_0_174, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_9_0_175 = textureCoords_9_0.elementAt(175);
      expect(textureCoord_9_0_175, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_9_0_176 = textureCoords_9_0.elementAt(176);
      expect(textureCoord_9_0_176, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_9_0_177 = textureCoords_9_0.elementAt(177);
      expect(textureCoord_9_0_177, vector3MoreOrLessEquals(Vector3(0.571429, 0, 0)));
      final textureCoord_9_0_178 = textureCoords_9_0.elementAt(178);
      expect(textureCoord_9_0_178, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_9_0_179 = textureCoords_9_0.elementAt(179);
      expect(textureCoord_9_0_179, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_9_0_180 = textureCoords_9_0.elementAt(180);
      expect(textureCoord_9_0_180, vector3MoreOrLessEquals(Vector3(0.571429, 0.166667, 0)));
      final textureCoord_9_0_181 = textureCoords_9_0.elementAt(181);
      expect(textureCoord_9_0_181, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_9_0_182 = textureCoords_9_0.elementAt(182);
      expect(textureCoord_9_0_182, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_9_0_183 = textureCoords_9_0.elementAt(183);
      expect(textureCoord_9_0_183, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_9_0_184 = textureCoords_9_0.elementAt(184);
      expect(textureCoord_9_0_184, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_9_0_185 = textureCoords_9_0.elementAt(185);
      expect(textureCoord_9_0_185, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_9_0_186 = textureCoords_9_0.elementAt(186);
      expect(textureCoord_9_0_186, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_9_0_187 = textureCoords_9_0.elementAt(187);
      expect(textureCoord_9_0_187, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_9_0_188 = textureCoords_9_0.elementAt(188);
      expect(textureCoord_9_0_188, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_9_0_189 = textureCoords_9_0.elementAt(189);
      expect(textureCoord_9_0_189, vector3MoreOrLessEquals(Vector3(0.571429, 0.333333, 0)));
      final textureCoord_9_0_190 = textureCoords_9_0.elementAt(190);
      expect(textureCoord_9_0_190, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_9_0_191 = textureCoords_9_0.elementAt(191);
      expect(textureCoord_9_0_191, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_9_0_192 = textureCoords_9_0.elementAt(192);
      expect(textureCoord_9_0_192, vector3MoreOrLessEquals(Vector3(0.571429, 0.5, 0)));
      final textureCoord_9_0_193 = textureCoords_9_0.elementAt(193);
      expect(textureCoord_9_0_193, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_9_0_194 = textureCoords_9_0.elementAt(194);
      expect(textureCoord_9_0_194, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_9_0_195 = textureCoords_9_0.elementAt(195);
      expect(textureCoord_9_0_195, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_9_0_196 = textureCoords_9_0.elementAt(196);
      expect(textureCoord_9_0_196, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_9_0_197 = textureCoords_9_0.elementAt(197);
      expect(textureCoord_9_0_197, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_9_0_198 = textureCoords_9_0.elementAt(198);
      expect(textureCoord_9_0_198, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_9_0_199 = textureCoords_9_0.elementAt(199);
      expect(textureCoord_9_0_199, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_9_0_200 = textureCoords_9_0.elementAt(200);
      expect(textureCoord_9_0_200, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_9_0_201 = textureCoords_9_0.elementAt(201);
      expect(textureCoord_9_0_201, vector3MoreOrLessEquals(Vector3(0.571429, 0.666667, 0)));
      final textureCoord_9_0_202 = textureCoords_9_0.elementAt(202);
      expect(textureCoord_9_0_202, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_9_0_203 = textureCoords_9_0.elementAt(203);
      expect(textureCoord_9_0_203, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_9_0_204 = textureCoords_9_0.elementAt(204);
      expect(textureCoord_9_0_204, vector3MoreOrLessEquals(Vector3(0.571429, 0.833333, 0)));
      final textureCoord_9_0_205 = textureCoords_9_0.elementAt(205);
      expect(textureCoord_9_0_205, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_9_0_206 = textureCoords_9_0.elementAt(206);
      expect(textureCoord_9_0_206, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_9_0_207 = textureCoords_9_0.elementAt(207);
      expect(textureCoord_9_0_207, vector3MoreOrLessEquals(Vector3(0.571429, 1, 0)));
      final textureCoord_9_0_208 = textureCoords_9_0.elementAt(208);
      expect(textureCoord_9_0_208, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_9_0_209 = textureCoords_9_0.elementAt(209);
      expect(textureCoord_9_0_209, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_9_0_210 = textureCoords_9_0.elementAt(210);
      expect(textureCoord_9_0_210, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_211 = textureCoords_9_0.elementAt(211);
      expect(textureCoord_9_0_211, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_212 = textureCoords_9_0.elementAt(212);
      expect(textureCoord_9_0_212, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_213 = textureCoords_9_0.elementAt(213);
      expect(textureCoord_9_0_213, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_214 = textureCoords_9_0.elementAt(214);
      expect(textureCoord_9_0_214, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_215 = textureCoords_9_0.elementAt(215);
      expect(textureCoord_9_0_215, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_216 = textureCoords_9_0.elementAt(216);
      expect(textureCoord_9_0_216, vector3MoreOrLessEquals(Vector3(0.714286, 0, 0)));
      final textureCoord_9_0_217 = textureCoords_9_0.elementAt(217);
      expect(textureCoord_9_0_217, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_9_0_218 = textureCoords_9_0.elementAt(218);
      expect(textureCoord_9_0_218, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_9_0_219 = textureCoords_9_0.elementAt(219);
      expect(textureCoord_9_0_219, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_9_0_220 = textureCoords_9_0.elementAt(220);
      expect(textureCoord_9_0_220, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_9_0_221 = textureCoords_9_0.elementAt(221);
      expect(textureCoord_9_0_221, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_9_0_222 = textureCoords_9_0.elementAt(222);
      expect(textureCoord_9_0_222, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_9_0_223 = textureCoords_9_0.elementAt(223);
      expect(textureCoord_9_0_223, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_9_0_224 = textureCoords_9_0.elementAt(224);
      expect(textureCoord_9_0_224, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_9_0_225 = textureCoords_9_0.elementAt(225);
      expect(textureCoord_9_0_225, vector3MoreOrLessEquals(Vector3(0.714286, 0.166667, 0)));
      final textureCoord_9_0_226 = textureCoords_9_0.elementAt(226);
      expect(textureCoord_9_0_226, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_9_0_227 = textureCoords_9_0.elementAt(227);
      expect(textureCoord_9_0_227, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_9_0_228 = textureCoords_9_0.elementAt(228);
      expect(textureCoord_9_0_228, vector3MoreOrLessEquals(Vector3(0.714286, 0.333333, 0)));
      final textureCoord_9_0_229 = textureCoords_9_0.elementAt(229);
      expect(textureCoord_9_0_229, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_9_0_230 = textureCoords_9_0.elementAt(230);
      expect(textureCoord_9_0_230, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_9_0_231 = textureCoords_9_0.elementAt(231);
      expect(textureCoord_9_0_231, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_9_0_232 = textureCoords_9_0.elementAt(232);
      expect(textureCoord_9_0_232, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_9_0_233 = textureCoords_9_0.elementAt(233);
      expect(textureCoord_9_0_233, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_9_0_234 = textureCoords_9_0.elementAt(234);
      expect(textureCoord_9_0_234, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_9_0_235 = textureCoords_9_0.elementAt(235);
      expect(textureCoord_9_0_235, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_9_0_236 = textureCoords_9_0.elementAt(236);
      expect(textureCoord_9_0_236, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_9_0_237 = textureCoords_9_0.elementAt(237);
      expect(textureCoord_9_0_237, vector3MoreOrLessEquals(Vector3(0.714286, 0.5, 0)));
      final textureCoord_9_0_238 = textureCoords_9_0.elementAt(238);
      expect(textureCoord_9_0_238, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_9_0_239 = textureCoords_9_0.elementAt(239);
      expect(textureCoord_9_0_239, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_9_0_240 = textureCoords_9_0.elementAt(240);
      expect(textureCoord_9_0_240, vector3MoreOrLessEquals(Vector3(0.714286, 0.666667, 0)));
      final textureCoord_9_0_241 = textureCoords_9_0.elementAt(241);
      expect(textureCoord_9_0_241, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_9_0_242 = textureCoords_9_0.elementAt(242);
      expect(textureCoord_9_0_242, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_9_0_243 = textureCoords_9_0.elementAt(243);
      expect(textureCoord_9_0_243, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_9_0_244 = textureCoords_9_0.elementAt(244);
      expect(textureCoord_9_0_244, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_9_0_245 = textureCoords_9_0.elementAt(245);
      expect(textureCoord_9_0_245, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_9_0_246 = textureCoords_9_0.elementAt(246);
      expect(textureCoord_9_0_246, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_9_0_247 = textureCoords_9_0.elementAt(247);
      expect(textureCoord_9_0_247, vector3MoreOrLessEquals(Vector3(0.714286, 1, 0)));
      final textureCoord_9_0_248 = textureCoords_9_0.elementAt(248);
      expect(textureCoord_9_0_248, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_9_0_249 = textureCoords_9_0.elementAt(249);
      expect(textureCoord_9_0_249, vector3MoreOrLessEquals(Vector3(0.714286, 0.833333, 0)));
      final textureCoord_9_0_250 = textureCoords_9_0.elementAt(250);
      expect(textureCoord_9_0_250, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_9_0_251 = textureCoords_9_0.elementAt(251);
      expect(textureCoord_9_0_251, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_9_0_252 = textureCoords_9_0.elementAt(252);
      expect(textureCoord_9_0_252, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_253 = textureCoords_9_0.elementAt(253);
      expect(textureCoord_9_0_253, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_254 = textureCoords_9_0.elementAt(254);
      expect(textureCoord_9_0_254, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_255 = textureCoords_9_0.elementAt(255);
      expect(textureCoord_9_0_255, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_256 = textureCoords_9_0.elementAt(256);
      expect(textureCoord_9_0_256, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_257 = textureCoords_9_0.elementAt(257);
      expect(textureCoord_9_0_257, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_9_0_258 = textureCoords_9_0.elementAt(258);
      expect(textureCoord_9_0_258, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_9_0_259 = textureCoords_9_0.elementAt(259);
      expect(textureCoord_9_0_259, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_9_0_260 = textureCoords_9_0.elementAt(260);
      expect(textureCoord_9_0_260, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_9_0_261 = textureCoords_9_0.elementAt(261);
      expect(textureCoord_9_0_261, vector3MoreOrLessEquals(Vector3(0.857143, 0, 0)));
      final textureCoord_9_0_262 = textureCoords_9_0.elementAt(262);
      expect(textureCoord_9_0_262, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_9_0_263 = textureCoords_9_0.elementAt(263);
      expect(textureCoord_9_0_263, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_9_0_264 = textureCoords_9_0.elementAt(264);
      expect(textureCoord_9_0_264, vector3MoreOrLessEquals(Vector3(0.857143, 0.166667, 0)));
      final textureCoord_9_0_265 = textureCoords_9_0.elementAt(265);
      expect(textureCoord_9_0_265, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_9_0_266 = textureCoords_9_0.elementAt(266);
      expect(textureCoord_9_0_266, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_9_0_267 = textureCoords_9_0.elementAt(267);
      expect(textureCoord_9_0_267, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_9_0_268 = textureCoords_9_0.elementAt(268);
      expect(textureCoord_9_0_268, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_9_0_269 = textureCoords_9_0.elementAt(269);
      expect(textureCoord_9_0_269, vector3MoreOrLessEquals(Vector3(1, 0.166667, 0)));
      final textureCoord_9_0_270 = textureCoords_9_0.elementAt(270);
      expect(textureCoord_9_0_270, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_9_0_271 = textureCoords_9_0.elementAt(271);
      expect(textureCoord_9_0_271, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_9_0_272 = textureCoords_9_0.elementAt(272);
      expect(textureCoord_9_0_272, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_9_0_273 = textureCoords_9_0.elementAt(273);
      expect(textureCoord_9_0_273, vector3MoreOrLessEquals(Vector3(0.857143, 0.333333, 0)));
      final textureCoord_9_0_274 = textureCoords_9_0.elementAt(274);
      expect(textureCoord_9_0_274, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_9_0_275 = textureCoords_9_0.elementAt(275);
      expect(textureCoord_9_0_275, vector3MoreOrLessEquals(Vector3(1, 0.333333, 0)));
      final textureCoord_9_0_276 = textureCoords_9_0.elementAt(276);
      expect(textureCoord_9_0_276, vector3MoreOrLessEquals(Vector3(0.857143, 0.5, 0)));
      final textureCoord_9_0_277 = textureCoords_9_0.elementAt(277);
      expect(textureCoord_9_0_277, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_9_0_278 = textureCoords_9_0.elementAt(278);
      expect(textureCoord_9_0_278, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_9_0_279 = textureCoords_9_0.elementAt(279);
      expect(textureCoord_9_0_279, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_9_0_280 = textureCoords_9_0.elementAt(280);
      expect(textureCoord_9_0_280, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_9_0_281 = textureCoords_9_0.elementAt(281);
      expect(textureCoord_9_0_281, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_9_0_282 = textureCoords_9_0.elementAt(282);
      expect(textureCoord_9_0_282, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_9_0_283 = textureCoords_9_0.elementAt(283);
      expect(textureCoord_9_0_283, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_9_0_284 = textureCoords_9_0.elementAt(284);
      expect(textureCoord_9_0_284, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_9_0_285 = textureCoords_9_0.elementAt(285);
      expect(textureCoord_9_0_285, vector3MoreOrLessEquals(Vector3(0.857143, 0.666667, 0)));
      final textureCoord_9_0_286 = textureCoords_9_0.elementAt(286);
      expect(textureCoord_9_0_286, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_9_0_287 = textureCoords_9_0.elementAt(287);
      expect(textureCoord_9_0_287, vector3MoreOrLessEquals(Vector3(1, 0.666667, 0)));
      final textureCoord_9_0_288 = textureCoords_9_0.elementAt(288);
      expect(textureCoord_9_0_288, vector3MoreOrLessEquals(Vector3(0.857143, 0.833333, 0)));
      final textureCoord_9_0_289 = textureCoords_9_0.elementAt(289);
      expect(textureCoord_9_0_289, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_9_0_290 = textureCoords_9_0.elementAt(290);
      expect(textureCoord_9_0_290, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      final textureCoord_9_0_291 = textureCoords_9_0.elementAt(291);
      expect(textureCoord_9_0_291, vector3MoreOrLessEquals(Vector3(0.857143, 1, 0)));
      final textureCoord_9_0_292 = textureCoords_9_0.elementAt(292);
      expect(textureCoord_9_0_292, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_9_0_293 = textureCoords_9_0.elementAt(293);
      expect(textureCoord_9_0_293, vector3MoreOrLessEquals(Vector3(1, 0.833333, 0)));
      expect(mesh_9.uvComponents.length, equals(1));
      expect(mesh_9.uvComponents, equals([2]));
      expect(mesh_9.faces.length, equals(98));
      expect(mesh_9.bones.length, isZero);
      expect(mesh_9.materialIndex, equals(4));
      expect(mesh_9.name, equals('Bein4Li'));
      expect(mesh_9.animMeshes.length, isZero);
      expect(mesh_9.morphingMethod, isZero);
      expect(mesh_9.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_10 = meshes.elementAt(10);
      expect(mesh_10.primitiveTypes, equals(4));
      expect(mesh_10.vertices.length, equals(126));
      final vertex_10_0 = mesh_10.vertices.elementAt(0);
      expect(vertex_10_0, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_1 = mesh_10.vertices.elementAt(1);
      expect(vertex_10_1, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_2 = mesh_10.vertices.elementAt(2);
      expect(vertex_10_2, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_3 = mesh_10.vertices.elementAt(3);
      expect(vertex_10_3, vector3MoreOrLessEquals(Vector3(-61.4965, 6.34016, -5.81228)));
      final vertex_10_4 = mesh_10.vertices.elementAt(4);
      expect(vertex_10_4, vector3MoreOrLessEquals(Vector3(-62.9869, 9.87084, -6.30849)));
      final vertex_10_5 = mesh_10.vertices.elementAt(5);
      expect(vertex_10_5, vector3MoreOrLessEquals(Vector3(-61.4476, 8.1901, -3.64704)));
      final vertex_10_6 = mesh_10.vertices.elementAt(6);
      expect(vertex_10_6, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_7 = mesh_10.vertices.elementAt(7);
      expect(vertex_10_7, vector3MoreOrLessEquals(Vector3(-63.9712, 3.6617, -3.83047)));
      final vertex_10_8 = mesh_10.vertices.elementAt(8);
      expect(vertex_10_8, vector3MoreOrLessEquals(Vector3(-64.846, 4.36871, -2.07566)));
      final vertex_10_9 = mesh_10.vertices.elementAt(9);
      expect(vertex_10_9, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_10 = mesh_10.vertices.elementAt(10);
      expect(vertex_10_10, vector3MoreOrLessEquals(Vector3(-64.846, 4.36871, -2.07566)));
      final vertex_10_11 = mesh_10.vertices.elementAt(11);
      expect(vertex_10_11, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_12 = mesh_10.vertices.elementAt(12);
      expect(vertex_10_12, vector3MoreOrLessEquals(Vector3(-63.9712, 3.6617, -3.83047)));
      final vertex_10_13 = mesh_10.vertices.elementAt(13);
      expect(vertex_10_13, vector3MoreOrLessEquals(Vector3(-61.4965, 6.34016, -5.81228)));
      final vertex_10_14 = mesh_10.vertices.elementAt(14);
      expect(vertex_10_14, vector3MoreOrLessEquals(Vector3(-64.846, 4.36871, -2.07566)));
      final vertex_10_15 = mesh_10.vertices.elementAt(15);
      expect(vertex_10_15, vector3MoreOrLessEquals(Vector3(-61.4965, 6.34016, -5.81228)));
      final vertex_10_16 = mesh_10.vertices.elementAt(16);
      expect(vertex_10_16, vector3MoreOrLessEquals(Vector3(-61.4476, 8.1901, -3.64704)));
      final vertex_10_17 = mesh_10.vertices.elementAt(17);
      expect(vertex_10_17, vector3MoreOrLessEquals(Vector3(-64.846, 4.36871, -2.07566)));
      final vertex_10_18 = mesh_10.vertices.elementAt(18);
      expect(vertex_10_18, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_19 = mesh_10.vertices.elementAt(19);
      expect(vertex_10_19, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_20 = mesh_10.vertices.elementAt(20);
      expect(vertex_10_20, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_21 = mesh_10.vertices.elementAt(21);
      expect(vertex_10_21, vector3MoreOrLessEquals(Vector3(-61.4476, 8.1901, -3.64704)));
      final vertex_10_22 = mesh_10.vertices.elementAt(22);
      expect(vertex_10_22, vector3MoreOrLessEquals(Vector3(-62.9869, 9.87084, -6.30849)));
      final vertex_10_23 = mesh_10.vertices.elementAt(23);
      expect(vertex_10_23, vector3MoreOrLessEquals(Vector3(-62.5578, 11.3056, -3.48591)));
      final vertex_10_24 = mesh_10.vertices.elementAt(24);
      expect(vertex_10_24, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_25 = mesh_10.vertices.elementAt(25);
      expect(vertex_10_25, vector3MoreOrLessEquals(Vector3(-64.846, 4.36871, -2.07566)));
      final vertex_10_26 = mesh_10.vertices.elementAt(26);
      expect(vertex_10_26, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_27 = mesh_10.vertices.elementAt(27);
      expect(vertex_10_27, vector3MoreOrLessEquals(Vector3(-64.846, 4.36871, -2.07566)));
      final vertex_10_28 = mesh_10.vertices.elementAt(28);
      expect(vertex_10_28, vector3MoreOrLessEquals(Vector3(-67.1371, 4.62209, -1.5312)));
      final vertex_10_29 = mesh_10.vertices.elementAt(29);
      expect(vertex_10_29, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_30 = mesh_10.vertices.elementAt(30);
      expect(vertex_10_30, vector3MoreOrLessEquals(Vector3(-64.846, 4.36871, -2.07566)));
      final vertex_10_31 = mesh_10.vertices.elementAt(31);
      expect(vertex_10_31, vector3MoreOrLessEquals(Vector3(-61.4476, 8.1901, -3.64704)));
      final vertex_10_32 = mesh_10.vertices.elementAt(32);
      expect(vertex_10_32, vector3MoreOrLessEquals(Vector3(-62.5578, 11.3056, -3.48591)));
      final vertex_10_33 = mesh_10.vertices.elementAt(33);
      expect(vertex_10_33, vector3MoreOrLessEquals(Vector3(-64.846, 4.36871, -2.07566)));
      final vertex_10_34 = mesh_10.vertices.elementAt(34);
      expect(vertex_10_34, vector3MoreOrLessEquals(Vector3(-62.5578, 11.3056, -3.48591)));
      final vertex_10_35 = mesh_10.vertices.elementAt(35);
      expect(vertex_10_35, vector3MoreOrLessEquals(Vector3(-67.1371, 4.62209, -1.5312)));
      final vertex_10_36 = mesh_10.vertices.elementAt(36);
      expect(vertex_10_36, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_37 = mesh_10.vertices.elementAt(37);
      expect(vertex_10_37, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_38 = mesh_10.vertices.elementAt(38);
      expect(vertex_10_38, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_39 = mesh_10.vertices.elementAt(39);
      expect(vertex_10_39, vector3MoreOrLessEquals(Vector3(-62.5578, 11.3056, -3.48591)));
      final vertex_10_40 = mesh_10.vertices.elementAt(40);
      expect(vertex_10_40, vector3MoreOrLessEquals(Vector3(-62.9869, 9.87084, -6.30849)));
      final vertex_10_41 = mesh_10.vertices.elementAt(41);
      expect(vertex_10_41, vector3MoreOrLessEquals(Vector3(-63.9911, 13.3408, -5.45025)));
      final vertex_10_42 = mesh_10.vertices.elementAt(42);
      expect(vertex_10_42, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_43 = mesh_10.vertices.elementAt(43);
      expect(vertex_10_43, vector3MoreOrLessEquals(Vector3(-67.1371, 4.62209, -1.5312)));
      final vertex_10_44 = mesh_10.vertices.elementAt(44);
      expect(vertex_10_44, vector3MoreOrLessEquals(Vector3(-69.1192, 4.23108, -2.6071)));
      final vertex_10_45 = mesh_10.vertices.elementAt(45);
      expect(vertex_10_45, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_46 = mesh_10.vertices.elementAt(46);
      expect(vertex_10_46, vector3MoreOrLessEquals(Vector3(-69.1192, 4.23108, -2.6071)));
      final vertex_10_47 = mesh_10.vertices.elementAt(47);
      expect(vertex_10_47, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_48 = mesh_10.vertices.elementAt(48);
      expect(vertex_10_48, vector3MoreOrLessEquals(Vector3(-67.1371, 4.62209, -1.5312)));
      final vertex_10_49 = mesh_10.vertices.elementAt(49);
      expect(vertex_10_49, vector3MoreOrLessEquals(Vector3(-62.5578, 11.3056, -3.48591)));
      final vertex_10_50 = mesh_10.vertices.elementAt(50);
      expect(vertex_10_50, vector3MoreOrLessEquals(Vector3(-69.1192, 4.23108, -2.6071)));
      final vertex_10_51 = mesh_10.vertices.elementAt(51);
      expect(vertex_10_51, vector3MoreOrLessEquals(Vector3(-62.5578, 11.3056, -3.48591)));
      final vertex_10_52 = mesh_10.vertices.elementAt(52);
      expect(vertex_10_52, vector3MoreOrLessEquals(Vector3(-63.9911, 13.3408, -5.45025)));
      final vertex_10_53 = mesh_10.vertices.elementAt(53);
      expect(vertex_10_53, vector3MoreOrLessEquals(Vector3(-69.1192, 4.23108, -2.6071)));
      final vertex_10_54 = mesh_10.vertices.elementAt(54);
      expect(vertex_10_54, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_55 = mesh_10.vertices.elementAt(55);
      expect(vertex_10_55, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_56 = mesh_10.vertices.elementAt(56);
      expect(vertex_10_56, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_57 = mesh_10.vertices.elementAt(57);
      expect(vertex_10_57, vector3MoreOrLessEquals(Vector3(-63.9911, 13.3408, -5.45025)));
      final vertex_10_58 = mesh_10.vertices.elementAt(58);
      expect(vertex_10_58, vector3MoreOrLessEquals(Vector3(-62.9869, 9.87084, -6.30849)));
      final vertex_10_59 = mesh_10.vertices.elementAt(59);
      expect(vertex_10_59, vector3MoreOrLessEquals(Vector3(-64.6682, 12.763, -8.06086)));
      final vertex_10_60 = mesh_10.vertices.elementAt(60);
      expect(vertex_10_60, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_61 = mesh_10.vertices.elementAt(61);
      expect(vertex_10_61, vector3MoreOrLessEquals(Vector3(-69.1192, 4.23108, -2.6071)));
      final vertex_10_62 = mesh_10.vertices.elementAt(62);
      expect(vertex_10_62, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_63 = mesh_10.vertices.elementAt(63);
      expect(vertex_10_63, vector3MoreOrLessEquals(Vector3(-69.1192, 4.23108, -2.6071)));
      final vertex_10_64 = mesh_10.vertices.elementAt(64);
      expect(vertex_10_64, vector3MoreOrLessEquals(Vector3(-69.2999, 3.49013, -4.49317)));
      final vertex_10_65 = mesh_10.vertices.elementAt(65);
      expect(vertex_10_65, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_66 = mesh_10.vertices.elementAt(66);
      expect(vertex_10_66, vector3MoreOrLessEquals(Vector3(-69.1192, 4.23108, -2.6071)));
      final vertex_10_67 = mesh_10.vertices.elementAt(67);
      expect(vertex_10_67, vector3MoreOrLessEquals(Vector3(-63.9911, 13.3408, -5.45025)));
      final vertex_10_68 = mesh_10.vertices.elementAt(68);
      expect(vertex_10_68, vector3MoreOrLessEquals(Vector3(-64.6682, 12.763, -8.06086)));
      final vertex_10_69 = mesh_10.vertices.elementAt(69);
      expect(vertex_10_69, vector3MoreOrLessEquals(Vector3(-69.1192, 4.23108, -2.6071)));
      final vertex_10_70 = mesh_10.vertices.elementAt(70);
      expect(vertex_10_70, vector3MoreOrLessEquals(Vector3(-64.6682, 12.763, -8.06086)));
      final vertex_10_71 = mesh_10.vertices.elementAt(71);
      expect(vertex_10_71, vector3MoreOrLessEquals(Vector3(-69.2999, 3.49013, -4.49317)));
      final vertex_10_72 = mesh_10.vertices.elementAt(72);
      expect(vertex_10_72, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_73 = mesh_10.vertices.elementAt(73);
      expect(vertex_10_73, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_74 = mesh_10.vertices.elementAt(74);
      expect(vertex_10_74, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_75 = mesh_10.vertices.elementAt(75);
      expect(vertex_10_75, vector3MoreOrLessEquals(Vector3(-64.6682, 12.763, -8.06086)));
      final vertex_10_76 = mesh_10.vertices.elementAt(76);
      expect(vertex_10_76, vector3MoreOrLessEquals(Vector3(-62.9869, 9.87084, -6.30849)));
      final vertex_10_77 = mesh_10.vertices.elementAt(77);
      expect(vertex_10_77, vector3MoreOrLessEquals(Vector3(-64.0793, 10.0074, -9.3519)));
      final vertex_10_78 = mesh_10.vertices.elementAt(78);
      expect(vertex_10_78, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_79 = mesh_10.vertices.elementAt(79);
      expect(vertex_10_79, vector3MoreOrLessEquals(Vector3(-69.2999, 3.49013, -4.49317)));
      final vertex_10_80 = mesh_10.vertices.elementAt(80);
      expect(vertex_10_80, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_81 = mesh_10.vertices.elementAt(81);
      expect(vertex_10_81, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_82 = mesh_10.vertices.elementAt(82);
      expect(vertex_10_82, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_83 = mesh_10.vertices.elementAt(83);
      expect(vertex_10_83, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_84 = mesh_10.vertices.elementAt(84);
      expect(vertex_10_84, vector3MoreOrLessEquals(Vector3(-69.2999, 3.49013, -4.49317)));
      final vertex_10_85 = mesh_10.vertices.elementAt(85);
      expect(vertex_10_85, vector3MoreOrLessEquals(Vector3(-64.6682, 12.763, -8.06086)));
      final vertex_10_86 = mesh_10.vertices.elementAt(86);
      expect(vertex_10_86, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_87 = mesh_10.vertices.elementAt(87);
      expect(vertex_10_87, vector3MoreOrLessEquals(Vector3(-64.6682, 12.763, -8.06086)));
      final vertex_10_88 = mesh_10.vertices.elementAt(88);
      expect(vertex_10_88, vector3MoreOrLessEquals(Vector3(-64.0793, 10.0074, -9.3519)));
      final vertex_10_89 = mesh_10.vertices.elementAt(89);
      expect(vertex_10_89, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_90 = mesh_10.vertices.elementAt(90);
      expect(vertex_10_90, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_91 = mesh_10.vertices.elementAt(91);
      expect(vertex_10_91, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_92 = mesh_10.vertices.elementAt(92);
      expect(vertex_10_92, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_93 = mesh_10.vertices.elementAt(93);
      expect(vertex_10_93, vector3MoreOrLessEquals(Vector3(-64.0793, 10.0074, -9.3519)));
      final vertex_10_94 = mesh_10.vertices.elementAt(94);
      expect(vertex_10_94, vector3MoreOrLessEquals(Vector3(-62.9869, 9.87084, -6.30849)));
      final vertex_10_95 = mesh_10.vertices.elementAt(95);
      expect(vertex_10_95, vector3MoreOrLessEquals(Vector3(-62.6678, 7.14898, -8.35118)));
      final vertex_10_96 = mesh_10.vertices.elementAt(96);
      expect(vertex_10_96, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_97 = mesh_10.vertices.elementAt(97);
      expect(vertex_10_97, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_98 = mesh_10.vertices.elementAt(98);
      expect(vertex_10_98, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_99 = mesh_10.vertices.elementAt(99);
      expect(vertex_10_99, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_100 = mesh_10.vertices.elementAt(100);
      expect(vertex_10_100, vector3MoreOrLessEquals(Vector3(-65.1715, 3.03351, -5.47424)));
      final vertex_10_101 = mesh_10.vertices.elementAt(101);
      expect(vertex_10_101, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_102 = mesh_10.vertices.elementAt(102);
      expect(vertex_10_102, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_103 = mesh_10.vertices.elementAt(103);
      expect(vertex_10_103, vector3MoreOrLessEquals(Vector3(-64.0793, 10.0074, -9.3519)));
      final vertex_10_104 = mesh_10.vertices.elementAt(104);
      expect(vertex_10_104, vector3MoreOrLessEquals(Vector3(-62.6678, 7.14898, -8.35118)));
      final vertex_10_105 = mesh_10.vertices.elementAt(105);
      expect(vertex_10_105, vector3MoreOrLessEquals(Vector3(-67.543, 2.95712, -5.76916)));
      final vertex_10_106 = mesh_10.vertices.elementAt(106);
      expect(vertex_10_106, vector3MoreOrLessEquals(Vector3(-62.6678, 7.14898, -8.35118)));
      final vertex_10_107 = mesh_10.vertices.elementAt(107);
      expect(vertex_10_107, vector3MoreOrLessEquals(Vector3(-65.1715, 3.03351, -5.47424)));
      final vertex_10_108 = mesh_10.vertices.elementAt(108);
      expect(vertex_10_108, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_109 = mesh_10.vertices.elementAt(109);
      expect(vertex_10_109, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_110 = mesh_10.vertices.elementAt(110);
      expect(vertex_10_110, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_111 = mesh_10.vertices.elementAt(111);
      expect(vertex_10_111, vector3MoreOrLessEquals(Vector3(-62.6678, 7.14898, -8.35118)));
      final vertex_10_112 = mesh_10.vertices.elementAt(112);
      expect(vertex_10_112, vector3MoreOrLessEquals(Vector3(-62.9869, 9.87084, -6.30849)));
      final vertex_10_113 = mesh_10.vertices.elementAt(113);
      expect(vertex_10_113, vector3MoreOrLessEquals(Vector3(-61.4965, 6.34016, -5.81228)));
      final vertex_10_114 = mesh_10.vertices.elementAt(114);
      expect(vertex_10_114, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_115 = mesh_10.vertices.elementAt(115);
      expect(vertex_10_115, vector3MoreOrLessEquals(Vector3(-65.1715, 3.03351, -5.47424)));
      final vertex_10_116 = mesh_10.vertices.elementAt(116);
      expect(vertex_10_116, vector3MoreOrLessEquals(Vector3(-63.9712, 3.6617, -3.83047)));
      final vertex_10_117 = mesh_10.vertices.elementAt(117);
      expect(vertex_10_117, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_118 = mesh_10.vertices.elementAt(118);
      expect(vertex_10_118, vector3MoreOrLessEquals(Vector3(-63.9712, 3.6617, -3.83047)));
      final vertex_10_119 = mesh_10.vertices.elementAt(119);
      expect(vertex_10_119, vector3MoreOrLessEquals(Vector3(-66.773, -11.8856, -0.202999)));
      final vertex_10_120 = mesh_10.vertices.elementAt(120);
      expect(vertex_10_120, vector3MoreOrLessEquals(Vector3(-65.1715, 3.03351, -5.47424)));
      final vertex_10_121 = mesh_10.vertices.elementAt(121);
      expect(vertex_10_121, vector3MoreOrLessEquals(Vector3(-62.6678, 7.14898, -8.35118)));
      final vertex_10_122 = mesh_10.vertices.elementAt(122);
      expect(vertex_10_122, vector3MoreOrLessEquals(Vector3(-63.9712, 3.6617, -3.83047)));
      final vertex_10_123 = mesh_10.vertices.elementAt(123);
      expect(vertex_10_123, vector3MoreOrLessEquals(Vector3(-62.6678, 7.14898, -8.35118)));
      final vertex_10_124 = mesh_10.vertices.elementAt(124);
      expect(vertex_10_124, vector3MoreOrLessEquals(Vector3(-61.4965, 6.34016, -5.81228)));
      final vertex_10_125 = mesh_10.vertices.elementAt(125);
      expect(vertex_10_125, vector3MoreOrLessEquals(Vector3(-63.9712, 3.6617, -3.83047)));
      expect(mesh_10.normals.length, equals(126));
      final normal_10_0 = mesh_10.normals.elementAt(0);
      expect(normal_10_0, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_1 = mesh_10.normals.elementAt(1);
      expect(normal_10_1, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_2 = mesh_10.normals.elementAt(2);
      expect(normal_10_2, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_3 = mesh_10.normals.elementAt(3);
      expect(normal_10_3, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_4 = mesh_10.normals.elementAt(4);
      expect(normal_10_4, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_5 = mesh_10.normals.elementAt(5);
      expect(normal_10_5, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_6 = mesh_10.normals.elementAt(6);
      expect(normal_10_6, vector3MoreOrLessEquals(Vector3(0.885286, -0.051708, 0.462163)));
      final normal_10_7 = mesh_10.normals.elementAt(7);
      expect(normal_10_7, vector3MoreOrLessEquals(Vector3(0.871701, -0.486404, -0.059574)));
      final normal_10_8 = mesh_10.normals.elementAt(8);
      expect(normal_10_8, vector3MoreOrLessEquals(Vector3(0.602535, -0.114023, 0.789906)));
      final normal_10_9 = mesh_10.normals.elementAt(9);
      expect(normal_10_9, vector3MoreOrLessEquals(Vector3(0.885286, -0.051708, 0.462163)));
      final normal_10_10 = mesh_10.normals.elementAt(10);
      expect(normal_10_10, vector3MoreOrLessEquals(Vector3(0.602535, -0.114023, 0.789906)));
      final normal_10_11 = mesh_10.normals.elementAt(11);
      expect(normal_10_11, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_12 = mesh_10.normals.elementAt(12);
      expect(normal_10_12, vector3MoreOrLessEquals(Vector3(0.871701, -0.486404, -0.059574)));
      final normal_10_13 = mesh_10.normals.elementAt(13);
      expect(normal_10_13, vector3MoreOrLessEquals(Vector3(0.767332, -0.613878, 0.185353)));
      final normal_10_14 = mesh_10.normals.elementAt(14);
      expect(normal_10_14, vector3MoreOrLessEquals(Vector3(0.602535, -0.114023, 0.789906)));
      final normal_10_15 = mesh_10.normals.elementAt(15);
      expect(normal_10_15, vector3MoreOrLessEquals(Vector3(0.767332, -0.613878, 0.185353)));
      final normal_10_16 = mesh_10.normals.elementAt(16);
      expect(normal_10_16, vector3MoreOrLessEquals(Vector3(0.615704, -0.238766, 0.750932)));
      final normal_10_17 = mesh_10.normals.elementAt(17);
      expect(normal_10_17, vector3MoreOrLessEquals(Vector3(0.602535, -0.114023, 0.789906)));
      final normal_10_18 = mesh_10.normals.elementAt(18);
      expect(normal_10_18, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_19 = mesh_10.normals.elementAt(19);
      expect(normal_10_19, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_20 = mesh_10.normals.elementAt(20);
      expect(normal_10_20, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_21 = mesh_10.normals.elementAt(21);
      expect(normal_10_21, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_22 = mesh_10.normals.elementAt(22);
      expect(normal_10_22, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_23 = mesh_10.normals.elementAt(23);
      expect(normal_10_23, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_24 = mesh_10.normals.elementAt(24);
      expect(normal_10_24, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_25 = mesh_10.normals.elementAt(25);
      expect(normal_10_25, vector3MoreOrLessEquals(Vector3(0.602535, -0.114023, 0.789906)));
      final normal_10_26 = mesh_10.normals.elementAt(26);
      expect(normal_10_26, vector3MoreOrLessEquals(Vector3(-0.132228, 0.076598, 0.988255)));
      final normal_10_27 = mesh_10.normals.elementAt(27);
      expect(normal_10_27, vector3MoreOrLessEquals(Vector3(0.602535, -0.114023, 0.789906)));
      final normal_10_28 = mesh_10.normals.elementAt(28);
      expect(normal_10_28, vector3MoreOrLessEquals(Vector3(-0.134483, 0.218923, 0.96643)));
      final normal_10_29 = mesh_10.normals.elementAt(29);
      expect(normal_10_29, vector3MoreOrLessEquals(Vector3(-0.132228, 0.076598, 0.988255)));
      final normal_10_30 = mesh_10.normals.elementAt(30);
      expect(normal_10_30, vector3MoreOrLessEquals(Vector3(0.602535, -0.114023, 0.789906)));
      final normal_10_31 = mesh_10.normals.elementAt(31);
      expect(normal_10_31, vector3MoreOrLessEquals(Vector3(0.615704, -0.238766, 0.750932)));
      final normal_10_32 = mesh_10.normals.elementAt(32);
      expect(normal_10_32, vector3MoreOrLessEquals(Vector3(-0.082654, 0.333036, 0.939285)));
      final normal_10_33 = mesh_10.normals.elementAt(33);
      expect(normal_10_33, vector3MoreOrLessEquals(Vector3(0.602535, -0.114023, 0.789906)));
      final normal_10_34 = mesh_10.normals.elementAt(34);
      expect(normal_10_34, vector3MoreOrLessEquals(Vector3(-0.082654, 0.333036, 0.939285)));
      final normal_10_35 = mesh_10.normals.elementAt(35);
      expect(normal_10_35, vector3MoreOrLessEquals(Vector3(-0.134483, 0.218923, 0.96643)));
      final normal_10_36 = mesh_10.normals.elementAt(36);
      expect(normal_10_36, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_37 = mesh_10.normals.elementAt(37);
      expect(normal_10_37, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_38 = mesh_10.normals.elementAt(38);
      expect(normal_10_38, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_39 = mesh_10.normals.elementAt(39);
      expect(normal_10_39, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_40 = mesh_10.normals.elementAt(40);
      expect(normal_10_40, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_41 = mesh_10.normals.elementAt(41);
      expect(normal_10_41, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_42 = mesh_10.normals.elementAt(42);
      expect(normal_10_42, vector3MoreOrLessEquals(Vector3(-0.132228, 0.076598, 0.988255)));
      final normal_10_43 = mesh_10.normals.elementAt(43);
      expect(normal_10_43, vector3MoreOrLessEquals(Vector3(-0.134483, 0.218923, 0.96643)));
      final normal_10_44 = mesh_10.normals.elementAt(44);
      expect(normal_10_44, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, 0.487325)));
      final normal_10_45 = mesh_10.normals.elementAt(45);
      expect(normal_10_45, vector3MoreOrLessEquals(Vector3(-0.132228, 0.076598, 0.988255)));
      final normal_10_46 = mesh_10.normals.elementAt(46);
      expect(normal_10_46, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, 0.487325)));
      final normal_10_47 = mesh_10.normals.elementAt(47);
      expect(normal_10_47, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_48 = mesh_10.normals.elementAt(48);
      expect(normal_10_48, vector3MoreOrLessEquals(Vector3(-0.134483, 0.218923, 0.96643)));
      final normal_10_49 = mesh_10.normals.elementAt(49);
      expect(normal_10_49, vector3MoreOrLessEquals(Vector3(-0.082654, 0.333036, 0.939285)));
      final normal_10_50 = mesh_10.normals.elementAt(50);
      expect(normal_10_50, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, 0.487325)));
      final normal_10_51 = mesh_10.normals.elementAt(51);
      expect(normal_10_51, vector3MoreOrLessEquals(Vector3(-0.082654, 0.333036, 0.939285)));
      final normal_10_52 = mesh_10.normals.elementAt(52);
      expect(normal_10_52, vector3MoreOrLessEquals(Vector3(-0.686973, 0.538875, 0.487527)));
      final normal_10_53 = mesh_10.normals.elementAt(53);
      expect(normal_10_53, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, 0.487325)));
      final normal_10_54 = mesh_10.normals.elementAt(54);
      expect(normal_10_54, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_55 = mesh_10.normals.elementAt(55);
      expect(normal_10_55, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_56 = mesh_10.normals.elementAt(56);
      expect(normal_10_56, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_57 = mesh_10.normals.elementAt(57);
      expect(normal_10_57, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_58 = mesh_10.normals.elementAt(58);
      expect(normal_10_58, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_59 = mesh_10.normals.elementAt(59);
      expect(normal_10_59, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_60 = mesh_10.normals.elementAt(60);
      expect(normal_10_60, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_61 = mesh_10.normals.elementAt(61);
      expect(normal_10_61, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, 0.487325)));
      final normal_10_62 = mesh_10.normals.elementAt(62);
      expect(normal_10_62, vector3MoreOrLessEquals(Vector3(-0.911656, -0.242414, -0.33184)));
      final normal_10_63 = mesh_10.normals.elementAt(63);
      expect(normal_10_63, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, 0.487325)));
      final normal_10_64 = mesh_10.normals.elementAt(64);
      expect(normal_10_64, vector3MoreOrLessEquals(Vector3(-0.90347, -0.005854, -0.428611)));
      final normal_10_65 = mesh_10.normals.elementAt(65);
      expect(normal_10_65, vector3MoreOrLessEquals(Vector3(-0.911656, -0.242414, -0.33184)));
      final normal_10_66 = mesh_10.normals.elementAt(66);
      expect(normal_10_66, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, 0.487325)));
      final normal_10_67 = mesh_10.normals.elementAt(67);
      expect(normal_10_67, vector3MoreOrLessEquals(Vector3(-0.686973, 0.538875, 0.487527)));
      final normal_10_68 = mesh_10.normals.elementAt(68);
      expect(normal_10_68, vector3MoreOrLessEquals(Vector3(-0.880207, 0.284493, -0.379868)));
      final normal_10_69 = mesh_10.normals.elementAt(69);
      expect(normal_10_69, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, 0.487325)));
      final normal_10_70 = mesh_10.normals.elementAt(70);
      expect(normal_10_70, vector3MoreOrLessEquals(Vector3(-0.880207, 0.284493, -0.379868)));
      final normal_10_71 = mesh_10.normals.elementAt(71);
      expect(normal_10_71, vector3MoreOrLessEquals(Vector3(-0.90347, -0.005854, -0.428611)));
      final normal_10_72 = mesh_10.normals.elementAt(72);
      expect(normal_10_72, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_73 = mesh_10.normals.elementAt(73);
      expect(normal_10_73, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_74 = mesh_10.normals.elementAt(74);
      expect(normal_10_74, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_75 = mesh_10.normals.elementAt(75);
      expect(normal_10_75, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_76 = mesh_10.normals.elementAt(76);
      expect(normal_10_76, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_77 = mesh_10.normals.elementAt(77);
      expect(normal_10_77, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_78 = mesh_10.normals.elementAt(78);
      expect(normal_10_78, vector3MoreOrLessEquals(Vector3(-0.911656, -0.242414, -0.33184)));
      final normal_10_79 = mesh_10.normals.elementAt(79);
      expect(normal_10_79, vector3MoreOrLessEquals(Vector3(-0.90347, -0.005854, -0.428611)));
      final normal_10_80 = mesh_10.normals.elementAt(80);
      expect(normal_10_80, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, -0.885991)));
      final normal_10_81 = mesh_10.normals.elementAt(81);
      expect(normal_10_81, vector3MoreOrLessEquals(Vector3(-0.911656, -0.242414, -0.33184)));
      final normal_10_82 = mesh_10.normals.elementAt(82);
      expect(normal_10_82, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, -0.885991)));
      final normal_10_83 = mesh_10.normals.elementAt(83);
      expect(normal_10_83, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_84 = mesh_10.normals.elementAt(84);
      expect(normal_10_84, vector3MoreOrLessEquals(Vector3(-0.90347, -0.005854, -0.428611)));
      final normal_10_85 = mesh_10.normals.elementAt(85);
      expect(normal_10_85, vector3MoreOrLessEquals(Vector3(-0.880207, 0.284493, -0.379868)));
      final normal_10_86 = mesh_10.normals.elementAt(86);
      expect(normal_10_86, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, -0.885991)));
      final normal_10_87 = mesh_10.normals.elementAt(87);
      expect(normal_10_87, vector3MoreOrLessEquals(Vector3(-0.880207, 0.284493, -0.379868)));
      final normal_10_88 = mesh_10.normals.elementAt(88);
      expect(normal_10_88, vector3MoreOrLessEquals(Vector3(-0.531215, -0.16165, -0.831673)));
      final normal_10_89 = mesh_10.normals.elementAt(89);
      expect(normal_10_89, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, -0.885991)));
      final normal_10_90 = mesh_10.normals.elementAt(90);
      expect(normal_10_90, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_91 = mesh_10.normals.elementAt(91);
      expect(normal_10_91, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_92 = mesh_10.normals.elementAt(92);
      expect(normal_10_92, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_93 = mesh_10.normals.elementAt(93);
      expect(normal_10_93, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_94 = mesh_10.normals.elementAt(94);
      expect(normal_10_94, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_95 = mesh_10.normals.elementAt(95);
      expect(normal_10_95, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_96 = mesh_10.normals.elementAt(96);
      expect(normal_10_96, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_97 = mesh_10.normals.elementAt(97);
      expect(normal_10_97, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, -0.885991)));
      final normal_10_98 = mesh_10.normals.elementAt(98);
      expect(normal_10_98, vector3MoreOrLessEquals(Vector3(0.52171, -0.333452, -0.785257)));
      final normal_10_99 = mesh_10.normals.elementAt(99);
      expect(normal_10_99, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, -0.885991)));
      final normal_10_100 = mesh_10.normals.elementAt(100);
      expect(normal_10_100, vector3MoreOrLessEquals(Vector3(0.498223, -0.518213, -0.695147)));
      final normal_10_101 = mesh_10.normals.elementAt(101);
      expect(normal_10_101, vector3MoreOrLessEquals(Vector3(0.52171, -0.333452, -0.785257)));
      final normal_10_102 = mesh_10.normals.elementAt(102);
      expect(normal_10_102, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, -0.885991)));
      final normal_10_103 = mesh_10.normals.elementAt(103);
      expect(normal_10_103, vector3MoreOrLessEquals(Vector3(-0.531215, -0.16165, -0.831673)));
      final normal_10_104 = mesh_10.normals.elementAt(104);
      expect(normal_10_104, vector3MoreOrLessEquals(Vector3(0.319252, -0.66693, -0.673263)));
      final normal_10_105 = mesh_10.normals.elementAt(105);
      expect(normal_10_105, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, -0.885991)));
      final normal_10_106 = mesh_10.normals.elementAt(106);
      expect(normal_10_106, vector3MoreOrLessEquals(Vector3(0.319252, -0.66693, -0.673263)));
      final normal_10_107 = mesh_10.normals.elementAt(107);
      expect(normal_10_107, vector3MoreOrLessEquals(Vector3(0.498223, -0.518213, -0.695147)));
      final normal_10_108 = mesh_10.normals.elementAt(108);
      expect(normal_10_108, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_109 = mesh_10.normals.elementAt(109);
      expect(normal_10_109, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_110 = mesh_10.normals.elementAt(110);
      expect(normal_10_110, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_10_111 = mesh_10.normals.elementAt(111);
      expect(normal_10_111, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_112 = mesh_10.normals.elementAt(112);
      expect(normal_10_112, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_113 = mesh_10.normals.elementAt(113);
      expect(normal_10_113, vector3MoreOrLessEquals(Vector3(0.891945, 0.333606, -0.30519)));
      final normal_10_114 = mesh_10.normals.elementAt(114);
      expect(normal_10_114, vector3MoreOrLessEquals(Vector3(0.52171, -0.333452, -0.785257)));
      final normal_10_115 = mesh_10.normals.elementAt(115);
      expect(normal_10_115, vector3MoreOrLessEquals(Vector3(0.498223, -0.518213, -0.695147)));
      final normal_10_116 = mesh_10.normals.elementAt(116);
      expect(normal_10_116, vector3MoreOrLessEquals(Vector3(0.871701, -0.486404, -0.059574)));
      final normal_10_117 = mesh_10.normals.elementAt(117);
      expect(normal_10_117, vector3MoreOrLessEquals(Vector3(0.52171, -0.333452, -0.785257)));
      final normal_10_118 = mesh_10.normals.elementAt(118);
      expect(normal_10_118, vector3MoreOrLessEquals(Vector3(0.871701, -0.486404, -0.059574)));
      final normal_10_119 = mesh_10.normals.elementAt(119);
      expect(normal_10_119, vector3MoreOrLessEquals(Vector3(0.885286, -0.051708, 0.462163)));
      final normal_10_120 = mesh_10.normals.elementAt(120);
      expect(normal_10_120, vector3MoreOrLessEquals(Vector3(0.498223, -0.518213, -0.695147)));
      final normal_10_121 = mesh_10.normals.elementAt(121);
      expect(normal_10_121, vector3MoreOrLessEquals(Vector3(0.319252, -0.66693, -0.673263)));
      final normal_10_122 = mesh_10.normals.elementAt(122);
      expect(normal_10_122, vector3MoreOrLessEquals(Vector3(0.871701, -0.486404, -0.059574)));
      final normal_10_123 = mesh_10.normals.elementAt(123);
      expect(normal_10_123, vector3MoreOrLessEquals(Vector3(0.319252, -0.66693, -0.673263)));
      final normal_10_124 = mesh_10.normals.elementAt(124);
      expect(normal_10_124, vector3MoreOrLessEquals(Vector3(0.767332, -0.613878, 0.185353)));
      final normal_10_125 = mesh_10.normals.elementAt(125);
      expect(normal_10_125, vector3MoreOrLessEquals(Vector3(0.871701, -0.486404, -0.059574)));
      expect(mesh_10.tangents.length, isZero);
      expect(mesh_10.bitangents.length, isZero);
      expect(mesh_10.colors.length, isZero);
      expect(mesh_10.textureCoords.length, equals(1));
      final textureCoords_10_0 = mesh_10.textureCoords.elementAt(0);
      expect(textureCoords_10_0.length, equals(126));
      final textureCoord_10_0_0 = textureCoords_10_0.elementAt(0);
      expect(textureCoord_10_0_0, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_1 = textureCoords_10_0.elementAt(1);
      expect(textureCoord_10_0_1, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_2 = textureCoords_10_0.elementAt(2);
      expect(textureCoord_10_0_2, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_3 = textureCoords_10_0.elementAt(3);
      expect(textureCoord_10_0_3, vector3MoreOrLessEquals(Vector3(0.446895, 0.397773, 0)));
      final textureCoord_10_0_4 = textureCoords_10_0.elementAt(4);
      expect(textureCoord_10_0_4, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_10_0_5 = textureCoords_10_0.elementAt(5);
      expect(textureCoord_10_0_5, vector3MoreOrLessEquals(Vector3(0.402899, 0.410469, 0)));
      final textureCoord_10_0_6 = textureCoords_10_0.elementAt(6);
      expect(textureCoord_10_0_6, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_7 = textureCoords_10_0.elementAt(7);
      expect(textureCoord_10_0_7, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_10_0_8 = textureCoords_10_0.elementAt(8);
      expect(textureCoord_10_0_8, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_10_0_9 = textureCoords_10_0.elementAt(9);
      expect(textureCoord_10_0_9, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_10 = textureCoords_10_0.elementAt(10);
      expect(textureCoord_10_0_10, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_10_0_11 = textureCoords_10_0.elementAt(11);
      expect(textureCoord_10_0_11, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_12 = textureCoords_10_0.elementAt(12);
      expect(textureCoord_10_0_12, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_10_0_13 = textureCoords_10_0.elementAt(13);
      expect(textureCoord_10_0_13, vector3MoreOrLessEquals(Vector3(0.446895, 0.397773, 0)));
      final textureCoord_10_0_14 = textureCoords_10_0.elementAt(14);
      expect(textureCoord_10_0_14, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_10_0_15 = textureCoords_10_0.elementAt(15);
      expect(textureCoord_10_0_15, vector3MoreOrLessEquals(Vector3(0.446895, 0.397773, 0)));
      final textureCoord_10_0_16 = textureCoords_10_0.elementAt(16);
      expect(textureCoord_10_0_16, vector3MoreOrLessEquals(Vector3(0.402899, 0.410469, 0)));
      final textureCoord_10_0_17 = textureCoords_10_0.elementAt(17);
      expect(textureCoord_10_0_17, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_10_0_18 = textureCoords_10_0.elementAt(18);
      expect(textureCoord_10_0_18, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_19 = textureCoords_10_0.elementAt(19);
      expect(textureCoord_10_0_19, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_20 = textureCoords_10_0.elementAt(20);
      expect(textureCoord_10_0_20, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_21 = textureCoords_10_0.elementAt(21);
      expect(textureCoord_10_0_21, vector3MoreOrLessEquals(Vector3(0.402899, 0.410469, 0)));
      final textureCoord_10_0_22 = textureCoords_10_0.elementAt(22);
      expect(textureCoord_10_0_22, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_10_0_23 = textureCoords_10_0.elementAt(23);
      expect(textureCoord_10_0_23, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_10_0_24 = textureCoords_10_0.elementAt(24);
      expect(textureCoord_10_0_24, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_25 = textureCoords_10_0.elementAt(25);
      expect(textureCoord_10_0_25, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_10_0_26 = textureCoords_10_0.elementAt(26);
      expect(textureCoord_10_0_26, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_27 = textureCoords_10_0.elementAt(27);
      expect(textureCoord_10_0_27, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_10_0_28 = textureCoords_10_0.elementAt(28);
      expect(textureCoord_10_0_28, vector3MoreOrLessEquals(Vector3(0.359907, 0.385983, 0)));
      final textureCoord_10_0_29 = textureCoords_10_0.elementAt(29);
      expect(textureCoord_10_0_29, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_30 = textureCoords_10_0.elementAt(30);
      expect(textureCoord_10_0_30, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_10_0_31 = textureCoords_10_0.elementAt(31);
      expect(textureCoord_10_0_31, vector3MoreOrLessEquals(Vector3(0.402899, 0.410469, 0)));
      final textureCoord_10_0_32 = textureCoords_10_0.elementAt(32);
      expect(textureCoord_10_0_32, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_10_0_33 = textureCoords_10_0.elementAt(33);
      expect(textureCoord_10_0_33, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_10_0_34 = textureCoords_10_0.elementAt(34);
      expect(textureCoord_10_0_34, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_10_0_35 = textureCoords_10_0.elementAt(35);
      expect(textureCoord_10_0_35, vector3MoreOrLessEquals(Vector3(0.359907, 0.385983, 0)));
      final textureCoord_10_0_36 = textureCoords_10_0.elementAt(36);
      expect(textureCoord_10_0_36, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_37 = textureCoords_10_0.elementAt(37);
      expect(textureCoord_10_0_37, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_38 = textureCoords_10_0.elementAt(38);
      expect(textureCoord_10_0_38, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_39 = textureCoords_10_0.elementAt(39);
      expect(textureCoord_10_0_39, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_10_0_40 = textureCoords_10_0.elementAt(40);
      expect(textureCoord_10_0_40, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_10_0_41 = textureCoords_10_0.elementAt(41);
      expect(textureCoord_10_0_41, vector3MoreOrLessEquals(Vector3(0.439539, 0.445817, 0)));
      final textureCoord_10_0_42 = textureCoords_10_0.elementAt(42);
      expect(textureCoord_10_0_42, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_43 = textureCoords_10_0.elementAt(43);
      expect(textureCoord_10_0_43, vector3MoreOrLessEquals(Vector3(0.359907, 0.385983, 0)));
      final textureCoord_10_0_44 = textureCoords_10_0.elementAt(44);
      expect(textureCoord_10_0_44, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_10_0_45 = textureCoords_10_0.elementAt(45);
      expect(textureCoord_10_0_45, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_46 = textureCoords_10_0.elementAt(46);
      expect(textureCoord_10_0_46, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_10_0_47 = textureCoords_10_0.elementAt(47);
      expect(textureCoord_10_0_47, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_48 = textureCoords_10_0.elementAt(48);
      expect(textureCoord_10_0_48, vector3MoreOrLessEquals(Vector3(0.359907, 0.385983, 0)));
      final textureCoord_10_0_49 = textureCoords_10_0.elementAt(49);
      expect(textureCoord_10_0_49, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_10_0_50 = textureCoords_10_0.elementAt(50);
      expect(textureCoord_10_0_50, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_10_0_51 = textureCoords_10_0.elementAt(51);
      expect(textureCoord_10_0_51, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_10_0_52 = textureCoords_10_0.elementAt(52);
      expect(textureCoord_10_0_52, vector3MoreOrLessEquals(Vector3(0.439539, 0.445817, 0)));
      final textureCoord_10_0_53 = textureCoords_10_0.elementAt(53);
      expect(textureCoord_10_0_53, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_10_0_54 = textureCoords_10_0.elementAt(54);
      expect(textureCoord_10_0_54, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_55 = textureCoords_10_0.elementAt(55);
      expect(textureCoord_10_0_55, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_56 = textureCoords_10_0.elementAt(56);
      expect(textureCoord_10_0_56, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_57 = textureCoords_10_0.elementAt(57);
      expect(textureCoord_10_0_57, vector3MoreOrLessEquals(Vector3(0.439539, 0.445817, 0)));
      final textureCoord_10_0_58 = textureCoords_10_0.elementAt(58);
      expect(textureCoord_10_0_58, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_10_0_59 = textureCoords_10_0.elementAt(59);
      expect(textureCoord_10_0_59, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_10_0_60 = textureCoords_10_0.elementAt(60);
      expect(textureCoord_10_0_60, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_61 = textureCoords_10_0.elementAt(61);
      expect(textureCoord_10_0_61, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_10_0_62 = textureCoords_10_0.elementAt(62);
      expect(textureCoord_10_0_62, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_63 = textureCoords_10_0.elementAt(63);
      expect(textureCoord_10_0_63, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_10_0_64 = textureCoords_10_0.elementAt(64);
      expect(textureCoord_10_0_64, vector3MoreOrLessEquals(Vector3(0.420092, 0.378214, 0)));
      final textureCoord_10_0_65 = textureCoords_10_0.elementAt(65);
      expect(textureCoord_10_0_65, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_66 = textureCoords_10_0.elementAt(66);
      expect(textureCoord_10_0_66, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_10_0_67 = textureCoords_10_0.elementAt(67);
      expect(textureCoord_10_0_67, vector3MoreOrLessEquals(Vector3(0.439539, 0.445817, 0)));
      final textureCoord_10_0_68 = textureCoords_10_0.elementAt(68);
      expect(textureCoord_10_0_68, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_10_0_69 = textureCoords_10_0.elementAt(69);
      expect(textureCoord_10_0_69, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_10_0_70 = textureCoords_10_0.elementAt(70);
      expect(textureCoord_10_0_70, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_10_0_71 = textureCoords_10_0.elementAt(71);
      expect(textureCoord_10_0_71, vector3MoreOrLessEquals(Vector3(0.420092, 0.378214, 0)));
      final textureCoord_10_0_72 = textureCoords_10_0.elementAt(72);
      expect(textureCoord_10_0_72, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_73 = textureCoords_10_0.elementAt(73);
      expect(textureCoord_10_0_73, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_74 = textureCoords_10_0.elementAt(74);
      expect(textureCoord_10_0_74, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_75 = textureCoords_10_0.elementAt(75);
      expect(textureCoord_10_0_75, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_10_0_76 = textureCoords_10_0.elementAt(76);
      expect(textureCoord_10_0_76, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_10_0_77 = textureCoords_10_0.elementAt(77);
      expect(textureCoord_10_0_77, vector3MoreOrLessEquals(Vector3(0.518816, 0.422941, 0)));
      final textureCoord_10_0_78 = textureCoords_10_0.elementAt(78);
      expect(textureCoord_10_0_78, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_79 = textureCoords_10_0.elementAt(79);
      expect(textureCoord_10_0_79, vector3MoreOrLessEquals(Vector3(0.420092, 0.378214, 0)));
      final textureCoord_10_0_80 = textureCoords_10_0.elementAt(80);
      expect(textureCoord_10_0_80, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_10_0_81 = textureCoords_10_0.elementAt(81);
      expect(textureCoord_10_0_81, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_82 = textureCoords_10_0.elementAt(82);
      expect(textureCoord_10_0_82, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_10_0_83 = textureCoords_10_0.elementAt(83);
      expect(textureCoord_10_0_83, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_84 = textureCoords_10_0.elementAt(84);
      expect(textureCoord_10_0_84, vector3MoreOrLessEquals(Vector3(0.420092, 0.378214, 0)));
      final textureCoord_10_0_85 = textureCoords_10_0.elementAt(85);
      expect(textureCoord_10_0_85, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_10_0_86 = textureCoords_10_0.elementAt(86);
      expect(textureCoord_10_0_86, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_10_0_87 = textureCoords_10_0.elementAt(87);
      expect(textureCoord_10_0_87, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_10_0_88 = textureCoords_10_0.elementAt(88);
      expect(textureCoord_10_0_88, vector3MoreOrLessEquals(Vector3(0.518816, 0.422941, 0)));
      final textureCoord_10_0_89 = textureCoords_10_0.elementAt(89);
      expect(textureCoord_10_0_89, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_10_0_90 = textureCoords_10_0.elementAt(90);
      expect(textureCoord_10_0_90, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_91 = textureCoords_10_0.elementAt(91);
      expect(textureCoord_10_0_91, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_92 = textureCoords_10_0.elementAt(92);
      expect(textureCoord_10_0_92, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_93 = textureCoords_10_0.elementAt(93);
      expect(textureCoord_10_0_93, vector3MoreOrLessEquals(Vector3(0.518816, 0.422941, 0)));
      final textureCoord_10_0_94 = textureCoords_10_0.elementAt(94);
      expect(textureCoord_10_0_94, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_10_0_95 = textureCoords_10_0.elementAt(95);
      expect(textureCoord_10_0_95, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_10_0_96 = textureCoords_10_0.elementAt(96);
      expect(textureCoord_10_0_96, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_97 = textureCoords_10_0.elementAt(97);
      expect(textureCoord_10_0_97, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_10_0_98 = textureCoords_10_0.elementAt(98);
      expect(textureCoord_10_0_98, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_99 = textureCoords_10_0.elementAt(99);
      expect(textureCoord_10_0_99, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_10_0_100 = textureCoords_10_0.elementAt(100);
      expect(textureCoord_10_0_100, vector3MoreOrLessEquals(Vector3(0.440026, 0.37508, 0)));
      final textureCoord_10_0_101 = textureCoords_10_0.elementAt(101);
      expect(textureCoord_10_0_101, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_102 = textureCoords_10_0.elementAt(102);
      expect(textureCoord_10_0_102, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_10_0_103 = textureCoords_10_0.elementAt(103);
      expect(textureCoord_10_0_103, vector3MoreOrLessEquals(Vector3(0.518816, 0.422941, 0)));
      final textureCoord_10_0_104 = textureCoords_10_0.elementAt(104);
      expect(textureCoord_10_0_104, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_10_0_105 = textureCoords_10_0.elementAt(105);
      expect(textureCoord_10_0_105, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_10_0_106 = textureCoords_10_0.elementAt(106);
      expect(textureCoord_10_0_106, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_10_0_107 = textureCoords_10_0.elementAt(107);
      expect(textureCoord_10_0_107, vector3MoreOrLessEquals(Vector3(0.440026, 0.37508, 0)));
      final textureCoord_10_0_108 = textureCoords_10_0.elementAt(108);
      expect(textureCoord_10_0_108, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_109 = textureCoords_10_0.elementAt(109);
      expect(textureCoord_10_0_109, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_110 = textureCoords_10_0.elementAt(110);
      expect(textureCoord_10_0_110, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_111 = textureCoords_10_0.elementAt(111);
      expect(textureCoord_10_0_111, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_10_0_112 = textureCoords_10_0.elementAt(112);
      expect(textureCoord_10_0_112, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_10_0_113 = textureCoords_10_0.elementAt(113);
      expect(textureCoord_10_0_113, vector3MoreOrLessEquals(Vector3(0.446895, 0.397773, 0)));
      final textureCoord_10_0_114 = textureCoords_10_0.elementAt(114);
      expect(textureCoord_10_0_114, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_115 = textureCoords_10_0.elementAt(115);
      expect(textureCoord_10_0_115, vector3MoreOrLessEquals(Vector3(0.440026, 0.37508, 0)));
      final textureCoord_10_0_116 = textureCoords_10_0.elementAt(116);
      expect(textureCoord_10_0_116, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_10_0_117 = textureCoords_10_0.elementAt(117);
      expect(textureCoord_10_0_117, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_118 = textureCoords_10_0.elementAt(118);
      expect(textureCoord_10_0_118, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_10_0_119 = textureCoords_10_0.elementAt(119);
      expect(textureCoord_10_0_119, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_10_0_120 = textureCoords_10_0.elementAt(120);
      expect(textureCoord_10_0_120, vector3MoreOrLessEquals(Vector3(0.440026, 0.37508, 0)));
      final textureCoord_10_0_121 = textureCoords_10_0.elementAt(121);
      expect(textureCoord_10_0_121, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_10_0_122 = textureCoords_10_0.elementAt(122);
      expect(textureCoord_10_0_122, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_10_0_123 = textureCoords_10_0.elementAt(123);
      expect(textureCoord_10_0_123, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_10_0_124 = textureCoords_10_0.elementAt(124);
      expect(textureCoord_10_0_124, vector3MoreOrLessEquals(Vector3(0.446895, 0.397773, 0)));
      final textureCoord_10_0_125 = textureCoords_10_0.elementAt(125);
      expect(textureCoord_10_0_125, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      expect(mesh_10.uvComponents.length, equals(1));
      expect(mesh_10.uvComponents, equals([2]));
      expect(mesh_10.faces.length, equals(42));
      expect(mesh_10.bones.length, isZero);
      expect(mesh_10.materialIndex, equals(4));
      expect(mesh_10.name, equals('Zahn'));
      expect(mesh_10.animMeshes.length, isZero);
      expect(mesh_10.morphingMethod, isZero);
      expect(mesh_10.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_11 = meshes.elementAt(11);
      expect(mesh_11.primitiveTypes, equals(4));
      expect(mesh_11.vertices.length, equals(126));
      final vertex_11_0 = mesh_11.vertices.elementAt(0);
      expect(vertex_11_0, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_1 = mesh_11.vertices.elementAt(1);
      expect(vertex_11_1, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_2 = mesh_11.vertices.elementAt(2);
      expect(vertex_11_2, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_3 = mesh_11.vertices.elementAt(3);
      expect(vertex_11_3, vector3MoreOrLessEquals(Vector3(-58.2127, 12.0868, -3.03212)));
      final vertex_11_4 = mesh_11.vertices.elementAt(4);
      expect(vertex_11_4, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6178, -0.764661)));
      final vertex_11_5 = mesh_11.vertices.elementAt(5);
      expect(vertex_11_5, vector3MoreOrLessEquals(Vector3(-55.5099, 10.2797, -2.97612)));
      final vertex_11_6 = mesh_11.vertices.elementAt(6);
      expect(vertex_11_6, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_7 = mesh_11.vertices.elementAt(7);
      expect(vertex_11_7, vector3MoreOrLessEquals(Vector3(-59.6895, 8.14495, 1.86181)));
      final vertex_11_8 = mesh_11.vertices.elementAt(8);
      expect(vertex_11_8, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_9 = mesh_11.vertices.elementAt(9);
      expect(vertex_11_9, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_10 = mesh_11.vertices.elementAt(10);
      expect(vertex_11_10, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_11 = mesh_11.vertices.elementAt(11);
      expect(vertex_11_11, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_12 = mesh_11.vertices.elementAt(12);
      expect(vertex_11_12, vector3MoreOrLessEquals(Vector3(-59.6895, 8.14495, 1.86181)));
      final vertex_11_13 = mesh_11.vertices.elementAt(13);
      expect(vertex_11_13, vector3MoreOrLessEquals(Vector3(-58.2127, 12.0868, -3.03212)));
      final vertex_11_14 = mesh_11.vertices.elementAt(14);
      expect(vertex_11_14, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_15 = mesh_11.vertices.elementAt(15);
      expect(vertex_11_15, vector3MoreOrLessEquals(Vector3(-58.2127, 12.0868, -3.03212)));
      final vertex_11_16 = mesh_11.vertices.elementAt(16);
      expect(vertex_11_16, vector3MoreOrLessEquals(Vector3(-55.5099, 10.2797, -2.97612)));
      final vertex_11_17 = mesh_11.vertices.elementAt(17);
      expect(vertex_11_17, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_18 = mesh_11.vertices.elementAt(18);
      expect(vertex_11_18, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_19 = mesh_11.vertices.elementAt(19);
      expect(vertex_11_19, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_20 = mesh_11.vertices.elementAt(20);
      expect(vertex_11_20, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_21 = mesh_11.vertices.elementAt(21);
      expect(vertex_11_21, vector3MoreOrLessEquals(Vector3(-55.5099, 10.2797, -2.97612)));
      final vertex_11_22 = mesh_11.vertices.elementAt(22);
      expect(vertex_11_22, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6178, -0.764661)));
      final vertex_11_23 = mesh_11.vertices.elementAt(23);
      expect(vertex_11_23, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2333, -1.25485)));
      final vertex_11_24 = mesh_11.vertices.elementAt(24);
      expect(vertex_11_24, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_25 = mesh_11.vertices.elementAt(25);
      expect(vertex_11_25, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_26 = mesh_11.vertices.elementAt(26);
      expect(vertex_11_26, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_27 = mesh_11.vertices.elementAt(27);
      expect(vertex_11_27, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_28 = mesh_11.vertices.elementAt(28);
      expect(vertex_11_28, vector3MoreOrLessEquals(Vector3(-56.2969, 6.18843, 3.35651)));
      final vertex_11_29 = mesh_11.vertices.elementAt(29);
      expect(vertex_11_29, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_30 = mesh_11.vertices.elementAt(30);
      expect(vertex_11_30, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_31 = mesh_11.vertices.elementAt(31);
      expect(vertex_11_31, vector3MoreOrLessEquals(Vector3(-55.5099, 10.2797, -2.97612)));
      final vertex_11_32 = mesh_11.vertices.elementAt(32);
      expect(vertex_11_32, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2333, -1.25485)));
      final vertex_11_33 = mesh_11.vertices.elementAt(33);
      expect(vertex_11_33, vector3MoreOrLessEquals(Vector3(-57.9159, 6.62838, 1.95887)));
      final vertex_11_34 = mesh_11.vertices.elementAt(34);
      expect(vertex_11_34, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2333, -1.25485)));
      final vertex_11_35 = mesh_11.vertices.elementAt(35);
      expect(vertex_11_35, vector3MoreOrLessEquals(Vector3(-56.2969, 6.18843, 3.35651)));
      final vertex_11_36 = mesh_11.vertices.elementAt(36);
      expect(vertex_11_36, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_37 = mesh_11.vertices.elementAt(37);
      expect(vertex_11_37, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_38 = mesh_11.vertices.elementAt(38);
      expect(vertex_11_38, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_39 = mesh_11.vertices.elementAt(39);
      expect(vertex_11_39, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2333, -1.25485)));
      final vertex_11_40 = mesh_11.vertices.elementAt(40);
      expect(vertex_11_40, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6178, -0.764661)));
      final vertex_11_41 = mesh_11.vertices.elementAt(41);
      expect(vertex_11_41, vector3MoreOrLessEquals(Vector3(-51.7578, 11.9824, 0.83556)));
      final vertex_11_42 = mesh_11.vertices.elementAt(42);
      expect(vertex_11_42, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_43 = mesh_11.vertices.elementAt(43);
      expect(vertex_11_43, vector3MoreOrLessEquals(Vector3(-56.2969, 6.18843, 3.35651)));
      final vertex_11_44 = mesh_11.vertices.elementAt(44);
      expect(vertex_11_44, vector3MoreOrLessEquals(Vector3(-56.0517, 7.15647, 5.00228)));
      final vertex_11_45 = mesh_11.vertices.elementAt(45);
      expect(vertex_11_45, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_46 = mesh_11.vertices.elementAt(46);
      expect(vertex_11_46, vector3MoreOrLessEquals(Vector3(-56.0517, 7.15647, 5.00228)));
      final vertex_11_47 = mesh_11.vertices.elementAt(47);
      expect(vertex_11_47, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_48 = mesh_11.vertices.elementAt(48);
      expect(vertex_11_48, vector3MoreOrLessEquals(Vector3(-56.2969, 6.18843, 3.35651)));
      final vertex_11_49 = mesh_11.vertices.elementAt(49);
      expect(vertex_11_49, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2333, -1.25485)));
      final vertex_11_50 = mesh_11.vertices.elementAt(50);
      expect(vertex_11_50, vector3MoreOrLessEquals(Vector3(-56.0517, 7.15647, 5.00228)));
      final vertex_11_51 = mesh_11.vertices.elementAt(51);
      expect(vertex_11_51, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2333, -1.25485)));
      final vertex_11_52 = mesh_11.vertices.elementAt(52);
      expect(vertex_11_52, vector3MoreOrLessEquals(Vector3(-51.7578, 11.9824, 0.83556)));
      final vertex_11_53 = mesh_11.vertices.elementAt(53);
      expect(vertex_11_53, vector3MoreOrLessEquals(Vector3(-56.0517, 7.15647, 5.00228)));
      final vertex_11_54 = mesh_11.vertices.elementAt(54);
      expect(vertex_11_54, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_55 = mesh_11.vertices.elementAt(55);
      expect(vertex_11_55, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_56 = mesh_11.vertices.elementAt(56);
      expect(vertex_11_56, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_57 = mesh_11.vertices.elementAt(57);
      expect(vertex_11_57, vector3MoreOrLessEquals(Vector3(-51.7578, 11.9824, 0.83556)));
      final vertex_11_58 = mesh_11.vertices.elementAt(58);
      expect(vertex_11_58, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6178, -0.764661)));
      final vertex_11_59 = mesh_11.vertices.elementAt(59);
      expect(vertex_11_59, vector3MoreOrLessEquals(Vector3(-53.534, 14.21, 1.72102)));
      final vertex_11_60 = mesh_11.vertices.elementAt(60);
      expect(vertex_11_60, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_61 = mesh_11.vertices.elementAt(61);
      expect(vertex_11_61, vector3MoreOrLessEquals(Vector3(-56.0517, 7.15647, 5.00228)));
      final vertex_11_62 = mesh_11.vertices.elementAt(62);
      expect(vertex_11_62, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_63 = mesh_11.vertices.elementAt(63);
      expect(vertex_11_63, vector3MoreOrLessEquals(Vector3(-56.0517, 7.15647, 5.00228)));
      final vertex_11_64 = mesh_11.vertices.elementAt(64);
      expect(vertex_11_64, vector3MoreOrLessEquals(Vector3(-57.3648, 8.80349, 5.6569)));
      final vertex_11_65 = mesh_11.vertices.elementAt(65);
      expect(vertex_11_65, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_66 = mesh_11.vertices.elementAt(66);
      expect(vertex_11_66, vector3MoreOrLessEquals(Vector3(-56.0517, 7.15647, 5.00228)));
      final vertex_11_67 = mesh_11.vertices.elementAt(67);
      expect(vertex_11_67, vector3MoreOrLessEquals(Vector3(-51.7578, 11.9824, 0.83556)));
      final vertex_11_68 = mesh_11.vertices.elementAt(68);
      expect(vertex_11_68, vector3MoreOrLessEquals(Vector3(-53.534, 14.21, 1.72102)));
      final vertex_11_69 = mesh_11.vertices.elementAt(69);
      expect(vertex_11_69, vector3MoreOrLessEquals(Vector3(-56.0517, 7.15647, 5.00228)));
      final vertex_11_70 = mesh_11.vertices.elementAt(70);
      expect(vertex_11_70, vector3MoreOrLessEquals(Vector3(-53.534, 14.21, 1.72102)));
      final vertex_11_71 = mesh_11.vertices.elementAt(71);
      expect(vertex_11_71, vector3MoreOrLessEquals(Vector3(-57.3648, 8.80349, 5.6569)));
      final vertex_11_72 = mesh_11.vertices.elementAt(72);
      expect(vertex_11_72, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_73 = mesh_11.vertices.elementAt(73);
      expect(vertex_11_73, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_74 = mesh_11.vertices.elementAt(74);
      expect(vertex_11_74, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_75 = mesh_11.vertices.elementAt(75);
      expect(vertex_11_75, vector3MoreOrLessEquals(Vector3(-53.534, 14.21, 1.72102)));
      final vertex_11_76 = mesh_11.vertices.elementAt(76);
      expect(vertex_11_76, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6178, -0.764661)));
      final vertex_11_77 = mesh_11.vertices.elementAt(77);
      expect(vertex_11_77, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2387, 0.734676)));
      final vertex_11_78 = mesh_11.vertices.elementAt(78);
      expect(vertex_11_78, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_79 = mesh_11.vertices.elementAt(79);
      expect(vertex_11_79, vector3MoreOrLessEquals(Vector3(-57.3648, 8.80349, 5.6569)));
      final vertex_11_80 = mesh_11.vertices.elementAt(80);
      expect(vertex_11_80, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_81 = mesh_11.vertices.elementAt(81);
      expect(vertex_11_81, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_82 = mesh_11.vertices.elementAt(82);
      expect(vertex_11_82, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_83 = mesh_11.vertices.elementAt(83);
      expect(vertex_11_83, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_84 = mesh_11.vertices.elementAt(84);
      expect(vertex_11_84, vector3MoreOrLessEquals(Vector3(-57.3648, 8.80349, 5.6569)));
      final vertex_11_85 = mesh_11.vertices.elementAt(85);
      expect(vertex_11_85, vector3MoreOrLessEquals(Vector3(-53.534, 14.21, 1.72102)));
      final vertex_11_86 = mesh_11.vertices.elementAt(86);
      expect(vertex_11_86, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_87 = mesh_11.vertices.elementAt(87);
      expect(vertex_11_87, vector3MoreOrLessEquals(Vector3(-53.534, 14.21, 1.72102)));
      final vertex_11_88 = mesh_11.vertices.elementAt(88);
      expect(vertex_11_88, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2387, 0.734676)));
      final vertex_11_89 = mesh_11.vertices.elementAt(89);
      expect(vertex_11_89, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_90 = mesh_11.vertices.elementAt(90);
      expect(vertex_11_90, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_91 = mesh_11.vertices.elementAt(91);
      expect(vertex_11_91, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_92 = mesh_11.vertices.elementAt(92);
      expect(vertex_11_92, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_93 = mesh_11.vertices.elementAt(93);
      expect(vertex_11_93, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2387, 0.734676)));
      final vertex_11_94 = mesh_11.vertices.elementAt(94);
      expect(vertex_11_94, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6178, -0.764661)));
      final vertex_11_95 = mesh_11.vertices.elementAt(95);
      expect(vertex_11_95, vector3MoreOrLessEquals(Vector3(-58.7103, 14.2937, -1.38064)));
      final vertex_11_96 = mesh_11.vertices.elementAt(96);
      expect(vertex_11_96, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_97 = mesh_11.vertices.elementAt(97);
      expect(vertex_11_97, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_98 = mesh_11.vertices.elementAt(98);
      expect(vertex_11_98, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_99 = mesh_11.vertices.elementAt(99);
      expect(vertex_11_99, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_100 = mesh_11.vertices.elementAt(100);
      expect(vertex_11_100, vector3MoreOrLessEquals(Vector3(-60.2821, 9.59619, 3.13846)));
      final vertex_11_101 = mesh_11.vertices.elementAt(101);
      expect(vertex_11_101, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_102 = mesh_11.vertices.elementAt(102);
      expect(vertex_11_102, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_103 = mesh_11.vertices.elementAt(103);
      expect(vertex_11_103, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2387, 0.734676)));
      final vertex_11_104 = mesh_11.vertices.elementAt(104);
      expect(vertex_11_104, vector3MoreOrLessEquals(Vector3(-58.7103, 14.2937, -1.38064)));
      final vertex_11_105 = mesh_11.vertices.elementAt(105);
      expect(vertex_11_105, vector3MoreOrLessEquals(Vector3(-59.2476, 9.88925, 4.82747)));
      final vertex_11_106 = mesh_11.vertices.elementAt(106);
      expect(vertex_11_106, vector3MoreOrLessEquals(Vector3(-58.7103, 14.2937, -1.38064)));
      final vertex_11_107 = mesh_11.vertices.elementAt(107);
      expect(vertex_11_107, vector3MoreOrLessEquals(Vector3(-60.2821, 9.59619, 3.13846)));
      final vertex_11_108 = mesh_11.vertices.elementAt(108);
      expect(vertex_11_108, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_109 = mesh_11.vertices.elementAt(109);
      expect(vertex_11_109, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_110 = mesh_11.vertices.elementAt(110);
      expect(vertex_11_110, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_111 = mesh_11.vertices.elementAt(111);
      expect(vertex_11_111, vector3MoreOrLessEquals(Vector3(-58.7103, 14.2937, -1.38064)));
      final vertex_11_112 = mesh_11.vertices.elementAt(112);
      expect(vertex_11_112, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6178, -0.764661)));
      final vertex_11_113 = mesh_11.vertices.elementAt(113);
      expect(vertex_11_113, vector3MoreOrLessEquals(Vector3(-58.2127, 12.0868, -3.03212)));
      final vertex_11_114 = mesh_11.vertices.elementAt(114);
      expect(vertex_11_114, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_115 = mesh_11.vertices.elementAt(115);
      expect(vertex_11_115, vector3MoreOrLessEquals(Vector3(-60.2821, 9.59619, 3.13846)));
      final vertex_11_116 = mesh_11.vertices.elementAt(116);
      expect(vertex_11_116, vector3MoreOrLessEquals(Vector3(-59.6895, 8.14495, 1.86181)));
      final vertex_11_117 = mesh_11.vertices.elementAt(117);
      expect(vertex_11_117, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_118 = mesh_11.vertices.elementAt(118);
      expect(vertex_11_118, vector3MoreOrLessEquals(Vector3(-59.6895, 8.14495, 1.86181)));
      final vertex_11_119 = mesh_11.vertices.elementAt(119);
      expect(vertex_11_119, vector3MoreOrLessEquals(Vector3(-66.7248, 1.17993, 10.0295)));
      final vertex_11_120 = mesh_11.vertices.elementAt(120);
      expect(vertex_11_120, vector3MoreOrLessEquals(Vector3(-60.2821, 9.59619, 3.13846)));
      final vertex_11_121 = mesh_11.vertices.elementAt(121);
      expect(vertex_11_121, vector3MoreOrLessEquals(Vector3(-58.7103, 14.2937, -1.38064)));
      final vertex_11_122 = mesh_11.vertices.elementAt(122);
      expect(vertex_11_122, vector3MoreOrLessEquals(Vector3(-59.6895, 8.14495, 1.86181)));
      final vertex_11_123 = mesh_11.vertices.elementAt(123);
      expect(vertex_11_123, vector3MoreOrLessEquals(Vector3(-58.7103, 14.2937, -1.38064)));
      final vertex_11_124 = mesh_11.vertices.elementAt(124);
      expect(vertex_11_124, vector3MoreOrLessEquals(Vector3(-58.2127, 12.0868, -3.03212)));
      final vertex_11_125 = mesh_11.vertices.elementAt(125);
      expect(vertex_11_125, vector3MoreOrLessEquals(Vector3(-59.6895, 8.14495, 1.86181)));
      expect(mesh_11.normals.length, equals(126));
      final normal_11_0 = mesh_11.normals.elementAt(0);
      expect(normal_11_0, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_1 = mesh_11.normals.elementAt(1);
      expect(normal_11_1, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_2 = mesh_11.normals.elementAt(2);
      expect(normal_11_2, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_3 = mesh_11.normals.elementAt(3);
      expect(normal_11_3, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_4 = mesh_11.normals.elementAt(4);
      expect(normal_11_4, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_5 = mesh_11.normals.elementAt(5);
      expect(normal_11_5, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_6 = mesh_11.normals.elementAt(6);
      expect(normal_11_6, vector3MoreOrLessEquals(Vector3(-0.390952, -0.506393, -0.768585)));
      final normal_11_7 = mesh_11.normals.elementAt(7);
      expect(normal_11_7, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, -0.577999)));
      final normal_11_8 = mesh_11.normals.elementAt(8);
      expect(normal_11_8, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, -0.631575)));
      final normal_11_9 = mesh_11.normals.elementAt(9);
      expect(normal_11_9, vector3MoreOrLessEquals(Vector3(-0.390952, -0.506393, -0.768585)));
      final normal_11_10 = mesh_11.normals.elementAt(10);
      expect(normal_11_10, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, -0.631575)));
      final normal_11_11 = mesh_11.normals.elementAt(11);
      expect(normal_11_11, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_12 = mesh_11.normals.elementAt(12);
      expect(normal_11_12, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, -0.577999)));
      final normal_11_13 = mesh_11.normals.elementAt(13);
      expect(normal_11_13, vector3MoreOrLessEquals(Vector3(-0.676852, -0.452073, -0.580948)));
      final normal_11_14 = mesh_11.normals.elementAt(14);
      expect(normal_11_14, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, -0.631575)));
      final normal_11_15 = mesh_11.normals.elementAt(15);
      expect(normal_11_15, vector3MoreOrLessEquals(Vector3(-0.676852, -0.452073, -0.580948)));
      final normal_11_16 = mesh_11.normals.elementAt(16);
      expect(normal_11_16, vector3MoreOrLessEquals(Vector3(-0.070613, -0.785109, -0.61532)));
      final normal_11_17 = mesh_11.normals.elementAt(17);
      expect(normal_11_17, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, -0.631575)));
      final normal_11_18 = mesh_11.normals.elementAt(18);
      expect(normal_11_18, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_19 = mesh_11.normals.elementAt(19);
      expect(normal_11_19, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_20 = mesh_11.normals.elementAt(20);
      expect(normal_11_20, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_21 = mesh_11.normals.elementAt(21);
      expect(normal_11_21, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_22 = mesh_11.normals.elementAt(22);
      expect(normal_11_22, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_23 = mesh_11.normals.elementAt(23);
      expect(normal_11_23, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_24 = mesh_11.normals.elementAt(24);
      expect(normal_11_24, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_25 = mesh_11.normals.elementAt(25);
      expect(normal_11_25, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, -0.631575)));
      final normal_11_26 = mesh_11.normals.elementAt(26);
      expect(normal_11_26, vector3MoreOrLessEquals(Vector3(0.404464, -0.913005, -0.053206)));
      final normal_11_27 = mesh_11.normals.elementAt(27);
      expect(normal_11_27, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, -0.631575)));
      final normal_11_28 = mesh_11.normals.elementAt(28);
      expect(normal_11_28, vector3MoreOrLessEquals(Vector3(0.510041, -0.851111, -0.124372)));
      final normal_11_29 = mesh_11.normals.elementAt(29);
      expect(normal_11_29, vector3MoreOrLessEquals(Vector3(0.404464, -0.913005, -0.053206)));
      final normal_11_30 = mesh_11.normals.elementAt(30);
      expect(normal_11_30, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, -0.631575)));
      final normal_11_31 = mesh_11.normals.elementAt(31);
      expect(normal_11_31, vector3MoreOrLessEquals(Vector3(-0.070613, -0.785109, -0.61532)));
      final normal_11_32 = mesh_11.normals.elementAt(32);
      expect(normal_11_32, vector3MoreOrLessEquals(Vector3(0.600863, -0.776753, -0.188727)));
      final normal_11_33 = mesh_11.normals.elementAt(33);
      expect(normal_11_33, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, -0.631575)));
      final normal_11_34 = mesh_11.normals.elementAt(34);
      expect(normal_11_34, vector3MoreOrLessEquals(Vector3(0.600863, -0.776753, -0.188727)));
      final normal_11_35 = mesh_11.normals.elementAt(35);
      expect(normal_11_35, vector3MoreOrLessEquals(Vector3(0.510041, -0.851111, -0.124372)));
      final normal_11_36 = mesh_11.normals.elementAt(36);
      expect(normal_11_36, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_37 = mesh_11.normals.elementAt(37);
      expect(normal_11_37, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_38 = mesh_11.normals.elementAt(38);
      expect(normal_11_38, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_39 = mesh_11.normals.elementAt(39);
      expect(normal_11_39, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_40 = mesh_11.normals.elementAt(40);
      expect(normal_11_40, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_41 = mesh_11.normals.elementAt(41);
      expect(normal_11_41, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_42 = mesh_11.normals.elementAt(42);
      expect(normal_11_42, vector3MoreOrLessEquals(Vector3(0.404464, -0.913005, -0.053206)));
      final normal_11_43 = mesh_11.normals.elementAt(43);
      expect(normal_11_43, vector3MoreOrLessEquals(Vector3(0.510041, -0.851111, -0.124372)));
      final normal_11_44 = mesh_11.normals.elementAt(44);
      expect(normal_11_44, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, 0.609964)));
      final normal_11_45 = mesh_11.normals.elementAt(45);
      expect(normal_11_45, vector3MoreOrLessEquals(Vector3(0.404464, -0.913005, -0.053206)));
      final normal_11_46 = mesh_11.normals.elementAt(46);
      expect(normal_11_46, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, 0.609964)));
      final normal_11_47 = mesh_11.normals.elementAt(47);
      expect(normal_11_47, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_48 = mesh_11.normals.elementAt(48);
      expect(normal_11_48, vector3MoreOrLessEquals(Vector3(0.510041, -0.851111, -0.124372)));
      final normal_11_49 = mesh_11.normals.elementAt(49);
      expect(normal_11_49, vector3MoreOrLessEquals(Vector3(0.600863, -0.776753, -0.188727)));
      final normal_11_50 = mesh_11.normals.elementAt(50);
      expect(normal_11_50, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, 0.609964)));
      final normal_11_51 = mesh_11.normals.elementAt(51);
      expect(normal_11_51, vector3MoreOrLessEquals(Vector3(0.600863, -0.776753, -0.188727)));
      final normal_11_52 = mesh_11.normals.elementAt(52);
      expect(normal_11_52, vector3MoreOrLessEquals(Vector3(0.802855, -0.245127, 0.543449)));
      final normal_11_53 = mesh_11.normals.elementAt(53);
      expect(normal_11_53, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, 0.609964)));
      final normal_11_54 = mesh_11.normals.elementAt(54);
      expect(normal_11_54, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_55 = mesh_11.normals.elementAt(55);
      expect(normal_11_55, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_56 = mesh_11.normals.elementAt(56);
      expect(normal_11_56, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_57 = mesh_11.normals.elementAt(57);
      expect(normal_11_57, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_58 = mesh_11.normals.elementAt(58);
      expect(normal_11_58, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_59 = mesh_11.normals.elementAt(59);
      expect(normal_11_59, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_60 = mesh_11.normals.elementAt(60);
      expect(normal_11_60, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_61 = mesh_11.normals.elementAt(61);
      expect(normal_11_61, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, 0.609964)));
      final normal_11_62 = mesh_11.normals.elementAt(62);
      expect(normal_11_62, vector3MoreOrLessEquals(Vector3(0.20392, 0.286548, 0.936113)));
      final normal_11_63 = mesh_11.normals.elementAt(63);
      expect(normal_11_63, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, 0.609964)));
      final normal_11_64 = mesh_11.normals.elementAt(64);
      expect(normal_11_64, vector3MoreOrLessEquals(Vector3(0.259058, 0.346923, 0.901407)));
      final normal_11_65 = mesh_11.normals.elementAt(65);
      expect(normal_11_65, vector3MoreOrLessEquals(Vector3(0.20392, 0.286548, 0.936113)));
      final normal_11_66 = mesh_11.normals.elementAt(66);
      expect(normal_11_66, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, 0.609964)));
      final normal_11_67 = mesh_11.normals.elementAt(67);
      expect(normal_11_67, vector3MoreOrLessEquals(Vector3(0.802855, -0.245127, 0.543449)));
      final normal_11_68 = mesh_11.normals.elementAt(68);
      expect(normal_11_68, vector3MoreOrLessEquals(Vector3(0.305077, 0.413607, 0.857821)));
      final normal_11_69 = mesh_11.normals.elementAt(69);
      expect(normal_11_69, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, 0.609964)));
      final normal_11_70 = mesh_11.normals.elementAt(70);
      expect(normal_11_70, vector3MoreOrLessEquals(Vector3(0.305077, 0.413607, 0.857821)));
      final normal_11_71 = mesh_11.normals.elementAt(71);
      expect(normal_11_71, vector3MoreOrLessEquals(Vector3(0.259058, 0.346923, 0.901407)));
      final normal_11_72 = mesh_11.normals.elementAt(72);
      expect(normal_11_72, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_73 = mesh_11.normals.elementAt(73);
      expect(normal_11_73, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_74 = mesh_11.normals.elementAt(74);
      expect(normal_11_74, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_75 = mesh_11.normals.elementAt(75);
      expect(normal_11_75, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_76 = mesh_11.normals.elementAt(76);
      expect(normal_11_76, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_77 = mesh_11.normals.elementAt(77);
      expect(normal_11_77, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_78 = mesh_11.normals.elementAt(78);
      expect(normal_11_78, vector3MoreOrLessEquals(Vector3(0.20392, 0.286548, 0.936113)));
      final normal_11_79 = mesh_11.normals.elementAt(79);
      expect(normal_11_79, vector3MoreOrLessEquals(Vector3(0.259058, 0.346923, 0.901407)));
      final normal_11_80 = mesh_11.normals.elementAt(80);
      expect(normal_11_80, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672313, 0.625987)));
      final normal_11_81 = mesh_11.normals.elementAt(81);
      expect(normal_11_81, vector3MoreOrLessEquals(Vector3(0.20392, 0.286548, 0.936113)));
      final normal_11_82 = mesh_11.normals.elementAt(82);
      expect(normal_11_82, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672313, 0.625987)));
      final normal_11_83 = mesh_11.normals.elementAt(83);
      expect(normal_11_83, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_84 = mesh_11.normals.elementAt(84);
      expect(normal_11_84, vector3MoreOrLessEquals(Vector3(0.259058, 0.346923, 0.901407)));
      final normal_11_85 = mesh_11.normals.elementAt(85);
      expect(normal_11_85, vector3MoreOrLessEquals(Vector3(0.305077, 0.413607, 0.857821)));
      final normal_11_86 = mesh_11.normals.elementAt(86);
      expect(normal_11_86, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672313, 0.625987)));
      final normal_11_87 = mesh_11.normals.elementAt(87);
      expect(normal_11_87, vector3MoreOrLessEquals(Vector3(0.305077, 0.413607, 0.857821)));
      final normal_11_88 = mesh_11.normals.elementAt(88);
      expect(normal_11_88, vector3MoreOrLessEquals(Vector3(-0.388204, 0.672327, 0.630297)));
      final normal_11_89 = mesh_11.normals.elementAt(89);
      expect(normal_11_89, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672313, 0.625987)));
      final normal_11_90 = mesh_11.normals.elementAt(90);
      expect(normal_11_90, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_91 = mesh_11.normals.elementAt(91);
      expect(normal_11_91, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_92 = mesh_11.normals.elementAt(92);
      expect(normal_11_92, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_93 = mesh_11.normals.elementAt(93);
      expect(normal_11_93, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_94 = mesh_11.normals.elementAt(94);
      expect(normal_11_94, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_95 = mesh_11.normals.elementAt(95);
      expect(normal_11_95, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_96 = mesh_11.normals.elementAt(96);
      expect(normal_11_96, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_97 = mesh_11.normals.elementAt(97);
      expect(normal_11_97, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672313, 0.625987)));
      final normal_11_98 = mesh_11.normals.elementAt(98);
      expect(normal_11_98, vector3MoreOrLessEquals(Vector3(-0.844407, 0.508563, -0.168344)));
      final normal_11_99 = mesh_11.normals.elementAt(99);
      expect(normal_11_99, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672313, 0.625987)));
      final normal_11_100 = mesh_11.normals.elementAt(100);
      expect(normal_11_100, vector3MoreOrLessEquals(Vector3(-0.907377, 0.410201, -0.091666)));
      final normal_11_101 = mesh_11.normals.elementAt(101);
      expect(normal_11_101, vector3MoreOrLessEquals(Vector3(-0.844407, 0.508563, -0.168344)));
      final normal_11_102 = mesh_11.normals.elementAt(102);
      expect(normal_11_102, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672313, 0.625987)));
      final normal_11_103 = mesh_11.normals.elementAt(103);
      expect(normal_11_103, vector3MoreOrLessEquals(Vector3(-0.388204, 0.672327, 0.630297)));
      final normal_11_104 = mesh_11.normals.elementAt(104);
      expect(normal_11_104, vector3MoreOrLessEquals(Vector3(-0.943128, 0.331776, 0.02084)));
      final normal_11_105 = mesh_11.normals.elementAt(105);
      expect(normal_11_105, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672313, 0.625987)));
      final normal_11_106 = mesh_11.normals.elementAt(106);
      expect(normal_11_106, vector3MoreOrLessEquals(Vector3(-0.943128, 0.331776, 0.02084)));
      final normal_11_107 = mesh_11.normals.elementAt(107);
      expect(normal_11_107, vector3MoreOrLessEquals(Vector3(-0.907377, 0.410201, -0.091666)));
      final normal_11_108 = mesh_11.normals.elementAt(108);
      expect(normal_11_108, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_109 = mesh_11.normals.elementAt(109);
      expect(normal_11_109, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_110 = mesh_11.normals.elementAt(110);
      expect(normal_11_110, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_11_111 = mesh_11.normals.elementAt(111);
      expect(normal_11_111, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_112 = mesh_11.normals.elementAt(112);
      expect(normal_11_112, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_113 = mesh_11.normals.elementAt(113);
      expect(normal_11_113, vector3MoreOrLessEquals(Vector3(0.417209, 0.60293, -0.680009)));
      final normal_11_114 = mesh_11.normals.elementAt(114);
      expect(normal_11_114, vector3MoreOrLessEquals(Vector3(-0.844407, 0.508563, -0.168344)));
      final normal_11_115 = mesh_11.normals.elementAt(115);
      expect(normal_11_115, vector3MoreOrLessEquals(Vector3(-0.907377, 0.410201, -0.091666)));
      final normal_11_116 = mesh_11.normals.elementAt(116);
      expect(normal_11_116, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, -0.577999)));
      final normal_11_117 = mesh_11.normals.elementAt(117);
      expect(normal_11_117, vector3MoreOrLessEquals(Vector3(-0.844407, 0.508563, -0.168344)));
      final normal_11_118 = mesh_11.normals.elementAt(118);
      expect(normal_11_118, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, -0.577999)));
      final normal_11_119 = mesh_11.normals.elementAt(119);
      expect(normal_11_119, vector3MoreOrLessEquals(Vector3(-0.390952, -0.506393, -0.768585)));
      final normal_11_120 = mesh_11.normals.elementAt(120);
      expect(normal_11_120, vector3MoreOrLessEquals(Vector3(-0.907377, 0.410201, -0.091666)));
      final normal_11_121 = mesh_11.normals.elementAt(121);
      expect(normal_11_121, vector3MoreOrLessEquals(Vector3(-0.943128, 0.331776, 0.02084)));
      final normal_11_122 = mesh_11.normals.elementAt(122);
      expect(normal_11_122, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, -0.577999)));
      final normal_11_123 = mesh_11.normals.elementAt(123);
      expect(normal_11_123, vector3MoreOrLessEquals(Vector3(-0.943128, 0.331776, 0.02084)));
      final normal_11_124 = mesh_11.normals.elementAt(124);
      expect(normal_11_124, vector3MoreOrLessEquals(Vector3(-0.676852, -0.452073, -0.580948)));
      final normal_11_125 = mesh_11.normals.elementAt(125);
      expect(normal_11_125, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, -0.577999)));
      expect(mesh_11.tangents.length, isZero);
      expect(mesh_11.bitangents.length, isZero);
      expect(mesh_11.colors.length, isZero);
      expect(mesh_11.textureCoords.length, equals(1));
      final textureCoords_11_0 = mesh_11.textureCoords.elementAt(0);
      expect(textureCoords_11_0.length, equals(126));
      final textureCoord_11_0_0 = textureCoords_11_0.elementAt(0);
      expect(textureCoord_11_0_0, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_1 = textureCoords_11_0.elementAt(1);
      expect(textureCoord_11_0_1, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_2 = textureCoords_11_0.elementAt(2);
      expect(textureCoord_11_0_2, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_3 = textureCoords_11_0.elementAt(3);
      expect(textureCoord_11_0_3, vector3MoreOrLessEquals(Vector3(0.488018, 0.424091, 0)));
      final textureCoord_11_0_4 = textureCoords_11_0.elementAt(4);
      expect(textureCoord_11_0_4, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_11_0_5 = textureCoords_11_0.elementAt(5);
      expect(textureCoord_11_0_5, vector3MoreOrLessEquals(Vector3(0.487405, 0.409841, 0)));
      final textureCoord_11_0_6 = textureCoords_11_0.elementAt(6);
      expect(textureCoord_11_0_6, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_7 = textureCoords_11_0.elementAt(7);
      expect(textureCoord_11_0_7, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_11_0_8 = textureCoords_11_0.elementAt(8);
      expect(textureCoord_11_0_8, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_11_0_9 = textureCoords_11_0.elementAt(9);
      expect(textureCoord_11_0_9, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_10 = textureCoords_11_0.elementAt(10);
      expect(textureCoord_11_0_10, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_11_0_11 = textureCoords_11_0.elementAt(11);
      expect(textureCoord_11_0_11, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_12 = textureCoords_11_0.elementAt(12);
      expect(textureCoord_11_0_12, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_11_0_13 = textureCoords_11_0.elementAt(13);
      expect(textureCoord_11_0_13, vector3MoreOrLessEquals(Vector3(0.488018, 0.424091, 0)));
      final textureCoord_11_0_14 = textureCoords_11_0.elementAt(14);
      expect(textureCoord_11_0_14, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_11_0_15 = textureCoords_11_0.elementAt(15);
      expect(textureCoord_11_0_15, vector3MoreOrLessEquals(Vector3(0.488018, 0.424091, 0)));
      final textureCoord_11_0_16 = textureCoords_11_0.elementAt(16);
      expect(textureCoord_11_0_16, vector3MoreOrLessEquals(Vector3(0.487405, 0.409841, 0)));
      final textureCoord_11_0_17 = textureCoords_11_0.elementAt(17);
      expect(textureCoord_11_0_17, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_11_0_18 = textureCoords_11_0.elementAt(18);
      expect(textureCoord_11_0_18, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_19 = textureCoords_11_0.elementAt(19);
      expect(textureCoord_11_0_19, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_20 = textureCoords_11_0.elementAt(20);
      expect(textureCoord_11_0_20, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_21 = textureCoords_11_0.elementAt(21);
      expect(textureCoord_11_0_21, vector3MoreOrLessEquals(Vector3(0.487405, 0.409841, 0)));
      final textureCoord_11_0_22 = textureCoords_11_0.elementAt(22);
      expect(textureCoord_11_0_22, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_11_0_23 = textureCoords_11_0.elementAt(23);
      expect(textureCoord_11_0_23, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_11_0_24 = textureCoords_11_0.elementAt(24);
      expect(textureCoord_11_0_24, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_25 = textureCoords_11_0.elementAt(25);
      expect(textureCoord_11_0_25, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_11_0_26 = textureCoords_11_0.elementAt(26);
      expect(textureCoord_11_0_26, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_27 = textureCoords_11_0.elementAt(27);
      expect(textureCoord_11_0_27, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_11_0_28 = textureCoords_11_0.elementAt(28);
      expect(textureCoord_11_0_28, vector3MoreOrLessEquals(Vector3(0.417973, 0.377579, 0)));
      final textureCoord_11_0_29 = textureCoords_11_0.elementAt(29);
      expect(textureCoord_11_0_29, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_30 = textureCoords_11_0.elementAt(30);
      expect(textureCoord_11_0_30, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_11_0_31 = textureCoords_11_0.elementAt(31);
      expect(textureCoord_11_0_31, vector3MoreOrLessEquals(Vector3(0.487405, 0.409841, 0)));
      final textureCoord_11_0_32 = textureCoords_11_0.elementAt(32);
      expect(textureCoord_11_0_32, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_11_0_33 = textureCoords_11_0.elementAt(33);
      expect(textureCoord_11_0_33, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_11_0_34 = textureCoords_11_0.elementAt(34);
      expect(textureCoord_11_0_34, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_11_0_35 = textureCoords_11_0.elementAt(35);
      expect(textureCoord_11_0_35, vector3MoreOrLessEquals(Vector3(0.417973, 0.377579, 0)));
      final textureCoord_11_0_36 = textureCoords_11_0.elementAt(36);
      expect(textureCoord_11_0_36, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_37 = textureCoords_11_0.elementAt(37);
      expect(textureCoord_11_0_37, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_38 = textureCoords_11_0.elementAt(38);
      expect(textureCoord_11_0_38, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_39 = textureCoords_11_0.elementAt(39);
      expect(textureCoord_11_0_39, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_11_0_40 = textureCoords_11_0.elementAt(40);
      expect(textureCoord_11_0_40, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_11_0_41 = textureCoords_11_0.elementAt(41);
      expect(textureCoord_11_0_41, vector3MoreOrLessEquals(Vector3(0.445613, 0.423268, 0)));
      final textureCoord_11_0_42 = textureCoords_11_0.elementAt(42);
      expect(textureCoord_11_0_42, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_43 = textureCoords_11_0.elementAt(43);
      expect(textureCoord_11_0_43, vector3MoreOrLessEquals(Vector3(0.417973, 0.377579, 0)));
      final textureCoord_11_0_44 = textureCoords_11_0.elementAt(44);
      expect(textureCoord_11_0_44, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_11_0_45 = textureCoords_11_0.elementAt(45);
      expect(textureCoord_11_0_45, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_46 = textureCoords_11_0.elementAt(46);
      expect(textureCoord_11_0_46, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_11_0_47 = textureCoords_11_0.elementAt(47);
      expect(textureCoord_11_0_47, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_48 = textureCoords_11_0.elementAt(48);
      expect(textureCoord_11_0_48, vector3MoreOrLessEquals(Vector3(0.417973, 0.377579, 0)));
      final textureCoord_11_0_49 = textureCoords_11_0.elementAt(49);
      expect(textureCoord_11_0_49, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_11_0_50 = textureCoords_11_0.elementAt(50);
      expect(textureCoord_11_0_50, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_11_0_51 = textureCoords_11_0.elementAt(51);
      expect(textureCoord_11_0_51, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_11_0_52 = textureCoords_11_0.elementAt(52);
      expect(textureCoord_11_0_52, vector3MoreOrLessEquals(Vector3(0.445613, 0.423268, 0)));
      final textureCoord_11_0_53 = textureCoords_11_0.elementAt(53);
      expect(textureCoord_11_0_53, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_11_0_54 = textureCoords_11_0.elementAt(54);
      expect(textureCoord_11_0_54, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_55 = textureCoords_11_0.elementAt(55);
      expect(textureCoord_11_0_55, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_56 = textureCoords_11_0.elementAt(56);
      expect(textureCoord_11_0_56, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_57 = textureCoords_11_0.elementAt(57);
      expect(textureCoord_11_0_57, vector3MoreOrLessEquals(Vector3(0.445613, 0.423268, 0)));
      final textureCoord_11_0_58 = textureCoords_11_0.elementAt(58);
      expect(textureCoord_11_0_58, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_11_0_59 = textureCoords_11_0.elementAt(59);
      expect(textureCoord_11_0_59, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_11_0_60 = textureCoords_11_0.elementAt(60);
      expect(textureCoord_11_0_60, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_61 = textureCoords_11_0.elementAt(61);
      expect(textureCoord_11_0_61, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_11_0_62 = textureCoords_11_0.elementAt(62);
      expect(textureCoord_11_0_62, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_63 = textureCoords_11_0.elementAt(63);
      expect(textureCoord_11_0_63, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_11_0_64 = textureCoords_11_0.elementAt(64);
      expect(textureCoord_11_0_64, vector3MoreOrLessEquals(Vector3(0.392751, 0.3982, 0)));
      final textureCoord_11_0_65 = textureCoords_11_0.elementAt(65);
      expect(textureCoord_11_0_65, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_66 = textureCoords_11_0.elementAt(66);
      expect(textureCoord_11_0_66, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_11_0_67 = textureCoords_11_0.elementAt(67);
      expect(textureCoord_11_0_67, vector3MoreOrLessEquals(Vector3(0.445613, 0.423268, 0)));
      final textureCoord_11_0_68 = textureCoords_11_0.elementAt(68);
      expect(textureCoord_11_0_68, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_11_0_69 = textureCoords_11_0.elementAt(69);
      expect(textureCoord_11_0_69, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_11_0_70 = textureCoords_11_0.elementAt(70);
      expect(textureCoord_11_0_70, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_11_0_71 = textureCoords_11_0.elementAt(71);
      expect(textureCoord_11_0_71, vector3MoreOrLessEquals(Vector3(0.392751, 0.3982, 0)));
      final textureCoord_11_0_72 = textureCoords_11_0.elementAt(72);
      expect(textureCoord_11_0_72, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_73 = textureCoords_11_0.elementAt(73);
      expect(textureCoord_11_0_73, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_74 = textureCoords_11_0.elementAt(74);
      expect(textureCoord_11_0_74, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_75 = textureCoords_11_0.elementAt(75);
      expect(textureCoord_11_0_75, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_11_0_76 = textureCoords_11_0.elementAt(76);
      expect(textureCoord_11_0_76, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_11_0_77 = textureCoords_11_0.elementAt(77);
      expect(textureCoord_11_0_77, vector3MoreOrLessEquals(Vector3(0.446719, 0.448945, 0)));
      final textureCoord_11_0_78 = textureCoords_11_0.elementAt(78);
      expect(textureCoord_11_0_78, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_79 = textureCoords_11_0.elementAt(79);
      expect(textureCoord_11_0_79, vector3MoreOrLessEquals(Vector3(0.392751, 0.3982, 0)));
      final textureCoord_11_0_80 = textureCoords_11_0.elementAt(80);
      expect(textureCoord_11_0_80, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_11_0_81 = textureCoords_11_0.elementAt(81);
      expect(textureCoord_11_0_81, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_82 = textureCoords_11_0.elementAt(82);
      expect(textureCoord_11_0_82, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_11_0_83 = textureCoords_11_0.elementAt(83);
      expect(textureCoord_11_0_83, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_84 = textureCoords_11_0.elementAt(84);
      expect(textureCoord_11_0_84, vector3MoreOrLessEquals(Vector3(0.392751, 0.3982, 0)));
      final textureCoord_11_0_85 = textureCoords_11_0.elementAt(85);
      expect(textureCoord_11_0_85, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_11_0_86 = textureCoords_11_0.elementAt(86);
      expect(textureCoord_11_0_86, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_11_0_87 = textureCoords_11_0.elementAt(87);
      expect(textureCoord_11_0_87, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_11_0_88 = textureCoords_11_0.elementAt(88);
      expect(textureCoord_11_0_88, vector3MoreOrLessEquals(Vector3(0.446719, 0.448945, 0)));
      final textureCoord_11_0_89 = textureCoords_11_0.elementAt(89);
      expect(textureCoord_11_0_89, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_11_0_90 = textureCoords_11_0.elementAt(90);
      expect(textureCoord_11_0_90, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_91 = textureCoords_11_0.elementAt(91);
      expect(textureCoord_11_0_91, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_92 = textureCoords_11_0.elementAt(92);
      expect(textureCoord_11_0_92, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_93 = textureCoords_11_0.elementAt(93);
      expect(textureCoord_11_0_93, vector3MoreOrLessEquals(Vector3(0.446719, 0.448945, 0)));
      final textureCoord_11_0_94 = textureCoords_11_0.elementAt(94);
      expect(textureCoord_11_0_94, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_11_0_95 = textureCoords_11_0.elementAt(95);
      expect(textureCoord_11_0_95, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_11_0_96 = textureCoords_11_0.elementAt(96);
      expect(textureCoord_11_0_96, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_97 = textureCoords_11_0.elementAt(97);
      expect(textureCoord_11_0_97, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_11_0_98 = textureCoords_11_0.elementAt(98);
      expect(textureCoord_11_0_98, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_99 = textureCoords_11_0.elementAt(99);
      expect(textureCoord_11_0_99, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_11_0_100 = textureCoords_11_0.elementAt(100);
      expect(textureCoord_11_0_100, vector3MoreOrLessEquals(Vector3(0.420363, 0.404451, 0)));
      final textureCoord_11_0_101 = textureCoords_11_0.elementAt(101);
      expect(textureCoord_11_0_101, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_102 = textureCoords_11_0.elementAt(102);
      expect(textureCoord_11_0_102, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_11_0_103 = textureCoords_11_0.elementAt(103);
      expect(textureCoord_11_0_103, vector3MoreOrLessEquals(Vector3(0.446719, 0.448945, 0)));
      final textureCoord_11_0_104 = textureCoords_11_0.elementAt(104);
      expect(textureCoord_11_0_104, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_11_0_105 = textureCoords_11_0.elementAt(105);
      expect(textureCoord_11_0_105, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_11_0_106 = textureCoords_11_0.elementAt(106);
      expect(textureCoord_11_0_106, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_11_0_107 = textureCoords_11_0.elementAt(107);
      expect(textureCoord_11_0_107, vector3MoreOrLessEquals(Vector3(0.420363, 0.404451, 0)));
      final textureCoord_11_0_108 = textureCoords_11_0.elementAt(108);
      expect(textureCoord_11_0_108, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_109 = textureCoords_11_0.elementAt(109);
      expect(textureCoord_11_0_109, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_110 = textureCoords_11_0.elementAt(110);
      expect(textureCoord_11_0_110, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_111 = textureCoords_11_0.elementAt(111);
      expect(textureCoord_11_0_111, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_11_0_112 = textureCoords_11_0.elementAt(112);
      expect(textureCoord_11_0_112, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_11_0_113 = textureCoords_11_0.elementAt(113);
      expect(textureCoord_11_0_113, vector3MoreOrLessEquals(Vector3(0.488018, 0.424091, 0)));
      final textureCoord_11_0_114 = textureCoords_11_0.elementAt(114);
      expect(textureCoord_11_0_114, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_115 = textureCoords_11_0.elementAt(115);
      expect(textureCoord_11_0_115, vector3MoreOrLessEquals(Vector3(0.420363, 0.404451, 0)));
      final textureCoord_11_0_116 = textureCoords_11_0.elementAt(116);
      expect(textureCoord_11_0_116, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_11_0_117 = textureCoords_11_0.elementAt(117);
      expect(textureCoord_11_0_117, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_118 = textureCoords_11_0.elementAt(118);
      expect(textureCoord_11_0_118, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_11_0_119 = textureCoords_11_0.elementAt(119);
      expect(textureCoord_11_0_119, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_11_0_120 = textureCoords_11_0.elementAt(120);
      expect(textureCoord_11_0_120, vector3MoreOrLessEquals(Vector3(0.420363, 0.404451, 0)));
      final textureCoord_11_0_121 = textureCoords_11_0.elementAt(121);
      expect(textureCoord_11_0_121, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_11_0_122 = textureCoords_11_0.elementAt(122);
      expect(textureCoord_11_0_122, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_11_0_123 = textureCoords_11_0.elementAt(123);
      expect(textureCoord_11_0_123, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_11_0_124 = textureCoords_11_0.elementAt(124);
      expect(textureCoord_11_0_124, vector3MoreOrLessEquals(Vector3(0.488018, 0.424091, 0)));
      final textureCoord_11_0_125 = textureCoords_11_0.elementAt(125);
      expect(textureCoord_11_0_125, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      expect(mesh_11.uvComponents.length, equals(1));
      expect(mesh_11.uvComponents, equals([2]));
      expect(mesh_11.faces.length, equals(42));
      expect(mesh_11.bones.length, isZero);
      expect(mesh_11.materialIndex, equals(4));
      expect(mesh_11.name, equals('klZahn'));
      expect(mesh_11.animMeshes.length, isZero);
      expect(mesh_11.morphingMethod, isZero);
      expect(mesh_11.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_12 = meshes.elementAt(12);
      expect(mesh_12.primitiveTypes, equals(4));
      expect(mesh_12.vertices.length, equals(270));
      final vertex_12_0 = mesh_12.vertices.elementAt(0);
      expect(vertex_12_0, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.94445)));
      final vertex_12_1 = mesh_12.vertices.elementAt(1);
      expect(vertex_12_1, vector3MoreOrLessEquals(Vector3(-44.0038, 24.2518, -7.33652)));
      final vertex_12_2 = mesh_12.vertices.elementAt(2);
      expect(vertex_12_2, vector3MoreOrLessEquals(Vector3(-43.2, 24.2518, -9.94445)));
      final vertex_12_3 = mesh_12.vertices.elementAt(3);
      expect(vertex_12_3, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.94445)));
      final vertex_12_4 = mesh_12.vertices.elementAt(4);
      expect(vertex_12_4, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -0.760711)));
      final vertex_12_5 = mesh_12.vertices.elementAt(5);
      expect(vertex_12_5, vector3MoreOrLessEquals(Vector3(-44.0038, 24.2518, -7.33652)));
      final vertex_12_6 = mesh_12.vertices.elementAt(6);
      expect(vertex_12_6, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.94445)));
      final vertex_12_7 = mesh_12.vertices.elementAt(7);
      expect(vertex_12_7, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -4.74829)));
      final vertex_12_8 = mesh_12.vertices.elementAt(8);
      expect(vertex_12_8, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -3.94445)));
      final vertex_12_9 = mesh_12.vertices.elementAt(9);
      expect(vertex_12_9, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.94445)));
      final vertex_12_10 = mesh_12.vertices.elementAt(10);
      expect(vertex_12_10, vector3MoreOrLessEquals(Vector3(-54, 24.7256, -3.94445)));
      final vertex_12_11 = mesh_12.vertices.elementAt(11);
      expect(vertex_12_11, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -0.760711)));
      final vertex_12_12 = mesh_12.vertices.elementAt(12);
      expect(vertex_12_12, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.94445)));
      final vertex_12_13 = mesh_12.vertices.elementAt(13);
      expect(vertex_12_13, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -3.94445)));
      final vertex_12_14 = mesh_12.vertices.elementAt(14);
      expect(vertex_12_14, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -4.74829)));
      final vertex_12_15 = mesh_12.vertices.elementAt(15);
      expect(vertex_12_15, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.94445)));
      final vertex_12_16 = mesh_12.vertices.elementAt(16);
      expect(vertex_12_16, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -4.74829)));
      final vertex_12_17 = mesh_12.vertices.elementAt(17);
      expect(vertex_12_17, vector3MoreOrLessEquals(Vector3(-54, 24.7256, -3.94445)));
      final vertex_12_18 = mesh_12.vertices.elementAt(18);
      expect(vertex_12_18, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.94445)));
      final vertex_12_19 = mesh_12.vertices.elementAt(19);
      expect(vertex_12_19, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -4.74829)));
      final vertex_12_20 = mesh_12.vertices.elementAt(20);
      expect(vertex_12_20, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -6.94445)));
      final vertex_12_21 = mesh_12.vertices.elementAt(21);
      expect(vertex_12_21, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.94445)));
      final vertex_12_22 = mesh_12.vertices.elementAt(22);
      expect(vertex_12_22, vector3MoreOrLessEquals(Vector3(-59.1961, 24.7256, -6.94445)));
      final vertex_12_23 = mesh_12.vertices.elementAt(23);
      expect(vertex_12_23, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -4.74829)));
      final vertex_12_24 = mesh_12.vertices.elementAt(24);
      expect(vertex_12_24, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.94445)));
      final vertex_12_25 = mesh_12.vertices.elementAt(25);
      expect(vertex_12_25, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -6.94445)));
      final vertex_12_26 = mesh_12.vertices.elementAt(26);
      expect(vertex_12_26, vector3MoreOrLessEquals(Vector3(-58.8, 5.77436, -9.94445)));
      final vertex_12_27 = mesh_12.vertices.elementAt(27);
      expect(vertex_12_27, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.94445)));
      final vertex_12_28 = mesh_12.vertices.elementAt(28);
      expect(vertex_12_28, vector3MoreOrLessEquals(Vector3(-60, 24.7256, -9.94445)));
      final vertex_12_29 = mesh_12.vertices.elementAt(29);
      expect(vertex_12_29, vector3MoreOrLessEquals(Vector3(-59.1961, 24.7256, -6.94445)));
      final vertex_12_30 = mesh_12.vertices.elementAt(30);
      expect(vertex_12_30, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -0.081627)));
      final vertex_12_31 = mesh_12.vertices.elementAt(31);
      expect(vertex_12_31, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -0.944447)));
      final vertex_12_32 = mesh_12.vertices.elementAt(32);
      expect(vertex_12_32, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -4.74829)));
      final vertex_12_33 = mesh_12.vertices.elementAt(33);
      expect(vertex_12_33, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -4.74829)));
      final vertex_12_34 = mesh_12.vertices.elementAt(34);
      expect(vertex_12_34, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -0.944447)));
      final vertex_12_35 = mesh_12.vertices.elementAt(35);
      expect(vertex_12_35, vector3MoreOrLessEquals(Vector3(-54, 10.6667, 1.82244)));
      final vertex_12_36 = mesh_12.vertices.elementAt(36);
      expect(vertex_12_36, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -4.74829)));
      final vertex_12_37 = mesh_12.vertices.elementAt(37);
      expect(vertex_12_37, vector3MoreOrLessEquals(Vector3(-54, 10.6667, 1.82244)));
      final vertex_12_38 = mesh_12.vertices.elementAt(38);
      expect(vertex_12_38, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -3.94445)));
      final vertex_12_39 = mesh_12.vertices.elementAt(39);
      expect(vertex_12_39, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -3.94445)));
      final vertex_12_40 = mesh_12.vertices.elementAt(40);
      expect(vertex_12_40, vector3MoreOrLessEquals(Vector3(-54, 10.6667, 1.82244)));
      final vertex_12_41 = mesh_12.vertices.elementAt(41);
      expect(vertex_12_41, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -4.74829)));
      final vertex_12_42 = mesh_12.vertices.elementAt(42);
      expect(vertex_12_42, vector3MoreOrLessEquals(Vector3(-54, 10.6667, 1.82244)));
      final vertex_12_43 = mesh_12.vertices.elementAt(43);
      expect(vertex_12_43, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -0.944447)));
      final vertex_12_44 = mesh_12.vertices.elementAt(44);
      expect(vertex_12_44, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -4.74829)));
      final vertex_12_45 = mesh_12.vertices.elementAt(45);
      expect(vertex_12_45, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -4.74829)));
      final vertex_12_46 = mesh_12.vertices.elementAt(46);
      expect(vertex_12_46, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -0.944447)));
      final vertex_12_47 = mesh_12.vertices.elementAt(47);
      expect(vertex_12_47, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -4.74829)));
      final vertex_12_48 = mesh_12.vertices.elementAt(48);
      expect(vertex_12_48, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -4.74829)));
      final vertex_12_49 = mesh_12.vertices.elementAt(49);
      expect(vertex_12_49, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -4.74829)));
      final vertex_12_50 = mesh_12.vertices.elementAt(50);
      expect(vertex_12_50, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -6.94445)));
      final vertex_12_51 = mesh_12.vertices.elementAt(51);
      expect(vertex_12_51, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -6.94445)));
      final vertex_12_52 = mesh_12.vertices.elementAt(52);
      expect(vertex_12_52, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -4.74829)));
      final vertex_12_53 = mesh_12.vertices.elementAt(53);
      expect(vertex_12_53, vector3MoreOrLessEquals(Vector3(-58.8, 5.77436, -9.94445)));
      final vertex_12_54 = mesh_12.vertices.elementAt(54);
      expect(vertex_12_54, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -4.74829)));
      final vertex_12_55 = mesh_12.vertices.elementAt(55);
      expect(vertex_12_55, vector3MoreOrLessEquals(Vector3(-64.1923, 7.53335, -9.94445)));
      final vertex_12_56 = mesh_12.vertices.elementAt(56);
      expect(vertex_12_56, vector3MoreOrLessEquals(Vector3(-58.8, 5.77436, -9.94445)));
      final vertex_12_57 = mesh_12.vertices.elementAt(57);
      expect(vertex_12_57, vector3MoreOrLessEquals(Vector3(-43.6077, 8.33333, -9.94445)));
      final vertex_12_58 = mesh_12.vertices.elementAt(58);
      expect(vertex_12_58, vector3MoreOrLessEquals(Vector3(-37.2, 18.6544, -9.94445)));
      final vertex_12_59 = mesh_12.vertices.elementAt(59);
      expect(vertex_12_59, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -0.081627)));
      final vertex_12_60 = mesh_12.vertices.elementAt(60);
      expect(vertex_12_60, vector3MoreOrLessEquals(Vector3(-37.2, 18.6544, -9.94445)));
      final vertex_12_61 = mesh_12.vertices.elementAt(61);
      expect(vertex_12_61, vector3MoreOrLessEquals(Vector3(-39.2521, 18.6544, -0.06192)));
      final vertex_12_62 = mesh_12.vertices.elementAt(62);
      expect(vertex_12_62, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -0.081627)));
      final vertex_12_63 = mesh_12.vertices.elementAt(63);
      expect(vertex_12_63, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -0.081627)));
      final vertex_12_64 = mesh_12.vertices.elementAt(64);
      expect(vertex_12_64, vector3MoreOrLessEquals(Vector3(-39.2521, 18.6544, -0.06192)));
      final vertex_12_65 = mesh_12.vertices.elementAt(65);
      expect(vertex_12_65, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_66 = mesh_12.vertices.elementAt(66);
      expect(vertex_12_66, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -0.081627)));
      final vertex_12_67 = mesh_12.vertices.elementAt(67);
      expect(vertex_12_67, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_68 = mesh_12.vertices.elementAt(68);
      expect(vertex_12_68, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -0.944447)));
      final vertex_12_69 = mesh_12.vertices.elementAt(69);
      expect(vertex_12_69, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -0.944447)));
      final vertex_12_70 = mesh_12.vertices.elementAt(70);
      expect(vertex_12_70, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_71 = mesh_12.vertices.elementAt(71);
      expect(vertex_12_71, vector3MoreOrLessEquals(Vector3(-54, 10.6667, 1.82244)));
      final vertex_12_72 = mesh_12.vertices.elementAt(72);
      expect(vertex_12_72, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_73 = mesh_12.vertices.elementAt(73);
      expect(vertex_12_73, vector3MoreOrLessEquals(Vector3(-54, 14.3333, 2.05555)));
      final vertex_12_74 = mesh_12.vertices.elementAt(74);
      expect(vertex_12_74, vector3MoreOrLessEquals(Vector3(-54, 10.6667, 1.82244)));
      final vertex_12_75 = mesh_12.vertices.elementAt(75);
      expect(vertex_12_75, vector3MoreOrLessEquals(Vector3(-54, 10.6667, 1.82244)));
      final vertex_12_76 = mesh_12.vertices.elementAt(76);
      expect(vertex_12_76, vector3MoreOrLessEquals(Vector3(-54, 14.3333, 2.05555)));
      final vertex_12_77 = mesh_12.vertices.elementAt(77);
      expect(vertex_12_77, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_78 = mesh_12.vertices.elementAt(78);
      expect(vertex_12_78, vector3MoreOrLessEquals(Vector3(-54, 10.6667, 1.82244)));
      final vertex_12_79 = mesh_12.vertices.elementAt(79);
      expect(vertex_12_79, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_80 = mesh_12.vertices.elementAt(80);
      expect(vertex_12_80, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -0.944447)));
      final vertex_12_81 = mesh_12.vertices.elementAt(81);
      expect(vertex_12_81, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -0.944447)));
      final vertex_12_82 = mesh_12.vertices.elementAt(82);
      expect(vertex_12_82, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_83 = mesh_12.vertices.elementAt(83);
      expect(vertex_12_83, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -4.74829)));
      final vertex_12_84 = mesh_12.vertices.elementAt(84);
      expect(vertex_12_84, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_85 = mesh_12.vertices.elementAt(85);
      expect(vertex_12_85, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -6.36709)));
      final vertex_12_86 = mesh_12.vertices.elementAt(86);
      expect(vertex_12_86, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -4.74829)));
      final vertex_12_87 = mesh_12.vertices.elementAt(87);
      expect(vertex_12_87, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -4.74829)));
      final vertex_12_88 = mesh_12.vertices.elementAt(88);
      expect(vertex_12_88, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -6.36709)));
      final vertex_12_89 = mesh_12.vertices.elementAt(89);
      expect(vertex_12_89, vector3MoreOrLessEquals(Vector3(-66.4, 12.3333, -9.94445)));
      final vertex_12_90 = mesh_12.vertices.elementAt(90);
      expect(vertex_12_90, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -4.74829)));
      final vertex_12_91 = mesh_12.vertices.elementAt(91);
      expect(vertex_12_91, vector3MoreOrLessEquals(Vector3(-66.4, 12.3333, -9.94445)));
      final vertex_12_92 = mesh_12.vertices.elementAt(92);
      expect(vertex_12_92, vector3MoreOrLessEquals(Vector3(-64.1923, 7.53335, -9.94445)));
      final vertex_12_93 = mesh_12.vertices.elementAt(93);
      expect(vertex_12_93, vector3MoreOrLessEquals(Vector3(-37.2, 18.6544, -9.94445)));
      final vertex_12_94 = mesh_12.vertices.elementAt(94);
      expect(vertex_12_94, vector3MoreOrLessEquals(Vector3(-38.8077, 21.886, -9.94445)));
      final vertex_12_95 = mesh_12.vertices.elementAt(95);
      expect(vertex_12_95, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -0.760713)));
      final vertex_12_96 = mesh_12.vertices.elementAt(96);
      expect(vertex_12_96, vector3MoreOrLessEquals(Vector3(-37.2, 18.6544, -9.94445)));
      final vertex_12_97 = mesh_12.vertices.elementAt(97);
      expect(vertex_12_97, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -0.760713)));
      final vertex_12_98 = mesh_12.vertices.elementAt(98);
      expect(vertex_12_98, vector3MoreOrLessEquals(Vector3(-39.2521, 18.6544, -0.06192)));
      final vertex_12_99 = mesh_12.vertices.elementAt(99);
      expect(vertex_12_99, vector3MoreOrLessEquals(Vector3(-39.2521, 18.6544, -0.06192)));
      final vertex_12_100 = mesh_12.vertices.elementAt(100);
      expect(vertex_12_100, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -0.760713)));
      final vertex_12_101 = mesh_12.vertices.elementAt(101);
      expect(vertex_12_101, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_102 = mesh_12.vertices.elementAt(102);
      expect(vertex_12_102, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -0.760713)));
      final vertex_12_103 = mesh_12.vertices.elementAt(103);
      expect(vertex_12_103, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, 2.54601)));
      final vertex_12_104 = mesh_12.vertices.elementAt(104);
      expect(vertex_12_104, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_105 = mesh_12.vertices.elementAt(105);
      expect(vertex_12_105, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_106 = mesh_12.vertices.elementAt(106);
      expect(vertex_12_106, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, 2.54601)));
      final vertex_12_107 = mesh_12.vertices.elementAt(107);
      expect(vertex_12_107, vector3MoreOrLessEquals(Vector3(-54, 20.3333, 0.447858)));
      final vertex_12_108 = mesh_12.vertices.elementAt(108);
      expect(vertex_12_108, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, 3.75635)));
      final vertex_12_109 = mesh_12.vertices.elementAt(109);
      expect(vertex_12_109, vector3MoreOrLessEquals(Vector3(-54, 20.3333, 0.447858)));
      final vertex_12_110 = mesh_12.vertices.elementAt(110);
      expect(vertex_12_110, vector3MoreOrLessEquals(Vector3(-54, 14.3333, 2.05555)));
      final vertex_12_111 = mesh_12.vertices.elementAt(111);
      expect(vertex_12_111, vector3MoreOrLessEquals(Vector3(-54, 14.3333, 2.05555)));
      final vertex_12_112 = mesh_12.vertices.elementAt(112);
      expect(vertex_12_112, vector3MoreOrLessEquals(Vector3(-54, 20.3333, 0.447858)));
      final vertex_12_113 = mesh_12.vertices.elementAt(113);
      expect(vertex_12_113, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_114 = mesh_12.vertices.elementAt(114);
      expect(vertex_12_114, vector3MoreOrLessEquals(Vector3(-54, 20.3333, 0.447858)));
      final vertex_12_115 = mesh_12.vertices.elementAt(115);
      expect(vertex_12_115, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -2.19914)));
      final vertex_12_116 = mesh_12.vertices.elementAt(116);
      expect(vertex_12_116, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_117 = mesh_12.vertices.elementAt(117);
      expect(vertex_12_117, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -6.36709)));
      final vertex_12_118 = mesh_12.vertices.elementAt(118);
      expect(vertex_12_118, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_119 = mesh_12.vertices.elementAt(119);
      expect(vertex_12_119, vector3MoreOrLessEquals(Vector3(-66.4, 12.3333, -9.94445)));
      final vertex_12_120 = mesh_12.vertices.elementAt(120);
      expect(vertex_12_120, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_121 = mesh_12.vertices.elementAt(121);
      expect(vertex_12_121, vector3MoreOrLessEquals(Vector3(-64.3923, 20.3333, -9.94445)));
      final vertex_12_122 = mesh_12.vertices.elementAt(122);
      expect(vertex_12_122, vector3MoreOrLessEquals(Vector3(-66.4, 12.3333, -9.94445)));
      final vertex_12_123 = mesh_12.vertices.elementAt(123);
      expect(vertex_12_123, vector3MoreOrLessEquals(Vector3(-38.8077, 21.886, -9.94445)));
      final vertex_12_124 = mesh_12.vertices.elementAt(124);
      expect(vertex_12_124, vector3MoreOrLessEquals(Vector3(-43.2, 24.2518, -9.94445)));
      final vertex_12_125 = mesh_12.vertices.elementAt(125);
      expect(vertex_12_125, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -0.760713)));
      final vertex_12_126 = mesh_12.vertices.elementAt(126);
      expect(vertex_12_126, vector3MoreOrLessEquals(Vector3(-43.2, 24.2518, -9.94445)));
      final vertex_12_127 = mesh_12.vertices.elementAt(127);
      expect(vertex_12_127, vector3MoreOrLessEquals(Vector3(-44.0038, 24.2518, -7.33652)));
      final vertex_12_128 = mesh_12.vertices.elementAt(128);
      expect(vertex_12_128, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -0.760713)));
      final vertex_12_129 = mesh_12.vertices.elementAt(129);
      expect(vertex_12_129, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -0.760713)));
      final vertex_12_130 = mesh_12.vertices.elementAt(130);
      expect(vertex_12_130, vector3MoreOrLessEquals(Vector3(-44.0038, 24.2518, -7.33652)));
      final vertex_12_131 = mesh_12.vertices.elementAt(131);
      expect(vertex_12_131, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -0.760711)));
      final vertex_12_132 = mesh_12.vertices.elementAt(132);
      expect(vertex_12_132, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -0.760713)));
      final vertex_12_133 = mesh_12.vertices.elementAt(133);
      expect(vertex_12_133, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -0.760711)));
      final vertex_12_134 = mesh_12.vertices.elementAt(134);
      expect(vertex_12_134, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, 2.54601)));
      final vertex_12_135 = mesh_12.vertices.elementAt(135);
      expect(vertex_12_135, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, 2.54601)));
      final vertex_12_136 = mesh_12.vertices.elementAt(136);
      expect(vertex_12_136, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -0.760711)));
      final vertex_12_137 = mesh_12.vertices.elementAt(137);
      expect(vertex_12_137, vector3MoreOrLessEquals(Vector3(-54, 20.3333, 0.447858)));
      final vertex_12_138 = mesh_12.vertices.elementAt(138);
      expect(vertex_12_138, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -0.760711)));
      final vertex_12_139 = mesh_12.vertices.elementAt(139);
      expect(vertex_12_139, vector3MoreOrLessEquals(Vector3(-54, 24.7256, -3.94445)));
      final vertex_12_140 = mesh_12.vertices.elementAt(140);
      expect(vertex_12_140, vector3MoreOrLessEquals(Vector3(-54, 20.3333, 0.447858)));
      final vertex_12_141 = mesh_12.vertices.elementAt(141);
      expect(vertex_12_141, vector3MoreOrLessEquals(Vector3(-54, 20.3333, 0.447858)));
      final vertex_12_142 = mesh_12.vertices.elementAt(142);
      expect(vertex_12_142, vector3MoreOrLessEquals(Vector3(-54, 24.7256, -3.94445)));
      final vertex_12_143 = mesh_12.vertices.elementAt(143);
      expect(vertex_12_143, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -4.74829)));
      final vertex_12_144 = mesh_12.vertices.elementAt(144);
      expect(vertex_12_144, vector3MoreOrLessEquals(Vector3(-54, 20.3333, 0.447858)));
      final vertex_12_145 = mesh_12.vertices.elementAt(145);
      expect(vertex_12_145, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -4.74829)));
      final vertex_12_146 = mesh_12.vertices.elementAt(146);
      expect(vertex_12_146, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -2.19914)));
      final vertex_12_147 = mesh_12.vertices.elementAt(147);
      expect(vertex_12_147, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -2.19914)));
      final vertex_12_148 = mesh_12.vertices.elementAt(148);
      expect(vertex_12_148, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -4.74829)));
      final vertex_12_149 = mesh_12.vertices.elementAt(149);
      expect(vertex_12_149, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_150 = mesh_12.vertices.elementAt(150);
      expect(vertex_12_150, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -4.74829)));
      final vertex_12_151 = mesh_12.vertices.elementAt(151);
      expect(vertex_12_151, vector3MoreOrLessEquals(Vector3(-59.1961, 24.7256, -6.94445)));
      final vertex_12_152 = mesh_12.vertices.elementAt(152);
      expect(vertex_12_152, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_153 = mesh_12.vertices.elementAt(153);
      expect(vertex_12_153, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_154 = mesh_12.vertices.elementAt(154);
      expect(vertex_12_154, vector3MoreOrLessEquals(Vector3(-59.1961, 24.7256, -6.94445)));
      final vertex_12_155 = mesh_12.vertices.elementAt(155);
      expect(vertex_12_155, vector3MoreOrLessEquals(Vector3(-60, 24.7256, -9.94445)));
      final vertex_12_156 = mesh_12.vertices.elementAt(156);
      expect(vertex_12_156, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_157 = mesh_12.vertices.elementAt(157);
      expect(vertex_12_157, vector3MoreOrLessEquals(Vector3(-60, 24.7256, -9.94445)));
      final vertex_12_158 = mesh_12.vertices.elementAt(158);
      expect(vertex_12_158, vector3MoreOrLessEquals(Vector3(-64.3923, 20.3333, -9.94445)));
      final vertex_12_159 = mesh_12.vertices.elementAt(159);
      expect(vertex_12_159, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -6.13926)));
      final vertex_12_160 = mesh_12.vertices.elementAt(160);
      expect(vertex_12_160, vector3MoreOrLessEquals(Vector3(-62.366, 15.3991, -5.60484)));
      final vertex_12_161 = mesh_12.vertices.elementAt(161);
      expect(vertex_12_161, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -5.48682)));
      final vertex_12_162 = mesh_12.vertices.elementAt(162);
      expect(vertex_12_162, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -6.36709)));
      final vertex_12_163 = mesh_12.vertices.elementAt(163);
      expect(vertex_12_163, vector3MoreOrLessEquals(Vector3(-62.9556, 14.6429, -5.39026)));
      final vertex_12_164 = mesh_12.vertices.elementAt(164);
      expect(vertex_12_164, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -5.48682)));
      final vertex_12_165 = mesh_12.vertices.elementAt(165);
      expect(vertex_12_165, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -5.48682)));
      final vertex_12_166 = mesh_12.vertices.elementAt(166);
      expect(vertex_12_166, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -6.13926)));
      final vertex_12_167 = mesh_12.vertices.elementAt(167);
      expect(vertex_12_167, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -6.36709)));
      final vertex_12_168 = mesh_12.vertices.elementAt(168);
      expect(vertex_12_168, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -4.19187)));
      final vertex_12_169 = mesh_12.vertices.elementAt(169);
      expect(vertex_12_169, vector3MoreOrLessEquals(Vector3(-62.9556, 14.6429, -5.39026)));
      final vertex_12_170 = mesh_12.vertices.elementAt(170);
      expect(vertex_12_170, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -6.36709)));
      final vertex_12_171 = mesh_12.vertices.elementAt(171);
      expect(vertex_12_171, vector3MoreOrLessEquals(Vector3(-62.9556, 14.6429, -5.39026)));
      final vertex_12_172 = mesh_12.vertices.elementAt(172);
      expect(vertex_12_172, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -4.19187)));
      final vertex_12_173 = mesh_12.vertices.elementAt(173);
      expect(vertex_12_173, vector3MoreOrLessEquals(Vector3(-62.0774, 15.0709, -4.59818)));
      final vertex_12_174 = mesh_12.vertices.elementAt(174);
      expect(vertex_12_174, vector3MoreOrLessEquals(Vector3(-62.0774, 15.0709, -4.59818)));
      final vertex_12_175 = mesh_12.vertices.elementAt(175);
      expect(vertex_12_175, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -5.48682)));
      final vertex_12_176 = mesh_12.vertices.elementAt(176);
      expect(vertex_12_176, vector3MoreOrLessEquals(Vector3(-62.9556, 14.6429, -5.39026)));
      final vertex_12_177 = mesh_12.vertices.elementAt(177);
      expect(vertex_12_177, vector3MoreOrLessEquals(Vector3(-61.7381, 15.7372, -3.41491)));
      final vertex_12_178 = mesh_12.vertices.elementAt(178);
      expect(vertex_12_178, vector3MoreOrLessEquals(Vector3(-62.0774, 15.0709, -4.59818)));
      final vertex_12_179 = mesh_12.vertices.elementAt(179);
      expect(vertex_12_179, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -4.19187)));
      final vertex_12_180 = mesh_12.vertices.elementAt(180);
      expect(vertex_12_180, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -4.19187)));
      final vertex_12_181 = mesh_12.vertices.elementAt(181);
      expect(vertex_12_181, vector3MoreOrLessEquals(Vector3(-61.6405, 15.3095, -2.69388)));
      final vertex_12_182 = mesh_12.vertices.elementAt(182);
      expect(vertex_12_182, vector3MoreOrLessEquals(Vector3(-61.7381, 15.7372, -3.41491)));
      final vertex_12_183 = mesh_12.vertices.elementAt(183);
      expect(vertex_12_183, vector3MoreOrLessEquals(Vector3(-61.5534, 16.7451, -2.77082)));
      final vertex_12_184 = mesh_12.vertices.elementAt(184);
      expect(vertex_12_184, vector3MoreOrLessEquals(Vector3(-61.7381, 15.7372, -3.41491)));
      final vertex_12_185 = mesh_12.vertices.elementAt(185);
      expect(vertex_12_185, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -2.24448)));
      final vertex_12_186 = mesh_12.vertices.elementAt(186);
      expect(vertex_12_186, vector3MoreOrLessEquals(Vector3(-61.6405, 15.3095, -2.69388)));
      final vertex_12_187 = mesh_12.vertices.elementAt(187);
      expect(vertex_12_187, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -2.24448)));
      final vertex_12_188 = mesh_12.vertices.elementAt(188);
      expect(vertex_12_188, vector3MoreOrLessEquals(Vector3(-61.7381, 15.7372, -3.41491)));
      final vertex_12_189 = mesh_12.vertices.elementAt(189);
      expect(vertex_12_189, vector3MoreOrLessEquals(Vector3(-61.5825, 17.6345, -2.87215)));
      final vertex_12_190 = mesh_12.vertices.elementAt(190);
      expect(vertex_12_190, vector3MoreOrLessEquals(Vector3(-61.5534, 16.7451, -2.77082)));
      final vertex_12_191 = mesh_12.vertices.elementAt(191);
      expect(vertex_12_191, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -2.54408)));
      final vertex_12_192 = mesh_12.vertices.elementAt(192);
      expect(vertex_12_192, vector3MoreOrLessEquals(Vector3(-61.5534, 16.7451, -2.77082)));
      final vertex_12_193 = mesh_12.vertices.elementAt(193);
      expect(vertex_12_193, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -2.24448)));
      final vertex_12_194 = mesh_12.vertices.elementAt(194);
      expect(vertex_12_194, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -2.54408)));
      final vertex_12_195 = mesh_12.vertices.elementAt(195);
      expect(vertex_12_195, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -2.54408)));
      final vertex_12_196 = mesh_12.vertices.elementAt(196);
      expect(vertex_12_196, vector3MoreOrLessEquals(Vector3(-61.725, 18.1557, -3.36926)));
      final vertex_12_197 = mesh_12.vertices.elementAt(197);
      expect(vertex_12_197, vector3MoreOrLessEquals(Vector3(-61.5825, 17.6345, -2.87215)));
      final vertex_12_198 = mesh_12.vertices.elementAt(198);
      expect(vertex_12_198, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -2.54408)));
      final vertex_12_199 = mesh_12.vertices.elementAt(199);
      expect(vertex_12_199, vector3MoreOrLessEquals(Vector3(-61.8597, 18.4762, -3.14327)));
      final vertex_12_200 = mesh_12.vertices.elementAt(200);
      expect(vertex_12_200, vector3MoreOrLessEquals(Vector3(-61.725, 18.1557, -3.36926)));
      final vertex_12_201 = mesh_12.vertices.elementAt(201);
      expect(vertex_12_201, vector3MoreOrLessEquals(Vector3(-61.8597, 18.4762, -3.14327)));
      final vertex_12_202 = mesh_12.vertices.elementAt(202);
      expect(vertex_12_202, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -4.04208)));
      final vertex_12_203 = mesh_12.vertices.elementAt(203);
      expect(vertex_12_203, vector3MoreOrLessEquals(Vector3(-61.725, 18.1557, -3.36926)));
      final vertex_12_204 = mesh_12.vertices.elementAt(204);
      expect(vertex_12_204, vector3MoreOrLessEquals(Vector3(-61.8941, 18.0416, -3.95886)));
      final vertex_12_205 = mesh_12.vertices.elementAt(205);
      expect(vertex_12_205, vector3MoreOrLessEquals(Vector3(-61.725, 18.1557, -3.36926)));
      final vertex_12_206 = mesh_12.vertices.elementAt(206);
      expect(vertex_12_206, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -4.04208)));
      final vertex_12_207 = mesh_12.vertices.elementAt(207);
      expect(vertex_12_207, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -4.04208)));
      final vertex_12_208 = mesh_12.vertices.elementAt(208);
      expect(vertex_12_208, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -4.94086)));
      final vertex_12_209 = mesh_12.vertices.elementAt(209);
      expect(vertex_12_209, vector3MoreOrLessEquals(Vector3(-61.8941, 18.0416, -3.95886)));
      final vertex_12_210 = mesh_12.vertices.elementAt(210);
      expect(vertex_12_210, vector3MoreOrLessEquals(Vector3(-62.0704, 17.6997, -4.57366)));
      final vertex_12_211 = mesh_12.vertices.elementAt(211);
      expect(vertex_12_211, vector3MoreOrLessEquals(Vector3(-61.8941, 18.0416, -3.95886)));
      final vertex_12_212 = mesh_12.vertices.elementAt(212);
      expect(vertex_12_212, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -4.94086)));
      final vertex_12_213 = mesh_12.vertices.elementAt(213);
      expect(vertex_12_213, vector3MoreOrLessEquals(Vector3(-62.1186, 16.9811, -4.74192)));
      final vertex_12_214 = mesh_12.vertices.elementAt(214);
      expect(vertex_12_214, vector3MoreOrLessEquals(Vector3(-62.0704, 17.6997, -4.57366)));
      final vertex_12_215 = mesh_12.vertices.elementAt(215);
      expect(vertex_12_215, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -4.94086)));
      final vertex_12_216 = mesh_12.vertices.elementAt(216);
      expect(vertex_12_216, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -4.94086)));
      final vertex_12_217 = mesh_12.vertices.elementAt(217);
      expect(vertex_12_217, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -5.39026)));
      final vertex_12_218 = mesh_12.vertices.elementAt(218);
      expect(vertex_12_218, vector3MoreOrLessEquals(Vector3(-62.1186, 16.9811, -4.74192)));
      final vertex_12_219 = mesh_12.vertices.elementAt(219);
      expect(vertex_12_219, vector3MoreOrLessEquals(Vector3(-62.2019, 16.1617, -5.03228)));
      final vertex_12_220 = mesh_12.vertices.elementAt(220);
      expect(vertex_12_220, vector3MoreOrLessEquals(Vector3(-62.1186, 16.9811, -4.74192)));
      final vertex_12_221 = mesh_12.vertices.elementAt(221);
      expect(vertex_12_221, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -5.39026)));
      final vertex_12_222 = mesh_12.vertices.elementAt(222);
      expect(vertex_12_222, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -5.39026)));
      final vertex_12_223 = mesh_12.vertices.elementAt(223);
      expect(vertex_12_223, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -5.98946)));
      final vertex_12_224 = mesh_12.vertices.elementAt(224);
      expect(vertex_12_224, vector3MoreOrLessEquals(Vector3(-62.2019, 16.1617, -5.03228)));
      final vertex_12_225 = mesh_12.vertices.elementAt(225);
      expect(vertex_12_225, vector3MoreOrLessEquals(Vector3(-62.366, 15.3991, -5.60484)));
      final vertex_12_226 = mesh_12.vertices.elementAt(226);
      expect(vertex_12_226, vector3MoreOrLessEquals(Vector3(-62.2019, 16.1617, -5.03228)));
      final vertex_12_227 = mesh_12.vertices.elementAt(227);
      expect(vertex_12_227, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -5.98946)));
      final vertex_12_228 = mesh_12.vertices.elementAt(228);
      expect(vertex_12_228, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -5.98946)));
      final vertex_12_229 = mesh_12.vertices.elementAt(229);
      expect(vertex_12_229, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -6.13926)));
      final vertex_12_230 = mesh_12.vertices.elementAt(230);
      expect(vertex_12_230, vector3MoreOrLessEquals(Vector3(-62.366, 15.3991, -5.60484)));
      final vertex_12_231 = mesh_12.vertices.elementAt(231);
      expect(vertex_12_231, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -6.13926)));
      final vertex_12_232 = mesh_12.vertices.elementAt(232);
      expect(vertex_12_232, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_233 = mesh_12.vertices.elementAt(233);
      expect(vertex_12_233, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -6.36709)));
      final vertex_12_234 = mesh_12.vertices.elementAt(234);
      expect(vertex_12_234, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -6.13926)));
      final vertex_12_235 = mesh_12.vertices.elementAt(235);
      expect(vertex_12_235, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -5.98946)));
      final vertex_12_236 = mesh_12.vertices.elementAt(236);
      expect(vertex_12_236, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_237 = mesh_12.vertices.elementAt(237);
      expect(vertex_12_237, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -5.98946)));
      final vertex_12_238 = mesh_12.vertices.elementAt(238);
      expect(vertex_12_238, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -5.39026)));
      final vertex_12_239 = mesh_12.vertices.elementAt(239);
      expect(vertex_12_239, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_240 = mesh_12.vertices.elementAt(240);
      expect(vertex_12_240, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -5.39026)));
      final vertex_12_241 = mesh_12.vertices.elementAt(241);
      expect(vertex_12_241, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -4.94086)));
      final vertex_12_242 = mesh_12.vertices.elementAt(242);
      expect(vertex_12_242, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_243 = mesh_12.vertices.elementAt(243);
      expect(vertex_12_243, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -4.94086)));
      final vertex_12_244 = mesh_12.vertices.elementAt(244);
      expect(vertex_12_244, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -4.04208)));
      final vertex_12_245 = mesh_12.vertices.elementAt(245);
      expect(vertex_12_245, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_246 = mesh_12.vertices.elementAt(246);
      expect(vertex_12_246, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -2.19914)));
      final vertex_12_247 = mesh_12.vertices.elementAt(247);
      expect(vertex_12_247, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -6.81024)));
      final vertex_12_248 = mesh_12.vertices.elementAt(248);
      expect(vertex_12_248, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -4.04208)));
      final vertex_12_249 = mesh_12.vertices.elementAt(249);
      expect(vertex_12_249, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -4.04208)));
      final vertex_12_250 = mesh_12.vertices.elementAt(250);
      expect(vertex_12_250, vector3MoreOrLessEquals(Vector3(-61.8597, 18.4762, -3.14327)));
      final vertex_12_251 = mesh_12.vertices.elementAt(251);
      expect(vertex_12_251, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -2.19914)));
      final vertex_12_252 = mesh_12.vertices.elementAt(252);
      expect(vertex_12_252, vector3MoreOrLessEquals(Vector3(-61.8597, 18.4762, -3.14327)));
      final vertex_12_253 = mesh_12.vertices.elementAt(253);
      expect(vertex_12_253, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -2.54408)));
      final vertex_12_254 = mesh_12.vertices.elementAt(254);
      expect(vertex_12_254, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -2.19914)));
      final vertex_12_255 = mesh_12.vertices.elementAt(255);
      expect(vertex_12_255, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -4.19187)));
      final vertex_12_256 = mesh_12.vertices.elementAt(256);
      expect(vertex_12_256, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -6.36709)));
      final vertex_12_257 = mesh_12.vertices.elementAt(257);
      expect(vertex_12_257, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_258 = mesh_12.vertices.elementAt(258);
      expect(vertex_12_258, vector3MoreOrLessEquals(Vector3(-61.6405, 15.3095, -2.69388)));
      final vertex_12_259 = mesh_12.vertices.elementAt(259);
      expect(vertex_12_259, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -4.19187)));
      final vertex_12_260 = mesh_12.vertices.elementAt(260);
      expect(vertex_12_260, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_261 = mesh_12.vertices.elementAt(261);
      expect(vertex_12_261, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -2.24448)));
      final vertex_12_262 = mesh_12.vertices.elementAt(262);
      expect(vertex_12_262, vector3MoreOrLessEquals(Vector3(-61.6405, 15.3095, -2.69388)));
      final vertex_12_263 = mesh_12.vertices.elementAt(263);
      expect(vertex_12_263, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_264 = mesh_12.vertices.elementAt(264);
      expect(vertex_12_264, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      final vertex_12_265 = mesh_12.vertices.elementAt(265);
      expect(vertex_12_265, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -2.19914)));
      final vertex_12_266 = mesh_12.vertices.elementAt(266);
      expect(vertex_12_266, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -2.54408)));
      final vertex_12_267 = mesh_12.vertices.elementAt(267);
      expect(vertex_12_267, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -2.24448)));
      final vertex_12_268 = mesh_12.vertices.elementAt(268);
      expect(vertex_12_268, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -2.54408)));
      final vertex_12_269 = mesh_12.vertices.elementAt(269);
      expect(vertex_12_269, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -1.04267)));
      expect(mesh_12.normals.length, equals(270));
      final normal_12_0 = mesh_12.normals.elementAt(0);
      expect(normal_12_0, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, 0.15406)));
      final normal_12_1 = mesh_12.normals.elementAt(1);
      expect(normal_12_1, vector3MoreOrLessEquals(Vector3(0.285617, 0.953018, 0.10089)));
      final normal_12_2 = mesh_12.normals.elementAt(2);
      expect(normal_12_2, vector3MoreOrLessEquals(Vector3(0.356408, 0.929723, 0.092678)));
      final normal_12_3 = mesh_12.normals.elementAt(3);
      expect(normal_12_3, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, 0.15406)));
      final normal_12_4 = mesh_12.normals.elementAt(4);
      expect(normal_12_4, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, 0.398579)));
      final normal_12_5 = mesh_12.normals.elementAt(5);
      expect(normal_12_5, vector3MoreOrLessEquals(Vector3(0.285617, 0.953018, 0.10089)));
      final normal_12_6 = mesh_12.normals.elementAt(6);
      expect(normal_12_6, vector3MoreOrLessEquals(Vector3(-0.438098, -0.839825, 0.32057)));
      final normal_12_7 = mesh_12.normals.elementAt(7);
      expect(normal_12_7, vector3MoreOrLessEquals(Vector3(0.039808, -0.749385, 0.660937)));
      final normal_12_8 = mesh_12.normals.elementAt(8);
      expect(normal_12_8, vector3MoreOrLessEquals(Vector3(-0.436422, -0.758689, 0.48366)));
      final normal_12_9 = mesh_12.normals.elementAt(9);
      expect(normal_12_9, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, 0.15406)));
      final normal_12_10 = mesh_12.normals.elementAt(10);
      expect(normal_12_10, vector3MoreOrLessEquals(Vector3(-0.144622, 0.858467, 0.492057)));
      final normal_12_11 = mesh_12.normals.elementAt(11);
      expect(normal_12_11, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, 0.398579)));
      final normal_12_12 = mesh_12.normals.elementAt(12);
      expect(normal_12_12, vector3MoreOrLessEquals(Vector3(-0.438098, -0.839825, 0.32057)));
      final normal_12_13 = mesh_12.normals.elementAt(13);
      expect(normal_12_13, vector3MoreOrLessEquals(Vector3(-0.436422, -0.758689, 0.48366)));
      final normal_12_14 = mesh_12.normals.elementAt(14);
      expect(normal_12_14, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, 0.451023)));
      final normal_12_15 = mesh_12.normals.elementAt(15);
      expect(normal_12_15, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, 0.15406)));
      final normal_12_16 = mesh_12.normals.elementAt(16);
      expect(normal_12_16, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, 0.515371)));
      final normal_12_17 = mesh_12.normals.elementAt(17);
      expect(normal_12_17, vector3MoreOrLessEquals(Vector3(-0.144622, 0.858467, 0.492057)));
      final normal_12_18 = mesh_12.normals.elementAt(18);
      expect(normal_12_18, vector3MoreOrLessEquals(Vector3(-0.438098, -0.839825, 0.32057)));
      final normal_12_19 = mesh_12.normals.elementAt(19);
      expect(normal_12_19, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, 0.451023)));
      final normal_12_20 = mesh_12.normals.elementAt(20);
      expect(normal_12_20, vector3MoreOrLessEquals(Vector3(-0.35184, -0.855427, 0.380071)));
      final normal_12_21 = mesh_12.normals.elementAt(21);
      expect(normal_12_21, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, 0.15406)));
      final normal_12_22 = mesh_12.normals.elementAt(22);
      expect(normal_12_22, vector3MoreOrLessEquals(Vector3(-0.503913, 0.811284, 0.296463)));
      final normal_12_23 = mesh_12.normals.elementAt(23);
      expect(normal_12_23, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, 0.515371)));
      final normal_12_24 = mesh_12.normals.elementAt(24);
      expect(normal_12_24, vector3MoreOrLessEquals(Vector3(-0.438098, -0.839825, 0.32057)));
      final normal_12_25 = mesh_12.normals.elementAt(25);
      expect(normal_12_25, vector3MoreOrLessEquals(Vector3(-0.35184, -0.855427, 0.380071)));
      final normal_12_26 = mesh_12.normals.elementAt(26);
      expect(normal_12_26, vector3MoreOrLessEquals(Vector3(-0.434503, -0.886238, 0.160593)));
      final normal_12_27 = mesh_12.normals.elementAt(27);
      expect(normal_12_27, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, 0.15406)));
      final normal_12_28 = mesh_12.normals.elementAt(28);
      expect(normal_12_28, vector3MoreOrLessEquals(Vector3(-0.589554, 0.76685, 0.253707)));
      final normal_12_29 = mesh_12.normals.elementAt(29);
      expect(normal_12_29, vector3MoreOrLessEquals(Vector3(-0.503913, 0.811284, 0.296463)));
      final normal_12_30 = mesh_12.normals.elementAt(30);
      expect(normal_12_30, vector3MoreOrLessEquals(Vector3(0.461124, -0.566742, 0.682765)));
      final normal_12_31 = mesh_12.normals.elementAt(31);
      expect(normal_12_31, vector3MoreOrLessEquals(Vector3(-0.033279, -0.530249, 0.847189)));
      final normal_12_32 = mesh_12.normals.elementAt(32);
      expect(normal_12_32, vector3MoreOrLessEquals(Vector3(0.039808, -0.749385, 0.660937)));
      final normal_12_33 = mesh_12.normals.elementAt(33);
      expect(normal_12_33, vector3MoreOrLessEquals(Vector3(0.039808, -0.749385, 0.660937)));
      final normal_12_34 = mesh_12.normals.elementAt(34);
      expect(normal_12_34, vector3MoreOrLessEquals(Vector3(-0.033279, -0.530249, 0.847189)));
      final normal_12_35 = mesh_12.normals.elementAt(35);
      expect(normal_12_35, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, 0.863794)));
      final normal_12_36 = mesh_12.normals.elementAt(36);
      expect(normal_12_36, vector3MoreOrLessEquals(Vector3(0.039808, -0.749385, 0.660937)));
      final normal_12_37 = mesh_12.normals.elementAt(37);
      expect(normal_12_37, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, 0.863794)));
      final normal_12_38 = mesh_12.normals.elementAt(38);
      expect(normal_12_38, vector3MoreOrLessEquals(Vector3(-0.436422, -0.758689, 0.48366)));
      final normal_12_39 = mesh_12.normals.elementAt(39);
      expect(normal_12_39, vector3MoreOrLessEquals(Vector3(-0.436422, -0.758689, 0.48366)));
      final normal_12_40 = mesh_12.normals.elementAt(40);
      expect(normal_12_40, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, 0.863794)));
      final normal_12_41 = mesh_12.normals.elementAt(41);
      expect(normal_12_41, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, 0.451023)));
      final normal_12_42 = mesh_12.normals.elementAt(42);
      expect(normal_12_42, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, 0.863794)));
      final normal_12_43 = mesh_12.normals.elementAt(43);
      expect(normal_12_43, vector3MoreOrLessEquals(Vector3(-0.332554, -0.675497, 0.658112)));
      final normal_12_44 = mesh_12.normals.elementAt(44);
      expect(normal_12_44, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, 0.451023)));
      final normal_12_45 = mesh_12.normals.elementAt(45);
      expect(normal_12_45, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, 0.451023)));
      final normal_12_46 = mesh_12.normals.elementAt(46);
      expect(normal_12_46, vector3MoreOrLessEquals(Vector3(-0.332554, -0.675497, 0.658112)));
      final normal_12_47 = mesh_12.normals.elementAt(47);
      expect(normal_12_47, vector3MoreOrLessEquals(Vector3(-0.624353, -0.649034, 0.434671)));
      final normal_12_48 = mesh_12.normals.elementAt(48);
      expect(normal_12_48, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, 0.451023)));
      final normal_12_49 = mesh_12.normals.elementAt(49);
      expect(normal_12_49, vector3MoreOrLessEquals(Vector3(-0.624353, -0.649034, 0.434671)));
      final normal_12_50 = mesh_12.normals.elementAt(50);
      expect(normal_12_50, vector3MoreOrLessEquals(Vector3(-0.35184, -0.855427, 0.380071)));
      final normal_12_51 = mesh_12.normals.elementAt(51);
      expect(normal_12_51, vector3MoreOrLessEquals(Vector3(-0.35184, -0.855427, 0.380071)));
      final normal_12_52 = mesh_12.normals.elementAt(52);
      expect(normal_12_52, vector3MoreOrLessEquals(Vector3(-0.624353, -0.649034, 0.434671)));
      final normal_12_53 = mesh_12.normals.elementAt(53);
      expect(normal_12_53, vector3MoreOrLessEquals(Vector3(-0.434503, -0.886238, 0.160593)));
      final normal_12_54 = mesh_12.normals.elementAt(54);
      expect(normal_12_54, vector3MoreOrLessEquals(Vector3(-0.624353, -0.649034, 0.434671)));
      final normal_12_55 = mesh_12.normals.elementAt(55);
      expect(normal_12_55, vector3MoreOrLessEquals(Vector3(-0.64043, -0.723275, 0.258307)));
      final normal_12_56 = mesh_12.normals.elementAt(56);
      expect(normal_12_56, vector3MoreOrLessEquals(Vector3(-0.434503, -0.886238, 0.160593)));
      final normal_12_57 = mesh_12.normals.elementAt(57);
      expect(normal_12_57, vector3MoreOrLessEquals(Vector3(0.839146, -0.520972, 0.156274)));
      final normal_12_58 = mesh_12.normals.elementAt(58);
      expect(normal_12_58, vector3MoreOrLessEquals(Vector3(0.979386, -0.047392, 0.196359)));
      final normal_12_59 = mesh_12.normals.elementAt(59);
      expect(normal_12_59, vector3MoreOrLessEquals(Vector3(0.461124, -0.566742, 0.682765)));
      final normal_12_60 = mesh_12.normals.elementAt(60);
      expect(normal_12_60, vector3MoreOrLessEquals(Vector3(0.979386, -0.047392, 0.196359)));
      final normal_12_61 = mesh_12.normals.elementAt(61);
      expect(normal_12_61, vector3MoreOrLessEquals(Vector3(0.859197, -0.013066, 0.511478)));
      final normal_12_62 = mesh_12.normals.elementAt(62);
      expect(normal_12_62, vector3MoreOrLessEquals(Vector3(0.461124, -0.566742, 0.682765)));
      final normal_12_63 = mesh_12.normals.elementAt(63);
      expect(normal_12_63, vector3MoreOrLessEquals(Vector3(0.461124, -0.566742, 0.682765)));
      final normal_12_64 = mesh_12.normals.elementAt(64);
      expect(normal_12_64, vector3MoreOrLessEquals(Vector3(0.859197, -0.013066, 0.511478)));
      final normal_12_65 = mesh_12.normals.elementAt(65);
      expect(normal_12_65, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, 0.985318)));
      final normal_12_66 = mesh_12.normals.elementAt(66);
      expect(normal_12_66, vector3MoreOrLessEquals(Vector3(0.461124, -0.566742, 0.682765)));
      final normal_12_67 = mesh_12.normals.elementAt(67);
      expect(normal_12_67, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, 0.985318)));
      final normal_12_68 = mesh_12.normals.elementAt(68);
      expect(normal_12_68, vector3MoreOrLessEquals(Vector3(-0.033279, -0.530249, 0.847189)));
      final normal_12_69 = mesh_12.normals.elementAt(69);
      expect(normal_12_69, vector3MoreOrLessEquals(Vector3(-0.033279, -0.530249, 0.847189)));
      final normal_12_70 = mesh_12.normals.elementAt(70);
      expect(normal_12_70, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, 0.985318)));
      final normal_12_71 = mesh_12.normals.elementAt(71);
      expect(normal_12_71, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, 0.863794)));
      final normal_12_72 = mesh_12.normals.elementAt(72);
      expect(normal_12_72, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, 0.985318)));
      final normal_12_73 = mesh_12.normals.elementAt(73);
      expect(normal_12_73, vector3MoreOrLessEquals(Vector3(-0.298124, 0.093164, 0.94997)));
      final normal_12_74 = mesh_12.normals.elementAt(74);
      expect(normal_12_74, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, 0.863794)));
      final normal_12_75 = mesh_12.normals.elementAt(75);
      expect(normal_12_75, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, 0.863794)));
      final normal_12_76 = mesh_12.normals.elementAt(76);
      expect(normal_12_76, vector3MoreOrLessEquals(Vector3(-0.298124, 0.093164, 0.94997)));
      final normal_12_77 = mesh_12.normals.elementAt(77);
      expect(normal_12_77, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      final normal_12_78 = mesh_12.normals.elementAt(78);
      expect(normal_12_78, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, 0.863794)));
      final normal_12_79 = mesh_12.normals.elementAt(79);
      expect(normal_12_79, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      final normal_12_80 = mesh_12.normals.elementAt(80);
      expect(normal_12_80, vector3MoreOrLessEquals(Vector3(-0.332554, -0.675497, 0.658112)));
      final normal_12_81 = mesh_12.normals.elementAt(81);
      expect(normal_12_81, vector3MoreOrLessEquals(Vector3(-0.332554, -0.675497, 0.658112)));
      final normal_12_82 = mesh_12.normals.elementAt(82);
      expect(normal_12_82, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      final normal_12_83 = mesh_12.normals.elementAt(83);
      expect(normal_12_83, vector3MoreOrLessEquals(Vector3(-0.624353, -0.649034, 0.434671)));
      final normal_12_84 = mesh_12.normals.elementAt(84);
      expect(normal_12_84, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      final normal_12_85 = mesh_12.normals.elementAt(85);
      expect(normal_12_85, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, 0.5423)));
      final normal_12_86 = mesh_12.normals.elementAt(86);
      expect(normal_12_86, vector3MoreOrLessEquals(Vector3(-0.624353, -0.649034, 0.434671)));
      final normal_12_87 = mesh_12.normals.elementAt(87);
      expect(normal_12_87, vector3MoreOrLessEquals(Vector3(-0.624353, -0.649034, 0.434671)));
      final normal_12_88 = mesh_12.normals.elementAt(88);
      expect(normal_12_88, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, 0.5423)));
      final normal_12_89 = mesh_12.normals.elementAt(89);
      expect(normal_12_89, vector3MoreOrLessEquals(Vector3(-0.916442, -0.012784, 0.399964)));
      final normal_12_90 = mesh_12.normals.elementAt(90);
      expect(normal_12_90, vector3MoreOrLessEquals(Vector3(-0.624353, -0.649034, 0.434671)));
      final normal_12_91 = mesh_12.normals.elementAt(91);
      expect(normal_12_91, vector3MoreOrLessEquals(Vector3(-0.916442, -0.012784, 0.399964)));
      final normal_12_92 = mesh_12.normals.elementAt(92);
      expect(normal_12_92, vector3MoreOrLessEquals(Vector3(-0.64043, -0.723275, 0.258307)));
      final normal_12_93 = mesh_12.normals.elementAt(93);
      expect(normal_12_93, vector3MoreOrLessEquals(Vector3(0.979386, -0.047392, 0.196359)));
      final normal_12_94 = mesh_12.normals.elementAt(94);
      expect(normal_12_94, vector3MoreOrLessEquals(Vector3(0.709959, 0.68978, 0.141992)));
      final normal_12_95 = mesh_12.normals.elementAt(95);
      expect(normal_12_95, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, 0.338227)));
      final normal_12_96 = mesh_12.normals.elementAt(96);
      expect(normal_12_96, vector3MoreOrLessEquals(Vector3(0.979386, -0.047392, 0.196359)));
      final normal_12_97 = mesh_12.normals.elementAt(97);
      expect(normal_12_97, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, 0.338227)));
      final normal_12_98 = mesh_12.normals.elementAt(98);
      expect(normal_12_98, vector3MoreOrLessEquals(Vector3(0.859197, -0.013066, 0.511478)));
      final normal_12_99 = mesh_12.normals.elementAt(99);
      expect(normal_12_99, vector3MoreOrLessEquals(Vector3(0.859197, -0.013066, 0.511478)));
      final normal_12_100 = mesh_12.normals.elementAt(100);
      expect(normal_12_100, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, 0.338227)));
      final normal_12_101 = mesh_12.normals.elementAt(101);
      expect(normal_12_101, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, 0.985318)));
      final normal_12_102 = mesh_12.normals.elementAt(102);
      expect(normal_12_102, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, 0.338227)));
      final normal_12_103 = mesh_12.normals.elementAt(103);
      expect(normal_12_103, vector3MoreOrLessEquals(Vector3(0.121528, 0.638102, 0.7603)));
      final normal_12_104 = mesh_12.normals.elementAt(104);
      expect(normal_12_104, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, 0.985318)));
      final normal_12_105 = mesh_12.normals.elementAt(105);
      expect(normal_12_105, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, 0.985318)));
      final normal_12_106 = mesh_12.normals.elementAt(106);
      expect(normal_12_106, vector3MoreOrLessEquals(Vector3(0.121528, 0.638102, 0.7603)));
      final normal_12_107 = mesh_12.normals.elementAt(107);
      expect(normal_12_107, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, 0.824563)));
      final normal_12_108 = mesh_12.normals.elementAt(108);
      expect(normal_12_108, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, 0.985318)));
      final normal_12_109 = mesh_12.normals.elementAt(109);
      expect(normal_12_109, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, 0.824563)));
      final normal_12_110 = mesh_12.normals.elementAt(110);
      expect(normal_12_110, vector3MoreOrLessEquals(Vector3(-0.298124, 0.093164, 0.94997)));
      final normal_12_111 = mesh_12.normals.elementAt(111);
      expect(normal_12_111, vector3MoreOrLessEquals(Vector3(-0.298124, 0.093164, 0.94997)));
      final normal_12_112 = mesh_12.normals.elementAt(112);
      expect(normal_12_112, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, 0.824563)));
      final normal_12_113 = mesh_12.normals.elementAt(113);
      expect(normal_12_113, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      final normal_12_114 = mesh_12.normals.elementAt(114);
      expect(normal_12_114, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, 0.824563)));
      final normal_12_115 = mesh_12.normals.elementAt(115);
      expect(normal_12_115, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497866, 0.640284)));
      final normal_12_116 = mesh_12.normals.elementAt(116);
      expect(normal_12_116, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      final normal_12_117 = mesh_12.normals.elementAt(117);
      expect(normal_12_117, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, 0.5423)));
      final normal_12_118 = mesh_12.normals.elementAt(118);
      expect(normal_12_118, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_119 = mesh_12.normals.elementAt(119);
      expect(normal_12_119, vector3MoreOrLessEquals(Vector3(-0.916442, -0.012784, 0.399964)));
      final normal_12_120 = mesh_12.normals.elementAt(120);
      expect(normal_12_120, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_121 = mesh_12.normals.elementAt(121);
      expect(normal_12_121, vector3MoreOrLessEquals(Vector3(-0.777389, 0.439755, 0.449757)));
      final normal_12_122 = mesh_12.normals.elementAt(122);
      expect(normal_12_122, vector3MoreOrLessEquals(Vector3(-0.916442, -0.012784, 0.399964)));
      final normal_12_123 = mesh_12.normals.elementAt(123);
      expect(normal_12_123, vector3MoreOrLessEquals(Vector3(0.709959, 0.68978, 0.141992)));
      final normal_12_124 = mesh_12.normals.elementAt(124);
      expect(normal_12_124, vector3MoreOrLessEquals(Vector3(0.356408, 0.929723, 0.092678)));
      final normal_12_125 = mesh_12.normals.elementAt(125);
      expect(normal_12_125, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, 0.338227)));
      final normal_12_126 = mesh_12.normals.elementAt(126);
      expect(normal_12_126, vector3MoreOrLessEquals(Vector3(0.356408, 0.929723, 0.092678)));
      final normal_12_127 = mesh_12.normals.elementAt(127);
      expect(normal_12_127, vector3MoreOrLessEquals(Vector3(0.285617, 0.953018, 0.10089)));
      final normal_12_128 = mesh_12.normals.elementAt(128);
      expect(normal_12_128, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, 0.338227)));
      final normal_12_129 = mesh_12.normals.elementAt(129);
      expect(normal_12_129, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, 0.338227)));
      final normal_12_130 = mesh_12.normals.elementAt(130);
      expect(normal_12_130, vector3MoreOrLessEquals(Vector3(0.285617, 0.953018, 0.10089)));
      final normal_12_131 = mesh_12.normals.elementAt(131);
      expect(normal_12_131, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, 0.398579)));
      final normal_12_132 = mesh_12.normals.elementAt(132);
      expect(normal_12_132, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, 0.338227)));
      final normal_12_133 = mesh_12.normals.elementAt(133);
      expect(normal_12_133, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, 0.398579)));
      final normal_12_134 = mesh_12.normals.elementAt(134);
      expect(normal_12_134, vector3MoreOrLessEquals(Vector3(0.121528, 0.638102, 0.7603)));
      final normal_12_135 = mesh_12.normals.elementAt(135);
      expect(normal_12_135, vector3MoreOrLessEquals(Vector3(0.121528, 0.638102, 0.7603)));
      final normal_12_136 = mesh_12.normals.elementAt(136);
      expect(normal_12_136, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, 0.398579)));
      final normal_12_137 = mesh_12.normals.elementAt(137);
      expect(normal_12_137, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, 0.824563)));
      final normal_12_138 = mesh_12.normals.elementAt(138);
      expect(normal_12_138, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, 0.398579)));
      final normal_12_139 = mesh_12.normals.elementAt(139);
      expect(normal_12_139, vector3MoreOrLessEquals(Vector3(-0.144622, 0.858467, 0.492057)));
      final normal_12_140 = mesh_12.normals.elementAt(140);
      expect(normal_12_140, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, 0.824563)));
      final normal_12_141 = mesh_12.normals.elementAt(141);
      expect(normal_12_141, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, 0.824563)));
      final normal_12_142 = mesh_12.normals.elementAt(142);
      expect(normal_12_142, vector3MoreOrLessEquals(Vector3(-0.144622, 0.858467, 0.492057)));
      final normal_12_143 = mesh_12.normals.elementAt(143);
      expect(normal_12_143, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, 0.515371)));
      final normal_12_144 = mesh_12.normals.elementAt(144);
      expect(normal_12_144, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, 0.824563)));
      final normal_12_145 = mesh_12.normals.elementAt(145);
      expect(normal_12_145, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, 0.515371)));
      final normal_12_146 = mesh_12.normals.elementAt(146);
      expect(normal_12_146, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497866, 0.640284)));
      final normal_12_147 = mesh_12.normals.elementAt(147);
      expect(normal_12_147, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497866, 0.640284)));
      final normal_12_148 = mesh_12.normals.elementAt(148);
      expect(normal_12_148, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, 0.515371)));
      final normal_12_149 = mesh_12.normals.elementAt(149);
      expect(normal_12_149, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_150 = mesh_12.normals.elementAt(150);
      expect(normal_12_150, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, 0.515371)));
      final normal_12_151 = mesh_12.normals.elementAt(151);
      expect(normal_12_151, vector3MoreOrLessEquals(Vector3(-0.503913, 0.811284, 0.296463)));
      final normal_12_152 = mesh_12.normals.elementAt(152);
      expect(normal_12_152, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_153 = mesh_12.normals.elementAt(153);
      expect(normal_12_153, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_154 = mesh_12.normals.elementAt(154);
      expect(normal_12_154, vector3MoreOrLessEquals(Vector3(-0.503913, 0.811284, 0.296463)));
      final normal_12_155 = mesh_12.normals.elementAt(155);
      expect(normal_12_155, vector3MoreOrLessEquals(Vector3(-0.589554, 0.76685, 0.253707)));
      final normal_12_156 = mesh_12.normals.elementAt(156);
      expect(normal_12_156, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_157 = mesh_12.normals.elementAt(157);
      expect(normal_12_157, vector3MoreOrLessEquals(Vector3(-0.589554, 0.76685, 0.253707)));
      final normal_12_158 = mesh_12.normals.elementAt(158);
      expect(normal_12_158, vector3MoreOrLessEquals(Vector3(-0.777389, 0.439755, 0.449757)));
      final normal_12_159 = mesh_12.normals.elementAt(159);
      expect(normal_12_159, vector3MoreOrLessEquals(Vector3(-0.712098, 0.074375, 0.69813)));
      final normal_12_160 = mesh_12.normals.elementAt(160);
      expect(normal_12_160, vector3MoreOrLessEquals(Vector3(-0.522162, -0.582125, 0.623279)));
      final normal_12_161 = mesh_12.normals.elementAt(161);
      expect(normal_12_161, vector3MoreOrLessEquals(Vector3(-0.536293, 0.842625, 0.04871)));
      final normal_12_162 = mesh_12.normals.elementAt(162);
      expect(normal_12_162, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, 0.5423)));
      final normal_12_163 = mesh_12.normals.elementAt(163);
      expect(normal_12_163, vector3MoreOrLessEquals(Vector3(-0.627855, 0.740316, 0.240274)));
      final normal_12_164 = mesh_12.normals.elementAt(164);
      expect(normal_12_164, vector3MoreOrLessEquals(Vector3(-0.536293, 0.842625, 0.04871)));
      final normal_12_165 = mesh_12.normals.elementAt(165);
      expect(normal_12_165, vector3MoreOrLessEquals(Vector3(-0.536293, 0.842625, 0.04871)));
      final normal_12_166 = mesh_12.normals.elementAt(166);
      expect(normal_12_166, vector3MoreOrLessEquals(Vector3(-0.712098, 0.074375, 0.69813)));
      final normal_12_167 = mesh_12.normals.elementAt(167);
      expect(normal_12_167, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, 0.5423)));
      final normal_12_168 = mesh_12.normals.elementAt(168);
      expect(normal_12_168, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476796, 0.321792)));
      final normal_12_169 = mesh_12.normals.elementAt(169);
      expect(normal_12_169, vector3MoreOrLessEquals(Vector3(-0.627855, 0.740316, 0.240274)));
      final normal_12_170 = mesh_12.normals.elementAt(170);
      expect(normal_12_170, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, 0.5423)));
      final normal_12_171 = mesh_12.normals.elementAt(171);
      expect(normal_12_171, vector3MoreOrLessEquals(Vector3(-0.627855, 0.740316, 0.240274)));
      final normal_12_172 = mesh_12.normals.elementAt(172);
      expect(normal_12_172, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476796, 0.321792)));
      final normal_12_173 = mesh_12.normals.elementAt(173);
      expect(normal_12_173, vector3MoreOrLessEquals(Vector3(-0.729171, 0.655795, 0.195555)));
      final normal_12_174 = mesh_12.normals.elementAt(174);
      expect(normal_12_174, vector3MoreOrLessEquals(Vector3(-0.729171, 0.655795, 0.195555)));
      final normal_12_175 = mesh_12.normals.elementAt(175);
      expect(normal_12_175, vector3MoreOrLessEquals(Vector3(-0.536293, 0.842625, 0.04871)));
      final normal_12_176 = mesh_12.normals.elementAt(176);
      expect(normal_12_176, vector3MoreOrLessEquals(Vector3(-0.627855, 0.740316, 0.240274)));
      final normal_12_177 = mesh_12.normals.elementAt(177);
      expect(normal_12_177, vector3MoreOrLessEquals(Vector3(-0.958544, 0.215108, 0.186875)));
      final normal_12_178 = mesh_12.normals.elementAt(178);
      expect(normal_12_178, vector3MoreOrLessEquals(Vector3(-0.729171, 0.655795, 0.195555)));
      final normal_12_179 = mesh_12.normals.elementAt(179);
      expect(normal_12_179, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476796, 0.321792)));
      final normal_12_180 = mesh_12.normals.elementAt(180);
      expect(normal_12_180, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476796, 0.321792)));
      final normal_12_181 = mesh_12.normals.elementAt(181);
      expect(normal_12_181, vector3MoreOrLessEquals(Vector3(-0.950592, 0.163928, 0.263634)));
      final normal_12_182 = mesh_12.normals.elementAt(182);
      expect(normal_12_182, vector3MoreOrLessEquals(Vector3(-0.958544, 0.215108, 0.186875)));
      final normal_12_183 = mesh_12.normals.elementAt(183);
      expect(normal_12_183, vector3MoreOrLessEquals(Vector3(-0.983392, -0.02283, 0.180052)));
      final normal_12_184 = mesh_12.normals.elementAt(184);
      expect(normal_12_184, vector3MoreOrLessEquals(Vector3(-0.958544, 0.215108, 0.186875)));
      final normal_12_185 = mesh_12.normals.elementAt(185);
      expect(normal_12_185, vector3MoreOrLessEquals(Vector3(-0.891745, 0.110754, 0.438776)));
      final normal_12_186 = mesh_12.normals.elementAt(186);
      expect(normal_12_186, vector3MoreOrLessEquals(Vector3(-0.950592, 0.163928, 0.263634)));
      final normal_12_187 = mesh_12.normals.elementAt(187);
      expect(normal_12_187, vector3MoreOrLessEquals(Vector3(-0.891745, 0.110754, 0.438776)));
      final normal_12_188 = mesh_12.normals.elementAt(188);
      expect(normal_12_188, vector3MoreOrLessEquals(Vector3(-0.958544, 0.215108, 0.186875)));
      final normal_12_189 = mesh_12.normals.elementAt(189);
      expect(normal_12_189, vector3MoreOrLessEquals(Vector3(-0.991858, -0.08783, 0.092218)));
      final normal_12_190 = mesh_12.normals.elementAt(190);
      expect(normal_12_190, vector3MoreOrLessEquals(Vector3(-0.983392, -0.02283, 0.180052)));
      final normal_12_191 = mesh_12.normals.elementAt(191);
      expect(normal_12_191, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, 0.509835)));
      final normal_12_192 = mesh_12.normals.elementAt(192);
      expect(normal_12_192, vector3MoreOrLessEquals(Vector3(-0.983392, -0.02283, 0.180052)));
      final normal_12_193 = mesh_12.normals.elementAt(193);
      expect(normal_12_193, vector3MoreOrLessEquals(Vector3(-0.891745, 0.110754, 0.438776)));
      final normal_12_194 = mesh_12.normals.elementAt(194);
      expect(normal_12_194, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, 0.509835)));
      final normal_12_195 = mesh_12.normals.elementAt(195);
      expect(normal_12_195, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, 0.509835)));
      final normal_12_196 = mesh_12.normals.elementAt(196);
      expect(normal_12_196, vector3MoreOrLessEquals(Vector3(-0.894952, -0.402899, 0.191658)));
      final normal_12_197 = mesh_12.normals.elementAt(197);
      expect(normal_12_197, vector3MoreOrLessEquals(Vector3(-0.991858, -0.08783, 0.092218)));
      final normal_12_198 = mesh_12.normals.elementAt(198);
      expect(normal_12_198, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, 0.509835)));
      final normal_12_199 = mesh_12.normals.elementAt(199);
      expect(normal_12_199, vector3MoreOrLessEquals(Vector3(-0.903611, 0.009093, 0.428257)));
      final normal_12_200 = mesh_12.normals.elementAt(200);
      expect(normal_12_200, vector3MoreOrLessEquals(Vector3(-0.894952, -0.402899, 0.191658)));
      final normal_12_201 = mesh_12.normals.elementAt(201);
      expect(normal_12_201, vector3MoreOrLessEquals(Vector3(-0.903611, 0.009093, 0.428257)));
      final normal_12_202 = mesh_12.normals.elementAt(202);
      expect(normal_12_202, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017457, 0.456952)));
      final normal_12_203 = mesh_12.normals.elementAt(203);
      expect(normal_12_203, vector3MoreOrLessEquals(Vector3(-0.894952, -0.402899, 0.191658)));
      final normal_12_204 = mesh_12.normals.elementAt(204);
      expect(normal_12_204, vector3MoreOrLessEquals(Vector3(-0.731541, -0.492421, 0.471561)));
      final normal_12_205 = mesh_12.normals.elementAt(205);
      expect(normal_12_205, vector3MoreOrLessEquals(Vector3(-0.894952, -0.402899, 0.191658)));
      final normal_12_206 = mesh_12.normals.elementAt(206);
      expect(normal_12_206, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017457, 0.456952)));
      final normal_12_207 = mesh_12.normals.elementAt(207);
      expect(normal_12_207, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017457, 0.456952)));
      final normal_12_208 = mesh_12.normals.elementAt(208);
      expect(normal_12_208, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, 0.581017)));
      final normal_12_209 = mesh_12.normals.elementAt(209);
      expect(normal_12_209, vector3MoreOrLessEquals(Vector3(-0.731541, -0.492421, 0.471561)));
      final normal_12_210 = mesh_12.normals.elementAt(210);
      expect(normal_12_210, vector3MoreOrLessEquals(Vector3(-0.625933, -0.373553, 0.684592)));
      final normal_12_211 = mesh_12.normals.elementAt(211);
      expect(normal_12_211, vector3MoreOrLessEquals(Vector3(-0.731541, -0.492421, 0.471561)));
      final normal_12_212 = mesh_12.normals.elementAt(212);
      expect(normal_12_212, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, 0.581017)));
      final normal_12_213 = mesh_12.normals.elementAt(213);
      expect(normal_12_213, vector3MoreOrLessEquals(Vector3(-0.584508, -0.184831, 0.790056)));
      final normal_12_214 = mesh_12.normals.elementAt(214);
      expect(normal_12_214, vector3MoreOrLessEquals(Vector3(-0.625933, -0.373553, 0.684592)));
      final normal_12_215 = mesh_12.normals.elementAt(215);
      expect(normal_12_215, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, 0.581017)));
      final normal_12_216 = mesh_12.normals.elementAt(216);
      expect(normal_12_216, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, 0.581017)));
      final normal_12_217 = mesh_12.normals.elementAt(217);
      expect(normal_12_217, vector3MoreOrLessEquals(Vector3(-0.801518, -0.104269, 0.588809)));
      final normal_12_218 = mesh_12.normals.elementAt(218);
      expect(normal_12_218, vector3MoreOrLessEquals(Vector3(-0.584508, -0.184831, 0.790056)));
      final normal_12_219 = mesh_12.normals.elementAt(219);
      expect(normal_12_219, vector3MoreOrLessEquals(Vector3(-0.642031, -0.296727, 0.706929)));
      final normal_12_220 = mesh_12.normals.elementAt(220);
      expect(normal_12_220, vector3MoreOrLessEquals(Vector3(-0.584508, -0.184831, 0.790056)));
      final normal_12_221 = mesh_12.normals.elementAt(221);
      expect(normal_12_221, vector3MoreOrLessEquals(Vector3(-0.801518, -0.104269, 0.588809)));
      final normal_12_222 = mesh_12.normals.elementAt(222);
      expect(normal_12_222, vector3MoreOrLessEquals(Vector3(-0.801518, -0.104269, 0.588809)));
      final normal_12_223 = mesh_12.normals.elementAt(223);
      expect(normal_12_223, vector3MoreOrLessEquals(Vector3(-0.820281, -0.123456, 0.558478)));
      final normal_12_224 = mesh_12.normals.elementAt(224);
      expect(normal_12_224, vector3MoreOrLessEquals(Vector3(-0.642031, -0.296727, 0.706929)));
      final normal_12_225 = mesh_12.normals.elementAt(225);
      expect(normal_12_225, vector3MoreOrLessEquals(Vector3(-0.522162, -0.582125, 0.623279)));
      final normal_12_226 = mesh_12.normals.elementAt(226);
      expect(normal_12_226, vector3MoreOrLessEquals(Vector3(-0.642031, -0.296727, 0.706929)));
      final normal_12_227 = mesh_12.normals.elementAt(227);
      expect(normal_12_227, vector3MoreOrLessEquals(Vector3(-0.820281, -0.123456, 0.558478)));
      final normal_12_228 = mesh_12.normals.elementAt(228);
      expect(normal_12_228, vector3MoreOrLessEquals(Vector3(-0.820281, -0.123456, 0.558478)));
      final normal_12_229 = mesh_12.normals.elementAt(229);
      expect(normal_12_229, vector3MoreOrLessEquals(Vector3(-0.712098, 0.074375, 0.69813)));
      final normal_12_230 = mesh_12.normals.elementAt(230);
      expect(normal_12_230, vector3MoreOrLessEquals(Vector3(-0.522162, -0.582125, 0.623279)));
      final normal_12_231 = mesh_12.normals.elementAt(231);
      expect(normal_12_231, vector3MoreOrLessEquals(Vector3(-0.712098, 0.074375, 0.69813)));
      final normal_12_232 = mesh_12.normals.elementAt(232);
      expect(normal_12_232, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_233 = mesh_12.normals.elementAt(233);
      expect(normal_12_233, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, 0.5423)));
      final normal_12_234 = mesh_12.normals.elementAt(234);
      expect(normal_12_234, vector3MoreOrLessEquals(Vector3(-0.712098, 0.074375, 0.69813)));
      final normal_12_235 = mesh_12.normals.elementAt(235);
      expect(normal_12_235, vector3MoreOrLessEquals(Vector3(-0.820281, -0.123456, 0.558478)));
      final normal_12_236 = mesh_12.normals.elementAt(236);
      expect(normal_12_236, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_237 = mesh_12.normals.elementAt(237);
      expect(normal_12_237, vector3MoreOrLessEquals(Vector3(-0.820281, -0.123456, 0.558478)));
      final normal_12_238 = mesh_12.normals.elementAt(238);
      expect(normal_12_238, vector3MoreOrLessEquals(Vector3(-0.801518, -0.104269, 0.588809)));
      final normal_12_239 = mesh_12.normals.elementAt(239);
      expect(normal_12_239, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_240 = mesh_12.normals.elementAt(240);
      expect(normal_12_240, vector3MoreOrLessEquals(Vector3(-0.801518, -0.104269, 0.588809)));
      final normal_12_241 = mesh_12.normals.elementAt(241);
      expect(normal_12_241, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, 0.581017)));
      final normal_12_242 = mesh_12.normals.elementAt(242);
      expect(normal_12_242, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_243 = mesh_12.normals.elementAt(243);
      expect(normal_12_243, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, 0.581017)));
      final normal_12_244 = mesh_12.normals.elementAt(244);
      expect(normal_12_244, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017457, 0.456952)));
      final normal_12_245 = mesh_12.normals.elementAt(245);
      expect(normal_12_245, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_246 = mesh_12.normals.elementAt(246);
      expect(normal_12_246, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497866, 0.640284)));
      final normal_12_247 = mesh_12.normals.elementAt(247);
      expect(normal_12_247, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, 0.414699)));
      final normal_12_248 = mesh_12.normals.elementAt(248);
      expect(normal_12_248, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017457, 0.456952)));
      final normal_12_249 = mesh_12.normals.elementAt(249);
      expect(normal_12_249, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017457, 0.456952)));
      final normal_12_250 = mesh_12.normals.elementAt(250);
      expect(normal_12_250, vector3MoreOrLessEquals(Vector3(-0.903611, 0.009093, 0.428257)));
      final normal_12_251 = mesh_12.normals.elementAt(251);
      expect(normal_12_251, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497866, 0.640284)));
      final normal_12_252 = mesh_12.normals.elementAt(252);
      expect(normal_12_252, vector3MoreOrLessEquals(Vector3(-0.903611, 0.009093, 0.428257)));
      final normal_12_253 = mesh_12.normals.elementAt(253);
      expect(normal_12_253, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, 0.509835)));
      final normal_12_254 = mesh_12.normals.elementAt(254);
      expect(normal_12_254, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497866, 0.640284)));
      final normal_12_255 = mesh_12.normals.elementAt(255);
      expect(normal_12_255, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476796, 0.321792)));
      final normal_12_256 = mesh_12.normals.elementAt(256);
      expect(normal_12_256, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, 0.5423)));
      final normal_12_257 = mesh_12.normals.elementAt(257);
      expect(normal_12_257, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      final normal_12_258 = mesh_12.normals.elementAt(258);
      expect(normal_12_258, vector3MoreOrLessEquals(Vector3(-0.950592, 0.163928, 0.263634)));
      final normal_12_259 = mesh_12.normals.elementAt(259);
      expect(normal_12_259, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476796, 0.321792)));
      final normal_12_260 = mesh_12.normals.elementAt(260);
      expect(normal_12_260, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      final normal_12_261 = mesh_12.normals.elementAt(261);
      expect(normal_12_261, vector3MoreOrLessEquals(Vector3(-0.891745, 0.110754, 0.438776)));
      final normal_12_262 = mesh_12.normals.elementAt(262);
      expect(normal_12_262, vector3MoreOrLessEquals(Vector3(-0.950592, 0.163928, 0.263634)));
      final normal_12_263 = mesh_12.normals.elementAt(263);
      expect(normal_12_263, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      final normal_12_264 = mesh_12.normals.elementAt(264);
      expect(normal_12_264, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      final normal_12_265 = mesh_12.normals.elementAt(265);
      expect(normal_12_265, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497866, 0.640284)));
      final normal_12_266 = mesh_12.normals.elementAt(266);
      expect(normal_12_266, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, 0.509835)));
      final normal_12_267 = mesh_12.normals.elementAt(267);
      expect(normal_12_267, vector3MoreOrLessEquals(Vector3(-0.891745, 0.110754, 0.438776)));
      final normal_12_268 = mesh_12.normals.elementAt(268);
      expect(normal_12_268, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, 0.509835)));
      final normal_12_269 = mesh_12.normals.elementAt(269);
      expect(normal_12_269, vector3MoreOrLessEquals(Vector3(-0.602581, 0.140795, 0.78554)));
      expect(mesh_12.tangents.length, isZero);
      expect(mesh_12.bitangents.length, isZero);
      expect(mesh_12.colors.length, isZero);
      expect(mesh_12.textureCoords.length, equals(1));
      final textureCoords_12_0 = mesh_12.textureCoords.elementAt(0);
      expect(textureCoords_12_0.length, equals(270));
      final textureCoord_12_0_0 = textureCoords_12_0.elementAt(0);
      expect(textureCoord_12_0_0, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_12_0_1 = textureCoords_12_0.elementAt(1);
      expect(textureCoord_12_0_1, vector3MoreOrLessEquals(Vector3(0.190349, 0.913269, 0)));
      final textureCoord_12_0_2 = textureCoords_12_0.elementAt(2);
      expect(textureCoord_12_0_2, vector3MoreOrLessEquals(Vector3(0, 0.913269, 0)));
      final textureCoord_12_0_3 = textureCoords_12_0.elementAt(3);
      expect(textureCoord_12_0_3, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_12_0_4 = textureCoords_12_0.elementAt(4);
      expect(textureCoord_12_0_4, vector3MoreOrLessEquals(Vector3(0.670306, 0.913269, 0)));
      final textureCoord_12_0_5 = textureCoords_12_0.elementAt(5);
      expect(textureCoord_12_0_5, vector3MoreOrLessEquals(Vector3(0.190349, 0.913269, 0)));
      final textureCoord_12_0_6 = textureCoords_12_0.elementAt(6);
      expect(textureCoord_12_0_6, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_12_0_7 = textureCoords_12_0.elementAt(7);
      expect(textureCoord_12_0_7, vector3MoreOrLessEquals(Vector3(0.379259, 0.066987, 0)));
      final textureCoord_12_0_8 = textureCoords_12_0.elementAt(8);
      expect(textureCoord_12_0_8, vector3MoreOrLessEquals(Vector3(0.437931, 0.066987, 0)));
      final textureCoord_12_0_9 = textureCoords_12_0.elementAt(9);
      expect(textureCoord_12_0_9, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_12_0_10 = textureCoords_12_0.elementAt(10);
      expect(textureCoord_12_0_10, vector3MoreOrLessEquals(Vector3(0.437931, 0.933013, 0)));
      final textureCoord_12_0_11 = textureCoords_12_0.elementAt(11);
      expect(textureCoord_12_0_11, vector3MoreOrLessEquals(Vector3(0.670306, 0.913269, 0)));
      final textureCoord_12_0_12 = textureCoords_12_0.elementAt(12);
      expect(textureCoord_12_0_12, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_12_0_13 = textureCoords_12_0.elementAt(13);
      expect(textureCoord_12_0_13, vector3MoreOrLessEquals(Vector3(0.437931, 0.066987, 0)));
      final textureCoord_12_0_14 = textureCoords_12_0.elementAt(14);
      expect(textureCoord_12_0_14, vector3MoreOrLessEquals(Vector3(0.379259, 0.191987, 0)));
      final textureCoord_12_0_15 = textureCoords_12_0.elementAt(15);
      expect(textureCoord_12_0_15, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_12_0_16 = textureCoords_12_0.elementAt(16);
      expect(textureCoord_12_0_16, vector3MoreOrLessEquals(Vector3(0.379259, 0.933013, 0)));
      final textureCoord_12_0_17 = textureCoords_12_0.elementAt(17);
      expect(textureCoord_12_0_17, vector3MoreOrLessEquals(Vector3(0.437931, 0.933013, 0)));
      final textureCoord_12_0_18 = textureCoords_12_0.elementAt(18);
      expect(textureCoord_12_0_18, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_12_0_19 = textureCoords_12_0.elementAt(19);
      expect(textureCoord_12_0_19, vector3MoreOrLessEquals(Vector3(0.379259, 0.191987, 0)));
      final textureCoord_12_0_20 = textureCoords_12_0.elementAt(20);
      expect(textureCoord_12_0_20, vector3MoreOrLessEquals(Vector3(0.218965, 0.143376, 0)));
      final textureCoord_12_0_21 = textureCoords_12_0.elementAt(21);
      expect(textureCoord_12_0_21, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_12_0_22 = textureCoords_12_0.elementAt(22);
      expect(textureCoord_12_0_22, vector3MoreOrLessEquals(Vector3(0.218965, 0.933013, 0)));
      final textureCoord_12_0_23 = textureCoords_12_0.elementAt(23);
      expect(textureCoord_12_0_23, vector3MoreOrLessEquals(Vector3(0.379259, 0.933013, 0)));
      final textureCoord_12_0_24 = textureCoords_12_0.elementAt(24);
      expect(textureCoord_12_0_24, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final textureCoord_12_0_25 = textureCoords_12_0.elementAt(25);
      expect(textureCoord_12_0_25, vector3MoreOrLessEquals(Vector3(0.218965, 0.143376, 0)));
      final textureCoord_12_0_26 = textureCoords_12_0.elementAt(26);
      expect(textureCoord_12_0_26, vector3MoreOrLessEquals(Vector3(0, 0.143376, 0)));
      final textureCoord_12_0_27 = textureCoords_12_0.elementAt(27);
      expect(textureCoord_12_0_27, vector3MoreOrLessEquals(Vector3(0, 1, 0)));
      final textureCoord_12_0_28 = textureCoords_12_0.elementAt(28);
      expect(textureCoord_12_0_28, vector3MoreOrLessEquals(Vector3(0, 0.933013, 0)));
      final textureCoord_12_0_29 = textureCoords_12_0.elementAt(29);
      expect(textureCoord_12_0_29, vector3MoreOrLessEquals(Vector3(0.218965, 0.933013, 0)));
      final textureCoord_12_0_30 = textureCoords_12_0.elementAt(30);
      expect(textureCoord_12_0_30, vector3MoreOrLessEquals(Vector3(0.719872, 0.25, 0)));
      final textureCoord_12_0_31 = textureCoords_12_0.elementAt(31);
      expect(textureCoord_12_0_31, vector3MoreOrLessEquals(Vector3(0.656896, 0.25, 0)));
      final textureCoord_12_0_32 = textureCoords_12_0.elementAt(32);
      expect(textureCoord_12_0_32, vector3MoreOrLessEquals(Vector3(0.379259, 0.066987, 0)));
      final textureCoord_12_0_33 = textureCoords_12_0.elementAt(33);
      expect(textureCoord_12_0_33, vector3MoreOrLessEquals(Vector3(0.379259, 0.066987, 0)));
      final textureCoord_12_0_34 = textureCoords_12_0.elementAt(34);
      expect(textureCoord_12_0_34, vector3MoreOrLessEquals(Vector3(0.656896, 0.25, 0)));
      final textureCoord_12_0_35 = textureCoords_12_0.elementAt(35);
      expect(textureCoord_12_0_35, vector3MoreOrLessEquals(Vector3(0.858846, 0.347222, 0)));
      final textureCoord_12_0_36 = textureCoords_12_0.elementAt(36);
      expect(textureCoord_12_0_36, vector3MoreOrLessEquals(Vector3(0.379259, 0.066987, 0)));
      final textureCoord_12_0_37 = textureCoords_12_0.elementAt(37);
      expect(textureCoord_12_0_37, vector3MoreOrLessEquals(Vector3(0.858846, 0.347222, 0)));
      final textureCoord_12_0_38 = textureCoords_12_0.elementAt(38);
      expect(textureCoord_12_0_38, vector3MoreOrLessEquals(Vector3(0.437931, 0.066987, 0)));
      final textureCoord_12_0_39 = textureCoords_12_0.elementAt(39);
      expect(textureCoord_12_0_39, vector3MoreOrLessEquals(Vector3(0.437931, 0.066987, 0)));
      final textureCoord_12_0_40 = textureCoords_12_0.elementAt(40);
      expect(textureCoord_12_0_40, vector3MoreOrLessEquals(Vector3(0.858846, 0.347222, 0)));
      final textureCoord_12_0_41 = textureCoords_12_0.elementAt(41);
      expect(textureCoord_12_0_41, vector3MoreOrLessEquals(Vector3(0.379259, 0.191987, 0)));
      final textureCoord_12_0_42 = textureCoords_12_0.elementAt(42);
      expect(textureCoord_12_0_42, vector3MoreOrLessEquals(Vector3(0.858846, 0.347222, 0)));
      final textureCoord_12_0_43 = textureCoords_12_0.elementAt(43);
      expect(textureCoord_12_0_43, vector3MoreOrLessEquals(Vector3(0.656896, 0.25, 0)));
      final textureCoord_12_0_44 = textureCoords_12_0.elementAt(44);
      expect(textureCoord_12_0_44, vector3MoreOrLessEquals(Vector3(0.379259, 0.191987, 0)));
      final textureCoord_12_0_45 = textureCoords_12_0.elementAt(45);
      expect(textureCoord_12_0_45, vector3MoreOrLessEquals(Vector3(0.379259, 0.191987, 0)));
      final textureCoord_12_0_46 = textureCoords_12_0.elementAt(46);
      expect(textureCoord_12_0_46, vector3MoreOrLessEquals(Vector3(0.656896, 0.25, 0)));
      final textureCoord_12_0_47 = textureCoords_12_0.elementAt(47);
      expect(textureCoord_12_0_47, vector3MoreOrLessEquals(Vector3(0.379259, 0.25, 0)));
      final textureCoord_12_0_48 = textureCoords_12_0.elementAt(48);
      expect(textureCoord_12_0_48, vector3MoreOrLessEquals(Vector3(0.379259, 0.191987, 0)));
      final textureCoord_12_0_49 = textureCoords_12_0.elementAt(49);
      expect(textureCoord_12_0_49, vector3MoreOrLessEquals(Vector3(0.379259, 0.25, 0)));
      final textureCoord_12_0_50 = textureCoords_12_0.elementAt(50);
      expect(textureCoord_12_0_50, vector3MoreOrLessEquals(Vector3(0.218965, 0.143376, 0)));
      final textureCoord_12_0_51 = textureCoords_12_0.elementAt(51);
      expect(textureCoord_12_0_51, vector3MoreOrLessEquals(Vector3(0.218965, 0.143376, 0)));
      final textureCoord_12_0_52 = textureCoords_12_0.elementAt(52);
      expect(textureCoord_12_0_52, vector3MoreOrLessEquals(Vector3(0.379259, 0.25, 0)));
      final textureCoord_12_0_53 = textureCoords_12_0.elementAt(53);
      expect(textureCoord_12_0_53, vector3MoreOrLessEquals(Vector3(0, 0.143376, 0)));
      final textureCoord_12_0_54 = textureCoords_12_0.elementAt(54);
      expect(textureCoord_12_0_54, vector3MoreOrLessEquals(Vector3(0.379259, 0.25, 0)));
      final textureCoord_12_0_55 = textureCoords_12_0.elementAt(55);
      expect(textureCoord_12_0_55, vector3MoreOrLessEquals(Vector3(0, 0.216667, 0)));
      final textureCoord_12_0_56 = textureCoords_12_0.elementAt(56);
      expect(textureCoord_12_0_56, vector3MoreOrLessEquals(Vector3(0, 0.143376, 0)));
      final textureCoord_12_0_57 = textureCoords_12_0.elementAt(57);
      expect(textureCoord_12_0_57, vector3MoreOrLessEquals(Vector3(0, 0.25, 0)));
      final textureCoord_12_0_58 = textureCoords_12_0.elementAt(58);
      expect(textureCoord_12_0_58, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_12_0_59 = textureCoords_12_0.elementAt(59);
      expect(textureCoord_12_0_59, vector3MoreOrLessEquals(Vector3(0.719872, 0.25, 0)));
      final textureCoord_12_0_60 = textureCoords_12_0.elementAt(60);
      expect(textureCoord_12_0_60, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_12_0_61 = textureCoords_12_0.elementAt(61);
      expect(textureCoord_12_0_61, vector3MoreOrLessEquals(Vector3(0.72131, 0.680045, 0)));
      final textureCoord_12_0_62 = textureCoords_12_0.elementAt(62);
      expect(textureCoord_12_0_62, vector3MoreOrLessEquals(Vector3(0.719872, 0.25, 0)));
      final textureCoord_12_0_63 = textureCoords_12_0.elementAt(63);
      expect(textureCoord_12_0_63, vector3MoreOrLessEquals(Vector3(0.719872, 0.25, 0)));
      final textureCoord_12_0_64 = textureCoords_12_0.elementAt(64);
      expect(textureCoord_12_0_64, vector3MoreOrLessEquals(Vector3(0.72131, 0.680045, 0)));
      final textureCoord_12_0_65 = textureCoords_12_0.elementAt(65);
      expect(textureCoord_12_0_65, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_12_0_66 = textureCoords_12_0.elementAt(66);
      expect(textureCoord_12_0_66, vector3MoreOrLessEquals(Vector3(0.719872, 0.25, 0)));
      final textureCoord_12_0_67 = textureCoords_12_0.elementAt(67);
      expect(textureCoord_12_0_67, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_12_0_68 = textureCoords_12_0.elementAt(68);
      expect(textureCoord_12_0_68, vector3MoreOrLessEquals(Vector3(0.656896, 0.25, 0)));
      final textureCoord_12_0_69 = textureCoords_12_0.elementAt(69);
      expect(textureCoord_12_0_69, vector3MoreOrLessEquals(Vector3(0.656896, 0.25, 0)));
      final textureCoord_12_0_70 = textureCoords_12_0.elementAt(70);
      expect(textureCoord_12_0_70, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_12_0_71 = textureCoords_12_0.elementAt(71);
      expect(textureCoord_12_0_71, vector3MoreOrLessEquals(Vector3(0.858846, 0.347222, 0)));
      final textureCoord_12_0_72 = textureCoords_12_0.elementAt(72);
      expect(textureCoord_12_0_72, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_12_0_73 = textureCoords_12_0.elementAt(73);
      expect(textureCoord_12_0_73, vector3MoreOrLessEquals(Vector3(0.875861, 0.5, 0)));
      final textureCoord_12_0_74 = textureCoords_12_0.elementAt(74);
      expect(textureCoord_12_0_74, vector3MoreOrLessEquals(Vector3(0.858846, 0.347222, 0)));
      final textureCoord_12_0_75 = textureCoords_12_0.elementAt(75);
      expect(textureCoord_12_0_75, vector3MoreOrLessEquals(Vector3(0.858846, 0.347222, 0)));
      final textureCoord_12_0_76 = textureCoords_12_0.elementAt(76);
      expect(textureCoord_12_0_76, vector3MoreOrLessEquals(Vector3(0.875861, 0.5, 0)));
      final textureCoord_12_0_77 = textureCoords_12_0.elementAt(77);
      expect(textureCoord_12_0_77, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      final textureCoord_12_0_78 = textureCoords_12_0.elementAt(78);
      expect(textureCoord_12_0_78, vector3MoreOrLessEquals(Vector3(0.858846, 0.347222, 0)));
      final textureCoord_12_0_79 = textureCoords_12_0.elementAt(79);
      expect(textureCoord_12_0_79, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      final textureCoord_12_0_80 = textureCoords_12_0.elementAt(80);
      expect(textureCoord_12_0_80, vector3MoreOrLessEquals(Vector3(0.656896, 0.25, 0)));
      final textureCoord_12_0_81 = textureCoords_12_0.elementAt(81);
      expect(textureCoord_12_0_81, vector3MoreOrLessEquals(Vector3(0.656896, 0.25, 0)));
      final textureCoord_12_0_82 = textureCoords_12_0.elementAt(82);
      expect(textureCoord_12_0_82, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      final textureCoord_12_0_83 = textureCoords_12_0.elementAt(83);
      expect(textureCoord_12_0_83, vector3MoreOrLessEquals(Vector3(0.379259, 0.25, 0)));
      final textureCoord_12_0_84 = textureCoords_12_0.elementAt(84);
      expect(textureCoord_12_0_84, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      final textureCoord_12_0_85 = textureCoords_12_0.elementAt(85);
      expect(textureCoord_12_0_85, vector3MoreOrLessEquals(Vector3(0.261105, 0.464286, 0)));
      final textureCoord_12_0_86 = textureCoords_12_0.elementAt(86);
      expect(textureCoord_12_0_86, vector3MoreOrLessEquals(Vector3(0.379259, 0.25, 0)));
      final textureCoord_12_0_87 = textureCoords_12_0.elementAt(87);
      expect(textureCoord_12_0_87, vector3MoreOrLessEquals(Vector3(0.379259, 0.25, 0)));
      final textureCoord_12_0_88 = textureCoords_12_0.elementAt(88);
      expect(textureCoord_12_0_88, vector3MoreOrLessEquals(Vector3(0.261105, 0.464286, 0)));
      final textureCoord_12_0_89 = textureCoords_12_0.elementAt(89);
      expect(textureCoord_12_0_89, vector3MoreOrLessEquals(Vector3(0, 0.416667, 0)));
      final textureCoord_12_0_90 = textureCoords_12_0.elementAt(90);
      expect(textureCoord_12_0_90, vector3MoreOrLessEquals(Vector3(0.379259, 0.25, 0)));
      final textureCoord_12_0_91 = textureCoords_12_0.elementAt(91);
      expect(textureCoord_12_0_91, vector3MoreOrLessEquals(Vector3(0, 0.416667, 0)));
      final textureCoord_12_0_92 = textureCoords_12_0.elementAt(92);
      expect(textureCoord_12_0_92, vector3MoreOrLessEquals(Vector3(0, 0.216667, 0)));
      final textureCoord_12_0_93 = textureCoords_12_0.elementAt(93);
      expect(textureCoord_12_0_93, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_12_0_94 = textureCoords_12_0.elementAt(94);
      expect(textureCoord_12_0_94, vector3MoreOrLessEquals(Vector3(0, 0.814696, 0)));
      final textureCoord_12_0_95 = textureCoords_12_0.elementAt(95);
      expect(textureCoord_12_0_95, vector3MoreOrLessEquals(Vector3(0.670306, 0.814696, 0)));
      final textureCoord_12_0_96 = textureCoords_12_0.elementAt(96);
      expect(textureCoord_12_0_96, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_12_0_97 = textureCoords_12_0.elementAt(97);
      expect(textureCoord_12_0_97, vector3MoreOrLessEquals(Vector3(0.670306, 0.814696, 0)));
      final textureCoord_12_0_98 = textureCoords_12_0.elementAt(98);
      expect(textureCoord_12_0_98, vector3MoreOrLessEquals(Vector3(0.72131, 0.680045, 0)));
      final textureCoord_12_0_99 = textureCoords_12_0.elementAt(99);
      expect(textureCoord_12_0_99, vector3MoreOrLessEquals(Vector3(0.72131, 0.680045, 0)));
      final textureCoord_12_0_100 = textureCoords_12_0.elementAt(100);
      expect(textureCoord_12_0_100, vector3MoreOrLessEquals(Vector3(0.670306, 0.814696, 0)));
      final textureCoord_12_0_101 = textureCoords_12_0.elementAt(101);
      expect(textureCoord_12_0_101, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_12_0_102 = textureCoords_12_0.elementAt(102);
      expect(textureCoord_12_0_102, vector3MoreOrLessEquals(Vector3(0.670306, 0.814696, 0)));
      final textureCoord_12_0_103 = textureCoords_12_0.elementAt(103);
      expect(textureCoord_12_0_103, vector3MoreOrLessEquals(Vector3(0.911659, 0.814696, 0)));
      final textureCoord_12_0_104 = textureCoords_12_0.elementAt(104);
      expect(textureCoord_12_0_104, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_12_0_105 = textureCoords_12_0.elementAt(105);
      expect(textureCoord_12_0_105, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_12_0_106 = textureCoords_12_0.elementAt(106);
      expect(textureCoord_12_0_106, vector3MoreOrLessEquals(Vector3(0.911659, 0.814696, 0)));
      final textureCoord_12_0_107 = textureCoords_12_0.elementAt(107);
      expect(textureCoord_12_0_107, vector3MoreOrLessEquals(Vector3(0.758518, 0.75, 0)));
      final textureCoord_12_0_108 = textureCoords_12_0.elementAt(108);
      expect(textureCoord_12_0_108, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_12_0_109 = textureCoords_12_0.elementAt(109);
      expect(textureCoord_12_0_109, vector3MoreOrLessEquals(Vector3(0.758518, 0.75, 0)));
      final textureCoord_12_0_110 = textureCoords_12_0.elementAt(110);
      expect(textureCoord_12_0_110, vector3MoreOrLessEquals(Vector3(0.875861, 0.5, 0)));
      final textureCoord_12_0_111 = textureCoords_12_0.elementAt(111);
      expect(textureCoord_12_0_111, vector3MoreOrLessEquals(Vector3(0.875861, 0.5, 0)));
      final textureCoord_12_0_112 = textureCoords_12_0.elementAt(112);
      expect(textureCoord_12_0_112, vector3MoreOrLessEquals(Vector3(0.758518, 0.75, 0)));
      final textureCoord_12_0_113 = textureCoords_12_0.elementAt(113);
      expect(textureCoord_12_0_113, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      final textureCoord_12_0_114 = textureCoords_12_0.elementAt(114);
      expect(textureCoord_12_0_114, vector3MoreOrLessEquals(Vector3(0.758518, 0.75, 0)));
      final textureCoord_12_0_115 = textureCoords_12_0.elementAt(115);
      expect(textureCoord_12_0_115, vector3MoreOrLessEquals(Vector3(0.565318, 0.714286, 0)));
      final textureCoord_12_0_116 = textureCoords_12_0.elementAt(116);
      expect(textureCoord_12_0_116, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      final textureCoord_12_0_117 = textureCoords_12_0.elementAt(117);
      expect(textureCoord_12_0_117, vector3MoreOrLessEquals(Vector3(0.261105, 0.464286, 0)));
      final textureCoord_12_0_118 = textureCoords_12_0.elementAt(118);
      expect(textureCoord_12_0_118, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_119 = textureCoords_12_0.elementAt(119);
      expect(textureCoord_12_0_119, vector3MoreOrLessEquals(Vector3(0, 0.416667, 0)));
      final textureCoord_12_0_120 = textureCoords_12_0.elementAt(120);
      expect(textureCoord_12_0_120, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_121 = textureCoords_12_0.elementAt(121);
      expect(textureCoord_12_0_121, vector3MoreOrLessEquals(Vector3(0, 0.75, 0)));
      final textureCoord_12_0_122 = textureCoords_12_0.elementAt(122);
      expect(textureCoord_12_0_122, vector3MoreOrLessEquals(Vector3(0, 0.416667, 0)));
      final textureCoord_12_0_123 = textureCoords_12_0.elementAt(123);
      expect(textureCoord_12_0_123, vector3MoreOrLessEquals(Vector3(0, 0.814696, 0)));
      final textureCoord_12_0_124 = textureCoords_12_0.elementAt(124);
      expect(textureCoord_12_0_124, vector3MoreOrLessEquals(Vector3(0, 0.913269, 0)));
      final textureCoord_12_0_125 = textureCoords_12_0.elementAt(125);
      expect(textureCoord_12_0_125, vector3MoreOrLessEquals(Vector3(0.670306, 0.814696, 0)));
      final textureCoord_12_0_126 = textureCoords_12_0.elementAt(126);
      expect(textureCoord_12_0_126, vector3MoreOrLessEquals(Vector3(0, 0.913269, 0)));
      final textureCoord_12_0_127 = textureCoords_12_0.elementAt(127);
      expect(textureCoord_12_0_127, vector3MoreOrLessEquals(Vector3(0.190349, 0.913269, 0)));
      final textureCoord_12_0_128 = textureCoords_12_0.elementAt(128);
      expect(textureCoord_12_0_128, vector3MoreOrLessEquals(Vector3(0.670306, 0.814696, 0)));
      final textureCoord_12_0_129 = textureCoords_12_0.elementAt(129);
      expect(textureCoord_12_0_129, vector3MoreOrLessEquals(Vector3(0.670306, 0.814696, 0)));
      final textureCoord_12_0_130 = textureCoords_12_0.elementAt(130);
      expect(textureCoord_12_0_130, vector3MoreOrLessEquals(Vector3(0.190349, 0.913269, 0)));
      final textureCoord_12_0_131 = textureCoords_12_0.elementAt(131);
      expect(textureCoord_12_0_131, vector3MoreOrLessEquals(Vector3(0.670306, 0.913269, 0)));
      final textureCoord_12_0_132 = textureCoords_12_0.elementAt(132);
      expect(textureCoord_12_0_132, vector3MoreOrLessEquals(Vector3(0.670306, 0.814696, 0)));
      final textureCoord_12_0_133 = textureCoords_12_0.elementAt(133);
      expect(textureCoord_12_0_133, vector3MoreOrLessEquals(Vector3(0.670306, 0.913269, 0)));
      final textureCoord_12_0_134 = textureCoords_12_0.elementAt(134);
      expect(textureCoord_12_0_134, vector3MoreOrLessEquals(Vector3(0.911659, 0.814696, 0)));
      final textureCoord_12_0_135 = textureCoords_12_0.elementAt(135);
      expect(textureCoord_12_0_135, vector3MoreOrLessEquals(Vector3(0.911659, 0.814696, 0)));
      final textureCoord_12_0_136 = textureCoords_12_0.elementAt(136);
      expect(textureCoord_12_0_136, vector3MoreOrLessEquals(Vector3(0.670306, 0.913269, 0)));
      final textureCoord_12_0_137 = textureCoords_12_0.elementAt(137);
      expect(textureCoord_12_0_137, vector3MoreOrLessEquals(Vector3(0.758518, 0.75, 0)));
      final textureCoord_12_0_138 = textureCoords_12_0.elementAt(138);
      expect(textureCoord_12_0_138, vector3MoreOrLessEquals(Vector3(0.670306, 0.913269, 0)));
      final textureCoord_12_0_139 = textureCoords_12_0.elementAt(139);
      expect(textureCoord_12_0_139, vector3MoreOrLessEquals(Vector3(0.437931, 0.933013, 0)));
      final textureCoord_12_0_140 = textureCoords_12_0.elementAt(140);
      expect(textureCoord_12_0_140, vector3MoreOrLessEquals(Vector3(0.758518, 0.75, 0)));
      final textureCoord_12_0_141 = textureCoords_12_0.elementAt(141);
      expect(textureCoord_12_0_141, vector3MoreOrLessEquals(Vector3(0.758518, 0.75, 0)));
      final textureCoord_12_0_142 = textureCoords_12_0.elementAt(142);
      expect(textureCoord_12_0_142, vector3MoreOrLessEquals(Vector3(0.437931, 0.933013, 0)));
      final textureCoord_12_0_143 = textureCoords_12_0.elementAt(143);
      expect(textureCoord_12_0_143, vector3MoreOrLessEquals(Vector3(0.379259, 0.933013, 0)));
      final textureCoord_12_0_144 = textureCoords_12_0.elementAt(144);
      expect(textureCoord_12_0_144, vector3MoreOrLessEquals(Vector3(0.758518, 0.75, 0)));
      final textureCoord_12_0_145 = textureCoords_12_0.elementAt(145);
      expect(textureCoord_12_0_145, vector3MoreOrLessEquals(Vector3(0.379259, 0.933013, 0)));
      final textureCoord_12_0_146 = textureCoords_12_0.elementAt(146);
      expect(textureCoord_12_0_146, vector3MoreOrLessEquals(Vector3(0.565318, 0.714286, 0)));
      final textureCoord_12_0_147 = textureCoords_12_0.elementAt(147);
      expect(textureCoord_12_0_147, vector3MoreOrLessEquals(Vector3(0.565318, 0.714286, 0)));
      final textureCoord_12_0_148 = textureCoords_12_0.elementAt(148);
      expect(textureCoord_12_0_148, vector3MoreOrLessEquals(Vector3(0.379259, 0.933013, 0)));
      final textureCoord_12_0_149 = textureCoords_12_0.elementAt(149);
      expect(textureCoord_12_0_149, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_150 = textureCoords_12_0.elementAt(150);
      expect(textureCoord_12_0_150, vector3MoreOrLessEquals(Vector3(0.379259, 0.933013, 0)));
      final textureCoord_12_0_151 = textureCoords_12_0.elementAt(151);
      expect(textureCoord_12_0_151, vector3MoreOrLessEquals(Vector3(0.218965, 0.933013, 0)));
      final textureCoord_12_0_152 = textureCoords_12_0.elementAt(152);
      expect(textureCoord_12_0_152, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_153 = textureCoords_12_0.elementAt(153);
      expect(textureCoord_12_0_153, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_154 = textureCoords_12_0.elementAt(154);
      expect(textureCoord_12_0_154, vector3MoreOrLessEquals(Vector3(0.218965, 0.933013, 0)));
      final textureCoord_12_0_155 = textureCoords_12_0.elementAt(155);
      expect(textureCoord_12_0_155, vector3MoreOrLessEquals(Vector3(0, 0.933013, 0)));
      final textureCoord_12_0_156 = textureCoords_12_0.elementAt(156);
      expect(textureCoord_12_0_156, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_157 = textureCoords_12_0.elementAt(157);
      expect(textureCoord_12_0_157, vector3MoreOrLessEquals(Vector3(0, 0.933013, 0)));
      final textureCoord_12_0_158 = textureCoords_12_0.elementAt(158);
      expect(textureCoord_12_0_158, vector3MoreOrLessEquals(Vector3(0, 0.75, 0)));
      final textureCoord_12_0_159 = textureCoords_12_0.elementAt(159);
      expect(textureCoord_12_0_159, vector3MoreOrLessEquals(Vector3(0.277735, 0.533731, 0)));
      final textureCoord_12_0_160 = textureCoords_12_0.elementAt(160);
      expect(textureCoord_12_0_160, vector3MoreOrLessEquals(Vector3(0.316741, 0.544409, 0)));
      final textureCoord_12_0_161 = textureCoords_12_0.elementAt(161);
      expect(textureCoord_12_0_161, vector3MoreOrLessEquals(Vector3(0.325355, 0.530353, 0)));
      final textureCoord_12_0_162 = textureCoords_12_0.elementAt(162);
      expect(textureCoord_12_0_162, vector3MoreOrLessEquals(Vector3(0.261105, 0.464286, 0)));
      final textureCoord_12_0_163 = textureCoords_12_0.elementAt(163);
      expect(textureCoord_12_0_163, vector3MoreOrLessEquals(Vector3(0.332403, 0.512897, 0)));
      final textureCoord_12_0_164 = textureCoords_12_0.elementAt(164);
      expect(textureCoord_12_0_164, vector3MoreOrLessEquals(Vector3(0.325355, 0.530353, 0)));
      final textureCoord_12_0_165 = textureCoords_12_0.elementAt(165);
      expect(textureCoord_12_0_165, vector3MoreOrLessEquals(Vector3(0.325355, 0.530353, 0)));
      final textureCoord_12_0_166 = textureCoords_12_0.elementAt(166);
      expect(textureCoord_12_0_166, vector3MoreOrLessEquals(Vector3(0.277735, 0.533731, 0)));
      final textureCoord_12_0_167 = textureCoords_12_0.elementAt(167);
      expect(textureCoord_12_0_167, vector3MoreOrLessEquals(Vector3(0.261105, 0.464286, 0)));
      final textureCoord_12_0_168 = textureCoords_12_0.elementAt(168);
      expect(textureCoord_12_0_168, vector3MoreOrLessEquals(Vector3(0.419872, 0.505953, 0)));
      final textureCoord_12_0_169 = textureCoords_12_0.elementAt(169);
      expect(textureCoord_12_0_169, vector3MoreOrLessEquals(Vector3(0.332403, 0.512897, 0)));
      final textureCoord_12_0_170 = textureCoords_12_0.elementAt(170);
      expect(textureCoord_12_0_170, vector3MoreOrLessEquals(Vector3(0.261105, 0.464286, 0)));
      final textureCoord_12_0_171 = textureCoords_12_0.elementAt(171);
      expect(textureCoord_12_0_171, vector3MoreOrLessEquals(Vector3(0.332403, 0.512897, 0)));
      final textureCoord_12_0_172 = textureCoords_12_0.elementAt(172);
      expect(textureCoord_12_0_172, vector3MoreOrLessEquals(Vector3(0.419872, 0.505953, 0)));
      final textureCoord_12_0_173 = textureCoords_12_0.elementAt(173);
      expect(textureCoord_12_0_173, vector3MoreOrLessEquals(Vector3(0.390216, 0.53073, 0)));
      final textureCoord_12_0_174 = textureCoords_12_0.elementAt(174);
      expect(textureCoord_12_0_174, vector3MoreOrLessEquals(Vector3(0.390216, 0.53073, 0)));
      final textureCoord_12_0_175 = textureCoords_12_0.elementAt(175);
      expect(textureCoord_12_0_175, vector3MoreOrLessEquals(Vector3(0.325355, 0.530353, 0)));
      final textureCoord_12_0_176 = textureCoords_12_0.elementAt(176);
      expect(textureCoord_12_0_176, vector3MoreOrLessEquals(Vector3(0.332403, 0.512897, 0)));
      final textureCoord_12_0_177 = textureCoords_12_0.elementAt(177);
      expect(textureCoord_12_0_177, vector3MoreOrLessEquals(Vector3(0.47658, 0.558494, 0)));
      final textureCoord_12_0_178 = textureCoords_12_0.elementAt(178);
      expect(textureCoord_12_0_178, vector3MoreOrLessEquals(Vector3(0.390216, 0.53073, 0)));
      final textureCoord_12_0_179 = textureCoords_12_0.elementAt(179);
      expect(textureCoord_12_0_179, vector3MoreOrLessEquals(Vector3(0.419872, 0.505953, 0)));
      final textureCoord_12_0_180 = textureCoords_12_0.elementAt(180);
      expect(textureCoord_12_0_180, vector3MoreOrLessEquals(Vector3(0.419872, 0.505953, 0)));
      final textureCoord_12_0_181 = textureCoords_12_0.elementAt(181);
      expect(textureCoord_12_0_181, vector3MoreOrLessEquals(Vector3(0.529208, 0.540675, 0)));
      final textureCoord_12_0_182 = textureCoords_12_0.elementAt(182);
      expect(textureCoord_12_0_182, vector3MoreOrLessEquals(Vector3(0.47658, 0.558494, 0)));
      final textureCoord_12_0_183 = textureCoords_12_0.elementAt(183);
      expect(textureCoord_12_0_183, vector3MoreOrLessEquals(Vector3(0.523592, 0.600489, 0)));
      final textureCoord_12_0_184 = textureCoords_12_0.elementAt(184);
      expect(textureCoord_12_0_184, vector3MoreOrLessEquals(Vector3(0.47658, 0.558494, 0)));
      final textureCoord_12_0_185 = textureCoords_12_0.elementAt(185);
      expect(textureCoord_12_0_185, vector3MoreOrLessEquals(Vector3(0.562009, 0.596231, 0)));
      final textureCoord_12_0_186 = textureCoords_12_0.elementAt(186);
      expect(textureCoord_12_0_186, vector3MoreOrLessEquals(Vector3(0.529208, 0.540675, 0)));
      final textureCoord_12_0_187 = textureCoords_12_0.elementAt(187);
      expect(textureCoord_12_0_187, vector3MoreOrLessEquals(Vector3(0.562009, 0.596231, 0)));
      final textureCoord_12_0_188 = textureCoords_12_0.elementAt(188);
      expect(textureCoord_12_0_188, vector3MoreOrLessEquals(Vector3(0.47658, 0.558494, 0)));
      final textureCoord_12_0_189 = textureCoords_12_0.elementAt(189);
      expect(textureCoord_12_0_189, vector3MoreOrLessEquals(Vector3(0.516196, 0.637547, 0)));
      final textureCoord_12_0_190 = textureCoords_12_0.elementAt(190);
      expect(textureCoord_12_0_190, vector3MoreOrLessEquals(Vector3(0.523592, 0.600489, 0)));
      final textureCoord_12_0_191 = textureCoords_12_0.elementAt(191);
      expect(textureCoord_12_0_191, vector3MoreOrLessEquals(Vector3(0.540141, 0.644841, 0)));
      final textureCoord_12_0_192 = textureCoords_12_0.elementAt(192);
      expect(textureCoord_12_0_192, vector3MoreOrLessEquals(Vector3(0.523592, 0.600489, 0)));
      final textureCoord_12_0_193 = textureCoords_12_0.elementAt(193);
      expect(textureCoord_12_0_193, vector3MoreOrLessEquals(Vector3(0.562009, 0.596231, 0)));
      final textureCoord_12_0_194 = textureCoords_12_0.elementAt(194);
      expect(textureCoord_12_0_194, vector3MoreOrLessEquals(Vector3(0.540141, 0.644841, 0)));
      final textureCoord_12_0_195 = textureCoords_12_0.elementAt(195);
      expect(textureCoord_12_0_195, vector3MoreOrLessEquals(Vector3(0.540141, 0.644841, 0)));
      final textureCoord_12_0_196 = textureCoords_12_0.elementAt(196);
      expect(textureCoord_12_0_196, vector3MoreOrLessEquals(Vector3(0.479912, 0.659265, 0)));
      final textureCoord_12_0_197 = textureCoords_12_0.elementAt(197);
      expect(textureCoord_12_0_197, vector3MoreOrLessEquals(Vector3(0.516196, 0.637547, 0)));
      final textureCoord_12_0_198 = textureCoords_12_0.elementAt(198);
      expect(textureCoord_12_0_198, vector3MoreOrLessEquals(Vector3(0.540141, 0.644841, 0)));
      final textureCoord_12_0_199 = textureCoords_12_0.elementAt(199);
      expect(textureCoord_12_0_199, vector3MoreOrLessEquals(Vector3(0.496407, 0.672619, 0)));
      final textureCoord_12_0_200 = textureCoords_12_0.elementAt(200);
      expect(textureCoord_12_0_200, vector3MoreOrLessEquals(Vector3(0.479912, 0.659265, 0)));
      final textureCoord_12_0_201 = textureCoords_12_0.elementAt(201);
      expect(textureCoord_12_0_201, vector3MoreOrLessEquals(Vector3(0.496407, 0.672619, 0)));
      final textureCoord_12_0_202 = textureCoords_12_0.elementAt(202);
      expect(textureCoord_12_0_202, vector3MoreOrLessEquals(Vector3(0.430805, 0.679564, 0)));
      final textureCoord_12_0_203 = textureCoords_12_0.elementAt(203);
      expect(textureCoord_12_0_203, vector3MoreOrLessEquals(Vector3(0.479912, 0.659265, 0)));
      final textureCoord_12_0_204 = textureCoords_12_0.elementAt(204);
      expect(textureCoord_12_0_204, vector3MoreOrLessEquals(Vector3(0.436879, 0.654511, 0)));
      final textureCoord_12_0_205 = textureCoords_12_0.elementAt(205);
      expect(textureCoord_12_0_205, vector3MoreOrLessEquals(Vector3(0.479912, 0.659265, 0)));
      final textureCoord_12_0_206 = textureCoords_12_0.elementAt(206);
      expect(textureCoord_12_0_206, vector3MoreOrLessEquals(Vector3(0.430805, 0.679564, 0)));
      final textureCoord_12_0_207 = textureCoords_12_0.elementAt(207);
      expect(textureCoord_12_0_207, vector3MoreOrLessEquals(Vector3(0.430805, 0.679564, 0)));
      final textureCoord_12_0_208 = textureCoords_12_0.elementAt(208);
      expect(textureCoord_12_0_208, vector3MoreOrLessEquals(Vector3(0.365204, 0.658731, 0)));
      final textureCoord_12_0_209 = textureCoords_12_0.elementAt(209);
      expect(textureCoord_12_0_209, vector3MoreOrLessEquals(Vector3(0.436879, 0.654511, 0)));
      final textureCoord_12_0_210 = textureCoords_12_0.elementAt(210);
      expect(textureCoord_12_0_210, vector3MoreOrLessEquals(Vector3(0.392006, 0.640264, 0)));
      final textureCoord_12_0_211 = textureCoords_12_0.elementAt(211);
      expect(textureCoord_12_0_211, vector3MoreOrLessEquals(Vector3(0.436879, 0.654511, 0)));
      final textureCoord_12_0_212 = textureCoords_12_0.elementAt(212);
      expect(textureCoord_12_0_212, vector3MoreOrLessEquals(Vector3(0.365204, 0.658731, 0)));
      final textureCoord_12_0_213 = textureCoords_12_0.elementAt(213);
      expect(textureCoord_12_0_213, vector3MoreOrLessEquals(Vector3(0.379724, 0.610322, 0)));
      final textureCoord_12_0_214 = textureCoords_12_0.elementAt(214);
      expect(textureCoord_12_0_214, vector3MoreOrLessEquals(Vector3(0.392006, 0.640264, 0)));
      final textureCoord_12_0_215 = textureCoords_12_0.elementAt(215);
      expect(textureCoord_12_0_215, vector3MoreOrLessEquals(Vector3(0.365204, 0.658731, 0)));
      final textureCoord_12_0_216 = textureCoords_12_0.elementAt(216);
      expect(textureCoord_12_0_216, vector3MoreOrLessEquals(Vector3(0.365204, 0.658731, 0)));
      final textureCoord_12_0_217 = textureCoords_12_0.elementAt(217);
      expect(textureCoord_12_0_217, vector3MoreOrLessEquals(Vector3(0.332403, 0.610119, 0)));
      final textureCoord_12_0_218 = textureCoords_12_0.elementAt(218);
      expect(textureCoord_12_0_218, vector3MoreOrLessEquals(Vector3(0.379724, 0.610322, 0)));
      final textureCoord_12_0_219 = textureCoords_12_0.elementAt(219);
      expect(textureCoord_12_0_219, vector3MoreOrLessEquals(Vector3(0.358531, 0.576181, 0)));
      final textureCoord_12_0_220 = textureCoords_12_0.elementAt(220);
      expect(textureCoord_12_0_220, vector3MoreOrLessEquals(Vector3(0.379724, 0.610322, 0)));
      final textureCoord_12_0_221 = textureCoords_12_0.elementAt(221);
      expect(textureCoord_12_0_221, vector3MoreOrLessEquals(Vector3(0.332403, 0.610119, 0)));
      final textureCoord_12_0_222 = textureCoords_12_0.elementAt(222);
      expect(textureCoord_12_0_222, vector3MoreOrLessEquals(Vector3(0.332403, 0.610119, 0)));
      final textureCoord_12_0_223 = textureCoords_12_0.elementAt(223);
      expect(textureCoord_12_0_223, vector3MoreOrLessEquals(Vector3(0.288668, 0.582341, 0)));
      final textureCoord_12_0_224 = textureCoords_12_0.elementAt(224);
      expect(textureCoord_12_0_224, vector3MoreOrLessEquals(Vector3(0.358531, 0.576181, 0)));
      final textureCoord_12_0_225 = textureCoords_12_0.elementAt(225);
      expect(textureCoord_12_0_225, vector3MoreOrLessEquals(Vector3(0.316741, 0.544409, 0)));
      final textureCoord_12_0_226 = textureCoords_12_0.elementAt(226);
      expect(textureCoord_12_0_226, vector3MoreOrLessEquals(Vector3(0.358531, 0.576181, 0)));
      final textureCoord_12_0_227 = textureCoords_12_0.elementAt(227);
      expect(textureCoord_12_0_227, vector3MoreOrLessEquals(Vector3(0.288668, 0.582341, 0)));
      final textureCoord_12_0_228 = textureCoords_12_0.elementAt(228);
      expect(textureCoord_12_0_228, vector3MoreOrLessEquals(Vector3(0.288668, 0.582341, 0)));
      final textureCoord_12_0_229 = textureCoords_12_0.elementAt(229);
      expect(textureCoord_12_0_229, vector3MoreOrLessEquals(Vector3(0.277735, 0.533731, 0)));
      final textureCoord_12_0_230 = textureCoords_12_0.elementAt(230);
      expect(textureCoord_12_0_230, vector3MoreOrLessEquals(Vector3(0.316741, 0.544409, 0)));
      final textureCoord_12_0_231 = textureCoords_12_0.elementAt(231);
      expect(textureCoord_12_0_231, vector3MoreOrLessEquals(Vector3(0.277735, 0.533731, 0)));
      final textureCoord_12_0_232 = textureCoords_12_0.elementAt(232);
      expect(textureCoord_12_0_232, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_233 = textureCoords_12_0.elementAt(233);
      expect(textureCoord_12_0_233, vector3MoreOrLessEquals(Vector3(0.261105, 0.464286, 0)));
      final textureCoord_12_0_234 = textureCoords_12_0.elementAt(234);
      expect(textureCoord_12_0_234, vector3MoreOrLessEquals(Vector3(0.277735, 0.533731, 0)));
      final textureCoord_12_0_235 = textureCoords_12_0.elementAt(235);
      expect(textureCoord_12_0_235, vector3MoreOrLessEquals(Vector3(0.288668, 0.582341, 0)));
      final textureCoord_12_0_236 = textureCoords_12_0.elementAt(236);
      expect(textureCoord_12_0_236, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_237 = textureCoords_12_0.elementAt(237);
      expect(textureCoord_12_0_237, vector3MoreOrLessEquals(Vector3(0.288668, 0.582341, 0)));
      final textureCoord_12_0_238 = textureCoords_12_0.elementAt(238);
      expect(textureCoord_12_0_238, vector3MoreOrLessEquals(Vector3(0.332403, 0.610119, 0)));
      final textureCoord_12_0_239 = textureCoords_12_0.elementAt(239);
      expect(textureCoord_12_0_239, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_240 = textureCoords_12_0.elementAt(240);
      expect(textureCoord_12_0_240, vector3MoreOrLessEquals(Vector3(0.332403, 0.610119, 0)));
      final textureCoord_12_0_241 = textureCoords_12_0.elementAt(241);
      expect(textureCoord_12_0_241, vector3MoreOrLessEquals(Vector3(0.365204, 0.658731, 0)));
      final textureCoord_12_0_242 = textureCoords_12_0.elementAt(242);
      expect(textureCoord_12_0_242, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_243 = textureCoords_12_0.elementAt(243);
      expect(textureCoord_12_0_243, vector3MoreOrLessEquals(Vector3(0.365204, 0.658731, 0)));
      final textureCoord_12_0_244 = textureCoords_12_0.elementAt(244);
      expect(textureCoord_12_0_244, vector3MoreOrLessEquals(Vector3(0.430805, 0.679564, 0)));
      final textureCoord_12_0_245 = textureCoords_12_0.elementAt(245);
      expect(textureCoord_12_0_245, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_246 = textureCoords_12_0.elementAt(246);
      expect(textureCoord_12_0_246, vector3MoreOrLessEquals(Vector3(0.565318, 0.714286, 0)));
      final textureCoord_12_0_247 = textureCoords_12_0.elementAt(247);
      expect(textureCoord_12_0_247, vector3MoreOrLessEquals(Vector3(0.228761, 0.714286, 0)));
      final textureCoord_12_0_248 = textureCoords_12_0.elementAt(248);
      expect(textureCoord_12_0_248, vector3MoreOrLessEquals(Vector3(0.430805, 0.679564, 0)));
      final textureCoord_12_0_249 = textureCoords_12_0.elementAt(249);
      expect(textureCoord_12_0_249, vector3MoreOrLessEquals(Vector3(0.430805, 0.679564, 0)));
      final textureCoord_12_0_250 = textureCoords_12_0.elementAt(250);
      expect(textureCoord_12_0_250, vector3MoreOrLessEquals(Vector3(0.496407, 0.672619, 0)));
      final textureCoord_12_0_251 = textureCoords_12_0.elementAt(251);
      expect(textureCoord_12_0_251, vector3MoreOrLessEquals(Vector3(0.565318, 0.714286, 0)));
      final textureCoord_12_0_252 = textureCoords_12_0.elementAt(252);
      expect(textureCoord_12_0_252, vector3MoreOrLessEquals(Vector3(0.496407, 0.672619, 0)));
      final textureCoord_12_0_253 = textureCoords_12_0.elementAt(253);
      expect(textureCoord_12_0_253, vector3MoreOrLessEquals(Vector3(0.540141, 0.644841, 0)));
      final textureCoord_12_0_254 = textureCoords_12_0.elementAt(254);
      expect(textureCoord_12_0_254, vector3MoreOrLessEquals(Vector3(0.565318, 0.714286, 0)));
      final textureCoord_12_0_255 = textureCoords_12_0.elementAt(255);
      expect(textureCoord_12_0_255, vector3MoreOrLessEquals(Vector3(0.419872, 0.505953, 0)));
      final textureCoord_12_0_256 = textureCoords_12_0.elementAt(256);
      expect(textureCoord_12_0_256, vector3MoreOrLessEquals(Vector3(0.261105, 0.464286, 0)));
      final textureCoord_12_0_257 = textureCoords_12_0.elementAt(257);
      expect(textureCoord_12_0_257, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      final textureCoord_12_0_258 = textureCoords_12_0.elementAt(258);
      expect(textureCoord_12_0_258, vector3MoreOrLessEquals(Vector3(0.529208, 0.540675, 0)));
      final textureCoord_12_0_259 = textureCoords_12_0.elementAt(259);
      expect(textureCoord_12_0_259, vector3MoreOrLessEquals(Vector3(0.419872, 0.505953, 0)));
      final textureCoord_12_0_260 = textureCoords_12_0.elementAt(260);
      expect(textureCoord_12_0_260, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      final textureCoord_12_0_261 = textureCoords_12_0.elementAt(261);
      expect(textureCoord_12_0_261, vector3MoreOrLessEquals(Vector3(0.562009, 0.596231, 0)));
      final textureCoord_12_0_262 = textureCoords_12_0.elementAt(262);
      expect(textureCoord_12_0_262, vector3MoreOrLessEquals(Vector3(0.529208, 0.540675, 0)));
      final textureCoord_12_0_263 = textureCoords_12_0.elementAt(263);
      expect(textureCoord_12_0_263, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      final textureCoord_12_0_264 = textureCoords_12_0.elementAt(264);
      expect(textureCoord_12_0_264, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      final textureCoord_12_0_265 = textureCoords_12_0.elementAt(265);
      expect(textureCoord_12_0_265, vector3MoreOrLessEquals(Vector3(0.565318, 0.714286, 0)));
      final textureCoord_12_0_266 = textureCoords_12_0.elementAt(266);
      expect(textureCoord_12_0_266, vector3MoreOrLessEquals(Vector3(0.540141, 0.644841, 0)));
      final textureCoord_12_0_267 = textureCoords_12_0.elementAt(267);
      expect(textureCoord_12_0_267, vector3MoreOrLessEquals(Vector3(0.562009, 0.596231, 0)));
      final textureCoord_12_0_268 = textureCoords_12_0.elementAt(268);
      expect(textureCoord_12_0_268, vector3MoreOrLessEquals(Vector3(0.540141, 0.644841, 0)));
      final textureCoord_12_0_269 = textureCoords_12_0.elementAt(269);
      expect(textureCoord_12_0_269, vector3MoreOrLessEquals(Vector3(0.649727, 0.464286, 0)));
      expect(mesh_12.uvComponents.length, equals(1));
      expect(mesh_12.uvComponents, equals([2]));
      expect(mesh_12.faces.length, equals(90));
      expect(mesh_12.bones.length, isZero);
      expect(mesh_12.materialIndex, equals(1));
      expect(mesh_12.name, equals('Kopf'));
      expect(mesh_12.animMeshes.length, isZero);
      expect(mesh_12.morphingMethod, isZero);
      expect(mesh_12.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_13 = meshes.elementAt(13);
      expect(mesh_13.primitiveTypes, equals(4));
      expect(mesh_13.vertices.length, equals(60));
      final vertex_13_0 = mesh_13.vertices.elementAt(0);
      expect(vertex_13_0, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -16.8773)));
      final vertex_13_1 = mesh_13.vertices.elementAt(1);
      expect(vertex_13_1, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, -20.5831)));
      final vertex_13_2 = mesh_13.vertices.elementAt(2);
      expect(vertex_13_2, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -14.0424)));
      final vertex_13_3 = mesh_13.vertices.elementAt(3);
      expect(vertex_13_3, vector3MoreOrLessEquals(Vector3(-6.30518, -14.1821, -10)));
      final vertex_13_4 = mesh_13.vertices.elementAt(4);
      expect(vertex_13_4, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -14.0424)));
      final vertex_13_5 = mesh_13.vertices.elementAt(5);
      expect(vertex_13_5, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -19.4053)));
      final vertex_13_6 = mesh_13.vertices.elementAt(6);
      expect(vertex_13_6, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -14.0424)));
      final vertex_13_7 = mesh_13.vertices.elementAt(7);
      expect(vertex_13_7, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, -20.5831)));
      final vertex_13_8 = mesh_13.vertices.elementAt(8);
      expect(vertex_13_8, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -19.4053)));
      final vertex_13_9 = mesh_13.vertices.elementAt(9);
      expect(vertex_13_9, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -16.8773)));
      final vertex_13_10 = mesh_13.vertices.elementAt(10);
      expect(vertex_13_10, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -14.0424)));
      final vertex_13_11 = mesh_13.vertices.elementAt(11);
      expect(vertex_13_11, vector3MoreOrLessEquals(Vector3(-32.1219, -11.5362, -10)));
      final vertex_13_12 = mesh_13.vertices.elementAt(12);
      expect(vertex_13_12, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -3.12269)));
      final vertex_13_13 = mesh_13.vertices.elementAt(13);
      expect(vertex_13_13, vector3MoreOrLessEquals(Vector3(-32.1219, -11.5362, -10)));
      final vertex_13_14 = mesh_13.vertices.elementAt(14);
      expect(vertex_13_14, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -5.95762)));
      final vertex_13_15 = mesh_13.vertices.elementAt(15);
      expect(vertex_13_15, vector3MoreOrLessEquals(Vector3(-6.30518, -14.1821, -10)));
      final vertex_13_16 = mesh_13.vertices.elementAt(16);
      expect(vertex_13_16, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -5.95762)));
      final vertex_13_17 = mesh_13.vertices.elementAt(17);
      expect(vertex_13_17, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -14.0424)));
      final vertex_13_18 = mesh_13.vertices.elementAt(18);
      expect(vertex_13_18, vector3MoreOrLessEquals(Vector3(-32.1219, -11.5362, -10)));
      final vertex_13_19 = mesh_13.vertices.elementAt(19);
      expect(vertex_13_19, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -14.0424)));
      final vertex_13_20 = mesh_13.vertices.elementAt(20);
      expect(vertex_13_20, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -5.95762)));
      final vertex_13_21 = mesh_13.vertices.elementAt(21);
      expect(vertex_13_21, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -16.8773)));
      final vertex_13_22 = mesh_13.vertices.elementAt(22);
      expect(vertex_13_22, vector3MoreOrLessEquals(Vector3(-32.1219, -11.5362, -10)));
      final vertex_13_23 = mesh_13.vertices.elementAt(23);
      expect(vertex_13_23, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -17.0586)));
      final vertex_13_24 = mesh_13.vertices.elementAt(24);
      expect(vertex_13_24, vector3MoreOrLessEquals(Vector3(-51.6476, -5.70869, -10)));
      final vertex_13_25 = mesh_13.vertices.elementAt(25);
      expect(vertex_13_25, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -17.0586)));
      final vertex_13_26 = mesh_13.vertices.elementAt(26);
      expect(vertex_13_26, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -2.94136)));
      final vertex_13_27 = mesh_13.vertices.elementAt(27);
      expect(vertex_13_27, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -3.12269)));
      final vertex_13_28 = mesh_13.vertices.elementAt(28);
      expect(vertex_13_28, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -2.94136)));
      final vertex_13_29 = mesh_13.vertices.elementAt(29);
      expect(vertex_13_29, vector3MoreOrLessEquals(Vector3(-32.1219, -11.5362, -10)));
      final vertex_13_30 = mesh_13.vertices.elementAt(30);
      expect(vertex_13_30, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -17.0586)));
      final vertex_13_31 = mesh_13.vertices.elementAt(31);
      expect(vertex_13_31, vector3MoreOrLessEquals(Vector3(-32.1219, -11.5362, -10)));
      final vertex_13_32 = mesh_13.vertices.elementAt(32);
      expect(vertex_13_32, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -2.94136)));
      final vertex_13_33 = mesh_13.vertices.elementAt(33);
      expect(vertex_13_33, vector3MoreOrLessEquals(Vector3(-51.6476, -5.70869, -10)));
      final vertex_13_34 = mesh_13.vertices.elementAt(34);
      expect(vertex_13_34, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -2.94136)));
      final vertex_13_35 = mesh_13.vertices.elementAt(35);
      expect(vertex_13_35, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, 1.42112)));
      final vertex_13_36 = mesh_13.vertices.elementAt(36);
      expect(vertex_13_36, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -3.12269)));
      final vertex_13_37 = mesh_13.vertices.elementAt(37);
      expect(vertex_13_37, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, 8.47976)));
      final vertex_13_38 = mesh_13.vertices.elementAt(38);
      expect(vertex_13_38, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -2.94136)));
      final vertex_13_39 = mesh_13.vertices.elementAt(39);
      expect(vertex_13_39, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, 1.42112)));
      final vertex_13_40 = mesh_13.vertices.elementAt(40);
      expect(vertex_13_40, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -2.94136)));
      final vertex_13_41 = mesh_13.vertices.elementAt(41);
      expect(vertex_13_41, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, 8.47976)));
      final vertex_13_42 = mesh_13.vertices.elementAt(42);
      expect(vertex_13_42, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -3.12269)));
      final vertex_13_43 = mesh_13.vertices.elementAt(43);
      expect(vertex_13_43, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -5.95762)));
      final vertex_13_44 = mesh_13.vertices.elementAt(44);
      expect(vertex_13_44, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, 0.583091)));
      final vertex_13_45 = mesh_13.vertices.elementAt(45);
      expect(vertex_13_45, vector3MoreOrLessEquals(Vector3(-6.30518, -14.1821, -10)));
      final vertex_13_46 = mesh_13.vertices.elementAt(46);
      expect(vertex_13_46, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -0.594703)));
      final vertex_13_47 = mesh_13.vertices.elementAt(47);
      expect(vertex_13_47, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -5.95762)));
      final vertex_13_48 = mesh_13.vertices.elementAt(48);
      expect(vertex_13_48, vector3MoreOrLessEquals(Vector3(-22.9981, -7.40338, 0.583091)));
      final vertex_13_49 = mesh_13.vertices.elementAt(49);
      expect(vertex_13_49, vector3MoreOrLessEquals(Vector3(-15.1823, -14.3293, -5.95762)));
      final vertex_13_50 = mesh_13.vertices.elementAt(50);
      expect(vertex_13_50, vector3MoreOrLessEquals(Vector3(-6.22944, -10.7226, -0.594703)));
      final vertex_13_51 = mesh_13.vertices.elementAt(51);
      expect(vertex_13_51, vector3MoreOrLessEquals(Vector3(-31.4989, -9.61872, -16.8773)));
      final vertex_13_52 = mesh_13.vertices.elementAt(52);
      expect(vertex_13_52, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -17.0586)));
      final vertex_13_53 = mesh_13.vertices.elementAt(53);
      expect(vertex_13_53, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, -28.4798)));
      final vertex_13_54 = mesh_13.vertices.elementAt(54);
      expect(vertex_13_54, vector3MoreOrLessEquals(Vector3(-51.6476, -5.70869, -10)));
      final vertex_13_55 = mesh_13.vertices.elementAt(55);
      expect(vertex_13_55, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, -21.4211)));
      final vertex_13_56 = mesh_13.vertices.elementAt(56);
      expect(vertex_13_56, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -17.0586)));
      final vertex_13_57 = mesh_13.vertices.elementAt(57);
      expect(vertex_13_57, vector3MoreOrLessEquals(Vector3(-39.1947, -9.35672, -28.4798)));
      final vertex_13_58 = mesh_13.vertices.elementAt(58);
      expect(vertex_13_58, vector3MoreOrLessEquals(Vector3(-44.9497, -12.2685, -17.0586)));
      final vertex_13_59 = mesh_13.vertices.elementAt(59);
      expect(vertex_13_59, vector3MoreOrLessEquals(Vector3(-49.7138, -2.98359, -21.4211)));
      expect(mesh_13.normals.length, equals(60));
      final normal_13_0 = mesh_13.normals.elementAt(0);
      expect(normal_13_0, vector3MoreOrLessEquals(Vector3(0.016905, -0.936472, -0.350333)));
      final normal_13_1 = mesh_13.normals.elementAt(1);
      expect(normal_13_1, vector3MoreOrLessEquals(Vector3(-0.098795, -0.7399, -0.665423)));
      final normal_13_2 = mesh_13.normals.elementAt(2);
      expect(normal_13_2, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, -0.343039)));
      final normal_13_3 = mesh_13.normals.elementAt(3);
      expect(normal_13_3, vector3MoreOrLessEquals(Vector3(0.123931, -0.992291, 0)));
      final normal_13_4 = mesh_13.normals.elementAt(4);
      expect(normal_13_4, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, -0.343039)));
      final normal_13_5 = mesh_13.normals.elementAt(5);
      expect(normal_13_5, vector3MoreOrLessEquals(Vector3(0.035891, -0.855981, -0.51576)));
      final normal_13_6 = mesh_13.normals.elementAt(6);
      expect(normal_13_6, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, -0.343039)));
      final normal_13_7 = mesh_13.normals.elementAt(7);
      expect(normal_13_7, vector3MoreOrLessEquals(Vector3(-0.098795, -0.7399, -0.665423)));
      final normal_13_8 = mesh_13.normals.elementAt(8);
      expect(normal_13_8, vector3MoreOrLessEquals(Vector3(0.035891, -0.855981, -0.51576)));
      final normal_13_9 = mesh_13.normals.elementAt(9);
      expect(normal_13_9, vector3MoreOrLessEquals(Vector3(0.016905, -0.936472, -0.350333)));
      final normal_13_10 = mesh_13.normals.elementAt(10);
      expect(normal_13_10, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, -0.343039)));
      final normal_13_11 = mesh_13.normals.elementAt(11);
      expect(normal_13_11, vector3MoreOrLessEquals(Vector3(-0.028951, -0.999581, 0)));
      final normal_13_12 = mesh_13.normals.elementAt(12);
      expect(normal_13_12, vector3MoreOrLessEquals(Vector3(0.016905, -0.936472, 0.350333)));
      final normal_13_13 = mesh_13.normals.elementAt(13);
      expect(normal_13_13, vector3MoreOrLessEquals(Vector3(-0.028951, -0.999581, 0)));
      final normal_13_14 = mesh_13.normals.elementAt(14);
      expect(normal_13_14, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, 0.343039)));
      final normal_13_15 = mesh_13.normals.elementAt(15);
      expect(normal_13_15, vector3MoreOrLessEquals(Vector3(0.123931, -0.992291, 0)));
      final normal_13_16 = mesh_13.normals.elementAt(16);
      expect(normal_13_16, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, 0.343039)));
      final normal_13_17 = mesh_13.normals.elementAt(17);
      expect(normal_13_17, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, -0.343039)));
      final normal_13_18 = mesh_13.normals.elementAt(18);
      expect(normal_13_18, vector3MoreOrLessEquals(Vector3(-0.028951, -0.999581, 0)));
      final normal_13_19 = mesh_13.normals.elementAt(19);
      expect(normal_13_19, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, -0.343039)));
      final normal_13_20 = mesh_13.normals.elementAt(20);
      expect(normal_13_20, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, 0.343039)));
      final normal_13_21 = mesh_13.normals.elementAt(21);
      expect(normal_13_21, vector3MoreOrLessEquals(Vector3(0.016905, -0.936472, -0.350333)));
      final normal_13_22 = mesh_13.normals.elementAt(22);
      expect(normal_13_22, vector3MoreOrLessEquals(Vector3(-0.028951, -0.999581, 0)));
      final normal_13_23 = mesh_13.normals.elementAt(23);
      expect(normal_13_23, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, -0.220964)));
      final normal_13_24 = mesh_13.normals.elementAt(24);
      expect(normal_13_24, vector3MoreOrLessEquals(Vector3(-0.790477, -0.612492, 0)));
      final normal_13_25 = mesh_13.normals.elementAt(25);
      expect(normal_13_25, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, -0.220964)));
      final normal_13_26 = mesh_13.normals.elementAt(26);
      expect(normal_13_26, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, 0.220964)));
      final normal_13_27 = mesh_13.normals.elementAt(27);
      expect(normal_13_27, vector3MoreOrLessEquals(Vector3(0.016905, -0.936472, 0.350333)));
      final normal_13_28 = mesh_13.normals.elementAt(28);
      expect(normal_13_28, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, 0.220964)));
      final normal_13_29 = mesh_13.normals.elementAt(29);
      expect(normal_13_29, vector3MoreOrLessEquals(Vector3(-0.028951, -0.999581, 0)));
      final normal_13_30 = mesh_13.normals.elementAt(30);
      expect(normal_13_30, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, -0.220964)));
      final normal_13_31 = mesh_13.normals.elementAt(31);
      expect(normal_13_31, vector3MoreOrLessEquals(Vector3(-0.028951, -0.999581, 0)));
      final normal_13_32 = mesh_13.normals.elementAt(32);
      expect(normal_13_32, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, 0.220964)));
      final normal_13_33 = mesh_13.normals.elementAt(33);
      expect(normal_13_33, vector3MoreOrLessEquals(Vector3(-0.790477, -0.612492, 0)));
      final normal_13_34 = mesh_13.normals.elementAt(34);
      expect(normal_13_34, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, 0.220964)));
      final normal_13_35 = mesh_13.normals.elementAt(35);
      expect(normal_13_35, vector3MoreOrLessEquals(Vector3(-0.74101, -0.55666, 0.375544)));
      final normal_13_36 = mesh_13.normals.elementAt(36);
      expect(normal_13_36, vector3MoreOrLessEquals(Vector3(0.016905, -0.936472, 0.350333)));
      final normal_13_37 = mesh_13.normals.elementAt(37);
      expect(normal_13_37, vector3MoreOrLessEquals(Vector3(-0.274313, -0.889661, 0.365042)));
      final normal_13_38 = mesh_13.normals.elementAt(38);
      expect(normal_13_38, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, 0.220964)));
      final normal_13_39 = mesh_13.normals.elementAt(39);
      expect(normal_13_39, vector3MoreOrLessEquals(Vector3(-0.74101, -0.55666, 0.375544)));
      final normal_13_40 = mesh_13.normals.elementAt(40);
      expect(normal_13_40, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, 0.220964)));
      final normal_13_41 = mesh_13.normals.elementAt(41);
      expect(normal_13_41, vector3MoreOrLessEquals(Vector3(-0.274313, -0.889661, 0.365042)));
      final normal_13_42 = mesh_13.normals.elementAt(42);
      expect(normal_13_42, vector3MoreOrLessEquals(Vector3(0.016905, -0.936472, 0.350333)));
      final normal_13_43 = mesh_13.normals.elementAt(43);
      expect(normal_13_43, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, 0.343039)));
      final normal_13_44 = mesh_13.normals.elementAt(44);
      expect(normal_13_44, vector3MoreOrLessEquals(Vector3(-0.098795, -0.7399, 0.665423)));
      final normal_13_45 = mesh_13.normals.elementAt(45);
      expect(normal_13_45, vector3MoreOrLessEquals(Vector3(0.123931, -0.992291, 0)));
      final normal_13_46 = mesh_13.normals.elementAt(46);
      expect(normal_13_46, vector3MoreOrLessEquals(Vector3(0.035891, -0.855981, 0.51576)));
      final normal_13_47 = mesh_13.normals.elementAt(47);
      expect(normal_13_47, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, 0.343039)));
      final normal_13_48 = mesh_13.normals.elementAt(48);
      expect(normal_13_48, vector3MoreOrLessEquals(Vector3(-0.098795, -0.7399, 0.665423)));
      final normal_13_49 = mesh_13.normals.elementAt(49);
      expect(normal_13_49, vector3MoreOrLessEquals(Vector3(-0.069462, -0.936749, 0.343039)));
      final normal_13_50 = mesh_13.normals.elementAt(50);
      expect(normal_13_50, vector3MoreOrLessEquals(Vector3(0.035891, -0.855981, 0.51576)));
      final normal_13_51 = mesh_13.normals.elementAt(51);
      expect(normal_13_51, vector3MoreOrLessEquals(Vector3(0.016905, -0.936472, -0.350333)));
      final normal_13_52 = mesh_13.normals.elementAt(52);
      expect(normal_13_52, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, -0.220964)));
      final normal_13_53 = mesh_13.normals.elementAt(53);
      expect(normal_13_53, vector3MoreOrLessEquals(Vector3(-0.274313, -0.889661, -0.365042)));
      final normal_13_54 = mesh_13.normals.elementAt(54);
      expect(normal_13_54, vector3MoreOrLessEquals(Vector3(-0.790477, -0.612492, 0)));
      final normal_13_55 = mesh_13.normals.elementAt(55);
      expect(normal_13_55, vector3MoreOrLessEquals(Vector3(-0.74101, -0.55666, -0.375544)));
      final normal_13_56 = mesh_13.normals.elementAt(56);
      expect(normal_13_56, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, -0.220964)));
      final normal_13_57 = mesh_13.normals.elementAt(57);
      expect(normal_13_57, vector3MoreOrLessEquals(Vector3(-0.274313, -0.889661, -0.365042)));
      final normal_13_58 = mesh_13.normals.elementAt(58);
      expect(normal_13_58, vector3MoreOrLessEquals(Vector3(-0.334402, -0.916161, -0.220964)));
      final normal_13_59 = mesh_13.normals.elementAt(59);
      expect(normal_13_59, vector3MoreOrLessEquals(Vector3(-0.74101, -0.55666, -0.375544)));
      expect(mesh_13.tangents.length, isZero);
      expect(mesh_13.bitangents.length, isZero);
      expect(mesh_13.colors.length, isZero);
      expect(mesh_13.textureCoords.length, equals(1));
      final textureCoords_13_0 = mesh_13.textureCoords.elementAt(0);
      expect(textureCoords_13_0.length, equals(60));
      final textureCoord_13_0_0 = textureCoords_13_0.elementAt(0);
      expect(textureCoord_13_0_0, vector3MoreOrLessEquals(Vector3(0.445345, 0.686077, 0)));
      final textureCoord_13_0_1 = textureCoords_13_0.elementAt(1);
      expect(textureCoord_13_0_1, vector3MoreOrLessEquals(Vector3(0.607126, 0.786343, 0)));
      final textureCoord_13_0_2 = textureCoords_13_0.elementAt(2);
      expect(textureCoord_13_0_2, vector3MoreOrLessEquals(Vector3(0.816422, 0.609373, 0)));
      final textureCoord_13_0_3 = textureCoords_13_0.elementAt(3);
      expect(textureCoord_13_0_3, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_13_0_4 = textureCoords_13_0.elementAt(4);
      expect(textureCoord_13_0_4, vector3MoreOrLessEquals(Vector3(0.816422, 0.609373, 0)));
      final textureCoord_13_0_5 = textureCoords_13_0.elementAt(5);
      expect(textureCoord_13_0_5, vector3MoreOrLessEquals(Vector3(0.978203, 0.754476, 0)));
      final textureCoord_13_0_6 = textureCoords_13_0.elementAt(6);
      expect(textureCoord_13_0_6, vector3MoreOrLessEquals(Vector3(0.816422, 0.609373, 0)));
      final textureCoord_13_0_7 = textureCoords_13_0.elementAt(7);
      expect(textureCoord_13_0_7, vector3MoreOrLessEquals(Vector3(0.607126, 0.786343, 0)));
      final textureCoord_13_0_8 = textureCoords_13_0.elementAt(8);
      expect(textureCoord_13_0_8, vector3MoreOrLessEquals(Vector3(0.978203, 0.754476, 0)));
      final textureCoord_13_0_9 = textureCoords_13_0.elementAt(9);
      expect(textureCoord_13_0_9, vector3MoreOrLessEquals(Vector3(0.445345, 0.686077, 0)));
      final textureCoord_13_0_10 = textureCoords_13_0.elementAt(10);
      expect(textureCoord_13_0_10, vector3MoreOrLessEquals(Vector3(0.816422, 0.609373, 0)));
      final textureCoord_13_0_11 = textureCoords_13_0.elementAt(11);
      expect(textureCoord_13_0_11, vector3MoreOrLessEquals(Vector3(0.445345, 0.5, 0)));
      final textureCoord_13_0_12 = textureCoords_13_0.elementAt(12);
      expect(textureCoord_13_0_12, vector3MoreOrLessEquals(Vector3(0.445345, 0.313923, 0)));
      final textureCoord_13_0_13 = textureCoords_13_0.elementAt(13);
      expect(textureCoord_13_0_13, vector3MoreOrLessEquals(Vector3(0.445345, 0.5, 0)));
      final textureCoord_13_0_14 = textureCoords_13_0.elementAt(14);
      expect(textureCoord_13_0_14, vector3MoreOrLessEquals(Vector3(0.816422, 0.390627, 0)));
      final textureCoord_13_0_15 = textureCoords_13_0.elementAt(15);
      expect(textureCoord_13_0_15, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_13_0_16 = textureCoords_13_0.elementAt(16);
      expect(textureCoord_13_0_16, vector3MoreOrLessEquals(Vector3(0.816422, 0.390627, 0)));
      final textureCoord_13_0_17 = textureCoords_13_0.elementAt(17);
      expect(textureCoord_13_0_17, vector3MoreOrLessEquals(Vector3(0.816422, 0.609373, 0)));
      final textureCoord_13_0_18 = textureCoords_13_0.elementAt(18);
      expect(textureCoord_13_0_18, vector3MoreOrLessEquals(Vector3(0.445345, 0.5, 0)));
      final textureCoord_13_0_19 = textureCoords_13_0.elementAt(19);
      expect(textureCoord_13_0_19, vector3MoreOrLessEquals(Vector3(0.816422, 0.609373, 0)));
      final textureCoord_13_0_20 = textureCoords_13_0.elementAt(20);
      expect(textureCoord_13_0_20, vector3MoreOrLessEquals(Vector3(0.816422, 0.390627, 0)));
      final textureCoord_13_0_21 = textureCoords_13_0.elementAt(21);
      expect(textureCoord_13_0_21, vector3MoreOrLessEquals(Vector3(0.445345, 0.686077, 0)));
      final textureCoord_13_0_22 = textureCoords_13_0.elementAt(22);
      expect(textureCoord_13_0_22, vector3MoreOrLessEquals(Vector3(0.445345, 0.5, 0)));
      final textureCoord_13_0_23 = textureCoords_13_0.elementAt(23);
      expect(textureCoord_13_0_23, vector3MoreOrLessEquals(Vector3(0.183578, 0.690983, 0)));
      final textureCoord_13_0_24 = textureCoords_13_0.elementAt(24);
      expect(textureCoord_13_0_24, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_13_0_25 = textureCoords_13_0.elementAt(25);
      expect(textureCoord_13_0_25, vector3MoreOrLessEquals(Vector3(0.183578, 0.690983, 0)));
      final textureCoord_13_0_26 = textureCoords_13_0.elementAt(26);
      expect(textureCoord_13_0_26, vector3MoreOrLessEquals(Vector3(0.183578, 0.309017, 0)));
      final textureCoord_13_0_27 = textureCoords_13_0.elementAt(27);
      expect(textureCoord_13_0_27, vector3MoreOrLessEquals(Vector3(0.445345, 0.313923, 0)));
      final textureCoord_13_0_28 = textureCoords_13_0.elementAt(28);
      expect(textureCoord_13_0_28, vector3MoreOrLessEquals(Vector3(0.183578, 0.309017, 0)));
      final textureCoord_13_0_29 = textureCoords_13_0.elementAt(29);
      expect(textureCoord_13_0_29, vector3MoreOrLessEquals(Vector3(0.445345, 0.5, 0)));
      final textureCoord_13_0_30 = textureCoords_13_0.elementAt(30);
      expect(textureCoord_13_0_30, vector3MoreOrLessEquals(Vector3(0.183578, 0.690983, 0)));
      final textureCoord_13_0_31 = textureCoords_13_0.elementAt(31);
      expect(textureCoord_13_0_31, vector3MoreOrLessEquals(Vector3(0.445345, 0.5, 0)));
      final textureCoord_13_0_32 = textureCoords_13_0.elementAt(32);
      expect(textureCoord_13_0_32, vector3MoreOrLessEquals(Vector3(0.183578, 0.309017, 0)));
      final textureCoord_13_0_33 = textureCoords_13_0.elementAt(33);
      expect(textureCoord_13_0_33, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_13_0_34 = textureCoords_13_0.elementAt(34);
      expect(textureCoord_13_0_34, vector3MoreOrLessEquals(Vector3(0.183578, 0.309017, 0)));
      final textureCoord_13_0_35 = textureCoords_13_0.elementAt(35);
      expect(textureCoord_13_0_35, vector3MoreOrLessEquals(Vector3(0.021797, 0.190983, 0)));
      final textureCoord_13_0_36 = textureCoords_13_0.elementAt(36);
      expect(textureCoord_13_0_36, vector3MoreOrLessEquals(Vector3(0.445345, 0.313923, 0)));
      final textureCoord_13_0_37 = textureCoords_13_0.elementAt(37);
      expect(textureCoord_13_0_37, vector3MoreOrLessEquals(Vector3(0.283564, 0, 0)));
      final textureCoord_13_0_38 = textureCoords_13_0.elementAt(38);
      expect(textureCoord_13_0_38, vector3MoreOrLessEquals(Vector3(0.183578, 0.309017, 0)));
      final textureCoord_13_0_39 = textureCoords_13_0.elementAt(39);
      expect(textureCoord_13_0_39, vector3MoreOrLessEquals(Vector3(0.021797, 0.190983, 0)));
      final textureCoord_13_0_40 = textureCoords_13_0.elementAt(40);
      expect(textureCoord_13_0_40, vector3MoreOrLessEquals(Vector3(0.183578, 0.309017, 0)));
      final textureCoord_13_0_41 = textureCoords_13_0.elementAt(41);
      expect(textureCoord_13_0_41, vector3MoreOrLessEquals(Vector3(0.283564, 0, 0)));
      final textureCoord_13_0_42 = textureCoords_13_0.elementAt(42);
      expect(textureCoord_13_0_42, vector3MoreOrLessEquals(Vector3(0.445345, 0.313923, 0)));
      final textureCoord_13_0_43 = textureCoords_13_0.elementAt(43);
      expect(textureCoord_13_0_43, vector3MoreOrLessEquals(Vector3(0.816422, 0.390627, 0)));
      final textureCoord_13_0_44 = textureCoords_13_0.elementAt(44);
      expect(textureCoord_13_0_44, vector3MoreOrLessEquals(Vector3(0.607126, 0.213657, 0)));
      final textureCoord_13_0_45 = textureCoords_13_0.elementAt(45);
      expect(textureCoord_13_0_45, vector3MoreOrLessEquals(Vector3(1, 0.5, 0)));
      final textureCoord_13_0_46 = textureCoords_13_0.elementAt(46);
      expect(textureCoord_13_0_46, vector3MoreOrLessEquals(Vector3(0.978203, 0.245524, 0)));
      final textureCoord_13_0_47 = textureCoords_13_0.elementAt(47);
      expect(textureCoord_13_0_47, vector3MoreOrLessEquals(Vector3(0.816422, 0.390627, 0)));
      final textureCoord_13_0_48 = textureCoords_13_0.elementAt(48);
      expect(textureCoord_13_0_48, vector3MoreOrLessEquals(Vector3(0.607126, 0.213657, 0)));
      final textureCoord_13_0_49 = textureCoords_13_0.elementAt(49);
      expect(textureCoord_13_0_49, vector3MoreOrLessEquals(Vector3(0.816422, 0.390627, 0)));
      final textureCoord_13_0_50 = textureCoords_13_0.elementAt(50);
      expect(textureCoord_13_0_50, vector3MoreOrLessEquals(Vector3(0.978203, 0.245524, 0)));
      final textureCoord_13_0_51 = textureCoords_13_0.elementAt(51);
      expect(textureCoord_13_0_51, vector3MoreOrLessEquals(Vector3(0.445345, 0.686077, 0)));
      final textureCoord_13_0_52 = textureCoords_13_0.elementAt(52);
      expect(textureCoord_13_0_52, vector3MoreOrLessEquals(Vector3(0.183578, 0.690983, 0)));
      final textureCoord_13_0_53 = textureCoords_13_0.elementAt(53);
      expect(textureCoord_13_0_53, vector3MoreOrLessEquals(Vector3(0.283564, 1, 0)));
      final textureCoord_13_0_54 = textureCoords_13_0.elementAt(54);
      expect(textureCoord_13_0_54, vector3MoreOrLessEquals(Vector3(0, 0.5, 0)));
      final textureCoord_13_0_55 = textureCoords_13_0.elementAt(55);
      expect(textureCoord_13_0_55, vector3MoreOrLessEquals(Vector3(0.021797, 0.809017, 0)));
      final textureCoord_13_0_56 = textureCoords_13_0.elementAt(56);
      expect(textureCoord_13_0_56, vector3MoreOrLessEquals(Vector3(0.183578, 0.690983, 0)));
      final textureCoord_13_0_57 = textureCoords_13_0.elementAt(57);
      expect(textureCoord_13_0_57, vector3MoreOrLessEquals(Vector3(0.283564, 1, 0)));
      final textureCoord_13_0_58 = textureCoords_13_0.elementAt(58);
      expect(textureCoord_13_0_58, vector3MoreOrLessEquals(Vector3(0.183578, 0.690983, 0)));
      final textureCoord_13_0_59 = textureCoords_13_0.elementAt(59);
      expect(textureCoord_13_0_59, vector3MoreOrLessEquals(Vector3(0.021797, 0.809017, 0)));
      expect(mesh_13.uvComponents.length, equals(1));
      expect(mesh_13.uvComponents, equals([2]));
      expect(mesh_13.faces.length, equals(20));
      expect(mesh_13.bones.length, isZero);
      expect(mesh_13.materialIndex, equals(1));
      expect(mesh_13.name, equals('Brust'));
      expect(mesh_13.animMeshes.length, isZero);
      expect(mesh_13.morphingMethod, isZero);
      expect(mesh_13.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_14 = meshes.elementAt(14);
      expect(mesh_14.primitiveTypes, equals(4));
      expect(mesh_14.vertices.length, equals(270));
      final vertex_14_0 = mesh_14.vertices.elementAt(0);
      expect(vertex_14_0, vector3MoreOrLessEquals(Vector3(-43.2, 24.2518, -9.98889)));
      final vertex_14_1 = mesh_14.vertices.elementAt(1);
      expect(vertex_14_1, vector3MoreOrLessEquals(Vector3(-44.0038, 24.2518, -12.5968)));
      final vertex_14_2 = mesh_14.vertices.elementAt(2);
      expect(vertex_14_2, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.98889)));
      final vertex_14_3 = mesh_14.vertices.elementAt(3);
      expect(vertex_14_3, vector3MoreOrLessEquals(Vector3(-44.0038, 24.2518, -12.5968)));
      final vertex_14_4 = mesh_14.vertices.elementAt(4);
      expect(vertex_14_4, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -19.1726)));
      final vertex_14_5 = mesh_14.vertices.elementAt(5);
      expect(vertex_14_5, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.98889)));
      final vertex_14_6 = mesh_14.vertices.elementAt(6);
      expect(vertex_14_6, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -15.9889)));
      final vertex_14_7 = mesh_14.vertices.elementAt(7);
      expect(vertex_14_7, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -15.185)));
      final vertex_14_8 = mesh_14.vertices.elementAt(8);
      expect(vertex_14_8, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.98889)));
      final vertex_14_9 = mesh_14.vertices.elementAt(9);
      expect(vertex_14_9, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -19.1726)));
      final vertex_14_10 = mesh_14.vertices.elementAt(10);
      expect(vertex_14_10, vector3MoreOrLessEquals(Vector3(-54, 24.7256, -15.9889)));
      final vertex_14_11 = mesh_14.vertices.elementAt(11);
      expect(vertex_14_11, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.98889)));
      final vertex_14_12 = mesh_14.vertices.elementAt(12);
      expect(vertex_14_12, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -15.185)));
      final vertex_14_13 = mesh_14.vertices.elementAt(13);
      expect(vertex_14_13, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -15.9889)));
      final vertex_14_14 = mesh_14.vertices.elementAt(14);
      expect(vertex_14_14, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.98889)));
      final vertex_14_15 = mesh_14.vertices.elementAt(15);
      expect(vertex_14_15, vector3MoreOrLessEquals(Vector3(-54, 24.7256, -15.9889)));
      final vertex_14_16 = mesh_14.vertices.elementAt(16);
      expect(vertex_14_16, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -15.185)));
      final vertex_14_17 = mesh_14.vertices.elementAt(17);
      expect(vertex_14_17, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.98889)));
      final vertex_14_18 = mesh_14.vertices.elementAt(18);
      expect(vertex_14_18, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -12.9889)));
      final vertex_14_19 = mesh_14.vertices.elementAt(19);
      expect(vertex_14_19, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -15.185)));
      final vertex_14_20 = mesh_14.vertices.elementAt(20);
      expect(vertex_14_20, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.98889)));
      final vertex_14_21 = mesh_14.vertices.elementAt(21);
      expect(vertex_14_21, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -15.185)));
      final vertex_14_22 = mesh_14.vertices.elementAt(22);
      expect(vertex_14_22, vector3MoreOrLessEquals(Vector3(-59.1961, 24.7256, -12.9889)));
      final vertex_14_23 = mesh_14.vertices.elementAt(23);
      expect(vertex_14_23, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.98889)));
      final vertex_14_24 = mesh_14.vertices.elementAt(24);
      expect(vertex_14_24, vector3MoreOrLessEquals(Vector3(-58.8, 5.77436, -9.98889)));
      final vertex_14_25 = mesh_14.vertices.elementAt(25);
      expect(vertex_14_25, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -12.9889)));
      final vertex_14_26 = mesh_14.vertices.elementAt(26);
      expect(vertex_14_26, vector3MoreOrLessEquals(Vector3(-54, 2.33333, -9.98889)));
      final vertex_14_27 = mesh_14.vertices.elementAt(27);
      expect(vertex_14_27, vector3MoreOrLessEquals(Vector3(-59.1961, 24.7256, -12.9889)));
      final vertex_14_28 = mesh_14.vertices.elementAt(28);
      expect(vertex_14_28, vector3MoreOrLessEquals(Vector3(-60, 24.7256, -9.98889)));
      final vertex_14_29 = mesh_14.vertices.elementAt(29);
      expect(vertex_14_29, vector3MoreOrLessEquals(Vector3(-54, 26.3333, -9.98889)));
      final vertex_14_30 = mesh_14.vertices.elementAt(30);
      expect(vertex_14_30, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -15.185)));
      final vertex_14_31 = mesh_14.vertices.elementAt(31);
      expect(vertex_14_31, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -18.9889)));
      final vertex_14_32 = mesh_14.vertices.elementAt(32);
      expect(vertex_14_32, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -19.8517)));
      final vertex_14_33 = mesh_14.vertices.elementAt(33);
      expect(vertex_14_33, vector3MoreOrLessEquals(Vector3(-54, 10.6667, -21.7558)));
      final vertex_14_34 = mesh_14.vertices.elementAt(34);
      expect(vertex_14_34, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -18.9889)));
      final vertex_14_35 = mesh_14.vertices.elementAt(35);
      expect(vertex_14_35, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -15.185)));
      final vertex_14_36 = mesh_14.vertices.elementAt(36);
      expect(vertex_14_36, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -15.9889)));
      final vertex_14_37 = mesh_14.vertices.elementAt(37);
      expect(vertex_14_37, vector3MoreOrLessEquals(Vector3(-54, 10.6667, -21.7558)));
      final vertex_14_38 = mesh_14.vertices.elementAt(38);
      expect(vertex_14_38, vector3MoreOrLessEquals(Vector3(-51, 3.94103, -15.185)));
      final vertex_14_39 = mesh_14.vertices.elementAt(39);
      expect(vertex_14_39, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -15.185)));
      final vertex_14_40 = mesh_14.vertices.elementAt(40);
      expect(vertex_14_40, vector3MoreOrLessEquals(Vector3(-54, 10.6667, -21.7558)));
      final vertex_14_41 = mesh_14.vertices.elementAt(41);
      expect(vertex_14_41, vector3MoreOrLessEquals(Vector3(-54, 3.94103, -15.9889)));
      final vertex_14_42 = mesh_14.vertices.elementAt(42);
      expect(vertex_14_42, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -15.185)));
      final vertex_14_43 = mesh_14.vertices.elementAt(43);
      expect(vertex_14_43, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -18.9889)));
      final vertex_14_44 = mesh_14.vertices.elementAt(44);
      expect(vertex_14_44, vector3MoreOrLessEquals(Vector3(-54, 10.6667, -21.7558)));
      final vertex_14_45 = mesh_14.vertices.elementAt(45);
      expect(vertex_14_45, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -15.185)));
      final vertex_14_46 = mesh_14.vertices.elementAt(46);
      expect(vertex_14_46, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -18.9889)));
      final vertex_14_47 = mesh_14.vertices.elementAt(47);
      expect(vertex_14_47, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -15.185)));
      final vertex_14_48 = mesh_14.vertices.elementAt(48);
      expect(vertex_14_48, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -12.9889)));
      final vertex_14_49 = mesh_14.vertices.elementAt(49);
      expect(vertex_14_49, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -15.185)));
      final vertex_14_50 = mesh_14.vertices.elementAt(50);
      expect(vertex_14_50, vector3MoreOrLessEquals(Vector3(-55.8, 6.94103, -15.185)));
      final vertex_14_51 = mesh_14.vertices.elementAt(51);
      expect(vertex_14_51, vector3MoreOrLessEquals(Vector3(-58.8, 5.77436, -9.98889)));
      final vertex_14_52 = mesh_14.vertices.elementAt(52);
      expect(vertex_14_52, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -15.185)));
      final vertex_14_53 = mesh_14.vertices.elementAt(53);
      expect(vertex_14_53, vector3MoreOrLessEquals(Vector3(-57.9962, 5.77436, -12.9889)));
      final vertex_14_54 = mesh_14.vertices.elementAt(54);
      expect(vertex_14_54, vector3MoreOrLessEquals(Vector3(-58.8, 5.77436, -9.98889)));
      final vertex_14_55 = mesh_14.vertices.elementAt(55);
      expect(vertex_14_55, vector3MoreOrLessEquals(Vector3(-64.1923, 7.53335, -9.98889)));
      final vertex_14_56 = mesh_14.vertices.elementAt(56);
      expect(vertex_14_56, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -15.185)));
      final vertex_14_57 = mesh_14.vertices.elementAt(57);
      expect(vertex_14_57, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -19.8517)));
      final vertex_14_58 = mesh_14.vertices.elementAt(58);
      expect(vertex_14_58, vector3MoreOrLessEquals(Vector3(-37.2, 18.6544, -9.98889)));
      final vertex_14_59 = mesh_14.vertices.elementAt(59);
      expect(vertex_14_59, vector3MoreOrLessEquals(Vector3(-43.6077, 8.33333, -9.98889)));
      final vertex_14_60 = mesh_14.vertices.elementAt(60);
      expect(vertex_14_60, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -19.8517)));
      final vertex_14_61 = mesh_14.vertices.elementAt(61);
      expect(vertex_14_61, vector3MoreOrLessEquals(Vector3(-39.2521, 18.6544, -19.8714)));
      final vertex_14_62 = mesh_14.vertices.elementAt(62);
      expect(vertex_14_62, vector3MoreOrLessEquals(Vector3(-37.2, 18.6544, -9.98889)));
      final vertex_14_63 = mesh_14.vertices.elementAt(63);
      expect(vertex_14_63, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_64 = mesh_14.vertices.elementAt(64);
      expect(vertex_14_64, vector3MoreOrLessEquals(Vector3(-39.2521, 18.6544, -19.8714)));
      final vertex_14_65 = mesh_14.vertices.elementAt(65);
      expect(vertex_14_65, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -19.8517)));
      final vertex_14_66 = mesh_14.vertices.elementAt(66);
      expect(vertex_14_66, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -18.9889)));
      final vertex_14_67 = mesh_14.vertices.elementAt(67);
      expect(vertex_14_67, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_68 = mesh_14.vertices.elementAt(68);
      expect(vertex_14_68, vector3MoreOrLessEquals(Vector3(-45.4444, 8.33333, -19.8517)));
      final vertex_14_69 = mesh_14.vertices.elementAt(69);
      expect(vertex_14_69, vector3MoreOrLessEquals(Vector3(-54, 10.6667, -21.7558)));
      final vertex_14_70 = mesh_14.vertices.elementAt(70);
      expect(vertex_14_70, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_71 = mesh_14.vertices.elementAt(71);
      expect(vertex_14_71, vector3MoreOrLessEquals(Vector3(-48.8038, 8.33333, -18.9889)));
      final vertex_14_72 = mesh_14.vertices.elementAt(72);
      expect(vertex_14_72, vector3MoreOrLessEquals(Vector3(-54, 10.6667, -21.7558)));
      final vertex_14_73 = mesh_14.vertices.elementAt(73);
      expect(vertex_14_73, vector3MoreOrLessEquals(Vector3(-54, 14.3333, -21.9889)));
      final vertex_14_74 = mesh_14.vertices.elementAt(74);
      expect(vertex_14_74, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_75 = mesh_14.vertices.elementAt(75);
      expect(vertex_14_75, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_76 = mesh_14.vertices.elementAt(76);
      expect(vertex_14_76, vector3MoreOrLessEquals(Vector3(-54, 14.3333, -21.9889)));
      final vertex_14_77 = mesh_14.vertices.elementAt(77);
      expect(vertex_14_77, vector3MoreOrLessEquals(Vector3(-54, 10.6667, -21.7558)));
      final vertex_14_78 = mesh_14.vertices.elementAt(78);
      expect(vertex_14_78, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -18.9889)));
      final vertex_14_79 = mesh_14.vertices.elementAt(79);
      expect(vertex_14_79, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_80 = mesh_14.vertices.elementAt(80);
      expect(vertex_14_80, vector3MoreOrLessEquals(Vector3(-54, 10.6667, -21.7558)));
      final vertex_14_81 = mesh_14.vertices.elementAt(81);
      expect(vertex_14_81, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -15.185)));
      final vertex_14_82 = mesh_14.vertices.elementAt(82);
      expect(vertex_14_82, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_83 = mesh_14.vertices.elementAt(83);
      expect(vertex_14_83, vector3MoreOrLessEquals(Vector3(-59.1961, 8.33333, -18.9889)));
      final vertex_14_84 = mesh_14.vertices.elementAt(84);
      expect(vertex_14_84, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -15.185)));
      final vertex_14_85 = mesh_14.vertices.elementAt(85);
      expect(vertex_14_85, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -13.5662)));
      final vertex_14_86 = mesh_14.vertices.elementAt(86);
      expect(vertex_14_86, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_87 = mesh_14.vertices.elementAt(87);
      expect(vertex_14_87, vector3MoreOrLessEquals(Vector3(-66.4, 12.3333, -9.98889)));
      final vertex_14_88 = mesh_14.vertices.elementAt(88);
      expect(vertex_14_88, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -13.5662)));
      final vertex_14_89 = mesh_14.vertices.elementAt(89);
      expect(vertex_14_89, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -15.185)));
      final vertex_14_90 = mesh_14.vertices.elementAt(90);
      expect(vertex_14_90, vector3MoreOrLessEquals(Vector3(-64.1923, 7.53335, -9.98889)));
      final vertex_14_91 = mesh_14.vertices.elementAt(91);
      expect(vertex_14_91, vector3MoreOrLessEquals(Vector3(-66.4, 12.3333, -9.98889)));
      final vertex_14_92 = mesh_14.vertices.elementAt(92);
      expect(vertex_14_92, vector3MoreOrLessEquals(Vector3(-63, 8.33333, -15.185)));
      final vertex_14_93 = mesh_14.vertices.elementAt(93);
      expect(vertex_14_93, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -19.1726)));
      final vertex_14_94 = mesh_14.vertices.elementAt(94);
      expect(vertex_14_94, vector3MoreOrLessEquals(Vector3(-38.8077, 21.886, -9.98889)));
      final vertex_14_95 = mesh_14.vertices.elementAt(95);
      expect(vertex_14_95, vector3MoreOrLessEquals(Vector3(-37.2, 18.6544, -9.98889)));
      final vertex_14_96 = mesh_14.vertices.elementAt(96);
      expect(vertex_14_96, vector3MoreOrLessEquals(Vector3(-39.2521, 18.6544, -19.8714)));
      final vertex_14_97 = mesh_14.vertices.elementAt(97);
      expect(vertex_14_97, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -19.1726)));
      final vertex_14_98 = mesh_14.vertices.elementAt(98);
      expect(vertex_14_98, vector3MoreOrLessEquals(Vector3(-37.2, 18.6544, -9.98889)));
      final vertex_14_99 = mesh_14.vertices.elementAt(99);
      expect(vertex_14_99, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_100 = mesh_14.vertices.elementAt(100);
      expect(vertex_14_100, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -19.1726)));
      final vertex_14_101 = mesh_14.vertices.elementAt(101);
      expect(vertex_14_101, vector3MoreOrLessEquals(Vector3(-39.2521, 18.6544, -19.8714)));
      final vertex_14_102 = mesh_14.vertices.elementAt(102);
      expect(vertex_14_102, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_103 = mesh_14.vertices.elementAt(103);
      expect(vertex_14_103, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, -22.4793)));
      final vertex_14_104 = mesh_14.vertices.elementAt(104);
      expect(vertex_14_104, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -19.1726)));
      final vertex_14_105 = mesh_14.vertices.elementAt(105);
      expect(vertex_14_105, vector3MoreOrLessEquals(Vector3(-54, 20.3333, -20.3812)));
      final vertex_14_106 = mesh_14.vertices.elementAt(106);
      expect(vertex_14_106, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, -22.4793)));
      final vertex_14_107 = mesh_14.vertices.elementAt(107);
      expect(vertex_14_107, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_108 = mesh_14.vertices.elementAt(108);
      expect(vertex_14_108, vector3MoreOrLessEquals(Vector3(-54, 14.3333, -21.9889)));
      final vertex_14_109 = mesh_14.vertices.elementAt(109);
      expect(vertex_14_109, vector3MoreOrLessEquals(Vector3(-54, 20.3333, -20.3812)));
      final vertex_14_110 = mesh_14.vertices.elementAt(110);
      expect(vertex_14_110, vector3MoreOrLessEquals(Vector3(-43.6444, 18.6544, -23.6897)));
      final vertex_14_111 = mesh_14.vertices.elementAt(111);
      expect(vertex_14_111, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_112 = mesh_14.vertices.elementAt(112);
      expect(vertex_14_112, vector3MoreOrLessEquals(Vector3(-54, 20.3333, -20.3812)));
      final vertex_14_113 = mesh_14.vertices.elementAt(113);
      expect(vertex_14_113, vector3MoreOrLessEquals(Vector3(-54, 14.3333, -21.9889)));
      final vertex_14_114 = mesh_14.vertices.elementAt(114);
      expect(vertex_14_114, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_115 = mesh_14.vertices.elementAt(115);
      expect(vertex_14_115, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -17.7342)));
      final vertex_14_116 = mesh_14.vertices.elementAt(116);
      expect(vertex_14_116, vector3MoreOrLessEquals(Vector3(-54, 20.3333, -20.3812)));
      final vertex_14_117 = mesh_14.vertices.elementAt(117);
      expect(vertex_14_117, vector3MoreOrLessEquals(Vector3(-66.4, 12.3333, -9.98889)));
      final vertex_14_118 = mesh_14.vertices.elementAt(118);
      expect(vertex_14_118, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_119 = mesh_14.vertices.elementAt(119);
      expect(vertex_14_119, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -13.5662)));
      final vertex_14_120 = mesh_14.vertices.elementAt(120);
      expect(vertex_14_120, vector3MoreOrLessEquals(Vector3(-66.4, 12.3333, -9.98889)));
      final vertex_14_121 = mesh_14.vertices.elementAt(121);
      expect(vertex_14_121, vector3MoreOrLessEquals(Vector3(-64.3923, 20.3333, -9.98889)));
      final vertex_14_122 = mesh_14.vertices.elementAt(122);
      expect(vertex_14_122, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_123 = mesh_14.vertices.elementAt(123);
      expect(vertex_14_123, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -19.1726)));
      final vertex_14_124 = mesh_14.vertices.elementAt(124);
      expect(vertex_14_124, vector3MoreOrLessEquals(Vector3(-43.2, 24.2518, -9.98889)));
      final vertex_14_125 = mesh_14.vertices.elementAt(125);
      expect(vertex_14_125, vector3MoreOrLessEquals(Vector3(-38.8077, 21.886, -9.98889)));
      final vertex_14_126 = mesh_14.vertices.elementAt(126);
      expect(vertex_14_126, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -19.1726)));
      final vertex_14_127 = mesh_14.vertices.elementAt(127);
      expect(vertex_14_127, vector3MoreOrLessEquals(Vector3(-44.0038, 24.2518, -12.5968)));
      final vertex_14_128 = mesh_14.vertices.elementAt(128);
      expect(vertex_14_128, vector3MoreOrLessEquals(Vector3(-43.2, 24.2518, -9.98889)));
      final vertex_14_129 = mesh_14.vertices.elementAt(129);
      expect(vertex_14_129, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -19.1726)));
      final vertex_14_130 = mesh_14.vertices.elementAt(130);
      expect(vertex_14_130, vector3MoreOrLessEquals(Vector3(-44.0038, 24.2518, -12.5968)));
      final vertex_14_131 = mesh_14.vertices.elementAt(131);
      expect(vertex_14_131, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -19.1726)));
      final vertex_14_132 = mesh_14.vertices.elementAt(132);
      expect(vertex_14_132, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, -22.4793)));
      final vertex_14_133 = mesh_14.vertices.elementAt(133);
      expect(vertex_14_133, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -19.1726)));
      final vertex_14_134 = mesh_14.vertices.elementAt(134);
      expect(vertex_14_134, vector3MoreOrLessEquals(Vector3(-40.6444, 21.886, -19.1726)));
      final vertex_14_135 = mesh_14.vertices.elementAt(135);
      expect(vertex_14_135, vector3MoreOrLessEquals(Vector3(-54, 20.3333, -20.3812)));
      final vertex_14_136 = mesh_14.vertices.elementAt(136);
      expect(vertex_14_136, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -19.1726)));
      final vertex_14_137 = mesh_14.vertices.elementAt(137);
      expect(vertex_14_137, vector3MoreOrLessEquals(Vector3(-44.4483, 21.886, -22.4793)));
      final vertex_14_138 = mesh_14.vertices.elementAt(138);
      expect(vertex_14_138, vector3MoreOrLessEquals(Vector3(-54, 20.3333, -20.3812)));
      final vertex_14_139 = mesh_14.vertices.elementAt(139);
      expect(vertex_14_139, vector3MoreOrLessEquals(Vector3(-54, 24.7256, -15.9889)));
      final vertex_14_140 = mesh_14.vertices.elementAt(140);
      expect(vertex_14_140, vector3MoreOrLessEquals(Vector3(-46.6444, 24.2518, -19.1726)));
      final vertex_14_141 = mesh_14.vertices.elementAt(141);
      expect(vertex_14_141, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -15.185)));
      final vertex_14_142 = mesh_14.vertices.elementAt(142);
      expect(vertex_14_142, vector3MoreOrLessEquals(Vector3(-54, 24.7256, -15.9889)));
      final vertex_14_143 = mesh_14.vertices.elementAt(143);
      expect(vertex_14_143, vector3MoreOrLessEquals(Vector3(-54, 20.3333, -20.3812)));
      final vertex_14_144 = mesh_14.vertices.elementAt(144);
      expect(vertex_14_144, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -17.7342)));
      final vertex_14_145 = mesh_14.vertices.elementAt(145);
      expect(vertex_14_145, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -15.185)));
      final vertex_14_146 = mesh_14.vertices.elementAt(146);
      expect(vertex_14_146, vector3MoreOrLessEquals(Vector3(-54, 20.3333, -20.3812)));
      final vertex_14_147 = mesh_14.vertices.elementAt(147);
      expect(vertex_14_147, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_148 = mesh_14.vertices.elementAt(148);
      expect(vertex_14_148, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -15.185)));
      final vertex_14_149 = mesh_14.vertices.elementAt(149);
      expect(vertex_14_149, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -17.7342)));
      final vertex_14_150 = mesh_14.vertices.elementAt(150);
      expect(vertex_14_150, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_151 = mesh_14.vertices.elementAt(151);
      expect(vertex_14_151, vector3MoreOrLessEquals(Vector3(-59.1961, 24.7256, -12.9889)));
      final vertex_14_152 = mesh_14.vertices.elementAt(152);
      expect(vertex_14_152, vector3MoreOrLessEquals(Vector3(-57, 24.7256, -15.185)));
      final vertex_14_153 = mesh_14.vertices.elementAt(153);
      expect(vertex_14_153, vector3MoreOrLessEquals(Vector3(-60, 24.7256, -9.98889)));
      final vertex_14_154 = mesh_14.vertices.elementAt(154);
      expect(vertex_14_154, vector3MoreOrLessEquals(Vector3(-59.1961, 24.7256, -12.9889)));
      final vertex_14_155 = mesh_14.vertices.elementAt(155);
      expect(vertex_14_155, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_156 = mesh_14.vertices.elementAt(156);
      expect(vertex_14_156, vector3MoreOrLessEquals(Vector3(-64.3923, 20.3333, -9.98889)));
      final vertex_14_157 = mesh_14.vertices.elementAt(157);
      expect(vertex_14_157, vector3MoreOrLessEquals(Vector3(-60, 24.7256, -9.98889)));
      final vertex_14_158 = mesh_14.vertices.elementAt(158);
      expect(vertex_14_158, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_159 = mesh_14.vertices.elementAt(159);
      expect(vertex_14_159, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -14.4465)));
      final vertex_14_160 = mesh_14.vertices.elementAt(160);
      expect(vertex_14_160, vector3MoreOrLessEquals(Vector3(-62.366, 15.3991, -14.3285)));
      final vertex_14_161 = mesh_14.vertices.elementAt(161);
      expect(vertex_14_161, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -13.7941)));
      final vertex_14_162 = mesh_14.vertices.elementAt(162);
      expect(vertex_14_162, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -14.4465)));
      final vertex_14_163 = mesh_14.vertices.elementAt(163);
      expect(vertex_14_163, vector3MoreOrLessEquals(Vector3(-62.9556, 14.6429, -14.5431)));
      final vertex_14_164 = mesh_14.vertices.elementAt(164);
      expect(vertex_14_164, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -13.5662)));
      final vertex_14_165 = mesh_14.vertices.elementAt(165);
      expect(vertex_14_165, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -13.5662)));
      final vertex_14_166 = mesh_14.vertices.elementAt(166);
      expect(vertex_14_166, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -13.7941)));
      final vertex_14_167 = mesh_14.vertices.elementAt(167);
      expect(vertex_14_167, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -14.4465)));
      final vertex_14_168 = mesh_14.vertices.elementAt(168);
      expect(vertex_14_168, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -13.5662)));
      final vertex_14_169 = mesh_14.vertices.elementAt(169);
      expect(vertex_14_169, vector3MoreOrLessEquals(Vector3(-62.9556, 14.6429, -14.5431)));
      final vertex_14_170 = mesh_14.vertices.elementAt(170);
      expect(vertex_14_170, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -15.7415)));
      final vertex_14_171 = mesh_14.vertices.elementAt(171);
      expect(vertex_14_171, vector3MoreOrLessEquals(Vector3(-62.0774, 15.0709, -15.3352)));
      final vertex_14_172 = mesh_14.vertices.elementAt(172);
      expect(vertex_14_172, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -15.7415)));
      final vertex_14_173 = mesh_14.vertices.elementAt(173);
      expect(vertex_14_173, vector3MoreOrLessEquals(Vector3(-62.9556, 14.6429, -14.5431)));
      final vertex_14_174 = mesh_14.vertices.elementAt(174);
      expect(vertex_14_174, vector3MoreOrLessEquals(Vector3(-62.9556, 14.6429, -14.5431)));
      final vertex_14_175 = mesh_14.vertices.elementAt(175);
      expect(vertex_14_175, vector3MoreOrLessEquals(Vector3(-62.3322, 15.0618, -14.4465)));
      final vertex_14_176 = mesh_14.vertices.elementAt(176);
      expect(vertex_14_176, vector3MoreOrLessEquals(Vector3(-62.0774, 15.0709, -15.3352)));
      final vertex_14_177 = mesh_14.vertices.elementAt(177);
      expect(vertex_14_177, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -15.7415)));
      final vertex_14_178 = mesh_14.vertices.elementAt(178);
      expect(vertex_14_178, vector3MoreOrLessEquals(Vector3(-62.0774, 15.0709, -15.3352)));
      final vertex_14_179 = mesh_14.vertices.elementAt(179);
      expect(vertex_14_179, vector3MoreOrLessEquals(Vector3(-61.7381, 15.7372, -16.5184)));
      final vertex_14_180 = mesh_14.vertices.elementAt(180);
      expect(vertex_14_180, vector3MoreOrLessEquals(Vector3(-61.7381, 15.7372, -16.5184)));
      final vertex_14_181 = mesh_14.vertices.elementAt(181);
      expect(vertex_14_181, vector3MoreOrLessEquals(Vector3(-61.6405, 15.3095, -17.2395)));
      final vertex_14_182 = mesh_14.vertices.elementAt(182);
      expect(vertex_14_182, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -15.7415)));
      final vertex_14_183 = mesh_14.vertices.elementAt(183);
      expect(vertex_14_183, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -17.6889)));
      final vertex_14_184 = mesh_14.vertices.elementAt(184);
      expect(vertex_14_184, vector3MoreOrLessEquals(Vector3(-61.7381, 15.7372, -16.5184)));
      final vertex_14_185 = mesh_14.vertices.elementAt(185);
      expect(vertex_14_185, vector3MoreOrLessEquals(Vector3(-61.5534, 16.7451, -17.1625)));
      final vertex_14_186 = mesh_14.vertices.elementAt(186);
      expect(vertex_14_186, vector3MoreOrLessEquals(Vector3(-61.7381, 15.7372, -16.5184)));
      final vertex_14_187 = mesh_14.vertices.elementAt(187);
      expect(vertex_14_187, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -17.6889)));
      final vertex_14_188 = mesh_14.vertices.elementAt(188);
      expect(vertex_14_188, vector3MoreOrLessEquals(Vector3(-61.6405, 15.3095, -17.2395)));
      final vertex_14_189 = mesh_14.vertices.elementAt(189);
      expect(vertex_14_189, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -17.3893)));
      final vertex_14_190 = mesh_14.vertices.elementAt(190);
      expect(vertex_14_190, vector3MoreOrLessEquals(Vector3(-61.5534, 16.7451, -17.1625)));
      final vertex_14_191 = mesh_14.vertices.elementAt(191);
      expect(vertex_14_191, vector3MoreOrLessEquals(Vector3(-61.5825, 17.6345, -17.0612)));
      final vertex_14_192 = mesh_14.vertices.elementAt(192);
      expect(vertex_14_192, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -17.3893)));
      final vertex_14_193 = mesh_14.vertices.elementAt(193);
      expect(vertex_14_193, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -17.6889)));
      final vertex_14_194 = mesh_14.vertices.elementAt(194);
      expect(vertex_14_194, vector3MoreOrLessEquals(Vector3(-61.5534, 16.7451, -17.1625)));
      final vertex_14_195 = mesh_14.vertices.elementAt(195);
      expect(vertex_14_195, vector3MoreOrLessEquals(Vector3(-61.5825, 17.6345, -17.0612)));
      final vertex_14_196 = mesh_14.vertices.elementAt(196);
      expect(vertex_14_196, vector3MoreOrLessEquals(Vector3(-61.725, 18.1557, -16.5641)));
      final vertex_14_197 = mesh_14.vertices.elementAt(197);
      expect(vertex_14_197, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -17.3893)));
      final vertex_14_198 = mesh_14.vertices.elementAt(198);
      expect(vertex_14_198, vector3MoreOrLessEquals(Vector3(-61.725, 18.1557, -16.5641)));
      final vertex_14_199 = mesh_14.vertices.elementAt(199);
      expect(vertex_14_199, vector3MoreOrLessEquals(Vector3(-61.8597, 18.4762, -16.7901)));
      final vertex_14_200 = mesh_14.vertices.elementAt(200);
      expect(vertex_14_200, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -17.3893)));
      final vertex_14_201 = mesh_14.vertices.elementAt(201);
      expect(vertex_14_201, vector3MoreOrLessEquals(Vector3(-61.725, 18.1557, -16.5641)));
      final vertex_14_202 = mesh_14.vertices.elementAt(202);
      expect(vertex_14_202, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -15.8913)));
      final vertex_14_203 = mesh_14.vertices.elementAt(203);
      expect(vertex_14_203, vector3MoreOrLessEquals(Vector3(-61.8597, 18.4762, -16.7901)));
      final vertex_14_204 = mesh_14.vertices.elementAt(204);
      expect(vertex_14_204, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -15.8913)));
      final vertex_14_205 = mesh_14.vertices.elementAt(205);
      expect(vertex_14_205, vector3MoreOrLessEquals(Vector3(-61.725, 18.1557, -16.5641)));
      final vertex_14_206 = mesh_14.vertices.elementAt(206);
      expect(vertex_14_206, vector3MoreOrLessEquals(Vector3(-61.8941, 18.0416, -15.9745)));
      final vertex_14_207 = mesh_14.vertices.elementAt(207);
      expect(vertex_14_207, vector3MoreOrLessEquals(Vector3(-61.8941, 18.0416, -15.9745)));
      final vertex_14_208 = mesh_14.vertices.elementAt(208);
      expect(vertex_14_208, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -14.9925)));
      final vertex_14_209 = mesh_14.vertices.elementAt(209);
      expect(vertex_14_209, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -15.8913)));
      final vertex_14_210 = mesh_14.vertices.elementAt(210);
      expect(vertex_14_210, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -14.9925)));
      final vertex_14_211 = mesh_14.vertices.elementAt(211);
      expect(vertex_14_211, vector3MoreOrLessEquals(Vector3(-61.8941, 18.0416, -15.9745)));
      final vertex_14_212 = mesh_14.vertices.elementAt(212);
      expect(vertex_14_212, vector3MoreOrLessEquals(Vector3(-62.0704, 17.6997, -15.3597)));
      final vertex_14_213 = mesh_14.vertices.elementAt(213);
      expect(vertex_14_213, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -14.9925)));
      final vertex_14_214 = mesh_14.vertices.elementAt(214);
      expect(vertex_14_214, vector3MoreOrLessEquals(Vector3(-62.0704, 17.6997, -15.3597)));
      final vertex_14_215 = mesh_14.vertices.elementAt(215);
      expect(vertex_14_215, vector3MoreOrLessEquals(Vector3(-62.1186, 16.9811, -15.1914)));
      final vertex_14_216 = mesh_14.vertices.elementAt(216);
      expect(vertex_14_216, vector3MoreOrLessEquals(Vector3(-62.1186, 16.9811, -15.1914)));
      final vertex_14_217 = mesh_14.vertices.elementAt(217);
      expect(vertex_14_217, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -14.5431)));
      final vertex_14_218 = mesh_14.vertices.elementAt(218);
      expect(vertex_14_218, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -14.9925)));
      final vertex_14_219 = mesh_14.vertices.elementAt(219);
      expect(vertex_14_219, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -14.5431)));
      final vertex_14_220 = mesh_14.vertices.elementAt(220);
      expect(vertex_14_220, vector3MoreOrLessEquals(Vector3(-62.1186, 16.9811, -15.1914)));
      final vertex_14_221 = mesh_14.vertices.elementAt(221);
      expect(vertex_14_221, vector3MoreOrLessEquals(Vector3(-62.2019, 16.1617, -14.9011)));
      final vertex_14_222 = mesh_14.vertices.elementAt(222);
      expect(vertex_14_222, vector3MoreOrLessEquals(Vector3(-62.2019, 16.1617, -14.9011)));
      final vertex_14_223 = mesh_14.vertices.elementAt(223);
      expect(vertex_14_223, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -13.9439)));
      final vertex_14_224 = mesh_14.vertices.elementAt(224);
      expect(vertex_14_224, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -14.5431)));
      final vertex_14_225 = mesh_14.vertices.elementAt(225);
      expect(vertex_14_225, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -13.9439)));
      final vertex_14_226 = mesh_14.vertices.elementAt(226);
      expect(vertex_14_226, vector3MoreOrLessEquals(Vector3(-62.2019, 16.1617, -14.9011)));
      final vertex_14_227 = mesh_14.vertices.elementAt(227);
      expect(vertex_14_227, vector3MoreOrLessEquals(Vector3(-62.366, 15.3991, -14.3285)));
      final vertex_14_228 = mesh_14.vertices.elementAt(228);
      expect(vertex_14_228, vector3MoreOrLessEquals(Vector3(-62.366, 15.3991, -14.3285)));
      final vertex_14_229 = mesh_14.vertices.elementAt(229);
      expect(vertex_14_229, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -13.7941)));
      final vertex_14_230 = mesh_14.vertices.elementAt(230);
      expect(vertex_14_230, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -13.9439)));
      final vertex_14_231 = mesh_14.vertices.elementAt(231);
      expect(vertex_14_231, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -13.5662)));
      final vertex_14_232 = mesh_14.vertices.elementAt(232);
      expect(vertex_14_232, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_233 = mesh_14.vertices.elementAt(233);
      expect(vertex_14_233, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -13.7941)));
      final vertex_14_234 = mesh_14.vertices.elementAt(234);
      expect(vertex_14_234, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_235 = mesh_14.vertices.elementAt(235);
      expect(vertex_14_235, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -13.9439)));
      final vertex_14_236 = mesh_14.vertices.elementAt(236);
      expect(vertex_14_236, vector3MoreOrLessEquals(Vector3(-63.3209, 15.1429, -13.7941)));
      final vertex_14_237 = mesh_14.vertices.elementAt(237);
      expect(vertex_14_237, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_238 = mesh_14.vertices.elementAt(238);
      expect(vertex_14_238, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -14.5431)));
      final vertex_14_239 = mesh_14.vertices.elementAt(239);
      expect(vertex_14_239, vector3MoreOrLessEquals(Vector3(-63.2479, 16.3095, -13.9439)));
      final vertex_14_240 = mesh_14.vertices.elementAt(240);
      expect(vertex_14_240, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_241 = mesh_14.vertices.elementAt(241);
      expect(vertex_14_241, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -14.9925)));
      final vertex_14_242 = mesh_14.vertices.elementAt(242);
      expect(vertex_14_242, vector3MoreOrLessEquals(Vector3(-62.9556, 16.9762, -14.5431)));
      final vertex_14_243 = mesh_14.vertices.elementAt(243);
      expect(vertex_14_243, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_244 = mesh_14.vertices.elementAt(244);
      expect(vertex_14_244, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -15.8913)));
      final vertex_14_245 = mesh_14.vertices.elementAt(245);
      expect(vertex_14_245, vector3MoreOrLessEquals(Vector3(-62.7365, 18.1429, -14.9925)));
      final vertex_14_246 = mesh_14.vertices.elementAt(246);
      expect(vertex_14_246, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -15.8913)));
      final vertex_14_247 = mesh_14.vertices.elementAt(247);
      expect(vertex_14_247, vector3MoreOrLessEquals(Vector3(-63.0639, 19.4762, -13.1231)));
      final vertex_14_248 = mesh_14.vertices.elementAt(248);
      expect(vertex_14_248, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -17.7342)));
      final vertex_14_249 = mesh_14.vertices.elementAt(249);
      expect(vertex_14_249, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -17.7342)));
      final vertex_14_250 = mesh_14.vertices.elementAt(250);
      expect(vertex_14_250, vector3MoreOrLessEquals(Vector3(-61.8597, 18.4762, -16.7901)));
      final vertex_14_251 = mesh_14.vertices.elementAt(251);
      expect(vertex_14_251, vector3MoreOrLessEquals(Vector3(-62.2981, 18.6429, -15.8913)));
      final vertex_14_252 = mesh_14.vertices.elementAt(252);
      expect(vertex_14_252, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -17.7342)));
      final vertex_14_253 = mesh_14.vertices.elementAt(253);
      expect(vertex_14_253, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -17.3893)));
      final vertex_14_254 = mesh_14.vertices.elementAt(254);
      expect(vertex_14_254, vector3MoreOrLessEquals(Vector3(-61.8597, 18.4762, -16.7901)));
      final vertex_14_255 = mesh_14.vertices.elementAt(255);
      expect(vertex_14_255, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_256 = mesh_14.vertices.elementAt(256);
      expect(vertex_14_256, vector3MoreOrLessEquals(Vector3(-64.6093, 13.4762, -13.5662)));
      final vertex_14_257 = mesh_14.vertices.elementAt(257);
      expect(vertex_14_257, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -15.7415)));
      final vertex_14_258 = mesh_14.vertices.elementAt(258);
      expect(vertex_14_258, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_259 = mesh_14.vertices.elementAt(259);
      expect(vertex_14_259, vector3MoreOrLessEquals(Vector3(-62.3711, 14.4762, -15.7415)));
      final vertex_14_260 = mesh_14.vertices.elementAt(260);
      expect(vertex_14_260, vector3MoreOrLessEquals(Vector3(-61.6405, 15.3095, -17.2395)));
      final vertex_14_261 = mesh_14.vertices.elementAt(261);
      expect(vertex_14_261, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_262 = mesh_14.vertices.elementAt(262);
      expect(vertex_14_262, vector3MoreOrLessEquals(Vector3(-61.6405, 15.3095, -17.2395)));
      final vertex_14_263 = mesh_14.vertices.elementAt(263);
      expect(vertex_14_263, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -17.6889)));
      final vertex_14_264 = mesh_14.vertices.elementAt(264);
      expect(vertex_14_264, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -17.3893)));
      final vertex_14_265 = mesh_14.vertices.elementAt(265);
      expect(vertex_14_265, vector3MoreOrLessEquals(Vector3(-60.2933, 19.4762, -17.7342)));
      final vertex_14_266 = mesh_14.vertices.elementAt(266);
      expect(vertex_14_266, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_267 = mesh_14.vertices.elementAt(267);
      expect(vertex_14_267, vector3MoreOrLessEquals(Vector3(-61.4101, 13.4762, -18.8907)));
      final vertex_14_268 = mesh_14.vertices.elementAt(268);
      expect(vertex_14_268, vector3MoreOrLessEquals(Vector3(-61.5675, 17.8095, -17.3893)));
      final vertex_14_269 = mesh_14.vertices.elementAt(269);
      expect(vertex_14_269, vector3MoreOrLessEquals(Vector3(-61.4213, 16.6429, -17.6889)));
      expect(mesh_14.normals.length, equals(270));
      final normal_14_0 = mesh_14.normals.elementAt(0);
      expect(normal_14_0, vector3MoreOrLessEquals(Vector3(0.356408, 0.929723, -0.092678)));
      final normal_14_1 = mesh_14.normals.elementAt(1);
      expect(normal_14_1, vector3MoreOrLessEquals(Vector3(0.285617, 0.953018, -0.10089)));
      final normal_14_2 = mesh_14.normals.elementAt(2);
      expect(normal_14_2, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, -0.15406)));
      final normal_14_3 = mesh_14.normals.elementAt(3);
      expect(normal_14_3, vector3MoreOrLessEquals(Vector3(0.285617, 0.953018, -0.10089)));
      final normal_14_4 = mesh_14.normals.elementAt(4);
      expect(normal_14_4, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, -0.398579)));
      final normal_14_5 = mesh_14.normals.elementAt(5);
      expect(normal_14_5, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, -0.15406)));
      final normal_14_6 = mesh_14.normals.elementAt(6);
      expect(normal_14_6, vector3MoreOrLessEquals(Vector3(-0.436422, -0.758689, -0.48366)));
      final normal_14_7 = mesh_14.normals.elementAt(7);
      expect(normal_14_7, vector3MoreOrLessEquals(Vector3(0.039808, -0.749385, -0.660937)));
      final normal_14_8 = mesh_14.normals.elementAt(8);
      expect(normal_14_8, vector3MoreOrLessEquals(Vector3(-0.438098, -0.839825, -0.32057)));
      final normal_14_9 = mesh_14.normals.elementAt(9);
      expect(normal_14_9, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, -0.398579)));
      final normal_14_10 = mesh_14.normals.elementAt(10);
      expect(normal_14_10, vector3MoreOrLessEquals(Vector3(-0.144622, 0.858467, -0.492057)));
      final normal_14_11 = mesh_14.normals.elementAt(11);
      expect(normal_14_11, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, -0.15406)));
      final normal_14_12 = mesh_14.normals.elementAt(12);
      expect(normal_14_12, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, -0.451023)));
      final normal_14_13 = mesh_14.normals.elementAt(13);
      expect(normal_14_13, vector3MoreOrLessEquals(Vector3(-0.436422, -0.758689, -0.48366)));
      final normal_14_14 = mesh_14.normals.elementAt(14);
      expect(normal_14_14, vector3MoreOrLessEquals(Vector3(-0.438098, -0.839825, -0.32057)));
      final normal_14_15 = mesh_14.normals.elementAt(15);
      expect(normal_14_15, vector3MoreOrLessEquals(Vector3(-0.144622, 0.858467, -0.492057)));
      final normal_14_16 = mesh_14.normals.elementAt(16);
      expect(normal_14_16, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, -0.515371)));
      final normal_14_17 = mesh_14.normals.elementAt(17);
      expect(normal_14_17, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, -0.15406)));
      final normal_14_18 = mesh_14.normals.elementAt(18);
      expect(normal_14_18, vector3MoreOrLessEquals(Vector3(-0.35184, -0.855427, -0.380071)));
      final normal_14_19 = mesh_14.normals.elementAt(19);
      expect(normal_14_19, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, -0.451023)));
      final normal_14_20 = mesh_14.normals.elementAt(20);
      expect(normal_14_20, vector3MoreOrLessEquals(Vector3(-0.438098, -0.839825, -0.32057)));
      final normal_14_21 = mesh_14.normals.elementAt(21);
      expect(normal_14_21, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, -0.515371)));
      final normal_14_22 = mesh_14.normals.elementAt(22);
      expect(normal_14_22, vector3MoreOrLessEquals(Vector3(-0.503913, 0.811284, -0.296463)));
      final normal_14_23 = mesh_14.normals.elementAt(23);
      expect(normal_14_23, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, -0.15406)));
      final normal_14_24 = mesh_14.normals.elementAt(24);
      expect(normal_14_24, vector3MoreOrLessEquals(Vector3(-0.434503, -0.886238, -0.160593)));
      final normal_14_25 = mesh_14.normals.elementAt(25);
      expect(normal_14_25, vector3MoreOrLessEquals(Vector3(-0.35184, -0.855427, -0.380071)));
      final normal_14_26 = mesh_14.normals.elementAt(26);
      expect(normal_14_26, vector3MoreOrLessEquals(Vector3(-0.438098, -0.839825, -0.32057)));
      final normal_14_27 = mesh_14.normals.elementAt(27);
      expect(normal_14_27, vector3MoreOrLessEquals(Vector3(-0.503913, 0.811284, -0.296463)));
      final normal_14_28 = mesh_14.normals.elementAt(28);
      expect(normal_14_28, vector3MoreOrLessEquals(Vector3(-0.589554, 0.76685, -0.253707)));
      final normal_14_29 = mesh_14.normals.elementAt(29);
      expect(normal_14_29, vector3MoreOrLessEquals(Vector3(-0.032685, 0.987521, -0.15406)));
      final normal_14_30 = mesh_14.normals.elementAt(30);
      expect(normal_14_30, vector3MoreOrLessEquals(Vector3(0.039808, -0.749385, -0.660937)));
      final normal_14_31 = mesh_14.normals.elementAt(31);
      expect(normal_14_31, vector3MoreOrLessEquals(Vector3(-0.033279, -0.530249, -0.847189)));
      final normal_14_32 = mesh_14.normals.elementAt(32);
      expect(normal_14_32, vector3MoreOrLessEquals(Vector3(0.461124, -0.566742, -0.682765)));
      final normal_14_33 = mesh_14.normals.elementAt(33);
      expect(normal_14_33, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, -0.863794)));
      final normal_14_34 = mesh_14.normals.elementAt(34);
      expect(normal_14_34, vector3MoreOrLessEquals(Vector3(-0.033279, -0.530249, -0.847189)));
      final normal_14_35 = mesh_14.normals.elementAt(35);
      expect(normal_14_35, vector3MoreOrLessEquals(Vector3(0.039808, -0.749385, -0.660937)));
      final normal_14_36 = mesh_14.normals.elementAt(36);
      expect(normal_14_36, vector3MoreOrLessEquals(Vector3(-0.436422, -0.758689, -0.48366)));
      final normal_14_37 = mesh_14.normals.elementAt(37);
      expect(normal_14_37, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, -0.863794)));
      final normal_14_38 = mesh_14.normals.elementAt(38);
      expect(normal_14_38, vector3MoreOrLessEquals(Vector3(0.039808, -0.749385, -0.660937)));
      final normal_14_39 = mesh_14.normals.elementAt(39);
      expect(normal_14_39, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, -0.451023)));
      final normal_14_40 = mesh_14.normals.elementAt(40);
      expect(normal_14_40, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, -0.863794)));
      final normal_14_41 = mesh_14.normals.elementAt(41);
      expect(normal_14_41, vector3MoreOrLessEquals(Vector3(-0.436422, -0.758689, -0.48366)));
      final normal_14_42 = mesh_14.normals.elementAt(42);
      expect(normal_14_42, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, -0.451023)));
      final normal_14_43 = mesh_14.normals.elementAt(43);
      expect(normal_14_43, vector3MoreOrLessEquals(Vector3(-0.332554, -0.675497, -0.658112)));
      final normal_14_44 = mesh_14.normals.elementAt(44);
      expect(normal_14_44, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, -0.863794)));
      final normal_14_45 = mesh_14.normals.elementAt(45);
      expect(normal_14_45, vector3MoreOrLessEquals(Vector3(-0.624352, -0.649034, -0.434671)));
      final normal_14_46 = mesh_14.normals.elementAt(46);
      expect(normal_14_46, vector3MoreOrLessEquals(Vector3(-0.332554, -0.675497, -0.658112)));
      final normal_14_47 = mesh_14.normals.elementAt(47);
      expect(normal_14_47, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, -0.451023)));
      final normal_14_48 = mesh_14.normals.elementAt(48);
      expect(normal_14_48, vector3MoreOrLessEquals(Vector3(-0.35184, -0.855427, -0.380071)));
      final normal_14_49 = mesh_14.normals.elementAt(49);
      expect(normal_14_49, vector3MoreOrLessEquals(Vector3(-0.624352, -0.649034, -0.434671)));
      final normal_14_50 = mesh_14.normals.elementAt(50);
      expect(normal_14_50, vector3MoreOrLessEquals(Vector3(-0.390508, -0.802547, -0.451023)));
      final normal_14_51 = mesh_14.normals.elementAt(51);
      expect(normal_14_51, vector3MoreOrLessEquals(Vector3(-0.434503, -0.886238, -0.160593)));
      final normal_14_52 = mesh_14.normals.elementAt(52);
      expect(normal_14_52, vector3MoreOrLessEquals(Vector3(-0.624352, -0.649034, -0.434671)));
      final normal_14_53 = mesh_14.normals.elementAt(53);
      expect(normal_14_53, vector3MoreOrLessEquals(Vector3(-0.35184, -0.855427, -0.380071)));
      final normal_14_54 = mesh_14.normals.elementAt(54);
      expect(normal_14_54, vector3MoreOrLessEquals(Vector3(-0.434503, -0.886238, -0.160593)));
      final normal_14_55 = mesh_14.normals.elementAt(55);
      expect(normal_14_55, vector3MoreOrLessEquals(Vector3(-0.64043, -0.723275, -0.258307)));
      final normal_14_56 = mesh_14.normals.elementAt(56);
      expect(normal_14_56, vector3MoreOrLessEquals(Vector3(-0.624352, -0.649034, -0.434671)));
      final normal_14_57 = mesh_14.normals.elementAt(57);
      expect(normal_14_57, vector3MoreOrLessEquals(Vector3(0.461124, -0.566742, -0.682765)));
      final normal_14_58 = mesh_14.normals.elementAt(58);
      expect(normal_14_58, vector3MoreOrLessEquals(Vector3(0.979386, -0.047392, -0.196359)));
      final normal_14_59 = mesh_14.normals.elementAt(59);
      expect(normal_14_59, vector3MoreOrLessEquals(Vector3(0.839147, -0.520972, -0.156274)));
      final normal_14_60 = mesh_14.normals.elementAt(60);
      expect(normal_14_60, vector3MoreOrLessEquals(Vector3(0.461124, -0.566742, -0.682765)));
      final normal_14_61 = mesh_14.normals.elementAt(61);
      expect(normal_14_61, vector3MoreOrLessEquals(Vector3(0.859197, -0.013067, -0.511478)));
      final normal_14_62 = mesh_14.normals.elementAt(62);
      expect(normal_14_62, vector3MoreOrLessEquals(Vector3(0.979386, -0.047392, -0.196359)));
      final normal_14_63 = mesh_14.normals.elementAt(63);
      expect(normal_14_63, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, -0.985318)));
      final normal_14_64 = mesh_14.normals.elementAt(64);
      expect(normal_14_64, vector3MoreOrLessEquals(Vector3(0.859197, -0.013067, -0.511478)));
      final normal_14_65 = mesh_14.normals.elementAt(65);
      expect(normal_14_65, vector3MoreOrLessEquals(Vector3(0.461124, -0.566742, -0.682765)));
      final normal_14_66 = mesh_14.normals.elementAt(66);
      expect(normal_14_66, vector3MoreOrLessEquals(Vector3(-0.033279, -0.530249, -0.847189)));
      final normal_14_67 = mesh_14.normals.elementAt(67);
      expect(normal_14_67, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, -0.985318)));
      final normal_14_68 = mesh_14.normals.elementAt(68);
      expect(normal_14_68, vector3MoreOrLessEquals(Vector3(0.461124, -0.566742, -0.682765)));
      final normal_14_69 = mesh_14.normals.elementAt(69);
      expect(normal_14_69, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, -0.863794)));
      final normal_14_70 = mesh_14.normals.elementAt(70);
      expect(normal_14_70, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, -0.985318)));
      final normal_14_71 = mesh_14.normals.elementAt(71);
      expect(normal_14_71, vector3MoreOrLessEquals(Vector3(-0.033279, -0.530249, -0.847189)));
      final normal_14_72 = mesh_14.normals.elementAt(72);
      expect(normal_14_72, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, -0.863794)));
      final normal_14_73 = mesh_14.normals.elementAt(73);
      expect(normal_14_73, vector3MoreOrLessEquals(Vector3(-0.298124, 0.093164, -0.94997)));
      final normal_14_74 = mesh_14.normals.elementAt(74);
      expect(normal_14_74, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, -0.985318)));
      final normal_14_75 = mesh_14.normals.elementAt(75);
      expect(normal_14_75, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_76 = mesh_14.normals.elementAt(76);
      expect(normal_14_76, vector3MoreOrLessEquals(Vector3(-0.298124, 0.093164, -0.94997)));
      final normal_14_77 = mesh_14.normals.elementAt(77);
      expect(normal_14_77, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, -0.863794)));
      final normal_14_78 = mesh_14.normals.elementAt(78);
      expect(normal_14_78, vector3MoreOrLessEquals(Vector3(-0.332554, -0.675497, -0.658112)));
      final normal_14_79 = mesh_14.normals.elementAt(79);
      expect(normal_14_79, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_80 = mesh_14.normals.elementAt(80);
      expect(normal_14_80, vector3MoreOrLessEquals(Vector3(-0.155076, -0.479386, -0.863794)));
      final normal_14_81 = mesh_14.normals.elementAt(81);
      expect(normal_14_81, vector3MoreOrLessEquals(Vector3(-0.624352, -0.649034, -0.434671)));
      final normal_14_82 = mesh_14.normals.elementAt(82);
      expect(normal_14_82, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_83 = mesh_14.normals.elementAt(83);
      expect(normal_14_83, vector3MoreOrLessEquals(Vector3(-0.332554, -0.675497, -0.658112)));
      final normal_14_84 = mesh_14.normals.elementAt(84);
      expect(normal_14_84, vector3MoreOrLessEquals(Vector3(-0.624352, -0.649034, -0.434671)));
      final normal_14_85 = mesh_14.normals.elementAt(85);
      expect(normal_14_85, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, -0.5423)));
      final normal_14_86 = mesh_14.normals.elementAt(86);
      expect(normal_14_86, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_87 = mesh_14.normals.elementAt(87);
      expect(normal_14_87, vector3MoreOrLessEquals(Vector3(-0.916442, -0.012784, -0.399964)));
      final normal_14_88 = mesh_14.normals.elementAt(88);
      expect(normal_14_88, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, -0.5423)));
      final normal_14_89 = mesh_14.normals.elementAt(89);
      expect(normal_14_89, vector3MoreOrLessEquals(Vector3(-0.624352, -0.649034, -0.434671)));
      final normal_14_90 = mesh_14.normals.elementAt(90);
      expect(normal_14_90, vector3MoreOrLessEquals(Vector3(-0.64043, -0.723275, -0.258307)));
      final normal_14_91 = mesh_14.normals.elementAt(91);
      expect(normal_14_91, vector3MoreOrLessEquals(Vector3(-0.916442, -0.012784, -0.399964)));
      final normal_14_92 = mesh_14.normals.elementAt(92);
      expect(normal_14_92, vector3MoreOrLessEquals(Vector3(-0.624352, -0.649034, -0.434671)));
      final normal_14_93 = mesh_14.normals.elementAt(93);
      expect(normal_14_93, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, -0.338227)));
      final normal_14_94 = mesh_14.normals.elementAt(94);
      expect(normal_14_94, vector3MoreOrLessEquals(Vector3(0.709959, 0.68978, -0.141992)));
      final normal_14_95 = mesh_14.normals.elementAt(95);
      expect(normal_14_95, vector3MoreOrLessEquals(Vector3(0.979386, -0.047392, -0.196359)));
      final normal_14_96 = mesh_14.normals.elementAt(96);
      expect(normal_14_96, vector3MoreOrLessEquals(Vector3(0.859197, -0.013067, -0.511478)));
      final normal_14_97 = mesh_14.normals.elementAt(97);
      expect(normal_14_97, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, -0.338227)));
      final normal_14_98 = mesh_14.normals.elementAt(98);
      expect(normal_14_98, vector3MoreOrLessEquals(Vector3(0.979386, -0.047392, -0.196359)));
      final normal_14_99 = mesh_14.normals.elementAt(99);
      expect(normal_14_99, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, -0.985318)));
      final normal_14_100 = mesh_14.normals.elementAt(100);
      expect(normal_14_100, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, -0.338227)));
      final normal_14_101 = mesh_14.normals.elementAt(101);
      expect(normal_14_101, vector3MoreOrLessEquals(Vector3(0.859197, -0.013067, -0.511478)));
      final normal_14_102 = mesh_14.normals.elementAt(102);
      expect(normal_14_102, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, -0.985318)));
      final normal_14_103 = mesh_14.normals.elementAt(103);
      expect(normal_14_103, vector3MoreOrLessEquals(Vector3(0.121527, 0.638102, -0.7603)));
      final normal_14_104 = mesh_14.normals.elementAt(104);
      expect(normal_14_104, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, -0.338227)));
      final normal_14_105 = mesh_14.normals.elementAt(105);
      expect(normal_14_105, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, -0.824563)));
      final normal_14_106 = mesh_14.normals.elementAt(106);
      expect(normal_14_106, vector3MoreOrLessEquals(Vector3(0.121527, 0.638102, -0.7603)));
      final normal_14_107 = mesh_14.normals.elementAt(107);
      expect(normal_14_107, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, -0.985318)));
      final normal_14_108 = mesh_14.normals.elementAt(108);
      expect(normal_14_108, vector3MoreOrLessEquals(Vector3(-0.298124, 0.093164, -0.94997)));
      final normal_14_109 = mesh_14.normals.elementAt(109);
      expect(normal_14_109, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, -0.824563)));
      final normal_14_110 = mesh_14.normals.elementAt(110);
      expect(normal_14_110, vector3MoreOrLessEquals(Vector3(0.169781, 0.017978, -0.985318)));
      final normal_14_111 = mesh_14.normals.elementAt(111);
      expect(normal_14_111, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_112 = mesh_14.normals.elementAt(112);
      expect(normal_14_112, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, -0.824563)));
      final normal_14_113 = mesh_14.normals.elementAt(113);
      expect(normal_14_113, vector3MoreOrLessEquals(Vector3(-0.298124, 0.093164, -0.94997)));
      final normal_14_114 = mesh_14.normals.elementAt(114);
      expect(normal_14_114, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_115 = mesh_14.normals.elementAt(115);
      expect(normal_14_115, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497867, -0.640284)));
      final normal_14_116 = mesh_14.normals.elementAt(116);
      expect(normal_14_116, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, -0.824563)));
      final normal_14_117 = mesh_14.normals.elementAt(117);
      expect(normal_14_117, vector3MoreOrLessEquals(Vector3(-0.916442, -0.012784, -0.399964)));
      final normal_14_118 = mesh_14.normals.elementAt(118);
      expect(normal_14_118, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_119 = mesh_14.normals.elementAt(119);
      expect(normal_14_119, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, -0.5423)));
      final normal_14_120 = mesh_14.normals.elementAt(120);
      expect(normal_14_120, vector3MoreOrLessEquals(Vector3(-0.916442, -0.012784, -0.399964)));
      final normal_14_121 = mesh_14.normals.elementAt(121);
      expect(normal_14_121, vector3MoreOrLessEquals(Vector3(-0.777389, 0.439755, -0.449757)));
      final normal_14_122 = mesh_14.normals.elementAt(122);
      expect(normal_14_122, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_123 = mesh_14.normals.elementAt(123);
      expect(normal_14_123, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, -0.338227)));
      final normal_14_124 = mesh_14.normals.elementAt(124);
      expect(normal_14_124, vector3MoreOrLessEquals(Vector3(0.356408, 0.929723, -0.092678)));
      final normal_14_125 = mesh_14.normals.elementAt(125);
      expect(normal_14_125, vector3MoreOrLessEquals(Vector3(0.709959, 0.68978, -0.141992)));
      final normal_14_126 = mesh_14.normals.elementAt(126);
      expect(normal_14_126, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, -0.338227)));
      final normal_14_127 = mesh_14.normals.elementAt(127);
      expect(normal_14_127, vector3MoreOrLessEquals(Vector3(0.285617, 0.953018, -0.10089)));
      final normal_14_128 = mesh_14.normals.elementAt(128);
      expect(normal_14_128, vector3MoreOrLessEquals(Vector3(0.356408, 0.929723, -0.092678)));
      final normal_14_129 = mesh_14.normals.elementAt(129);
      expect(normal_14_129, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, -0.398579)));
      final normal_14_130 = mesh_14.normals.elementAt(130);
      expect(normal_14_130, vector3MoreOrLessEquals(Vector3(0.285617, 0.953018, -0.10089)));
      final normal_14_131 = mesh_14.normals.elementAt(131);
      expect(normal_14_131, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, -0.338227)));
      final normal_14_132 = mesh_14.normals.elementAt(132);
      expect(normal_14_132, vector3MoreOrLessEquals(Vector3(0.121527, 0.638102, -0.7603)));
      final normal_14_133 = mesh_14.normals.elementAt(133);
      expect(normal_14_133, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, -0.398579)));
      final normal_14_134 = mesh_14.normals.elementAt(134);
      expect(normal_14_134, vector3MoreOrLessEquals(Vector3(0.616328, 0.711155, -0.338227)));
      final normal_14_135 = mesh_14.normals.elementAt(135);
      expect(normal_14_135, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, -0.824563)));
      final normal_14_136 = mesh_14.normals.elementAt(136);
      expect(normal_14_136, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, -0.398579)));
      final normal_14_137 = mesh_14.normals.elementAt(137);
      expect(normal_14_137, vector3MoreOrLessEquals(Vector3(0.121527, 0.638102, -0.7603)));
      final normal_14_138 = mesh_14.normals.elementAt(138);
      expect(normal_14_138, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, -0.824563)));
      final normal_14_139 = mesh_14.normals.elementAt(139);
      expect(normal_14_139, vector3MoreOrLessEquals(Vector3(-0.144622, 0.858467, -0.492057)));
      final normal_14_140 = mesh_14.normals.elementAt(140);
      expect(normal_14_140, vector3MoreOrLessEquals(Vector3(0.058045, 0.915295, -0.398579)));
      final normal_14_141 = mesh_14.normals.elementAt(141);
      expect(normal_14_141, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, -0.515371)));
      final normal_14_142 = mesh_14.normals.elementAt(142);
      expect(normal_14_142, vector3MoreOrLessEquals(Vector3(-0.144622, 0.858467, -0.492057)));
      final normal_14_143 = mesh_14.normals.elementAt(143);
      expect(normal_14_143, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, -0.824563)));
      final normal_14_144 = mesh_14.normals.elementAt(144);
      expect(normal_14_144, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497867, -0.640284)));
      final normal_14_145 = mesh_14.normals.elementAt(145);
      expect(normal_14_145, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, -0.515371)));
      final normal_14_146 = mesh_14.normals.elementAt(146);
      expect(normal_14_146, vector3MoreOrLessEquals(Vector3(-0.308158, 0.474484, -0.824563)));
      final normal_14_147 = mesh_14.normals.elementAt(147);
      expect(normal_14_147, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_148 = mesh_14.normals.elementAt(148);
      expect(normal_14_148, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, -0.515371)));
      final normal_14_149 = mesh_14.normals.elementAt(149);
      expect(normal_14_149, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497867, -0.640284)));
      final normal_14_150 = mesh_14.normals.elementAt(150);
      expect(normal_14_150, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_151 = mesh_14.normals.elementAt(151);
      expect(normal_14_151, vector3MoreOrLessEquals(Vector3(-0.503913, 0.811284, -0.296463)));
      final normal_14_152 = mesh_14.normals.elementAt(152);
      expect(normal_14_152, vector3MoreOrLessEquals(Vector3(-0.378955, 0.768626, -0.515371)));
      final normal_14_153 = mesh_14.normals.elementAt(153);
      expect(normal_14_153, vector3MoreOrLessEquals(Vector3(-0.589554, 0.76685, -0.253707)));
      final normal_14_154 = mesh_14.normals.elementAt(154);
      expect(normal_14_154, vector3MoreOrLessEquals(Vector3(-0.503913, 0.811284, -0.296463)));
      final normal_14_155 = mesh_14.normals.elementAt(155);
      expect(normal_14_155, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_156 = mesh_14.normals.elementAt(156);
      expect(normal_14_156, vector3MoreOrLessEquals(Vector3(-0.777389, 0.439755, -0.449757)));
      final normal_14_157 = mesh_14.normals.elementAt(157);
      expect(normal_14_157, vector3MoreOrLessEquals(Vector3(-0.589554, 0.76685, -0.253707)));
      final normal_14_158 = mesh_14.normals.elementAt(158);
      expect(normal_14_158, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_159 = mesh_14.normals.elementAt(159);
      expect(normal_14_159, vector3MoreOrLessEquals(Vector3(-0.536292, 0.842626, -0.04871)));
      final normal_14_160 = mesh_14.normals.elementAt(160);
      expect(normal_14_160, vector3MoreOrLessEquals(Vector3(-0.522164, -0.582123, -0.62328)));
      final normal_14_161 = mesh_14.normals.elementAt(161);
      expect(normal_14_161, vector3MoreOrLessEquals(Vector3(-0.712098, 0.074377, -0.698129)));
      final normal_14_162 = mesh_14.normals.elementAt(162);
      expect(normal_14_162, vector3MoreOrLessEquals(Vector3(-0.536292, 0.842626, -0.04871)));
      final normal_14_163 = mesh_14.normals.elementAt(163);
      expect(normal_14_163, vector3MoreOrLessEquals(Vector3(-0.627854, 0.740316, -0.240274)));
      final normal_14_164 = mesh_14.normals.elementAt(164);
      expect(normal_14_164, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, -0.5423)));
      final normal_14_165 = mesh_14.normals.elementAt(165);
      expect(normal_14_165, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, -0.5423)));
      final normal_14_166 = mesh_14.normals.elementAt(166);
      expect(normal_14_166, vector3MoreOrLessEquals(Vector3(-0.712098, 0.074377, -0.698129)));
      final normal_14_167 = mesh_14.normals.elementAt(167);
      expect(normal_14_167, vector3MoreOrLessEquals(Vector3(-0.536292, 0.842626, -0.04871)));
      final normal_14_168 = mesh_14.normals.elementAt(168);
      expect(normal_14_168, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, -0.5423)));
      final normal_14_169 = mesh_14.normals.elementAt(169);
      expect(normal_14_169, vector3MoreOrLessEquals(Vector3(-0.627854, 0.740316, -0.240274)));
      final normal_14_170 = mesh_14.normals.elementAt(170);
      expect(normal_14_170, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476797, -0.321792)));
      final normal_14_171 = mesh_14.normals.elementAt(171);
      expect(normal_14_171, vector3MoreOrLessEquals(Vector3(-0.729171, 0.655796, -0.195555)));
      final normal_14_172 = mesh_14.normals.elementAt(172);
      expect(normal_14_172, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476797, -0.321792)));
      final normal_14_173 = mesh_14.normals.elementAt(173);
      expect(normal_14_173, vector3MoreOrLessEquals(Vector3(-0.627854, 0.740316, -0.240274)));
      final normal_14_174 = mesh_14.normals.elementAt(174);
      expect(normal_14_174, vector3MoreOrLessEquals(Vector3(-0.627854, 0.740316, -0.240274)));
      final normal_14_175 = mesh_14.normals.elementAt(175);
      expect(normal_14_175, vector3MoreOrLessEquals(Vector3(-0.536292, 0.842626, -0.04871)));
      final normal_14_176 = mesh_14.normals.elementAt(176);
      expect(normal_14_176, vector3MoreOrLessEquals(Vector3(-0.729171, 0.655796, -0.195555)));
      final normal_14_177 = mesh_14.normals.elementAt(177);
      expect(normal_14_177, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476797, -0.321792)));
      final normal_14_178 = mesh_14.normals.elementAt(178);
      expect(normal_14_178, vector3MoreOrLessEquals(Vector3(-0.729171, 0.655796, -0.195555)));
      final normal_14_179 = mesh_14.normals.elementAt(179);
      expect(normal_14_179, vector3MoreOrLessEquals(Vector3(-0.958544, 0.215108, -0.186875)));
      final normal_14_180 = mesh_14.normals.elementAt(180);
      expect(normal_14_180, vector3MoreOrLessEquals(Vector3(-0.958544, 0.215108, -0.186875)));
      final normal_14_181 = mesh_14.normals.elementAt(181);
      expect(normal_14_181, vector3MoreOrLessEquals(Vector3(-0.950592, 0.163928, -0.263634)));
      final normal_14_182 = mesh_14.normals.elementAt(182);
      expect(normal_14_182, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476797, -0.321792)));
      final normal_14_183 = mesh_14.normals.elementAt(183);
      expect(normal_14_183, vector3MoreOrLessEquals(Vector3(-0.891745, 0.110753, -0.438776)));
      final normal_14_184 = mesh_14.normals.elementAt(184);
      expect(normal_14_184, vector3MoreOrLessEquals(Vector3(-0.958544, 0.215108, -0.186875)));
      final normal_14_185 = mesh_14.normals.elementAt(185);
      expect(normal_14_185, vector3MoreOrLessEquals(Vector3(-0.983392, -0.02283, -0.180053)));
      final normal_14_186 = mesh_14.normals.elementAt(186);
      expect(normal_14_186, vector3MoreOrLessEquals(Vector3(-0.958544, 0.215108, -0.186875)));
      final normal_14_187 = mesh_14.normals.elementAt(187);
      expect(normal_14_187, vector3MoreOrLessEquals(Vector3(-0.891745, 0.110753, -0.438776)));
      final normal_14_188 = mesh_14.normals.elementAt(188);
      expect(normal_14_188, vector3MoreOrLessEquals(Vector3(-0.950592, 0.163928, -0.263634)));
      final normal_14_189 = mesh_14.normals.elementAt(189);
      expect(normal_14_189, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, -0.509834)));
      final normal_14_190 = mesh_14.normals.elementAt(190);
      expect(normal_14_190, vector3MoreOrLessEquals(Vector3(-0.983392, -0.02283, -0.180053)));
      final normal_14_191 = mesh_14.normals.elementAt(191);
      expect(normal_14_191, vector3MoreOrLessEquals(Vector3(-0.991858, -0.087831, -0.092217)));
      final normal_14_192 = mesh_14.normals.elementAt(192);
      expect(normal_14_192, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, -0.509834)));
      final normal_14_193 = mesh_14.normals.elementAt(193);
      expect(normal_14_193, vector3MoreOrLessEquals(Vector3(-0.891745, 0.110753, -0.438776)));
      final normal_14_194 = mesh_14.normals.elementAt(194);
      expect(normal_14_194, vector3MoreOrLessEquals(Vector3(-0.983392, -0.02283, -0.180053)));
      final normal_14_195 = mesh_14.normals.elementAt(195);
      expect(normal_14_195, vector3MoreOrLessEquals(Vector3(-0.991858, -0.087831, -0.092217)));
      final normal_14_196 = mesh_14.normals.elementAt(196);
      expect(normal_14_196, vector3MoreOrLessEquals(Vector3(-0.894953, -0.402899, -0.191657)));
      final normal_14_197 = mesh_14.normals.elementAt(197);
      expect(normal_14_197, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, -0.509834)));
      final normal_14_198 = mesh_14.normals.elementAt(198);
      expect(normal_14_198, vector3MoreOrLessEquals(Vector3(-0.894953, -0.402899, -0.191657)));
      final normal_14_199 = mesh_14.normals.elementAt(199);
      expect(normal_14_199, vector3MoreOrLessEquals(Vector3(-0.903611, 0.009093, -0.428257)));
      final normal_14_200 = mesh_14.normals.elementAt(200);
      expect(normal_14_200, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, -0.509834)));
      final normal_14_201 = mesh_14.normals.elementAt(201);
      expect(normal_14_201, vector3MoreOrLessEquals(Vector3(-0.894953, -0.402899, -0.191657)));
      final normal_14_202 = mesh_14.normals.elementAt(202);
      expect(normal_14_202, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017458, -0.456952)));
      final normal_14_203 = mesh_14.normals.elementAt(203);
      expect(normal_14_203, vector3MoreOrLessEquals(Vector3(-0.903611, 0.009093, -0.428257)));
      final normal_14_204 = mesh_14.normals.elementAt(204);
      expect(normal_14_204, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017458, -0.456952)));
      final normal_14_205 = mesh_14.normals.elementAt(205);
      expect(normal_14_205, vector3MoreOrLessEquals(Vector3(-0.894953, -0.402899, -0.191657)));
      final normal_14_206 = mesh_14.normals.elementAt(206);
      expect(normal_14_206, vector3MoreOrLessEquals(Vector3(-0.731541, -0.49242, -0.471561)));
      final normal_14_207 = mesh_14.normals.elementAt(207);
      expect(normal_14_207, vector3MoreOrLessEquals(Vector3(-0.731541, -0.49242, -0.471561)));
      final normal_14_208 = mesh_14.normals.elementAt(208);
      expect(normal_14_208, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, -0.581018)));
      final normal_14_209 = mesh_14.normals.elementAt(209);
      expect(normal_14_209, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017458, -0.456952)));
      final normal_14_210 = mesh_14.normals.elementAt(210);
      expect(normal_14_210, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, -0.581018)));
      final normal_14_211 = mesh_14.normals.elementAt(211);
      expect(normal_14_211, vector3MoreOrLessEquals(Vector3(-0.731541, -0.49242, -0.471561)));
      final normal_14_212 = mesh_14.normals.elementAt(212);
      expect(normal_14_212, vector3MoreOrLessEquals(Vector3(-0.625932, -0.373553, -0.684593)));
      final normal_14_213 = mesh_14.normals.elementAt(213);
      expect(normal_14_213, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, -0.581018)));
      final normal_14_214 = mesh_14.normals.elementAt(214);
      expect(normal_14_214, vector3MoreOrLessEquals(Vector3(-0.625932, -0.373553, -0.684593)));
      final normal_14_215 = mesh_14.normals.elementAt(215);
      expect(normal_14_215, vector3MoreOrLessEquals(Vector3(-0.584507, -0.18483, -0.790056)));
      final normal_14_216 = mesh_14.normals.elementAt(216);
      expect(normal_14_216, vector3MoreOrLessEquals(Vector3(-0.584507, -0.18483, -0.790056)));
      final normal_14_217 = mesh_14.normals.elementAt(217);
      expect(normal_14_217, vector3MoreOrLessEquals(Vector3(-0.801518, -0.104269, -0.588809)));
      final normal_14_218 = mesh_14.normals.elementAt(218);
      expect(normal_14_218, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, -0.581018)));
      final normal_14_219 = mesh_14.normals.elementAt(219);
      expect(normal_14_219, vector3MoreOrLessEquals(Vector3(-0.801518, -0.104269, -0.588809)));
      final normal_14_220 = mesh_14.normals.elementAt(220);
      expect(normal_14_220, vector3MoreOrLessEquals(Vector3(-0.584507, -0.18483, -0.790056)));
      final normal_14_221 = mesh_14.normals.elementAt(221);
      expect(normal_14_221, vector3MoreOrLessEquals(Vector3(-0.642031, -0.296727, -0.70693)));
      final normal_14_222 = mesh_14.normals.elementAt(222);
      expect(normal_14_222, vector3MoreOrLessEquals(Vector3(-0.642031, -0.296727, -0.70693)));
      final normal_14_223 = mesh_14.normals.elementAt(223);
      expect(normal_14_223, vector3MoreOrLessEquals(Vector3(-0.820281, -0.123456, -0.558478)));
      final normal_14_224 = mesh_14.normals.elementAt(224);
      expect(normal_14_224, vector3MoreOrLessEquals(Vector3(-0.801518, -0.104269, -0.588809)));
      final normal_14_225 = mesh_14.normals.elementAt(225);
      expect(normal_14_225, vector3MoreOrLessEquals(Vector3(-0.820281, -0.123456, -0.558478)));
      final normal_14_226 = mesh_14.normals.elementAt(226);
      expect(normal_14_226, vector3MoreOrLessEquals(Vector3(-0.642031, -0.296727, -0.70693)));
      final normal_14_227 = mesh_14.normals.elementAt(227);
      expect(normal_14_227, vector3MoreOrLessEquals(Vector3(-0.522164, -0.582123, -0.62328)));
      final normal_14_228 = mesh_14.normals.elementAt(228);
      expect(normal_14_228, vector3MoreOrLessEquals(Vector3(-0.522164, -0.582123, -0.62328)));
      final normal_14_229 = mesh_14.normals.elementAt(229);
      expect(normal_14_229, vector3MoreOrLessEquals(Vector3(-0.712098, 0.074377, -0.698129)));
      final normal_14_230 = mesh_14.normals.elementAt(230);
      expect(normal_14_230, vector3MoreOrLessEquals(Vector3(-0.820281, -0.123456, -0.558478)));
      final normal_14_231 = mesh_14.normals.elementAt(231);
      expect(normal_14_231, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, -0.5423)));
      final normal_14_232 = mesh_14.normals.elementAt(232);
      expect(normal_14_232, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_233 = mesh_14.normals.elementAt(233);
      expect(normal_14_233, vector3MoreOrLessEquals(Vector3(-0.712098, 0.074377, -0.698129)));
      final normal_14_234 = mesh_14.normals.elementAt(234);
      expect(normal_14_234, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_235 = mesh_14.normals.elementAt(235);
      expect(normal_14_235, vector3MoreOrLessEquals(Vector3(-0.820281, -0.123456, -0.558478)));
      final normal_14_236 = mesh_14.normals.elementAt(236);
      expect(normal_14_236, vector3MoreOrLessEquals(Vector3(-0.712098, 0.074377, -0.698129)));
      final normal_14_237 = mesh_14.normals.elementAt(237);
      expect(normal_14_237, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_238 = mesh_14.normals.elementAt(238);
      expect(normal_14_238, vector3MoreOrLessEquals(Vector3(-0.801518, -0.104269, -0.588809)));
      final normal_14_239 = mesh_14.normals.elementAt(239);
      expect(normal_14_239, vector3MoreOrLessEquals(Vector3(-0.820281, -0.123456, -0.558478)));
      final normal_14_240 = mesh_14.normals.elementAt(240);
      expect(normal_14_240, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_241 = mesh_14.normals.elementAt(241);
      expect(normal_14_241, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, -0.581018)));
      final normal_14_242 = mesh_14.normals.elementAt(242);
      expect(normal_14_242, vector3MoreOrLessEquals(Vector3(-0.801518, -0.104269, -0.588809)));
      final normal_14_243 = mesh_14.normals.elementAt(243);
      expect(normal_14_243, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_244 = mesh_14.normals.elementAt(244);
      expect(normal_14_244, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017458, -0.456952)));
      final normal_14_245 = mesh_14.normals.elementAt(245);
      expect(normal_14_245, vector3MoreOrLessEquals(Vector3(-0.794103, -0.178378, -0.581018)));
      final normal_14_246 = mesh_14.normals.elementAt(246);
      expect(normal_14_246, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017458, -0.456952)));
      final normal_14_247 = mesh_14.normals.elementAt(247);
      expect(normal_14_247, vector3MoreOrLessEquals(Vector3(-0.831395, 0.369875, -0.414699)));
      final normal_14_248 = mesh_14.normals.elementAt(248);
      expect(normal_14_248, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497867, -0.640284)));
      final normal_14_249 = mesh_14.normals.elementAt(249);
      expect(normal_14_249, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497867, -0.640284)));
      final normal_14_250 = mesh_14.normals.elementAt(250);
      expect(normal_14_250, vector3MoreOrLessEquals(Vector3(-0.903611, 0.009093, -0.428257)));
      final normal_14_251 = mesh_14.normals.elementAt(251);
      expect(normal_14_251, vector3MoreOrLessEquals(Vector3(-0.88932, 0.017458, -0.456952)));
      final normal_14_252 = mesh_14.normals.elementAt(252);
      expect(normal_14_252, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497867, -0.640284)));
      final normal_14_253 = mesh_14.normals.elementAt(253);
      expect(normal_14_253, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, -0.509834)));
      final normal_14_254 = mesh_14.normals.elementAt(254);
      expect(normal_14_254, vector3MoreOrLessEquals(Vector3(-0.903611, 0.009093, -0.428257)));
      final normal_14_255 = mesh_14.normals.elementAt(255);
      expect(normal_14_255, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_256 = mesh_14.normals.elementAt(256);
      expect(normal_14_256, vector3MoreOrLessEquals(Vector3(-0.760623, 0.35688, -0.5423)));
      final normal_14_257 = mesh_14.normals.elementAt(257);
      expect(normal_14_257, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476797, -0.321792)));
      final normal_14_258 = mesh_14.normals.elementAt(258);
      expect(normal_14_258, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_259 = mesh_14.normals.elementAt(259);
      expect(normal_14_259, vector3MoreOrLessEquals(Vector3(-0.817995, 0.476797, -0.321792)));
      final normal_14_260 = mesh_14.normals.elementAt(260);
      expect(normal_14_260, vector3MoreOrLessEquals(Vector3(-0.950592, 0.163928, -0.263634)));
      final normal_14_261 = mesh_14.normals.elementAt(261);
      expect(normal_14_261, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_262 = mesh_14.normals.elementAt(262);
      expect(normal_14_262, vector3MoreOrLessEquals(Vector3(-0.950592, 0.163928, -0.263634)));
      final normal_14_263 = mesh_14.normals.elementAt(263);
      expect(normal_14_263, vector3MoreOrLessEquals(Vector3(-0.891745, 0.110753, -0.438776)));
      final normal_14_264 = mesh_14.normals.elementAt(264);
      expect(normal_14_264, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, -0.509834)));
      final normal_14_265 = mesh_14.normals.elementAt(265);
      expect(normal_14_265, vector3MoreOrLessEquals(Vector3(-0.584949, 0.497867, -0.640284)));
      final normal_14_266 = mesh_14.normals.elementAt(266);
      expect(normal_14_266, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_267 = mesh_14.normals.elementAt(267);
      expect(normal_14_267, vector3MoreOrLessEquals(Vector3(-0.60258, 0.140795, -0.78554)));
      final normal_14_268 = mesh_14.normals.elementAt(268);
      expect(normal_14_268, vector3MoreOrLessEquals(Vector3(-0.859104, 0.044821, -0.509834)));
      final normal_14_269 = mesh_14.normals.elementAt(269);
      expect(normal_14_269, vector3MoreOrLessEquals(Vector3(-0.891745, 0.110753, -0.438776)));
      expect(mesh_14.tangents.length, isZero);
      expect(mesh_14.bitangents.length, isZero);
      expect(mesh_14.colors.length, isZero);
      expect(mesh_14.textureCoords.length, equals(1));
      final textureCoords_14_0 = mesh_14.textureCoords.elementAt(0);
      expect(textureCoords_14_0.length, equals(270));
      final textureCoord_14_0_0 = textureCoords_14_0.elementAt(0);
      expect(textureCoord_14_0_0, vector3MoreOrLessEquals(Vector3(1, 0.913269, 0)));
      final textureCoord_14_0_1 = textureCoords_14_0.elementAt(1);
      expect(textureCoord_14_0_1, vector3MoreOrLessEquals(Vector3(0.809651, 0.913269, 0)));
      final textureCoord_14_0_2 = textureCoords_14_0.elementAt(2);
      expect(textureCoord_14_0_2, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_14_0_3 = textureCoords_14_0.elementAt(3);
      expect(textureCoord_14_0_3, vector3MoreOrLessEquals(Vector3(0.809651, 0.913269, 0)));
      final textureCoord_14_0_4 = textureCoords_14_0.elementAt(4);
      expect(textureCoord_14_0_4, vector3MoreOrLessEquals(Vector3(0.329694, 0.913269, 0)));
      final textureCoord_14_0_5 = textureCoords_14_0.elementAt(5);
      expect(textureCoord_14_0_5, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_14_0_6 = textureCoords_14_0.elementAt(6);
      expect(textureCoord_14_0_6, vector3MoreOrLessEquals(Vector3(0.562069, 0.066987, 0)));
      final textureCoord_14_0_7 = textureCoords_14_0.elementAt(7);
      expect(textureCoord_14_0_7, vector3MoreOrLessEquals(Vector3(0.620741, 0.066987, 0)));
      final textureCoord_14_0_8 = textureCoords_14_0.elementAt(8);
      expect(textureCoord_14_0_8, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_14_0_9 = textureCoords_14_0.elementAt(9);
      expect(textureCoord_14_0_9, vector3MoreOrLessEquals(Vector3(0.329694, 0.913269, 0)));
      final textureCoord_14_0_10 = textureCoords_14_0.elementAt(10);
      expect(textureCoord_14_0_10, vector3MoreOrLessEquals(Vector3(0.562069, 0.933013, 0)));
      final textureCoord_14_0_11 = textureCoords_14_0.elementAt(11);
      expect(textureCoord_14_0_11, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_14_0_12 = textureCoords_14_0.elementAt(12);
      expect(textureCoord_14_0_12, vector3MoreOrLessEquals(Vector3(0.620741, 0.191987, 0)));
      final textureCoord_14_0_13 = textureCoords_14_0.elementAt(13);
      expect(textureCoord_14_0_13, vector3MoreOrLessEquals(Vector3(0.562069, 0.066987, 0)));
      final textureCoord_14_0_14 = textureCoords_14_0.elementAt(14);
      expect(textureCoord_14_0_14, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_14_0_15 = textureCoords_14_0.elementAt(15);
      expect(textureCoord_14_0_15, vector3MoreOrLessEquals(Vector3(0.562069, 0.933013, 0)));
      final textureCoord_14_0_16 = textureCoords_14_0.elementAt(16);
      expect(textureCoord_14_0_16, vector3MoreOrLessEquals(Vector3(0.620741, 0.933013, 0)));
      final textureCoord_14_0_17 = textureCoords_14_0.elementAt(17);
      expect(textureCoord_14_0_17, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_14_0_18 = textureCoords_14_0.elementAt(18);
      expect(textureCoord_14_0_18, vector3MoreOrLessEquals(Vector3(0.781035, 0.143376, 0)));
      final textureCoord_14_0_19 = textureCoords_14_0.elementAt(19);
      expect(textureCoord_14_0_19, vector3MoreOrLessEquals(Vector3(0.620741, 0.191987, 0)));
      final textureCoord_14_0_20 = textureCoords_14_0.elementAt(20);
      expect(textureCoord_14_0_20, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_14_0_21 = textureCoords_14_0.elementAt(21);
      expect(textureCoord_14_0_21, vector3MoreOrLessEquals(Vector3(0.620741, 0.933013, 0)));
      final textureCoord_14_0_22 = textureCoords_14_0.elementAt(22);
      expect(textureCoord_14_0_22, vector3MoreOrLessEquals(Vector3(0.781035, 0.933013, 0)));
      final textureCoord_14_0_23 = textureCoords_14_0.elementAt(23);
      expect(textureCoord_14_0_23, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_14_0_24 = textureCoords_14_0.elementAt(24);
      expect(textureCoord_14_0_24, vector3MoreOrLessEquals(Vector3(1, 0.143376, 0)));
      final textureCoord_14_0_25 = textureCoords_14_0.elementAt(25);
      expect(textureCoord_14_0_25, vector3MoreOrLessEquals(Vector3(0.781035, 0.143376, 0)));
      final textureCoord_14_0_26 = textureCoords_14_0.elementAt(26);
      expect(textureCoord_14_0_26, vector3MoreOrLessEquals(Vector3(1, 0, 0)));
      final textureCoord_14_0_27 = textureCoords_14_0.elementAt(27);
      expect(textureCoord_14_0_27, vector3MoreOrLessEquals(Vector3(0.781035, 0.933013, 0)));
      final textureCoord_14_0_28 = textureCoords_14_0.elementAt(28);
      expect(textureCoord_14_0_28, vector3MoreOrLessEquals(Vector3(1, 0.933013, 0)));
      final textureCoord_14_0_29 = textureCoords_14_0.elementAt(29);
      expect(textureCoord_14_0_29, vector3MoreOrLessEquals(Vector3(1, 1, 0)));
      final textureCoord_14_0_30 = textureCoords_14_0.elementAt(30);
      expect(textureCoord_14_0_30, vector3MoreOrLessEquals(Vector3(0.620741, 0.066987, 0)));
      final textureCoord_14_0_31 = textureCoords_14_0.elementAt(31);
      expect(textureCoord_14_0_31, vector3MoreOrLessEquals(Vector3(0.343104, 0.25, 0)));
      final textureCoord_14_0_32 = textureCoords_14_0.elementAt(32);
      expect(textureCoord_14_0_32, vector3MoreOrLessEquals(Vector3(0.280128, 0.25, 0)));
      final textureCoord_14_0_33 = textureCoords_14_0.elementAt(33);
      expect(textureCoord_14_0_33, vector3MoreOrLessEquals(Vector3(0.141154, 0.347222, 0)));
      final textureCoord_14_0_34 = textureCoords_14_0.elementAt(34);
      expect(textureCoord_14_0_34, vector3MoreOrLessEquals(Vector3(0.343104, 0.25, 0)));
      final textureCoord_14_0_35 = textureCoords_14_0.elementAt(35);
      expect(textureCoord_14_0_35, vector3MoreOrLessEquals(Vector3(0.620741, 0.066987, 0)));
      final textureCoord_14_0_36 = textureCoords_14_0.elementAt(36);
      expect(textureCoord_14_0_36, vector3MoreOrLessEquals(Vector3(0.562069, 0.066987, 0)));
      final textureCoord_14_0_37 = textureCoords_14_0.elementAt(37);
      expect(textureCoord_14_0_37, vector3MoreOrLessEquals(Vector3(0.141154, 0.347222, 0)));
      final textureCoord_14_0_38 = textureCoords_14_0.elementAt(38);
      expect(textureCoord_14_0_38, vector3MoreOrLessEquals(Vector3(0.620741, 0.066987, 0)));
      final textureCoord_14_0_39 = textureCoords_14_0.elementAt(39);
      expect(textureCoord_14_0_39, vector3MoreOrLessEquals(Vector3(0.620741, 0.191987, 0)));
      final textureCoord_14_0_40 = textureCoords_14_0.elementAt(40);
      expect(textureCoord_14_0_40, vector3MoreOrLessEquals(Vector3(0.141154, 0.347222, 0)));
      final textureCoord_14_0_41 = textureCoords_14_0.elementAt(41);
      expect(textureCoord_14_0_41, vector3MoreOrLessEquals(Vector3(0.562069, 0.066987, 0)));
      final textureCoord_14_0_42 = textureCoords_14_0.elementAt(42);
      expect(textureCoord_14_0_42, vector3MoreOrLessEquals(Vector3(0.620741, 0.191987, 0)));
      final textureCoord_14_0_43 = textureCoords_14_0.elementAt(43);
      expect(textureCoord_14_0_43, vector3MoreOrLessEquals(Vector3(0.343104, 0.25, 0)));
      final textureCoord_14_0_44 = textureCoords_14_0.elementAt(44);
      expect(textureCoord_14_0_44, vector3MoreOrLessEquals(Vector3(0.141154, 0.347222, 0)));
      final textureCoord_14_0_45 = textureCoords_14_0.elementAt(45);
      expect(textureCoord_14_0_45, vector3MoreOrLessEquals(Vector3(0.620741, 0.25, 0)));
      final textureCoord_14_0_46 = textureCoords_14_0.elementAt(46);
      expect(textureCoord_14_0_46, vector3MoreOrLessEquals(Vector3(0.343104, 0.25, 0)));
      final textureCoord_14_0_47 = textureCoords_14_0.elementAt(47);
      expect(textureCoord_14_0_47, vector3MoreOrLessEquals(Vector3(0.620741, 0.191987, 0)));
      final textureCoord_14_0_48 = textureCoords_14_0.elementAt(48);
      expect(textureCoord_14_0_48, vector3MoreOrLessEquals(Vector3(0.781035, 0.143376, 0)));
      final textureCoord_14_0_49 = textureCoords_14_0.elementAt(49);
      expect(textureCoord_14_0_49, vector3MoreOrLessEquals(Vector3(0.620741, 0.25, 0)));
      final textureCoord_14_0_50 = textureCoords_14_0.elementAt(50);
      expect(textureCoord_14_0_50, vector3MoreOrLessEquals(Vector3(0.620741, 0.191987, 0)));
      final textureCoord_14_0_51 = textureCoords_14_0.elementAt(51);
      expect(textureCoord_14_0_51, vector3MoreOrLessEquals(Vector3(1, 0.143376, 0)));
      final textureCoord_14_0_52 = textureCoords_14_0.elementAt(52);
      expect(textureCoord_14_0_52, vector3MoreOrLessEquals(Vector3(0.620741, 0.25, 0)));
      final textureCoord_14_0_53 = textureCoords_14_0.elementAt(53);
      expect(textureCoord_14_0_53, vector3MoreOrLessEquals(Vector3(0.781035, 0.143376, 0)));
      final textureCoord_14_0_54 = textureCoords_14_0.elementAt(54);
      expect(textureCoord_14_0_54, vector3MoreOrLessEquals(Vector3(1, 0.143376, 0)));
      final textureCoord_14_0_55 = textureCoords_14_0.elementAt(55);
      expect(textureCoord_14_0_55, vector3MoreOrLessEquals(Vector3(1, 0.216667, 0)));
      final textureCoord_14_0_56 = textureCoords_14_0.elementAt(56);
      expect(textureCoord_14_0_56, vector3MoreOrLessEquals(Vector3(0.620741, 0.25, 0)));
      final textureCoord_14_0_57 = textureCoords_14_0.elementAt(57);
      expect(textureCoord_14_0_57, vector3MoreOrLessEquals(Vector3(0.280128, 0.25, 0)));
      final textureCoord_14_0_58 = textureCoords_14_0.elementAt(58);
      expect(textureCoord_14_0_58, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_14_0_59 = textureCoords_14_0.elementAt(59);
      expect(textureCoord_14_0_59, vector3MoreOrLessEquals(Vector3(1, 0.25, 0)));
      final textureCoord_14_0_60 = textureCoords_14_0.elementAt(60);
      expect(textureCoord_14_0_60, vector3MoreOrLessEquals(Vector3(0.280128, 0.25, 0)));
      final textureCoord_14_0_61 = textureCoords_14_0.elementAt(61);
      expect(textureCoord_14_0_61, vector3MoreOrLessEquals(Vector3(0.27869, 0.680045, 0)));
      final textureCoord_14_0_62 = textureCoords_14_0.elementAt(62);
      expect(textureCoord_14_0_62, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_14_0_63 = textureCoords_14_0.elementAt(63);
      expect(textureCoord_14_0_63, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_14_0_64 = textureCoords_14_0.elementAt(64);
      expect(textureCoord_14_0_64, vector3MoreOrLessEquals(Vector3(0.27869, 0.680045, 0)));
      final textureCoord_14_0_65 = textureCoords_14_0.elementAt(65);
      expect(textureCoord_14_0_65, vector3MoreOrLessEquals(Vector3(0.280128, 0.25, 0)));
      final textureCoord_14_0_66 = textureCoords_14_0.elementAt(66);
      expect(textureCoord_14_0_66, vector3MoreOrLessEquals(Vector3(0.343104, 0.25, 0)));
      final textureCoord_14_0_67 = textureCoords_14_0.elementAt(67);
      expect(textureCoord_14_0_67, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_14_0_68 = textureCoords_14_0.elementAt(68);
      expect(textureCoord_14_0_68, vector3MoreOrLessEquals(Vector3(0.280128, 0.25, 0)));
      final textureCoord_14_0_69 = textureCoords_14_0.elementAt(69);
      expect(textureCoord_14_0_69, vector3MoreOrLessEquals(Vector3(0.141154, 0.347222, 0)));
      final textureCoord_14_0_70 = textureCoords_14_0.elementAt(70);
      expect(textureCoord_14_0_70, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_14_0_71 = textureCoords_14_0.elementAt(71);
      expect(textureCoord_14_0_71, vector3MoreOrLessEquals(Vector3(0.343104, 0.25, 0)));
      final textureCoord_14_0_72 = textureCoords_14_0.elementAt(72);
      expect(textureCoord_14_0_72, vector3MoreOrLessEquals(Vector3(0.141154, 0.347222, 0)));
      final textureCoord_14_0_73 = textureCoords_14_0.elementAt(73);
      expect(textureCoord_14_0_73, vector3MoreOrLessEquals(Vector3(0.124139, 0.5, 0)));
      final textureCoord_14_0_74 = textureCoords_14_0.elementAt(74);
      expect(textureCoord_14_0_74, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_14_0_75 = textureCoords_14_0.elementAt(75);
      expect(textureCoord_14_0_75, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_76 = textureCoords_14_0.elementAt(76);
      expect(textureCoord_14_0_76, vector3MoreOrLessEquals(Vector3(0.124139, 0.5, 0)));
      final textureCoord_14_0_77 = textureCoords_14_0.elementAt(77);
      expect(textureCoord_14_0_77, vector3MoreOrLessEquals(Vector3(0.141154, 0.347222, 0)));
      final textureCoord_14_0_78 = textureCoords_14_0.elementAt(78);
      expect(textureCoord_14_0_78, vector3MoreOrLessEquals(Vector3(0.343104, 0.25, 0)));
      final textureCoord_14_0_79 = textureCoords_14_0.elementAt(79);
      expect(textureCoord_14_0_79, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_80 = textureCoords_14_0.elementAt(80);
      expect(textureCoord_14_0_80, vector3MoreOrLessEquals(Vector3(0.141154, 0.347222, 0)));
      final textureCoord_14_0_81 = textureCoords_14_0.elementAt(81);
      expect(textureCoord_14_0_81, vector3MoreOrLessEquals(Vector3(0.620741, 0.25, 0)));
      final textureCoord_14_0_82 = textureCoords_14_0.elementAt(82);
      expect(textureCoord_14_0_82, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_83 = textureCoords_14_0.elementAt(83);
      expect(textureCoord_14_0_83, vector3MoreOrLessEquals(Vector3(0.343104, 0.25, 0)));
      final textureCoord_14_0_84 = textureCoords_14_0.elementAt(84);
      expect(textureCoord_14_0_84, vector3MoreOrLessEquals(Vector3(0.620741, 0.25, 0)));
      final textureCoord_14_0_85 = textureCoords_14_0.elementAt(85);
      expect(textureCoord_14_0_85, vector3MoreOrLessEquals(Vector3(0.738895, 0.464286, 0)));
      final textureCoord_14_0_86 = textureCoords_14_0.elementAt(86);
      expect(textureCoord_14_0_86, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_87 = textureCoords_14_0.elementAt(87);
      expect(textureCoord_14_0_87, vector3MoreOrLessEquals(Vector3(1, 0.416667, 0)));
      final textureCoord_14_0_88 = textureCoords_14_0.elementAt(88);
      expect(textureCoord_14_0_88, vector3MoreOrLessEquals(Vector3(0.738895, 0.464286, 0)));
      final textureCoord_14_0_89 = textureCoords_14_0.elementAt(89);
      expect(textureCoord_14_0_89, vector3MoreOrLessEquals(Vector3(0.620741, 0.25, 0)));
      final textureCoord_14_0_90 = textureCoords_14_0.elementAt(90);
      expect(textureCoord_14_0_90, vector3MoreOrLessEquals(Vector3(1, 0.216667, 0)));
      final textureCoord_14_0_91 = textureCoords_14_0.elementAt(91);
      expect(textureCoord_14_0_91, vector3MoreOrLessEquals(Vector3(1, 0.416667, 0)));
      final textureCoord_14_0_92 = textureCoords_14_0.elementAt(92);
      expect(textureCoord_14_0_92, vector3MoreOrLessEquals(Vector3(0.620741, 0.25, 0)));
      final textureCoord_14_0_93 = textureCoords_14_0.elementAt(93);
      expect(textureCoord_14_0_93, vector3MoreOrLessEquals(Vector3(0.329694, 0.814696, 0)));
      final textureCoord_14_0_94 = textureCoords_14_0.elementAt(94);
      expect(textureCoord_14_0_94, vector3MoreOrLessEquals(Vector3(1, 0.814696, 0)));
      final textureCoord_14_0_95 = textureCoords_14_0.elementAt(95);
      expect(textureCoord_14_0_95, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_14_0_96 = textureCoords_14_0.elementAt(96);
      expect(textureCoord_14_0_96, vector3MoreOrLessEquals(Vector3(0.27869, 0.680045, 0)));
      final textureCoord_14_0_97 = textureCoords_14_0.elementAt(97);
      expect(textureCoord_14_0_97, vector3MoreOrLessEquals(Vector3(0.329694, 0.814696, 0)));
      final textureCoord_14_0_98 = textureCoords_14_0.elementAt(98);
      expect(textureCoord_14_0_98, vector3MoreOrLessEquals(Vector3(1, 0.680045, 0)));
      final textureCoord_14_0_99 = textureCoords_14_0.elementAt(99);
      expect(textureCoord_14_0_99, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_14_0_100 = textureCoords_14_0.elementAt(100);
      expect(textureCoord_14_0_100, vector3MoreOrLessEquals(Vector3(0.329694, 0.814696, 0)));
      final textureCoord_14_0_101 = textureCoords_14_0.elementAt(101);
      expect(textureCoord_14_0_101, vector3MoreOrLessEquals(Vector3(0.27869, 0.680045, 0)));
      final textureCoord_14_0_102 = textureCoords_14_0.elementAt(102);
      expect(textureCoord_14_0_102, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_14_0_103 = textureCoords_14_0.elementAt(103);
      expect(textureCoord_14_0_103, vector3MoreOrLessEquals(Vector3(0.088341, 0.814696, 0)));
      final textureCoord_14_0_104 = textureCoords_14_0.elementAt(104);
      expect(textureCoord_14_0_104, vector3MoreOrLessEquals(Vector3(0.329694, 0.814696, 0)));
      final textureCoord_14_0_105 = textureCoords_14_0.elementAt(105);
      expect(textureCoord_14_0_105, vector3MoreOrLessEquals(Vector3(0.241482, 0.75, 0)));
      final textureCoord_14_0_106 = textureCoords_14_0.elementAt(106);
      expect(textureCoord_14_0_106, vector3MoreOrLessEquals(Vector3(0.088341, 0.814696, 0)));
      final textureCoord_14_0_107 = textureCoords_14_0.elementAt(107);
      expect(textureCoord_14_0_107, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_14_0_108 = textureCoords_14_0.elementAt(108);
      expect(textureCoord_14_0_108, vector3MoreOrLessEquals(Vector3(0.124139, 0.5, 0)));
      final textureCoord_14_0_109 = textureCoords_14_0.elementAt(109);
      expect(textureCoord_14_0_109, vector3MoreOrLessEquals(Vector3(0.241482, 0.75, 0)));
      final textureCoord_14_0_110 = textureCoords_14_0.elementAt(110);
      expect(textureCoord_14_0_110, vector3MoreOrLessEquals(Vector3(0, 0.680045, 0)));
      final textureCoord_14_0_111 = textureCoords_14_0.elementAt(111);
      expect(textureCoord_14_0_111, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_112 = textureCoords_14_0.elementAt(112);
      expect(textureCoord_14_0_112, vector3MoreOrLessEquals(Vector3(0.241482, 0.75, 0)));
      final textureCoord_14_0_113 = textureCoords_14_0.elementAt(113);
      expect(textureCoord_14_0_113, vector3MoreOrLessEquals(Vector3(0.124139, 0.5, 0)));
      final textureCoord_14_0_114 = textureCoords_14_0.elementAt(114);
      expect(textureCoord_14_0_114, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_115 = textureCoords_14_0.elementAt(115);
      expect(textureCoord_14_0_115, vector3MoreOrLessEquals(Vector3(0.434682, 0.714286, 0)));
      final textureCoord_14_0_116 = textureCoords_14_0.elementAt(116);
      expect(textureCoord_14_0_116, vector3MoreOrLessEquals(Vector3(0.241482, 0.75, 0)));
      final textureCoord_14_0_117 = textureCoords_14_0.elementAt(117);
      expect(textureCoord_14_0_117, vector3MoreOrLessEquals(Vector3(1, 0.416667, 0)));
      final textureCoord_14_0_118 = textureCoords_14_0.elementAt(118);
      expect(textureCoord_14_0_118, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_119 = textureCoords_14_0.elementAt(119);
      expect(textureCoord_14_0_119, vector3MoreOrLessEquals(Vector3(0.738895, 0.464286, 0)));
      final textureCoord_14_0_120 = textureCoords_14_0.elementAt(120);
      expect(textureCoord_14_0_120, vector3MoreOrLessEquals(Vector3(1, 0.416667, 0)));
      final textureCoord_14_0_121 = textureCoords_14_0.elementAt(121);
      expect(textureCoord_14_0_121, vector3MoreOrLessEquals(Vector3(1, 0.75, 0)));
      final textureCoord_14_0_122 = textureCoords_14_0.elementAt(122);
      expect(textureCoord_14_0_122, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_123 = textureCoords_14_0.elementAt(123);
      expect(textureCoord_14_0_123, vector3MoreOrLessEquals(Vector3(0.329694, 0.814696, 0)));
      final textureCoord_14_0_124 = textureCoords_14_0.elementAt(124);
      expect(textureCoord_14_0_124, vector3MoreOrLessEquals(Vector3(1, 0.913269, 0)));
      final textureCoord_14_0_125 = textureCoords_14_0.elementAt(125);
      expect(textureCoord_14_0_125, vector3MoreOrLessEquals(Vector3(1, 0.814696, 0)));
      final textureCoord_14_0_126 = textureCoords_14_0.elementAt(126);
      expect(textureCoord_14_0_126, vector3MoreOrLessEquals(Vector3(0.329694, 0.814696, 0)));
      final textureCoord_14_0_127 = textureCoords_14_0.elementAt(127);
      expect(textureCoord_14_0_127, vector3MoreOrLessEquals(Vector3(0.809651, 0.913269, 0)));
      final textureCoord_14_0_128 = textureCoords_14_0.elementAt(128);
      expect(textureCoord_14_0_128, vector3MoreOrLessEquals(Vector3(1, 0.913269, 0)));
      final textureCoord_14_0_129 = textureCoords_14_0.elementAt(129);
      expect(textureCoord_14_0_129, vector3MoreOrLessEquals(Vector3(0.329694, 0.913269, 0)));
      final textureCoord_14_0_130 = textureCoords_14_0.elementAt(130);
      expect(textureCoord_14_0_130, vector3MoreOrLessEquals(Vector3(0.809651, 0.913269, 0)));
      final textureCoord_14_0_131 = textureCoords_14_0.elementAt(131);
      expect(textureCoord_14_0_131, vector3MoreOrLessEquals(Vector3(0.329694, 0.814696, 0)));
      final textureCoord_14_0_132 = textureCoords_14_0.elementAt(132);
      expect(textureCoord_14_0_132, vector3MoreOrLessEquals(Vector3(0.088341, 0.814696, 0)));
      final textureCoord_14_0_133 = textureCoords_14_0.elementAt(133);
      expect(textureCoord_14_0_133, vector3MoreOrLessEquals(Vector3(0.329694, 0.913269, 0)));
      final textureCoord_14_0_134 = textureCoords_14_0.elementAt(134);
      expect(textureCoord_14_0_134, vector3MoreOrLessEquals(Vector3(0.329694, 0.814696, 0)));
      final textureCoord_14_0_135 = textureCoords_14_0.elementAt(135);
      expect(textureCoord_14_0_135, vector3MoreOrLessEquals(Vector3(0.241482, 0.75, 0)));
      final textureCoord_14_0_136 = textureCoords_14_0.elementAt(136);
      expect(textureCoord_14_0_136, vector3MoreOrLessEquals(Vector3(0.329694, 0.913269, 0)));
      final textureCoord_14_0_137 = textureCoords_14_0.elementAt(137);
      expect(textureCoord_14_0_137, vector3MoreOrLessEquals(Vector3(0.088341, 0.814696, 0)));
      final textureCoord_14_0_138 = textureCoords_14_0.elementAt(138);
      expect(textureCoord_14_0_138, vector3MoreOrLessEquals(Vector3(0.241482, 0.75, 0)));
      final textureCoord_14_0_139 = textureCoords_14_0.elementAt(139);
      expect(textureCoord_14_0_139, vector3MoreOrLessEquals(Vector3(0.562069, 0.933013, 0)));
      final textureCoord_14_0_140 = textureCoords_14_0.elementAt(140);
      expect(textureCoord_14_0_140, vector3MoreOrLessEquals(Vector3(0.329694, 0.913269, 0)));
      final textureCoord_14_0_141 = textureCoords_14_0.elementAt(141);
      expect(textureCoord_14_0_141, vector3MoreOrLessEquals(Vector3(0.620741, 0.933013, 0)));
      final textureCoord_14_0_142 = textureCoords_14_0.elementAt(142);
      expect(textureCoord_14_0_142, vector3MoreOrLessEquals(Vector3(0.562069, 0.933013, 0)));
      final textureCoord_14_0_143 = textureCoords_14_0.elementAt(143);
      expect(textureCoord_14_0_143, vector3MoreOrLessEquals(Vector3(0.241482, 0.75, 0)));
      final textureCoord_14_0_144 = textureCoords_14_0.elementAt(144);
      expect(textureCoord_14_0_144, vector3MoreOrLessEquals(Vector3(0.434682, 0.714286, 0)));
      final textureCoord_14_0_145 = textureCoords_14_0.elementAt(145);
      expect(textureCoord_14_0_145, vector3MoreOrLessEquals(Vector3(0.620741, 0.933013, 0)));
      final textureCoord_14_0_146 = textureCoords_14_0.elementAt(146);
      expect(textureCoord_14_0_146, vector3MoreOrLessEquals(Vector3(0.241482, 0.75, 0)));
      final textureCoord_14_0_147 = textureCoords_14_0.elementAt(147);
      expect(textureCoord_14_0_147, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_148 = textureCoords_14_0.elementAt(148);
      expect(textureCoord_14_0_148, vector3MoreOrLessEquals(Vector3(0.620741, 0.933013, 0)));
      final textureCoord_14_0_149 = textureCoords_14_0.elementAt(149);
      expect(textureCoord_14_0_149, vector3MoreOrLessEquals(Vector3(0.434682, 0.714286, 0)));
      final textureCoord_14_0_150 = textureCoords_14_0.elementAt(150);
      expect(textureCoord_14_0_150, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_151 = textureCoords_14_0.elementAt(151);
      expect(textureCoord_14_0_151, vector3MoreOrLessEquals(Vector3(0.781035, 0.933013, 0)));
      final textureCoord_14_0_152 = textureCoords_14_0.elementAt(152);
      expect(textureCoord_14_0_152, vector3MoreOrLessEquals(Vector3(0.620741, 0.933013, 0)));
      final textureCoord_14_0_153 = textureCoords_14_0.elementAt(153);
      expect(textureCoord_14_0_153, vector3MoreOrLessEquals(Vector3(1, 0.933013, 0)));
      final textureCoord_14_0_154 = textureCoords_14_0.elementAt(154);
      expect(textureCoord_14_0_154, vector3MoreOrLessEquals(Vector3(0.781035, 0.933013, 0)));
      final textureCoord_14_0_155 = textureCoords_14_0.elementAt(155);
      expect(textureCoord_14_0_155, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_156 = textureCoords_14_0.elementAt(156);
      expect(textureCoord_14_0_156, vector3MoreOrLessEquals(Vector3(1, 0.75, 0)));
      final textureCoord_14_0_157 = textureCoords_14_0.elementAt(157);
      expect(textureCoord_14_0_157, vector3MoreOrLessEquals(Vector3(1, 0.933013, 0)));
      final textureCoord_14_0_158 = textureCoords_14_0.elementAt(158);
      expect(textureCoord_14_0_158, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_159 = textureCoords_14_0.elementAt(159);
      expect(textureCoord_14_0_159, vector3MoreOrLessEquals(Vector3(0.674645, 0.530353, 0)));
      final textureCoord_14_0_160 = textureCoords_14_0.elementAt(160);
      expect(textureCoord_14_0_160, vector3MoreOrLessEquals(Vector3(0.683259, 0.544409, 0)));
      final textureCoord_14_0_161 = textureCoords_14_0.elementAt(161);
      expect(textureCoord_14_0_161, vector3MoreOrLessEquals(Vector3(0.722265, 0.533731, 0)));
      final textureCoord_14_0_162 = textureCoords_14_0.elementAt(162);
      expect(textureCoord_14_0_162, vector3MoreOrLessEquals(Vector3(0.674645, 0.530353, 0)));
      final textureCoord_14_0_163 = textureCoords_14_0.elementAt(163);
      expect(textureCoord_14_0_163, vector3MoreOrLessEquals(Vector3(0.667597, 0.512897, 0)));
      final textureCoord_14_0_164 = textureCoords_14_0.elementAt(164);
      expect(textureCoord_14_0_164, vector3MoreOrLessEquals(Vector3(0.738895, 0.464286, 0)));
      final textureCoord_14_0_165 = textureCoords_14_0.elementAt(165);
      expect(textureCoord_14_0_165, vector3MoreOrLessEquals(Vector3(0.738895, 0.464286, 0)));
      final textureCoord_14_0_166 = textureCoords_14_0.elementAt(166);
      expect(textureCoord_14_0_166, vector3MoreOrLessEquals(Vector3(0.722265, 0.533731, 0)));
      final textureCoord_14_0_167 = textureCoords_14_0.elementAt(167);
      expect(textureCoord_14_0_167, vector3MoreOrLessEquals(Vector3(0.674645, 0.530353, 0)));
      final textureCoord_14_0_168 = textureCoords_14_0.elementAt(168);
      expect(textureCoord_14_0_168, vector3MoreOrLessEquals(Vector3(0.738895, 0.464286, 0)));
      final textureCoord_14_0_169 = textureCoords_14_0.elementAt(169);
      expect(textureCoord_14_0_169, vector3MoreOrLessEquals(Vector3(0.667597, 0.512897, 0)));
      final textureCoord_14_0_170 = textureCoords_14_0.elementAt(170);
      expect(textureCoord_14_0_170, vector3MoreOrLessEquals(Vector3(0.580128, 0.505953, 0)));
      final textureCoord_14_0_171 = textureCoords_14_0.elementAt(171);
      expect(textureCoord_14_0_171, vector3MoreOrLessEquals(Vector3(0.609784, 0.53073, 0)));
      final textureCoord_14_0_172 = textureCoords_14_0.elementAt(172);
      expect(textureCoord_14_0_172, vector3MoreOrLessEquals(Vector3(0.580128, 0.505953, 0)));
      final textureCoord_14_0_173 = textureCoords_14_0.elementAt(173);
      expect(textureCoord_14_0_173, vector3MoreOrLessEquals(Vector3(0.667597, 0.512897, 0)));
      final textureCoord_14_0_174 = textureCoords_14_0.elementAt(174);
      expect(textureCoord_14_0_174, vector3MoreOrLessEquals(Vector3(0.667597, 0.512897, 0)));
      final textureCoord_14_0_175 = textureCoords_14_0.elementAt(175);
      expect(textureCoord_14_0_175, vector3MoreOrLessEquals(Vector3(0.674645, 0.530353, 0)));
      final textureCoord_14_0_176 = textureCoords_14_0.elementAt(176);
      expect(textureCoord_14_0_176, vector3MoreOrLessEquals(Vector3(0.609784, 0.53073, 0)));
      final textureCoord_14_0_177 = textureCoords_14_0.elementAt(177);
      expect(textureCoord_14_0_177, vector3MoreOrLessEquals(Vector3(0.580128, 0.505953, 0)));
      final textureCoord_14_0_178 = textureCoords_14_0.elementAt(178);
      expect(textureCoord_14_0_178, vector3MoreOrLessEquals(Vector3(0.609784, 0.53073, 0)));
      final textureCoord_14_0_179 = textureCoords_14_0.elementAt(179);
      expect(textureCoord_14_0_179, vector3MoreOrLessEquals(Vector3(0.52342, 0.558494, 0)));
      final textureCoord_14_0_180 = textureCoords_14_0.elementAt(180);
      expect(textureCoord_14_0_180, vector3MoreOrLessEquals(Vector3(0.52342, 0.558494, 0)));
      final textureCoord_14_0_181 = textureCoords_14_0.elementAt(181);
      expect(textureCoord_14_0_181, vector3MoreOrLessEquals(Vector3(0.470792, 0.540675, 0)));
      final textureCoord_14_0_182 = textureCoords_14_0.elementAt(182);
      expect(textureCoord_14_0_182, vector3MoreOrLessEquals(Vector3(0.580128, 0.505953, 0)));
      final textureCoord_14_0_183 = textureCoords_14_0.elementAt(183);
      expect(textureCoord_14_0_183, vector3MoreOrLessEquals(Vector3(0.437991, 0.596231, 0)));
      final textureCoord_14_0_184 = textureCoords_14_0.elementAt(184);
      expect(textureCoord_14_0_184, vector3MoreOrLessEquals(Vector3(0.52342, 0.558494, 0)));
      final textureCoord_14_0_185 = textureCoords_14_0.elementAt(185);
      expect(textureCoord_14_0_185, vector3MoreOrLessEquals(Vector3(0.476408, 0.600489, 0)));
      final textureCoord_14_0_186 = textureCoords_14_0.elementAt(186);
      expect(textureCoord_14_0_186, vector3MoreOrLessEquals(Vector3(0.52342, 0.558494, 0)));
      final textureCoord_14_0_187 = textureCoords_14_0.elementAt(187);
      expect(textureCoord_14_0_187, vector3MoreOrLessEquals(Vector3(0.437991, 0.596231, 0)));
      final textureCoord_14_0_188 = textureCoords_14_0.elementAt(188);
      expect(textureCoord_14_0_188, vector3MoreOrLessEquals(Vector3(0.470792, 0.540675, 0)));
      final textureCoord_14_0_189 = textureCoords_14_0.elementAt(189);
      expect(textureCoord_14_0_189, vector3MoreOrLessEquals(Vector3(0.459859, 0.644841, 0)));
      final textureCoord_14_0_190 = textureCoords_14_0.elementAt(190);
      expect(textureCoord_14_0_190, vector3MoreOrLessEquals(Vector3(0.476408, 0.600489, 0)));
      final textureCoord_14_0_191 = textureCoords_14_0.elementAt(191);
      expect(textureCoord_14_0_191, vector3MoreOrLessEquals(Vector3(0.483804, 0.637547, 0)));
      final textureCoord_14_0_192 = textureCoords_14_0.elementAt(192);
      expect(textureCoord_14_0_192, vector3MoreOrLessEquals(Vector3(0.459859, 0.644841, 0)));
      final textureCoord_14_0_193 = textureCoords_14_0.elementAt(193);
      expect(textureCoord_14_0_193, vector3MoreOrLessEquals(Vector3(0.437991, 0.596231, 0)));
      final textureCoord_14_0_194 = textureCoords_14_0.elementAt(194);
      expect(textureCoord_14_0_194, vector3MoreOrLessEquals(Vector3(0.476408, 0.600489, 0)));
      final textureCoord_14_0_195 = textureCoords_14_0.elementAt(195);
      expect(textureCoord_14_0_195, vector3MoreOrLessEquals(Vector3(0.483804, 0.637547, 0)));
      final textureCoord_14_0_196 = textureCoords_14_0.elementAt(196);
      expect(textureCoord_14_0_196, vector3MoreOrLessEquals(Vector3(0.520088, 0.659265, 0)));
      final textureCoord_14_0_197 = textureCoords_14_0.elementAt(197);
      expect(textureCoord_14_0_197, vector3MoreOrLessEquals(Vector3(0.459859, 0.644841, 0)));
      final textureCoord_14_0_198 = textureCoords_14_0.elementAt(198);
      expect(textureCoord_14_0_198, vector3MoreOrLessEquals(Vector3(0.520088, 0.659265, 0)));
      final textureCoord_14_0_199 = textureCoords_14_0.elementAt(199);
      expect(textureCoord_14_0_199, vector3MoreOrLessEquals(Vector3(0.503593, 0.672619, 0)));
      final textureCoord_14_0_200 = textureCoords_14_0.elementAt(200);
      expect(textureCoord_14_0_200, vector3MoreOrLessEquals(Vector3(0.459859, 0.644841, 0)));
      final textureCoord_14_0_201 = textureCoords_14_0.elementAt(201);
      expect(textureCoord_14_0_201, vector3MoreOrLessEquals(Vector3(0.520088, 0.659265, 0)));
      final textureCoord_14_0_202 = textureCoords_14_0.elementAt(202);
      expect(textureCoord_14_0_202, vector3MoreOrLessEquals(Vector3(0.569195, 0.679564, 0)));
      final textureCoord_14_0_203 = textureCoords_14_0.elementAt(203);
      expect(textureCoord_14_0_203, vector3MoreOrLessEquals(Vector3(0.503593, 0.672619, 0)));
      final textureCoord_14_0_204 = textureCoords_14_0.elementAt(204);
      expect(textureCoord_14_0_204, vector3MoreOrLessEquals(Vector3(0.569195, 0.679564, 0)));
      final textureCoord_14_0_205 = textureCoords_14_0.elementAt(205);
      expect(textureCoord_14_0_205, vector3MoreOrLessEquals(Vector3(0.520088, 0.659265, 0)));
      final textureCoord_14_0_206 = textureCoords_14_0.elementAt(206);
      expect(textureCoord_14_0_206, vector3MoreOrLessEquals(Vector3(0.563121, 0.654511, 0)));
      final textureCoord_14_0_207 = textureCoords_14_0.elementAt(207);
      expect(textureCoord_14_0_207, vector3MoreOrLessEquals(Vector3(0.563121, 0.654511, 0)));
      final textureCoord_14_0_208 = textureCoords_14_0.elementAt(208);
      expect(textureCoord_14_0_208, vector3MoreOrLessEquals(Vector3(0.634796, 0.658731, 0)));
      final textureCoord_14_0_209 = textureCoords_14_0.elementAt(209);
      expect(textureCoord_14_0_209, vector3MoreOrLessEquals(Vector3(0.569195, 0.679564, 0)));
      final textureCoord_14_0_210 = textureCoords_14_0.elementAt(210);
      expect(textureCoord_14_0_210, vector3MoreOrLessEquals(Vector3(0.634796, 0.658731, 0)));
      final textureCoord_14_0_211 = textureCoords_14_0.elementAt(211);
      expect(textureCoord_14_0_211, vector3MoreOrLessEquals(Vector3(0.563121, 0.654511, 0)));
      final textureCoord_14_0_212 = textureCoords_14_0.elementAt(212);
      expect(textureCoord_14_0_212, vector3MoreOrLessEquals(Vector3(0.607995, 0.640264, 0)));
      final textureCoord_14_0_213 = textureCoords_14_0.elementAt(213);
      expect(textureCoord_14_0_213, vector3MoreOrLessEquals(Vector3(0.634796, 0.658731, 0)));
      final textureCoord_14_0_214 = textureCoords_14_0.elementAt(214);
      expect(textureCoord_14_0_214, vector3MoreOrLessEquals(Vector3(0.607995, 0.640264, 0)));
      final textureCoord_14_0_215 = textureCoords_14_0.elementAt(215);
      expect(textureCoord_14_0_215, vector3MoreOrLessEquals(Vector3(0.620276, 0.610322, 0)));
      final textureCoord_14_0_216 = textureCoords_14_0.elementAt(216);
      expect(textureCoord_14_0_216, vector3MoreOrLessEquals(Vector3(0.620276, 0.610322, 0)));
      final textureCoord_14_0_217 = textureCoords_14_0.elementAt(217);
      expect(textureCoord_14_0_217, vector3MoreOrLessEquals(Vector3(0.667597, 0.610119, 0)));
      final textureCoord_14_0_218 = textureCoords_14_0.elementAt(218);
      expect(textureCoord_14_0_218, vector3MoreOrLessEquals(Vector3(0.634796, 0.658731, 0)));
      final textureCoord_14_0_219 = textureCoords_14_0.elementAt(219);
      expect(textureCoord_14_0_219, vector3MoreOrLessEquals(Vector3(0.667597, 0.610119, 0)));
      final textureCoord_14_0_220 = textureCoords_14_0.elementAt(220);
      expect(textureCoord_14_0_220, vector3MoreOrLessEquals(Vector3(0.620276, 0.610322, 0)));
      final textureCoord_14_0_221 = textureCoords_14_0.elementAt(221);
      expect(textureCoord_14_0_221, vector3MoreOrLessEquals(Vector3(0.641469, 0.576181, 0)));
      final textureCoord_14_0_222 = textureCoords_14_0.elementAt(222);
      expect(textureCoord_14_0_222, vector3MoreOrLessEquals(Vector3(0.641469, 0.576181, 0)));
      final textureCoord_14_0_223 = textureCoords_14_0.elementAt(223);
      expect(textureCoord_14_0_223, vector3MoreOrLessEquals(Vector3(0.711332, 0.582341, 0)));
      final textureCoord_14_0_224 = textureCoords_14_0.elementAt(224);
      expect(textureCoord_14_0_224, vector3MoreOrLessEquals(Vector3(0.667597, 0.610119, 0)));
      final textureCoord_14_0_225 = textureCoords_14_0.elementAt(225);
      expect(textureCoord_14_0_225, vector3MoreOrLessEquals(Vector3(0.711332, 0.582341, 0)));
      final textureCoord_14_0_226 = textureCoords_14_0.elementAt(226);
      expect(textureCoord_14_0_226, vector3MoreOrLessEquals(Vector3(0.641469, 0.576181, 0)));
      final textureCoord_14_0_227 = textureCoords_14_0.elementAt(227);
      expect(textureCoord_14_0_227, vector3MoreOrLessEquals(Vector3(0.683259, 0.544409, 0)));
      final textureCoord_14_0_228 = textureCoords_14_0.elementAt(228);
      expect(textureCoord_14_0_228, vector3MoreOrLessEquals(Vector3(0.683259, 0.544409, 0)));
      final textureCoord_14_0_229 = textureCoords_14_0.elementAt(229);
      expect(textureCoord_14_0_229, vector3MoreOrLessEquals(Vector3(0.722265, 0.533731, 0)));
      final textureCoord_14_0_230 = textureCoords_14_0.elementAt(230);
      expect(textureCoord_14_0_230, vector3MoreOrLessEquals(Vector3(0.711332, 0.582341, 0)));
      final textureCoord_14_0_231 = textureCoords_14_0.elementAt(231);
      expect(textureCoord_14_0_231, vector3MoreOrLessEquals(Vector3(0.738895, 0.464286, 0)));
      final textureCoord_14_0_232 = textureCoords_14_0.elementAt(232);
      expect(textureCoord_14_0_232, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_233 = textureCoords_14_0.elementAt(233);
      expect(textureCoord_14_0_233, vector3MoreOrLessEquals(Vector3(0.722265, 0.533731, 0)));
      final textureCoord_14_0_234 = textureCoords_14_0.elementAt(234);
      expect(textureCoord_14_0_234, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_235 = textureCoords_14_0.elementAt(235);
      expect(textureCoord_14_0_235, vector3MoreOrLessEquals(Vector3(0.711332, 0.582341, 0)));
      final textureCoord_14_0_236 = textureCoords_14_0.elementAt(236);
      expect(textureCoord_14_0_236, vector3MoreOrLessEquals(Vector3(0.722265, 0.533731, 0)));
      final textureCoord_14_0_237 = textureCoords_14_0.elementAt(237);
      expect(textureCoord_14_0_237, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_238 = textureCoords_14_0.elementAt(238);
      expect(textureCoord_14_0_238, vector3MoreOrLessEquals(Vector3(0.667597, 0.610119, 0)));
      final textureCoord_14_0_239 = textureCoords_14_0.elementAt(239);
      expect(textureCoord_14_0_239, vector3MoreOrLessEquals(Vector3(0.711332, 0.582341, 0)));
      final textureCoord_14_0_240 = textureCoords_14_0.elementAt(240);
      expect(textureCoord_14_0_240, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_241 = textureCoords_14_0.elementAt(241);
      expect(textureCoord_14_0_241, vector3MoreOrLessEquals(Vector3(0.634796, 0.658731, 0)));
      final textureCoord_14_0_242 = textureCoords_14_0.elementAt(242);
      expect(textureCoord_14_0_242, vector3MoreOrLessEquals(Vector3(0.667597, 0.610119, 0)));
      final textureCoord_14_0_243 = textureCoords_14_0.elementAt(243);
      expect(textureCoord_14_0_243, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_244 = textureCoords_14_0.elementAt(244);
      expect(textureCoord_14_0_244, vector3MoreOrLessEquals(Vector3(0.569195, 0.679564, 0)));
      final textureCoord_14_0_245 = textureCoords_14_0.elementAt(245);
      expect(textureCoord_14_0_245, vector3MoreOrLessEquals(Vector3(0.634796, 0.658731, 0)));
      final textureCoord_14_0_246 = textureCoords_14_0.elementAt(246);
      expect(textureCoord_14_0_246, vector3MoreOrLessEquals(Vector3(0.569195, 0.679564, 0)));
      final textureCoord_14_0_247 = textureCoords_14_0.elementAt(247);
      expect(textureCoord_14_0_247, vector3MoreOrLessEquals(Vector3(0.771239, 0.714286, 0)));
      final textureCoord_14_0_248 = textureCoords_14_0.elementAt(248);
      expect(textureCoord_14_0_248, vector3MoreOrLessEquals(Vector3(0.434682, 0.714286, 0)));
      final textureCoord_14_0_249 = textureCoords_14_0.elementAt(249);
      expect(textureCoord_14_0_249, vector3MoreOrLessEquals(Vector3(0.434682, 0.714286, 0)));
      final textureCoord_14_0_250 = textureCoords_14_0.elementAt(250);
      expect(textureCoord_14_0_250, vector3MoreOrLessEquals(Vector3(0.503593, 0.672619, 0)));
      final textureCoord_14_0_251 = textureCoords_14_0.elementAt(251);
      expect(textureCoord_14_0_251, vector3MoreOrLessEquals(Vector3(0.569195, 0.679564, 0)));
      final textureCoord_14_0_252 = textureCoords_14_0.elementAt(252);
      expect(textureCoord_14_0_252, vector3MoreOrLessEquals(Vector3(0.434682, 0.714286, 0)));
      final textureCoord_14_0_253 = textureCoords_14_0.elementAt(253);
      expect(textureCoord_14_0_253, vector3MoreOrLessEquals(Vector3(0.459859, 0.644841, 0)));
      final textureCoord_14_0_254 = textureCoords_14_0.elementAt(254);
      expect(textureCoord_14_0_254, vector3MoreOrLessEquals(Vector3(0.503593, 0.672619, 0)));
      final textureCoord_14_0_255 = textureCoords_14_0.elementAt(255);
      expect(textureCoord_14_0_255, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_256 = textureCoords_14_0.elementAt(256);
      expect(textureCoord_14_0_256, vector3MoreOrLessEquals(Vector3(0.738895, 0.464286, 0)));
      final textureCoord_14_0_257 = textureCoords_14_0.elementAt(257);
      expect(textureCoord_14_0_257, vector3MoreOrLessEquals(Vector3(0.580128, 0.505953, 0)));
      final textureCoord_14_0_258 = textureCoords_14_0.elementAt(258);
      expect(textureCoord_14_0_258, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_259 = textureCoords_14_0.elementAt(259);
      expect(textureCoord_14_0_259, vector3MoreOrLessEquals(Vector3(0.580128, 0.505953, 0)));
      final textureCoord_14_0_260 = textureCoords_14_0.elementAt(260);
      expect(textureCoord_14_0_260, vector3MoreOrLessEquals(Vector3(0.470792, 0.540675, 0)));
      final textureCoord_14_0_261 = textureCoords_14_0.elementAt(261);
      expect(textureCoord_14_0_261, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_262 = textureCoords_14_0.elementAt(262);
      expect(textureCoord_14_0_262, vector3MoreOrLessEquals(Vector3(0.470792, 0.540675, 0)));
      final textureCoord_14_0_263 = textureCoords_14_0.elementAt(263);
      expect(textureCoord_14_0_263, vector3MoreOrLessEquals(Vector3(0.437991, 0.596231, 0)));
      final textureCoord_14_0_264 = textureCoords_14_0.elementAt(264);
      expect(textureCoord_14_0_264, vector3MoreOrLessEquals(Vector3(0.459859, 0.644841, 0)));
      final textureCoord_14_0_265 = textureCoords_14_0.elementAt(265);
      expect(textureCoord_14_0_265, vector3MoreOrLessEquals(Vector3(0.434682, 0.714286, 0)));
      final textureCoord_14_0_266 = textureCoords_14_0.elementAt(266);
      expect(textureCoord_14_0_266, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_267 = textureCoords_14_0.elementAt(267);
      expect(textureCoord_14_0_267, vector3MoreOrLessEquals(Vector3(0.350273, 0.464286, 0)));
      final textureCoord_14_0_268 = textureCoords_14_0.elementAt(268);
      expect(textureCoord_14_0_268, vector3MoreOrLessEquals(Vector3(0.459859, 0.644841, 0)));
      final textureCoord_14_0_269 = textureCoords_14_0.elementAt(269);
      expect(textureCoord_14_0_269, vector3MoreOrLessEquals(Vector3(0.437991, 0.596231, 0)));
      expect(mesh_14.uvComponents.length, equals(1));
      expect(mesh_14.uvComponents, equals([2]));
      expect(mesh_14.faces.length, equals(90));
      expect(mesh_14.bones.length, isZero);
      expect(mesh_14.materialIndex, equals(1));
      expect(mesh_14.name, equals('Kopf2'));
      expect(mesh_14.animMeshes.length, isZero);
      expect(mesh_14.morphingMethod, isZero);
      expect(mesh_14.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_15 = meshes.elementAt(15);
      expect(mesh_15.primitiveTypes, equals(4));
      expect(mesh_15.vertices.length, equals(126));
      final vertex_15_0 = mesh_15.vertices.elementAt(0);
      expect(vertex_15_0, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_1 = mesh_15.vertices.elementAt(1);
      expect(vertex_15_1, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_2 = mesh_15.vertices.elementAt(2);
      expect(vertex_15_2, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_3 = mesh_15.vertices.elementAt(3);
      expect(vertex_15_3, vector3MoreOrLessEquals(Vector3(-61.2658, 8.09919, -16.6681)));
      final vertex_15_4 = mesh_15.vertices.elementAt(4);
      expect(vertex_15_4, vector3MoreOrLessEquals(Vector3(-62.805, 9.77993, -14.0067)));
      final vertex_15_5 = mesh_15.vertices.elementAt(5);
      expect(vertex_15_5, vector3MoreOrLessEquals(Vector3(-61.3147, 6.24925, -14.5029)));
      final vertex_15_6 = mesh_15.vertices.elementAt(6);
      expect(vertex_15_6, vector3MoreOrLessEquals(Vector3(-64.6642, 4.2778, -18.2395)));
      final vertex_15_7 = mesh_15.vertices.elementAt(7);
      expect(vertex_15_7, vector3MoreOrLessEquals(Vector3(-63.7893, 3.57079, -16.4847)));
      final vertex_15_8 = mesh_15.vertices.elementAt(8);
      expect(vertex_15_8, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_9 = mesh_15.vertices.elementAt(9);
      expect(vertex_15_9, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_10 = mesh_15.vertices.elementAt(10);
      expect(vertex_15_10, vector3MoreOrLessEquals(Vector3(-64.6642, 4.2778, -18.2395)));
      final vertex_15_11 = mesh_15.vertices.elementAt(11);
      expect(vertex_15_11, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_12 = mesh_15.vertices.elementAt(12);
      expect(vertex_15_12, vector3MoreOrLessEquals(Vector3(-64.6642, 4.2778, -18.2395)));
      final vertex_15_13 = mesh_15.vertices.elementAt(13);
      expect(vertex_15_13, vector3MoreOrLessEquals(Vector3(-61.3147, 6.24925, -14.5029)));
      final vertex_15_14 = mesh_15.vertices.elementAt(14);
      expect(vertex_15_14, vector3MoreOrLessEquals(Vector3(-63.7893, 3.57079, -16.4847)));
      final vertex_15_15 = mesh_15.vertices.elementAt(15);
      expect(vertex_15_15, vector3MoreOrLessEquals(Vector3(-64.6642, 4.2778, -18.2395)));
      final vertex_15_16 = mesh_15.vertices.elementAt(16);
      expect(vertex_15_16, vector3MoreOrLessEquals(Vector3(-61.2658, 8.09919, -16.6681)));
      final vertex_15_17 = mesh_15.vertices.elementAt(17);
      expect(vertex_15_17, vector3MoreOrLessEquals(Vector3(-61.3147, 6.24925, -14.5029)));
      final vertex_15_18 = mesh_15.vertices.elementAt(18);
      expect(vertex_15_18, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_19 = mesh_15.vertices.elementAt(19);
      expect(vertex_15_19, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_20 = mesh_15.vertices.elementAt(20);
      expect(vertex_15_20, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_21 = mesh_15.vertices.elementAt(21);
      expect(vertex_15_21, vector3MoreOrLessEquals(Vector3(-62.376, 11.2147, -16.8292)));
      final vertex_15_22 = mesh_15.vertices.elementAt(22);
      expect(vertex_15_22, vector3MoreOrLessEquals(Vector3(-62.805, 9.77993, -14.0067)));
      final vertex_15_23 = mesh_15.vertices.elementAt(23);
      expect(vertex_15_23, vector3MoreOrLessEquals(Vector3(-61.2658, 8.09919, -16.6681)));
      final vertex_15_24 = mesh_15.vertices.elementAt(24);
      expect(vertex_15_24, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_25 = mesh_15.vertices.elementAt(25);
      expect(vertex_15_25, vector3MoreOrLessEquals(Vector3(-64.6642, 4.2778, -18.2395)));
      final vertex_15_26 = mesh_15.vertices.elementAt(26);
      expect(vertex_15_26, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_27 = mesh_15.vertices.elementAt(27);
      expect(vertex_15_27, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_28 = mesh_15.vertices.elementAt(28);
      expect(vertex_15_28, vector3MoreOrLessEquals(Vector3(-66.9553, 4.53118, -18.784)));
      final vertex_15_29 = mesh_15.vertices.elementAt(29);
      expect(vertex_15_29, vector3MoreOrLessEquals(Vector3(-64.6642, 4.2778, -18.2395)));
      final vertex_15_30 = mesh_15.vertices.elementAt(30);
      expect(vertex_15_30, vector3MoreOrLessEquals(Vector3(-62.376, 11.2147, -16.8292)));
      final vertex_15_31 = mesh_15.vertices.elementAt(31);
      expect(vertex_15_31, vector3MoreOrLessEquals(Vector3(-61.2658, 8.09919, -16.6681)));
      final vertex_15_32 = mesh_15.vertices.elementAt(32);
      expect(vertex_15_32, vector3MoreOrLessEquals(Vector3(-64.6642, 4.2778, -18.2395)));
      final vertex_15_33 = mesh_15.vertices.elementAt(33);
      expect(vertex_15_33, vector3MoreOrLessEquals(Vector3(-66.9553, 4.53118, -18.784)));
      final vertex_15_34 = mesh_15.vertices.elementAt(34);
      expect(vertex_15_34, vector3MoreOrLessEquals(Vector3(-62.376, 11.2147, -16.8292)));
      final vertex_15_35 = mesh_15.vertices.elementAt(35);
      expect(vertex_15_35, vector3MoreOrLessEquals(Vector3(-64.6642, 4.2778, -18.2395)));
      final vertex_15_36 = mesh_15.vertices.elementAt(36);
      expect(vertex_15_36, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_37 = mesh_15.vertices.elementAt(37);
      expect(vertex_15_37, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_38 = mesh_15.vertices.elementAt(38);
      expect(vertex_15_38, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_39 = mesh_15.vertices.elementAt(39);
      expect(vertex_15_39, vector3MoreOrLessEquals(Vector3(-63.8093, 13.2499, -14.8649)));
      final vertex_15_40 = mesh_15.vertices.elementAt(40);
      expect(vertex_15_40, vector3MoreOrLessEquals(Vector3(-62.805, 9.77993, -14.0067)));
      final vertex_15_41 = mesh_15.vertices.elementAt(41);
      expect(vertex_15_41, vector3MoreOrLessEquals(Vector3(-62.376, 11.2147, -16.8292)));
      final vertex_15_42 = mesh_15.vertices.elementAt(42);
      expect(vertex_15_42, vector3MoreOrLessEquals(Vector3(-68.9374, 4.14017, -17.7081)));
      final vertex_15_43 = mesh_15.vertices.elementAt(43);
      expect(vertex_15_43, vector3MoreOrLessEquals(Vector3(-66.9553, 4.53118, -18.784)));
      final vertex_15_44 = mesh_15.vertices.elementAt(44);
      expect(vertex_15_44, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_45 = mesh_15.vertices.elementAt(45);
      expect(vertex_15_45, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_46 = mesh_15.vertices.elementAt(46);
      expect(vertex_15_46, vector3MoreOrLessEquals(Vector3(-68.9374, 4.14017, -17.7081)));
      final vertex_15_47 = mesh_15.vertices.elementAt(47);
      expect(vertex_15_47, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_48 = mesh_15.vertices.elementAt(48);
      expect(vertex_15_48, vector3MoreOrLessEquals(Vector3(-68.9374, 4.14017, -17.7081)));
      final vertex_15_49 = mesh_15.vertices.elementAt(49);
      expect(vertex_15_49, vector3MoreOrLessEquals(Vector3(-62.376, 11.2147, -16.8292)));
      final vertex_15_50 = mesh_15.vertices.elementAt(50);
      expect(vertex_15_50, vector3MoreOrLessEquals(Vector3(-66.9553, 4.53118, -18.784)));
      final vertex_15_51 = mesh_15.vertices.elementAt(51);
      expect(vertex_15_51, vector3MoreOrLessEquals(Vector3(-68.9374, 4.14017, -17.7081)));
      final vertex_15_52 = mesh_15.vertices.elementAt(52);
      expect(vertex_15_52, vector3MoreOrLessEquals(Vector3(-63.8093, 13.2499, -14.8649)));
      final vertex_15_53 = mesh_15.vertices.elementAt(53);
      expect(vertex_15_53, vector3MoreOrLessEquals(Vector3(-62.376, 11.2147, -16.8292)));
      final vertex_15_54 = mesh_15.vertices.elementAt(54);
      expect(vertex_15_54, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_55 = mesh_15.vertices.elementAt(55);
      expect(vertex_15_55, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_56 = mesh_15.vertices.elementAt(56);
      expect(vertex_15_56, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_57 = mesh_15.vertices.elementAt(57);
      expect(vertex_15_57, vector3MoreOrLessEquals(Vector3(-64.4864, 12.6721, -12.2543)));
      final vertex_15_58 = mesh_15.vertices.elementAt(58);
      expect(vertex_15_58, vector3MoreOrLessEquals(Vector3(-62.805, 9.77993, -14.0067)));
      final vertex_15_59 = mesh_15.vertices.elementAt(59);
      expect(vertex_15_59, vector3MoreOrLessEquals(Vector3(-63.8093, 13.2499, -14.8649)));
      final vertex_15_60 = mesh_15.vertices.elementAt(60);
      expect(vertex_15_60, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_61 = mesh_15.vertices.elementAt(61);
      expect(vertex_15_61, vector3MoreOrLessEquals(Vector3(-68.9374, 4.14017, -17.7081)));
      final vertex_15_62 = mesh_15.vertices.elementAt(62);
      expect(vertex_15_62, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_63 = mesh_15.vertices.elementAt(63);
      expect(vertex_15_63, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_64 = mesh_15.vertices.elementAt(64);
      expect(vertex_15_64, vector3MoreOrLessEquals(Vector3(-69.118, 3.39922, -15.822)));
      final vertex_15_65 = mesh_15.vertices.elementAt(65);
      expect(vertex_15_65, vector3MoreOrLessEquals(Vector3(-68.9374, 4.14017, -17.7081)));
      final vertex_15_66 = mesh_15.vertices.elementAt(66);
      expect(vertex_15_66, vector3MoreOrLessEquals(Vector3(-64.4864, 12.6721, -12.2543)));
      final vertex_15_67 = mesh_15.vertices.elementAt(67);
      expect(vertex_15_67, vector3MoreOrLessEquals(Vector3(-63.8093, 13.2499, -14.8649)));
      final vertex_15_68 = mesh_15.vertices.elementAt(68);
      expect(vertex_15_68, vector3MoreOrLessEquals(Vector3(-68.9374, 4.14017, -17.7081)));
      final vertex_15_69 = mesh_15.vertices.elementAt(69);
      expect(vertex_15_69, vector3MoreOrLessEquals(Vector3(-69.118, 3.39922, -15.822)));
      final vertex_15_70 = mesh_15.vertices.elementAt(70);
      expect(vertex_15_70, vector3MoreOrLessEquals(Vector3(-64.4864, 12.6721, -12.2543)));
      final vertex_15_71 = mesh_15.vertices.elementAt(71);
      expect(vertex_15_71, vector3MoreOrLessEquals(Vector3(-68.9374, 4.14017, -17.7081)));
      final vertex_15_72 = mesh_15.vertices.elementAt(72);
      expect(vertex_15_72, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_73 = mesh_15.vertices.elementAt(73);
      expect(vertex_15_73, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_74 = mesh_15.vertices.elementAt(74);
      expect(vertex_15_74, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_75 = mesh_15.vertices.elementAt(75);
      expect(vertex_15_75, vector3MoreOrLessEquals(Vector3(-63.8974, 9.91648, -10.9633)));
      final vertex_15_76 = mesh_15.vertices.elementAt(76);
      expect(vertex_15_76, vector3MoreOrLessEquals(Vector3(-62.805, 9.77993, -14.0067)));
      final vertex_15_77 = mesh_15.vertices.elementAt(77);
      expect(vertex_15_77, vector3MoreOrLessEquals(Vector3(-64.4864, 12.6721, -12.2543)));
      final vertex_15_78 = mesh_15.vertices.elementAt(78);
      expect(vertex_15_78, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_79 = mesh_15.vertices.elementAt(79);
      expect(vertex_15_79, vector3MoreOrLessEquals(Vector3(-69.118, 3.39922, -15.822)));
      final vertex_15_80 = mesh_15.vertices.elementAt(80);
      expect(vertex_15_80, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_81 = mesh_15.vertices.elementAt(81);
      expect(vertex_15_81, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_82 = mesh_15.vertices.elementAt(82);
      expect(vertex_15_82, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_83 = mesh_15.vertices.elementAt(83);
      expect(vertex_15_83, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_84 = mesh_15.vertices.elementAt(84);
      expect(vertex_15_84, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_85 = mesh_15.vertices.elementAt(85);
      expect(vertex_15_85, vector3MoreOrLessEquals(Vector3(-64.4864, 12.6721, -12.2543)));
      final vertex_15_86 = mesh_15.vertices.elementAt(86);
      expect(vertex_15_86, vector3MoreOrLessEquals(Vector3(-69.118, 3.39922, -15.822)));
      final vertex_15_87 = mesh_15.vertices.elementAt(87);
      expect(vertex_15_87, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_88 = mesh_15.vertices.elementAt(88);
      expect(vertex_15_88, vector3MoreOrLessEquals(Vector3(-63.8974, 9.91648, -10.9633)));
      final vertex_15_89 = mesh_15.vertices.elementAt(89);
      expect(vertex_15_89, vector3MoreOrLessEquals(Vector3(-64.4864, 12.6721, -12.2543)));
      final vertex_15_90 = mesh_15.vertices.elementAt(90);
      expect(vertex_15_90, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_91 = mesh_15.vertices.elementAt(91);
      expect(vertex_15_91, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_92 = mesh_15.vertices.elementAt(92);
      expect(vertex_15_92, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_93 = mesh_15.vertices.elementAt(93);
      expect(vertex_15_93, vector3MoreOrLessEquals(Vector3(-62.4859, 7.05807, -11.964)));
      final vertex_15_94 = mesh_15.vertices.elementAt(94);
      expect(vertex_15_94, vector3MoreOrLessEquals(Vector3(-62.805, 9.77993, -14.0067)));
      final vertex_15_95 = mesh_15.vertices.elementAt(95);
      expect(vertex_15_95, vector3MoreOrLessEquals(Vector3(-63.8974, 9.91648, -10.9633)));
      final vertex_15_96 = mesh_15.vertices.elementAt(96);
      expect(vertex_15_96, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_97 = mesh_15.vertices.elementAt(97);
      expect(vertex_15_97, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_98 = mesh_15.vertices.elementAt(98);
      expect(vertex_15_98, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_99 = mesh_15.vertices.elementAt(99);
      expect(vertex_15_99, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_100 = mesh_15.vertices.elementAt(100);
      expect(vertex_15_100, vector3MoreOrLessEquals(Vector3(-64.9896, 2.9426, -14.8409)));
      final vertex_15_101 = mesh_15.vertices.elementAt(101);
      expect(vertex_15_101, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_102 = mesh_15.vertices.elementAt(102);
      expect(vertex_15_102, vector3MoreOrLessEquals(Vector3(-62.4859, 7.05807, -11.964)));
      final vertex_15_103 = mesh_15.vertices.elementAt(103);
      expect(vertex_15_103, vector3MoreOrLessEquals(Vector3(-63.8974, 9.91648, -10.9633)));
      final vertex_15_104 = mesh_15.vertices.elementAt(104);
      expect(vertex_15_104, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_105 = mesh_15.vertices.elementAt(105);
      expect(vertex_15_105, vector3MoreOrLessEquals(Vector3(-64.9896, 2.9426, -14.8409)));
      final vertex_15_106 = mesh_15.vertices.elementAt(106);
      expect(vertex_15_106, vector3MoreOrLessEquals(Vector3(-62.4859, 7.05807, -11.964)));
      final vertex_15_107 = mesh_15.vertices.elementAt(107);
      expect(vertex_15_107, vector3MoreOrLessEquals(Vector3(-67.3612, 2.86621, -14.546)));
      final vertex_15_108 = mesh_15.vertices.elementAt(108);
      expect(vertex_15_108, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_109 = mesh_15.vertices.elementAt(109);
      expect(vertex_15_109, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_110 = mesh_15.vertices.elementAt(110);
      expect(vertex_15_110, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_111 = mesh_15.vertices.elementAt(111);
      expect(vertex_15_111, vector3MoreOrLessEquals(Vector3(-61.3147, 6.24925, -14.5029)));
      final vertex_15_112 = mesh_15.vertices.elementAt(112);
      expect(vertex_15_112, vector3MoreOrLessEquals(Vector3(-62.805, 9.77993, -14.0067)));
      final vertex_15_113 = mesh_15.vertices.elementAt(113);
      expect(vertex_15_113, vector3MoreOrLessEquals(Vector3(-62.4859, 7.05807, -11.964)));
      final vertex_15_114 = mesh_15.vertices.elementAt(114);
      expect(vertex_15_114, vector3MoreOrLessEquals(Vector3(-63.7893, 3.57079, -16.4847)));
      final vertex_15_115 = mesh_15.vertices.elementAt(115);
      expect(vertex_15_115, vector3MoreOrLessEquals(Vector3(-64.9896, 2.9426, -14.8409)));
      final vertex_15_116 = mesh_15.vertices.elementAt(116);
      expect(vertex_15_116, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_117 = mesh_15.vertices.elementAt(117);
      expect(vertex_15_117, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_118 = mesh_15.vertices.elementAt(118);
      expect(vertex_15_118, vector3MoreOrLessEquals(Vector3(-63.7893, 3.57079, -16.4847)));
      final vertex_15_119 = mesh_15.vertices.elementAt(119);
      expect(vertex_15_119, vector3MoreOrLessEquals(Vector3(-66.5912, -11.9765, -20.1122)));
      final vertex_15_120 = mesh_15.vertices.elementAt(120);
      expect(vertex_15_120, vector3MoreOrLessEquals(Vector3(-63.7893, 3.57079, -16.4847)));
      final vertex_15_121 = mesh_15.vertices.elementAt(121);
      expect(vertex_15_121, vector3MoreOrLessEquals(Vector3(-62.4859, 7.05807, -11.964)));
      final vertex_15_122 = mesh_15.vertices.elementAt(122);
      expect(vertex_15_122, vector3MoreOrLessEquals(Vector3(-64.9896, 2.9426, -14.8409)));
      final vertex_15_123 = mesh_15.vertices.elementAt(123);
      expect(vertex_15_123, vector3MoreOrLessEquals(Vector3(-63.7893, 3.57079, -16.4847)));
      final vertex_15_124 = mesh_15.vertices.elementAt(124);
      expect(vertex_15_124, vector3MoreOrLessEquals(Vector3(-61.3147, 6.24925, -14.5029)));
      final vertex_15_125 = mesh_15.vertices.elementAt(125);
      expect(vertex_15_125, vector3MoreOrLessEquals(Vector3(-62.4859, 7.05807, -11.964)));
      expect(mesh_15.normals.length, equals(126));
      final normal_15_0 = mesh_15.normals.elementAt(0);
      expect(normal_15_0, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_1 = mesh_15.normals.elementAt(1);
      expect(normal_15_1, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_2 = mesh_15.normals.elementAt(2);
      expect(normal_15_2, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_3 = mesh_15.normals.elementAt(3);
      expect(normal_15_3, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_4 = mesh_15.normals.elementAt(4);
      expect(normal_15_4, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_5 = mesh_15.normals.elementAt(5);
      expect(normal_15_5, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_6 = mesh_15.normals.elementAt(6);
      expect(normal_15_6, vector3MoreOrLessEquals(Vector3(0.602535, -0.114021, -0.789905)));
      final normal_15_7 = mesh_15.normals.elementAt(7);
      expect(normal_15_7, vector3MoreOrLessEquals(Vector3(0.871702, -0.486402, 0.059575)));
      final normal_15_8 = mesh_15.normals.elementAt(8);
      expect(normal_15_8, vector3MoreOrLessEquals(Vector3(0.885285, -0.051707, -0.462165)));
      final normal_15_9 = mesh_15.normals.elementAt(9);
      expect(normal_15_9, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_10 = mesh_15.normals.elementAt(10);
      expect(normal_15_10, vector3MoreOrLessEquals(Vector3(0.602535, -0.114021, -0.789905)));
      final normal_15_11 = mesh_15.normals.elementAt(11);
      expect(normal_15_11, vector3MoreOrLessEquals(Vector3(0.885285, -0.051707, -0.462165)));
      final normal_15_12 = mesh_15.normals.elementAt(12);
      expect(normal_15_12, vector3MoreOrLessEquals(Vector3(0.602535, -0.114021, -0.789905)));
      final normal_15_13 = mesh_15.normals.elementAt(13);
      expect(normal_15_13, vector3MoreOrLessEquals(Vector3(0.767335, -0.613875, -0.185352)));
      final normal_15_14 = mesh_15.normals.elementAt(14);
      expect(normal_15_14, vector3MoreOrLessEquals(Vector3(0.871702, -0.486402, 0.059575)));
      final normal_15_15 = mesh_15.normals.elementAt(15);
      expect(normal_15_15, vector3MoreOrLessEquals(Vector3(0.602535, -0.114021, -0.789905)));
      final normal_15_16 = mesh_15.normals.elementAt(16);
      expect(normal_15_16, vector3MoreOrLessEquals(Vector3(0.615706, -0.238765, -0.750931)));
      final normal_15_17 = mesh_15.normals.elementAt(17);
      expect(normal_15_17, vector3MoreOrLessEquals(Vector3(0.767335, -0.613875, -0.185352)));
      final normal_15_18 = mesh_15.normals.elementAt(18);
      expect(normal_15_18, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_19 = mesh_15.normals.elementAt(19);
      expect(normal_15_19, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_20 = mesh_15.normals.elementAt(20);
      expect(normal_15_20, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_21 = mesh_15.normals.elementAt(21);
      expect(normal_15_21, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_22 = mesh_15.normals.elementAt(22);
      expect(normal_15_22, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_23 = mesh_15.normals.elementAt(23);
      expect(normal_15_23, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_24 = mesh_15.normals.elementAt(24);
      expect(normal_15_24, vector3MoreOrLessEquals(Vector3(-0.132228, 0.076598, -0.988255)));
      final normal_15_25 = mesh_15.normals.elementAt(25);
      expect(normal_15_25, vector3MoreOrLessEquals(Vector3(0.602535, -0.114021, -0.789905)));
      final normal_15_26 = mesh_15.normals.elementAt(26);
      expect(normal_15_26, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_27 = mesh_15.normals.elementAt(27);
      expect(normal_15_27, vector3MoreOrLessEquals(Vector3(-0.132228, 0.076598, -0.988255)));
      final normal_15_28 = mesh_15.normals.elementAt(28);
      expect(normal_15_28, vector3MoreOrLessEquals(Vector3(-0.134482, 0.218923, -0.96643)));
      final normal_15_29 = mesh_15.normals.elementAt(29);
      expect(normal_15_29, vector3MoreOrLessEquals(Vector3(0.602535, -0.114021, -0.789905)));
      final normal_15_30 = mesh_15.normals.elementAt(30);
      expect(normal_15_30, vector3MoreOrLessEquals(Vector3(-0.082654, 0.333036, -0.939284)));
      final normal_15_31 = mesh_15.normals.elementAt(31);
      expect(normal_15_31, vector3MoreOrLessEquals(Vector3(0.615706, -0.238765, -0.750931)));
      final normal_15_32 = mesh_15.normals.elementAt(32);
      expect(normal_15_32, vector3MoreOrLessEquals(Vector3(0.602535, -0.114021, -0.789905)));
      final normal_15_33 = mesh_15.normals.elementAt(33);
      expect(normal_15_33, vector3MoreOrLessEquals(Vector3(-0.134482, 0.218923, -0.96643)));
      final normal_15_34 = mesh_15.normals.elementAt(34);
      expect(normal_15_34, vector3MoreOrLessEquals(Vector3(-0.082654, 0.333036, -0.939284)));
      final normal_15_35 = mesh_15.normals.elementAt(35);
      expect(normal_15_35, vector3MoreOrLessEquals(Vector3(0.602535, -0.114021, -0.789905)));
      final normal_15_36 = mesh_15.normals.elementAt(36);
      expect(normal_15_36, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_37 = mesh_15.normals.elementAt(37);
      expect(normal_15_37, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_38 = mesh_15.normals.elementAt(38);
      expect(normal_15_38, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_39 = mesh_15.normals.elementAt(39);
      expect(normal_15_39, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_40 = mesh_15.normals.elementAt(40);
      expect(normal_15_40, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_41 = mesh_15.normals.elementAt(41);
      expect(normal_15_41, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_42 = mesh_15.normals.elementAt(42);
      expect(normal_15_42, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, -0.487325)));
      final normal_15_43 = mesh_15.normals.elementAt(43);
      expect(normal_15_43, vector3MoreOrLessEquals(Vector3(-0.134482, 0.218923, -0.96643)));
      final normal_15_44 = mesh_15.normals.elementAt(44);
      expect(normal_15_44, vector3MoreOrLessEquals(Vector3(-0.132228, 0.076598, -0.988255)));
      final normal_15_45 = mesh_15.normals.elementAt(45);
      expect(normal_15_45, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_46 = mesh_15.normals.elementAt(46);
      expect(normal_15_46, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, -0.487325)));
      final normal_15_47 = mesh_15.normals.elementAt(47);
      expect(normal_15_47, vector3MoreOrLessEquals(Vector3(-0.132228, 0.076598, -0.988255)));
      final normal_15_48 = mesh_15.normals.elementAt(48);
      expect(normal_15_48, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, -0.487325)));
      final normal_15_49 = mesh_15.normals.elementAt(49);
      expect(normal_15_49, vector3MoreOrLessEquals(Vector3(-0.082654, 0.333036, -0.939284)));
      final normal_15_50 = mesh_15.normals.elementAt(50);
      expect(normal_15_50, vector3MoreOrLessEquals(Vector3(-0.134482, 0.218923, -0.96643)));
      final normal_15_51 = mesh_15.normals.elementAt(51);
      expect(normal_15_51, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, -0.487325)));
      final normal_15_52 = mesh_15.normals.elementAt(52);
      expect(normal_15_52, vector3MoreOrLessEquals(Vector3(-0.686973, 0.538875, -0.487526)));
      final normal_15_53 = mesh_15.normals.elementAt(53);
      expect(normal_15_53, vector3MoreOrLessEquals(Vector3(-0.082654, 0.333036, -0.939284)));
      final normal_15_54 = mesh_15.normals.elementAt(54);
      expect(normal_15_54, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_55 = mesh_15.normals.elementAt(55);
      expect(normal_15_55, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_56 = mesh_15.normals.elementAt(56);
      expect(normal_15_56, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_57 = mesh_15.normals.elementAt(57);
      expect(normal_15_57, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_58 = mesh_15.normals.elementAt(58);
      expect(normal_15_58, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_59 = mesh_15.normals.elementAt(59);
      expect(normal_15_59, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_60 = mesh_15.normals.elementAt(60);
      expect(normal_15_60, vector3MoreOrLessEquals(Vector3(-0.911656, -0.242414, 0.33184)));
      final normal_15_61 = mesh_15.normals.elementAt(61);
      expect(normal_15_61, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, -0.487325)));
      final normal_15_62 = mesh_15.normals.elementAt(62);
      expect(normal_15_62, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_63 = mesh_15.normals.elementAt(63);
      expect(normal_15_63, vector3MoreOrLessEquals(Vector3(-0.911656, -0.242414, 0.33184)));
      final normal_15_64 = mesh_15.normals.elementAt(64);
      expect(normal_15_64, vector3MoreOrLessEquals(Vector3(-0.90347, -0.005854, 0.428611)));
      final normal_15_65 = mesh_15.normals.elementAt(65);
      expect(normal_15_65, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, -0.487325)));
      final normal_15_66 = mesh_15.normals.elementAt(66);
      expect(normal_15_66, vector3MoreOrLessEquals(Vector3(-0.880207, 0.284493, 0.379868)));
      final normal_15_67 = mesh_15.normals.elementAt(67);
      expect(normal_15_67, vector3MoreOrLessEquals(Vector3(-0.686973, 0.538875, -0.487526)));
      final normal_15_68 = mesh_15.normals.elementAt(68);
      expect(normal_15_68, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, -0.487325)));
      final normal_15_69 = mesh_15.normals.elementAt(69);
      expect(normal_15_69, vector3MoreOrLessEquals(Vector3(-0.90347, -0.005854, 0.428611)));
      final normal_15_70 = mesh_15.normals.elementAt(70);
      expect(normal_15_70, vector3MoreOrLessEquals(Vector3(-0.880207, 0.284493, 0.379868)));
      final normal_15_71 = mesh_15.normals.elementAt(71);
      expect(normal_15_71, vector3MoreOrLessEquals(Vector3(-0.794263, 0.362851, -0.487325)));
      final normal_15_72 = mesh_15.normals.elementAt(72);
      expect(normal_15_72, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_73 = mesh_15.normals.elementAt(73);
      expect(normal_15_73, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_74 = mesh_15.normals.elementAt(74);
      expect(normal_15_74, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_75 = mesh_15.normals.elementAt(75);
      expect(normal_15_75, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_76 = mesh_15.normals.elementAt(76);
      expect(normal_15_76, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_77 = mesh_15.normals.elementAt(77);
      expect(normal_15_77, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_78 = mesh_15.normals.elementAt(78);
      expect(normal_15_78, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, 0.885991)));
      final normal_15_79 = mesh_15.normals.elementAt(79);
      expect(normal_15_79, vector3MoreOrLessEquals(Vector3(-0.90347, -0.005854, 0.428611)));
      final normal_15_80 = mesh_15.normals.elementAt(80);
      expect(normal_15_80, vector3MoreOrLessEquals(Vector3(-0.911656, -0.242414, 0.33184)));
      final normal_15_81 = mesh_15.normals.elementAt(81);
      expect(normal_15_81, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_82 = mesh_15.normals.elementAt(82);
      expect(normal_15_82, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, 0.885991)));
      final normal_15_83 = mesh_15.normals.elementAt(83);
      expect(normal_15_83, vector3MoreOrLessEquals(Vector3(-0.911656, -0.242414, 0.33184)));
      final normal_15_84 = mesh_15.normals.elementAt(84);
      expect(normal_15_84, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, 0.885991)));
      final normal_15_85 = mesh_15.normals.elementAt(85);
      expect(normal_15_85, vector3MoreOrLessEquals(Vector3(-0.880207, 0.284493, 0.379868)));
      final normal_15_86 = mesh_15.normals.elementAt(86);
      expect(normal_15_86, vector3MoreOrLessEquals(Vector3(-0.90347, -0.005854, 0.428611)));
      final normal_15_87 = mesh_15.normals.elementAt(87);
      expect(normal_15_87, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, 0.885991)));
      final normal_15_88 = mesh_15.normals.elementAt(88);
      expect(normal_15_88, vector3MoreOrLessEquals(Vector3(-0.531215, -0.16165, 0.831673)));
      final normal_15_89 = mesh_15.normals.elementAt(89);
      expect(normal_15_89, vector3MoreOrLessEquals(Vector3(-0.880207, 0.284493, 0.379868)));
      final normal_15_90 = mesh_15.normals.elementAt(90);
      expect(normal_15_90, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_91 = mesh_15.normals.elementAt(91);
      expect(normal_15_91, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_92 = mesh_15.normals.elementAt(92);
      expect(normal_15_92, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_93 = mesh_15.normals.elementAt(93);
      expect(normal_15_93, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_94 = mesh_15.normals.elementAt(94);
      expect(normal_15_94, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_95 = mesh_15.normals.elementAt(95);
      expect(normal_15_95, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_96 = mesh_15.normals.elementAt(96);
      expect(normal_15_96, vector3MoreOrLessEquals(Vector3(0.521709, -0.333452, 0.785258)));
      final normal_15_97 = mesh_15.normals.elementAt(97);
      expect(normal_15_97, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, 0.885991)));
      final normal_15_98 = mesh_15.normals.elementAt(98);
      expect(normal_15_98, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_99 = mesh_15.normals.elementAt(99);
      expect(normal_15_99, vector3MoreOrLessEquals(Vector3(0.521709, -0.333452, 0.785258)));
      final normal_15_100 = mesh_15.normals.elementAt(100);
      expect(normal_15_100, vector3MoreOrLessEquals(Vector3(0.498223, -0.518212, 0.695148)));
      final normal_15_101 = mesh_15.normals.elementAt(101);
      expect(normal_15_101, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, 0.885991)));
      final normal_15_102 = mesh_15.normals.elementAt(102);
      expect(normal_15_102, vector3MoreOrLessEquals(Vector3(0.319253, -0.666929, 0.673264)));
      final normal_15_103 = mesh_15.normals.elementAt(103);
      expect(normal_15_103, vector3MoreOrLessEquals(Vector3(-0.531215, -0.16165, 0.831673)));
      final normal_15_104 = mesh_15.normals.elementAt(104);
      expect(normal_15_104, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, 0.885991)));
      final normal_15_105 = mesh_15.normals.elementAt(105);
      expect(normal_15_105, vector3MoreOrLessEquals(Vector3(0.498223, -0.518212, 0.695148)));
      final normal_15_106 = mesh_15.normals.elementAt(106);
      expect(normal_15_106, vector3MoreOrLessEquals(Vector3(0.319253, -0.666929, 0.673264)));
      final normal_15_107 = mesh_15.normals.elementAt(107);
      expect(normal_15_107, vector3MoreOrLessEquals(Vector3(-0.359072, -0.293407, 0.885991)));
      final normal_15_108 = mesh_15.normals.elementAt(108);
      expect(normal_15_108, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_109 = mesh_15.normals.elementAt(109);
      expect(normal_15_109, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_110 = mesh_15.normals.elementAt(110);
      expect(normal_15_110, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_15_111 = mesh_15.normals.elementAt(111);
      expect(normal_15_111, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_112 = mesh_15.normals.elementAt(112);
      expect(normal_15_112, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_113 = mesh_15.normals.elementAt(113);
      expect(normal_15_113, vector3MoreOrLessEquals(Vector3(0.891944, 0.333618, 0.305179)));
      final normal_15_114 = mesh_15.normals.elementAt(114);
      expect(normal_15_114, vector3MoreOrLessEquals(Vector3(0.871702, -0.486402, 0.059575)));
      final normal_15_115 = mesh_15.normals.elementAt(115);
      expect(normal_15_115, vector3MoreOrLessEquals(Vector3(0.498223, -0.518212, 0.695148)));
      final normal_15_116 = mesh_15.normals.elementAt(116);
      expect(normal_15_116, vector3MoreOrLessEquals(Vector3(0.521709, -0.333452, 0.785258)));
      final normal_15_117 = mesh_15.normals.elementAt(117);
      expect(normal_15_117, vector3MoreOrLessEquals(Vector3(0.885285, -0.051707, -0.462165)));
      final normal_15_118 = mesh_15.normals.elementAt(118);
      expect(normal_15_118, vector3MoreOrLessEquals(Vector3(0.871702, -0.486402, 0.059575)));
      final normal_15_119 = mesh_15.normals.elementAt(119);
      expect(normal_15_119, vector3MoreOrLessEquals(Vector3(0.521709, -0.333452, 0.785258)));
      final normal_15_120 = mesh_15.normals.elementAt(120);
      expect(normal_15_120, vector3MoreOrLessEquals(Vector3(0.871702, -0.486402, 0.059575)));
      final normal_15_121 = mesh_15.normals.elementAt(121);
      expect(normal_15_121, vector3MoreOrLessEquals(Vector3(0.319253, -0.666929, 0.673264)));
      final normal_15_122 = mesh_15.normals.elementAt(122);
      expect(normal_15_122, vector3MoreOrLessEquals(Vector3(0.498223, -0.518212, 0.695148)));
      final normal_15_123 = mesh_15.normals.elementAt(123);
      expect(normal_15_123, vector3MoreOrLessEquals(Vector3(0.871702, -0.486402, 0.059575)));
      final normal_15_124 = mesh_15.normals.elementAt(124);
      expect(normal_15_124, vector3MoreOrLessEquals(Vector3(0.767335, -0.613875, -0.185352)));
      final normal_15_125 = mesh_15.normals.elementAt(125);
      expect(normal_15_125, vector3MoreOrLessEquals(Vector3(0.319253, -0.666929, 0.673264)));
      expect(mesh_15.tangents.length, isZero);
      expect(mesh_15.bitangents.length, isZero);
      expect(mesh_15.colors.length, isZero);
      expect(mesh_15.textureCoords.length, equals(1));
      final textureCoords_15_0 = mesh_15.textureCoords.elementAt(0);
      expect(textureCoords_15_0.length, equals(126));
      final textureCoord_15_0_0 = textureCoords_15_0.elementAt(0);
      expect(textureCoord_15_0_0, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_1 = textureCoords_15_0.elementAt(1);
      expect(textureCoord_15_0_1, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_2 = textureCoords_15_0.elementAt(2);
      expect(textureCoord_15_0_2, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_3 = textureCoords_15_0.elementAt(3);
      expect(textureCoord_15_0_3, vector3MoreOrLessEquals(Vector3(0.402899, 0.410469, 0)));
      final textureCoord_15_0_4 = textureCoords_15_0.elementAt(4);
      expect(textureCoord_15_0_4, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_15_0_5 = textureCoords_15_0.elementAt(5);
      expect(textureCoord_15_0_5, vector3MoreOrLessEquals(Vector3(0.446895, 0.397773, 0)));
      final textureCoord_15_0_6 = textureCoords_15_0.elementAt(6);
      expect(textureCoord_15_0_6, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_15_0_7 = textureCoords_15_0.elementAt(7);
      expect(textureCoord_15_0_7, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_15_0_8 = textureCoords_15_0.elementAt(8);
      expect(textureCoord_15_0_8, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_9 = textureCoords_15_0.elementAt(9);
      expect(textureCoord_15_0_9, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_10 = textureCoords_15_0.elementAt(10);
      expect(textureCoord_15_0_10, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_15_0_11 = textureCoords_15_0.elementAt(11);
      expect(textureCoord_15_0_11, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_12 = textureCoords_15_0.elementAt(12);
      expect(textureCoord_15_0_12, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_15_0_13 = textureCoords_15_0.elementAt(13);
      expect(textureCoord_15_0_13, vector3MoreOrLessEquals(Vector3(0.446895, 0.397773, 0)));
      final textureCoord_15_0_14 = textureCoords_15_0.elementAt(14);
      expect(textureCoord_15_0_14, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_15_0_15 = textureCoords_15_0.elementAt(15);
      expect(textureCoord_15_0_15, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_15_0_16 = textureCoords_15_0.elementAt(16);
      expect(textureCoord_15_0_16, vector3MoreOrLessEquals(Vector3(0.402899, 0.410469, 0)));
      final textureCoord_15_0_17 = textureCoords_15_0.elementAt(17);
      expect(textureCoord_15_0_17, vector3MoreOrLessEquals(Vector3(0.446895, 0.397773, 0)));
      final textureCoord_15_0_18 = textureCoords_15_0.elementAt(18);
      expect(textureCoord_15_0_18, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_19 = textureCoords_15_0.elementAt(19);
      expect(textureCoord_15_0_19, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_20 = textureCoords_15_0.elementAt(20);
      expect(textureCoord_15_0_20, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_21 = textureCoords_15_0.elementAt(21);
      expect(textureCoord_15_0_21, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_15_0_22 = textureCoords_15_0.elementAt(22);
      expect(textureCoord_15_0_22, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_15_0_23 = textureCoords_15_0.elementAt(23);
      expect(textureCoord_15_0_23, vector3MoreOrLessEquals(Vector3(0.402899, 0.410469, 0)));
      final textureCoord_15_0_24 = textureCoords_15_0.elementAt(24);
      expect(textureCoord_15_0_24, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_25 = textureCoords_15_0.elementAt(25);
      expect(textureCoord_15_0_25, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_15_0_26 = textureCoords_15_0.elementAt(26);
      expect(textureCoord_15_0_26, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_27 = textureCoords_15_0.elementAt(27);
      expect(textureCoord_15_0_27, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_28 = textureCoords_15_0.elementAt(28);
      expect(textureCoord_15_0_28, vector3MoreOrLessEquals(Vector3(0.359907, 0.385983, 0)));
      final textureCoord_15_0_29 = textureCoords_15_0.elementAt(29);
      expect(textureCoord_15_0_29, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_15_0_30 = textureCoords_15_0.elementAt(30);
      expect(textureCoord_15_0_30, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_15_0_31 = textureCoords_15_0.elementAt(31);
      expect(textureCoord_15_0_31, vector3MoreOrLessEquals(Vector3(0.402899, 0.410469, 0)));
      final textureCoord_15_0_32 = textureCoords_15_0.elementAt(32);
      expect(textureCoord_15_0_32, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_15_0_33 = textureCoords_15_0.elementAt(33);
      expect(textureCoord_15_0_33, vector3MoreOrLessEquals(Vector3(0.359907, 0.385983, 0)));
      final textureCoord_15_0_34 = textureCoords_15_0.elementAt(34);
      expect(textureCoord_15_0_34, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_15_0_35 = textureCoords_15_0.elementAt(35);
      expect(textureCoord_15_0_35, vector3MoreOrLessEquals(Vector3(0.37097, 0.384244, 0)));
      final textureCoord_15_0_36 = textureCoords_15_0.elementAt(36);
      expect(textureCoord_15_0_36, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_37 = textureCoords_15_0.elementAt(37);
      expect(textureCoord_15_0_37, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_38 = textureCoords_15_0.elementAt(38);
      expect(textureCoord_15_0_38, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_39 = textureCoords_15_0.elementAt(39);
      expect(textureCoord_15_0_39, vector3MoreOrLessEquals(Vector3(0.439539, 0.445817, 0)));
      final textureCoord_15_0_40 = textureCoords_15_0.elementAt(40);
      expect(textureCoord_15_0_40, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_15_0_41 = textureCoords_15_0.elementAt(41);
      expect(textureCoord_15_0_41, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_15_0_42 = textureCoords_15_0.elementAt(42);
      expect(textureCoord_15_0_42, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_15_0_43 = textureCoords_15_0.elementAt(43);
      expect(textureCoord_15_0_43, vector3MoreOrLessEquals(Vector3(0.359907, 0.385983, 0)));
      final textureCoord_15_0_44 = textureCoords_15_0.elementAt(44);
      expect(textureCoord_15_0_44, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_45 = textureCoords_15_0.elementAt(45);
      expect(textureCoord_15_0_45, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_46 = textureCoords_15_0.elementAt(46);
      expect(textureCoord_15_0_46, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_15_0_47 = textureCoords_15_0.elementAt(47);
      expect(textureCoord_15_0_47, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_48 = textureCoords_15_0.elementAt(48);
      expect(textureCoord_15_0_48, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_15_0_49 = textureCoords_15_0.elementAt(49);
      expect(textureCoord_15_0_49, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_15_0_50 = textureCoords_15_0.elementAt(50);
      expect(textureCoord_15_0_50, vector3MoreOrLessEquals(Vector3(0.359907, 0.385983, 0)));
      final textureCoord_15_0_51 = textureCoords_15_0.elementAt(51);
      expect(textureCoord_15_0_51, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_15_0_52 = textureCoords_15_0.elementAt(52);
      expect(textureCoord_15_0_52, vector3MoreOrLessEquals(Vector3(0.439539, 0.445817, 0)));
      final textureCoord_15_0_53 = textureCoords_15_0.elementAt(53);
      expect(textureCoord_15_0_53, vector3MoreOrLessEquals(Vector3(0.399625, 0.43185, 0)));
      final textureCoord_15_0_54 = textureCoords_15_0.elementAt(54);
      expect(textureCoord_15_0_54, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_55 = textureCoords_15_0.elementAt(55);
      expect(textureCoord_15_0_55, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_56 = textureCoords_15_0.elementAt(56);
      expect(textureCoord_15_0_56, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_57 = textureCoords_15_0.elementAt(57);
      expect(textureCoord_15_0_57, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_15_0_58 = textureCoords_15_0.elementAt(58);
      expect(textureCoord_15_0_58, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_15_0_59 = textureCoords_15_0.elementAt(59);
      expect(textureCoord_15_0_59, vector3MoreOrLessEquals(Vector3(0.439539, 0.445817, 0)));
      final textureCoord_15_0_60 = textureCoords_15_0.elementAt(60);
      expect(textureCoord_15_0_60, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_61 = textureCoords_15_0.elementAt(61);
      expect(textureCoord_15_0_61, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_15_0_62 = textureCoords_15_0.elementAt(62);
      expect(textureCoord_15_0_62, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_63 = textureCoords_15_0.elementAt(63);
      expect(textureCoord_15_0_63, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_64 = textureCoords_15_0.elementAt(64);
      expect(textureCoord_15_0_64, vector3MoreOrLessEquals(Vector3(0.420092, 0.378214, 0)));
      final textureCoord_15_0_65 = textureCoords_15_0.elementAt(65);
      expect(textureCoord_15_0_65, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_15_0_66 = textureCoords_15_0.elementAt(66);
      expect(textureCoord_15_0_66, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_15_0_67 = textureCoords_15_0.elementAt(67);
      expect(textureCoord_15_0_67, vector3MoreOrLessEquals(Vector3(0.439539, 0.445817, 0)));
      final textureCoord_15_0_68 = textureCoords_15_0.elementAt(68);
      expect(textureCoord_15_0_68, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_15_0_69 = textureCoords_15_0.elementAt(69);
      expect(textureCoord_15_0_69, vector3MoreOrLessEquals(Vector3(0.420092, 0.378214, 0)));
      final textureCoord_15_0_70 = textureCoords_15_0.elementAt(70);
      expect(textureCoord_15_0_70, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_15_0_71 = textureCoords_15_0.elementAt(71);
      expect(textureCoord_15_0_71, vector3MoreOrLessEquals(Vector3(0.381768, 0.383299, 0)));
      final textureCoord_15_0_72 = textureCoords_15_0.elementAt(72);
      expect(textureCoord_15_0_72, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_73 = textureCoords_15_0.elementAt(73);
      expect(textureCoord_15_0_73, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_74 = textureCoords_15_0.elementAt(74);
      expect(textureCoord_15_0_74, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_75 = textureCoords_15_0.elementAt(75);
      expect(textureCoord_15_0_75, vector3MoreOrLessEquals(Vector3(0.518816, 0.422941, 0)));
      final textureCoord_15_0_76 = textureCoords_15_0.elementAt(76);
      expect(textureCoord_15_0_76, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_15_0_77 = textureCoords_15_0.elementAt(77);
      expect(textureCoord_15_0_77, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_15_0_78 = textureCoords_15_0.elementAt(78);
      expect(textureCoord_15_0_78, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_15_0_79 = textureCoords_15_0.elementAt(79);
      expect(textureCoord_15_0_79, vector3MoreOrLessEquals(Vector3(0.420092, 0.378214, 0)));
      final textureCoord_15_0_80 = textureCoords_15_0.elementAt(80);
      expect(textureCoord_15_0_80, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_81 = textureCoords_15_0.elementAt(81);
      expect(textureCoord_15_0_81, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_82 = textureCoords_15_0.elementAt(82);
      expect(textureCoord_15_0_82, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_15_0_83 = textureCoords_15_0.elementAt(83);
      expect(textureCoord_15_0_83, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_84 = textureCoords_15_0.elementAt(84);
      expect(textureCoord_15_0_84, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_15_0_85 = textureCoords_15_0.elementAt(85);
      expect(textureCoord_15_0_85, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_15_0_86 = textureCoords_15_0.elementAt(86);
      expect(textureCoord_15_0_86, vector3MoreOrLessEquals(Vector3(0.420092, 0.378214, 0)));
      final textureCoord_15_0_87 = textureCoords_15_0.elementAt(87);
      expect(textureCoord_15_0_87, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_15_0_88 = textureCoords_15_0.elementAt(88);
      expect(textureCoord_15_0_88, vector3MoreOrLessEquals(Vector3(0.518816, 0.422941, 0)));
      final textureCoord_15_0_89 = textureCoords_15_0.elementAt(89);
      expect(textureCoord_15_0_89, vector3MoreOrLessEquals(Vector3(0.492584, 0.441852, 0)));
      final textureCoord_15_0_90 = textureCoords_15_0.elementAt(90);
      expect(textureCoord_15_0_90, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_91 = textureCoords_15_0.elementAt(91);
      expect(textureCoord_15_0_91, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_92 = textureCoords_15_0.elementAt(92);
      expect(textureCoord_15_0_92, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_93 = textureCoords_15_0.elementAt(93);
      expect(textureCoord_15_0_93, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_15_0_94 = textureCoords_15_0.elementAt(94);
      expect(textureCoord_15_0_94, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_15_0_95 = textureCoords_15_0.elementAt(95);
      expect(textureCoord_15_0_95, vector3MoreOrLessEquals(Vector3(0.518816, 0.422941, 0)));
      final textureCoord_15_0_96 = textureCoords_15_0.elementAt(96);
      expect(textureCoord_15_0_96, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_97 = textureCoords_15_0.elementAt(97);
      expect(textureCoord_15_0_97, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_15_0_98 = textureCoords_15_0.elementAt(98);
      expect(textureCoord_15_0_98, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_99 = textureCoords_15_0.elementAt(99);
      expect(textureCoord_15_0_99, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_100 = textureCoords_15_0.elementAt(100);
      expect(textureCoord_15_0_100, vector3MoreOrLessEquals(Vector3(0.440026, 0.37508, 0)));
      final textureCoord_15_0_101 = textureCoords_15_0.elementAt(101);
      expect(textureCoord_15_0_101, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_15_0_102 = textureCoords_15_0.elementAt(102);
      expect(textureCoord_15_0_102, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_15_0_103 = textureCoords_15_0.elementAt(103);
      expect(textureCoord_15_0_103, vector3MoreOrLessEquals(Vector3(0.518816, 0.422941, 0)));
      final textureCoord_15_0_104 = textureCoords_15_0.elementAt(104);
      expect(textureCoord_15_0_104, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_15_0_105 = textureCoords_15_0.elementAt(105);
      expect(textureCoord_15_0_105, vector3MoreOrLessEquals(Vector3(0.440026, 0.37508, 0)));
      final textureCoord_15_0_106 = textureCoords_15_0.elementAt(106);
      expect(textureCoord_15_0_106, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_15_0_107 = textureCoords_15_0.elementAt(107);
      expect(textureCoord_15_0_107, vector3MoreOrLessEquals(Vector3(0.446019, 0.374556, 0)));
      final textureCoord_15_0_108 = textureCoords_15_0.elementAt(108);
      expect(textureCoord_15_0_108, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_109 = textureCoords_15_0.elementAt(109);
      expect(textureCoord_15_0_109, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_110 = textureCoords_15_0.elementAt(110);
      expect(textureCoord_15_0_110, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_111 = textureCoords_15_0.elementAt(111);
      expect(textureCoord_15_0_111, vector3MoreOrLessEquals(Vector3(0.446895, 0.397773, 0)));
      final textureCoord_15_0_112 = textureCoords_15_0.elementAt(112);
      expect(textureCoord_15_0_112, vector3MoreOrLessEquals(Vector3(0.456977, 0.422004, 0)));
      final textureCoord_15_0_113 = textureCoords_15_0.elementAt(113);
      expect(textureCoord_15_0_113, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_15_0_114 = textureCoords_15_0.elementAt(114);
      expect(textureCoord_15_0_114, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_15_0_115 = textureCoords_15_0.elementAt(115);
      expect(textureCoord_15_0_115, vector3MoreOrLessEquals(Vector3(0.440026, 0.37508, 0)));
      final textureCoord_15_0_116 = textureCoords_15_0.elementAt(116);
      expect(textureCoord_15_0_116, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_117 = textureCoords_15_0.elementAt(117);
      expect(textureCoord_15_0_117, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_118 = textureCoords_15_0.elementAt(118);
      expect(textureCoord_15_0_118, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_15_0_119 = textureCoords_15_0.elementAt(119);
      expect(textureCoord_15_0_119, vector3MoreOrLessEquals(Vector3(0.332919, 0.272694, 0)));
      final textureCoord_15_0_120 = textureCoords_15_0.elementAt(120);
      expect(textureCoord_15_0_120, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_15_0_121 = textureCoords_15_0.elementAt(121);
      expect(textureCoord_15_0_121, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      final textureCoord_15_0_122 = textureCoords_15_0.elementAt(122);
      expect(textureCoord_15_0_122, vector3MoreOrLessEquals(Vector3(0.440026, 0.37508, 0)));
      final textureCoord_15_0_123 = textureCoords_15_0.elementAt(123);
      expect(textureCoord_15_0_123, vector3MoreOrLessEquals(Vector3(0.406626, 0.379392, 0)));
      final textureCoord_15_0_124 = textureCoords_15_0.elementAt(124);
      expect(textureCoord_15_0_124, vector3MoreOrLessEquals(Vector3(0.446895, 0.397773, 0)));
      final textureCoord_15_0_125 = textureCoords_15_0.elementAt(125);
      expect(textureCoord_15_0_125, vector3MoreOrLessEquals(Vector3(0.498483, 0.403324, 0)));
      expect(mesh_15.uvComponents.length, equals(1));
      expect(mesh_15.uvComponents, equals([2]));
      expect(mesh_15.faces.length, equals(42));
      expect(mesh_15.bones.length, isZero);
      expect(mesh_15.materialIndex, equals(4));
      expect(mesh_15.name, equals('Zahn2'));
      expect(mesh_15.animMeshes.length, isZero);
      expect(mesh_15.morphingMethod, isZero);
      expect(mesh_15.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_16 = meshes.elementAt(16);
      expect(mesh_16.primitiveTypes, equals(4));
      expect(mesh_16.vertices.length, equals(126));
      final vertex_16_0 = mesh_16.vertices.elementAt(0);
      expect(vertex_16_0, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_1 = mesh_16.vertices.elementAt(1);
      expect(vertex_16_1, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_2 = mesh_16.vertices.elementAt(2);
      expect(vertex_16_2, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_3 = mesh_16.vertices.elementAt(3);
      expect(vertex_16_3, vector3MoreOrLessEquals(Vector3(-55.5099, 10.3343, -15.6905)));
      final vertex_16_4 = mesh_16.vertices.elementAt(4);
      expect(vertex_16_4, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6723, -17.902)));
      final vertex_16_5 = mesh_16.vertices.elementAt(5);
      expect(vertex_16_5, vector3MoreOrLessEquals(Vector3(-58.2127, 12.1413, -15.6345)));
      final vertex_16_6 = mesh_16.vertices.elementAt(6);
      expect(vertex_16_6, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_7 = mesh_16.vertices.elementAt(7);
      expect(vertex_16_7, vector3MoreOrLessEquals(Vector3(-59.6895, 8.1995, -20.5285)));
      final vertex_16_8 = mesh_16.vertices.elementAt(8);
      expect(vertex_16_8, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_9 = mesh_16.vertices.elementAt(9);
      expect(vertex_16_9, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_10 = mesh_16.vertices.elementAt(10);
      expect(vertex_16_10, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_11 = mesh_16.vertices.elementAt(11);
      expect(vertex_16_11, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_12 = mesh_16.vertices.elementAt(12);
      expect(vertex_16_12, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_13 = mesh_16.vertices.elementAt(13);
      expect(vertex_16_13, vector3MoreOrLessEquals(Vector3(-58.2127, 12.1413, -15.6345)));
      final vertex_16_14 = mesh_16.vertices.elementAt(14);
      expect(vertex_16_14, vector3MoreOrLessEquals(Vector3(-59.6895, 8.1995, -20.5285)));
      final vertex_16_15 = mesh_16.vertices.elementAt(15);
      expect(vertex_16_15, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_16 = mesh_16.vertices.elementAt(16);
      expect(vertex_16_16, vector3MoreOrLessEquals(Vector3(-55.5099, 10.3343, -15.6905)));
      final vertex_16_17 = mesh_16.vertices.elementAt(17);
      expect(vertex_16_17, vector3MoreOrLessEquals(Vector3(-58.2127, 12.1413, -15.6345)));
      final vertex_16_18 = mesh_16.vertices.elementAt(18);
      expect(vertex_16_18, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_19 = mesh_16.vertices.elementAt(19);
      expect(vertex_16_19, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_20 = mesh_16.vertices.elementAt(20);
      expect(vertex_16_20, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_21 = mesh_16.vertices.elementAt(21);
      expect(vertex_16_21, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2878, -17.4118)));
      final vertex_16_22 = mesh_16.vertices.elementAt(22);
      expect(vertex_16_22, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6723, -17.902)));
      final vertex_16_23 = mesh_16.vertices.elementAt(23);
      expect(vertex_16_23, vector3MoreOrLessEquals(Vector3(-55.5099, 10.3343, -15.6905)));
      final vertex_16_24 = mesh_16.vertices.elementAt(24);
      expect(vertex_16_24, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_25 = mesh_16.vertices.elementAt(25);
      expect(vertex_16_25, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_26 = mesh_16.vertices.elementAt(26);
      expect(vertex_16_26, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_27 = mesh_16.vertices.elementAt(27);
      expect(vertex_16_27, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_28 = mesh_16.vertices.elementAt(28);
      expect(vertex_16_28, vector3MoreOrLessEquals(Vector3(-56.2969, 6.24298, -22.0232)));
      final vertex_16_29 = mesh_16.vertices.elementAt(29);
      expect(vertex_16_29, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_30 = mesh_16.vertices.elementAt(30);
      expect(vertex_16_30, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2878, -17.4118)));
      final vertex_16_31 = mesh_16.vertices.elementAt(31);
      expect(vertex_16_31, vector3MoreOrLessEquals(Vector3(-55.5099, 10.3343, -15.6905)));
      final vertex_16_32 = mesh_16.vertices.elementAt(32);
      expect(vertex_16_32, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_33 = mesh_16.vertices.elementAt(33);
      expect(vertex_16_33, vector3MoreOrLessEquals(Vector3(-56.2969, 6.24298, -22.0232)));
      final vertex_16_34 = mesh_16.vertices.elementAt(34);
      expect(vertex_16_34, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2878, -17.4118)));
      final vertex_16_35 = mesh_16.vertices.elementAt(35);
      expect(vertex_16_35, vector3MoreOrLessEquals(Vector3(-57.9159, 6.68292, -20.6255)));
      final vertex_16_36 = mesh_16.vertices.elementAt(36);
      expect(vertex_16_36, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_37 = mesh_16.vertices.elementAt(37);
      expect(vertex_16_37, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_38 = mesh_16.vertices.elementAt(38);
      expect(vertex_16_38, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_39 = mesh_16.vertices.elementAt(39);
      expect(vertex_16_39, vector3MoreOrLessEquals(Vector3(-51.7578, 12.0369, -19.5022)));
      final vertex_16_40 = mesh_16.vertices.elementAt(40);
      expect(vertex_16_40, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6723, -17.902)));
      final vertex_16_41 = mesh_16.vertices.elementAt(41);
      expect(vertex_16_41, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2878, -17.4118)));
      final vertex_16_42 = mesh_16.vertices.elementAt(42);
      expect(vertex_16_42, vector3MoreOrLessEquals(Vector3(-56.0517, 7.21101, -23.6689)));
      final vertex_16_43 = mesh_16.vertices.elementAt(43);
      expect(vertex_16_43, vector3MoreOrLessEquals(Vector3(-56.2969, 6.24298, -22.0232)));
      final vertex_16_44 = mesh_16.vertices.elementAt(44);
      expect(vertex_16_44, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_45 = mesh_16.vertices.elementAt(45);
      expect(vertex_16_45, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_46 = mesh_16.vertices.elementAt(46);
      expect(vertex_16_46, vector3MoreOrLessEquals(Vector3(-56.0517, 7.21101, -23.6689)));
      final vertex_16_47 = mesh_16.vertices.elementAt(47);
      expect(vertex_16_47, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_48 = mesh_16.vertices.elementAt(48);
      expect(vertex_16_48, vector3MoreOrLessEquals(Vector3(-56.0517, 7.21101, -23.6689)));
      final vertex_16_49 = mesh_16.vertices.elementAt(49);
      expect(vertex_16_49, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2878, -17.4118)));
      final vertex_16_50 = mesh_16.vertices.elementAt(50);
      expect(vertex_16_50, vector3MoreOrLessEquals(Vector3(-56.2969, 6.24298, -22.0232)));
      final vertex_16_51 = mesh_16.vertices.elementAt(51);
      expect(vertex_16_51, vector3MoreOrLessEquals(Vector3(-56.0517, 7.21101, -23.6689)));
      final vertex_16_52 = mesh_16.vertices.elementAt(52);
      expect(vertex_16_52, vector3MoreOrLessEquals(Vector3(-51.7578, 12.0369, -19.5022)));
      final vertex_16_53 = mesh_16.vertices.elementAt(53);
      expect(vertex_16_53, vector3MoreOrLessEquals(Vector3(-52.6372, 10.2878, -17.4118)));
      final vertex_16_54 = mesh_16.vertices.elementAt(54);
      expect(vertex_16_54, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_55 = mesh_16.vertices.elementAt(55);
      expect(vertex_16_55, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_56 = mesh_16.vertices.elementAt(56);
      expect(vertex_16_56, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_57 = mesh_16.vertices.elementAt(57);
      expect(vertex_16_57, vector3MoreOrLessEquals(Vector3(-53.534, 14.2646, -20.3877)));
      final vertex_16_58 = mesh_16.vertices.elementAt(58);
      expect(vertex_16_58, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6723, -17.902)));
      final vertex_16_59 = mesh_16.vertices.elementAt(59);
      expect(vertex_16_59, vector3MoreOrLessEquals(Vector3(-51.7578, 12.0369, -19.5022)));
      final vertex_16_60 = mesh_16.vertices.elementAt(60);
      expect(vertex_16_60, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_61 = mesh_16.vertices.elementAt(61);
      expect(vertex_16_61, vector3MoreOrLessEquals(Vector3(-56.0517, 7.21101, -23.6689)));
      final vertex_16_62 = mesh_16.vertices.elementAt(62);
      expect(vertex_16_62, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_63 = mesh_16.vertices.elementAt(63);
      expect(vertex_16_63, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_64 = mesh_16.vertices.elementAt(64);
      expect(vertex_16_64, vector3MoreOrLessEquals(Vector3(-57.3648, 8.85803, -24.3236)));
      final vertex_16_65 = mesh_16.vertices.elementAt(65);
      expect(vertex_16_65, vector3MoreOrLessEquals(Vector3(-56.0517, 7.21101, -23.6689)));
      final vertex_16_66 = mesh_16.vertices.elementAt(66);
      expect(vertex_16_66, vector3MoreOrLessEquals(Vector3(-53.534, 14.2646, -20.3877)));
      final vertex_16_67 = mesh_16.vertices.elementAt(67);
      expect(vertex_16_67, vector3MoreOrLessEquals(Vector3(-51.7578, 12.0369, -19.5022)));
      final vertex_16_68 = mesh_16.vertices.elementAt(68);
      expect(vertex_16_68, vector3MoreOrLessEquals(Vector3(-56.0517, 7.21101, -23.6689)));
      final vertex_16_69 = mesh_16.vertices.elementAt(69);
      expect(vertex_16_69, vector3MoreOrLessEquals(Vector3(-57.3648, 8.85803, -24.3236)));
      final vertex_16_70 = mesh_16.vertices.elementAt(70);
      expect(vertex_16_70, vector3MoreOrLessEquals(Vector3(-53.534, 14.2646, -20.3877)));
      final vertex_16_71 = mesh_16.vertices.elementAt(71);
      expect(vertex_16_71, vector3MoreOrLessEquals(Vector3(-56.0517, 7.21101, -23.6689)));
      final vertex_16_72 = mesh_16.vertices.elementAt(72);
      expect(vertex_16_72, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_73 = mesh_16.vertices.elementAt(73);
      expect(vertex_16_73, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_74 = mesh_16.vertices.elementAt(74);
      expect(vertex_16_74, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_75 = mesh_16.vertices.elementAt(75);
      expect(vertex_16_75, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2932, -19.4013)));
      final vertex_16_76 = mesh_16.vertices.elementAt(76);
      expect(vertex_16_76, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6723, -17.902)));
      final vertex_16_77 = mesh_16.vertices.elementAt(77);
      expect(vertex_16_77, vector3MoreOrLessEquals(Vector3(-53.534, 14.2646, -20.3877)));
      final vertex_16_78 = mesh_16.vertices.elementAt(78);
      expect(vertex_16_78, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_79 = mesh_16.vertices.elementAt(79);
      expect(vertex_16_79, vector3MoreOrLessEquals(Vector3(-57.3648, 8.85803, -24.3236)));
      final vertex_16_80 = mesh_16.vertices.elementAt(80);
      expect(vertex_16_80, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_81 = mesh_16.vertices.elementAt(81);
      expect(vertex_16_81, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_82 = mesh_16.vertices.elementAt(82);
      expect(vertex_16_82, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_83 = mesh_16.vertices.elementAt(83);
      expect(vertex_16_83, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_84 = mesh_16.vertices.elementAt(84);
      expect(vertex_16_84, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_85 = mesh_16.vertices.elementAt(85);
      expect(vertex_16_85, vector3MoreOrLessEquals(Vector3(-53.534, 14.2646, -20.3877)));
      final vertex_16_86 = mesh_16.vertices.elementAt(86);
      expect(vertex_16_86, vector3MoreOrLessEquals(Vector3(-57.3648, 8.85803, -24.3236)));
      final vertex_16_87 = mesh_16.vertices.elementAt(87);
      expect(vertex_16_87, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_88 = mesh_16.vertices.elementAt(88);
      expect(vertex_16_88, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2932, -19.4013)));
      final vertex_16_89 = mesh_16.vertices.elementAt(89);
      expect(vertex_16_89, vector3MoreOrLessEquals(Vector3(-53.534, 14.2646, -20.3877)));
      final vertex_16_90 = mesh_16.vertices.elementAt(90);
      expect(vertex_16_90, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_91 = mesh_16.vertices.elementAt(91);
      expect(vertex_16_91, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_92 = mesh_16.vertices.elementAt(92);
      expect(vertex_16_92, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_93 = mesh_16.vertices.elementAt(93);
      expect(vertex_16_93, vector3MoreOrLessEquals(Vector3(-58.7103, 14.3483, -17.286)));
      final vertex_16_94 = mesh_16.vertices.elementAt(94);
      expect(vertex_16_94, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6723, -17.902)));
      final vertex_16_95 = mesh_16.vertices.elementAt(95);
      expect(vertex_16_95, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2932, -19.4013)));
      final vertex_16_96 = mesh_16.vertices.elementAt(96);
      expect(vertex_16_96, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_97 = mesh_16.vertices.elementAt(97);
      expect(vertex_16_97, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_98 = mesh_16.vertices.elementAt(98);
      expect(vertex_16_98, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_99 = mesh_16.vertices.elementAt(99);
      expect(vertex_16_99, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_100 = mesh_16.vertices.elementAt(100);
      expect(vertex_16_100, vector3MoreOrLessEquals(Vector3(-60.2821, 9.65074, -21.8051)));
      final vertex_16_101 = mesh_16.vertices.elementAt(101);
      expect(vertex_16_101, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_102 = mesh_16.vertices.elementAt(102);
      expect(vertex_16_102, vector3MoreOrLessEquals(Vector3(-58.7103, 14.3483, -17.286)));
      final vertex_16_103 = mesh_16.vertices.elementAt(103);
      expect(vertex_16_103, vector3MoreOrLessEquals(Vector3(-56.6281, 15.2932, -19.4013)));
      final vertex_16_104 = mesh_16.vertices.elementAt(104);
      expect(vertex_16_104, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_105 = mesh_16.vertices.elementAt(105);
      expect(vertex_16_105, vector3MoreOrLessEquals(Vector3(-60.2821, 9.65074, -21.8051)));
      final vertex_16_106 = mesh_16.vertices.elementAt(106);
      expect(vertex_16_106, vector3MoreOrLessEquals(Vector3(-58.7103, 14.3483, -17.286)));
      final vertex_16_107 = mesh_16.vertices.elementAt(107);
      expect(vertex_16_107, vector3MoreOrLessEquals(Vector3(-59.2476, 9.94379, -23.4941)));
      final vertex_16_108 = mesh_16.vertices.elementAt(108);
      expect(vertex_16_108, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_109 = mesh_16.vertices.elementAt(109);
      expect(vertex_16_109, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_110 = mesh_16.vertices.elementAt(110);
      expect(vertex_16_110, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_111 = mesh_16.vertices.elementAt(111);
      expect(vertex_16_111, vector3MoreOrLessEquals(Vector3(-58.2127, 12.1413, -15.6345)));
      final vertex_16_112 = mesh_16.vertices.elementAt(112);
      expect(vertex_16_112, vector3MoreOrLessEquals(Vector3(-55.2843, 12.6723, -17.902)));
      final vertex_16_113 = mesh_16.vertices.elementAt(113);
      expect(vertex_16_113, vector3MoreOrLessEquals(Vector3(-58.7103, 14.3483, -17.286)));
      final vertex_16_114 = mesh_16.vertices.elementAt(114);
      expect(vertex_16_114, vector3MoreOrLessEquals(Vector3(-59.6895, 8.1995, -20.5285)));
      final vertex_16_115 = mesh_16.vertices.elementAt(115);
      expect(vertex_16_115, vector3MoreOrLessEquals(Vector3(-60.2821, 9.65074, -21.8051)));
      final vertex_16_116 = mesh_16.vertices.elementAt(116);
      expect(vertex_16_116, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_117 = mesh_16.vertices.elementAt(117);
      expect(vertex_16_117, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_118 = mesh_16.vertices.elementAt(118);
      expect(vertex_16_118, vector3MoreOrLessEquals(Vector3(-59.6895, 8.1995, -20.5285)));
      final vertex_16_119 = mesh_16.vertices.elementAt(119);
      expect(vertex_16_119, vector3MoreOrLessEquals(Vector3(-66.7248, 1.23447, -28.6961)));
      final vertex_16_120 = mesh_16.vertices.elementAt(120);
      expect(vertex_16_120, vector3MoreOrLessEquals(Vector3(-59.6895, 8.1995, -20.5285)));
      final vertex_16_121 = mesh_16.vertices.elementAt(121);
      expect(vertex_16_121, vector3MoreOrLessEquals(Vector3(-58.7103, 14.3483, -17.286)));
      final vertex_16_122 = mesh_16.vertices.elementAt(122);
      expect(vertex_16_122, vector3MoreOrLessEquals(Vector3(-60.2821, 9.65074, -21.8051)));
      final vertex_16_123 = mesh_16.vertices.elementAt(123);
      expect(vertex_16_123, vector3MoreOrLessEquals(Vector3(-59.6895, 8.1995, -20.5285)));
      final vertex_16_124 = mesh_16.vertices.elementAt(124);
      expect(vertex_16_124, vector3MoreOrLessEquals(Vector3(-58.2127, 12.1413, -15.6345)));
      final vertex_16_125 = mesh_16.vertices.elementAt(125);
      expect(vertex_16_125, vector3MoreOrLessEquals(Vector3(-58.7103, 14.3483, -17.286)));
      expect(mesh_16.normals.length, equals(126));
      final normal_16_0 = mesh_16.normals.elementAt(0);
      expect(normal_16_0, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_1 = mesh_16.normals.elementAt(1);
      expect(normal_16_1, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_2 = mesh_16.normals.elementAt(2);
      expect(normal_16_2, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_3 = mesh_16.normals.elementAt(3);
      expect(normal_16_3, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_4 = mesh_16.normals.elementAt(4);
      expect(normal_16_4, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_5 = mesh_16.normals.elementAt(5);
      expect(normal_16_5, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_6 = mesh_16.normals.elementAt(6);
      expect(normal_16_6, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, 0.631575)));
      final normal_16_7 = mesh_16.normals.elementAt(7);
      expect(normal_16_7, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, 0.577998)));
      final normal_16_8 = mesh_16.normals.elementAt(8);
      expect(normal_16_8, vector3MoreOrLessEquals(Vector3(-0.390952, -0.506392, 0.768585)));
      final normal_16_9 = mesh_16.normals.elementAt(9);
      expect(normal_16_9, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_10 = mesh_16.normals.elementAt(10);
      expect(normal_16_10, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, 0.631575)));
      final normal_16_11 = mesh_16.normals.elementAt(11);
      expect(normal_16_11, vector3MoreOrLessEquals(Vector3(-0.390952, -0.506392, 0.768585)));
      final normal_16_12 = mesh_16.normals.elementAt(12);
      expect(normal_16_12, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, 0.631575)));
      final normal_16_13 = mesh_16.normals.elementAt(13);
      expect(normal_16_13, vector3MoreOrLessEquals(Vector3(-0.676852, -0.452073, 0.580948)));
      final normal_16_14 = mesh_16.normals.elementAt(14);
      expect(normal_16_14, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, 0.577998)));
      final normal_16_15 = mesh_16.normals.elementAt(15);
      expect(normal_16_15, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, 0.631575)));
      final normal_16_16 = mesh_16.normals.elementAt(16);
      expect(normal_16_16, vector3MoreOrLessEquals(Vector3(-0.070613, -0.785108, 0.61532)));
      final normal_16_17 = mesh_16.normals.elementAt(17);
      expect(normal_16_17, vector3MoreOrLessEquals(Vector3(-0.676852, -0.452073, 0.580948)));
      final normal_16_18 = mesh_16.normals.elementAt(18);
      expect(normal_16_18, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_19 = mesh_16.normals.elementAt(19);
      expect(normal_16_19, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_20 = mesh_16.normals.elementAt(20);
      expect(normal_16_20, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_21 = mesh_16.normals.elementAt(21);
      expect(normal_16_21, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_22 = mesh_16.normals.elementAt(22);
      expect(normal_16_22, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_23 = mesh_16.normals.elementAt(23);
      expect(normal_16_23, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_24 = mesh_16.normals.elementAt(24);
      expect(normal_16_24, vector3MoreOrLessEquals(Vector3(0.404464, -0.913005, 0.053206)));
      final normal_16_25 = mesh_16.normals.elementAt(25);
      expect(normal_16_25, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, 0.631575)));
      final normal_16_26 = mesh_16.normals.elementAt(26);
      expect(normal_16_26, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_27 = mesh_16.normals.elementAt(27);
      expect(normal_16_27, vector3MoreOrLessEquals(Vector3(0.404464, -0.913005, 0.053206)));
      final normal_16_28 = mesh_16.normals.elementAt(28);
      expect(normal_16_28, vector3MoreOrLessEquals(Vector3(0.510042, -0.851111, 0.124372)));
      final normal_16_29 = mesh_16.normals.elementAt(29);
      expect(normal_16_29, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, 0.631575)));
      final normal_16_30 = mesh_16.normals.elementAt(30);
      expect(normal_16_30, vector3MoreOrLessEquals(Vector3(0.600863, -0.776753, 0.188727)));
      final normal_16_31 = mesh_16.normals.elementAt(31);
      expect(normal_16_31, vector3MoreOrLessEquals(Vector3(-0.070613, -0.785108, 0.61532)));
      final normal_16_32 = mesh_16.normals.elementAt(32);
      expect(normal_16_32, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, 0.631575)));
      final normal_16_33 = mesh_16.normals.elementAt(33);
      expect(normal_16_33, vector3MoreOrLessEquals(Vector3(0.510042, -0.851111, 0.124372)));
      final normal_16_34 = mesh_16.normals.elementAt(34);
      expect(normal_16_34, vector3MoreOrLessEquals(Vector3(0.600863, -0.776753, 0.188727)));
      final normal_16_35 = mesh_16.normals.elementAt(35);
      expect(normal_16_35, vector3MoreOrLessEquals(Vector3(-0.112803, -0.767065, 0.631575)));
      final normal_16_36 = mesh_16.normals.elementAt(36);
      expect(normal_16_36, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_37 = mesh_16.normals.elementAt(37);
      expect(normal_16_37, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_38 = mesh_16.normals.elementAt(38);
      expect(normal_16_38, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_39 = mesh_16.normals.elementAt(39);
      expect(normal_16_39, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_40 = mesh_16.normals.elementAt(40);
      expect(normal_16_40, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_41 = mesh_16.normals.elementAt(41);
      expect(normal_16_41, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_42 = mesh_16.normals.elementAt(42);
      expect(normal_16_42, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, -0.609964)));
      final normal_16_43 = mesh_16.normals.elementAt(43);
      expect(normal_16_43, vector3MoreOrLessEquals(Vector3(0.510042, -0.851111, 0.124372)));
      final normal_16_44 = mesh_16.normals.elementAt(44);
      expect(normal_16_44, vector3MoreOrLessEquals(Vector3(0.404464, -0.913005, 0.053206)));
      final normal_16_45 = mesh_16.normals.elementAt(45);
      expect(normal_16_45, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_46 = mesh_16.normals.elementAt(46);
      expect(normal_16_46, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, -0.609964)));
      final normal_16_47 = mesh_16.normals.elementAt(47);
      expect(normal_16_47, vector3MoreOrLessEquals(Vector3(0.404464, -0.913005, 0.053206)));
      final normal_16_48 = mesh_16.normals.elementAt(48);
      expect(normal_16_48, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, -0.609964)));
      final normal_16_49 = mesh_16.normals.elementAt(49);
      expect(normal_16_49, vector3MoreOrLessEquals(Vector3(0.600863, -0.776753, 0.188727)));
      final normal_16_50 = mesh_16.normals.elementAt(50);
      expect(normal_16_50, vector3MoreOrLessEquals(Vector3(0.510042, -0.851111, 0.124372)));
      final normal_16_51 = mesh_16.normals.elementAt(51);
      expect(normal_16_51, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, -0.609964)));
      final normal_16_52 = mesh_16.normals.elementAt(52);
      expect(normal_16_52, vector3MoreOrLessEquals(Vector3(0.802854, -0.245127, -0.54345)));
      final normal_16_53 = mesh_16.normals.elementAt(53);
      expect(normal_16_53, vector3MoreOrLessEquals(Vector3(0.600863, -0.776753, 0.188727)));
      final normal_16_54 = mesh_16.normals.elementAt(54);
      expect(normal_16_54, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_55 = mesh_16.normals.elementAt(55);
      expect(normal_16_55, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_56 = mesh_16.normals.elementAt(56);
      expect(normal_16_56, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_57 = mesh_16.normals.elementAt(57);
      expect(normal_16_57, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_58 = mesh_16.normals.elementAt(58);
      expect(normal_16_58, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_59 = mesh_16.normals.elementAt(59);
      expect(normal_16_59, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_60 = mesh_16.normals.elementAt(60);
      expect(normal_16_60, vector3MoreOrLessEquals(Vector3(0.20392, 0.286548, -0.936113)));
      final normal_16_61 = mesh_16.normals.elementAt(61);
      expect(normal_16_61, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, -0.609964)));
      final normal_16_62 = mesh_16.normals.elementAt(62);
      expect(normal_16_62, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_63 = mesh_16.normals.elementAt(63);
      expect(normal_16_63, vector3MoreOrLessEquals(Vector3(0.20392, 0.286548, -0.936113)));
      final normal_16_64 = mesh_16.normals.elementAt(64);
      expect(normal_16_64, vector3MoreOrLessEquals(Vector3(0.259058, 0.346923, -0.901407)));
      final normal_16_65 = mesh_16.normals.elementAt(65);
      expect(normal_16_65, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, -0.609964)));
      final normal_16_66 = mesh_16.normals.elementAt(66);
      expect(normal_16_66, vector3MoreOrLessEquals(Vector3(0.305077, 0.413607, -0.857821)));
      final normal_16_67 = mesh_16.normals.elementAt(67);
      expect(normal_16_67, vector3MoreOrLessEquals(Vector3(0.802854, -0.245127, -0.54345)));
      final normal_16_68 = mesh_16.normals.elementAt(68);
      expect(normal_16_68, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, -0.609964)));
      final normal_16_69 = mesh_16.normals.elementAt(69);
      expect(normal_16_69, vector3MoreOrLessEquals(Vector3(0.259058, 0.346923, -0.901407)));
      final normal_16_70 = mesh_16.normals.elementAt(70);
      expect(normal_16_70, vector3MoreOrLessEquals(Vector3(0.305077, 0.413607, -0.857821)));
      final normal_16_71 = mesh_16.normals.elementAt(71);
      expect(normal_16_71, vector3MoreOrLessEquals(Vector3(0.73416, -0.298249, -0.609964)));
      final normal_16_72 = mesh_16.normals.elementAt(72);
      expect(normal_16_72, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_73 = mesh_16.normals.elementAt(73);
      expect(normal_16_73, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_74 = mesh_16.normals.elementAt(74);
      expect(normal_16_74, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_75 = mesh_16.normals.elementAt(75);
      expect(normal_16_75, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_76 = mesh_16.normals.elementAt(76);
      expect(normal_16_76, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_77 = mesh_16.normals.elementAt(77);
      expect(normal_16_77, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_78 = mesh_16.normals.elementAt(78);
      expect(normal_16_78, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672312, -0.625988)));
      final normal_16_79 = mesh_16.normals.elementAt(79);
      expect(normal_16_79, vector3MoreOrLessEquals(Vector3(0.259058, 0.346923, -0.901407)));
      final normal_16_80 = mesh_16.normals.elementAt(80);
      expect(normal_16_80, vector3MoreOrLessEquals(Vector3(0.20392, 0.286548, -0.936113)));
      final normal_16_81 = mesh_16.normals.elementAt(81);
      expect(normal_16_81, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_82 = mesh_16.normals.elementAt(82);
      expect(normal_16_82, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672312, -0.625988)));
      final normal_16_83 = mesh_16.normals.elementAt(83);
      expect(normal_16_83, vector3MoreOrLessEquals(Vector3(0.20392, 0.286548, -0.936113)));
      final normal_16_84 = mesh_16.normals.elementAt(84);
      expect(normal_16_84, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672312, -0.625988)));
      final normal_16_85 = mesh_16.normals.elementAt(85);
      expect(normal_16_85, vector3MoreOrLessEquals(Vector3(0.305077, 0.413607, -0.857821)));
      final normal_16_86 = mesh_16.normals.elementAt(86);
      expect(normal_16_86, vector3MoreOrLessEquals(Vector3(0.259058, 0.346923, -0.901407)));
      final normal_16_87 = mesh_16.normals.elementAt(87);
      expect(normal_16_87, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672312, -0.625988)));
      final normal_16_88 = mesh_16.normals.elementAt(88);
      expect(normal_16_88, vector3MoreOrLessEquals(Vector3(-0.388204, 0.672327, -0.630297)));
      final normal_16_89 = mesh_16.normals.elementAt(89);
      expect(normal_16_89, vector3MoreOrLessEquals(Vector3(0.305077, 0.413607, -0.857821)));
      final normal_16_90 = mesh_16.normals.elementAt(90);
      expect(normal_16_90, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_91 = mesh_16.normals.elementAt(91);
      expect(normal_16_91, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_92 = mesh_16.normals.elementAt(92);
      expect(normal_16_92, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_93 = mesh_16.normals.elementAt(93);
      expect(normal_16_93, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_94 = mesh_16.normals.elementAt(94);
      expect(normal_16_94, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_95 = mesh_16.normals.elementAt(95);
      expect(normal_16_95, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_96 = mesh_16.normals.elementAt(96);
      expect(normal_16_96, vector3MoreOrLessEquals(Vector3(-0.844407, 0.508563, 0.168344)));
      final normal_16_97 = mesh_16.normals.elementAt(97);
      expect(normal_16_97, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672312, -0.625988)));
      final normal_16_98 = mesh_16.normals.elementAt(98);
      expect(normal_16_98, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_99 = mesh_16.normals.elementAt(99);
      expect(normal_16_99, vector3MoreOrLessEquals(Vector3(-0.844407, 0.508563, 0.168344)));
      final normal_16_100 = mesh_16.normals.elementAt(100);
      expect(normal_16_100, vector3MoreOrLessEquals(Vector3(-0.907377, 0.410201, 0.091666)));
      final normal_16_101 = mesh_16.normals.elementAt(101);
      expect(normal_16_101, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672312, -0.625988)));
      final normal_16_102 = mesh_16.normals.elementAt(102);
      expect(normal_16_102, vector3MoreOrLessEquals(Vector3(-0.943128, 0.331776, -0.02084)));
      final normal_16_103 = mesh_16.normals.elementAt(103);
      expect(normal_16_103, vector3MoreOrLessEquals(Vector3(-0.388204, 0.672327, -0.630297)));
      final normal_16_104 = mesh_16.normals.elementAt(104);
      expect(normal_16_104, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672312, -0.625988)));
      final normal_16_105 = mesh_16.normals.elementAt(105);
      expect(normal_16_105, vector3MoreOrLessEquals(Vector3(-0.907377, 0.410201, 0.091666)));
      final normal_16_106 = mesh_16.normals.elementAt(106);
      expect(normal_16_106, vector3MoreOrLessEquals(Vector3(-0.943128, 0.331776, -0.02084)));
      final normal_16_107 = mesh_16.normals.elementAt(107);
      expect(normal_16_107, vector3MoreOrLessEquals(Vector3(-0.39514, 0.672312, -0.625988)));
      final normal_16_108 = mesh_16.normals.elementAt(108);
      expect(normal_16_108, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_109 = mesh_16.normals.elementAt(109);
      expect(normal_16_109, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_110 = mesh_16.normals.elementAt(110);
      expect(normal_16_110, vector3MoreOrLessEquals(Vector3(0, 0, 0)));
      final normal_16_111 = mesh_16.normals.elementAt(111);
      expect(normal_16_111, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_112 = mesh_16.normals.elementAt(112);
      expect(normal_16_112, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_113 = mesh_16.normals.elementAt(113);
      expect(normal_16_113, vector3MoreOrLessEquals(Vector3(0.417208, 0.602931, 0.680009)));
      final normal_16_114 = mesh_16.normals.elementAt(114);
      expect(normal_16_114, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, 0.577998)));
      final normal_16_115 = mesh_16.normals.elementAt(115);
      expect(normal_16_115, vector3MoreOrLessEquals(Vector3(-0.907377, 0.410201, 0.091666)));
      final normal_16_116 = mesh_16.normals.elementAt(116);
      expect(normal_16_116, vector3MoreOrLessEquals(Vector3(-0.844407, 0.508563, 0.168344)));
      final normal_16_117 = mesh_16.normals.elementAt(117);
      expect(normal_16_117, vector3MoreOrLessEquals(Vector3(-0.390952, -0.506392, 0.768585)));
      final normal_16_118 = mesh_16.normals.elementAt(118);
      expect(normal_16_118, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, 0.577998)));
      final normal_16_119 = mesh_16.normals.elementAt(119);
      expect(normal_16_119, vector3MoreOrLessEquals(Vector3(-0.844407, 0.508563, 0.168344)));
      final normal_16_120 = mesh_16.normals.elementAt(120);
      expect(normal_16_120, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, 0.577998)));
      final normal_16_121 = mesh_16.normals.elementAt(121);
      expect(normal_16_121, vector3MoreOrLessEquals(Vector3(-0.943128, 0.331776, -0.02084)));
      final normal_16_122 = mesh_16.normals.elementAt(122);
      expect(normal_16_122, vector3MoreOrLessEquals(Vector3(-0.907377, 0.410201, 0.091666)));
      final normal_16_123 = mesh_16.normals.elementAt(123);
      expect(normal_16_123, vector3MoreOrLessEquals(Vector3(-0.785847, -0.219916, 0.577998)));
      final normal_16_124 = mesh_16.normals.elementAt(124);
      expect(normal_16_124, vector3MoreOrLessEquals(Vector3(-0.676852, -0.452073, 0.580948)));
      final normal_16_125 = mesh_16.normals.elementAt(125);
      expect(normal_16_125, vector3MoreOrLessEquals(Vector3(-0.943128, 0.331776, -0.02084)));
      expect(mesh_16.tangents.length, isZero);
      expect(mesh_16.bitangents.length, isZero);
      expect(mesh_16.colors.length, isZero);
      expect(mesh_16.textureCoords.length, equals(1));
      final textureCoords_16_0 = mesh_16.textureCoords.elementAt(0);
      expect(textureCoords_16_0.length, equals(126));
      final textureCoord_16_0_0 = textureCoords_16_0.elementAt(0);
      expect(textureCoord_16_0_0, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_1 = textureCoords_16_0.elementAt(1);
      expect(textureCoord_16_0_1, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_2 = textureCoords_16_0.elementAt(2);
      expect(textureCoord_16_0_2, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_3 = textureCoords_16_0.elementAt(3);
      expect(textureCoord_16_0_3, vector3MoreOrLessEquals(Vector3(0.487405, 0.409841, 0)));
      final textureCoord_16_0_4 = textureCoords_16_0.elementAt(4);
      expect(textureCoord_16_0_4, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_16_0_5 = textureCoords_16_0.elementAt(5);
      expect(textureCoord_16_0_5, vector3MoreOrLessEquals(Vector3(0.488018, 0.424091, 0)));
      final textureCoord_16_0_6 = textureCoords_16_0.elementAt(6);
      expect(textureCoord_16_0_6, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_16_0_7 = textureCoords_16_0.elementAt(7);
      expect(textureCoord_16_0_7, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_16_0_8 = textureCoords_16_0.elementAt(8);
      expect(textureCoord_16_0_8, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_9 = textureCoords_16_0.elementAt(9);
      expect(textureCoord_16_0_9, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_10 = textureCoords_16_0.elementAt(10);
      expect(textureCoord_16_0_10, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_16_0_11 = textureCoords_16_0.elementAt(11);
      expect(textureCoord_16_0_11, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_12 = textureCoords_16_0.elementAt(12);
      expect(textureCoord_16_0_12, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_16_0_13 = textureCoords_16_0.elementAt(13);
      expect(textureCoord_16_0_13, vector3MoreOrLessEquals(Vector3(0.488018, 0.424091, 0)));
      final textureCoord_16_0_14 = textureCoords_16_0.elementAt(14);
      expect(textureCoord_16_0_14, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_16_0_15 = textureCoords_16_0.elementAt(15);
      expect(textureCoord_16_0_15, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_16_0_16 = textureCoords_16_0.elementAt(16);
      expect(textureCoord_16_0_16, vector3MoreOrLessEquals(Vector3(0.487405, 0.409841, 0)));
      final textureCoord_16_0_17 = textureCoords_16_0.elementAt(17);
      expect(textureCoord_16_0_17, vector3MoreOrLessEquals(Vector3(0.488018, 0.424091, 0)));
      final textureCoord_16_0_18 = textureCoords_16_0.elementAt(18);
      expect(textureCoord_16_0_18, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_19 = textureCoords_16_0.elementAt(19);
      expect(textureCoord_16_0_19, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_20 = textureCoords_16_0.elementAt(20);
      expect(textureCoord_16_0_20, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_21 = textureCoords_16_0.elementAt(21);
      expect(textureCoord_16_0_21, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_16_0_22 = textureCoords_16_0.elementAt(22);
      expect(textureCoord_16_0_22, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_16_0_23 = textureCoords_16_0.elementAt(23);
      expect(textureCoord_16_0_23, vector3MoreOrLessEquals(Vector3(0.487405, 0.409841, 0)));
      final textureCoord_16_0_24 = textureCoords_16_0.elementAt(24);
      expect(textureCoord_16_0_24, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_25 = textureCoords_16_0.elementAt(25);
      expect(textureCoord_16_0_25, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_16_0_26 = textureCoords_16_0.elementAt(26);
      expect(textureCoord_16_0_26, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_27 = textureCoords_16_0.elementAt(27);
      expect(textureCoord_16_0_27, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_28 = textureCoords_16_0.elementAt(28);
      expect(textureCoord_16_0_28, vector3MoreOrLessEquals(Vector3(0.417973, 0.377579, 0)));
      final textureCoord_16_0_29 = textureCoords_16_0.elementAt(29);
      expect(textureCoord_16_0_29, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_16_0_30 = textureCoords_16_0.elementAt(30);
      expect(textureCoord_16_0_30, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_16_0_31 = textureCoords_16_0.elementAt(31);
      expect(textureCoord_16_0_31, vector3MoreOrLessEquals(Vector3(0.487405, 0.409841, 0)));
      final textureCoord_16_0_32 = textureCoords_16_0.elementAt(32);
      expect(textureCoord_16_0_32, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_16_0_33 = textureCoords_16_0.elementAt(33);
      expect(textureCoord_16_0_33, vector3MoreOrLessEquals(Vector3(0.417973, 0.377579, 0)));
      final textureCoord_16_0_34 = textureCoords_16_0.elementAt(34);
      expect(textureCoord_16_0_34, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_16_0_35 = textureCoords_16_0.elementAt(35);
      expect(textureCoord_16_0_35, vector3MoreOrLessEquals(Vector3(0.433297, 0.381048, 0)));
      final textureCoord_16_0_36 = textureCoords_16_0.elementAt(36);
      expect(textureCoord_16_0_36, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_37 = textureCoords_16_0.elementAt(37);
      expect(textureCoord_16_0_37, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_38 = textureCoords_16_0.elementAt(38);
      expect(textureCoord_16_0_38, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_39 = textureCoords_16_0.elementAt(39);
      expect(textureCoord_16_0_39, vector3MoreOrLessEquals(Vector3(0.445613, 0.423268, 0)));
      final textureCoord_16_0_40 = textureCoords_16_0.elementAt(40);
      expect(textureCoord_16_0_40, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_16_0_41 = textureCoords_16_0.elementAt(41);
      expect(textureCoord_16_0_41, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_16_0_42 = textureCoords_16_0.elementAt(42);
      expect(textureCoord_16_0_42, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_16_0_43 = textureCoords_16_0.elementAt(43);
      expect(textureCoord_16_0_43, vector3MoreOrLessEquals(Vector3(0.417973, 0.377579, 0)));
      final textureCoord_16_0_44 = textureCoords_16_0.elementAt(44);
      expect(textureCoord_16_0_44, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_45 = textureCoords_16_0.elementAt(45);
      expect(textureCoord_16_0_45, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_46 = textureCoords_16_0.elementAt(46);
      expect(textureCoord_16_0_46, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_16_0_47 = textureCoords_16_0.elementAt(47);
      expect(textureCoord_16_0_47, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_48 = textureCoords_16_0.elementAt(48);
      expect(textureCoord_16_0_48, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_16_0_49 = textureCoords_16_0.elementAt(49);
      expect(textureCoord_16_0_49, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_16_0_50 = textureCoords_16_0.elementAt(50);
      expect(textureCoord_16_0_50, vector3MoreOrLessEquals(Vector3(0.417973, 0.377579, 0)));
      final textureCoord_16_0_51 = textureCoords_16_0.elementAt(51);
      expect(textureCoord_16_0_51, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_16_0_52 = textureCoords_16_0.elementAt(52);
      expect(textureCoord_16_0_52, vector3MoreOrLessEquals(Vector3(0.445613, 0.423268, 0)));
      final textureCoord_16_0_53 = textureCoords_16_0.elementAt(53);
      expect(textureCoord_16_0_53, vector3MoreOrLessEquals(Vector3(0.468532, 0.409475, 0)));
      final textureCoord_16_0_54 = textureCoords_16_0.elementAt(54);
      expect(textureCoord_16_0_54, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_55 = textureCoords_16_0.elementAt(55);
      expect(textureCoord_16_0_55, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_56 = textureCoords_16_0.elementAt(56);
      expect(textureCoord_16_0_56, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_57 = textureCoords_16_0.elementAt(57);
      expect(textureCoord_16_0_57, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_16_0_58 = textureCoords_16_0.elementAt(58);
      expect(textureCoord_16_0_58, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_16_0_59 = textureCoords_16_0.elementAt(59);
      expect(textureCoord_16_0_59, vector3MoreOrLessEquals(Vector3(0.445613, 0.423268, 0)));
      final textureCoord_16_0_60 = textureCoords_16_0.elementAt(60);
      expect(textureCoord_16_0_60, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_61 = textureCoords_16_0.elementAt(61);
      expect(textureCoord_16_0_61, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_16_0_62 = textureCoords_16_0.elementAt(62);
      expect(textureCoord_16_0_62, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_63 = textureCoords_16_0.elementAt(63);
      expect(textureCoord_16_0_63, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_64 = textureCoords_16_0.elementAt(64);
      expect(textureCoord_16_0_64, vector3MoreOrLessEquals(Vector3(0.392751, 0.3982, 0)));
      final textureCoord_16_0_65 = textureCoords_16_0.elementAt(65);
      expect(textureCoord_16_0_65, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_16_0_66 = textureCoords_16_0.elementAt(66);
      expect(textureCoord_16_0_66, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_16_0_67 = textureCoords_16_0.elementAt(67);
      expect(textureCoord_16_0_67, vector3MoreOrLessEquals(Vector3(0.445613, 0.423268, 0)));
      final textureCoord_16_0_68 = textureCoords_16_0.elementAt(68);
      expect(textureCoord_16_0_68, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_16_0_69 = textureCoords_16_0.elementAt(69);
      expect(textureCoord_16_0_69, vector3MoreOrLessEquals(Vector3(0.392751, 0.3982, 0)));
      final textureCoord_16_0_70 = textureCoords_16_0.elementAt(70);
      expect(textureCoord_16_0_70, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_16_0_71 = textureCoords_16_0.elementAt(71);
      expect(textureCoord_16_0_71, vector3MoreOrLessEquals(Vector3(0.399928, 0.385213, 0)));
      final textureCoord_16_0_72 = textureCoords_16_0.elementAt(72);
      expect(textureCoord_16_0_72, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_73 = textureCoords_16_0.elementAt(73);
      expect(textureCoord_16_0_73, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_74 = textureCoords_16_0.elementAt(74);
      expect(textureCoord_16_0_74, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_75 = textureCoords_16_0.elementAt(75);
      expect(textureCoord_16_0_75, vector3MoreOrLessEquals(Vector3(0.446719, 0.448945, 0)));
      final textureCoord_16_0_76 = textureCoords_16_0.elementAt(76);
      expect(textureCoord_16_0_76, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_16_0_77 = textureCoords_16_0.elementAt(77);
      expect(textureCoord_16_0_77, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_16_0_78 = textureCoords_16_0.elementAt(78);
      expect(textureCoord_16_0_78, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_16_0_79 = textureCoords_16_0.elementAt(79);
      expect(textureCoord_16_0_79, vector3MoreOrLessEquals(Vector3(0.392751, 0.3982, 0)));
      final textureCoord_16_0_80 = textureCoords_16_0.elementAt(80);
      expect(textureCoord_16_0_80, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_81 = textureCoords_16_0.elementAt(81);
      expect(textureCoord_16_0_81, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_82 = textureCoords_16_0.elementAt(82);
      expect(textureCoord_16_0_82, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_16_0_83 = textureCoords_16_0.elementAt(83);
      expect(textureCoord_16_0_83, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_84 = textureCoords_16_0.elementAt(84);
      expect(textureCoord_16_0_84, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_16_0_85 = textureCoords_16_0.elementAt(85);
      expect(textureCoord_16_0_85, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_16_0_86 = textureCoords_16_0.elementAt(86);
      expect(textureCoord_16_0_86, vector3MoreOrLessEquals(Vector3(0.392751, 0.3982, 0)));
      final textureCoord_16_0_87 = textureCoords_16_0.elementAt(87);
      expect(textureCoord_16_0_87, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_16_0_88 = textureCoords_16_0.elementAt(88);
      expect(textureCoord_16_0_88, vector3MoreOrLessEquals(Vector3(0.446719, 0.448945, 0)));
      final textureCoord_16_0_89 = textureCoords_16_0.elementAt(89);
      expect(textureCoord_16_0_89, vector3MoreOrLessEquals(Vector3(0.435904, 0.440834, 0)));
      final textureCoord_16_0_90 = textureCoords_16_0.elementAt(90);
      expect(textureCoord_16_0_90, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_91 = textureCoords_16_0.elementAt(91);
      expect(textureCoord_16_0_91, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_92 = textureCoords_16_0.elementAt(92);
      expect(textureCoord_16_0_92, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_93 = textureCoords_16_0.elementAt(93);
      expect(textureCoord_16_0_93, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_16_0_94 = textureCoords_16_0.elementAt(94);
      expect(textureCoord_16_0_94, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_16_0_95 = textureCoords_16_0.elementAt(95);
      expect(textureCoord_16_0_95, vector3MoreOrLessEquals(Vector3(0.446719, 0.448945, 0)));
      final textureCoord_16_0_96 = textureCoords_16_0.elementAt(96);
      expect(textureCoord_16_0_96, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_97 = textureCoords_16_0.elementAt(97);
      expect(textureCoord_16_0_97, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_16_0_98 = textureCoords_16_0.elementAt(98);
      expect(textureCoord_16_0_98, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_99 = textureCoords_16_0.elementAt(99);
      expect(textureCoord_16_0_99, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_100 = textureCoords_16_0.elementAt(100);
      expect(textureCoord_16_0_100, vector3MoreOrLessEquals(Vector3(0.420363, 0.404451, 0)));
      final textureCoord_16_0_101 = textureCoords_16_0.elementAt(101);
      expect(textureCoord_16_0_101, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_16_0_102 = textureCoords_16_0.elementAt(102);
      expect(textureCoord_16_0_102, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_16_0_103 = textureCoords_16_0.elementAt(103);
      expect(textureCoord_16_0_103, vector3MoreOrLessEquals(Vector3(0.446719, 0.448945, 0)));
      final textureCoord_16_0_104 = textureCoords_16_0.elementAt(104);
      expect(textureCoord_16_0_104, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_16_0_105 = textureCoords_16_0.elementAt(105);
      expect(textureCoord_16_0_105, vector3MoreOrLessEquals(Vector3(0.420363, 0.404451, 0)));
      final textureCoord_16_0_106 = textureCoords_16_0.elementAt(106);
      expect(textureCoord_16_0_106, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_16_0_107 = textureCoords_16_0.elementAt(107);
      expect(textureCoord_16_0_107, vector3MoreOrLessEquals(Vector3(0.401845, 0.406762, 0)));
      final textureCoord_16_0_108 = textureCoords_16_0.elementAt(108);
      expect(textureCoord_16_0_108, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_109 = textureCoords_16_0.elementAt(109);
      expect(textureCoord_16_0_109, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_110 = textureCoords_16_0.elementAt(110);
      expect(textureCoord_16_0_110, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_111 = textureCoords_16_0.elementAt(111);
      expect(textureCoord_16_0_111, vector3MoreOrLessEquals(Vector3(0.488018, 0.424091, 0)));
      final textureCoord_16_0_112 = textureCoords_16_0.elementAt(112);
      expect(textureCoord_16_0_112, vector3MoreOrLessEquals(Vector3(0.463158, 0.428278, 0)));
      final textureCoord_16_0_113 = textureCoords_16_0.elementAt(113);
      expect(textureCoord_16_0_113, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_16_0_114 = textureCoords_16_0.elementAt(114);
      expect(textureCoord_16_0_114, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_16_0_115 = textureCoords_16_0.elementAt(115);
      expect(textureCoord_16_0_115, vector3MoreOrLessEquals(Vector3(0.420363, 0.404451, 0)));
      final textureCoord_16_0_116 = textureCoords_16_0.elementAt(116);
      expect(textureCoord_16_0_116, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_117 = textureCoords_16_0.elementAt(117);
      expect(textureCoord_16_0_117, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_118 = textureCoords_16_0.elementAt(118);
      expect(textureCoord_16_0_118, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_16_0_119 = textureCoords_16_0.elementAt(119);
      expect(textureCoord_16_0_119, vector3MoreOrLessEquals(Vector3(0.34481, 0.338084, 0)));
      final textureCoord_16_0_120 = textureCoords_16_0.elementAt(120);
      expect(textureCoord_16_0_120, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_16_0_121 = textureCoords_16_0.elementAt(121);
      expect(textureCoord_16_0_121, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      final textureCoord_16_0_122 = textureCoords_16_0.elementAt(122);
      expect(textureCoord_16_0_122, vector3MoreOrLessEquals(Vector3(0.420363, 0.404451, 0)));
      final textureCoord_16_0_123 = textureCoords_16_0.elementAt(123);
      expect(textureCoord_16_0_123, vector3MoreOrLessEquals(Vector3(0.434361, 0.393007, 0)));
      final textureCoord_16_0_124 = textureCoords_16_0.elementAt(124);
      expect(textureCoord_16_0_124, vector3MoreOrLessEquals(Vector3(0.488018, 0.424091, 0)));
      final textureCoord_16_0_125 = textureCoords_16_0.elementAt(125);
      expect(textureCoord_16_0_125, vector3MoreOrLessEquals(Vector3(0.469911, 0.441494, 0)));
      expect(mesh_16.uvComponents.length, equals(1));
      expect(mesh_16.uvComponents, equals([2]));
      expect(mesh_16.faces.length, equals(42));
      expect(mesh_16.bones.length, isZero);
      expect(mesh_16.materialIndex, equals(4));
      expect(mesh_16.name, equals('klZahn2'));
      expect(mesh_16.animMeshes.length, isZero);
      expect(mesh_16.morphingMethod, isZero);
      expect(mesh_16.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_17 = meshes.elementAt(17);
      expect(mesh_17.primitiveTypes, equals(4));
      expect(mesh_17.vertices.length, equals(114));
      final vertex_17_0 = mesh_17.vertices.elementAt(0);
      expect(vertex_17_0, vector3MoreOrLessEquals(Vector3(-59.6705, 17.6709, -1.85303)));
      final vertex_17_1 = mesh_17.vertices.elementAt(1);
      expect(vertex_17_1, vector3MoreOrLessEquals(Vector3(-58.7436, 17.5185, -2.2717)));
      final vertex_17_2 = mesh_17.vertices.elementAt(2);
      expect(vertex_17_2, vector3MoreOrLessEquals(Vector3(-59.467, 18.4067, -2.53898)));
      final vertex_17_3 = mesh_17.vertices.elementAt(3);
      expect(vertex_17_3, vector3MoreOrLessEquals(Vector3(-59.6705, 17.6709, -1.85303)));
      final vertex_17_4 = mesh_17.vertices.elementAt(4);
      expect(vertex_17_4, vector3MoreOrLessEquals(Vector3(-59.467, 18.4067, -2.53898)));
      final vertex_17_5 = mesh_17.vertices.elementAt(5);
      expect(vertex_17_5, vector3MoreOrLessEquals(Vector3(-60.6376, 18.1035, -2.33792)));
      final vertex_17_6 = mesh_17.vertices.elementAt(6);
      expect(vertex_17_6, vector3MoreOrLessEquals(Vector3(-61.5559, 18.1542, -3.37207)));
      final vertex_17_7 = mesh_17.vertices.elementAt(7);
      expect(vertex_17_7, vector3MoreOrLessEquals(Vector3(-60.6376, 18.1035, -2.33792)));
      final vertex_17_8 = mesh_17.vertices.elementAt(8);
      expect(vertex_17_8, vector3MoreOrLessEquals(Vector3(-60.5752, 18.6909, -3.43184)));
      final vertex_17_9 = mesh_17.vertices.elementAt(9);
      expect(vertex_17_9, vector3MoreOrLessEquals(Vector3(-60.6376, 18.1035, -2.33792)));
      final vertex_17_10 = mesh_17.vertices.elementAt(10);
      expect(vertex_17_10, vector3MoreOrLessEquals(Vector3(-59.467, 18.4067, -2.53898)));
      final vertex_17_11 = mesh_17.vertices.elementAt(11);
      expect(vertex_17_11, vector3MoreOrLessEquals(Vector3(-60.5752, 18.6909, -3.43184)));
      final vertex_17_12 = mesh_17.vertices.elementAt(12);
      expect(vertex_17_12, vector3MoreOrLessEquals(Vector3(-61.5559, 18.1542, -3.37207)));
      final vertex_17_13 = mesh_17.vertices.elementAt(13);
      expect(vertex_17_13, vector3MoreOrLessEquals(Vector3(-60.5752, 18.6909, -3.43184)));
      final vertex_17_14 = mesh_17.vertices.elementAt(14);
      expect(vertex_17_14, vector3MoreOrLessEquals(Vector3(-61.6449, 18.2623, -4.60926)));
      final vertex_17_15 = mesh_17.vertices.elementAt(15);
      expect(vertex_17_15, vector3MoreOrLessEquals(Vector3(-61.3842, 17.9411, -5.71727)));
      final vertex_17_16 = mesh_17.vertices.elementAt(16);
      expect(vertex_17_16, vector3MoreOrLessEquals(Vector3(-61.4815, 16.9839, -6.44816)));
      final vertex_17_17 = mesh_17.vertices.elementAt(17);
      expect(vertex_17_17, vector3MoreOrLessEquals(Vector3(-62.2674, 17.2848, -5.62151)));
      final vertex_17_18 = mesh_17.vertices.elementAt(18);
      expect(vertex_17_18, vector3MoreOrLessEquals(Vector3(-62.615, 16.4912, -5.0942)));
      final vertex_17_19 = mesh_17.vertices.elementAt(19);
      expect(vertex_17_19, vector3MoreOrLessEquals(Vector3(-62.2674, 17.2848, -5.62151)));
      final vertex_17_20 = mesh_17.vertices.elementAt(20);
      expect(vertex_17_20, vector3MoreOrLessEquals(Vector3(-62.205, 16.1317, -6.08192)));
      final vertex_17_21 = mesh_17.vertices.elementAt(21);
      expect(vertex_17_21, vector3MoreOrLessEquals(Vector3(-61.2781, 15.9793, -6.50059)));
      final vertex_17_22 = mesh_17.vertices.elementAt(22);
      expect(vertex_17_22, vector3MoreOrLessEquals(Vector3(-62.205, 16.1317, -6.08192)));
      final vertex_17_23 = mesh_17.vertices.elementAt(23);
      expect(vertex_17_23, vector3MoreOrLessEquals(Vector3(-61.4815, 16.9839, -6.44816)));
      final vertex_17_24 = mesh_17.vertices.elementAt(24);
      expect(vertex_17_24, vector3MoreOrLessEquals(Vector3(-62.2674, 17.2848, -5.62151)));
      final vertex_17_25 = mesh_17.vertices.elementAt(25);
      expect(vertex_17_25, vector3MoreOrLessEquals(Vector3(-61.4815, 16.9839, -6.44816)));
      final vertex_17_26 = mesh_17.vertices.elementAt(26);
      expect(vertex_17_26, vector3MoreOrLessEquals(Vector3(-62.205, 16.1317, -6.08192)));
      final vertex_17_27 = mesh_17.vertices.elementAt(27);
      expect(vertex_17_27, vector3MoreOrLessEquals(Vector3(-62.615, 16.4912, -5.0942)));
      final vertex_17_28 = mesh_17.vertices.elementAt(28);
      expect(vertex_17_28, vector3MoreOrLessEquals(Vector3(-62.205, 16.1317, -6.08192)));
      final vertex_17_29 = mesh_17.vertices.elementAt(29);
      expect(vertex_17_29, vector3MoreOrLessEquals(Vector3(-62.2674, 15.5443, -4.98801)));
      final vertex_17_30 = mesh_17.vertices.elementAt(30);
      expect(vertex_17_30, vector3MoreOrLessEquals(Vector3(-61.3842, 14.9799, -4.6395)));
      final vertex_17_31 = mesh_17.vertices.elementAt(31);
      expect(vertex_17_31, vector3MoreOrLessEquals(Vector3(-62.2674, 15.5443, -4.98801)));
      final vertex_17_32 = mesh_17.vertices.elementAt(32);
      expect(vertex_17_32, vector3MoreOrLessEquals(Vector3(-61.4815, 15.2434, -5.81466)));
      final vertex_17_33 = mesh_17.vertices.elementAt(33);
      expect(vertex_17_33, vector3MoreOrLessEquals(Vector3(-61.2781, 15.9793, -6.50059)));
      final vertex_17_34 = mesh_17.vertices.elementAt(34);
      expect(vertex_17_34, vector3MoreOrLessEquals(Vector3(-61.4815, 15.2434, -5.81466)));
      final vertex_17_35 = mesh_17.vertices.elementAt(35);
      expect(vertex_17_35, vector3MoreOrLessEquals(Vector3(-62.205, 16.1317, -6.08192)));
      final vertex_17_36 = mesh_17.vertices.elementAt(36);
      expect(vertex_17_36, vector3MoreOrLessEquals(Vector3(-62.2674, 15.5443, -4.98801)));
      final vertex_17_37 = mesh_17.vertices.elementAt(37);
      expect(vertex_17_37, vector3MoreOrLessEquals(Vector3(-62.205, 16.1317, -6.08192)));
      final vertex_17_38 = mesh_17.vertices.elementAt(38);
      expect(vertex_17_38, vector3MoreOrLessEquals(Vector3(-61.4815, 15.2434, -5.81466)));
      final vertex_17_39 = mesh_17.vertices.elementAt(39);
      expect(vertex_17_39, vector3MoreOrLessEquals(Vector3(-61.3842, 14.9799, -4.6395)));
      final vertex_17_40 = mesh_17.vertices.elementAt(40);
      expect(vertex_17_40, vector3MoreOrLessEquals(Vector3(-60.4743, 15.0845, -3.54331)));
      final vertex_17_41 = mesh_17.vertices.elementAt(41);
      expect(vertex_17_41, vector3MoreOrLessEquals(Vector3(-61.6449, 15.4461, -3.58423)));
      final vertex_17_42 = mesh_17.vertices.elementAt(42);
      expect(vertex_17_42, vector3MoreOrLessEquals(Vector3(-61.5559, 16.3241, -2.70597)));
      final vertex_17_43 = mesh_17.vertices.elementAt(43);
      expect(vertex_17_43, vector3MoreOrLessEquals(Vector3(-61.6449, 15.4461, -3.58423)));
      final vertex_17_44 = mesh_17.vertices.elementAt(44);
      expect(vertex_17_44, vector3MoreOrLessEquals(Vector3(-60.5752, 15.8746, -2.40682)));
      final vertex_17_45 = mesh_17.vertices.elementAt(45);
      expect(vertex_17_45, vector3MoreOrLessEquals(Vector3(-59.5644, 15.709, -2.63635)));
      final vertex_17_46 = mesh_17.vertices.elementAt(46);
      expect(vertex_17_46, vector3MoreOrLessEquals(Vector3(-60.5752, 15.8746, -2.40682)));
      final vertex_17_47 = mesh_17.vertices.elementAt(47);
      expect(vertex_17_47, vector3MoreOrLessEquals(Vector3(-60.4743, 15.0845, -3.54331)));
      final vertex_17_48 = mesh_17.vertices.elementAt(48);
      expect(vertex_17_48, vector3MoreOrLessEquals(Vector3(-61.6449, 15.4461, -3.58423)));
      final vertex_17_49 = mesh_17.vertices.elementAt(49);
      expect(vertex_17_49, vector3MoreOrLessEquals(Vector3(-60.4743, 15.0845, -3.54331)));
      final vertex_17_50 = mesh_17.vertices.elementAt(50);
      expect(vertex_17_50, vector3MoreOrLessEquals(Vector3(-60.5752, 15.8746, -2.40682)));
      final vertex_17_51 = mesh_17.vertices.elementAt(51);
      expect(vertex_17_51, vector3MoreOrLessEquals(Vector3(-61.5559, 16.3241, -2.70597)));
      final vertex_17_52 = mesh_17.vertices.elementAt(52);
      expect(vertex_17_52, vector3MoreOrLessEquals(Vector3(-60.5752, 15.8746, -2.40682)));
      final vertex_17_53 = mesh_17.vertices.elementAt(53);
      expect(vertex_17_53, vector3MoreOrLessEquals(Vector3(-60.6376, 17.0278, -1.9464)));
      final vertex_17_54 = mesh_17.vertices.elementAt(54);
      expect(vertex_17_54, vector3MoreOrLessEquals(Vector3(-59.6705, 17.6709, -1.85303)));
      final vertex_17_55 = mesh_17.vertices.elementAt(55);
      expect(vertex_17_55, vector3MoreOrLessEquals(Vector3(-60.6376, 17.0278, -1.9464)));
      final vertex_17_56 = mesh_17.vertices.elementAt(56);
      expect(vertex_17_56, vector3MoreOrLessEquals(Vector3(-59.467, 16.6662, -1.90547)));
      final vertex_17_57 = mesh_17.vertices.elementAt(57);
      expect(vertex_17_57, vector3MoreOrLessEquals(Vector3(-59.5644, 15.709, -2.63635)));
      final vertex_17_58 = mesh_17.vertices.elementAt(58);
      expect(vertex_17_58, vector3MoreOrLessEquals(Vector3(-59.467, 16.6662, -1.90547)));
      final vertex_17_59 = mesh_17.vertices.elementAt(59);
      expect(vertex_17_59, vector3MoreOrLessEquals(Vector3(-60.5752, 15.8746, -2.40682)));
      final vertex_17_60 = mesh_17.vertices.elementAt(60);
      expect(vertex_17_60, vector3MoreOrLessEquals(Vector3(-60.6376, 17.0278, -1.9464)));
      final vertex_17_61 = mesh_17.vertices.elementAt(61);
      expect(vertex_17_61, vector3MoreOrLessEquals(Vector3(-60.5752, 15.8746, -2.40682)));
      final vertex_17_62 = mesh_17.vertices.elementAt(62);
      expect(vertex_17_62, vector3MoreOrLessEquals(Vector3(-59.467, 16.6662, -1.90547)));
      final vertex_17_63 = mesh_17.vertices.elementAt(63);
      expect(vertex_17_63, vector3MoreOrLessEquals(Vector3(-59.6705, 17.6709, -1.85303)));
      final vertex_17_64 = mesh_17.vertices.elementAt(64);
      expect(vertex_17_64, vector3MoreOrLessEquals(Vector3(-59.467, 16.6662, -1.90547)));
      final vertex_17_65 = mesh_17.vertices.elementAt(65);
      expect(vertex_17_65, vector3MoreOrLessEquals(Vector3(-58.7436, 17.5185, -2.2717)));
      final vertex_17_66 = mesh_17.vertices.elementAt(66);
      expect(vertex_17_66, vector3MoreOrLessEquals(Vector3(-61.5559, 18.1542, -3.37207)));
      final vertex_17_67 = mesh_17.vertices.elementAt(67);
      expect(vertex_17_67, vector3MoreOrLessEquals(Vector3(-61.7458, 17.3119, -2.83926)));
      final vertex_17_68 = mesh_17.vertices.elementAt(68);
      expect(vertex_17_68, vector3MoreOrLessEquals(Vector3(-60.6376, 18.1035, -2.33792)));
      final vertex_17_69 = mesh_17.vertices.elementAt(69);
      expect(vertex_17_69, vector3MoreOrLessEquals(Vector3(-59.6705, 17.6709, -1.85303)));
      final vertex_17_70 = mesh_17.vertices.elementAt(70);
      expect(vertex_17_70, vector3MoreOrLessEquals(Vector3(-60.6376, 18.1035, -2.33792)));
      final vertex_17_71 = mesh_17.vertices.elementAt(71);
      expect(vertex_17_71, vector3MoreOrLessEquals(Vector3(-60.6376, 17.0278, -1.9464)));
      final vertex_17_72 = mesh_17.vertices.elementAt(72);
      expect(vertex_17_72, vector3MoreOrLessEquals(Vector3(-61.5559, 16.3241, -2.70597)));
      final vertex_17_73 = mesh_17.vertices.elementAt(73);
      expect(vertex_17_73, vector3MoreOrLessEquals(Vector3(-60.6376, 17.0278, -1.9464)));
      final vertex_17_74 = mesh_17.vertices.elementAt(74);
      expect(vertex_17_74, vector3MoreOrLessEquals(Vector3(-61.7458, 17.3119, -2.83926)));
      final vertex_17_75 = mesh_17.vertices.elementAt(75);
      expect(vertex_17_75, vector3MoreOrLessEquals(Vector3(-60.6376, 18.1035, -2.33792)));
      final vertex_17_76 = mesh_17.vertices.elementAt(76);
      expect(vertex_17_76, vector3MoreOrLessEquals(Vector3(-61.7458, 17.3119, -2.83926)));
      final vertex_17_77 = mesh_17.vertices.elementAt(77);
      expect(vertex_17_77, vector3MoreOrLessEquals(Vector3(-60.6376, 17.0278, -1.9464)));
      final vertex_17_78 = mesh_17.vertices.elementAt(78);
      expect(vertex_17_78, vector3MoreOrLessEquals(Vector3(-61.5559, 18.1542, -3.37207)));
      final vertex_17_79 = mesh_17.vertices.elementAt(79);
      expect(vertex_17_79, vector3MoreOrLessEquals(Vector3(-62.3683, 17.4101, -4.24303)));
      final vertex_17_80 = mesh_17.vertices.elementAt(80);
      expect(vertex_17_80, vector3MoreOrLessEquals(Vector3(-61.7458, 17.3119, -2.83926)));
      final vertex_17_81 = mesh_17.vertices.elementAt(81);
      expect(vertex_17_81, vector3MoreOrLessEquals(Vector3(-61.5559, 16.3241, -2.70597)));
      final vertex_17_82 = mesh_17.vertices.elementAt(82);
      expect(vertex_17_82, vector3MoreOrLessEquals(Vector3(-61.7458, 17.3119, -2.83926)));
      final vertex_17_83 = mesh_17.vertices.elementAt(83);
      expect(vertex_17_83, vector3MoreOrLessEquals(Vector3(-62.3683, 16.3344, -3.85151)));
      final vertex_17_84 = mesh_17.vertices.elementAt(84);
      expect(vertex_17_84, vector3MoreOrLessEquals(Vector3(-62.615, 16.4912, -5.0942)));
      final vertex_17_85 = mesh_17.vertices.elementAt(85);
      expect(vertex_17_85, vector3MoreOrLessEquals(Vector3(-62.3683, 16.3344, -3.85151)));
      final vertex_17_86 = mesh_17.vertices.elementAt(86);
      expect(vertex_17_86, vector3MoreOrLessEquals(Vector3(-62.3683, 17.4101, -4.24303)));
      final vertex_17_87 = mesh_17.vertices.elementAt(87);
      expect(vertex_17_87, vector3MoreOrLessEquals(Vector3(-61.7458, 17.3119, -2.83926)));
      final vertex_17_88 = mesh_17.vertices.elementAt(88);
      expect(vertex_17_88, vector3MoreOrLessEquals(Vector3(-62.3683, 17.4101, -4.24303)));
      final vertex_17_89 = mesh_17.vertices.elementAt(89);
      expect(vertex_17_89, vector3MoreOrLessEquals(Vector3(-62.3683, 16.3344, -3.85151)));
      final vertex_17_90 = mesh_17.vertices.elementAt(90);
      expect(vertex_17_90, vector3MoreOrLessEquals(Vector3(-61.5559, 18.1542, -3.37207)));
      final vertex_17_91 = mesh_17.vertices.elementAt(91);
      expect(vertex_17_91, vector3MoreOrLessEquals(Vector3(-61.6449, 18.2623, -4.60926)));
      final vertex_17_92 = mesh_17.vertices.elementAt(92);
      expect(vertex_17_92, vector3MoreOrLessEquals(Vector3(-62.3683, 17.4101, -4.24303)));
      final vertex_17_93 = mesh_17.vertices.elementAt(93);
      expect(vertex_17_93, vector3MoreOrLessEquals(Vector3(-62.615, 16.4912, -5.0942)));
      final vertex_17_94 = mesh_17.vertices.elementAt(94);
      expect(vertex_17_94, vector3MoreOrLessEquals(Vector3(-62.3683, 17.4101, -4.24303)));
      final vertex_17_95 = mesh_17.vertices.elementAt(95);
      expect(vertex_17_95, vector3MoreOrLessEquals(Vector3(-62.2674, 17.2848, -5.62151)));
      final vertex_17_96 = mesh_17.vertices.elementAt(96);
      expect(vertex_17_96, vector3MoreOrLessEquals(Vector3(-61.3842, 17.9411, -5.71727)));
      final vertex_17_97 = mesh_17.vertices.elementAt(97);
      expect(vertex_17_97, vector3MoreOrLessEquals(Vector3(-62.2674, 17.2848, -5.62151)));
      final vertex_17_98 = mesh_17.vertices.elementAt(98);
      expect(vertex_17_98, vector3MoreOrLessEquals(Vector3(-61.6449, 18.2623, -4.60926)));
      final vertex_17_99 = mesh_17.vertices.elementAt(99);
      expect(vertex_17_99, vector3MoreOrLessEquals(Vector3(-62.3683, 17.4101, -4.24303)));
      final vertex_17_100 = mesh_17.vertices.elementAt(100);
      expect(vertex_17_100, vector3MoreOrLessEquals(Vector3(-61.6449, 18.2623, -4.60926)));
      final vertex_17_101 = mesh_17.vertices.elementAt(101);
      expect(vertex_17_101, vector3MoreOrLessEquals(Vector3(-62.2674, 17.2848, -5.62151)));
      final vertex_17_102 = mesh_17.vertices.elementAt(102);
      expect(vertex_17_102, vector3MoreOrLessEquals(Vector3(-61.3842, 14.9799, -4.6395)));
      final vertex_17_103 = mesh_17.vertices.elementAt(103);
      expect(vertex_17_103, vector3MoreOrLessEquals(Vector3(-61.6449, 15.4461, -3.58423)));
      final vertex_17_104 = mesh_17.vertices.elementAt(104);
      expect(vertex_17_104, vector3MoreOrLessEquals(Vector3(-62.2674, 15.5443, -4.98801)));
      final vertex_17_105 = mesh_17.vertices.elementAt(105);
      expect(vertex_17_105, vector3MoreOrLessEquals(Vector3(-62.615, 16.4912, -5.0942)));
      final vertex_17_106 = mesh_17.vertices.elementAt(106);
      expect(vertex_17_106, vector3MoreOrLessEquals(Vector3(-62.2674, 15.5443, -4.98801)));
      final vertex_17_107 = mesh_17.vertices.elementAt(107);
      expect(vertex_17_107, vector3MoreOrLessEquals(Vector3(-62.3683, 16.3344, -3.85151)));
      final vertex_17_108 = mesh_17.vertices.elementAt(108);
      expect(vertex_17_108, vector3MoreOrLessEquals(Vector3(-61.5559, 16.3241, -2.70597)));
      final vertex_17_109 = mesh_17.vertices.elementAt(109);
      expect(vertex_17_109, vector3MoreOrLessEquals(Vector3(-62.3683, 16.3344, -3.85151)));
      final vertex_17_110 = mesh_17.vertices.elementAt(110);
      expect(vertex_17_110, vector3MoreOrLessEquals(Vector3(-61.6449, 15.4461, -3.58423)));
      final vertex_17_111 = mesh_17.vertices.elementAt(111);
      expect(vertex_17_111, vector3MoreOrLessEquals(Vector3(-62.2674, 15.5443, -4.98801)));
      final vertex_17_112 = mesh_17.vertices.elementAt(112);
      expect(vertex_17_112, vector3MoreOrLessEquals(Vector3(-61.6449, 15.4461, -3.58423)));
      final vertex_17_113 = mesh_17.vertices.elementAt(113);
      expect(vertex_17_113, vector3MoreOrLessEquals(Vector3(-62.3683, 16.3344, -3.85151)));
      expect(mesh_17.normals.length, equals(114));
      final normal_17_0 = mesh_17.normals.elementAt(0);
      expect(normal_17_0, vector3MoreOrLessEquals(Vector3(0.092832, 0.340544, 0.935634)));
      final normal_17_1 = mesh_17.normals.elementAt(1);
      expect(normal_17_1, vector3MoreOrLessEquals(Vector3(0.433215, 0.30826, 0.846936)));
      final normal_17_2 = mesh_17.normals.elementAt(2);
      expect(normal_17_2, vector3MoreOrLessEquals(Vector3(0.075136, 0.741809, 0.666389)));
      final normal_17_3 = mesh_17.normals.elementAt(3);
      expect(normal_17_3, vector3MoreOrLessEquals(Vector3(0.092832, 0.340544, 0.935634)));
      final normal_17_4 = mesh_17.normals.elementAt(4);
      expect(normal_17_4, vector3MoreOrLessEquals(Vector3(0.075136, 0.741809, 0.666389)));
      final normal_17_5 = mesh_17.normals.elementAt(5);
      expect(normal_17_5, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, 0.686654)));
      final normal_17_6 = mesh_17.normals.elementAt(6);
      expect(normal_17_6, vector3MoreOrLessEquals(Vector3(-0.641388, 0.689588, 0.336288)));
      final normal_17_7 = mesh_17.normals.elementAt(7);
      expect(normal_17_7, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, 0.686654)));
      final normal_17_8 = mesh_17.normals.elementAt(8);
      expect(normal_17_8, vector3MoreOrLessEquals(Vector3(-0.353918, 0.873123, 0.335258)));
      final normal_17_9 = mesh_17.normals.elementAt(9);
      expect(normal_17_9, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, 0.686654)));
      final normal_17_10 = mesh_17.normals.elementAt(10);
      expect(normal_17_10, vector3MoreOrLessEquals(Vector3(0.075136, 0.741809, 0.666389)));
      final normal_17_11 = mesh_17.normals.elementAt(11);
      expect(normal_17_11, vector3MoreOrLessEquals(Vector3(-0.353918, 0.873123, 0.335258)));
      final normal_17_12 = mesh_17.normals.elementAt(12);
      expect(normal_17_12, vector3MoreOrLessEquals(Vector3(-0.641388, 0.689588, 0.336288)));
      final normal_17_13 = mesh_17.normals.elementAt(13);
      expect(normal_17_13, vector3MoreOrLessEquals(Vector3(-0.353918, 0.873123, 0.335258)));
      final normal_17_14 = mesh_17.normals.elementAt(14);
      expect(normal_17_14, vector3MoreOrLessEquals(Vector3(-0.662764, 0.746241, -0.062188)));
      final normal_17_15 = mesh_17.normals.elementAt(15);
      expect(normal_17_15, vector3MoreOrLessEquals(Vector3(-0.545563, 0.658509, -0.518389)));
      final normal_17_16 = mesh_17.normals.elementAt(16);
      expect(normal_17_16, vector3MoreOrLessEquals(Vector3(-0.542286, 0.268594, -0.796105)));
      final normal_17_17 = mesh_17.normals.elementAt(17);
      expect(normal_17_17, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, -0.422116)));
      final normal_17_18 = mesh_17.normals.elementAt(18);
      expect(normal_17_18, vector3MoreOrLessEquals(Vector3(-0.995559, -0.032197, -0.088459)));
      final normal_17_19 = mesh_17.normals.elementAt(19);
      expect(normal_17_19, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, -0.422116)));
      final normal_17_20 = mesh_17.normals.elementAt(20);
      expect(normal_17_20, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, -0.633948)));
      final normal_17_21 = mesh_17.normals.elementAt(21);
      expect(normal_17_21, vector3MoreOrLessEquals(Vector3(-0.433216, -0.308258, -0.846936)));
      final normal_17_22 = mesh_17.normals.elementAt(22);
      expect(normal_17_22, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, -0.633948)));
      final normal_17_23 = mesh_17.normals.elementAt(23);
      expect(normal_17_23, vector3MoreOrLessEquals(Vector3(-0.542286, 0.268594, -0.796105)));
      final normal_17_24 = mesh_17.normals.elementAt(24);
      expect(normal_17_24, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, -0.422116)));
      final normal_17_25 = mesh_17.normals.elementAt(25);
      expect(normal_17_25, vector3MoreOrLessEquals(Vector3(-0.542286, 0.268594, -0.796105)));
      final normal_17_26 = mesh_17.normals.elementAt(26);
      expect(normal_17_26, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, -0.633948)));
      final normal_17_27 = mesh_17.normals.elementAt(27);
      expect(normal_17_27, vector3MoreOrLessEquals(Vector3(-0.995559, -0.032197, -0.088459)));
      final normal_17_28 = mesh_17.normals.elementAt(28);
      expect(normal_17_28, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, -0.633948)));
      final normal_17_29 = mesh_17.normals.elementAt(29);
      expect(normal_17_29, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629857, -0.022517)));
      final normal_17_30 = mesh_17.normals.elementAt(30);
      expect(normal_17_30, vector3MoreOrLessEquals(Vector3(-0.467564, -0.874397, 0.129668)));
      final normal_17_31 = mesh_17.normals.elementAt(31);
      expect(normal_17_31, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629857, -0.022517)));
      final normal_17_32 = mesh_17.normals.elementAt(32);
      expect(normal_17_32, vector3MoreOrLessEquals(Vector3(-0.542292, -0.717476, -0.437204)));
      final normal_17_33 = mesh_17.normals.elementAt(33);
      expect(normal_17_33, vector3MoreOrLessEquals(Vector3(-0.433216, -0.308258, -0.846936)));
      final normal_17_34 = mesh_17.normals.elementAt(34);
      expect(normal_17_34, vector3MoreOrLessEquals(Vector3(-0.542292, -0.717476, -0.437204)));
      final normal_17_35 = mesh_17.normals.elementAt(35);
      expect(normal_17_35, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, -0.633948)));
      final normal_17_36 = mesh_17.normals.elementAt(36);
      expect(normal_17_36, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629857, -0.022517)));
      final normal_17_37 = mesh_17.normals.elementAt(37);
      expect(normal_17_37, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, -0.633948)));
      final normal_17_38 = mesh_17.normals.elementAt(38);
      expect(normal_17_38, vector3MoreOrLessEquals(Vector3(-0.542292, -0.717476, -0.437204)));
      final normal_17_39 = mesh_17.normals.elementAt(39);
      expect(normal_17_39, vector3MoreOrLessEquals(Vector3(-0.467564, -0.874397, 0.129668)));
      final normal_17_40 = mesh_17.normals.elementAt(40);
      expect(normal_17_40, vector3MoreOrLessEquals(Vector3(-0.189834, -0.854102, 0.484223)));
      final normal_17_41 = mesh_17.normals.elementAt(41);
      expect(normal_17_41, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711395, 0.442735)));
      final normal_17_42 = mesh_17.normals.elementAt(42);
      expect(normal_17_42, vector3MoreOrLessEquals(Vector3(-0.641391, -0.312091, 0.700868)));
      final normal_17_43 = mesh_17.normals.elementAt(43);
      expect(normal_17_43, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711395, 0.442735)));
      final normal_17_44 = mesh_17.normals.elementAt(44);
      expect(normal_17_44, vector3MoreOrLessEquals(Vector3(-0.215356, -0.62378, 0.751346)));
      final normal_17_45 = mesh_17.normals.elementAt(45);
      expect(normal_17_45, vector3MoreOrLessEquals(Vector3(0.037501, -0.724698, 0.688046)));
      final normal_17_46 = mesh_17.normals.elementAt(46);
      expect(normal_17_46, vector3MoreOrLessEquals(Vector3(-0.215356, -0.62378, 0.751346)));
      final normal_17_47 = mesh_17.normals.elementAt(47);
      expect(normal_17_47, vector3MoreOrLessEquals(Vector3(-0.189834, -0.854102, 0.484223)));
      final normal_17_48 = mesh_17.normals.elementAt(48);
      expect(normal_17_48, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711395, 0.442735)));
      final normal_17_49 = mesh_17.normals.elementAt(49);
      expect(normal_17_49, vector3MoreOrLessEquals(Vector3(-0.189834, -0.854102, 0.484223)));
      final normal_17_50 = mesh_17.normals.elementAt(50);
      expect(normal_17_50, vector3MoreOrLessEquals(Vector3(-0.215356, -0.62378, 0.751346)));
      final normal_17_51 = mesh_17.normals.elementAt(51);
      expect(normal_17_51, vector3MoreOrLessEquals(Vector3(-0.641391, -0.312091, 0.700868)));
      final normal_17_52 = mesh_17.normals.elementAt(52);
      expect(normal_17_52, vector3MoreOrLessEquals(Vector3(-0.215356, -0.62378, 0.751346)));
      final normal_17_53 = mesh_17.normals.elementAt(53);
      expect(normal_17_53, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, 0.926107)));
      final normal_17_54 = mesh_17.normals.elementAt(54);
      expect(normal_17_54, vector3MoreOrLessEquals(Vector3(0.092832, 0.340544, 0.935634)));
      final normal_17_55 = mesh_17.normals.elementAt(55);
      expect(normal_17_55, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, 0.926107)));
      final normal_17_56 = mesh_17.normals.elementAt(56);
      expect(normal_17_56, vector3MoreOrLessEquals(Vector3(0.078137, -0.268605, 0.960076)));
      final normal_17_57 = mesh_17.normals.elementAt(57);
      expect(normal_17_57, vector3MoreOrLessEquals(Vector3(0.037501, -0.724698, 0.688046)));
      final normal_17_58 = mesh_17.normals.elementAt(58);
      expect(normal_17_58, vector3MoreOrLessEquals(Vector3(0.078137, -0.268605, 0.960076)));
      final normal_17_59 = mesh_17.normals.elementAt(59);
      expect(normal_17_59, vector3MoreOrLessEquals(Vector3(-0.215356, -0.62378, 0.751346)));
      final normal_17_60 = mesh_17.normals.elementAt(60);
      expect(normal_17_60, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, 0.926107)));
      final normal_17_61 = mesh_17.normals.elementAt(61);
      expect(normal_17_61, vector3MoreOrLessEquals(Vector3(-0.215356, -0.62378, 0.751346)));
      final normal_17_62 = mesh_17.normals.elementAt(62);
      expect(normal_17_62, vector3MoreOrLessEquals(Vector3(0.078137, -0.268605, 0.960076)));
      final normal_17_63 = mesh_17.normals.elementAt(63);
      expect(normal_17_63, vector3MoreOrLessEquals(Vector3(0.092832, 0.340544, 0.935634)));
      final normal_17_64 = mesh_17.normals.elementAt(64);
      expect(normal_17_64, vector3MoreOrLessEquals(Vector3(0.078137, -0.268605, 0.960076)));
      final normal_17_65 = mesh_17.normals.elementAt(65);
      expect(normal_17_65, vector3MoreOrLessEquals(Vector3(0.433215, 0.30826, 0.846936)));
      final normal_17_66 = mesh_17.normals.elementAt(66);
      expect(normal_17_66, vector3MoreOrLessEquals(Vector3(-0.641388, 0.689588, 0.336288)));
      final normal_17_67 = mesh_17.normals.elementAt(67);
      expect(normal_17_67, vector3MoreOrLessEquals(Vector3(-0.757385, 0.223328, 0.61359)));
      final normal_17_68 = mesh_17.normals.elementAt(68);
      expect(normal_17_68, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, 0.686654)));
      final normal_17_69 = mesh_17.normals.elementAt(69);
      expect(normal_17_69, vector3MoreOrLessEquals(Vector3(0.092832, 0.340544, 0.935634)));
      final normal_17_70 = mesh_17.normals.elementAt(70);
      expect(normal_17_70, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, 0.686654)));
      final normal_17_71 = mesh_17.normals.elementAt(71);
      expect(normal_17_71, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, 0.926107)));
      final normal_17_72 = mesh_17.normals.elementAt(72);
      expect(normal_17_72, vector3MoreOrLessEquals(Vector3(-0.641391, -0.312091, 0.700868)));
      final normal_17_73 = mesh_17.normals.elementAt(73);
      expect(normal_17_73, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, 0.926107)));
      final normal_17_74 = mesh_17.normals.elementAt(74);
      expect(normal_17_74, vector3MoreOrLessEquals(Vector3(-0.757385, 0.223328, 0.61359)));
      final normal_17_75 = mesh_17.normals.elementAt(75);
      expect(normal_17_75, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, 0.686654)));
      final normal_17_76 = mesh_17.normals.elementAt(76);
      expect(normal_17_76, vector3MoreOrLessEquals(Vector3(-0.757385, 0.223328, 0.61359)));
      final normal_17_77 = mesh_17.normals.elementAt(77);
      expect(normal_17_77, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, 0.926107)));
      final normal_17_78 = mesh_17.normals.elementAt(78);
      expect(normal_17_78, vector3MoreOrLessEquals(Vector3(-0.641388, 0.689588, 0.336288)));
      final normal_17_79 = mesh_17.normals.elementAt(79);
      expect(normal_17_79, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, 0.158468)));
      final normal_17_80 = mesh_17.normals.elementAt(80);
      expect(normal_17_80, vector3MoreOrLessEquals(Vector3(-0.757385, 0.223328, 0.61359)));
      final normal_17_81 = mesh_17.normals.elementAt(81);
      expect(normal_17_81, vector3MoreOrLessEquals(Vector3(-0.641391, -0.312091, 0.700868)));
      final normal_17_82 = mesh_17.normals.elementAt(82);
      expect(normal_17_82, vector3MoreOrLessEquals(Vector3(-0.757385, 0.223328, 0.61359)));
      final normal_17_83 = mesh_17.normals.elementAt(83);
      expect(normal_17_83, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, 0.378934)));
      final normal_17_84 = mesh_17.normals.elementAt(84);
      expect(normal_17_84, vector3MoreOrLessEquals(Vector3(-0.995559, -0.032197, -0.088459)));
      final normal_17_85 = mesh_17.normals.elementAt(85);
      expect(normal_17_85, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, 0.378934)));
      final normal_17_86 = mesh_17.normals.elementAt(86);
      expect(normal_17_86, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, 0.158468)));
      final normal_17_87 = mesh_17.normals.elementAt(87);
      expect(normal_17_87, vector3MoreOrLessEquals(Vector3(-0.757385, 0.223328, 0.61359)));
      final normal_17_88 = mesh_17.normals.elementAt(88);
      expect(normal_17_88, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, 0.158468)));
      final normal_17_89 = mesh_17.normals.elementAt(89);
      expect(normal_17_89, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, 0.378934)));
      final normal_17_90 = mesh_17.normals.elementAt(90);
      expect(normal_17_90, vector3MoreOrLessEquals(Vector3(-0.641388, 0.689588, 0.336288)));
      final normal_17_91 = mesh_17.normals.elementAt(91);
      expect(normal_17_91, vector3MoreOrLessEquals(Vector3(-0.662764, 0.746241, -0.062188)));
      final normal_17_92 = mesh_17.normals.elementAt(92);
      expect(normal_17_92, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, 0.158468)));
      final normal_17_93 = mesh_17.normals.elementAt(93);
      expect(normal_17_93, vector3MoreOrLessEquals(Vector3(-0.995559, -0.032197, -0.088459)));
      final normal_17_94 = mesh_17.normals.elementAt(94);
      expect(normal_17_94, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, 0.158468)));
      final normal_17_95 = mesh_17.normals.elementAt(95);
      expect(normal_17_95, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, -0.422116)));
      final normal_17_96 = mesh_17.normals.elementAt(96);
      expect(normal_17_96, vector3MoreOrLessEquals(Vector3(-0.545563, 0.658509, -0.518389)));
      final normal_17_97 = mesh_17.normals.elementAt(97);
      expect(normal_17_97, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, -0.422116)));
      final normal_17_98 = mesh_17.normals.elementAt(98);
      expect(normal_17_98, vector3MoreOrLessEquals(Vector3(-0.662764, 0.746241, -0.062188)));
      final normal_17_99 = mesh_17.normals.elementAt(99);
      expect(normal_17_99, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, 0.158468)));
      final normal_17_100 = mesh_17.normals.elementAt(100);
      expect(normal_17_100, vector3MoreOrLessEquals(Vector3(-0.662764, 0.746241, -0.062188)));
      final normal_17_101 = mesh_17.normals.elementAt(101);
      expect(normal_17_101, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, -0.422116)));
      final normal_17_102 = mesh_17.normals.elementAt(102);
      expect(normal_17_102, vector3MoreOrLessEquals(Vector3(-0.467564, -0.874397, 0.129668)));
      final normal_17_103 = mesh_17.normals.elementAt(103);
      expect(normal_17_103, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711395, 0.442735)));
      final normal_17_104 = mesh_17.normals.elementAt(104);
      expect(normal_17_104, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629857, -0.022517)));
      final normal_17_105 = mesh_17.normals.elementAt(105);
      expect(normal_17_105, vector3MoreOrLessEquals(Vector3(-0.995559, -0.032197, -0.088459)));
      final normal_17_106 = mesh_17.normals.elementAt(106);
      expect(normal_17_106, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629857, -0.022517)));
      final normal_17_107 = mesh_17.normals.elementAt(107);
      expect(normal_17_107, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, 0.378934)));
      final normal_17_108 = mesh_17.normals.elementAt(108);
      expect(normal_17_108, vector3MoreOrLessEquals(Vector3(-0.641391, -0.312091, 0.700868)));
      final normal_17_109 = mesh_17.normals.elementAt(109);
      expect(normal_17_109, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, 0.378934)));
      final normal_17_110 = mesh_17.normals.elementAt(110);
      expect(normal_17_110, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711395, 0.442735)));
      final normal_17_111 = mesh_17.normals.elementAt(111);
      expect(normal_17_111, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629857, -0.022517)));
      final normal_17_112 = mesh_17.normals.elementAt(112);
      expect(normal_17_112, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711395, 0.442735)));
      final normal_17_113 = mesh_17.normals.elementAt(113);
      expect(normal_17_113, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, 0.378934)));
      expect(mesh_17.tangents.length, isZero);
      expect(mesh_17.bitangents.length, isZero);
      expect(mesh_17.colors.length, isZero);
      expect(mesh_17.textureCoords.length, equals(1));
      final textureCoords_17_0 = mesh_17.textureCoords.elementAt(0);
      expect(textureCoords_17_0.length, equals(114));
      final textureCoord_17_0_0 = textureCoords_17_0.elementAt(0);
      expect(textureCoord_17_0_0, vector3MoreOrLessEquals(Vector3(1.04688, 0.77201, 0)));
      final textureCoord_17_0_1 = textureCoords_17_0.elementAt(1);
      expect(textureCoord_17_0_1, vector3MoreOrLessEquals(Vector3(0.956791, 0.730945, 0)));
      final textureCoord_17_0_2 = textureCoords_17_0.elementAt(2);
      expect(textureCoord_17_0_2, vector3MoreOrLessEquals(Vector3(0.899283, 0.970312, 0)));
      final textureCoord_17_0_3 = textureCoords_17_0.elementAt(3);
      expect(textureCoord_17_0_3, vector3MoreOrLessEquals(Vector3(1.04688, 0.77201, 0)));
      final textureCoord_17_0_4 = textureCoords_17_0.elementAt(4);
      expect(textureCoord_17_0_4, vector3MoreOrLessEquals(Vector3(0.899283, 0.970312, 0)));
      final textureCoord_17_0_5 = textureCoords_17_0.elementAt(5);
      expect(textureCoord_17_0_5, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_17_0_6 = textureCoords_17_0.elementAt(6);
      expect(textureCoord_17_0_6, vector3MoreOrLessEquals(Vector3(0.720028, 0.902269, 0)));
      final textureCoord_17_0_7 = textureCoords_17_0.elementAt(7);
      expect(textureCoord_17_0_7, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_17_0_8 = textureCoords_17_0.elementAt(8);
      expect(textureCoord_17_0_8, vector3MoreOrLessEquals(Vector3(0.707168, 1.04688, 0)));
      final textureCoord_17_0_9 = textureCoords_17_0.elementAt(9);
      expect(textureCoord_17_0_9, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_17_0_10 = textureCoords_17_0.elementAt(10);
      expect(textureCoord_17_0_10, vector3MoreOrLessEquals(Vector3(0.899283, 0.970312, 0)));
      final textureCoord_17_0_11 = textureCoords_17_0.elementAt(11);
      expect(textureCoord_17_0_11, vector3MoreOrLessEquals(Vector3(0.707168, 1.04688, 0)));
      final textureCoord_17_0_12 = textureCoords_17_0.elementAt(12);
      expect(textureCoord_17_0_12, vector3MoreOrLessEquals(Vector3(0.720028, 0.902269, 0)));
      final textureCoord_17_0_13 = textureCoords_17_0.elementAt(13);
      expect(textureCoord_17_0_13, vector3MoreOrLessEquals(Vector3(0.707168, 1.04688, 0)));
      final textureCoord_17_0_14 = textureCoords_17_0.elementAt(14);
      expect(textureCoord_17_0_14, vector3MoreOrLessEquals(Vector3(0.453826, 0.931398, 0)));
      final textureCoord_17_0_15 = textureCoords_17_0.elementAt(15);
      expect(textureCoord_17_0_15, vector3MoreOrLessEquals(Vector3(0.215418, 0.844835, 0)));
      final textureCoord_17_0_16 = textureCoords_17_0.elementAt(16);
      expect(textureCoord_17_0_16, vector3MoreOrLessEquals(Vector3(0.058156, 0.586898, 0)));
      final textureCoord_17_0_17 = textureCoords_17_0.elementAt(17);
      expect(textureCoord_17_0_17, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_17_0_18 = textureCoords_17_0.elementAt(18);
      expect(textureCoord_17_0_18, vector3MoreOrLessEquals(Vector3(0.349482, 0.454114, 0)));
      final textureCoord_17_0_19 = textureCoords_17_0.elementAt(19);
      expect(textureCoord_17_0_19, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_17_0_20 = textureCoords_17_0.elementAt(20);
      expect(textureCoord_17_0_20, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_17_0_21 = textureCoords_17_0.elementAt(21);
      expect(textureCoord_17_0_21, vector3MoreOrLessEquals(Vector3(0.046875, 0.316174, 0)));
      final textureCoord_17_0_22 = textureCoords_17_0.elementAt(22);
      expect(textureCoord_17_0_22, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_17_0_23 = textureCoords_17_0.elementAt(23);
      expect(textureCoord_17_0_23, vector3MoreOrLessEquals(Vector3(0.058156, 0.586898, 0)));
      final textureCoord_17_0_24 = textureCoords_17_0.elementAt(24);
      expect(textureCoord_17_0_24, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_17_0_25 = textureCoords_17_0.elementAt(25);
      expect(textureCoord_17_0_25, vector3MoreOrLessEquals(Vector3(0.058156, 0.586898, 0)));
      final textureCoord_17_0_26 = textureCoords_17_0.elementAt(26);
      expect(textureCoord_17_0_26, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_17_0_27 = textureCoords_17_0.elementAt(27);
      expect(textureCoord_17_0_27, vector3MoreOrLessEquals(Vector3(0.349482, 0.454114, 0)));
      final textureCoord_17_0_28 = textureCoords_17_0.elementAt(28);
      expect(textureCoord_17_0_28, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_17_0_29 = textureCoords_17_0.elementAt(29);
      expect(textureCoord_17_0_29, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_17_0_30 = textureCoords_17_0.elementAt(30);
      expect(textureCoord_17_0_30, vector3MoreOrLessEquals(Vector3(0.44732, 0.046875, 0)));
      final textureCoord_17_0_31 = textureCoords_17_0.elementAt(31);
      expect(textureCoord_17_0_31, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_17_0_32 = textureCoords_17_0.elementAt(32);
      expect(textureCoord_17_0_32, vector3MoreOrLessEquals(Vector3(0.194464, 0.117868, 0)));
      final textureCoord_17_0_33 = textureCoords_17_0.elementAt(33);
      expect(textureCoord_17_0_33, vector3MoreOrLessEquals(Vector3(0.046875, 0.316174, 0)));
      final textureCoord_17_0_34 = textureCoords_17_0.elementAt(34);
      expect(textureCoord_17_0_34, vector3MoreOrLessEquals(Vector3(0.194464, 0.117868, 0)));
      final textureCoord_17_0_35 = textureCoords_17_0.elementAt(35);
      expect(textureCoord_17_0_35, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_17_0_36 = textureCoords_17_0.elementAt(36);
      expect(textureCoord_17_0_36, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_17_0_37 = textureCoords_17_0.elementAt(37);
      expect(textureCoord_17_0_37, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_17_0_38 = textureCoords_17_0.elementAt(38);
      expect(textureCoord_17_0_38, vector3MoreOrLessEquals(Vector3(0.194464, 0.117868, 0)));
      final textureCoord_17_0_39 = textureCoords_17_0.elementAt(39);
      expect(textureCoord_17_0_39, vector3MoreOrLessEquals(Vector3(0.44732, 0.046875, 0)));
      final textureCoord_17_0_40 = textureCoords_17_0.elementAt(40);
      expect(textureCoord_17_0_40, vector3MoreOrLessEquals(Vector3(0.683183, 0.075062, 0)));
      final textureCoord_17_0_41 = textureCoords_17_0.elementAt(41);
      expect(textureCoord_17_0_41, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_17_0_42 = textureCoords_17_0.elementAt(42);
      expect(textureCoord_17_0_42, vector3MoreOrLessEquals(Vector3(0.863351, 0.409106, 0)));
      final textureCoord_17_0_43 = textureCoords_17_0.elementAt(43);
      expect(textureCoord_17_0_43, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_17_0_44 = textureCoords_17_0.elementAt(44);
      expect(textureCoord_17_0_44, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_17_0_45 = textureCoords_17_0.elementAt(45);
      expect(textureCoord_17_0_45, vector3MoreOrLessEquals(Vector3(0.878332, 0.243345, 0)));
      final textureCoord_17_0_46 = textureCoords_17_0.elementAt(46);
      expect(textureCoord_17_0_46, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_17_0_47 = textureCoords_17_0.elementAt(47);
      expect(textureCoord_17_0_47, vector3MoreOrLessEquals(Vector3(0.683183, 0.075062, 0)));
      final textureCoord_17_0_48 = textureCoords_17_0.elementAt(48);
      expect(textureCoord_17_0_48, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_17_0_49 = textureCoords_17_0.elementAt(49);
      expect(textureCoord_17_0_49, vector3MoreOrLessEquals(Vector3(0.683183, 0.075062, 0)));
      final textureCoord_17_0_50 = textureCoords_17_0.elementAt(50);
      expect(textureCoord_17_0_50, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_17_0_51 = textureCoords_17_0.elementAt(51);
      expect(textureCoord_17_0_51, vector3MoreOrLessEquals(Vector3(0.863351, 0.409106, 0)));
      final textureCoord_17_0_52 = textureCoords_17_0.elementAt(52);
      expect(textureCoord_17_0_52, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_17_0_53 = textureCoords_17_0.elementAt(53);
      expect(textureCoord_17_0_53, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_17_0_54 = textureCoords_17_0.elementAt(54);
      expect(textureCoord_17_0_54, vector3MoreOrLessEquals(Vector3(1.04688, 0.77201, 0)));
      final textureCoord_17_0_55 = textureCoords_17_0.elementAt(55);
      expect(textureCoord_17_0_55, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_17_0_56 = textureCoords_17_0.elementAt(56);
      expect(textureCoord_17_0_56, vector3MoreOrLessEquals(Vector3(1.03559, 0.501285, 0)));
      final textureCoord_17_0_57 = textureCoords_17_0.elementAt(57);
      expect(textureCoord_17_0_57, vector3MoreOrLessEquals(Vector3(0.878332, 0.243345, 0)));
      final textureCoord_17_0_58 = textureCoords_17_0.elementAt(58);
      expect(textureCoord_17_0_58, vector3MoreOrLessEquals(Vector3(1.03559, 0.501285, 0)));
      final textureCoord_17_0_59 = textureCoords_17_0.elementAt(59);
      expect(textureCoord_17_0_59, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_17_0_60 = textureCoords_17_0.elementAt(60);
      expect(textureCoord_17_0_60, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_17_0_61 = textureCoords_17_0.elementAt(61);
      expect(textureCoord_17_0_61, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_17_0_62 = textureCoords_17_0.elementAt(62);
      expect(textureCoord_17_0_62, vector3MoreOrLessEquals(Vector3(1.03559, 0.501285, 0)));
      final textureCoord_17_0_63 = textureCoords_17_0.elementAt(63);
      expect(textureCoord_17_0_63, vector3MoreOrLessEquals(Vector3(1.04688, 0.77201, 0)));
      final textureCoord_17_0_64 = textureCoords_17_0.elementAt(64);
      expect(textureCoord_17_0_64, vector3MoreOrLessEquals(Vector3(1.03559, 0.501285, 0)));
      final textureCoord_17_0_65 = textureCoords_17_0.elementAt(65);
      expect(textureCoord_17_0_65, vector3MoreOrLessEquals(Vector3(0.956791, 0.730945, 0)));
      final textureCoord_17_0_66 = textureCoords_17_0.elementAt(66);
      expect(textureCoord_17_0_66, vector3MoreOrLessEquals(Vector3(0.720028, 0.902269, 0)));
      final textureCoord_17_0_67 = textureCoords_17_0.elementAt(67);
      expect(textureCoord_17_0_67, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_17_0_68 = textureCoords_17_0.elementAt(68);
      expect(textureCoord_17_0_68, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_17_0_69 = textureCoords_17_0.elementAt(69);
      expect(textureCoord_17_0_69, vector3MoreOrLessEquals(Vector3(1.04688, 0.77201, 0)));
      final textureCoord_17_0_70 = textureCoords_17_0.elementAt(70);
      expect(textureCoord_17_0_70, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_17_0_71 = textureCoords_17_0.elementAt(71);
      expect(textureCoord_17_0_71, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_17_0_72 = textureCoords_17_0.elementAt(72);
      expect(textureCoord_17_0_72, vector3MoreOrLessEquals(Vector3(0.863351, 0.409106, 0)));
      final textureCoord_17_0_73 = textureCoords_17_0.elementAt(73);
      expect(textureCoord_17_0_73, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_17_0_74 = textureCoords_17_0.elementAt(74);
      expect(textureCoord_17_0_74, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_17_0_75 = textureCoords_17_0.elementAt(75);
      expect(textureCoord_17_0_75, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_17_0_76 = textureCoords_17_0.elementAt(76);
      expect(textureCoord_17_0_76, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_17_0_77 = textureCoords_17_0.elementAt(77);
      expect(textureCoord_17_0_77, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_17_0_78 = textureCoords_17_0.elementAt(78);
      expect(textureCoord_17_0_78, vector3MoreOrLessEquals(Vector3(0.720028, 0.902269, 0)));
      final textureCoord_17_0_79 = textureCoords_17_0.elementAt(79);
      expect(textureCoord_17_0_79, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_17_0_80 = textureCoords_17_0.elementAt(80);
      expect(textureCoord_17_0_80, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_17_0_81 = textureCoords_17_0.elementAt(81);
      expect(textureCoord_17_0_81, vector3MoreOrLessEquals(Vector3(0.863351, 0.409106, 0)));
      final textureCoord_17_0_82 = textureCoords_17_0.elementAt(82);
      expect(textureCoord_17_0_82, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_17_0_83 = textureCoords_17_0.elementAt(83);
      expect(textureCoord_17_0_83, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_17_0_84 = textureCoords_17_0.elementAt(84);
      expect(textureCoord_17_0_84, vector3MoreOrLessEquals(Vector3(0.349482, 0.454114, 0)));
      final textureCoord_17_0_85 = textureCoords_17_0.elementAt(85);
      expect(textureCoord_17_0_85, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_17_0_86 = textureCoords_17_0.elementAt(86);
      expect(textureCoord_17_0_86, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_17_0_87 = textureCoords_17_0.elementAt(87);
      expect(textureCoord_17_0_87, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_17_0_88 = textureCoords_17_0.elementAt(88);
      expect(textureCoord_17_0_88, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_17_0_89 = textureCoords_17_0.elementAt(89);
      expect(textureCoord_17_0_89, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_17_0_90 = textureCoords_17_0.elementAt(90);
      expect(textureCoord_17_0_90, vector3MoreOrLessEquals(Vector3(0.720028, 0.902269, 0)));
      final textureCoord_17_0_91 = textureCoords_17_0.elementAt(91);
      expect(textureCoord_17_0_91, vector3MoreOrLessEquals(Vector3(0.453826, 0.931398, 0)));
      final textureCoord_17_0_92 = textureCoords_17_0.elementAt(92);
      expect(textureCoord_17_0_92, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_17_0_93 = textureCoords_17_0.elementAt(93);
      expect(textureCoord_17_0_93, vector3MoreOrLessEquals(Vector3(0.349482, 0.454114, 0)));
      final textureCoord_17_0_94 = textureCoords_17_0.elementAt(94);
      expect(textureCoord_17_0_94, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_17_0_95 = textureCoords_17_0.elementAt(95);
      expect(textureCoord_17_0_95, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_17_0_96 = textureCoords_17_0.elementAt(96);
      expect(textureCoord_17_0_96, vector3MoreOrLessEquals(Vector3(0.215418, 0.844835, 0)));
      final textureCoord_17_0_97 = textureCoords_17_0.elementAt(97);
      expect(textureCoord_17_0_97, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_17_0_98 = textureCoords_17_0.elementAt(98);
      expect(textureCoord_17_0_98, vector3MoreOrLessEquals(Vector3(0.453826, 0.931398, 0)));
      final textureCoord_17_0_99 = textureCoords_17_0.elementAt(99);
      expect(textureCoord_17_0_99, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_17_0_100 = textureCoords_17_0.elementAt(100);
      expect(textureCoord_17_0_100, vector3MoreOrLessEquals(Vector3(0.453826, 0.931398, 0)));
      final textureCoord_17_0_101 = textureCoords_17_0.elementAt(101);
      expect(textureCoord_17_0_101, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_17_0_102 = textureCoords_17_0.elementAt(102);
      expect(textureCoord_17_0_102, vector3MoreOrLessEquals(Vector3(0.44732, 0.046875, 0)));
      final textureCoord_17_0_103 = textureCoords_17_0.elementAt(103);
      expect(textureCoord_17_0_103, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_17_0_104 = textureCoords_17_0.elementAt(104);
      expect(textureCoord_17_0_104, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_17_0_105 = textureCoords_17_0.elementAt(105);
      expect(textureCoord_17_0_105, vector3MoreOrLessEquals(Vector3(0.349482, 0.454114, 0)));
      final textureCoord_17_0_106 = textureCoords_17_0.elementAt(106);
      expect(textureCoord_17_0_106, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_17_0_107 = textureCoords_17_0.elementAt(107);
      expect(textureCoord_17_0_107, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_17_0_108 = textureCoords_17_0.elementAt(108);
      expect(textureCoord_17_0_108, vector3MoreOrLessEquals(Vector3(0.863351, 0.409106, 0)));
      final textureCoord_17_0_109 = textureCoords_17_0.elementAt(109);
      expect(textureCoord_17_0_109, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_17_0_110 = textureCoords_17_0.elementAt(110);
      expect(textureCoord_17_0_110, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_17_0_111 = textureCoords_17_0.elementAt(111);
      expect(textureCoord_17_0_111, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_17_0_112 = textureCoords_17_0.elementAt(112);
      expect(textureCoord_17_0_112, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_17_0_113 = textureCoords_17_0.elementAt(113);
      expect(textureCoord_17_0_113, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      expect(mesh_17.uvComponents.length, equals(1));
      expect(mesh_17.uvComponents, equals([2]));
      expect(mesh_17.faces.length, equals(38));
      expect(mesh_17.bones.length, isZero);
      expect(mesh_17.materialIndex, equals(5));
      expect(mesh_17.name, equals('Auge'));
      expect(mesh_17.animMeshes.length, isZero);
      expect(mesh_17.morphingMethod, isZero);
      expect(mesh_17.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));

      final mesh_18 = meshes.elementAt(18);
      expect(mesh_18.primitiveTypes, equals(4));
      expect(mesh_18.vertices.length, equals(114));
      final vertex_18_0 = mesh_18.vertices.elementAt(0);
      expect(vertex_18_0, vector3MoreOrLessEquals(Vector3(-59.467, 18.1401, -17.1944)));
      final vertex_18_1 = mesh_18.vertices.elementAt(1);
      expect(vertex_18_1, vector3MoreOrLessEquals(Vector3(-58.7436, 17.2518, -17.4616)));
      final vertex_18_2 = mesh_18.vertices.elementAt(2);
      expect(vertex_18_2, vector3MoreOrLessEquals(Vector3(-59.6705, 17.4042, -17.8803)));
      final vertex_18_3 = mesh_18.vertices.elementAt(3);
      expect(vertex_18_3, vector3MoreOrLessEquals(Vector3(-60.6376, 17.8368, -17.3954)));
      final vertex_18_4 = mesh_18.vertices.elementAt(4);
      expect(vertex_18_4, vector3MoreOrLessEquals(Vector3(-59.467, 18.1401, -17.1944)));
      final vertex_18_5 = mesh_18.vertices.elementAt(5);
      expect(vertex_18_5, vector3MoreOrLessEquals(Vector3(-59.6705, 17.4042, -17.8803)));
      final vertex_18_6 = mesh_18.vertices.elementAt(6);
      expect(vertex_18_6, vector3MoreOrLessEquals(Vector3(-60.5752, 18.4242, -16.3015)));
      final vertex_18_7 = mesh_18.vertices.elementAt(7);
      expect(vertex_18_7, vector3MoreOrLessEquals(Vector3(-60.6376, 17.8368, -17.3954)));
      final vertex_18_8 = mesh_18.vertices.elementAt(8);
      expect(vertex_18_8, vector3MoreOrLessEquals(Vector3(-61.5559, 17.8876, -16.3613)));
      final vertex_18_9 = mesh_18.vertices.elementAt(9);
      expect(vertex_18_9, vector3MoreOrLessEquals(Vector3(-60.5752, 18.4242, -16.3015)));
      final vertex_18_10 = mesh_18.vertices.elementAt(10);
      expect(vertex_18_10, vector3MoreOrLessEquals(Vector3(-59.467, 18.1401, -17.1944)));
      final vertex_18_11 = mesh_18.vertices.elementAt(11);
      expect(vertex_18_11, vector3MoreOrLessEquals(Vector3(-60.6376, 17.8368, -17.3954)));
      final vertex_18_12 = mesh_18.vertices.elementAt(12);
      expect(vertex_18_12, vector3MoreOrLessEquals(Vector3(-61.6449, 17.9957, -15.1241)));
      final vertex_18_13 = mesh_18.vertices.elementAt(13);
      expect(vertex_18_13, vector3MoreOrLessEquals(Vector3(-60.5752, 18.4242, -16.3015)));
      final vertex_18_14 = mesh_18.vertices.elementAt(14);
      expect(vertex_18_14, vector3MoreOrLessEquals(Vector3(-61.5559, 17.8876, -16.3613)));
      final vertex_18_15 = mesh_18.vertices.elementAt(15);
      expect(vertex_18_15, vector3MoreOrLessEquals(Vector3(-62.2674, 17.0181, -14.1118)));
      final vertex_18_16 = mesh_18.vertices.elementAt(16);
      expect(vertex_18_16, vector3MoreOrLessEquals(Vector3(-61.4815, 16.7173, -13.2852)));
      final vertex_18_17 = mesh_18.vertices.elementAt(17);
      expect(vertex_18_17, vector3MoreOrLessEquals(Vector3(-61.3842, 17.6744, -14.0161)));
      final vertex_18_18 = mesh_18.vertices.elementAt(18);
      expect(vertex_18_18, vector3MoreOrLessEquals(Vector3(-62.205, 15.865, -13.6514)));
      final vertex_18_19 = mesh_18.vertices.elementAt(19);
      expect(vertex_18_19, vector3MoreOrLessEquals(Vector3(-62.2674, 17.0181, -14.1118)));
      final vertex_18_20 = mesh_18.vertices.elementAt(20);
      expect(vertex_18_20, vector3MoreOrLessEquals(Vector3(-62.615, 16.2245, -14.6391)));
      final vertex_18_21 = mesh_18.vertices.elementAt(21);
      expect(vertex_18_21, vector3MoreOrLessEquals(Vector3(-61.4815, 16.7173, -13.2852)));
      final vertex_18_22 = mesh_18.vertices.elementAt(22);
      expect(vertex_18_22, vector3MoreOrLessEquals(Vector3(-62.205, 15.865, -13.6514)));
      final vertex_18_23 = mesh_18.vertices.elementAt(23);
      expect(vertex_18_23, vector3MoreOrLessEquals(Vector3(-61.2781, 15.7126, -13.2327)));
      final vertex_18_24 = mesh_18.vertices.elementAt(24);
      expect(vertex_18_24, vector3MoreOrLessEquals(Vector3(-62.205, 15.865, -13.6514)));
      final vertex_18_25 = mesh_18.vertices.elementAt(25);
      expect(vertex_18_25, vector3MoreOrLessEquals(Vector3(-61.4815, 16.7173, -13.2852)));
      final vertex_18_26 = mesh_18.vertices.elementAt(26);
      expect(vertex_18_26, vector3MoreOrLessEquals(Vector3(-62.2674, 17.0181, -14.1118)));
      final vertex_18_27 = mesh_18.vertices.elementAt(27);
      expect(vertex_18_27, vector3MoreOrLessEquals(Vector3(-62.2674, 15.2776, -14.7453)));
      final vertex_18_28 = mesh_18.vertices.elementAt(28);
      expect(vertex_18_28, vector3MoreOrLessEquals(Vector3(-62.205, 15.865, -13.6514)));
      final vertex_18_29 = mesh_18.vertices.elementAt(29);
      expect(vertex_18_29, vector3MoreOrLessEquals(Vector3(-62.615, 16.2245, -14.6391)));
      final vertex_18_30 = mesh_18.vertices.elementAt(30);
      expect(vertex_18_30, vector3MoreOrLessEquals(Vector3(-61.4815, 14.9767, -13.9187)));
      final vertex_18_31 = mesh_18.vertices.elementAt(31);
      expect(vertex_18_31, vector3MoreOrLessEquals(Vector3(-62.2674, 15.2776, -14.7453)));
      final vertex_18_32 = mesh_18.vertices.elementAt(32);
      expect(vertex_18_32, vector3MoreOrLessEquals(Vector3(-61.3842, 14.7133, -15.0938)));
      final vertex_18_33 = mesh_18.vertices.elementAt(33);
      expect(vertex_18_33, vector3MoreOrLessEquals(Vector3(-62.205, 15.865, -13.6514)));
      final vertex_18_34 = mesh_18.vertices.elementAt(34);
      expect(vertex_18_34, vector3MoreOrLessEquals(Vector3(-61.4815, 14.9767, -13.9187)));
      final vertex_18_35 = mesh_18.vertices.elementAt(35);
      expect(vertex_18_35, vector3MoreOrLessEquals(Vector3(-61.2781, 15.7126, -13.2327)));
      final vertex_18_36 = mesh_18.vertices.elementAt(36);
      expect(vertex_18_36, vector3MoreOrLessEquals(Vector3(-61.4815, 14.9767, -13.9187)));
      final vertex_18_37 = mesh_18.vertices.elementAt(37);
      expect(vertex_18_37, vector3MoreOrLessEquals(Vector3(-62.205, 15.865, -13.6514)));
      final vertex_18_38 = mesh_18.vertices.elementAt(38);
      expect(vertex_18_38, vector3MoreOrLessEquals(Vector3(-62.2674, 15.2776, -14.7453)));
      final vertex_18_39 = mesh_18.vertices.elementAt(39);
      expect(vertex_18_39, vector3MoreOrLessEquals(Vector3(-61.6449, 15.1794, -16.1491)));
      final vertex_18_40 = mesh_18.vertices.elementAt(40);
      expect(vertex_18_40, vector3MoreOrLessEquals(Vector3(-60.4743, 14.8179, -16.19)));
      final vertex_18_41 = mesh_18.vertices.elementAt(41);
      expect(vertex_18_41, vector3MoreOrLessEquals(Vector3(-61.3842, 14.7133, -15.0938)));
      final vertex_18_42 = mesh_18.vertices.elementAt(42);
      expect(vertex_18_42, vector3MoreOrLessEquals(Vector3(-60.5752, 15.608, -17.3265)));
      final vertex_18_43 = mesh_18.vertices.elementAt(43);
      expect(vertex_18_43, vector3MoreOrLessEquals(Vector3(-61.6449, 15.1794, -16.1491)));
      final vertex_18_44 = mesh_18.vertices.elementAt(44);
      expect(vertex_18_44, vector3MoreOrLessEquals(Vector3(-61.5559, 16.0575, -17.0274)));
      final vertex_18_45 = mesh_18.vertices.elementAt(45);
      expect(vertex_18_45, vector3MoreOrLessEquals(Vector3(-60.4743, 14.8179, -16.19)));
      final vertex_18_46 = mesh_18.vertices.elementAt(46);
      expect(vertex_18_46, vector3MoreOrLessEquals(Vector3(-60.5752, 15.608, -17.3265)));
      final vertex_18_47 = mesh_18.vertices.elementAt(47);
      expect(vertex_18_47, vector3MoreOrLessEquals(Vector3(-59.5644, 15.4424, -17.097)));
      final vertex_18_48 = mesh_18.vertices.elementAt(48);
      expect(vertex_18_48, vector3MoreOrLessEquals(Vector3(-60.5752, 15.608, -17.3265)));
      final vertex_18_49 = mesh_18.vertices.elementAt(49);
      expect(vertex_18_49, vector3MoreOrLessEquals(Vector3(-60.4743, 14.8179, -16.19)));
      final vertex_18_50 = mesh_18.vertices.elementAt(50);
      expect(vertex_18_50, vector3MoreOrLessEquals(Vector3(-61.6449, 15.1794, -16.1491)));
      final vertex_18_51 = mesh_18.vertices.elementAt(51);
      expect(vertex_18_51, vector3MoreOrLessEquals(Vector3(-60.6376, 16.7611, -17.7869)));
      final vertex_18_52 = mesh_18.vertices.elementAt(52);
      expect(vertex_18_52, vector3MoreOrLessEquals(Vector3(-60.5752, 15.608, -17.3265)));
      final vertex_18_53 = mesh_18.vertices.elementAt(53);
      expect(vertex_18_53, vector3MoreOrLessEquals(Vector3(-61.5559, 16.0575, -17.0274)));
      final vertex_18_54 = mesh_18.vertices.elementAt(54);
      expect(vertex_18_54, vector3MoreOrLessEquals(Vector3(-59.467, 16.3996, -17.8279)));
      final vertex_18_55 = mesh_18.vertices.elementAt(55);
      expect(vertex_18_55, vector3MoreOrLessEquals(Vector3(-60.6376, 16.7611, -17.7869)));
      final vertex_18_56 = mesh_18.vertices.elementAt(56);
      expect(vertex_18_56, vector3MoreOrLessEquals(Vector3(-59.6705, 17.4042, -17.8803)));
      final vertex_18_57 = mesh_18.vertices.elementAt(57);
      expect(vertex_18_57, vector3MoreOrLessEquals(Vector3(-60.5752, 15.608, -17.3265)));
      final vertex_18_58 = mesh_18.vertices.elementAt(58);
      expect(vertex_18_58, vector3MoreOrLessEquals(Vector3(-59.467, 16.3996, -17.8279)));
      final vertex_18_59 = mesh_18.vertices.elementAt(59);
      expect(vertex_18_59, vector3MoreOrLessEquals(Vector3(-59.5644, 15.4424, -17.097)));
      final vertex_18_60 = mesh_18.vertices.elementAt(60);
      expect(vertex_18_60, vector3MoreOrLessEquals(Vector3(-59.467, 16.3996, -17.8279)));
      final vertex_18_61 = mesh_18.vertices.elementAt(61);
      expect(vertex_18_61, vector3MoreOrLessEquals(Vector3(-60.5752, 15.608, -17.3265)));
      final vertex_18_62 = mesh_18.vertices.elementAt(62);
      expect(vertex_18_62, vector3MoreOrLessEquals(Vector3(-60.6376, 16.7611, -17.7869)));
      final vertex_18_63 = mesh_18.vertices.elementAt(63);
      expect(vertex_18_63, vector3MoreOrLessEquals(Vector3(-58.7436, 17.2518, -17.4616)));
      final vertex_18_64 = mesh_18.vertices.elementAt(64);
      expect(vertex_18_64, vector3MoreOrLessEquals(Vector3(-59.467, 16.3996, -17.8279)));
      final vertex_18_65 = mesh_18.vertices.elementAt(65);
      expect(vertex_18_65, vector3MoreOrLessEquals(Vector3(-59.6705, 17.4042, -17.8803)));
      final vertex_18_66 = mesh_18.vertices.elementAt(66);
      expect(vertex_18_66, vector3MoreOrLessEquals(Vector3(-60.6376, 17.8368, -17.3954)));
      final vertex_18_67 = mesh_18.vertices.elementAt(67);
      expect(vertex_18_67, vector3MoreOrLessEquals(Vector3(-61.7458, 17.0452, -16.8941)));
      final vertex_18_68 = mesh_18.vertices.elementAt(68);
      expect(vertex_18_68, vector3MoreOrLessEquals(Vector3(-61.5559, 17.8876, -16.3613)));
      final vertex_18_69 = mesh_18.vertices.elementAt(69);
      expect(vertex_18_69, vector3MoreOrLessEquals(Vector3(-60.6376, 16.7611, -17.7869)));
      final vertex_18_70 = mesh_18.vertices.elementAt(70);
      expect(vertex_18_70, vector3MoreOrLessEquals(Vector3(-60.6376, 17.8368, -17.3954)));
      final vertex_18_71 = mesh_18.vertices.elementAt(71);
      expect(vertex_18_71, vector3MoreOrLessEquals(Vector3(-59.6705, 17.4042, -17.8803)));
      final vertex_18_72 = mesh_18.vertices.elementAt(72);
      expect(vertex_18_72, vector3MoreOrLessEquals(Vector3(-61.7458, 17.0452, -16.8941)));
      final vertex_18_73 = mesh_18.vertices.elementAt(73);
      expect(vertex_18_73, vector3MoreOrLessEquals(Vector3(-60.6376, 16.7611, -17.7869)));
      final vertex_18_74 = mesh_18.vertices.elementAt(74);
      expect(vertex_18_74, vector3MoreOrLessEquals(Vector3(-61.5559, 16.0575, -17.0274)));
      final vertex_18_75 = mesh_18.vertices.elementAt(75);
      expect(vertex_18_75, vector3MoreOrLessEquals(Vector3(-60.6376, 16.7611, -17.7869)));
      final vertex_18_76 = mesh_18.vertices.elementAt(76);
      expect(vertex_18_76, vector3MoreOrLessEquals(Vector3(-61.7458, 17.0452, -16.8941)));
      final vertex_18_77 = mesh_18.vertices.elementAt(77);
      expect(vertex_18_77, vector3MoreOrLessEquals(Vector3(-60.6376, 17.8368, -17.3954)));
      final vertex_18_78 = mesh_18.vertices.elementAt(78);
      expect(vertex_18_78, vector3MoreOrLessEquals(Vector3(-61.7458, 17.0452, -16.8941)));
      final vertex_18_79 = mesh_18.vertices.elementAt(79);
      expect(vertex_18_79, vector3MoreOrLessEquals(Vector3(-62.3683, 17.1434, -15.4903)));
      final vertex_18_80 = mesh_18.vertices.elementAt(80);
      expect(vertex_18_80, vector3MoreOrLessEquals(Vector3(-61.5559, 17.8876, -16.3613)));
      final vertex_18_81 = mesh_18.vertices.elementAt(81);
      expect(vertex_18_81, vector3MoreOrLessEquals(Vector3(-62.3683, 16.0677, -15.8818)));
      final vertex_18_82 = mesh_18.vertices.elementAt(82);
      expect(vertex_18_82, vector3MoreOrLessEquals(Vector3(-61.7458, 17.0452, -16.8941)));
      final vertex_18_83 = mesh_18.vertices.elementAt(83);
      expect(vertex_18_83, vector3MoreOrLessEquals(Vector3(-61.5559, 16.0575, -17.0274)));
      final vertex_18_84 = mesh_18.vertices.elementAt(84);
      expect(vertex_18_84, vector3MoreOrLessEquals(Vector3(-62.3683, 17.1434, -15.4903)));
      final vertex_18_85 = mesh_18.vertices.elementAt(85);
      expect(vertex_18_85, vector3MoreOrLessEquals(Vector3(-62.3683, 16.0677, -15.8818)));
      final vertex_18_86 = mesh_18.vertices.elementAt(86);
      expect(vertex_18_86, vector3MoreOrLessEquals(Vector3(-62.615, 16.2245, -14.6391)));
      final vertex_18_87 = mesh_18.vertices.elementAt(87);
      expect(vertex_18_87, vector3MoreOrLessEquals(Vector3(-62.3683, 16.0677, -15.8818)));
      final vertex_18_88 = mesh_18.vertices.elementAt(88);
      expect(vertex_18_88, vector3MoreOrLessEquals(Vector3(-62.3683, 17.1434, -15.4903)));
      final vertex_18_89 = mesh_18.vertices.elementAt(89);
      expect(vertex_18_89, vector3MoreOrLessEquals(Vector3(-61.7458, 17.0452, -16.8941)));
      final vertex_18_90 = mesh_18.vertices.elementAt(90);
      expect(vertex_18_90, vector3MoreOrLessEquals(Vector3(-62.3683, 17.1434, -15.4903)));
      final vertex_18_91 = mesh_18.vertices.elementAt(91);
      expect(vertex_18_91, vector3MoreOrLessEquals(Vector3(-61.6449, 17.9957, -15.1241)));
      final vertex_18_92 = mesh_18.vertices.elementAt(92);
      expect(vertex_18_92, vector3MoreOrLessEquals(Vector3(-61.5559, 17.8876, -16.3613)));
      final vertex_18_93 = mesh_18.vertices.elementAt(93);
      expect(vertex_18_93, vector3MoreOrLessEquals(Vector3(-62.2674, 17.0181, -14.1118)));
      final vertex_18_94 = mesh_18.vertices.elementAt(94);
      expect(vertex_18_94, vector3MoreOrLessEquals(Vector3(-62.3683, 17.1434, -15.4903)));
      final vertex_18_95 = mesh_18.vertices.elementAt(95);
      expect(vertex_18_95, vector3MoreOrLessEquals(Vector3(-62.615, 16.2245, -14.6391)));
      final vertex_18_96 = mesh_18.vertices.elementAt(96);
      expect(vertex_18_96, vector3MoreOrLessEquals(Vector3(-61.6449, 17.9957, -15.1241)));
      final vertex_18_97 = mesh_18.vertices.elementAt(97);
      expect(vertex_18_97, vector3MoreOrLessEquals(Vector3(-62.2674, 17.0181, -14.1118)));
      final vertex_18_98 = mesh_18.vertices.elementAt(98);
      expect(vertex_18_98, vector3MoreOrLessEquals(Vector3(-61.3842, 17.6744, -14.0161)));
      final vertex_18_99 = mesh_18.vertices.elementAt(99);
      expect(vertex_18_99, vector3MoreOrLessEquals(Vector3(-62.2674, 17.0181, -14.1118)));
      final vertex_18_100 = mesh_18.vertices.elementAt(100);
      expect(vertex_18_100, vector3MoreOrLessEquals(Vector3(-61.6449, 17.9957, -15.1241)));
      final vertex_18_101 = mesh_18.vertices.elementAt(101);
      expect(vertex_18_101, vector3MoreOrLessEquals(Vector3(-62.3683, 17.1434, -15.4903)));
      final vertex_18_102 = mesh_18.vertices.elementAt(102);
      expect(vertex_18_102, vector3MoreOrLessEquals(Vector3(-62.2674, 15.2776, -14.7453)));
      final vertex_18_103 = mesh_18.vertices.elementAt(103);
      expect(vertex_18_103, vector3MoreOrLessEquals(Vector3(-61.6449, 15.1794, -16.1491)));
      final vertex_18_104 = mesh_18.vertices.elementAt(104);
      expect(vertex_18_104, vector3MoreOrLessEquals(Vector3(-61.3842, 14.7133, -15.0938)));
      final vertex_18_105 = mesh_18.vertices.elementAt(105);
      expect(vertex_18_105, vector3MoreOrLessEquals(Vector3(-62.3683, 16.0677, -15.8818)));
      final vertex_18_106 = mesh_18.vertices.elementAt(106);
      expect(vertex_18_106, vector3MoreOrLessEquals(Vector3(-62.2674, 15.2776, -14.7453)));
      final vertex_18_107 = mesh_18.vertices.elementAt(107);
      expect(vertex_18_107, vector3MoreOrLessEquals(Vector3(-62.615, 16.2245, -14.6391)));
      final vertex_18_108 = mesh_18.vertices.elementAt(108);
      expect(vertex_18_108, vector3MoreOrLessEquals(Vector3(-61.6449, 15.1794, -16.1491)));
      final vertex_18_109 = mesh_18.vertices.elementAt(109);
      expect(vertex_18_109, vector3MoreOrLessEquals(Vector3(-62.3683, 16.0677, -15.8818)));
      final vertex_18_110 = mesh_18.vertices.elementAt(110);
      expect(vertex_18_110, vector3MoreOrLessEquals(Vector3(-61.5559, 16.0575, -17.0274)));
      final vertex_18_111 = mesh_18.vertices.elementAt(111);
      expect(vertex_18_111, vector3MoreOrLessEquals(Vector3(-62.3683, 16.0677, -15.8818)));
      final vertex_18_112 = mesh_18.vertices.elementAt(112);
      expect(vertex_18_112, vector3MoreOrLessEquals(Vector3(-61.6449, 15.1794, -16.1491)));
      final vertex_18_113 = mesh_18.vertices.elementAt(113);
      expect(vertex_18_113, vector3MoreOrLessEquals(Vector3(-62.2674, 15.2776, -14.7453)));
      expect(mesh_18.normals.length, equals(114));
      final normal_18_0 = mesh_18.normals.elementAt(0);
      expect(normal_18_0, vector3MoreOrLessEquals(Vector3(0.075136, 0.741809, -0.666389)));
      final normal_18_1 = mesh_18.normals.elementAt(1);
      expect(normal_18_1, vector3MoreOrLessEquals(Vector3(0.433215, 0.30826, -0.846936)));
      final normal_18_2 = mesh_18.normals.elementAt(2);
      expect(normal_18_2, vector3MoreOrLessEquals(Vector3(0.092832, 0.340544, -0.935635)));
      final normal_18_3 = mesh_18.normals.elementAt(3);
      expect(normal_18_3, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, -0.686654)));
      final normal_18_4 = mesh_18.normals.elementAt(4);
      expect(normal_18_4, vector3MoreOrLessEquals(Vector3(0.075136, 0.741809, -0.666389)));
      final normal_18_5 = mesh_18.normals.elementAt(5);
      expect(normal_18_5, vector3MoreOrLessEquals(Vector3(0.092832, 0.340544, -0.935635)));
      final normal_18_6 = mesh_18.normals.elementAt(6);
      expect(normal_18_6, vector3MoreOrLessEquals(Vector3(-0.353918, 0.873123, -0.335257)));
      final normal_18_7 = mesh_18.normals.elementAt(7);
      expect(normal_18_7, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, -0.686654)));
      final normal_18_8 = mesh_18.normals.elementAt(8);
      expect(normal_18_8, vector3MoreOrLessEquals(Vector3(-0.641388, 0.689588, -0.336288)));
      final normal_18_9 = mesh_18.normals.elementAt(9);
      expect(normal_18_9, vector3MoreOrLessEquals(Vector3(-0.353918, 0.873123, -0.335257)));
      final normal_18_10 = mesh_18.normals.elementAt(10);
      expect(normal_18_10, vector3MoreOrLessEquals(Vector3(0.075136, 0.741809, -0.666389)));
      final normal_18_11 = mesh_18.normals.elementAt(11);
      expect(normal_18_11, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, -0.686654)));
      final normal_18_12 = mesh_18.normals.elementAt(12);
      expect(normal_18_12, vector3MoreOrLessEquals(Vector3(-0.662764, 0.746241, 0.062188)));
      final normal_18_13 = mesh_18.normals.elementAt(13);
      expect(normal_18_13, vector3MoreOrLessEquals(Vector3(-0.353918, 0.873123, -0.335257)));
      final normal_18_14 = mesh_18.normals.elementAt(14);
      expect(normal_18_14, vector3MoreOrLessEquals(Vector3(-0.641388, 0.689588, -0.336288)));
      final normal_18_15 = mesh_18.normals.elementAt(15);
      expect(normal_18_15, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, 0.422116)));
      final normal_18_16 = mesh_18.normals.elementAt(16);
      expect(normal_18_16, vector3MoreOrLessEquals(Vector3(-0.542286, 0.268594, 0.796105)));
      final normal_18_17 = mesh_18.normals.elementAt(17);
      expect(normal_18_17, vector3MoreOrLessEquals(Vector3(-0.545562, 0.65851, 0.518389)));
      final normal_18_18 = mesh_18.normals.elementAt(18);
      expect(normal_18_18, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, 0.633948)));
      final normal_18_19 = mesh_18.normals.elementAt(19);
      expect(normal_18_19, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, 0.422116)));
      final normal_18_20 = mesh_18.normals.elementAt(20);
      expect(normal_18_20, vector3MoreOrLessEquals(Vector3(-0.995559, -0.032196, 0.088459)));
      final normal_18_21 = mesh_18.normals.elementAt(21);
      expect(normal_18_21, vector3MoreOrLessEquals(Vector3(-0.542286, 0.268594, 0.796105)));
      final normal_18_22 = mesh_18.normals.elementAt(22);
      expect(normal_18_22, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, 0.633948)));
      final normal_18_23 = mesh_18.normals.elementAt(23);
      expect(normal_18_23, vector3MoreOrLessEquals(Vector3(-0.433216, -0.308258, 0.846936)));
      final normal_18_24 = mesh_18.normals.elementAt(24);
      expect(normal_18_24, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, 0.633948)));
      final normal_18_25 = mesh_18.normals.elementAt(25);
      expect(normal_18_25, vector3MoreOrLessEquals(Vector3(-0.542286, 0.268594, 0.796105)));
      final normal_18_26 = mesh_18.normals.elementAt(26);
      expect(normal_18_26, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, 0.422116)));
      final normal_18_27 = mesh_18.normals.elementAt(27);
      expect(normal_18_27, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629856, 0.022517)));
      final normal_18_28 = mesh_18.normals.elementAt(28);
      expect(normal_18_28, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, 0.633948)));
      final normal_18_29 = mesh_18.normals.elementAt(29);
      expect(normal_18_29, vector3MoreOrLessEquals(Vector3(-0.995559, -0.032196, 0.088459)));
      final normal_18_30 = mesh_18.normals.elementAt(30);
      expect(normal_18_30, vector3MoreOrLessEquals(Vector3(-0.542292, -0.717477, 0.437204)));
      final normal_18_31 = mesh_18.normals.elementAt(31);
      expect(normal_18_31, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629856, 0.022517)));
      final normal_18_32 = mesh_18.normals.elementAt(32);
      expect(normal_18_32, vector3MoreOrLessEquals(Vector3(-0.467565, -0.874397, -0.129668)));
      final normal_18_33 = mesh_18.normals.elementAt(33);
      expect(normal_18_33, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, 0.633948)));
      final normal_18_34 = mesh_18.normals.elementAt(34);
      expect(normal_18_34, vector3MoreOrLessEquals(Vector3(-0.542292, -0.717477, 0.437204)));
      final normal_18_35 = mesh_18.normals.elementAt(35);
      expect(normal_18_35, vector3MoreOrLessEquals(Vector3(-0.433216, -0.308258, 0.846936)));
      final normal_18_36 = mesh_18.normals.elementAt(36);
      expect(normal_18_36, vector3MoreOrLessEquals(Vector3(-0.542292, -0.717477, 0.437204)));
      final normal_18_37 = mesh_18.normals.elementAt(37);
      expect(normal_18_37, vector3MoreOrLessEquals(Vector3(-0.738154, -0.230737, 0.633948)));
      final normal_18_38 = mesh_18.normals.elementAt(38);
      expect(normal_18_38, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629856, 0.022517)));
      final normal_18_39 = mesh_18.normals.elementAt(39);
      expect(normal_18_39, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711394, -0.442736)));
      final normal_18_40 = mesh_18.normals.elementAt(40);
      expect(normal_18_40, vector3MoreOrLessEquals(Vector3(-0.189834, -0.854102, -0.484223)));
      final normal_18_41 = mesh_18.normals.elementAt(41);
      expect(normal_18_41, vector3MoreOrLessEquals(Vector3(-0.467565, -0.874397, -0.129668)));
      final normal_18_42 = mesh_18.normals.elementAt(42);
      expect(normal_18_42, vector3MoreOrLessEquals(Vector3(-0.215356, -0.623779, -0.751346)));
      final normal_18_43 = mesh_18.normals.elementAt(43);
      expect(normal_18_43, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711394, -0.442736)));
      final normal_18_44 = mesh_18.normals.elementAt(44);
      expect(normal_18_44, vector3MoreOrLessEquals(Vector3(-0.641391, -0.312091, -0.700869)));
      final normal_18_45 = mesh_18.normals.elementAt(45);
      expect(normal_18_45, vector3MoreOrLessEquals(Vector3(-0.189834, -0.854102, -0.484223)));
      final normal_18_46 = mesh_18.normals.elementAt(46);
      expect(normal_18_46, vector3MoreOrLessEquals(Vector3(-0.215356, -0.623779, -0.751346)));
      final normal_18_47 = mesh_18.normals.elementAt(47);
      expect(normal_18_47, vector3MoreOrLessEquals(Vector3(0.037501, -0.724698, -0.688046)));
      final normal_18_48 = mesh_18.normals.elementAt(48);
      expect(normal_18_48, vector3MoreOrLessEquals(Vector3(-0.215356, -0.623779, -0.751346)));
      final normal_18_49 = mesh_18.normals.elementAt(49);
      expect(normal_18_49, vector3MoreOrLessEquals(Vector3(-0.189834, -0.854102, -0.484223)));
      final normal_18_50 = mesh_18.normals.elementAt(50);
      expect(normal_18_50, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711394, -0.442736)));
      final normal_18_51 = mesh_18.normals.elementAt(51);
      expect(normal_18_51, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, -0.926106)));
      final normal_18_52 = mesh_18.normals.elementAt(52);
      expect(normal_18_52, vector3MoreOrLessEquals(Vector3(-0.215356, -0.623779, -0.751346)));
      final normal_18_53 = mesh_18.normals.elementAt(53);
      expect(normal_18_53, vector3MoreOrLessEquals(Vector3(-0.641391, -0.312091, -0.700869)));
      final normal_18_54 = mesh_18.normals.elementAt(54);
      expect(normal_18_54, vector3MoreOrLessEquals(Vector3(0.078136, -0.268605, -0.960076)));
      final normal_18_55 = mesh_18.normals.elementAt(55);
      expect(normal_18_55, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, -0.926106)));
      final normal_18_56 = mesh_18.normals.elementAt(56);
      expect(normal_18_56, vector3MoreOrLessEquals(Vector3(0.092832, 0.340544, -0.935635)));
      final normal_18_57 = mesh_18.normals.elementAt(57);
      expect(normal_18_57, vector3MoreOrLessEquals(Vector3(-0.215356, -0.623779, -0.751346)));
      final normal_18_58 = mesh_18.normals.elementAt(58);
      expect(normal_18_58, vector3MoreOrLessEquals(Vector3(0.078136, -0.268605, -0.960076)));
      final normal_18_59 = mesh_18.normals.elementAt(59);
      expect(normal_18_59, vector3MoreOrLessEquals(Vector3(0.037501, -0.724698, -0.688046)));
      final normal_18_60 = mesh_18.normals.elementAt(60);
      expect(normal_18_60, vector3MoreOrLessEquals(Vector3(0.078136, -0.268605, -0.960076)));
      final normal_18_61 = mesh_18.normals.elementAt(61);
      expect(normal_18_61, vector3MoreOrLessEquals(Vector3(-0.215356, -0.623779, -0.751346)));
      final normal_18_62 = mesh_18.normals.elementAt(62);
      expect(normal_18_62, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, -0.926106)));
      final normal_18_63 = mesh_18.normals.elementAt(63);
      expect(normal_18_63, vector3MoreOrLessEquals(Vector3(0.433215, 0.30826, -0.846936)));
      final normal_18_64 = mesh_18.normals.elementAt(64);
      expect(normal_18_64, vector3MoreOrLessEquals(Vector3(0.078136, -0.268605, -0.960076)));
      final normal_18_65 = mesh_18.normals.elementAt(65);
      expect(normal_18_65, vector3MoreOrLessEquals(Vector3(0.092832, 0.340544, -0.935635)));
      final normal_18_66 = mesh_18.normals.elementAt(66);
      expect(normal_18_66, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, -0.686654)));
      final normal_18_67 = mesh_18.normals.elementAt(67);
      expect(normal_18_67, vector3MoreOrLessEquals(Vector3(-0.757384, 0.223328, -0.61359)));
      final normal_18_68 = mesh_18.normals.elementAt(68);
      expect(normal_18_68, vector3MoreOrLessEquals(Vector3(-0.641388, 0.689588, -0.336288)));
      final normal_18_69 = mesh_18.normals.elementAt(69);
      expect(normal_18_69, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, -0.926106)));
      final normal_18_70 = mesh_18.normals.elementAt(70);
      expect(normal_18_70, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, -0.686654)));
      final normal_18_71 = mesh_18.normals.elementAt(71);
      expect(normal_18_71, vector3MoreOrLessEquals(Vector3(0.092832, 0.340544, -0.935635)));
      final normal_18_72 = mesh_18.normals.elementAt(72);
      expect(normal_18_72, vector3MoreOrLessEquals(Vector3(-0.757384, 0.223328, -0.61359)));
      final normal_18_73 = mesh_18.normals.elementAt(73);
      expect(normal_18_73, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, -0.926106)));
      final normal_18_74 = mesh_18.normals.elementAt(74);
      expect(normal_18_74, vector3MoreOrLessEquals(Vector3(-0.641391, -0.312091, -0.700869)));
      final normal_18_75 = mesh_18.normals.elementAt(75);
      expect(normal_18_75, vector3MoreOrLessEquals(Vector3(-0.375594, -0.035443, -0.926106)));
      final normal_18_76 = mesh_18.normals.elementAt(76);
      expect(normal_18_76, vector3MoreOrLessEquals(Vector3(-0.757384, 0.223328, -0.61359)));
      final normal_18_77 = mesh_18.normals.elementAt(77);
      expect(normal_18_77, vector3MoreOrLessEquals(Vector3(-0.375593, 0.622444, -0.686654)));
      final normal_18_78 = mesh_18.normals.elementAt(78);
      expect(normal_18_78, vector3MoreOrLessEquals(Vector3(-0.757384, 0.223328, -0.61359)));
      final normal_18_79 = mesh_18.normals.elementAt(79);
      expect(normal_18_79, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, -0.158468)));
      final normal_18_80 = mesh_18.normals.elementAt(80);
      expect(normal_18_80, vector3MoreOrLessEquals(Vector3(-0.641388, 0.689588, -0.336288)));
      final normal_18_81 = mesh_18.normals.elementAt(81);
      expect(normal_18_81, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, -0.378934)));
      final normal_18_82 = mesh_18.normals.elementAt(82);
      expect(normal_18_82, vector3MoreOrLessEquals(Vector3(-0.757384, 0.223328, -0.61359)));
      final normal_18_83 = mesh_18.normals.elementAt(83);
      expect(normal_18_83, vector3MoreOrLessEquals(Vector3(-0.641391, -0.312091, -0.700869)));
      final normal_18_84 = mesh_18.normals.elementAt(84);
      expect(normal_18_84, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, -0.158468)));
      final normal_18_85 = mesh_18.normals.elementAt(85);
      expect(normal_18_85, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, -0.378934)));
      final normal_18_86 = mesh_18.normals.elementAt(86);
      expect(normal_18_86, vector3MoreOrLessEquals(Vector3(-0.995559, -0.032196, 0.088459)));
      final normal_18_87 = mesh_18.normals.elementAt(87);
      expect(normal_18_87, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, -0.378934)));
      final normal_18_88 = mesh_18.normals.elementAt(88);
      expect(normal_18_88, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, -0.158468)));
      final normal_18_89 = mesh_18.normals.elementAt(89);
      expect(normal_18_89, vector3MoreOrLessEquals(Vector3(-0.757384, 0.223328, -0.61359)));
      final normal_18_90 = mesh_18.normals.elementAt(90);
      expect(normal_18_90, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, -0.158468)));
      final normal_18_91 = mesh_18.normals.elementAt(91);
      expect(normal_18_91, vector3MoreOrLessEquals(Vector3(-0.662764, 0.746241, 0.062188)));
      final normal_18_92 = mesh_18.normals.elementAt(92);
      expect(normal_18_92, vector3MoreOrLessEquals(Vector3(-0.641388, 0.689588, -0.336288)));
      final normal_18_93 = mesh_18.normals.elementAt(93);
      expect(normal_18_93, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, 0.422116)));
      final normal_18_94 = mesh_18.normals.elementAt(94);
      expect(normal_18_94, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, -0.158468)));
      final normal_18_95 = mesh_18.normals.elementAt(95);
      expect(normal_18_95, vector3MoreOrLessEquals(Vector3(-0.995559, -0.032196, 0.088459)));
      final normal_18_96 = mesh_18.normals.elementAt(96);
      expect(normal_18_96, vector3MoreOrLessEquals(Vector3(-0.662764, 0.746241, 0.062188)));
      final normal_18_97 = mesh_18.normals.elementAt(97);
      expect(normal_18_97, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, 0.422116)));
      final normal_18_98 = mesh_18.normals.elementAt(98);
      expect(normal_18_98, vector3MoreOrLessEquals(Vector3(-0.545562, 0.65851, 0.518389)));
      final normal_18_99 = mesh_18.normals.elementAt(99);
      expect(normal_18_99, vector3MoreOrLessEquals(Vector3(-0.776382, 0.468027, 0.422116)));
      final normal_18_100 = mesh_18.normals.elementAt(100);
      expect(normal_18_100, vector3MoreOrLessEquals(Vector3(-0.662764, 0.746241, 0.062188)));
      final normal_18_101 = mesh_18.normals.elementAt(101);
      expect(normal_18_101, vector3MoreOrLessEquals(Vector3(-0.902417, 0.400663, -0.158468)));
      final normal_18_102 = mesh_18.normals.elementAt(102);
      expect(normal_18_102, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629856, 0.022517)));
      final normal_18_103 = mesh_18.normals.elementAt(103);
      expect(normal_18_103, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711394, -0.442736)));
      final normal_18_104 = mesh_18.normals.elementAt(104);
      expect(normal_18_104, vector3MoreOrLessEquals(Vector3(-0.467565, -0.874397, -0.129668)));
      final normal_18_105 = mesh_18.normals.elementAt(105);
      expect(normal_18_105, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, -0.378934)));
      final normal_18_106 = mesh_18.normals.elementAt(106);
      expect(normal_18_106, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629856, 0.022517)));
      final normal_18_107 = mesh_18.normals.elementAt(107);
      expect(normal_18_107, vector3MoreOrLessEquals(Vector3(-0.995559, -0.032196, 0.088459)));
      final normal_18_108 = mesh_18.normals.elementAt(108);
      expect(normal_18_108, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711394, -0.442736)));
      final normal_18_109 = mesh_18.normals.elementAt(109);
      expect(normal_18_109, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, -0.378934)));
      final normal_18_110 = mesh_18.normals.elementAt(110);
      expect(normal_18_110, vector3MoreOrLessEquals(Vector3(-0.641391, -0.312091, -0.700869)));
      final normal_18_111 = mesh_18.normals.elementAt(111);
      expect(normal_18_111, vector3MoreOrLessEquals(Vector3(-0.902417, -0.205066, -0.378934)));
      final normal_18_112 = mesh_18.normals.elementAt(112);
      expect(normal_18_112, vector3MoreOrLessEquals(Vector3(-0.545805, -0.711394, -0.442736)));
      final normal_18_113 = mesh_18.normals.elementAt(113);
      expect(normal_18_113, vector3MoreOrLessEquals(Vector3(-0.776385, -0.629856, 0.022517)));
      expect(mesh_18.tangents.length, isZero);
      expect(mesh_18.bitangents.length, isZero);
      expect(mesh_18.colors.length, isZero);
      expect(mesh_18.textureCoords.length, equals(1));
      final textureCoords_18_0 = mesh_18.textureCoords.elementAt(0);
      expect(textureCoords_18_0.length, equals(114));
      final textureCoord_18_0_0 = textureCoords_18_0.elementAt(0);
      expect(textureCoord_18_0_0, vector3MoreOrLessEquals(Vector3(0.899283, 0.970312, 0)));
      final textureCoord_18_0_1 = textureCoords_18_0.elementAt(1);
      expect(textureCoord_18_0_1, vector3MoreOrLessEquals(Vector3(0.956791, 0.730945, 0)));
      final textureCoord_18_0_2 = textureCoords_18_0.elementAt(2);
      expect(textureCoord_18_0_2, vector3MoreOrLessEquals(Vector3(1.04688, 0.77201, 0)));
      final textureCoord_18_0_3 = textureCoords_18_0.elementAt(3);
      expect(textureCoord_18_0_3, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_18_0_4 = textureCoords_18_0.elementAt(4);
      expect(textureCoord_18_0_4, vector3MoreOrLessEquals(Vector3(0.899283, 0.970312, 0)));
      final textureCoord_18_0_5 = textureCoords_18_0.elementAt(5);
      expect(textureCoord_18_0_5, vector3MoreOrLessEquals(Vector3(1.04688, 0.77201, 0)));
      final textureCoord_18_0_6 = textureCoords_18_0.elementAt(6);
      expect(textureCoord_18_0_6, vector3MoreOrLessEquals(Vector3(0.707168, 1.04688, 0)));
      final textureCoord_18_0_7 = textureCoords_18_0.elementAt(7);
      expect(textureCoord_18_0_7, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_18_0_8 = textureCoords_18_0.elementAt(8);
      expect(textureCoord_18_0_8, vector3MoreOrLessEquals(Vector3(0.720028, 0.902269, 0)));
      final textureCoord_18_0_9 = textureCoords_18_0.elementAt(9);
      expect(textureCoord_18_0_9, vector3MoreOrLessEquals(Vector3(0.707168, 1.04688, 0)));
      final textureCoord_18_0_10 = textureCoords_18_0.elementAt(10);
      expect(textureCoord_18_0_10, vector3MoreOrLessEquals(Vector3(0.899283, 0.970312, 0)));
      final textureCoord_18_0_11 = textureCoords_18_0.elementAt(11);
      expect(textureCoord_18_0_11, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_18_0_12 = textureCoords_18_0.elementAt(12);
      expect(textureCoord_18_0_12, vector3MoreOrLessEquals(Vector3(0.453826, 0.931398, 0)));
      final textureCoord_18_0_13 = textureCoords_18_0.elementAt(13);
      expect(textureCoord_18_0_13, vector3MoreOrLessEquals(Vector3(0.707168, 1.04688, 0)));
      final textureCoord_18_0_14 = textureCoords_18_0.elementAt(14);
      expect(textureCoord_18_0_14, vector3MoreOrLessEquals(Vector3(0.720028, 0.902269, 0)));
      final textureCoord_18_0_15 = textureCoords_18_0.elementAt(15);
      expect(textureCoord_18_0_15, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_18_0_16 = textureCoords_18_0.elementAt(16);
      expect(textureCoord_18_0_16, vector3MoreOrLessEquals(Vector3(0.058156, 0.586898, 0)));
      final textureCoord_18_0_17 = textureCoords_18_0.elementAt(17);
      expect(textureCoord_18_0_17, vector3MoreOrLessEquals(Vector3(0.215418, 0.844835, 0)));
      final textureCoord_18_0_18 = textureCoords_18_0.elementAt(18);
      expect(textureCoord_18_0_18, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_18_0_19 = textureCoords_18_0.elementAt(19);
      expect(textureCoord_18_0_19, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_18_0_20 = textureCoords_18_0.elementAt(20);
      expect(textureCoord_18_0_20, vector3MoreOrLessEquals(Vector3(0.349482, 0.454114, 0)));
      final textureCoord_18_0_21 = textureCoords_18_0.elementAt(21);
      expect(textureCoord_18_0_21, vector3MoreOrLessEquals(Vector3(0.058156, 0.586898, 0)));
      final textureCoord_18_0_22 = textureCoords_18_0.elementAt(22);
      expect(textureCoord_18_0_22, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_18_0_23 = textureCoords_18_0.elementAt(23);
      expect(textureCoord_18_0_23, vector3MoreOrLessEquals(Vector3(0.046875, 0.316174, 0)));
      final textureCoord_18_0_24 = textureCoords_18_0.elementAt(24);
      expect(textureCoord_18_0_24, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_18_0_25 = textureCoords_18_0.elementAt(25);
      expect(textureCoord_18_0_25, vector3MoreOrLessEquals(Vector3(0.058156, 0.586898, 0)));
      final textureCoord_18_0_26 = textureCoords_18_0.elementAt(26);
      expect(textureCoord_18_0_26, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_18_0_27 = textureCoords_18_0.elementAt(27);
      expect(textureCoord_18_0_27, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_18_0_28 = textureCoords_18_0.elementAt(28);
      expect(textureCoord_18_0_28, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_18_0_29 = textureCoords_18_0.elementAt(29);
      expect(textureCoord_18_0_29, vector3MoreOrLessEquals(Vector3(0.349482, 0.454114, 0)));
      final textureCoord_18_0_30 = textureCoords_18_0.elementAt(30);
      expect(textureCoord_18_0_30, vector3MoreOrLessEquals(Vector3(0.194464, 0.117868, 0)));
      final textureCoord_18_0_31 = textureCoords_18_0.elementAt(31);
      expect(textureCoord_18_0_31, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_18_0_32 = textureCoords_18_0.elementAt(32);
      expect(textureCoord_18_0_32, vector3MoreOrLessEquals(Vector3(0.44732, 0.046875, 0)));
      final textureCoord_18_0_33 = textureCoords_18_0.elementAt(33);
      expect(textureCoord_18_0_33, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_18_0_34 = textureCoords_18_0.elementAt(34);
      expect(textureCoord_18_0_34, vector3MoreOrLessEquals(Vector3(0.194464, 0.117868, 0)));
      final textureCoord_18_0_35 = textureCoords_18_0.elementAt(35);
      expect(textureCoord_18_0_35, vector3MoreOrLessEquals(Vector3(0.046875, 0.316174, 0)));
      final textureCoord_18_0_36 = textureCoords_18_0.elementAt(36);
      expect(textureCoord_18_0_36, vector3MoreOrLessEquals(Vector3(0.194464, 0.117868, 0)));
      final textureCoord_18_0_37 = textureCoords_18_0.elementAt(37);
      expect(textureCoord_18_0_37, vector3MoreOrLessEquals(Vector3(0.136958, 0.357239, 0)));
      final textureCoord_18_0_38 = textureCoords_18_0.elementAt(38);
      expect(textureCoord_18_0_38, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_18_0_39 = textureCoords_18_0.elementAt(39);
      expect(textureCoord_18_0_39, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_18_0_40 = textureCoords_18_0.elementAt(40);
      expect(textureCoord_18_0_40, vector3MoreOrLessEquals(Vector3(0.683183, 0.075062, 0)));
      final textureCoord_18_0_41 = textureCoords_18_0.elementAt(41);
      expect(textureCoord_18_0_41, vector3MoreOrLessEquals(Vector3(0.44732, 0.046875, 0)));
      final textureCoord_18_0_42 = textureCoords_18_0.elementAt(42);
      expect(textureCoord_18_0_42, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_18_0_43 = textureCoords_18_0.elementAt(43);
      expect(textureCoord_18_0_43, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_18_0_44 = textureCoords_18_0.elementAt(44);
      expect(textureCoord_18_0_44, vector3MoreOrLessEquals(Vector3(0.863351, 0.409106, 0)));
      final textureCoord_18_0_45 = textureCoords_18_0.elementAt(45);
      expect(textureCoord_18_0_45, vector3MoreOrLessEquals(Vector3(0.683183, 0.075062, 0)));
      final textureCoord_18_0_46 = textureCoords_18_0.elementAt(46);
      expect(textureCoord_18_0_46, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_18_0_47 = textureCoords_18_0.elementAt(47);
      expect(textureCoord_18_0_47, vector3MoreOrLessEquals(Vector3(0.878332, 0.243345, 0)));
      final textureCoord_18_0_48 = textureCoords_18_0.elementAt(48);
      expect(textureCoord_18_0_48, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_18_0_49 = textureCoords_18_0.elementAt(49);
      expect(textureCoord_18_0_49, vector3MoreOrLessEquals(Vector3(0.683183, 0.075062, 0)));
      final textureCoord_18_0_50 = textureCoords_18_0.elementAt(50);
      expect(textureCoord_18_0_50, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_18_0_51 = textureCoords_18_0.elementAt(51);
      expect(textureCoord_18_0_51, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_18_0_52 = textureCoords_18_0.elementAt(52);
      expect(textureCoord_18_0_52, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_18_0_53 = textureCoords_18_0.elementAt(53);
      expect(textureCoord_18_0_53, vector3MoreOrLessEquals(Vector3(0.863351, 0.409106, 0)));
      final textureCoord_18_0_54 = textureCoords_18_0.elementAt(54);
      expect(textureCoord_18_0_54, vector3MoreOrLessEquals(Vector3(1.03559, 0.501285, 0)));
      final textureCoord_18_0_55 = textureCoords_18_0.elementAt(55);
      expect(textureCoord_18_0_55, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_18_0_56 = textureCoords_18_0.elementAt(56);
      expect(textureCoord_18_0_56, vector3MoreOrLessEquals(Vector3(1.04688, 0.77201, 0)));
      final textureCoord_18_0_57 = textureCoords_18_0.elementAt(57);
      expect(textureCoord_18_0_57, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_18_0_58 = textureCoords_18_0.elementAt(58);
      expect(textureCoord_18_0_58, vector3MoreOrLessEquals(Vector3(1.03559, 0.501285, 0)));
      final textureCoord_18_0_59 = textureCoords_18_0.elementAt(59);
      expect(textureCoord_18_0_59, vector3MoreOrLessEquals(Vector3(0.878332, 0.243345, 0)));
      final textureCoord_18_0_60 = textureCoords_18_0.elementAt(60);
      expect(textureCoord_18_0_60, vector3MoreOrLessEquals(Vector3(1.03559, 0.501285, 0)));
      final textureCoord_18_0_61 = textureCoords_18_0.elementAt(61);
      expect(textureCoord_18_0_61, vector3MoreOrLessEquals(Vector3(0.92772, 0.287975, 0)));
      final textureCoord_18_0_62 = textureCoords_18_0.elementAt(62);
      expect(textureCoord_18_0_62, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_18_0_63 = textureCoords_18_0.elementAt(63);
      expect(textureCoord_18_0_63, vector3MoreOrLessEquals(Vector3(0.956791, 0.730945, 0)));
      final textureCoord_18_0_64 = textureCoords_18_0.elementAt(64);
      expect(textureCoord_18_0_64, vector3MoreOrLessEquals(Vector3(1.03559, 0.501285, 0)));
      final textureCoord_18_0_65 = textureCoords_18_0.elementAt(65);
      expect(textureCoord_18_0_65, vector3MoreOrLessEquals(Vector3(1.04688, 0.77201, 0)));
      final textureCoord_18_0_66 = textureCoords_18_0.elementAt(66);
      expect(textureCoord_18_0_66, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_18_0_67 = textureCoords_18_0.elementAt(67);
      expect(textureCoord_18_0_67, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_18_0_68 = textureCoords_18_0.elementAt(68);
      expect(textureCoord_18_0_68, vector3MoreOrLessEquals(Vector3(0.720028, 0.902269, 0)));
      final textureCoord_18_0_69 = textureCoords_18_0.elementAt(69);
      expect(textureCoord_18_0_69, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_18_0_70 = textureCoords_18_0.elementAt(70);
      expect(textureCoord_18_0_70, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_18_0_71 = textureCoords_18_0.elementAt(71);
      expect(textureCoord_18_0_71, vector3MoreOrLessEquals(Vector3(1.04688, 0.77201, 0)));
      final textureCoord_18_0_72 = textureCoords_18_0.elementAt(72);
      expect(textureCoord_18_0_72, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_18_0_73 = textureCoords_18_0.elementAt(73);
      expect(textureCoord_18_0_73, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_18_0_74 = textureCoords_18_0.elementAt(74);
      expect(textureCoord_18_0_74, vector3MoreOrLessEquals(Vector3(0.863351, 0.409106, 0)));
      final textureCoord_18_0_75 = textureCoords_18_0.elementAt(75);
      expect(textureCoord_18_0_75, vector3MoreOrLessEquals(Vector3(1.02679, 0.598716, 0)));
      final textureCoord_18_0_76 = textureCoords_18_0.elementAt(76);
      expect(textureCoord_18_0_76, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_18_0_77 = textureCoords_18_0.elementAt(77);
      expect(textureCoord_18_0_77, vector3MoreOrLessEquals(Vector3(0.942544, 0.888589, 0)));
      final textureCoord_18_0_78 = textureCoords_18_0.elementAt(78);
      expect(textureCoord_18_0_78, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_18_0_79 = textureCoords_18_0.elementAt(79);
      expect(textureCoord_18_0_79, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_18_0_80 = textureCoords_18_0.elementAt(80);
      expect(textureCoord_18_0_80, vector3MoreOrLessEquals(Vector3(0.720028, 0.902269, 0)));
      final textureCoord_18_0_81 = textureCoords_18_0.elementAt(81);
      expect(textureCoord_18_0_81, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_18_0_82 = textureCoords_18_0.elementAt(82);
      expect(textureCoord_18_0_82, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_18_0_83 = textureCoords_18_0.elementAt(83);
      expect(textureCoord_18_0_83, vector3MoreOrLessEquals(Vector3(0.863351, 0.409106, 0)));
      final textureCoord_18_0_84 = textureCoords_18_0.elementAt(84);
      expect(textureCoord_18_0_84, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_18_0_85 = textureCoords_18_0.elementAt(85);
      expect(textureCoord_18_0_85, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_18_0_86 = textureCoords_18_0.elementAt(86);
      expect(textureCoord_18_0_86, vector3MoreOrLessEquals(Vector3(0.349482, 0.454114, 0)));
      final textureCoord_18_0_87 = textureCoords_18_0.elementAt(87);
      expect(textureCoord_18_0_87, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_18_0_88 = textureCoords_18_0.elementAt(88);
      expect(textureCoord_18_0_88, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_18_0_89 = textureCoords_18_0.elementAt(89);
      expect(textureCoord_18_0_89, vector3MoreOrLessEquals(Vector3(0.834671, 0.675278, 0)));
      final textureCoord_18_0_90 = textureCoords_18_0.elementAt(90);
      expect(textureCoord_18_0_90, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_18_0_91 = textureCoords_18_0.elementAt(91);
      expect(textureCoord_18_0_91, vector3MoreOrLessEquals(Vector3(0.453826, 0.931398, 0)));
      final textureCoord_18_0_92 = textureCoords_18_0.elementAt(92);
      expect(textureCoord_18_0_92, vector3MoreOrLessEquals(Vector3(0.720028, 0.902269, 0)));
      final textureCoord_18_0_93 = textureCoords_18_0.elementAt(93);
      expect(textureCoord_18_0_93, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_18_0_94 = textureCoords_18_0.elementAt(94);
      expect(textureCoord_18_0_94, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_18_0_95 = textureCoords_18_0.elementAt(95);
      expect(textureCoord_18_0_95, vector3MoreOrLessEquals(Vector3(0.349482, 0.454114, 0)));
      final textureCoord_18_0_96 = textureCoords_18_0.elementAt(96);
      expect(textureCoord_18_0_96, vector3MoreOrLessEquals(Vector3(0.453826, 0.931398, 0)));
      final textureCoord_18_0_97 = textureCoords_18_0.elementAt(97);
      expect(textureCoord_18_0_97, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_18_0_98 = textureCoords_18_0.elementAt(98);
      expect(textureCoord_18_0_98, vector3MoreOrLessEquals(Vector3(0.215418, 0.844835, 0)));
      final textureCoord_18_0_99 = textureCoords_18_0.elementAt(99);
      expect(textureCoord_18_0_99, vector3MoreOrLessEquals(Vector3(0.236023, 0.667976, 0)));
      final textureCoord_18_0_100 = textureCoords_18_0.elementAt(100);
      expect(textureCoord_18_0_100, vector3MoreOrLessEquals(Vector3(0.453826, 0.931398, 0)));
      final textureCoord_18_0_101 = textureCoords_18_0.elementAt(101);
      expect(textureCoord_18_0_101, vector3MoreOrLessEquals(Vector3(0.532626, 0.701734, 0)));
      final textureCoord_18_0_102 = textureCoords_18_0.elementAt(102);
      expect(textureCoord_18_0_102, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_18_0_103 = textureCoords_18_0.elementAt(103);
      expect(textureCoord_18_0_103, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_18_0_104 = textureCoords_18_0.elementAt(104);
      expect(textureCoord_18_0_104, vector3MoreOrLessEquals(Vector3(0.44732, 0.046875, 0)));
      final textureCoord_18_0_105 = textureCoords_18_0.elementAt(105);
      expect(textureCoord_18_0_105, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_18_0_106 = textureCoords_18_0.elementAt(106);
      expect(textureCoord_18_0_106, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      final textureCoord_18_0_107 = textureCoords_18_0.elementAt(107);
      expect(textureCoord_18_0_107, vector3MoreOrLessEquals(Vector3(0.349482, 0.454114, 0)));
      final textureCoord_18_0_108 = textureCoords_18_0.elementAt(108);
      expect(textureCoord_18_0_108, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_18_0_109 = textureCoords_18_0.elementAt(109);
      expect(textureCoord_18_0_109, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_18_0_110 = textureCoords_18_0.elementAt(110);
      expect(textureCoord_18_0_110, vector3MoreOrLessEquals(Vector3(0.863351, 0.409106, 0)));
      final textureCoord_18_0_111 = textureCoords_18_0.elementAt(111);
      expect(textureCoord_18_0_111, vector3MoreOrLessEquals(Vector3(0.616869, 0.411861, 0)));
      final textureCoord_18_0_112 = textureCoords_18_0.elementAt(112);
      expect(textureCoord_18_0_112, vector3MoreOrLessEquals(Vector3(0.674378, 0.172493, 0)));
      final textureCoord_18_0_113 = textureCoords_18_0.elementAt(113);
      expect(textureCoord_18_0_113, vector3MoreOrLessEquals(Vector3(0.372331, 0.198949, 0)));
      expect(mesh_18.uvComponents.length, equals(1));
      expect(mesh_18.uvComponents, equals([2]));
      expect(mesh_18.faces.length, equals(38));
      expect(mesh_18.bones.length, isZero);
      expect(mesh_18.materialIndex, equals(5));
      expect(mesh_18.name, equals('Duplicate05'));
      expect(mesh_18.animMeshes.length, isZero);
      expect(mesh_18.morphingMethod, isZero);
      expect(mesh_18.aabb, aabb3MoreOrLessEquals(Aabb3.minMax(Vector3(0, 0, 0), Vector3(0, 0, 0))));
    });
  });

}
